module GGconst
implicit none

! these parameters are used to set up the correct prefactors in the Full...GG functions,
! and to set up nup and ndown for the electroweak factor in the Bv1g1GG matrix element.
! (arising from the photons being emitted from a quark loop)

double precision, parameter :: nc = 3d0
double precision, parameter :: nup = 2d0
double precision, parameter :: ndown = 3d0
double precision, parameter :: nf = 5d0

double precision, parameter :: qup = 2d0/3d0
double precision, parameter :: qdown = -1d0/3d0


end module GGconst
