!-------------------------------------------------------------------------------
! NNLOJET
!-------------------------------------------------------------------------------
!
! MODULE: NNLOJET [external members: `_nnlojet`]
!
! DESCRIPTION:
!> Module collecting program settings and parameters
!> eventually, will replace NNLOJT.f with the main program routine here
!-------------------------------------------------------------------------------

#ifndef VERSION
#define VERSION "unknown"
#endif

!-------------------------------------------------------------------------------
module NNLOJET_mod
!-------------------------------------------------------------------------------
  implicit none
  public

  !> version number
  character(*), parameter :: version_nnlojet = VERSION


contains

!  subroutine setCollider_epem(Ee,Ep)
!    common /pinee/pa(4),pb(4)
!    double precision :: pa,pb
!    double precision :: Ee,Ep
!
!    pa(4)=Ee
!    pa(1)=0d0
!    pa(2)=0d0
!    pa(3)=Ee
!
!    pb(4)=Ep
!    pb(1)=0d0
!    pb(2)=0d0
!    pb(3)=-Ep
!
!  end subroutine setCollider_epem
!
!  subroutine setCollider_dis(sEe,sEp)
!    use DIS_mod, only : setetaep,setEs
!    implicit none
!    double precision sEe,sEp
!    call setEs(sEe,sEp)
!    call setetaep(sEp/sEe)
!  end subroutine setCollider_dis

end module NNLOJET_mod

