module Softdrop_mod
implicit none

integer, allocatable, dimension(:) :: clusterHist_phot
integer, allocatable, dimension(:) :: clusterHist_orig
integer :: njets_orig
!$OMP THREADPRIVATE(clusterHist_phot)
!$OMP THREADPRIVATE(clusterHist_orig,njets_orig)

! note that R0_sdrop should be equal to the jet radius set elsewhere in the runcard.
! if they differ, the program will print a warning.
double precision :: R0_sdrop, zcut_sdrop, beta_sdrop
integer :: ip_jet2_sdrop

integer :: njetoffset_upper_orig

! 'true' applies the softdrop criterion during the reclustering;
! 'false' simply reclusters with the second algorithm
logical :: sdtest = .true.

end module Softdrop_mod
