
*********************************************
* Sets the relative technical cut off values
* between the momentum configurations. For now
* it is assumed that the cut off drops by an
* order of magnitude between each mapping in the
* process. Something more sophisticated could be
* implemented later

      subroutine setTechcuts(npar)
      implicit real*8(a-h,o-z)
      common /tcutnpar/y0p10,y0p9,y0p8,y0p7,y0p6,y0p5,y0p4
      common /tcuts/ymin,y0

      y0p9=0d0
      y0p8=0d0
      y0p7=0d0
      y0p6=0d0
      y0p5=0d0
      y0p4=0d0

      if(npar.eq.10)then
         y0p10=y0
         y0p9=y0/100d0!1d-1*y0
         y0p8=0d0!1d-2*y0
      elseif(npar.eq.9)then
         y0p9=y0
         y0p8=y0/100d0!1d-1*y0
         y0p7=0d0!1d-2*y0
      elseif(npar.eq.8)then
         y0p8=y0
         y0p7=y0/100d0!1d-1*y0
         y0p6=0d0!1d-2*y0
      elseif(npar.eq.7)then
         y0p7=y0
         y0p6=y0/100d0!1d-1*y0
         y0p5=0d0!1d-2*y0
      elseif(npar.eq.6)then
         y0p6=y0
         y0p5=y0/100d0!1d-1*y0
         y0p4=0d0!1d-2*y0
      elseif(npar.eq.5)then
         y0p5=y0
         y0p4=0d0!1d-1*y0
      elseif(npar.eq.4)then
         y0p4=y0
      else
         write(*,*) "Unknown dimensionality in setTechcuts: ", npar
         stop
      endif

      return
      end
