!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!phasenewXGG_qT is  similiar to phasenewXh_qT !!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!Phase spce wedges and cuts are recycling the phasenewhXXX code!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase3GG_qT(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4),pap(4),pbp(4),qp(4)
      dimension p1a(4),p2a(4),p3a(4)
      dimension p1ap(4),p2ap(4),p3ap(4)
      dimension p12(4),p12p(4)
      dimension pqa(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common /pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common /invar3/sij3(3,3),tij3(2,3)
!$omp threadprivate(/invar3/)
      common /pmomang3/pang3(4,3,2)
!$omp threadprivate(/pmomang3/)
      common /invarang3/sijang3(3,3,2),tijang3(2,3,2),iacc(2)
!$omp threadprivate(/invarang3/)
      common /nwa/rm12,rg12,inwa
      common /tcuts/ymin,y0
      common /mxdim/ mxdim
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase3GG_qT", x(1), wt, ifail

      wtps = 1d0
      Nphase = 1

*
* phase space for 2->3 scattering, a+b -> 1+2+3 with q=p1+p2
*
* incoming momenta along z-axis, pa is +z
*
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      ifail =1
      wt = 0d0

      s12min=y0*s_proc
      s12max=s_proc
c      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
c      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3)))**2,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick_tanh_generic(-1,s12,1d0,7d0,s12min,s12max,r1,wtps)
c      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return ! Insufficient scattering energy
      wtps = wtps/2d0/pi
      call p2generic_qT(0,3d0,r2,0d0,shat,rma2,rmb2,s12,rm2(3),
     .                   p12,p3,pa,pb,wtps)
      if(wtps.eq.0d0) return
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r3,wtps)
      call pick(1,phi,0d0,twopi,r4,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2
      call unboostrest(p12,ubmat)

      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         pang3(i,1,1) = p1(i)
         pang3(i,2,1) = p2(i)
         pang3(i,3,1) = p3(i)
      enddo

      if(p3(4).lt.0d0)then ! negative energy jets
         ifail=1
         return
      endif

      call fillinv(3,pang3(1:4,1:3,1),pa,pb,sijang3(1:3,1:3,1)
     .                                     ,tijang3(1:2,1:3,1))

 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 105  format('pa:',4f14.6)
 106  format('pb:',4f14.6)
 109  format('pp:',4f14.6)

      ifail =0
      wt = wtps

      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase4GG_qT(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),pap(4)
      dimension p1a(4),p2a(4),p3a(4),p4a(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4)
      dimension p12(4)
      dimension p34(4),p34p(4),p34g(4),papg(4),parb(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common /pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common /invar4/sij4(4,4),tij4(2,4)
!$omp threadprivate(/invar4/)
      common /pmomang4/pang4(4,4,4)
!$omp threadprivate(/pmomang4/)
      common /invarang4/sijang4(4,4,4),tijang4(2,4,4),iacc(4)
!$omp threadprivate(/invarang4/)
      common /nwa/rm12,rg12,inwa
      common /techpar/iang
      common /tcuts/ymin,y0
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase4GG_qT", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=2
      else
         Nphase=4
         wtps=wtps/2d0
      endif

c---  corresponds to the phase space(3,4;a)

*
* phase space for 2->4 scattering, a+b -> 1+2+3+4 with q=p1+p2
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_4 = 1/24576/pi**5 = 1.32965643x10^-7
*

      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      ifail =1
      wt = 0d0

      s12min=y0*s_proc
      s12max=s_proc
      if (s12min.ge.s12max) return
      call pick_tanh_generic(-1,s12,5d-1,12d0,s12min,s12max,r1,wtps)
c      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
      s34min = dmax1(y0*shat,(dsqrt(rm2(3))+dsqrt(rm2(4)))**2)
      s34max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s34min.ge.s34max) return
      call pick_tanh_generic(-1,s34,1d0,7d0,s34min,s34max,r2,wtps)
c      call pick_tanh_generic(0,s34,1d0,5d0,s34min,s34max,r2,wtps)!better for gg channel

      wtps = wtps/2d0/pi
      call p2generic_qT(0,4d0,r3,0d0,shat,rma2,rmb2,s12,s34,
     .                   p12,p34,pa,pb,wtps)
      if(wtps.eq.0d0) return

c      call pick(1,phi,0d0,twopi,r4,wtps)
      call pick_wwphi(phi,2d0,4d0,0d0,twopi,r4,wtps)

c--XC-- gg channel works better with following setup
      call makeps2com_qT(0,3d0,r5,phi,s34,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap,wtps)
c--XC-- qg channel works better with following setup
c      call makeps2com_qT(0,3d0,r5,phi,s34,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap,wtps)
c--XC-- qq channel works better with following setup
c      call makeps2com_qT(0,4d0,r5,phi,s34,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap,wtps)

*****************************************

      call boostrest(p34,bmat)
      call unboostrest(p34,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p3(i) = 0d0
         p4(i) = 0d0
         p3a(i) = 0d0
         p4a(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
         enddo
      enddo

      if((p3(4).lt.0).or.(p3a(4).lt.0).or.(p4(4).lt.0).or.(p4a(4).lt.0))then
         ifail = 1
         return
      endif


      call pick(1,costh,-1d0,1d0,r6,wtps)

      call pick(1,phi,0d0,twopi,r7,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p1a(i) = p1(i)
         p2a(i) = p2(i)
         pang4(i,1,1) = p1(i)
         pang4(i,2,1) = p2(i)
         pang4(i,3,1) = p3(i)
         pang4(i,4,1) = p4(i)
         pang4(i,1,2) = p1a(i)
         pang4(i,2,2) = p2a(i)
         pang4(i,3,2) = p3a(i)
         pang4(i,4,2) = p4a(i)
      enddo

      call fillinv(4,p,pa,pb,sij4,tij4)
      do i=1,2
         call fillinv(4,pang4(1:4,1:4,i),pa,pb,sijang4(1:4,1:4,i)
     .                                        ,tijang4(1:2,1:4,i))
      enddo

      do i=1,2
         call acceptcuts4(sijang4(1:4,1:4,i),tijang4(1:2,1:4,i),iacc(i))
      enddo
      if (iacc(1)+iacc(2).eq.0) return
      ifail =0
      wt = wtps

 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 105  format('pa:',4f14.6)
 106  format('pb:',4f14.6)

      return
      end


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase5aGG_qT(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          p3pp(4),p3app(4),papp(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p12(4),p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension parb(4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5aGG_qT", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
      else
         Nphase=24
         wtps=wtps/4d0
      endif


* this is (3;4,5;a)
*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to pa axis
* (45)  system is rotated with respect to p3 axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*

      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      r9 = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1


      s12min=y0*s_proc
      s12max=s_proc
      if (s12min.ge.s12max) return
      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return    ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r2,wtps)
      call pick(1,phi,0d0,twopi,r3,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s345max.le.s345min) return

c--XC-- gg channel works better with following setup
      call pick(10,s345,s345min,s345max,r4,wtps)
c--XC-- qg channel works better with following setup
c      call pick(10,s345,s345min,s345max,r4,wtps)
c--XC-- qq channel works better with following setup
c      call pick_tanh(s345,1d0,3d0,s345min,s345max,r4,wtps)


      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
      call pick(2,s45,s45min,s45max,r5,wtps)
      wtps = wtps/2d0/pi

c--XC-- gg channel works better with following setup
      call p2generic_qT(4,0d0,r6,0d0,shat,0d0,0d0,s12,s345,
     .                   p12,p345,pa,pb,wtps)
c--XC-- qg channel works better with following setup
c      call p2generic_qT(4,0d0,r6,0d0,shat,0d0,0d0,s12,s345,
c     .                   p12,p345,pa,pb,wtps)
c--XC-- qq channel works better with following setup
c      call p2generic_qT(0,5d0,r6,0d0,shat,0d0,0d0,s12,s345,
c     .                   p12,p345,pa,pb,wtps)
      if(wtps.eq.0d0) return


* TODO: change of variables only works in the massless case.
*       Add a condition s.t. we return to the old calculations
*       for massive partons

c--XC-- gg channel works better with following setup
      call pick_wphi(phi,1d0,3d0,0d0,twopi,r7,wtps)
c--XC-- gg channels work better with following setup
c      call pick_wphi(phi,1d0,3.5d0,0d0,twopi,r7,wtps)
c--XC-- qq channel works better with following setup
c      call pick_wphi(phi,1d0,4d0,0d0,twopi,r7,wtps)

c--XC-- gg channel works better with following setup
      call makeps2com_qT(0,3d0,r8,phi,s345,rm2(3),s45,p3p,p45p,p3ap,p45ap,wtps)
c--XC-- qg channel works better with following setup
c      call makeps2com_qT(0,3d0,r8,phi,s345,rm2(3),s45,p3p,p45p,p3ap,p45ap,wtps)
c--XC-- qq channel works better with following setup
c      call makeps2com_qT(-1,4d0,r8,phi,s345,rm2(3),s45,p3p,p45p,p3ap,p45ap,wtps)

***********************************************

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo


c--XC-- gg channel works better with following setup
      call pick(1,phi,0d0,twopi,r9,wtps)
c--XC-- qg channel works better with following setup
c      call pick_wphi(phi,1d0,2d0,0d0,twopi,r9,wtps)
c--XC-- qq channel works better with following setup
c      call pick_wphi(phi,1d0,3d0,0d0,twopi,r9,wtps)

      call makeps2com_qT(0,3d0,r10,phi,s45,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap,wtps)

***********************************************


      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo


      if(p345(4).lt.0d0)then
         ifail = 1
         return
      endif

c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,1,1) = p1(i)
         pang5(i,2,1) = p2(i)
         pang5(i,3,1) = p3(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)

         pang5(i,1,2) = p1(i)
         pang5(i,2,2) = p2(i)
         pang5(i,3,2) = p3(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)

         pang5(i,1,3) = p1(i)
         pang5(i,2,3) = p2(i)
         pang5(i,3,3) = p3a(i)
         pang5(i,4,3) = p4t(i)
         pang5(i,5,3) = p5t(i)

         pang5(i,1,4) = p1(i)
         pang5(i,2,4) = p2(i)
         pang5(i,3,4) = p3a(i)
         pang5(i,4,4) = p4ta(i)
         pang5(i,5,4) = p5ta(i)
      enddo

      do i=1,4
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo

      do i=1,4
        call acceptcuts5a(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

      ifail =0
      wt = wtps

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase5bGG_qT(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          pbp(4),pbap(4)
      dimension parb(4),pbrb(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p12(4),p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5bGG_qT", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase = 6
      else
         Nphase = 24
         wtps=wtps/4d0
      endif


* this is (3;a;4,5;b)
*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to pa axis
* (45)  system is rotated with respect to pb axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*

      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      r9 = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1


      s12min=y0*s_proc
      s12max=s_proc
      if (s12min.ge.s12max) return
      call pick_sinv_generic(s12,s12min,s12max,rm12,rg12,r1,wtps,inwa)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the heavy particle
      wtps = wtps/2d0/pi
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r2,wtps)
      call pick(1,phi,0d0,twopi,r3,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s345max.le.s345min) return

c--XC-- gg channel works better with following setup
      call pick_tanh(s345,1d0,5d0,s345min,s345max,r4,wtps)
c--XC-- qg channel works better with following setup
c      call pick_tanh(s345,1d0,5d0,s345min,s345max,r4,wtps)
c--XC-- qq channel works better with following setup
c      call pick_tanh_generic(1,s345,1d0,3d0,s345min,s345max,r4,wtps)

      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
c--XC-- gg channel works better with following setup
      call pick(2,s45,s45min,s45max,r5,wtps)
c--XC-- qg channel works better with following setup
c      call pick(2,s45,s45min,s45max,r5,wtps)
c--XC-- qq channel works better with following setup
c      call pick_tanh_generic(-1,s45,1d0,6d0,s45min,s45max,r5,wtps)


      wtps = wtps/2d0/pi

c--XC-- gg channel works better with following setup
      call p2generic_qT(3,0d0,r6,0d0,shat,0d0,0d0,s12,
     .                   s345,p12,p345,pa,pb,wtps)
c--XC-- qg channel works better with following setup
c      call p2generic_qT_noy0cut(0,5d0,r6,0d0,shat,0d0,0d0,s12,
c     .                   s345,p12,p345,pa,pb,wtps)
c--XC-- qq channel works better with following setup
c      call p2generic_qT(0,3d0,r6,0d0,shat,0d0,0d0,s12,
c     .                   s345,p12,p345,pa,pb,wtps)
      if(wtps.eq.0d0) return

c--XC-- gg channel works better with following setup
      call pick(1,phi,0d0,twopi,r7,wtps)
c--XC-- qg channel works better with following setup
c      call pick_wphi(phi,1d0,3d0,0d0,twopi,r7,wtps)
c--XC-- qq channel works better with following setup
c      call pick_wphi(phi,1d0,3d0,0d0,twopi,r7,wtps)

c--XC-- gg channel works better with following setup
      call makeps2com_qT(0,3d0,r8,phi,s345,rm2(3),s45,p3p,p45p,p3ap,p45ap,wtps)
c--XC-- qg channel works better with following setup
c      call makeps2com_qT_noqTcut(0,2d0,r8,phi,s345,rm2(3),s45,p3p,p45p,p3ap,p45ap,wtps)
c--XC-- qq channel works better with following setup
c      call makeps2com_qT(-1,6d0,r8,phi,s345,rm2(3),s45,p3p,p45p,p3ap,p45ap,wtps)

***********************************************

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      call pick_wphi(phi,1d0,3d0,0d0,twopi,r9,wtps)
c--XC-- gg channel works better with following setup
      call makeps2com_qT(0,3d0,r10,phi,s45,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap,wtps)
c--XC-- qg channel works better with following setup
c      call makeps2com_qT_noqTcut(0,3d0,r10,phi,s45,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap,wtps)
c--XC-- qq channel works better with following setup
c      call makeps2com_qT(0,3d0,r10,phi,s45,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap,wtps)

***********************************************

      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      if(p345(4).lt.0d0)then
         ifail = 1
         return
      endif


c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         pbp(i) = 0d0
         do j=1,4
            pbp(i) = pbp(i) + bmat(i,j)*pb(j)
         enddo
      enddo
      call unrotatetoz(pbp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pbp(j)
         enddo
      enddo

c      write(6,107) v(1:4)

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         pbap(i) = 0d0
         do j=1,4
            pbap(i) = pbap(i) + bmat(i,j)*pb(j)
         enddo
      enddo
      call unrotatetoz(pbap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pbap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,1,1) = p1(i)
         pang5(i,2,1) = p2(i)
         pang5(i,3,1) = p3(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)
         pang5(i,1,2) = p1(i)
         pang5(i,2,2) = p2(i)
         pang5(i,3,2) = p3(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)
         pang5(i,1,3) = p1(i)
         pang5(i,2,3) = p2(i)
         pang5(i,3,3) = p3a(i)
         pang5(i,4,3) = p4t(i)
         pang5(i,5,3) = p5t(i)
         pang5(i,1,4) = p1(i)
         pang5(i,2,4) = p2(i)
         pang5(i,3,4) = p3a(i)
         pang5(i,4,4) = p4ta(i)
         pang5(i,5,4) = p5ta(i)
      enddo

      do i=1,4
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo
      do i=1,4
        call acceptcuts5b(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo

      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return


      ifail =0
      wt = wtps

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

C       subroutine phase5allGG_qT(x,wt,ifail)
C       use Constants_mod, only : pi, twopi
C       use Process_mod, only : s_proc
C       use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
C       implicit real*8(a-h,o-z)
C       dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
C       dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
C      .          p3pp(4),p3app(4),papp(4)
C       dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
C       dimension p3a(4),p4a(4),p5a(4)
C       dimension p12(4),p345(4),p45p(4),p45(4)
C       dimension p345p(4)
C       dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
C       dimension x(15)
C       dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
C       dimension parb(4)
C       common/pmasses/rma2,rmb2,rm2(1:7),shat
C !$omp threadprivate(/pmasses/)
C       common /nwa/rm12,rg12,inwa
C       common/pin/pa(4),pb(4)
C !$omp threadprivate(/pin/)
C       common/pmom/p(4,7)
C !$omp threadprivate(/pmom/)
C       common/pmomang5/pang5(4,5,4)
C !$omp threadprivate(/pmomang5/)
C       common/invar5/sij5(5,5),tij5(2,5)
C !$omp threadprivate(/invar5/)
C       common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
C !$omp threadprivate(/invarang5/)
C       common/tcuts/ymin,y0
C       common /techpar/iang
C       common /Nphase/Nphase
C !$omp threadprivate(/Nphase/)

C       wtps = 1d0

C       if(iang.eq.0)then
C          Nphase=6
C       else
C          Nphase=24
C          wtps=wtps/4d0
C       endif


C * this is (3;4,5;a)
C *
C * phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
C * with sequential splitting (345) -> 3+(45) -> 3+4+5
C *
C * (345) system is rotated with respect to pa axis
C * (45)  system is rotated with respect to pa axis
C *
C * default momenta             : pang(i,j,1)
C * (45) rotated                : pang(i,j,2)
C * (345) rotated               : pang(i,j,3)
C * (345) rotated, (45) rotated : pang(i,j,4)
C *
C * incoming momenta along z-axis, pa is +z
C *
C *
C * massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
C *
C * incoming momenta along z-axis, pa is +z
C *
C       r1 = x(1)
C       r2 = x(2)
C       r3 = x(3)
C       r4 = x(4)
C       r5 = x(5)
C       r6 = x(6)
C       r7 = x(7)
C       r8 = x(8)
C       r9 = x(9)
C       r10 = x(10)
C       wt = 0d0
C       ifail =1


C       s12min=y0*s_proc
C       s12max=s_proc
C       if (s12min.ge.s12max) return
C       call pick(2,s12,s12min,s12max,r1,wtps)

C       if(shat.lt.s12) return ! Insufficient scattering energy to produce the di-photon
C       wtps = wtps/2d0/pi
C       costhmin = -1d0
C       costhmax = 1d0
C       call pick(1,costh,costhmin,costhmax,r2,wtps)
C       call pick(1,phi,0d0,twopi,r3,wtps)
C       call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
C       wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

C       s345min = dmax1(y0*shat,
C      .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
C       s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
C       if (s345max.le.s345min) return

C       call pick(10,s345,s345min,s345max,r4,wtps)

C       wtps = wtps/2d0/pi
C       s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
C       s45max = dmin1(s345,(1d0-y0)*shat)
C       if (s45max.le.s45min) return
C       call pick(2,s45,s45min,s45max,r5,wtps)
C       wtps = wtps/2d0/pi

C       call p2generic_qT(4,0d0,r6,0d0,shat,0d0,0d0,s12,s345,
C      .                   p12,p345,pa,pb,wtps)

C       if(wtps.eq.0d0) return

C       call pick_wphi(phi,1d0,3d0,0d0,twopi,r7,wtps)

C       call makeps2com_qT(0,3d0,r8,phi,s345,rm2(3),s45,p3p,p45p,p3ap,p45ap,wtps)

C ***********************************************

C c---- rotate the (345) system
C       call boostrest(p345,bmat)
C       call unboostrest(p345,ubmat)
C       do i=1,4
C          v(i) = 0d0
C          pap(i) = 0d0
C          do j=1,4
C             pap(i) = pap(i) + bmat(i,j)*pa(j)
C          enddo
C       enddo
C       call unrotatetoz(pap,urmat)
C       do i=1,4
C          do j=1,4
C             fmat(i,j) = 0d0
C             do k=1,4
C                fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
C             enddo
C          enddo
C       enddo
C       do i=1,4
C          p3(i) = 0d0
C          p45(i) = 0d0
C          p3a(i) = 0d0
C          p45a(i) = 0d0
C          v(i) = 0d0
C          do j=1,4
C             p3(i) = p3(i) + fmat(i,j)*p3p(j)
C             p45(i) = p45(i) + fmat(i,j)*p45p(j)
C             p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
C             p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
C             v(i) = v(i) + fmat(i,j)*pap(j)
C          enddo
C       enddo

C      call pick_wphi(phi,1d0,2d0,0d0,twopi,r9,wtps)
C      call makeps2com_qT(0,3d0,r10,phi,s45,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap,wtps)

C ***********************************************


C       call unboostrest(p12,ubmat)
C       do i=1,4
C          p1(i) = 0d0
C          p2(i) = 0d0
C          do j=1,4
C             p1(i) = p1(i) + ubmat(i,j)*p1p(j)
C             p2(i) = p2(i) + ubmat(i,j)*p2p(j)
C          enddo
C       enddo


C       if(p345(4).lt.0d0)then
C          ifail = 1
C          return
C       endif

C c---- rotate the (45) system
C       call boostrest(p45,bmat)
C       call unboostrest(p45,ubmat)
C       do i=1,4
C          v(i) = 0d0
C          papp(i) = 0d0
C          do j=1,4
C             papp(i) = papp(i) + bmat(i,j)*pa(j)
C          enddo
C       enddo
C       call unrotatetoz(papp,urmat)
C       do i=1,4
C          do j=1,4
C             fmat(i,j) = 0d0
C             do k=1,4
C                fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
C             enddo
C          enddo
C       enddo

C       do i=1,4
C          p4(i) = 0d0
C          p5(i) = 0d0
C          p4a(i) = 0d0
C          p5a(i) = 0d0
C          v(i) = 0d0
C          do j=1,4
C             p4(i) = p4(i) + fmat(i,j)*p4p(j)
C             p5(i) = p5(i) + fmat(i,j)*p5p(j)
C             p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
C             p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
C             v(i) = v(i) + fmat(i,j)*pap(j)
C          enddo
C       enddo

C c---- rotate the (45ang) system
C       call boostrest(p45a,bmat)
C       call unboostrest(p45a,ubmat)
C       do i=1,4
C          v(i) = 0d0
C          papp(i) = 0d0
C          do j=1,4
C             papp(i) = papp(i) + bmat(i,j)*pa(j)
C          enddo
C       enddo
C       call unrotatetoz(papp,urmat)
C       do i=1,4
C          do j=1,4
C             fmat(i,j) = 0d0
C             do k=1,4
C                fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
C             enddo
C          enddo
C       enddo
C       do i=1,4
C          p4t(i) = 0d0
C          p5t(i) = 0d0
C          p4ta(i) = 0d0
C          p5ta(i) = 0d0
C          v(i) = 0d0
C          do j=1,4
C             p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
C             p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
C             p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
C             p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
C             v(i) = v(i) + fmat(i,j)*pap(j)
C          enddo
C       enddo

C       do i=1,4
C          p(i,1) = p1(i)
C          p(i,2) = p2(i)
C          p(i,3) = p3(i)
C          p(i,4) = p4(i)
C          p(i,5) = p5(i)
C          pang5(i,1,1) = p1(i)
C          pang5(i,2,1) = p2(i)
C          pang5(i,3,1) = p3(i)
C          pang5(i,4,1) = p4(i)
C          pang5(i,5,1) = p5(i)

C          pang5(i,1,2) = p1(i)
C          pang5(i,2,2) = p2(i)
C          pang5(i,3,2) = p3(i)
C          pang5(i,4,2) = p4a(i)
C          pang5(i,5,2) = p5a(i)

C          pang5(i,1,3) = p1(i)
C          pang5(i,2,3) = p2(i)
C          pang5(i,3,3) = p3a(i)
C          pang5(i,4,3) = p4t(i)
C          pang5(i,5,3) = p5t(i)

C          pang5(i,1,4) = p1(i)
C          pang5(i,2,4) = p2(i)
C          pang5(i,3,4) = p3a(i)
C          pang5(i,4,4) = p4ta(i)
C          pang5(i,5,4) = p5ta(i)
C       enddo

C       do i=1,4
C          call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
C      .                                        ,tijang5(1:2,1:5,i))
C       enddo

C       do i=1,4
C         call acceptcuts5all(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
C c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
C       enddo
C       if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

C       ifail =0
C       wt = wtps

C  101  format('p1:',4f14.9)
C  102  format('p2:',4f14.9)
C  103  format('p3:',4f14.9)
C  104  format('p4:',4f14.9)
C  105  format('p5:',4f14.9)
C  106  format('pa:',4f14.9)
C  107  format('pb:',4f14.9)
C  109  format('pp:',4f14.9)

C       return
C       end

