      function sigS2jetfc(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use Charges_EW_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigS2jetfc=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      jflag=.false.
      ix=1
      ix_chan=1

c--- g g to g g g g      
      if (qactive_chan(191).and.qselect_chan(191)) then
        current_chan = 191
        ip1_chan     = 0
        ip2_chan     = 0
        wt = ggA6g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q g to g g g q      
      if (qactive_chan(192).and.qselect_chan(192)) then
        current_chan = 192
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgB4g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to g g g g     
      if (qactive_chan(193).and.qselect_chan(193)) then
        current_chan = 193
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbB4g0S(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- g q to g g g q      
      if (qactive_chan(194).and.qselect_chan(194)) then
        current_chan = 194
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gqB4g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to g g g g     
      if (qactive_chan(195).and.qselect_chan(195)) then
        current_chan = 195
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqB4g0S(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- g g to qb g g q     
      if (qactive_chan(196).and.qselect_chan(196)) then
        current_chan = 196
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = ggB4g0S(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g qb to qb g g g    
      if (qactive_chan(197).and.qselect_chan(197)) then
        current_chan = 197
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gqbB4g0S(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb g to qb g g g    
      if (qactive_chan(198).and.qselect_chan(198)) then
        current_chan = 198
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgB4g0S(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- q qb to Qb Q g g    
      if (qactive_chan(199).and.qselect_chan(199)) then
        current_chan = 199
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = qqbsC2g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q Q g g      
      if (qactive_chan(200).and.qselect_chan(200)) then
        current_chan = 200
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qqpsC2g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q Qb g g    
      if (qactive_chan(201).and.qselect_chan(201)) then
        current_chan = 201
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qqpbsC2g0XS(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- q g to q Qb Q g     
      if (qactive_chan(202).and.qselect_chan(202)) then
        current_chan = 202
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = qgsC2g0XS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb q to Qb Q g g    
      if (qactive_chan(203).and.qselect_chan(203)) then
        current_chan = 203
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = qbqsC2g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g q to q Qb Q g     
      if (qactive_chan(204).and.qselect_chan(204)) then
        current_chan = 204
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = gqsC2g0XS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb Q g g    
      if (qactive_chan(205).and.qselect_chan(205)) then
        current_chan = 205
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpsC2g0XS(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb Qb g g  
      if (qactive_chan(206).and.qselect_chan(206)) then
        current_chan = 206
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpbsC2g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb g to qb Qb Q g   
      if (qactive_chan(207).and.qselect_chan(207)) then
        current_chan = 207
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = qbgsC2g0XS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g qb to qb Qb Q g   
      if (qactive_chan(208).and.qselect_chan(208)) then
        current_chan = 208
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = gqbsC2g0XS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- g g to qb q Qb Q    
      if (qactive_chan(209).and.qselect_chan(209)) then
        current_chan = 209
        ip1_chan     = 0
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = ggsC2g0XS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- q qb to Qb Q Rb R   
      if (qactive_chan(210).and.qselect_chan(210)) then
        current_chan = 210
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = qqbE0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q Q Rb R     
      if (qactive_chan(211).and.qselect_chan(211)) then
        current_chan = 211
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qqpE0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q Qb Rb R   
      if (qactive_chan(212).and.qselect_chan(212)) then
        current_chan = 212
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qqpbE0g0XS(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to Qb Q Rb R   
      if (qactive_chan(213).and.qselect_chan(213)) then
        current_chan = 213
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = qbqE0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb Q Rb R   
      if (qactive_chan(214).and.qselect_chan(214)) then
        current_chan = 214
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpE0g0XS(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb Qb Rb R 
      if (qactive_chan(215).and.qselect_chan(215)) then
        current_chan = 215
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpbE0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- g g to g g g g      
      if (qactive_chan(216).and.qselect_chan(216)) then
        current_chan = 216
        ip1_chan     = 0
        ip2_chan     = 0
        wt = ggAt6g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q g to g g g q      
      if (qactive_chan(217).and.qselect_chan(217)) then
        current_chan = 217
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgBt4g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to g g g g     
      if (qactive_chan(218).and.qselect_chan(218)) then
        current_chan = 218
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbBt4g0S(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- g q to g g g q      
      if (qactive_chan(219).and.qselect_chan(219)) then
        current_chan = 219
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gqBt4g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to g g g g     
      if (qactive_chan(220).and.qselect_chan(220)) then
        current_chan = 220
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqBt4g0S(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- g g to qb g g q     
      if (qactive_chan(221).and.qselect_chan(221)) then
        current_chan = 221
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = ggBt4g0S(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g qb to qb g g g    
      if (qactive_chan(222).and.qselect_chan(222)) then
        current_chan = 222
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gqbBt4g0S(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb g to qb g g g    
      if (qactive_chan(223).and.qselect_chan(223)) then
        current_chan = 223
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgBt4g0S(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- q gt to gt g g q    
      if (qactive_chan(224).and.qselect_chan(224)) then
        current_chan = 224
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgtBtt4g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to gt gt g g   
      if (qactive_chan(225).and.qselect_chan(225)) then
        current_chan = 225
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbBtt4g0S(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- gt q to gt g g q    
      if (qactive_chan(226).and.qselect_chan(226)) then
        current_chan = 226
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gtqBtt4g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to gt gt g g   
      if (qactive_chan(227).and.qselect_chan(227)) then
        current_chan = 227
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqBtt4g0S(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb gt g g  
      if (qactive_chan(228).and.qselect_chan(228)) then
        current_chan = 228
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gtqbBtt4g0S(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb gt g g  
      if (qactive_chan(229).and.qselect_chan(229)) then
        current_chan = 229
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgtBtt4g0S(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- g g to qb gt gt q   
      if (qactive_chan(230).and.qselect_chan(230)) then
        current_chan = 230
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = ggBtt4g0S(3,4,5,1,2,6)
        wtsum = wtsum + wt
      endif
c--- q gt to gt gt gt q  
      if (qactive_chan(231).and.qselect_chan(231)) then
        current_chan = 231
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgtBttt4g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to gt gt gt gt 
      if (qactive_chan(232).and.qselect_chan(232)) then
        current_chan = 232
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbBttt4g0S(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- gt q to gt gt gt q  
      if (qactive_chan(233).and.qselect_chan(233)) then
        current_chan = 233
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gtqBttt4g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to gt gt gt gt 
      if (qactive_chan(234).and.qselect_chan(234)) then
        current_chan = 234
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqBttt4g0S(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb gt gt q 
      if (qactive_chan(235).and.qselect_chan(235)) then
        current_chan = 235
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = gtgtBttt4g0S(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb gt gt gt 
      if (qactive_chan(236).and.qselect_chan(236)) then
        current_chan = 236
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gtqbBttt4g0S(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb gt gt gt 
      if (qactive_chan(237).and.qselect_chan(237)) then
        current_chan = 237
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgtBttt4g0S(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- q gt to gt gt gt q  
      if (qactive_chan(238).and.qselect_chan(238)) then
        current_chan = 238
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgtBttt4g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to gt gt gt gt 
      if (qactive_chan(239).and.qselect_chan(239)) then
        current_chan = 239
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbBttt4g0S(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- gt q to gt gt gt q  
      if (qactive_chan(240).and.qselect_chan(240)) then
        current_chan = 240
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gtqBttt4g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to gt gt gt gt 
      if (qactive_chan(241).and.qselect_chan(241)) then
        current_chan = 241
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqBttt4g0S(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb gt gt q 
      if (qactive_chan(242).and.qselect_chan(242)) then
        current_chan = 242
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = gtgtBttt4g0S(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb gt gt gt 
      if (qactive_chan(243).and.qselect_chan(243)) then
        current_chan = 243
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gtqbBttt4g0S(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb gt gt gt 
      if (qactive_chan(244).and.qselect_chan(244)) then
        current_chan = 244
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgtBttt4g0S(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- q gt to gt gt gt q  
      if (qactive_chan(245).and.qselect_chan(245)) then
        current_chan = 245
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgtBttt4g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to gt gt gt gt 
      if (qactive_chan(246).and.qselect_chan(246)) then
        current_chan = 246
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbBttt4g0S(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- gt q to gt gt gt q  
      if (qactive_chan(247).and.qselect_chan(247)) then
        current_chan = 247
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gtqBttt4g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to gt gt gt gt 
      if (qactive_chan(248).and.qselect_chan(248)) then
        current_chan = 248
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqBttt4g0S(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb gt gt q 
      if (qactive_chan(249).and.qselect_chan(249)) then
        current_chan = 249
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = gtgtBttt4g0S(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb gt gt gt 
      if (qactive_chan(250).and.qselect_chan(250)) then
        current_chan = 250
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gtqbBttt4g0S(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb gt gt gt 
      if (qactive_chan(251).and.qselect_chan(251)) then
        current_chan = 251
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgtBttt4g0S(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- q gt to gt gt gt q  
      if (qactive_chan(252).and.qselect_chan(252)) then
        current_chan = 252
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgtR4g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to gt gt gt gt 
      if (qactive_chan(253).and.qselect_chan(253)) then
        current_chan = 253
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbR4g0S(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- gt q to gt gt gt q  
      if (qactive_chan(254).and.qselect_chan(254)) then
        current_chan = 254
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gtqR4g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to gt gt gt gt 
      if (qactive_chan(255).and.qselect_chan(255)) then
        current_chan = 255
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqR4g0S(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb gt gt q 
      if (qactive_chan(256).and.qselect_chan(256)) then
        current_chan = 256
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = gtgtR4g0S(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb gt gt gt 
      if (qactive_chan(257).and.qselect_chan(257)) then
        current_chan = 257
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gtqbR4g0S(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb gt gt gt 
      if (qactive_chan(258).and.qselect_chan(258)) then
        current_chan = 258
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgtR4g0S(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- q qb to Qb Q gt gt  
      if (qactive_chan(259).and.qselect_chan(259)) then
        current_chan = 259
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = qqbsCt2g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q Q gt gt    
      if (qactive_chan(260).and.qselect_chan(260)) then
        current_chan = 260
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qqpsCt2g0S(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q Qb gt gt  
      if (qactive_chan(261).and.qselect_chan(261)) then
        current_chan = 261
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qqpbsCt2g0S(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- q gt to q Qb Q gt   
      if (qactive_chan(262).and.qselect_chan(262)) then
        current_chan = 262
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = qgtsCt2g0S(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb q to Qb Q gt gt  
      if (qactive_chan(263).and.qselect_chan(263)) then
        current_chan = 263
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = qbqsCt2g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt q to q Qb Q gt   
      if (qactive_chan(264).and.qselect_chan(264)) then
        current_chan = 264
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = gtqsCt2g0S(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb Q gt gt  
      if (qactive_chan(265).and.qselect_chan(265)) then
        current_chan = 265
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpsCt2g0S(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb Qb gt gt 
      if (qactive_chan(266).and.qselect_chan(266)) then
        current_chan = 266
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpbsCt2g0S(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb Qb Q gt 
      if (qactive_chan(267).and.qselect_chan(267)) then
        current_chan = 267
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = qbgtsCt2g0S(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb Qb Q gt 
      if (qactive_chan(268).and.qselect_chan(268)) then
        current_chan = 268
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = gtqbsCt2g0S(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb q Qb Q  
      if (qactive_chan(269).and.qselect_chan(269)) then
        current_chan = 269
        ip1_chan     = 0
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = gtgtsCt2g0S(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- q qb to Qb Q gt gt  
      if (qactive_chan(270).and.qselect_chan(270)) then
        current_chan = 270
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = qqbsCtt2g0S(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q Q gt gt    
      if (qactive_chan(271).and.qselect_chan(271)) then
        current_chan = 271
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qqpsCtt2g0S(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q Qb gt gt  
      if (qactive_chan(272).and.qselect_chan(272)) then
        current_chan = 272
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qqpbsCtt2g0S(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- q gt to q Qb Q gt   
      if (qactive_chan(273).and.qselect_chan(273)) then
        current_chan = 273
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = qgtsCtt2g0S(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb q to Qb Q gt gt  
      if (qactive_chan(274).and.qselect_chan(274)) then
        current_chan = 274
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = qbqsCtt2g0S(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt q to q Qb Q gt   
      if (qactive_chan(275).and.qselect_chan(275)) then
        current_chan = 275
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = gtqsCtt2g0S(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb Q gt gt  
      if (qactive_chan(276).and.qselect_chan(276)) then
        current_chan = 276
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpsCtt2g0S(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb Qb gt gt 
      if (qactive_chan(277).and.qselect_chan(277)) then
        current_chan = 277
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpbsCtt2g0S(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb Qb Q gt 
      if (qactive_chan(278).and.qselect_chan(278)) then
        current_chan = 278
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = qbgtsCtt2g0S(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb Qb Q gt 
      if (qactive_chan(279).and.qselect_chan(279)) then
        current_chan = 279
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = gtqbsCtt2g0S(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb q Qb Q  
      if (qactive_chan(280).and.qselect_chan(280)) then
        current_chan = 280
        ip1_chan     = 0
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 4
        wt = gtgtsCtt2g0S(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q gt gt  
      if (qactive_chan(281).and.qselect_chan(281)) then
        current_chan = 281
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbD2g0fullS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q gt gt    
      if (qactive_chan(282).and.qselect_chan(282)) then
        current_chan = 282
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqD2g0fullS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q gt to q qb q gt   
      if (qactive_chan(283).and.qselect_chan(283)) then
        current_chan = 283
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = qgtD2g0fullS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q gt gt  
      if (qactive_chan(284).and.qselect_chan(284)) then
        current_chan = 284
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqD2g0fullS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt q to q qb q gt   
      if (qactive_chan(285).and.qselect_chan(285)) then
        current_chan = 285
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = gtqD2g0fullS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb gt gt 
      if (qactive_chan(286).and.qselect_chan(286)) then
        current_chan = 286
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbD2g0fullS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb qb q gt 
      if (qactive_chan(287).and.qselect_chan(287)) then
        current_chan = 287
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = qbgtD2g0fullS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb qb q gt 
      if (qactive_chan(288).and.qselect_chan(288)) then
        current_chan = 288
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = gtqbD2g0fullS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb q qb q  
      if (qactive_chan(289).and.qselect_chan(289)) then
        current_chan = 289
        ip1_chan     = 0
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = gtgtD2g0fullS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q gt gt  
      if (qactive_chan(290).and.qselect_chan(290)) then
        current_chan = 290
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbDt2g0fullS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q gt gt    
      if (qactive_chan(291).and.qselect_chan(291)) then
        current_chan = 291
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqDt2g0fullS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q gt to q qb q gt   
      if (qactive_chan(292).and.qselect_chan(292)) then
        current_chan = 292
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = qgtDt2g0fullS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q gt gt  
      if (qactive_chan(293).and.qselect_chan(293)) then
        current_chan = 293
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqDt2g0fullS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt q to q qb q gt   
      if (qactive_chan(294).and.qselect_chan(294)) then
        current_chan = 294
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = gtqDt2g0fullS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb gt gt 
      if (qactive_chan(295).and.qselect_chan(295)) then
        current_chan = 295
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbDt2g0fullS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb qb q gt 
      if (qactive_chan(296).and.qselect_chan(296)) then
        current_chan = 296
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = qbgtDt2g0fullS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb qb q gt 
      if (qactive_chan(297).and.qselect_chan(297)) then
        current_chan = 297
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = gtqbDt2g0fullS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb q qb q  
      if (qactive_chan(298).and.qselect_chan(298)) then
        current_chan = 298
        ip1_chan     = 0
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = gtgtDt2g0fullS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q gt gt  
      if (qactive_chan(299).and.qselect_chan(299)) then
        current_chan = 299
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbDtt2g0fullS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q gt gt    
      if (qactive_chan(300).and.qselect_chan(300)) then
        current_chan = 300
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqDtt2g0fullS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q gt to q qb q gt   
      if (qactive_chan(301).and.qselect_chan(301)) then
        current_chan = 301
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = qgtDtt2g0fullS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q gt gt  
      if (qactive_chan(302).and.qselect_chan(302)) then
        current_chan = 302
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqDtt2g0fullS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt q to q qb q gt   
      if (qactive_chan(303).and.qselect_chan(303)) then
        current_chan = 303
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = gtqDtt2g0fullS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb gt gt 
      if (qactive_chan(304).and.qselect_chan(304)) then
        current_chan = 304
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbDtt2g0fullS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb qb q gt 
      if (qactive_chan(305).and.qselect_chan(305)) then
        current_chan = 305
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = qbgtDtt2g0fullS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb qb q gt 
      if (qactive_chan(306).and.qselect_chan(306)) then
        current_chan = 306
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = gtqbDtt2g0fullS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb q qb q  
      if (qactive_chan(307).and.qselect_chan(307)) then
        current_chan = 307
        ip1_chan     = 0
        ip2_chan     = 0
        nfC1 = 3
        nfC2 = 3
        wt = gtgtDtt2g0fullS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- q qb to Qb Q Rb R   
      if (qactive_chan(308).and.qselect_chan(308)) then
        current_chan = 308
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = qqbEt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q Q Rb R     
      if (qactive_chan(309).and.qselect_chan(309)) then
        current_chan = 309
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qqpEt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q Qb Rb R   
      if (qactive_chan(310).and.qselect_chan(310)) then
        current_chan = 310
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qqpbEt0g0XS(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to Qb Q Rb R   
      if (qactive_chan(311).and.qselect_chan(311)) then
        current_chan = 311
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = qbqEt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb Q Rb R   
      if (qactive_chan(312).and.qselect_chan(312)) then
        current_chan = 312
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpEt0g0XS(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb Qb Rb R 
      if (qactive_chan(313).and.qselect_chan(313)) then
        current_chan = 313
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpbEt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to Qb Q Rb R   
      if (qactive_chan(314).and.qselect_chan(314)) then
        current_chan = 314
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = qqbEtt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q Q Rb R     
      if (qactive_chan(315).and.qselect_chan(315)) then
        current_chan = 315
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qqpEtt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q Qb Rb R   
      if (qactive_chan(316).and.qselect_chan(316)) then
        current_chan = 316
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qqpbEtt0g0XS(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to Qb Q Rb R   
      if (qactive_chan(317).and.qselect_chan(317)) then
        current_chan = 317
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = qbqEtt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb Q Rb R   
      if (qactive_chan(318).and.qselect_chan(318)) then
        current_chan = 318
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpEtt0g0XS(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb Qb Rb R 
      if (qactive_chan(319).and.qselect_chan(319)) then
        current_chan = 319
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpbEtt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q Qb Q   
      if (qactive_chan(320).and.qselect_chan(320)) then
        current_chan = 320
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbF0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q Qb Q     
      if (qactive_chan(321).and.qselect_chan(321)) then
        current_chan = 321
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqF0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q qb q Q     
      if (qactive_chan(322).and.qselect_chan(322)) then
        current_chan = 322
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qqpF0g0XS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q qb q Qb   
      if (qactive_chan(323).and.qselect_chan(323)) then
        current_chan = 323
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qqpbF0g0XS(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q Qb Q   
      if (qactive_chan(324).and.qselect_chan(324)) then
        current_chan = 324
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqF0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- Q q to q qb q Q     
      if (qactive_chan(325).and.qselect_chan(325)) then
        current_chan = 325
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpqF0g0XS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb q to q qb q Qb   
      if (qactive_chan(326).and.qselect_chan(326)) then
        current_chan = 326
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqF0g0XS(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb Qb Q 
      if (qactive_chan(327).and.qselect_chan(327)) then
        current_chan = 327
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbF0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb qb q Q   
      if (qactive_chan(328).and.qselect_chan(328)) then
        current_chan = 328
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpF0g0XS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb qb q Qb 
      if (qactive_chan(329).and.qselect_chan(329)) then
        current_chan = 329
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpbF0g0XS(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- Q qb to qb qb q Q   
      if (qactive_chan(330).and.qselect_chan(330)) then
        current_chan = 330
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpqbF0g0XS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb qb to qb qb q Qb 
      if (qactive_chan(331).and.qselect_chan(331)) then
        current_chan = 331
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqbF0g0XS(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- Q Qb to qb q qb q   
      if (qactive_chan(332).and.qselect_chan(332)) then
        current_chan = 332
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qpqpbF0g0XS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- Qb Q to qb q qb q   
      if (qactive_chan(333).and.qselect_chan(333)) then
        current_chan = 333
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qpbqpF0g0XS(3,4,5,6,2,1)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q Qb Q   
      if (qactive_chan(334).and.qselect_chan(334)) then
        current_chan = 334
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbFt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q Qb Q     
      if (qactive_chan(335).and.qselect_chan(335)) then
        current_chan = 335
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqFt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q qb q Q     
      if (qactive_chan(336).and.qselect_chan(336)) then
        current_chan = 336
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qqpFt0g0XS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q qb q Qb   
      if (qactive_chan(337).and.qselect_chan(337)) then
        current_chan = 337
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qqpbFt0g0XS(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q Qb Q   
      if (qactive_chan(338).and.qselect_chan(338)) then
        current_chan = 338
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqFt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- Q q to q qb q Q     
      if (qactive_chan(339).and.qselect_chan(339)) then
        current_chan = 339
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpqFt0g0XS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb q to q qb q Qb   
      if (qactive_chan(340).and.qselect_chan(340)) then
        current_chan = 340
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqFt0g0XS(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb Qb Q 
      if (qactive_chan(341).and.qselect_chan(341)) then
        current_chan = 341
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbFt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb qb q Q   
      if (qactive_chan(342).and.qselect_chan(342)) then
        current_chan = 342
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpFt0g0XS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb qb q Qb 
      if (qactive_chan(343).and.qselect_chan(343)) then
        current_chan = 343
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpbFt0g0XS(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- Q qb to qb qb q Q   
      if (qactive_chan(344).and.qselect_chan(344)) then
        current_chan = 344
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpqbFt0g0XS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb qb to qb qb q Qb 
      if (qactive_chan(345).and.qselect_chan(345)) then
        current_chan = 345
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqbFt0g0XS(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- Q Qb to qb q qb q   
      if (qactive_chan(346).and.qselect_chan(346)) then
        current_chan = 346
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qpqpbFt0g0XS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- Qb Q to qb q qb q   
      if (qactive_chan(347).and.qselect_chan(347)) then
        current_chan = 347
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qpbqpFt0g0XS(3,4,5,6,2,1)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q Qb Q   
      if (qactive_chan(348).and.qselect_chan(348)) then
        current_chan = 348
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbFt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q Qb Q     
      if (qactive_chan(349).and.qselect_chan(349)) then
        current_chan = 349
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqFt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q qb q Q     
      if (qactive_chan(350).and.qselect_chan(350)) then
        current_chan = 350
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qqpFt0g0XS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q qb q Qb   
      if (qactive_chan(351).and.qselect_chan(351)) then
        current_chan = 351
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qqpbFt0g0XS(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q Qb Q   
      if (qactive_chan(352).and.qselect_chan(352)) then
        current_chan = 352
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqFt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- Q q to q qb q Q     
      if (qactive_chan(353).and.qselect_chan(353)) then
        current_chan = 353
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpqFt0g0XS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb q to q qb q Qb   
      if (qactive_chan(354).and.qselect_chan(354)) then
        current_chan = 354
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqFt0g0XS(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb Qb Q 
      if (qactive_chan(355).and.qselect_chan(355)) then
        current_chan = 355
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbFt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb qb q Q   
      if (qactive_chan(356).and.qselect_chan(356)) then
        current_chan = 356
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpFt0g0XS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb qb q Qb 
      if (qactive_chan(357).and.qselect_chan(357)) then
        current_chan = 357
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpbFt0g0XS(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- Q qb to qb qb q Q   
      if (qactive_chan(358).and.qselect_chan(358)) then
        current_chan = 358
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpqbFt0g0XS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb qb to qb qb q Qb 
      if (qactive_chan(359).and.qselect_chan(359)) then
        current_chan = 359
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqbFt0g0XS(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- Q Qb to qb q qb q   
      if (qactive_chan(360).and.qselect_chan(360)) then
        current_chan = 360
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qpqpbFt0g0XS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- Qb Q to qb q qb q   
      if (qactive_chan(361).and.qselect_chan(361)) then
        current_chan = 361
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qpbqpFt0g0XS(3,4,5,6,2,1)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q Qb Q   
      if (qactive_chan(362).and.qselect_chan(362)) then
        current_chan = 362
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbFtt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q Qb Q     
      if (qactive_chan(363).and.qselect_chan(363)) then
        current_chan = 363
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqFtt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q qb q Q     
      if (qactive_chan(364).and.qselect_chan(364)) then
        current_chan = 364
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qqpFtt0g0XS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q qb q Qb   
      if (qactive_chan(365).and.qselect_chan(365)) then
        current_chan = 365
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qqpbFtt0g0XS(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q Qb Q   
      if (qactive_chan(366).and.qselect_chan(366)) then
        current_chan = 366
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqFtt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- Q q to q qb q Q     
      if (qactive_chan(367).and.qselect_chan(367)) then
        current_chan = 367
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpqFtt0g0XS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb q to q qb q Qb   
      if (qactive_chan(368).and.qselect_chan(368)) then
        current_chan = 368
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqFtt0g0XS(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb Qb Q 
      if (qactive_chan(369).and.qselect_chan(369)) then
        current_chan = 369
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbFtt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb qb q Q   
      if (qactive_chan(370).and.qselect_chan(370)) then
        current_chan = 370
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpFtt0g0XS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb qb q Qb 
      if (qactive_chan(371).and.qselect_chan(371)) then
        current_chan = 371
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpbFtt0g0XS(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- Q qb to qb qb q Q   
      if (qactive_chan(372).and.qselect_chan(372)) then
        current_chan = 372
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpqbFtt0g0XS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb qb to qb qb q Qb 
      if (qactive_chan(373).and.qselect_chan(373)) then
        current_chan = 373
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqbFtt0g0XS(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- Q Qb to qb q qb q   
      if (qactive_chan(374).and.qselect_chan(374)) then
        current_chan = 374
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qpqpbFtt0g0XS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- Qb Q to qb q qb q   
      if (qactive_chan(375).and.qselect_chan(375)) then
        current_chan = 375
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qpbqpFtt0g0XS(3,4,5,6,2,1)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q Qb Q   
      if (qactive_chan(376).and.qselect_chan(376)) then
        current_chan = 376
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbFtt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q Qb Q     
      if (qactive_chan(377).and.qselect_chan(377)) then
        current_chan = 377
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqFtt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to q qb q Q     
      if (qactive_chan(378).and.qselect_chan(378)) then
        current_chan = 378
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qqpFtt0g0XS(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to q qb q Qb   
      if (qactive_chan(379).and.qselect_chan(379)) then
        current_chan = 379
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qqpbFtt0g0XS(1,3,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q Qb Q   
      if (qactive_chan(380).and.qselect_chan(380)) then
        current_chan = 380
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqFtt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- Q q to q qb q Q     
      if (qactive_chan(381).and.qselect_chan(381)) then
        current_chan = 381
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpqFtt0g0XS(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb q to q qb q Qb   
      if (qactive_chan(382).and.qselect_chan(382)) then
        current_chan = 382
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqFtt0g0XS(2,3,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb Qb Q 
      if (qactive_chan(383).and.qselect_chan(383)) then
        current_chan = 383
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbFtt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb qb q Q   
      if (qactive_chan(384).and.qselect_chan(384)) then
        current_chan = 384
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpFtt0g0XS(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb qb q Qb 
      if (qactive_chan(385).and.qselect_chan(385)) then
        current_chan = 385
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qbqpbFtt0g0XS(3,1,4,5,6,2)
        wtsum = wtsum + wt
      endif
c--- Q qb to qb qb q Q   
      if (qactive_chan(386).and.qselect_chan(386)) then
        current_chan = 386
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpqbFtt0g0XS(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- Qb qb to qb qb q Qb 
      if (qactive_chan(387).and.qselect_chan(387)) then
        current_chan = 387
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 3
        wt = qpbqbFtt0g0XS(3,2,4,5,6,1)
        wtsum = wtsum + wt
      endif
c--- Q Qb to qb q qb q   
      if (qactive_chan(388).and.qselect_chan(388)) then
        current_chan = 388
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qpqpbFtt0g0XS(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- Qb Q to qb q qb q   
      if (qactive_chan(389).and.qselect_chan(389)) then
        current_chan = 389
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qpbqpFtt0g0XS(3,4,5,6,2,1)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q qb q   
      if (qactive_chan(390).and.qselect_chan(390)) then
        current_chan = 390
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbG0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q qb q     
      if (qactive_chan(391).and.qselect_chan(391)) then
        current_chan = 391
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqG0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q qb q   
      if (qactive_chan(392).and.qselect_chan(392)) then
        current_chan = 392
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqG0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb qb q 
      if (qactive_chan(393).and.qselect_chan(393)) then
        current_chan = 393
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbG0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q qb q   
      if (qactive_chan(394).and.qselect_chan(394)) then
        current_chan = 394
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbGt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q qb q     
      if (qactive_chan(395).and.qselect_chan(395)) then
        current_chan = 395
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqGt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q qb q   
      if (qactive_chan(396).and.qselect_chan(396)) then
        current_chan = 396
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqGt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb qb q 
      if (qactive_chan(397).and.qselect_chan(397)) then
        current_chan = 397
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbGt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q qb q   
      if (qactive_chan(398).and.qselect_chan(398)) then
        current_chan = 398
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbGtt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q qb q     
      if (qactive_chan(399).and.qselect_chan(399)) then
        current_chan = 399
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqGtt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q qb q   
      if (qactive_chan(400).and.qselect_chan(400)) then
        current_chan = 400
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqGtt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb qb q 
      if (qactive_chan(401).and.qselect_chan(401)) then
        current_chan = 401
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbGtt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q qb q   
      if (qactive_chan(402).and.qselect_chan(402)) then
        current_chan = 402
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbGtt0g0XS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q qb q     
      if (qactive_chan(403).and.qselect_chan(403)) then
        current_chan = 403
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqGtt0g0XS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q qb q   
      if (qactive_chan(404).and.qselect_chan(404)) then
        current_chan = 404
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqGtt0g0XS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb qb q 
      if (qactive_chan(405).and.qselect_chan(405)) then
        current_chan = 405
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbGtt0g0XS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
      sigS2jetfc=sigS2jetfc+rnorm*wtsum

      return
      end
