      function sigT2jetfc(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use Charges_EW_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigT2jetfc=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- g g to g g g        
        if (qactive_chan(406).and.qselect_chan(406)) then
          current_chan = 406
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggA5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(407).and.qselect_chan(407)) then
          current_chan = 407
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqA5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(408).and.qselect_chan(408)) then
          current_chan = 408
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbA5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(409).and.qselect_chan(409)) then
          current_chan = 409
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgA5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(410).and.qselect_chan(410)) then
          current_chan = 410
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgA5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g g        
        if (qactive_chan(411).and.qselect_chan(411)) then
          current_chan = 411
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggAh5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(412).and.qselect_chan(412)) then
          current_chan = 412
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqAh5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(413).and.qselect_chan(413)) then
          current_chan = 413
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbAh5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(414).and.qselect_chan(414)) then
          current_chan = 414
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgAh5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(415).and.qselect_chan(415)) then
          current_chan = 415
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgAh5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g g q        
        if (qactive_chan(416).and.qselect_chan(416)) then
          current_chan = 416
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgB3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g g       
        if (qactive_chan(417).and.qselect_chan(417)) then
          current_chan = 417
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbB3g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g g q        
        if (qactive_chan(418).and.qselect_chan(418)) then
          current_chan = 418
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqB3g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g g       
        if (qactive_chan(419).and.qselect_chan(419)) then
          current_chan = 419
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqB3g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb g q       
        if (qactive_chan(420).and.qselect_chan(420)) then
          current_chan = 420
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggB3g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g g      
        if (qactive_chan(421).and.qselect_chan(421)) then
          current_chan = 421
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbB3g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g g      
        if (qactive_chan(422).and.qselect_chan(422)) then
          current_chan = 422
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgB3g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(423).and.qselect_chan(423)) then
          current_chan = 423
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpB3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(424).and.qselect_chan(424)) then
          current_chan = 424
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbB3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(425).and.qselect_chan(425)) then
          current_chan = 425
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpB3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(426).and.qselect_chan(426)) then
          current_chan = 426
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbB3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g g q        
        if (qactive_chan(427).and.qselect_chan(427)) then
          current_chan = 427
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgBh3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g g       
        if (qactive_chan(428).and.qselect_chan(428)) then
          current_chan = 428
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBh3g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g g q        
        if (qactive_chan(429).and.qselect_chan(429)) then
          current_chan = 429
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqBh3g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g g       
        if (qactive_chan(430).and.qselect_chan(430)) then
          current_chan = 430
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBh3g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb g q       
        if (qactive_chan(431).and.qselect_chan(431)) then
          current_chan = 431
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggBh3g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g g      
        if (qactive_chan(432).and.qselect_chan(432)) then
          current_chan = 432
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbBh3g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g g      
        if (qactive_chan(433).and.qselect_chan(433)) then
          current_chan = 433
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgBh3g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(434).and.qselect_chan(434)) then
          current_chan = 434
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpBh3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(435).and.qselect_chan(435)) then
          current_chan = 435
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBh3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(436).and.qselect_chan(436)) then
          current_chan = 436
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBh3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(437).and.qselect_chan(437)) then
          current_chan = 437
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBh3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Qb Q g      
        if (qactive_chan(438).and.qselect_chan(438)) then
          current_chan = 438
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbsC1g1XT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to q Q g        
        if (qactive_chan(439).and.qselect_chan(439)) then
          current_chan = 439
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpsC1g1XT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to q Qb g      
        if (qactive_chan(440).and.qselect_chan(440)) then
          current_chan = 440
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbsC1g1XT(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q Qb Q       
        if (qactive_chan(441).and.qselect_chan(441)) then
          current_chan = 441
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgsC1g1XT(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Qb Q g      
        if (qactive_chan(442).and.qselect_chan(442)) then
          current_chan = 442
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqsC1g1XT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q Qb Q       
        if (qactive_chan(443).and.qselect_chan(443)) then
          current_chan = 443
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqsC1g1XT(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q g      
        if (qactive_chan(444).and.qselect_chan(444)) then
          current_chan = 444
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpsC1g1XT(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb g    
        if (qactive_chan(445).and.qselect_chan(445)) then
          current_chan = 445
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbsC1g1XT(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb Qb Q     
        if (qactive_chan(446).and.qselect_chan(446)) then
          current_chan = 446
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgsC1g1XT(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb Qb Q     
        if (qactive_chan(447).and.qselect_chan(447)) then
          current_chan = 447
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbsC1g1XT(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(448).and.qselect_chan(448)) then
          current_chan = 448
          ip1_chan     = 0
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = ggsC1g1XT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Qb Q g      
        if (qactive_chan(449).and.qselect_chan(449)) then
          current_chan = 449
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbsCh1g1XT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to q Q g        
        if (qactive_chan(450).and.qselect_chan(450)) then
          current_chan = 450
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpsCh1g1XT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to q Qb g      
        if (qactive_chan(451).and.qselect_chan(451)) then
          current_chan = 451
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbsCh1g1XT(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q Qb Q       
        if (qactive_chan(452).and.qselect_chan(452)) then
          current_chan = 452
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgsCh1g1XT(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Qb Q g      
        if (qactive_chan(453).and.qselect_chan(453)) then
          current_chan = 453
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqsCh1g1XT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q Qb Q       
        if (qactive_chan(454).and.qselect_chan(454)) then
          current_chan = 454
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqsCh1g1XT(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q g      
        if (qactive_chan(455).and.qselect_chan(455)) then
          current_chan = 455
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpsCh1g1XT(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb g    
        if (qactive_chan(456).and.qselect_chan(456)) then
          current_chan = 456
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbsCh1g1XT(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb Qb Q     
        if (qactive_chan(457).and.qselect_chan(457)) then
          current_chan = 457
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgsCh1g1XT(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb Qb Q     
        if (qactive_chan(458).and.qselect_chan(458)) then
          current_chan = 458
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbsCh1g1XT(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(459).and.qselect_chan(459)) then
          current_chan = 459
          ip1_chan     = 0
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = ggsCh1g1XT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g g        
        if (qactive_chan(460).and.qselect_chan(460)) then
          current_chan = 460
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggAt5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(461).and.qselect_chan(461)) then
          current_chan = 461
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqAt5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(462).and.qselect_chan(462)) then
          current_chan = 462
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbAt5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(463).and.qselect_chan(463)) then
          current_chan = 463
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgAt5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(464).and.qselect_chan(464)) then
          current_chan = 464
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgAt5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g g        
        if (qactive_chan(465).and.qselect_chan(465)) then
          current_chan = 465
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggAth5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(466).and.qselect_chan(466)) then
          current_chan = 466
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqAth5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(467).and.qselect_chan(467)) then
          current_chan = 467
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbAth5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(468).and.qselect_chan(468)) then
          current_chan = 468
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgAth5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(469).and.qselect_chan(469)) then
          current_chan = 469
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgAth5g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt gt q     
        if (qactive_chan(470).and.qselect_chan(470)) then
          current_chan = 470
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBt3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt gt    
        if (qactive_chan(471).and.qselect_chan(471)) then
          current_chan = 471
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBt3g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt gt q     
        if (qactive_chan(472).and.qselect_chan(472)) then
          current_chan = 472
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBt3g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt gt    
        if (qactive_chan(473).and.qselect_chan(473)) then
          current_chan = 473
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBt3g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb gt q    
        if (qactive_chan(474).and.qselect_chan(474)) then
          current_chan = 474
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBt3g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt gt   
        if (qactive_chan(475).and.qselect_chan(475)) then
          current_chan = 475
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBt3g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt gt   
        if (qactive_chan(476).and.qselect_chan(476)) then
          current_chan = 476
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBt3g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt gt q     
        if (qactive_chan(477).and.qselect_chan(477)) then
          current_chan = 477
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBth3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt gt    
        if (qactive_chan(478).and.qselect_chan(478)) then
          current_chan = 478
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBth3g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt gt q     
        if (qactive_chan(479).and.qselect_chan(479)) then
          current_chan = 479
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBth3g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt gt    
        if (qactive_chan(480).and.qselect_chan(480)) then
          current_chan = 480
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBth3g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb gt q    
        if (qactive_chan(481).and.qselect_chan(481)) then
          current_chan = 481
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBth3g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt gt   
        if (qactive_chan(482).and.qselect_chan(482)) then
          current_chan = 482
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBth3g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt gt   
        if (qactive_chan(483).and.qselect_chan(483)) then
          current_chan = 483
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBth3g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt gt q     
        if (qactive_chan(484).and.qselect_chan(484)) then
          current_chan = 484
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBtt3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt gt    
        if (qactive_chan(485).and.qselect_chan(485)) then
          current_chan = 485
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBtt3g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt gt q     
        if (qactive_chan(486).and.qselect_chan(486)) then
          current_chan = 486
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBtt3g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt gt    
        if (qactive_chan(487).and.qselect_chan(487)) then
          current_chan = 487
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBtt3g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb gt q    
        if (qactive_chan(488).and.qselect_chan(488)) then
          current_chan = 488
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBtt3g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt gt   
        if (qactive_chan(489).and.qselect_chan(489)) then
          current_chan = 489
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBtt3g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt gt   
        if (qactive_chan(490).and.qselect_chan(490)) then
          current_chan = 490
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBtt3g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt gt q     
        if (qactive_chan(491).and.qselect_chan(491)) then
          current_chan = 491
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBtth3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt gt    
        if (qactive_chan(492).and.qselect_chan(492)) then
          current_chan = 492
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBtth3g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt gt q     
        if (qactive_chan(493).and.qselect_chan(493)) then
          current_chan = 493
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBtth3g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt gt    
        if (qactive_chan(494).and.qselect_chan(494)) then
          current_chan = 494
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBtth3g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb gt q    
        if (qactive_chan(495).and.qselect_chan(495)) then
          current_chan = 495
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBtth3g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt gt   
        if (qactive_chan(496).and.qselect_chan(496)) then
          current_chan = 496
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBtth3g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt gt   
        if (qactive_chan(497).and.qselect_chan(497)) then
          current_chan = 497
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBtth3g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt gt q     
        if (qactive_chan(498).and.qselect_chan(498)) then
          current_chan = 498
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBttt3g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt gt    
        if (qactive_chan(499).and.qselect_chan(499)) then
          current_chan = 499
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBttt3g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt gt q     
        if (qactive_chan(500).and.qselect_chan(500)) then
          current_chan = 500
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBttt3g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt gt    
        if (qactive_chan(501).and.qselect_chan(501)) then
          current_chan = 501
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBttt3g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb gt q    
        if (qactive_chan(502).and.qselect_chan(502)) then
          current_chan = 502
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBttt3g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt gt   
        if (qactive_chan(503).and.qselect_chan(503)) then
          current_chan = 503
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBttt3g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt gt   
        if (qactive_chan(504).and.qselect_chan(504)) then
          current_chan = 504
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBttt3g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Qb Q g      
        if (qactive_chan(505).and.qselect_chan(505)) then
          current_chan = 505
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbsCt1g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to q Q g        
        if (qactive_chan(506).and.qselect_chan(506)) then
          current_chan = 506
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpsCt1g1T(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to q Qb g      
        if (qactive_chan(507).and.qselect_chan(507)) then
          current_chan = 507
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbsCt1g1T(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q Qb Q       
        if (qactive_chan(508).and.qselect_chan(508)) then
          current_chan = 508
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgsCt1g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Qb Q g      
        if (qactive_chan(509).and.qselect_chan(509)) then
          current_chan = 509
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqsCt1g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q Qb Q       
        if (qactive_chan(510).and.qselect_chan(510)) then
          current_chan = 510
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqsCt1g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q g      
        if (qactive_chan(511).and.qselect_chan(511)) then
          current_chan = 511
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpsCt1g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb g    
        if (qactive_chan(512).and.qselect_chan(512)) then
          current_chan = 512
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbsCt1g1T(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb Qb Q     
        if (qactive_chan(513).and.qselect_chan(513)) then
          current_chan = 513
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgsCt1g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb Qb Q     
        if (qactive_chan(514).and.qselect_chan(514)) then
          current_chan = 514
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbsCt1g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(515).and.qselect_chan(515)) then
          current_chan = 515
          ip1_chan     = 0
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = ggsCt1g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Qb Q g      
        if (qactive_chan(516).and.qselect_chan(516)) then
          current_chan = 516
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbCth1g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to q Q g        
        if (qactive_chan(517).and.qselect_chan(517)) then
          current_chan = 517
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpCth1g1T(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to q Qb g      
        if (qactive_chan(518).and.qselect_chan(518)) then
          current_chan = 518
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCth1g1T(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q Qb Q       
        if (qactive_chan(519).and.qselect_chan(519)) then
          current_chan = 519
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgCth1g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Qb Q g      
        if (qactive_chan(520).and.qselect_chan(520)) then
          current_chan = 520
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqCth1g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q Qb Q       
        if (qactive_chan(521).and.qselect_chan(521)) then
          current_chan = 521
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqCth1g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q g      
        if (qactive_chan(522).and.qselect_chan(522)) then
          current_chan = 522
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCth1g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb g    
        if (qactive_chan(523).and.qselect_chan(523)) then
          current_chan = 523
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCth1g1T(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb Qb Q     
        if (qactive_chan(524).and.qselect_chan(524)) then
          current_chan = 524
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgCth1g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb Qb Q     
        if (qactive_chan(525).and.qselect_chan(525)) then
          current_chan = 525
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbCth1g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(526).and.qselect_chan(526)) then
          current_chan = 526
          ip1_chan     = 0
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = ggCth1g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Qb Q g      
        if (qactive_chan(527).and.qselect_chan(527)) then
          current_chan = 527
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbsCtt1g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to q Q g        
        if (qactive_chan(528).and.qselect_chan(528)) then
          current_chan = 528
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpsCtt1g1T(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to q Qb g      
        if (qactive_chan(529).and.qselect_chan(529)) then
          current_chan = 529
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbsCtt1g1T(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q Qb Q       
        if (qactive_chan(530).and.qselect_chan(530)) then
          current_chan = 530
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgsCtt1g1T(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Qb Q g      
        if (qactive_chan(531).and.qselect_chan(531)) then
          current_chan = 531
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqsCtt1g1T(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q Qb Q       
        if (qactive_chan(532).and.qselect_chan(532)) then
          current_chan = 532
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqsCtt1g1T(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q g      
        if (qactive_chan(533).and.qselect_chan(533)) then
          current_chan = 533
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpsCtt1g1T(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb g    
        if (qactive_chan(534).and.qselect_chan(534)) then
          current_chan = 534
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbsCtt1g1T(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb Qb Q     
        if (qactive_chan(535).and.qselect_chan(535)) then
          current_chan = 535
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgsCtt1g1T(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb Qb Q     
        if (qactive_chan(536).and.qselect_chan(536)) then
          current_chan = 536
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbsCtt1g1T(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(537).and.qselect_chan(537)) then
          current_chan = 537
          ip1_chan     = 0
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = ggsCtt1g1T(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q g      
        if (qactive_chan(538).and.qselect_chan(538)) then
          current_chan = 538
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q g        
        if (qactive_chan(539).and.qselect_chan(539)) then
          current_chan = 539
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqD1g1fullT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q qb q       
        if (qactive_chan(540).and.qselect_chan(540)) then
          current_chan = 540
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qgD1g1fullT(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q g      
        if (qactive_chan(541).and.qselect_chan(541)) then
          current_chan = 541
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqD1g1fullT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q qb q       
        if (qactive_chan(542).and.qselect_chan(542)) then
          current_chan = 542
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = gqD1g1fullT(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb g    
        if (qactive_chan(543).and.qselect_chan(543)) then
          current_chan = 543
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbD1g1fullT(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb qb q     
        if (qactive_chan(544).and.qselect_chan(544)) then
          current_chan = 544
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qbgD1g1fullT(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb qb q     
        if (qactive_chan(545).and.qselect_chan(545)) then
          current_chan = 545
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = gqbD1g1fullT(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(546).and.qselect_chan(546)) then
          current_chan = 546
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpqD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(547).and.qselect_chan(547)) then
          current_chan = 547
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpqbD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(548).and.qselect_chan(548)) then
          current_chan = 548
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(549).and.qselect_chan(549)) then
          current_chan = 549
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(550).and.qselect_chan(550)) then
          current_chan = 550
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(551).and.qselect_chan(551)) then
          current_chan = 551
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qqpD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(552).and.qselect_chan(552)) then
          current_chan = 552
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqpbD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(553).and.qselect_chan(553)) then
          current_chan = 553
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(554).and.qselect_chan(554)) then
          current_chan = 554
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbD1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q g      
        if (qactive_chan(555).and.qselect_chan(555)) then
          current_chan = 555
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q g        
        if (qactive_chan(556).and.qselect_chan(556)) then
          current_chan = 556
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqDh1g1fullT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q qb q       
        if (qactive_chan(557).and.qselect_chan(557)) then
          current_chan = 557
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qgDh1g1fullT(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q g      
        if (qactive_chan(558).and.qselect_chan(558)) then
          current_chan = 558
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqDh1g1fullT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q qb q       
        if (qactive_chan(559).and.qselect_chan(559)) then
          current_chan = 559
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = gqDh1g1fullT(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb g    
        if (qactive_chan(560).and.qselect_chan(560)) then
          current_chan = 560
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDh1g1fullT(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb qb q     
        if (qactive_chan(561).and.qselect_chan(561)) then
          current_chan = 561
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qbgDh1g1fullT(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb qb q     
        if (qactive_chan(562).and.qselect_chan(562)) then
          current_chan = 562
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = gqbDh1g1fullT(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(563).and.qselect_chan(563)) then
          current_chan = 563
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpqDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(564).and.qselect_chan(564)) then
          current_chan = 564
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(565).and.qselect_chan(565)) then
          current_chan = 565
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(566).and.qselect_chan(566)) then
          current_chan = 566
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(567).and.qselect_chan(567)) then
          current_chan = 567
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(568).and.qselect_chan(568)) then
          current_chan = 568
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qqpDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(569).and.qselect_chan(569)) then
          current_chan = 569
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(570).and.qselect_chan(570)) then
          current_chan = 570
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(571).and.qselect_chan(571)) then
          current_chan = 571
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDh1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q g      
        if (qactive_chan(572).and.qselect_chan(572)) then
          current_chan = 572
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q g        
        if (qactive_chan(573).and.qselect_chan(573)) then
          current_chan = 573
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqDt1g1fullT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q qb q       
        if (qactive_chan(574).and.qselect_chan(574)) then
          current_chan = 574
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qgDt1g1fullT(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q g      
        if (qactive_chan(575).and.qselect_chan(575)) then
          current_chan = 575
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqDt1g1fullT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q qb q       
        if (qactive_chan(576).and.qselect_chan(576)) then
          current_chan = 576
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = gqDt1g1fullT(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb g    
        if (qactive_chan(577).and.qselect_chan(577)) then
          current_chan = 577
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDt1g1fullT(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb qb q     
        if (qactive_chan(578).and.qselect_chan(578)) then
          current_chan = 578
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qbgDt1g1fullT(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb qb q     
        if (qactive_chan(579).and.qselect_chan(579)) then
          current_chan = 579
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = gqbDt1g1fullT(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(580).and.qselect_chan(580)) then
          current_chan = 580
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpqDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(581).and.qselect_chan(581)) then
          current_chan = 581
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(582).and.qselect_chan(582)) then
          current_chan = 582
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(583).and.qselect_chan(583)) then
          current_chan = 583
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(584).and.qselect_chan(584)) then
          current_chan = 584
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(585).and.qselect_chan(585)) then
          current_chan = 585
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qqpDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(586).and.qselect_chan(586)) then
          current_chan = 586
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(587).and.qselect_chan(587)) then
          current_chan = 587
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(588).and.qselect_chan(588)) then
          current_chan = 588
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q g      
        if (qactive_chan(589).and.qselect_chan(589)) then
          current_chan = 589
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q g        
        if (qactive_chan(590).and.qselect_chan(590)) then
          current_chan = 590
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqDth1g1fullT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q qb q       
        if (qactive_chan(591).and.qselect_chan(591)) then
          current_chan = 591
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qgDth1g1fullT(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q g      
        if (qactive_chan(592).and.qselect_chan(592)) then
          current_chan = 592
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqDth1g1fullT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q qb q       
        if (qactive_chan(593).and.qselect_chan(593)) then
          current_chan = 593
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = gqDth1g1fullT(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb g    
        if (qactive_chan(594).and.qselect_chan(594)) then
          current_chan = 594
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDth1g1fullT(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb qb q     
        if (qactive_chan(595).and.qselect_chan(595)) then
          current_chan = 595
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qbgDth1g1fullT(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb qb q     
        if (qactive_chan(596).and.qselect_chan(596)) then
          current_chan = 596
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = gqbDth1g1fullT(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(597).and.qselect_chan(597)) then
          current_chan = 597
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpqDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(598).and.qselect_chan(598)) then
          current_chan = 598
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(599).and.qselect_chan(599)) then
          current_chan = 599
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(600).and.qselect_chan(600)) then
          current_chan = 600
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(601).and.qselect_chan(601)) then
          current_chan = 601
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(602).and.qselect_chan(602)) then
          current_chan = 602
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qqpDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(603).and.qselect_chan(603)) then
          current_chan = 603
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(604).and.qselect_chan(604)) then
          current_chan = 604
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(605).and.qselect_chan(605)) then
          current_chan = 605
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDth1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q g      
        if (qactive_chan(606).and.qselect_chan(606)) then
          current_chan = 606
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q g        
        if (qactive_chan(607).and.qselect_chan(607)) then
          current_chan = 607
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqDtt1g1fullT(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q qb q       
        if (qactive_chan(608).and.qselect_chan(608)) then
          current_chan = 608
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qgDtt1g1fullT(ix,xri1,xri2,1,3,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q g      
        if (qactive_chan(609).and.qselect_chan(609)) then
          current_chan = 609
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqDtt1g1fullT(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q qb q       
        if (qactive_chan(610).and.qselect_chan(610)) then
          current_chan = 610
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = gqDtt1g1fullT(ix,xri1,xri2,2,3,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb g    
        if (qactive_chan(611).and.qselect_chan(611)) then
          current_chan = 611
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDtt1g1fullT(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb qb q     
        if (qactive_chan(612).and.qselect_chan(612)) then
          current_chan = 612
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 3
          wt = qbgDtt1g1fullT(ix,xri1,xri2,3,1,4,5,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb qb q     
        if (qactive_chan(613).and.qselect_chan(613)) then
          current_chan = 613
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = gqbDtt1g1fullT(ix,xri1,xri2,3,2,4,5,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q q initiated       
        if (qactive_chan(614).and.qselect_chan(614)) then
          current_chan = 614
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpqDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q qb initiated      
        if (qactive_chan(615).and.qselect_chan(615)) then
          current_chan = 615
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpqbDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb q initiated      
        if (qactive_chan(616).and.qselect_chan(616)) then
          current_chan = 616
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb qb initiated     
        if (qactive_chan(617).and.qselect_chan(617)) then
          current_chan = 617
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qpbqbDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(618).and.qselect_chan(618)) then
          current_chan = 618
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(619).and.qselect_chan(619)) then
          current_chan = 619
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qqpDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(620).and.qselect_chan(620)) then
          current_chan = 620
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqpbDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(621).and.qselect_chan(621)) then
          current_chan = 621
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(622).and.qselect_chan(622)) then
          current_chan = 622
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbDtt1g1fullT(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigT2jetfc=sigT2jetfc+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
