      function sigTNLO2jetfc(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use Charges_EW_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLO2jetfc=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- g g to g g          
        if (qactive_chan(84).and.qselect_chan(84)) then
          current_chan = 84
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggA4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(85).and.qselect_chan(85)) then
          current_chan = 85
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqA4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(86).and.qselect_chan(86)) then
          current_chan = 86
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbA4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(87).and.qselect_chan(87)) then
          current_chan = 87
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgA4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(88).and.qselect_chan(88)) then
          current_chan = 88
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgA4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g          
        if (qactive_chan(89).and.qselect_chan(89)) then
          current_chan = 89
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggAh4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(90).and.qselect_chan(90)) then
          current_chan = 90
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqAh4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(91).and.qselect_chan(91)) then
          current_chan = 91
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbAh4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(92).and.qselect_chan(92)) then
          current_chan = 92
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgAh4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(93).and.qselect_chan(93)) then
          current_chan = 93
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgAh4g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g q          
        if (qactive_chan(94).and.qselect_chan(94)) then
          current_chan = 94
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgB2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g         
        if (qactive_chan(95).and.qselect_chan(95)) then
          current_chan = 95
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbB2g1TNLO(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g q          
        if (qactive_chan(96).and.qselect_chan(96)) then
          current_chan = 96
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqB2g1TNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g         
        if (qactive_chan(97).and.qselect_chan(97)) then
          current_chan = 97
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqB2g1TNLO(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb q         
        if (qactive_chan(98).and.qselect_chan(98)) then
          current_chan = 98
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggB2g1TNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g        
        if (qactive_chan(99).and.qselect_chan(99)) then
          current_chan = 99
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbB2g1TNLO(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g        
        if (qactive_chan(100).and.qselect_chan(100)) then
          current_chan = 100
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgB2g1TNLO(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(101).and.qselect_chan(101)) then
          current_chan = 101
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpB2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(102).and.qselect_chan(102)) then
          current_chan = 102
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbB2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(103).and.qselect_chan(103)) then
          current_chan = 103
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpB2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(104).and.qselect_chan(104)) then
          current_chan = 104
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbB2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g q          
        if (qactive_chan(105).and.qselect_chan(105)) then
          current_chan = 105
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgBh2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g         
        if (qactive_chan(106).and.qselect_chan(106)) then
          current_chan = 106
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBh2g1TNLO(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g q          
        if (qactive_chan(107).and.qselect_chan(107)) then
          current_chan = 107
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqBh2g1TNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g         
        if (qactive_chan(108).and.qselect_chan(108)) then
          current_chan = 108
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBh2g1TNLO(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb q         
        if (qactive_chan(109).and.qselect_chan(109)) then
          current_chan = 109
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggBh2g1TNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g        
        if (qactive_chan(110).and.qselect_chan(110)) then
          current_chan = 110
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbBh2g1TNLO(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g        
        if (qactive_chan(111).and.qselect_chan(111)) then
          current_chan = 111
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgBh2g1TNLO(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(112).and.qselect_chan(112)) then
          current_chan = 112
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpBh2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(113).and.qselect_chan(113)) then
          current_chan = 113
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBh2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(114).and.qselect_chan(114)) then
          current_chan = 114
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBh2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(115).and.qselect_chan(115)) then
          current_chan = 115
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBh2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(116).and.qselect_chan(116)) then
          current_chan = 116
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBt2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(117).and.qselect_chan(117)) then
          current_chan = 117
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBt2g1TNLO(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(118).and.qselect_chan(118)) then
          current_chan = 118
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBt2g1TNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(119).and.qselect_chan(119)) then
          current_chan = 119
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBt2g1TNLO(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(120).and.qselect_chan(120)) then
          current_chan = 120
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBt2g1TNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(121).and.qselect_chan(121)) then
          current_chan = 121
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBt2g1TNLO(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(122).and.qselect_chan(122)) then
          current_chan = 122
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBt2g1TNLO(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(123).and.qselect_chan(123)) then
          current_chan = 123
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBth2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(124).and.qselect_chan(124)) then
          current_chan = 124
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBth2g1TNLO(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(125).and.qselect_chan(125)) then
          current_chan = 125
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBth2g1TNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(126).and.qselect_chan(126)) then
          current_chan = 126
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBth2g1TNLO(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(127).and.qselect_chan(127)) then
          current_chan = 127
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBth2g1TNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(128).and.qselect_chan(128)) then
          current_chan = 128
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBth2g1TNLO(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(129).and.qselect_chan(129)) then
          current_chan = 129
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBth2g1TNLO(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q        
        if (qactive_chan(130).and.qselect_chan(130)) then
          current_chan = 130
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBtt2g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt       
        if (qactive_chan(131).and.qselect_chan(131)) then
          current_chan = 131
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBtt2g1TNLO(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q        
        if (qactive_chan(132).and.qselect_chan(132)) then
          current_chan = 132
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBtt2g1TNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt       
        if (qactive_chan(133).and.qselect_chan(133)) then
          current_chan = 133
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBtt2g1TNLO(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q       
        if (qactive_chan(134).and.qselect_chan(134)) then
          current_chan = 134
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBtt2g1TNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt      
        if (qactive_chan(135).and.qselect_chan(135)) then
          current_chan = 135
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBtt2g1TNLO(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt      
        if (qactive_chan(136).and.qselect_chan(136)) then
          current_chan = 136
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBtt2g1TNLO(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(137).and.qselect_chan(137)) then
          current_chan = 137
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbC0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(138).and.qselect_chan(138)) then
          current_chan = 138
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpC0g1TNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(139).and.qselect_chan(139)) then
          current_chan = 139
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbC0g1TNLO(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(140).and.qselect_chan(140)) then
          current_chan = 140
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqC0g1TNLO(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(141).and.qselect_chan(141)) then
          current_chan = 141
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbC0g1TNLO(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(142).and.qselect_chan(142)) then
          current_chan = 142
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpC0g1TNLO(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(143).and.qselect_chan(143)) then
          current_chan = 143
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqC0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(144).and.qselect_chan(144)) then
          current_chan = 144
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbC0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(145).and.qselect_chan(145)) then
          current_chan = 145
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgC0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(146).and.qselect_chan(146)) then
          current_chan = 146
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgC0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(147).and.qselect_chan(147)) then
          current_chan = 147
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(148).and.qselect_chan(148)) then
          current_chan = 148
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpCh0g1TNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(149).and.qselect_chan(149)) then
          current_chan = 149
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbCh0g1TNLO(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(150).and.qselect_chan(150)) then
          current_chan = 150
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqCh0g1TNLO(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(151).and.qselect_chan(151)) then
          current_chan = 151
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCh0g1TNLO(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(152).and.qselect_chan(152)) then
          current_chan = 152
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCh0g1TNLO(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(153).and.qselect_chan(153)) then
          current_chan = 153
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqCh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(154).and.qselect_chan(154)) then
          current_chan = 154
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbCh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(155).and.qselect_chan(155)) then
          current_chan = 155
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgCh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(156).and.qselect_chan(156)) then
          current_chan = 156
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgCh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q        
        if (qactive_chan(157).and.qselect_chan(157)) then
          current_chan = 157
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q          
        if (qactive_chan(158).and.qselect_chan(158)) then
          current_chan = 158
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpCt0g1TNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb        
        if (qactive_chan(159).and.qselect_chan(159)) then
          current_chan = 159
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbCt0g1TNLO(ix,xri1,xri2,1,3,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb        
        if (qactive_chan(160).and.qselect_chan(160)) then
          current_chan = 160
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqCt0g1TNLO(ix,xri1,xri2,2,3,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb      
        if (qactive_chan(161).and.qselect_chan(161)) then
          current_chan = 161
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCt0g1TNLO(ix,xri1,xri2,3,2,4,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q        
        if (qactive_chan(162).and.qselect_chan(162)) then
          current_chan = 162
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCt0g1TNLO(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(163).and.qselect_chan(163)) then
          current_chan = 163
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqCt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(164).and.qselect_chan(164)) then
          current_chan = 164
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbCt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(165).and.qselect_chan(165)) then
          current_chan = 165
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgCt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(166).and.qselect_chan(166)) then
          current_chan = 166
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgCt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(167).and.qselect_chan(167)) then
          current_chan = 167
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbD0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(168).and.qselect_chan(168)) then
          current_chan = 168
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqD0g1TNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(169).and.qselect_chan(169)) then
          current_chan = 169
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqD0g1TNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(170).and.qselect_chan(170)) then
          current_chan = 170
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbD0g1TNLO(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(171).and.qselect_chan(171)) then
          current_chan = 171
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqD0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(172).and.qselect_chan(172)) then
          current_chan = 172
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbD0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(173).and.qselect_chan(173)) then
          current_chan = 173
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgD0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(174).and.qselect_chan(174)) then
          current_chan = 174
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgD0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(175).and.qselect_chan(175)) then
          current_chan = 175
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbDh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(176).and.qselect_chan(176)) then
          current_chan = 176
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqDh0g1TNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(177).and.qselect_chan(177)) then
          current_chan = 177
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqDh0g1TNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(178).and.qselect_chan(178)) then
          current_chan = 178
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDh0g1TNLO(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(179).and.qselect_chan(179)) then
          current_chan = 179
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqDh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(180).and.qselect_chan(180)) then
          current_chan = 180
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbDh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(181).and.qselect_chan(181)) then
          current_chan = 181
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgDh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(182).and.qselect_chan(182)) then
          current_chan = 182
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgDh0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q        
        if (qactive_chan(183).and.qselect_chan(183)) then
          current_chan = 183
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbDt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q          
        if (qactive_chan(184).and.qselect_chan(184)) then
          current_chan = 184
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqDt0g1TNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q        
        if (qactive_chan(185).and.qselect_chan(185)) then
          current_chan = 185
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqDt0g1TNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb      
        if (qactive_chan(186).and.qselect_chan(186)) then
          current_chan = 186
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDt0g1TNLO(ix,xri1,xri2,3,1,4,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(187).and.qselect_chan(187)) then
          current_chan = 187
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqDt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(188).and.qselect_chan(188)) then
          current_chan = 188
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbDt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(189).and.qselect_chan(189)) then
          current_chan = 189
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgDt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(190).and.qselect_chan(190)) then
          current_chan = 190
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgDt0g1TNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLO2jetfc=sigTNLO2jetfc+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
