      function sigTDIS(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTDIS=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(6,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(6,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d em to em g g d    
        if (qactive_chan(115).and.qselect_chan(115)) then
          current_chan = 115
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsB2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g g u    
        if (qactive_chan(116).and.qselect_chan(116)) then
          current_chan = 116
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemsB2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db g d   
        if (qactive_chan(117).and.qselect_chan(117)) then
          current_chan = 117
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemsB2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub g u   
        if (qactive_chan(118).and.qselect_chan(118)) then
          current_chan = 118
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemsB2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g g  
        if (qactive_chan(119).and.qselect_chan(119)) then
          current_chan = 119
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsB2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g g  
        if (qactive_chan(120).and.qselect_chan(120)) then
          current_chan = 120
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemsB2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(121).and.qselect_chan(121)) then
          current_chan = 121
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsB2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(122).and.qselect_chan(122)) then
          current_chan = 122
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemsB2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(123).and.qselect_chan(123)) then
          current_chan = 123
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsB2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(124).and.qselect_chan(124)) then
          current_chan = 124
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemsB2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em gt gt d  
        if (qactive_chan(125).and.qselect_chan(125)) then
          current_chan = 125
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsBt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em gt gt u  
        if (qactive_chan(126).and.qselect_chan(126)) then
          current_chan = 126
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemsBt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to em db gt d 
        if (qactive_chan(127).and.qselect_chan(127)) then
          current_chan = 127
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gtemsBt2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to em ub gt u 
        if (qactive_chan(128).and.qselect_chan(128)) then
          current_chan = 128
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gtemsBt2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db gt gt 
        if (qactive_chan(129).and.qselect_chan(129)) then
          current_chan = 129
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsBt2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub gt gt 
        if (qactive_chan(130).and.qselect_chan(130)) then
          current_chan = 130
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemsBt2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(131).and.qselect_chan(131)) then
          current_chan = 131
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsBt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(132).and.qselect_chan(132)) then
          current_chan = 132
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemsBt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(133).and.qselect_chan(133)) then
          current_chan = 133
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsBt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(134).and.qselect_chan(134)) then
          current_chan = 134
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemsBt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em gt gt d  
        if (qactive_chan(135).and.qselect_chan(135)) then
          current_chan = 135
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsBttt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em gt gt u  
        if (qactive_chan(136).and.qselect_chan(136)) then
          current_chan = 136
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemsBttt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to em db gt d 
        if (qactive_chan(137).and.qselect_chan(137)) then
          current_chan = 137
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gtemsBttt2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to em ub gt u 
        if (qactive_chan(138).and.qselect_chan(138)) then
          current_chan = 138
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gtemsBttt2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db gt gt 
        if (qactive_chan(139).and.qselect_chan(139)) then
          current_chan = 139
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsBttt2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub gt gt 
        if (qactive_chan(140).and.qselect_chan(140)) then
          current_chan = 140
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemsBttt2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(141).and.qselect_chan(141)) then
          current_chan = 141
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsBttt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(142).and.qselect_chan(142)) then
          current_chan = 142
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemsBttt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(143).and.qselect_chan(143)) then
          current_chan = 143
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsBttt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(144).and.qselect_chan(144)) then
          current_chan = 144
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemsBttt2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g g d    
        if (qactive_chan(145).and.qselect_chan(145)) then
          current_chan = 145
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsBh2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g g u    
        if (qactive_chan(146).and.qselect_chan(146)) then
          current_chan = 146
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemsBh2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db g d   
        if (qactive_chan(147).and.qselect_chan(147)) then
          current_chan = 147
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemsBh2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub g u   
        if (qactive_chan(148).and.qselect_chan(148)) then
          current_chan = 148
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemsBh2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g g  
        if (qactive_chan(149).and.qselect_chan(149)) then
          current_chan = 149
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsBh2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g g  
        if (qactive_chan(150).and.qselect_chan(150)) then
          current_chan = 150
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemsBh2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(151).and.qselect_chan(151)) then
          current_chan = 151
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsBh2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(152).and.qselect_chan(152)) then
          current_chan = 152
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemsBh2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(153).and.qselect_chan(153)) then
          current_chan = 153
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsBh2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(154).and.qselect_chan(154)) then
          current_chan = 154
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemsBh2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em gt gt d  
        if (qactive_chan(155).and.qselect_chan(155)) then
          current_chan = 155
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsBth2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em gt gt u  
        if (qactive_chan(156).and.qselect_chan(156)) then
          current_chan = 156
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemsBth2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to em db gt d 
        if (qactive_chan(157).and.qselect_chan(157)) then
          current_chan = 157
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gtemsBth2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to em ub gt u 
        if (qactive_chan(158).and.qselect_chan(158)) then
          current_chan = 158
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gtemsBth2g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db gt gt 
        if (qactive_chan(159).and.qselect_chan(159)) then
          current_chan = 159
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsBth2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub gt gt 
        if (qactive_chan(160).and.qselect_chan(160)) then
          current_chan = 160
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemsBth2g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(161).and.qselect_chan(161)) then
          current_chan = 161
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsBth2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(162).and.qselect_chan(162)) then
          current_chan = 162
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemsBth2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(163).and.qselect_chan(163)) then
          current_chan = 163
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsBth2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(164).and.qselect_chan(164)) then
          current_chan = 164
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemsBth2g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em d db d   
        if (qactive_chan(165).and.qselect_chan(165)) then
          current_chan = 165
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemsC0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em u ub d   
        if (qactive_chan(166).and.qselect_chan(166)) then
          current_chan = 166
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = qemsC0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em d db u   
        if (qactive_chan(167).and.qselect_chan(167)) then
          current_chan = 167
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = qemsC0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u ub u   
        if (qactive_chan(168).and.qselect_chan(168)) then
          current_chan = 168
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemsC0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db d db 
        if (qactive_chan(169).and.qselect_chan(169)) then
          current_chan = 169
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qbemsC0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db u ub 
        if (qactive_chan(170).and.qselect_chan(170)) then
          current_chan = 170
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = qbemsC0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub d db 
        if (qactive_chan(171).and.qselect_chan(171)) then
          current_chan = 171
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = qbemsC0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub u ub 
        if (qactive_chan(172).and.qselect_chan(172)) then
          current_chan = 172
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemsC0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(173).and.qselect_chan(173)) then
          current_chan = 173
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = gemsC0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(174).and.qselect_chan(174)) then
          current_chan = 174
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = gemsC0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(175).and.qselect_chan(175)) then
          current_chan = 175
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = gemsC0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(176).and.qselect_chan(176)) then
          current_chan = 176
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = gemsC0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em d db d   
        if (qactive_chan(177).and.qselect_chan(177)) then
          current_chan = 177
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemCt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em u ub d   
        if (qactive_chan(178).and.qselect_chan(178)) then
          current_chan = 178
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = qemCt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em d db u   
        if (qactive_chan(179).and.qselect_chan(179)) then
          current_chan = 179
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = qemCt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u ub u   
        if (qactive_chan(180).and.qselect_chan(180)) then
          current_chan = 180
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemCt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db d db 
        if (qactive_chan(181).and.qselect_chan(181)) then
          current_chan = 181
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qbemCt0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db u ub 
        if (qactive_chan(182).and.qselect_chan(182)) then
          current_chan = 182
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = qbemCt0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub d db 
        if (qactive_chan(183).and.qselect_chan(183)) then
          current_chan = 183
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = qbemCt0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub u ub 
        if (qactive_chan(184).and.qselect_chan(184)) then
          current_chan = 184
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemCt0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(185).and.qselect_chan(185)) then
          current_chan = 185
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = gemCt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(186).and.qselect_chan(186)) then
          current_chan = 186
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = gemCt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(187).and.qselect_chan(187)) then
          current_chan = 187
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = gemCt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(188).and.qselect_chan(188)) then
          current_chan = 188
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = gemCt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em d db d   
        if (qactive_chan(189).and.qselect_chan(189)) then
          current_chan = 189
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemCh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em u ub d   
        if (qactive_chan(190).and.qselect_chan(190)) then
          current_chan = 190
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = qemCh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em d db u   
        if (qactive_chan(191).and.qselect_chan(191)) then
          current_chan = 191
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = qemCh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u ub u   
        if (qactive_chan(192).and.qselect_chan(192)) then
          current_chan = 192
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemCh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db d db 
        if (qactive_chan(193).and.qselect_chan(193)) then
          current_chan = 193
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qbemCh0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db u ub 
        if (qactive_chan(194).and.qselect_chan(194)) then
          current_chan = 194
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = qbemCh0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub d db 
        if (qactive_chan(195).and.qselect_chan(195)) then
          current_chan = 195
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = qbemCh0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub u ub 
        if (qactive_chan(196).and.qselect_chan(196)) then
          current_chan = 196
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemCh0g1ZDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(197).and.qselect_chan(197)) then
          current_chan = 197
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = gemCh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(198).and.qselect_chan(198)) then
          current_chan = 198
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = gemCh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(199).and.qselect_chan(199)) then
          current_chan = 199
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = gemCh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(200).and.qselect_chan(200)) then
          current_chan = 200
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = gemCh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em d db d   
        if (qactive_chan(201).and.qselect_chan(201)) then
          current_chan = 201
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemD0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u ub u   
        if (qactive_chan(202).and.qselect_chan(202)) then
          current_chan = 202
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemD0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db db d 
        if (qactive_chan(203).and.qselect_chan(203)) then
          current_chan = 203
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qbemD0g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub ub u 
        if (qactive_chan(204).and.qselect_chan(204)) then
          current_chan = 204
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemD0g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(205).and.qselect_chan(205)) then
          current_chan = 205
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemD0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(206).and.qselect_chan(206)) then
          current_chan = 206
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemD0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em d db d   
        if (qactive_chan(207).and.qselect_chan(207)) then
          current_chan = 207
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemDt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u ub u   
        if (qactive_chan(208).and.qselect_chan(208)) then
          current_chan = 208
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemDt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db db d 
        if (qactive_chan(209).and.qselect_chan(209)) then
          current_chan = 209
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qbemDt0g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub ub u 
        if (qactive_chan(210).and.qselect_chan(210)) then
          current_chan = 210
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemDt0g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(211).and.qselect_chan(211)) then
          current_chan = 211
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemDt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(212).and.qselect_chan(212)) then
          current_chan = 212
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemDt0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em d db d   
        if (qactive_chan(213).and.qselect_chan(213)) then
          current_chan = 213
          ip1_chan     = 10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemDh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u ub u   
        if (qactive_chan(214).and.qselect_chan(214)) then
          current_chan = 214
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemDh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db db d 
        if (qactive_chan(215).and.qselect_chan(215)) then
          current_chan = 215
          ip1_chan     = -10
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qbemDh0g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub ub u 
        if (qactive_chan(216).and.qselect_chan(216)) then
          current_chan = 216
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemDh0g1ZDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(217).and.qselect_chan(217)) then
          current_chan = 217
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemDh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(218).and.qselect_chan(218)) then
          current_chan = 218
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemDh0g1ZDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTDIS=sigTDIS+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
