      function sigTNLODIS(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLODIS=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d em to em g d      
        if (qactive_chan(31).and.qselect_chan(31)) then
          current_chan = 31
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemB1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(32).and.qselect_chan(32)) then
          current_chan = 32
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemB1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(33).and.qselect_chan(33)) then
          current_chan = 33
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemB1g1ZDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(34).and.qselect_chan(34)) then
          current_chan = 34
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemB1g1ZDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(35).and.qselect_chan(35)) then
          current_chan = 35
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemB1g1ZDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(36).and.qselect_chan(36)) then
          current_chan = 36
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemB1g1ZDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(37).and.qselect_chan(37)) then
          current_chan = 37
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemB1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(38).and.qselect_chan(38)) then
          current_chan = 38
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemB1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(39).and.qselect_chan(39)) then
          current_chan = 39
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemB1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(40).and.qselect_chan(40)) then
          current_chan = 40
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemB1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(41).and.qselect_chan(41)) then
          current_chan = 41
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemBt1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(42).and.qselect_chan(42)) then
          current_chan = 42
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemBt1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(43).and.qselect_chan(43)) then
          current_chan = 43
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemBt1g1ZDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(44).and.qselect_chan(44)) then
          current_chan = 44
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemBt1g1ZDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(45).and.qselect_chan(45)) then
          current_chan = 45
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemBt1g1ZDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(46).and.qselect_chan(46)) then
          current_chan = 46
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemBt1g1ZDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(47).and.qselect_chan(47)) then
          current_chan = 47
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemBt1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(48).and.qselect_chan(48)) then
          current_chan = 48
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemBt1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(49).and.qselect_chan(49)) then
          current_chan = 49
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemBt1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(50).and.qselect_chan(50)) then
          current_chan = 50
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemBt1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(51).and.qselect_chan(51)) then
          current_chan = 51
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemBh1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(52).and.qselect_chan(52)) then
          current_chan = 52
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemBh1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(53).and.qselect_chan(53)) then
          current_chan = 53
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemBh1g1ZDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(54).and.qselect_chan(54)) then
          current_chan = 54
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemBh1g1ZDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(55).and.qselect_chan(55)) then
          current_chan = 55
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemBh1g1ZDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(56).and.qselect_chan(56)) then
          current_chan = 56
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemBh1g1ZDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(57).and.qselect_chan(57)) then
          current_chan = 57
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemBh1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(58).and.qselect_chan(58)) then
          current_chan = 58
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemBh1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(59).and.qselect_chan(59)) then
          current_chan = 59
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemBh1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(60).and.qselect_chan(60)) then
          current_chan = 60
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemBh1g1ZDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLODIS=sigTNLODIS+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
