      function sigUDIS1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUDIS1j=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d em to em d        
        if (qactive_chan(75).and.qselect_chan(75)) then
          current_chan = 75
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemB0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u        
        if (qactive_chan(76).and.qselect_chan(76)) then
          current_chan = 76
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemB0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db      
        if (qactive_chan(77).and.qselect_chan(77)) then
          current_chan = 77
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemB0g2ZDIS1jU(ix,xri1,xri2,4,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub      
        if (qactive_chan(78).and.qselect_chan(78)) then
          current_chan = 78
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemB0g2ZDIS1jU(ix,xri1,xri2,4,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(79).and.qselect_chan(79)) then
          current_chan = 79
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemB0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(80).and.qselect_chan(80)) then
          current_chan = 80
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemB0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(81).and.qselect_chan(81)) then
          current_chan = 81
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemB0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(82).and.qselect_chan(82)) then
          current_chan = 82
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemB0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(83).and.qselect_chan(83)) then
          current_chan = 83
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemB0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(84).and.qselect_chan(84)) then
          current_chan = 84
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemB0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em d        
        if (qactive_chan(85).and.qselect_chan(85)) then
          current_chan = 85
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBt0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u        
        if (qactive_chan(86).and.qselect_chan(86)) then
          current_chan = 86
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemBt0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db      
        if (qactive_chan(87).and.qselect_chan(87)) then
          current_chan = 87
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBt0g2ZDIS1jU(ix,xri1,xri2,4,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub      
        if (qactive_chan(88).and.qselect_chan(88)) then
          current_chan = 88
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemBt0g2ZDIS1jU(ix,xri1,xri2,4,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(89).and.qselect_chan(89)) then
          current_chan = 89
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBt0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(90).and.qselect_chan(90)) then
          current_chan = 90
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemBt0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(91).and.qselect_chan(91)) then
          current_chan = 91
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBt0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(92).and.qselect_chan(92)) then
          current_chan = 92
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemBt0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(93).and.qselect_chan(93)) then
          current_chan = 93
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBt0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(94).and.qselect_chan(94)) then
          current_chan = 94
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemBt0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em d        
        if (qactive_chan(95).and.qselect_chan(95)) then
          current_chan = 95
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBh0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u        
        if (qactive_chan(96).and.qselect_chan(96)) then
          current_chan = 96
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemBh0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db      
        if (qactive_chan(97).and.qselect_chan(97)) then
          current_chan = 97
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBh0g2ZDIS1jU(ix,xri1,xri2,4,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub      
        if (qactive_chan(98).and.qselect_chan(98)) then
          current_chan = 98
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemBh0g2ZDIS1jU(ix,xri1,xri2,4,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(99).and.qselect_chan(99)) then
          current_chan = 99
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBh0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(100).and.qselect_chan(100)) then
          current_chan = 100
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemBh0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(101).and.qselect_chan(101)) then
          current_chan = 101
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBh0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(102).and.qselect_chan(102)) then
          current_chan = 102
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemBh0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(103).and.qselect_chan(103)) then
          current_chan = 103
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBh0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(104).and.qselect_chan(104)) then
          current_chan = 104
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemBh0g2ZDIS1jU(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUDIS1j=sigUDIS1j+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
