      function sigSNLODISWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLODISWm=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- u em to enu g g d   
      if (qactive_chan(4).and.qselect_chan(4)) then
        current_chan = 4
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        wt = qemB2g0WDISSNLO(1,4,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub g d  
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        wt = gemB2g0WDISSNLO(4,1,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g g 
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        wt = qbemB2g0WDISSNLO(4,5,6,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu gt gt d 
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        wt = qemBt2g0WDISSNLO(1,4,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- gt em to enu ub gt d 
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        wt = gtemBt2g0WDISSNLO(4,1,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub gt gt 
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        wt = qbemBt2g0WDISSNLO(4,5,6,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu Q Qb d  
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qemC0g0WDISSNLO(1,4,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- Qb em to enu ub Qb d 
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = -30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qpbemC0g0WDISSNLO(4,1,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- Q em to enu ub Q d  
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = 30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qpemC0g0WDISSNLO(4,5,1,6,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub Q Qb 
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qbemC0g0WDISSNLO(4,5,6,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu u ub d  
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qemD0g0WaDISSNLO(1,4,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- ub em to enu ub ub d 
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qbemD0g0WaDISSNLO(4,1,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub u ub 
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qpbemD0g0WaDISSNLO(4,5,6,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu d db d  
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qemD0g0WbDISSNLO(1,4,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub db d 
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qpbemD0g0WbDISSNLO(4,1,5,6,3,2)
        wtsum = wtsum + wt
      endif
c--- d em to enu ub d d  
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = 40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qpemD0g0WbDISSNLO(4,5,1,6,3,2)
        wtsum = wtsum + wt
      endif
      sigSNLODISWm=sigSNLODISWm+rnorm*wtsum

      return
      end
