      function sigTDISWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTDISWm=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(6,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(6,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- u em to enu g g d   
        if (qactive_chan(70).and.qselect_chan(70)) then
          current_chan = 70
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsB2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub g d  
        if (qactive_chan(71).and.qselect_chan(71)) then
          current_chan = 71
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemsB2g1WDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g g 
        if (qactive_chan(72).and.qselect_chan(72)) then
          current_chan = 72
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsB2g1WDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(73).and.qselect_chan(73)) then
          current_chan = 73
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsB2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(74).and.qselect_chan(74)) then
          current_chan = 74
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsB2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu gt gt d 
        if (qactive_chan(75).and.qselect_chan(75)) then
          current_chan = 75
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsBt2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to enu ub gt d 
        if (qactive_chan(76).and.qselect_chan(76)) then
          current_chan = 76
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gtemsBt2g1WDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub gt gt 
        if (qactive_chan(77).and.qselect_chan(77)) then
          current_chan = 77
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsBt2g1WDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(78).and.qselect_chan(78)) then
          current_chan = 78
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsBt2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(79).and.qselect_chan(79)) then
          current_chan = 79
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsBt2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu gt gt d 
        if (qactive_chan(80).and.qselect_chan(80)) then
          current_chan = 80
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsBttt2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to enu ub gt d 
        if (qactive_chan(81).and.qselect_chan(81)) then
          current_chan = 81
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gtemsBttt2g1WDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub gt gt 
        if (qactive_chan(82).and.qselect_chan(82)) then
          current_chan = 82
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsBttt2g1WDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(83).and.qselect_chan(83)) then
          current_chan = 83
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsBttt2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(84).and.qselect_chan(84)) then
          current_chan = 84
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsBttt2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g g d   
        if (qactive_chan(85).and.qselect_chan(85)) then
          current_chan = 85
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsBh2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub g d  
        if (qactive_chan(86).and.qselect_chan(86)) then
          current_chan = 86
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemsBh2g1WDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g g 
        if (qactive_chan(87).and.qselect_chan(87)) then
          current_chan = 87
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsBh2g1WDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(88).and.qselect_chan(88)) then
          current_chan = 88
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsBh2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(89).and.qselect_chan(89)) then
          current_chan = 89
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsBh2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu gt gt d 
        if (qactive_chan(90).and.qselect_chan(90)) then
          current_chan = 90
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemsBth2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt em to enu ub gt d 
        if (qactive_chan(91).and.qselect_chan(91)) then
          current_chan = 91
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gtemsBth2g1WDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub gt gt 
        if (qactive_chan(92).and.qselect_chan(92)) then
          current_chan = 92
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemsBth2g1WDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(93).and.qselect_chan(93)) then
          current_chan = 93
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemsBth2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(94).and.qselect_chan(94)) then
          current_chan = 94
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemsBth2g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu Q Qb d  
        if (qactive_chan(95).and.qselect_chan(95)) then
          current_chan = 95
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qemsC0g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em to enu ub Qb d 
        if (qactive_chan(96).and.qselect_chan(96)) then
          current_chan = 96
          ip1_chan     = -30
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qpbemsC0g1WDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em to enu ub Q d  
        if (qactive_chan(97).and.qselect_chan(97)) then
          current_chan = 97
          ip1_chan     = 30
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qpemsC0g1WDIST(ix,xri1,xri2,4,5,1,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub Q Qb 
        if (qactive_chan(98).and.qselect_chan(98)) then
          current_chan = 98
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qbemsC0g1WDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(99).and.qselect_chan(99)) then
          current_chan = 99
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = gemsC0g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu Q Qb d  
        if (qactive_chan(100).and.qselect_chan(100)) then
          current_chan = 100
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qemCt0g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em to enu ub Qb d 
        if (qactive_chan(101).and.qselect_chan(101)) then
          current_chan = 101
          ip1_chan     = -30
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qpbemCt0g1WDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em to enu ub Q d  
        if (qactive_chan(102).and.qselect_chan(102)) then
          current_chan = 102
          ip1_chan     = 30
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qpemCt0g1WDIST(ix,xri1,xri2,4,5,1,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub Q Qb 
        if (qactive_chan(103).and.qselect_chan(103)) then
          current_chan = 103
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qbemCt0g1WDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(104).and.qselect_chan(104)) then
          current_chan = 104
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = gemCt0g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu Q Qb d  
        if (qactive_chan(105).and.qselect_chan(105)) then
          current_chan = 105
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qemCh0g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em to enu ub Qb d 
        if (qactive_chan(106).and.qselect_chan(106)) then
          current_chan = 106
          ip1_chan     = -30
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qpbemCh0g1WDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em to enu ub Q d  
        if (qactive_chan(107).and.qselect_chan(107)) then
          current_chan = 107
          ip1_chan     = 30
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qpemCh0g1WDIST(ix,xri1,xri2,4,5,1,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub Q Qb 
        if (qactive_chan(108).and.qselect_chan(108)) then
          current_chan = 108
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = qbemCh0g1WDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(109).and.qselect_chan(109)) then
          current_chan = 109
          ip1_chan     = 0
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 4
          wt = gemCh0g1WDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu u ub d  
        if (qactive_chan(110).and.qselect_chan(110)) then
          current_chan = 110
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemD0g1WpaDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to enu ub ub d 
        if (qactive_chan(111).and.qselect_chan(111)) then
          current_chan = 111
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemD0g1WpaDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub u ub 
        if (qactive_chan(112).and.qselect_chan(112)) then
          current_chan = 112
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qpbemD0g1WpaDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(113).and.qselect_chan(113)) then
          current_chan = 113
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemD0g1WpaDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu d db d  
        if (qactive_chan(114).and.qselect_chan(114)) then
          current_chan = 114
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemD0g1WpbDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub db d 
        if (qactive_chan(115).and.qselect_chan(115)) then
          current_chan = 115
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qpbemD0g1WpbDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to enu ub d d  
        if (qactive_chan(116).and.qselect_chan(116)) then
          current_chan = 116
          ip1_chan     = 40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qpemD0g1WpbDIST(ix,xri1,xri2,4,5,1,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(117).and.qselect_chan(117)) then
          current_chan = 117
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemD0g1WpbDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu u ub d  
        if (qactive_chan(118).and.qselect_chan(118)) then
          current_chan = 118
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemDt0g1WpaDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to enu ub ub d 
        if (qactive_chan(119).and.qselect_chan(119)) then
          current_chan = 119
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemDt0g1WpaDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub u ub 
        if (qactive_chan(120).and.qselect_chan(120)) then
          current_chan = 120
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qpbemDt0g1WpaDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(121).and.qselect_chan(121)) then
          current_chan = 121
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemDt0g1WpaDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu d db d  
        if (qactive_chan(122).and.qselect_chan(122)) then
          current_chan = 122
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemDt0g1WpbDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub db d 
        if (qactive_chan(123).and.qselect_chan(123)) then
          current_chan = 123
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qpbemDt0g1WpbDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to enu ub d d  
        if (qactive_chan(124).and.qselect_chan(124)) then
          current_chan = 124
          ip1_chan     = 40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qpemDt0g1WpbDIST(ix,xri1,xri2,4,5,1,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(125).and.qselect_chan(125)) then
          current_chan = 125
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemDt0g1WpbDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu u ub d  
        if (qactive_chan(126).and.qselect_chan(126)) then
          current_chan = 126
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qemDh0g1WpaDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to enu ub ub d 
        if (qactive_chan(127).and.qselect_chan(127)) then
          current_chan = 127
          ip1_chan     = -20
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qbemDh0g1WpaDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub u ub 
        if (qactive_chan(128).and.qselect_chan(128)) then
          current_chan = 128
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = qpbemDh0g1WpaDIST(ix,xri1,xri2,4,5,6,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(129).and.qselect_chan(129)) then
          current_chan = 129
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemDh0g1WpaDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu d db d  
        if (qactive_chan(130).and.qselect_chan(130)) then
          current_chan = 130
          ip1_chan     = 20
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qemDh0g1WpbDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub db d 
        if (qactive_chan(131).and.qselect_chan(131)) then
          current_chan = 131
          ip1_chan     = -40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qpbemDh0g1WpbDIST(ix,xri1,xri2,4,1,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to enu ub d d  
        if (qactive_chan(132).and.qselect_chan(132)) then
          current_chan = 132
          ip1_chan     = 40
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = qpemDh0g1WpbDIST(ix,xri1,xri2,4,5,1,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(133).and.qselect_chan(133)) then
          current_chan = 133
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemDh0g1WpbDIST(ix,xri1,xri2,1,4,5,6,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTDISWm=sigTDISWm+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
