      function sigTDISWp(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTDISWp=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(6,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(6,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d ep to enub g g u  
        if (qactive_chan(70).and.qselect_chan(70)) then
          current_chan = 70
          ip1_chan     = 40
          ip2_chan     = -99
          nfB1 = 2
          wt = qepsB2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep to enub db g u 
        if (qactive_chan(71).and.qselect_chan(71)) then
          current_chan = 71
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gepsB2g1WDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db g g 
        if (qactive_chan(72).and.qselect_chan(72)) then
          current_chan = 72
          ip1_chan     = -20
          ip2_chan     = -99
          nfB1 = 2
          wt = qbepsB2g1WDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep initiated      
        if (qactive_chan(73).and.qselect_chan(73)) then
          current_chan = 73
          ip1_chan     = 30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpepsB2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep initiated     
        if (qactive_chan(74).and.qselect_chan(74)) then
          current_chan = 74
          ip1_chan     = -30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpbepsB2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub gt gt u 
        if (qactive_chan(75).and.qselect_chan(75)) then
          current_chan = 75
          ip1_chan     = 40
          ip2_chan     = -99
          nfB1 = 2
          wt = qepsBt2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ep to enub db gt u 
        if (qactive_chan(76).and.qselect_chan(76)) then
          current_chan = 76
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gtepsBt2g1WDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db gt gt 
        if (qactive_chan(77).and.qselect_chan(77)) then
          current_chan = 77
          ip1_chan     = -20
          ip2_chan     = -99
          nfB1 = 2
          wt = qbepsBt2g1WDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep initiated      
        if (qactive_chan(78).and.qselect_chan(78)) then
          current_chan = 78
          ip1_chan     = 30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpepsBt2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep initiated     
        if (qactive_chan(79).and.qselect_chan(79)) then
          current_chan = 79
          ip1_chan     = -30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpbepsBt2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub gt gt u 
        if (qactive_chan(80).and.qselect_chan(80)) then
          current_chan = 80
          ip1_chan     = 40
          ip2_chan     = -99
          nfB1 = 2
          wt = qepsBttt2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ep to enub db gt u 
        if (qactive_chan(81).and.qselect_chan(81)) then
          current_chan = 81
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gtepsBttt2g1WDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db gt gt 
        if (qactive_chan(82).and.qselect_chan(82)) then
          current_chan = 82
          ip1_chan     = -20
          ip2_chan     = -99
          nfB1 = 2
          wt = qbepsBttt2g1WDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep initiated      
        if (qactive_chan(83).and.qselect_chan(83)) then
          current_chan = 83
          ip1_chan     = 30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpepsBttt2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep initiated     
        if (qactive_chan(84).and.qselect_chan(84)) then
          current_chan = 84
          ip1_chan     = -30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpbepsBttt2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub g g u  
        if (qactive_chan(85).and.qselect_chan(85)) then
          current_chan = 85
          ip1_chan     = 40
          ip2_chan     = -99
          nfB1 = 2
          wt = qepsBh2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep to enub db g u 
        if (qactive_chan(86).and.qselect_chan(86)) then
          current_chan = 86
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gepsBh2g1WDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db g g 
        if (qactive_chan(87).and.qselect_chan(87)) then
          current_chan = 87
          ip1_chan     = -20
          ip2_chan     = -99
          nfB1 = 2
          wt = qbepsBh2g1WDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep initiated      
        if (qactive_chan(88).and.qselect_chan(88)) then
          current_chan = 88
          ip1_chan     = 30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpepsBh2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep initiated     
        if (qactive_chan(89).and.qselect_chan(89)) then
          current_chan = 89
          ip1_chan     = -30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpbepsBh2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub gt gt u 
        if (qactive_chan(90).and.qselect_chan(90)) then
          current_chan = 90
          ip1_chan     = 40
          ip2_chan     = -99
          nfB1 = 2
          wt = qepsBth2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ep to enub db gt u 
        if (qactive_chan(91).and.qselect_chan(91)) then
          current_chan = 91
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gtepsBth2g1WDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db gt gt 
        if (qactive_chan(92).and.qselect_chan(92)) then
          current_chan = 92
          ip1_chan     = -20
          ip2_chan     = -99
          nfB1 = 2
          wt = qbepsBth2g1WDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep initiated      
        if (qactive_chan(93).and.qselect_chan(93)) then
          current_chan = 93
          ip1_chan     = 30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpepsBth2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep initiated     
        if (qactive_chan(94).and.qselect_chan(94)) then
          current_chan = 94
          ip1_chan     = -30
          ip2_chan     = -99
          nfB1 = 2
          wt = qpbepsBth2g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub Q Qb u 
        if (qactive_chan(95).and.qselect_chan(95)) then
          current_chan = 95
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qepsC0g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep to enub db Qb u 
        if (qactive_chan(96).and.qselect_chan(96)) then
          current_chan = 96
          ip1_chan     = -30
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qpbepsC0g1WDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep to enub db Q u 
        if (qactive_chan(97).and.qselect_chan(97)) then
          current_chan = 97
          ip1_chan     = 30
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qpepsC0g1WDIST(ix,xri1,xri2,4,5,1,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db Q Qb 
        if (qactive_chan(98).and.qselect_chan(98)) then
          current_chan = 98
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qbepsC0g1WDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(99).and.qselect_chan(99)) then
          current_chan = 99
          ip1_chan     = 0
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = gepsC0g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub Q Qb u 
        if (qactive_chan(100).and.qselect_chan(100)) then
          current_chan = 100
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qepCt0g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep to enub db Qb u 
        if (qactive_chan(101).and.qselect_chan(101)) then
          current_chan = 101
          ip1_chan     = -30
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qpbepCt0g1WDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep to enub db Q u 
        if (qactive_chan(102).and.qselect_chan(102)) then
          current_chan = 102
          ip1_chan     = 30
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qpepCt0g1WDIST(ix,xri1,xri2,4,5,1,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db Q Qb 
        if (qactive_chan(103).and.qselect_chan(103)) then
          current_chan = 103
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qbepCt0g1WDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(104).and.qselect_chan(104)) then
          current_chan = 104
          ip1_chan     = 0
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = gepCt0g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub Q Qb u 
        if (qactive_chan(105).and.qselect_chan(105)) then
          current_chan = 105
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qepCh0g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep to enub db Qb u 
        if (qactive_chan(106).and.qselect_chan(106)) then
          current_chan = 106
          ip1_chan     = -30
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qpbepCh0g1WDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep to enub db Q u 
        if (qactive_chan(107).and.qselect_chan(107)) then
          current_chan = 107
          ip1_chan     = 30
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qpepCh0g1WDIST(ix,xri1,xri2,4,5,1,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db Q Qb 
        if (qactive_chan(108).and.qselect_chan(108)) then
          current_chan = 108
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = qbepCh0g1WDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(109).and.qselect_chan(109)) then
          current_chan = 109
          ip1_chan     = 0
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 4
          wt = gepCh0g1WDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub d db u 
        if (qactive_chan(110).and.qselect_chan(110)) then
          current_chan = 110
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qpepD0g1WmaDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ep to enub db db u 
        if (qactive_chan(111).and.qselect_chan(111)) then
          current_chan = 111
          ip1_chan     = -40
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qpbepD0g1WmaDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db d db 
        if (qactive_chan(112).and.qselect_chan(112)) then
          current_chan = 112
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qbepD0g1WmaDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(113).and.qselect_chan(113)) then
          current_chan = 113
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gepD0g1WmaDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub u ub u 
        if (qactive_chan(114).and.qselect_chan(114)) then
          current_chan = 114
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qpepD0g1WmbDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db ub u 
        if (qactive_chan(115).and.qselect_chan(115)) then
          current_chan = 115
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qbepD0g1WmbDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ep to enub db u u 
        if (qactive_chan(116).and.qselect_chan(116)) then
          current_chan = 116
          ip1_chan     = 20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qepD0g1WmbDIST(ix,xri1,xri2,4,5,1,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(117).and.qselect_chan(117)) then
          current_chan = 117
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gepD0g1WmbDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub d db u 
        if (qactive_chan(118).and.qselect_chan(118)) then
          current_chan = 118
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qpepDt0g1WmaDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ep to enub db db u 
        if (qactive_chan(119).and.qselect_chan(119)) then
          current_chan = 119
          ip1_chan     = -40
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qpbepDt0g1WmaDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db d db 
        if (qactive_chan(120).and.qselect_chan(120)) then
          current_chan = 120
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qbepDt0g1WmaDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(121).and.qselect_chan(121)) then
          current_chan = 121
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gepDt0g1WmaDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub u ub u 
        if (qactive_chan(122).and.qselect_chan(122)) then
          current_chan = 122
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qpepDt0g1WmbDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db ub u 
        if (qactive_chan(123).and.qselect_chan(123)) then
          current_chan = 123
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qbepDt0g1WmbDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ep to enub db u u 
        if (qactive_chan(124).and.qselect_chan(124)) then
          current_chan = 124
          ip1_chan     = 20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qepDt0g1WmbDIST(ix,xri1,xri2,4,5,1,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(125).and.qselect_chan(125)) then
          current_chan = 125
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gepDt0g1WmbDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub d db u 
        if (qactive_chan(126).and.qselect_chan(126)) then
          current_chan = 126
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qpepDh0g1WmaDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ep to enub db db u 
        if (qactive_chan(127).and.qselect_chan(127)) then
          current_chan = 127
          ip1_chan     = -40
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qpbepDh0g1WmaDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db d db 
        if (qactive_chan(128).and.qselect_chan(128)) then
          current_chan = 128
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 1
          nfC2 = 1
          wt = qbepDh0g1WmaDIST(ix,xri1,xri2,4,5,6,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(129).and.qselect_chan(129)) then
          current_chan = 129
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gepDh0g1WmaDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub u ub u 
        if (qactive_chan(130).and.qselect_chan(130)) then
          current_chan = 130
          ip1_chan     = 40
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qpepDh0g1WmbDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db ub u 
        if (qactive_chan(131).and.qselect_chan(131)) then
          current_chan = 131
          ip1_chan     = -20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qbepDh0g1WmbDIST(ix,xri1,xri2,4,1,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ep to enub db u u 
        if (qactive_chan(132).and.qselect_chan(132)) then
          current_chan = 132
          ip1_chan     = 20
          ip2_chan     = -99
          nfC1 = 2
          nfC2 = 2
          wt = qepDh0g1WmbDIST(ix,xri1,xri2,4,5,1,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(133).and.qselect_chan(133)) then
          current_chan = 133
          ip1_chan     = 0
          ip2_chan     = -99
          nfB1 = 2
          wt = gepDh0g1WmbDIST(ix,xri1,xri2,1,4,5,6,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTDISWp=sigTDISWp+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
