      function sigTNLODISWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLODISWm=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- u em to enu g d     
        if (qactive_chan(20).and.qselect_chan(20)) then
          current_chan = 20
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemB1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(21).and.qselect_chan(21)) then
          current_chan = 21
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemB1g1WDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(22).and.qselect_chan(22)) then
          current_chan = 22
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemB1g1WDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(23).and.qselect_chan(23)) then
          current_chan = 23
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemB1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(24).and.qselect_chan(24)) then
          current_chan = 24
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemB1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(25).and.qselect_chan(25)) then
          current_chan = 25
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemBt1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(26).and.qselect_chan(26)) then
          current_chan = 26
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemBt1g1WDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(27).and.qselect_chan(27)) then
          current_chan = 27
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemBt1g1WDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(28).and.qselect_chan(28)) then
          current_chan = 28
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemBt1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(29).and.qselect_chan(29)) then
          current_chan = 29
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemBt1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(30).and.qselect_chan(30)) then
          current_chan = 30
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemBh1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(31).and.qselect_chan(31)) then
          current_chan = 31
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemBh1g1WDISTNLO(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(32).and.qselect_chan(32)) then
          current_chan = 32
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemBh1g1WDISTNLO(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(33).and.qselect_chan(33)) then
          current_chan = 33
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemBh1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(34).and.qselect_chan(34)) then
          current_chan = 34
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemBh1g1WDISTNLO(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLODISWm=sigTNLODISWm+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
