      function sigSDISWp1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSDISWp1j=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      jflag=.false.
      ix=1
      ix_chan=1

c--- d ep to enub g g u  
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = 40
        ip2_chan     = -99
        nfB1 = 2
        wt = qepcsB2g0WDIS1jS(1,4,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db g u 
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = 0
        ip2_chan     = -99
        nfB1 = 2
        wt = gepcsB2g0WDIS1jS(4,1,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g g 
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = -20
        ip2_chan     = -99
        nfB1 = 2
        wt = qbepcsB2g0WDIS1jS(4,5,6,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub gt gt u 
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = 40
        ip2_chan     = -99
        nfB1 = 2
        wt = qepcsBt2g0WDIS1jS(1,4,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- gt ep to enub db gt u 
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = 0
        ip2_chan     = -99
        nfB1 = 2
        wt = gtepcsBt2g0WDIS1jS(4,1,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db gt gt 
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = -20
        ip2_chan     = -99
        nfB1 = 2
        wt = qbepcsBt2g0WDIS1jS(4,5,6,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub Q Qb u 
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qepsC0g0WDIS1jS(1,4,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- Qb ep to enub db Qb u 
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = -30
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qpbepsC0g0WDIS1jS(4,1,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- Q ep to enub db Q u 
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = 30
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qpepsC0g0WDIS1jS(4,5,1,6,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db Q Qb 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qbepsC0g0WDIS1jS(4,5,6,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub d db u 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qpepD0g0WaDIS1jS(1,4,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- db ep to enub db db u 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = -40
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qpbepD0g0WaDIS1jS(4,1,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db d db 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qbepD0g0WaDIS1jS(4,5,6,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub u ub u 
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qpepD0g0WbDIS1jS(1,4,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db ub u 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qbepD0g0WbDIS1jS(4,1,5,6,2,3)
        wtsum = wtsum + wt
      endif
c--- u ep to enub db u u 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = 20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qepD0g0WbDIS1jS(4,5,1,6,2,3)
        wtsum = wtsum + wt
      endif
      sigSDISWp1j=sigSDISWp1j+rnorm*wtsum

      return
      end
