      function sigTDISWm1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTDISWm1j=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- u em to enu g d     
        if (qactive_chan(27).and.qselect_chan(27)) then
          current_chan = 27
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemcsB1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(28).and.qselect_chan(28)) then
          current_chan = 28
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemcsB1g1WDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(29).and.qselect_chan(29)) then
          current_chan = 29
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemcsB1g1WDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(30).and.qselect_chan(30)) then
          current_chan = 30
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemcsB1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(31).and.qselect_chan(31)) then
          current_chan = 31
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemcsB1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(32).and.qselect_chan(32)) then
          current_chan = 32
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemcsBt1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(33).and.qselect_chan(33)) then
          current_chan = 33
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemcsBt1g1WDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(34).and.qselect_chan(34)) then
          current_chan = 34
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemcsBt1g1WDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(35).and.qselect_chan(35)) then
          current_chan = 35
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemcsBt1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(36).and.qselect_chan(36)) then
          current_chan = 36
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemcsBt1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(37).and.qselect_chan(37)) then
          current_chan = 37
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 1
          wt = qemcsBh1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(38).and.qselect_chan(38)) then
          current_chan = 38
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemcsBh1g1WDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(39).and.qselect_chan(39)) then
          current_chan = 39
          ip1_chan     = -40
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemcsBh1g1WDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(40).and.qselect_chan(40)) then
          current_chan = 40
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemcsBh1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(41).and.qselect_chan(41)) then
          current_chan = 41
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemcsBh1g1WDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTDISWm1j=sigTDISWm1j+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
