*********************************************************************
*
*
* Quark pair NLO real subtraction term for
*
* q(i1) g (i2) g (i3) qb(i4) e-(i5) e+(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BGFlav/

      function gtqBt2g0GSNLO(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gtqBt2g0GSNLO = qgtBt2g0GSNLO(i1,i2,i3,i4,i5)

      return
      end
      function gtqbBt2g0GSNLO(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gtqbBt2g0GSNLO = qbgtBt2g0GSNLO(i1,i2,i3,i4,i5)

      return
      end

      function qbqBt2g0GSNLO(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbqBt2g0GSNLO = qqbBt2g0GSNLO(i1,i2,i3,i4,i5)

      return
      end


*      function gtgtBt2g0GSNLO(i1,i2,i3,i4,i5)
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*      parameter(pi=3.141592653589793238d0)
*
*      gtgtBt2g0GSNLO = ggB2g0GSNLO(i1,i2,i3,i4,i5)
*
*      return
*      end

*      function gtqBt2g0GSNLO_frag(i1,i2,i3,i4,i5)
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*      parameter(pi=3.141592653589793238d0)
*
*      gtqBt2g0GSNLO_frag = qgtBt2g0GSNLO_frag(i1,i2,i3,i4,i5)
*
*      return
*      end
*      
*      function gtqbBt2g0GSNLO_frag(i1,i2,i3,i4,i5)
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*      parameter(pi=3.141592653589793238d0)
*
*      gtqbBt2g0GSNLO_frag = qbgtBt2g0GSNLO_frag(i1,i2,i3,i4,i5)
*
*      return
*      end

