      function ggsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      !--- Xuan's converted subtraction terms
      ! ggsB2g1GT = ggB2g1GT_v1(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      !-- Aude's subtraction terms
      ggsB2g1GT = ggB2g1GXT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
     .          + ggB2g1GXT(ix,x1,x2,i1,i3,i2,i4,i5,renscale2,facscale2)

      return
      end

      function gqsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C --- called as gqsB2g1GT(2,1,3,4,5,6)
      gqsB2g1GT = qgsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function gqbsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C --- called as gqbsB2g1GT(3,1,4,2,5,6)
      gqbsB2g1GT = qbgsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbgsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C --- called as qbgsB2g1GT(3,2,4,1,5,6)
      qbgsB2g1GT = qbgB2g1GT(ix,x1,x2,i1,i3,i2,i4,i5,renscale2,facscale2) ! i2 <--> i3

      return
      end

      function qbqsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqsB2g1GT = qqbsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbqpsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqpsB2g1GT = 0d0 ! No subtraction term, initial state in C0g1G

      return
      end

      function qbqpbsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqpbsB2g1GT = 0d0 ! No subtraction term, initial state in C0g1G

      return
      end

      function qgsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C --- called as qgsB2g1GT(1,2,3,4,5,6)
      qgsB2g1GT = qgB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqbsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqbsB2g1GT = qqbB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
     .            +qqbB2g1GT(ix,x1,x2,i1,i3,i2,i4,i5,renscale2,facscale2)

      return
      end

      function qqpsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqpsB2g1GT = 0d0 ! No subtraction term, initial state in C0g1G

      return
      end

      function qqpbsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqpbsB2g1GT = 0d0

      return
      end

c     FRAGMENTATION SUBTRACTION TERMS

      function qgsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qgsB2g1GT_frag = qgB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqbsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqbsB2g1GT_frag = qqbsB2g1GT(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function gqsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqsB2g1GT_frag = qgsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbqsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqsB2g1GT_frag = qqbsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function ggsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      ggsB2g1GT_frag = ggB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbgsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbgsB2g1GT_frag = qgsB2g1GT_frag(ix,x1,x2,i4,i2,i3,i1,i5,renscale2,facscale2)

      return
      end

      function gqbsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqbsB2g1GT_frag = qbgsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqpsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqpsB2g1GT_frag = 0d0 ! No subtraction term, initial state in C0g1G

      return
      end

      function qqpbsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqpbsB2g1GT_frag = 0d0

      return
      end

      function qbqpsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqpsB2g1GT_frag = 0d0 ! No subtraction term, initial state in C0g1G

      return
      end

      function qbqpbsB2g1GT_frag(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqpbsB2g1GT_frag = 0d0 ! No subtraction term, initial state in C0g1G

      return
      end
