      function sigSNLOGJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLOGJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- d g to g d G        
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgB2g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- u g to g u G        
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgB2g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- d db to g g G       
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbB2g0GSNLO(1,3,4,2,5)
        wtsum = wtsum + wt
      endif
c--- u ub to g g G       
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbB2g0GSNLO(1,3,4,2,5)
        wtsum = wtsum + wt
      endif
c--- g d to g d G        
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gqB2g0GSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- g u to g u G        
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gqB2g0GSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- db d to g g G       
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqB2g0GSNLO(2,3,4,1,5)
        wtsum = wtsum + wt
      endif
c--- ub u to g g G       
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqB2g0GSNLO(2,3,4,1,5)
        wtsum = wtsum + wt
      endif
c--- g g to db d G       
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        wt = ggB2g0GSNLO(3,1,2,4,5)
        wtsum = wtsum + wt
      endif
c--- g g to ub u G       
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        wt = ggB2g0GSNLO(3,1,2,4,5)
        wtsum = wtsum + wt
      endif
c--- g db to db g G      
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gqbB2g0GSNLO(3,1,4,2,5)
        wtsum = wtsum + wt
      endif
c--- g ub to ub g G      
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gqbB2g0GSNLO(3,1,4,2,5)
        wtsum = wtsum + wt
      endif
c--- db g to db g G      
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgB2g0GSNLO(3,2,4,1,5)
        wtsum = wtsum + wt
      endif
c--- ub g to ub g G      
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgB2g0GSNLO(3,2,4,1,5)
        wtsum = wtsum + wt
      endif
c--- d gt to gt d G      
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgtBt2g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- u gt to gt u G      
      if (qactive_chan(28).and.qselect_chan(28)) then
        current_chan = 28
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgtBt2g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- d db to gt gt G     
      if (qactive_chan(29).and.qselect_chan(29)) then
        current_chan = 29
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbBt2g0GSNLO(1,3,4,2,5)
        wtsum = wtsum + wt
      endif
c--- u ub to gt gt G     
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbBt2g0GSNLO(1,3,4,2,5)
        wtsum = wtsum + wt
      endif
c--- gt d to gt d G      
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gtqBt2g0GSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- gt u to gt u G      
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gtqBt2g0GSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- db d to gt gt G     
      if (qactive_chan(33).and.qselect_chan(33)) then
        current_chan = 33
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqBt2g0GSNLO(2,3,4,1,5)
        wtsum = wtsum + wt
      endif
c--- ub u to gt gt G     
      if (qactive_chan(34).and.qselect_chan(34)) then
        current_chan = 34
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqBt2g0GSNLO(2,3,4,1,5)
        wtsum = wtsum + wt
      endif
c--- gt gt to db d G     
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        wt = gtgtBt2g0GSNLO(3,1,2,4,5)
        wtsum = wtsum + wt
      endif
c--- gt gt to ub u G     
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        wt = gtgtBt2g0GSNLO(3,1,2,4,5)
        wtsum = wtsum + wt
      endif
c--- gt db to db gt G    
      if (qactive_chan(37).and.qselect_chan(37)) then
        current_chan = 37
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gtqbBt2g0GSNLO(3,1,4,2,5)
        wtsum = wtsum + wt
      endif
c--- gt ub to ub gt G    
      if (qactive_chan(38).and.qselect_chan(38)) then
        current_chan = 38
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gtqbBt2g0GSNLO(3,1,4,2,5)
        wtsum = wtsum + wt
      endif
c--- db gt to db gt G    
      if (qactive_chan(39).and.qselect_chan(39)) then
        current_chan = 39
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgtBt2g0GSNLO(3,2,4,1,5)
        wtsum = wtsum + wt
      endif
c--- ub gt to ub gt G    
      if (qactive_chan(40).and.qselect_chan(40)) then
        current_chan = 40
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgtBt2g0GSNLO(3,2,4,1,5)
        wtsum = wtsum + wt
      endif
c--- d db to db d G      
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qqpbC0g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- d ub to ub d G      
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qqpbC0g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- u db to db u G      
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qqpbC0g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- u ub to ub u G      
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qqpbC0g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- d d to d d G        
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qqpC0g0GSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- d u to u d G        
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qqpC0g0GSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- u d to d u G        
      if (qactive_chan(47).and.qselect_chan(47)) then
        current_chan = 47
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qqpC0g0GSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- u u to u u G        
      if (qactive_chan(48).and.qselect_chan(48)) then
        current_chan = 48
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qqpC0g0GSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- d db to d db G      
      if (qactive_chan(49).and.qselect_chan(49)) then
        current_chan = 49
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbC0g0GSNLO(1,3,4,2,5)
        wtsum = wtsum + wt
      endif
c--- d db to u ub G      
      if (qactive_chan(50).and.qselect_chan(50)) then
        current_chan = 50
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = qqbC0g0GSNLO(1,3,4,2,5)
        wtsum = wtsum + wt
      endif
c--- u ub to d db G      
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = qqbC0g0GSNLO(1,3,4,2,5)
        wtsum = wtsum + wt
      endif
c--- u ub to u ub G      
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbC0g0GSNLO(1,3,4,2,5)
        wtsum = wtsum + wt
      endif
c--- db d to d db G      
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqC0g0GSNLO(2,3,4,1,5)
        wtsum = wtsum + wt
      endif
c--- db d to u ub G      
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = qbqC0g0GSNLO(2,3,4,1,5)
        wtsum = wtsum + wt
      endif
c--- ub u to d db G      
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = qbqC0g0GSNLO(2,3,4,1,5)
        wtsum = wtsum + wt
      endif
c--- ub u to u ub G      
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqC0g0GSNLO(2,3,4,1,5)
        wtsum = wtsum + wt
      endif
c--- db db to db db G    
      if (qactive_chan(57).and.qselect_chan(57)) then
        current_chan = 57
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpbC0g0GSNLO(3,2,4,1,5)
        wtsum = wtsum + wt
      endif
c--- db ub to db ub G    
      if (qactive_chan(58).and.qselect_chan(58)) then
        current_chan = 58
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpbC0g0GSNLO(3,2,4,1,5)
        wtsum = wtsum + wt
      endif
c--- ub db to ub db G    
      if (qactive_chan(59).and.qselect_chan(59)) then
        current_chan = 59
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpbC0g0GSNLO(3,2,4,1,5)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub ub G    
      if (qactive_chan(60).and.qselect_chan(60)) then
        current_chan = 60
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpbC0g0GSNLO(3,2,4,1,5)
        wtsum = wtsum + wt
      endif
c--- db d to db d G      
      if (qactive_chan(61).and.qselect_chan(61)) then
        current_chan = 61
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpC0g0GSNLO(3,4,2,1,5)
        wtsum = wtsum + wt
      endif
c--- db u to db u G      
      if (qactive_chan(62).and.qselect_chan(62)) then
        current_chan = 62
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpC0g0GSNLO(3,4,2,1,5)
        wtsum = wtsum + wt
      endif
c--- ub d to ub d G      
      if (qactive_chan(63).and.qselect_chan(63)) then
        current_chan = 63
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpC0g0GSNLO(3,4,2,1,5)
        wtsum = wtsum + wt
      endif
c--- ub u to ub u G      
      if (qactive_chan(64).and.qselect_chan(64)) then
        current_chan = 64
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpC0g0GSNLO(3,4,2,1,5)
        wtsum = wtsum + wt
      endif
c--- d db to db d G      
      if (qactive_chan(65).and.qselect_chan(65)) then
        current_chan = 65
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbD0g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- u ub to ub u G      
      if (qactive_chan(66).and.qselect_chan(66)) then
        current_chan = 66
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbD0g0GSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- d d to d d G        
      if (qactive_chan(67).and.qselect_chan(67)) then
        current_chan = 67
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qqD0g0GSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- u u to u u G        
      if (qactive_chan(68).and.qselect_chan(68)) then
        current_chan = 68
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qqD0g0GSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- db d to db d G      
      if (qactive_chan(69).and.qselect_chan(69)) then
        current_chan = 69
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqD0g0GSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- ub u to ub u G      
      if (qactive_chan(70).and.qselect_chan(70)) then
        current_chan = 70
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqD0g0GSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- db db to db db G    
      if (qactive_chan(71).and.qselect_chan(71)) then
        current_chan = 71
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qbqbD0g0GSNLO(3,1,4,2,5)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub ub G    
      if (qactive_chan(72).and.qselect_chan(72)) then
        current_chan = 72
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qbqbD0g0GSNLO(3,1,4,2,5)
        wtsum = wtsum + wt
      endif
      sigSNLOGJ=sigSNLOGJ+rnorm*wtsum

      return
      end
