      function sigTNLOGJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLOGJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d g to d G          
        if (qactive_chan(73).and.qselect_chan(73)) then
          current_chan = 73
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u G          
        if (qactive_chan(74).and.qselect_chan(74)) then
          current_chan = 74
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g G         
        if (qactive_chan(75).and.qselect_chan(75)) then
          current_chan = 75
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbB1g1GTNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g G         
        if (qactive_chan(76).and.qselect_chan(76)) then
          current_chan = 76
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbB1g1GTNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d G          
        if (qactive_chan(77).and.qselect_chan(77)) then
          current_chan = 77
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqB1g1GTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u G          
        if (qactive_chan(78).and.qselect_chan(78)) then
          current_chan = 78
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqB1g1GTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g G         
        if (qactive_chan(79).and.qselect_chan(79)) then
          current_chan = 79
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqB1g1GTNLO(ix,xri1,xri2,2,3,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g G         
        if (qactive_chan(80).and.qselect_chan(80)) then
          current_chan = 80
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqB1g1GTNLO(ix,xri1,xri2,2,3,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db G        
        if (qactive_chan(81).and.qselect_chan(81)) then
          current_chan = 81
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbB1g1GTNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub G        
        if (qactive_chan(82).and.qselect_chan(82)) then
          current_chan = 82
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbB1g1GTNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db G        
        if (qactive_chan(83).and.qselect_chan(83)) then
          current_chan = 83
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgB1g1GTNLO(ix,xri1,xri2,3,2,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub G        
        if (qactive_chan(84).and.qselect_chan(84)) then
          current_chan = 84
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgB1g1GTNLO(ix,xri1,xri2,3,2,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(85).and.qselect_chan(85)) then
          current_chan = 85
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(86).and.qselect_chan(86)) then
          current_chan = 86
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(87).and.qselect_chan(87)) then
          current_chan = 87
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(88).and.qselect_chan(88)) then
          current_chan = 88
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(89).and.qselect_chan(89)) then
          current_chan = 89
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(90).and.qselect_chan(90)) then
          current_chan = 90
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(91).and.qselect_chan(91)) then
          current_chan = 91
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(92).and.qselect_chan(92)) then
          current_chan = 92
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(93).and.qselect_chan(93)) then
          current_chan = 93
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(94).and.qselect_chan(94)) then
          current_chan = 94
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(95).and.qselect_chan(95)) then
          current_chan = 95
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(96).and.qselect_chan(96)) then
          current_chan = 96
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(97).and.qselect_chan(97)) then
          current_chan = 97
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(98).and.qselect_chan(98)) then
          current_chan = 98
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(99).and.qselect_chan(99)) then
          current_chan = 99
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(100).and.qselect_chan(100)) then
          current_chan = 100
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(101).and.qselect_chan(101)) then
          current_chan = 101
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(102).and.qselect_chan(102)) then
          current_chan = 102
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbB1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to d G          
        if (qactive_chan(103).and.qselect_chan(103)) then
          current_chan = 103
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u G          
        if (qactive_chan(104).and.qselect_chan(104)) then
          current_chan = 104
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g G         
        if (qactive_chan(105).and.qselect_chan(105)) then
          current_chan = 105
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbBt1g1GTNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g G         
        if (qactive_chan(106).and.qselect_chan(106)) then
          current_chan = 106
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbBt1g1GTNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d G          
        if (qactive_chan(107).and.qselect_chan(107)) then
          current_chan = 107
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqBt1g1GTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u G          
        if (qactive_chan(108).and.qselect_chan(108)) then
          current_chan = 108
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqBt1g1GTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g G         
        if (qactive_chan(109).and.qselect_chan(109)) then
          current_chan = 109
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqBt1g1GTNLO(ix,xri1,xri2,2,3,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g G         
        if (qactive_chan(110).and.qselect_chan(110)) then
          current_chan = 110
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqBt1g1GTNLO(ix,xri1,xri2,2,3,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db G        
        if (qactive_chan(111).and.qselect_chan(111)) then
          current_chan = 111
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbBt1g1GTNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub G        
        if (qactive_chan(112).and.qselect_chan(112)) then
          current_chan = 112
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbBt1g1GTNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db G        
        if (qactive_chan(113).and.qselect_chan(113)) then
          current_chan = 113
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgBt1g1GTNLO(ix,xri1,xri2,3,2,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub G        
        if (qactive_chan(114).and.qselect_chan(114)) then
          current_chan = 114
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgBt1g1GTNLO(ix,xri1,xri2,3,2,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(115).and.qselect_chan(115)) then
          current_chan = 115
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(116).and.qselect_chan(116)) then
          current_chan = 116
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(117).and.qselect_chan(117)) then
          current_chan = 117
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(118).and.qselect_chan(118)) then
          current_chan = 118
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(119).and.qselect_chan(119)) then
          current_chan = 119
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(120).and.qselect_chan(120)) then
          current_chan = 120
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(121).and.qselect_chan(121)) then
          current_chan = 121
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(122).and.qselect_chan(122)) then
          current_chan = 122
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(123).and.qselect_chan(123)) then
          current_chan = 123
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(124).and.qselect_chan(124)) then
          current_chan = 124
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(125).and.qselect_chan(125)) then
          current_chan = 125
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(126).and.qselect_chan(126)) then
          current_chan = 126
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(127).and.qselect_chan(127)) then
          current_chan = 127
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(128).and.qselect_chan(128)) then
          current_chan = 128
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(129).and.qselect_chan(129)) then
          current_chan = 129
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(130).and.qselect_chan(130)) then
          current_chan = 130
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(131).and.qselect_chan(131)) then
          current_chan = 131
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(132).and.qselect_chan(132)) then
          current_chan = 132
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBt1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to d G          
        if (qactive_chan(133).and.qselect_chan(133)) then
          current_chan = 133
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u G          
        if (qactive_chan(134).and.qselect_chan(134)) then
          current_chan = 134
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g G         
        if (qactive_chan(135).and.qselect_chan(135)) then
          current_chan = 135
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbBh1g1GTNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g G         
        if (qactive_chan(136).and.qselect_chan(136)) then
          current_chan = 136
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbBh1g1GTNLO(ix,xri1,xri2,1,3,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d G          
        if (qactive_chan(137).and.qselect_chan(137)) then
          current_chan = 137
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqBh1g1GTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u G          
        if (qactive_chan(138).and.qselect_chan(138)) then
          current_chan = 138
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqBh1g1GTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g G         
        if (qactive_chan(139).and.qselect_chan(139)) then
          current_chan = 139
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqBh1g1GTNLO(ix,xri1,xri2,2,3,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g G         
        if (qactive_chan(140).and.qselect_chan(140)) then
          current_chan = 140
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqBh1g1GTNLO(ix,xri1,xri2,2,3,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db G        
        if (qactive_chan(141).and.qselect_chan(141)) then
          current_chan = 141
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbBh1g1GTNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub G        
        if (qactive_chan(142).and.qselect_chan(142)) then
          current_chan = 142
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbBh1g1GTNLO(ix,xri1,xri2,3,1,2,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db G        
        if (qactive_chan(143).and.qselect_chan(143)) then
          current_chan = 143
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgBh1g1GTNLO(ix,xri1,xri2,3,2,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub G        
        if (qactive_chan(144).and.qselect_chan(144)) then
          current_chan = 144
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgBh1g1GTNLO(ix,xri1,xri2,3,2,1,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(145).and.qselect_chan(145)) then
          current_chan = 145
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(146).and.qselect_chan(146)) then
          current_chan = 146
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(147).and.qselect_chan(147)) then
          current_chan = 147
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(148).and.qselect_chan(148)) then
          current_chan = 148
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(149).and.qselect_chan(149)) then
          current_chan = 149
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(150).and.qselect_chan(150)) then
          current_chan = 150
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(151).and.qselect_chan(151)) then
          current_chan = 151
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(152).and.qselect_chan(152)) then
          current_chan = 152
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(153).and.qselect_chan(153)) then
          current_chan = 153
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(154).and.qselect_chan(154)) then
          current_chan = 154
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(155).and.qselect_chan(155)) then
          current_chan = 155
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(156).and.qselect_chan(156)) then
          current_chan = 156
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(157).and.qselect_chan(157)) then
          current_chan = 157
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(158).and.qselect_chan(158)) then
          current_chan = 158
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(159).and.qselect_chan(159)) then
          current_chan = 159
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(160).and.qselect_chan(160)) then
          current_chan = 160
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(161).and.qselect_chan(161)) then
          current_chan = 161
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(162).and.qselect_chan(162)) then
          current_chan = 162
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBh1g1GTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLOGJ=sigTNLOGJ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
