      function sigSNLOGJJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLOGJJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- d g to g g d G      
      if (qactive_chan(61).and.qselect_chan(61)) then
        current_chan = 61
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgsB3g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u g to g g u G      
      if (qactive_chan(62).and.qselect_chan(62)) then
        current_chan = 62
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgsB3g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to g g g G     
      if (qactive_chan(63).and.qselect_chan(63)) then
        current_chan = 63
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbsB3g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g g g G     
      if (qactive_chan(64).and.qselect_chan(64)) then
        current_chan = 64
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbsB3g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g d to g g d G      
      if (qactive_chan(65).and.qselect_chan(65)) then
        current_chan = 65
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gqsB3g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to g g u G      
      if (qactive_chan(66).and.qselect_chan(66)) then
        current_chan = 66
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gqsB3g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db d to g g g G     
      if (qactive_chan(67).and.qselect_chan(67)) then
        current_chan = 67
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqsB3g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to g g g G     
      if (qactive_chan(68).and.qselect_chan(68)) then
        current_chan = 68
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqsB3g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- g g to db g d G     
      if (qactive_chan(69).and.qselect_chan(69)) then
        current_chan = 69
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        wt = ggsB3g0GSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g g to ub g u G     
      if (qactive_chan(70).and.qselect_chan(70)) then
        current_chan = 70
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        wt = ggsB3g0GSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g db to db g g G    
      if (qactive_chan(71).and.qselect_chan(71)) then
        current_chan = 71
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gqbsB3g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g ub to ub g g G    
      if (qactive_chan(72).and.qselect_chan(72)) then
        current_chan = 72
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gqbsB3g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- db g to db g g G    
      if (qactive_chan(73).and.qselect_chan(73)) then
        current_chan = 73
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgsB3g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub g to ub g g G    
      if (qactive_chan(74).and.qselect_chan(74)) then
        current_chan = 74
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgsB3g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- d g to g g d G      
      if (qactive_chan(75).and.qselect_chan(75)) then
        current_chan = 75
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgsBt3g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u g to g g u G      
      if (qactive_chan(76).and.qselect_chan(76)) then
        current_chan = 76
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgsBt3g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to g g g G     
      if (qactive_chan(77).and.qselect_chan(77)) then
        current_chan = 77
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbsBt3g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g g g G     
      if (qactive_chan(78).and.qselect_chan(78)) then
        current_chan = 78
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbsBt3g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g d to g g d G      
      if (qactive_chan(79).and.qselect_chan(79)) then
        current_chan = 79
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gqsBt3g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to g g u G      
      if (qactive_chan(80).and.qselect_chan(80)) then
        current_chan = 80
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gqsBt3g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db d to g g g G     
      if (qactive_chan(81).and.qselect_chan(81)) then
        current_chan = 81
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqsBt3g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to g g g G     
      if (qactive_chan(82).and.qselect_chan(82)) then
        current_chan = 82
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqsBt3g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- g g to db g d G     
      if (qactive_chan(83).and.qselect_chan(83)) then
        current_chan = 83
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        wt = ggsBt3g0GSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g g to ub g u G     
      if (qactive_chan(84).and.qselect_chan(84)) then
        current_chan = 84
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        wt = ggsBt3g0GSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g db to db g g G    
      if (qactive_chan(85).and.qselect_chan(85)) then
        current_chan = 85
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gqbsBt3g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g ub to ub g g G    
      if (qactive_chan(86).and.qselect_chan(86)) then
        current_chan = 86
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gqbsBt3g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- db g to db g g G    
      if (qactive_chan(87).and.qselect_chan(87)) then
        current_chan = 87
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgsBt3g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub g to ub g g G    
      if (qactive_chan(88).and.qselect_chan(88)) then
        current_chan = 88
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgsBt3g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- d gt to gt gt d G   
      if (qactive_chan(89).and.qselect_chan(89)) then
        current_chan = 89
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgtsBtt3g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u gt to gt gt u G   
      if (qactive_chan(90).and.qselect_chan(90)) then
        current_chan = 90
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgtsBtt3g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to gt gt gt G  
      if (qactive_chan(91).and.qselect_chan(91)) then
        current_chan = 91
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbsBtt3g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- u ub to gt gt gt G  
      if (qactive_chan(92).and.qselect_chan(92)) then
        current_chan = 92
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbsBtt3g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- gt d to gt gt d G   
      if (qactive_chan(93).and.qselect_chan(93)) then
        current_chan = 93
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gtqsBtt3g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt u to gt gt u G   
      if (qactive_chan(94).and.qselect_chan(94)) then
        current_chan = 94
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gtqsBtt3g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db d to gt gt gt G  
      if (qactive_chan(95).and.qselect_chan(95)) then
        current_chan = 95
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqsBtt3g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to gt gt gt G  
      if (qactive_chan(96).and.qselect_chan(96)) then
        current_chan = 96
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqsBtt3g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to db gt d G  
      if (qactive_chan(97).and.qselect_chan(97)) then
        current_chan = 97
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        wt = gtgtsBtt3g0GSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to ub gt u G  
      if (qactive_chan(98).and.qselect_chan(98)) then
        current_chan = 98
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        wt = gtgtsBtt3g0GSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt db to db gt gt G 
      if (qactive_chan(99).and.qselect_chan(99)) then
        current_chan = 99
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gtqbsBtt3g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- gt ub to ub gt gt G 
      if (qactive_chan(100).and.qselect_chan(100)) then
        current_chan = 100
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gtqbsBtt3g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- db gt to db gt gt G 
      if (qactive_chan(101).and.qselect_chan(101)) then
        current_chan = 101
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgtsBtt3g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub gt to ub gt gt G 
      if (qactive_chan(102).and.qselect_chan(102)) then
        current_chan = 102
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgtsBtt3g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- d g to d db d G     
      if (qactive_chan(103).and.qselect_chan(103)) then
        current_chan = 103
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qgsC1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d g to u ub d G     
      if (qactive_chan(104).and.qselect_chan(104)) then
        current_chan = 104
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 2
        wt = qgsC1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u g to d db u G     
      if (qactive_chan(105).and.qselect_chan(105)) then
        current_chan = 105
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 1
        wt = qgsC1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u g to u ub u G     
      if (qactive_chan(106).and.qselect_chan(106)) then
        current_chan = 106
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qgsC1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to g db d G    
      if (qactive_chan(107).and.qselect_chan(107)) then
        current_chan = 107
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qqpbsC1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d ub to g ub d G    
      if (qactive_chan(108).and.qselect_chan(108)) then
        current_chan = 108
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qqpbsC1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u db to g db u G    
      if (qactive_chan(109).and.qselect_chan(109)) then
        current_chan = 109
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qqpbsC1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub u G    
      if (qactive_chan(110).and.qselect_chan(110)) then
        current_chan = 110
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qqpbsC1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d d to g d d G      
      if (qactive_chan(111).and.qselect_chan(111)) then
        current_chan = 111
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qqpsC1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- d u to g u d G      
      if (qactive_chan(112).and.qselect_chan(112)) then
        current_chan = 112
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qqpsC1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- u d to g d u G      
      if (qactive_chan(113).and.qselect_chan(113)) then
        current_chan = 113
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qqpsC1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- u u to g u u G      
      if (qactive_chan(114).and.qselect_chan(114)) then
        current_chan = 114
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qqpsC1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to g d db G    
      if (qactive_chan(115).and.qselect_chan(115)) then
        current_chan = 115
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbsC1g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- d db to g u ub G    
      if (qactive_chan(116).and.qselect_chan(116)) then
        current_chan = 116
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = qqbsC1g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g d db G    
      if (qactive_chan(117).and.qselect_chan(117)) then
        current_chan = 117
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = qqbsC1g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g u ub G    
      if (qactive_chan(118).and.qselect_chan(118)) then
        current_chan = 118
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbsC1g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g d to d db d G     
      if (qactive_chan(119).and.qselect_chan(119)) then
        current_chan = 119
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = gqsC1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g d to u ub d G     
      if (qactive_chan(120).and.qselect_chan(120)) then
        current_chan = 120
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = gqsC1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to d db u G     
      if (qactive_chan(121).and.qselect_chan(121)) then
        current_chan = 121
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = gqsC1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to u ub u G     
      if (qactive_chan(122).and.qselect_chan(122)) then
        current_chan = 122
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = gqsC1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db d to g d db G    
      if (qactive_chan(123).and.qselect_chan(123)) then
        current_chan = 123
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqsC1g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db d to g u ub G    
      if (qactive_chan(124).and.qselect_chan(124)) then
        current_chan = 124
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = qbqsC1g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to g d db G    
      if (qactive_chan(125).and.qselect_chan(125)) then
        current_chan = 125
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = qbqsC1g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to g u ub G    
      if (qactive_chan(126).and.qselect_chan(126)) then
        current_chan = 126
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqsC1g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- g db to db d db G   
      if (qactive_chan(127).and.qselect_chan(127)) then
        current_chan = 127
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = gqbsC1g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g db to db u ub G   
      if (qactive_chan(128).and.qselect_chan(128)) then
        current_chan = 128
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = gqbsC1g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g ub to ub d db G   
      if (qactive_chan(129).and.qselect_chan(129)) then
        current_chan = 129
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = gqbsC1g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g ub to ub u ub G   
      if (qactive_chan(130).and.qselect_chan(130)) then
        current_chan = 130
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = gqbsC1g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- db g to db d db G   
      if (qactive_chan(131).and.qselect_chan(131)) then
        current_chan = 131
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qbgsC1g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db g to db u ub G   
      if (qactive_chan(132).and.qselect_chan(132)) then
        current_chan = 132
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 2
        wt = qbgsC1g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub g to ub d db G   
      if (qactive_chan(133).and.qselect_chan(133)) then
        current_chan = 133
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 1
        wt = qbgsC1g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub g to ub u ub G   
      if (qactive_chan(134).and.qselect_chan(134)) then
        current_chan = 134
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qbgsC1g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db db to db g db G  
      if (qactive_chan(135).and.qselect_chan(135)) then
        current_chan = 135
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpbsC1g0GSNLO(3,4,2,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db ub to db g ub G  
      if (qactive_chan(136).and.qselect_chan(136)) then
        current_chan = 136
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpbsC1g0GSNLO(3,4,2,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub db to ub g db G  
      if (qactive_chan(137).and.qselect_chan(137)) then
        current_chan = 137
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpbsC1g0GSNLO(3,4,2,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub g ub G  
      if (qactive_chan(138).and.qselect_chan(138)) then
        current_chan = 138
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpbsC1g0GSNLO(3,4,2,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db d to db g d G    
      if (qactive_chan(139).and.qselect_chan(139)) then
        current_chan = 139
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpsC1g0GSNLO(3,4,5,2,1,6)
        wtsum = wtsum + wt
      endif
c--- db u to db g u G    
      if (qactive_chan(140).and.qselect_chan(140)) then
        current_chan = 140
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpsC1g0GSNLO(3,4,5,2,1,6)
        wtsum = wtsum + wt
      endif
c--- ub d to ub g d G    
      if (qactive_chan(141).and.qselect_chan(141)) then
        current_chan = 141
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpsC1g0GSNLO(3,4,5,2,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to ub g u G    
      if (qactive_chan(142).and.qselect_chan(142)) then
        current_chan = 142
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpsC1g0GSNLO(3,4,5,2,1,6)
        wtsum = wtsum + wt
      endif
c--- d g to d db d G     
      if (qactive_chan(143).and.qselect_chan(143)) then
        current_chan = 143
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qgsCt1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d g to u ub d G     
      if (qactive_chan(144).and.qselect_chan(144)) then
        current_chan = 144
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 2
        wt = qgsCt1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u g to d db u G     
      if (qactive_chan(145).and.qselect_chan(145)) then
        current_chan = 145
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 1
        wt = qgsCt1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u g to u ub u G     
      if (qactive_chan(146).and.qselect_chan(146)) then
        current_chan = 146
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qgsCt1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to g db d G    
      if (qactive_chan(147).and.qselect_chan(147)) then
        current_chan = 147
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qqpbsCt1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d ub to g ub d G    
      if (qactive_chan(148).and.qselect_chan(148)) then
        current_chan = 148
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qqpbsCt1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u db to g db u G    
      if (qactive_chan(149).and.qselect_chan(149)) then
        current_chan = 149
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qqpbsCt1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub u G    
      if (qactive_chan(150).and.qselect_chan(150)) then
        current_chan = 150
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qqpbsCt1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d d to g d d G      
      if (qactive_chan(151).and.qselect_chan(151)) then
        current_chan = 151
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qqpsCt1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- d u to g u d G      
      if (qactive_chan(152).and.qselect_chan(152)) then
        current_chan = 152
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qqpsCt1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- u d to g d u G      
      if (qactive_chan(153).and.qselect_chan(153)) then
        current_chan = 153
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qqpsCt1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- u u to g u u G      
      if (qactive_chan(154).and.qselect_chan(154)) then
        current_chan = 154
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qqpsCt1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to g d db G    
      if (qactive_chan(155).and.qselect_chan(155)) then
        current_chan = 155
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbsCt1g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- d db to g u ub G    
      if (qactive_chan(156).and.qselect_chan(156)) then
        current_chan = 156
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = qqbsCt1g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g d db G    
      if (qactive_chan(157).and.qselect_chan(157)) then
        current_chan = 157
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = qqbsCt1g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g u ub G    
      if (qactive_chan(158).and.qselect_chan(158)) then
        current_chan = 158
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbsCt1g0GSNLO(1,3,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g d to d db d G     
      if (qactive_chan(159).and.qselect_chan(159)) then
        current_chan = 159
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = gqsCt1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g d to u ub d G     
      if (qactive_chan(160).and.qselect_chan(160)) then
        current_chan = 160
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = gqsCt1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to d db u G     
      if (qactive_chan(161).and.qselect_chan(161)) then
        current_chan = 161
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = gqsCt1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to u ub u G     
      if (qactive_chan(162).and.qselect_chan(162)) then
        current_chan = 162
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = gqsCt1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db d to g d db G    
      if (qactive_chan(163).and.qselect_chan(163)) then
        current_chan = 163
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqsCt1g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db d to g u ub G    
      if (qactive_chan(164).and.qselect_chan(164)) then
        current_chan = 164
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = qbqsCt1g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to g d db G    
      if (qactive_chan(165).and.qselect_chan(165)) then
        current_chan = 165
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = qbqsCt1g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to g u ub G    
      if (qactive_chan(166).and.qselect_chan(166)) then
        current_chan = 166
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqsCt1g0GSNLO(2,3,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- g db to db d db G   
      if (qactive_chan(167).and.qselect_chan(167)) then
        current_chan = 167
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = gqbsCt1g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g db to db u ub G   
      if (qactive_chan(168).and.qselect_chan(168)) then
        current_chan = 168
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = gqbsCt1g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g ub to ub d db G   
      if (qactive_chan(169).and.qselect_chan(169)) then
        current_chan = 169
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = gqbsCt1g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- g ub to ub u ub G   
      if (qactive_chan(170).and.qselect_chan(170)) then
        current_chan = 170
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = gqbsCt1g0GSNLO(3,1,4,5,2,6)
        wtsum = wtsum + wt
      endif
c--- db g to db d db G   
      if (qactive_chan(171).and.qselect_chan(171)) then
        current_chan = 171
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qbgsCt1g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db g to db u ub G   
      if (qactive_chan(172).and.qselect_chan(172)) then
        current_chan = 172
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 2
        wt = qbgsCt1g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub g to ub d db G   
      if (qactive_chan(173).and.qselect_chan(173)) then
        current_chan = 173
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 1
        wt = qbgsCt1g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub g to ub u ub G   
      if (qactive_chan(174).and.qselect_chan(174)) then
        current_chan = 174
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qbgsCt1g0GSNLO(3,2,4,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db db to db g db G  
      if (qactive_chan(175).and.qselect_chan(175)) then
        current_chan = 175
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpbsCt1g0GSNLO(3,4,2,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db ub to db g ub G  
      if (qactive_chan(176).and.qselect_chan(176)) then
        current_chan = 176
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpbsCt1g0GSNLO(3,4,2,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub db to ub g db G  
      if (qactive_chan(177).and.qselect_chan(177)) then
        current_chan = 177
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpbsCt1g0GSNLO(3,4,2,5,1,6)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub g ub G  
      if (qactive_chan(178).and.qselect_chan(178)) then
        current_chan = 178
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpbsCt1g0GSNLO(3,4,2,5,1,6)
        wtsum = wtsum + wt
      endif
c--- db d to db g d G    
      if (qactive_chan(179).and.qselect_chan(179)) then
        current_chan = 179
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpsCt1g0GSNLO(3,4,5,2,1,6)
        wtsum = wtsum + wt
      endif
c--- db u to db g u G    
      if (qactive_chan(180).and.qselect_chan(180)) then
        current_chan = 180
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpsCt1g0GSNLO(3,4,5,2,1,6)
        wtsum = wtsum + wt
      endif
c--- ub d to ub g d G    
      if (qactive_chan(181).and.qselect_chan(181)) then
        current_chan = 181
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpsCt1g0GSNLO(3,4,5,2,1,6)
        wtsum = wtsum + wt
      endif
c--- ub u to ub g u G    
      if (qactive_chan(182).and.qselect_chan(182)) then
        current_chan = 182
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpsCt1g0GSNLO(3,4,5,2,1,6)
        wtsum = wtsum + wt
      endif
c--- d g to d db d G     
      if (qactive_chan(183).and.qselect_chan(183)) then
        current_chan = 183
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qgD1g0GcSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u g to u ub u G     
      if (qactive_chan(184).and.qselect_chan(184)) then
        current_chan = 184
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qgD1g0GcSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to g db d G    
      if (qactive_chan(185).and.qselect_chan(185)) then
        current_chan = 185
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbD1g0GcSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub u G    
      if (qactive_chan(186).and.qselect_chan(186)) then
        current_chan = 186
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbD1g0GcSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d d to g d d G      
      if (qactive_chan(187).and.qselect_chan(187)) then
        current_chan = 187
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qqD1g0GcSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- u u to g u u G      
      if (qactive_chan(188).and.qselect_chan(188)) then
        current_chan = 188
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qqD1g0GcSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- g d to d db d G     
      if (qactive_chan(189).and.qselect_chan(189)) then
        current_chan = 189
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = gqD1g0GcSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to u ub u G     
      if (qactive_chan(190).and.qselect_chan(190)) then
        current_chan = 190
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = gqD1g0GcSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db d to g db d G    
      if (qactive_chan(191).and.qselect_chan(191)) then
        current_chan = 191
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqD1g0GcSNLO(2,3,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- ub u to g ub u G    
      if (qactive_chan(192).and.qselect_chan(192)) then
        current_chan = 192
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqD1g0GcSNLO(2,3,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g db to db db d G   
      if (qactive_chan(193).and.qselect_chan(193)) then
        current_chan = 193
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = gqbD1g0GcSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g ub to ub ub u G   
      if (qactive_chan(194).and.qselect_chan(194)) then
        current_chan = 194
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = gqbD1g0GcSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db g to db db d G   
      if (qactive_chan(195).and.qselect_chan(195)) then
        current_chan = 195
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qbgD1g0GcSNLO(3,2,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- ub g to ub ub u G   
      if (qactive_chan(196).and.qselect_chan(196)) then
        current_chan = 196
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qbgD1g0GcSNLO(3,2,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db db to db g db G  
      if (qactive_chan(197).and.qselect_chan(197)) then
        current_chan = 197
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qbqbD1g0GcSNLO(3,4,1,5,2,6)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub g ub G  
      if (qactive_chan(198).and.qselect_chan(198)) then
        current_chan = 198
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qbqbD1g0GcSNLO(3,4,1,5,2,6)
        wtsum = wtsum + wt
      endif
c--- d g to d db d G     
      if (qactive_chan(199).and.qselect_chan(199)) then
        current_chan = 199
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qgDt1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u g to u ub u G     
      if (qactive_chan(200).and.qselect_chan(200)) then
        current_chan = 200
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qgDt1g0GSNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to g db d G    
      if (qactive_chan(201).and.qselect_chan(201)) then
        current_chan = 201
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbDt1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub u G    
      if (qactive_chan(202).and.qselect_chan(202)) then
        current_chan = 202
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbDt1g0GSNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d d to g d d G      
      if (qactive_chan(203).and.qselect_chan(203)) then
        current_chan = 203
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qqDt1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- u u to g u u G      
      if (qactive_chan(204).and.qselect_chan(204)) then
        current_chan = 204
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qqDt1g0GSNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- g d to d db d G     
      if (qactive_chan(205).and.qselect_chan(205)) then
        current_chan = 205
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = gqDt1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to u ub u G     
      if (qactive_chan(206).and.qselect_chan(206)) then
        current_chan = 206
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = gqDt1g0GSNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db d to g db d G    
      if (qactive_chan(207).and.qselect_chan(207)) then
        current_chan = 207
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqDt1g0GSNLO(2,3,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- ub u to g ub u G    
      if (qactive_chan(208).and.qselect_chan(208)) then
        current_chan = 208
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqDt1g0GSNLO(2,3,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g db to db db d G   
      if (qactive_chan(209).and.qselect_chan(209)) then
        current_chan = 209
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = gqbDt1g0GSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g ub to ub ub u G   
      if (qactive_chan(210).and.qselect_chan(210)) then
        current_chan = 210
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = gqbDt1g0GSNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db g to db db d G   
      if (qactive_chan(211).and.qselect_chan(211)) then
        current_chan = 211
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qbgDt1g0GSNLO(3,2,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- ub g to ub ub u G   
      if (qactive_chan(212).and.qselect_chan(212)) then
        current_chan = 212
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qbgDt1g0GSNLO(3,2,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db db to db g db G  
      if (qactive_chan(213).and.qselect_chan(213)) then
        current_chan = 213
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qbqbDt1g0GSNLO(3,4,1,5,2,6)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub g ub G  
      if (qactive_chan(214).and.qselect_chan(214)) then
        current_chan = 214
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qbqbDt1g0GSNLO(3,4,1,5,2,6)
        wtsum = wtsum + wt
      endif
      sigSNLOGJJ=sigSNLOGJJ+rnorm*wtsum

      return
      end
