      subroutine selectchannelGJJJ()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*alphas_scl)**3*(4d0*pi*amz)*nc**3*(nc**2-1)/(2d0*nc)*8d0
      n_alphas_proc = 3
      n_alpha_proc  = 1
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelGJJJ: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelGJJJ: already allocated'  
        stop
      end if

      ntot_chan = 154

      allocate(qactive_chan(1:154))
      allocate(contrib_chan(1:154))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! d g to g g d G        sB3g0G(1,2,3,4,5,6)   
c      qactive_chan(2)  = .true.   ! u g to g g u G        sB3g0G(1,2,3,4,5,6)   
c      qactive_chan(3)  = .true.   ! d db to g g g G       sB3g0G(1,3,4,5,2,6)   
c      qactive_chan(4)  = .true.   ! u ub to g g g G       sB3g0G(1,3,4,5,2,6)   
c      qactive_chan(5)  = .true.   ! g d to g g d G        sB3g0G(2,1,3,4,5,6)   
c      qactive_chan(6)  = .true.   ! g u to g g u G        sB3g0G(2,1,3,4,5,6)   
c      qactive_chan(7)  = .true.   ! db d to g g g G       sB3g0G(2,3,4,5,1,6)   
c      qactive_chan(8)  = .true.   ! ub u to g g g G       sB3g0G(2,3,4,5,1,6)   
c      qactive_chan(9)  = .true.   ! g g to db g d G       sB3g0G(3,1,2,4,5,6)   
c      qactive_chan(10) = .true.   ! g g to ub g u G       sB3g0G(3,1,2,4,5,6)   
c      qactive_chan(11) = .true.   ! g db to db g g G      sB3g0G(3,1,4,5,2,6)   
c      qactive_chan(12) = .true.   ! g ub to ub g g G      sB3g0G(3,1,4,5,2,6)   
c      qactive_chan(13) = .true.   ! db g to db g g G      sB3g0G(3,2,4,5,1,6)   
c      qactive_chan(14) = .true.   ! ub g to ub g g G      sB3g0G(3,2,4,5,1,6)   
c      qactive_chan(15) = .true.   ! d g to g g d G        sBt3g0G(1,2,3,4,5,6)  
c      qactive_chan(16) = .true.   ! u g to g g u G        sBt3g0G(1,2,3,4,5,6)  
c      qactive_chan(17) = .true.   ! d db to g g g G       sBt3g0G(1,3,4,5,2,6)  
c      qactive_chan(18) = .true.   ! u ub to g g g G       sBt3g0G(1,3,4,5,2,6)  
c      qactive_chan(19) = .true.   ! g d to g g d G        sBt3g0G(2,1,3,4,5,6)  
c      qactive_chan(20) = .true.   ! g u to g g u G        sBt3g0G(2,1,3,4,5,6)  
c      qactive_chan(21) = .true.   ! db d to g g g G       sBt3g0G(2,3,4,5,1,6)  
c      qactive_chan(22) = .true.   ! ub u to g g g G       sBt3g0G(2,3,4,5,1,6)  
c      qactive_chan(23) = .true.   ! g g to db g d G       sBt3g0G(3,1,2,4,5,6)  
c      qactive_chan(24) = .true.   ! g g to ub g u G       sBt3g0G(3,1,2,4,5,6)  
c      qactive_chan(25) = .true.   ! g db to db g g G      sBt3g0G(3,1,4,5,2,6)  
c      qactive_chan(26) = .true.   ! g ub to ub g g G      sBt3g0G(3,1,4,5,2,6)  
c      qactive_chan(27) = .true.   ! db g to db g g G      sBt3g0G(3,2,4,5,1,6)  
c      qactive_chan(28) = .true.   ! ub g to ub g g G      sBt3g0G(3,2,4,5,1,6)  
c      qactive_chan(29) = .true.   ! d gt to gt gt d G     sBtt3g0G(1,2,3,4,5,6)  
c      qactive_chan(30) = .true.   ! u gt to gt gt u G     sBtt3g0G(1,2,3,4,5,6)  
c      qactive_chan(31) = .true.   ! d db to gt gt gt G    sBtt3g0G(1,3,4,5,2,6)  
c      qactive_chan(32) = .true.   ! u ub to gt gt gt G    sBtt3g0G(1,3,4,5,2,6)  
c      qactive_chan(33) = .true.   ! gt d to gt gt d G     sBtt3g0G(2,1,3,4,5,6)  
c      qactive_chan(34) = .true.   ! gt u to gt gt u G     sBtt3g0G(2,1,3,4,5,6)  
c      qactive_chan(35) = .true.   ! db d to gt gt gt G    sBtt3g0G(2,3,4,5,1,6)  
c      qactive_chan(36) = .true.   ! ub u to gt gt gt G    sBtt3g0G(2,3,4,5,1,6)  
c      qactive_chan(37) = .true.   ! gt gt to db gt d G    sBtt3g0G(3,1,2,4,5,6)  
c      qactive_chan(38) = .true.   ! gt gt to ub gt u G    sBtt3g0G(3,1,2,4,5,6)  
c      qactive_chan(39) = .true.   ! gt db to db gt gt G   sBtt3g0G(3,1,4,5,2,6)  
c      qactive_chan(40) = .true.   ! gt ub to ub gt gt G   sBtt3g0G(3,1,4,5,2,6)  
c      qactive_chan(41) = .true.   ! db gt to db gt gt G   sBtt3g0G(3,2,4,5,1,6)  
c      qactive_chan(42) = .true.   ! ub gt to ub gt gt G   sBtt3g0G(3,2,4,5,1,6)  
c      qactive_chan(43) = .true.   ! d g to d db d G       sC1g0G(1,2,3,4,5,6)   
c      qactive_chan(44) = .true.   ! d g to u ub d G       sC1g0G(1,2,3,4,5,6)   
c      qactive_chan(45) = .true.   ! u g to d db u G       sC1g0G(1,2,3,4,5,6)   
c      qactive_chan(46) = .true.   ! u g to u ub u G       sC1g0G(1,2,3,4,5,6)   
c      qactive_chan(47) = .true.   ! d db to g db d G      sC1g0G(1,3,2,4,5,6)   
c      qactive_chan(48) = .true.   ! d ub to g ub d G      sC1g0G(1,3,2,4,5,6)   
c      qactive_chan(49) = .true.   ! u db to g db u G      sC1g0G(1,3,2,4,5,6)   
c      qactive_chan(50) = .true.   ! u ub to g ub u G      sC1g0G(1,3,2,4,5,6)   
c      qactive_chan(51) = .true.   ! d d to g d d G        sC1g0G(1,3,4,2,5,6)   
c      qactive_chan(52) = .true.   ! d u to g u d G        sC1g0G(1,3,4,2,5,6)   
c      qactive_chan(53) = .true.   ! u d to g d u G        sC1g0G(1,3,4,2,5,6)   
c      qactive_chan(54) = .true.   ! u u to g u u G        sC1g0G(1,3,4,2,5,6)   
c      qactive_chan(55) = .true.   ! d db to g d db G      sC1g0G(1,3,4,5,2,6)   
c      qactive_chan(56) = .true.   ! d db to g u ub G      sC1g0G(1,3,4,5,2,6)   
c      qactive_chan(57) = .true.   ! u ub to g d db G      sC1g0G(1,3,4,5,2,6)   
c      qactive_chan(58) = .true.   ! u ub to g u ub G      sC1g0G(1,3,4,5,2,6)   
c      qactive_chan(59) = .true.   ! g d to d db d G       sC1g0G(2,1,3,4,5,6)   
c      qactive_chan(60) = .true.   ! g d to u ub d G       sC1g0G(2,1,3,4,5,6)   
c      qactive_chan(61) = .true.   ! g u to d db u G       sC1g0G(2,1,3,4,5,6)   
c      qactive_chan(62) = .true.   ! g u to u ub u G       sC1g0G(2,1,3,4,5,6)   
c      qactive_chan(63) = .true.   ! db d to g d db G      sC1g0G(2,3,4,5,1,6)   
c      qactive_chan(64) = .true.   ! db d to g u ub G      sC1g0G(2,3,4,5,1,6)   
c      qactive_chan(65) = .true.   ! ub u to g d db G      sC1g0G(2,3,4,5,1,6)   
c      qactive_chan(66) = .true.   ! ub u to g u ub G      sC1g0G(2,3,4,5,1,6)   
c      qactive_chan(67) = .true.   ! g db to db d db G     sC1g0G(3,1,4,5,2,6)   
c      qactive_chan(68) = .true.   ! g db to db u ub G     sC1g0G(3,1,4,5,2,6)   
c      qactive_chan(69) = .true.   ! g ub to ub d db G     sC1g0G(3,1,4,5,2,6)   
c      qactive_chan(70) = .true.   ! g ub to ub u ub G     sC1g0G(3,1,4,5,2,6)   
c      qactive_chan(71) = .true.   ! db g to db d db G     sC1g0G(3,2,4,5,1,6)   
c      qactive_chan(72) = .true.   ! db g to db u ub G     sC1g0G(3,2,4,5,1,6)   
c      qactive_chan(73) = .true.   ! ub g to ub d db G     sC1g0G(3,2,4,5,1,6)   
c      qactive_chan(74) = .true.   ! ub g to ub u ub G     sC1g0G(3,2,4,5,1,6)   
c      qactive_chan(75) = .true.   ! db db to db g db G    sC1g0G(3,4,2,5,1,6)   
c      qactive_chan(76) = .true.   ! db ub to db g ub G    sC1g0G(3,4,2,5,1,6)   
c      qactive_chan(77) = .true.   ! ub db to ub g db G    sC1g0G(3,4,2,5,1,6)   
c      qactive_chan(78) = .true.   ! ub ub to ub g ub G    sC1g0G(3,4,2,5,1,6)   
c      qactive_chan(79) = .true.   ! db d to db g d G      sC1g0G(3,4,5,2,1,6)   
c      qactive_chan(80) = .true.   ! db u to db g u G      sC1g0G(3,4,5,2,1,6)   
c      qactive_chan(81) = .true.   ! ub d to ub g d G      sC1g0G(3,4,5,2,1,6)   
c      qactive_chan(82) = .true.   ! ub u to ub g u G      sC1g0G(3,4,5,2,1,6)   
c      qactive_chan(83) = .true.   ! d g to d db d G       sCt1g0G(1,2,3,4,5,6)  
c      qactive_chan(84) = .true.   ! d g to u ub d G       sCt1g0G(1,2,3,4,5,6)  
c      qactive_chan(85) = .true.   ! u g to d db u G       sCt1g0G(1,2,3,4,5,6)  
c      qactive_chan(86) = .true.   ! u g to u ub u G       sCt1g0G(1,2,3,4,5,6)  
c      qactive_chan(87) = .true.   ! d db to g db d G      sCt1g0G(1,3,2,4,5,6)  
c      qactive_chan(88) = .true.   ! d ub to g ub d G      sCt1g0G(1,3,2,4,5,6)  
c      qactive_chan(89) = .true.   ! u db to g db u G      sCt1g0G(1,3,2,4,5,6)  
c      qactive_chan(90) = .true.   ! u ub to g ub u G      sCt1g0G(1,3,2,4,5,6)  
c      qactive_chan(91) = .true.   ! d d to g d d G        sCt1g0G(1,3,4,2,5,6)  
c      qactive_chan(92) = .true.   ! d u to g u d G        sCt1g0G(1,3,4,2,5,6)  
c      qactive_chan(93) = .true.   ! u d to g d u G        sCt1g0G(1,3,4,2,5,6)  
c      qactive_chan(94) = .true.   ! u u to g u u G        sCt1g0G(1,3,4,2,5,6)  
c      qactive_chan(95) = .true.   ! d db to g d db G      sCt1g0G(1,3,4,5,2,6)  
c      qactive_chan(96) = .true.   ! d db to g u ub G      sCt1g0G(1,3,4,5,2,6)  
c      qactive_chan(97) = .true.   ! u ub to g d db G      sCt1g0G(1,3,4,5,2,6)  
c      qactive_chan(98) = .true.   ! u ub to g u ub G      sCt1g0G(1,3,4,5,2,6)  
c      qactive_chan(99) = .true.   ! g d to d db d G       sCt1g0G(2,1,3,4,5,6)  
c      qactive_chan(100)= .true.   ! g d to u ub d G       sCt1g0G(2,1,3,4,5,6)  
c      qactive_chan(101)= .true.   ! g u to d db u G       sCt1g0G(2,1,3,4,5,6)  
c      qactive_chan(102)= .true.   ! g u to u ub u G       sCt1g0G(2,1,3,4,5,6)  
c      qactive_chan(103)= .true.   ! db d to g d db G      sCt1g0G(2,3,4,5,1,6)  
c      qactive_chan(104)= .true.   ! db d to g u ub G      sCt1g0G(2,3,4,5,1,6)  
c      qactive_chan(105)= .true.   ! ub u to g d db G      sCt1g0G(2,3,4,5,1,6)  
c      qactive_chan(106)= .true.   ! ub u to g u ub G      sCt1g0G(2,3,4,5,1,6)  
c      qactive_chan(107)= .true.   ! g db to db d db G     sCt1g0G(3,1,4,5,2,6)  
c      qactive_chan(108)= .true.   ! g db to db u ub G     sCt1g0G(3,1,4,5,2,6)  
c      qactive_chan(109)= .true.   ! g ub to ub d db G     sCt1g0G(3,1,4,5,2,6)  
c      qactive_chan(110)= .true.   ! g ub to ub u ub G     sCt1g0G(3,1,4,5,2,6)  
c      qactive_chan(111)= .true.   ! db g to db d db G     sCt1g0G(3,2,4,5,1,6)  
c      qactive_chan(112)= .true.   ! db g to db u ub G     sCt1g0G(3,2,4,5,1,6)  
c      qactive_chan(113)= .true.   ! ub g to ub d db G     sCt1g0G(3,2,4,5,1,6)  
c      qactive_chan(114)= .true.   ! ub g to ub u ub G     sCt1g0G(3,2,4,5,1,6)  
c      qactive_chan(115)= .true.   ! db db to db g db G    sCt1g0G(3,4,2,5,1,6)  
c      qactive_chan(116)= .true.   ! db ub to db g ub G    sCt1g0G(3,4,2,5,1,6)  
c      qactive_chan(117)= .true.   ! ub db to ub g db G    sCt1g0G(3,4,2,5,1,6)  
c      qactive_chan(118)= .true.   ! ub ub to ub g ub G    sCt1g0G(3,4,2,5,1,6)  
c      qactive_chan(119)= .true.   ! db d to db g d G      sCt1g0G(3,4,5,2,1,6)  
c      qactive_chan(120)= .true.   ! db u to db g u G      sCt1g0G(3,4,5,2,1,6)  
c      qactive_chan(121)= .true.   ! ub d to ub g d G      sCt1g0G(3,4,5,2,1,6)  
c      qactive_chan(122)= .true.   ! ub u to ub g u G      sCt1g0G(3,4,5,2,1,6)  
c      qactive_chan(123)= .true.   ! d g to d db d G       D1g0Gc(1,2,3,4,5,6)   
c      qactive_chan(124)= .true.   ! u g to u ub u G       D1g0Gc(1,2,3,4,5,6)   
c      qactive_chan(125)= .true.   ! d db to g db d G      D1g0Gc(1,3,2,4,5,6)   
c      qactive_chan(126)= .true.   ! u ub to g ub u G      D1g0Gc(1,3,2,4,5,6)   
c      qactive_chan(127)= .true.   ! d d to g d d G        D1g0Gc(1,3,4,2,5,6)   
c      qactive_chan(128)= .true.   ! u u to g u u G        D1g0Gc(1,3,4,2,5,6)   
c      qactive_chan(129)= .true.   ! g d to d db d G       D1g0Gc(2,1,3,4,5,6)   
c      qactive_chan(130)= .true.   ! g u to u ub u G       D1g0Gc(2,1,3,4,5,6)   
c      qactive_chan(131)= .true.   ! db d to g db d G      D1g0Gc(2,3,1,4,5,6)   
c      qactive_chan(132)= .true.   ! ub u to g ub u G      D1g0Gc(2,3,1,4,5,6)   
c      qactive_chan(133)= .true.   ! g db to db db d G     D1g0Gc(3,1,2,4,5,6)   
c      qactive_chan(134)= .true.   ! g ub to ub ub u G     D1g0Gc(3,1,2,4,5,6)   
c      qactive_chan(135)= .true.   ! db g to db db d G     D1g0Gc(3,2,1,4,5,6)   
c      qactive_chan(136)= .true.   ! ub g to ub ub u G     D1g0Gc(3,2,1,4,5,6)   
c      qactive_chan(137)= .true.   ! db db to db g db G    D1g0Gc(3,4,1,5,2,6)   
c      qactive_chan(138)= .true.   ! ub ub to ub g ub G    D1g0Gc(3,4,1,5,2,6)   
c      qactive_chan(139)= .true.   ! d g to d db d G       Dt1g0G(1,2,3,4,5,6)   
c      qactive_chan(140)= .true.   ! u g to u ub u G       Dt1g0G(1,2,3,4,5,6)   
c      qactive_chan(141)= .true.   ! d db to g db d G      Dt1g0G(1,3,2,4,5,6)   
c      qactive_chan(142)= .true.   ! u ub to g ub u G      Dt1g0G(1,3,2,4,5,6)   
c      qactive_chan(143)= .true.   ! d d to g d d G        Dt1g0G(1,3,4,2,5,6)   
c      qactive_chan(144)= .true.   ! u u to g u u G        Dt1g0G(1,3,4,2,5,6)   
c      qactive_chan(145)= .true.   ! g d to d db d G       Dt1g0G(2,1,3,4,5,6)   
c      qactive_chan(146)= .true.   ! g u to u ub u G       Dt1g0G(2,1,3,4,5,6)   
c      qactive_chan(147)= .true.   ! db d to g db d G      Dt1g0G(2,3,1,4,5,6)   
c      qactive_chan(148)= .true.   ! ub u to g ub u G      Dt1g0G(2,3,1,4,5,6)   
c      qactive_chan(149)= .true.   ! g db to db db d G     Dt1g0G(3,1,2,4,5,6)   
c      qactive_chan(150)= .true.   ! g ub to ub ub u G     Dt1g0G(3,1,2,4,5,6)   
c      qactive_chan(151)= .true.   ! db g to db db d G     Dt1g0G(3,2,1,4,5,6)   
c      qactive_chan(152)= .true.   ! ub g to ub ub u G     Dt1g0G(3,2,1,4,5,6)   
c      qactive_chan(153)= .true.   ! db db to db g db G    Dt1g0G(3,4,1,5,2,6)   
c      qactive_chan(154)= .true.   ! ub ub to ub g ub G    Dt1g0G(3,4,1,5,2,6)   

      do i=1,154
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c -- virtual                                      ME                   TNLO  

c -- double real                                  ME                   S  

c -- real virtual                                 ME                   T  

c -- double virtual                               ME                   U  

      return
      end


c---- get channel strings
      subroutine getchannelGJJJ(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'd g to g g d G      '
        me_str   = 'sB3g0G(1,2,3,4,5,6) '
        sub_str  = ''

      case (2)
        chan_str = 'u g to g g u G      '
        me_str   = 'sB3g0G(1,2,3,4,5,6) '
        sub_str  = ''

      case (3)
        chan_str = 'd db to g g g G     '
        me_str   = 'sB3g0G(1,3,4,5,2,6) '
        sub_str  = ''

      case (4)
        chan_str = 'u ub to g g g G     '
        me_str   = 'sB3g0G(1,3,4,5,2,6) '
        sub_str  = ''

      case (5)
        chan_str = 'g d to g g d G      '
        me_str   = 'sB3g0G(2,1,3,4,5,6) '
        sub_str  = ''

      case (6)
        chan_str = 'g u to g g u G      '
        me_str   = 'sB3g0G(2,1,3,4,5,6) '
        sub_str  = ''

      case (7)
        chan_str = 'db d to g g g G     '
        me_str   = 'sB3g0G(2,3,4,5,1,6) '
        sub_str  = ''

      case (8)
        chan_str = 'ub u to g g g G     '
        me_str   = 'sB3g0G(2,3,4,5,1,6) '
        sub_str  = ''

      case (9)
        chan_str = 'g g to db g d G     '
        me_str   = 'sB3g0G(3,1,2,4,5,6) '
        sub_str  = ''

      case (10)
        chan_str = 'g g to ub g u G     '
        me_str   = 'sB3g0G(3,1,2,4,5,6) '
        sub_str  = ''

      case (11)
        chan_str = 'g db to db g g G    '
        me_str   = 'sB3g0G(3,1,4,5,2,6) '
        sub_str  = ''

      case (12)
        chan_str = 'g ub to ub g g G    '
        me_str   = 'sB3g0G(3,1,4,5,2,6) '
        sub_str  = ''

      case (13)
        chan_str = 'db g to db g g G    '
        me_str   = 'sB3g0G(3,2,4,5,1,6) '
        sub_str  = ''

      case (14)
        chan_str = 'ub g to ub g g G    '
        me_str   = 'sB3g0G(3,2,4,5,1,6) '
        sub_str  = ''

      case (15)
        chan_str = 'd g to g g d G      '
        me_str   = 'sBt3g0G(1,2,3,4,5,6)'
        sub_str  = ''

      case (16)
        chan_str = 'u g to g g u G      '
        me_str   = 'sBt3g0G(1,2,3,4,5,6)'
        sub_str  = ''

      case (17)
        chan_str = 'd db to g g g G     '
        me_str   = 'sBt3g0G(1,3,4,5,2,6)'
        sub_str  = ''

      case (18)
        chan_str = 'u ub to g g g G     '
        me_str   = 'sBt3g0G(1,3,4,5,2,6)'
        sub_str  = ''

      case (19)
        chan_str = 'g d to g g d G      '
        me_str   = 'sBt3g0G(2,1,3,4,5,6)'
        sub_str  = ''

      case (20)
        chan_str = 'g u to g g u G      '
        me_str   = 'sBt3g0G(2,1,3,4,5,6)'
        sub_str  = ''

      case (21)
        chan_str = 'db d to g g g G     '
        me_str   = 'sBt3g0G(2,3,4,5,1,6)'
        sub_str  = ''

      case (22)
        chan_str = 'ub u to g g g G     '
        me_str   = 'sBt3g0G(2,3,4,5,1,6)'
        sub_str  = ''

      case (23)
        chan_str = 'g g to db g d G     '
        me_str   = 'sBt3g0G(3,1,2,4,5,6)'
        sub_str  = ''

      case (24)
        chan_str = 'g g to ub g u G     '
        me_str   = 'sBt3g0G(3,1,2,4,5,6)'
        sub_str  = ''

      case (25)
        chan_str = 'g db to db g g G    '
        me_str   = 'sBt3g0G(3,1,4,5,2,6)'
        sub_str  = ''

      case (26)
        chan_str = 'g ub to ub g g G    '
        me_str   = 'sBt3g0G(3,1,4,5,2,6)'
        sub_str  = ''

      case (27)
        chan_str = 'db g to db g g G    '
        me_str   = 'sBt3g0G(3,2,4,5,1,6)'
        sub_str  = ''

      case (28)
        chan_str = 'ub g to ub g g G    '
        me_str   = 'sBt3g0G(3,2,4,5,1,6)'
        sub_str  = ''

      case (29)
        chan_str = 'd gt to gt gt d G   '
        me_str   = 'sBtt3g0G(1,2,3,4,5,6)'
        sub_str  = ''

      case (30)
        chan_str = 'u gt to gt gt u G   '
        me_str   = 'sBtt3g0G(1,2,3,4,5,6)'
        sub_str  = ''

      case (31)
        chan_str = 'd db to gt gt gt G  '
        me_str   = 'sBtt3g0G(1,3,4,5,2,6)'
        sub_str  = ''

      case (32)
        chan_str = 'u ub to gt gt gt G  '
        me_str   = 'sBtt3g0G(1,3,4,5,2,6)'
        sub_str  = ''

      case (33)
        chan_str = 'gt d to gt gt d G   '
        me_str   = 'sBtt3g0G(2,1,3,4,5,6)'
        sub_str  = ''

      case (34)
        chan_str = 'gt u to gt gt u G   '
        me_str   = 'sBtt3g0G(2,1,3,4,5,6)'
        sub_str  = ''

      case (35)
        chan_str = 'db d to gt gt gt G  '
        me_str   = 'sBtt3g0G(2,3,4,5,1,6)'
        sub_str  = ''

      case (36)
        chan_str = 'ub u to gt gt gt G  '
        me_str   = 'sBtt3g0G(2,3,4,5,1,6)'
        sub_str  = ''

      case (37)
        chan_str = 'gt gt to db gt d G  '
        me_str   = 'sBtt3g0G(3,1,2,4,5,6)'
        sub_str  = ''

      case (38)
        chan_str = 'gt gt to ub gt u G  '
        me_str   = 'sBtt3g0G(3,1,2,4,5,6)'
        sub_str  = ''

      case (39)
        chan_str = 'gt db to db gt gt G '
        me_str   = 'sBtt3g0G(3,1,4,5,2,6)'
        sub_str  = ''

      case (40)
        chan_str = 'gt ub to ub gt gt G '
        me_str   = 'sBtt3g0G(3,1,4,5,2,6)'
        sub_str  = ''

      case (41)
        chan_str = 'db gt to db gt gt G '
        me_str   = 'sBtt3g0G(3,2,4,5,1,6)'
        sub_str  = ''

      case (42)
        chan_str = 'ub gt to ub gt gt G '
        me_str   = 'sBtt3g0G(3,2,4,5,1,6)'
        sub_str  = ''

      case (43)
        chan_str = 'd g to d db d G     '
        me_str   = 'sC1g0G(1,2,3,4,5,6) '
        sub_str  = ''

      case (44)
        chan_str = 'd g to u ub d G     '
        me_str   = 'sC1g0G(1,2,3,4,5,6) '
        sub_str  = ''

      case (45)
        chan_str = 'u g to d db u G     '
        me_str   = 'sC1g0G(1,2,3,4,5,6) '
        sub_str  = ''

      case (46)
        chan_str = 'u g to u ub u G     '
        me_str   = 'sC1g0G(1,2,3,4,5,6) '
        sub_str  = ''

      case (47)
        chan_str = 'd db to g db d G    '
        me_str   = 'sC1g0G(1,3,2,4,5,6) '
        sub_str  = ''

      case (48)
        chan_str = 'd ub to g ub d G    '
        me_str   = 'sC1g0G(1,3,2,4,5,6) '
        sub_str  = ''

      case (49)
        chan_str = 'u db to g db u G    '
        me_str   = 'sC1g0G(1,3,2,4,5,6) '
        sub_str  = ''

      case (50)
        chan_str = 'u ub to g ub u G    '
        me_str   = 'sC1g0G(1,3,2,4,5,6) '
        sub_str  = ''

      case (51)
        chan_str = 'd d to g d d G      '
        me_str   = 'sC1g0G(1,3,4,2,5,6) '
        sub_str  = ''

      case (52)
        chan_str = 'd u to g u d G      '
        me_str   = 'sC1g0G(1,3,4,2,5,6) '
        sub_str  = ''

      case (53)
        chan_str = 'u d to g d u G      '
        me_str   = 'sC1g0G(1,3,4,2,5,6) '
        sub_str  = ''

      case (54)
        chan_str = 'u u to g u u G      '
        me_str   = 'sC1g0G(1,3,4,2,5,6) '
        sub_str  = ''

      case (55)
        chan_str = 'd db to g d db G    '
        me_str   = 'sC1g0G(1,3,4,5,2,6) '
        sub_str  = ''

      case (56)
        chan_str = 'd db to g u ub G    '
        me_str   = 'sC1g0G(1,3,4,5,2,6) '
        sub_str  = ''

      case (57)
        chan_str = 'u ub to g d db G    '
        me_str   = 'sC1g0G(1,3,4,5,2,6) '
        sub_str  = ''

      case (58)
        chan_str = 'u ub to g u ub G    '
        me_str   = 'sC1g0G(1,3,4,5,2,6) '
        sub_str  = ''

      case (59)
        chan_str = 'g d to d db d G     '
        me_str   = 'sC1g0G(2,1,3,4,5,6) '
        sub_str  = ''

      case (60)
        chan_str = 'g d to u ub d G     '
        me_str   = 'sC1g0G(2,1,3,4,5,6) '
        sub_str  = ''

      case (61)
        chan_str = 'g u to d db u G     '
        me_str   = 'sC1g0G(2,1,3,4,5,6) '
        sub_str  = ''

      case (62)
        chan_str = 'g u to u ub u G     '
        me_str   = 'sC1g0G(2,1,3,4,5,6) '
        sub_str  = ''

      case (63)
        chan_str = 'db d to g d db G    '
        me_str   = 'sC1g0G(2,3,4,5,1,6) '
        sub_str  = ''

      case (64)
        chan_str = 'db d to g u ub G    '
        me_str   = 'sC1g0G(2,3,4,5,1,6) '
        sub_str  = ''

      case (65)
        chan_str = 'ub u to g d db G    '
        me_str   = 'sC1g0G(2,3,4,5,1,6) '
        sub_str  = ''

      case (66)
        chan_str = 'ub u to g u ub G    '
        me_str   = 'sC1g0G(2,3,4,5,1,6) '
        sub_str  = ''

      case (67)
        chan_str = 'g db to db d db G   '
        me_str   = 'sC1g0G(3,1,4,5,2,6) '
        sub_str  = ''

      case (68)
        chan_str = 'g db to db u ub G   '
        me_str   = 'sC1g0G(3,1,4,5,2,6) '
        sub_str  = ''

      case (69)
        chan_str = 'g ub to ub d db G   '
        me_str   = 'sC1g0G(3,1,4,5,2,6) '
        sub_str  = ''

      case (70)
        chan_str = 'g ub to ub u ub G   '
        me_str   = 'sC1g0G(3,1,4,5,2,6) '
        sub_str  = ''

      case (71)
        chan_str = 'db g to db d db G   '
        me_str   = 'sC1g0G(3,2,4,5,1,6) '
        sub_str  = ''

      case (72)
        chan_str = 'db g to db u ub G   '
        me_str   = 'sC1g0G(3,2,4,5,1,6) '
        sub_str  = ''

      case (73)
        chan_str = 'ub g to ub d db G   '
        me_str   = 'sC1g0G(3,2,4,5,1,6) '
        sub_str  = ''

      case (74)
        chan_str = 'ub g to ub u ub G   '
        me_str   = 'sC1g0G(3,2,4,5,1,6) '
        sub_str  = ''

      case (75)
        chan_str = 'db db to db g db G  '
        me_str   = 'sC1g0G(3,4,2,5,1,6) '
        sub_str  = ''

      case (76)
        chan_str = 'db ub to db g ub G  '
        me_str   = 'sC1g0G(3,4,2,5,1,6) '
        sub_str  = ''

      case (77)
        chan_str = 'ub db to ub g db G  '
        me_str   = 'sC1g0G(3,4,2,5,1,6) '
        sub_str  = ''

      case (78)
        chan_str = 'ub ub to ub g ub G  '
        me_str   = 'sC1g0G(3,4,2,5,1,6) '
        sub_str  = ''

      case (79)
        chan_str = 'db d to db g d G    '
        me_str   = 'sC1g0G(3,4,5,2,1,6) '
        sub_str  = ''

      case (80)
        chan_str = 'db u to db g u G    '
        me_str   = 'sC1g0G(3,4,5,2,1,6) '
        sub_str  = ''

      case (81)
        chan_str = 'ub d to ub g d G    '
        me_str   = 'sC1g0G(3,4,5,2,1,6) '
        sub_str  = ''

      case (82)
        chan_str = 'ub u to ub g u G    '
        me_str   = 'sC1g0G(3,4,5,2,1,6) '
        sub_str  = ''

      case (83)
        chan_str = 'd g to d db d G     '
        me_str   = 'sCt1g0G(1,2,3,4,5,6)'
        sub_str  = ''

      case (84)
        chan_str = 'd g to u ub d G     '
        me_str   = 'sCt1g0G(1,2,3,4,5,6)'
        sub_str  = ''

      case (85)
        chan_str = 'u g to d db u G     '
        me_str   = 'sCt1g0G(1,2,3,4,5,6)'
        sub_str  = ''

      case (86)
        chan_str = 'u g to u ub u G     '
        me_str   = 'sCt1g0G(1,2,3,4,5,6)'
        sub_str  = ''

      case (87)
        chan_str = 'd db to g db d G    '
        me_str   = 'sCt1g0G(1,3,2,4,5,6)'
        sub_str  = ''

      case (88)
        chan_str = 'd ub to g ub d G    '
        me_str   = 'sCt1g0G(1,3,2,4,5,6)'
        sub_str  = ''

      case (89)
        chan_str = 'u db to g db u G    '
        me_str   = 'sCt1g0G(1,3,2,4,5,6)'
        sub_str  = ''

      case (90)
        chan_str = 'u ub to g ub u G    '
        me_str   = 'sCt1g0G(1,3,2,4,5,6)'
        sub_str  = ''

      case (91)
        chan_str = 'd d to g d d G      '
        me_str   = 'sCt1g0G(1,3,4,2,5,6)'
        sub_str  = ''

      case (92)
        chan_str = 'd u to g u d G      '
        me_str   = 'sCt1g0G(1,3,4,2,5,6)'
        sub_str  = ''

      case (93)
        chan_str = 'u d to g d u G      '
        me_str   = 'sCt1g0G(1,3,4,2,5,6)'
        sub_str  = ''

      case (94)
        chan_str = 'u u to g u u G      '
        me_str   = 'sCt1g0G(1,3,4,2,5,6)'
        sub_str  = ''

      case (95)
        chan_str = 'd db to g d db G    '
        me_str   = 'sCt1g0G(1,3,4,5,2,6)'
        sub_str  = ''

      case (96)
        chan_str = 'd db to g u ub G    '
        me_str   = 'sCt1g0G(1,3,4,5,2,6)'
        sub_str  = ''

      case (97)
        chan_str = 'u ub to g d db G    '
        me_str   = 'sCt1g0G(1,3,4,5,2,6)'
        sub_str  = ''

      case (98)
        chan_str = 'u ub to g u ub G    '
        me_str   = 'sCt1g0G(1,3,4,5,2,6)'
        sub_str  = ''

      case (99)
        chan_str = 'g d to d db d G     '
        me_str   = 'sCt1g0G(2,1,3,4,5,6)'
        sub_str  = ''

      case (100)
        chan_str = 'g d to u ub d G     '
        me_str   = 'sCt1g0G(2,1,3,4,5,6)'
        sub_str  = ''

      case (101)
        chan_str = 'g u to d db u G     '
        me_str   = 'sCt1g0G(2,1,3,4,5,6)'
        sub_str  = ''

      case (102)
        chan_str = 'g u to u ub u G     '
        me_str   = 'sCt1g0G(2,1,3,4,5,6)'
        sub_str  = ''

      case (103)
        chan_str = 'db d to g d db G    '
        me_str   = 'sCt1g0G(2,3,4,5,1,6)'
        sub_str  = ''

      case (104)
        chan_str = 'db d to g u ub G    '
        me_str   = 'sCt1g0G(2,3,4,5,1,6)'
        sub_str  = ''

      case (105)
        chan_str = 'ub u to g d db G    '
        me_str   = 'sCt1g0G(2,3,4,5,1,6)'
        sub_str  = ''

      case (106)
        chan_str = 'ub u to g u ub G    '
        me_str   = 'sCt1g0G(2,3,4,5,1,6)'
        sub_str  = ''

      case (107)
        chan_str = 'g db to db d db G   '
        me_str   = 'sCt1g0G(3,1,4,5,2,6)'
        sub_str  = ''

      case (108)
        chan_str = 'g db to db u ub G   '
        me_str   = 'sCt1g0G(3,1,4,5,2,6)'
        sub_str  = ''

      case (109)
        chan_str = 'g ub to ub d db G   '
        me_str   = 'sCt1g0G(3,1,4,5,2,6)'
        sub_str  = ''

      case (110)
        chan_str = 'g ub to ub u ub G   '
        me_str   = 'sCt1g0G(3,1,4,5,2,6)'
        sub_str  = ''

      case (111)
        chan_str = 'db g to db d db G   '
        me_str   = 'sCt1g0G(3,2,4,5,1,6)'
        sub_str  = ''

      case (112)
        chan_str = 'db g to db u ub G   '
        me_str   = 'sCt1g0G(3,2,4,5,1,6)'
        sub_str  = ''

      case (113)
        chan_str = 'ub g to ub d db G   '
        me_str   = 'sCt1g0G(3,2,4,5,1,6)'
        sub_str  = ''

      case (114)
        chan_str = 'ub g to ub u ub G   '
        me_str   = 'sCt1g0G(3,2,4,5,1,6)'
        sub_str  = ''

      case (115)
        chan_str = 'db db to db g db G  '
        me_str   = 'sCt1g0G(3,4,2,5,1,6)'
        sub_str  = ''

      case (116)
        chan_str = 'db ub to db g ub G  '
        me_str   = 'sCt1g0G(3,4,2,5,1,6)'
        sub_str  = ''

      case (117)
        chan_str = 'ub db to ub g db G  '
        me_str   = 'sCt1g0G(3,4,2,5,1,6)'
        sub_str  = ''

      case (118)
        chan_str = 'ub ub to ub g ub G  '
        me_str   = 'sCt1g0G(3,4,2,5,1,6)'
        sub_str  = ''

      case (119)
        chan_str = 'db d to db g d G    '
        me_str   = 'sCt1g0G(3,4,5,2,1,6)'
        sub_str  = ''

      case (120)
        chan_str = 'db u to db g u G    '
        me_str   = 'sCt1g0G(3,4,5,2,1,6)'
        sub_str  = ''

      case (121)
        chan_str = 'ub d to ub g d G    '
        me_str   = 'sCt1g0G(3,4,5,2,1,6)'
        sub_str  = ''

      case (122)
        chan_str = 'ub u to ub g u G    '
        me_str   = 'sCt1g0G(3,4,5,2,1,6)'
        sub_str  = ''

      case (123)
        chan_str = 'd g to d db d G     '
        me_str   = 'D1g0Gc(1,2,3,4,5,6) '
        sub_str  = ''

      case (124)
        chan_str = 'u g to u ub u G     '
        me_str   = 'D1g0Gc(1,2,3,4,5,6) '
        sub_str  = ''

      case (125)
        chan_str = 'd db to g db d G    '
        me_str   = 'D1g0Gc(1,3,2,4,5,6) '
        sub_str  = ''

      case (126)
        chan_str = 'u ub to g ub u G    '
        me_str   = 'D1g0Gc(1,3,2,4,5,6) '
        sub_str  = ''

      case (127)
        chan_str = 'd d to g d d G      '
        me_str   = 'D1g0Gc(1,3,4,2,5,6) '
        sub_str  = ''

      case (128)
        chan_str = 'u u to g u u G      '
        me_str   = 'D1g0Gc(1,3,4,2,5,6) '
        sub_str  = ''

      case (129)
        chan_str = 'g d to d db d G     '
        me_str   = 'D1g0Gc(2,1,3,4,5,6) '
        sub_str  = ''

      case (130)
        chan_str = 'g u to u ub u G     '
        me_str   = 'D1g0Gc(2,1,3,4,5,6) '
        sub_str  = ''

      case (131)
        chan_str = 'db d to g db d G    '
        me_str   = 'D1g0Gc(2,3,1,4,5,6) '
        sub_str  = ''

      case (132)
        chan_str = 'ub u to g ub u G    '
        me_str   = 'D1g0Gc(2,3,1,4,5,6) '
        sub_str  = ''

      case (133)
        chan_str = 'g db to db db d G   '
        me_str   = 'D1g0Gc(3,1,2,4,5,6) '
        sub_str  = ''

      case (134)
        chan_str = 'g ub to ub ub u G   '
        me_str   = 'D1g0Gc(3,1,2,4,5,6) '
        sub_str  = ''

      case (135)
        chan_str = 'db g to db db d G   '
        me_str   = 'D1g0Gc(3,2,1,4,5,6) '
        sub_str  = ''

      case (136)
        chan_str = 'ub g to ub ub u G   '
        me_str   = 'D1g0Gc(3,2,1,4,5,6) '
        sub_str  = ''

      case (137)
        chan_str = 'db db to db g db G  '
        me_str   = 'D1g0Gc(3,4,1,5,2,6) '
        sub_str  = ''

      case (138)
        chan_str = 'ub ub to ub g ub G  '
        me_str   = 'D1g0Gc(3,4,1,5,2,6) '
        sub_str  = ''

      case (139)
        chan_str = 'd g to d db d G     '
        me_str   = 'Dt1g0G(1,2,3,4,5,6) '
        sub_str  = ''

      case (140)
        chan_str = 'u g to u ub u G     '
        me_str   = 'Dt1g0G(1,2,3,4,5,6) '
        sub_str  = ''

      case (141)
        chan_str = 'd db to g db d G    '
        me_str   = 'Dt1g0G(1,3,2,4,5,6) '
        sub_str  = ''

      case (142)
        chan_str = 'u ub to g ub u G    '
        me_str   = 'Dt1g0G(1,3,2,4,5,6) '
        sub_str  = ''

      case (143)
        chan_str = 'd d to g d d G      '
        me_str   = 'Dt1g0G(1,3,4,2,5,6) '
        sub_str  = ''

      case (144)
        chan_str = 'u u to g u u G      '
        me_str   = 'Dt1g0G(1,3,4,2,5,6) '
        sub_str  = ''

      case (145)
        chan_str = 'g d to d db d G     '
        me_str   = 'Dt1g0G(2,1,3,4,5,6) '
        sub_str  = ''

      case (146)
        chan_str = 'g u to u ub u G     '
        me_str   = 'Dt1g0G(2,1,3,4,5,6) '
        sub_str  = ''

      case (147)
        chan_str = 'db d to g db d G    '
        me_str   = 'Dt1g0G(2,3,1,4,5,6) '
        sub_str  = ''

      case (148)
        chan_str = 'ub u to g ub u G    '
        me_str   = 'Dt1g0G(2,3,1,4,5,6) '
        sub_str  = ''

      case (149)
        chan_str = 'g db to db db d G   '
        me_str   = 'Dt1g0G(3,1,2,4,5,6) '
        sub_str  = ''

      case (150)
        chan_str = 'g ub to ub ub u G   '
        me_str   = 'Dt1g0G(3,1,2,4,5,6) '
        sub_str  = ''

      case (151)
        chan_str = 'db g to db db d G   '
        me_str   = 'Dt1g0G(3,2,1,4,5,6) '
        sub_str  = ''

      case (152)
        chan_str = 'ub g to ub ub u G   '
        me_str   = 'Dt1g0G(3,2,1,4,5,6) '
        sub_str  = ''

      case (153)
        chan_str = 'db db to db g db G  '
        me_str   = 'Dt1g0G(3,4,1,5,2,6) '
        sub_str  = ''

      case (154)
        chan_str = 'ub ub to ub g ub G  '
        me_str   = 'Dt1g0G(3,4,1,5,2,6) '
        sub_str  = ''

      case default
        print*, 'getchannelGJJJ: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtGJJJ(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtGJJJ = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (1)
        ! [g, g, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (2)
        ! [g, g, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (3)
        ! [g, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (4)
        ! [g, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (5)
        ! [g, g, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (6)
        ! [g, g, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (7)
        ! [g, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (8)
        ! [g, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (11)
        ! [db, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (12)
        ! [ub, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (13)
        ! [db, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (14)
        ! [ub, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (15)
        ! [g, g, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (16)
        ! [g, g, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (17)
        ! [g, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (18)
        ! [g, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (19)
        ! [g, g, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (20)
        ! [g, g, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (21)
        ! [g, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (22)
        ! [g, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (25)
        ! [db, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (26)
        ! [ub, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (27)
        ! [db, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (28)
        ! [ub, g, g, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (29)
        ! [gt, gt, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (30)
        ! [gt, gt, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (31)
        ! [gt, gt, gt, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (32)
        ! [gt, gt, gt, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (33)
        ! [gt, gt, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (34)
        ! [gt, gt, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (35)
        ! [gt, gt, gt, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (36)
        ! [gt, gt, gt, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4,5 /))

      case (39)
        ! [db, gt, gt, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (40)
        ! [ub, gt, gt, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (41)
        ! [db, gt, gt, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (42)
        ! [ub, gt, gt, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (43)
        ! [d, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (46)
        ! [u, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (51)
        ! [g, d, d, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (54)
        ! [g, u, u, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (59)
        ! [d, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (62)
        ! [u, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (67)
        ! [db, d, db, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (70)
        ! [ub, u, ub, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (71)
        ! [db, d, db, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (74)
        ! [ub, u, ub, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (75)
        ! [db, g, db, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (78)
        ! [ub, g, ub, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (83)
        ! [d, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (86)
        ! [u, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (91)
        ! [g, d, d, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (94)
        ! [g, u, u, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (99)
        ! [d, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (102)
        ! [u, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (107)
        ! [db, d, db, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (110)
        ! [ub, u, ub, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (111)
        ! [db, d, db, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (114)
        ! [ub, u, ub, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (115)
        ! [db, g, db, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (118)
        ! [ub, g, ub, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (123)
        ! [d, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (124)
        ! [u, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (127)
        ! [g, d, d, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (128)
        ! [g, u, u, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (129)
        ! [d, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (130)
        ! [u, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (133)
        ! [db, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (134)
        ! [ub, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (135)
        ! [db, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (136)
        ! [ub, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (137)
        ! [db, g, db, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (138)
        ! [ub, g, ub, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (139)
        ! [d, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (140)
        ! [u, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (143)
        ! [g, d, d, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (144)
        ! [g, u, u, G]
        LIPSwgtGJJJ = weight_lips((/ 4,5 /))

      case (145)
        ! [d, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (146)
        ! [u, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (149)
        ! [db, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (150)
        ! [ub, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (151)
        ! [db, db, d, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (152)
        ! [ub, ub, u, G]
        LIPSwgtGJJJ = weight_lips((/ 3,4 /))

      case (153)
        ! [db, g, db, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case (154)
        ! [ub, g, ub, G]
        LIPSwgtGJJJ = weight_lips((/ 3,5 /))

      case default
        LIPSwgtGJJJ = 1

      end select
      end
