      function sigSNLOH2(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLOH2=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- g g to g ph1 ph2    
      if (qactive_chan(2).and.qselect_chan(2)) then
        current_chan = 2
        ip1_chan     = 0
        ip2_chan     = 0
        wt = ggA3g0H2SNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- q g to q ph1 ph2    
      if (qactive_chan(3).and.qselect_chan(3)) then
        current_chan = 3
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgB1g0H2SNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- q qb to g ph1 ph2   
      if (qactive_chan(4).and.qselect_chan(4)) then
        current_chan = 4
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbB1g0H2SNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- g q to q ph1 ph2    
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gqB1g0H2SNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- qb q to g ph1 ph2   
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqB1g0H2SNLO(2,3,1,4,5)
        wtsum = wtsum + wt
      endif
c--- g qb to qb ph1 ph2  
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gqbB1g0H2SNLO(3,1,2,4,5)
        wtsum = wtsum + wt
      endif
c--- qb g to qb ph1 ph2  
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgB1g0H2SNLO(3,2,1,4,5)
        wtsum = wtsum + wt
      endif
      sigSNLOH2=sigSNLOH2+rnorm*wtsum

      return
      end
