      function sigUH4J(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUH4J=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(7,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(7,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- g g to g l1 l2 l3 l4 
        if (qactive_chan(284).and.qselect_chan(284)) then
          current_chan = 284
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(285).and.qselect_chan(285)) then
          current_chan = 285
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(286).and.qselect_chan(286)) then
          current_chan = 286
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(287).and.qselect_chan(287)) then
          current_chan = 287
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(288).and.qselect_chan(288)) then
          current_chan = 288
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(289).and.qselect_chan(289)) then
          current_chan = 289
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(290).and.qselect_chan(290)) then
          current_chan = 290
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(291).and.qselect_chan(291)) then
          current_chan = 291
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(292).and.qselect_chan(292)) then
          current_chan = 292
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgA3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 
        if (qactive_chan(293).and.qselect_chan(293)) then
          current_chan = 293
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(294).and.qselect_chan(294)) then
          current_chan = 294
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(295).and.qselect_chan(295)) then
          current_chan = 295
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(296).and.qselect_chan(296)) then
          current_chan = 296
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(297).and.qselect_chan(297)) then
          current_chan = 297
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(298).and.qselect_chan(298)) then
          current_chan = 298
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(299).and.qselect_chan(299)) then
          current_chan = 299
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(300).and.qselect_chan(300)) then
          current_chan = 300
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(301).and.qselect_chan(301)) then
          current_chan = 301
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 
        if (qactive_chan(302).and.qselect_chan(302)) then
          current_chan = 302
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(303).and.qselect_chan(303)) then
          current_chan = 303
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(304).and.qselect_chan(304)) then
          current_chan = 304
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(305).and.qselect_chan(305)) then
          current_chan = 305
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(306).and.qselect_chan(306)) then
          current_chan = 306
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(307).and.qselect_chan(307)) then
          current_chan = 307
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(308).and.qselect_chan(308)) then
          current_chan = 308
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(309).and.qselect_chan(309)) then
          current_chan = 309
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(310).and.qselect_chan(310)) then
          current_chan = 310
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 
        if (qactive_chan(311).and.qselect_chan(311)) then
          current_chan = 311
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(312).and.qselect_chan(312)) then
          current_chan = 312
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(313).and.qselect_chan(313)) then
          current_chan = 313
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(314).and.qselect_chan(314)) then
          current_chan = 314
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(315).and.qselect_chan(315)) then
          current_chan = 315
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(316).and.qselect_chan(316)) then
          current_chan = 316
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(317).and.qselect_chan(317)) then
          current_chan = 317
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(318).and.qselect_chan(318)) then
          current_chan = 318
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(319).and.qselect_chan(319)) then
          current_chan = 319
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAhh3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 
        if (qactive_chan(320).and.qselect_chan(320)) then
          current_chan = 320
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(321).and.qselect_chan(321)) then
          current_chan = 321
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(322).and.qselect_chan(322)) then
          current_chan = 322
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(323).and.qselect_chan(323)) then
          current_chan = 323
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(324).and.qselect_chan(324)) then
          current_chan = 324
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(325).and.qselect_chan(325)) then
          current_chan = 325
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(326).and.qselect_chan(326)) then
          current_chan = 326
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(327).and.qselect_chan(327)) then
          current_chan = 327
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(328).and.qselect_chan(328)) then
          current_chan = 328
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAht3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 
        if (qactive_chan(329).and.qselect_chan(329)) then
          current_chan = 329
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(330).and.qselect_chan(330)) then
          current_chan = 330
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(331).and.qselect_chan(331)) then
          current_chan = 331
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(332).and.qselect_chan(332)) then
          current_chan = 332
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(333).and.qselect_chan(333)) then
          current_chan = 333
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(334).and.qselect_chan(334)) then
          current_chan = 334
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(335).and.qselect_chan(335)) then
          current_chan = 335
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(336).and.qselect_chan(336)) then
          current_chan = 336
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(337).and.qselect_chan(337)) then
          current_chan = 337
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAtt3g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 
        if (qactive_chan(338).and.qselect_chan(338)) then
          current_chan = 338
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgB1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 
        if (qactive_chan(339).and.qselect_chan(339)) then
          current_chan = 339
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbB1g2H4U(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 
        if (qactive_chan(340).and.qselect_chan(340)) then
          current_chan = 340
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqB1g2H4U(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 
        if (qactive_chan(341).and.qselect_chan(341)) then
          current_chan = 341
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqB1g2H4U(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 
        if (qactive_chan(342).and.qselect_chan(342)) then
          current_chan = 342
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbB1g2H4U(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 
        if (qactive_chan(343).and.qselect_chan(343)) then
          current_chan = 343
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgB1g2H4U(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(344).and.qselect_chan(344)) then
          current_chan = 344
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggB1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(345).and.qselect_chan(345)) then
          current_chan = 345
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpB1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(346).and.qselect_chan(346)) then
          current_chan = 346
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbB1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(347).and.qselect_chan(347)) then
          current_chan = 347
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqB1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(348).and.qselect_chan(348)) then
          current_chan = 348
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpB1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(349).and.qselect_chan(349)) then
          current_chan = 349
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbB1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(350).and.qselect_chan(350)) then
          current_chan = 350
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbB1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 
        if (qactive_chan(351).and.qselect_chan(351)) then
          current_chan = 351
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 
        if (qactive_chan(352).and.qselect_chan(352)) then
          current_chan = 352
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBt1g2H4U(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 
        if (qactive_chan(353).and.qselect_chan(353)) then
          current_chan = 353
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBt1g2H4U(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 
        if (qactive_chan(354).and.qselect_chan(354)) then
          current_chan = 354
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBt1g2H4U(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 
        if (qactive_chan(355).and.qselect_chan(355)) then
          current_chan = 355
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBt1g2H4U(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 
        if (qactive_chan(356).and.qselect_chan(356)) then
          current_chan = 356
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBt1g2H4U(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(357).and.qselect_chan(357)) then
          current_chan = 357
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(358).and.qselect_chan(358)) then
          current_chan = 358
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(359).and.qselect_chan(359)) then
          current_chan = 359
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(360).and.qselect_chan(360)) then
          current_chan = 360
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqBt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(361).and.qselect_chan(361)) then
          current_chan = 361
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(362).and.qselect_chan(362)) then
          current_chan = 362
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(363).and.qselect_chan(363)) then
          current_chan = 363
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbBt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 
        if (qactive_chan(364).and.qselect_chan(364)) then
          current_chan = 364
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 
        if (qactive_chan(365).and.qselect_chan(365)) then
          current_chan = 365
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBh1g2H4U(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 
        if (qactive_chan(366).and.qselect_chan(366)) then
          current_chan = 366
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBh1g2H4U(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 
        if (qactive_chan(367).and.qselect_chan(367)) then
          current_chan = 367
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBh1g2H4U(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 
        if (qactive_chan(368).and.qselect_chan(368)) then
          current_chan = 368
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBh1g2H4U(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 
        if (qactive_chan(369).and.qselect_chan(369)) then
          current_chan = 369
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBh1g2H4U(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(370).and.qselect_chan(370)) then
          current_chan = 370
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpgBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(371).and.qselect_chan(371)) then
          current_chan = 371
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbgBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(372).and.qselect_chan(372)) then
          current_chan = 372
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(373).and.qselect_chan(373)) then
          current_chan = 373
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpbBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(374).and.qselect_chan(374)) then
          current_chan = 374
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(375).and.qselect_chan(375)) then
          current_chan = 375
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(376).and.qselect_chan(376)) then
          current_chan = 376
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(377).and.qselect_chan(377)) then
          current_chan = 377
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(378).and.qselect_chan(378)) then
          current_chan = 378
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(379).and.qselect_chan(379)) then
          current_chan = 379
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(380).and.qselect_chan(380)) then
          current_chan = 380
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbBh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 
        if (qactive_chan(381).and.qselect_chan(381)) then
          current_chan = 381
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 
        if (qactive_chan(382).and.qselect_chan(382)) then
          current_chan = 382
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBhh1g2H4U(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 
        if (qactive_chan(383).and.qselect_chan(383)) then
          current_chan = 383
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBhh1g2H4U(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 
        if (qactive_chan(384).and.qselect_chan(384)) then
          current_chan = 384
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBhh1g2H4U(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 
        if (qactive_chan(385).and.qselect_chan(385)) then
          current_chan = 385
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBhh1g2H4U(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 
        if (qactive_chan(386).and.qselect_chan(386)) then
          current_chan = 386
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBhh1g2H4U(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(387).and.qselect_chan(387)) then
          current_chan = 387
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpgBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(388).and.qselect_chan(388)) then
          current_chan = 388
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbgBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(389).and.qselect_chan(389)) then
          current_chan = 389
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(390).and.qselect_chan(390)) then
          current_chan = 390
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpbBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(391).and.qselect_chan(391)) then
          current_chan = 391
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(392).and.qselect_chan(392)) then
          current_chan = 392
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(393).and.qselect_chan(393)) then
          current_chan = 393
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(394).and.qselect_chan(394)) then
          current_chan = 394
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(395).and.qselect_chan(395)) then
          current_chan = 395
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(396).and.qselect_chan(396)) then
          current_chan = 396
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(397).and.qselect_chan(397)) then
          current_chan = 397
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbBhh1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 
        if (qactive_chan(398).and.qselect_chan(398)) then
          current_chan = 398
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 
        if (qactive_chan(399).and.qselect_chan(399)) then
          current_chan = 399
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBht1g2H4U(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 
        if (qactive_chan(400).and.qselect_chan(400)) then
          current_chan = 400
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBht1g2H4U(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 
        if (qactive_chan(401).and.qselect_chan(401)) then
          current_chan = 401
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBht1g2H4U(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 
        if (qactive_chan(402).and.qselect_chan(402)) then
          current_chan = 402
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBht1g2H4U(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 
        if (qactive_chan(403).and.qselect_chan(403)) then
          current_chan = 403
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBht1g2H4U(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(404).and.qselect_chan(404)) then
          current_chan = 404
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpgBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(405).and.qselect_chan(405)) then
          current_chan = 405
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qpbgBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(406).and.qselect_chan(406)) then
          current_chan = 406
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(407).and.qselect_chan(407)) then
          current_chan = 407
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = gqpbBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(408).and.qselect_chan(408)) then
          current_chan = 408
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(409).and.qselect_chan(409)) then
          current_chan = 409
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(410).and.qselect_chan(410)) then
          current_chan = 410
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(411).and.qselect_chan(411)) then
          current_chan = 411
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(412).and.qselect_chan(412)) then
          current_chan = 412
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(413).and.qselect_chan(413)) then
          current_chan = 413
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(414).and.qselect_chan(414)) then
          current_chan = 414
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbBht1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 
        if (qactive_chan(415).and.qselect_chan(415)) then
          current_chan = 415
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBtt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 
        if (qactive_chan(416).and.qselect_chan(416)) then
          current_chan = 416
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBtt1g2H4U(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 
        if (qactive_chan(417).and.qselect_chan(417)) then
          current_chan = 417
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBtt1g2H4U(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 
        if (qactive_chan(418).and.qselect_chan(418)) then
          current_chan = 418
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBtt1g2H4U(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 
        if (qactive_chan(419).and.qselect_chan(419)) then
          current_chan = 419
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBtt1g2H4U(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 
        if (qactive_chan(420).and.qselect_chan(420)) then
          current_chan = 420
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBtt1g2H4U(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(421).and.qselect_chan(421)) then
          current_chan = 421
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBtt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(422).and.qselect_chan(422)) then
          current_chan = 422
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBtt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(423).and.qselect_chan(423)) then
          current_chan = 423
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBtt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q initiated       
        if (qactive_chan(424).and.qselect_chan(424)) then
          current_chan = 424
          ip1_chan     = 30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qqBtt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(425).and.qselect_chan(425)) then
          current_chan = 425
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBtt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(426).and.qselect_chan(426)) then
          current_chan = 426
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBtt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb initiated     
        if (qactive_chan(427).and.qselect_chan(427)) then
          current_chan = 427
          ip1_chan     = -30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qbqbBtt1g2H4U(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 wilson
        if (qactive_chan(428).and.qselect_chan(428)) then
          current_chan = 428
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 wilson
        if (qactive_chan(429).and.qselect_chan(429)) then
          current_chan = 429
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 wilson
        if (qactive_chan(430).and.qselect_chan(430)) then
          current_chan = 430
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 wilson
        if (qactive_chan(431).and.qselect_chan(431)) then
          current_chan = 431
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 wilson
        if (qactive_chan(432).and.qselect_chan(432)) then
          current_chan = 432
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 wilson
        if (qactive_chan(433).and.qselect_chan(433)) then
          current_chan = 433
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 wilson
        if (qactive_chan(434).and.qselect_chan(434)) then
          current_chan = 434
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 wilson
        if (qactive_chan(435).and.qselect_chan(435)) then
          current_chan = 435
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 wilson
        if (qactive_chan(436).and.qselect_chan(436)) then
          current_chan = 436
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 wilson
        if (qactive_chan(437).and.qselect_chan(437)) then
          current_chan = 437
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 wilson
        if (qactive_chan(438).and.qselect_chan(438)) then
          current_chan = 438
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 wilson
        if (qactive_chan(439).and.qselect_chan(439)) then
          current_chan = 439
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 wilson
        if (qactive_chan(440).and.qselect_chan(440)) then
          current_chan = 440
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 wilson
        if (qactive_chan(441).and.qselect_chan(441)) then
          current_chan = 441
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = 0d0
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 wilson
        if (qactive_chan(442).and.qselect_chan(442)) then
          current_chan = 442
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggA3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiatedwilson 
        if (qactive_chan(443).and.qselect_chan(443)) then
          current_chan = 443
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqA3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiatedwilson
        if (qactive_chan(444).and.qselect_chan(444)) then
          current_chan = 444
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbA3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiatedwilson 
        if (qactive_chan(445).and.qselect_chan(445)) then
          current_chan = 445
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgA3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiatedwilson
        if (qactive_chan(446).and.qselect_chan(446)) then
          current_chan = 446
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgA3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g l1 l2 l3 l4 wilson
        if (qactive_chan(447).and.qselect_chan(447)) then
          current_chan = 447
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          wt = ggAh3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiatedwilson 
        if (qactive_chan(448).and.qselect_chan(448)) then
          current_chan = 448
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqAh3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiatedwilson
        if (qactive_chan(449).and.qselect_chan(449)) then
          current_chan = 449
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbAh3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiatedwilson 
        if (qactive_chan(450).and.qselect_chan(450)) then
          current_chan = 450
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgAh3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiatedwilson
        if (qactive_chan(451).and.qselect_chan(451)) then
          current_chan = 451
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgAh3g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 wilson
        if (qactive_chan(452).and.qselect_chan(452)) then
          current_chan = 452
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgB1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 wilson
        if (qactive_chan(453).and.qselect_chan(453)) then
          current_chan = 453
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbB1g1H4TNLO(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 wilson
        if (qactive_chan(454).and.qselect_chan(454)) then
          current_chan = 454
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqB1g1H4TNLO(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 wilson
        if (qactive_chan(455).and.qselect_chan(455)) then
          current_chan = 455
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqB1g1H4TNLO(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 wilson
        if (qactive_chan(456).and.qselect_chan(456)) then
          current_chan = 456
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbB1g1H4TNLO(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 wilson
        if (qactive_chan(457).and.qselect_chan(457)) then
          current_chan = 457
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgB1g1H4TNLO(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiatedwilson 
        if (qactive_chan(458).and.qselect_chan(458)) then
          current_chan = 458
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggB1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiatedwilson 
        if (qactive_chan(459).and.qselect_chan(459)) then
          current_chan = 459
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpB1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiatedwilson
        if (qactive_chan(460).and.qselect_chan(460)) then
          current_chan = 460
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbB1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiatedwilson
        if (qactive_chan(461).and.qselect_chan(461)) then
          current_chan = 461
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpB1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiatedwilson
        if (qactive_chan(462).and.qselect_chan(462)) then
          current_chan = 462
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbB1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 wilson
        if (qactive_chan(463).and.qselect_chan(463)) then
          current_chan = 463
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBh1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 wilson
        if (qactive_chan(464).and.qselect_chan(464)) then
          current_chan = 464
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBh1g1H4TNLO(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 wilson
        if (qactive_chan(465).and.qselect_chan(465)) then
          current_chan = 465
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBh1g1H4TNLO(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 wilson
        if (qactive_chan(466).and.qselect_chan(466)) then
          current_chan = 466
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBh1g1H4TNLO(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 wilson
        if (qactive_chan(467).and.qselect_chan(467)) then
          current_chan = 467
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBh1g1H4TNLO(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 wilson
        if (qactive_chan(468).and.qselect_chan(468)) then
          current_chan = 468
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBh1g1H4TNLO(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiatedwilson 
        if (qactive_chan(469).and.qselect_chan(469)) then
          current_chan = 469
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBh1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiatedwilson 
        if (qactive_chan(470).and.qselect_chan(470)) then
          current_chan = 470
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBh1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiatedwilson
        if (qactive_chan(471).and.qselect_chan(471)) then
          current_chan = 471
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBh1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiatedwilson
        if (qactive_chan(472).and.qselect_chan(472)) then
          current_chan = 472
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBh1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiatedwilson
        if (qactive_chan(473).and.qselect_chan(473)) then
          current_chan = 473
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBh1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to q l1 l2 l3 l4 wilson
        if (qactive_chan(474).and.qselect_chan(474)) then
          current_chan = 474
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qgBt1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g l1 l2 l3 l4 wilson
        if (qactive_chan(475).and.qselect_chan(475)) then
          current_chan = 475
          ip1_chan     = 30
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = qqbBt1g1H4TNLO(ix,xri1,xri2,1,3,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to q l1 l2 l3 l4 wilson
        if (qactive_chan(476).and.qselect_chan(476)) then
          current_chan = 476
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = gqBt1g1H4TNLO(ix,xri1,xri2,2,1,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g l1 l2 l3 l4 wilson
        if (qactive_chan(477).and.qselect_chan(477)) then
          current_chan = 477
          ip1_chan     = -30
          ip2_chan     = 30
          call Q3_check
          nfB1 = 3
          wt = qbqBt1g1H4TNLO(ix,xri1,xri2,2,3,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb l1 l2 l3 l4 wilson
        if (qactive_chan(478).and.qselect_chan(478)) then
          current_chan = 478
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfB1 = 3
          wt = gqbBt1g1H4TNLO(ix,xri1,xri2,3,1,2,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb l1 l2 l3 l4 wilson
        if (qactive_chan(479).and.qselect_chan(479)) then
          current_chan = 479
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = qbgBt1g1H4TNLO(ix,xri1,xri2,3,2,1,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiatedwilson 
        if (qactive_chan(480).and.qselect_chan(480)) then
          current_chan = 480
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 3
          wt = ggBt1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiatedwilson 
        if (qactive_chan(481).and.qselect_chan(481)) then
          current_chan = 481
          ip1_chan     = 31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpBt1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiatedwilson
        if (qactive_chan(482).and.qselect_chan(482)) then
          current_chan = 482
          ip1_chan     = 31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBt1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiatedwilson
        if (qactive_chan(483).and.qselect_chan(483)) then
          current_chan = 483
          ip1_chan     = -31
          ip2_chan     = 31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBt1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiatedwilson
        if (qactive_chan(484).and.qselect_chan(484)) then
          current_chan = 484
          ip1_chan     = -31
          ip2_chan     = -31
          call Q3_check
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBt1g1H4TNLO(ix,xri1,xri2,1,2,3,4,5,6,7,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUH4J=sigUH4J+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
