      subroutine selectchannelHJJJ()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*C0*(nc**2d0-1d0)*nc**3*(4d0*pi*alphas_scl)**3
      n_alphas_proc = 5
      n_alpha_proc  = 0
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelHJJJ: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelHJJJ: already allocated'  
        stop
      end if

      ntot_chan = 58

      allocate(qactive_chan(1:58))
      allocate(contrib_chan(1:58))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! g g to g g g ph1 ph2   A5g0H(1,2,3,4,5,6,7)  
c      qactive_chan(2)  = .true.   ! q g to g g q ph1 ph2   B3g0H(1,2,3,4,5,6,7)  
c      qactive_chan(3)  = .true.   ! q qb to g g g ph1 ph2   B3g0H(1,3,4,5,2,6,7)  
c      qactive_chan(4)  = .true.   ! g q to g g q ph1 ph2   B3g0H(2,1,3,4,5,6,7)  
c      qactive_chan(5)  = .true.   ! qb q to g g g ph1 ph2   B3g0H(2,3,4,5,1,6,7)  
c      qactive_chan(6)  = .true.   ! g g to qb g q ph1 ph2   B3g0H(3,1,2,4,5,6,7)  
c      qactive_chan(7)  = .true.   ! g qb to qb g g ph1 ph2   B3g0H(3,1,4,5,2,6,7)  
c      qactive_chan(8)  = .true.   ! qb g to qb g g ph1 ph2   B3g0H(3,2,4,5,1,6,7)  
c      qactive_chan(9)  = .true.   ! q g to g g q ph1 ph2   Bt3g0H(1,2,3,4,5,6,7)  
c      qactive_chan(10) = .true.   ! q qb to g g g ph1 ph2   Bt3g0H(1,3,4,5,2,6,7)  
c      qactive_chan(11) = .true.   ! g q to g g q ph1 ph2   Bt3g0H(2,1,3,4,5,6,7)  
c      qactive_chan(12) = .true.   ! qb q to g g g ph1 ph2   Bt3g0H(2,3,4,5,1,6,7)  
c      qactive_chan(13) = .true.   ! g g to qb g q ph1 ph2   Bt3g0H(3,1,2,4,5,6,7)  
c      qactive_chan(14) = .true.   ! g qb to qb g g ph1 ph2   Bt3g0H(3,1,4,5,2,6,7)  
c      qactive_chan(15) = .true.   ! qb g to qb g g ph1 ph2   Bt3g0H(3,2,4,5,1,6,7)  
c      qactive_chan(16) = .true.   ! q gt to gt gt q ph1 ph2   Btt3g0H(1,2,3,4,5,6,7)  
c      qactive_chan(17) = .true.   ! q qb to gt gt gt ph1 ph2   Btt3g0H(1,3,4,5,2,6,7)  
c      qactive_chan(18) = .true.   ! gt q to gt gt q ph1 ph2   Btt3g0H(2,1,3,4,5,6,7)  
c      qactive_chan(19) = .true.   ! qb q to gt gt gt ph1 ph2   Btt3g0H(2,3,4,5,1,6,7)  
c      qactive_chan(20) = .true.   ! gt gt to qb gt q ph1 ph2   Btt3g0H(3,1,2,4,5,6,7)  
c      qactive_chan(21) = .true.   ! gt qb to qb gt gt ph1 ph2   Btt3g0H(3,1,4,5,2,6,7)  
c      qactive_chan(22) = .true.   ! qb gt to qb gt gt ph1 ph2   Btt3g0H(3,2,4,5,1,6,7)  
c      qactive_chan(23) = .true.   ! q g to Q Qb q ph1 ph2   C1g0HF(1,2,3,4,5,6,7)  
c      qactive_chan(24) = .true.   ! q Qb to g Qb q ph1 ph2   C1g0HF(1,3,2,4,5,6,7)  
c      qactive_chan(25) = .true.   ! q Q to g Q q ph1 ph2   C1g0HF(1,3,4,2,5,6,7)  
c      qactive_chan(26) = .true.   ! q qb to g Q Qb ph1 ph2   C1g0HF(1,3,4,5,2,6,7)  
c      qactive_chan(27) = .true.   ! g q to Q Qb q ph1 ph2   C1g0HF(2,1,3,4,5,6,7)  
c      qactive_chan(28) = .true.   ! qb q to g Q Qb ph1 ph2   C1g0HF(2,3,4,5,1,6,7)  
c      qactive_chan(29) = .true.   ! g qb to qb Q Qb ph1 ph2   C1g0HF(3,1,4,5,2,6,7)  
c      qactive_chan(30) = .true.   ! qb g to qb Q Qb ph1 ph2   C1g0HF(3,2,4,5,1,6,7)  
c      qactive_chan(31) = .true.   ! qb Qb to qb g Qb ph1 ph2   C1g0HF(3,4,2,5,1,6,7)  
c      qactive_chan(32) = .true.   ! qb Q to qb g Q ph1 ph2   C1g0HF(3,4,5,2,1,6,7)  
c      qactive_chan(33) = .true.   ! q g to Q Qb q ph1 ph2   Ct1g0HF(1,2,3,4,5,6,7)  
c      qactive_chan(34) = .true.   ! q Qb to g Qb q ph1 ph2   Ct1g0HF(1,3,2,4,5,6,7)  
c      qactive_chan(35) = .true.   ! q Q to g Q q ph1 ph2   Ct1g0HF(1,3,4,2,5,6,7)  
c      qactive_chan(36) = .true.   ! q qb to g Q Qb ph1 ph2   Ct1g0HF(1,3,4,5,2,6,7)  
c      qactive_chan(37) = .true.   ! g q to Q Qb q ph1 ph2   Ct1g0HF(2,1,3,4,5,6,7)  
c      qactive_chan(38) = .true.   ! qb q to g Q Qb ph1 ph2   Ct1g0HF(2,3,4,5,1,6,7)  
c      qactive_chan(39) = .true.   ! g qb to qb Q Qb ph1 ph2   Ct1g0HF(3,1,4,5,2,6,7)  
c      qactive_chan(40) = .true.   ! qb g to qb Q Qb ph1 ph2   Ct1g0HF(3,2,4,5,1,6,7)  
c      qactive_chan(41) = .true.   ! qb Qb to qb g Qb ph1 ph2   Ct1g0HF(3,4,2,5,1,6,7)  
c      qactive_chan(42) = .true.   ! qb Q to qb g Q ph1 ph2   Ct1g0HF(3,4,5,2,1,6,7)  
c      qactive_chan(43) = .true.   ! q g to q qb q ph1 ph2   D1g0HF(1,2,3,4,5,6,7)  
c      qactive_chan(44) = .true.   ! q qb to g qb q ph1 ph2   D1g0HF(1,3,2,4,5,6,7)  
c      qactive_chan(45) = .true.   ! q q to g q q ph1 ph2   D1g0HF(1,3,4,2,5,6,7)  
c      qactive_chan(46) = .true.   ! g q to q qb q ph1 ph2   D1g0HF(2,1,3,4,5,6,7)  
c      qactive_chan(47) = .true.   ! qb q to g qb q ph1 ph2   D1g0HF(2,3,1,4,5,6,7)  
c      qactive_chan(48) = .true.   ! g qb to qb qb q ph1 ph2   D1g0HF(3,1,2,4,5,6,7)  
c      qactive_chan(49) = .true.   ! qb g to qb qb q ph1 ph2   D1g0HF(3,2,1,4,5,6,7)  
c      qactive_chan(50) = .true.   ! qb qb to qb g qb ph1 ph2   D1g0HF(3,4,1,5,2,6,7)  
c      qactive_chan(51) = .true.   ! q g to q qb q ph1 ph2   Dt1g0H(1,2,3,4,5,6,7)  
c      qactive_chan(52) = .true.   ! q qb to g qb q ph1 ph2   Dt1g0H(1,3,2,4,5,6,7)  
c      qactive_chan(53) = .true.   ! q q to g q q ph1 ph2   Dt1g0H(1,3,4,2,5,6,7)  
c      qactive_chan(54) = .true.   ! g q to q qb q ph1 ph2   Dt1g0H(2,1,3,4,5,6,7)  
c      qactive_chan(55) = .true.   ! qb q to g qb q ph1 ph2   Dt1g0H(2,3,1,4,5,6,7)  
c      qactive_chan(56) = .true.   ! g qb to qb qb q ph1 ph2   Dt1g0H(3,1,2,4,5,6,7)  
c      qactive_chan(57) = .true.   ! qb g to qb qb q ph1 ph2   Dt1g0H(3,2,1,4,5,6,7)  
c      qactive_chan(58) = .true.   ! qb qb to qb g qb ph1 ph2   Dt1g0H(3,4,1,5,2,6,7)  

      do i=1,58
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c -- virtual                                      ME                   TNLO  

c -- double real                                  ME                   S  

c -- real virtual                                 ME                   T  

c -- double virtual                               ME                   U  

      return
      end


c---- get channel strings
      subroutine getchannelHJJJ(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'g g to g g g ph1 ph2 '
        me_str   = 'A5g0H(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (2)
        chan_str = 'q g to g g q ph1 ph2 '
        me_str   = 'B3g0H(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (3)
        chan_str = 'q qb to g g g ph1 ph2 '
        me_str   = 'B3g0H(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (4)
        chan_str = 'g q to g g q ph1 ph2 '
        me_str   = 'B3g0H(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (5)
        chan_str = 'qb q to g g g ph1 ph2 '
        me_str   = 'B3g0H(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (6)
        chan_str = 'g g to qb g q ph1 ph2 '
        me_str   = 'B3g0H(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (7)
        chan_str = 'g qb to qb g g ph1 ph2 '
        me_str   = 'B3g0H(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (8)
        chan_str = 'qb g to qb g g ph1 ph2 '
        me_str   = 'B3g0H(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (9)
        chan_str = 'q g to g g q ph1 ph2 '
        me_str   = 'Bt3g0H(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (10)
        chan_str = 'q qb to g g g ph1 ph2 '
        me_str   = 'Bt3g0H(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (11)
        chan_str = 'g q to g g q ph1 ph2 '
        me_str   = 'Bt3g0H(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (12)
        chan_str = 'qb q to g g g ph1 ph2 '
        me_str   = 'Bt3g0H(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (13)
        chan_str = 'g g to qb g q ph1 ph2 '
        me_str   = 'Bt3g0H(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (14)
        chan_str = 'g qb to qb g g ph1 ph2 '
        me_str   = 'Bt3g0H(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (15)
        chan_str = 'qb g to qb g g ph1 ph2 '
        me_str   = 'Bt3g0H(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (16)
        chan_str = 'q gt to gt gt q ph1 ph2 '
        me_str   = 'Btt3g0H(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (17)
        chan_str = 'q qb to gt gt gt ph1 ph2 '
        me_str   = 'Btt3g0H(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (18)
        chan_str = 'gt q to gt gt q ph1 ph2 '
        me_str   = 'Btt3g0H(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (19)
        chan_str = 'qb q to gt gt gt ph1 ph2 '
        me_str   = 'Btt3g0H(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (20)
        chan_str = 'gt gt to qb gt q ph1 ph2 '
        me_str   = 'Btt3g0H(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (21)
        chan_str = 'gt qb to qb gt gt ph1 ph2 '
        me_str   = 'Btt3g0H(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (22)
        chan_str = 'qb gt to qb gt gt ph1 ph2 '
        me_str   = 'Btt3g0H(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (23)
        chan_str = 'q g to Q Qb q ph1 ph2 '
        me_str   = 'C1g0HF(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (24)
        chan_str = 'q Qb to g Qb q ph1 ph2 '
        me_str   = 'C1g0HF(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (25)
        chan_str = 'q Q to g Q q ph1 ph2 '
        me_str   = 'C1g0HF(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (26)
        chan_str = 'q qb to g Q Qb ph1 ph2 '
        me_str   = 'C1g0HF(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (27)
        chan_str = 'g q to Q Qb q ph1 ph2 '
        me_str   = 'C1g0HF(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (28)
        chan_str = 'qb q to g Q Qb ph1 ph2 '
        me_str   = 'C1g0HF(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (29)
        chan_str = 'g qb to qb Q Qb ph1 ph2 '
        me_str   = 'C1g0HF(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (30)
        chan_str = 'qb g to qb Q Qb ph1 ph2 '
        me_str   = 'C1g0HF(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (31)
        chan_str = 'qb Qb to qb g Qb ph1 ph2 '
        me_str   = 'C1g0HF(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (32)
        chan_str = 'qb Q to qb g Q ph1 ph2 '
        me_str   = 'C1g0HF(3,4,5,2,1,6,7)'
        sub_str  = ''

      case (33)
        chan_str = 'q g to Q Qb q ph1 ph2 '
        me_str   = 'Ct1g0HF(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (34)
        chan_str = 'q Qb to g Qb q ph1 ph2 '
        me_str   = 'Ct1g0HF(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (35)
        chan_str = 'q Q to g Q q ph1 ph2 '
        me_str   = 'Ct1g0HF(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (36)
        chan_str = 'q qb to g Q Qb ph1 ph2 '
        me_str   = 'Ct1g0HF(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (37)
        chan_str = 'g q to Q Qb q ph1 ph2 '
        me_str   = 'Ct1g0HF(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (38)
        chan_str = 'qb q to g Q Qb ph1 ph2 '
        me_str   = 'Ct1g0HF(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (39)
        chan_str = 'g qb to qb Q Qb ph1 ph2 '
        me_str   = 'Ct1g0HF(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (40)
        chan_str = 'qb g to qb Q Qb ph1 ph2 '
        me_str   = 'Ct1g0HF(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (41)
        chan_str = 'qb Qb to qb g Qb ph1 ph2 '
        me_str   = 'Ct1g0HF(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (42)
        chan_str = 'qb Q to qb g Q ph1 ph2 '
        me_str   = 'Ct1g0HF(3,4,5,2,1,6,7)'
        sub_str  = ''

      case (43)
        chan_str = 'q g to q qb q ph1 ph2 '
        me_str   = 'D1g0HF(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (44)
        chan_str = 'q qb to g qb q ph1 ph2 '
        me_str   = 'D1g0HF(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (45)
        chan_str = 'q q to g q q ph1 ph2 '
        me_str   = 'D1g0HF(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (46)
        chan_str = 'g q to q qb q ph1 ph2 '
        me_str   = 'D1g0HF(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (47)
        chan_str = 'qb q to g qb q ph1 ph2 '
        me_str   = 'D1g0HF(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (48)
        chan_str = 'g qb to qb qb q ph1 ph2 '
        me_str   = 'D1g0HF(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (49)
        chan_str = 'qb g to qb qb q ph1 ph2 '
        me_str   = 'D1g0HF(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (50)
        chan_str = 'qb qb to qb g qb ph1 ph2 '
        me_str   = 'D1g0HF(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (51)
        chan_str = 'q g to q qb q ph1 ph2 '
        me_str   = 'Dt1g0H(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (52)
        chan_str = 'q qb to g qb q ph1 ph2 '
        me_str   = 'Dt1g0H(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (53)
        chan_str = 'q q to g q q ph1 ph2 '
        me_str   = 'Dt1g0H(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (54)
        chan_str = 'g q to q qb q ph1 ph2 '
        me_str   = 'Dt1g0H(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (55)
        chan_str = 'qb q to g qb q ph1 ph2 '
        me_str   = 'Dt1g0H(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (56)
        chan_str = 'g qb to qb qb q ph1 ph2 '
        me_str   = 'Dt1g0H(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (57)
        chan_str = 'qb g to qb qb q ph1 ph2 '
        me_str   = 'Dt1g0H(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (58)
        chan_str = 'qb qb to qb g qb ph1 ph2 '
        me_str   = 'Dt1g0H(3,4,1,5,2,6,7)'
        sub_str  = ''

      case default
        print*, 'getchannelHJJJ: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtHJJJ(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtHJJJ = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (1)
        ! [g, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4,5 /))

      case (2)
        ! [g, g, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (3)
        ! [g, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4,5 /))

      case (4)
        ! [g, g, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (5)
        ! [g, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4,5 /))

      case (7)
        ! [qb, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 4,5 /))

      case (8)
        ! [qb, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 4,5 /))

      case (9)
        ! [g, g, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (10)
        ! [g, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4,5 /))

      case (11)
        ! [g, g, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (12)
        ! [g, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4,5 /))

      case (14)
        ! [qb, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 4,5 /))

      case (15)
        ! [qb, g, g, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 4,5 /))

      case (16)
        ! [gt, gt, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (17)
        ! [gt, gt, gt, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4,5 /))

      case (18)
        ! [gt, gt, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (19)
        ! [gt, gt, gt, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4,5 /))

      case (21)
        ! [qb, gt, gt, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 4,5 /))

      case (22)
        ! [qb, gt, gt, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 4,5 /))

      case (43)
        ! [q, qb, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,5 /))

      case (45)
        ! [g, q, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 4,5 /))

      case (46)
        ! [q, qb, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,5 /))

      case (48)
        ! [qb, qb, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (49)
        ! [qb, qb, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (50)
        ! [qb, g, qb, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,5 /))

      case (51)
        ! [q, qb, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,5 /))

      case (53)
        ! [g, q, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 4,5 /))

      case (54)
        ! [q, qb, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,5 /))

      case (56)
        ! [qb, qb, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (57)
        ! [qb, qb, q, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,4 /))

      case (58)
        ! [qb, g, qb, ph1, ph2]
        LIPSwgtHJJJ = weight_lips((/ 3,5 /))

      case default
        LIPSwgtHJJJ = 1

      end select
      end
