      function sigSWp(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSWp=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      jflag=.false.
      ix=1
      ix_chan=1

c--- u g to g d nu lp    
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qgB2g0WS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u db to g g nu lp   
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = 20
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .true.
        wt = qqbB2g0WS(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- g u to g d nu lp    
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .false.
        wt = gqB2g0WS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db u to g g nu lp   
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = -40
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .true.
        wt = qbqB2g0WS(2,3,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- g g to ub d nu lp   
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = ggB2g0WS(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g db to ub g nu lp  
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = 0
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .false.
        wt = gqbB2g0WS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- db g to ub g nu lp  
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = -40
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qbgB2g0WS(3,2,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- u gt to gt d nu lp  
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qgtBt2g0WS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u db to gt gt nu lp 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = 20
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .true.
        wt = qqbBt2g0WS(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- gt u to gt d nu lp  
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .false.
        wt = gtqBt2g0WS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db u to gt gt nu lp 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = -40
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .true.
        wt = qbqBt2g0WS(2,3,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to ub d nu lp 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = gtgtBt2g0WS(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt db to ub gt nu lp 
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = 0
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .false.
        wt = gtqbBt2g0WS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- db gt to ub gt nu lp 
      if (qactive_chan(28).and.qselect_chan(28)) then
        current_chan = 28
        ip1_chan     = -40
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qbgtBt2g0WS(3,2,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- u Qb to Qb d nu lp  
      if (qactive_chan(29).and.qselect_chan(29)) then
        current_chan = 29
        ip1_chan     = 21
        ip2_chan     = -31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qqpbC0g0WS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u Q to Q d nu lp    
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = 21
        ip2_chan     = 31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qqpC0g0WS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u db to Q Qb nu lp  
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 4
          ckmflag = .true.
        wt = qqbC0g0WS(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- Qb u to Qb d nu lp  
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = -31
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqC0g0WS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- Q u to Q d nu lp    
      if (qactive_chan(33).and.qselect_chan(33)) then
        current_chan = 33
        ip1_chan     = 31
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqC0g0WS(2,3,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db u to Q Qb nu lp  
      if (qactive_chan(34).and.qselect_chan(34)) then
        current_chan = 34
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 4
          ckmflag = .true.
        wt = qbqC0g0WS(2,3,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- Qb Q to ub d nu lp  
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqpC0g0WS(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- Qb db to ub Qb nu lp 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = -31
        ip2_chan     = -41
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqbC0g0WS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- Q Qb to ub d nu lp  
      if (qactive_chan(37).and.qselect_chan(37)) then
        current_chan = 37
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqpbC0g0WS(3,2,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db Qb to ub Qb nu lp 
      if (qactive_chan(38).and.qselect_chan(38)) then
        current_chan = 38
        ip1_chan     = -41
        ip2_chan     = -31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpbC0g0WS(3,2,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- Q db to ub Q nu lp  
      if (qactive_chan(39).and.qselect_chan(39)) then
        current_chan = 39
        ip1_chan     = 31
        ip2_chan     = -41
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqbC0g0WS(3,4,1,2,5,6)
        wtsum = wtsum + wt
      endif
c--- db Q to ub Q nu lp  
      if (qactive_chan(40).and.qselect_chan(40)) then
        current_chan = 40
        ip1_chan     = -41
        ip2_chan     = 31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpC0g0WS(3,4,2,1,5,6)
        wtsum = wtsum + wt
      endif
c--- u ub to ub d nu lp  
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqbD0g0WaS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u u to u d nu lp    
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqD0g0WaS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u db to u ub nu lp  
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qqpbD0g0WaS(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- ub u to ub d nu lp  
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqD0g0WaS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db u to u ub nu lp  
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qpbqD0g0WaS(2,3,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- ub db to ub ub nu lp 
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqpbD0g0WaS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- db ub to ub ub nu lp 
      if (qactive_chan(47).and.qselect_chan(47)) then
        current_chan = 47
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpbqbD0g0WaS(3,2,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- u db to db d nu lp  
      if (qactive_chan(48).and.qselect_chan(48)) then
        current_chan = 48
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qqpbD0g0WbS(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- u d to d d nu lp    
      if (qactive_chan(49).and.qselect_chan(49)) then
        current_chan = 49
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qqpD0g0WbS(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db u to db d nu lp  
      if (qactive_chan(50).and.qselect_chan(50)) then
        current_chan = 50
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qpbqD0g0WbS(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- d u to d d nu lp    
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqD0g0WbS(2,3,1,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db d to ub d nu lp  
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqpD0g0WbS(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- db db to ub db nu lp 
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = -40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqpbD0g0WbS(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- d db to ub d nu lp  
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqpbD0g0WbS(3,2,1,4,5,6)
        wtsum = wtsum + wt
      endif
      sigSWp=sigSWp+rnorm*wtsum

      return
      end
