      function sigTNLOWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLOWm=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d ub to lm nub      
        if (qactive_chan(9).and.qselect_chan(9)) then
          current_chan = 9
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbB0g1WTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to lm nub      
        if (qactive_chan(10).and.qselect_chan(10)) then
          current_chan = 10
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqB0g1WTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(11).and.qselect_chan(11)) then
          current_chan = 11
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gqB0g1WTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(12).and.qselect_chan(12)) then
          current_chan = 12
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gqbB0g1WTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(13).and.qselect_chan(13)) then
          current_chan = 13
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgB0g1WTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(14).and.qselect_chan(14)) then
          current_chan = 14
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgB0g1WTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLOWm=sigTNLOWm+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
