*********************************************************************
*
*
* Quark pair NLO real subtraction term for
*
* q(i1) g (i2) g (i3) qb(i4) e-(i5) e+(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BWFlav/

      function gqB2g0WSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqB2g0WSNLO = qgB2g0WSNLO(i1,i2,i3,i4,i5,i6)

      return
      end
      function gqbB2g0WSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqbB2g0WSNLO = qbgB2g0WSNLO(i1,i2,i3,i4,i5,i6)

      return
      end

      function qbqB2g0WSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbqB2g0WSNLO = qqbB2g0WSNLO(i1,i2,i3,i4,i5,i6)

      return
      end

