! DW added i1 <-> i2 swaps for all Q/Qb initiated subtraction only terms as required 16/17
* TM 22/09/2015: Need to think about "qqBt1g2WU" and "qbqbBt1g2WU", these are integrated D-type subtraction terms that don't precisely factorise onto these colour levels
! DW split up Wp/Wm to avoid conflicts in finite subtraction only channels inherited from D-type RR contributions

      function gqBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqBt1g2WmU = qgBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function gqbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqbBt1g2WmU = qbgBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbgBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbgBt1g2WmU =qbgBt1g2WFPU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
     .           +qbgBt1g2WgtoqU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbqBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqBt1g2WmU =qqbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqbBt1g2WmU =qqbBt1g2WFPU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qgBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qgBt1g2WmU =qgBt1g2WFPU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
     .          +qgBt1g2WgtoqU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qpbqBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpbqBt1g2WmU = qqpbBt1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpbqbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpbqbBt1g2WmU = qbqpbBt1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpqBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpqBt1g2WmU = qqpBt1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpqbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpqbBt1g2WmU = qbqpBt1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)!i1 <-> i2 swap

      return
      end


      function dbubBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used Wp as source for ordering)
C       dbubBt1g2WmU = qbqpbD0g2WaU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp
      dbubBt1g2WmU = ubdbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp

      return
      end

      function duBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used Wp as source for ordering)
C       duBt1g2WmU = qqpD0g2WbU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp
      duBt1g2WmU = udB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp

      return
      end

      function ubdbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used Wp as source for ordering)
C       ubdbBt1g2WmU = qbqpbD0g2WaU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp
      ubdbBt1g2WmU = ubdbB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp

      return
      end

      function udBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used Wp as source for ordering)
C       udBt1g2WmU = qqpD0g2WbU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp
      udBt1g2WmU = udB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp

      return
      end

      function qbqpBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqpBt1g2WmU = qbqpBt1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbqpbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqpbBt1g2WmU = qbqpbBt1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqpBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqpBt1g2WmU = qqpBt1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqpbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqpbBt1g2WmU = qqpbBt1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function ggBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      ggBt1g2WmU = ggBt1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function dbgBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      fac = subfac(-1d0)

C IM: renamed (used Wp as source for ordering)
C       dbgBt1g2WmU = -1d0*qbgD0g2WaU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      dbgBt1g2WmU = -1d0*ubgBt1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      fac = subfac(1d0)

      return
      end

      function gdbBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      fac = subfac(-1d0)

C IM: renamed (used Wp as source for ordering)
C       gdbBt1g2WmU = -1d0*qbgD0g2WaU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)
      gdbBt1g2WmU = -1d0*ubgBt1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)

      fac = subfac(1d0)


      return
      end

      function ugBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      fac = subfac(-1d0)

C IM: renamed (used Wp as source for ordering)
C       ugBt1g2WmU = -1d0*qpgD0g2WbU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      ugBt1g2WmU = -1d0*dgBt1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      fac = subfac(1d0)

      return
      end


      function guBt1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      fac = subfac(-1d0)

C IM: renamed (used Wp as source for ordering)
C       guBt1g2WmU = -1d0*qpgD0g2WbU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)
      guBt1g2WmU = -1d0*dgBt1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)

      fac = subfac(1d0)

      return
      end
