c    D0g0WaSNLO and D0g0WbSNLO contain different flavour structures for the D0g0W matrix
c    elements. The different structures mean that makeproc generates different
c    autoD0g0Wa/b files for Wp and Wm processes. As Wm is the charge conjugate of Wp,
c    all of the D0g0Wa for Wp are present in D0g0Wb for Wm processes and vice versa, but
c    there are no duplicates.
c    As a result, there are functions from autoD0g0WbSNLO.f (Wp run) and
c    autoD0g0WbSNLO.f  (Wm run) in this file - it does not correspond to a single
c    autoD0g0WbS.f file

      function qpbqD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qpbqD0g0WbSNLO = 0d0

      return
      end

      function qpbqpD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qpbqpD0g0WbSNLO = 0d0

      return
      end

      function qpbqpbD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qpbqpbD0g0WbSNLO = 0d0

      return
      end

      function qpqD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qpqD0g0WbSNLO = 0d0

      return
      end

      function qpqpbD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qpqpbD0g0WbSNLO = 0d0

      return
      end

      function qqpD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qqpD0g0WbSNLO = 0d0

      return
      end

      function qqpbD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qqpbD0g0WbSNLO = 0d0

      return
      end

      function qbqpD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qbqpD0g0WbSNLO = 0d0

      return
      end

      function qpqbD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qpqbD0g0WbSNLO = 0d0

      return
      end

      function qqbD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qqbD0g0WbSNLO = 0d0

      return
      end

      function qbqD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qbqD0g0WbSNLO = 0d0

      return
      end

      function qbqbD0g0WbSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)

      qbqbD0g0WbSNLO = 0d0

      return
      end
