      subroutine selectchannelWpJJ()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*alphas_scl)*(4d0*pi*amzw/stw)**2*(nc**2-1)*nc*(4d0*pi*alphas_scl)
      n_alphas_proc = 2
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelWpJJ: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelWpJJ: already allocated'  
        stop
      end if

      ntot_chan = 357

      allocate(qactive_chan(1:357))
      allocate(contrib_chan(1:357))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! u g to g d nu lp      B2g0W(1,2,3,4,5,6)    
c      qactive_chan(2)  = .true.   ! u db to g g nu lp     B2g0W(1,3,4,2,5,6)    
c      qactive_chan(3)  = .true.   ! g u to g d nu lp      B2g0W(2,1,3,4,5,6)    
c      qactive_chan(4)  = .true.   ! db u to g g nu lp     B2g0W(2,3,4,1,5,6)    
c      qactive_chan(5)  = .true.   ! g g to ub d nu lp     B2g0W(3,1,2,4,5,6)    
c      qactive_chan(6)  = .true.   ! g db to ub g nu lp    B2g0W(3,1,4,2,5,6)    
c      qactive_chan(7)  = .true.   ! db g to ub g nu lp    B2g0W(3,2,4,1,5,6)    
c      qactive_chan(8)  = .true.   ! u gt to gt d nu lp    Bt2g0W(1,2,3,4,5,6)   
c      qactive_chan(9)  = .true.   ! u db to gt gt nu lp   Bt2g0W(1,3,4,2,5,6)   
c      qactive_chan(10) = .true.   ! gt u to gt d nu lp    Bt2g0W(2,1,3,4,5,6)   
c      qactive_chan(11) = .true.   ! db u to gt gt nu lp   Bt2g0W(2,3,4,1,5,6)   
c      qactive_chan(12) = .true.   ! gt gt to ub d nu lp   Bt2g0W(3,1,2,4,5,6)   
c      qactive_chan(13) = .true.   ! gt db to ub gt nu lp   Bt2g0W(3,1,4,2,5,6)   
c      qactive_chan(14) = .true.   ! db gt to ub gt nu lp   Bt2g0W(3,2,4,1,5,6)   
c      qactive_chan(15) = .true.   ! u Qb to Qb d nu lp    C0g0W(1,2,3,4,5,6)    
c      qactive_chan(16) = .true.   ! u Q to Q d nu lp      C0g0W(1,3,2,4,5,6)    
c      qactive_chan(17) = .true.   ! u db to Q Qb nu lp    C0g0W(1,3,4,2,5,6)    
c      qactive_chan(18) = .true.   ! Qb u to Qb d nu lp    C0g0W(2,1,3,4,5,6)    
c      qactive_chan(19) = .true.   ! Q u to Q d nu lp      C0g0W(2,3,1,4,5,6)    
c      qactive_chan(20) = .true.   ! db u to Q Qb nu lp    C0g0W(2,3,4,1,5,6)    
c      qactive_chan(21) = .true.   ! Qb Q to ub d nu lp    C0g0W(3,1,2,4,5,6)    
c      qactive_chan(22) = .true.   ! Qb db to ub Qb nu lp   C0g0W(3,1,4,2,5,6)    
c      qactive_chan(23) = .true.   ! Q Qb to ub d nu lp    C0g0W(3,2,1,4,5,6)    
c      qactive_chan(24) = .true.   ! db Qb to ub Qb nu lp   C0g0W(3,2,4,1,5,6)    
c      qactive_chan(25) = .true.   ! Q db to ub Q nu lp    C0g0W(3,4,1,2,5,6)    
c      qactive_chan(26) = .true.   ! db Q to ub Q nu lp    C0g0W(3,4,2,1,5,6)    
c      qactive_chan(27) = .true.   ! u ub to ub d nu lp    D0g0Wa(1,2,3,4,5,6)   
c      qactive_chan(28) = .true.   ! u u to u d nu lp      D0g0Wa(1,3,2,4,5,6)   
c      qactive_chan(29) = .true.   ! u db to u ub nu lp    D0g0Wa(1,3,4,2,5,6)   
c      qactive_chan(30) = .true.   ! ub u to ub d nu lp    D0g0Wa(2,1,3,4,5,6)   
c      qactive_chan(31) = .true.   ! db u to u ub nu lp    D0g0Wa(2,3,4,1,5,6)   
c      qactive_chan(32) = .true.   ! ub db to ub ub nu lp   D0g0Wa(3,1,4,2,5,6)   
c      qactive_chan(33) = .true.   ! db ub to ub ub nu lp   D0g0Wa(3,2,4,1,5,6)   
c      qactive_chan(34) = .true.   ! u db to db d nu lp    D0g0Wb(1,2,3,4,5,6)   
c      qactive_chan(35) = .true.   ! u d to d d nu lp      D0g0Wb(1,3,2,4,5,6)   
c      qactive_chan(36) = .true.   ! db u to db d nu lp    D0g0Wb(2,1,3,4,5,6)   
c      qactive_chan(37) = .true.   ! d u to d d nu lp      D0g0Wb(2,3,1,4,5,6)   
c      qactive_chan(38) = .true.   ! db d to ub d nu lp    D0g0Wb(3,1,2,4,5,6)   
c      qactive_chan(39) = .true.   ! db db to ub db nu lp   D0g0Wb(3,1,4,2,5,6)   
c      qactive_chan(40) = .true.   ! d db to ub d nu lp    D0g0Wb(3,2,1,4,5,6)   

      do i=1,40
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c      qactive_chan(41) = .true.   ! u g to g g d nu lp    sB3g0W(1,2,3,4,5,6,7)  qgsB3g0WSNLO(1,2,3,4,5,6,7)
c      qactive_chan(42) = .true.   ! u db to g g g nu lp   sB3g0W(1,3,4,5,2,6,7)  qqbsB3g0WSNLO(1,3,4,5,2,6,7)
c      qactive_chan(43) = .true.   ! g u to g g d nu lp    sB3g0W(2,1,3,4,5,6,7)  gqsB3g0WSNLO(2,1,3,4,5,6,7)
c      qactive_chan(44) = .true.   ! db u to g g g nu lp   sB3g0W(2,3,4,5,1,6,7)  qbqsB3g0WSNLO(2,3,4,5,1,6,7)
c      qactive_chan(45) = .true.   ! g g to ub g d nu lp   sB3g0W(3,1,2,4,5,6,7)  ggsB3g0WSNLO(3,1,2,4,5,6,7)
c      qactive_chan(46) = .true.   ! g db to ub g g nu lp   sB3g0W(3,1,4,5,2,6,7)  gqbsB3g0WSNLO(3,1,4,5,2,6,7)
c      qactive_chan(47) = .true.   ! db g to ub g g nu lp   sB3g0W(3,2,4,5,1,6,7)  qbgsB3g0WSNLO(3,2,4,5,1,6,7)
c      qactive_chan(48) = .true.   ! u g to g g d nu lp    sBt3g0W(1,2,3,4,5,6,7)  qgsBt3g0WSNLO(1,2,3,4,5,6,7)
c      qactive_chan(49) = .true.   ! u db to g g g nu lp   sBt3g0W(1,3,4,5,2,6,7)  qqbsBt3g0WSNLO(1,3,4,5,2,6,7)
c      qactive_chan(50) = .true.   ! g u to g g d nu lp    sBt3g0W(2,1,3,4,5,6,7)  gqsBt3g0WSNLO(2,1,3,4,5,6,7)
c      qactive_chan(51) = .true.   ! db u to g g g nu lp   sBt3g0W(2,3,4,5,1,6,7)  qbqsBt3g0WSNLO(2,3,4,5,1,6,7)
c      qactive_chan(52) = .true.   ! g g to ub g d nu lp   sBt3g0W(3,1,2,4,5,6,7)  ggsBt3g0WSNLO(3,1,2,4,5,6,7)
c      qactive_chan(53) = .true.   ! g db to ub g g nu lp   sBt3g0W(3,1,4,5,2,6,7)  gqbsBt3g0WSNLO(3,1,4,5,2,6,7)
c      qactive_chan(54) = .true.   ! db g to ub g g nu lp   sBt3g0W(3,2,4,5,1,6,7)  qbgsBt3g0WSNLO(3,2,4,5,1,6,7)
c      qactive_chan(55) = .true.   ! u gt to gt gt d nu lp   sBtt3g0W(1,2,3,4,5,6,7)  qgtsBtt3g0WSNLO(1,2,3,4,5,6,7)
c      qactive_chan(56) = .true.   ! u db to gt gt gt nu lp   sBtt3g0W(1,3,4,5,2,6,7)  qqbsBtt3g0WSNLO(1,3,4,5,2,6,7)
c      qactive_chan(57) = .true.   ! gt u to gt gt d nu lp   sBtt3g0W(2,1,3,4,5,6,7)  gtqsBtt3g0WSNLO(2,1,3,4,5,6,7)
c      qactive_chan(58) = .true.   ! db u to gt gt gt nu lp   sBtt3g0W(2,3,4,5,1,6,7)  qbqsBtt3g0WSNLO(2,3,4,5,1,6,7)
c      qactive_chan(59) = .true.   ! gt gt to ub gt d nu lp   sBtt3g0W(3,1,2,4,5,6,7)  gtgtsBtt3g0WSNLO(3,1,2,4,5,6,7)
c      qactive_chan(60) = .true.   ! gt db to ub gt gt nu lp   sBtt3g0W(3,1,4,5,2,6,7)  gtqbsBtt3g0WSNLO(3,1,4,5,2,6,7)
c      qactive_chan(61) = .true.   ! db gt to ub gt gt nu lp   sBtt3g0W(3,2,4,5,1,6,7)  qbgtsBtt3g0WSNLO(3,2,4,5,1,6,7)
c      qactive_chan(62) = .true.   ! u g to Q Qb d nu lp   sC1g0W(1,2,3,4,5,6,7)  qgsC1g0WSNLO(1,2,3,4,5,6,7)
c      qactive_chan(63) = .true.   ! u Qb to g Qb d nu lp   sC1g0W(1,3,2,4,5,6,7)  qqpbsC1g0WSNLO(1,3,2,4,5,6,7)
c      qactive_chan(64) = .true.   ! u Q to g Q d nu lp    sC1g0W(1,3,4,2,5,6,7)  qqpsC1g0WSNLO(1,3,4,2,5,6,7)
c      qactive_chan(65) = .true.   ! u db to g Q Qb nu lp   sC1g0W(1,3,4,5,2,6,7)  qqbsC1g0WSNLO(1,3,4,5,2,6,7)
c      qactive_chan(66) = .true.   ! g u to Q Qb d nu lp   sC1g0W(2,1,3,4,5,6,7)  gqsC1g0WSNLO(2,1,3,4,5,6,7)
c      qactive_chan(67) = .true.   ! Qb u to g Qb d nu lp   sC1g0W(2,3,1,4,5,6,7)  qpbqsC1g0WSNLO(2,3,1,4,5,6,7)
c      qactive_chan(68) = .true.   ! Q u to g Q d nu lp    sC1g0W(2,3,4,1,5,6,7)  qpqsC1g0WSNLO(2,3,4,1,5,6,7)
c      qactive_chan(69) = .true.   ! db u to g Q Qb nu lp   sC1g0W(2,3,4,5,1,6,7)  qbqsC1g0WSNLO(2,3,4,5,1,6,7)
c      qactive_chan(70) = .true.   ! g Qb to ub Qb d nu lp   sC1g0W(3,1,2,4,5,6,7)  gqpbsC1g0WSNLO(3,1,2,4,5,6,7)
c      qactive_chan(71) = .true.   ! g Q to ub Q d nu lp   sC1g0W(3,1,4,2,5,6,7)  gqpsC1g0WSNLO(3,1,4,2,5,6,7)
c      qactive_chan(72) = .true.   ! g db to ub Q Qb nu lp   sC1g0W(3,1,4,5,2,6,7)  gqbsC1g0WSNLO(3,1,4,5,2,6,7)
c      qactive_chan(73) = .true.   ! Qb g to ub Qb d nu lp   sC1g0W(3,2,1,4,5,6,7)  qpbgsC1g0WSNLO(3,2,1,4,5,6,7)
c      qactive_chan(74) = .true.   ! Q g to ub Q d nu lp   sC1g0W(3,2,4,1,5,6,7)  qpgsC1g0WSNLO(3,2,4,1,5,6,7)
c      qactive_chan(75) = .true.   ! db g to ub Q Qb nu lp   sC1g0W(3,2,4,5,1,6,7)  qbgsC1g0WSNLO(3,2,4,5,1,6,7)
c      qactive_chan(76) = .true.   ! Qb Q to ub g d nu lp   sC1g0W(3,4,1,2,5,6,7)  qpbqpsC1g0WSNLO(3,4,1,2,5,6,7)
c      qactive_chan(77) = .true.   ! Qb db to ub g Qb nu lp   sC1g0W(3,4,1,5,2,6,7)  qpbqbsC1g0WSNLO(3,4,1,5,2,6,7)
c      qactive_chan(78) = .true.   ! Q Qb to ub g d nu lp   sC1g0W(3,4,2,1,5,6,7)  qpqpbsC1g0WSNLO(3,4,2,1,5,6,7)
c      qactive_chan(79) = .true.   ! db Qb to ub g Qb nu lp   sC1g0W(3,4,2,5,1,6,7)  qbqpbsC1g0WSNLO(3,4,2,5,1,6,7)
c      qactive_chan(80) = .true.   ! Q db to ub g Q nu lp   sC1g0W(3,4,5,1,2,6,7)  qpqbsC1g0WSNLO(3,4,5,1,2,6,7)
c      qactive_chan(81) = .true.   ! db Q to ub g Q nu lp   sC1g0W(3,4,5,2,1,6,7)  qbqpsC1g0WSNLO(3,4,5,2,1,6,7)
c      qactive_chan(82) = .true.   ! u g to Q Qb d nu lp   sCt1g0W(1,2,3,4,5,6,7)  qgsCt1g0WSNLO(1,2,3,4,5,6,7)
c      qactive_chan(83) = .true.   ! u Qb to g Qb d nu lp   sCt1g0W(1,3,2,4,5,6,7)  qqpbsCt1g0WSNLO(1,3,2,4,5,6,7)
c      qactive_chan(84) = .true.   ! u Q to g Q d nu lp    sCt1g0W(1,3,4,2,5,6,7)  qqpsCt1g0WSNLO(1,3,4,2,5,6,7)
c      qactive_chan(85) = .true.   ! u db to g Q Qb nu lp   sCt1g0W(1,3,4,5,2,6,7)  qqbsCt1g0WSNLO(1,3,4,5,2,6,7)
c      qactive_chan(86) = .true.   ! g u to Q Qb d nu lp   sCt1g0W(2,1,3,4,5,6,7)  gqsCt1g0WSNLO(2,1,3,4,5,6,7)
c      qactive_chan(87) = .true.   ! Qb u to g Qb d nu lp   sCt1g0W(2,3,1,4,5,6,7)  qpbqsCt1g0WSNLO(2,3,1,4,5,6,7)
c      qactive_chan(88) = .true.   ! Q u to g Q d nu lp    sCt1g0W(2,3,4,1,5,6,7)  qpqsCt1g0WSNLO(2,3,4,1,5,6,7)
c      qactive_chan(89) = .true.   ! db u to g Q Qb nu lp   sCt1g0W(2,3,4,5,1,6,7)  qbqsCt1g0WSNLO(2,3,4,5,1,6,7)
c      qactive_chan(90) = .true.   ! g Qb to ub Qb d nu lp   sCt1g0W(3,1,2,4,5,6,7)  gqpbsCt1g0WSNLO(3,1,2,4,5,6,7)
c      qactive_chan(91) = .true.   ! g Q to ub Q d nu lp   sCt1g0W(3,1,4,2,5,6,7)  gqpsCt1g0WSNLO(3,1,4,2,5,6,7)
c      qactive_chan(92) = .true.   ! g db to ub Q Qb nu lp   sCt1g0W(3,1,4,5,2,6,7)  gqbsCt1g0WSNLO(3,1,4,5,2,6,7)
c      qactive_chan(93) = .true.   ! Qb g to ub Qb d nu lp   sCt1g0W(3,2,1,4,5,6,7)  qpbgsCt1g0WSNLO(3,2,1,4,5,6,7)
c      qactive_chan(94) = .true.   ! Q g to ub Q d nu lp   sCt1g0W(3,2,4,1,5,6,7)  qpgsCt1g0WSNLO(3,2,4,1,5,6,7)
c      qactive_chan(95) = .true.   ! db g to ub Q Qb nu lp   sCt1g0W(3,2,4,5,1,6,7)  qbgsCt1g0WSNLO(3,2,4,5,1,6,7)
c      qactive_chan(96) = .true.   ! Qb Q to ub g d nu lp   sCt1g0W(3,4,1,2,5,6,7)  qpbqpsCt1g0WSNLO(3,4,1,2,5,6,7)
c      qactive_chan(97) = .true.   ! Qb db to ub g Qb nu lp   sCt1g0W(3,4,1,5,2,6,7)  qpbqbsCt1g0WSNLO(3,4,1,5,2,6,7)
c      qactive_chan(98) = .true.   ! Q Qb to ub g d nu lp   sCt1g0W(3,4,2,1,5,6,7)  qpqpbsCt1g0WSNLO(3,4,2,1,5,6,7)
c      qactive_chan(99) = .true.   ! db Qb to ub g Qb nu lp   sCt1g0W(3,4,2,5,1,6,7)  qbqpbsCt1g0WSNLO(3,4,2,5,1,6,7)
c      qactive_chan(100)= .true.   ! Q db to ub g Q nu lp   sCt1g0W(3,4,5,1,2,6,7)  qpqbsCt1g0WSNLO(3,4,5,1,2,6,7)
c      qactive_chan(101)= .true.   ! db Q to ub g Q nu lp   sCt1g0W(3,4,5,2,1,6,7)  qbqpsCt1g0WSNLO(3,4,5,2,1,6,7)
c      qactive_chan(102)= .true.   ! u g to u ub d nu lp   D1g0Wpac(1,2,3,4,5,6,7)  qgD1g0WpacSNLO(1,2,3,4,5,6,7)
c      qactive_chan(103)= .true.   ! u ub to g ub d nu lp   D1g0Wpac(1,3,2,4,5,6,7)  qqbD1g0WpacSNLO(1,3,2,4,5,6,7)
c      qactive_chan(104)= .true.   ! u u to g u d nu lp    D1g0Wpac(1,3,4,2,5,6,7)  qqD1g0WpacSNLO(1,3,4,2,5,6,7)
c      qactive_chan(105)= .true.   ! u db to g u ub nu lp   D1g0Wpac(1,3,4,5,2,6,7)  qqpbD1g0WpacSNLO(1,3,4,5,2,6,7)
c      qactive_chan(106)= .true.   ! g u to u ub d nu lp   D1g0Wpac(2,1,3,4,5,6,7)  gqD1g0WpacSNLO(2,1,3,4,5,6,7)
c      qactive_chan(107)= .true.   ! ub u to g ub d nu lp   D1g0Wpac(2,3,1,4,5,6,7)  qbqD1g0WpacSNLO(2,3,1,4,5,6,7)
c      qactive_chan(108)= .true.   ! db u to g u ub nu lp   D1g0Wpac(2,3,4,5,1,6,7)  qpbqD1g0WpacSNLO(2,3,4,5,1,6,7)
c      qactive_chan(109)= .true.   ! g ub to ub ub d nu lp   D1g0Wpac(3,1,2,4,5,6,7)  gqbD1g0WpacSNLO(3,1,2,4,5,6,7)
c      qactive_chan(110)= .true.   ! g db to ub u ub nu lp   D1g0Wpac(3,1,4,5,2,6,7)  gqpbD1g0WpacSNLO(3,1,4,5,2,6,7)
c      qactive_chan(111)= .true.   ! ub g to ub ub d nu lp   D1g0Wpac(3,2,1,4,5,6,7)  qbgD1g0WpacSNLO(3,2,1,4,5,6,7)
c      qactive_chan(112)= .true.   ! db g to ub u ub nu lp   D1g0Wpac(3,2,4,5,1,6,7)  qpbgD1g0WpacSNLO(3,2,4,5,1,6,7)
c      qactive_chan(113)= .true.   ! ub db to ub g ub nu lp   D1g0Wpac(3,4,1,5,2,6,7)  qbqpbD1g0WpacSNLO(3,4,1,5,2,6,7)
c      qactive_chan(114)= .true.   ! db ub to ub g ub nu lp   D1g0Wpac(3,4,2,5,1,6,7)  qpbqbD1g0WpacSNLO(3,4,2,5,1,6,7)
c      qactive_chan(115)= .true.   ! u g to d db d nu lp   D1g0Wpbc(1,2,3,4,5,6,7)  qgD1g0WpbcSNLO(1,2,3,4,5,6,7)
c      qactive_chan(116)= .true.   ! u db to g db d nu lp   D1g0Wpbc(1,3,2,4,5,6,7)  qqpbD1g0WpbcSNLO(1,3,2,4,5,6,7)
c      qactive_chan(117)= .true.   ! u d to g d d nu lp    D1g0Wpbc(1,3,4,2,5,6,7)  qqpD1g0WpbcSNLO(1,3,4,2,5,6,7)
c      qactive_chan(118)= .true.   ! g u to d db d nu lp   D1g0Wpbc(2,1,3,4,5,6,7)  gqD1g0WpbcSNLO(2,1,3,4,5,6,7)
c      qactive_chan(119)= .true.   ! db u to g db d nu lp   D1g0Wpbc(2,3,1,4,5,6,7)  qpbqD1g0WpbcSNLO(2,3,1,4,5,6,7)
c      qactive_chan(120)= .true.   ! d u to g d d nu lp    D1g0Wpbc(2,3,4,1,5,6,7)  qpqD1g0WpbcSNLO(2,3,4,1,5,6,7)
c      qactive_chan(121)= .true.   ! g db to ub db d nu lp   D1g0Wpbc(3,1,2,4,5,6,7)  gqpbD1g0WpbcSNLO(3,1,2,4,5,6,7)
c      qactive_chan(122)= .true.   ! g d to ub d d nu lp   D1g0Wpbc(3,1,4,2,5,6,7)  gqpD1g0WpbcSNLO(3,1,4,2,5,6,7)
c      qactive_chan(123)= .true.   ! db g to ub db d nu lp   D1g0Wpbc(3,2,1,4,5,6,7)  qpbgD1g0WpbcSNLO(3,2,1,4,5,6,7)
c      qactive_chan(124)= .true.   ! d g to ub d d nu lp   D1g0Wpbc(3,2,4,1,5,6,7)  qpgD1g0WpbcSNLO(3,2,4,1,5,6,7)
c      qactive_chan(125)= .true.   ! db d to ub g d nu lp   D1g0Wpbc(3,4,1,2,5,6,7)  qpbqpD1g0WpbcSNLO(3,4,1,2,5,6,7)
c      qactive_chan(126)= .true.   ! db db to ub g db nu lp   D1g0Wpbc(3,4,1,5,2,6,7)  qpbqpbD1g0WpbcSNLO(3,4,1,5,2,6,7)
c      qactive_chan(127)= .true.   ! d db to ub g d nu lp   D1g0Wpbc(3,4,2,1,5,6,7)  qpqpbD1g0WpbcSNLO(3,4,2,1,5,6,7)
c      qactive_chan(128)= .true.   ! u g to u ub d nu lp   Dt1g0Wpa(1,2,3,4,5,6,7)  qgDt1g0WpaSNLO(1,2,3,4,5,6,7)
c      qactive_chan(129)= .true.   ! u ub to g ub d nu lp   Dt1g0Wpa(1,3,2,4,5,6,7)  qqbDt1g0WpaSNLO(1,3,2,4,5,6,7)
c      qactive_chan(130)= .true.   ! u u to g u d nu lp    Dt1g0Wpa(1,3,4,2,5,6,7)  qqDt1g0WpaSNLO(1,3,4,2,5,6,7)
c      qactive_chan(131)= .true.   ! u db to g u ub nu lp   Dt1g0Wpa(1,3,4,5,2,6,7)  qqpbDt1g0WpaSNLO(1,3,4,5,2,6,7)
c      qactive_chan(132)= .true.   ! g u to u ub d nu lp   Dt1g0Wpa(2,1,3,4,5,6,7)  gqDt1g0WpaSNLO(2,1,3,4,5,6,7)
c      qactive_chan(133)= .true.   ! ub u to g ub d nu lp   Dt1g0Wpa(2,3,1,4,5,6,7)  qbqDt1g0WpaSNLO(2,3,1,4,5,6,7)
c      qactive_chan(134)= .true.   ! db u to g u ub nu lp   Dt1g0Wpa(2,3,4,5,1,6,7)  qpbqDt1g0WpaSNLO(2,3,4,5,1,6,7)
c      qactive_chan(135)= .true.   ! g ub to ub ub d nu lp   Dt1g0Wpa(3,1,2,4,5,6,7)  gqbDt1g0WpaSNLO(3,1,2,4,5,6,7)
c      qactive_chan(136)= .true.   ! g db to ub u ub nu lp   Dt1g0Wpa(3,1,4,5,2,6,7)  gqpbDt1g0WpaSNLO(3,1,4,5,2,6,7)
c      qactive_chan(137)= .true.   ! ub g to ub ub d nu lp   Dt1g0Wpa(3,2,1,4,5,6,7)  qbgDt1g0WpaSNLO(3,2,1,4,5,6,7)
c      qactive_chan(138)= .true.   ! db g to ub u ub nu lp   Dt1g0Wpa(3,2,4,5,1,6,7)  qpbgDt1g0WpaSNLO(3,2,4,5,1,6,7)
c      qactive_chan(139)= .true.   ! ub db to ub g ub nu lp   Dt1g0Wpa(3,4,1,5,2,6,7)  qbqpbDt1g0WpaSNLO(3,4,1,5,2,6,7)
c      qactive_chan(140)= .true.   ! db ub to ub g ub nu lp   Dt1g0Wpa(3,4,2,5,1,6,7)  qpbqbDt1g0WpaSNLO(3,4,2,5,1,6,7)
c      qactive_chan(141)= .true.   ! u g to d db d nu lp   Dt1g0Wpb(1,2,3,4,5,6,7)  qgDt1g0WpbSNLO(1,2,3,4,5,6,7)
c      qactive_chan(142)= .true.   ! u db to g db d nu lp   Dt1g0Wpb(1,3,2,4,5,6,7)  qqpbDt1g0WpbSNLO(1,3,2,4,5,6,7)
c      qactive_chan(143)= .true.   ! u d to g d d nu lp    Dt1g0Wpb(1,3,4,2,5,6,7)  qqpDt1g0WpbSNLO(1,3,4,2,5,6,7)
c      qactive_chan(144)= .true.   ! g u to d db d nu lp   Dt1g0Wpb(2,1,3,4,5,6,7)  gqDt1g0WpbSNLO(2,1,3,4,5,6,7)
c      qactive_chan(145)= .true.   ! db u to g db d nu lp   Dt1g0Wpb(2,3,1,4,5,6,7)  qpbqDt1g0WpbSNLO(2,3,1,4,5,6,7)
c      qactive_chan(146)= .true.   ! d u to g d d nu lp    Dt1g0Wpb(2,3,4,1,5,6,7)  qpqDt1g0WpbSNLO(2,3,4,1,5,6,7)
c      qactive_chan(147)= .true.   ! g db to ub db d nu lp   Dt1g0Wpb(3,1,2,4,5,6,7)  gqpbDt1g0WpbSNLO(3,1,2,4,5,6,7)
c      qactive_chan(148)= .true.   ! g d to ub d d nu lp   Dt1g0Wpb(3,1,4,2,5,6,7)  gqpDt1g0WpbSNLO(3,1,4,2,5,6,7)
c      qactive_chan(149)= .true.   ! db g to ub db d nu lp   Dt1g0Wpb(3,2,1,4,5,6,7)  qpbgDt1g0WpbSNLO(3,2,1,4,5,6,7)
c      qactive_chan(150)= .true.   ! d g to ub d d nu lp   Dt1g0Wpb(3,2,4,1,5,6,7)  qpgDt1g0WpbSNLO(3,2,4,1,5,6,7)
c      qactive_chan(151)= .true.   ! db d to ub g d nu lp   Dt1g0Wpb(3,4,1,2,5,6,7)  qpbqpDt1g0WpbSNLO(3,4,1,2,5,6,7)
c      qactive_chan(152)= .true.   ! db db to ub g db nu lp   Dt1g0Wpb(3,4,1,5,2,6,7)  qpbqpbDt1g0WpbSNLO(3,4,1,5,2,6,7)
c      qactive_chan(153)= .true.   ! d db to ub g d nu lp   Dt1g0Wpb(3,4,2,1,5,6,7)  qpqpbDt1g0WpbSNLO(3,4,2,1,5,6,7)

      do i=41,153
        contrib_chan(i)=2
      enddo

c -- virtual                                      ME                   TNLO  

c      qactive_chan(154)= .true.   ! u g to g d nu lp      sB2g1W(1,2,3,4,5,6)   qgsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(155)= .true.   ! u db to g g nu lp     sB2g1W(1,3,4,2,5,6)   qqbsB2g1WTNLO(1,3,4,2,5,6)
c      qactive_chan(156)= .true.   ! g u to g d nu lp      sB2g1W(2,1,3,4,5,6)   gqsB2g1WTNLO(2,1,3,4,5,6)
c      qactive_chan(157)= .true.   ! db u to g g nu lp     sB2g1W(2,3,4,1,5,6)   qbqsB2g1WTNLO(2,3,4,1,5,6)
c      qactive_chan(158)= .true.   ! g g to ub d nu lp     sB2g1W(3,1,2,4,5,6)   ggsB2g1WTNLO(3,1,2,4,5,6)
c      qactive_chan(159)= .true.   ! g db to ub g nu lp    sB2g1W(3,1,4,2,5,6)   gqbsB2g1WTNLO(3,1,4,2,5,6)
c      qactive_chan(160)= .true.   ! db g to ub g nu lp    sB2g1W(3,2,4,1,5,6)   qbgsB2g1WTNLO(3,2,4,1,5,6)
c      qactive_chan(161)= .true.   ! Q u subtraction                             qpqsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(162)= .true.   ! Q db subtraction                            qpqbsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(163)= .true.   ! Qb u subtraction                            qpbqsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(164)= .true.   ! Qb db subtraction                           qpbqbsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(165)= .true.   ! u Q subtraction                             qqpsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(166)= .true.   ! u Qb subtraction                            qqpbsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(167)= .true.   ! db Q subtraction                            qbqpsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(168)= .true.   ! db Qb subtraction                           qbqpbsB2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(169)= .true.   ! u g to g d nu lp      sBt2g1W(1,2,3,4,5,6)  qgsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(170)= .true.   ! u db to g g nu lp     sBt2g1W(1,3,4,2,5,6)  qqbsBt2g1WTNLO(1,3,4,2,5,6)
c      qactive_chan(171)= .true.   ! g u to g d nu lp      sBt2g1W(2,1,3,4,5,6)  gqsBt2g1WTNLO(2,1,3,4,5,6)
c      qactive_chan(172)= .true.   ! db u to g g nu lp     sBt2g1W(2,3,4,1,5,6)  qbqsBt2g1WTNLO(2,3,4,1,5,6)
c      qactive_chan(173)= .true.   ! g g to ub d nu lp     sBt2g1W(3,1,2,4,5,6)  ggsBt2g1WTNLO(3,1,2,4,5,6)
c      qactive_chan(174)= .true.   ! g db to ub g nu lp    sBt2g1W(3,1,4,2,5,6)  gqbsBt2g1WTNLO(3,1,4,2,5,6)
c      qactive_chan(175)= .true.   ! db g to ub g nu lp    sBt2g1W(3,2,4,1,5,6)  qbgsBt2g1WTNLO(3,2,4,1,5,6)
c      qactive_chan(176)= .true.   ! Q u subtraction                             qpqsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(177)= .true.   ! Q db subtraction                            qpqbsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(178)= .true.   ! Qb u subtraction                            qpbqsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(179)= .true.   ! Qb db subtraction                           qpbqbsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(180)= .true.   ! u Q subtraction                             qqpsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(181)= .true.   ! u Qb subtraction                            qqpbsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(182)= .true.   ! db Q subtraction                            qbqpsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(183)= .true.   ! db Qb subtraction                           qbqpbsBt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(184)= .true.   ! u gt to gt d nu lp    sBtt2g1Wc(1,2,3,4,5,6)  qgtsBtt2g1WcTNLO(1,2,3,4,5,6)
c      qactive_chan(185)= .true.   ! u db to gt gt nu lp   sBtt2g1Wc(1,3,4,2,5,6)  qqbsBtt2g1WcTNLO(1,3,4,2,5,6)
c      qactive_chan(186)= .true.   ! gt u to gt d nu lp    sBtt2g1Wc(2,1,3,4,5,6)  gtqsBtt2g1WcTNLO(2,1,3,4,5,6)
c      qactive_chan(187)= .true.   ! db u to gt gt nu lp   sBtt2g1Wc(2,3,4,1,5,6)  qbqsBtt2g1WcTNLO(2,3,4,1,5,6)
c      qactive_chan(188)= .true.   ! gt gt to ub d nu lp   sBtt2g1Wc(3,1,2,4,5,6)  gtgtsBtt2g1WcTNLO(3,1,2,4,5,6)
c      qactive_chan(189)= .true.   ! gt db to ub gt nu lp   sBtt2g1Wc(3,1,4,2,5,6)  gtqbsBtt2g1WcTNLO(3,1,4,2,5,6)
c      qactive_chan(190)= .true.   ! db gt to ub gt nu lp   sBtt2g1Wc(3,2,4,1,5,6)  qbgtsBtt2g1WcTNLO(3,2,4,1,5,6)
c      qactive_chan(191)= .true.   ! u gt to gt d nu lp    sBttt2g1W(1,2,3,4,5,6)  qgtsBttt2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(192)= .true.   ! u db to gt gt nu lp   sBttt2g1W(1,3,4,2,5,6)  qqbsBttt2g1WTNLO(1,3,4,2,5,6)
c      qactive_chan(193)= .true.   ! gt u to gt d nu lp    sBttt2g1W(2,1,3,4,5,6)  gtqsBttt2g1WTNLO(2,1,3,4,5,6)
c      qactive_chan(194)= .true.   ! db u to gt gt nu lp   sBttt2g1W(2,3,4,1,5,6)  qbqsBttt2g1WTNLO(2,3,4,1,5,6)
c      qactive_chan(195)= .true.   ! gt gt to ub d nu lp   sBttt2g1W(3,1,2,4,5,6)  gtgtsBttt2g1WTNLO(3,1,2,4,5,6)
c      qactive_chan(196)= .true.   ! gt db to ub gt nu lp   sBttt2g1W(3,1,4,2,5,6)  gtqbsBttt2g1WTNLO(3,1,4,2,5,6)
c      qactive_chan(197)= .true.   ! db gt to ub gt nu lp   sBttt2g1W(3,2,4,1,5,6)  qbgtsBttt2g1WTNLO(3,2,4,1,5,6)
c      qactive_chan(198)= .true.   ! u g to g d nu lp      sBh2g1W(1,2,3,4,5,6)  qgsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(199)= .true.   ! u db to g g nu lp     sBh2g1W(1,3,4,2,5,6)  qqbsBh2g1WTNLO(1,3,4,2,5,6)
c      qactive_chan(200)= .true.   ! g u to g d nu lp      sBh2g1W(2,1,3,4,5,6)  gqsBh2g1WTNLO(2,1,3,4,5,6)
c      qactive_chan(201)= .true.   ! db u to g g nu lp     sBh2g1W(2,3,4,1,5,6)  qbqsBh2g1WTNLO(2,3,4,1,5,6)
c      qactive_chan(202)= .true.   ! g g to ub d nu lp     sBh2g1W(3,1,2,4,5,6)  ggsBh2g1WTNLO(3,1,2,4,5,6)
c      qactive_chan(203)= .true.   ! g db to ub g nu lp    sBh2g1W(3,1,4,2,5,6)  gqbsBh2g1WTNLO(3,1,4,2,5,6)
c      qactive_chan(204)= .true.   ! db g to ub g nu lp    sBh2g1W(3,2,4,1,5,6)  qbgsBh2g1WTNLO(3,2,4,1,5,6)
c      qactive_chan(205)= .true.   ! Q u subtraction                             qpqsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(206)= .true.   ! Q db subtraction                            qpqbsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(207)= .true.   ! Qb u subtraction                            qpbqsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(208)= .true.   ! Qb db subtraction                           qpbqbsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(209)= .true.   ! u Q subtraction                             qqpsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(210)= .true.   ! u Qb subtraction                            qqpbsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(211)= .true.   ! db Q subtraction                            qbqpsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(212)= .true.   ! db Qb subtraction                           qbqpbsBh2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(213)= .true.   ! u gt to gt d nu lp    sBth2g1W(1,2,3,4,5,6)  qgtsBth2g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(214)= .true.   ! u db to gt gt nu lp   sBth2g1W(1,3,4,2,5,6)  qqbsBth2g1WTNLO(1,3,4,2,5,6)
c      qactive_chan(215)= .true.   ! gt u to gt d nu lp    sBth2g1W(2,1,3,4,5,6)  gtqsBth2g1WTNLO(2,1,3,4,5,6)
c      qactive_chan(216)= .true.   ! db u to gt gt nu lp   sBth2g1W(2,3,4,1,5,6)  qbqsBth2g1WTNLO(2,3,4,1,5,6)
c      qactive_chan(217)= .true.   ! gt gt to ub d nu lp   sBth2g1W(3,1,2,4,5,6)  gtgtsBth2g1WTNLO(3,1,2,4,5,6)
c      qactive_chan(218)= .true.   ! gt db to ub gt nu lp   sBth2g1W(3,1,4,2,5,6)  gtqbsBth2g1WTNLO(3,1,4,2,5,6)
c      qactive_chan(219)= .true.   ! db gt to ub gt nu lp   sBth2g1W(3,2,4,1,5,6)  qbgtsBth2g1WTNLO(3,2,4,1,5,6)
c      qactive_chan(220)= .true.   ! u Qb to Qb d nu lp    sC0g1W(1,2,3,4,5,6)   qqpbsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(221)= .true.   ! u Q to Q d nu lp      sC0g1W(1,3,2,4,5,6)   qqpsC0g1WTNLO(1,3,2,4,5,6)
c      qactive_chan(222)= .true.   ! u db to Q Qb nu lp    sC0g1W(1,3,4,2,5,6)   qqbsC0g1WTNLO(1,3,4,2,5,6)
c      qactive_chan(223)= .true.   ! Qb u to Qb d nu lp    sC0g1W(2,1,3,4,5,6)   qpbqsC0g1WTNLO(2,1,3,4,5,6)
c      qactive_chan(224)= .true.   ! Q u to Q d nu lp      sC0g1W(2,3,1,4,5,6)   qpqsC0g1WTNLO(2,3,1,4,5,6)
c      qactive_chan(225)= .true.   ! db u to Q Qb nu lp    sC0g1W(2,3,4,1,5,6)   qbqsC0g1WTNLO(2,3,4,1,5,6)
c      qactive_chan(226)= .true.   ! Qb Q to ub d nu lp    sC0g1W(3,1,2,4,5,6)   qpbqpsC0g1WTNLO(3,1,2,4,5,6)
c      qactive_chan(227)= .true.   ! Qb db to ub Qb nu lp   sC0g1W(3,1,4,2,5,6)   qpbqbsC0g1WTNLO(3,1,4,2,5,6)
c      qactive_chan(228)= .true.   ! Q Qb to ub d nu lp    sC0g1W(3,2,1,4,5,6)   qpqpbsC0g1WTNLO(3,2,1,4,5,6)
c      qactive_chan(229)= .true.   ! db Qb to ub Qb nu lp   sC0g1W(3,2,4,1,5,6)   qbqpbsC0g1WTNLO(3,2,4,1,5,6)
c      qactive_chan(230)= .true.   ! Q db to ub Q nu lp    sC0g1W(3,4,1,2,5,6)   qpqbsC0g1WTNLO(3,4,1,2,5,6)
c      qactive_chan(231)= .true.   ! db Q to ub Q nu lp    sC0g1W(3,4,2,1,5,6)   qbqpsC0g1WTNLO(3,4,2,1,5,6)
c      qactive_chan(232)= .true.   ! Q g subtraction                             qpgsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(233)= .true.   ! Qb g subtraction                            qpbgsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(234)= .true.   ! g Q subtraction                             gqpsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(235)= .true.   ! g Qb subtraction                            gqpbsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(236)= .true.   ! g u subtraction                             gqsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(237)= .true.   ! g db subtraction                            gqbsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(238)= .true.   ! u g subtraction                             qgsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(239)= .true.   ! db g subtraction                            qbgsC0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(240)= .true.   ! u Qb to Qb d nu lp    Ct0g1W(1,2,3,4,5,6)   qqpbCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(241)= .true.   ! u Q to Q d nu lp      Ct0g1W(1,3,2,4,5,6)   qqpCt0g1WTNLO(1,3,2,4,5,6)
c      qactive_chan(242)= .true.   ! u db to Q Qb nu lp    Ct0g1W(1,3,4,2,5,6)   qqbCt0g1WTNLO(1,3,4,2,5,6)
c      qactive_chan(243)= .true.   ! Qb u to Qb d nu lp    Ct0g1W(2,1,3,4,5,6)   qpbqCt0g1WTNLO(2,1,3,4,5,6)
c      qactive_chan(244)= .true.   ! Q u to Q d nu lp      Ct0g1W(2,3,1,4,5,6)   qpqCt0g1WTNLO(2,3,1,4,5,6)
c      qactive_chan(245)= .true.   ! db u to Q Qb nu lp    Ct0g1W(2,3,4,1,5,6)   qbqCt0g1WTNLO(2,3,4,1,5,6)
c      qactive_chan(246)= .true.   ! Qb Q to ub d nu lp    Ct0g1W(3,1,2,4,5,6)   qpbqpCt0g1WTNLO(3,1,2,4,5,6)
c      qactive_chan(247)= .true.   ! Qb db to ub Qb nu lp   Ct0g1W(3,1,4,2,5,6)   qpbqbCt0g1WTNLO(3,1,4,2,5,6)
c      qactive_chan(248)= .true.   ! Q Qb to ub d nu lp    Ct0g1W(3,2,1,4,5,6)   qpqpbCt0g1WTNLO(3,2,1,4,5,6)
c      qactive_chan(249)= .true.   ! db Qb to ub Qb nu lp   Ct0g1W(3,2,4,1,5,6)   qbqpbCt0g1WTNLO(3,2,4,1,5,6)
c      qactive_chan(250)= .true.   ! Q db to ub Q nu lp    Ct0g1W(3,4,1,2,5,6)   qpqbCt0g1WTNLO(3,4,1,2,5,6)
c      qactive_chan(251)= .true.   ! db Q to ub Q nu lp    Ct0g1W(3,4,2,1,5,6)   qbqpCt0g1WTNLO(3,4,2,1,5,6)
c      qactive_chan(252)= .true.   ! Q g subtraction                             qpgCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(253)= .true.   ! Qb g subtraction                            qpbgCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(254)= .true.   ! g Q subtraction                             gqpCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(255)= .true.   ! g Qb subtraction                            gqpbCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(256)= .true.   ! g u subtraction                             gqCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(257)= .true.   ! g db subtraction                            gqbCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(258)= .true.   ! u g subtraction                             qgCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(259)= .true.   ! db g subtraction                            qbgCt0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(260)= .true.   ! u Qb to Qb d nu lp    Ch0g1W(1,2,3,4,5,6)   qqpbCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(261)= .true.   ! u Q to Q d nu lp      Ch0g1W(1,3,2,4,5,6)   qqpCh0g1WTNLO(1,3,2,4,5,6)
c      qactive_chan(262)= .true.   ! u db to Q Qb nu lp    Ch0g1W(1,3,4,2,5,6)   qqbCh0g1WTNLO(1,3,4,2,5,6)
c      qactive_chan(263)= .true.   ! Qb u to Qb d nu lp    Ch0g1W(2,1,3,4,5,6)   qpbqCh0g1WTNLO(2,1,3,4,5,6)
c      qactive_chan(264)= .true.   ! Q u to Q d nu lp      Ch0g1W(2,3,1,4,5,6)   qpqCh0g1WTNLO(2,3,1,4,5,6)
c      qactive_chan(265)= .true.   ! db u to Q Qb nu lp    Ch0g1W(2,3,4,1,5,6)   qbqCh0g1WTNLO(2,3,4,1,5,6)
c      qactive_chan(266)= .true.   ! Qb Q to ub d nu lp    Ch0g1W(3,1,2,4,5,6)   qpbqpCh0g1WTNLO(3,1,2,4,5,6)
c      qactive_chan(267)= .true.   ! Qb db to ub Qb nu lp   Ch0g1W(3,1,4,2,5,6)   qpbqbCh0g1WTNLO(3,1,4,2,5,6)
c      qactive_chan(268)= .true.   ! Q Qb to ub d nu lp    Ch0g1W(3,2,1,4,5,6)   qpqpbCh0g1WTNLO(3,2,1,4,5,6)
c      qactive_chan(269)= .true.   ! db Qb to ub Qb nu lp   Ch0g1W(3,2,4,1,5,6)   qbqpbCh0g1WTNLO(3,2,4,1,5,6)
c      qactive_chan(270)= .true.   ! Q db to ub Q nu lp    Ch0g1W(3,4,1,2,5,6)   qpqbCh0g1WTNLO(3,4,1,2,5,6)
c      qactive_chan(271)= .true.   ! db Q to ub Q nu lp    Ch0g1W(3,4,2,1,5,6)   qbqpCh0g1WTNLO(3,4,2,1,5,6)
c      qactive_chan(272)= .true.   ! Q g subtraction                             qpgCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(273)= .true.   ! Qb g subtraction                            qpbgCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(274)= .true.   ! g Q subtraction                             gqpCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(275)= .true.   ! g Qb subtraction                            gqpbCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(276)= .true.   ! g u subtraction                             gqCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(277)= .true.   ! g db subtraction                            gqbCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(278)= .true.   ! u g subtraction                             qgCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(279)= .true.   ! db g subtraction                            qbgCh0g1WTNLO(1,2,3,4,5,6)
c      qactive_chan(280)= .true.   ! u ub to ub d nu lp    D0g1Wpa(1,2,3,4,5,6)  qqbD0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(281)= .true.   ! u u to u d nu lp      D0g1Wpa(1,3,2,4,5,6)  qqD0g1WpaTNLO(1,3,2,4,5,6)
c      qactive_chan(282)= .true.   ! u db to u ub nu lp    D0g1Wpa(1,3,4,2,5,6)  qqpbD0g1WpaTNLO(1,3,4,2,5,6)
c      qactive_chan(283)= .true.   ! ub u to ub d nu lp    D0g1Wpa(2,1,3,4,5,6)  qbqD0g1WpaTNLO(2,1,3,4,5,6)
c      qactive_chan(284)= .true.   ! db u to u ub nu lp    D0g1Wpa(2,3,4,1,5,6)  qpbqD0g1WpaTNLO(2,3,4,1,5,6)
c      qactive_chan(285)= .true.   ! ub db to ub ub nu lp   D0g1Wpa(3,1,4,2,5,6)  qbqpbD0g1WpaTNLO(3,1,4,2,5,6)
c      qactive_chan(286)= .true.   ! db ub to ub ub nu lp   D0g1Wpa(3,2,4,1,5,6)  qpbqbD0g1WpaTNLO(3,2,4,1,5,6)
c      qactive_chan(287)= .true.   ! d g subtraction                             dgD0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(288)= .true.   ! g d subtraction                             gdD0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(289)= .true.   ! g u subtraction                             guD0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(290)= .true.   ! g ub subtraction                            gubD0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(291)= .true.   ! u g subtraction                             ugD0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(292)= .true.   ! ub g subtraction                            ubgD0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(293)= .true.   ! u db to db d nu lp    D0g1Wpb(1,2,3,4,5,6)  qqpbD0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(294)= .true.   ! u d to d d nu lp      D0g1Wpb(1,3,2,4,5,6)  qqpD0g1WpbTNLO(1,3,2,4,5,6)
c      qactive_chan(295)= .true.   ! db u to db d nu lp    D0g1Wpb(2,1,3,4,5,6)  qpbqD0g1WpbTNLO(2,1,3,4,5,6)
c      qactive_chan(296)= .true.   ! d u to d d nu lp      D0g1Wpb(2,3,1,4,5,6)  qpqD0g1WpbTNLO(2,3,1,4,5,6)
c      qactive_chan(297)= .true.   ! db d to ub d nu lp    D0g1Wpb(3,1,2,4,5,6)  qpbqpD0g1WpbTNLO(3,1,2,4,5,6)
c      qactive_chan(298)= .true.   ! db db to ub db nu lp   D0g1Wpb(3,1,4,2,5,6)  qpbqpbD0g1WpbTNLO(3,1,4,2,5,6)
c      qactive_chan(299)= .true.   ! d db to ub d nu lp    D0g1Wpb(3,2,1,4,5,6)  qpqpbD0g1WpbTNLO(3,2,1,4,5,6)
c      qactive_chan(300)= .true.   ! d g subtraction                             dgD0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(301)= .true.   ! db g subtraction                            dbgD0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(302)= .true.   ! g d subtraction                             gdD0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(303)= .true.   ! g db subtraction                            gdbD0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(304)= .true.   ! g ub subtraction                            gubD0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(305)= .true.   ! ub g subtraction                            ubgD0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(306)= .true.   ! u ub to ub d nu lp    Dt0g1Wpa(1,2,3,4,5,6)  qqbDt0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(307)= .true.   ! u u to u d nu lp      Dt0g1Wpa(1,3,2,4,5,6)  qqDt0g1WpaTNLO(1,3,2,4,5,6)
c      qactive_chan(308)= .true.   ! u db to u ub nu lp    Dt0g1Wpa(1,3,4,2,5,6)  qqpbDt0g1WpaTNLO(1,3,4,2,5,6)
c      qactive_chan(309)= .true.   ! ub u to ub d nu lp    Dt0g1Wpa(2,1,3,4,5,6)  qbqDt0g1WpaTNLO(2,1,3,4,5,6)
c      qactive_chan(310)= .true.   ! db u to u ub nu lp    Dt0g1Wpa(2,3,4,1,5,6)  qpbqDt0g1WpaTNLO(2,3,4,1,5,6)
c      qactive_chan(311)= .true.   ! ub db to ub ub nu lp   Dt0g1Wpa(3,1,4,2,5,6)  qbqpbDt0g1WpaTNLO(3,1,4,2,5,6)
c      qactive_chan(312)= .true.   ! db ub to ub ub nu lp   Dt0g1Wpa(3,2,4,1,5,6)  qpbqbDt0g1WpaTNLO(3,2,4,1,5,6)
c      qactive_chan(313)= .true.   ! d g subtraction                             dgDt0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(314)= .true.   ! g d subtraction                             gdDt0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(315)= .true.   ! g u subtraction                             guDt0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(316)= .true.   ! g ub subtraction                            gubDt0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(317)= .true.   ! u g subtraction                             ugDt0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(318)= .true.   ! ub g subtraction                            ubgDt0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(319)= .true.   ! u db to db d nu lp    Dt0g1Wpb(1,2,3,4,5,6)  qqpbDt0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(320)= .true.   ! u d to d d nu lp      Dt0g1Wpb(1,3,2,4,5,6)  qqpDt0g1WpbTNLO(1,3,2,4,5,6)
c      qactive_chan(321)= .true.   ! db u to db d nu lp    Dt0g1Wpb(2,1,3,4,5,6)  qpbqDt0g1WpbTNLO(2,1,3,4,5,6)
c      qactive_chan(322)= .true.   ! d u to d d nu lp      Dt0g1Wpb(2,3,1,4,5,6)  qpqDt0g1WpbTNLO(2,3,1,4,5,6)
c      qactive_chan(323)= .true.   ! db d to ub d nu lp    Dt0g1Wpb(3,1,2,4,5,6)  qpbqpDt0g1WpbTNLO(3,1,2,4,5,6)
c      qactive_chan(324)= .true.   ! db db to ub db nu lp   Dt0g1Wpb(3,1,4,2,5,6)  qpbqpbDt0g1WpbTNLO(3,1,4,2,5,6)
c      qactive_chan(325)= .true.   ! d db to ub d nu lp    Dt0g1Wpb(3,2,1,4,5,6)  qpqpbDt0g1WpbTNLO(3,2,1,4,5,6)
c      qactive_chan(326)= .true.   ! d g subtraction                             dgDt0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(327)= .true.   ! db g subtraction                            dbgDt0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(328)= .true.   ! g d subtraction                             gdDt0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(329)= .true.   ! g db subtraction                            gdbDt0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(330)= .true.   ! g ub subtraction                            gubDt0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(331)= .true.   ! ub g subtraction                            ubgDt0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(332)= .true.   ! u ub to ub d nu lp    Dh0g1Wpa(1,2,3,4,5,6)  qqbDh0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(333)= .true.   ! u u to u d nu lp      Dh0g1Wpa(1,3,2,4,5,6)  qqDh0g1WpaTNLO(1,3,2,4,5,6)
c      qactive_chan(334)= .true.   ! u db to u ub nu lp    Dh0g1Wpa(1,3,4,2,5,6)  qqpbDh0g1WpaTNLO(1,3,4,2,5,6)
c      qactive_chan(335)= .true.   ! ub u to ub d nu lp    Dh0g1Wpa(2,1,3,4,5,6)  qbqDh0g1WpaTNLO(2,1,3,4,5,6)
c      qactive_chan(336)= .true.   ! db u to u ub nu lp    Dh0g1Wpa(2,3,4,1,5,6)  qpbqDh0g1WpaTNLO(2,3,4,1,5,6)
c      qactive_chan(337)= .true.   ! ub db to ub ub nu lp   Dh0g1Wpa(3,1,4,2,5,6)  qbqpbDh0g1WpaTNLO(3,1,4,2,5,6)
c      qactive_chan(338)= .true.   ! db ub to ub ub nu lp   Dh0g1Wpa(3,2,4,1,5,6)  qpbqbDh0g1WpaTNLO(3,2,4,1,5,6)
c      qactive_chan(339)= .true.   ! d g subtraction                             dgDh0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(340)= .true.   ! g d subtraction                             gdDh0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(341)= .true.   ! g u subtraction                             guDh0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(342)= .true.   ! g ub subtraction                            gubDh0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(343)= .true.   ! u g subtraction                             ugDh0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(344)= .true.   ! ub g subtraction                            ubgDh0g1WpaTNLO(1,2,3,4,5,6)
c      qactive_chan(345)= .true.   ! u db to db d nu lp    Dh0g1Wpb(1,2,3,4,5,6)  qqpbDh0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(346)= .true.   ! u d to d d nu lp      Dh0g1Wpb(1,3,2,4,5,6)  qqpDh0g1WpbTNLO(1,3,2,4,5,6)
c      qactive_chan(347)= .true.   ! db u to db d nu lp    Dh0g1Wpb(2,1,3,4,5,6)  qpbqDh0g1WpbTNLO(2,1,3,4,5,6)
c      qactive_chan(348)= .true.   ! d u to d d nu lp      Dh0g1Wpb(2,3,1,4,5,6)  qpqDh0g1WpbTNLO(2,3,1,4,5,6)
c      qactive_chan(349)= .true.   ! db d to ub d nu lp    Dh0g1Wpb(3,1,2,4,5,6)  qpbqpDh0g1WpbTNLO(3,1,2,4,5,6)
c      qactive_chan(350)= .true.   ! db db to ub db nu lp   Dh0g1Wpb(3,1,4,2,5,6)  qpbqpbDh0g1WpbTNLO(3,1,4,2,5,6)
c      qactive_chan(351)= .true.   ! d db to ub d nu lp    Dh0g1Wpb(3,2,1,4,5,6)  qpqpbDh0g1WpbTNLO(3,2,1,4,5,6)
c      qactive_chan(352)= .true.   ! d g subtraction                             dgDh0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(353)= .true.   ! db g subtraction                            dbgDh0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(354)= .true.   ! g d subtraction                             gdDh0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(355)= .true.   ! g db subtraction                            gdbDh0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(356)= .true.   ! g ub subtraction                            gubDh0g1WpbTNLO(1,2,3,4,5,6)
c      qactive_chan(357)= .true.   ! ub g subtraction                            ubgDh0g1WpbTNLO(1,2,3,4,5,6)

      do i=154,357
        contrib_chan(i)=3
      enddo

c -- double real                                  ME                   S  

c -- real virtual                                 ME                   T  

c -- double virtual                               ME                   U  

      return
      end


c---- get channel strings
      subroutine getchannelWpJJ(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'u g to g d nu lp    '
        me_str   = 'B2g0W(1,2,3,4,5,6)  '
        sub_str  = ''

      case (2)
        chan_str = 'u db to g g nu lp   '
        me_str   = 'B2g0W(1,3,4,2,5,6)  '
        sub_str  = ''

      case (3)
        chan_str = 'g u to g d nu lp    '
        me_str   = 'B2g0W(2,1,3,4,5,6)  '
        sub_str  = ''

      case (4)
        chan_str = 'db u to g g nu lp   '
        me_str   = 'B2g0W(2,3,4,1,5,6)  '
        sub_str  = ''

      case (5)
        chan_str = 'g g to ub d nu lp   '
        me_str   = 'B2g0W(3,1,2,4,5,6)  '
        sub_str  = ''

      case (6)
        chan_str = 'g db to ub g nu lp  '
        me_str   = 'B2g0W(3,1,4,2,5,6)  '
        sub_str  = ''

      case (7)
        chan_str = 'db g to ub g nu lp  '
        me_str   = 'B2g0W(3,2,4,1,5,6)  '
        sub_str  = ''

      case (8)
        chan_str = 'u gt to gt d nu lp  '
        me_str   = 'Bt2g0W(1,2,3,4,5,6) '
        sub_str  = ''

      case (9)
        chan_str = 'u db to gt gt nu lp '
        me_str   = 'Bt2g0W(1,3,4,2,5,6) '
        sub_str  = ''

      case (10)
        chan_str = 'gt u to gt d nu lp  '
        me_str   = 'Bt2g0W(2,1,3,4,5,6) '
        sub_str  = ''

      case (11)
        chan_str = 'db u to gt gt nu lp '
        me_str   = 'Bt2g0W(2,3,4,1,5,6) '
        sub_str  = ''

      case (12)
        chan_str = 'gt gt to ub d nu lp '
        me_str   = 'Bt2g0W(3,1,2,4,5,6) '
        sub_str  = ''

      case (13)
        chan_str = 'gt db to ub gt nu lp '
        me_str   = 'Bt2g0W(3,1,4,2,5,6) '
        sub_str  = ''

      case (14)
        chan_str = 'db gt to ub gt nu lp '
        me_str   = 'Bt2g0W(3,2,4,1,5,6) '
        sub_str  = ''

      case (15)
        chan_str = 'u Qb to Qb d nu lp  '
        me_str   = 'C0g0W(1,2,3,4,5,6)  '
        sub_str  = ''

      case (16)
        chan_str = 'u Q to Q d nu lp    '
        me_str   = 'C0g0W(1,3,2,4,5,6)  '
        sub_str  = ''

      case (17)
        chan_str = 'u db to Q Qb nu lp  '
        me_str   = 'C0g0W(1,3,4,2,5,6)  '
        sub_str  = ''

      case (18)
        chan_str = 'Qb u to Qb d nu lp  '
        me_str   = 'C0g0W(2,1,3,4,5,6)  '
        sub_str  = ''

      case (19)
        chan_str = 'Q u to Q d nu lp    '
        me_str   = 'C0g0W(2,3,1,4,5,6)  '
        sub_str  = ''

      case (20)
        chan_str = 'db u to Q Qb nu lp  '
        me_str   = 'C0g0W(2,3,4,1,5,6)  '
        sub_str  = ''

      case (21)
        chan_str = 'Qb Q to ub d nu lp  '
        me_str   = 'C0g0W(3,1,2,4,5,6)  '
        sub_str  = ''

      case (22)
        chan_str = 'Qb db to ub Qb nu lp '
        me_str   = 'C0g0W(3,1,4,2,5,6)  '
        sub_str  = ''

      case (23)
        chan_str = 'Q Qb to ub d nu lp  '
        me_str   = 'C0g0W(3,2,1,4,5,6)  '
        sub_str  = ''

      case (24)
        chan_str = 'db Qb to ub Qb nu lp '
        me_str   = 'C0g0W(3,2,4,1,5,6)  '
        sub_str  = ''

      case (25)
        chan_str = 'Q db to ub Q nu lp  '
        me_str   = 'C0g0W(3,4,1,2,5,6)  '
        sub_str  = ''

      case (26)
        chan_str = 'db Q to ub Q nu lp  '
        me_str   = 'C0g0W(3,4,2,1,5,6)  '
        sub_str  = ''

      case (27)
        chan_str = 'u ub to ub d nu lp  '
        me_str   = 'D0g0Wa(1,2,3,4,5,6) '
        sub_str  = ''

      case (28)
        chan_str = 'u u to u d nu lp    '
        me_str   = 'D0g0Wa(1,3,2,4,5,6) '
        sub_str  = ''

      case (29)
        chan_str = 'u db to u ub nu lp  '
        me_str   = 'D0g0Wa(1,3,4,2,5,6) '
        sub_str  = ''

      case (30)
        chan_str = 'ub u to ub d nu lp  '
        me_str   = 'D0g0Wa(2,1,3,4,5,6) '
        sub_str  = ''

      case (31)
        chan_str = 'db u to u ub nu lp  '
        me_str   = 'D0g0Wa(2,3,4,1,5,6) '
        sub_str  = ''

      case (32)
        chan_str = 'ub db to ub ub nu lp '
        me_str   = 'D0g0Wa(3,1,4,2,5,6) '
        sub_str  = ''

      case (33)
        chan_str = 'db ub to ub ub nu lp '
        me_str   = 'D0g0Wa(3,2,4,1,5,6) '
        sub_str  = ''

      case (34)
        chan_str = 'u db to db d nu lp  '
        me_str   = 'D0g0Wb(1,2,3,4,5,6) '
        sub_str  = ''

      case (35)
        chan_str = 'u d to d d nu lp    '
        me_str   = 'D0g0Wb(1,3,2,4,5,6) '
        sub_str  = ''

      case (36)
        chan_str = 'db u to db d nu lp  '
        me_str   = 'D0g0Wb(2,1,3,4,5,6) '
        sub_str  = ''

      case (37)
        chan_str = 'd u to d d nu lp    '
        me_str   = 'D0g0Wb(2,3,1,4,5,6) '
        sub_str  = ''

      case (38)
        chan_str = 'db d to ub d nu lp  '
        me_str   = 'D0g0Wb(3,1,2,4,5,6) '
        sub_str  = ''

      case (39)
        chan_str = 'db db to ub db nu lp '
        me_str   = 'D0g0Wb(3,1,4,2,5,6) '
        sub_str  = ''

      case (40)
        chan_str = 'd db to ub d nu lp  '
        me_str   = 'D0g0Wb(3,2,1,4,5,6) '
        sub_str  = ''

      case (41)
        chan_str = 'u g to g g d nu lp  '
        me_str   = 'sB3g0W(1,2,3,4,5,6,7)'
        sub_str  = 'qgsB3g0WSNLO(1,2,3,4,5,6,7)'

      case (42)
        chan_str = 'u db to g g g nu lp '
        me_str   = 'sB3g0W(1,3,4,5,2,6,7)'
        sub_str  = 'qqbsB3g0WSNLO(1,3,4,5,2,6,7)'

      case (43)
        chan_str = 'g u to g g d nu lp  '
        me_str   = 'sB3g0W(2,1,3,4,5,6,7)'
        sub_str  = 'gqsB3g0WSNLO(2,1,3,4,5,6,7)'

      case (44)
        chan_str = 'db u to g g g nu lp '
        me_str   = 'sB3g0W(2,3,4,5,1,6,7)'
        sub_str  = 'qbqsB3g0WSNLO(2,3,4,5,1,6,7)'

      case (45)
        chan_str = 'g g to ub g d nu lp '
        me_str   = 'sB3g0W(3,1,2,4,5,6,7)'
        sub_str  = 'ggsB3g0WSNLO(3,1,2,4,5,6,7)'

      case (46)
        chan_str = 'g db to ub g g nu lp '
        me_str   = 'sB3g0W(3,1,4,5,2,6,7)'
        sub_str  = 'gqbsB3g0WSNLO(3,1,4,5,2,6,7)'

      case (47)
        chan_str = 'db g to ub g g nu lp '
        me_str   = 'sB3g0W(3,2,4,5,1,6,7)'
        sub_str  = 'qbgsB3g0WSNLO(3,2,4,5,1,6,7)'

      case (48)
        chan_str = 'u g to g g d nu lp  '
        me_str   = 'sBt3g0W(1,2,3,4,5,6,7)'
        sub_str  = 'qgsBt3g0WSNLO(1,2,3,4,5,6,7)'

      case (49)
        chan_str = 'u db to g g g nu lp '
        me_str   = 'sBt3g0W(1,3,4,5,2,6,7)'
        sub_str  = 'qqbsBt3g0WSNLO(1,3,4,5,2,6,7)'

      case (50)
        chan_str = 'g u to g g d nu lp  '
        me_str   = 'sBt3g0W(2,1,3,4,5,6,7)'
        sub_str  = 'gqsBt3g0WSNLO(2,1,3,4,5,6,7)'

      case (51)
        chan_str = 'db u to g g g nu lp '
        me_str   = 'sBt3g0W(2,3,4,5,1,6,7)'
        sub_str  = 'qbqsBt3g0WSNLO(2,3,4,5,1,6,7)'

      case (52)
        chan_str = 'g g to ub g d nu lp '
        me_str   = 'sBt3g0W(3,1,2,4,5,6,7)'
        sub_str  = 'ggsBt3g0WSNLO(3,1,2,4,5,6,7)'

      case (53)
        chan_str = 'g db to ub g g nu lp '
        me_str   = 'sBt3g0W(3,1,4,5,2,6,7)'
        sub_str  = 'gqbsBt3g0WSNLO(3,1,4,5,2,6,7)'

      case (54)
        chan_str = 'db g to ub g g nu lp '
        me_str   = 'sBt3g0W(3,2,4,5,1,6,7)'
        sub_str  = 'qbgsBt3g0WSNLO(3,2,4,5,1,6,7)'

      case (55)
        chan_str = 'u gt to gt gt d nu lp '
        me_str   = 'sBtt3g0W(1,2,3,4,5,6,7)'
        sub_str  = 'qgtsBtt3g0WSNLO(1,2,3,4,5,6,7)'

      case (56)
        chan_str = 'u db to gt gt gt nu lp '
        me_str   = 'sBtt3g0W(1,3,4,5,2,6,7)'
        sub_str  = 'qqbsBtt3g0WSNLO(1,3,4,5,2,6,7)'

      case (57)
        chan_str = 'gt u to gt gt d nu lp '
        me_str   = 'sBtt3g0W(2,1,3,4,5,6,7)'
        sub_str  = 'gtqsBtt3g0WSNLO(2,1,3,4,5,6,7)'

      case (58)
        chan_str = 'db u to gt gt gt nu lp '
        me_str   = 'sBtt3g0W(2,3,4,5,1,6,7)'
        sub_str  = 'qbqsBtt3g0WSNLO(2,3,4,5,1,6,7)'

      case (59)
        chan_str = 'gt gt to ub gt d nu lp '
        me_str   = 'sBtt3g0W(3,1,2,4,5,6,7)'
        sub_str  = 'gtgtsBtt3g0WSNLO(3,1,2,4,5,6,7)'

      case (60)
        chan_str = 'gt db to ub gt gt nu lp '
        me_str   = 'sBtt3g0W(3,1,4,5,2,6,7)'
        sub_str  = 'gtqbsBtt3g0WSNLO(3,1,4,5,2,6,7)'

      case (61)
        chan_str = 'db gt to ub gt gt nu lp '
        me_str   = 'sBtt3g0W(3,2,4,5,1,6,7)'
        sub_str  = 'qbgtsBtt3g0WSNLO(3,2,4,5,1,6,7)'

      case (62)
        chan_str = 'u g to Q Qb d nu lp '
        me_str   = 'sC1g0W(1,2,3,4,5,6,7)'
        sub_str  = 'qgsC1g0WSNLO(1,2,3,4,5,6,7)'

      case (63)
        chan_str = 'u Qb to g Qb d nu lp '
        me_str   = 'sC1g0W(1,3,2,4,5,6,7)'
        sub_str  = 'qqpbsC1g0WSNLO(1,3,2,4,5,6,7)'

      case (64)
        chan_str = 'u Q to g Q d nu lp  '
        me_str   = 'sC1g0W(1,3,4,2,5,6,7)'
        sub_str  = 'qqpsC1g0WSNLO(1,3,4,2,5,6,7)'

      case (65)
        chan_str = 'u db to g Q Qb nu lp '
        me_str   = 'sC1g0W(1,3,4,5,2,6,7)'
        sub_str  = 'qqbsC1g0WSNLO(1,3,4,5,2,6,7)'

      case (66)
        chan_str = 'g u to Q Qb d nu lp '
        me_str   = 'sC1g0W(2,1,3,4,5,6,7)'
        sub_str  = 'gqsC1g0WSNLO(2,1,3,4,5,6,7)'

      case (67)
        chan_str = 'Qb u to g Qb d nu lp '
        me_str   = 'sC1g0W(2,3,1,4,5,6,7)'
        sub_str  = 'qpbqsC1g0WSNLO(2,3,1,4,5,6,7)'

      case (68)
        chan_str = 'Q u to g Q d nu lp  '
        me_str   = 'sC1g0W(2,3,4,1,5,6,7)'
        sub_str  = 'qpqsC1g0WSNLO(2,3,4,1,5,6,7)'

      case (69)
        chan_str = 'db u to g Q Qb nu lp '
        me_str   = 'sC1g0W(2,3,4,5,1,6,7)'
        sub_str  = 'qbqsC1g0WSNLO(2,3,4,5,1,6,7)'

      case (70)
        chan_str = 'g Qb to ub Qb d nu lp '
        me_str   = 'sC1g0W(3,1,2,4,5,6,7)'
        sub_str  = 'gqpbsC1g0WSNLO(3,1,2,4,5,6,7)'

      case (71)
        chan_str = 'g Q to ub Q d nu lp '
        me_str   = 'sC1g0W(3,1,4,2,5,6,7)'
        sub_str  = 'gqpsC1g0WSNLO(3,1,4,2,5,6,7)'

      case (72)
        chan_str = 'g db to ub Q Qb nu lp '
        me_str   = 'sC1g0W(3,1,4,5,2,6,7)'
        sub_str  = 'gqbsC1g0WSNLO(3,1,4,5,2,6,7)'

      case (73)
        chan_str = 'Qb g to ub Qb d nu lp '
        me_str   = 'sC1g0W(3,2,1,4,5,6,7)'
        sub_str  = 'qpbgsC1g0WSNLO(3,2,1,4,5,6,7)'

      case (74)
        chan_str = 'Q g to ub Q d nu lp '
        me_str   = 'sC1g0W(3,2,4,1,5,6,7)'
        sub_str  = 'qpgsC1g0WSNLO(3,2,4,1,5,6,7)'

      case (75)
        chan_str = 'db g to ub Q Qb nu lp '
        me_str   = 'sC1g0W(3,2,4,5,1,6,7)'
        sub_str  = 'qbgsC1g0WSNLO(3,2,4,5,1,6,7)'

      case (76)
        chan_str = 'Qb Q to ub g d nu lp '
        me_str   = 'sC1g0W(3,4,1,2,5,6,7)'
        sub_str  = 'qpbqpsC1g0WSNLO(3,4,1,2,5,6,7)'

      case (77)
        chan_str = 'Qb db to ub g Qb nu lp '
        me_str   = 'sC1g0W(3,4,1,5,2,6,7)'
        sub_str  = 'qpbqbsC1g0WSNLO(3,4,1,5,2,6,7)'

      case (78)
        chan_str = 'Q Qb to ub g d nu lp '
        me_str   = 'sC1g0W(3,4,2,1,5,6,7)'
        sub_str  = 'qpqpbsC1g0WSNLO(3,4,2,1,5,6,7)'

      case (79)
        chan_str = 'db Qb to ub g Qb nu lp '
        me_str   = 'sC1g0W(3,4,2,5,1,6,7)'
        sub_str  = 'qbqpbsC1g0WSNLO(3,4,2,5,1,6,7)'

      case (80)
        chan_str = 'Q db to ub g Q nu lp '
        me_str   = 'sC1g0W(3,4,5,1,2,6,7)'
        sub_str  = 'qpqbsC1g0WSNLO(3,4,5,1,2,6,7)'

      case (81)
        chan_str = 'db Q to ub g Q nu lp '
        me_str   = 'sC1g0W(3,4,5,2,1,6,7)'
        sub_str  = 'qbqpsC1g0WSNLO(3,4,5,2,1,6,7)'

      case (82)
        chan_str = 'u g to Q Qb d nu lp '
        me_str   = 'sCt1g0W(1,2,3,4,5,6,7)'
        sub_str  = 'qgsCt1g0WSNLO(1,2,3,4,5,6,7)'

      case (83)
        chan_str = 'u Qb to g Qb d nu lp '
        me_str   = 'sCt1g0W(1,3,2,4,5,6,7)'
        sub_str  = 'qqpbsCt1g0WSNLO(1,3,2,4,5,6,7)'

      case (84)
        chan_str = 'u Q to g Q d nu lp  '
        me_str   = 'sCt1g0W(1,3,4,2,5,6,7)'
        sub_str  = 'qqpsCt1g0WSNLO(1,3,4,2,5,6,7)'

      case (85)
        chan_str = 'u db to g Q Qb nu lp '
        me_str   = 'sCt1g0W(1,3,4,5,2,6,7)'
        sub_str  = 'qqbsCt1g0WSNLO(1,3,4,5,2,6,7)'

      case (86)
        chan_str = 'g u to Q Qb d nu lp '
        me_str   = 'sCt1g0W(2,1,3,4,5,6,7)'
        sub_str  = 'gqsCt1g0WSNLO(2,1,3,4,5,6,7)'

      case (87)
        chan_str = 'Qb u to g Qb d nu lp '
        me_str   = 'sCt1g0W(2,3,1,4,5,6,7)'
        sub_str  = 'qpbqsCt1g0WSNLO(2,3,1,4,5,6,7)'

      case (88)
        chan_str = 'Q u to g Q d nu lp  '
        me_str   = 'sCt1g0W(2,3,4,1,5,6,7)'
        sub_str  = 'qpqsCt1g0WSNLO(2,3,4,1,5,6,7)'

      case (89)
        chan_str = 'db u to g Q Qb nu lp '
        me_str   = 'sCt1g0W(2,3,4,5,1,6,7)'
        sub_str  = 'qbqsCt1g0WSNLO(2,3,4,5,1,6,7)'

      case (90)
        chan_str = 'g Qb to ub Qb d nu lp '
        me_str   = 'sCt1g0W(3,1,2,4,5,6,7)'
        sub_str  = 'gqpbsCt1g0WSNLO(3,1,2,4,5,6,7)'

      case (91)
        chan_str = 'g Q to ub Q d nu lp '
        me_str   = 'sCt1g0W(3,1,4,2,5,6,7)'
        sub_str  = 'gqpsCt1g0WSNLO(3,1,4,2,5,6,7)'

      case (92)
        chan_str = 'g db to ub Q Qb nu lp '
        me_str   = 'sCt1g0W(3,1,4,5,2,6,7)'
        sub_str  = 'gqbsCt1g0WSNLO(3,1,4,5,2,6,7)'

      case (93)
        chan_str = 'Qb g to ub Qb d nu lp '
        me_str   = 'sCt1g0W(3,2,1,4,5,6,7)'
        sub_str  = 'qpbgsCt1g0WSNLO(3,2,1,4,5,6,7)'

      case (94)
        chan_str = 'Q g to ub Q d nu lp '
        me_str   = 'sCt1g0W(3,2,4,1,5,6,7)'
        sub_str  = 'qpgsCt1g0WSNLO(3,2,4,1,5,6,7)'

      case (95)
        chan_str = 'db g to ub Q Qb nu lp '
        me_str   = 'sCt1g0W(3,2,4,5,1,6,7)'
        sub_str  = 'qbgsCt1g0WSNLO(3,2,4,5,1,6,7)'

      case (96)
        chan_str = 'Qb Q to ub g d nu lp '
        me_str   = 'sCt1g0W(3,4,1,2,5,6,7)'
        sub_str  = 'qpbqpsCt1g0WSNLO(3,4,1,2,5,6,7)'

      case (97)
        chan_str = 'Qb db to ub g Qb nu lp '
        me_str   = 'sCt1g0W(3,4,1,5,2,6,7)'
        sub_str  = 'qpbqbsCt1g0WSNLO(3,4,1,5,2,6,7)'

      case (98)
        chan_str = 'Q Qb to ub g d nu lp '
        me_str   = 'sCt1g0W(3,4,2,1,5,6,7)'
        sub_str  = 'qpqpbsCt1g0WSNLO(3,4,2,1,5,6,7)'

      case (99)
        chan_str = 'db Qb to ub g Qb nu lp '
        me_str   = 'sCt1g0W(3,4,2,5,1,6,7)'
        sub_str  = 'qbqpbsCt1g0WSNLO(3,4,2,5,1,6,7)'

      case (100)
        chan_str = 'Q db to ub g Q nu lp '
        me_str   = 'sCt1g0W(3,4,5,1,2,6,7)'
        sub_str  = 'qpqbsCt1g0WSNLO(3,4,5,1,2,6,7)'

      case (101)
        chan_str = 'db Q to ub g Q nu lp '
        me_str   = 'sCt1g0W(3,4,5,2,1,6,7)'
        sub_str  = 'qbqpsCt1g0WSNLO(3,4,5,2,1,6,7)'

      case (102)
        chan_str = 'u g to u ub d nu lp '
        me_str   = 'D1g0Wpac(1,2,3,4,5,6,7)'
        sub_str  = 'qgD1g0WpacSNLO(1,2,3,4,5,6,7)'

      case (103)
        chan_str = 'u ub to g ub d nu lp '
        me_str   = 'D1g0Wpac(1,3,2,4,5,6,7)'
        sub_str  = 'qqbD1g0WpacSNLO(1,3,2,4,5,6,7)'

      case (104)
        chan_str = 'u u to g u d nu lp  '
        me_str   = 'D1g0Wpac(1,3,4,2,5,6,7)'
        sub_str  = 'qqD1g0WpacSNLO(1,3,4,2,5,6,7)'

      case (105)
        chan_str = 'u db to g u ub nu lp '
        me_str   = 'D1g0Wpac(1,3,4,5,2,6,7)'
        sub_str  = 'qqpbD1g0WpacSNLO(1,3,4,5,2,6,7)'

      case (106)
        chan_str = 'g u to u ub d nu lp '
        me_str   = 'D1g0Wpac(2,1,3,4,5,6,7)'
        sub_str  = 'gqD1g0WpacSNLO(2,1,3,4,5,6,7)'

      case (107)
        chan_str = 'ub u to g ub d nu lp '
        me_str   = 'D1g0Wpac(2,3,1,4,5,6,7)'
        sub_str  = 'qbqD1g0WpacSNLO(2,3,1,4,5,6,7)'

      case (108)
        chan_str = 'db u to g u ub nu lp '
        me_str   = 'D1g0Wpac(2,3,4,5,1,6,7)'
        sub_str  = 'qpbqD1g0WpacSNLO(2,3,4,5,1,6,7)'

      case (109)
        chan_str = 'g ub to ub ub d nu lp '
        me_str   = 'D1g0Wpac(3,1,2,4,5,6,7)'
        sub_str  = 'gqbD1g0WpacSNLO(3,1,2,4,5,6,7)'

      case (110)
        chan_str = 'g db to ub u ub nu lp '
        me_str   = 'D1g0Wpac(3,1,4,5,2,6,7)'
        sub_str  = 'gqpbD1g0WpacSNLO(3,1,4,5,2,6,7)'

      case (111)
        chan_str = 'ub g to ub ub d nu lp '
        me_str   = 'D1g0Wpac(3,2,1,4,5,6,7)'
        sub_str  = 'qbgD1g0WpacSNLO(3,2,1,4,5,6,7)'

      case (112)
        chan_str = 'db g to ub u ub nu lp '
        me_str   = 'D1g0Wpac(3,2,4,5,1,6,7)'
        sub_str  = 'qpbgD1g0WpacSNLO(3,2,4,5,1,6,7)'

      case (113)
        chan_str = 'ub db to ub g ub nu lp '
        me_str   = 'D1g0Wpac(3,4,1,5,2,6,7)'
        sub_str  = 'qbqpbD1g0WpacSNLO(3,4,1,5,2,6,7)'

      case (114)
        chan_str = 'db ub to ub g ub nu lp '
        me_str   = 'D1g0Wpac(3,4,2,5,1,6,7)'
        sub_str  = 'qpbqbD1g0WpacSNLO(3,4,2,5,1,6,7)'

      case (115)
        chan_str = 'u g to d db d nu lp '
        me_str   = 'D1g0Wpbc(1,2,3,4,5,6,7)'
        sub_str  = 'qgD1g0WpbcSNLO(1,2,3,4,5,6,7)'

      case (116)
        chan_str = 'u db to g db d nu lp '
        me_str   = 'D1g0Wpbc(1,3,2,4,5,6,7)'
        sub_str  = 'qqpbD1g0WpbcSNLO(1,3,2,4,5,6,7)'

      case (117)
        chan_str = 'u d to g d d nu lp  '
        me_str   = 'D1g0Wpbc(1,3,4,2,5,6,7)'
        sub_str  = 'qqpD1g0WpbcSNLO(1,3,4,2,5,6,7)'

      case (118)
        chan_str = 'g u to d db d nu lp '
        me_str   = 'D1g0Wpbc(2,1,3,4,5,6,7)'
        sub_str  = 'gqD1g0WpbcSNLO(2,1,3,4,5,6,7)'

      case (119)
        chan_str = 'db u to g db d nu lp '
        me_str   = 'D1g0Wpbc(2,3,1,4,5,6,7)'
        sub_str  = 'qpbqD1g0WpbcSNLO(2,3,1,4,5,6,7)'

      case (120)
        chan_str = 'd u to g d d nu lp  '
        me_str   = 'D1g0Wpbc(2,3,4,1,5,6,7)'
        sub_str  = 'qpqD1g0WpbcSNLO(2,3,4,1,5,6,7)'

      case (121)
        chan_str = 'g db to ub db d nu lp '
        me_str   = 'D1g0Wpbc(3,1,2,4,5,6,7)'
        sub_str  = 'gqpbD1g0WpbcSNLO(3,1,2,4,5,6,7)'

      case (122)
        chan_str = 'g d to ub d d nu lp '
        me_str   = 'D1g0Wpbc(3,1,4,2,5,6,7)'
        sub_str  = 'gqpD1g0WpbcSNLO(3,1,4,2,5,6,7)'

      case (123)
        chan_str = 'db g to ub db d nu lp '
        me_str   = 'D1g0Wpbc(3,2,1,4,5,6,7)'
        sub_str  = 'qpbgD1g0WpbcSNLO(3,2,1,4,5,6,7)'

      case (124)
        chan_str = 'd g to ub d d nu lp '
        me_str   = 'D1g0Wpbc(3,2,4,1,5,6,7)'
        sub_str  = 'qpgD1g0WpbcSNLO(3,2,4,1,5,6,7)'

      case (125)
        chan_str = 'db d to ub g d nu lp '
        me_str   = 'D1g0Wpbc(3,4,1,2,5,6,7)'
        sub_str  = 'qpbqpD1g0WpbcSNLO(3,4,1,2,5,6,7)'

      case (126)
        chan_str = 'db db to ub g db nu lp '
        me_str   = 'D1g0Wpbc(3,4,1,5,2,6,7)'
        sub_str  = 'qpbqpbD1g0WpbcSNLO(3,4,1,5,2,6,7)'

      case (127)
        chan_str = 'd db to ub g d nu lp '
        me_str   = 'D1g0Wpbc(3,4,2,1,5,6,7)'
        sub_str  = 'qpqpbD1g0WpbcSNLO(3,4,2,1,5,6,7)'

      case (128)
        chan_str = 'u g to u ub d nu lp '
        me_str   = 'Dt1g0Wpa(1,2,3,4,5,6,7)'
        sub_str  = 'qgDt1g0WpaSNLO(1,2,3,4,5,6,7)'

      case (129)
        chan_str = 'u ub to g ub d nu lp '
        me_str   = 'Dt1g0Wpa(1,3,2,4,5,6,7)'
        sub_str  = 'qqbDt1g0WpaSNLO(1,3,2,4,5,6,7)'

      case (130)
        chan_str = 'u u to g u d nu lp  '
        me_str   = 'Dt1g0Wpa(1,3,4,2,5,6,7)'
        sub_str  = 'qqDt1g0WpaSNLO(1,3,4,2,5,6,7)'

      case (131)
        chan_str = 'u db to g u ub nu lp '
        me_str   = 'Dt1g0Wpa(1,3,4,5,2,6,7)'
        sub_str  = 'qqpbDt1g0WpaSNLO(1,3,4,5,2,6,7)'

      case (132)
        chan_str = 'g u to u ub d nu lp '
        me_str   = 'Dt1g0Wpa(2,1,3,4,5,6,7)'
        sub_str  = 'gqDt1g0WpaSNLO(2,1,3,4,5,6,7)'

      case (133)
        chan_str = 'ub u to g ub d nu lp '
        me_str   = 'Dt1g0Wpa(2,3,1,4,5,6,7)'
        sub_str  = 'qbqDt1g0WpaSNLO(2,3,1,4,5,6,7)'

      case (134)
        chan_str = 'db u to g u ub nu lp '
        me_str   = 'Dt1g0Wpa(2,3,4,5,1,6,7)'
        sub_str  = 'qpbqDt1g0WpaSNLO(2,3,4,5,1,6,7)'

      case (135)
        chan_str = 'g ub to ub ub d nu lp '
        me_str   = 'Dt1g0Wpa(3,1,2,4,5,6,7)'
        sub_str  = 'gqbDt1g0WpaSNLO(3,1,2,4,5,6,7)'

      case (136)
        chan_str = 'g db to ub u ub nu lp '
        me_str   = 'Dt1g0Wpa(3,1,4,5,2,6,7)'
        sub_str  = 'gqpbDt1g0WpaSNLO(3,1,4,5,2,6,7)'

      case (137)
        chan_str = 'ub g to ub ub d nu lp '
        me_str   = 'Dt1g0Wpa(3,2,1,4,5,6,7)'
        sub_str  = 'qbgDt1g0WpaSNLO(3,2,1,4,5,6,7)'

      case (138)
        chan_str = 'db g to ub u ub nu lp '
        me_str   = 'Dt1g0Wpa(3,2,4,5,1,6,7)'
        sub_str  = 'qpbgDt1g0WpaSNLO(3,2,4,5,1,6,7)'

      case (139)
        chan_str = 'ub db to ub g ub nu lp '
        me_str   = 'Dt1g0Wpa(3,4,1,5,2,6,7)'
        sub_str  = 'qbqpbDt1g0WpaSNLO(3,4,1,5,2,6,7)'

      case (140)
        chan_str = 'db ub to ub g ub nu lp '
        me_str   = 'Dt1g0Wpa(3,4,2,5,1,6,7)'
        sub_str  = 'qpbqbDt1g0WpaSNLO(3,4,2,5,1,6,7)'

      case (141)
        chan_str = 'u g to d db d nu lp '
        me_str   = 'Dt1g0Wpb(1,2,3,4,5,6,7)'
        sub_str  = 'qgDt1g0WpbSNLO(1,2,3,4,5,6,7)'

      case (142)
        chan_str = 'u db to g db d nu lp '
        me_str   = 'Dt1g0Wpb(1,3,2,4,5,6,7)'
        sub_str  = 'qqpbDt1g0WpbSNLO(1,3,2,4,5,6,7)'

      case (143)
        chan_str = 'u d to g d d nu lp  '
        me_str   = 'Dt1g0Wpb(1,3,4,2,5,6,7)'
        sub_str  = 'qqpDt1g0WpbSNLO(1,3,4,2,5,6,7)'

      case (144)
        chan_str = 'g u to d db d nu lp '
        me_str   = 'Dt1g0Wpb(2,1,3,4,5,6,7)'
        sub_str  = 'gqDt1g0WpbSNLO(2,1,3,4,5,6,7)'

      case (145)
        chan_str = 'db u to g db d nu lp '
        me_str   = 'Dt1g0Wpb(2,3,1,4,5,6,7)'
        sub_str  = 'qpbqDt1g0WpbSNLO(2,3,1,4,5,6,7)'

      case (146)
        chan_str = 'd u to g d d nu lp  '
        me_str   = 'Dt1g0Wpb(2,3,4,1,5,6,7)'
        sub_str  = 'qpqDt1g0WpbSNLO(2,3,4,1,5,6,7)'

      case (147)
        chan_str = 'g db to ub db d nu lp '
        me_str   = 'Dt1g0Wpb(3,1,2,4,5,6,7)'
        sub_str  = 'gqpbDt1g0WpbSNLO(3,1,2,4,5,6,7)'

      case (148)
        chan_str = 'g d to ub d d nu lp '
        me_str   = 'Dt1g0Wpb(3,1,4,2,5,6,7)'
        sub_str  = 'gqpDt1g0WpbSNLO(3,1,4,2,5,6,7)'

      case (149)
        chan_str = 'db g to ub db d nu lp '
        me_str   = 'Dt1g0Wpb(3,2,1,4,5,6,7)'
        sub_str  = 'qpbgDt1g0WpbSNLO(3,2,1,4,5,6,7)'

      case (150)
        chan_str = 'd g to ub d d nu lp '
        me_str   = 'Dt1g0Wpb(3,2,4,1,5,6,7)'
        sub_str  = 'qpgDt1g0WpbSNLO(3,2,4,1,5,6,7)'

      case (151)
        chan_str = 'db d to ub g d nu lp '
        me_str   = 'Dt1g0Wpb(3,4,1,2,5,6,7)'
        sub_str  = 'qpbqpDt1g0WpbSNLO(3,4,1,2,5,6,7)'

      case (152)
        chan_str = 'db db to ub g db nu lp '
        me_str   = 'Dt1g0Wpb(3,4,1,5,2,6,7)'
        sub_str  = 'qpbqpbDt1g0WpbSNLO(3,4,1,5,2,6,7)'

      case (153)
        chan_str = 'd db to ub g d nu lp '
        me_str   = 'Dt1g0Wpb(3,4,2,1,5,6,7)'
        sub_str  = 'qpqpbDt1g0WpbSNLO(3,4,2,1,5,6,7)'

      case (154)
        chan_str = 'u g to g d nu lp    '
        me_str   = 'sB2g1W(1,2,3,4,5,6) '
        sub_str  = 'qgsB2g1WTNLO(1,2,3,4,5,6)'

      case (155)
        chan_str = 'u db to g g nu lp   '
        me_str   = 'sB2g1W(1,3,4,2,5,6) '
        sub_str  = 'qqbsB2g1WTNLO(1,3,4,2,5,6)'

      case (156)
        chan_str = 'g u to g d nu lp    '
        me_str   = 'sB2g1W(2,1,3,4,5,6) '
        sub_str  = 'gqsB2g1WTNLO(2,1,3,4,5,6)'

      case (157)
        chan_str = 'db u to g g nu lp   '
        me_str   = 'sB2g1W(2,3,4,1,5,6) '
        sub_str  = 'qbqsB2g1WTNLO(2,3,4,1,5,6)'

      case (158)
        chan_str = 'g g to ub d nu lp   '
        me_str   = 'sB2g1W(3,1,2,4,5,6) '
        sub_str  = 'ggsB2g1WTNLO(3,1,2,4,5,6)'

      case (159)
        chan_str = 'g db to ub g nu lp  '
        me_str   = 'sB2g1W(3,1,4,2,5,6) '
        sub_str  = 'gqbsB2g1WTNLO(3,1,4,2,5,6)'

      case (160)
        chan_str = 'db g to ub g nu lp  '
        me_str   = 'sB2g1W(3,2,4,1,5,6) '
        sub_str  = 'qbgsB2g1WTNLO(3,2,4,1,5,6)'

      case (161)
        chan_str = 'Q u subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqsB2g1WTNLO(1,2,3,4,5,6)'

      case (162)
        chan_str = 'Q db subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbsB2g1WTNLO(1,2,3,4,5,6)'

      case (163)
        chan_str = 'Qb u subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqsB2g1WTNLO(1,2,3,4,5,6)'

      case (164)
        chan_str = 'Qb db subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbsB2g1WTNLO(1,2,3,4,5,6)'

      case (165)
        chan_str = 'u Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpsB2g1WTNLO(1,2,3,4,5,6)'

      case (166)
        chan_str = 'u Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbsB2g1WTNLO(1,2,3,4,5,6)'

      case (167)
        chan_str = 'db Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpsB2g1WTNLO(1,2,3,4,5,6)'

      case (168)
        chan_str = 'db Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbsB2g1WTNLO(1,2,3,4,5,6)'

      case (169)
        chan_str = 'u g to g d nu lp    '
        me_str   = 'sBt2g1W(1,2,3,4,5,6)'
        sub_str  = 'qgsBt2g1WTNLO(1,2,3,4,5,6)'

      case (170)
        chan_str = 'u db to g g nu lp   '
        me_str   = 'sBt2g1W(1,3,4,2,5,6)'
        sub_str  = 'qqbsBt2g1WTNLO(1,3,4,2,5,6)'

      case (171)
        chan_str = 'g u to g d nu lp    '
        me_str   = 'sBt2g1W(2,1,3,4,5,6)'
        sub_str  = 'gqsBt2g1WTNLO(2,1,3,4,5,6)'

      case (172)
        chan_str = 'db u to g g nu lp   '
        me_str   = 'sBt2g1W(2,3,4,1,5,6)'
        sub_str  = 'qbqsBt2g1WTNLO(2,3,4,1,5,6)'

      case (173)
        chan_str = 'g g to ub d nu lp   '
        me_str   = 'sBt2g1W(3,1,2,4,5,6)'
        sub_str  = 'ggsBt2g1WTNLO(3,1,2,4,5,6)'

      case (174)
        chan_str = 'g db to ub g nu lp  '
        me_str   = 'sBt2g1W(3,1,4,2,5,6)'
        sub_str  = 'gqbsBt2g1WTNLO(3,1,4,2,5,6)'

      case (175)
        chan_str = 'db g to ub g nu lp  '
        me_str   = 'sBt2g1W(3,2,4,1,5,6)'
        sub_str  = 'qbgsBt2g1WTNLO(3,2,4,1,5,6)'

      case (176)
        chan_str = 'Q u subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqsBt2g1WTNLO(1,2,3,4,5,6)'

      case (177)
        chan_str = 'Q db subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbsBt2g1WTNLO(1,2,3,4,5,6)'

      case (178)
        chan_str = 'Qb u subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqsBt2g1WTNLO(1,2,3,4,5,6)'

      case (179)
        chan_str = 'Qb db subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbsBt2g1WTNLO(1,2,3,4,5,6)'

      case (180)
        chan_str = 'u Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpsBt2g1WTNLO(1,2,3,4,5,6)'

      case (181)
        chan_str = 'u Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbsBt2g1WTNLO(1,2,3,4,5,6)'

      case (182)
        chan_str = 'db Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpsBt2g1WTNLO(1,2,3,4,5,6)'

      case (183)
        chan_str = 'db Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbsBt2g1WTNLO(1,2,3,4,5,6)'

      case (184)
        chan_str = 'u gt to gt d nu lp  '
        me_str   = 'sBtt2g1Wc(1,2,3,4,5,6)'
        sub_str  = 'qgtsBtt2g1WcTNLO(1,2,3,4,5,6)'

      case (185)
        chan_str = 'u db to gt gt nu lp '
        me_str   = 'sBtt2g1Wc(1,3,4,2,5,6)'
        sub_str  = 'qqbsBtt2g1WcTNLO(1,3,4,2,5,6)'

      case (186)
        chan_str = 'gt u to gt d nu lp  '
        me_str   = 'sBtt2g1Wc(2,1,3,4,5,6)'
        sub_str  = 'gtqsBtt2g1WcTNLO(2,1,3,4,5,6)'

      case (187)
        chan_str = 'db u to gt gt nu lp '
        me_str   = 'sBtt2g1Wc(2,3,4,1,5,6)'
        sub_str  = 'qbqsBtt2g1WcTNLO(2,3,4,1,5,6)'

      case (188)
        chan_str = 'gt gt to ub d nu lp '
        me_str   = 'sBtt2g1Wc(3,1,2,4,5,6)'
        sub_str  = 'gtgtsBtt2g1WcTNLO(3,1,2,4,5,6)'

      case (189)
        chan_str = 'gt db to ub gt nu lp '
        me_str   = 'sBtt2g1Wc(3,1,4,2,5,6)'
        sub_str  = 'gtqbsBtt2g1WcTNLO(3,1,4,2,5,6)'

      case (190)
        chan_str = 'db gt to ub gt nu lp '
        me_str   = 'sBtt2g1Wc(3,2,4,1,5,6)'
        sub_str  = 'qbgtsBtt2g1WcTNLO(3,2,4,1,5,6)'

      case (191)
        chan_str = 'u gt to gt d nu lp  '
        me_str   = 'sBttt2g1W(1,2,3,4,5,6)'
        sub_str  = 'qgtsBttt2g1WTNLO(1,2,3,4,5,6)'

      case (192)
        chan_str = 'u db to gt gt nu lp '
        me_str   = 'sBttt2g1W(1,3,4,2,5,6)'
        sub_str  = 'qqbsBttt2g1WTNLO(1,3,4,2,5,6)'

      case (193)
        chan_str = 'gt u to gt d nu lp  '
        me_str   = 'sBttt2g1W(2,1,3,4,5,6)'
        sub_str  = 'gtqsBttt2g1WTNLO(2,1,3,4,5,6)'

      case (194)
        chan_str = 'db u to gt gt nu lp '
        me_str   = 'sBttt2g1W(2,3,4,1,5,6)'
        sub_str  = 'qbqsBttt2g1WTNLO(2,3,4,1,5,6)'

      case (195)
        chan_str = 'gt gt to ub d nu lp '
        me_str   = 'sBttt2g1W(3,1,2,4,5,6)'
        sub_str  = 'gtgtsBttt2g1WTNLO(3,1,2,4,5,6)'

      case (196)
        chan_str = 'gt db to ub gt nu lp '
        me_str   = 'sBttt2g1W(3,1,4,2,5,6)'
        sub_str  = 'gtqbsBttt2g1WTNLO(3,1,4,2,5,6)'

      case (197)
        chan_str = 'db gt to ub gt nu lp '
        me_str   = 'sBttt2g1W(3,2,4,1,5,6)'
        sub_str  = 'qbgtsBttt2g1WTNLO(3,2,4,1,5,6)'

      case (198)
        chan_str = 'u g to g d nu lp    '
        me_str   = 'sBh2g1W(1,2,3,4,5,6)'
        sub_str  = 'qgsBh2g1WTNLO(1,2,3,4,5,6)'

      case (199)
        chan_str = 'u db to g g nu lp   '
        me_str   = 'sBh2g1W(1,3,4,2,5,6)'
        sub_str  = 'qqbsBh2g1WTNLO(1,3,4,2,5,6)'

      case (200)
        chan_str = 'g u to g d nu lp    '
        me_str   = 'sBh2g1W(2,1,3,4,5,6)'
        sub_str  = 'gqsBh2g1WTNLO(2,1,3,4,5,6)'

      case (201)
        chan_str = 'db u to g g nu lp   '
        me_str   = 'sBh2g1W(2,3,4,1,5,6)'
        sub_str  = 'qbqsBh2g1WTNLO(2,3,4,1,5,6)'

      case (202)
        chan_str = 'g g to ub d nu lp   '
        me_str   = 'sBh2g1W(3,1,2,4,5,6)'
        sub_str  = 'ggsBh2g1WTNLO(3,1,2,4,5,6)'

      case (203)
        chan_str = 'g db to ub g nu lp  '
        me_str   = 'sBh2g1W(3,1,4,2,5,6)'
        sub_str  = 'gqbsBh2g1WTNLO(3,1,4,2,5,6)'

      case (204)
        chan_str = 'db g to ub g nu lp  '
        me_str   = 'sBh2g1W(3,2,4,1,5,6)'
        sub_str  = 'qbgsBh2g1WTNLO(3,2,4,1,5,6)'

      case (205)
        chan_str = 'Q u subtraction     '
        me_str   = '                    '
        sub_str  = 'qpqsBh2g1WTNLO(1,2,3,4,5,6)'

      case (206)
        chan_str = 'Q db subtraction    '
        me_str   = '                    '
        sub_str  = 'qpqbsBh2g1WTNLO(1,2,3,4,5,6)'

      case (207)
        chan_str = 'Qb u subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbqsBh2g1WTNLO(1,2,3,4,5,6)'

      case (208)
        chan_str = 'Qb db subtraction   '
        me_str   = '                    '
        sub_str  = 'qpbqbsBh2g1WTNLO(1,2,3,4,5,6)'

      case (209)
        chan_str = 'u Q subtraction     '
        me_str   = '                    '
        sub_str  = 'qqpsBh2g1WTNLO(1,2,3,4,5,6)'

      case (210)
        chan_str = 'u Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'qqpbsBh2g1WTNLO(1,2,3,4,5,6)'

      case (211)
        chan_str = 'db Q subtraction    '
        me_str   = '                    '
        sub_str  = 'qbqpsBh2g1WTNLO(1,2,3,4,5,6)'

      case (212)
        chan_str = 'db Qb subtraction   '
        me_str   = '                    '
        sub_str  = 'qbqpbsBh2g1WTNLO(1,2,3,4,5,6)'

      case (213)
        chan_str = 'u gt to gt d nu lp  '
        me_str   = 'sBth2g1W(1,2,3,4,5,6)'
        sub_str  = 'qgtsBth2g1WTNLO(1,2,3,4,5,6)'

      case (214)
        chan_str = 'u db to gt gt nu lp '
        me_str   = 'sBth2g1W(1,3,4,2,5,6)'
        sub_str  = 'qqbsBth2g1WTNLO(1,3,4,2,5,6)'

      case (215)
        chan_str = 'gt u to gt d nu lp  '
        me_str   = 'sBth2g1W(2,1,3,4,5,6)'
        sub_str  = 'gtqsBth2g1WTNLO(2,1,3,4,5,6)'

      case (216)
        chan_str = 'db u to gt gt nu lp '
        me_str   = 'sBth2g1W(2,3,4,1,5,6)'
        sub_str  = 'qbqsBth2g1WTNLO(2,3,4,1,5,6)'

      case (217)
        chan_str = 'gt gt to ub d nu lp '
        me_str   = 'sBth2g1W(3,1,2,4,5,6)'
        sub_str  = 'gtgtsBth2g1WTNLO(3,1,2,4,5,6)'

      case (218)
        chan_str = 'gt db to ub gt nu lp '
        me_str   = 'sBth2g1W(3,1,4,2,5,6)'
        sub_str  = 'gtqbsBth2g1WTNLO(3,1,4,2,5,6)'

      case (219)
        chan_str = 'db gt to ub gt nu lp '
        me_str   = 'sBth2g1W(3,2,4,1,5,6)'
        sub_str  = 'qbgtsBth2g1WTNLO(3,2,4,1,5,6)'

      case (220)
        chan_str = 'u Qb to Qb d nu lp  '
        me_str   = 'sC0g1W(1,2,3,4,5,6) '
        sub_str  = 'qqpbsC0g1WTNLO(1,2,3,4,5,6)'

      case (221)
        chan_str = 'u Q to Q d nu lp    '
        me_str   = 'sC0g1W(1,3,2,4,5,6) '
        sub_str  = 'qqpsC0g1WTNLO(1,3,2,4,5,6)'

      case (222)
        chan_str = 'u db to Q Qb nu lp  '
        me_str   = 'sC0g1W(1,3,4,2,5,6) '
        sub_str  = 'qqbsC0g1WTNLO(1,3,4,2,5,6)'

      case (223)
        chan_str = 'Qb u to Qb d nu lp  '
        me_str   = 'sC0g1W(2,1,3,4,5,6) '
        sub_str  = 'qpbqsC0g1WTNLO(2,1,3,4,5,6)'

      case (224)
        chan_str = 'Q u to Q d nu lp    '
        me_str   = 'sC0g1W(2,3,1,4,5,6) '
        sub_str  = 'qpqsC0g1WTNLO(2,3,1,4,5,6)'

      case (225)
        chan_str = 'db u to Q Qb nu lp  '
        me_str   = 'sC0g1W(2,3,4,1,5,6) '
        sub_str  = 'qbqsC0g1WTNLO(2,3,4,1,5,6)'

      case (226)
        chan_str = 'Qb Q to ub d nu lp  '
        me_str   = 'sC0g1W(3,1,2,4,5,6) '
        sub_str  = 'qpbqpsC0g1WTNLO(3,1,2,4,5,6)'

      case (227)
        chan_str = 'Qb db to ub Qb nu lp '
        me_str   = 'sC0g1W(3,1,4,2,5,6) '
        sub_str  = 'qpbqbsC0g1WTNLO(3,1,4,2,5,6)'

      case (228)
        chan_str = 'Q Qb to ub d nu lp  '
        me_str   = 'sC0g1W(3,2,1,4,5,6) '
        sub_str  = 'qpqpbsC0g1WTNLO(3,2,1,4,5,6)'

      case (229)
        chan_str = 'db Qb to ub Qb nu lp '
        me_str   = 'sC0g1W(3,2,4,1,5,6) '
        sub_str  = 'qbqpbsC0g1WTNLO(3,2,4,1,5,6)'

      case (230)
        chan_str = 'Q db to ub Q nu lp  '
        me_str   = 'sC0g1W(3,4,1,2,5,6) '
        sub_str  = 'qpqbsC0g1WTNLO(3,4,1,2,5,6)'

      case (231)
        chan_str = 'db Q to ub Q nu lp  '
        me_str   = 'sC0g1W(3,4,2,1,5,6) '
        sub_str  = 'qbqpsC0g1WTNLO(3,4,2,1,5,6)'

      case (232)
        chan_str = 'Q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qpgsC0g1WTNLO(1,2,3,4,5,6)'

      case (233)
        chan_str = 'Qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbgsC0g1WTNLO(1,2,3,4,5,6)'

      case (234)
        chan_str = 'g Q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqpsC0g1WTNLO(1,2,3,4,5,6)'

      case (235)
        chan_str = 'g Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqpbsC0g1WTNLO(1,2,3,4,5,6)'

      case (236)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'gqsC0g1WTNLO(1,2,3,4,5,6)'

      case (237)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbsC0g1WTNLO(1,2,3,4,5,6)'

      case (238)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgsC0g1WTNLO(1,2,3,4,5,6)'

      case (239)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgsC0g1WTNLO(1,2,3,4,5,6)'

      case (240)
        chan_str = 'u Qb to Qb d nu lp  '
        me_str   = 'Ct0g1W(1,2,3,4,5,6) '
        sub_str  = 'qqpbCt0g1WTNLO(1,2,3,4,5,6)'

      case (241)
        chan_str = 'u Q to Q d nu lp    '
        me_str   = 'Ct0g1W(1,3,2,4,5,6) '
        sub_str  = 'qqpCt0g1WTNLO(1,3,2,4,5,6)'

      case (242)
        chan_str = 'u db to Q Qb nu lp  '
        me_str   = 'Ct0g1W(1,3,4,2,5,6) '
        sub_str  = 'qqbCt0g1WTNLO(1,3,4,2,5,6)'

      case (243)
        chan_str = 'Qb u to Qb d nu lp  '
        me_str   = 'Ct0g1W(2,1,3,4,5,6) '
        sub_str  = 'qpbqCt0g1WTNLO(2,1,3,4,5,6)'

      case (244)
        chan_str = 'Q u to Q d nu lp    '
        me_str   = 'Ct0g1W(2,3,1,4,5,6) '
        sub_str  = 'qpqCt0g1WTNLO(2,3,1,4,5,6)'

      case (245)
        chan_str = 'db u to Q Qb nu lp  '
        me_str   = 'Ct0g1W(2,3,4,1,5,6) '
        sub_str  = 'qbqCt0g1WTNLO(2,3,4,1,5,6)'

      case (246)
        chan_str = 'Qb Q to ub d nu lp  '
        me_str   = 'Ct0g1W(3,1,2,4,5,6) '
        sub_str  = 'qpbqpCt0g1WTNLO(3,1,2,4,5,6)'

      case (247)
        chan_str = 'Qb db to ub Qb nu lp '
        me_str   = 'Ct0g1W(3,1,4,2,5,6) '
        sub_str  = 'qpbqbCt0g1WTNLO(3,1,4,2,5,6)'

      case (248)
        chan_str = 'Q Qb to ub d nu lp  '
        me_str   = 'Ct0g1W(3,2,1,4,5,6) '
        sub_str  = 'qpqpbCt0g1WTNLO(3,2,1,4,5,6)'

      case (249)
        chan_str = 'db Qb to ub Qb nu lp '
        me_str   = 'Ct0g1W(3,2,4,1,5,6) '
        sub_str  = 'qbqpbCt0g1WTNLO(3,2,4,1,5,6)'

      case (250)
        chan_str = 'Q db to ub Q nu lp  '
        me_str   = 'Ct0g1W(3,4,1,2,5,6) '
        sub_str  = 'qpqbCt0g1WTNLO(3,4,1,2,5,6)'

      case (251)
        chan_str = 'db Q to ub Q nu lp  '
        me_str   = 'Ct0g1W(3,4,2,1,5,6) '
        sub_str  = 'qbqpCt0g1WTNLO(3,4,2,1,5,6)'

      case (252)
        chan_str = 'Q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qpgCt0g1WTNLO(1,2,3,4,5,6)'

      case (253)
        chan_str = 'Qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbgCt0g1WTNLO(1,2,3,4,5,6)'

      case (254)
        chan_str = 'g Q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqpCt0g1WTNLO(1,2,3,4,5,6)'

      case (255)
        chan_str = 'g Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqpbCt0g1WTNLO(1,2,3,4,5,6)'

      case (256)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'gqCt0g1WTNLO(1,2,3,4,5,6)'

      case (257)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbCt0g1WTNLO(1,2,3,4,5,6)'

      case (258)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgCt0g1WTNLO(1,2,3,4,5,6)'

      case (259)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgCt0g1WTNLO(1,2,3,4,5,6)'

      case (260)
        chan_str = 'u Qb to Qb d nu lp  '
        me_str   = 'Ch0g1W(1,2,3,4,5,6) '
        sub_str  = 'qqpbCh0g1WTNLO(1,2,3,4,5,6)'

      case (261)
        chan_str = 'u Q to Q d nu lp    '
        me_str   = 'Ch0g1W(1,3,2,4,5,6) '
        sub_str  = 'qqpCh0g1WTNLO(1,3,2,4,5,6)'

      case (262)
        chan_str = 'u db to Q Qb nu lp  '
        me_str   = 'Ch0g1W(1,3,4,2,5,6) '
        sub_str  = 'qqbCh0g1WTNLO(1,3,4,2,5,6)'

      case (263)
        chan_str = 'Qb u to Qb d nu lp  '
        me_str   = 'Ch0g1W(2,1,3,4,5,6) '
        sub_str  = 'qpbqCh0g1WTNLO(2,1,3,4,5,6)'

      case (264)
        chan_str = 'Q u to Q d nu lp    '
        me_str   = 'Ch0g1W(2,3,1,4,5,6) '
        sub_str  = 'qpqCh0g1WTNLO(2,3,1,4,5,6)'

      case (265)
        chan_str = 'db u to Q Qb nu lp  '
        me_str   = 'Ch0g1W(2,3,4,1,5,6) '
        sub_str  = 'qbqCh0g1WTNLO(2,3,4,1,5,6)'

      case (266)
        chan_str = 'Qb Q to ub d nu lp  '
        me_str   = 'Ch0g1W(3,1,2,4,5,6) '
        sub_str  = 'qpbqpCh0g1WTNLO(3,1,2,4,5,6)'

      case (267)
        chan_str = 'Qb db to ub Qb nu lp '
        me_str   = 'Ch0g1W(3,1,4,2,5,6) '
        sub_str  = 'qpbqbCh0g1WTNLO(3,1,4,2,5,6)'

      case (268)
        chan_str = 'Q Qb to ub d nu lp  '
        me_str   = 'Ch0g1W(3,2,1,4,5,6) '
        sub_str  = 'qpqpbCh0g1WTNLO(3,2,1,4,5,6)'

      case (269)
        chan_str = 'db Qb to ub Qb nu lp '
        me_str   = 'Ch0g1W(3,2,4,1,5,6) '
        sub_str  = 'qbqpbCh0g1WTNLO(3,2,4,1,5,6)'

      case (270)
        chan_str = 'Q db to ub Q nu lp  '
        me_str   = 'Ch0g1W(3,4,1,2,5,6) '
        sub_str  = 'qpqbCh0g1WTNLO(3,4,1,2,5,6)'

      case (271)
        chan_str = 'db Q to ub Q nu lp  '
        me_str   = 'Ch0g1W(3,4,2,1,5,6) '
        sub_str  = 'qbqpCh0g1WTNLO(3,4,2,1,5,6)'

      case (272)
        chan_str = 'Q g subtraction     '
        me_str   = '                    '
        sub_str  = 'qpgCh0g1WTNLO(1,2,3,4,5,6)'

      case (273)
        chan_str = 'Qb g subtraction    '
        me_str   = '                    '
        sub_str  = 'qpbgCh0g1WTNLO(1,2,3,4,5,6)'

      case (274)
        chan_str = 'g Q subtraction     '
        me_str   = '                    '
        sub_str  = 'gqpCh0g1WTNLO(1,2,3,4,5,6)'

      case (275)
        chan_str = 'g Qb subtraction    '
        me_str   = '                    '
        sub_str  = 'gqpbCh0g1WTNLO(1,2,3,4,5,6)'

      case (276)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'gqCh0g1WTNLO(1,2,3,4,5,6)'

      case (277)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gqbCh0g1WTNLO(1,2,3,4,5,6)'

      case (278)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'qgCh0g1WTNLO(1,2,3,4,5,6)'

      case (279)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'qbgCh0g1WTNLO(1,2,3,4,5,6)'

      case (280)
        chan_str = 'u ub to ub d nu lp  '
        me_str   = 'D0g1Wpa(1,2,3,4,5,6)'
        sub_str  = 'qqbD0g1WpaTNLO(1,2,3,4,5,6)'

      case (281)
        chan_str = 'u u to u d nu lp    '
        me_str   = 'D0g1Wpa(1,3,2,4,5,6)'
        sub_str  = 'qqD0g1WpaTNLO(1,3,2,4,5,6)'

      case (282)
        chan_str = 'u db to u ub nu lp  '
        me_str   = 'D0g1Wpa(1,3,4,2,5,6)'
        sub_str  = 'qqpbD0g1WpaTNLO(1,3,4,2,5,6)'

      case (283)
        chan_str = 'ub u to ub d nu lp  '
        me_str   = 'D0g1Wpa(2,1,3,4,5,6)'
        sub_str  = 'qbqD0g1WpaTNLO(2,1,3,4,5,6)'

      case (284)
        chan_str = 'db u to u ub nu lp  '
        me_str   = 'D0g1Wpa(2,3,4,1,5,6)'
        sub_str  = 'qpbqD0g1WpaTNLO(2,3,4,1,5,6)'

      case (285)
        chan_str = 'ub db to ub ub nu lp '
        me_str   = 'D0g1Wpa(3,1,4,2,5,6)'
        sub_str  = 'qbqpbD0g1WpaTNLO(3,1,4,2,5,6)'

      case (286)
        chan_str = 'db ub to ub ub nu lp '
        me_str   = 'D0g1Wpa(3,2,4,1,5,6)'
        sub_str  = 'qpbqbD0g1WpaTNLO(3,2,4,1,5,6)'

      case (287)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'dgD0g1WpaTNLO(1,2,3,4,5,6)'

      case (288)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gdD0g1WpaTNLO(1,2,3,4,5,6)'

      case (289)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'guD0g1WpaTNLO(1,2,3,4,5,6)'

      case (290)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gubD0g1WpaTNLO(1,2,3,4,5,6)'

      case (291)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'ugD0g1WpaTNLO(1,2,3,4,5,6)'

      case (292)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'ubgD0g1WpaTNLO(1,2,3,4,5,6)'

      case (293)
        chan_str = 'u db to db d nu lp  '
        me_str   = 'D0g1Wpb(1,2,3,4,5,6)'
        sub_str  = 'qqpbD0g1WpbTNLO(1,2,3,4,5,6)'

      case (294)
        chan_str = 'u d to d d nu lp    '
        me_str   = 'D0g1Wpb(1,3,2,4,5,6)'
        sub_str  = 'qqpD0g1WpbTNLO(1,3,2,4,5,6)'

      case (295)
        chan_str = 'db u to db d nu lp  '
        me_str   = 'D0g1Wpb(2,1,3,4,5,6)'
        sub_str  = 'qpbqD0g1WpbTNLO(2,1,3,4,5,6)'

      case (296)
        chan_str = 'd u to d d nu lp    '
        me_str   = 'D0g1Wpb(2,3,1,4,5,6)'
        sub_str  = 'qpqD0g1WpbTNLO(2,3,1,4,5,6)'

      case (297)
        chan_str = 'db d to ub d nu lp  '
        me_str   = 'D0g1Wpb(3,1,2,4,5,6)'
        sub_str  = 'qpbqpD0g1WpbTNLO(3,1,2,4,5,6)'

      case (298)
        chan_str = 'db db to ub db nu lp '
        me_str   = 'D0g1Wpb(3,1,4,2,5,6)'
        sub_str  = 'qpbqpbD0g1WpbTNLO(3,1,4,2,5,6)'

      case (299)
        chan_str = 'd db to ub d nu lp  '
        me_str   = 'D0g1Wpb(3,2,1,4,5,6)'
        sub_str  = 'qpqpbD0g1WpbTNLO(3,2,1,4,5,6)'

      case (300)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'dgD0g1WpbTNLO(1,2,3,4,5,6)'

      case (301)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'dbgD0g1WpbTNLO(1,2,3,4,5,6)'

      case (302)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gdD0g1WpbTNLO(1,2,3,4,5,6)'

      case (303)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gdbD0g1WpbTNLO(1,2,3,4,5,6)'

      case (304)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gubD0g1WpbTNLO(1,2,3,4,5,6)'

      case (305)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'ubgD0g1WpbTNLO(1,2,3,4,5,6)'

      case (306)
        chan_str = 'u ub to ub d nu lp  '
        me_str   = 'Dt0g1Wpa(1,2,3,4,5,6)'
        sub_str  = 'qqbDt0g1WpaTNLO(1,2,3,4,5,6)'

      case (307)
        chan_str = 'u u to u d nu lp    '
        me_str   = 'Dt0g1Wpa(1,3,2,4,5,6)'
        sub_str  = 'qqDt0g1WpaTNLO(1,3,2,4,5,6)'

      case (308)
        chan_str = 'u db to u ub nu lp  '
        me_str   = 'Dt0g1Wpa(1,3,4,2,5,6)'
        sub_str  = 'qqpbDt0g1WpaTNLO(1,3,4,2,5,6)'

      case (309)
        chan_str = 'ub u to ub d nu lp  '
        me_str   = 'Dt0g1Wpa(2,1,3,4,5,6)'
        sub_str  = 'qbqDt0g1WpaTNLO(2,1,3,4,5,6)'

      case (310)
        chan_str = 'db u to u ub nu lp  '
        me_str   = 'Dt0g1Wpa(2,3,4,1,5,6)'
        sub_str  = 'qpbqDt0g1WpaTNLO(2,3,4,1,5,6)'

      case (311)
        chan_str = 'ub db to ub ub nu lp '
        me_str   = 'Dt0g1Wpa(3,1,4,2,5,6)'
        sub_str  = 'qbqpbDt0g1WpaTNLO(3,1,4,2,5,6)'

      case (312)
        chan_str = 'db ub to ub ub nu lp '
        me_str   = 'Dt0g1Wpa(3,2,4,1,5,6)'
        sub_str  = 'qpbqbDt0g1WpaTNLO(3,2,4,1,5,6)'

      case (313)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'dgDt0g1WpaTNLO(1,2,3,4,5,6)'

      case (314)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gdDt0g1WpaTNLO(1,2,3,4,5,6)'

      case (315)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'guDt0g1WpaTNLO(1,2,3,4,5,6)'

      case (316)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gubDt0g1WpaTNLO(1,2,3,4,5,6)'

      case (317)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'ugDt0g1WpaTNLO(1,2,3,4,5,6)'

      case (318)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'ubgDt0g1WpaTNLO(1,2,3,4,5,6)'

      case (319)
        chan_str = 'u db to db d nu lp  '
        me_str   = 'Dt0g1Wpb(1,2,3,4,5,6)'
        sub_str  = 'qqpbDt0g1WpbTNLO(1,2,3,4,5,6)'

      case (320)
        chan_str = 'u d to d d nu lp    '
        me_str   = 'Dt0g1Wpb(1,3,2,4,5,6)'
        sub_str  = 'qqpDt0g1WpbTNLO(1,3,2,4,5,6)'

      case (321)
        chan_str = 'db u to db d nu lp  '
        me_str   = 'Dt0g1Wpb(2,1,3,4,5,6)'
        sub_str  = 'qpbqDt0g1WpbTNLO(2,1,3,4,5,6)'

      case (322)
        chan_str = 'd u to d d nu lp    '
        me_str   = 'Dt0g1Wpb(2,3,1,4,5,6)'
        sub_str  = 'qpqDt0g1WpbTNLO(2,3,1,4,5,6)'

      case (323)
        chan_str = 'db d to ub d nu lp  '
        me_str   = 'Dt0g1Wpb(3,1,2,4,5,6)'
        sub_str  = 'qpbqpDt0g1WpbTNLO(3,1,2,4,5,6)'

      case (324)
        chan_str = 'db db to ub db nu lp '
        me_str   = 'Dt0g1Wpb(3,1,4,2,5,6)'
        sub_str  = 'qpbqpbDt0g1WpbTNLO(3,1,4,2,5,6)'

      case (325)
        chan_str = 'd db to ub d nu lp  '
        me_str   = 'Dt0g1Wpb(3,2,1,4,5,6)'
        sub_str  = 'qpqpbDt0g1WpbTNLO(3,2,1,4,5,6)'

      case (326)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'dgDt0g1WpbTNLO(1,2,3,4,5,6)'

      case (327)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'dbgDt0g1WpbTNLO(1,2,3,4,5,6)'

      case (328)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gdDt0g1WpbTNLO(1,2,3,4,5,6)'

      case (329)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gdbDt0g1WpbTNLO(1,2,3,4,5,6)'

      case (330)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gubDt0g1WpbTNLO(1,2,3,4,5,6)'

      case (331)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'ubgDt0g1WpbTNLO(1,2,3,4,5,6)'

      case (332)
        chan_str = 'u ub to ub d nu lp  '
        me_str   = 'Dh0g1Wpa(1,2,3,4,5,6)'
        sub_str  = 'qqbDh0g1WpaTNLO(1,2,3,4,5,6)'

      case (333)
        chan_str = 'u u to u d nu lp    '
        me_str   = 'Dh0g1Wpa(1,3,2,4,5,6)'
        sub_str  = 'qqDh0g1WpaTNLO(1,3,2,4,5,6)'

      case (334)
        chan_str = 'u db to u ub nu lp  '
        me_str   = 'Dh0g1Wpa(1,3,4,2,5,6)'
        sub_str  = 'qqpbDh0g1WpaTNLO(1,3,4,2,5,6)'

      case (335)
        chan_str = 'ub u to ub d nu lp  '
        me_str   = 'Dh0g1Wpa(2,1,3,4,5,6)'
        sub_str  = 'qbqDh0g1WpaTNLO(2,1,3,4,5,6)'

      case (336)
        chan_str = 'db u to u ub nu lp  '
        me_str   = 'Dh0g1Wpa(2,3,4,1,5,6)'
        sub_str  = 'qpbqDh0g1WpaTNLO(2,3,4,1,5,6)'

      case (337)
        chan_str = 'ub db to ub ub nu lp '
        me_str   = 'Dh0g1Wpa(3,1,4,2,5,6)'
        sub_str  = 'qbqpbDh0g1WpaTNLO(3,1,4,2,5,6)'

      case (338)
        chan_str = 'db ub to ub ub nu lp '
        me_str   = 'Dh0g1Wpa(3,2,4,1,5,6)'
        sub_str  = 'qpbqbDh0g1WpaTNLO(3,2,4,1,5,6)'

      case (339)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'dgDh0g1WpaTNLO(1,2,3,4,5,6)'

      case (340)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gdDh0g1WpaTNLO(1,2,3,4,5,6)'

      case (341)
        chan_str = 'g u subtraction     '
        me_str   = '                    '
        sub_str  = 'guDh0g1WpaTNLO(1,2,3,4,5,6)'

      case (342)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gubDh0g1WpaTNLO(1,2,3,4,5,6)'

      case (343)
        chan_str = 'u g subtraction     '
        me_str   = '                    '
        sub_str  = 'ugDh0g1WpaTNLO(1,2,3,4,5,6)'

      case (344)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'ubgDh0g1WpaTNLO(1,2,3,4,5,6)'

      case (345)
        chan_str = 'u db to db d nu lp  '
        me_str   = 'Dh0g1Wpb(1,2,3,4,5,6)'
        sub_str  = 'qqpbDh0g1WpbTNLO(1,2,3,4,5,6)'

      case (346)
        chan_str = 'u d to d d nu lp    '
        me_str   = 'Dh0g1Wpb(1,3,2,4,5,6)'
        sub_str  = 'qqpDh0g1WpbTNLO(1,3,2,4,5,6)'

      case (347)
        chan_str = 'db u to db d nu lp  '
        me_str   = 'Dh0g1Wpb(2,1,3,4,5,6)'
        sub_str  = 'qpbqDh0g1WpbTNLO(2,1,3,4,5,6)'

      case (348)
        chan_str = 'd u to d d nu lp    '
        me_str   = 'Dh0g1Wpb(2,3,1,4,5,6)'
        sub_str  = 'qpqDh0g1WpbTNLO(2,3,1,4,5,6)'

      case (349)
        chan_str = 'db d to ub d nu lp  '
        me_str   = 'Dh0g1Wpb(3,1,2,4,5,6)'
        sub_str  = 'qpbqpDh0g1WpbTNLO(3,1,2,4,5,6)'

      case (350)
        chan_str = 'db db to ub db nu lp '
        me_str   = 'Dh0g1Wpb(3,1,4,2,5,6)'
        sub_str  = 'qpbqpbDh0g1WpbTNLO(3,1,4,2,5,6)'

      case (351)
        chan_str = 'd db to ub d nu lp  '
        me_str   = 'Dh0g1Wpb(3,2,1,4,5,6)'
        sub_str  = 'qpqpbDh0g1WpbTNLO(3,2,1,4,5,6)'

      case (352)
        chan_str = 'd g subtraction     '
        me_str   = '                    '
        sub_str  = 'dgDh0g1WpbTNLO(1,2,3,4,5,6)'

      case (353)
        chan_str = 'db g subtraction    '
        me_str   = '                    '
        sub_str  = 'dbgDh0g1WpbTNLO(1,2,3,4,5,6)'

      case (354)
        chan_str = 'g d subtraction     '
        me_str   = '                    '
        sub_str  = 'gdDh0g1WpbTNLO(1,2,3,4,5,6)'

      case (355)
        chan_str = 'g db subtraction    '
        me_str   = '                    '
        sub_str  = 'gdbDh0g1WpbTNLO(1,2,3,4,5,6)'

      case (356)
        chan_str = 'g ub subtraction    '
        me_str   = '                    '
        sub_str  = 'gubDh0g1WpbTNLO(1,2,3,4,5,6)'

      case (357)
        chan_str = 'ub g subtraction    '
        me_str   = '                    '
        sub_str  = 'ubgDh0g1WpbTNLO(1,2,3,4,5,6)'

      case default
        print*, 'getchannelWpJJ: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtWpJJ(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtWpJJ = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (2)
        ! [g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (4)
        ! [g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (9)
        ! [gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (11)
        ! [gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (32)
        ! [ub, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (33)
        ! [ub, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (35)
        ! [d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (37)
        ! [d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (41)
        ! [g, g, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (42)
        ! [g, g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4,5 /))

      case (43)
        ! [g, g, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (44)
        ! [g, g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4,5 /))

      case (46)
        ! [ub, g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (47)
        ! [ub, g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (48)
        ! [g, g, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (49)
        ! [g, g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4,5 /))

      case (50)
        ! [g, g, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (51)
        ! [g, g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4,5 /))

      case (53)
        ! [ub, g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (54)
        ! [ub, g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (55)
        ! [gt, gt, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (56)
        ! [gt, gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4,5 /))

      case (57)
        ! [gt, gt, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (58)
        ! [gt, gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4,5 /))

      case (60)
        ! [ub, gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (61)
        ! [ub, gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (109)
        ! [ub, ub, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (110)
        ! [ub, u, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (111)
        ! [ub, ub, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (112)
        ! [ub, u, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (113)
        ! [ub, g, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (114)
        ! [ub, g, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (115)
        ! [d, db, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (117)
        ! [g, d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (118)
        ! [d, db, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (120)
        ! [g, d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (122)
        ! [ub, d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (124)
        ! [ub, d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (135)
        ! [ub, ub, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (136)
        ! [ub, u, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (137)
        ! [ub, ub, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (138)
        ! [ub, u, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (139)
        ! [ub, g, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (140)
        ! [ub, g, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (141)
        ! [d, db, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (143)
        ! [g, d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (144)
        ! [d, db, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,5 /))

      case (146)
        ! [g, d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (148)
        ! [ub, d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (150)
        ! [ub, d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 4,5 /))

      case (155)
        ! [g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (157)
        ! [g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (170)
        ! [g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (172)
        ! [g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (185)
        ! [gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (187)
        ! [gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (192)
        ! [gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (194)
        ! [gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (199)
        ! [g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (201)
        ! [g, g, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (214)
        ! [gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (216)
        ! [gt, gt, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (285)
        ! [ub, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (286)
        ! [ub, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (294)
        ! [d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (296)
        ! [d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (311)
        ! [ub, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (312)
        ! [ub, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (320)
        ! [d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (322)
        ! [d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (337)
        ! [ub, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (338)
        ! [ub, ub, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (346)
        ! [d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case (348)
        ! [d, d, nu, lp]
        LIPSwgtWpJJ = weight_lips((/ 3,4 /))

      case default
        LIPSwgtWpJJ = 1

      end select
      end
