      function sigSNLOWpJJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLOWpJJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- u g to g g d nu lp  
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qgsB3g0WSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g g g nu lp 
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = 20
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .true.
        wt = qqbsB3g0WSNLO(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to g g d nu lp  
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .false.
        wt = gqsB3g0WSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to g g g nu lp 
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = -40
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .true.
        wt = qbqsB3g0WSNLO(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g g to ub g d nu lp 
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = ggsB3g0WSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to ub g g nu lp 
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = 0
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .false.
        wt = gqbsB3g0WSNLO(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to ub g g nu lp 
      if (qactive_chan(47).and.qselect_chan(47)) then
        current_chan = 47
        ip1_chan     = -40
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qbgsB3g0WSNLO(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to g g d nu lp  
      if (qactive_chan(48).and.qselect_chan(48)) then
        current_chan = 48
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qgsBt3g0WSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g g g nu lp 
      if (qactive_chan(49).and.qselect_chan(49)) then
        current_chan = 49
        ip1_chan     = 20
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .true.
        wt = qqbsBt3g0WSNLO(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to g g d nu lp  
      if (qactive_chan(50).and.qselect_chan(50)) then
        current_chan = 50
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .false.
        wt = gqsBt3g0WSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to g g g nu lp 
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = -40
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .true.
        wt = qbqsBt3g0WSNLO(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g g to ub g d nu lp 
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = ggsBt3g0WSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to ub g g nu lp 
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = 0
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .false.
        wt = gqbsBt3g0WSNLO(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to ub g g nu lp 
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = -40
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qbgsBt3g0WSNLO(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- u gt to gt gt d nu lp 
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qgtsBtt3g0WSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to gt gt gt nu lp 
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = 20
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .true.
        wt = qqbsBtt3g0WSNLO(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- gt u to gt gt d nu lp 
      if (qactive_chan(57).and.qselect_chan(57)) then
        current_chan = 57
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .false.
        wt = gtqsBtt3g0WSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to gt gt gt nu lp 
      if (qactive_chan(58).and.qselect_chan(58)) then
        current_chan = 58
        ip1_chan     = -40
        ip2_chan     = 20
        nfB1 = 1
          ckmflag = .true.
        wt = qbqsBtt3g0WSNLO(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- gt gt to ub gt d nu lp 
      if (qactive_chan(59).and.qselect_chan(59)) then
        current_chan = 59
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = gtgtsBtt3g0WSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- gt db to ub gt gt nu lp 
      if (qactive_chan(60).and.qselect_chan(60)) then
        current_chan = 60
        ip1_chan     = 0
        ip2_chan     = -40
        nfB1 = 1
          ckmflag = .false.
        wt = gtqbsBtt3g0WSNLO(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db gt to ub gt gt nu lp 
      if (qactive_chan(61).and.qselect_chan(61)) then
        current_chan = 61
        ip1_chan     = -40
        ip2_chan     = 0
        nfB1 = 1
          ckmflag = .false.
        wt = qbgtsBtt3g0WSNLO(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to Q Qb d nu lp 
      if (qactive_chan(62).and.qselect_chan(62)) then
        current_chan = 62
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qgsC1g0WSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u Qb to g Qb d nu lp 
      if (qactive_chan(63).and.qselect_chan(63)) then
        current_chan = 63
        ip1_chan     = 21
        ip2_chan     = -31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qqpbsC1g0WSNLO(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u Q to g Q d nu lp  
      if (qactive_chan(64).and.qselect_chan(64)) then
        current_chan = 64
        ip1_chan     = 21
        ip2_chan     = 31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qqpsC1g0WSNLO(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g Q Qb nu lp 
      if (qactive_chan(65).and.qselect_chan(65)) then
        current_chan = 65
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 4
          ckmflag = .true.
        wt = qqbsC1g0WSNLO(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to Q Qb d nu lp 
      if (qactive_chan(66).and.qselect_chan(66)) then
        current_chan = 66
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = gqsC1g0WSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb u to g Qb d nu lp 
      if (qactive_chan(67).and.qselect_chan(67)) then
        current_chan = 67
        ip1_chan     = -31
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqsC1g0WSNLO(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Q u to g Q d nu lp  
      if (qactive_chan(68).and.qselect_chan(68)) then
        current_chan = 68
        ip1_chan     = 31
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqsC1g0WSNLO(2,3,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to g Q Qb nu lp 
      if (qactive_chan(69).and.qselect_chan(69)) then
        current_chan = 69
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 4
          ckmflag = .true.
        wt = qbqsC1g0WSNLO(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g Qb to ub Qb d nu lp 
      if (qactive_chan(70).and.qselect_chan(70)) then
        current_chan = 70
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = gqpbsC1g0WSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g Q to ub Q d nu lp 
      if (qactive_chan(71).and.qselect_chan(71)) then
        current_chan = 71
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = gqpsC1g0WSNLO(3,1,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to ub Q Qb nu lp 
      if (qactive_chan(72).and.qselect_chan(72)) then
        current_chan = 72
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = gqbsC1g0WSNLO(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb g to ub Qb d nu lp 
      if (qactive_chan(73).and.qselect_chan(73)) then
        current_chan = 73
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbgsC1g0WSNLO(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Q g to ub Q d nu lp 
      if (qactive_chan(74).and.qselect_chan(74)) then
        current_chan = 74
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpgsC1g0WSNLO(3,2,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to ub Q Qb nu lp 
      if (qactive_chan(75).and.qselect_chan(75)) then
        current_chan = 75
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qbgsC1g0WSNLO(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb Q to ub g d nu lp 
      if (qactive_chan(76).and.qselect_chan(76)) then
        current_chan = 76
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqpsC1g0WSNLO(3,4,1,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb db to ub g Qb nu lp 
      if (qactive_chan(77).and.qselect_chan(77)) then
        current_chan = 77
        ip1_chan     = -31
        ip2_chan     = -41
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqbsC1g0WSNLO(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- Q Qb to ub g d nu lp 
      if (qactive_chan(78).and.qselect_chan(78)) then
        current_chan = 78
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqpbsC1g0WSNLO(3,4,2,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db Qb to ub g Qb nu lp 
      if (qactive_chan(79).and.qselect_chan(79)) then
        current_chan = 79
        ip1_chan     = -41
        ip2_chan     = -31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpbsC1g0WSNLO(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- Q db to ub g Q nu lp 
      if (qactive_chan(80).and.qselect_chan(80)) then
        current_chan = 80
        ip1_chan     = 31
        ip2_chan     = -41
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqbsC1g0WSNLO(3,4,5,1,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db Q to ub g Q nu lp 
      if (qactive_chan(81).and.qselect_chan(81)) then
        current_chan = 81
        ip1_chan     = -41
        ip2_chan     = 31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpsC1g0WSNLO(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to Q Qb d nu lp 
      if (qactive_chan(82).and.qselect_chan(82)) then
        current_chan = 82
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qgsCt1g0WSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u Qb to g Qb d nu lp 
      if (qactive_chan(83).and.qselect_chan(83)) then
        current_chan = 83
        ip1_chan     = 21
        ip2_chan     = -31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qqpbsCt1g0WSNLO(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u Q to g Q d nu lp  
      if (qactive_chan(84).and.qselect_chan(84)) then
        current_chan = 84
        ip1_chan     = 21
        ip2_chan     = 31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qqpsCt1g0WSNLO(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g Q Qb nu lp 
      if (qactive_chan(85).and.qselect_chan(85)) then
        current_chan = 85
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 4
          ckmflag = .true.
        wt = qqbsCt1g0WSNLO(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to Q Qb d nu lp 
      if (qactive_chan(86).and.qselect_chan(86)) then
        current_chan = 86
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = gqsCt1g0WSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb u to g Qb d nu lp 
      if (qactive_chan(87).and.qselect_chan(87)) then
        current_chan = 87
        ip1_chan     = -31
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqsCt1g0WSNLO(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Q u to g Q d nu lp  
      if (qactive_chan(88).and.qselect_chan(88)) then
        current_chan = 88
        ip1_chan     = 31
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqsCt1g0WSNLO(2,3,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to g Q Qb nu lp 
      if (qactive_chan(89).and.qselect_chan(89)) then
        current_chan = 89
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 4
          ckmflag = .true.
        wt = qbqsCt1g0WSNLO(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g Qb to ub Qb d nu lp 
      if (qactive_chan(90).and.qselect_chan(90)) then
        current_chan = 90
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = gqpbsCt1g0WSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g Q to ub Q d nu lp 
      if (qactive_chan(91).and.qselect_chan(91)) then
        current_chan = 91
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = gqpsCt1g0WSNLO(3,1,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to ub Q Qb nu lp 
      if (qactive_chan(92).and.qselect_chan(92)) then
        current_chan = 92
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = gqbsCt1g0WSNLO(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb g to ub Qb d nu lp 
      if (qactive_chan(93).and.qselect_chan(93)) then
        current_chan = 93
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbgsCt1g0WSNLO(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Q g to ub Q d nu lp 
      if (qactive_chan(94).and.qselect_chan(94)) then
        current_chan = 94
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpgsCt1g0WSNLO(3,2,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to ub Q Qb nu lp 
      if (qactive_chan(95).and.qselect_chan(95)) then
        current_chan = 95
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qbgsCt1g0WSNLO(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb Q to ub g d nu lp 
      if (qactive_chan(96).and.qselect_chan(96)) then
        current_chan = 96
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqpsCt1g0WSNLO(3,4,1,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb db to ub g Qb nu lp 
      if (qactive_chan(97).and.qselect_chan(97)) then
        current_chan = 97
        ip1_chan     = -31
        ip2_chan     = -41
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqbsCt1g0WSNLO(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- Q Qb to ub g d nu lp 
      if (qactive_chan(98).and.qselect_chan(98)) then
        current_chan = 98
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqpbsCt1g0WSNLO(3,4,2,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db Qb to ub g Qb nu lp 
      if (qactive_chan(99).and.qselect_chan(99)) then
        current_chan = 99
        ip1_chan     = -41
        ip2_chan     = -31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpbsCt1g0WSNLO(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- Q db to ub g Q nu lp 
      if (qactive_chan(100).and.qselect_chan(100)) then
        current_chan = 100
        ip1_chan     = 31
        ip2_chan     = -41
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qpqbsCt1g0WSNLO(3,4,5,1,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db Q to ub g Q nu lp 
      if (qactive_chan(101).and.qselect_chan(101)) then
        current_chan = 101
        ip1_chan     = -41
        ip2_chan     = 31
        nfC1 = 1
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpsCt1g0WSNLO(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to u ub d nu lp 
      if (qactive_chan(102).and.qselect_chan(102)) then
        current_chan = 102
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qgD1g0WpacSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub d nu lp 
      if (qactive_chan(103).and.qselect_chan(103)) then
        current_chan = 103
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqbD1g0WpacSNLO(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u u to g u d nu lp  
      if (qactive_chan(104).and.qselect_chan(104)) then
        current_chan = 104
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqD1g0WpacSNLO(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g u ub nu lp 
      if (qactive_chan(105).and.qselect_chan(105)) then
        current_chan = 105
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qqpbD1g0WpacSNLO(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to u ub d nu lp 
      if (qactive_chan(106).and.qselect_chan(106)) then
        current_chan = 106
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqD1g0WpacSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g ub d nu lp 
      if (qactive_chan(107).and.qselect_chan(107)) then
        current_chan = 107
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqD1g0WpacSNLO(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to g u ub nu lp 
      if (qactive_chan(108).and.qselect_chan(108)) then
        current_chan = 108
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qpbqD1g0WpacSNLO(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub ub d nu lp 
      if (qactive_chan(109).and.qselect_chan(109)) then
        current_chan = 109
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqbD1g0WpacSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to ub u ub nu lp 
      if (qactive_chan(110).and.qselect_chan(110)) then
        current_chan = 110
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqpbD1g0WpacSNLO(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub ub d nu lp 
      if (qactive_chan(111).and.qselect_chan(111)) then
        current_chan = 111
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbgD1g0WpacSNLO(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to ub u ub nu lp 
      if (qactive_chan(112).and.qselect_chan(112)) then
        current_chan = 112
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpbgD1g0WpacSNLO(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub db to ub g ub nu lp 
      if (qactive_chan(113).and.qselect_chan(113)) then
        current_chan = 113
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqpbD1g0WpacSNLO(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db ub to ub g ub nu lp 
      if (qactive_chan(114).and.qselect_chan(114)) then
        current_chan = 114
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpbqbD1g0WpacSNLO(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to d db d nu lp 
      if (qactive_chan(115).and.qselect_chan(115)) then
        current_chan = 115
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qgD1g0WpbcSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g db d nu lp 
      if (qactive_chan(116).and.qselect_chan(116)) then
        current_chan = 116
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qqpbD1g0WpbcSNLO(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u d to g d d nu lp  
      if (qactive_chan(117).and.qselect_chan(117)) then
        current_chan = 117
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qqpD1g0WpbcSNLO(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to d db d nu lp 
      if (qactive_chan(118).and.qselect_chan(118)) then
        current_chan = 118
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqD1g0WpbcSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to g db d nu lp 
      if (qactive_chan(119).and.qselect_chan(119)) then
        current_chan = 119
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qpbqD1g0WpbcSNLO(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d u to g d d nu lp  
      if (qactive_chan(120).and.qselect_chan(120)) then
        current_chan = 120
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqD1g0WpbcSNLO(2,3,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to ub db d nu lp 
      if (qactive_chan(121).and.qselect_chan(121)) then
        current_chan = 121
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqpbD1g0WpbcSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to ub d d nu lp 
      if (qactive_chan(122).and.qselect_chan(122)) then
        current_chan = 122
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqpD1g0WpbcSNLO(3,1,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to ub db d nu lp 
      if (qactive_chan(123).and.qselect_chan(123)) then
        current_chan = 123
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbgD1g0WpbcSNLO(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to ub d d nu lp 
      if (qactive_chan(124).and.qselect_chan(124)) then
        current_chan = 124
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpgD1g0WpbcSNLO(3,2,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to ub g d nu lp 
      if (qactive_chan(125).and.qselect_chan(125)) then
        current_chan = 125
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqpD1g0WpbcSNLO(3,4,1,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db db to ub g db nu lp 
      if (qactive_chan(126).and.qselect_chan(126)) then
        current_chan = 126
        ip1_chan     = -40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqpbD1g0WpbcSNLO(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to ub g d nu lp 
      if (qactive_chan(127).and.qselect_chan(127)) then
        current_chan = 127
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqpbD1g0WpbcSNLO(3,4,2,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to u ub d nu lp 
      if (qactive_chan(128).and.qselect_chan(128)) then
        current_chan = 128
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qgDt1g0WpaSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub d nu lp 
      if (qactive_chan(129).and.qselect_chan(129)) then
        current_chan = 129
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqbDt1g0WpaSNLO(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u u to g u d nu lp  
      if (qactive_chan(130).and.qselect_chan(130)) then
        current_chan = 130
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqDt1g0WpaSNLO(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g u ub nu lp 
      if (qactive_chan(131).and.qselect_chan(131)) then
        current_chan = 131
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qqpbDt1g0WpaSNLO(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to u ub d nu lp 
      if (qactive_chan(132).and.qselect_chan(132)) then
        current_chan = 132
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqDt1g0WpaSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g ub d nu lp 
      if (qactive_chan(133).and.qselect_chan(133)) then
        current_chan = 133
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqDt1g0WpaSNLO(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to g u ub nu lp 
      if (qactive_chan(134).and.qselect_chan(134)) then
        current_chan = 134
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qpbqDt1g0WpaSNLO(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub ub d nu lp 
      if (qactive_chan(135).and.qselect_chan(135)) then
        current_chan = 135
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqbDt1g0WpaSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to ub u ub nu lp 
      if (qactive_chan(136).and.qselect_chan(136)) then
        current_chan = 136
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqpbDt1g0WpaSNLO(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub ub d nu lp 
      if (qactive_chan(137).and.qselect_chan(137)) then
        current_chan = 137
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbgDt1g0WpaSNLO(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to ub u ub nu lp 
      if (qactive_chan(138).and.qselect_chan(138)) then
        current_chan = 138
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpbgDt1g0WpaSNLO(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub db to ub g ub nu lp 
      if (qactive_chan(139).and.qselect_chan(139)) then
        current_chan = 139
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqpbDt1g0WpaSNLO(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db ub to ub g ub nu lp 
      if (qactive_chan(140).and.qselect_chan(140)) then
        current_chan = 140
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpbqbDt1g0WpaSNLO(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to d db d nu lp 
      if (qactive_chan(141).and.qselect_chan(141)) then
        current_chan = 141
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qgDt1g0WpbSNLO(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g db d nu lp 
      if (qactive_chan(142).and.qselect_chan(142)) then
        current_chan = 142
        ip1_chan     = 20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qqpbDt1g0WpbSNLO(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u d to g d d nu lp  
      if (qactive_chan(143).and.qselect_chan(143)) then
        current_chan = 143
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qqpDt1g0WpbSNLO(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to d db d nu lp 
      if (qactive_chan(144).and.qselect_chan(144)) then
        current_chan = 144
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqDt1g0WpbSNLO(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to g db d nu lp 
      if (qactive_chan(145).and.qselect_chan(145)) then
        current_chan = 145
        ip1_chan     = -40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qpbqDt1g0WpbSNLO(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d u to g d d nu lp  
      if (qactive_chan(146).and.qselect_chan(146)) then
        current_chan = 146
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqDt1g0WpbSNLO(2,3,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to ub db d nu lp 
      if (qactive_chan(147).and.qselect_chan(147)) then
        current_chan = 147
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqpbDt1g0WpbSNLO(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to ub d d nu lp 
      if (qactive_chan(148).and.qselect_chan(148)) then
        current_chan = 148
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqpDt1g0WpbSNLO(3,1,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to ub db d nu lp 
      if (qactive_chan(149).and.qselect_chan(149)) then
        current_chan = 149
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbgDt1g0WpbSNLO(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to ub d d nu lp 
      if (qactive_chan(150).and.qselect_chan(150)) then
        current_chan = 150
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpgDt1g0WpbSNLO(3,2,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to ub g d nu lp 
      if (qactive_chan(151).and.qselect_chan(151)) then
        current_chan = 151
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqpDt1g0WpbSNLO(3,4,1,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db db to ub g db nu lp 
      if (qactive_chan(152).and.qselect_chan(152)) then
        current_chan = 152
        ip1_chan     = -40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqpbDt1g0WpbSNLO(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to ub g d nu lp 
      if (qactive_chan(153).and.qselect_chan(153)) then
        current_chan = 153
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqpbDt1g0WpbSNLO(3,4,2,1,5,6,7)
        wtsum = wtsum + wt
      endif
      sigSNLOWpJJ=sigSNLOWpJJ+rnorm*wtsum

      return
      end
