      function sigTNLOWmJJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLOWmJJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(6,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(6,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d g to g u lm nub   
        if (qactive_chan(154).and.qselect_chan(154)) then
          current_chan = 154
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g g lm nub  
        if (qactive_chan(155).and.qselect_chan(155)) then
          current_chan = 155
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbsB2g1WTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g u lm nub   
        if (qactive_chan(156).and.qselect_chan(156)) then
          current_chan = 156
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gqsB2g1WTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g g lm nub  
        if (qactive_chan(157).and.qselect_chan(157)) then
          current_chan = 157
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqsB2g1WTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db u lm nub  
        if (qactive_chan(158).and.qselect_chan(158)) then
          current_chan = 158
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ggsB2g1WTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db g lm nub 
        if (qactive_chan(159).and.qselect_chan(159)) then
          current_chan = 159
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gqbsB2g1WTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db g lm nub 
        if (qactive_chan(160).and.qselect_chan(160)) then
          current_chan = 160
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgsB2g1WTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(161).and.qselect_chan(161)) then
          current_chan = 161
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(162).and.qselect_chan(162)) then
          current_chan = 162
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(163).and.qselect_chan(163)) then
          current_chan = 163
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(164).and.qselect_chan(164)) then
          current_chan = 164
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(165).and.qselect_chan(165)) then
          current_chan = 165
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(166).and.qselect_chan(166)) then
          current_chan = 166
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(167).and.qselect_chan(167)) then
          current_chan = 167
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(168).and.qselect_chan(168)) then
          current_chan = 168
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbsB2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to g u lm nub   
        if (qactive_chan(169).and.qselect_chan(169)) then
          current_chan = 169
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g g lm nub  
        if (qactive_chan(170).and.qselect_chan(170)) then
          current_chan = 170
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbsBt2g1WTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g u lm nub   
        if (qactive_chan(171).and.qselect_chan(171)) then
          current_chan = 171
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gqsBt2g1WTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g g lm nub  
        if (qactive_chan(172).and.qselect_chan(172)) then
          current_chan = 172
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqsBt2g1WTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db u lm nub  
        if (qactive_chan(173).and.qselect_chan(173)) then
          current_chan = 173
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ggsBt2g1WTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db g lm nub 
        if (qactive_chan(174).and.qselect_chan(174)) then
          current_chan = 174
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gqbsBt2g1WTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db g lm nub 
        if (qactive_chan(175).and.qselect_chan(175)) then
          current_chan = 175
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgsBt2g1WTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(176).and.qselect_chan(176)) then
          current_chan = 176
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(177).and.qselect_chan(177)) then
          current_chan = 177
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(178).and.qselect_chan(178)) then
          current_chan = 178
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(179).and.qselect_chan(179)) then
          current_chan = 179
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(180).and.qselect_chan(180)) then
          current_chan = 180
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(181).and.qselect_chan(181)) then
          current_chan = 181
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(182).and.qselect_chan(182)) then
          current_chan = 182
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(183).and.qselect_chan(183)) then
          current_chan = 183
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbsBt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt u lm nub 
        if (qactive_chan(184).and.qselect_chan(184)) then
          current_chan = 184
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgtsBtt2g1WcTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to gt gt lm nub 
        if (qactive_chan(185).and.qselect_chan(185)) then
          current_chan = 185
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbsBtt2g1WcTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt u lm nub 
        if (qactive_chan(186).and.qselect_chan(186)) then
          current_chan = 186
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gtqsBtt2g1WcTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to gt gt lm nub 
        if (qactive_chan(187).and.qselect_chan(187)) then
          current_chan = 187
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqsBtt2g1WcTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db u lm nub 
        if (qactive_chan(188).and.qselect_chan(188)) then
          current_chan = 188
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = gtgtsBtt2g1WcTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to db gt lm nub 
        if (qactive_chan(189).and.qselect_chan(189)) then
          current_chan = 189
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gtqbsBtt2g1WcTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to db gt lm nub 
        if (qactive_chan(190).and.qselect_chan(190)) then
          current_chan = 190
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgtsBtt2g1WcTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt u lm nub 
        if (qactive_chan(191).and.qselect_chan(191)) then
          current_chan = 191
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgtsBttt2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to gt gt lm nub 
        if (qactive_chan(192).and.qselect_chan(192)) then
          current_chan = 192
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbsBttt2g1WTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt u lm nub 
        if (qactive_chan(193).and.qselect_chan(193)) then
          current_chan = 193
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gtqsBttt2g1WTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to gt gt lm nub 
        if (qactive_chan(194).and.qselect_chan(194)) then
          current_chan = 194
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqsBttt2g1WTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db u lm nub 
        if (qactive_chan(195).and.qselect_chan(195)) then
          current_chan = 195
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = gtgtsBttt2g1WTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to db gt lm nub 
        if (qactive_chan(196).and.qselect_chan(196)) then
          current_chan = 196
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gtqbsBttt2g1WTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to db gt lm nub 
        if (qactive_chan(197).and.qselect_chan(197)) then
          current_chan = 197
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgtsBttt2g1WTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to g u lm nub   
        if (qactive_chan(198).and.qselect_chan(198)) then
          current_chan = 198
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g g lm nub  
        if (qactive_chan(199).and.qselect_chan(199)) then
          current_chan = 199
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbsBh2g1WTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g u lm nub   
        if (qactive_chan(200).and.qselect_chan(200)) then
          current_chan = 200
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gqsBh2g1WTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g g lm nub  
        if (qactive_chan(201).and.qselect_chan(201)) then
          current_chan = 201
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqsBh2g1WTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db u lm nub  
        if (qactive_chan(202).and.qselect_chan(202)) then
          current_chan = 202
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ggsBh2g1WTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db g lm nub 
        if (qactive_chan(203).and.qselect_chan(203)) then
          current_chan = 203
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gqbsBh2g1WTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db g lm nub 
        if (qactive_chan(204).and.qselect_chan(204)) then
          current_chan = 204
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgsBh2g1WTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(205).and.qselect_chan(205)) then
          current_chan = 205
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(206).and.qselect_chan(206)) then
          current_chan = 206
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(207).and.qselect_chan(207)) then
          current_chan = 207
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(208).and.qselect_chan(208)) then
          current_chan = 208
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(209).and.qselect_chan(209)) then
          current_chan = 209
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(210).and.qselect_chan(210)) then
          current_chan = 210
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(211).and.qselect_chan(211)) then
          current_chan = 211
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(212).and.qselect_chan(212)) then
          current_chan = 212
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbsBh2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt u lm nub 
        if (qactive_chan(213).and.qselect_chan(213)) then
          current_chan = 213
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qgtsBth2g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to gt gt lm nub 
        if (qactive_chan(214).and.qselect_chan(214)) then
          current_chan = 214
          ip1_chan     = 40
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .true.
          wt = qqbsBth2g1WTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt u lm nub 
        if (qactive_chan(215).and.qselect_chan(215)) then
          current_chan = 215
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gtqsBth2g1WTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to gt gt lm nub 
        if (qactive_chan(216).and.qselect_chan(216)) then
          current_chan = 216
          ip1_chan     = -20
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .true.
          wt = qbqsBth2g1WTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db u lm nub 
        if (qactive_chan(217).and.qselect_chan(217)) then
          current_chan = 217
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = gtgtsBth2g1WTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to db gt lm nub 
        if (qactive_chan(218).and.qselect_chan(218)) then
          current_chan = 218
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gtqbsBth2g1WTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to db gt lm nub 
        if (qactive_chan(219).and.qselect_chan(219)) then
          current_chan = 219
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = qbgtsBth2g1WTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb to Qb u lm nub 
        if (qactive_chan(220).and.qselect_chan(220)) then
          current_chan = 220
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q to Q u lm nub   
        if (qactive_chan(221).and.qselect_chan(221)) then
          current_chan = 221
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpsC0g1WTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to Q Qb lm nub 
        if (qactive_chan(222).and.qselect_chan(222)) then
          current_chan = 222
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 4
          ckmflag = .true.
          wt = qqbsC0g1WTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d to Qb u lm nub 
        if (qactive_chan(223).and.qselect_chan(223)) then
          current_chan = 223
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqsC0g1WTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d to Q u lm nub   
        if (qactive_chan(224).and.qselect_chan(224)) then
          current_chan = 224
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqsC0g1WTNLO(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to Q Qb lm nub 
        if (qactive_chan(225).and.qselect_chan(225)) then
          current_chan = 225
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 4
          ckmflag = .true.
          wt = qbqsC0g1WTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb Q to db u lm nub 
        if (qactive_chan(226).and.qselect_chan(226)) then
          current_chan = 226
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqpsC0g1WTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub to db Qb lm nub 
        if (qactive_chan(227).and.qselect_chan(227)) then
          current_chan = 227
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbsC0g1WTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q Qb to db u lm nub 
        if (qactive_chan(228).and.qselect_chan(228)) then
          current_chan = 228
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqpbsC0g1WTNLO(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb to db Qb lm nub 
        if (qactive_chan(229).and.qselect_chan(229)) then
          current_chan = 229
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbsC0g1WTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub to db Q lm nub 
        if (qactive_chan(230).and.qselect_chan(230)) then
          current_chan = 230
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbsC0g1WTNLO(ix,xri1,xri2,3,4,1,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q to db Q lm nub 
        if (qactive_chan(231).and.qselect_chan(231)) then
          current_chan = 231
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpsC0g1WTNLO(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(232).and.qselect_chan(232)) then
          current_chan = 232
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpgsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(233).and.qselect_chan(233)) then
          current_chan = 233
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(234).and.qselect_chan(234)) then
          current_chan = 234
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(235).and.qselect_chan(235)) then
          current_chan = 235
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(236).and.qselect_chan(236)) then
          current_chan = 236
          ip1_chan     = 0
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(237).and.qselect_chan(237)) then
          current_chan = 237
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqbsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(238).and.qselect_chan(238)) then
          current_chan = 238
          ip1_chan     = 40
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qgsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(239).and.qselect_chan(239)) then
          current_chan = 239
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbgsC0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb to Qb u lm nub 
        if (qactive_chan(240).and.qselect_chan(240)) then
          current_chan = 240
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q to Q u lm nub   
        if (qactive_chan(241).and.qselect_chan(241)) then
          current_chan = 241
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpCt0g1WTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to Q Qb lm nub 
        if (qactive_chan(242).and.qselect_chan(242)) then
          current_chan = 242
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 4
          ckmflag = .true.
          wt = qqbCt0g1WTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d to Qb u lm nub 
        if (qactive_chan(243).and.qselect_chan(243)) then
          current_chan = 243
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqCt0g1WTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d to Q u lm nub   
        if (qactive_chan(244).and.qselect_chan(244)) then
          current_chan = 244
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqCt0g1WTNLO(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to Q Qb lm nub 
        if (qactive_chan(245).and.qselect_chan(245)) then
          current_chan = 245
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 4
          ckmflag = .true.
          wt = qbqCt0g1WTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb Q to db u lm nub 
        if (qactive_chan(246).and.qselect_chan(246)) then
          current_chan = 246
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqpCt0g1WTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub to db Qb lm nub 
        if (qactive_chan(247).and.qselect_chan(247)) then
          current_chan = 247
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbCt0g1WTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q Qb to db u lm nub 
        if (qactive_chan(248).and.qselect_chan(248)) then
          current_chan = 248
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqpbCt0g1WTNLO(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb to db Qb lm nub 
        if (qactive_chan(249).and.qselect_chan(249)) then
          current_chan = 249
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbCt0g1WTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub to db Q lm nub 
        if (qactive_chan(250).and.qselect_chan(250)) then
          current_chan = 250
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbCt0g1WTNLO(ix,xri1,xri2,3,4,1,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q to db Q lm nub 
        if (qactive_chan(251).and.qselect_chan(251)) then
          current_chan = 251
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpCt0g1WTNLO(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(252).and.qselect_chan(252)) then
          current_chan = 252
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpgCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(253).and.qselect_chan(253)) then
          current_chan = 253
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(254).and.qselect_chan(254)) then
          current_chan = 254
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(255).and.qselect_chan(255)) then
          current_chan = 255
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(256).and.qselect_chan(256)) then
          current_chan = 256
          ip1_chan     = 0
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(257).and.qselect_chan(257)) then
          current_chan = 257
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqbCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(258).and.qselect_chan(258)) then
          current_chan = 258
          ip1_chan     = 40
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qgCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(259).and.qselect_chan(259)) then
          current_chan = 259
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbgCt0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb to Qb u lm nub 
        if (qactive_chan(260).and.qselect_chan(260)) then
          current_chan = 260
          ip1_chan     = 41
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q to Q u lm nub   
        if (qactive_chan(261).and.qselect_chan(261)) then
          current_chan = 261
          ip1_chan     = 41
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpCh0g1WTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to Q Qb lm nub 
        if (qactive_chan(262).and.qselect_chan(262)) then
          current_chan = 262
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 4
          ckmflag = .true.
          wt = qqbCh0g1WTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d to Qb u lm nub 
        if (qactive_chan(263).and.qselect_chan(263)) then
          current_chan = 263
          ip1_chan     = -31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqCh0g1WTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d to Q u lm nub   
        if (qactive_chan(264).and.qselect_chan(264)) then
          current_chan = 264
          ip1_chan     = 31
          ip2_chan     = 41
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqCh0g1WTNLO(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to Q Qb lm nub 
        if (qactive_chan(265).and.qselect_chan(265)) then
          current_chan = 265
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 4
          ckmflag = .true.
          wt = qbqCh0g1WTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb Q to db u lm nub 
        if (qactive_chan(266).and.qselect_chan(266)) then
          current_chan = 266
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqpCh0g1WTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub to db Qb lm nub 
        if (qactive_chan(267).and.qselect_chan(267)) then
          current_chan = 267
          ip1_chan     = -31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbCh0g1WTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q Qb to db u lm nub 
        if (qactive_chan(268).and.qselect_chan(268)) then
          current_chan = 268
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqpbCh0g1WTNLO(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb to db Qb lm nub 
        if (qactive_chan(269).and.qselect_chan(269)) then
          current_chan = 269
          ip1_chan     = -21
          ip2_chan     = -31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbCh0g1WTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub to db Q lm nub 
        if (qactive_chan(270).and.qselect_chan(270)) then
          current_chan = 270
          ip1_chan     = 31
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbCh0g1WTNLO(ix,xri1,xri2,3,4,1,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q to db Q lm nub 
        if (qactive_chan(271).and.qselect_chan(271)) then
          current_chan = 271
          ip1_chan     = -21
          ip2_chan     = 31
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpCh0g1WTNLO(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(272).and.qselect_chan(272)) then
          current_chan = 272
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpgCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(273).and.qselect_chan(273)) then
          current_chan = 273
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(274).and.qselect_chan(274)) then
          current_chan = 274
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(275).and.qselect_chan(275)) then
          current_chan = 275
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(276).and.qselect_chan(276)) then
          current_chan = 276
          ip1_chan     = 0
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(277).and.qselect_chan(277)) then
          current_chan = 277
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqbCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(278).and.qselect_chan(278)) then
          current_chan = 278
          ip1_chan     = 40
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qgCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(279).and.qselect_chan(279)) then
          current_chan = 279
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbgCh0g1WTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db u lm nub 
        if (qactive_chan(280).and.qselect_chan(280)) then
          current_chan = 280
          ip1_chan     = 40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpbD0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d u lm nub   
        if (qactive_chan(281).and.qselect_chan(281)) then
          current_chan = 281
          ip1_chan     = 40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpD0g1WmaTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to d db lm nub 
        if (qactive_chan(282).and.qselect_chan(282)) then
          current_chan = 282
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qpqbD0g1WmaTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db u lm nub 
        if (qactive_chan(283).and.qselect_chan(283)) then
          current_chan = 283
          ip1_chan     = -40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpD0g1WmaTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to d db lm nub 
        if (qactive_chan(284).and.qselect_chan(284)) then
          current_chan = 284
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qbqpD0g1WmaTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db db lm nub 
        if (qactive_chan(285).and.qselect_chan(285)) then
          current_chan = 285
          ip1_chan     = -40
          ip2_chan     = -20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqbD0g1WmaTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to db db lm nub 
        if (qactive_chan(286).and.qselect_chan(286)) then
          current_chan = 286
          ip1_chan     = -20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qbqpbD0g1WmaTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(287).and.qselect_chan(287)) then
          current_chan = 287
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dgD0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(288).and.qselect_chan(288)) then
          current_chan = 288
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dbgD0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(289).and.qselect_chan(289)) then
          current_chan = 289
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gdD0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(290).and.qselect_chan(290)) then
          current_chan = 290
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 2
          ckmflag = .false.
          wt = gdbD0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(291).and.qselect_chan(291)) then
          current_chan = 291
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          ckmflag = .false.
          wt = guD0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(292).and.qselect_chan(292)) then
          current_chan = 292
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ugD0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub u lm nub 
        if (qactive_chan(293).and.qselect_chan(293)) then
          current_chan = 293
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qpqbD0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u u lm nub   
        if (qactive_chan(294).and.qselect_chan(294)) then
          current_chan = 294
          ip1_chan     = 40
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qpqD0g1WmbTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub u lm nub 
        if (qactive_chan(295).and.qselect_chan(295)) then
          current_chan = 295
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qbqpD0g1WmbTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to u u lm nub   
        if (qactive_chan(296).and.qselect_chan(296)) then
          current_chan = 296
          ip1_chan     = 20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqpD0g1WmbTNLO(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to db u lm nub 
        if (qactive_chan(297).and.qselect_chan(297)) then
          current_chan = 297
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqD0g1WmbTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to db ub lm nub 
        if (qactive_chan(298).and.qselect_chan(298)) then
          current_chan = 298
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqbD0g1WmbTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to db u lm nub 
        if (qactive_chan(299).and.qselect_chan(299)) then
          current_chan = 299
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqbD0g1WmbTNLO(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(300).and.qselect_chan(300)) then
          current_chan = 300
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dbgD0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(301).and.qselect_chan(301)) then
          current_chan = 301
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 2
          ckmflag = .false.
          wt = gdbD0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(302).and.qselect_chan(302)) then
          current_chan = 302
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          ckmflag = .false.
          wt = guD0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(303).and.qselect_chan(303)) then
          current_chan = 303
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gubD0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(304).and.qselect_chan(304)) then
          current_chan = 304
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ugD0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(305).and.qselect_chan(305)) then
          current_chan = 305
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ubgD0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db u lm nub 
        if (qactive_chan(306).and.qselect_chan(306)) then
          current_chan = 306
          ip1_chan     = 40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpbDt0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d u lm nub   
        if (qactive_chan(307).and.qselect_chan(307)) then
          current_chan = 307
          ip1_chan     = 40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpDt0g1WmaTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to d db lm nub 
        if (qactive_chan(308).and.qselect_chan(308)) then
          current_chan = 308
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qpqbDt0g1WmaTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db u lm nub 
        if (qactive_chan(309).and.qselect_chan(309)) then
          current_chan = 309
          ip1_chan     = -40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpDt0g1WmaTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to d db lm nub 
        if (qactive_chan(310).and.qselect_chan(310)) then
          current_chan = 310
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qbqpDt0g1WmaTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db db lm nub 
        if (qactive_chan(311).and.qselect_chan(311)) then
          current_chan = 311
          ip1_chan     = -40
          ip2_chan     = -20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqbDt0g1WmaTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to db db lm nub 
        if (qactive_chan(312).and.qselect_chan(312)) then
          current_chan = 312
          ip1_chan     = -20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qbqpbDt0g1WmaTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(313).and.qselect_chan(313)) then
          current_chan = 313
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dgDt0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(314).and.qselect_chan(314)) then
          current_chan = 314
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dbgDt0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(315).and.qselect_chan(315)) then
          current_chan = 315
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gdDt0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(316).and.qselect_chan(316)) then
          current_chan = 316
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 2
          ckmflag = .false.
          wt = gdbDt0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(317).and.qselect_chan(317)) then
          current_chan = 317
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          ckmflag = .false.
          wt = guDt0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(318).and.qselect_chan(318)) then
          current_chan = 318
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ugDt0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub u lm nub 
        if (qactive_chan(319).and.qselect_chan(319)) then
          current_chan = 319
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qpqbDt0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u u lm nub   
        if (qactive_chan(320).and.qselect_chan(320)) then
          current_chan = 320
          ip1_chan     = 40
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qpqDt0g1WmbTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub u lm nub 
        if (qactive_chan(321).and.qselect_chan(321)) then
          current_chan = 321
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qbqpDt0g1WmbTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to u u lm nub   
        if (qactive_chan(322).and.qselect_chan(322)) then
          current_chan = 322
          ip1_chan     = 20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqpDt0g1WmbTNLO(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to db u lm nub 
        if (qactive_chan(323).and.qselect_chan(323)) then
          current_chan = 323
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqDt0g1WmbTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to db ub lm nub 
        if (qactive_chan(324).and.qselect_chan(324)) then
          current_chan = 324
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqbDt0g1WmbTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to db u lm nub 
        if (qactive_chan(325).and.qselect_chan(325)) then
          current_chan = 325
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqbDt0g1WmbTNLO(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(326).and.qselect_chan(326)) then
          current_chan = 326
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dbgDt0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(327).and.qselect_chan(327)) then
          current_chan = 327
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 2
          ckmflag = .false.
          wt = gdbDt0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(328).and.qselect_chan(328)) then
          current_chan = 328
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          ckmflag = .false.
          wt = guDt0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(329).and.qselect_chan(329)) then
          current_chan = 329
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gubDt0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(330).and.qselect_chan(330)) then
          current_chan = 330
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ugDt0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(331).and.qselect_chan(331)) then
          current_chan = 331
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ubgDt0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db u lm nub 
        if (qactive_chan(332).and.qselect_chan(332)) then
          current_chan = 332
          ip1_chan     = 40
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpbDh0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d u lm nub   
        if (qactive_chan(333).and.qselect_chan(333)) then
          current_chan = 333
          ip1_chan     = 40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpqpDh0g1WmaTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to d db lm nub 
        if (qactive_chan(334).and.qselect_chan(334)) then
          current_chan = 334
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qpqbDh0g1WmaTNLO(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db u lm nub 
        if (qactive_chan(335).and.qselect_chan(335)) then
          current_chan = 335
          ip1_chan     = -40
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqpDh0g1WmaTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to d db lm nub 
        if (qactive_chan(336).and.qselect_chan(336)) then
          current_chan = 336
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .true.
          wt = qbqpDh0g1WmaTNLO(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db db lm nub 
        if (qactive_chan(337).and.qselect_chan(337)) then
          current_chan = 337
          ip1_chan     = -40
          ip2_chan     = -20
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qpbqbDh0g1WmaTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to db db lm nub 
        if (qactive_chan(338).and.qselect_chan(338)) then
          current_chan = 338
          ip1_chan     = -20
          ip2_chan     = -40
          nfC1 = 1
          nfC2 = 1
          ckmflag = .false.
          wt = qbqpbDh0g1WmaTNLO(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(339).and.qselect_chan(339)) then
          current_chan = 339
          ip1_chan     = 40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dgDh0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(340).and.qselect_chan(340)) then
          current_chan = 340
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dbgDh0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(341).and.qselect_chan(341)) then
          current_chan = 341
          ip1_chan     = 0
          ip2_chan     = 40
          nfB1 = 2
          ckmflag = .false.
          wt = gdDh0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(342).and.qselect_chan(342)) then
          current_chan = 342
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 2
          ckmflag = .false.
          wt = gdbDh0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(343).and.qselect_chan(343)) then
          current_chan = 343
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          ckmflag = .false.
          wt = guDh0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(344).and.qselect_chan(344)) then
          current_chan = 344
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ugDh0g1WmaTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub u lm nub 
        if (qactive_chan(345).and.qselect_chan(345)) then
          current_chan = 345
          ip1_chan     = 40
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qpqbDh0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u u lm nub   
        if (qactive_chan(346).and.qselect_chan(346)) then
          current_chan = 346
          ip1_chan     = 40
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qpqDh0g1WmbTNLO(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub u lm nub 
        if (qactive_chan(347).and.qselect_chan(347)) then
          current_chan = 347
          ip1_chan     = -20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .true.
          wt = qbqpDh0g1WmbTNLO(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to u u lm nub   
        if (qactive_chan(348).and.qselect_chan(348)) then
          current_chan = 348
          ip1_chan     = 20
          ip2_chan     = 40
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqpDh0g1WmbTNLO(ix,xri1,xri2,2,3,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to db u lm nub 
        if (qactive_chan(349).and.qselect_chan(349)) then
          current_chan = 349
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqDh0g1WmbTNLO(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to db ub lm nub 
        if (qactive_chan(350).and.qselect_chan(350)) then
          current_chan = 350
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qbqbDh0g1WmbTNLO(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to db u lm nub 
        if (qactive_chan(351).and.qselect_chan(351)) then
          current_chan = 351
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          ckmflag = .false.
          wt = qqbDh0g1WmbTNLO(ix,xri1,xri2,3,2,1,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(352).and.qselect_chan(352)) then
          current_chan = 352
          ip1_chan     = -40
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = dbgDh0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(353).and.qselect_chan(353)) then
          current_chan = 353
          ip1_chan     = 0
          ip2_chan     = -40
          nfB1 = 2
          ckmflag = .false.
          wt = gdbDh0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(354).and.qselect_chan(354)) then
          current_chan = 354
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          ckmflag = .false.
          wt = guDh0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(355).and.qselect_chan(355)) then
          current_chan = 355
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          ckmflag = .false.
          wt = gubDh0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(356).and.qselect_chan(356)) then
          current_chan = 356
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ugDh0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(357).and.qselect_chan(357)) then
          current_chan = 357
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          ckmflag = .false.
          wt = ubgDh0g1WmbTNLO(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLOWmJJ=sigTNLOWmJJ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
