      subroutine selectchannelWmJJJ()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*alphas_scl)*(4d0*pi*amzw/stw)**2*(nc**2-1)*(nc*(4d0*pi*alphas_scl))**2
      n_alphas_proc = 3
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelWmJJJ: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelWmJJJ: already allocated'  
        stop
      end if

      ntot_chan = 113

      allocate(qactive_chan(1:113))
      allocate(contrib_chan(1:113))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! d g to g g u lm nub   sB3g0W(1,2,3,4,5,6,7)  
c      qactive_chan(2)  = .true.   ! d ub to g g g lm nub   sB3g0W(1,3,4,5,2,6,7)  
c      qactive_chan(3)  = .true.   ! g d to g g u lm nub   sB3g0W(2,1,3,4,5,6,7)  
c      qactive_chan(4)  = .true.   ! ub d to g g g lm nub   sB3g0W(2,3,4,5,1,6,7)  
c      qactive_chan(5)  = .true.   ! g g to db g u lm nub   sB3g0W(3,1,2,4,5,6,7)  
c      qactive_chan(6)  = .true.   ! g ub to db g g lm nub   sB3g0W(3,1,4,5,2,6,7)  
c      qactive_chan(7)  = .true.   ! ub g to db g g lm nub   sB3g0W(3,2,4,5,1,6,7)  
c      qactive_chan(8)  = .true.   ! d g to g g u lm nub   sBt3g0W(1,2,3,4,5,6,7)  
c      qactive_chan(9)  = .true.   ! d ub to g g g lm nub   sBt3g0W(1,3,4,5,2,6,7)  
c      qactive_chan(10) = .true.   ! g d to g g u lm nub   sBt3g0W(2,1,3,4,5,6,7)  
c      qactive_chan(11) = .true.   ! ub d to g g g lm nub   sBt3g0W(2,3,4,5,1,6,7)  
c      qactive_chan(12) = .true.   ! g g to db g u lm nub   sBt3g0W(3,1,2,4,5,6,7)  
c      qactive_chan(13) = .true.   ! g ub to db g g lm nub   sBt3g0W(3,1,4,5,2,6,7)  
c      qactive_chan(14) = .true.   ! ub g to db g g lm nub   sBt3g0W(3,2,4,5,1,6,7)  
c      qactive_chan(15) = .true.   ! d gt to gt gt u lm nub   sBtt3g0W(1,2,3,4,5,6,7)  
c      qactive_chan(16) = .true.   ! d ub to gt gt gt lm nub   sBtt3g0W(1,3,4,5,2,6,7)  
c      qactive_chan(17) = .true.   ! gt d to gt gt u lm nub   sBtt3g0W(2,1,3,4,5,6,7)  
c      qactive_chan(18) = .true.   ! ub d to gt gt gt lm nub   sBtt3g0W(2,3,4,5,1,6,7)  
c      qactive_chan(19) = .true.   ! gt gt to db gt u lm nub   sBtt3g0W(3,1,2,4,5,6,7)  
c      qactive_chan(20) = .true.   ! gt ub to db gt gt lm nub   sBtt3g0W(3,1,4,5,2,6,7)  
c      qactive_chan(21) = .true.   ! ub gt to db gt gt lm nub   sBtt3g0W(3,2,4,5,1,6,7)  
c      qactive_chan(22) = .true.   ! d g to Q Qb u lm nub   sC1g0W(1,2,3,4,5,6,7)  
c      qactive_chan(23) = .true.   ! d Qb to g Qb u lm nub   sC1g0W(1,3,2,4,5,6,7)  
c      qactive_chan(24) = .true.   ! d Q to g Q u lm nub   sC1g0W(1,3,4,2,5,6,7)  
c      qactive_chan(25) = .true.   ! d ub to g Q Qb lm nub   sC1g0W(1,3,4,5,2,6,7)  
c      qactive_chan(26) = .true.   ! g d to Q Qb u lm nub   sC1g0W(2,1,3,4,5,6,7)  
c      qactive_chan(27) = .true.   ! Qb d to g Qb u lm nub   sC1g0W(2,3,1,4,5,6,7)  
c      qactive_chan(28) = .true.   ! Q d to g Q u lm nub   sC1g0W(2,3,4,1,5,6,7)  
c      qactive_chan(29) = .true.   ! ub d to g Q Qb lm nub   sC1g0W(2,3,4,5,1,6,7)  
c      qactive_chan(30) = .true.   ! g Qb to db Qb u lm nub   sC1g0W(3,1,2,4,5,6,7)  
c      qactive_chan(31) = .true.   ! g Q to db Q u lm nub   sC1g0W(3,1,4,2,5,6,7)  
c      qactive_chan(32) = .true.   ! g ub to db Q Qb lm nub   sC1g0W(3,1,4,5,2,6,7)  
c      qactive_chan(33) = .true.   ! Qb g to db Qb u lm nub   sC1g0W(3,2,1,4,5,6,7)  
c      qactive_chan(34) = .true.   ! Q g to db Q u lm nub   sC1g0W(3,2,4,1,5,6,7)  
c      qactive_chan(35) = .true.   ! ub g to db Q Qb lm nub   sC1g0W(3,2,4,5,1,6,7)  
c      qactive_chan(36) = .true.   ! Qb Q to db g u lm nub   sC1g0W(3,4,1,2,5,6,7)  
c      qactive_chan(37) = .true.   ! Qb ub to db g Qb lm nub   sC1g0W(3,4,1,5,2,6,7)  
c      qactive_chan(38) = .true.   ! Q Qb to db g u lm nub   sC1g0W(3,4,2,1,5,6,7)  
c      qactive_chan(39) = .true.   ! ub Qb to db g Qb lm nub   sC1g0W(3,4,2,5,1,6,7)  
c      qactive_chan(40) = .true.   ! Q ub to db g Q lm nub   sC1g0W(3,4,5,1,2,6,7)  
c      qactive_chan(41) = .true.   ! ub Q to db g Q lm nub   sC1g0W(3,4,5,2,1,6,7)  
c      qactive_chan(42) = .true.   ! d g to Q Qb u lm nub   sCt1g0W(1,2,3,4,5,6,7)  
c      qactive_chan(43) = .true.   ! d Qb to g Qb u lm nub   sCt1g0W(1,3,2,4,5,6,7)  
c      qactive_chan(44) = .true.   ! d Q to g Q u lm nub   sCt1g0W(1,3,4,2,5,6,7)  
c      qactive_chan(45) = .true.   ! d ub to g Q Qb lm nub   sCt1g0W(1,3,4,5,2,6,7)  
c      qactive_chan(46) = .true.   ! g d to Q Qb u lm nub   sCt1g0W(2,1,3,4,5,6,7)  
c      qactive_chan(47) = .true.   ! Qb d to g Qb u lm nub   sCt1g0W(2,3,1,4,5,6,7)  
c      qactive_chan(48) = .true.   ! Q d to g Q u lm nub   sCt1g0W(2,3,4,1,5,6,7)  
c      qactive_chan(49) = .true.   ! ub d to g Q Qb lm nub   sCt1g0W(2,3,4,5,1,6,7)  
c      qactive_chan(50) = .true.   ! g Qb to db Qb u lm nub   sCt1g0W(3,1,2,4,5,6,7)  
c      qactive_chan(51) = .true.   ! g Q to db Q u lm nub   sCt1g0W(3,1,4,2,5,6,7)  
c      qactive_chan(52) = .true.   ! g ub to db Q Qb lm nub   sCt1g0W(3,1,4,5,2,6,7)  
c      qactive_chan(53) = .true.   ! Qb g to db Qb u lm nub   sCt1g0W(3,2,1,4,5,6,7)  
c      qactive_chan(54) = .true.   ! Q g to db Q u lm nub   sCt1g0W(3,2,4,1,5,6,7)  
c      qactive_chan(55) = .true.   ! ub g to db Q Qb lm nub   sCt1g0W(3,2,4,5,1,6,7)  
c      qactive_chan(56) = .true.   ! Qb Q to db g u lm nub   sCt1g0W(3,4,1,2,5,6,7)  
c      qactive_chan(57) = .true.   ! Qb ub to db g Qb lm nub   sCt1g0W(3,4,1,5,2,6,7)  
c      qactive_chan(58) = .true.   ! Q Qb to db g u lm nub   sCt1g0W(3,4,2,1,5,6,7)  
c      qactive_chan(59) = .true.   ! ub Qb to db g Qb lm nub   sCt1g0W(3,4,2,5,1,6,7)  
c      qactive_chan(60) = .true.   ! Q ub to db g Q lm nub   sCt1g0W(3,4,5,1,2,6,7)  
c      qactive_chan(61) = .true.   ! ub Q to db g Q lm nub   sCt1g0W(3,4,5,2,1,6,7)  
c      qactive_chan(62) = .true.   ! d g to d db u lm nub   D1g0Wac(1,2,3,4,5,6,7)  
c      qactive_chan(63) = .true.   ! d db to g db u lm nub   D1g0Wac(1,3,2,4,5,6,7)  
c      qactive_chan(64) = .true.   ! d d to g d u lm nub   D1g0Wac(1,3,4,2,5,6,7)  
c      qactive_chan(65) = .true.   ! d ub to g d db lm nub   D1g0Wac(1,3,4,5,2,6,7)  
c      qactive_chan(66) = .true.   ! g d to d db u lm nub   D1g0Wac(2,1,3,4,5,6,7)  
c      qactive_chan(67) = .true.   ! db d to g db u lm nub   D1g0Wac(2,3,1,4,5,6,7)  
c      qactive_chan(68) = .true.   ! ub d to g d db lm nub   D1g0Wac(2,3,4,5,1,6,7)  
c      qactive_chan(69) = .true.   ! g db to db db u lm nub   D1g0Wac(3,1,2,4,5,6,7)  
c      qactive_chan(70) = .true.   ! g ub to db d db lm nub   D1g0Wac(3,1,4,5,2,6,7)  
c      qactive_chan(71) = .true.   ! db g to db db u lm nub   D1g0Wac(3,2,1,4,5,6,7)  
c      qactive_chan(72) = .true.   ! ub g to db d db lm nub   D1g0Wac(3,2,4,5,1,6,7)  
c      qactive_chan(73) = .true.   ! db ub to db g db lm nub   D1g0Wac(3,4,1,5,2,6,7)  
c      qactive_chan(74) = .true.   ! ub db to db g db lm nub   D1g0Wac(3,4,2,5,1,6,7)  
c      qactive_chan(75) = .true.   ! d g to u ub u lm nub   D1g0Wbc(1,2,3,4,5,6,7)  
c      qactive_chan(76) = .true.   ! d ub to g ub u lm nub   D1g0Wbc(1,3,2,4,5,6,7)  
c      qactive_chan(77) = .true.   ! d u to g u u lm nub   D1g0Wbc(1,3,4,2,5,6,7)  
c      qactive_chan(78) = .true.   ! g d to u ub u lm nub   D1g0Wbc(2,1,3,4,5,6,7)  
c      qactive_chan(79) = .true.   ! ub d to g ub u lm nub   D1g0Wbc(2,3,1,4,5,6,7)  
c      qactive_chan(80) = .true.   ! u d to g u u lm nub   D1g0Wbc(2,3,4,1,5,6,7)  
c      qactive_chan(81) = .true.   ! g ub to db ub u lm nub   D1g0Wbc(3,1,2,4,5,6,7)  
c      qactive_chan(82) = .true.   ! g u to db u u lm nub   D1g0Wbc(3,1,4,2,5,6,7)  
c      qactive_chan(83) = .true.   ! ub g to db ub u lm nub   D1g0Wbc(3,2,1,4,5,6,7)  
c      qactive_chan(84) = .true.   ! u g to db u u lm nub   D1g0Wbc(3,2,4,1,5,6,7)  
c      qactive_chan(85) = .true.   ! ub u to db g u lm nub   D1g0Wbc(3,4,1,2,5,6,7)  
c      qactive_chan(86) = .true.   ! ub ub to db g ub lm nub   D1g0Wbc(3,4,1,5,2,6,7)  
c      qactive_chan(87) = .true.   ! u ub to db g u lm nub   D1g0Wbc(3,4,2,1,5,6,7)  
c      qactive_chan(88) = .true.   ! d g to d db u lm nub   Dt1g0Wa(1,2,3,4,5,6,7)  
c      qactive_chan(89) = .true.   ! d db to g db u lm nub   Dt1g0Wa(1,3,2,4,5,6,7)  
c      qactive_chan(90) = .true.   ! d d to g d u lm nub   Dt1g0Wa(1,3,4,2,5,6,7)  
c      qactive_chan(91) = .true.   ! d ub to g d db lm nub   Dt1g0Wa(1,3,4,5,2,6,7)  
c      qactive_chan(92) = .true.   ! g d to d db u lm nub   Dt1g0Wa(2,1,3,4,5,6,7)  
c      qactive_chan(93) = .true.   ! db d to g db u lm nub   Dt1g0Wa(2,3,1,4,5,6,7)  
c      qactive_chan(94) = .true.   ! ub d to g d db lm nub   Dt1g0Wa(2,3,4,5,1,6,7)  
c      qactive_chan(95) = .true.   ! g db to db db u lm nub   Dt1g0Wa(3,1,2,4,5,6,7)  
c      qactive_chan(96) = .true.   ! g ub to db d db lm nub   Dt1g0Wa(3,1,4,5,2,6,7)  
c      qactive_chan(97) = .true.   ! db g to db db u lm nub   Dt1g0Wa(3,2,1,4,5,6,7)  
c      qactive_chan(98) = .true.   ! ub g to db d db lm nub   Dt1g0Wa(3,2,4,5,1,6,7)  
c      qactive_chan(99) = .true.   ! db ub to db g db lm nub   Dt1g0Wa(3,4,1,5,2,6,7)  
c      qactive_chan(100)= .true.   ! ub db to db g db lm nub   Dt1g0Wa(3,4,2,5,1,6,7)  
c      qactive_chan(101)= .true.   ! d g to u ub u lm nub   Dt1g0Wb(1,2,3,4,5,6,7)  
c      qactive_chan(102)= .true.   ! d ub to g ub u lm nub   Dt1g0Wb(1,3,2,4,5,6,7)  
c      qactive_chan(103)= .true.   ! d u to g u u lm nub   Dt1g0Wb(1,3,4,2,5,6,7)  
c      qactive_chan(104)= .true.   ! g d to u ub u lm nub   Dt1g0Wb(2,1,3,4,5,6,7)  
c      qactive_chan(105)= .true.   ! ub d to g ub u lm nub   Dt1g0Wb(2,3,1,4,5,6,7)  
c      qactive_chan(106)= .true.   ! u d to g u u lm nub   Dt1g0Wb(2,3,4,1,5,6,7)  
c      qactive_chan(107)= .true.   ! g ub to db ub u lm nub   Dt1g0Wb(3,1,2,4,5,6,7)  
c      qactive_chan(108)= .true.   ! g u to db u u lm nub   Dt1g0Wb(3,1,4,2,5,6,7)  
c      qactive_chan(109)= .true.   ! ub g to db ub u lm nub   Dt1g0Wb(3,2,1,4,5,6,7)  
c      qactive_chan(110)= .true.   ! u g to db u u lm nub   Dt1g0Wb(3,2,4,1,5,6,7)  
c      qactive_chan(111)= .true.   ! ub u to db g u lm nub   Dt1g0Wb(3,4,1,2,5,6,7)  
c      qactive_chan(112)= .true.   ! ub ub to db g ub lm nub   Dt1g0Wb(3,4,1,5,2,6,7)  
c      qactive_chan(113)= .true.   ! u ub to db g u lm nub   Dt1g0Wb(3,4,2,1,5,6,7)  

      do i=1,113
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c -- virtual                                      ME                   TNLO  

c -- double real                                  ME                   S  

c -- real virtual                                 ME                   T  

c -- double virtual                               ME                   U  

      return
      end


c---- get channel strings
      subroutine getchannelWmJJJ(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'd g to g g u lm nub '
        me_str   = 'sB3g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (2)
        chan_str = 'd ub to g g g lm nub '
        me_str   = 'sB3g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (3)
        chan_str = 'g d to g g u lm nub '
        me_str   = 'sB3g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (4)
        chan_str = 'ub d to g g g lm nub '
        me_str   = 'sB3g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (5)
        chan_str = 'g g to db g u lm nub '
        me_str   = 'sB3g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (6)
        chan_str = 'g ub to db g g lm nub '
        me_str   = 'sB3g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (7)
        chan_str = 'ub g to db g g lm nub '
        me_str   = 'sB3g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (8)
        chan_str = 'd g to g g u lm nub '
        me_str   = 'sBt3g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (9)
        chan_str = 'd ub to g g g lm nub '
        me_str   = 'sBt3g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (10)
        chan_str = 'g d to g g u lm nub '
        me_str   = 'sBt3g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (11)
        chan_str = 'ub d to g g g lm nub '
        me_str   = 'sBt3g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (12)
        chan_str = 'g g to db g u lm nub '
        me_str   = 'sBt3g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (13)
        chan_str = 'g ub to db g g lm nub '
        me_str   = 'sBt3g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (14)
        chan_str = 'ub g to db g g lm nub '
        me_str   = 'sBt3g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (15)
        chan_str = 'd gt to gt gt u lm nub '
        me_str   = 'sBtt3g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (16)
        chan_str = 'd ub to gt gt gt lm nub '
        me_str   = 'sBtt3g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (17)
        chan_str = 'gt d to gt gt u lm nub '
        me_str   = 'sBtt3g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (18)
        chan_str = 'ub d to gt gt gt lm nub '
        me_str   = 'sBtt3g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (19)
        chan_str = 'gt gt to db gt u lm nub '
        me_str   = 'sBtt3g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (20)
        chan_str = 'gt ub to db gt gt lm nub '
        me_str   = 'sBtt3g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (21)
        chan_str = 'ub gt to db gt gt lm nub '
        me_str   = 'sBtt3g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (22)
        chan_str = 'd g to Q Qb u lm nub '
        me_str   = 'sC1g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (23)
        chan_str = 'd Qb to g Qb u lm nub '
        me_str   = 'sC1g0W(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (24)
        chan_str = 'd Q to g Q u lm nub '
        me_str   = 'sC1g0W(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (25)
        chan_str = 'd ub to g Q Qb lm nub '
        me_str   = 'sC1g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (26)
        chan_str = 'g d to Q Qb u lm nub '
        me_str   = 'sC1g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (27)
        chan_str = 'Qb d to g Qb u lm nub '
        me_str   = 'sC1g0W(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (28)
        chan_str = 'Q d to g Q u lm nub '
        me_str   = 'sC1g0W(2,3,4,1,5,6,7)'
        sub_str  = ''

      case (29)
        chan_str = 'ub d to g Q Qb lm nub '
        me_str   = 'sC1g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (30)
        chan_str = 'g Qb to db Qb u lm nub '
        me_str   = 'sC1g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (31)
        chan_str = 'g Q to db Q u lm nub '
        me_str   = 'sC1g0W(3,1,4,2,5,6,7)'
        sub_str  = ''

      case (32)
        chan_str = 'g ub to db Q Qb lm nub '
        me_str   = 'sC1g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (33)
        chan_str = 'Qb g to db Qb u lm nub '
        me_str   = 'sC1g0W(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (34)
        chan_str = 'Q g to db Q u lm nub '
        me_str   = 'sC1g0W(3,2,4,1,5,6,7)'
        sub_str  = ''

      case (35)
        chan_str = 'ub g to db Q Qb lm nub '
        me_str   = 'sC1g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (36)
        chan_str = 'Qb Q to db g u lm nub '
        me_str   = 'sC1g0W(3,4,1,2,5,6,7)'
        sub_str  = ''

      case (37)
        chan_str = 'Qb ub to db g Qb lm nub '
        me_str   = 'sC1g0W(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (38)
        chan_str = 'Q Qb to db g u lm nub '
        me_str   = 'sC1g0W(3,4,2,1,5,6,7)'
        sub_str  = ''

      case (39)
        chan_str = 'ub Qb to db g Qb lm nub '
        me_str   = 'sC1g0W(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (40)
        chan_str = 'Q ub to db g Q lm nub '
        me_str   = 'sC1g0W(3,4,5,1,2,6,7)'
        sub_str  = ''

      case (41)
        chan_str = 'ub Q to db g Q lm nub '
        me_str   = 'sC1g0W(3,4,5,2,1,6,7)'
        sub_str  = ''

      case (42)
        chan_str = 'd g to Q Qb u lm nub '
        me_str   = 'sCt1g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (43)
        chan_str = 'd Qb to g Qb u lm nub '
        me_str   = 'sCt1g0W(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (44)
        chan_str = 'd Q to g Q u lm nub '
        me_str   = 'sCt1g0W(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (45)
        chan_str = 'd ub to g Q Qb lm nub '
        me_str   = 'sCt1g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (46)
        chan_str = 'g d to Q Qb u lm nub '
        me_str   = 'sCt1g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (47)
        chan_str = 'Qb d to g Qb u lm nub '
        me_str   = 'sCt1g0W(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (48)
        chan_str = 'Q d to g Q u lm nub '
        me_str   = 'sCt1g0W(2,3,4,1,5,6,7)'
        sub_str  = ''

      case (49)
        chan_str = 'ub d to g Q Qb lm nub '
        me_str   = 'sCt1g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (50)
        chan_str = 'g Qb to db Qb u lm nub '
        me_str   = 'sCt1g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (51)
        chan_str = 'g Q to db Q u lm nub '
        me_str   = 'sCt1g0W(3,1,4,2,5,6,7)'
        sub_str  = ''

      case (52)
        chan_str = 'g ub to db Q Qb lm nub '
        me_str   = 'sCt1g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (53)
        chan_str = 'Qb g to db Qb u lm nub '
        me_str   = 'sCt1g0W(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (54)
        chan_str = 'Q g to db Q u lm nub '
        me_str   = 'sCt1g0W(3,2,4,1,5,6,7)'
        sub_str  = ''

      case (55)
        chan_str = 'ub g to db Q Qb lm nub '
        me_str   = 'sCt1g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (56)
        chan_str = 'Qb Q to db g u lm nub '
        me_str   = 'sCt1g0W(3,4,1,2,5,6,7)'
        sub_str  = ''

      case (57)
        chan_str = 'Qb ub to db g Qb lm nub '
        me_str   = 'sCt1g0W(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (58)
        chan_str = 'Q Qb to db g u lm nub '
        me_str   = 'sCt1g0W(3,4,2,1,5,6,7)'
        sub_str  = ''

      case (59)
        chan_str = 'ub Qb to db g Qb lm nub '
        me_str   = 'sCt1g0W(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (60)
        chan_str = 'Q ub to db g Q lm nub '
        me_str   = 'sCt1g0W(3,4,5,1,2,6,7)'
        sub_str  = ''

      case (61)
        chan_str = 'ub Q to db g Q lm nub '
        me_str   = 'sCt1g0W(3,4,5,2,1,6,7)'
        sub_str  = ''

      case (62)
        chan_str = 'd g to d db u lm nub '
        me_str   = 'D1g0Wac(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (63)
        chan_str = 'd db to g db u lm nub '
        me_str   = 'D1g0Wac(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (64)
        chan_str = 'd d to g d u lm nub '
        me_str   = 'D1g0Wac(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (65)
        chan_str = 'd ub to g d db lm nub '
        me_str   = 'D1g0Wac(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (66)
        chan_str = 'g d to d db u lm nub '
        me_str   = 'D1g0Wac(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (67)
        chan_str = 'db d to g db u lm nub '
        me_str   = 'D1g0Wac(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (68)
        chan_str = 'ub d to g d db lm nub '
        me_str   = 'D1g0Wac(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (69)
        chan_str = 'g db to db db u lm nub '
        me_str   = 'D1g0Wac(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (70)
        chan_str = 'g ub to db d db lm nub '
        me_str   = 'D1g0Wac(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (71)
        chan_str = 'db g to db db u lm nub '
        me_str   = 'D1g0Wac(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (72)
        chan_str = 'ub g to db d db lm nub '
        me_str   = 'D1g0Wac(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (73)
        chan_str = 'db ub to db g db lm nub '
        me_str   = 'D1g0Wac(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (74)
        chan_str = 'ub db to db g db lm nub '
        me_str   = 'D1g0Wac(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (75)
        chan_str = 'd g to u ub u lm nub '
        me_str   = 'D1g0Wbc(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (76)
        chan_str = 'd ub to g ub u lm nub '
        me_str   = 'D1g0Wbc(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (77)
        chan_str = 'd u to g u u lm nub '
        me_str   = 'D1g0Wbc(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (78)
        chan_str = 'g d to u ub u lm nub '
        me_str   = 'D1g0Wbc(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (79)
        chan_str = 'ub d to g ub u lm nub '
        me_str   = 'D1g0Wbc(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (80)
        chan_str = 'u d to g u u lm nub '
        me_str   = 'D1g0Wbc(2,3,4,1,5,6,7)'
        sub_str  = ''

      case (81)
        chan_str = 'g ub to db ub u lm nub '
        me_str   = 'D1g0Wbc(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (82)
        chan_str = 'g u to db u u lm nub '
        me_str   = 'D1g0Wbc(3,1,4,2,5,6,7)'
        sub_str  = ''

      case (83)
        chan_str = 'ub g to db ub u lm nub '
        me_str   = 'D1g0Wbc(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (84)
        chan_str = 'u g to db u u lm nub '
        me_str   = 'D1g0Wbc(3,2,4,1,5,6,7)'
        sub_str  = ''

      case (85)
        chan_str = 'ub u to db g u lm nub '
        me_str   = 'D1g0Wbc(3,4,1,2,5,6,7)'
        sub_str  = ''

      case (86)
        chan_str = 'ub ub to db g ub lm nub '
        me_str   = 'D1g0Wbc(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (87)
        chan_str = 'u ub to db g u lm nub '
        me_str   = 'D1g0Wbc(3,4,2,1,5,6,7)'
        sub_str  = ''

      case (88)
        chan_str = 'd g to d db u lm nub '
        me_str   = 'Dt1g0Wa(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (89)
        chan_str = 'd db to g db u lm nub '
        me_str   = 'Dt1g0Wa(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (90)
        chan_str = 'd d to g d u lm nub '
        me_str   = 'Dt1g0Wa(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (91)
        chan_str = 'd ub to g d db lm nub '
        me_str   = 'Dt1g0Wa(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (92)
        chan_str = 'g d to d db u lm nub '
        me_str   = 'Dt1g0Wa(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (93)
        chan_str = 'db d to g db u lm nub '
        me_str   = 'Dt1g0Wa(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (94)
        chan_str = 'ub d to g d db lm nub '
        me_str   = 'Dt1g0Wa(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (95)
        chan_str = 'g db to db db u lm nub '
        me_str   = 'Dt1g0Wa(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (96)
        chan_str = 'g ub to db d db lm nub '
        me_str   = 'Dt1g0Wa(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (97)
        chan_str = 'db g to db db u lm nub '
        me_str   = 'Dt1g0Wa(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (98)
        chan_str = 'ub g to db d db lm nub '
        me_str   = 'Dt1g0Wa(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (99)
        chan_str = 'db ub to db g db lm nub '
        me_str   = 'Dt1g0Wa(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (100)
        chan_str = 'ub db to db g db lm nub '
        me_str   = 'Dt1g0Wa(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (101)
        chan_str = 'd g to u ub u lm nub '
        me_str   = 'Dt1g0Wb(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (102)
        chan_str = 'd ub to g ub u lm nub '
        me_str   = 'Dt1g0Wb(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (103)
        chan_str = 'd u to g u u lm nub '
        me_str   = 'Dt1g0Wb(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (104)
        chan_str = 'g d to u ub u lm nub '
        me_str   = 'Dt1g0Wb(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (105)
        chan_str = 'ub d to g ub u lm nub '
        me_str   = 'Dt1g0Wb(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (106)
        chan_str = 'u d to g u u lm nub '
        me_str   = 'Dt1g0Wb(2,3,4,1,5,6,7)'
        sub_str  = ''

      case (107)
        chan_str = 'g ub to db ub u lm nub '
        me_str   = 'Dt1g0Wb(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (108)
        chan_str = 'g u to db u u lm nub '
        me_str   = 'Dt1g0Wb(3,1,4,2,5,6,7)'
        sub_str  = ''

      case (109)
        chan_str = 'ub g to db ub u lm nub '
        me_str   = 'Dt1g0Wb(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (110)
        chan_str = 'u g to db u u lm nub '
        me_str   = 'Dt1g0Wb(3,2,4,1,5,6,7)'
        sub_str  = ''

      case (111)
        chan_str = 'ub u to db g u lm nub '
        me_str   = 'Dt1g0Wb(3,4,1,2,5,6,7)'
        sub_str  = ''

      case (112)
        chan_str = 'ub ub to db g ub lm nub '
        me_str   = 'Dt1g0Wb(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (113)
        chan_str = 'u ub to db g u lm nub '
        me_str   = 'Dt1g0Wb(3,4,2,1,5,6,7)'
        sub_str  = ''

      case default
        print*, 'getchannelWmJJJ: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtWmJJJ(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtWmJJJ = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (1)
        ! [g, g, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (2)
        ! [g, g, g, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4,5 /))

      case (3)
        ! [g, g, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (4)
        ! [g, g, g, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4,5 /))

      case (6)
        ! [db, g, g, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (7)
        ! [db, g, g, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (8)
        ! [g, g, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (9)
        ! [g, g, g, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4,5 /))

      case (10)
        ! [g, g, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (11)
        ! [g, g, g, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4,5 /))

      case (13)
        ! [db, g, g, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (14)
        ! [db, g, g, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (15)
        ! [gt, gt, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (16)
        ! [gt, gt, gt, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4,5 /))

      case (17)
        ! [gt, gt, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (18)
        ! [gt, gt, gt, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4,5 /))

      case (20)
        ! [db, gt, gt, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (21)
        ! [db, gt, gt, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (69)
        ! [db, db, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (70)
        ! [db, d, db, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (71)
        ! [db, db, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (72)
        ! [db, d, db, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (73)
        ! [db, g, db, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (74)
        ! [db, g, db, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (75)
        ! [u, ub, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (77)
        ! [g, u, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (78)
        ! [u, ub, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (80)
        ! [g, u, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (82)
        ! [db, u, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (84)
        ! [db, u, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (95)
        ! [db, db, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (96)
        ! [db, d, db, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (97)
        ! [db, db, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,4 /))

      case (98)
        ! [db, d, db, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (99)
        ! [db, g, db, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (100)
        ! [db, g, db, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (101)
        ! [u, ub, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (103)
        ! [g, u, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (104)
        ! [u, ub, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 3,5 /))

      case (106)
        ! [g, u, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (108)
        ! [db, u, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case (110)
        ! [db, u, u, lm, nub]
        LIPSwgtWmJJJ = weight_lips((/ 4,5 /))

      case default
        LIPSwgtWmJJJ = 1

      end select
      end
