      subroutine selectchannelWpJJJ()
      use Process_mod, only : nsub_proc, n_alphas_proc, n_alpha_proc
      use Channels_mod
      use PhotonFragmentation_mod
      implicit none
      integer :: i

c---- ave*(4d0*pi*alphas_scl)*(4d0*pi*amzw/stw)**2*(nc**2-1)*(nc*(4d0*pi*alphas_scl))**2
      n_alphas_proc = 3
      n_alpha_proc  = 2
      nsub_proc = 1

      ! PHOTON FRAGMENTATION: DISABLED

      if ( isActive_frag() ) then
        print*, 'selectchannelWpJJJ: no fragmentation supproted!'
        stop
      end if

      ! HADRON FRAGMENTATION: DISABLED

      if ( allocated(qactive_chan) .or.  
     &     allocated(contrib_chan) ) then
        print*, 'selectchannelWpJJJ: already allocated'  
        stop
      end if

      ntot_chan = 113

      allocate(qactive_chan(1:113))
      allocate(contrib_chan(1:113))

      qactive_chan(:) = .false.
      contrib_chan(:) = 0

c---- iproc refers to specific subprocess contributions

c -- tree level 

c      qactive_chan(1)  = .true.   ! u g to g g d nu lp    sB3g0W(1,2,3,4,5,6,7)  
c      qactive_chan(2)  = .true.   ! u db to g g g nu lp   sB3g0W(1,3,4,5,2,6,7)  
c      qactive_chan(3)  = .true.   ! g u to g g d nu lp    sB3g0W(2,1,3,4,5,6,7)  
c      qactive_chan(4)  = .true.   ! db u to g g g nu lp   sB3g0W(2,3,4,5,1,6,7)  
c      qactive_chan(5)  = .true.   ! g g to ub g d nu lp   sB3g0W(3,1,2,4,5,6,7)  
c      qactive_chan(6)  = .true.   ! g db to ub g g nu lp   sB3g0W(3,1,4,5,2,6,7)  
c      qactive_chan(7)  = .true.   ! db g to ub g g nu lp   sB3g0W(3,2,4,5,1,6,7)  
c      qactive_chan(8)  = .true.   ! u g to g g d nu lp    sBt3g0W(1,2,3,4,5,6,7)  
c      qactive_chan(9)  = .true.   ! u db to g g g nu lp   sBt3g0W(1,3,4,5,2,6,7)  
c      qactive_chan(10) = .true.   ! g u to g g d nu lp    sBt3g0W(2,1,3,4,5,6,7)  
c      qactive_chan(11) = .true.   ! db u to g g g nu lp   sBt3g0W(2,3,4,5,1,6,7)  
c      qactive_chan(12) = .true.   ! g g to ub g d nu lp   sBt3g0W(3,1,2,4,5,6,7)  
c      qactive_chan(13) = .true.   ! g db to ub g g nu lp   sBt3g0W(3,1,4,5,2,6,7)  
c      qactive_chan(14) = .true.   ! db g to ub g g nu lp   sBt3g0W(3,2,4,5,1,6,7)  
c      qactive_chan(15) = .true.   ! u gt to gt gt d nu lp   sBtt3g0W(1,2,3,4,5,6,7)  
c      qactive_chan(16) = .true.   ! u db to gt gt gt nu lp   sBtt3g0W(1,3,4,5,2,6,7)  
c      qactive_chan(17) = .true.   ! gt u to gt gt d nu lp   sBtt3g0W(2,1,3,4,5,6,7)  
c      qactive_chan(18) = .true.   ! db u to gt gt gt nu lp   sBtt3g0W(2,3,4,5,1,6,7)  
c      qactive_chan(19) = .true.   ! gt gt to ub gt d nu lp   sBtt3g0W(3,1,2,4,5,6,7)  
c      qactive_chan(20) = .true.   ! gt db to ub gt gt nu lp   sBtt3g0W(3,1,4,5,2,6,7)  
c      qactive_chan(21) = .true.   ! db gt to ub gt gt nu lp   sBtt3g0W(3,2,4,5,1,6,7)  
c      qactive_chan(22) = .true.   ! u g to Q Qb d nu lp   sC1g0W(1,2,3,4,5,6,7)  
c      qactive_chan(23) = .true.   ! u Qb to g Qb d nu lp   sC1g0W(1,3,2,4,5,6,7)  
c      qactive_chan(24) = .true.   ! u Q to g Q d nu lp    sC1g0W(1,3,4,2,5,6,7)  
c      qactive_chan(25) = .true.   ! u db to g Q Qb nu lp   sC1g0W(1,3,4,5,2,6,7)  
c      qactive_chan(26) = .true.   ! g u to Q Qb d nu lp   sC1g0W(2,1,3,4,5,6,7)  
c      qactive_chan(27) = .true.   ! Qb u to g Qb d nu lp   sC1g0W(2,3,1,4,5,6,7)  
c      qactive_chan(28) = .true.   ! Q u to g Q d nu lp    sC1g0W(2,3,4,1,5,6,7)  
c      qactive_chan(29) = .true.   ! db u to g Q Qb nu lp   sC1g0W(2,3,4,5,1,6,7)  
c      qactive_chan(30) = .true.   ! g Qb to ub Qb d nu lp   sC1g0W(3,1,2,4,5,6,7)  
c      qactive_chan(31) = .true.   ! g Q to ub Q d nu lp   sC1g0W(3,1,4,2,5,6,7)  
c      qactive_chan(32) = .true.   ! g db to ub Q Qb nu lp   sC1g0W(3,1,4,5,2,6,7)  
c      qactive_chan(33) = .true.   ! Qb g to ub Qb d nu lp   sC1g0W(3,2,1,4,5,6,7)  
c      qactive_chan(34) = .true.   ! Q g to ub Q d nu lp   sC1g0W(3,2,4,1,5,6,7)  
c      qactive_chan(35) = .true.   ! db g to ub Q Qb nu lp   sC1g0W(3,2,4,5,1,6,7)  
c      qactive_chan(36) = .true.   ! Qb Q to ub g d nu lp   sC1g0W(3,4,1,2,5,6,7)  
c      qactive_chan(37) = .true.   ! Qb db to ub g Qb nu lp   sC1g0W(3,4,1,5,2,6,7)  
c      qactive_chan(38) = .true.   ! Q Qb to ub g d nu lp   sC1g0W(3,4,2,1,5,6,7)  
c      qactive_chan(39) = .true.   ! db Qb to ub g Qb nu lp   sC1g0W(3,4,2,5,1,6,7)  
c      qactive_chan(40) = .true.   ! Q db to ub g Q nu lp   sC1g0W(3,4,5,1,2,6,7)  
c      qactive_chan(41) = .true.   ! db Q to ub g Q nu lp   sC1g0W(3,4,5,2,1,6,7)  
c      qactive_chan(42) = .true.   ! u g to Q Qb d nu lp   sCt1g0W(1,2,3,4,5,6,7)  
c      qactive_chan(43) = .true.   ! u Qb to g Qb d nu lp   sCt1g0W(1,3,2,4,5,6,7)  
c      qactive_chan(44) = .true.   ! u Q to g Q d nu lp    sCt1g0W(1,3,4,2,5,6,7)  
c      qactive_chan(45) = .true.   ! u db to g Q Qb nu lp   sCt1g0W(1,3,4,5,2,6,7)  
c      qactive_chan(46) = .true.   ! g u to Q Qb d nu lp   sCt1g0W(2,1,3,4,5,6,7)  
c      qactive_chan(47) = .true.   ! Qb u to g Qb d nu lp   sCt1g0W(2,3,1,4,5,6,7)  
c      qactive_chan(48) = .true.   ! Q u to g Q d nu lp    sCt1g0W(2,3,4,1,5,6,7)  
c      qactive_chan(49) = .true.   ! db u to g Q Qb nu lp   sCt1g0W(2,3,4,5,1,6,7)  
c      qactive_chan(50) = .true.   ! g Qb to ub Qb d nu lp   sCt1g0W(3,1,2,4,5,6,7)  
c      qactive_chan(51) = .true.   ! g Q to ub Q d nu lp   sCt1g0W(3,1,4,2,5,6,7)  
c      qactive_chan(52) = .true.   ! g db to ub Q Qb nu lp   sCt1g0W(3,1,4,5,2,6,7)  
c      qactive_chan(53) = .true.   ! Qb g to ub Qb d nu lp   sCt1g0W(3,2,1,4,5,6,7)  
c      qactive_chan(54) = .true.   ! Q g to ub Q d nu lp   sCt1g0W(3,2,4,1,5,6,7)  
c      qactive_chan(55) = .true.   ! db g to ub Q Qb nu lp   sCt1g0W(3,2,4,5,1,6,7)  
c      qactive_chan(56) = .true.   ! Qb Q to ub g d nu lp   sCt1g0W(3,4,1,2,5,6,7)  
c      qactive_chan(57) = .true.   ! Qb db to ub g Qb nu lp   sCt1g0W(3,4,1,5,2,6,7)  
c      qactive_chan(58) = .true.   ! Q Qb to ub g d nu lp   sCt1g0W(3,4,2,1,5,6,7)  
c      qactive_chan(59) = .true.   ! db Qb to ub g Qb nu lp   sCt1g0W(3,4,2,5,1,6,7)  
c      qactive_chan(60) = .true.   ! Q db to ub g Q nu lp   sCt1g0W(3,4,5,1,2,6,7)  
c      qactive_chan(61) = .true.   ! db Q to ub g Q nu lp   sCt1g0W(3,4,5,2,1,6,7)  
c      qactive_chan(62) = .true.   ! u g to u ub d nu lp   D1g0Wac(1,2,3,4,5,6,7)  
c      qactive_chan(63) = .true.   ! u ub to g ub d nu lp   D1g0Wac(1,3,2,4,5,6,7)  
c      qactive_chan(64) = .true.   ! u u to g u d nu lp    D1g0Wac(1,3,4,2,5,6,7)  
c      qactive_chan(65) = .true.   ! u db to g u ub nu lp   D1g0Wac(1,3,4,5,2,6,7)  
c      qactive_chan(66) = .true.   ! g u to u ub d nu lp   D1g0Wac(2,1,3,4,5,6,7)  
c      qactive_chan(67) = .true.   ! ub u to g ub d nu lp   D1g0Wac(2,3,1,4,5,6,7)  
c      qactive_chan(68) = .true.   ! db u to g u ub nu lp   D1g0Wac(2,3,4,5,1,6,7)  
c      qactive_chan(69) = .true.   ! g ub to ub ub d nu lp   D1g0Wac(3,1,2,4,5,6,7)  
c      qactive_chan(70) = .true.   ! g db to ub u ub nu lp   D1g0Wac(3,1,4,5,2,6,7)  
c      qactive_chan(71) = .true.   ! ub g to ub ub d nu lp   D1g0Wac(3,2,1,4,5,6,7)  
c      qactive_chan(72) = .true.   ! db g to ub u ub nu lp   D1g0Wac(3,2,4,5,1,6,7)  
c      qactive_chan(73) = .true.   ! ub db to ub g ub nu lp   D1g0Wac(3,4,1,5,2,6,7)  
c      qactive_chan(74) = .true.   ! db ub to ub g ub nu lp   D1g0Wac(3,4,2,5,1,6,7)  
c      qactive_chan(75) = .true.   ! u g to d db d nu lp   D1g0Wbc(1,2,3,4,5,6,7)  
c      qactive_chan(76) = .true.   ! u db to g db d nu lp   D1g0Wbc(1,3,2,4,5,6,7)  
c      qactive_chan(77) = .true.   ! u d to g d d nu lp    D1g0Wbc(1,3,4,2,5,6,7)  
c      qactive_chan(78) = .true.   ! g u to d db d nu lp   D1g0Wbc(2,1,3,4,5,6,7)  
c      qactive_chan(79) = .true.   ! db u to g db d nu lp   D1g0Wbc(2,3,1,4,5,6,7)  
c      qactive_chan(80) = .true.   ! d u to g d d nu lp    D1g0Wbc(2,3,4,1,5,6,7)  
c      qactive_chan(81) = .true.   ! g db to ub db d nu lp   D1g0Wbc(3,1,2,4,5,6,7)  
c      qactive_chan(82) = .true.   ! g d to ub d d nu lp   D1g0Wbc(3,1,4,2,5,6,7)  
c      qactive_chan(83) = .true.   ! db g to ub db d nu lp   D1g0Wbc(3,2,1,4,5,6,7)  
c      qactive_chan(84) = .true.   ! d g to ub d d nu lp   D1g0Wbc(3,2,4,1,5,6,7)  
c      qactive_chan(85) = .true.   ! db d to ub g d nu lp   D1g0Wbc(3,4,1,2,5,6,7)  
c      qactive_chan(86) = .true.   ! db db to ub g db nu lp   D1g0Wbc(3,4,1,5,2,6,7)  
c      qactive_chan(87) = .true.   ! d db to ub g d nu lp   D1g0Wbc(3,4,2,1,5,6,7)  
c      qactive_chan(88) = .true.   ! u g to u ub d nu lp   Dt1g0Wa(1,2,3,4,5,6,7)  
c      qactive_chan(89) = .true.   ! u ub to g ub d nu lp   Dt1g0Wa(1,3,2,4,5,6,7)  
c      qactive_chan(90) = .true.   ! u u to g u d nu lp    Dt1g0Wa(1,3,4,2,5,6,7)  
c      qactive_chan(91) = .true.   ! u db to g u ub nu lp   Dt1g0Wa(1,3,4,5,2,6,7)  
c      qactive_chan(92) = .true.   ! g u to u ub d nu lp   Dt1g0Wa(2,1,3,4,5,6,7)  
c      qactive_chan(93) = .true.   ! ub u to g ub d nu lp   Dt1g0Wa(2,3,1,4,5,6,7)  
c      qactive_chan(94) = .true.   ! db u to g u ub nu lp   Dt1g0Wa(2,3,4,5,1,6,7)  
c      qactive_chan(95) = .true.   ! g ub to ub ub d nu lp   Dt1g0Wa(3,1,2,4,5,6,7)  
c      qactive_chan(96) = .true.   ! g db to ub u ub nu lp   Dt1g0Wa(3,1,4,5,2,6,7)  
c      qactive_chan(97) = .true.   ! ub g to ub ub d nu lp   Dt1g0Wa(3,2,1,4,5,6,7)  
c      qactive_chan(98) = .true.   ! db g to ub u ub nu lp   Dt1g0Wa(3,2,4,5,1,6,7)  
c      qactive_chan(99) = .true.   ! ub db to ub g ub nu lp   Dt1g0Wa(3,4,1,5,2,6,7)  
c      qactive_chan(100)= .true.   ! db ub to ub g ub nu lp   Dt1g0Wa(3,4,2,5,1,6,7)  
c      qactive_chan(101)= .true.   ! u g to d db d nu lp   Dt1g0Wb(1,2,3,4,5,6,7)  
c      qactive_chan(102)= .true.   ! u db to g db d nu lp   Dt1g0Wb(1,3,2,4,5,6,7)  
c      qactive_chan(103)= .true.   ! u d to g d d nu lp    Dt1g0Wb(1,3,4,2,5,6,7)  
c      qactive_chan(104)= .true.   ! g u to d db d nu lp   Dt1g0Wb(2,1,3,4,5,6,7)  
c      qactive_chan(105)= .true.   ! db u to g db d nu lp   Dt1g0Wb(2,3,1,4,5,6,7)  
c      qactive_chan(106)= .true.   ! d u to g d d nu lp    Dt1g0Wb(2,3,4,1,5,6,7)  
c      qactive_chan(107)= .true.   ! g db to ub db d nu lp   Dt1g0Wb(3,1,2,4,5,6,7)  
c      qactive_chan(108)= .true.   ! g d to ub d d nu lp   Dt1g0Wb(3,1,4,2,5,6,7)  
c      qactive_chan(109)= .true.   ! db g to ub db d nu lp   Dt1g0Wb(3,2,1,4,5,6,7)  
c      qactive_chan(110)= .true.   ! d g to ub d d nu lp   Dt1g0Wb(3,2,4,1,5,6,7)  
c      qactive_chan(111)= .true.   ! db d to ub g d nu lp   Dt1g0Wb(3,4,1,2,5,6,7)  
c      qactive_chan(112)= .true.   ! db db to ub g db nu lp   Dt1g0Wb(3,4,1,5,2,6,7)  
c      qactive_chan(113)= .true.   ! d db to ub g d nu lp   Dt1g0Wb(3,4,2,1,5,6,7)  

      do i=1,113
        contrib_chan(i)=1
      enddo

c -- real                                         ME                   SNLO 

c -- virtual                                      ME                   TNLO  

c -- double real                                  ME                   S  

c -- real virtual                                 ME                   T  

c -- double virtual                               ME                   U  

      return
      end


c---- get channel strings
      subroutine getchannelWpJJJ(ip, chan_str, me_str, sub_str)
      implicit none
      integer, intent(in) :: ip
      character(:), allocatable, intent(out) :: chan_str, me_str, sub_str

      select case (ip)

      case (1)
        chan_str = 'u g to g g d nu lp  '
        me_str   = 'sB3g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (2)
        chan_str = 'u db to g g g nu lp '
        me_str   = 'sB3g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (3)
        chan_str = 'g u to g g d nu lp  '
        me_str   = 'sB3g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (4)
        chan_str = 'db u to g g g nu lp '
        me_str   = 'sB3g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (5)
        chan_str = 'g g to ub g d nu lp '
        me_str   = 'sB3g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (6)
        chan_str = 'g db to ub g g nu lp '
        me_str   = 'sB3g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (7)
        chan_str = 'db g to ub g g nu lp '
        me_str   = 'sB3g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (8)
        chan_str = 'u g to g g d nu lp  '
        me_str   = 'sBt3g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (9)
        chan_str = 'u db to g g g nu lp '
        me_str   = 'sBt3g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (10)
        chan_str = 'g u to g g d nu lp  '
        me_str   = 'sBt3g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (11)
        chan_str = 'db u to g g g nu lp '
        me_str   = 'sBt3g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (12)
        chan_str = 'g g to ub g d nu lp '
        me_str   = 'sBt3g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (13)
        chan_str = 'g db to ub g g nu lp '
        me_str   = 'sBt3g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (14)
        chan_str = 'db g to ub g g nu lp '
        me_str   = 'sBt3g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (15)
        chan_str = 'u gt to gt gt d nu lp '
        me_str   = 'sBtt3g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (16)
        chan_str = 'u db to gt gt gt nu lp '
        me_str   = 'sBtt3g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (17)
        chan_str = 'gt u to gt gt d nu lp '
        me_str   = 'sBtt3g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (18)
        chan_str = 'db u to gt gt gt nu lp '
        me_str   = 'sBtt3g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (19)
        chan_str = 'gt gt to ub gt d nu lp '
        me_str   = 'sBtt3g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (20)
        chan_str = 'gt db to ub gt gt nu lp '
        me_str   = 'sBtt3g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (21)
        chan_str = 'db gt to ub gt gt nu lp '
        me_str   = 'sBtt3g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (22)
        chan_str = 'u g to Q Qb d nu lp '
        me_str   = 'sC1g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (23)
        chan_str = 'u Qb to g Qb d nu lp '
        me_str   = 'sC1g0W(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (24)
        chan_str = 'u Q to g Q d nu lp  '
        me_str   = 'sC1g0W(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (25)
        chan_str = 'u db to g Q Qb nu lp '
        me_str   = 'sC1g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (26)
        chan_str = 'g u to Q Qb d nu lp '
        me_str   = 'sC1g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (27)
        chan_str = 'Qb u to g Qb d nu lp '
        me_str   = 'sC1g0W(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (28)
        chan_str = 'Q u to g Q d nu lp  '
        me_str   = 'sC1g0W(2,3,4,1,5,6,7)'
        sub_str  = ''

      case (29)
        chan_str = 'db u to g Q Qb nu lp '
        me_str   = 'sC1g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (30)
        chan_str = 'g Qb to ub Qb d nu lp '
        me_str   = 'sC1g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (31)
        chan_str = 'g Q to ub Q d nu lp '
        me_str   = 'sC1g0W(3,1,4,2,5,6,7)'
        sub_str  = ''

      case (32)
        chan_str = 'g db to ub Q Qb nu lp '
        me_str   = 'sC1g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (33)
        chan_str = 'Qb g to ub Qb d nu lp '
        me_str   = 'sC1g0W(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (34)
        chan_str = 'Q g to ub Q d nu lp '
        me_str   = 'sC1g0W(3,2,4,1,5,6,7)'
        sub_str  = ''

      case (35)
        chan_str = 'db g to ub Q Qb nu lp '
        me_str   = 'sC1g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (36)
        chan_str = 'Qb Q to ub g d nu lp '
        me_str   = 'sC1g0W(3,4,1,2,5,6,7)'
        sub_str  = ''

      case (37)
        chan_str = 'Qb db to ub g Qb nu lp '
        me_str   = 'sC1g0W(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (38)
        chan_str = 'Q Qb to ub g d nu lp '
        me_str   = 'sC1g0W(3,4,2,1,5,6,7)'
        sub_str  = ''

      case (39)
        chan_str = 'db Qb to ub g Qb nu lp '
        me_str   = 'sC1g0W(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (40)
        chan_str = 'Q db to ub g Q nu lp '
        me_str   = 'sC1g0W(3,4,5,1,2,6,7)'
        sub_str  = ''

      case (41)
        chan_str = 'db Q to ub g Q nu lp '
        me_str   = 'sC1g0W(3,4,5,2,1,6,7)'
        sub_str  = ''

      case (42)
        chan_str = 'u g to Q Qb d nu lp '
        me_str   = 'sCt1g0W(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (43)
        chan_str = 'u Qb to g Qb d nu lp '
        me_str   = 'sCt1g0W(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (44)
        chan_str = 'u Q to g Q d nu lp  '
        me_str   = 'sCt1g0W(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (45)
        chan_str = 'u db to g Q Qb nu lp '
        me_str   = 'sCt1g0W(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (46)
        chan_str = 'g u to Q Qb d nu lp '
        me_str   = 'sCt1g0W(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (47)
        chan_str = 'Qb u to g Qb d nu lp '
        me_str   = 'sCt1g0W(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (48)
        chan_str = 'Q u to g Q d nu lp  '
        me_str   = 'sCt1g0W(2,3,4,1,5,6,7)'
        sub_str  = ''

      case (49)
        chan_str = 'db u to g Q Qb nu lp '
        me_str   = 'sCt1g0W(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (50)
        chan_str = 'g Qb to ub Qb d nu lp '
        me_str   = 'sCt1g0W(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (51)
        chan_str = 'g Q to ub Q d nu lp '
        me_str   = 'sCt1g0W(3,1,4,2,5,6,7)'
        sub_str  = ''

      case (52)
        chan_str = 'g db to ub Q Qb nu lp '
        me_str   = 'sCt1g0W(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (53)
        chan_str = 'Qb g to ub Qb d nu lp '
        me_str   = 'sCt1g0W(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (54)
        chan_str = 'Q g to ub Q d nu lp '
        me_str   = 'sCt1g0W(3,2,4,1,5,6,7)'
        sub_str  = ''

      case (55)
        chan_str = 'db g to ub Q Qb nu lp '
        me_str   = 'sCt1g0W(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (56)
        chan_str = 'Qb Q to ub g d nu lp '
        me_str   = 'sCt1g0W(3,4,1,2,5,6,7)'
        sub_str  = ''

      case (57)
        chan_str = 'Qb db to ub g Qb nu lp '
        me_str   = 'sCt1g0W(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (58)
        chan_str = 'Q Qb to ub g d nu lp '
        me_str   = 'sCt1g0W(3,4,2,1,5,6,7)'
        sub_str  = ''

      case (59)
        chan_str = 'db Qb to ub g Qb nu lp '
        me_str   = 'sCt1g0W(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (60)
        chan_str = 'Q db to ub g Q nu lp '
        me_str   = 'sCt1g0W(3,4,5,1,2,6,7)'
        sub_str  = ''

      case (61)
        chan_str = 'db Q to ub g Q nu lp '
        me_str   = 'sCt1g0W(3,4,5,2,1,6,7)'
        sub_str  = ''

      case (62)
        chan_str = 'u g to u ub d nu lp '
        me_str   = 'D1g0Wac(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (63)
        chan_str = 'u ub to g ub d nu lp '
        me_str   = 'D1g0Wac(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (64)
        chan_str = 'u u to g u d nu lp  '
        me_str   = 'D1g0Wac(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (65)
        chan_str = 'u db to g u ub nu lp '
        me_str   = 'D1g0Wac(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (66)
        chan_str = 'g u to u ub d nu lp '
        me_str   = 'D1g0Wac(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (67)
        chan_str = 'ub u to g ub d nu lp '
        me_str   = 'D1g0Wac(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (68)
        chan_str = 'db u to g u ub nu lp '
        me_str   = 'D1g0Wac(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (69)
        chan_str = 'g ub to ub ub d nu lp '
        me_str   = 'D1g0Wac(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (70)
        chan_str = 'g db to ub u ub nu lp '
        me_str   = 'D1g0Wac(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (71)
        chan_str = 'ub g to ub ub d nu lp '
        me_str   = 'D1g0Wac(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (72)
        chan_str = 'db g to ub u ub nu lp '
        me_str   = 'D1g0Wac(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (73)
        chan_str = 'ub db to ub g ub nu lp '
        me_str   = 'D1g0Wac(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (74)
        chan_str = 'db ub to ub g ub nu lp '
        me_str   = 'D1g0Wac(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (75)
        chan_str = 'u g to d db d nu lp '
        me_str   = 'D1g0Wbc(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (76)
        chan_str = 'u db to g db d nu lp '
        me_str   = 'D1g0Wbc(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (77)
        chan_str = 'u d to g d d nu lp  '
        me_str   = 'D1g0Wbc(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (78)
        chan_str = 'g u to d db d nu lp '
        me_str   = 'D1g0Wbc(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (79)
        chan_str = 'db u to g db d nu lp '
        me_str   = 'D1g0Wbc(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (80)
        chan_str = 'd u to g d d nu lp  '
        me_str   = 'D1g0Wbc(2,3,4,1,5,6,7)'
        sub_str  = ''

      case (81)
        chan_str = 'g db to ub db d nu lp '
        me_str   = 'D1g0Wbc(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (82)
        chan_str = 'g d to ub d d nu lp '
        me_str   = 'D1g0Wbc(3,1,4,2,5,6,7)'
        sub_str  = ''

      case (83)
        chan_str = 'db g to ub db d nu lp '
        me_str   = 'D1g0Wbc(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (84)
        chan_str = 'd g to ub d d nu lp '
        me_str   = 'D1g0Wbc(3,2,4,1,5,6,7)'
        sub_str  = ''

      case (85)
        chan_str = 'db d to ub g d nu lp '
        me_str   = 'D1g0Wbc(3,4,1,2,5,6,7)'
        sub_str  = ''

      case (86)
        chan_str = 'db db to ub g db nu lp '
        me_str   = 'D1g0Wbc(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (87)
        chan_str = 'd db to ub g d nu lp '
        me_str   = 'D1g0Wbc(3,4,2,1,5,6,7)'
        sub_str  = ''

      case (88)
        chan_str = 'u g to u ub d nu lp '
        me_str   = 'Dt1g0Wa(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (89)
        chan_str = 'u ub to g ub d nu lp '
        me_str   = 'Dt1g0Wa(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (90)
        chan_str = 'u u to g u d nu lp  '
        me_str   = 'Dt1g0Wa(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (91)
        chan_str = 'u db to g u ub nu lp '
        me_str   = 'Dt1g0Wa(1,3,4,5,2,6,7)'
        sub_str  = ''

      case (92)
        chan_str = 'g u to u ub d nu lp '
        me_str   = 'Dt1g0Wa(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (93)
        chan_str = 'ub u to g ub d nu lp '
        me_str   = 'Dt1g0Wa(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (94)
        chan_str = 'db u to g u ub nu lp '
        me_str   = 'Dt1g0Wa(2,3,4,5,1,6,7)'
        sub_str  = ''

      case (95)
        chan_str = 'g ub to ub ub d nu lp '
        me_str   = 'Dt1g0Wa(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (96)
        chan_str = 'g db to ub u ub nu lp '
        me_str   = 'Dt1g0Wa(3,1,4,5,2,6,7)'
        sub_str  = ''

      case (97)
        chan_str = 'ub g to ub ub d nu lp '
        me_str   = 'Dt1g0Wa(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (98)
        chan_str = 'db g to ub u ub nu lp '
        me_str   = 'Dt1g0Wa(3,2,4,5,1,6,7)'
        sub_str  = ''

      case (99)
        chan_str = 'ub db to ub g ub nu lp '
        me_str   = 'Dt1g0Wa(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (100)
        chan_str = 'db ub to ub g ub nu lp '
        me_str   = 'Dt1g0Wa(3,4,2,5,1,6,7)'
        sub_str  = ''

      case (101)
        chan_str = 'u g to d db d nu lp '
        me_str   = 'Dt1g0Wb(1,2,3,4,5,6,7)'
        sub_str  = ''

      case (102)
        chan_str = 'u db to g db d nu lp '
        me_str   = 'Dt1g0Wb(1,3,2,4,5,6,7)'
        sub_str  = ''

      case (103)
        chan_str = 'u d to g d d nu lp  '
        me_str   = 'Dt1g0Wb(1,3,4,2,5,6,7)'
        sub_str  = ''

      case (104)
        chan_str = 'g u to d db d nu lp '
        me_str   = 'Dt1g0Wb(2,1,3,4,5,6,7)'
        sub_str  = ''

      case (105)
        chan_str = 'db u to g db d nu lp '
        me_str   = 'Dt1g0Wb(2,3,1,4,5,6,7)'
        sub_str  = ''

      case (106)
        chan_str = 'd u to g d d nu lp  '
        me_str   = 'Dt1g0Wb(2,3,4,1,5,6,7)'
        sub_str  = ''

      case (107)
        chan_str = 'g db to ub db d nu lp '
        me_str   = 'Dt1g0Wb(3,1,2,4,5,6,7)'
        sub_str  = ''

      case (108)
        chan_str = 'g d to ub d d nu lp '
        me_str   = 'Dt1g0Wb(3,1,4,2,5,6,7)'
        sub_str  = ''

      case (109)
        chan_str = 'db g to ub db d nu lp '
        me_str   = 'Dt1g0Wb(3,2,1,4,5,6,7)'
        sub_str  = ''

      case (110)
        chan_str = 'd g to ub d d nu lp '
        me_str   = 'Dt1g0Wb(3,2,4,1,5,6,7)'
        sub_str  = ''

      case (111)
        chan_str = 'db d to ub g d nu lp '
        me_str   = 'Dt1g0Wb(3,4,1,2,5,6,7)'
        sub_str  = ''

      case (112)
        chan_str = 'db db to ub g db nu lp '
        me_str   = 'Dt1g0Wb(3,4,1,5,2,6,7)'
        sub_str  = ''

      case (113)
        chan_str = 'd db to ub g d nu lp '
        me_str   = 'Dt1g0Wb(3,4,2,1,5,6,7)'
        sub_str  = ''

      case default
        print*, 'getchannelWpJJJ: invalid ip:', ip
        stop

      end select
      end

c---- get final-state permutation
      integer function LIPSwgtWpJJJ(ip)
      use LIPS_mod
      implicit none
      integer, intent(in) :: ip

      LIPSwgtWpJJJ = 1
      if ( .not. isActive_reduce_lips() ) return

      select case (ip)

      case (1)
        ! [g, g, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (2)
        ! [g, g, g, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4,5 /))

      case (3)
        ! [g, g, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (4)
        ! [g, g, g, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4,5 /))

      case (6)
        ! [ub, g, g, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (7)
        ! [ub, g, g, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (8)
        ! [g, g, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (9)
        ! [g, g, g, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4,5 /))

      case (10)
        ! [g, g, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (11)
        ! [g, g, g, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4,5 /))

      case (13)
        ! [ub, g, g, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (14)
        ! [ub, g, g, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (15)
        ! [gt, gt, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (16)
        ! [gt, gt, gt, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4,5 /))

      case (17)
        ! [gt, gt, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (18)
        ! [gt, gt, gt, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4,5 /))

      case (20)
        ! [ub, gt, gt, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (21)
        ! [ub, gt, gt, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (69)
        ! [ub, ub, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (70)
        ! [ub, u, ub, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (71)
        ! [ub, ub, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (72)
        ! [ub, u, ub, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (73)
        ! [ub, g, ub, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (74)
        ! [ub, g, ub, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (75)
        ! [d, db, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (77)
        ! [g, d, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (78)
        ! [d, db, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (80)
        ! [g, d, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (82)
        ! [ub, d, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (84)
        ! [ub, d, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (95)
        ! [ub, ub, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (96)
        ! [ub, u, ub, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (97)
        ! [ub, ub, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,4 /))

      case (98)
        ! [ub, u, ub, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (99)
        ! [ub, g, ub, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (100)
        ! [ub, g, ub, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (101)
        ! [d, db, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (103)
        ! [g, d, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (104)
        ! [d, db, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 3,5 /))

      case (106)
        ! [g, d, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (108)
        ! [ub, d, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case (110)
        ! [ub, d, d, nu, lp]
        LIPSwgtWpJJJ = weight_lips((/ 4,5 /))

      case default
        LIPSwgtWpJJJ = 1

      end select
      end
