      function sigUZ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUZ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d db to lp lm       
        if (qactive_chan(179).and.qselect_chan(179)) then
          current_chan = 179
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to lp lm       
        if (qactive_chan(180).and.qselect_chan(180)) then
          current_chan = 180
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to lp lm       
        if (qactive_chan(181).and.qselect_chan(181)) then
          current_chan = 181
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqB0g2ZU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to lp lm       
        if (qactive_chan(182).and.qselect_chan(182)) then
          current_chan = 182
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqB0g2ZU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(183).and.qselect_chan(183)) then
          current_chan = 183
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(184).and.qselect_chan(184)) then
          current_chan = 184
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(185).and.qselect_chan(185)) then
          current_chan = 185
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(186).and.qselect_chan(186)) then
          current_chan = 186
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(187).and.qselect_chan(187)) then
          current_chan = 187
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(188).and.qselect_chan(188)) then
          current_chan = 188
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(189).and.qselect_chan(189)) then
          current_chan = 189
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(190).and.qselect_chan(190)) then
          current_chan = 190
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(191).and.qselect_chan(191)) then
          current_chan = 191
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(192).and.qselect_chan(192)) then
          current_chan = 192
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(193).and.qselect_chan(193)) then
          current_chan = 193
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(194).and.qselect_chan(194)) then
          current_chan = 194
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(195).and.qselect_chan(195)) then
          current_chan = 195
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(196).and.qselect_chan(196)) then
          current_chan = 196
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(197).and.qselect_chan(197)) then
          current_chan = 197
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(198).and.qselect_chan(198)) then
          current_chan = 198
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(199).and.qselect_chan(199)) then
          current_chan = 199
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(200).and.qselect_chan(200)) then
          current_chan = 200
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(201).and.qselect_chan(201)) then
          current_chan = 201
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(202).and.qselect_chan(202)) then
          current_chan = 202
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(203).and.qselect_chan(203)) then
          current_chan = 203
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(204).and.qselect_chan(204)) then
          current_chan = 204
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(205).and.qselect_chan(205)) then
          current_chan = 205
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(206).and.qselect_chan(206)) then
          current_chan = 206
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(207).and.qselect_chan(207)) then
          current_chan = 207
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(208).and.qselect_chan(208)) then
          current_chan = 208
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(209).and.qselect_chan(209)) then
          current_chan = 209
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(210).and.qselect_chan(210)) then
          current_chan = 210
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(211).and.qselect_chan(211)) then
          current_chan = 211
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(212).and.qselect_chan(212)) then
          current_chan = 212
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbB0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to lp lm       
        if (qactive_chan(213).and.qselect_chan(213)) then
          current_chan = 213
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to lp lm       
        if (qactive_chan(214).and.qselect_chan(214)) then
          current_chan = 214
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to lp lm       
        if (qactive_chan(215).and.qselect_chan(215)) then
          current_chan = 215
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqBt0g2ZU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to lp lm       
        if (qactive_chan(216).and.qselect_chan(216)) then
          current_chan = 216
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqBt0g2ZU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(217).and.qselect_chan(217)) then
          current_chan = 217
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(218).and.qselect_chan(218)) then
          current_chan = 218
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(219).and.qselect_chan(219)) then
          current_chan = 219
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(220).and.qselect_chan(220)) then
          current_chan = 220
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(221).and.qselect_chan(221)) then
          current_chan = 221
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(222).and.qselect_chan(222)) then
          current_chan = 222
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(223).and.qselect_chan(223)) then
          current_chan = 223
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(224).and.qselect_chan(224)) then
          current_chan = 224
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(225).and.qselect_chan(225)) then
          current_chan = 225
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(226).and.qselect_chan(226)) then
          current_chan = 226
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(227).and.qselect_chan(227)) then
          current_chan = 227
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(228).and.qselect_chan(228)) then
          current_chan = 228
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(229).and.qselect_chan(229)) then
          current_chan = 229
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(230).and.qselect_chan(230)) then
          current_chan = 230
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(231).and.qselect_chan(231)) then
          current_chan = 231
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(232).and.qselect_chan(232)) then
          current_chan = 232
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(233).and.qselect_chan(233)) then
          current_chan = 233
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(234).and.qselect_chan(234)) then
          current_chan = 234
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(235).and.qselect_chan(235)) then
          current_chan = 235
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(236).and.qselect_chan(236)) then
          current_chan = 236
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(237).and.qselect_chan(237)) then
          current_chan = 237
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(238).and.qselect_chan(238)) then
          current_chan = 238
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(239).and.qselect_chan(239)) then
          current_chan = 239
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(240).and.qselect_chan(240)) then
          current_chan = 240
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(241).and.qselect_chan(241)) then
          current_chan = 241
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(242).and.qselect_chan(242)) then
          current_chan = 242
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(243).and.qselect_chan(243)) then
          current_chan = 243
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(244).and.qselect_chan(244)) then
          current_chan = 244
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(245).and.qselect_chan(245)) then
          current_chan = 245
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(246).and.qselect_chan(246)) then
          current_chan = 246
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbBt0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to lp lm       
        if (qactive_chan(247).and.qselect_chan(247)) then
          current_chan = 247
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to lp lm       
        if (qactive_chan(248).and.qselect_chan(248)) then
          current_chan = 248
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to lp lm       
        if (qactive_chan(249).and.qselect_chan(249)) then
          current_chan = 249
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqBh0g2ZU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to lp lm       
        if (qactive_chan(250).and.qselect_chan(250)) then
          current_chan = 250
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqBh0g2ZU(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(251).and.qselect_chan(251)) then
          current_chan = 251
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(252).and.qselect_chan(252)) then
          current_chan = 252
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(253).and.qselect_chan(253)) then
          current_chan = 253
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(254).and.qselect_chan(254)) then
          current_chan = 254
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(255).and.qselect_chan(255)) then
          current_chan = 255
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(256).and.qselect_chan(256)) then
          current_chan = 256
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(257).and.qselect_chan(257)) then
          current_chan = 257
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(258).and.qselect_chan(258)) then
          current_chan = 258
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(259).and.qselect_chan(259)) then
          current_chan = 259
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(260).and.qselect_chan(260)) then
          current_chan = 260
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(261).and.qselect_chan(261)) then
          current_chan = 261
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(262).and.qselect_chan(262)) then
          current_chan = 262
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(263).and.qselect_chan(263)) then
          current_chan = 263
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(264).and.qselect_chan(264)) then
          current_chan = 264
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(265).and.qselect_chan(265)) then
          current_chan = 265
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(266).and.qselect_chan(266)) then
          current_chan = 266
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(267).and.qselect_chan(267)) then
          current_chan = 267
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(268).and.qselect_chan(268)) then
          current_chan = 268
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(269).and.qselect_chan(269)) then
          current_chan = 269
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(270).and.qselect_chan(270)) then
          current_chan = 270
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(271).and.qselect_chan(271)) then
          current_chan = 271
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(272).and.qselect_chan(272)) then
          current_chan = 272
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(273).and.qselect_chan(273)) then
          current_chan = 273
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(274).and.qselect_chan(274)) then
          current_chan = 274
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(275).and.qselect_chan(275)) then
          current_chan = 275
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(276).and.qselect_chan(276)) then
          current_chan = 276
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(277).and.qselect_chan(277)) then
          current_chan = 277
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(278).and.qselect_chan(278)) then
          current_chan = 278
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(279).and.qselect_chan(279)) then
          current_chan = 279
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(280).and.qselect_chan(280)) then
          current_chan = 280
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbBh0g2ZU(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUZ=sigUZ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
