C --- Quark pair NLO real subtraction term for
C ---
C --- q(i1) g (i2) g (i3) qb(i4) e-(i5) e+(i6)
C ---
C --- summed and squared over helicities, single colour ordering without
C --- overall factors

C --- The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BZFlav/

      function gtqBt2g0ZSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gtqBt2g0ZSNLO = qgtBt2g0ZSNLO(i1,i2,i3,i4,i5,i6)

      return
      end
      function gtqbBt2g0ZSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gtqbBt2g0ZSNLO = qbgtBt2g0ZSNLO(i1,i2,i3,i4,i5,i6)

      return
      end

      function qbqBt2g0ZSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbqBt2g0ZSNLO = qqbBt2g0ZSNLO(i1,i2,i3,i4,i5,i6)

      return
      end


      function gtgtBt2g0ZSNLO(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gtgtBt2g0ZSNLO = ggB2g0ZSNLO(i1,i2,i3,i4,i5,i6)

      return
      end


