      function sigSZJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSZJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      jflag=.false.
      ix=1
      ix_chan=1

c--- d g to g g d lm lp  
      if (qactive_chan(163).and.qselect_chan(163)) then
        current_chan = 163
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgsB3g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to g g u lm lp  
      if (qactive_chan(164).and.qselect_chan(164)) then
        current_chan = 164
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgsB3g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g g g lm lp 
      if (qactive_chan(165).and.qselect_chan(165)) then
        current_chan = 165
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbsB3g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g g g lm lp 
      if (qactive_chan(166).and.qselect_chan(166)) then
        current_chan = 166
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbsB3g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to g g d lm lp  
      if (qactive_chan(167).and.qselect_chan(167)) then
        current_chan = 167
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gqsB3g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to g g u lm lp  
      if (qactive_chan(168).and.qselect_chan(168)) then
        current_chan = 168
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gqsB3g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g g g lm lp 
      if (qactive_chan(169).and.qselect_chan(169)) then
        current_chan = 169
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqsB3g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g g g lm lp 
      if (qactive_chan(170).and.qselect_chan(170)) then
        current_chan = 170
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqsB3g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g g to db g d lm lp 
      if (qactive_chan(171).and.qselect_chan(171)) then
        current_chan = 171
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        wt = ggsB3g0ZS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g g to ub g u lm lp 
      if (qactive_chan(172).and.qselect_chan(172)) then
        current_chan = 172
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        wt = ggsB3g0ZS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db g g lm lp 
      if (qactive_chan(173).and.qselect_chan(173)) then
        current_chan = 173
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gqbsB3g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub g g lm lp 
      if (qactive_chan(174).and.qselect_chan(174)) then
        current_chan = 174
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gqbsB3g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db g g lm lp 
      if (qactive_chan(175).and.qselect_chan(175)) then
        current_chan = 175
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgsB3g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub g g lm lp 
      if (qactive_chan(176).and.qselect_chan(176)) then
        current_chan = 176
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgsB3g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to g g d lm lp  
      if (qactive_chan(177).and.qselect_chan(177)) then
        current_chan = 177
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgsBt3g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to g g u lm lp  
      if (qactive_chan(178).and.qselect_chan(178)) then
        current_chan = 178
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgsBt3g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g g g lm lp 
      if (qactive_chan(179).and.qselect_chan(179)) then
        current_chan = 179
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbsBt3g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g g g lm lp 
      if (qactive_chan(180).and.qselect_chan(180)) then
        current_chan = 180
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbsBt3g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to g g d lm lp  
      if (qactive_chan(181).and.qselect_chan(181)) then
        current_chan = 181
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gqsBt3g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to g g u lm lp  
      if (qactive_chan(182).and.qselect_chan(182)) then
        current_chan = 182
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gqsBt3g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g g g lm lp 
      if (qactive_chan(183).and.qselect_chan(183)) then
        current_chan = 183
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqsBt3g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g g g lm lp 
      if (qactive_chan(184).and.qselect_chan(184)) then
        current_chan = 184
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqsBt3g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g g to db g d lm lp 
      if (qactive_chan(185).and.qselect_chan(185)) then
        current_chan = 185
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        wt = ggsBt3g0ZS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g g to ub g u lm lp 
      if (qactive_chan(186).and.qselect_chan(186)) then
        current_chan = 186
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        wt = ggsBt3g0ZS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db g g lm lp 
      if (qactive_chan(187).and.qselect_chan(187)) then
        current_chan = 187
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gqbsBt3g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub g g lm lp 
      if (qactive_chan(188).and.qselect_chan(188)) then
        current_chan = 188
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gqbsBt3g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db g g lm lp 
      if (qactive_chan(189).and.qselect_chan(189)) then
        current_chan = 189
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgsBt3g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub g g lm lp 
      if (qactive_chan(190).and.qselect_chan(190)) then
        current_chan = 190
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgsBt3g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d gt to gt gt d lm lp 
      if (qactive_chan(191).and.qselect_chan(191)) then
        current_chan = 191
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgtsBtt3g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u gt to gt gt u lm lp 
      if (qactive_chan(192).and.qselect_chan(192)) then
        current_chan = 192
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgtsBtt3g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to gt gt gt lm lp 
      if (qactive_chan(193).and.qselect_chan(193)) then
        current_chan = 193
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbsBtt3g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to gt gt gt lm lp 
      if (qactive_chan(194).and.qselect_chan(194)) then
        current_chan = 194
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbsBtt3g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- gt d to gt gt d lm lp 
      if (qactive_chan(195).and.qselect_chan(195)) then
        current_chan = 195
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gtqsBtt3g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- gt u to gt gt u lm lp 
      if (qactive_chan(196).and.qselect_chan(196)) then
        current_chan = 196
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gtqsBtt3g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to gt gt gt lm lp 
      if (qactive_chan(197).and.qselect_chan(197)) then
        current_chan = 197
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqsBtt3g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to gt gt gt lm lp 
      if (qactive_chan(198).and.qselect_chan(198)) then
        current_chan = 198
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqsBtt3g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- gt gt to db gt d lm lp 
      if (qactive_chan(199).and.qselect_chan(199)) then
        current_chan = 199
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 1
        wt = gtgtsBtt3g0ZS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- gt gt to ub gt u lm lp 
      if (qactive_chan(200).and.qselect_chan(200)) then
        current_chan = 200
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
        wt = gtgtsBtt3g0ZS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- gt db to db gt gt lm lp 
      if (qactive_chan(201).and.qselect_chan(201)) then
        current_chan = 201
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gtqbsBtt3g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- gt ub to ub gt gt lm lp 
      if (qactive_chan(202).and.qselect_chan(202)) then
        current_chan = 202
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gtqbsBtt3g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db gt to db gt gt lm lp 
      if (qactive_chan(203).and.qselect_chan(203)) then
        current_chan = 203
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgtsBtt3g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub gt to ub gt gt lm lp 
      if (qactive_chan(204).and.qselect_chan(204)) then
        current_chan = 204
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgtsBtt3g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to d db d lm lp 
      if (qactive_chan(205).and.qselect_chan(205)) then
        current_chan = 205
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qgsC1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to u ub d lm lp 
      if (qactive_chan(206).and.qselect_chan(206)) then
        current_chan = 206
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 2
        wt = qgsC1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to d db u lm lp 
      if (qactive_chan(207).and.qselect_chan(207)) then
        current_chan = 207
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 1
        wt = qgsC1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to u ub u lm lp 
      if (qactive_chan(208).and.qselect_chan(208)) then
        current_chan = 208
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qgsC1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g db d lm lp 
      if (qactive_chan(209).and.qselect_chan(209)) then
        current_chan = 209
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qqpbsC1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g ub d lm lp 
      if (qactive_chan(210).and.qselect_chan(210)) then
        current_chan = 210
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qqpbsC1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g db u lm lp 
      if (qactive_chan(211).and.qselect_chan(211)) then
        current_chan = 211
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qqpbsC1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub u lm lp 
      if (qactive_chan(212).and.qselect_chan(212)) then
        current_chan = 212
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qqpbsC1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d d to g d d lm lp  
      if (qactive_chan(213).and.qselect_chan(213)) then
        current_chan = 213
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qqpsC1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d u to g u d lm lp  
      if (qactive_chan(214).and.qselect_chan(214)) then
        current_chan = 214
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qqpsC1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u d to g d u lm lp  
      if (qactive_chan(215).and.qselect_chan(215)) then
        current_chan = 215
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qqpsC1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u u to g u u lm lp  
      if (qactive_chan(216).and.qselect_chan(216)) then
        current_chan = 216
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qqpsC1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g d db lm lp 
      if (qactive_chan(217).and.qselect_chan(217)) then
        current_chan = 217
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbsC1g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g u ub lm lp 
      if (qactive_chan(218).and.qselect_chan(218)) then
        current_chan = 218
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = qqbsC1g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g d db lm lp 
      if (qactive_chan(219).and.qselect_chan(219)) then
        current_chan = 219
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = qqbsC1g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g u ub lm lp 
      if (qactive_chan(220).and.qselect_chan(220)) then
        current_chan = 220
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbsC1g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to d db d lm lp 
      if (qactive_chan(221).and.qselect_chan(221)) then
        current_chan = 221
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = gqsC1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to u ub d lm lp 
      if (qactive_chan(222).and.qselect_chan(222)) then
        current_chan = 222
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = gqsC1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to d db u lm lp 
      if (qactive_chan(223).and.qselect_chan(223)) then
        current_chan = 223
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = gqsC1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to u ub u lm lp 
      if (qactive_chan(224).and.qselect_chan(224)) then
        current_chan = 224
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = gqsC1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g d db lm lp 
      if (qactive_chan(225).and.qselect_chan(225)) then
        current_chan = 225
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqsC1g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g u ub lm lp 
      if (qactive_chan(226).and.qselect_chan(226)) then
        current_chan = 226
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = qbqsC1g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g d db lm lp 
      if (qactive_chan(227).and.qselect_chan(227)) then
        current_chan = 227
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = qbqsC1g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g u ub lm lp 
      if (qactive_chan(228).and.qselect_chan(228)) then
        current_chan = 228
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqsC1g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db d db lm lp 
      if (qactive_chan(229).and.qselect_chan(229)) then
        current_chan = 229
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = gqbsC1g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db u ub lm lp 
      if (qactive_chan(230).and.qselect_chan(230)) then
        current_chan = 230
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = gqbsC1g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub d db lm lp 
      if (qactive_chan(231).and.qselect_chan(231)) then
        current_chan = 231
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = gqbsC1g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub u ub lm lp 
      if (qactive_chan(232).and.qselect_chan(232)) then
        current_chan = 232
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = gqbsC1g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db d db lm lp 
      if (qactive_chan(233).and.qselect_chan(233)) then
        current_chan = 233
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qbgsC1g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db u ub lm lp 
      if (qactive_chan(234).and.qselect_chan(234)) then
        current_chan = 234
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 2
        wt = qbgsC1g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub d db lm lp 
      if (qactive_chan(235).and.qselect_chan(235)) then
        current_chan = 235
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 1
        wt = qbgsC1g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub u ub lm lp 
      if (qactive_chan(236).and.qselect_chan(236)) then
        current_chan = 236
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qbgsC1g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db db to db g db lm lp 
      if (qactive_chan(237).and.qselect_chan(237)) then
        current_chan = 237
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpbsC1g0ZS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db ub to db g ub lm lp 
      if (qactive_chan(238).and.qselect_chan(238)) then
        current_chan = 238
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpbsC1g0ZS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub db to ub g db lm lp 
      if (qactive_chan(239).and.qselect_chan(239)) then
        current_chan = 239
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpbsC1g0ZS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub g ub lm lp 
      if (qactive_chan(240).and.qselect_chan(240)) then
        current_chan = 240
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpbsC1g0ZS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to db g d lm lp 
      if (qactive_chan(241).and.qselect_chan(241)) then
        current_chan = 241
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpsC1g0ZS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to db g u lm lp 
      if (qactive_chan(242).and.qselect_chan(242)) then
        current_chan = 242
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpsC1g0ZS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to ub g d lm lp 
      if (qactive_chan(243).and.qselect_chan(243)) then
        current_chan = 243
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpsC1g0ZS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to ub g u lm lp 
      if (qactive_chan(244).and.qselect_chan(244)) then
        current_chan = 244
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpsC1g0ZS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to d db d lm lp 
      if (qactive_chan(245).and.qselect_chan(245)) then
        current_chan = 245
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qgsCt1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to u ub d lm lp 
      if (qactive_chan(246).and.qselect_chan(246)) then
        current_chan = 246
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 2
        wt = qgsCt1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to d db u lm lp 
      if (qactive_chan(247).and.qselect_chan(247)) then
        current_chan = 247
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 1
        wt = qgsCt1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to u ub u lm lp 
      if (qactive_chan(248).and.qselect_chan(248)) then
        current_chan = 248
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qgsCt1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g db d lm lp 
      if (qactive_chan(249).and.qselect_chan(249)) then
        current_chan = 249
        ip1_chan     = 11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qqpbsCt1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g ub d lm lp 
      if (qactive_chan(250).and.qselect_chan(250)) then
        current_chan = 250
        ip1_chan     = 11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qqpbsCt1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u db to g db u lm lp 
      if (qactive_chan(251).and.qselect_chan(251)) then
        current_chan = 251
        ip1_chan     = 21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qqpbsCt1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub u lm lp 
      if (qactive_chan(252).and.qselect_chan(252)) then
        current_chan = 252
        ip1_chan     = 21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qqpbsCt1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d d to g d d lm lp  
      if (qactive_chan(253).and.qselect_chan(253)) then
        current_chan = 253
        ip1_chan     = 11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qqpsCt1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d u to g u d lm lp  
      if (qactive_chan(254).and.qselect_chan(254)) then
        current_chan = 254
        ip1_chan     = 11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qqpsCt1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u d to g d u lm lp  
      if (qactive_chan(255).and.qselect_chan(255)) then
        current_chan = 255
        ip1_chan     = 21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qqpsCt1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u u to g u u lm lp  
      if (qactive_chan(256).and.qselect_chan(256)) then
        current_chan = 256
        ip1_chan     = 21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qqpsCt1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g d db lm lp 
      if (qactive_chan(257).and.qselect_chan(257)) then
        current_chan = 257
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbsCt1g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g u ub lm lp 
      if (qactive_chan(258).and.qselect_chan(258)) then
        current_chan = 258
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = qqbsCt1g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g d db lm lp 
      if (qactive_chan(259).and.qselect_chan(259)) then
        current_chan = 259
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = qqbsCt1g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g u ub lm lp 
      if (qactive_chan(260).and.qselect_chan(260)) then
        current_chan = 260
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbsCt1g0ZS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to d db d lm lp 
      if (qactive_chan(261).and.qselect_chan(261)) then
        current_chan = 261
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = gqsCt1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to u ub d lm lp 
      if (qactive_chan(262).and.qselect_chan(262)) then
        current_chan = 262
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = gqsCt1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to d db u lm lp 
      if (qactive_chan(263).and.qselect_chan(263)) then
        current_chan = 263
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = gqsCt1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to u ub u lm lp 
      if (qactive_chan(264).and.qselect_chan(264)) then
        current_chan = 264
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = gqsCt1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g d db lm lp 
      if (qactive_chan(265).and.qselect_chan(265)) then
        current_chan = 265
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqsCt1g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g u ub lm lp 
      if (qactive_chan(266).and.qselect_chan(266)) then
        current_chan = 266
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 2
        wt = qbqsCt1g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g d db lm lp 
      if (qactive_chan(267).and.qselect_chan(267)) then
        current_chan = 267
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 1
        wt = qbqsCt1g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g u ub lm lp 
      if (qactive_chan(268).and.qselect_chan(268)) then
        current_chan = 268
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqsCt1g0ZS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db d db lm lp 
      if (qactive_chan(269).and.qselect_chan(269)) then
        current_chan = 269
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = gqbsCt1g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db u ub lm lp 
      if (qactive_chan(270).and.qselect_chan(270)) then
        current_chan = 270
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 2
        wt = gqbsCt1g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub d db lm lp 
      if (qactive_chan(271).and.qselect_chan(271)) then
        current_chan = 271
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 1
        wt = gqbsCt1g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub u ub lm lp 
      if (qactive_chan(272).and.qselect_chan(272)) then
        current_chan = 272
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = gqbsCt1g0ZS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db d db lm lp 
      if (qactive_chan(273).and.qselect_chan(273)) then
        current_chan = 273
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qbgsCt1g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db u ub lm lp 
      if (qactive_chan(274).and.qselect_chan(274)) then
        current_chan = 274
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 2
        wt = qbgsCt1g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub d db lm lp 
      if (qactive_chan(275).and.qselect_chan(275)) then
        current_chan = 275
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 1
        wt = qbgsCt1g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub u ub lm lp 
      if (qactive_chan(276).and.qselect_chan(276)) then
        current_chan = 276
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qbgsCt1g0ZS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db db to db g db lm lp 
      if (qactive_chan(277).and.qselect_chan(277)) then
        current_chan = 277
        ip1_chan     = -11
        ip2_chan     = -11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpbsCt1g0ZS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db ub to db g ub lm lp 
      if (qactive_chan(278).and.qselect_chan(278)) then
        current_chan = 278
        ip1_chan     = -11
        ip2_chan     = -21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpbsCt1g0ZS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub db to ub g db lm lp 
      if (qactive_chan(279).and.qselect_chan(279)) then
        current_chan = 279
        ip1_chan     = -21
        ip2_chan     = -11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpbsCt1g0ZS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub g ub lm lp 
      if (qactive_chan(280).and.qselect_chan(280)) then
        current_chan = 280
        ip1_chan     = -21
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpbsCt1g0ZS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to db g d lm lp 
      if (qactive_chan(281).and.qselect_chan(281)) then
        current_chan = 281
        ip1_chan     = -11
        ip2_chan     = 11
        nfC1 = 1
        nfC2 = 1
        wt = qbqpsCt1g0ZS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db u to db g u lm lp 
      if (qactive_chan(282).and.qselect_chan(282)) then
        current_chan = 282
        ip1_chan     = -11
        ip2_chan     = 21
        nfC1 = 1
        nfC2 = 2
        wt = qbqpsCt1g0ZS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to ub g d lm lp 
      if (qactive_chan(283).and.qselect_chan(283)) then
        current_chan = 283
        ip1_chan     = -21
        ip2_chan     = 11
        nfC1 = 2
        nfC2 = 1
        wt = qbqpsCt1g0ZS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to ub g u lm lp 
      if (qactive_chan(284).and.qselect_chan(284)) then
        current_chan = 284
        ip1_chan     = -21
        ip2_chan     = 21
        nfC1 = 2
        nfC2 = 2
        wt = qbqpsCt1g0ZS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to d db d lm lp 
      if (qactive_chan(285).and.qselect_chan(285)) then
        current_chan = 285
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qgD1g0ZcS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to u ub u lm lp 
      if (qactive_chan(286).and.qselect_chan(286)) then
        current_chan = 286
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qgD1g0ZcS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g db d lm lp 
      if (qactive_chan(287).and.qselect_chan(287)) then
        current_chan = 287
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbD1g0ZcS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub u lm lp 
      if (qactive_chan(288).and.qselect_chan(288)) then
        current_chan = 288
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbD1g0ZcS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d d to g d d lm lp  
      if (qactive_chan(289).and.qselect_chan(289)) then
        current_chan = 289
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qqD1g0ZcS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u u to g u u lm lp  
      if (qactive_chan(290).and.qselect_chan(290)) then
        current_chan = 290
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qqD1g0ZcS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to d db d lm lp 
      if (qactive_chan(291).and.qselect_chan(291)) then
        current_chan = 291
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = gqD1g0ZcS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to u ub u lm lp 
      if (qactive_chan(292).and.qselect_chan(292)) then
        current_chan = 292
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = gqD1g0ZcS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g db d lm lp 
      if (qactive_chan(293).and.qselect_chan(293)) then
        current_chan = 293
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqD1g0ZcS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g ub u lm lp 
      if (qactive_chan(294).and.qselect_chan(294)) then
        current_chan = 294
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqD1g0ZcS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db db d lm lp 
      if (qactive_chan(295).and.qselect_chan(295)) then
        current_chan = 295
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = gqbD1g0ZcS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub ub u lm lp 
      if (qactive_chan(296).and.qselect_chan(296)) then
        current_chan = 296
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = gqbD1g0ZcS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db db d lm lp 
      if (qactive_chan(297).and.qselect_chan(297)) then
        current_chan = 297
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qbgD1g0ZcS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub ub u lm lp 
      if (qactive_chan(298).and.qselect_chan(298)) then
        current_chan = 298
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qbgD1g0ZcS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db db to db g db lm lp 
      if (qactive_chan(299).and.qselect_chan(299)) then
        current_chan = 299
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qbqbD1g0ZcS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub g ub lm lp 
      if (qactive_chan(300).and.qselect_chan(300)) then
        current_chan = 300
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qbqbD1g0ZcS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to d db d lm lp 
      if (qactive_chan(301).and.qselect_chan(301)) then
        current_chan = 301
        ip1_chan     = 10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qgDt1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to u ub u lm lp 
      if (qactive_chan(302).and.qselect_chan(302)) then
        current_chan = 302
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qgDt1g0ZS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g db d lm lp 
      if (qactive_chan(303).and.qselect_chan(303)) then
        current_chan = 303
        ip1_chan     = 10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qqbDt1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to g ub u lm lp 
      if (qactive_chan(304).and.qselect_chan(304)) then
        current_chan = 304
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qqbDt1g0ZS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d d to g d d lm lp  
      if (qactive_chan(305).and.qselect_chan(305)) then
        current_chan = 305
        ip1_chan     = 10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qqDt1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u u to g u u lm lp  
      if (qactive_chan(306).and.qselect_chan(306)) then
        current_chan = 306
        ip1_chan     = 20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qqDt1g0ZS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to d db d lm lp 
      if (qactive_chan(307).and.qselect_chan(307)) then
        current_chan = 307
        ip1_chan     = 0
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = gqDt1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to u ub u lm lp 
      if (qactive_chan(308).and.qselect_chan(308)) then
        current_chan = 308
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = gqDt1g0ZS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g db d lm lp 
      if (qactive_chan(309).and.qselect_chan(309)) then
        current_chan = 309
        ip1_chan     = -10
        ip2_chan     = 10
        nfC1 = 1
        nfC2 = 1
        wt = qbqDt1g0ZS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to g ub u lm lp 
      if (qactive_chan(310).and.qselect_chan(310)) then
        current_chan = 310
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
        wt = qbqDt1g0ZS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db db d lm lp 
      if (qactive_chan(311).and.qselect_chan(311)) then
        current_chan = 311
        ip1_chan     = 0
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = gqbDt1g0ZS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to ub ub u lm lp 
      if (qactive_chan(312).and.qselect_chan(312)) then
        current_chan = 312
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = gqbDt1g0ZS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db db d lm lp 
      if (qactive_chan(313).and.qselect_chan(313)) then
        current_chan = 313
        ip1_chan     = -10
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
        wt = qbgDt1g0ZS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to ub ub u lm lp 
      if (qactive_chan(314).and.qselect_chan(314)) then
        current_chan = 314
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
        wt = qbgDt1g0ZS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db db to db g db lm lp 
      if (qactive_chan(315).and.qselect_chan(315)) then
        current_chan = 315
        ip1_chan     = -10
        ip2_chan     = -10
        nfC1 = 1
        nfC2 = 1
        wt = qbqbDt1g0ZS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub ub to ub g ub lm lp 
      if (qactive_chan(316).and.qselect_chan(316)) then
        current_chan = 316
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
        wt = qbqbDt1g0ZS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
      sigSZJ=sigSZJ+rnorm*wtsum

      return
      end
