      function sigTZJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTZJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(6,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(6,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d g to g d lm lp    
        if (qactive_chan(317).and.qselect_chan(317)) then
          current_chan = 317
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g u lm lp    
        if (qactive_chan(318).and.qselect_chan(318)) then
          current_chan = 318
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g g lm lp   
        if (qactive_chan(319).and.qselect_chan(319)) then
          current_chan = 319
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsB2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g g lm lp   
        if (qactive_chan(320).and.qselect_chan(320)) then
          current_chan = 320
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsB2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g d lm lp    
        if (qactive_chan(321).and.qselect_chan(321)) then
          current_chan = 321
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqsB2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g u lm lp    
        if (qactive_chan(322).and.qselect_chan(322)) then
          current_chan = 322
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqsB2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g g lm lp   
        if (qactive_chan(323).and.qselect_chan(323)) then
          current_chan = 323
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsB2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g g lm lp   
        if (qactive_chan(324).and.qselect_chan(324)) then
          current_chan = 324
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsB2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db d lm lp   
        if (qactive_chan(325).and.qselect_chan(325)) then
          current_chan = 325
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggsB2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub u lm lp   
        if (qactive_chan(326).and.qselect_chan(326)) then
          current_chan = 326
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggsB2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db g lm lp  
        if (qactive_chan(327).and.qselect_chan(327)) then
          current_chan = 327
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbsB2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub g lm lp  
        if (qactive_chan(328).and.qselect_chan(328)) then
          current_chan = 328
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbsB2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db g lm lp  
        if (qactive_chan(329).and.qselect_chan(329)) then
          current_chan = 329
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgsB2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub g lm lp  
        if (qactive_chan(330).and.qselect_chan(330)) then
          current_chan = 330
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgsB2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(331).and.qselect_chan(331)) then
          current_chan = 331
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(332).and.qselect_chan(332)) then
          current_chan = 332
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(333).and.qselect_chan(333)) then
          current_chan = 333
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(334).and.qselect_chan(334)) then
          current_chan = 334
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(335).and.qselect_chan(335)) then
          current_chan = 335
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(336).and.qselect_chan(336)) then
          current_chan = 336
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(337).and.qselect_chan(337)) then
          current_chan = 337
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(338).and.qselect_chan(338)) then
          current_chan = 338
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(339).and.qselect_chan(339)) then
          current_chan = 339
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(340).and.qselect_chan(340)) then
          current_chan = 340
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(341).and.qselect_chan(341)) then
          current_chan = 341
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(342).and.qselect_chan(342)) then
          current_chan = 342
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(343).and.qselect_chan(343)) then
          current_chan = 343
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(344).and.qselect_chan(344)) then
          current_chan = 344
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(345).and.qselect_chan(345)) then
          current_chan = 345
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(346).and.qselect_chan(346)) then
          current_chan = 346
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsB2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to g d lm lp    
        if (qactive_chan(347).and.qselect_chan(347)) then
          current_chan = 347
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g u lm lp    
        if (qactive_chan(348).and.qselect_chan(348)) then
          current_chan = 348
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g g lm lp   
        if (qactive_chan(349).and.qselect_chan(349)) then
          current_chan = 349
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBt2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g g lm lp   
        if (qactive_chan(350).and.qselect_chan(350)) then
          current_chan = 350
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBt2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g d lm lp    
        if (qactive_chan(351).and.qselect_chan(351)) then
          current_chan = 351
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqsBt2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g u lm lp    
        if (qactive_chan(352).and.qselect_chan(352)) then
          current_chan = 352
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqsBt2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g g lm lp   
        if (qactive_chan(353).and.qselect_chan(353)) then
          current_chan = 353
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBt2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g g lm lp   
        if (qactive_chan(354).and.qselect_chan(354)) then
          current_chan = 354
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBt2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db d lm lp   
        if (qactive_chan(355).and.qselect_chan(355)) then
          current_chan = 355
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggsBt2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub u lm lp   
        if (qactive_chan(356).and.qselect_chan(356)) then
          current_chan = 356
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggsBt2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db g lm lp  
        if (qactive_chan(357).and.qselect_chan(357)) then
          current_chan = 357
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbsBt2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub g lm lp  
        if (qactive_chan(358).and.qselect_chan(358)) then
          current_chan = 358
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbsBt2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db g lm lp  
        if (qactive_chan(359).and.qselect_chan(359)) then
          current_chan = 359
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgsBt2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub g lm lp  
        if (qactive_chan(360).and.qselect_chan(360)) then
          current_chan = 360
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgsBt2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(361).and.qselect_chan(361)) then
          current_chan = 361
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(362).and.qselect_chan(362)) then
          current_chan = 362
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(363).and.qselect_chan(363)) then
          current_chan = 363
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(364).and.qselect_chan(364)) then
          current_chan = 364
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(365).and.qselect_chan(365)) then
          current_chan = 365
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(366).and.qselect_chan(366)) then
          current_chan = 366
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(367).and.qselect_chan(367)) then
          current_chan = 367
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(368).and.qselect_chan(368)) then
          current_chan = 368
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(369).and.qselect_chan(369)) then
          current_chan = 369
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(370).and.qselect_chan(370)) then
          current_chan = 370
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(371).and.qselect_chan(371)) then
          current_chan = 371
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(372).and.qselect_chan(372)) then
          current_chan = 372
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(373).and.qselect_chan(373)) then
          current_chan = 373
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(374).and.qselect_chan(374)) then
          current_chan = 374
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(375).and.qselect_chan(375)) then
          current_chan = 375
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(376).and.qselect_chan(376)) then
          current_chan = 376
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsBt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt d lm lp  
        if (qactive_chan(377).and.qselect_chan(377)) then
          current_chan = 377
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgtsBtt2g1ZcT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt u lm lp  
        if (qactive_chan(378).and.qselect_chan(378)) then
          current_chan = 378
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgtsBtt2g1ZcT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to gt gt lm lp 
        if (qactive_chan(379).and.qselect_chan(379)) then
          current_chan = 379
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBtt2g1ZcT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to gt gt lm lp 
        if (qactive_chan(380).and.qselect_chan(380)) then
          current_chan = 380
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBtt2g1ZcT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt d lm lp  
        if (qactive_chan(381).and.qselect_chan(381)) then
          current_chan = 381
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gtqsBtt2g1ZcT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt u lm lp  
        if (qactive_chan(382).and.qselect_chan(382)) then
          current_chan = 382
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gtqsBtt2g1ZcT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to gt gt lm lp 
        if (qactive_chan(383).and.qselect_chan(383)) then
          current_chan = 383
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBtt2g1ZcT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to gt gt lm lp 
        if (qactive_chan(384).and.qselect_chan(384)) then
          current_chan = 384
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBtt2g1ZcT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db d lm lp 
        if (qactive_chan(385).and.qselect_chan(385)) then
          current_chan = 385
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = gtgtsBtt2g1ZcT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub u lm lp 
        if (qactive_chan(386).and.qselect_chan(386)) then
          current_chan = 386
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = gtgtsBtt2g1ZcT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to db gt lm lp 
        if (qactive_chan(387).and.qselect_chan(387)) then
          current_chan = 387
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gtqbsBtt2g1ZcT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to ub gt lm lp 
        if (qactive_chan(388).and.qselect_chan(388)) then
          current_chan = 388
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gtqbsBtt2g1ZcT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to db gt lm lp 
        if (qactive_chan(389).and.qselect_chan(389)) then
          current_chan = 389
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgtsBtt2g1ZcT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to ub gt lm lp 
        if (qactive_chan(390).and.qselect_chan(390)) then
          current_chan = 390
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgtsBtt2g1ZcT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt d lm lp  
        if (qactive_chan(391).and.qselect_chan(391)) then
          current_chan = 391
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgtsBttt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt u lm lp  
        if (qactive_chan(392).and.qselect_chan(392)) then
          current_chan = 392
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgtsBttt2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to gt gt lm lp 
        if (qactive_chan(393).and.qselect_chan(393)) then
          current_chan = 393
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBttt2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to gt gt lm lp 
        if (qactive_chan(394).and.qselect_chan(394)) then
          current_chan = 394
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBttt2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt d lm lp  
        if (qactive_chan(395).and.qselect_chan(395)) then
          current_chan = 395
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gtqsBttt2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt u lm lp  
        if (qactive_chan(396).and.qselect_chan(396)) then
          current_chan = 396
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gtqsBttt2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to gt gt lm lp 
        if (qactive_chan(397).and.qselect_chan(397)) then
          current_chan = 397
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBttt2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to gt gt lm lp 
        if (qactive_chan(398).and.qselect_chan(398)) then
          current_chan = 398
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBttt2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db d lm lp 
        if (qactive_chan(399).and.qselect_chan(399)) then
          current_chan = 399
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = gtgtsBttt2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub u lm lp 
        if (qactive_chan(400).and.qselect_chan(400)) then
          current_chan = 400
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = gtgtsBttt2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to db gt lm lp 
        if (qactive_chan(401).and.qselect_chan(401)) then
          current_chan = 401
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gtqbsBttt2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to ub gt lm lp 
        if (qactive_chan(402).and.qselect_chan(402)) then
          current_chan = 402
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gtqbsBttt2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to db gt lm lp 
        if (qactive_chan(403).and.qselect_chan(403)) then
          current_chan = 403
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgtsBttt2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to ub gt lm lp 
        if (qactive_chan(404).and.qselect_chan(404)) then
          current_chan = 404
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgtsBttt2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to g d lm lp    
        if (qactive_chan(405).and.qselect_chan(405)) then
          current_chan = 405
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g u lm lp    
        if (qactive_chan(406).and.qselect_chan(406)) then
          current_chan = 406
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g g lm lp   
        if (qactive_chan(407).and.qselect_chan(407)) then
          current_chan = 407
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBh2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g g lm lp   
        if (qactive_chan(408).and.qselect_chan(408)) then
          current_chan = 408
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBh2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g d lm lp    
        if (qactive_chan(409).and.qselect_chan(409)) then
          current_chan = 409
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqsBh2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g u lm lp    
        if (qactive_chan(410).and.qselect_chan(410)) then
          current_chan = 410
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqsBh2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g g lm lp   
        if (qactive_chan(411).and.qselect_chan(411)) then
          current_chan = 411
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBh2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g g lm lp   
        if (qactive_chan(412).and.qselect_chan(412)) then
          current_chan = 412
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBh2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db d lm lp   
        if (qactive_chan(413).and.qselect_chan(413)) then
          current_chan = 413
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggsBh2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub u lm lp   
        if (qactive_chan(414).and.qselect_chan(414)) then
          current_chan = 414
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggsBh2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db g lm lp  
        if (qactive_chan(415).and.qselect_chan(415)) then
          current_chan = 415
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbsBh2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub g lm lp  
        if (qactive_chan(416).and.qselect_chan(416)) then
          current_chan = 416
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbsBh2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db g lm lp  
        if (qactive_chan(417).and.qselect_chan(417)) then
          current_chan = 417
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgsBh2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub g lm lp  
        if (qactive_chan(418).and.qselect_chan(418)) then
          current_chan = 418
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgsBh2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(419).and.qselect_chan(419)) then
          current_chan = 419
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(420).and.qselect_chan(420)) then
          current_chan = 420
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(421).and.qselect_chan(421)) then
          current_chan = 421
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(422).and.qselect_chan(422)) then
          current_chan = 422
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(423).and.qselect_chan(423)) then
          current_chan = 423
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(424).and.qselect_chan(424)) then
          current_chan = 424
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(425).and.qselect_chan(425)) then
          current_chan = 425
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(426).and.qselect_chan(426)) then
          current_chan = 426
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(427).and.qselect_chan(427)) then
          current_chan = 427
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(428).and.qselect_chan(428)) then
          current_chan = 428
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(429).and.qselect_chan(429)) then
          current_chan = 429
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(430).and.qselect_chan(430)) then
          current_chan = 430
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(431).and.qselect_chan(431)) then
          current_chan = 431
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(432).and.qselect_chan(432)) then
          current_chan = 432
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(433).and.qselect_chan(433)) then
          current_chan = 433
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(434).and.qselect_chan(434)) then
          current_chan = 434
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsBh2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt d lm lp  
        if (qactive_chan(435).and.qselect_chan(435)) then
          current_chan = 435
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgtsBth2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt u lm lp  
        if (qactive_chan(436).and.qselect_chan(436)) then
          current_chan = 436
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgtsBth2g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to gt gt lm lp 
        if (qactive_chan(437).and.qselect_chan(437)) then
          current_chan = 437
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBth2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to gt gt lm lp 
        if (qactive_chan(438).and.qselect_chan(438)) then
          current_chan = 438
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBth2g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt d lm lp  
        if (qactive_chan(439).and.qselect_chan(439)) then
          current_chan = 439
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gtqsBth2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt u lm lp  
        if (qactive_chan(440).and.qselect_chan(440)) then
          current_chan = 440
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gtqsBth2g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to gt gt lm lp 
        if (qactive_chan(441).and.qselect_chan(441)) then
          current_chan = 441
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBth2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to gt gt lm lp 
        if (qactive_chan(442).and.qselect_chan(442)) then
          current_chan = 442
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBth2g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db d lm lp 
        if (qactive_chan(443).and.qselect_chan(443)) then
          current_chan = 443
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = gtgtsBth2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub u lm lp 
        if (qactive_chan(444).and.qselect_chan(444)) then
          current_chan = 444
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = gtgtsBth2g1ZT(ix,xri1,xri2,3,1,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to db gt lm lp 
        if (qactive_chan(445).and.qselect_chan(445)) then
          current_chan = 445
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gtqbsBth2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to ub gt lm lp 
        if (qactive_chan(446).and.qselect_chan(446)) then
          current_chan = 446
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gtqbsBth2g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to db gt lm lp 
        if (qactive_chan(447).and.qselect_chan(447)) then
          current_chan = 447
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgtsBth2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to ub gt lm lp 
        if (qactive_chan(448).and.qselect_chan(448)) then
          current_chan = 448
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgtsBth2g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d lm lp  
        if (qactive_chan(449).and.qselect_chan(449)) then
          current_chan = 449
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub d lm lp  
        if (qactive_chan(450).and.qselect_chan(450)) then
          current_chan = 450
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db u lm lp  
        if (qactive_chan(451).and.qselect_chan(451)) then
          current_chan = 451
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u lm lp  
        if (qactive_chan(452).and.qselect_chan(452)) then
          current_chan = 452
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d lm lp    
        if (qactive_chan(453).and.qselect_chan(453)) then
          current_chan = 453
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsC0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u d lm lp    
        if (qactive_chan(454).and.qselect_chan(454)) then
          current_chan = 454
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsC0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d u lm lp    
        if (qactive_chan(455).and.qselect_chan(455)) then
          current_chan = 455
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsC0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u lm lp    
        if (qactive_chan(456).and.qselect_chan(456)) then
          current_chan = 456
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsC0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to d db lm lp  
        if (qactive_chan(457).and.qselect_chan(457)) then
          current_chan = 457
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbsC0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to u ub lm lp  
        if (qactive_chan(458).and.qselect_chan(458)) then
          current_chan = 458
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = qqbsC0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to d db lm lp  
        if (qactive_chan(459).and.qselect_chan(459)) then
          current_chan = 459
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = qqbsC0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to u ub lm lp  
        if (qactive_chan(460).and.qselect_chan(460)) then
          current_chan = 460
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbsC0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to d db lm lp  
        if (qactive_chan(461).and.qselect_chan(461)) then
          current_chan = 461
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqsC0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to u ub lm lp  
        if (qactive_chan(462).and.qselect_chan(462)) then
          current_chan = 462
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = qbqsC0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to d db lm lp  
        if (qactive_chan(463).and.qselect_chan(463)) then
          current_chan = 463
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = qbqsC0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to u ub lm lp  
        if (qactive_chan(464).and.qselect_chan(464)) then
          current_chan = 464
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqsC0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db lm lp 
        if (qactive_chan(465).and.qselect_chan(465)) then
          current_chan = 465
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsC0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db ub lm lp 
        if (qactive_chan(466).and.qselect_chan(466)) then
          current_chan = 466
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsC0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub db lm lp 
        if (qactive_chan(467).and.qselect_chan(467)) then
          current_chan = 467
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsC0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub lm lp 
        if (qactive_chan(468).and.qselect_chan(468)) then
          current_chan = 468
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsC0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d lm lp  
        if (qactive_chan(469).and.qselect_chan(469)) then
          current_chan = 469
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsC0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db u lm lp  
        if (qactive_chan(470).and.qselect_chan(470)) then
          current_chan = 470
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsC0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub d lm lp  
        if (qactive_chan(471).and.qselect_chan(471)) then
          current_chan = 471
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsC0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u lm lp  
        if (qactive_chan(472).and.qselect_chan(472)) then
          current_chan = 472
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsC0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(473).and.qselect_chan(473)) then
          current_chan = 473
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = gqsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(474).and.qselect_chan(474)) then
          current_chan = 474
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = gqsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(475).and.qselect_chan(475)) then
          current_chan = 475
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = gqsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(476).and.qselect_chan(476)) then
          current_chan = 476
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = gqsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(477).and.qselect_chan(477)) then
          current_chan = 477
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = gqbsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(478).and.qselect_chan(478)) then
          current_chan = 478
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = gqbsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(479).and.qselect_chan(479)) then
          current_chan = 479
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = gqbsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(480).and.qselect_chan(480)) then
          current_chan = 480
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = gqbsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(481).and.qselect_chan(481)) then
          current_chan = 481
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qgsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(482).and.qselect_chan(482)) then
          current_chan = 482
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qgsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(483).and.qselect_chan(483)) then
          current_chan = 483
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qgsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(484).and.qselect_chan(484)) then
          current_chan = 484
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qgsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(485).and.qselect_chan(485)) then
          current_chan = 485
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qbgsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(486).and.qselect_chan(486)) then
          current_chan = 486
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qbgsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(487).and.qselect_chan(487)) then
          current_chan = 487
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qbgsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(488).and.qselect_chan(488)) then
          current_chan = 488
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qbgsC0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d lm lp  
        if (qactive_chan(489).and.qselect_chan(489)) then
          current_chan = 489
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub d lm lp  
        if (qactive_chan(490).and.qselect_chan(490)) then
          current_chan = 490
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db u lm lp  
        if (qactive_chan(491).and.qselect_chan(491)) then
          current_chan = 491
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u lm lp  
        if (qactive_chan(492).and.qselect_chan(492)) then
          current_chan = 492
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d lm lp    
        if (qactive_chan(493).and.qselect_chan(493)) then
          current_chan = 493
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpCt0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u d lm lp    
        if (qactive_chan(494).and.qselect_chan(494)) then
          current_chan = 494
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpCt0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d u lm lp    
        if (qactive_chan(495).and.qselect_chan(495)) then
          current_chan = 495
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpCt0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u lm lp    
        if (qactive_chan(496).and.qselect_chan(496)) then
          current_chan = 496
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpCt0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to d db lm lp  
        if (qactive_chan(497).and.qselect_chan(497)) then
          current_chan = 497
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbCt0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to u ub lm lp  
        if (qactive_chan(498).and.qselect_chan(498)) then
          current_chan = 498
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = qqbCt0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to d db lm lp  
        if (qactive_chan(499).and.qselect_chan(499)) then
          current_chan = 499
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = qqbCt0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to u ub lm lp  
        if (qactive_chan(500).and.qselect_chan(500)) then
          current_chan = 500
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbCt0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to d db lm lp  
        if (qactive_chan(501).and.qselect_chan(501)) then
          current_chan = 501
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqCt0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to u ub lm lp  
        if (qactive_chan(502).and.qselect_chan(502)) then
          current_chan = 502
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = qbqCt0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to d db lm lp  
        if (qactive_chan(503).and.qselect_chan(503)) then
          current_chan = 503
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = qbqCt0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to u ub lm lp  
        if (qactive_chan(504).and.qselect_chan(504)) then
          current_chan = 504
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqCt0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db lm lp 
        if (qactive_chan(505).and.qselect_chan(505)) then
          current_chan = 505
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbCt0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db ub lm lp 
        if (qactive_chan(506).and.qselect_chan(506)) then
          current_chan = 506
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbCt0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub db lm lp 
        if (qactive_chan(507).and.qselect_chan(507)) then
          current_chan = 507
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbCt0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub lm lp 
        if (qactive_chan(508).and.qselect_chan(508)) then
          current_chan = 508
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbCt0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d lm lp  
        if (qactive_chan(509).and.qselect_chan(509)) then
          current_chan = 509
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpCt0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db u lm lp  
        if (qactive_chan(510).and.qselect_chan(510)) then
          current_chan = 510
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpCt0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub d lm lp  
        if (qactive_chan(511).and.qselect_chan(511)) then
          current_chan = 511
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpCt0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u lm lp  
        if (qactive_chan(512).and.qselect_chan(512)) then
          current_chan = 512
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpCt0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(513).and.qselect_chan(513)) then
          current_chan = 513
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = gqCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(514).and.qselect_chan(514)) then
          current_chan = 514
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = gqCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(515).and.qselect_chan(515)) then
          current_chan = 515
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = gqCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(516).and.qselect_chan(516)) then
          current_chan = 516
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = gqCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(517).and.qselect_chan(517)) then
          current_chan = 517
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = gqbCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(518).and.qselect_chan(518)) then
          current_chan = 518
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = gqbCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(519).and.qselect_chan(519)) then
          current_chan = 519
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = gqbCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(520).and.qselect_chan(520)) then
          current_chan = 520
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = gqbCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(521).and.qselect_chan(521)) then
          current_chan = 521
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qgCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(522).and.qselect_chan(522)) then
          current_chan = 522
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qgCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(523).and.qselect_chan(523)) then
          current_chan = 523
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qgCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(524).and.qselect_chan(524)) then
          current_chan = 524
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qgCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(525).and.qselect_chan(525)) then
          current_chan = 525
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qbgCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(526).and.qselect_chan(526)) then
          current_chan = 526
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qbgCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(527).and.qselect_chan(527)) then
          current_chan = 527
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qbgCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(528).and.qselect_chan(528)) then
          current_chan = 528
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qbgCt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d lm lp  
        if (qactive_chan(529).and.qselect_chan(529)) then
          current_chan = 529
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub d lm lp  
        if (qactive_chan(530).and.qselect_chan(530)) then
          current_chan = 530
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db u lm lp  
        if (qactive_chan(531).and.qselect_chan(531)) then
          current_chan = 531
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u lm lp  
        if (qactive_chan(532).and.qselect_chan(532)) then
          current_chan = 532
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d lm lp    
        if (qactive_chan(533).and.qselect_chan(533)) then
          current_chan = 533
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpCh0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u d lm lp    
        if (qactive_chan(534).and.qselect_chan(534)) then
          current_chan = 534
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpCh0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d u lm lp    
        if (qactive_chan(535).and.qselect_chan(535)) then
          current_chan = 535
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpCh0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u lm lp    
        if (qactive_chan(536).and.qselect_chan(536)) then
          current_chan = 536
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpCh0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to d db lm lp  
        if (qactive_chan(537).and.qselect_chan(537)) then
          current_chan = 537
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbCh0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to u ub lm lp  
        if (qactive_chan(538).and.qselect_chan(538)) then
          current_chan = 538
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = qqbCh0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to d db lm lp  
        if (qactive_chan(539).and.qselect_chan(539)) then
          current_chan = 539
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = qqbCh0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to u ub lm lp  
        if (qactive_chan(540).and.qselect_chan(540)) then
          current_chan = 540
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbCh0g1ZT(ix,xri1,xri2,1,3,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to d db lm lp  
        if (qactive_chan(541).and.qselect_chan(541)) then
          current_chan = 541
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqCh0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to u ub lm lp  
        if (qactive_chan(542).and.qselect_chan(542)) then
          current_chan = 542
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = qbqCh0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to d db lm lp  
        if (qactive_chan(543).and.qselect_chan(543)) then
          current_chan = 543
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = qbqCh0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to u ub lm lp  
        if (qactive_chan(544).and.qselect_chan(544)) then
          current_chan = 544
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqCh0g1ZT(ix,xri1,xri2,2,3,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db lm lp 
        if (qactive_chan(545).and.qselect_chan(545)) then
          current_chan = 545
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbCh0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db ub lm lp 
        if (qactive_chan(546).and.qselect_chan(546)) then
          current_chan = 546
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbCh0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub db lm lp 
        if (qactive_chan(547).and.qselect_chan(547)) then
          current_chan = 547
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbCh0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub lm lp 
        if (qactive_chan(548).and.qselect_chan(548)) then
          current_chan = 548
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbCh0g1ZT(ix,xri1,xri2,3,2,4,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d lm lp  
        if (qactive_chan(549).and.qselect_chan(549)) then
          current_chan = 549
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpCh0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db u lm lp  
        if (qactive_chan(550).and.qselect_chan(550)) then
          current_chan = 550
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpCh0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub d lm lp  
        if (qactive_chan(551).and.qselect_chan(551)) then
          current_chan = 551
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpCh0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u lm lp  
        if (qactive_chan(552).and.qselect_chan(552)) then
          current_chan = 552
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpCh0g1ZT(ix,xri1,xri2,3,4,2,1,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(553).and.qselect_chan(553)) then
          current_chan = 553
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = gqCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(554).and.qselect_chan(554)) then
          current_chan = 554
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = gqCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(555).and.qselect_chan(555)) then
          current_chan = 555
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = gqCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(556).and.qselect_chan(556)) then
          current_chan = 556
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = gqCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(557).and.qselect_chan(557)) then
          current_chan = 557
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = gqbCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(558).and.qselect_chan(558)) then
          current_chan = 558
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = gqbCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(559).and.qselect_chan(559)) then
          current_chan = 559
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = gqbCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(560).and.qselect_chan(560)) then
          current_chan = 560
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = gqbCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(561).and.qselect_chan(561)) then
          current_chan = 561
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qgCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(562).and.qselect_chan(562)) then
          current_chan = 562
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qgCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(563).and.qselect_chan(563)) then
          current_chan = 563
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qgCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(564).and.qselect_chan(564)) then
          current_chan = 564
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qgCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(565).and.qselect_chan(565)) then
          current_chan = 565
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qbgCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(566).and.qselect_chan(566)) then
          current_chan = 566
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qbgCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(567).and.qselect_chan(567)) then
          current_chan = 567
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qbgCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(568).and.qselect_chan(568)) then
          current_chan = 568
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qbgCh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d lm lp  
        if (qactive_chan(569).and.qselect_chan(569)) then
          current_chan = 569
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u lm lp  
        if (qactive_chan(570).and.qselect_chan(570)) then
          current_chan = 570
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d lm lp    
        if (qactive_chan(571).and.qselect_chan(571)) then
          current_chan = 571
          ip1_chan     = 10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qqD0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u lm lp    
        if (qactive_chan(572).and.qselect_chan(572)) then
          current_chan = 572
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qqD0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d lm lp  
        if (qactive_chan(573).and.qselect_chan(573)) then
          current_chan = 573
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqD0g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u lm lp  
        if (qactive_chan(574).and.qselect_chan(574)) then
          current_chan = 574
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqD0g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db lm lp 
        if (qactive_chan(575).and.qselect_chan(575)) then
          current_chan = 575
          ip1_chan     = -10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qbqbD0g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub lm lp 
        if (qactive_chan(576).and.qselect_chan(576)) then
          current_chan = 576
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qbqbD0g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(577).and.qselect_chan(577)) then
          current_chan = 577
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(578).and.qselect_chan(578)) then
          current_chan = 578
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(579).and.qselect_chan(579)) then
          current_chan = 579
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(580).and.qselect_chan(580)) then
          current_chan = 580
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(581).and.qselect_chan(581)) then
          current_chan = 581
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(582).and.qselect_chan(582)) then
          current_chan = 582
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(583).and.qselect_chan(583)) then
          current_chan = 583
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(584).and.qselect_chan(584)) then
          current_chan = 584
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgD0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d lm lp  
        if (qactive_chan(585).and.qselect_chan(585)) then
          current_chan = 585
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u lm lp  
        if (qactive_chan(586).and.qselect_chan(586)) then
          current_chan = 586
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d lm lp    
        if (qactive_chan(587).and.qselect_chan(587)) then
          current_chan = 587
          ip1_chan     = 10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qqDt0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u lm lp    
        if (qactive_chan(588).and.qselect_chan(588)) then
          current_chan = 588
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qqDt0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d lm lp  
        if (qactive_chan(589).and.qselect_chan(589)) then
          current_chan = 589
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqDt0g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u lm lp  
        if (qactive_chan(590).and.qselect_chan(590)) then
          current_chan = 590
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqDt0g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db lm lp 
        if (qactive_chan(591).and.qselect_chan(591)) then
          current_chan = 591
          ip1_chan     = -10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qbqbDt0g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub lm lp 
        if (qactive_chan(592).and.qselect_chan(592)) then
          current_chan = 592
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qbqbDt0g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(593).and.qselect_chan(593)) then
          current_chan = 593
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(594).and.qselect_chan(594)) then
          current_chan = 594
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(595).and.qselect_chan(595)) then
          current_chan = 595
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(596).and.qselect_chan(596)) then
          current_chan = 596
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(597).and.qselect_chan(597)) then
          current_chan = 597
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(598).and.qselect_chan(598)) then
          current_chan = 598
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(599).and.qselect_chan(599)) then
          current_chan = 599
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(600).and.qselect_chan(600)) then
          current_chan = 600
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgDt0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d lm lp  
        if (qactive_chan(601).and.qselect_chan(601)) then
          current_chan = 601
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u lm lp  
        if (qactive_chan(602).and.qselect_chan(602)) then
          current_chan = 602
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d lm lp    
        if (qactive_chan(603).and.qselect_chan(603)) then
          current_chan = 603
          ip1_chan     = 10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qqDh0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u lm lp    
        if (qactive_chan(604).and.qselect_chan(604)) then
          current_chan = 604
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qqDh0g1ZT(ix,xri1,xri2,1,3,2,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d lm lp  
        if (qactive_chan(605).and.qselect_chan(605)) then
          current_chan = 605
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqDh0g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u lm lp  
        if (qactive_chan(606).and.qselect_chan(606)) then
          current_chan = 606
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqDh0g1ZT(ix,xri1,xri2,2,1,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db lm lp 
        if (qactive_chan(607).and.qselect_chan(607)) then
          current_chan = 607
          ip1_chan     = -10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qbqbDh0g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub lm lp 
        if (qactive_chan(608).and.qselect_chan(608)) then
          current_chan = 608
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qbqbDh0g1ZT(ix,xri1,xri2,3,1,4,2,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(609).and.qselect_chan(609)) then
          current_chan = 609
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(610).and.qselect_chan(610)) then
          current_chan = 610
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(611).and.qselect_chan(611)) then
          current_chan = 611
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(612).and.qselect_chan(612)) then
          current_chan = 612
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(613).and.qselect_chan(613)) then
          current_chan = 613
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(614).and.qselect_chan(614)) then
          current_chan = 614
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(615).and.qselect_chan(615)) then
          current_chan = 615
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(616).and.qselect_chan(616)) then
          current_chan = 616
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgDh0g1ZT(ix,xri1,xri2,1,2,3,4,5,6,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTZJ=sigTZJ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
