      function sigUZJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUZJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d g to d lm lp      
        if (qactive_chan(617).and.qselect_chan(617)) then
          current_chan = 617
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u lm lp      
        if (qactive_chan(618).and.qselect_chan(618)) then
          current_chan = 618
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g lm lp     
        if (qactive_chan(619).and.qselect_chan(619)) then
          current_chan = 619
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbB1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g lm lp     
        if (qactive_chan(620).and.qselect_chan(620)) then
          current_chan = 620
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbB1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d lm lp      
        if (qactive_chan(621).and.qselect_chan(621)) then
          current_chan = 621
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqB1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u lm lp      
        if (qactive_chan(622).and.qselect_chan(622)) then
          current_chan = 622
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqB1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g lm lp     
        if (qactive_chan(623).and.qselect_chan(623)) then
          current_chan = 623
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqB1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g lm lp     
        if (qactive_chan(624).and.qselect_chan(624)) then
          current_chan = 624
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqB1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db lm lp    
        if (qactive_chan(625).and.qselect_chan(625)) then
          current_chan = 625
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbB1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub lm lp    
        if (qactive_chan(626).and.qselect_chan(626)) then
          current_chan = 626
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbB1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db lm lp    
        if (qactive_chan(627).and.qselect_chan(627)) then
          current_chan = 627
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgB1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub lm lp    
        if (qactive_chan(628).and.qselect_chan(628)) then
          current_chan = 628
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgB1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(629).and.qselect_chan(629)) then
          current_chan = 629
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(630).and.qselect_chan(630)) then
          current_chan = 630
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(631).and.qselect_chan(631)) then
          current_chan = 631
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(632).and.qselect_chan(632)) then
          current_chan = 632
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(633).and.qselect_chan(633)) then
          current_chan = 633
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(634).and.qselect_chan(634)) then
          current_chan = 634
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(635).and.qselect_chan(635)) then
          current_chan = 635
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(636).and.qselect_chan(636)) then
          current_chan = 636
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(637).and.qselect_chan(637)) then
          current_chan = 637
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(638).and.qselect_chan(638)) then
          current_chan = 638
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(639).and.qselect_chan(639)) then
          current_chan = 639
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(640).and.qselect_chan(640)) then
          current_chan = 640
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(641).and.qselect_chan(641)) then
          current_chan = 641
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(642).and.qselect_chan(642)) then
          current_chan = 642
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(643).and.qselect_chan(643)) then
          current_chan = 643
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(644).and.qselect_chan(644)) then
          current_chan = 644
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(645).and.qselect_chan(645)) then
          current_chan = 645
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(646).and.qselect_chan(646)) then
          current_chan = 646
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(647).and.qselect_chan(647)) then
          current_chan = 647
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(648).and.qselect_chan(648)) then
          current_chan = 648
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(649).and.qselect_chan(649)) then
          current_chan = 649
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(650).and.qselect_chan(650)) then
          current_chan = 650
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbB1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to d lm lp      
        if (qactive_chan(651).and.qselect_chan(651)) then
          current_chan = 651
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u lm lp      
        if (qactive_chan(652).and.qselect_chan(652)) then
          current_chan = 652
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g lm lp     
        if (qactive_chan(653).and.qselect_chan(653)) then
          current_chan = 653
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbBt1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g lm lp     
        if (qactive_chan(654).and.qselect_chan(654)) then
          current_chan = 654
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbBt1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d lm lp      
        if (qactive_chan(655).and.qselect_chan(655)) then
          current_chan = 655
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqBt1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u lm lp      
        if (qactive_chan(656).and.qselect_chan(656)) then
          current_chan = 656
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqBt1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g lm lp     
        if (qactive_chan(657).and.qselect_chan(657)) then
          current_chan = 657
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqBt1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g lm lp     
        if (qactive_chan(658).and.qselect_chan(658)) then
          current_chan = 658
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqBt1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db lm lp    
        if (qactive_chan(659).and.qselect_chan(659)) then
          current_chan = 659
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbBt1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub lm lp    
        if (qactive_chan(660).and.qselect_chan(660)) then
          current_chan = 660
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbBt1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db lm lp    
        if (qactive_chan(661).and.qselect_chan(661)) then
          current_chan = 661
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgBt1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub lm lp    
        if (qactive_chan(662).and.qselect_chan(662)) then
          current_chan = 662
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgBt1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(663).and.qselect_chan(663)) then
          current_chan = 663
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(664).and.qselect_chan(664)) then
          current_chan = 664
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(665).and.qselect_chan(665)) then
          current_chan = 665
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(666).and.qselect_chan(666)) then
          current_chan = 666
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(667).and.qselect_chan(667)) then
          current_chan = 667
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(668).and.qselect_chan(668)) then
          current_chan = 668
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(669).and.qselect_chan(669)) then
          current_chan = 669
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(670).and.qselect_chan(670)) then
          current_chan = 670
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(671).and.qselect_chan(671)) then
          current_chan = 671
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(672).and.qselect_chan(672)) then
          current_chan = 672
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(673).and.qselect_chan(673)) then
          current_chan = 673
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(674).and.qselect_chan(674)) then
          current_chan = 674
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(675).and.qselect_chan(675)) then
          current_chan = 675
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(676).and.qselect_chan(676)) then
          current_chan = 676
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(677).and.qselect_chan(677)) then
          current_chan = 677
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(678).and.qselect_chan(678)) then
          current_chan = 678
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(679).and.qselect_chan(679)) then
          current_chan = 679
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(680).and.qselect_chan(680)) then
          current_chan = 680
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(681).and.qselect_chan(681)) then
          current_chan = 681
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(682).and.qselect_chan(682)) then
          current_chan = 682
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(683).and.qselect_chan(683)) then
          current_chan = 683
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(684).and.qselect_chan(684)) then
          current_chan = 684
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbBt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to d lm lp      
        if (qactive_chan(685).and.qselect_chan(685)) then
          current_chan = 685
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u lm lp      
        if (qactive_chan(686).and.qselect_chan(686)) then
          current_chan = 686
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g lm lp     
        if (qactive_chan(687).and.qselect_chan(687)) then
          current_chan = 687
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbBtt1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g lm lp     
        if (qactive_chan(688).and.qselect_chan(688)) then
          current_chan = 688
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbBtt1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d lm lp      
        if (qactive_chan(689).and.qselect_chan(689)) then
          current_chan = 689
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqBtt1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u lm lp      
        if (qactive_chan(690).and.qselect_chan(690)) then
          current_chan = 690
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqBtt1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g lm lp     
        if (qactive_chan(691).and.qselect_chan(691)) then
          current_chan = 691
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqBtt1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g lm lp     
        if (qactive_chan(692).and.qselect_chan(692)) then
          current_chan = 692
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqBtt1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db lm lp    
        if (qactive_chan(693).and.qselect_chan(693)) then
          current_chan = 693
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbBtt1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub lm lp    
        if (qactive_chan(694).and.qselect_chan(694)) then
          current_chan = 694
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbBtt1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db lm lp    
        if (qactive_chan(695).and.qselect_chan(695)) then
          current_chan = 695
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgBtt1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub lm lp    
        if (qactive_chan(696).and.qselect_chan(696)) then
          current_chan = 696
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgBtt1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(697).and.qselect_chan(697)) then
          current_chan = 697
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(698).and.qselect_chan(698)) then
          current_chan = 698
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(699).and.qselect_chan(699)) then
          current_chan = 699
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(700).and.qselect_chan(700)) then
          current_chan = 700
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(701).and.qselect_chan(701)) then
          current_chan = 701
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(702).and.qselect_chan(702)) then
          current_chan = 702
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(703).and.qselect_chan(703)) then
          current_chan = 703
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(704).and.qselect_chan(704)) then
          current_chan = 704
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(705).and.qselect_chan(705)) then
          current_chan = 705
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(706).and.qselect_chan(706)) then
          current_chan = 706
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(707).and.qselect_chan(707)) then
          current_chan = 707
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(708).and.qselect_chan(708)) then
          current_chan = 708
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(709).and.qselect_chan(709)) then
          current_chan = 709
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(710).and.qselect_chan(710)) then
          current_chan = 710
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(711).and.qselect_chan(711)) then
          current_chan = 711
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(712).and.qselect_chan(712)) then
          current_chan = 712
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(713).and.qselect_chan(713)) then
          current_chan = 713
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(714).and.qselect_chan(714)) then
          current_chan = 714
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(715).and.qselect_chan(715)) then
          current_chan = 715
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(716).and.qselect_chan(716)) then
          current_chan = 716
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(717).and.qselect_chan(717)) then
          current_chan = 717
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(718).and.qselect_chan(718)) then
          current_chan = 718
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbBtt1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to d lm lp      
        if (qactive_chan(719).and.qselect_chan(719)) then
          current_chan = 719
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u lm lp      
        if (qactive_chan(720).and.qselect_chan(720)) then
          current_chan = 720
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g lm lp     
        if (qactive_chan(721).and.qselect_chan(721)) then
          current_chan = 721
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbBh1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g lm lp     
        if (qactive_chan(722).and.qselect_chan(722)) then
          current_chan = 722
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbBh1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d lm lp      
        if (qactive_chan(723).and.qselect_chan(723)) then
          current_chan = 723
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqBh1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u lm lp      
        if (qactive_chan(724).and.qselect_chan(724)) then
          current_chan = 724
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqBh1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g lm lp     
        if (qactive_chan(725).and.qselect_chan(725)) then
          current_chan = 725
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqBh1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g lm lp     
        if (qactive_chan(726).and.qselect_chan(726)) then
          current_chan = 726
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqBh1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db lm lp    
        if (qactive_chan(727).and.qselect_chan(727)) then
          current_chan = 727
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbBh1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub lm lp    
        if (qactive_chan(728).and.qselect_chan(728)) then
          current_chan = 728
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbBh1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db lm lp    
        if (qactive_chan(729).and.qselect_chan(729)) then
          current_chan = 729
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgBh1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub lm lp    
        if (qactive_chan(730).and.qselect_chan(730)) then
          current_chan = 730
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgBh1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(731).and.qselect_chan(731)) then
          current_chan = 731
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qpgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(732).and.qselect_chan(732)) then
          current_chan = 732
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qpgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(733).and.qselect_chan(733)) then
          current_chan = 733
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qpgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(734).and.qselect_chan(734)) then
          current_chan = 734
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qpgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(735).and.qselect_chan(735)) then
          current_chan = 735
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qpbgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(736).and.qselect_chan(736)) then
          current_chan = 736
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qpbgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(737).and.qselect_chan(737)) then
          current_chan = 737
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qpbgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(738).and.qselect_chan(738)) then
          current_chan = 738
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qpbgBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(739).and.qselect_chan(739)) then
          current_chan = 739
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = gqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(740).and.qselect_chan(740)) then
          current_chan = 740
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = gqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(741).and.qselect_chan(741)) then
          current_chan = 741
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = gqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(742).and.qselect_chan(742)) then
          current_chan = 742
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = gqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(743).and.qselect_chan(743)) then
          current_chan = 743
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = gqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(744).and.qselect_chan(744)) then
          current_chan = 744
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = gqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(745).and.qselect_chan(745)) then
          current_chan = 745
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = gqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(746).and.qselect_chan(746)) then
          current_chan = 746
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = gqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(747).and.qselect_chan(747)) then
          current_chan = 747
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(748).and.qselect_chan(748)) then
          current_chan = 748
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(749).and.qselect_chan(749)) then
          current_chan = 749
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(750).and.qselect_chan(750)) then
          current_chan = 750
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(751).and.qselect_chan(751)) then
          current_chan = 751
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(752).and.qselect_chan(752)) then
          current_chan = 752
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(753).and.qselect_chan(753)) then
          current_chan = 753
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(754).and.qselect_chan(754)) then
          current_chan = 754
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(755).and.qselect_chan(755)) then
          current_chan = 755
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(756).and.qselect_chan(756)) then
          current_chan = 756
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(757).and.qselect_chan(757)) then
          current_chan = 757
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(758).and.qselect_chan(758)) then
          current_chan = 758
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(759).and.qselect_chan(759)) then
          current_chan = 759
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(760).and.qselect_chan(760)) then
          current_chan = 760
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(761).and.qselect_chan(761)) then
          current_chan = 761
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(762).and.qselect_chan(762)) then
          current_chan = 762
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(763).and.qselect_chan(763)) then
          current_chan = 763
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(764).and.qselect_chan(764)) then
          current_chan = 764
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(765).and.qselect_chan(765)) then
          current_chan = 765
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(766).and.qselect_chan(766)) then
          current_chan = 766
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(767).and.qselect_chan(767)) then
          current_chan = 767
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(768).and.qselect_chan(768)) then
          current_chan = 768
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbBh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to d lm lp      
        if (qactive_chan(769).and.qselect_chan(769)) then
          current_chan = 769
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u lm lp      
        if (qactive_chan(770).and.qselect_chan(770)) then
          current_chan = 770
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g lm lp     
        if (qactive_chan(771).and.qselect_chan(771)) then
          current_chan = 771
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbBht1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g lm lp     
        if (qactive_chan(772).and.qselect_chan(772)) then
          current_chan = 772
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbBht1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d lm lp      
        if (qactive_chan(773).and.qselect_chan(773)) then
          current_chan = 773
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqBht1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u lm lp      
        if (qactive_chan(774).and.qselect_chan(774)) then
          current_chan = 774
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqBht1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g lm lp     
        if (qactive_chan(775).and.qselect_chan(775)) then
          current_chan = 775
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqBht1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g lm lp     
        if (qactive_chan(776).and.qselect_chan(776)) then
          current_chan = 776
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqBht1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db lm lp    
        if (qactive_chan(777).and.qselect_chan(777)) then
          current_chan = 777
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbBht1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub lm lp    
        if (qactive_chan(778).and.qselect_chan(778)) then
          current_chan = 778
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbBht1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db lm lp    
        if (qactive_chan(779).and.qselect_chan(779)) then
          current_chan = 779
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgBht1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub lm lp    
        if (qactive_chan(780).and.qselect_chan(780)) then
          current_chan = 780
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgBht1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(781).and.qselect_chan(781)) then
          current_chan = 781
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qpgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(782).and.qselect_chan(782)) then
          current_chan = 782
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qpgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(783).and.qselect_chan(783)) then
          current_chan = 783
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qpgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(784).and.qselect_chan(784)) then
          current_chan = 784
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qpgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(785).and.qselect_chan(785)) then
          current_chan = 785
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qpbgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(786).and.qselect_chan(786)) then
          current_chan = 786
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qpbgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(787).and.qselect_chan(787)) then
          current_chan = 787
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qpbgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(788).and.qselect_chan(788)) then
          current_chan = 788
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qpbgBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(789).and.qselect_chan(789)) then
          current_chan = 789
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = gqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(790).and.qselect_chan(790)) then
          current_chan = 790
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = gqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(791).and.qselect_chan(791)) then
          current_chan = 791
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = gqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(792).and.qselect_chan(792)) then
          current_chan = 792
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = gqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(793).and.qselect_chan(793)) then
          current_chan = 793
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = gqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(794).and.qselect_chan(794)) then
          current_chan = 794
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = gqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(795).and.qselect_chan(795)) then
          current_chan = 795
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = gqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(796).and.qselect_chan(796)) then
          current_chan = 796
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = gqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(797).and.qselect_chan(797)) then
          current_chan = 797
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(798).and.qselect_chan(798)) then
          current_chan = 798
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(799).and.qselect_chan(799)) then
          current_chan = 799
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(800).and.qselect_chan(800)) then
          current_chan = 800
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(801).and.qselect_chan(801)) then
          current_chan = 801
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(802).and.qselect_chan(802)) then
          current_chan = 802
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(803).and.qselect_chan(803)) then
          current_chan = 803
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(804).and.qselect_chan(804)) then
          current_chan = 804
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(805).and.qselect_chan(805)) then
          current_chan = 805
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(806).and.qselect_chan(806)) then
          current_chan = 806
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(807).and.qselect_chan(807)) then
          current_chan = 807
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(808).and.qselect_chan(808)) then
          current_chan = 808
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(809).and.qselect_chan(809)) then
          current_chan = 809
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(810).and.qselect_chan(810)) then
          current_chan = 810
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(811).and.qselect_chan(811)) then
          current_chan = 811
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(812).and.qselect_chan(812)) then
          current_chan = 812
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(813).and.qselect_chan(813)) then
          current_chan = 813
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(814).and.qselect_chan(814)) then
          current_chan = 814
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(815).and.qselect_chan(815)) then
          current_chan = 815
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(816).and.qselect_chan(816)) then
          current_chan = 816
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(817).and.qselect_chan(817)) then
          current_chan = 817
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(818).and.qselect_chan(818)) then
          current_chan = 818
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbBht1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to d lm lp      
        if (qactive_chan(819).and.qselect_chan(819)) then
          current_chan = 819
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to u lm lp      
        if (qactive_chan(820).and.qselect_chan(820)) then
          current_chan = 820
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g lm lp     
        if (qactive_chan(821).and.qselect_chan(821)) then
          current_chan = 821
          ip1_chan     = 10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qqbBhh1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g lm lp     
        if (qactive_chan(822).and.qselect_chan(822)) then
          current_chan = 822
          ip1_chan     = 20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qqbBhh1g2ZU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to d lm lp      
        if (qactive_chan(823).and.qselect_chan(823)) then
          current_chan = 823
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = gqBhh1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to u lm lp      
        if (qactive_chan(824).and.qselect_chan(824)) then
          current_chan = 824
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = gqBhh1g2ZU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g lm lp     
        if (qactive_chan(825).and.qselect_chan(825)) then
          current_chan = 825
          ip1_chan     = -10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qbqBhh1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g lm lp     
        if (qactive_chan(826).and.qselect_chan(826)) then
          current_chan = 826
          ip1_chan     = -20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qbqBhh1g2ZU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db lm lp    
        if (qactive_chan(827).and.qselect_chan(827)) then
          current_chan = 827
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = gqbBhh1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub lm lp    
        if (qactive_chan(828).and.qselect_chan(828)) then
          current_chan = 828
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = gqbBhh1g2ZU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db lm lp    
        if (qactive_chan(829).and.qselect_chan(829)) then
          current_chan = 829
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = qbgBhh1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub lm lp    
        if (qactive_chan(830).and.qselect_chan(830)) then
          current_chan = 830
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = qbgBhh1g2ZU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(831).and.qselect_chan(831)) then
          current_chan = 831
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qpgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(832).and.qselect_chan(832)) then
          current_chan = 832
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qpgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(833).and.qselect_chan(833)) then
          current_chan = 833
          ip1_chan     = 10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qpgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(834).and.qselect_chan(834)) then
          current_chan = 834
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qpgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(835).and.qselect_chan(835)) then
          current_chan = 835
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qpbgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(836).and.qselect_chan(836)) then
          current_chan = 836
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qpbgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(837).and.qselect_chan(837)) then
          current_chan = 837
          ip1_chan     = -10
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qpbgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(838).and.qselect_chan(838)) then
          current_chan = 838
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qpbgBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(839).and.qselect_chan(839)) then
          current_chan = 839
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = gqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(840).and.qselect_chan(840)) then
          current_chan = 840
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = gqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(841).and.qselect_chan(841)) then
          current_chan = 841
          ip1_chan     = 0
          ip2_chan     = 10
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = gqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(842).and.qselect_chan(842)) then
          current_chan = 842
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = gqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(843).and.qselect_chan(843)) then
          current_chan = 843
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = gqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(844).and.qselect_chan(844)) then
          current_chan = 844
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = gqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(845).and.qselect_chan(845)) then
          current_chan = 845
          ip1_chan     = 0
          ip2_chan     = -10
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = gqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(846).and.qselect_chan(846)) then
          current_chan = 846
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = gqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(847).and.qselect_chan(847)) then
          current_chan = 847
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 1
          wt = ggBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(848).and.qselect_chan(848)) then
          current_chan = 848
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          wt = ggBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(849).and.qselect_chan(849)) then
          current_chan = 849
          ip1_chan     = 11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(850).and.qselect_chan(850)) then
          current_chan = 850
          ip1_chan     = 11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(851).and.qselect_chan(851)) then
          current_chan = 851
          ip1_chan     = 21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(852).and.qselect_chan(852)) then
          current_chan = 852
          ip1_chan     = 21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(853).and.qselect_chan(853)) then
          current_chan = 853
          ip1_chan     = 11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(854).and.qselect_chan(854)) then
          current_chan = 854
          ip1_chan     = 11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(855).and.qselect_chan(855)) then
          current_chan = 855
          ip1_chan     = 21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(856).and.qselect_chan(856)) then
          current_chan = 856
          ip1_chan     = 21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(857).and.qselect_chan(857)) then
          current_chan = 857
          ip1_chan     = 10
          ip2_chan     = 10
          call Q3_check
          nfB1 = 1
          wt = qqBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(858).and.qselect_chan(858)) then
          current_chan = 858
          ip1_chan     = 20
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          wt = qqBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(859).and.qselect_chan(859)) then
          current_chan = 859
          ip1_chan     = -11
          ip2_chan     = 11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(860).and.qselect_chan(860)) then
          current_chan = 860
          ip1_chan     = -11
          ip2_chan     = 21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(861).and.qselect_chan(861)) then
          current_chan = 861
          ip1_chan     = -21
          ip2_chan     = 11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(862).and.qselect_chan(862)) then
          current_chan = 862
          ip1_chan     = -21
          ip2_chan     = 21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(863).and.qselect_chan(863)) then
          current_chan = 863
          ip1_chan     = -11
          ip2_chan     = -11
          call Q3_check
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(864).and.qselect_chan(864)) then
          current_chan = 864
          ip1_chan     = -11
          ip2_chan     = -21
          call Q3_check
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(865).and.qselect_chan(865)) then
          current_chan = 865
          ip1_chan     = -21
          ip2_chan     = -11
          call Q3_check
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(866).and.qselect_chan(866)) then
          current_chan = 866
          ip1_chan     = -21
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(867).and.qselect_chan(867)) then
          current_chan = 867
          ip1_chan     = -10
          ip2_chan     = -10
          call Q3_check
          nfB1 = 1
          wt = qbqbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(868).and.qselect_chan(868)) then
          current_chan = 868
          ip1_chan     = -20
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          wt = qbqbBhh1g2ZU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUZJ=sigUZJ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
