      function sigTNLOepemjj(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use Charges_EW_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLOepemjj=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.ne.1) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- ep em to db d       
        if (qactive_chan(5).and.qselect_chan(5)) then
          current_chan = 5
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 1
          wt = epemB0g1ZTNLO(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub u       
        if (qactive_chan(6).and.qselect_chan(6)) then
          current_chan = 6
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 2
          wt = epemB0g1ZTNLO(ix,xri1,xri2,3,4,2,1,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLOepemjj=sigTNLOepemjj+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
