# NNLOJET Runcard Examples

This `examples` directory contains selected example runcards.
A more detailed and up-to-date collection of examples can be found on the [NNLOJET website](https://nnlojet.hepforge.org/examples.html).

## Note for contributors

The Examples page on the website is updated automatically based on this directory structure and these naming conventions:
- each folder refers to a process name PROCESS as given by the `NNLOJET --listprocs` command
- inside each folder, there is one or more runcards with extension `.run`. If the runcard has been used for previous NNLOJET publication, the naming convention for the prefix is `nnlojet-XXX.YYY-...`, with XXX.YYY the arxiv number of the publication. If the runcard adopts the fiducial setup of a specific measurement, the naming convention for the prefix is `EXP-XXX.YYY-...`, with EXP the name of the experiment and XXX.YYY the arxiv number of the publication. In case of NNLOJET publications adopting experimental setups, priority to the NNLOJET arxiv number. In case of runcards w/o associated publications, complete freedom in the choice of the name.
- please collect the reference numbers for runcard `PROCESS/RUNNAME.run` under the folder `PROCESS/RUNNAME-results`
