****************************************************
* FullggF30II(i1,i3,i2,ipset) i.e. for 3 soft
      function FullggF30II(i1,i3,i2,ipset)
      use KinData_mod
      implicit double precision (a-h,o-z)
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      FullggF30II=8d0*s13**2/s23+8d0*s13**2/s12
     .         +8d0*s23**2/s13+8d0*s23**2/s12
     .         +8d0*s12**2/s13+8d0*s12**2/s23
     .         +12d0*s13*s23/s12
     .         +12d0*s12*s23/s13
     .         +12d0*s13*s12/s23
     .         +4d0*s13**3/s12/s23
     .         +4d0*s23**3/s12/s13
     .         +4d0*s12**3/s13/s23
     .         +24d0*s123

      FullggF30II=FullggF30II/2d0/s123**2
*      write(*,*)" FullggF30II ",FullggF30II
      return
      end
************************************************************************
