************************************************************************
*
      function SSint(ix,x1,x2,i1,i2,i12set,i3,i4,i34set,renscale)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)


      sac = 2d0*dot(kin(i12set)%p(:,i1),kin(i12set)%p(:,i2))
      sai = 2d0*dot(kin(i12set)%p(:,i1),kin(i34set)%p(:,i3))
      sak = 2d0*dot(kin(i12set)%p(:,i1),kin(i34set)%p(:,i4))
      sci = 2d0*dot(kin(i12set)%p(:,i2),kin(i34set)%p(:,i3))
      sck = 2d0*dot(kin(i12set)%p(:,i2),kin(i34set)%p(:,i4))
      sik = 2d0*dot(kin(i34set)%p(:,i3),kin(i34set)%p(:,i4))


      ! if(i12set.eq.7.and.i34set.eq.7)then
      !   sac = 2d0*dot(p7(:,i1),p7(:,i2))
      !   sai = 2d0*dot(p7(:,i1),p7(:,i3))
      !   sak = 2d0*dot(p7(:,i1),p7(:,i4))
      !   sci = 2d0*dot(p7(:,i2),p7(:,i3))
      !   sck = 2d0*dot(p7(:,i2),p7(:,i4))
      !   sik = 2d0*dot(p7(:,i3),p7(:,i4))
      ! elseif(i12set.eq.6.and.i34set.eq.7)then
      !   sac = 2d0*dot(p6(1,i1),p6(1,i2))
      !   sai = 2d0*dot(p6(1,i1),p7(1,i3))
      !   sak = 2d0*dot(p6(1,i1),p7(1,i4))
      !   sci = 2d0*dot(p6(1,i2),p7(1,i3))
      !   sck = 2d0*dot(p6(1,i2),p7(1,i4))
      !   sik = 2d0*dot(p7(1,i3),p7(1,i4))
      ! elseif(i12set.eq.6.and.i34set.eq.6)then
      !   sac = 2d0*dot(p6(1,i1),p6(1,i2))
      !   sai = 2d0*dot(p6(1,i1),p6(1,i3))
      !   sak = 2d0*dot(p6(1,i1),p6(1,i4))
      !   sci = 2d0*dot(p6(1,i2),p6(1,i3))
      !   sck = 2d0*dot(p6(1,i2),p6(1,i4))
      !   sik = 2d0*dot(p6(1,i3),p6(1,i4))
      ! elseif(i12set.eq.5.and.i34set.eq.6)then
      !   sac = 2d0*dot(p5(1,i1),p5(1,i2))
      !   sai = 2d0*dot(p5(1,i1),p6(1,i3))
      !   sak = 2d0*dot(p5(1,i1),p6(1,i4))
      !   sci = 2d0*dot(p5(1,i2),p6(1,i3))
      !   sck = 2d0*dot(p5(1,i2),p6(1,i4))
      !   sik = 2d0*dot(p6(1,i3),p6(1,i4))
      ! elseif(i12set.eq.5.and.i34set.eq.5)then
      !   sac = 2d0*dot(p5(1,i1),p5(1,i2))
      !   sai = 2d0*dot(p5(1,i1),p5(1,i3))
      !   sak = 2d0*dot(p5(1,i1),p5(1,i4))
      !   sci = 2d0*dot(p5(1,i2),p5(1,i3))
      !   sck = 2d0*dot(p5(1,i2),p5(1,i4))
      !   sik = 2d0*dot(p5(1,i3),p5(1,i4))
      ! elseif(i12set.eq.4.and.i34set.eq.5)then
      !   sac = 2d0*dot(p4(1,i1),p4(1,i2))
      !   sai = 2d0*dot(p4(1,i1),p5(1,i3))
      !   sak = 2d0*dot(p4(1,i1),p5(1,i4))
      !   sci = 2d0*dot(p4(1,i2),p5(1,i3))
      !   sck = 2d0*dot(p4(1,i2),p5(1,i4))
      !   sik = 2d0*dot(p5(1,i3),p5(1,i4))
      ! elseif(i12set.eq.4.and.i34set.eq.4)then
      !   sac = 2d0*dot(p4(1,i1),p4(1,i2))
      !   sai = 2d0*dot(p4(1,i1),p4(1,i3))
      !   sak = 2d0*dot(p4(1,i1),p4(1,i4))
      !   sci = 2d0*dot(p4(1,i2),p4(1,i3))
      !   sck = 2d0*dot(p4(1,i2),p4(1,i4))
      !   sik = 2d0*dot(p4(1,i3),p4(1,i4))
      ! endif

      yy=sac*sik/(sai+sak)/(sci+sck)
      yy1=1d0-1d0/yy

      dls=log(renscale/abs(sik))

      e2=0d0
      e1=0d0
      e0=0d0
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = -rH1(0, yy)
      e0 = -0.7D1 / 0.12D2 * pi ** 2 - rH2(0, 1, yy1)
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = -rH1(0, yy) / omz1 / omz2
      e0 = -0.1D1 / omz1 / omz2 * rH2(0, 1, yy1) - 0.7D1 / 0.12D2 * pi
     # ** 2 / omz1 / omz2
      endif

      if(ieorder.eq.-2)then
        SSint=e2
      elseif(ieorder.eq.-1)then
        SSint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        SSint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

      return
      end
