************************************************************************
*
      function rJ21QQII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.3D1 / 0.2D1 + dls
      e0 = -pi ** 2 / 0.12D2 + dls ** 2 / 0.2D1 - d0x1 * dlm + d0x1 * 
     #dls - d1x1 - d1x2 - d0x2 * dlm + d0x2 * dls + 0.3D1 / 0.2D1 * dlm 
     #+ d0x1 * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.3D1 / 0.2D1 / omz1 / omz2
      e0 = d0x1 * d0x2 - 0.1D1 / omz2 * d0x1 * dlm + 0.1D1 / omz2 * rH
     #1(1, z2) * d0x1 + dls / omz2 * d0x1 - 0.1D1 / omz1 * d0x2 * dlm + 
     #0.1D1 / omz1 * rH1(1, z1) * d0x2 + dls / omz1 * d0x2 - 0.1D1 / omz
     #2 * d1x1 - 0.1D1 / omz1 * d1x2 + 0.3D1 / 0.2D1 / omz1 / omz2 * dlm
     # - 0.1D1 / omz1 / omz2 * rH1(1, z1) * dlm - 0.1D1 / omz1 / omz2 * 
     #rH1(1, z2) * dlm + 0.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.1D1 
     #/ omz1 / omz2 * rH1(1, z1) * dls + 0.1D1 / omz1 / omz2 * dls * rH1
     #(1, z2) + 0.1D1 / omz1 / omz2 * rH1(1, z2) * rH1(1, z1) + 0.1D1 / 
     #omz1 / omz2 * rH2(1, 1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2) 
     #- pi ** 2 / omz1 / omz2 / 0.12D2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 + x2 / 0.2D1) * d0x1 - d0x1 * d0x2 + d0x2 * 
     #dlm - d0x2 * dls + d1x2 + dlm * (-0.1D1 / 0.2D1 - x2 / 0.2D1) + dl
     #s * (0.1D1 / 0.2D1 + x2 / 0.2D1) + 0.1D1 / 0.2D1 - x2 / 0.2D1 + (-
     #0.1D1 / 0.2D1 - x2 / 0.2D1) * rln2 + (0.1D1 / 0.2D1 + x2 / 0.2D1) 
     #* rH1(-1, x2) + rH1(1, x2) * (0.1D1 / 0.2D1 + x2 / 0.2D1) + 0.1D1 
     #/ omx2 * rln2 - rH1(-1, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 + x2 / 0.2D1) * d0x1 - d0x1 * d0x2 + 0.1D1 /
     # omz1 * d0x2 * dlm - 0.1D1 / omz1 * rH1(1, z1) * d0x2 - dls / omz1
     # * d0x2 + 0.1D1 / omz1 * d1x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / om
     #z1 * dlm + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * dls + (0.1D1 / 0.
     #2D1 - x2 / 0.2D1) / omz1 + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * r
     #H1(1, z1) + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * rH1(-1, x2) + (-
     #0.1D1 / 0.2D1 - x2 / 0.2D1) / omz1 * rln2 + (0.1D1 / 0.2D1 + x2 / 
     #0.2D1) * rH1(1, x2) / omz1 - 0.1D1 / omz1 * rH1(-1, x2) / omx2 + 0
     #.1D1 / omz1 * rln2 / omx2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + d0x1 * dlm - d0x1 * dls + (0.1D1 / 0.2D1 + x
     #1 / 0.2D1) * d0x2 + d1x1 + dlm * (-0.1D1 / 0.2D1 - x1 / 0.2D1) + d
     #ls * (0.1D1 / 0.2D1 + x1 / 0.2D1) - x1 / 0.2D1 + 0.1D1 / 0.2D1 + (
     #-0.1D1 / 0.2D1 - x1 / 0.2D1) * rln2 + (0.1D1 / 0.2D1 + x1 / 0.2D1)
     # * rH1(-1, x1) + rH1(1, x1) * (0.1D1 / 0.2D1 + x1 / 0.2D1) + 0.1D1
     # / omx1 * rln2 - rH1(-1, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + 0.1D1 / omz2 * d0x1 * dlm - 0.1D1 / omz2 * r
     #H1(1, z2) * d0x1 - dls / omz2 * d0x1 + (0.1D1 / 0.2D1 + x1 / 0.2D1
     #) * d0x2 + 0.1D1 / omz2 * d1x1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / o
     #mz2 * dlm + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * dls + (-x1 / 0.2
     #D1 + 0.1D1 / 0.2D1) / omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 *
     # rH1(1, z2) + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * rH1(-1, x1) + 
     #(-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 * rln2 + (0.1D1 / 0.2D1 + x1 
     #/ 0.2D1) * rH1(1, x1) / omz2 - 0.1D1 / omz2 * rH1(-1, x1) / omx1 +
     # 0.1D1 / omz2 * rln2 / omx1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = d0x1 * d0x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) * d0x1 + (-0.1D
     #1 / 0.2D1 - x1 / 0.2D1) * d0x2 + (x1 ** 2 + x2 ** 2) * (0.2D1 * x1
     # ** 2 * x2 ** 2 + 0.2D1 * x1 ** 2 * x2 + 0.2D1 * x1 * x2 ** 2 + x1
     # ** 2 + 0.6D1 * x1 * x2 + x2 ** 2 + 0.2D1 * x1 + 0.2D1 * x2 + 0.2D
     #1) / (x2 + x1) ** 2 / (0.1D1 + x1) / (0.1D1 + x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QQII=e2
      elseif(ieorder.eq.-1)then
        rJ21QQII=e1
      elseif(ieorder.eq.0)then
        rJ21QQII=e0
      endif

*      write(*,*)" rJ21QQII ",rJ21QQII

      return
      end
************************************************************************
*
      function rJ21hQQII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2


      if(ieorder.eq.-2)then
        rJ21hQQII=e2
      elseif(ieorder.eq.-1)then
        rJ21hQQII=e1
      elseif(ieorder.eq.0)then
        rJ21hQQII=e0
      endif

*      write(*,*)" rJ21hQQII ",rJ21hQQII

      return
      end
************************************************************************
*
      function rJ21QGII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21QGII=rJ21GQII(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.5D1 / 0.3D1 + dls
      e0 = -pi ** 2 / 0.12D2 + dls ** 2 / 0.2D1 - d0x1 * dlm + d0x1 * 
     #dls - d1x1 - d1x2 - d0x2 * dlm + d0x2 * dls + 0.5D1 / 0.3D1 * dlm 
     #+ d0x1 * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.5D1 / 0.3D1 / omz1 / omz2
      e0 = d0x1 * d0x2 - 0.1D1 / omz2 * d0x1 * dlm + 0.1D1 / omz2 * rH
     #1(1, z2) * d0x1 + dls / omz2 * d0x1 - 0.1D1 / omz1 * d0x2 * dlm + 
     #0.1D1 / omz1 * rH1(1, z1) * d0x2 + dls / omz1 * d0x2 - 0.1D1 / omz
     #2 * d1x1 - 0.1D1 / omz1 * d1x2 + 0.5D1 / 0.3D1 / omz1 / omz2 * dlm
     # - 0.1D1 / omz1 / omz2 * rH1(1, z1) * dlm - 0.1D1 / omz1 / omz2 * 
     #rH1(1, z2) * dlm + 0.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.1D1 
     #/ omz1 / omz2 * rH1(1, z1) * dls + 0.1D1 / omz1 / omz2 * dls * rH1
     #(1, z2) + 0.1D1 / omz1 / omz2 * rH1(1, z2) * rH1(1, z1) + 0.1D1 / 
     #omz1 / omz2 * rH2(1, 1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2) 
     #- pi ** 2 / omz1 / omz2 / 0.12D2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 * d0x1 + d0x2 * dlm - d0x2 * dls + d1x2 - (x2 ** 3 - x2 ** 2 + 0
     #.2D1 * x2 - 0.1D1) / x2 * dlm + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 
     #0.1D1) / x2 * dls + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 
     #* rH1(-1, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH
     #1(1, x2) - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rln2 + 
     #0.1D1 / omx2 * rln2 - rH1(-1, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 * d0x1 + 0.1D1 / omz1 * d0x2 * dlm - 0.1D1 / omz1 * rH1(1, z1) *
     # d0x2 - dls / omz1 * d0x2 + 0.1D1 / omz1 * d1x2 - (x2 ** 3 - x2 **
     # 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * dlm + dls * (x2 ** 3 - x2 *
     #* 2 + 0.2D1 * x2 - 0.1D1) / omz1 / x2 + (x2 ** 3 - x2 ** 2 + 0.2D1
     # * x2 - 0.1D1) / x2 / omz1 * rH1(1, z1) + (x2 ** 3 - x2 ** 2 + 0.2
     #D1 * x2 - 0.1D1) / omz1 / x2 * rH1(-1, x2) - (x2 ** 3 - x2 ** 2 + 
     #0.2D1 * x2 - 0.1D1) / omz1 / x2 * rln2 + (x2 ** 3 - x2 ** 2 + 0.2D
     #1 * x2 - 0.1D1) / omz1 / x2 * rH1(1, x2) - 0.1D1 / omz1 * rH1(-1, 
     #x2) / omx2 + 0.1D1 / omz1 * rln2 / omx2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + d0x1 * dlm - d0x1 * dls + (0.1D1 / 0.2D1 + x
     #1 / 0.2D1) * d0x2 + d1x1 + dlm * (-0.1D1 / 0.2D1 - x1 / 0.2D1) + d
     #ls * (0.1D1 / 0.2D1 + x1 / 0.2D1) - x1 / 0.2D1 + 0.1D1 / 0.2D1 + (
     #-0.1D1 / 0.2D1 - x1 / 0.2D1) * rln2 + (0.1D1 / 0.2D1 + x1 / 0.2D1)
     # * rH1(-1, x1) + rH1(1, x1) * (0.1D1 / 0.2D1 + x1 / 0.2D1) + 0.1D1
     # / omx1 * rln2 - rH1(-1, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + 0.1D1 / omz2 * d0x1 * dlm - 0.1D1 / omz2 * r
     #H1(1, z2) * d0x1 - dls / omz2 * d0x1 + (0.1D1 / 0.2D1 + x1 / 0.2D1
     #) * d0x2 + 0.1D1 / omz2 * d1x1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / o
     #mz2 * dlm + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * dls + (-x1 / 0.2
     #D1 + 0.1D1 / 0.2D1) / omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 *
     # rH1(1, z2) + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * rH1(-1, x1) + 
     #(-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 * rln2 + (0.1D1 / 0.2D1 + x1 
     #/ 0.2D1) * rH1(1, x1) / omz2 - 0.1D1 / omz2 * rH1(-1, x1) / omx1 +
     # 0.1D1 / omz2 * rln2 / omx1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = d0x1 * d0x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2
     # * d0x1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * d0x2 + (0.2D1 * x1 ** 5 
     #* x2 ** 5 + 0.4D1 * x1 ** 4 * x2 ** 6 + 0.4D1 * x1 ** 3 * x2 ** 7 
     #+ 0.2D1 * x1 ** 5 * x2 ** 4 + 0.6D1 * x1 ** 4 * x2 ** 5 + 0.8D1 * 
     #x1 ** 3 * x2 ** 6 + 0.4D1 * x1 ** 2 * x2 ** 7 + 0.2D1 * x1 ** 5 * 
     #x2 ** 3 + 0.10D2 * x1 ** 4 * x2 ** 4 + 0.12D2 * x1 ** 3 * x2 ** 5 
     #+ 0.12D2 * x1 ** 2 * x2 ** 6 + 0.4D1 * x1 * x2 ** 7 + 0.2D1 * x1 *
     #* 5 * x2 ** 2 + 0.10D2 * x1 ** 4 * x2 ** 3 + 0.14D2 * x1 ** 3 * x2
     # ** 4 + 0.10D2 * x1 ** 2 * x2 ** 5 + 0.6D1 * x1 * x2 ** 6 + 0.2D1 
     #* x2 ** 7 + x1 ** 5 * x2 + 0.7D1 * x1 ** 4 * x2 ** 2 + 0.21D2 * x2
     # ** 3 * x1 ** 3 + 0.19D2 * x1 ** 2 * x2 ** 4 + 0.4D1 * x1 * x2 ** 
     #5 + 0.2D1 * x1 ** 4 * x2 + 0.10D2 * x1 ** 3 * x2 ** 2 + 0.18D2 * x
     #1 ** 2 * x2 ** 3 + 0.12D2 * x1 * x2 ** 4 + 0.2D1 * x2 ** 5 + x2 * 
     #x1 ** 3 + 0.3D1 * x1 ** 2 * x2 ** 2 + 0.9D1 * x1 * x2 ** 3 + 0.3D1
     # * x2 ** 4 + 0.2D1 * x1 ** 3 + 0.2D1 * x1 ** 2 * x2 + 0.4D1 * x1 *
     #* 2 + 0.4D1 * x1 * x2 + 0.2D1 * x2 ** 2) / (x2 + x1) ** 3 / x2 / (
     #0.1D1 + x1) / (0.1D1 + x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QGII=e2
      elseif(ieorder.eq.-1)then
        rJ21QGII=e1
      elseif(ieorder.eq.0)then
        rJ21QGII=e0
      endif

*      write(*,*)" rJ21QGII ",rJ21QGII

      return
      end
************************************************************************
*
      function rJ21hQGII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21hQGII=rJ21hGQII(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.6D1
      e0 = -dlm / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 * dlm / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hQGII=e2
      elseif(ieorder.eq.-1)then
        rJ21hQGII=e1
      elseif(ieorder.eq.0)then
        rJ21hQGII=e0
      endif

*      write(*,*)" rJ21hQGII ",rJ21hQGII

      return
      end
************************************************************************
*
      function rJ21GQII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21GQII=rJ21QGII(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.5D1 / 0.3D1 + dls
      e0 = -pi ** 2 / 0.12D2 + dls ** 2 / 0.2D1 - d0x1 * dlm + d0x1 * 
     #dls - d1x1 - d1x2 - d0x2 * dlm + d0x2 * dls + 0.5D1 / 0.3D1 * dlm 
     #+ d0x1 * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.5D1 / 0.3D1 / omz1 / omz2
      e0 = d0x1 * d0x2 - 0.1D1 / omz2 * d0x1 * dlm + 0.1D1 / omz2 * rH
     #1(1, z2) * d0x1 + dls / omz2 * d0x1 - 0.1D1 / omz1 * d0x2 * dlm + 
     #0.1D1 / omz1 * rH1(1, z1) * d0x2 + dls / omz1 * d0x2 - 0.1D1 / omz
     #2 * d1x1 - 0.1D1 / omz1 * d1x2 + 0.5D1 / 0.3D1 / omz1 / omz2 * dlm
     # - 0.1D1 / omz1 / omz2 * rH1(1, z1) * dlm - 0.1D1 / omz1 / omz2 * 
     #rH1(1, z2) * dlm + 0.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.1D1 
     #/ omz1 / omz2 * rH1(1, z1) * dls + 0.1D1 / omz1 / omz2 * dls * rH1
     #(1, z2) + 0.1D1 / omz1 / omz2 * rH1(1, z2) * rH1(1, z1) + 0.1D1 / 
     #omz1 / omz2 * rH2(1, 1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2) 
     #- pi ** 2 / omz1 / omz2 / 0.12D2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 + x2 / 0.2D1) * d0x1 - d0x1 * d0x2 + d0x2 * 
     #dlm - d0x2 * dls + d1x2 + dlm * (-0.1D1 / 0.2D1 - x2 / 0.2D1) + dl
     #s * (0.1D1 / 0.2D1 + x2 / 0.2D1) + 0.1D1 / 0.2D1 - x2 / 0.2D1 + (-
     #0.1D1 / 0.2D1 - x2 / 0.2D1) * rln2 + (0.1D1 / 0.2D1 + x2 / 0.2D1) 
     #* rH1(-1, x2) + rH1(1, x2) * (0.1D1 / 0.2D1 + x2 / 0.2D1) + 0.1D1 
     #/ omx2 * rln2 - rH1(-1, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 + x2 / 0.2D1) * d0x1 - d0x1 * d0x2 + 0.1D1 /
     # omz1 * d0x2 * dlm - 0.1D1 / omz1 * rH1(1, z1) * d0x2 - dls / omz1
     # * d0x2 + 0.1D1 / omz1 * d1x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) / om
     #z1 * dlm + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * dls + (0.1D1 / 0.
     #2D1 - x2 / 0.2D1) / omz1 + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * r
     #H1(1, z1) + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * rH1(-1, x2) + (-
     #0.1D1 / 0.2D1 - x2 / 0.2D1) / omz1 * rln2 + (0.1D1 / 0.2D1 + x2 / 
     #0.2D1) * rH1(1, x2) / omz1 - 0.1D1 / omz1 * rH1(-1, x2) / omx2 + 0
     #.1D1 / omz1 * rln2 / omx2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + d0x1 * dlm - d0x1 * dls + (x1 ** 3 - x1 ** 2
     # + 0.2D1 * x1 - 0.1D1) / x1 * d0x2 + d1x1 - (x1 ** 3 - x1 ** 2 + 0
     #.2D1 * x1 - 0.1D1) / x1 * dlm + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 
     #0.1D1) / x1 * dls + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 
     #* rH1(-1, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * rH
     #1(1, x1) - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * rln2 + 
     #0.1D1 / omx1 * rln2 - rH1(-1, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + 0.1D1 / omz2 * d0x1 * dlm - 0.1D1 / omz2 * r
     #H1(1, z2) * d0x1 - dls / omz2 * d0x1 + (x1 ** 3 - x1 ** 2 + 0.2D1 
     #* x1 - 0.1D1) / x1 * d0x2 + 0.1D1 / omz2 * d1x1 - (x1 ** 3 - x1 **
     # 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * dlm + dls * (x1 ** 3 - x1 *
     #* 2 + 0.2D1 * x1 - 0.1D1) / omz2 / x1 + (x1 ** 3 - x1 ** 2 + 0.2D1
     # * x1 - 0.1D1) / x1 / omz2 * rH1(1, z2) + (x1 ** 3 - x1 ** 2 + 0.2
     #D1 * x1 - 0.1D1) / omz2 / x1 * rH1(-1, x1) - (x1 ** 3 - x1 ** 2 + 
     #0.2D1 * x1 - 0.1D1) / omz2 / x1 * rln2 + (x1 ** 3 - x1 ** 2 + 0.2D
     #1 * x1 - 0.1D1) / omz2 / x1 * rH1(1, x1) - 0.1D1 / omz2 * rH1(-1, 
     #x1) / omx1 + 0.1D1 / omz2 * rln2 / omx1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = d0x1 * d0x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) * d0x1 - (x1 **
     # 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * d0x2 + (0.4D1 * x1 ** 7 
     #* x2 ** 3 + 0.4D1 * x1 ** 6 * x2 ** 4 + 0.2D1 * x1 ** 5 * x2 ** 5 
     #+ 0.4D1 * x1 ** 7 * x2 ** 2 + 0.8D1 * x1 ** 6 * x2 ** 3 + 0.6D1 * 
     #x1 ** 5 * x2 ** 4 + 0.2D1 * x1 ** 4 * x2 ** 5 + 0.4D1 * x1 ** 7 * 
     #x2 + 0.12D2 * x1 ** 6 * x2 ** 2 + 0.12D2 * x1 ** 5 * x2 ** 3 + 0.1
     #0D2 * x1 ** 4 * x2 ** 4 + 0.2D1 * x1 ** 3 * x2 ** 5 + 0.2D1 * x1 *
     #* 7 + 0.6D1 * x1 ** 6 * x2 + 0.10D2 * x1 ** 5 * x2 ** 2 + 0.14D2 *
     # x1 ** 4 * x2 ** 3 + 0.10D2 * x1 ** 3 * x2 ** 4 + 0.2D1 * x1 ** 2 
     #* x2 ** 5 + 0.4D1 * x1 ** 5 * x2 + 0.19D2 * x1 ** 4 * x2 ** 2 + 0.
     #21D2 * x2 ** 3 * x1 ** 3 + 0.7D1 * x1 ** 2 * x2 ** 4 + x1 * x2 ** 
     #5 + 0.2D1 * x1 ** 5 + 0.12D2 * x1 ** 4 * x2 + 0.18D2 * x1 ** 3 * x
     #2 ** 2 + 0.10D2 * x1 ** 2 * x2 ** 3 + 0.2D1 * x1 * x2 ** 4 + 0.3D1
     # * x1 ** 4 + 0.9D1 * x2 * x1 ** 3 + 0.3D1 * x1 ** 2 * x2 ** 2 + x1
     # * x2 ** 3 + 0.2D1 * x1 * x2 ** 2 + 0.2D1 * x2 ** 3 + 0.2D1 * x1 *
     #* 2 + 0.4D1 * x1 * x2 + 0.4D1 * x2 ** 2) / (x2 + x1) ** 3 / (0.1D1
     # + x1) / (0.1D1 + x2) / x1 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GQII=e2
      elseif(ieorder.eq.-1)then
        rJ21GQII=e1
      elseif(ieorder.eq.0)then
        rJ21GQII=e0
      endif

*      write(*,*)" rJ21GQII ",rJ21GQII

      return
      end
************************************************************************
*
      function rJ21hGQII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21hGQII=rJ21hQGII(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.6D1
      e0 = -dlm / 0.6D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.6D1
      e0 = -0.1D1 / omz1 / omz2 * dlm / 0.6D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGQII=e2
      elseif(ieorder.eq.-1)then
        rJ21hGQII=e1
      elseif(ieorder.eq.0)then
        rJ21hGQII=e0
      endif

*      write(*,*)" rJ21hGQII ",rJ21hGQII

      return
      end
************************************************************************
*
      function rJ21GGII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = 0.11D2 / 0.6D1 + dls
      e0 = -pi ** 2 / 0.12D2 + dls ** 2 / 0.2D1 - d0x1 * dlm + d0x1 * 
     #dls - d1x1 - d1x2 - d0x2 * dlm + d0x2 * dls + 0.11D2 / 0.6D1 * dlm
     # + d0x1 * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = 0.1D1 / omz1 / omz2 * dls + 0.11D2 / 0.6D1 / omz1 / omz2
      e0 = d0x1 * d0x2 - 0.1D1 / omz2 * d0x1 * dlm + 0.1D1 / omz2 * rH
     #1(1, z2) * d0x1 + dls / omz2 * d0x1 - 0.1D1 / omz1 * d0x2 * dlm + 
     #0.1D1 / omz1 * rH1(1, z1) * d0x2 + dls / omz1 * d0x2 - 0.1D1 / omz
     #2 * d1x1 - 0.1D1 / omz1 * d1x2 + 0.11D2 / 0.6D1 / omz1 / omz2 * dl
     #m - 0.1D1 / omz1 / omz2 * rH1(1, z1) * dlm - 0.1D1 / omz1 / omz2 *
     # rH1(1, z2) * dlm + 0.1D1 / omz1 / omz2 * dls ** 2 / 0.2D1 + 0.1D1
     # / omz1 / omz2 * rH1(1, z1) * dls + 0.1D1 / omz1 / omz2 * dls * rH
     #1(1, z2) + 0.1D1 / omz1 / omz2 * rH1(1, z2) * rH1(1, z1) + 0.1D1 /
     # omz1 / omz2 * rH2(1, 1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2)
     # - pi ** 2 / omz1 / omz2 / 0.12D2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 * d0x1 + d0x2 * dlm - d0x2 * dls + d1x2 - (x2 ** 3 - x2 ** 2 + 0
     #.2D1 * x2 - 0.1D1) / x2 * dlm + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 
     #0.1D1) / x2 * dls + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 
     #* rH1(-1, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH
     #1(1, x2) - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rln2 + 
     #0.1D1 / omx2 * rln2 - rH1(-1, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 * d0x1 + 0.1D1 / omz1 * d0x2 * dlm - 0.1D1 / omz1 * rH1(1, z1) *
     # d0x2 - dls / omz1 * d0x2 + 0.1D1 / omz1 * d1x2 - (x2 ** 3 - x2 **
     # 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * dlm + dls * (x2 ** 3 - x2 *
     #* 2 + 0.2D1 * x2 - 0.1D1) / omz1 / x2 + (x2 ** 3 - x2 ** 2 + 0.2D1
     # * x2 - 0.1D1) / x2 / omz1 * rH1(1, z1) + (x2 ** 3 - x2 ** 2 + 0.2
     #D1 * x2 - 0.1D1) / omz1 / x2 * rH1(-1, x2) - (x2 ** 3 - x2 ** 2 + 
     #0.2D1 * x2 - 0.1D1) / omz1 / x2 * rln2 + (x2 ** 3 - x2 ** 2 + 0.2D
     #1 * x2 - 0.1D1) / omz1 / x2 * rH1(1, x2) - 0.1D1 / omz1 * rH1(-1, 
     #x2) / omx2 + 0.1D1 / omz1 * rln2 / omx2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + d0x1 * dlm - d0x1 * dls + (x1 ** 3 - x1 ** 2
     # + 0.2D1 * x1 - 0.1D1) / x1 * d0x2 + d1x1 - (x1 ** 3 - x1 ** 2 + 0
     #.2D1 * x1 - 0.1D1) / x1 * dlm + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 
     #0.1D1) / x1 * dls + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 
     #* rH1(-1, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * rH
     #1(1, x1) - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * rln2 + 
     #0.1D1 / omx1 * rln2 - rH1(-1, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -d0x1 * d0x2 + 0.1D1 / omz2 * d0x1 * dlm - 0.1D1 / omz2 * r
     #H1(1, z2) * d0x1 - dls / omz2 * d0x1 + (x1 ** 3 - x1 ** 2 + 0.2D1 
     #* x1 - 0.1D1) / x1 * d0x2 + 0.1D1 / omz2 * d1x1 - (x1 ** 3 - x1 **
     # 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * dlm + dls * (x1 ** 3 - x1 *
     #* 2 + 0.2D1 * x1 - 0.1D1) / omz2 / x1 + (x1 ** 3 - x1 ** 2 + 0.2D1
     # * x1 - 0.1D1) / x1 / omz2 * rH1(1, z2) + (x1 ** 3 - x1 ** 2 + 0.2
     #D1 * x1 - 0.1D1) / omz2 / x1 * rH1(-1, x1) - (x1 ** 3 - x1 ** 2 + 
     #0.2D1 * x1 - 0.1D1) / omz2 / x1 * rln2 + (x1 ** 3 - x1 ** 2 + 0.2D
     #1 * x1 - 0.1D1) / omz2 / x1 * rH1(1, x1) - 0.1D1 / omz2 * rH1(-1, 
     #x1) / omx1 + 0.1D1 / omz2 * rln2 / omx1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = d0x1 * d0x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2
     # * d0x1 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * d0x2 + (
     #0.2D1 * x1 ** 8 * x2 ** 4 + 0.4D1 * x1 ** 7 * x2 ** 5 + 0.6D1 * x1
     # ** 6 * x2 ** 6 + 0.4D1 * x1 ** 5 * x2 ** 7 + 0.2D1 * x1 ** 4 * x2
     # ** 8 + 0.2D1 * x1 ** 8 * x2 ** 3 + 0.6D1 * x1 ** 7 * x2 ** 4 + 0.
     #10D2 * x1 ** 6 * x2 ** 5 + 0.10D2 * x1 ** 5 * x2 ** 6 + 0.6D1 * x1
     # ** 4 * x2 ** 7 + 0.2D1 * x1 ** 3 * x2 ** 8 + 0.2D1 * x1 ** 8 * x2
     # ** 2 + 0.8D1 * x1 ** 7 * x2 ** 3 + 0.12D2 * x1 ** 6 * x2 ** 4 + 0
     #.20D2 * x1 ** 5 * x2 ** 5 + 0.12D2 * x1 ** 4 * x2 ** 6 + 0.8D1 * x
     #1 ** 3 * x2 ** 7 + 0.2D1 * x1 ** 2 * x2 ** 8 + x1 ** 8 * x2 + 0.4D
     #1 * x1 ** 7 * x2 ** 2 + 0.8D1 * x1 ** 6 * x2 ** 3 + 0.17D2 * x1 **
     # 5 * x2 ** 4 + 0.17D2 * x1 ** 4 * x2 ** 5 + 0.8D1 * x1 ** 3 * x2 *
     #* 6 + 0.4D1 * x1 ** 2 * x2 ** 7 + x1 * x2 ** 8 + 0.2D1 * x1 ** 6 *
     # x2 ** 2 + 0.12D2 * x1 ** 5 * x2 ** 3 + 0.32D2 * x1 ** 4 * x2 ** 4
     # + 0.12D2 * x1 ** 3 * x2 ** 5 + 0.2D1 * x1 ** 2 * x2 ** 6 + x1 ** 
     #6 * x2 + 0.7D1 * x1 ** 5 * x2 ** 2 + 0.22D2 * x1 ** 4 * x2 ** 3 + 
     #0.22D2 * x1 ** 3 * x2 ** 4 + 0.7D1 * x1 ** 2 * x2 ** 5 + x1 * x2 *
     #* 6 + x1 ** 5 * x2 + 0.2D1 * x1 ** 4 * x2 ** 2 + 0.10D2 * x1 ** 3 
     #* x2 ** 3 + 0.2D1 * x1 ** 2 * x2 ** 4 + x1 * x2 ** 5 + x1 ** 5 + x
     #1 ** 4 * x2 + x1 * x2 ** 4 + x2 ** 5 + 0.2D1 * x1 ** 4 + 0.4D1 * x
     #2 * x1 ** 3 + 0.6D1 * x1 ** 2 * x2 ** 2 + 0.4D1 * x1 * x2 ** 3 + 0
     #.2D1 * x2 ** 4) / (x2 + x1) ** 4 / x2 / x1 / (0.1D1 + x1) / (0.1D1
     # + x2)
      endif

      if(ieorder.eq.-2)then
        rJ21GGII=e2
      elseif(ieorder.eq.-1)then
        rJ21GGII=e1
      elseif(ieorder.eq.0)then
        rJ21GGII=e0
      endif

*      write(*,*)" rJ21GGII ",rJ21GGII

      return
      end
************************************************************************
*
      function rJ21hGGII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 0
      e1 = -0.1D1 / 0.3D1
      e0 = -dlm / 0.3D1
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0
      e1 = -0.1D1 / omz1 / omz2 / 0.3D1
      e0 = -dlm / omz1 / omz2 / 0.3D1
      endif

      if(ieorder.eq.-2)then
        rJ21hGGII=e2
      elseif(ieorder.eq.-1)then
        rJ21hGGII=e1
      elseif(ieorder.eq.0)then
        rJ21hGGII=e0
      endif

*      write(*,*)" rJ21hGGII ",rJ21hGGII

      return
      end
************************************************************************
*
      function rJ21QQgtoqII1(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21QQgtoqII1=rJ21QQgtoqII2(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -x1 * (-0.1D1 + x1) + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) * d0x
     #2 + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rln2 + rH1(-1, x1) * (-0.1D1 
     #/ 0.2D1 + x1 - x1 ** 2) + rH1(1, x1) * (-0.1D1 / 0.2D1 + x1 - x1 *
     #* 2) + dls * (-0.1D1 / 0.2D1 + x1 - x1 ** 2) + dlm * (0.1D1 / 0.2D
     #1 - x1 + x1 ** 2)
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x1 - x1 ** 2) * d0x2 + (0.1D1 / 0.2D1 - x
     #1 + x1 ** 2) / omz2 * dlm + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2
     # * dls + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2 * rH1(1, z2) + (-0
     #.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2 * rH1(-1, x1) + (0.1D1 / 0.2D1
     # - x1 + x1 ** 2) / omz2 * rln2 + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) *
     # rH1(1, x1) / omz2 - x1 * (-0.1D1 + x1) / omz2
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) * d0x2 - (0.4D1 * x1 ** 5 * 
     #x2 ** 3 + 0.4D1 * x1 ** 4 * x2 ** 4 + 0.2D1 * x1 ** 3 * x2 ** 5 + 
     #0.4D1 * x1 ** 5 * x2 ** 2 + 0.4D1 * x1 ** 4 * x2 ** 3 + 0.2D1 * x1
     # ** 3 * x2 ** 4 + 0.4D1 * x1 ** 5 * x2 + 0.8D1 * x1 ** 4 * x2 ** 2
     # - 0.2D1 * x1 ** 3 * x2 ** 3 - 0.2D1 * x1 ** 2 * x2 ** 4 + 0.2D1 *
     # x1 ** 5 + 0.2D1 * x1 ** 4 * x2 - 0.8D1 * x1 ** 3 * x2 ** 2 - 0.4D
     #1 * x1 ** 2 * x2 ** 3 - 0.2D1 * x1 ** 4 - 0.4D1 * x2 * x1 ** 3 - 0
     #.4D1 * x1 ** 2 * x2 ** 2 + x1 ** 3 - x1 ** 2 * x2 - x2 ** 2 * x1 -
     # x2 ** 3) / (0.1D1 + x2) / (x2 + x1) ** 3 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QQgtoqII1=e2
      elseif(ieorder.eq.-1)then
        rJ21QQgtoqII1=e1
      elseif(ieorder.eq.0)then
        rJ21QQgtoqII1=e0
      endif

*      write(*,*)" rJ21QQgtoqII1 ",rJ21QQgtoqII1

      return
      end
************************************************************************
*
      function rJ21QQgtoqII2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21QQgtoqII2=rJ21QQgtoqII1(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -x2 * (x2 - 0.1D1) + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * d0x1
     # + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rln2 + rH1(-1, x2) * (-0.1D1 /
     # 0.2D1 + x2 - x2 ** 2) + rH1(1, x2) * (-0.1D1 / 0.2D1 + x2 - x2 **
     # 2) + dls * (-0.1D1 / 0.2D1 + x2 - x2 ** 2) + dlm * (0.1D1 / 0.2D1
     # - x2 + x2 ** 2)
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * d0x1 + (0.1D1 / 0.2D1 - x
     #2 + x2 ** 2) / omz1 * dlm + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) / omz1
     # * dls + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * rH1(1, x2) / omz1 + (-0
     #.1D1 / 0.2D1 + x2 - x2 ** 2) * rH1(1, z1) / omz1 + (0.1D1 / 0.2D1 
     #- x2 + x2 ** 2) * rln2 / omz1 - x2 * (x2 - 0.1D1) / omz1 + (-0.1D1
     # / 0.2D1 + x2 - x2 ** 2) * rH1(-1, x2) / omz1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) * d0x1 - (0.2D1 * x1 ** 5 * 
     #x2 ** 3 + 0.4D1 * x1 ** 4 * x2 ** 4 + 0.4D1 * x1 ** 3 * x2 ** 5 + 
     #0.2D1 * x1 ** 4 * x2 ** 3 + 0.4D1 * x1 ** 3 * x2 ** 4 + 0.4D1 * x1
     # ** 2 * x2 ** 5 - 0.2D1 * x1 ** 4 * x2 ** 2 - 0.2D1 * x1 ** 3 * x2
     # ** 3 + 0.8D1 * x1 ** 2 * x2 ** 4 + 0.4D1 * x1 * x2 ** 5 - 0.4D1 *
     # x1 ** 3 * x2 ** 2 - 0.8D1 * x1 ** 2 * x2 ** 3 + 0.2D1 * x1 * x2 *
     #* 4 + 0.2D1 * x2 ** 5 - 0.4D1 * x1 ** 2 * x2 ** 2 - 0.4D1 * x1 * x
     #2 ** 3 - 0.2D1 * x2 ** 4 - x1 ** 3 - x1 ** 2 * x2 - x2 ** 2 * x1 +
     # x2 ** 3) / (0.1D1 + x1) / (x2 + x1) ** 3 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QQgtoqII2=e2
      elseif(ieorder.eq.-1)then
        rJ21QQgtoqII2=e1
      elseif(ieorder.eq.0)then
        rJ21QQgtoqII2=e0
      endif

*      write(*,*)" rJ21QQgtoqII2 ",rJ21QQgtoqII2

      return
      end
************************************************************************
*
      function rJ21QGgtoqII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21QGgtoqII=rJ21GQgtoqII(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -x1 * (-0.1D1 + x1) + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) * d0x
     #2 + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rln2 + rH1(-1, x1) * (-0.1D1 
     #/ 0.2D1 + x1 - x1 ** 2) + rH1(1, x1) * (-0.1D1 / 0.2D1 + x1 - x1 *
     #* 2) + dls * (-0.1D1 / 0.2D1 + x1 - x1 ** 2) + dlm * (0.1D1 / 0.2D
     #1 - x1 + x1 ** 2)
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x1 - x1 ** 2) * d0x2 + (0.1D1 / 0.2D1 - x
     #1 + x1 ** 2) / omz2 * dlm + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2
     # * dls + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2 * rH1(1, z2) + (-0
     #.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2 * rH1(-1, x1) + (0.1D1 / 0.2D1
     # - x1 + x1 ** 2) / omz2 * rln2 + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) *
     # rH1(1, x1) / omz2 - x1 * (-0.1D1 + x1) / omz2
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) * d0x2 - (0.4D1 * x1 ** 6 * 
     #x2 ** 3 + 0.6D1 * x1 ** 4 * x2 ** 5 + 0.8D1 * x1 ** 3 * x2 ** 6 + 
     #0.4D1 * x1 ** 6 * x2 ** 2 + 0.6D1 * x1 ** 4 * x2 ** 4 + 0.8D1 * x1
     # ** 3 * x2 ** 5 + 0.4D1 * x1 ** 6 * x2 + 0.12D2 * x1 ** 5 * x2 ** 
     #2 - 0.10D2 * x1 ** 4 * x2 ** 3 + 0.8D1 * x1 ** 3 * x2 ** 4 + 0.20D
     #2 * x1 ** 2 * x2 ** 5 + 0.2D1 * x1 ** 6 + 0.4D1 * x1 ** 5 * x2 - 0
     #.22D2 * x1 ** 4 * x2 ** 2 + 0.18D2 * x1 ** 2 * x2 ** 4 - 0.2D1 * x
     #1 ** 5 - 0.6D1 * x1 ** 4 * x2 - 0.22D2 * x1 ** 3 * x2 ** 2 + 0.8D1
     # * x1 ** 2 * x2 ** 3 + 0.20D2 * x1 * x2 ** 4 + x1 ** 4 - 0.14D2 * 
     #x2 * x1 ** 3 + 0.10D2 * x1 ** 2 * x2 ** 2 + 0.18D2 * x1 * x2 ** 3 
     #- x2 ** 4 - 0.6D1 * x1 ** 2 * x2 + 0.4D1 * x2 ** 3 - 0.6D1 * x1 **
     # 2 + 0.4D1 * x2 ** 2) / (x2 + x1) ** 4 / (0.1D1 + x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QGgtoqII=e2
      elseif(ieorder.eq.-1)then
        rJ21QGgtoqII=e1
      elseif(ieorder.eq.0)then
        rJ21QGgtoqII=e0
      endif

*      write(*,*)" rJ21QGgtoqII ",rJ21QGgtoqII

      return
      end
************************************************************************
*
      function rJ21GQgtoqII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21GQgtoqII=rJ21QGgtoqII(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -x2 * (x2 - 0.1D1) + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * d0x1
     # + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rln2 + rH1(-1, x2) * (-0.1D1 /
     # 0.2D1 + x2 - x2 ** 2) + rH1(1, x2) * (-0.1D1 / 0.2D1 + x2 - x2 **
     # 2) + dls * (-0.1D1 / 0.2D1 + x2 - x2 ** 2) + dlm * (0.1D1 / 0.2D1
     # - x2 + x2 ** 2)
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * d0x1 + (0.1D1 / 0.2D1 - x
     #2 + x2 ** 2) / omz1 * dlm + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) / omz1
     # * dls + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * rH1(1, x2) / omz1 + (-0
     #.1D1 / 0.2D1 + x2 - x2 ** 2) * rH1(1, z1) / omz1 + (0.1D1 / 0.2D1 
     #- x2 + x2 ** 2) * rln2 / omz1 - x2 * (x2 - 0.1D1) / omz1 + (-0.1D1
     # / 0.2D1 + x2 - x2 ** 2) * rH1(-1, x2) / omz1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) * d0x1 - (0.8D1 * x1 ** 6 * 
     #x2 ** 3 + 0.6D1 * x1 ** 5 * x2 ** 4 + 0.4D1 * x1 ** 3 * x2 ** 6 + 
     #0.8D1 * x1 ** 5 * x2 ** 3 + 0.6D1 * x1 ** 4 * x2 ** 4 + 0.4D1 * x1
     # ** 2 * x2 ** 6 + 0.20D2 * x1 ** 5 * x2 ** 2 + 0.8D1 * x1 ** 4 * x
     #2 ** 3 - 0.10D2 * x1 ** 3 * x2 ** 4 + 0.12D2 * x1 ** 2 * x2 ** 5 +
     # 0.4D1 * x1 * x2 ** 6 + 0.18D2 * x1 ** 4 * x2 ** 2 - 0.22D2 * x1 *
     #* 2 * x2 ** 4 + 0.4D1 * x1 * x2 ** 5 + 0.2D1 * x2 ** 6 + 0.20D2 * 
     #x1 ** 4 * x2 + 0.8D1 * x1 ** 3 * x2 ** 2 - 0.22D2 * x1 ** 2 * x2 *
     #* 3 - 0.6D1 * x1 * x2 ** 4 - 0.2D1 * x2 ** 5 - x1 ** 4 + 0.18D2 * 
     #x2 * x1 ** 3 + 0.10D2 * x1 ** 2 * x2 ** 2 - 0.14D2 * x1 * x2 ** 3 
     #+ x2 ** 4 + 0.4D1 * x1 ** 3 - 0.6D1 * x2 ** 2 * x1 + 0.4D1 * x1 **
     # 2 - 0.6D1 * x2 ** 2) / (x2 + x1) ** 4 / (0.1D1 + x1) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GQgtoqII=e2
      elseif(ieorder.eq.-1)then
        rJ21GQgtoqII=e1
      elseif(ieorder.eq.0)then
        rJ21GQgtoqII=e0
      endif

*      write(*,*)" rJ21GQgtoqII ",rJ21GQgtoqII

      return
      end
************************************************************************
*
      function rJ21QGqtogII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21QGqtogII=rJ21GQqtogII(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 + (x2 *
     #* 2 - 0.2D1 * x2 + 0.2D1) / x2 * dlm / 0.2D1 - (x2 ** 2 - 0.2D1 * 
     #x2 + 0.2D1) / x2 * dls / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / 
     #x2 * rH1(-1, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * r
     #H1(1, x2) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rln2 / 0
     #.2D1 + x2 / 0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 + (x2 *
     #* 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * dlm / 0.2D1 - (x2 ** 2 - 0
     #.2D1 * x2 + 0.2D1) / x2 / omz1 * dls / 0.2D1 - (x2 ** 2 - 0.2D1 * 
     #x2 + 0.2D1) / omz1 / x2 * rH1(-1, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 *
     # x2 + 0.2D1) / omz1 / x2 * rH1(1, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 *
     # x2 + 0.2D1) / omz1 / x2 * rH1(1, z1) / 0.2D1 + (x2 ** 2 - 0.2D1 *
     # x2 + 0.2D1) / omz1 / x2 * rln2 / 0.2D1 + x2 / omz1 / 0.2D1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (0.2D1
     # * x1 ** 2 * x2 ** 4 + 0.2D1 * x1 * x2 ** 4 - x1 ** 2 * x2 ** 2 - 
     #0.2D1 * x1 * x2 ** 3 + x2 ** 4 + 0.2D1 * x1 ** 2 * x2 + 0.2D1 * x2
     # ** 2 * x1 - 0.2D1 * x2 ** 3 - 0.2D1 * x1 ** 2 + 0.4D1 * x1 * x2 +
     # 0.2D1 * x2 ** 2 - 0.4D1 * x1) / x2 / (0.1D1 + x1) / (x2 + x1) ** 
     #2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21QGqtogII=e2
      elseif(ieorder.eq.-1)then
        rJ21QGqtogII=e1
      elseif(ieorder.eq.0)then
        rJ21QGqtogII=e0
      endif

*      write(*,*)" rJ21QGqtogII ",rJ21QGqtogII

      return
      end
************************************************************************
*
      function rJ21GQqtogII(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21GQqtogII=rJ21QGqtogII(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0x2 / 0.2D1 + (x1 *
     #* 2 - 0.2D1 * x1 + 0.2D1) / x1 * dlm / 0.2D1 - (x1 ** 2 - 0.2D1 * 
     #x1 + 0.2D1) / x1 * dls / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / 
     #x1 * rH1(-1, x1) / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * r
     #H1(1, x1) / 0.2D1 + (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * rln2 / 0
     #.2D1 + x1 / 0.2D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0x2 / 0.2D1 + (x1 *
     #* 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * dlm / 0.2D1 - (x1 ** 2 - 0
     #.2D1 * x1 + 0.2D1) / x1 / omz2 * dls / 0.2D1 - (x1 ** 2 - 0.2D1 * 
     #x1 + 0.2D1) / omz2 / x1 * rH1(-1, x1) / 0.2D1 - (x1 ** 2 - 0.2D1 *
     # x1 + 0.2D1) / omz2 / x1 * rH1(1, x1) / 0.2D1 - (x1 ** 2 - 0.2D1 *
     # x1 + 0.2D1) / omz2 / x1 * rH1(1, z2) / 0.2D1 + (x1 ** 2 - 0.2D1 *
     # x1 + 0.2D1) / omz2 / x1 * rln2 / 0.2D1 + x1 / omz2 / 0.2D1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0x2 / 0.2D1 - (0.2D1
     # * x1 ** 4 * x2 ** 2 + 0.2D1 * x1 ** 4 * x2 + x1 ** 4 - 0.2D1 * x2
     # * x1 ** 3 - x1 ** 2 * x2 ** 2 - 0.2D1 * x1 ** 3 + 0.2D1 * x1 ** 2
     # * x2 + 0.2D1 * x2 ** 2 * x1 + 0.2D1 * x1 ** 2 + 0.4D1 * x1 * x2 -
     # 0.2D1 * x2 ** 2 - 0.4D1 * x2) / x1 / (0.1D1 + x2) / (x2 + x1) ** 
     #2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GQqtogII=e2
      elseif(ieorder.eq.-1)then
        rJ21GQqtogII=e1
      elseif(ieorder.eq.0)then
        rJ21GQqtogII=e0
      endif

*      write(*,*)" rJ21GQqtogII ",rJ21GQqtogII

      return
      end
************************************************************************
*
      function rJ21GGqtogII1(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21GGqtogII1=rJ21GGqtogII2(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0x2 / 0.2D1 + (x1 *
     #* 2 - 0.2D1 * x1 + 0.2D1) / x1 * dlm / 0.2D1 - (x1 ** 2 - 0.2D1 * 
     #x1 + 0.2D1) / x1 * dls / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / 
     #x1 * rH1(-1, x1) / 0.2D1 - (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * r
     #H1(1, x1) / 0.2D1 + (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * rln2 / 0
     #.2D1 + x1 / 0.2D1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -(x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0x2 / 0.2D1 + (x1 *
     #* 2 - 0.2D1 * x1 + 0.2D1) / x1 / omz2 * dlm / 0.2D1 - (x1 ** 2 - 0
     #.2D1 * x1 + 0.2D1) / x1 / omz2 * dls / 0.2D1 - (x1 ** 2 - 0.2D1 * 
     #x1 + 0.2D1) / omz2 / x1 * rH1(-1, x1) / 0.2D1 - (x1 ** 2 - 0.2D1 *
     # x1 + 0.2D1) / omz2 / x1 * rH1(1, x1) / 0.2D1 - (x1 ** 2 - 0.2D1 *
     # x1 + 0.2D1) / omz2 / x1 * rH1(1, z2) / 0.2D1 + (x1 ** 2 - 0.2D1 *
     # x1 + 0.2D1) / omz2 / x1 * rln2 / 0.2D1 + x1 / omz2 / 0.2D1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (x1 ** 2 - 0.2D1 * x1 + 0.2D1) / x1 * d0x2 / 0.2D1 - (0.2D1
     # * x1 ** 5 * x2 ** 2 + 0.2D1 * x1 ** 5 * x2 + x1 ** 5 - x1 ** 4 * 
     #x2 - 0.7D1 * x1 ** 3 * x2 ** 2 - x1 ** 2 * x2 ** 3 - 0.2D1 * x1 **
     # 4 - 0.4D1 * x2 * x1 ** 3 + 0.4D1 * x1 ** 2 * x2 ** 2 + 0.2D1 * x1
     # * x2 ** 3 + 0.2D1 * x1 ** 3 + 0.4D1 * x1 ** 2 * x2 + 0.2D1 * x2 *
     #* 2 * x1 - 0.2D1 * x2 ** 3 - 0.2D1 * x1 ** 2 - 0.4D1 * x1 * x2 - 0
     #.4D1 * x2 ** 2) / x1 / (0.1D1 + x2) / (x2 + x1) ** 3 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogII1=e2
      elseif(ieorder.eq.-1)then
        rJ21GGqtogII1=e1
      elseif(ieorder.eq.0)then
        rJ21GGqtogII1=e0
      endif

*      write(*,*)" rJ21GGqtogII1 ",rJ21GGqtogII1

      return
      end
************************************************************************
*
      function rJ21GGqtogII2(ix,x1,x2,i1,i2,ipset,renscale2,facscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        rJ21GGqtogII2=rJ21GGqtogII1(ix,x1,x2,i2,i1,ipset,renscale2,facscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      dlm=log(renscale2/facscale2)
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 + (x2 *
     #* 2 - 0.2D1 * x2 + 0.2D1) / x2 * dlm / 0.2D1 - (x2 ** 2 - 0.2D1 * 
     #x2 + 0.2D1) / x2 * dls / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / 
     #x2 * rH1(-1, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * r
     #H1(1, x2) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rln2 / 0
     #.2D1 + x2 / 0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 + (x2 *
     #* 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * dlm / 0.2D1 - (x2 ** 2 - 0
     #.2D1 * x2 + 0.2D1) / x2 / omz1 * dls / 0.2D1 - (x2 ** 2 - 0.2D1 * 
     #x2 + 0.2D1) / omz1 / x2 * rH1(-1, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 *
     # x2 + 0.2D1) / omz1 / x2 * rH1(1, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 *
     # x2 + 0.2D1) / omz1 / x2 * rH1(1, z1) / 0.2D1 + (x2 ** 2 - 0.2D1 *
     # x2 + 0.2D1) / omz1 / x2 * rln2 / 0.2D1 + x2 / omz1 / 0.2D1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 + (-0.2D
     #1 * x1 ** 2 * x2 ** 5 - 0.2D1 * x1 * x2 ** 5 + x1 ** 3 * x2 ** 2 +
     # 0.7D1 * x1 ** 2 * x2 ** 3 + x1 * x2 ** 4 - x2 ** 5 - 0.2D1 * x2 *
     # x1 ** 3 - 0.4D1 * x1 ** 2 * x2 ** 2 + 0.4D1 * x1 * x2 ** 3 + 0.2D
     #1 * x2 ** 4 + 0.2D1 * x1 ** 3 - 0.2D1 * x1 ** 2 * x2 - 0.4D1 * x2 
     #** 2 * x1 - 0.2D1 * x2 ** 3 + 0.4D1 * x1 ** 2 + 0.4D1 * x1 * x2 + 
     #0.2D1 * x2 ** 2) / x2 / (0.1D1 + x1) / (x2 + x1) ** 3 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        rJ21GGqtogII2=e2
      elseif(ieorder.eq.-1)then
        rJ21GGqtogII2=e1
      elseif(ieorder.eq.0)then
        rJ21GGqtogII2=e0
      endif

*      write(*,*)" rJ21GGqtogII2 ",rJ21GGqtogII2

      return
      end
