****************************************************
* FullEh31FF(i1,i2,i3,ipset,renscale) i.e. for i2 soft
      function FullEh31FF(i1,i2,i3,ipset,renscale)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      FullE30=FullE30FF(i1,i2,i3,ipset)
      y12=s12/s123
      y13=s13/s123
      y23=s23/s123

      FullEh31FF=
     . -4d0*(xIqgFone(s123,renscale))*FullE30

      if(ieorder.eq.0)then
      FullEh31FF=FullEh31FF
     . +(-10d0/9d0+2d0/3d0*rH1(0,abs(y23)))*FullE30
     .  -2d0/6d0*log(renscale/abs(s123))*FullE30
      endif
*      write(*,*)" FullEh31FF ",FullEh31FF
      return
      end
************************************************************************
