****************************************************
* FullG31FF(i1,i2,i3,ipset,renscale) i.e. for i2 soft
      function FullG31FF(i1,i2,i3,ipset,renscale)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      G30=FullG30FF(i1,i2,i3,ipset)
      y12=s12/s123
      y13=s13/s123
      y23=s23/s123

      FullG31FF=
     . 2d0*(xIqgone(s12,renscale)
     .     +xIqgone(s13,renscale)
     . -2d0*xIggone(s123,renscale))*G30

      if(ieorder.eq.0)then
      FullG31FF=FullG31FF
     .  -(rr(y12,y23)+rr(y13,y23)
     .   +5d0/3d0*rH1(0,abs(y12))
     .   +5d0/3d0*rH1(0,abs(y13))
     .  +13d0/6d0*rH1(0,abs(y23))-40d0/9d0)*G30
     .  -(s12+s13)/2d0/s123**2
     .  +11d0/6d0*log(renscale/abs(s123))*G30
      endif
*      write(*,*)" FullG31FF ",FullG31FF
      return
      end
************************************************************************
