****************************************************
*The full D40 antenna.  quark i1, gluons i2,i3,i4 can become unresolved

      function FullD40(i1,i2,i3,i4,ipset)
      use KinData_mod
      implicit real*8(a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34

      s1234=s12+s13+s14+s23+s24+s34

      d40 =  + s123**(-2)*s1234**(-2)*S12**(-1) * (
     &     + s23*s34**2
     &     + 2.D0*s23*s24*s34
     &     + s23*s24**2
     &     + 2.D0*s14*s23*s34
     &     + 2.D0*s14*s23*s24
     &     + s14**2*s23
     &     )
      d40 = d40 + s123**(-2)*s1234**(-2)*S23**(-2) * (
     &     + 2.D0*s13**2*s34**2
     &     + 4.D0*s13**2*s24*s34
     &     + 2.D0*s13**2*s24**2
     &     + 4.D0*s13**2*s14*s34
     &     + 4.D0*s13**2*s14*s24
     &     + 2.D0*s13**2*s14**2
     &     )
      d40 = d40 + s123**(-2)*s1234**(-2) * (
     &     + s34**2
     &     + 2.D0*s24*s34
     &     + s24**2
     &     + 2.D0*s14*s34
     &     + 2.D0*s14*s24
     &     + s14**2
     &     )
      d40 = d40 + s123**(-1)*s124**(-1)*s1234**(-2)*S14**(-1)*S23**(-1)
     &  * (
     &     + s24*s34**3
     &     + 3.D0*s24**2*s34**2
     &     + 3.D0*s24**3*s34
     &     + s24**4
     &     )
      d40 = d40 + s123**(-1)*s124**(-1)*s1234**(-2)*S14**(-1) * (
     &     - 3.D0*s24*s34**2
     &     - 6.D0*s24**2*s34
     &     - 3.D0*s24**3
     &     + 3.D0*s23*s24*s34
     &     + 3.D0*s23*s24**2
     &     - s23**2*s24
     &     )
      d40 = d40 + s123**(-1)*s124**(-1)*s1234**(-2)*S23**(-1) * (
     &     + s34**3
     &     + 6.D0*s24*s34**2
     &     + 9.D0*s24**2*s34
     &     + 4.D0*s24**3
     &     + 3.D0*s14*s34**2
     &     + 9.D0*s14*s24*s34
     &     + 6.D0*s14*s24**2
     &     + 3.D0*s14**2*s34
     &     + 5.D0*s14**2*s24
     &     + 2.D0*s14**3
     &     )
      d40 = d40 + s123**(-1)*s124**(-1)*s1234**(-2) * (
     &     - 9.D0*s24*s34
     &     - 9.D0*s24**2
     &     + 6.D0*s23*s24
     &     - s23**2
     &     - 9.D0*s14*s24
     &     + 3.D0*s14*s23
     &     - 3.D0*s14**2
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2)*S12**(-1)*S14**(-1)
     &  * (
     &     + s24**3*s34
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2)*S12**(-1)*S34**(-1)
     &  * (
     &     + s14*s24**3
     &     + 3.D0*s14**2*s24**2
     &     + 3.D0*s14**3*s24
     &     + s14**4
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 3.D0*s24**2*s34
     &     + 2.D0*s24**3
     &     + 3.D0*s14*s24*s34
     &     + 6.D0*s14*s24**2
     &     + s14**2*s34
     &     + 6.D0*s14**2*s24
     &     + 2.D0*s14**3
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2)*S14**(-1)*S23**(-1)
     &  * (
     &     + s34**4
     &     + 3.D0*s24*s34**3
     &     + 3.D0*s24**2*s34**2
     &     + s24**3*s34
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2)*S14**(-1) * (
     &     - 2.D0*s34**3
     &     - 3.D0*s24*s34**2
     &     + s23*s34**2
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2)*S23**(-1)*S34**(-1)
     &  * (
     &     + s14*s24**3
     &     + 3.D0*s14**2*s24**2
     &     + 3.D0*s14**3*s24
     &     + 2.D0*s14**4
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 5.D0*s34**3
     &     + 12.D0*s24*s34**2
     &     + 9.D0*s24**2*s34
     &     + 2.D0*s24**3
     &     + 10.D0*s14*s34**2
     &     + 18.D0*s14*s24*s34
     &     + 9.D0*s14*s24**2
     &     + 11.D0*s14**2*s34
     &     + 12.D0*s14**2*s24
     &     + 7.D0*s14**3
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2)*S34**(-1) * (
     &     + s14**2*s23
     &     - 2.D0*s14**3
     &     )
      d40 = d40 + s123**(-1)*s134**(-1)*s1234**(-2) * (
     &     - 8.D0*s34**2
     &     - 6.D0*s24*s34
     &     + 3.D0*s23*s34
     &     - 12.D0*s14*s34
     &     - 3.D0*s14*s24
     &     + 3.D0*s14*s23
     &     - 8.D0*s14**2
     &     )
      d40 = d40 + s123**(-1)*s234**(-1)*s1234**(-2)*S12**(-1)*S34**(-1)
     &  * (
     &     + s24**4
     &     + 5.D0*s14*s24**3
     &     + 9.D0*s14**2*s24**2
     &     + 7.D0*s14**3*s24
     &     + 2.D0*s14**4
     &     )
      d40 = d40 + s123**(-1)*s234**(-1)*s1234**(-2)*S12**(-1) * (
     &     + s24*s34**2
     &     + 3.D0*s24**2*s34
     &     + 3.D0*s24**3
     &     + s14*s34**2
     &     + 6.D0*s14*s24*s34
     &     + 9.D0*s14*s24**2
     &     + 3.D0*s14**2*s34
     &     + 9.D0*s14**2*s24
     &     + 3.D0*s14**3
     &     )
      d40 = d40 + s123**(-1)*s234**(-1)*s1234**(-2)*S23**(-2) * (
     &     - 4.D0*s13*s14**2*s34
     &     )
      d40 = d40 + s123**(-1)*s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     - 2.D0*s14*s34**2
     &     - 8.D0*s14**3
     &     - 2.D0*s13*s14*s34
     &     - 4.D0*s13*s14**2
     &     - 8.D0*s13**2*s14
     &     )
      d40 = d40 + s123**(-1)*s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     - s24**3
     &     - 4.D0*s14*s24**2
     &     - 6.D0*s14**2*s24
     &     - 4.D0*s14**3
     &     - 2.D0*s13*s24**2
     &     - 4.D0*s13*s14*s24
     &     - 6.D0*s13*s14**2
     &     + s13**2*s24
     &     - 4.D0*s13**2*s14
     &     - 2.D0*s13**3
     &     )
      d40 = d40 + s123**(-1)*s234**(-1)*s1234**(-2) * (
     &     + s34**2
     &     + s24*s34
     &     - s24**2
     &     + 2.D0*s14*s34
     &     + s14*s24
     &     + 6.D0*s14**2
     &     - 3.D0*s13*s34
     &     - 5.D0*s13*s24
     &     - 10.D0*s13*s14
     &     + 3.D0*s13**2
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S12**(-1)*S14**(-1) * (
     &     - s24**3
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     - s24**3
     &     + s23*s24**2
     &     - 4.D0*s14*s24**2
     &     + 2.D0*s14*s23*s24
     &     - 5.D0*s14**2*s24
     &     + s14**2*s23
     &     - 2.D0*s14**3
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S12**(-1) * (
     &     - 2.D0*s34**2
     &     - 5.D0*s24*s34
     &     - 7.D0*s24**2
     &     + 3.D0*s23*s34
     &     + 4.D0*s23*s24
     &     - 6.D0*s14*s34
     &     - 13.D0*s14*s24
     &     + 4.D0*s14*s23
     &     - 7.D0*s14**2
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     - 2.D0*s34**3
     &     - 6.D0*s24*s34**2
     &     - 6.D0*s24**2*s34
     &     - 2.D0*s24**3
     &     - s13*s34**2
     &     + s13*s24**2
     &     - 2.D0*s13**2*s34
     &     - 2.D0*s13**2*s24
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S14**(-1) * (
     &     + 2.D0*s34**2
     &     + 6.D0*s24*s34
     &     + 2.D0*s24**2
     &     - s23*s34
     &     - s23*s24
     &     - 2.D0*s13*s34
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S23**(-2) * (
     &     - 4.D0*s13*s34**2
     &     - 4.D0*s13*s24*s34
     &     - 8.D0*s13*s14*s34
     &     + 4.D0*s13**2*s34
     &     + 4.D0*s13**2*s24
     &     + 4.D0*s13**2*s14
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S23**(-1)*S34**(-1) * (
     &     + s14**2*s24
     &     + 2.D0*s13*s14*s24
     &     + 4.D0*s13*s14**2
     &     + s13**2*s24
     &     + 2.D0*s13**2*s14
     &     + 2.D0*s13**3
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S23**(-1) * (
     &     - 10.D0*s34**2
     &     - 19.D0*s24*s34
     &     - 11.D0*s24**2
     &     - 18.D0*s14*s34
     &     - 21.D0*s14*s24
     &     - 21.D0*s14**2
     &     - 3.D0*s13*s34
     &     + 5.D0*s13*s24
     &     + 2.D0*s13*s14
     &     - 7.D0*s13**2
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2)*S34**(-1) * (
     &     + s24**2
     &     + 2.D0*s14*s24
     &     - s14*s23
     &     + 3.D0*s14**2
     &     + s13*s24
     &     - 2.D0*s13*s14
     &     )
      d40 = d40 + s123**(-1)*s1234**(-2) * (
     &     + 9.D0*s34
     &     + 11.D0*s24
     &     - 3.D0*s23
     &     + 12.D0*s14
     &     - 3.D0*s13
     &     )
      d40 = d40 + s124**(-2)*s1234**(-2)*S12**(-1) * (
     &     + s24*s34**2
     &     + 2.D0*s23*s24*s34
     &     + s23**2*s24
     &     + 2.D0*s13*s24*s34
     &     + 2.D0*s13*s23*s24
     &     + s13**2*s24
     &     )
      d40 = d40 + s124**(-2)*s1234**(-2)*S14**(-1) * (
     &     + s24*s34**2
     &     + 2.D0*s23*s24*s34
     &     + s23**2*s24
     &     + 2.D0*s13*s24*s34
     &     + 2.D0*s13*s23*s24
     &     + s13**2*s24
     &     )
      d40 = d40 + s124**(-2)*s1234**(-2) * (
     &     + 2.D0*s34**2
     &     + 4.D0*s23*s34
     &     + 2.D0*s23**2
     &     + 4.D0*s13*s34
     &     + 4.D0*s13*s23
     &     + 2.D0*s13**2
     &     )
      d40 = d40 + s124**(-1)*s134**(-1)*s1234**(-2)*S12**(-1)*S34**(-1)
     &  * (
     &     + s24**4
     &     + 3.D0*s23*s24**3
     &     + 3.D0*s23**2*s24**2
     &     + s23**3*s24
     &     )
      d40 = d40 + s124**(-1)*s134**(-1)*s1234**(-2)*S12**(-1) * (
     &     - s24*s34**2
     &     + 3.D0*s24**2*s34
     &     - 3.D0*s24**3
     &     + 3.D0*s23*s24*s34
     &     - 6.D0*s23*s24**2
     &     - 3.D0*s23**2*s24
     &     )
      d40 = d40 + s124**(-1)*s134**(-1)*s1234**(-2)*S34**(-1) * (
     &     + s24**3
     &     + 3.D0*s23*s24**2
     &     + 3.D0*s23**2*s24
     &     + s23**3
     &     - 2.D0*s14*s24**2
     &     - 3.D0*s14*s23*s24
     &     - 3.D0*s14*s23**2
     &     - s14**2*s24
     &     + 3.D0*s14**2*s23
     &     - 2.D0*s14**3
     &     )
      d40 = d40 + s124**(-1)*s134**(-1)*s1234**(-2) * (
     &     - s34**2
     &     + 3.D0*s24*s34
     &     - 3.D0*s24**2
     &     - 9.D0*s23*s24
     &     - 3.D0*s14*s34
     &     + 3.D0*s14*s24
     &     - 3.D0*s14**2
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2)*S12**(-1)*S23**(-1)
     &  * (
     &     + s13*s34**3
     &     + 3.D0*s13**2*s34**2
     &     + 3.D0*s13**3*s34
     &     + 2.D0*s13**4
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2)*S12**(-1)*S34**(-1)
     &  * (
     &     + s24**4
     &     - 5.D0*s13*s24**3
     &     + 9.D0*s13**2*s24**2
     &     - 7.D0*s13**3*s24
     &     + 2.D0*s13**4
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2)*S12**(-1) * (
     &     + s13*s34**2
     &     - 2.D0*s13*s24*s34
     &     - s13*s24**2
     &     + 3.D0*s13**2*s34
     &     + 3.D0*s13**3
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2)*S14**(-1)*S23**(-1)
     &  * (
     &     + s34**4
     &     + 5.D0*s13*s34**3
     &     + 9.D0*s13**2*s34**2
     &     + 7.D0*s13**3*s34
     &     + 2.D0*s13**4
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2)*S14**(-1)*S34**(-1)
     &  * (
     &     - s13*s24**3
     &     + 3.D0*s13**2*s24**2
     &     - 3.D0*s13**3*s24
     &     + 2.D0*s13**4
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2)*S14**(-1) * (
     &     + s34**3
     &     - s24*s34**2
     &     + s24**2*s34
     &     - s24**3
     &     + 5.D0*s13*s34**2
     &     - 4.D0*s13*s24*s34
     &     + 4.D0*s13*s24**2
     &     + 9.D0*s13**2*s34
     &     - 6.D0*s13**2*s24
     &     + 7.D0*s13**3
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     - 3.D0*s34**3
     &     + 3.D0*s14*s34**2
     &     - 2.D0*s14**2*s34
     &     - 8.D0*s13*s34**2
     &     + 4.D0*s13*s14*s34
     &     - 6.D0*s13**2*s34
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 2.D0*s24**3
     &     + s14*s24**2
     &     + 2.D0*s14**2*s24
     &     - 4.D0*s13*s24**2
     &     + 4.D0*s13*s14*s24
     &     + 6.D0*s13**2*s24
     &     )
      d40 = d40 + s124**(-1)*s234**(-1)*s1234**(-2) * (
     &     - 3.D0*s34**2
     &     + 3.D0*s24*s34
     &     - 3.D0*s24**2
     &     + 3.D0*s14*s34
     &     - 3.D0*s14*s24
     &     - 2.D0*s14**2
     &     - 8.D0*s13*s34
     &     + 10.D0*s13*s24
     &     + 4.D0*s13*s14
     &     - 2.D0*s13**2
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2)*S12**(-1)*S23**(-1) * (
     &     + s13**3
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 4.D0*s23*s24**2
     &     + 3.D0*s23**2*s24
     &     + s23**3
     &     + 6.D0*s13*s24**2
     &     + 4.D0*s13*s23**2
     &     - 7.D0*s13**2*s24
     &     + 7.D0*s13**2*s23
     &     + 6.D0*s13**3
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2)*S12**(-1) * (
     &     - s34**2
     &     + 3.D0*s24*s34
     &     - s24**2
     &     - 2.D0*s23*s34
     &     - s23*s24
     &     - s13*s24
     &     + 2.D0*s13*s23
     &     + 6.D0*s13**2
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     + 4.D0*s24*s34**2
     &     + 3.D0*s24**2*s34
     &     + s24**3
     &     - s13*s34**2
     &     + 5.D0*s13*s24*s34
     &     + s13*s24**2
     &     - 2.D0*s13**2*s34
     &     + 2.D0*s13**2*s24
     &     - s13**3
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2)*S14**(-1)*S34**(-1) * (
     &     + s13*s24**2
     &     - s13*s23*s24
     &     + s13*s23**2
     &     - 3.D0*s13**2*s24
     &     + 3.D0*s13**2*s23
     &     + 4.D0*s13**3
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2)*S14**(-1) * (
     &     - s24*s34
     &     - s24**2
     &     - 2.D0*s23*s34
     &     + 3.D0*s23*s24
     &     - s23**2
     &     + 2.D0*s13*s34
     &     - 2.D0*s13*s24
     &     + 6.D0*s13**2
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 6.D0*s34**2
     &     + 5.D0*s24*s34
     &     + 3.D0*s24**2
     &     + s14*s34
     &     + 3.D0*s14*s24
     &     + 2.D0*s14**2
     &     + 9.D0*s13*s34
     &     + s13*s24
     &     + 4.D0*s13**2
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 4.D0*s23*s24
     &     + 3.D0*s23**2
     &     - 4.D0*s14*s23
     &     + 5.D0*s13*s24
     &     + s13*s23
     &     - 4.D0*s13*s14
     &     - 2.D0*s13**2
     &     )
      d40 = d40 + s124**(-1)*s1234**(-2) * (
     &     + 7.D0*s34
     &     - 4.D0*s24
     &     + 7.D0*s23
     &     + 4.D0*s13
     &     )
      d40 = d40 + s134**(-2)*s1234**(-2)*S14**(-1) * (
     &     + s24**2*s34
     &     + 2.D0*s23*s24*s34
     &     + s23**2*s34
     &     + 2.D0*s12*s24*s34
     &     + 2.D0*s12*s23*s34
     &     + s12**2*s34
     &     )
      d40 = d40 + s134**(-2)*s1234**(-2)*S34**(-2) * (
     &     + 2.D0*s14**2*s24**2
     &     + 4.D0*s14**2*s23*s24
     &     + 2.D0*s14**2*s23**2
     &     + 4.D0*s12*s14**2*s24
     &     + 4.D0*s12*s14**2*s23
     &     + 2.D0*s12**2*s14**2
     &     )
      d40 = d40 + s134**(-2)*s1234**(-2)*S34**(-1) * (
     &     + 4.D0*s14*s24**2
     &     + 8.D0*s14*s23*s24
     &     + 4.D0*s14*s23**2
     &     + 8.D0*s12*s14*s24
     &     + 8.D0*s12*s14*s23
     &     + 4.D0*s12**2*s14
     &     )
      d40 = d40 + s134**(-2)*s1234**(-2) * (
     &     + 3.D0*s24**2
     &     + 6.D0*s23*s24
     &     + 3.D0*s23**2
     &     + 6.D0*s12*s24
     &     + 6.D0*s12*s23
     &     + 3.D0*s12**2
     &     )
      d40 = d40 + s134**(-1)*s234**(-1)*s1234**(-2)*S14**(-1)*S23**(-1)
     &  * (
     &     + s34**4
     &     - 5.D0*s12*s34**3
     &     + 9.D0*s12**2*s34**2
     &     - 7.D0*s12**3*s34
     &     + 2.D0*s12**4
     &     )
      d40 = d40 + s134**(-1)*s234**(-1)*s1234**(-2)*S14**(-1) * (
     &     + s34**3
     &     - 4.D0*s12*s34**2
     &     + s12*s24*s34
     &     - s12*s24**2
     &     + 6.D0*s12**2*s34
     &     - 3.D0*s12**2*s24
     &     - 4.D0*s12**3
     &     )
      d40 = d40 + s134**(-1)*s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 4.D0*s34**3
     &     + 6.D0*s14*s34**2
     &     + 5.D0*s14**2*s34
     &     + 2.D0*s14**3
     &     - 12.D0*s12*s34**2
     &     - 12.D0*s12*s14*s34
     &     - 4.D0*s12*s14**2
     &     + 12.D0*s12**2*s34
     &     + 6.D0*s12**2*s14
     &     - 4.D0*s12**3
     &     )
      d40 = d40 + s134**(-1)*s234**(-1)*s1234**(-2)*S34**(-2) * (
     &     - 4.D0*s12**2*s14*s24
     &     )
      d40 = d40 + s134**(-1)*s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     - 2.D0*s12*s24**2
     &     - 2.D0*s12*s14*s24
     &     - 8.D0*s12*s14**2
     &     - 4.D0*s12**2*s24
     &     - 8.D0*s12**3
     &     )
      d40 = d40 + s134**(-1)*s234**(-1)*s1234**(-2) * (
     &     + 3.D0*s34**2
     &     + 3.D0*s14*s34
     &     + 2.D0*s14**2
     &     - 12.D0*s12*s34
     &     - 3.D0*s12*s24
     &     - 12.D0*s12*s14
     &     + 12.D0*s12**2
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     - s24**3
     &     - 3.D0*s23*s24**2
     &     - 3.D0*s23**2*s24
     &     - s23**3
     &     + 2.D0*s14*s24**2
     &     + 3.D0*s14*s23*s24
     &     + 2.D0*s14*s23**2
     &     + s14**2*s24
     &     - s14**2*s23
     &     + s14**3
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2)*S12**(-1) * (
     &     - 3.D0*s24*s34
     &     + 4.D0*s24**2
     &     - s23*s34
     &     + 6.D0*s23*s24
     &     + 2.D0*s23**2
     &     - s14*s24
     &     - 2.D0*s14*s23
     &     + s14**2
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     + 4.D0*s24*s34**2
     &     + 3.D0*s24**2*s34
     &     + s24**3
     &     + 6.D0*s12*s34**2
     &     + 4.D0*s12*s24**2
     &     - 7.D0*s12**2*s34
     &     + 7.D0*s12**2*s24
     &     + 6.D0*s12**3
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2)*S14**(-1) * (
     &     - s34**2
     &     + 3.D0*s24*s34
     &     - 2.D0*s24**2
     &     + 3.D0*s23*s34
     &     - 4.D0*s23*s24
     &     - 2.D0*s23**2
     &     + 3.D0*s12*s34
     &     - 5.D0*s12*s24
     &     - 5.D0*s12*s23
     &     - 3.D0*s12**2
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2)*S23**(-1)*S34**(-1) * (
     &     + s24**3
     &     + 3.D0*s14*s24**2
     &     + 4.D0*s14**2*s24
     &     + 3.D0*s12*s24**2
     &     + s12*s14*s24
     &     + 4.D0*s12*s14**2
     &     + 4.D0*s12**2*s24
     &     - 2.D0*s12**2*s14
     &     + 2.D0*s12**3
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 12.D0*s24*s34
     &     + 6.D0*s24**2
     &     + 12.D0*s14*s24
     &     + 14.D0*s12*s34
     &     + 2.D0*s12*s24
     &     + 13.D0*s12*s14
     &     - 6.D0*s12**2
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2)*S34**(-2) * (
     &     - 4.D0*s14*s24**2
     &     - 4.D0*s14*s23*s24
     &     + 4.D0*s14**2*s24
     &     + 4.D0*s14**2*s23
     &     - 8.D0*s12*s14*s24
     &     + 4.D0*s12*s14**2
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2)*S34**(-1) * (
     &     - 6.D0*s24**2
     &     - 8.D0*s23*s24
     &     - 3.D0*s23**2
     &     + 8.D0*s14*s24
     &     + 11.D0*s14*s23
     &     - 4.D0*s14**2
     &     - 15.D0*s12*s24
     &     - 11.D0*s12*s23
     &     + 9.D0*s12*s14
     &     - 14.D0*s12**2
     &     )
      d40 = d40 + s134**(-1)*s1234**(-2) * (
     &     - 5.D0*s34
     &     + 7.D0*s24
     &     + 14.D0*s23
     &     - 8.D0*s14
     &     + 14.D0*s12
     &     )
      d40 = d40 + s234**(-2)*s1234**(-2)*S23**(-2) * (
     &     + 2.D0*s14**2*s34**2
     &     + 4.D0*s13*s14*s34**2
     &     + 2.D0*s13**2*s34**2
     &     + 4.D0*s12*s14*s34**2
     &     + 4.D0*s12*s13*s34**2
     &     + 2.D0*s12**2*s34**2
     &     )
      d40 = d40 + s234**(-2)*s1234**(-2)*S23**(-1) * (
     &     + 4.D0*s14**2*s34
     &     + 8.D0*s13*s14*s34
     &     + 4.D0*s13**2*s34
     &     + 8.D0*s12*s14*s34
     &     + 8.D0*s12*s13*s34
     &     + 4.D0*s12**2*s34
     &     )
      d40 = d40 + s234**(-2)*s1234**(-2)*S34**(-2) * (
     &     + 2.D0*s14**2*s24**2
     &     + 4.D0*s13*s14*s24**2
     &     + 2.D0*s13**2*s24**2
     &     + 4.D0*s12*s14*s24**2
     &     + 4.D0*s12*s13*s24**2
     &     + 2.D0*s12**2*s24**2
     &     )
      d40 = d40 + s234**(-2)*s1234**(-2) * (
     &     + 4.D0*s14**2
     &     + 8.D0*s13*s14
     &     + 4.D0*s13**2
     &     + 8.D0*s12*s14
     &     + 8.D0*s12*s13
     &     + 4.D0*s12**2
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S12**(-1)*S23**(-1) * (
     &     + s14*s34**2
     &     - 2.D0*s14**2*s34
     &     + 2.D0*s14**3
     &     + s13*s34**2
     &     + s13*s14*s34
     &     + 4.D0*s13*s14**2
     &     + 3.D0*s13**2*s34
     &     + 6.D0*s13**2*s14
     &     + 4.D0*s13**3
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 6.D0*s14*s24**2
     &     + 7.D0*s14**2*s24
     &     + 6.D0*s14**3
     &     + 6.D0*s13*s24**2
     &     + 10.D0*s13*s14**2
     &     - 7.D0*s13**2*s24
     &     + 10.D0*s13**2*s14
     &     + 6.D0*s13**3
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S12**(-1) * (
     &     + s24*s34
     &     + 2.D0*s24**2
     &     + 2.D0*s14*s34
     &     + 4.D0*s14*s24
     &     + s14**2
     &     + 2.D0*s13*s34
     &     + 2.D0*s13*s24
     &     + 2.D0*s13*s14
     &     + s13**2
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     + 6.D0*s13*s34**2
     &     + 7.D0*s13**2*s34
     &     + 6.D0*s13**3
     &     + 6.D0*s12*s34**2
     &     + 10.D0*s12*s13**2
     &     - 7.D0*s12**2*s34
     &     + 10.D0*s12**2*s13
     &     + 6.D0*s12**3
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S14**(-1)*S34**(-1) * (
     &     + s13*s24**2
     &     - 3.D0*s13**2*s24
     &     + 4.D0*s13**3
     &     + s12*s24**2
     &     - s12*s13*s24
     &     + 6.D0*s12*s13**2
     &     + 2.D0*s12**2*s24
     &     + 4.D0*s12**2*s13
     &     + 2.D0*s12**3
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S14**(-1) * (
     &     - s24*s34
     &     + s24**2
     &     + 5.D0*s13*s34
     &     - 4.D0*s13*s24
     &     + 5.D0*s13**2
     &     + 5.D0*s12*s34
     &     - 2.D0*s12*s24
     &     + s12*s13
     &     - 4.D0*s12**2
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S23**(-2) * (
     &     + 4.D0*s14*s34**2
     &     + 4.D0*s13*s34**2
     &     - 8.D0*s13*s14*s34
     &     - 4.D0*s13**2*s34
     &     + 4.D0*s12*s34**2
     &     - 4.D0*s12*s13*s34
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     - 5.D0*s34**2
     &     + 8.D0*s14*s34
     &     - 16.D0*s14**2
     &     + 5.D0*s13*s34
     &     - 10.D0*s13*s14
     &     - 8.D0*s13**2
     &     + 17.D0*s12*s34
     &     - 10.D0*s12*s14
     &     - 12.D0*s12*s13
     &     - 12.D0*s12**2
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S34**(-2) * (
     &     + 4.D0*s14*s24**2
     &     - 4.D0*s14**2*s24
     &     + 4.D0*s13*s24**2
     &     - 4.D0*s13*s14*s24
     &     + 4.D0*s12*s24**2
     &     - 8.D0*s12*s14*s24
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     - s24**2
     &     - 3.D0*s14*s24
     &     - 6.D0*s14**2
     &     - 4.D0*s13*s14
     &     - 2.D0*s13**2
     &     + s12*s24
     &     - 6.D0*s12*s14
     &     - 12.D0*s12*s13
     &     - 14.D0*s12**2
     &     )
      d40 = d40 + s234**(-1)*s1234**(-2) * (
     &     - 3.D0*s34
     &     + 3.D0*s24
     &     + 15.D0*s14
     &     + 4.D0*s13
     &     + 19.D0*s12
     &     )
      d40 = d40 + s1234**(-2)*S12**(-1)*S14**(-1)*S23**(-1)*S34**(-1)
     &  * (
     &     + s13*s24**3
     &     + 3.D0*s13**2*s24**2
     &     + 3.D0*s13**3*s24
     &     + 2.D0*s13**4
     &     )
      d40 = d40 + s1234**(-2)*S12**(-1)*S14**(-1)*S23**(-1) * (
     &     + s13*s34**2
     &     + 3.D0*s13*s24*s34
     &     + 3.D0*s13*s24**2
     &     + 3.D0*s13**2*s34
     &     + 6.D0*s13**2*s24
     &     + 4.D0*s13**3
     &     )
      d40 = d40 + s1234**(-2)*S12**(-1)*S14**(-1)*S34**(-1) * (
     &     + 3.D0*s13*s24**2
     &     + 3.D0*s13*s23*s24
     &     + s13*s23**2
     &     + 6.D0*s13**2*s24
     &     + 3.D0*s13**2*s23
     &     + 4.D0*s13**3
     &     )
      d40 = d40 + s1234**(-2)*S12**(-1)*S14**(-1) * (
     &     + 3.D0*s13*s34
     &     + 6.D0*s13*s24
     &     + 3.D0*s13*s23
     &     + 6.D0*s13**2
     &     )
      d40 = d40 + s1234**(-2)*S12**(-1)*S23**(-1)*S34**(-1) * (
     &     + s24**3
     &     + 3.D0*s14*s24**2
     &     + 4.D0*s14**2*s24
     &     + 2.D0*s14**3
     &     + 6.D0*s13*s24**2
     &     + 9.D0*s13*s14*s24
     &     + 4.D0*s13*s14**2
     &     + 9.D0*s13**2*s24
     &     + 6.D0*s13**2*s14
     &     + 4.D0*s13**3
     &     )
      d40 = d40 + s1234**(-2)*S12**(-1)*S23**(-1) * (
     &     + 2.D0*s34**2
     &     + 5.D0*s24*s34
     &     + 5.D0*s24**2
     &     + 5.D0*s14*s34
     &     + 12.D0*s14*s24
     &     + 10.D0*s14**2
     &     + 11.D0*s13*s34
     &     + 16.D0*s13*s24
     &     + 17.D0*s13*s14
     &     + 15.D0*s13**2
     &     )
      d40 = d40 + s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 2.D0*s24**2
     &     - s23*s24
     &     - s23**2
     &     + 4.D0*s14*s24
     &     + 5.D0*s14*s23
     &     + 5.D0*s14**2
     &     + 6.D0*s13*s24
     &     + 8.D0*s13*s23
     &     + 17.D0*s13*s14
     &     + 18.D0*s13**2
     &     )
      d40 = d40 + s1234**(-2)*S12**(-1) * (
     &     - 2.D0*s34
     &     + 3.D0*s24
     &     + 2.D0*s23
     &     + 2.D0*s14
     &     + 14.D0*s13
     &     )
      d40 = d40 + s1234**(-2)*S14**(-1)*S23**(-1)*S34**(-1) * (
     &     + s24**3
     &     + 6.D0*s13*s24**2
     &     + 9.D0*s13**2*s24
     &     + 4.D0*s13**3
     &     + 3.D0*s12*s24**2
     &     + 9.D0*s12*s13*s24
     &     + 6.D0*s12*s13**2
     &     + 4.D0*s12**2*s24
     &     + 4.D0*s12**2*s13
     &     + 2.D0*s12**3
     &     )
      d40 = d40 + s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     - s24*s34
     &     + s24**2
     &     + 4.D0*s13*s34
     &     + 14.D0*s13*s24
     &     + 11.D0*s13**2
     &     - 3.D0*s12*s34
     &     + 8.D0*s12*s24
     &     + 17.D0*s12*s13
     &     + 12.D0*s12**2
     &     )
      d40 = d40 + s1234**(-2)*S14**(-1)*S34**(-1) * (
     &     + 5.D0*s24**2
     &     + 5.D0*s23*s24
     &     + 2.D0*s23**2
     &     + 15.D0*s13*s24
     &     + 12.D0*s13*s23
     &     + 18.D0*s13**2
     &     + 11.D0*s12*s24
     &     + 6.D0*s12*s23
     &     + 18.D0*s12*s13
     &     + 8.D0*s12**2
     &     )
      d40 = d40 + s1234**(-2)*S14**(-1) * (
     &     + 2.D0*s34
     &     + 2.D0*s24
     &     - 2.D0*s23
     &     + 15.D0*s13
     &     + 3.D0*s12
     &     )
      d40 = d40 + s1234**(-2)*S23**(-2) * (
     &     + 2.D0*s34**2
     &     - 8.D0*s13*s34
     &     + 2.D0*s13**2
     &     )
      d40 = d40 + s1234**(-2)*S23**(-1)*S34**(-1) * (
     &     + 9.D0*s24**2
     &     + 14.D0*s14*s24
     &     + 8.D0*s14**2
     &     + 22.D0*s13*s24
     &     + 14.D0*s13*s14
     &     + 14.D0*s13**2
     &     + 17.D0*s12*s24
     &     + 8.D0*s12*s14
     &     + 18.D0*s12*s13
     &     + 10.D0*s12**2
     &     )
      d40 = d40 + s1234**(-2)*S23**(-1) * (
     &     + 5.D0*s34
     &     + s24
     &     - 8.D0*s14
     &     + 14.D0*s13
     &     - 9.D0*s12
     &     )
      d40 = d40 + s1234**(-2)*S34**(-2) * (
     &     + 2.D0*s24**2
     &     - 8.D0*s14*s24
     &     + 2.D0*s14**2
     &     )
      d40 = d40 + s1234**(-2)*S34**(-1) * (
     &     + 6.D0*s24
     &     - 3.D0*s23
     &     + 11.D0*s14
     &     + 12.D0*s13
     &     - 8.D0*s12
     &     )
      d40 = d40 + s1234**(-2) * (
     &     + 16.D0
     &     )

      FullD40=d40
*      write(*,*)"FullD40",FullD40

      return
      end


