************************************************************************
      function FullG40(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit double precision(a-h,o-z)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34

      s1234=s12+s13+s14+s23+s24+s34

      g40 =  + s134**(-2)*s1234**(-2)*S13**(-1) * (
     &     - 2.D0*s24**2*s34
     &     - 4.D0*s23*s24*s34
     &     - 2.D0*s23**2*s34
     &     - 4.D0*s12*s24*s34
     &     - 4.D0*s12*s23*s34
     &     - 2.D0*s12**2*s34
     &     )
      g40 = g40 + s134**(-2)*s1234**(-2)*S34**(-2) * (
     &     - 2.D0*s14**2*s24**2
     &     - 4.D0*s14**2*s23*s24
     &     - 2.D0*s14**2*s23**2
     &     - 2.D0*s13**2*s24**2
     &     - 4.D0*s13**2*s23*s24
     &     - 2.D0*s13**2*s23**2
     &     - 4.D0*s12*s14**2*s24
     &     - 4.D0*s12*s14**2*s23
     &     - 4.D0*s12*s13**2*s24
     &     - 4.D0*s12*s13**2*s23
     &     - 2.D0*s12**2*s14**2
     &     - 2.D0*s12**2*s13**2
     &     )
      g40 = g40 + s134**(-2)*s1234**(-2)*S34**(-1) * (
     &     - 4.D0*s13*s24**2
     &     - 8.D0*s13*s23*s24
     &     - 4.D0*s13*s23**2
     &     - 8.D0*s12*s13*s24
     &     - 8.D0*s12*s13*s23
     &     - 4.D0*s12**2*s13
     &     )
      g40 = g40 + s134**(-2)*s1234**(-2) * (
     &     - 4.D0*s24**2
     &     - 8.D0*s23*s24
     &     - 4.D0*s23**2
     &     - 8.D0*s12*s24
     &     - 8.D0*s12*s23
     &     - 4.D0*s12**2
     &     )
      g40 = g40 + s134**(-1)*s234**(-1)*s1234**(-2)*S13**(-1) * (
     &     - s34**3
     &     - 3.D0*s24*s34**2
     &     - 4.D0*s24**2*s34
     &     - 2.D0*s24**3
     &     + s23*s34**2
     &     + 2.D0*s23**2*s34
     &     + 2.D0*s23**3
     &     + 4.D0*s12*s34**2
     &     + 6.D0*s12*s24*s34
     &     + 4.D0*s12*s24**2
     &     + 2.D0*s12*s23*s34
     &     + 4.D0*s12*s23**2
     &     - 3.D0*s12**2*s34
     &     - 3.D0*s12**2*s24
     &     )
      g40 = g40 + s134**(-1)*s234**(-1)*s1234**(-2)*S13**(-1) * (
     &     + 3.D0*s12**2*s23
     &     + 2.D0*s12**3
     &     )
      g40 = g40 + s134**(-1)*s234**(-1)*s1234**(-2)*S24**(-1) * (
     &     - s34**3
     &     + s14*s34**2
     &     + 2.D0*s14**2*s34
     &     + 2.D0*s14**3
     &     - 3.D0*s13*s34**2
     &     - 4.D0*s13**2*s34
     &     - 2.D0*s13**3
     &     + 4.D0*s12*s34**2
     &     + 2.D0*s12*s14*s34
     &     + 4.D0*s12*s14**2
     &     + 6.D0*s12*s13*s34
     &     + 4.D0*s12*s13**2
     &     - 3.D0*s12**2*s34
     &     + 3.D0*s12**2*s14
     &     )
      g40 = g40 + s134**(-1)*s234**(-1)*s1234**(-2)*S24**(-1) * (
     &     - 3.D0*s12**2*s13
     &     + 2.D0*s12**3
     &     )
      g40 = g40 + s134**(-1)*s234**(-1)*s1234**(-2)*S34**(-2) * (
     &     + 4.D0*s12**2*s14*s24
     &     + 4.D0*s12**2*s13*s23
     &     )
      g40 = g40 + s134**(-1)*s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 8.D0*s12*s24**2
     &     + 8.D0*s12*s23**2
     &     + 8.D0*s12*s14*s24
     &     + 8.D0*s12*s14**2
     &     + 8.D0*s12*s13*s23
     &     + 8.D0*s12*s13**2
     &     + 4.D0*s12**2*s23
     &     + 4.D0*s12**2*s14
     &     + 4.D0*s12**3
     &     )
      g40 = g40 + s134**(-1)*s234**(-1)*s1234**(-2) * (
     &     + 12.D0*s12*s34
     &     + 12.D0*s12*s24
     &     + 12.D0*s12*s23
     &     + 12.D0*s12*s14
     &     + 12.D0*s12*s13
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2)*S12**(-1)*S13**(-1) * (
     &     + 2.D0*s23*s34**2
     &     - 4.D0*s23*s24*s34
     &     + 2.D0*s23*s24**2
     &     + 2.D0*s23**3
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 2.D0*s24**3
     &     + 2.D0*s23*s24**2
     &     + 2.D0*s23**2*s24
     &     + 2.D0*s23**3
     &     + 2.D0*s14*s24**2
     &     - 2.D0*s14*s23**2
     &     + 2.D0*s14**2*s24
     &     + 2.D0*s14**2*s23
     &     - 2.D0*s13*s24**2
     &     + 2.D0*s13*s23**2
     &     + 2.D0*s13**2*s24
     &     + 2.D0*s13**2*s23
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 2.D0*s24*s34
     &     - 2.D0*s24**2
     &     + 4.D0*s23*s34
     &     - 8.D0*s23*s24
     &     + 2.D0*s23**2
     &     + 2.D0*s14*s24
     &     + 2.D0*s13*s24
     &     + 4.D0*s13*s23
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2)*S13**(-1) * (
     &     + 3.D0*s34**2
     &     - 2.D0*s24*s34
     &     + 2.D0*s24**2
     &     - 4.D0*s23*s34
     &     + 2.D0*s23*s24
     &     + 10.D0*s23**2
     &     - 6.D0*s12*s34
     &     - 4.D0*s12*s24
     &     + 12.D0*s12*s23
     &     + 5.D0*s12**2
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2)*S24**(-1)*S34**(-1) * (
     &     - 2.D0*s14**3
     &     + 2.D0*s13**3
     &     - 2.D0*s12*s14**2
     &     - 2.D0*s12*s13**2
     &     - s12**2*s14
     &     + s12**2*s13
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2)*S24**(-1) * (
     &     + s34**2
     &     - s14*s34
     &     - 2.D0*s14**2
     &     + 3.D0*s13*s34
     &     + 4.D0*s13**2
     &     - 2.D0*s12*s34
     &     - 4.D0*s12*s13
     &     + s12**2
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2)*S34**(-2) * (
     &     + 4.D0*s14*s24**2
     &     + 4.D0*s14*s23*s24
     &     - 4.D0*s14**2*s24
     &     - 4.D0*s14**2*s23
     &     + 4.D0*s13*s23*s24
     &     + 4.D0*s13*s23**2
     &     - 4.D0*s13**2*s24
     &     - 4.D0*s13**2*s23
     &     + 8.D0*s12*s14*s24
     &     - 4.D0*s12*s14**2
     &     + 8.D0*s12*s13*s23
     &     - 4.D0*s12*s13**2
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 8.D0*s24**2
     &     + 4.D0*s23*s24
     &     + 16.D0*s23**2
     &     + 6.D0*s14*s24
     &     - 8.D0*s14*s23
     &     + 6.D0*s14**2
     &     - 14.D0*s13*s24
     &     + 6.D0*s13**2
     &     + 4.D0*s12*s24
     &     + 16.D0*s12*s23
     &     - 4.D0*s12*s14
     &     - 12.D0*s12*s13
     &     + 10.D0*s12**2
     &     )
      g40 = g40 + s134**(-1)*s1234**(-2) * (
     &     + 8.D0*s34
     &     - 14.D0*s24
     &     - 4.D0*s23
     &     + 4.D0*s14
     &     + 8.D0*s13
     &     - 16.D0*s12
     &     )
      g40 = g40 + s234**(-2)*s1234**(-2)*S24**(-1) * (
     &     - 2.D0*s14**2*s34
     &     - 4.D0*s13*s14*s34
     &     - 2.D0*s13**2*s34
     &     - 4.D0*s12*s14*s34
     &     - 4.D0*s12*s13*s34
     &     - 2.D0*s12**2*s34
     &     )
      g40 = g40 + s234**(-2)*s1234**(-2)*S34**(-2) * (
     &     - 2.D0*s14**2*s24**2
     &     - 2.D0*s14**2*s23**2
     &     - 4.D0*s13*s14*s24**2
     &     - 4.D0*s13*s14*s23**2
     &     - 2.D0*s13**2*s24**2
     &     - 2.D0*s13**2*s23**2
     &     - 4.D0*s12*s14*s24**2
     &     - 4.D0*s12*s14*s23**2
     &     - 4.D0*s12*s13*s24**2
     &     - 4.D0*s12*s13*s23**2
     &     - 2.D0*s12**2*s24**2
     &     - 2.D0*s12**2*s23**2
     &     )
      g40 = g40 + s234**(-2)*s1234**(-2)*S34**(-1) * (
     &     - 4.D0*s14**2*s24
     &     - 8.D0*s13*s14*s24
     &     - 4.D0*s13**2*s24
     &     - 8.D0*s12*s14*s24
     &     - 8.D0*s12*s13*s24
     &     - 4.D0*s12**2*s24
     &     )
      g40 = g40 + s234**(-2)*s1234**(-2) * (
     &     - 4.D0*s14**2
     &     - 8.D0*s13*s14
     &     - 4.D0*s13**2
     &     - 8.D0*s12*s14
     &     - 8.D0*s12*s13
     &     - 4.D0*s12**2
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2)*S12**(-1)*S24**(-1) * (
     &     + 2.D0*s14*s34**2
     &     + 2.D0*s14**3
     &     - 4.D0*s13*s14*s34
     &     + 2.D0*s13**2*s14
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 2.D0*s14*s24**2
     &     + 2.D0*s14*s23**2
     &     + 2.D0*s14**2*s24
     &     - 2.D0*s14**2*s23
     &     + 2.D0*s14**3
     &     + 2.D0*s13*s24**2
     &     + 2.D0*s13*s23**2
     &     + 2.D0*s13*s14**2
     &     - 2.D0*s13**2*s24
     &     + 2.D0*s13**2*s23
     &     + 2.D0*s13**2*s14
     &     + 2.D0*s13**3
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2)*S12**(-1) * (
     &     + 4.D0*s14*s34
     &     + 4.D0*s14*s24
     &     + 2.D0*s14**2
     &     + 2.D0*s13*s34
     &     + 2.D0*s13*s24
     &     + 2.D0*s13*s23
     &     - 8.D0*s13*s14
     &     - 2.D0*s13**2
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2)*S13**(-1)*S34**(-1) * (
     &     + 2.D0*s24**3
     &     - 2.D0*s23**3
     &     - 2.D0*s12*s24**2
     &     - 2.D0*s12*s23**2
     &     + s12**2*s24
     &     - s12**2*s23
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2)*S13**(-1) * (
     &     + s34**2
     &     + 3.D0*s24*s34
     &     + 4.D0*s24**2
     &     - s23*s34
     &     - 2.D0*s23**2
     &     - 2.D0*s12*s34
     &     - 4.D0*s12*s24
     &     + s12**2
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2)*S24**(-1) * (
     &     + 3.D0*s34**2
     &     - 4.D0*s14*s34
     &     + 10.D0*s14**2
     &     - 2.D0*s13*s34
     &     + 2.D0*s13*s14
     &     + 2.D0*s13**2
     &     - 6.D0*s12*s34
     &     + 12.D0*s12*s14
     &     - 4.D0*s12*s13
     &     + 5.D0*s12**2
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2)*S34**(-2) * (
     &     - 4.D0*s14*s24**2
     &     - 4.D0*s14*s23**2
     &     + 4.D0*s14**2*s24
     &     - 4.D0*s13*s24**2
     &     - 4.D0*s13*s23**2
     &     + 4.D0*s13*s14*s24
     &     + 4.D0*s13*s14*s23
     &     + 4.D0*s13**2*s23
     &     - 4.D0*s12*s24**2
     &     - 4.D0*s12*s23**2
     &     + 8.D0*s12*s14*s24
     &     + 8.D0*s12*s13*s23
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2)*S34**(-1) * (
     &     + 6.D0*s24**2
     &     + 6.D0*s23**2
     &     - 8.D0*s14*s23
     &     + 16.D0*s14**2
     &     - 14.D0*s13*s24
     &     + 6.D0*s13*s23
     &     + 4.D0*s13*s14
     &     + 8.D0*s13**2
     &     - 12.D0*s12*s24
     &     - 4.D0*s12*s23
     &     + 16.D0*s12*s14
     &     + 4.D0*s12*s13
     &     + 10.D0*s12**2
     &     )
      g40 = g40 + s234**(-1)*s1234**(-2) * (
     &     + 8.D0*s34
     &     + 8.D0*s24
     &     + 4.D0*s23
     &     - 4.D0*s14
     &     - 14.D0*s13
     &     - 16.D0*s12
     &     )
      g40 = g40 + s1234**(-2)*S12**(-1)*S13**(-1)*S34**(-1) * (
     &     + 2.D0*s23*s24**2
     &     + 2.D0*s23**3
     &     )
      g40 = g40 + s1234**(-2)*S12**(-1)*S13**(-1) * (
     &     - 2.D0*s23*s34
     &     + 4.D0*s23*s24
     &     + 2.D0*s14*s23
     &     )
      g40 = g40 + s1234**(-2)*S12**(-1)*S24**(-1)*S34**(-1) * (
     &     + 2.D0*s14**3
     &     + 2.D0*s13**2*s14
     &     )
      g40 = g40 + s1234**(-2)*S12**(-1)*S24**(-1) * (
     &     - 2.D0*s14*s34
     &     + 2.D0*s14*s23
     &     + 4.D0*s13*s14
     &     )
      g40 = g40 + s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + 6.D0*s24**2
     &     + 4.D0*s23*s24
     &     + 6.D0*s23**2
     &     + 8.D0*s14*s24
     &     + 6.D0*s14**2
     &     + 8.D0*s13*s24
     &     + 8.D0*s13*s23
     &     + 4.D0*s13*s14
     &     + 6.D0*s13**2
     &     )
      g40 = g40 + s1234**(-2)*S12**(-1) * (
     &     - 2.D0*s24
     &     - 2.D0*s23
     &     - 2.D0*s14
     &     - 2.D0*s13
     &     )
      g40 = g40 + s1234**(-2)*S13**(-1)*S24**(-1) * (
     &     - 2.D0*s14*s23
     &     + 2.D0*s12*s34
     &     )
      g40 = g40 + s1234**(-2)*S13**(-1)*S34**(-1) * (
     &     - 2.D0*s24**2
     &     + 2.D0*s23*s24
     &     - 2.D0*s23**2
     &     + 2.D0*s12*s24
     &     - 2.D0*s12*s23
     &     - s12**2
     &     )
      g40 = g40 + s1234**(-2)*S13**(-1) * (
     &     - 3.D0*s34
     &     - 2.D0*s24
     &     + 4.D0*s23
     &     + 2.D0*s12
     &     )
      g40 = g40 + s1234**(-2)*S24**(-1)*S34**(-1) * (
     &     - 2.D0*s14**2
     &     + 2.D0*s13*s14
     &     - 2.D0*s13**2
     &     - 2.D0*s12*s14
     &     + 2.D0*s12*s13
     &     - s12**2
     &     )
      g40 = g40 + s1234**(-2)*S24**(-1) * (
     &     - 3.D0*s34
     &     + 4.D0*s14
     &     - 2.D0*s13
     &     + 2.D0*s12
     &     )
      g40 = g40 + s1234**(-2)*S34**(-2) * (
     &     - 2.D0*s24**2
     &     - 2.D0*s23**2
     &     + 8.D0*s14*s24
     &     - 2.D0*s14**2
     &     + 8.D0*s13*s23
     &     - 2.D0*s13**2
     &     )
      g40 = g40 + s1234**(-2)*S34**(-1) * (
     &     + 8.D0*s24
     &     + 14.D0*s23
     &     + 14.D0*s14
     &     + 8.D0*s13
     &     + 24.D0*s12
     &     )
      g40 = g40 + s1234**(-2) * (
     &     - 18.D0
     &     )
      g40 = g40 - 4d0*(s13*s24-s14*s23)**2/s12**2/s34**2/s1234**2

      FullG40 = g40/2d0

      return
      end
