************************************************************************
      function FullH40(i1,i2,i3,i4,ipset)
      use KinData_mod
      implicit double precision(a-h,o-z)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34

      s1234=s12+s13+s14+s23+s24+s34

      h40 =  + s1234**(-2)*S12**(-1)*S34**(-1) * (
     &     + s24**2
     &     + s23**2
     &     - 2.D0*s14*s23
     &     + s14**2
     &     - 2.D0*s13*s24
     &     + s13**2
     &     )
      h40 = h40 + s1234**(-2) * (
     &     + 2.D0
     &     )

      h40 =  h40 + 2d0*((s14*s23-s13*s24)/(s12*s34))**(2)/s1234**(2)

      FullH40 = h40

      return
      end

