*********************************************************************
*   BASE FUNCTIONS
*********************************************************************
      function zzR(a,b,c)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /order/iorder
      parameter( Pi2_6 = 1.64493406684822643646d0 )

      write(*,*)"zzR:  not sure what this is doing
     .           - is it real or complex?"
      write(*,*)"zzR:  why is it calling complex zh2?"
      y = a/c
      w = b/c
*
      zy = dcmplx(y)
      zw = dcmplx(w)
*
      yy = 1d0-y
      ww = 1d0-w
c	This needs to be linked with chaplin
      zwt = zzlog(y)*zzlog(w) -zzlog(y)*zzlog(yy)
     .     -zzlog(w)*zzlog(ww) + Pi2_6 - zh2(0,1,zy) - zh2(0,1,zw)

      zzR = zwt
      return
      end
*********************************************************************
*  Singularity operators
************************************************************************
*
      function xIggone(sij,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      zz = zzlog(renscale2)-zzlog(-sij)
      e2=-1d0/2d0
      e1=-11d0/12d0
      e0=+1d0/24d0*pi**2

      if(ieorder.eq.-2)then
        xIggone=e2
      elseif(ieorder.eq.-1)then
        xIggone=e1+real(zz)*e2
      elseif(ieorder.eq.0)then
        xIggone=e0+real(zz)*e1+1d0/2d0*real(zz**2)*e2
      endif

*      write(*,*)" xIggone ",xIggone

      return
      end
************************************************************************
*
      function xIggFone(sij,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      zz = zzlog(renscale2)-zzlog(-sij)
      e2=0d0
      e1=1d0/6d0
      e0=0d0

      if(ieorder.eq.-2)then
        xIggFone=e2
      elseif(ieorder.eq.-1)then
        xIggFone=e1+real(zz)*e2
      elseif(ieorder.eq.0)then
        xIggFone=e0+real(zz)*e1+1d0/2d0*real(zz**2)*e2
      endif

*      write(*,*)" xIggFone ",xIggFone

      return
      end
************************************************************************
      function xIggFonev2(sij,renscale2)
      implicit real*8(a-h,o-y)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      yy = dLog(dabs(renscale2/sij))
      e2=0d0
      e1=+1d0/6d0
      e0=0d0

      if(ieorder.eq.-2)then
        xIggFonev2=e2
      elseif(ieorder.eq.-1)then
        xIggFonev2=e1+yy*e2
      elseif(ieorder.eq.0)then
        xIggFonev2=e0+yy*e1+1d0/2d0*yy**2*e2
      endif
*      write(*,*)" xIgFgonev2 ",xIggFonev2

      return
      end
************************************************************************
*
      function xIqgone(sij,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      zz = zzlog(renscale2)-zzlog(-sij)
      e2=-1d0/2d0
      e1=-5d0/6d0
      e0=+1d0/24d0*pi**2

      if(ieorder.eq.-2)then
        xIqgone=e2
      elseif(ieorder.eq.-1)then
        xIqgone=e1+real(zz)*e2
      elseif(ieorder.eq.0)then
        xIqgone=e0+real(zz)*e1+1d0/2d0*real(zz**2)*e2
      endif

*      write(*,*)" xIqgone ",xIqgone

      return
      end
************************************************************************
*
      function xIqgFone(sij,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      zz = zzlog(renscale2)-zzlog(-sij)
      e2=0d0
      e1=1d0/12d0
      e0=0d0

      if(ieorder.eq.-2)then
        xIqgFone=e2
      elseif(ieorder.eq.-1)then
        xIqgFone=e1+real(zz)*e2
      elseif(ieorder.eq.0)then
        xIqgFone=e0+real(zz)*e1+1d0/2d0*real(zz**2)*e2
      endif

*      write(*,*)" xIqgFone ",xIqgFone

      return
      end
************************************************************************
*
      function xIgqone(sij,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      xIgqone=xIqgone(sij,renscale2)

*      write(*,*)" xIgqone ",xIgqone

      return
      end
************************************************************************
*
      function xIgqFone(sij,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      xIgqFone=xIqgFone(sij,renscale2)

*      write(*,*)" xIgqFone ",xIgqFone

      return
      end
************************************************************************
*
      function xIqqone(sij,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      zz = zzlog(renscale2)-zzlog(-sij)
      e2=-1d0/2d0
      e1=-3d0/4d0
      e0=+1d0/24d0*pi**2

      if(ieorder.eq.-2)then
        xIqqone=e2
      elseif(ieorder.eq.-1)then
        xIqqone=e1+real(zz)*e2
      elseif(ieorder.eq.0)then
        xIqqone=e0+real(zz)*e1+1d0/2d0*real(zz**2)*e2
      endif

*      write(*,*)" xIqqone ",xIqqone

      return
      end
*************************************************************************
*
      function xIqqFone(sij,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      common /order/ieorder
      parameter( pi = 3.14159265358979323846d0 )

      zz = zzlog(renscale2)-zzlog(-sij)
      e2=0d0
      e1=0d0
      e0=0d0

      if(ieorder.eq.-2)then
        xIqqFone=e2
      elseif(ieorder.eq.-1)then
        xIqqFone=e1+real(zz)*e2
      elseif(ieorder.eq.0)then
        xIqqFone=e0+real(zz)*e1+1d0/2d0*real(zz**2)*e2
      endif

*      write(*,*)" xIqqFone ",xIqqFone

      return
      end
*************************************************************************
*
      function PolesIgg(sij,renscale2)
      implicit real*8(a-h,o-y)
      write(*,*)"please use xIggone"
      PolesIgg=xIggone(sij,renscale2)
      return
      end
*************************************************************************
*
      function PolesIqg(sij,renscale2)
      implicit real*8(a-h,o-y)
      write(*,*)"please use xIqgone"
      PolesIqg=xIqgone(sij,renscale2)
      return
      end
*************************************************************************
*
      function PolesIqq(sij,renscale2)
      implicit real*8(a-h,o-y)
      write(*,*)"please use xIqqone"
      PolesIqq=xIqqone(sij,renscale2)
      return
      end
*************************************************************************
*
      function PolesIggF(sij,renscale2)
      implicit real*8(a-h,o-y)
      write(*,*)"please use xIggFone"
      PolesIggF=xIggone(sij,renscale2)
      return
      end
*************************************************************************
*
      function PolesIqgF(sij,renscale2)
      implicit real*8(a-h,o-y)
      write(*,*)"please use xIqgFone"
      PolesIqgF=xIqgone(sij,renscale2)
      return
      end
*************************************************************************
*
      function PolesIqqF(sij,renscale2)
      implicit real*8(a-h,o-y)
      write(*,*)"please use xIqqFone"
      PolesIqqF=xIqqone(sij,renscale2)
      return
      end
*********************************************************************
*   Logarithms and HPLs
************************************************************************
*
      complex*16 function zzlog(x)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      parameter (pi = 3.141592653589793238d0)
      zone=(1d0,0d0)

      if(x.ge.0d0) then
         zzlog = log(x)*zone
      else
         zzlog=log(abs(x))-(0d0,pi)
      endif
      return
      end
************************************************************************
*
* wrapper for CHAPLIN
*
*
      real*8 function rh1(n1,z)
      implicit real*8(a-h,o-z)

      rh1=HPL1real(n1,z,0d0)

      return
      end
************************************************************************
*
      real*8 function rh2(n1,n2,z)
      implicit real*8(a-h,o-z)

      rh2=HPL2real(n1,n2,z,0d0)

      return
      end
************************************************************************
*
      real*8 function rh3(n1,n2,n3,z)
      implicit real*8(a-h,o-z)

      rh3=HPL3real(n1,n2,n3,z,0d0)

      return
      end
************************************************************************
*
      real*8 function rh4(n1,n2,n3,n4,z)
      implicit real*8(a-h,o-z)

      rh4=HPL4real(n1,n2,n3,n4,z,0d0)

      return
      end
************************************************************************
*
      complex*16 function zh1(n1,z)
      implicit real*8(a-h,o-y)
      complex*16 z,HPL1

      zh1=HPL1(n1,z)

      return
      end
************************************************************************
*
      complex*16 function zh2(n1,n2,z)
      implicit real*8(a-h,o-y)
      complex*16 z,HPL2

      zh2=HPL2(n1,n2,z)

      return
      end
************************************************************************
*
      complex*16 function zh3(n1,n2,n3,z)
      implicit real*8(a-h,o-y)
      complex*16 z,HPL3

      zh3=HPL3(n1,n2,n3,z)

      return
      end
************************************************************************
*
      complex*16 function zh4(n1,n2,n3,n4,z)
      implicit real*8(a-h,o-y)
      complex*16 z,HPL4

      zh4=HPL4(n1,n2,n3,n4,z)

      return
      end
************************************************************************
