************************************************************************
*
      function rJ22QQIFqgam_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : zfrag_kin
      implicit double precision (a-h,o-z)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /method/imethod


      if(imethod /= 2)then
        stop 'J22QQIFqgam_frag: only imethod=2!' 
      endif

      if((i1.eq.2).or.(i2.eq.2))then
        rJ22QQIFqgam_frag=rJ22QQFIqgam_frag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif
     
      x1h = xreg1
      x2h = xreg2
      omx1h=1d0-x1h
      omx2h=1d0-x2h
      zh=zfrag_kin
      cutdia = 1.0d-4

      if(abs(zh-x1h)<cutdia .and. abs(zh-omx1h)<cutdia)then
        step1 = (cutdia - abs(zh-x1h))/sqrt(2.d0)
        step2 = (cutdia - abs(zh-omx1h))/sqrt(2.d0)
        zeval = zh + sign(1d0,zh-x1h) * step1 + sign(1d0,zh-omx1h) * step2
        xeval = x1h - sign(1d0,zh-x1h) * step1 + sign(1d0,zh-omx1h) * step2
        rJ22QQIFqgam_frag = rJ22QQIFqgam_fragh(ix,xeval,x2h,zeval,i1,i2,ipset,renscale2,facscale2,fragscale2)
      else if(abs(zh-x1h)<cutdia) then
        step1 = (cutdia - abs(zh-x1h))/sqrt(2d0)
        step2 = (cutdia + abs(zh-x1h))/sqrt(2d0)
        zeval1 = zh + sign(1d0,zh-x1h) * step1
        xeval1 = x1h - sign(1d0,zh-x1h) * step1
        zeval2 = zh - sign(1d0,zh-x1h) * step2
        xeval2 = x1h + sign(1d0,zh-x1h) * step2
        res1 = rJ22QQIFqgam_fragh(ix,xeval1,x2h,zeval1,i1,i2,ipset,renscale2,facscale2,fragscale2)
        res2 = rJ22QQIFqgam_fragh(ix,xeval2,x2h,zeval2,i1,i2,ipset,renscale2,facscale2,fragscale2)
        rJ22QQIFqgam_frag = step2 * sqrt(2d0) / 2d0 / cutdia * res1 + step1 * sqrt(2d0) / 2d0 / cutdia * res2
      else if(abs(zh-omx1h)<cutdia) then
        step1 = (cutdia - abs(zh-omx1h))/sqrt(2d0)
        step2 = (cutdia + abs(zh-omx1h))/sqrt(2d0)
        zeval1 = zh + sign(1d0,zh-omx1h) * step1
        xeval1 = x1h + sign(1d0,zh-omx1h) * step1
        zeval2 = zh - sign(1d0,zh-omx1h) * step2
        xeval2 = x1h - sign(1d0,zh-omx1h) * step2
        res1 = rJ22QQIFqgam_fragh(ix,xeval1,x2h,zeval1,i1,i2,ipset,renscale2,facscale2,fragscale2)
        res2 = rJ22QQIFqgam_fragh(ix,xeval2,x2h,zeval2,i1,i2,ipset,renscale2,facscale2,fragscale2)
        rJ22QQIFqgam_frag = step2 * sqrt(2d0) / 2d0 / cutdia * res1 + step1 * sqrt(2d0) / 2d0 / cutdia *  res2
      else
        rJ22QQIFqgam_frag = rJ22QQIFqgam_fragh(ix,x1h,x2h,zh,i1,i2,ipset,renscale2,facscale2,fragscale2)
      end if

*      write(*,*)" rJ22QQIFqgam_frag ", rJ22QQIFqgam_frag

      return
      end
