************************************************************************
*  generated using makeformVV on 2025-02-16
*
      function qbBh1g2WmDISU(iix,xx1,xx2,i4,i3,i1,i5,i2,
     .rscale2,fscale2)
      use Constants_mod
      use KinData_mod
      use Scales_mod
      use Flavour_mod, only: isActive_flav,set_flav_perm,unset_flav_perm
      implicit double precision (a-h,o-z)
      integer :: nBlocks, block
      double precision rloop1(nMax_scl)
      double precision rloop2(nMax_scl)
      double precision rtree1(nMax_scl)
      double precision dlmuF(nMax_scl)
      double precision dls12(nMax_scl)
      double precision dls13(nMax_scl)
      double precision dls14(nMax_scl)
      double precision dls15(nMax_scl)
      double precision dls23(nMax_scl)
      double precision dls24(nMax_scl)
      double precision dls25(nMax_scl)
      double precision dls34(nMax_scl)
      double precision dls35(nMax_scl)
      double precision dls45(nMax_scl)
      double precision dls134(nMax_scl)
      double precision e0(nMax_scl)
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      logical jflag
      common /order2l/ipole
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /distomx/ dd0x1,dd1x1,dd2x1,dd3x1,dd0x2,dd1x2,dd2x2,dd3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ zz1,zz2
!$omp threadprivate(/parfrac/)
      dimension GII(32,2),GIIdiff(32),PLI1(5)
      parameter(dli2one=1.6449340668482264365d0)
      parameter(dli2mone=-.82246703342411321826d0)
      parameter(dli2half=0.58224052646501250592d0)
      parameter(dli3one=1.2020569031595942854d0)
      parameter(dli3mone=-.90154267736969571405d0)
      parameter(dli3half=0.53721319360804020089d0)
      dimension ixSwap(4)
      data      ixSwap /1,3,2,4/
      qbBh1g2WmDISU = 0d0
      ipass=1
      call ecuts_dis(0,5,ipass)
      if(ipass.eq.0)return
      ipass=0
      jflag = .false.
      if ( i1.eq.1 .and. i2.eq.2 ) then
        ix=iix
        x1=xx1
        x2=xx2
        z1=zz1
        z2=zz2
        d0x1=dd0x1
        d1x1=dd1x1
        d2x1=dd2x1
        d3x1=dd3x1
        d0x2=dd0x2
        d1x2=dd1x2
        d2x2=dd2x2
        d3x2=dd3x2
      elseif ( i1.eq.2 .and. i2.eq.1 ) then
        ix=ixSwap(iix)
        x1=xx2
        x2=xx1
        z1=zz2
        z2=zz1
        d0x1=dd0x2
        d1x1=dd1x2
        d2x1=dd2x2
        d3x1=dd3x2
        d0x2=dd0x1
        d1x2=dd1x1
        d2x2=dd2x1
        d3x2=dd3x1
      else
        write(*,*) "qbBh1g2WmDISU: bad input ",i4,i3,i1,i5,i2 
        stop
      endif
      s12=s5(i1,i2)
      s13=s5(i1,i3)
      s14=s5(i1,i4)
      s15=s5(i1,i5)
      s23=s5(i2,i3)
      s24=s5(i2,i4)
      s25=s5(i2,i5)
      s34=s5(i3,i4)
      s35=s5(i3,i5)
      s45=s5(i4,i5)
      s134=s13+s34+s14
      nBlocks=3
      e0=0d0
      GII=0d0
      GIIdiff=0d0
      if(ix.eq.4)then
          small=1d-12
          dsmall = dmin1(abs(1d0-x1),abs(1d0-x2),
     .                   abs(1d0-x1*x2),abs(x1-x2))
          if(dsmall.lt.small)call VVdebug(x1,x2)
      endif
      omz1 = 1d0-z1
      omz2 = 1d0-z2
      opx1 = 1d0+x1
      omx1 = 1d0-x1
      opx2 = 1d0+x2
      omx2 = 1d0-x2
      x1px2 = x1+x2
      x1mx2 = x1-x2
      omx1x2 = 1d0-x1*x2
      opx1x2 = 1d0+x1*x2
      GII(1,1)=g13(x1,x2)-g13(1d0,x2)-g13(x1,1d0)+g13(1d0,1d0)
      GII(2,1)=g14(x1,x2)-g14(1d0,x2)-g14(x1,1d0)+g14(1d0,1d0)
      GII(3,1)=g22(x1,x2)-g22(1d0,x2)-g22(x1,1d0)+g22(1d0,1d0)
      GII(4,1)=g23(x1,x2)-g23(1d0,x2)-g23(x1,1d0)+g23(1d0,1d0)
      GII(5,1)=g24(x1,x2)-g24(1d0,x2)-g24(x1,1d0)+g24(1d0,1d0)
      GII(6,1)=g25(x1,x2)-g25(1d0,x2)-g25(x1,1d0)+g25(1d0,1d0)
      GII(7,1)=dli2(x1mx2/opx1)-dli2(omx2/2d0)-dli2(-omx1/opx1)
      GII(8,1)=dli2(x1mx2/x1px2)-dli2(omx2/opx2)-dli2(-omx1/opx1)
      GII(9,1)=dli2(x1*opx2/opx1)-dli2(opx2/2d0)-dli2(2d0*x1/opx1)
     .+dli2one
      GII(10,1)=dli2(opx1*omx1/opx1x2)-dli2(omx1)
      GII(11,1)=dli2(-x1/x2)-dli2(-1d0/x2)-dli2(-x1)+dli2mone
      GII(12,1)=dli2(-omx1/x1px2)-dli2(-omx1/opx1)
      GII(13,1)=dli2(omx1x2)-dli2(omx2)-dli2(omx1)
      GII(14,1)=log(opx1x2)-log(opx2)-log(opx1)+rln2
      GII(15,1)=log(x1px2)-log(opx2)-log(opx1)+rln2
      GII(1,2)=g13(x2,x1)-g13(1d0,x1)-g13(x2,1d0)+g13(1d0,1d0)
      GII(2,2)=g14(x2,x1)-g14(1d0,x1)-g14(x2,1d0)+g14(1d0,1d0)
      GII(3,2)=g22(x2,x1)-g22(1d0,x1)-g22(x2,1d0)+g22(1d0,1d0)
      GII(4,2)=g23(x2,x1)-g23(1d0,x1)-g23(x2,1d0)+g23(1d0,1d0)
      GII(5,2)=g24(x2,x1)-g24(1d0,x1)-g24(x2,1d0)+g24(1d0,1d0)
      GII(6,2)=g25(x2,x1)-g25(1d0,x1)-g25(x2,1d0)+g25(1d0,1d0)
      GII(7,2)=dli2(-x1mx2/opx2)-dli2(omx1/2d0)-dli2(-omx2/opx2)
      GII(8,2)=dli2(-x1mx2/x1px2)-dli2(omx1/opx1)-dli2(-omx2/opx2)
      GII(9,2)=dli2(x2*opx1/opx2)-dli2(opx1/2d0)-dli2(2d0*x2/opx2)
     .+dli2one
      GII(10,2)=dli2(opx2*omx2/opx1x2)-dli2(omx2)
      GII(11,2)=dli2(-x2/x1)-dli2(-1d0/x1)-dli2(-x2)+dli2mone
      GII(12,2)=dli2(-omx2/x1px2)-dli2(-omx2/opx2)
      GII(13,2)=dli2(omx1x2)-dli2(omx1)-dli2(omx2)
      GII(14,2)=GII(14,1)
      GII(15,2)=GII(15,1)
      GII(16,1)=g23b(x1)
      GII(17,1)=g23c(x1)
      GII(18,1)=dli2(x1)-dli2one
      GII(19,1)=dli2(x1/opx1)-dli2half
      GII(20,1)=dli2(-x1)-dli2mone
      GII(21,1)=dli2(1d0/2d0*omx1)
      GII(22,1)=dli3(x1)-dli3one
      GII(23,1)=dli3(1d0/opx1)-dli3half
      GII(24,1)=dli3(omx1/opx1)
      GII(25,1)=dli3(-x1)-dli3mone
      GII(26,1)=dli3(2d0*x1/opx1)-dli3one
      GII(27,1)=dli3(omx1)
      GII(28,1)=dli3(1d0/2d0*omx1)
      GII(29,1)=dli3(1d0/2d0*opx1)-dli3one
      GII(30,1)=log(x1)
      GII(31,1)=log(opx1)-rln2
      GII(16,2)=g23b(x2)
      GII(17,2)=g23c(x2)
      GII(18,2)=dli2(x2)-dli2one
      GII(19,2)=dli2(x2/opx2)-dli2half
      GII(20,2)=dli2(-x2)-dli2mone
      GII(21,2)=dli2(1d0/2d0*omx2)
      GII(22,2)=dli3(x2)-dli3one
      GII(23,2)=dli3(1d0/opx2)-dli3half
      GII(24,2)=dli3(omx2/opx2)
      GII(25,2)=dli3(-x2)-dli3mone
      GII(26,2)=dli3(2d0*x2/opx2)-dli3one
      GII(27,2)=dli3(omx2)
      GII(28,2)=dli3(1d0/2d0*omx2)
      GII(29,2)=dli3(1d0/2d0*opx2)-dli3one
      GII(30,2)=log(x2)
      GII(31,2)=log(opx2)-rln2
      do i=1,32
        GIIdiff(i)=GII(i,1)-GII(i,2)
      enddo
      PLI1(1)=log(omx1)
      PLI1(2)=log(omx2)
      PLI1(3)=log(omx1x2)
      PLI1(4)=log(omz1)
      PLI1(5)=log(omz2)
      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      rtree1=0d0
      rloop1=0d0
      rloop2=0d0
      do block = 1, nBlocks
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      
      select case (block)
      
      case (1)
        ipass_block=1
        call set_flav_perm(5, (/ i4,i3,i1,i5,i2 /))
        call getqcdnorm(iix, partons, factor, 5, ipass_block, 1)
        call unset_flav_perm()
        if ( ipass_block == 0 ) cycle
        ipass=1
        rtree1=factor(:)*B1g0W(i4,i3,i1,i5,i2)
C       skip all but last to accumulate rtree
        if ( .not.isActive_flav() ) cycle
      
      case (2)
        ipass_block=1
        call set_flav_perm(5, (/ i4,i3,i1,i5,i2 /))
        call getqcdnorm(iix, partons, factor, 5, ipass_block, 2)
        call unset_flav_perm()
        if ( ipass_block == 0 ) cycle
        ipass=1
        do i=1,nAct_scl
          rloop1(i)=factor(i)*B1g1W(i4,i3,i1,i5,i2,muR2_scl(i))
        enddo
C       skip all but last to accumulate rloop
        if ( .not.isActive_flav() ) cycle
      
      case (3)
        ipass_block=1
        call set_flav_perm(5, (/ i4,i3,i1,i5,i2 /))
        call getqcdnorm(iix, partons, factor, 5, ipass_block, 3)
        call unset_flav_perm()
        if ( ipass_block == 0 ) cycle
        ipass=1
        do i=1,nAct_scl
          rloop2(i)=factor(i)*Bh1g1W(i4,i3,i1,i5,i2,muR2_scl(i))
        enddo
      
      end select
      
      dls12(:)  = 0d0
      dls13(:)  = 0d0
      dls134(:)  = 0d0
      dls14(:)  = 0d0
      dls15(:)  = 0d0
      dls23(:)  = 0d0
      dls24(:)  = 0d0
      dls25(:)  = 0d0
      dls34(:)  = 0d0
      dls35(:)  = 0d0
      dls45(:)  = 0d0
      do i=1,nAct_scl
        idmap = idmap_scl(i, withR=.true.)
        if (idmap == i) then
          dls12(i)  = log(muR2_scl(i)/abs(s12))
          dls13(i)  = log(muR2_scl(i)/abs(s13))
          dls134(i)  = log(muR2_scl(i)/abs(s134))
          dls14(i)  = log(muR2_scl(i)/abs(s14))
          dls15(i)  = log(muR2_scl(i)/abs(s15))
          dls23(i)  = log(muR2_scl(i)/abs(s23))
          dls24(i)  = log(muR2_scl(i)/abs(s24))
          dls25(i)  = log(muR2_scl(i)/abs(s25))
          dls34(i)  = log(muR2_scl(i)/abs(s34))
          dls35(i)  = log(muR2_scl(i)/abs(s35))
          dls45(i)  = log(muR2_scl(i)/abs(s45))
        else
          dls12(i)  = dls12(idmap)
          dls13(i)  = dls13(idmap)
          dls134(i)  = dls134(idmap)
          dls14(i)  = dls14(idmap)
          dls15(i)  = dls15(idmap)
          dls23(i)  = dls23(idmap)
          dls24(i)  = dls24(idmap)
          dls25(i)  = dls25(idmap)
          dls34(i)  = dls34(idmap)
          dls35(i)  = dls35(idmap)
          dls45(i)  = dls45(idmap)
        end if
      enddo
      dlmuF(:) = 0d0
      do i=1,nAct_scl
        idmap = idmap_scl(i, withR=.true., withF=.true.)
        if (idmap == i) then
          dlmuF(i) = log(muR2_scl(i)/muF2_scl(i))
        else
          dlmuF(i) = dlmuF(idmap)
        end if
      enddo
      if(ipass.eq.0)return
      if(ix.eq.1.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  + rloop2 * (  - 271.D0/36.D0 + 1.D0/6.D0*pi**2 )
      e0 = e0 + rloop1 * ( 7.D0/9.D0 )
      e0 = e0 + rtree1 * ( 46117.D0/2592.D0 + 19.D0/18.D0*dls134 - 31.D0
     &    /18.D0*zeta3 - 23.D0/24.D0*pi**2 - 1.D0/36.D0*pi**2*dls134 )
      e0 = e0 + dls34*rtree1 * ( 1043.D0/216.D0 - 1.D0/72.D0*pi**2 )
      e0 = e0 + dls34**2*rtree1 * ( 7.D0/18.D0 )
      e0 = e0 + dls13*rloop2 * ( 3.D0/4.D0 )
      e0 = e0 + dls13*rtree1 * ( 91.D0/36.D0 - 11.D0/72.D0*pi**2 )
      e0 = e0 + dls13*dls34*rtree1 * (  - 1.D0/8.D0 )
      e0 = e0 + dls13**2*rtree1 * ( 5.D0/36.D0 )
      e0 = e0 + d2x1*rtree1 * ( 5.D0/12.D0 )
      e0 = e0 + d1x1*rloop2 * ( 1 )
      e0 = e0 + d1x1*rtree1 * (  - 9.D0/4.D0 )
      e0 = e0 + d1x1*dls34*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + d1x1*dls13*rtree1 * (  - 5.D0/6.D0 )
      e0 = e0 + d0x1*rloop2 * (  - 11.D0/12.D0 )
      e0 = e0 + d0x1*rloop1 * ( 1.D0/6.D0 )
      e0 = e0 + d0x1*rtree1 * ( 110.D0/27.D0 - 5.D0/18.D0*pi**2 )
      e0 = e0 + d0x1*dls34*rtree1 * ( 31.D0/72.D0 )
      e0 = e0 + d0x1*dls34**2*rtree1 * ( 1.D0/12.D0 )
      e0 = e0 + d0x1*dls13*rloop2 * (  - 1 )
      e0 = e0 + d0x1*dls13*rtree1 * ( 9.D0/4.D0 )
      e0 = e0 + d0x1*dls13*dls34*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + d0x1*dls13**2*rtree1 * ( 5.D0/12.D0 )
      e0 = e0 + dlmuF*rloop2 * (  - 3.D0/4.D0 )
      e0 = e0 + dlmuF*rtree1 * ( 5.D0/8.D0 + 1.D0/12.D0*pi**2 )
      e0 = e0 + dlmuF*dls34*rtree1 * ( 1.D0/8.D0 )
      e0 = e0 + dlmuF*dls13*rtree1 * ( 1.D0/8.D0 )
      e0 = e0 + dlmuF*d1x1*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*rloop2 * ( 1 )
      e0 = e0 + dlmuF*d0x1*rtree1 * (  - 29.D0/24.D0 )
      e0 = e0 + dlmuF*d0x1*dls34*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + dlmuF*d0x1*dls13*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + dlmuF**2*rtree1 * ( 1.D0/8.D0 )
      e0 = e0 + dlmuF**2*d0x1*rtree1 * (  - 1.D0/6.D0 )
        elseif(ipole.eq.-1)then
          e0 =  + rloop2 * (  - 10.D0/3.D0 )
      e0 = e0 + rloop1 * ( 1.D0/3.D0 )
      e0 = e0 + rtree1 * ( 55.D0/54.D0 + 1.D0/36.D0*pi**2 )
      e0 = e0 + dls34*rloop2 * (  - 1 )
      e0 = e0 + dls34*rtree1 * ( 5.D0/18.D0 )
      e0 = e0 + dls13*rloop2 * (  - 1 )
      e0 = e0 + dls13*rtree1 * ( 5.D0/18.D0 )
      e0 = e0 - 2*Bh1g1Wp1
        elseif(ipole.eq.-2)then
          e0 =  + rloop2 * (  - 2 )
      e0 = e0 + rtree1 * (  - 61.D0/36.D0 )
      e0 = e0 + dls34*rtree1 * (  - 1.D0/2.D0 )
      e0 = e0 + dls13*rtree1 * (  - 1.D0/2.D0 )
        elseif(ipole.eq.-3)then
          e0 =  + rtree1 * (  - 7.D0/6.D0 )
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.1.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  + omz1**(-1)*omz2**(-1)*rloop2 * (  - 271.D0/36.D0 + 1.D
     &    0/6.D0*pi**2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rloop1 * ( 7.D0/9.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rtree1 * ( 46117.D0/2592.D0 + 19.D
     &    0/18.D0*dls134 - 31.D0/18.D0*zeta3 - 23.D0/24.D0*pi**2 - 1.D0/
     &    36.D0*pi**2*dls134 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls34*rtree1 * ( 1043.D0/216.D0
     &     - 1.D0/72.D0*pi**2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls34**2*rtree1 * ( 7.D0/18.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls13*rloop2 * ( 3.D0/4.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls13*rtree1 * ( 91.D0/36.D0 - 11.
     &    D0/72.D0*pi**2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls13*dls34*rtree1 * (  - 1.D0/8.D
     &    0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls13**2*rtree1 * ( 5.D0/36.D0 )
      e0 = e0 + omz2**(-1)*d2x1*rtree1 * ( 5.D0/12.D0 )
      e0 = e0 + omz2**(-1)*d1x1*rloop2 * ( 1 )
      e0 = e0 + omz2**(-1)*d1x1*rtree1 * (  - 9.D0/4.D0 )
      e0 = e0 + omz2**(-1)*d1x1*dls34*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + omz2**(-1)*d1x1*dls13*rtree1 * (  - 5.D0/6.D0 )
      e0 = e0 + omz2**(-1)*d0x1*rloop2 * (  - 11.D0/12.D0 )
      e0 = e0 + omz2**(-1)*d0x1*rloop1 * ( 1.D0/6.D0 )
      e0 = e0 + omz2**(-1)*d0x1*rtree1 * ( 110.D0/27.D0 - 5.D0/18.D0*
     &    pi**2 )
      e0 = e0 + omz2**(-1)*d0x1*dls34*rtree1 * ( 31.D0/72.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls34**2*rtree1 * ( 1.D0/12.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls13*rloop2 * (  - 1 )
      e0 = e0 + omz2**(-1)*d0x1*dls13*rtree1 * ( 9.D0/4.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls13*dls34*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls13**2*rtree1 * ( 5.D0/12.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*omz2**(-1)*rloop2 * (  - 3.D0/4.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * ( 5.D0/8.D0 + 1.D0/
     &    12.D0*pi**2 )
      e0 = e0 + dlmuF*omz1**(-1)*omz2**(-1)*dls34*rtree1 * ( 1.D0/8.D0
     &     )
      e0 = e0 + dlmuF*omz1**(-1)*omz2**(-1)*dls13*rtree1 * ( 1.D0/8.D0
     &     )
      e0 = e0 + dlmuF*omz2**(-1)*d1x1*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*rloop2 * ( 1 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*rtree1 * (  - 29.D0/24.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*dls34*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*dls13*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + dlmuF**2*omz1**(-1)*omz2**(-1)*rtree1 * ( 1.D0/8.D0 )
      e0 = e0 + dlmuF**2*omz2**(-1)*d0x1*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*rloop2 * ( 11.D0/12.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*rloop1 * (  - 1.D0/6.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*rtree1 * (  - 110.D0/27.D0
     &     + 5.D0/18.D0*pi**2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls34*rtree1 * (  - 31.D0/
     &    72.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls34**2*rtree1 * (  - 1.D
     &    0/12.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls13*rloop2 * ( 1 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls13*rtree1 * (  - 9.D0/
     &    4.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls13*dls34*rtree1 * ( 
     &     - 1.D0/6.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls13**2*rtree1 * (  - 5.D
     &    0/12.D0 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*omz2**(-1)*rloop2 * (  - 1 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * ( 29.D0/24.
     &    D0 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*omz2**(-1)*dls34*rtree1 * ( 1.D
     &    0/6.D0 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*omz2**(-1)*dls13*rtree1 * ( 1.D
     &    0/6.D0 )
      e0 = e0 + PLI1(4)*dlmuF**2*omz1**(-1)*omz2**(-1)*rtree1 * ( 1.D0/
     &    6.D0 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*omz2**(-1)*rloop2 * (  - 1.D0/2.D0
     &     )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*omz2**(-1)*rtree1 * ( 9.D0/8.D0 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*omz2**(-1)*dls34*rtree1 * ( 1.D0/
     &    12.D0 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*omz2**(-1)*dls13*rtree1 * ( 5.D0/
     &    12.D0 )
      e0 = e0 + PLI1(4)**2*dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * (  - 1.D
     &    0/6.D0 )
      e0 = e0 + PLI1(4)**3*omz1**(-1)*omz2**(-1)*rtree1 * (  - 5.D0/36.D
     &    0 )
        elseif(ipole.eq.-1)then
          e0 =  + omz1**(-1)*omz2**(-1) * (  - 2*Bh1g1Wp1 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rloop2 * (  - 10.D0/3.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rloop1 * ( 1.D0/3.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rtree1 * ( 55.D0/54.D0 + 1.D0/36.D
     &    0*pi**2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls34*rloop2 * (  - 1 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls34*rtree1 * ( 5.D0/18.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls13*rloop2 * (  - 1 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls13*rtree1 * ( 5.D0/18.D0 )
        elseif(ipole.eq.-2)then
          e0 =  + omz1**(-1)*omz2**(-1)*rloop2 * (  - 2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rtree1 * (  - 61.D0/36.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls34*rtree1 * (  - 1.D0/2.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls13*rtree1 * (  - 1.D0/2.D0 )
        elseif(ipole.eq.-3)then
          e0 =  + omz1**(-1)*omz2**(-1)*rtree1 * (  - 7.D0/6.D0 )
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.2.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.2.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.3.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  + rloop2 * (  - 1.D0/2.D0 + 1.D0/6.D0*x1**(-1) + 1.D0/2.
     &    D0*x1 )
      e0 = e0 + rloop1 * ( 1.D0/12.D0*x1**(-1) )
      e0 = e0 + rtree1 * (  - 143.D0/432.D0 + 157.D0/144.D0*x1**(-1) - 
     &    5.D0/72.D0*x1**(-1)*pi**2 - 5.D0/72.D0*pi**2 + 7.D0/432.D0*x1
     &     - 5.D0/72.D0*x1*pi**2 )
      e0 = e0 + dls34*rtree1 * ( 1.D0/12.D0 + 1.D0/9.D0*x1**(-1) - 1.D0/
     &    12.D0*x1 )
      e0 = e0 + dls34**2*rtree1 * ( 1.D0/24.D0*x1**(-1) )
      e0 = e0 + dls13*rloop2 * (  - 1.D0/2.D0 - 1.D0/2.D0*x1 )
      e0 = e0 + dls13*rtree1 * ( 11.D0/24.D0 + 5.D0/24.D0*x1**(-1) + 13.
     &    D0/16.D0*x1 )
      e0 = e0 + dls13*dls34*rtree1 * ( 1.D0/12.D0 + 1.D0/12.D0*x1 )
      e0 = e0 + dls13**2*rtree1 * ( 1.D0/6.D0 + 1.D0/24.D0*x1**(-1) + 1.
     &    D0/6.D0*x1 )
      e0 = e0 + d2x1*rtree1 * (  - 5.D0/12.D0 )
      e0 = e0 + d1x1*rloop2 * (  - 1 )
      e0 = e0 + d1x1*rtree1 * ( 9.D0/4.D0 )
      e0 = e0 + d1x1*dls34*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + d1x1*dls13*rtree1 * ( 5.D0/6.D0 )
      e0 = e0 + d0x1*rloop2 * ( 11.D0/12.D0 )
      e0 = e0 + d0x1*rloop1 * (  - 1.D0/6.D0 )
      e0 = e0 + d0x1*rtree1 * (  - 110.D0/27.D0 + 5.D0/18.D0*pi**2 )
      e0 = e0 + d0x1*dls34*rtree1 * (  - 31.D0/72.D0 )
      e0 = e0 + d0x1*dls34**2*rtree1 * (  - 1.D0/12.D0 )
      e0 = e0 + d0x1*dls13*rloop2 * ( 1 )
      e0 = e0 + d0x1*dls13*rtree1 * (  - 9.D0/4.D0 )
      e0 = e0 + d0x1*dls13*dls34*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + d0x1*dls13**2*rtree1 * (  - 5.D0/12.D0 )
      e0 = e0 + dlmuF*rloop2 * ( 1.D0/2.D0 + 1.D0/2.D0*x1 )
      e0 = e0 + dlmuF*rtree1 * (  - 5.D0/24.D0 - 17.D0/16.D0*x1 )
      e0 = e0 + dlmuF*dls34*rtree1 * (  - 1.D0/12.D0 - 1.D0/12.D0*x1 )
      e0 = e0 + dlmuF*dls13*rtree1 * (  - 1.D0/12.D0 - 1.D0/12.D0*x1 )
      e0 = e0 + dlmuF*d1x1*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*rloop2 * (  - 1 )
      e0 = e0 + dlmuF*d0x1*rtree1 * ( 29.D0/24.D0 )
      e0 = e0 + dlmuF*d0x1*dls34*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + dlmuF*d0x1*dls13*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + dlmuF**2*rtree1 * (  - 1.D0/12.D0 - 1.D0/12.D0*x1 )
      e0 = e0 + dlmuF**2*d0x1*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + GII(18,1)*omx1**(-1)*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + GII(18,1)*rtree1 * ( 1.D0/12.D0 + 1.D0/12.D0*x1**(-1)
     &     + 1.D0/12.D0*x1 )
      e0 = e0 + GII(30,1)*omx1**(-1)*rloop2 * ( 1 )
      e0 = e0 + GII(30,1)*omx1**(-1)*rtree1 * (  - 193.D0/72.D0 )
      e0 = e0 + GII(30,1)*omx1**(-1)*dls34*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + GII(30,1)*omx1**(-1)*dls13*rtree1 * (  - 1 )
      e0 = e0 + GII(30,1)*rloop2 * (  - 1.D0/2.D0 - 1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)*rtree1 * ( 61.D0/72.D0 + 11.D0/36.D0*x1**(-1)
     &     + 137.D0/144.D0*x1 )
      e0 = e0 + GII(30,1)*dls34*rtree1 * ( 1.D0/12.D0 + 1.D0/12.D0*x1 )
      e0 = e0 + GII(30,1)*dls13*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)*dlmuF*omx1**(-1)*rtree1 * ( 1.D0/2.D0 )
      e0 = e0 + GII(30,1)*dlmuF*rtree1 * (  - 1.D0/4.D0 - 1.D0/4.D0*x1
     &     )
      e0 = e0 + GII(30,1)**2*omx1**(-1)*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(30,1)**2*rtree1 * ( 1.D0/3.D0 + 1.D0/3.D0*x1 )
      e0 = e0 + GII(30,1)*PLI1(1)*omx1**(-1)*rtree1 * ( 1 )
      e0 = e0 + GII(30,1)*PLI1(1)*rtree1 * (  - 5.D0/12.D0 - 1.D0/12.D0
     &    *x1**(-1) - 5.D0/12.D0*x1 )
      e0 = e0 + PLI1(1)*rloop2 * ( 1.D0/2.D0 + 1.D0/2.D0*x1 )
      e0 = e0 + PLI1(1)*rtree1 * (  - 11.D0/24.D0 - 1.D0/3.D0*x1**(-1)
     &     - 13.D0/16.D0*x1 )
      e0 = e0 + PLI1(1)*dls34*rtree1 * (  - 1.D0/12.D0 - 1.D0/12.D0*x1
     &     )
      e0 = e0 + PLI1(1)*dls13*rtree1 * (  - 1.D0/3.D0 - 1.D0/12.D0*
     &    x1**(-1) - 1.D0/3.D0*x1 )
      e0 = e0 + PLI1(1)*dlmuF*rtree1 * ( 1.D0/12.D0 + 1.D0/12.D0*
     &    x1**(-1) + 1.D0/12.D0*x1 )
      e0 = e0 + PLI1(1)**2*rtree1 * ( 1.D0/6.D0 + 1.D0/24.D0*x1**(-1)
     &     + 1.D0/6.D0*x1 )
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.3.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  + omz2**(-1)*rloop2 * (  - 1.D0/2.D0 + 1.D0/6.D0*
     &    x1**(-1) + 1.D0/2.D0*x1 )
      e0 = e0 + omz2**(-1)*rloop1 * ( 1.D0/12.D0*x1**(-1) )
      e0 = e0 + omz2**(-1)*rtree1 * (  - 143.D0/432.D0 + 157.D0/144.D0*
     &    x1**(-1) - 5.D0/72.D0*x1**(-1)*pi**2 - 5.D0/72.D0*pi**2 + 7.D0
     &    /432.D0*x1 - 5.D0/72.D0*x1*pi**2 )
      e0 = e0 + omz2**(-1)*dls34*rtree1 * ( 1.D0/12.D0 + 1.D0/9.D0*
     &    x1**(-1) - 1.D0/12.D0*x1 )
      e0 = e0 + omz2**(-1)*dls34**2*rtree1 * ( 1.D0/24.D0*x1**(-1) )
      e0 = e0 + omz2**(-1)*dls13*rloop2 * (  - 1.D0/2.D0 - 1.D0/2.D0*x1
     &     )
      e0 = e0 + omz2**(-1)*dls13*rtree1 * ( 11.D0/24.D0 + 5.D0/24.D0*
     &    x1**(-1) + 13.D0/16.D0*x1 )
      e0 = e0 + omz2**(-1)*dls13*dls34*rtree1 * ( 1.D0/12.D0 + 1.D0/12.D
     &    0*x1 )
      e0 = e0 + omz2**(-1)*dls13**2*rtree1 * ( 1.D0/6.D0 + 1.D0/24.D0*
     &    x1**(-1) + 1.D0/6.D0*x1 )
      e0 = e0 + omz2**(-1)*d2x1*rtree1 * (  - 5.D0/12.D0 )
      e0 = e0 + omz2**(-1)*d1x1*rloop2 * (  - 1 )
      e0 = e0 + omz2**(-1)*d1x1*rtree1 * ( 9.D0/4.D0 )
      e0 = e0 + omz2**(-1)*d1x1*dls34*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + omz2**(-1)*d1x1*dls13*rtree1 * ( 5.D0/6.D0 )
      e0 = e0 + omz2**(-1)*d0x1*rloop2 * ( 11.D0/12.D0 )
      e0 = e0 + omz2**(-1)*d0x1*rloop1 * (  - 1.D0/6.D0 )
      e0 = e0 + omz2**(-1)*d0x1*rtree1 * (  - 110.D0/27.D0 + 5.D0/18.D0
     &    *pi**2 )
      e0 = e0 + omz2**(-1)*d0x1*dls34*rtree1 * (  - 31.D0/72.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls34**2*rtree1 * (  - 1.D0/12.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls13*rloop2 * ( 1 )
      e0 = e0 + omz2**(-1)*d0x1*dls13*rtree1 * (  - 9.D0/4.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls13*dls34*rtree1 * (  - 1.D0/6.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls13**2*rtree1 * (  - 5.D0/12.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*rloop2 * ( 1.D0/2.D0 + 1.D0/2.D0*x1 )
      e0 = e0 + dlmuF*omz2**(-1)*rtree1 * (  - 5.D0/24.D0 - 17.D0/16.D0
     &    *x1 )
      e0 = e0 + dlmuF*omz2**(-1)*dls34*rtree1 * (  - 1.D0/12.D0 - 1.D0/
     &    12.D0*x1 )
      e0 = e0 + dlmuF*omz2**(-1)*dls13*rtree1 * (  - 1.D0/12.D0 - 1.D0/
     &    12.D0*x1 )
      e0 = e0 + dlmuF*omz2**(-1)*d1x1*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*rloop2 * (  - 1 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*rtree1 * ( 29.D0/24.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*dls34*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*dls13*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + dlmuF**2*omz2**(-1)*rtree1 * (  - 1.D0/12.D0 - 1.D0/12.D
     &    0*x1 )
      e0 = e0 + dlmuF**2*omz2**(-1)*d0x1*rtree1 * ( 1.D0/6.D0 )
      e0 = e0 + GII(18,1)*omx1**(-1)*omz2**(-1)*rtree1 * (  - 1.D0/3.D0
     &     )
      e0 = e0 + GII(18,1)*omz2**(-1)*rtree1 * ( 1.D0/12.D0 + 1.D0/12.D0
     &    *x1**(-1) + 1.D0/12.D0*x1 )
      e0 = e0 + GII(30,1)*omx1**(-1)*omz2**(-1)*rloop2 * ( 1 )
      e0 = e0 + GII(30,1)*omx1**(-1)*omz2**(-1)*rtree1 * (  - 193.D0/72.
     &    D0 )
      e0 = e0 + GII(30,1)*omx1**(-1)*omz2**(-1)*dls34*rtree1 * (  - 1.D0
     &    /6.D0 )
      e0 = e0 + GII(30,1)*omx1**(-1)*omz2**(-1)*dls13*rtree1 * (  - 1 )
      e0 = e0 + GII(30,1)*omz2**(-1)*rloop2 * (  - 1.D0/2.D0 - 1.D0/2.D0
     &    *x1 )
      e0 = e0 + GII(30,1)*omz2**(-1)*rtree1 * ( 61.D0/72.D0 + 11.D0/36.D
     &    0*x1**(-1) + 137.D0/144.D0*x1 )
      e0 = e0 + GII(30,1)*omz2**(-1)*dls34*rtree1 * ( 1.D0/12.D0 + 1.D0/
     &    12.D0*x1 )
      e0 = e0 + GII(30,1)*omz2**(-1)*dls13*rtree1 * ( 1.D0/2.D0 + 1.D0/
     &    2.D0*x1 )
      e0 = e0 + GII(30,1)*dlmuF*omx1**(-1)*omz2**(-1)*rtree1 * ( 1.D0/2.
     &    D0 )
      e0 = e0 + GII(30,1)*dlmuF*omz2**(-1)*rtree1 * (  - 1.D0/4.D0 - 1.D
     &    0/4.D0*x1 )
      e0 = e0 + GII(30,1)**2*omx1**(-1)*omz2**(-1)*rtree1 * (  - 2.D0/3.
     &    D0 )
      e0 = e0 + GII(30,1)**2*omz2**(-1)*rtree1 * ( 1.D0/3.D0 + 1.D0/3.D0
     &    *x1 )
      e0 = e0 + GII(30,1)*PLI1(1)*omx1**(-1)*omz2**(-1)*rtree1 * ( 1 )
      e0 = e0 + GII(30,1)*PLI1(1)*omz2**(-1)*rtree1 * (  - 5.D0/12.D0
     &     - 1.D0/12.D0*x1**(-1) - 5.D0/12.D0*x1 )
      e0 = e0 + PLI1(1)*omz2**(-1)*rloop2 * ( 1.D0/2.D0 + 1.D0/2.D0*x1
     &     )
      e0 = e0 + PLI1(1)*omz2**(-1)*rtree1 * (  - 11.D0/24.D0 - 1.D0/3.D0
     &    *x1**(-1) - 13.D0/16.D0*x1 )
      e0 = e0 + PLI1(1)*omz2**(-1)*dls34*rtree1 * (  - 1.D0/12.D0 - 1.D0
     &    /12.D0*x1 )
      e0 = e0 + PLI1(1)*omz2**(-1)*dls13*rtree1 * (  - 1.D0/3.D0 - 1.D0/
     &    12.D0*x1**(-1) - 1.D0/3.D0*x1 )
      e0 = e0 + PLI1(1)*dlmuF*omz2**(-1)*rtree1 * ( 1.D0/12.D0 + 1.D0/
     &    12.D0*x1**(-1) + 1.D0/12.D0*x1 )
      e0 = e0 + PLI1(1)**2*omz2**(-1)*rtree1 * ( 1.D0/6.D0 + 1.D0/24.D0
     &    *x1**(-1) + 1.D0/6.D0*x1 )
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.4)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      endif
      qbBh1g2WmDISU = qbBh1g2WmDISU - bino(iix,partons,-e0)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      rtree1=0d0
      rloop1=0d0
      rloop2=0d0
      end do
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      return
      end
