************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qpbCh0g1WpDIST(ix,x1,x2,i3,i1,i4,i5,i2,i6,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(2)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qpbCh0g1WpDIST"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 4
      call ecuts_dis(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j1,j4,j2,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqpE30IF(i3,i1,i4,6)*Bh1g1W(j3,j1,j4,j2,j5,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1) ! Jacobian factor
        endif
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 5
      call ecuts_dis(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j1,j4,j2,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqpEh31IF(i3,i1,i4,6,muR2_scl(i))*B1g0W(j3,j1,j4,j2,j5)
          kinwt(i)=kinwt(i)/(1d0-z1) ! Jacobian factor
        endif
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qpbCh0g1WpDIST = - sum(wt)  ! minus in bino(-...)


      return


      end function qpbCh0g1WpDIST
