************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function ggAh4g1U_frag(ix,x1,x2,i1,i2,i3,i4,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(34)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello ggAh4g1U_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Ah4g1(i1,i2,i3,i4,muR2_scl(i))*(-1d0)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(1)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Ah4g1(i1,i2,i4,i3,muR2_scl(i))*(-1d0)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(2)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Ah4g1(i1,i3,i2,i4,muR2_scl(i))*(-1d0)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(3)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGIF(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(4)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21hGGFFqg_frag(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
        wt(5)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i4,i2,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGIF(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i4,i2,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(6)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i4,i2,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGFI(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i4,i2,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(7)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21hGGFFqg_frag(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(8)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGFI(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(9)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(10)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(11)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21hGGFFg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(12)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21hGGFFg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
        wt(13)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21hGGFFg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i3,i2,i4)*(wtcalX30)
        end do
        wt(14)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(15)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(16)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i3,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(17)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Ah4g1(i1,i2,i3,i4,muR2_scl(i))*(-1d0)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(18)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Ah4g1(i1,i2,i4,i3,muR2_scl(i))*(-1d0)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(19)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Ah4g1(i1,i3,i2,i4,muR2_scl(i))*(-1d0)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(20)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGIF(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(21)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21hGGFFqg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(22)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGIF(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i3,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(23)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGFI(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i3,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(24)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21hGGFFqg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
        wt(25)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGFI(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(26)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(27)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(28)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21hGGFFg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(29)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21hGGFFg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
        wt(30)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21hGGFFg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i3,i2,i4)*(wtcalX30)
        end do
        wt(31)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(32)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(33)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=A4g0(i1,i3,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(34)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)


      ggAh4g1U_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function ggAh4g1U_frag
