************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function gtgtBtt3g0T_frag(ix,x1,x2,i3,i1,i2,i4,i5,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(47)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello gtgtBtt3g0T_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Btt3g0(i3,i4,i1,i2,i5)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Btt3g0(i3,i4,i1,i2,i5)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*Bt2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*Bt2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullA30FF(i3,i4,i5,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullA30FF(i3,i4,i5,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*Bt2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*Bt2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i3,i1,i4,5)*Bt2g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i5,i1,i4,5)*Bt2g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i3,i2,i4,5)*Bt2g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i5,i2,i4,5)*Bt2g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Btt3g0(i3,i4,i1,i2,i5)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Btt3g0(i3,i4,i1,i2,i5)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i3,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*Bt2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*Bt2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i3,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullA30FF(i3,i4,i5,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullA30FF(i3,i4,i5,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i3,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(25)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*Bt2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(26)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i3,5)*Bt2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(27)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*Bt2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(28)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i3,i2,i4,5)*Bt2g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(29)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i5,i2,i4,5)*Bt2g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(30)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i3,i1,i4,5)*Bt2g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(31)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i5,i1,i4,5)*Bt2g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(32)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=Btt3g0(i3,i4,i1,i2,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(33)=bino_Dfrag(ix, if1, i5, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i4,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullA30FF(i3,i4,i5,5)*Bt2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(34)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i5,i1,i2,5)*Bt2g0(j3,j2,j4,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(35)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i5,i2,i1,5)*Bt2g0(j3,j1,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(36)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=Btt3g0(i3,i4,i1,i2,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(37)=bino_Dfrag(ix, if1, i3, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i4,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullA30FF(i3,i4,i5,5)*Bt2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(38)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i3,i1,i2,5)*Bt2g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(39)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i3,i2,i1,5)*Bt2g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(40)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=Btt3g0(i3,i4,i1,i2,i5)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(41)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i5,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*FullA30FF(i3,i4,i5,5)*Bt2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(42)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*FullA30FF(i3,i4,i5,5)*Bt2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(43)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i3,i1,i2,5)*Bt2g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(44)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i5,i1,i2,5)*Bt2g0(j3,j2,j4,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(45)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i3,i2,i1,5)*Bt2g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(46)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i5,i2,i1,5)*Bt2g0(j3,j1,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(47)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)


      gtgtBtt3g0T_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function gtgtBtt3g0T_frag
