************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qgC0g1U_frag(ix,x1,x2,i1,i2,i3,i4,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(28)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgC0g1U_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i4,i3,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQgtoqII2_frag(ix,x1,x2,i1,i3,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i4,i3,i2,i1)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQgtoqII2_frag(ix,x1,x2,i1,i3,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQgtoqII2_frag(ix,x1,x2,i1,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i3,i2,i4,i1)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQgtoqII2_frag(ix,x1,x2,i1,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21GGqtogII1_frag(ix,x1,x2,i1,i3,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21GGqtogII1_frag(ix,x1,x2,i1,i3,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21GGqtogII1_frag(ix,x1,x2,i1,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21GGqtogII1_frag(ix,x1,x2,i1,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ22hQGIFqgam_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ22hQGIFqgam_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i3,i2,i4)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -8 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21hQGIFqqp_frag(ix,x1,x2,i1,i3,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -8 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21hQGIFqqp_frag(ix,x1,x2,i1,i3,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i3,i2,i4)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i2,i3,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(13)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i4,i1,i2,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21GQqtogIF(ix,x1,x2,i4,i1,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i4,i1,i2,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(14)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i4,i2,i1,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21GQqtogIF(ix,x1,x2,i4,i1,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i4,i2,i1,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(15)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i4,i2,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21hGGFIgq_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i4,i2,i3,i1)*(wtcalX30)
        end do
        wt(16)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i4,i2,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21hQGIFqqp_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i4,i2,i3,i1)*(wtcalX30)
        end do
        wt(17)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i4,i3,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i4,i3,i2,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(18)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i4,i3,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21hGGFIgq_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i4,i3,i2,i1)*(wtcalX30)
        end do
        wt(19)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i4,i3,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21hQGFFqqp_frag(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i4,i3,i2,i1)*(wtcalX30)
        end do
        wt(20)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i2,i3,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(21)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i2,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i3,i2,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(22)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i4,i1,i2,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21GQqtogIF(ix,x1,x2,i3,i1,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i4,i1,i2,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(23)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i4,i2,i1,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21GQqtogIF(ix,x1,x2,i3,i1,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i4,i2,i1,i3)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(24)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i2,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21hGGFIgq_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i2,i4,i1)*(wtcalX30)
        end do
        wt(25)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i4,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21hGGFIgq_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i4,i2,i1)*(wtcalX30)
        end do
        wt(26)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i2,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21hQGIFqqp_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i2,i4,i1)*(wtcalX30)
        end do
        wt(27)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i4,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf2 ** 2 )
     .  *rJ21hQGFFqqp_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i4,i2,i1)*(wtcalX30)
        end do
        wt(28)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)


      qgC0g1U_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function qgC0g1U_frag
