************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qgtBt2g1U_frag(ix,x1,x2,i1,i2,i3,i4,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(36)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgtBt2g1U_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag_ho(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_Bt2g1(i1,i2,i3,i4,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21GQFFgq_frag(ix,x1,x2,i1,i4,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QGIF_frag(ix,x1,x2,i1,i4,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QQIFqq_frag(ix,x1,x2,i1,i4,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QGFIgq_frag(ix,x1,x2,i1,i4,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QGII_frag(ix,x1,x2,i1,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ22QQIFqgam_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QQIFqq_frag(ix,x1,x2,i1,i4,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ22QQIFqgam_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QQIFqq_frag(ix,x1,x2,i1,i4,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i3,i2,i4)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ22QQIFqgam_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i3,i2,i4)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Bt2g1(i1,i2,i3,i4,muR2_scl(i))*(+( -Qf1 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(12)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QQIFqq_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(13)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf1 ** 2 )
     .  *rJ21GQFFgq_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(14)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf1 ** 2 )
     .  *rJ21QGIF(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(15)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf1 ** 2 )
     .  *rJ21QQIFqq_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i1,i3,i2,i4)*(wtcalX30)
        end do
        wt(16)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf1 ** 2 )
     .  *rJ21QGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(17)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf1 ** 2 )
     .  *rJ21QQIFqq_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(18)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf1 ** 2 )
     .  *rJ21QGFIgq_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(19)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Bt2g1(i1,i2,i3,i4,muR2_scl(i))*(-1d0)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(20)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(21)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGFFqg_frag(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(22)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGIFqg_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(23)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(24)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGFI(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(25)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i1,i3,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(26)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(27)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i2,i3,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(28)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i2,i3,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(29)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGFFgg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(30)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIFqg_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i1,i3,i2,i4)*(wtcalX30)
        end do
        wt(31)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0/2d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=Bt2g0(i2,i3,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(32)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIFqg_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(33)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0/2d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=Bt2g0(i2,i3,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(34)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGFIgg_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(35)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIFqg_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(36)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)


      qgtBt2g1U_frag = - sum(wt)  ! minus in bino(-...)


      return


      contains


      real(8) function poles_Bt2g1(j1,j2,j3,j4,muR2,ieps)
      integer :: j1, j2, j3, j4, ieps
      real(8) :: rln1, rln2, rln3, rln4, rln5, muR2
      real(8) :: ref
      integer :: ieorder, ieorder_sav
      common /order/ieorder
      rln1 = log(abs(s4(j1,j2))/muR2)
      rln2 = log(abs(s4(j1,j3))/muR2)
      rln3 = log(abs(s4(j1,j4))/muR2)
      rln4 = log(abs(s4(j2,j4))/muR2)
      rln5 = log(abs(s4(j3,j4))/muR2)
      select case (ieps)
      case(-2)
        poles_Bt2g1 = B2g0(j1, j2, j3, j4) + B2g0(j1, j3, j2, j4) + 3 * Bt2g0(j1
     #, j2, j3, j4)
      case(-1)
        poles_Bt2g1 = -0.2D1 * (-0.3D1 / 0.4D1 + rln3 / 0.2D1) * B2g0(j1, j2, j3
     #, j4) - 0.2D1 * (-0.3D1 / 0.4D1 + rln3 / 0.2D1) * B2g0(j1, j3, j2,
     # j4) - 0.2D1 * (-0.31D2 / 0.12D2 + rln1 / 0.2D1 + rln5 / 0.2D1 + r
     #ln2 / 0.2D1 + rln4 / 0.2D1 - rln3 / 0.2D1) * Bt2g0(j1, j2, j3, j4)
      case(0)
        poles_Bt2g1 = Bt2g1(j1,j2,j3,j4,muR2)
      case default
        stop "poles_Bt2g1: unintended case"
      end select
C ATTENTION: this only works on a single thread!
#ifdef DEBUG_POLES
        ieorder_sav = ieorder 
        ieorder = ieps 
        ref = Bt2g1(j1,j2,j3,j4,muR2)
        ieorder = ieorder_sav 
        if ( abs(poles_Bt2g1)+abs(ref) > 0d0 ) then 
          if ( abs((poles_Bt2g1-ref)/(poles_Bt2g1+ref)) > 1d-6 ) then 
            print*, "Bt2g1 pole check failed", ieps
          end if
        end if
#endif
      end function poles_Bt2g1


      end function qgtBt2g1U_frag
