************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qqpCh0g1GT_frag(ix,x1,x2,i1,i3,i2,i4,i5,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(6)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qqpCh0g1GT_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 4
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqpE30IF(i3,i1,i4,5)*f2Bh1g1G(j2,j1,j3,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 5
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqpEh31IF(i3,i1,i4,5,muR2_scl(i))*f2B1g0G(j2,j1,j3,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 4
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqpE30IF(i4,i2,i3,5)*f1Bh1g1G(j1,j2,j3,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 5
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqpEh31IF(i4,i2,i3,5,muR2_scl(i))*f1B1g0G(j1,j2,j3,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 4
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+( Qf1 ** 2 / 0.2D1 ))*FullqA30IF(i1,i5,i4,5)*Ch0g1(j3,j2,j4,j1,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* BLOCK 4
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j3,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+( Qf2 ** 2 / 0.2D1 ))*FullqA30IF(i2,i5,i3,5)*Ch0g1(j4,j2,j3,j1,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qqpCh0g1GT_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function qqpCh0g1GT_frag
