************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qbgC1g0XTNLO_frag(ix,x1,x2,i3,i1,i4,i5,i2,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(3)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qbgC1g0XTNLO_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C1g0X(i3,i1,i4,i5,i2)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQFFqgam_frag(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C1g0X(i3,i1,i4,i5,i2)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQFFqgam_frag(ix,x1,x2,i5,i4,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C1g0X(i3,i1,i4,i5,i2)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)


      qbgC1g0XTNLO_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function qbgC1g0XTNLO_frag
