************************************************************************
*
*  generated using makefortRR on 2025-02-16
*
      function qgBt3g0GXSNLO_frag(i1,i2,i3,i4,i5,i6)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      dimension wt(4)
      double precision partons(nMax_scl)
      double precision facnorm(nMax_scl)
      dimension jpass(4)
*      write(*,*)" hello qgBt3g0GXSNLO_frag"

      ix=1

      wt=0d0
      partons=0d0
      facnorm=0d0
      jpass=0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(1)=1
        call set_flav_perm(5, (/ j1,j3,j4,j2,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        wt(1)=-1d0*FullqgA30II(i1,i2,i5,6)*B2g0G(j1,j3,j4,j2,j5)
        wt(1)=bino(ix,partons,-wt(1)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(2)=1
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        wt(2)=+1d0*qd30IF(i1,i3,i4,6)*Bt2g0G(j1,j2,j3,j4,j5)
        wt(2)=bino(ix,partons,-wt(2)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i4] = j4, [i4, i3] = j4, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i5,i4,i3/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(3)=1
        call set_flav_perm(5, (/ j1,j2,j4,j3,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        wt(3)=+1d0*d30FF(i5,i4,i3,6)*Bt2g0G(j1,j2,j4,j3,j5)
        wt(3)=bino(ix,partons,-wt(3)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i4 = j5, [i1] = j1, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i1,i5,i6/), (/i1,i2,i6,i3,i4/), ipass, frag=(/i5,i6/))
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(4)=1
        call set_flav_perm(5, (/ j3,j2,j5,j4,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(4)=+( Qf1 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i5,6)*Bt3g0(j3,j2,j5,j4,j1)
        wt(4)=bino(ix,partons,-wt(4)*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgBt3g0GXSNLO_frag = - sum(wt)  ! minus in bino(-...)


      return
      end function qgBt3g0GXSNLO_frag
