************************************************************************
*  generated using makeformVV on 2025-02-16
*
      function Ah2g2H2U(iix,xx1,xx2,i1,i2,i3,i4,
     .rscale2,fscale2)
      use Constants_mod
      use KinData_mod
      use Scales_mod
      use Flavour_mod, only: isActive_flav,set_flav_perm,unset_flav_perm
      implicit double precision (a-h,o-z)
      integer :: nBlocks, block
      double precision rloop1(nMax_scl)
      double precision rloop2(nMax_scl)
      double precision rtree1(nMax_scl)
      double precision dlmuF(nMax_scl)
      double precision dls12(nMax_scl)
      double precision dls13(nMax_scl)
      double precision dls14(nMax_scl)
      double precision dls23(nMax_scl)
      double precision dls24(nMax_scl)
      double precision dls34(nMax_scl)
      double precision e0(nMax_scl)
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      logical jflag
      common /order2l/ipole
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /distomx/ dd0x1,dd1x1,dd2x1,dd3x1,dd0x2,dd1x2,dd2x2,dd3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ zz1,zz2
!$omp threadprivate(/parfrac/)
      dimension GII(32,2),GIIdiff(32),PLI1(5)
      parameter(dli2one=1.6449340668482264365d0)
      parameter(dli2mone=-.82246703342411321826d0)
      parameter(dli2half=0.58224052646501250592d0)
      parameter(dli3one=1.2020569031595942854d0)
      parameter(dli3mone=-.90154267736969571405d0)
      parameter(dli3half=0.53721319360804020089d0)
      dimension ixSwap(4)
      data      ixSwap /1,3,2,4/
      Ah2g2H2U = 0d0
      ipass=1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.0)return
      ipass=0
      jflag = .false.
      if ( i1.eq.1 .and. i2.eq.2 ) then
        ix=iix
        x1=xx1
        x2=xx2
        z1=zz1
        z2=zz2
        d0x1=dd0x1
        d1x1=dd1x1
        d2x1=dd2x1
        d3x1=dd3x1
        d0x2=dd0x2
        d1x2=dd1x2
        d2x2=dd2x2
        d3x2=dd3x2
      elseif ( i1.eq.2 .and. i2.eq.1 ) then
        ix=ixSwap(iix)
        x1=xx2
        x2=xx1
        z1=zz2
        z2=zz1
        d0x1=dd0x2
        d1x1=dd1x2
        d2x1=dd2x2
        d3x1=dd3x2
        d0x2=dd0x1
        d1x2=dd1x1
        d2x2=dd2x1
        d3x2=dd3x1
      else
        write(*,*) "Ah2g2H2U: bad input ",i1,i2,i3,i4 
        stop
      endif
      s12=s4(i1,i2)
      s13=s4(i1,i3)
      s14=s4(i1,i4)
      s23=s4(i2,i3)
      s24=s4(i2,i4)
      s34=s4(i3,i4)
      nBlocks=3
      e0=0d0
      GII=0d0
      GIIdiff=0d0
      if(ix.eq.4)then
          small=1d-12
          dsmall = dmin1(abs(1d0-x1),abs(1d0-x2),
     .                   abs(1d0-x1*x2),abs(x1-x2))
          if(dsmall.lt.small)call VVdebug(x1,x2)
      endif
      omz1 = 1d0-z1
      omz2 = 1d0-z2
      opx1 = 1d0+x1
      omx1 = 1d0-x1
      opx2 = 1d0+x2
      omx2 = 1d0-x2
      x1px2 = x1+x2
      x1mx2 = x1-x2
      omx1x2 = 1d0-x1*x2
      opx1x2 = 1d0+x1*x2
      GII(1,1)=g13(x1,x2)-g13(1d0,x2)-g13(x1,1d0)+g13(1d0,1d0)
      GII(2,1)=g14(x1,x2)-g14(1d0,x2)-g14(x1,1d0)+g14(1d0,1d0)
      GII(3,1)=g22(x1,x2)-g22(1d0,x2)-g22(x1,1d0)+g22(1d0,1d0)
      GII(4,1)=g23(x1,x2)-g23(1d0,x2)-g23(x1,1d0)+g23(1d0,1d0)
      GII(5,1)=g24(x1,x2)-g24(1d0,x2)-g24(x1,1d0)+g24(1d0,1d0)
      GII(6,1)=g25(x1,x2)-g25(1d0,x2)-g25(x1,1d0)+g25(1d0,1d0)
      GII(7,1)=dli2(x1mx2/opx1)-dli2(omx2/2d0)-dli2(-omx1/opx1)
      GII(8,1)=dli2(x1mx2/x1px2)-dli2(omx2/opx2)-dli2(-omx1/opx1)
      GII(9,1)=dli2(x1*opx2/opx1)-dli2(opx2/2d0)-dli2(2d0*x1/opx1)
     .+dli2one
      GII(10,1)=dli2(opx1*omx1/opx1x2)-dli2(omx1)
      GII(11,1)=dli2(-x1/x2)-dli2(-1d0/x2)-dli2(-x1)+dli2mone
      GII(12,1)=dli2(-omx1/x1px2)-dli2(-omx1/opx1)
      GII(13,1)=dli2(omx1x2)-dli2(omx2)-dli2(omx1)
      GII(14,1)=log(opx1x2)-log(opx2)-log(opx1)+rln2
      GII(15,1)=log(x1px2)-log(opx2)-log(opx1)+rln2
      GII(1,2)=g13(x2,x1)-g13(1d0,x1)-g13(x2,1d0)+g13(1d0,1d0)
      GII(2,2)=g14(x2,x1)-g14(1d0,x1)-g14(x2,1d0)+g14(1d0,1d0)
      GII(3,2)=g22(x2,x1)-g22(1d0,x1)-g22(x2,1d0)+g22(1d0,1d0)
      GII(4,2)=g23(x2,x1)-g23(1d0,x1)-g23(x2,1d0)+g23(1d0,1d0)
      GII(5,2)=g24(x2,x1)-g24(1d0,x1)-g24(x2,1d0)+g24(1d0,1d0)
      GII(6,2)=g25(x2,x1)-g25(1d0,x1)-g25(x2,1d0)+g25(1d0,1d0)
      GII(7,2)=dli2(-x1mx2/opx2)-dli2(omx1/2d0)-dli2(-omx2/opx2)
      GII(8,2)=dli2(-x1mx2/x1px2)-dli2(omx1/opx1)-dli2(-omx2/opx2)
      GII(9,2)=dli2(x2*opx1/opx2)-dli2(opx1/2d0)-dli2(2d0*x2/opx2)
     .+dli2one
      GII(10,2)=dli2(opx2*omx2/opx1x2)-dli2(omx2)
      GII(11,2)=dli2(-x2/x1)-dli2(-1d0/x1)-dli2(-x2)+dli2mone
      GII(12,2)=dli2(-omx2/x1px2)-dli2(-omx2/opx2)
      GII(13,2)=dli2(omx1x2)-dli2(omx1)-dli2(omx2)
      GII(14,2)=GII(14,1)
      GII(15,2)=GII(15,1)
      GII(16,1)=g23b(x1)
      GII(17,1)=g23c(x1)
      GII(18,1)=dli2(x1)-dli2one
      GII(19,1)=dli2(x1/opx1)-dli2half
      GII(20,1)=dli2(-x1)-dli2mone
      GII(21,1)=dli2(1d0/2d0*omx1)
      GII(22,1)=dli3(x1)-dli3one
      GII(23,1)=dli3(1d0/opx1)-dli3half
      GII(24,1)=dli3(omx1/opx1)
      GII(25,1)=dli3(-x1)-dli3mone
      GII(26,1)=dli3(2d0*x1/opx1)-dli3one
      GII(27,1)=dli3(omx1)
      GII(28,1)=dli3(1d0/2d0*omx1)
      GII(29,1)=dli3(1d0/2d0*opx1)-dli3one
      GII(30,1)=log(x1)
      GII(31,1)=log(opx1)-rln2
      GII(16,2)=g23b(x2)
      GII(17,2)=g23c(x2)
      GII(18,2)=dli2(x2)-dli2one
      GII(19,2)=dli2(x2/opx2)-dli2half
      GII(20,2)=dli2(-x2)-dli2mone
      GII(21,2)=dli2(1d0/2d0*omx2)
      GII(22,2)=dli3(x2)-dli3one
      GII(23,2)=dli3(1d0/opx2)-dli3half
      GII(24,2)=dli3(omx2/opx2)
      GII(25,2)=dli3(-x2)-dli3mone
      GII(26,2)=dli3(2d0*x2/opx2)-dli3one
      GII(27,2)=dli3(omx2)
      GII(28,2)=dli3(1d0/2d0*omx2)
      GII(29,2)=dli3(1d0/2d0*opx2)-dli3one
      GII(30,2)=log(x2)
      GII(31,2)=log(opx2)-rln2
      do i=1,32
        GIIdiff(i)=GII(i,1)-GII(i,2)
      enddo
      PLI1(1)=log(omx1)
      PLI1(2)=log(omx2)
      PLI1(3)=log(omx1x2)
      PLI1(4)=log(omz1)
      PLI1(5)=log(omz2)
      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      rtree1=0d0
      rloop1=0d0
      rloop2=0d0
      do block = 1, nBlocks
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      
      select case (block)
      
      case (1)
        ipass_block=1
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(iix, partons, factor, 4, ipass_block, 1)
        call unset_flav_perm()
        if ( ipass_block == 0 ) cycle
        ipass=1
        rtree1=factor(:)*A2g0H2(i1,i2,i3,i4)
C       skip all but last to accumulate rtree
        if ( .not.isActive_flav() ) cycle
      
      case (2)
        ipass_block=1
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(iix, partons, factor, 4, ipass_block, 2)
        call unset_flav_perm()
        if ( ipass_block == 0 ) cycle
        ipass=1
        do i=1,nAct_scl
          rloop1(i)=factor(i)*A2g1H2(i1,i2,i3,i4,muR2_scl(i))
        enddo
C       skip all but last to accumulate rloop
        if ( .not.isActive_flav() ) cycle
      
      case (3)
        ipass_block=1
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(iix, partons, factor, 4, ipass_block, 3)
        call unset_flav_perm()
        if ( ipass_block == 0 ) cycle
        ipass=1
        do i=1,nAct_scl
          rloop2(i)=factor(i)*Ah2g1H2(i1,i2,i3,i4,muR2_scl(i))
        enddo
      
      end select
      
      dls12(:)  = 0d0
      dls13(:)  = 0d0
      dls14(:)  = 0d0
      dls23(:)  = 0d0
      dls24(:)  = 0d0
      dls34(:)  = 0d0
      do i=1,nAct_scl
        idmap = idmap_scl(i, withR=.true.)
        if (idmap == i) then
          dls12(i)  = log(muR2_scl(i)/abs(s12))
          dls13(i)  = log(muR2_scl(i)/abs(s13))
          dls14(i)  = log(muR2_scl(i)/abs(s14))
          dls23(i)  = log(muR2_scl(i)/abs(s23))
          dls24(i)  = log(muR2_scl(i)/abs(s24))
          dls34(i)  = log(muR2_scl(i)/abs(s34))
        else
          dls12(i)  = dls12(idmap)
          dls13(i)  = dls13(idmap)
          dls14(i)  = dls14(idmap)
          dls23(i)  = dls23(idmap)
          dls24(i)  = dls24(idmap)
          dls34(i)  = dls34(idmap)
        end if
      enddo
      dlmuF(:) = 0d0
      do i=1,nAct_scl
        idmap = idmap_scl(i, withR=.true., withF=.true.)
        if (idmap == i) then
          dlmuF(i) = log(muR2_scl(i)/muF2_scl(i))
        else
          dlmuF(i) = dlmuF(idmap)
        end if
      enddo
      if(ipass.eq.0)return
      if(ix.eq.1.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  + rloop2 * (  - pi**2 )
      e0 = e0 + rtree1 * ( 82.D0/81.D0 - 13.D0/18.D0*zeta3 + 337.D0/216.
     &    D0*pi**2 )
      e0 = e0 + dls12*rloop2 * ( 11.D0/3.D0 )
      e0 = e0 + dls12*rloop1 * (  - 2.D0/3.D0 )
      e0 = e0 + dls12*rtree1 * (  - 11.D0/6.D0 + 10.D0/9.D0*pi**2 )
      e0 = e0 + dls12**2*rtree1 * (  - 11.D0/3.D0 )
      e0 = e0 + dls12**3*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d2x2*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + d1x2*rloop2 * ( 2 )
      e0 = e0 + d1x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + d1x2*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d0x2*rtree1 * ( 28.D0/27.D0 - 1.D0/9.D0*pi**2 )
      e0 = e0 + d0x2*dls12*rloop2 * (  - 2 )
      e0 = e0 + d0x2*dls12*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + d0x2*dls12**2*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + d2x1*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + d1x1*rloop2 * ( 2 )
      e0 = e0 + d1x1*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + d1x1*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d1x1*d0x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d0x1*rtree1 * ( 28.D0/27.D0 - 1.D0/9.D0*pi**2 )
      e0 = e0 + d0x1*dls12*rloop2 * (  - 2 )
      e0 = e0 + d0x1*dls12*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + d0x1*dls12**2*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + d0x1*d1x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d0x1*d0x2*rloop2 * (  - 2 )
      e0 = e0 + d0x1*d0x2*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + d0x1*d0x2*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + dlmuF*rloop2 * (  - 11.D0/3.D0 )
      e0 = e0 + dlmuF*rloop1 * ( 2.D0/3.D0 )
      e0 = e0 + dlmuF*rtree1 * ( 11.D0/6.D0 - 1.D0/9.D0*pi**2 )
      e0 = e0 + dlmuF*dls12**2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + dlmuF*d1x2*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x2*rloop2 * ( 2 )
      e0 = e0 + dlmuF*d0x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + dlmuF*d0x2*dls12*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*d1x1*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*rloop2 * ( 2 )
      e0 = e0 + dlmuF*d0x1*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + dlmuF*d0x1*dls12*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*d0x2*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF**2*rtree1 * ( 11.D0/3.D0 )
      e0 = e0 + dlmuF**2*d0x2*rtree1 * (  - 5.D0/3.D0 )
      e0 = e0 + dlmuF**2*d0x1*rtree1 * (  - 5.D0/3.D0 )
        elseif(ipole.eq.-1)then
          e0 =  + rloop2 * (  - 11.D0/3.D0 )
      e0 = e0 + rloop1 * ( 2.D0/3.D0 )
      e0 = e0 + rtree1 * ( 155.D0/108.D0 - 1.D0/36.D0*pi**2 )
      e0 = e0 + dls12*rloop2 * (  - 2 )
      e0 = e0 + dls12*rtree1 * ( 5.D0/9.D0 )
      e0 = e0 - 2*Ah2g1H2p1
        elseif(ipole.eq.-2)then
          e0 =  + rloop2 * (  - 2 )
      e0 = e0 + rtree1 * (  - 61.D0/18.D0 )
      e0 = e0 + dls12*rtree1 * (  - 5.D0/3.D0 )
        elseif(ipole.eq.-3)then
          e0 =  + rtree1 * (  - 11.D0/6.D0 )
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.1.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  + omz1**(-1)*omz2**(-1)*rloop2 * (  - pi**2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rtree1 * ( 82.D0/81.D0 - 13.D0/18.
     &    D0*zeta3 + 337.D0/216.D0*pi**2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls12*rloop2 * ( 11.D0/3.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls12*rloop1 * (  - 2.D0/3.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls12*rtree1 * (  - 11.D0/6.D0 + 
     &    10.D0/9.D0*pi**2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls12**2*rtree1 * (  - 11.D0/3.D0
     &     )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls12**3*rtree1 * (  - 2.D0/3.D0
     &     )
      e0 = e0 + omz1**(-1)*d2x2*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + omz1**(-1)*d1x2*rloop2 * ( 2 )
      e0 = e0 + omz1**(-1)*d1x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + omz1**(-1)*d1x2*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + omz1**(-1)*d0x2*rtree1 * ( 28.D0/27.D0 - 1.D0/9.D0*
     &    pi**2 )
      e0 = e0 + omz1**(-1)*d0x2*dls12*rloop2 * (  - 2 )
      e0 = e0 + omz1**(-1)*d0x2*dls12*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + omz1**(-1)*d0x2*dls12**2*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + omz2**(-1)*d2x1*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + omz2**(-1)*d1x1*rloop2 * ( 2 )
      e0 = e0 + omz2**(-1)*d1x1*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + omz2**(-1)*d1x1*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + omz2**(-1)*d0x1*rtree1 * ( 28.D0/27.D0 - 1.D0/9.D0*
     &    pi**2 )
      e0 = e0 + omz2**(-1)*d0x1*dls12*rloop2 * (  - 2 )
      e0 = e0 + omz2**(-1)*d0x1*dls12*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls12**2*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + d1x1*d0x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d0x1*d1x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d0x1*d0x2*rloop2 * (  - 2 )
      e0 = e0 + d0x1*d0x2*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + d0x1*d0x2*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*omz2**(-1)*rloop2 * (  - 11.D0/3.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*omz2**(-1)*rloop1 * ( 2.D0/3.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * ( 11.D0/6.D0 - 1.D0
     &    /9.D0*pi**2 )
      e0 = e0 + dlmuF*omz1**(-1)*omz2**(-1)*dls12**2*rtree1 * ( 2.D0/3.D
     &    0 )
      e0 = e0 + dlmuF*omz1**(-1)*d1x2*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*d0x2*rloop2 * ( 2 )
      e0 = e0 + dlmuF*omz1**(-1)*d0x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*d0x2*dls12*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d1x1*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*rloop2 * ( 2 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*dls12*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*d0x2*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF**2*omz1**(-1)*omz2**(-1)*rtree1 * ( 11.D0/3.D0 )
      e0 = e0 + dlmuF**2*omz1**(-1)*d0x2*rtree1 * (  - 5.D0/3.D0 )
      e0 = e0 + dlmuF**2*omz2**(-1)*d0x1*rtree1 * (  - 5.D0/3.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*rtree1 * (  - 28.D0/27.D0
     &     + 1.D0/9.D0*pi**2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls12*rloop2 * ( 2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls12*rtree1 * (  - 10.D0/
     &    9.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*omz2**(-1)*dls12**2*rtree1 * (  - 1.D
     &    0/3.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*d1x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*d0x2*rloop2 * ( 2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*d0x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*d0x2*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*omz2**(-1)*rloop2 * (  - 2 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * ( 10.D0/9.D
     &    0 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*omz2**(-1)*dls12*rtree1 * ( 
     &     - 4.D0/3.D0 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*d0x2*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + PLI1(4)*dlmuF**2*omz1**(-1)*omz2**(-1)*rtree1 * ( 5.D0/
     &    3.D0 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*omz2**(-1)*rloop2 * (  - 1 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*omz2**(-1)*rtree1 * ( 5.D0/9.D0 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*omz2**(-1)*dls12*rtree1 * ( 1.D0/
     &    3.D0 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*d0x2*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + PLI1(4)**2*dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * ( 2.D0/
     &    3.D0 )
      e0 = e0 + PLI1(4)**3*omz1**(-1)*omz2**(-1)*rtree1 * (  - 1.D0/9.D0
     &     )
      e0 = e0 + PLI1(4)**2*PLI1(5)*omz1**(-1)*omz2**(-1)*rtree1 * (  - 
     &    1.D0/3.D0 )
      e0 = e0 + PLI1(4)*PLI1(5)*omz1**(-1)*omz2**(-1)*rloop2 * (  - 2 )
      e0 = e0 + PLI1(4)*PLI1(5)*omz1**(-1)*omz2**(-1)*rtree1 * ( 10.D0/
     &    9.D0 )
      e0 = e0 + PLI1(4)*PLI1(5)*omz1**(-1)*omz2**(-1)*dls12*rtree1 * ( 
     &    2.D0/3.D0 )
      e0 = e0 + PLI1(4)*PLI1(5)*dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * ( 
     &    4.D0/3.D0 )
      e0 = e0 + PLI1(4)*PLI1(5)**2*omz1**(-1)*omz2**(-1)*rtree1 * (  - 
     &    1.D0/3.D0 )
      e0 = e0 + PLI1(5)*omz1**(-1)*omz2**(-1)*rtree1 * (  - 28.D0/27.D0
     &     + 1.D0/9.D0*pi**2 )
      e0 = e0 + PLI1(5)*omz1**(-1)*omz2**(-1)*dls12*rloop2 * ( 2 )
      e0 = e0 + PLI1(5)*omz1**(-1)*omz2**(-1)*dls12*rtree1 * (  - 10.D0/
     &    9.D0 )
      e0 = e0 + PLI1(5)*omz1**(-1)*omz2**(-1)*dls12**2*rtree1 * (  - 1.D
     &    0/3.D0 )
      e0 = e0 + PLI1(5)*omz2**(-1)*d1x1*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + PLI1(5)*omz2**(-1)*d0x1*rloop2 * ( 2 )
      e0 = e0 + PLI1(5)*omz2**(-1)*d0x1*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + PLI1(5)*omz2**(-1)*d0x1*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + PLI1(5)*dlmuF*omz1**(-1)*omz2**(-1)*rloop2 * (  - 2 )
      e0 = e0 + PLI1(5)*dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * ( 10.D0/9.D
     &    0 )
      e0 = e0 + PLI1(5)*dlmuF*omz1**(-1)*omz2**(-1)*dls12*rtree1 * ( 
     &     - 4.D0/3.D0 )
      e0 = e0 + PLI1(5)*dlmuF*omz2**(-1)*d0x1*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + PLI1(5)*dlmuF**2*omz1**(-1)*omz2**(-1)*rtree1 * ( 5.D0/
     &    3.D0 )
      e0 = e0 + PLI1(5)**2*omz1**(-1)*omz2**(-1)*rloop2 * (  - 1 )
      e0 = e0 + PLI1(5)**2*omz1**(-1)*omz2**(-1)*rtree1 * ( 5.D0/9.D0 )
      e0 = e0 + PLI1(5)**2*omz1**(-1)*omz2**(-1)*dls12*rtree1 * ( 1.D0/
     &    3.D0 )
      e0 = e0 + PLI1(5)**2*omz2**(-1)*d0x1*rtree1 * ( 1.D0/3.D0 )
      e0 = e0 + PLI1(5)**2*dlmuF*omz1**(-1)*omz2**(-1)*rtree1 * ( 2.D0/
     &    3.D0 )
      e0 = e0 + PLI1(5)**3*omz1**(-1)*omz2**(-1)*rtree1 * (  - 1.D0/9.D0
     &     )
        elseif(ipole.eq.-1)then
          e0 =  + omz1**(-1)*omz2**(-1) * (  - 2*Ah2g1H2p1 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rloop2 * (  - 11.D0/3.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rloop1 * ( 2.D0/3.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rtree1 * ( 155.D0/108.D0 - 1.D0/
     &    36.D0*pi**2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls12*rloop2 * (  - 2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls12*rtree1 * ( 5.D0/9.D0 )
        elseif(ipole.eq.-2)then
          e0 =  + omz1**(-1)*omz2**(-1)*rloop2 * (  - 2 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*rtree1 * (  - 61.D0/18.D0 )
      e0 = e0 + omz1**(-1)*omz2**(-1)*dls12*rtree1 * (  - 5.D0/3.D0 )
        elseif(ipole.eq.-3)then
          e0 =  + omz1**(-1)*omz2**(-1)*rtree1 * (  - 11.D0/6.D0 )
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.2.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  + rtree1 * ( 89.D0/27.D0 - 56.D0/27.D0*x2**(-1) + 2.D0/
     &    9.D0*x2**(-1)*pi**2 - 5.D0/36.D0*pi**2 + 107.D0/27.D0*x2 + 1.D
     &    0/36.D0*x2*pi**2 - 121.D0/27.D0*x2**2 - 2.D0/9.D0*x2**2*pi**2
     &     )
      e0 = e0 + dls12*rloop2 * (  - 4 + 2*x2**(-1) + 2*x2 - 2*x2**2 )
      e0 = e0 + dls12*rtree1 * ( 19.D0/18.D0 - 20.D0/9.D0*x2**(-1) + 7.D
     &    0/18.D0*x2 + 17.D0/9.D0*x2**2 )
      e0 = e0 + dls12**2*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0*x2**(-1) - 1.
     &    D0/12.D0*x2 + 2.D0/3.D0*x2**2 )
      e0 = e0 + d2x2*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + d1x2*rloop2 * (  - 2 )
      e0 = e0 + d1x2*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + d1x2*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x2*rtree1 * (  - 28.D0/27.D0 + 1.D0/9.D0*pi**2 )
      e0 = e0 + d0x2*dls12*rloop2 * ( 2 )
      e0 = e0 + d0x2*dls12*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + d0x2*dls12**2*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + d1x1*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*x2**(-1) + 1.D0
     &    /6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + d1x1*d0x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x1*rloop2 * (  - 4 + 2*x2**(-1) + 2*x2 - 2*x2**2 )
      e0 = e0 + d0x1*rtree1 * ( 19.D0/18.D0 - 20.D0/9.D0*x2**(-1) + 7.D0
     &    /18.D0*x2 + 17.D0/9.D0*x2**2 )
      e0 = e0 + d0x1*dls12*rtree1 * ( 5.D0/6.D0 - 4.D0/3.D0*x2**(-1) - 
     &    1.D0/6.D0*x2 + 4.D0/3.D0*x2**2 )
      e0 = e0 + d0x1*d1x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x1*d0x2*rloop2 * ( 2 )
      e0 = e0 + d0x1*d0x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + d0x1*d0x2*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + dlmuF*rloop2 * ( 4 - 2*x2**(-1) - 2*x2 + 2*x2**2 )
      e0 = e0 + dlmuF*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D0*x2**(-1)
     &     - 7.D0/18.D0*x2 - 17.D0/9.D0*x2**2 )
      e0 = e0 + dlmuF*dls12*rtree1 * ( 19.D0/6.D0 - 2.D0/3.D0*x2**(-1)
     &     - 11.D0/6.D0*x2 + 2.D0/3.D0*x2**2 )
      e0 = e0 + dlmuF*d1x2*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x2*rloop2 * (  - 2 )
      e0 = e0 + dlmuF*d0x2*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + dlmuF*d0x2*dls12*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*rtree1 * ( 19.D0/6.D0 - 2.D0/3.D0*x2**(-1)
     &     - 11.D0/6.D0*x2 + 2.D0/3.D0*x2**2 )
      e0 = e0 + dlmuF*d0x1*d0x2*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF**2*rtree1 * (  - 43.D0/12.D0 + 4.D0/3.D0*x2**(-1)
     &     + 23.D0/12.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + dlmuF**2*d0x2*rtree1 * ( 5.D0/3.D0 )
      e0 = e0 + GII(18,2)*omx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(18,2)*rtree1 * (  - 1 + 4.D0/3.D0*x2**(-1) + 2*x2
     &     + 2*x2**2 )
      e0 = e0 + GII(18,2)*dls12*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(18,2)*d0x1*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(18,2)*dlmuF*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(18,2)*GII(30,2)*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(18,2)*PLI1(2)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,2)*omx2**(-1)*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(20,2)*rtree1 * ( 1 - 4.D0/3.D0*x2**(-1) - 2*x2 - 2*
     &    x2**2 )
      e0 = e0 + GII(20,2)*dls12*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,2)*d0x1*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,2)*dlmuF*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(20,2)*GII(30,2)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,2)*PLI1(2)*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(21,2)*omx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(21,2)*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*x2**(-1) + 
     &    25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + GII(24,2)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(26,2)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(28,2)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*omx2**(-1)*rtree1 * (  - 2.D0/3.D0 - 2.D0/3.D0
     &    *rln2 )
      e0 = e0 + GII(30,2)*rtree1 * ( 22.D0/9.D0 - 4.D0/3.D0*x2**(-1)*
     &    rln2 + rln2 + 215.D0/18.D0*x2 - 2*x2*rln2 + 98.D0/9.D0*x2**2
     &     - 2*x2**2*rln2 )
      e0 = e0 + GII(30,2)*dls12*rtree1 * (  - 1.D0/6.D0 + rln2 + 11.D0/
     &    6.D0*x2 + x2*rln2 + 10.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*dls12**2*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x2 )
      e0 = e0 + GII(30,2)*d1x1*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*d0x1*rtree1 * (  - 1.D0/6.D0 + rln2 + 11.D0/6.
     &    D0*x2 + x2*rln2 + 10.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*d0x1*dls12*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(30,2)*dlmuF*rtree1 * ( 1.D0/6.D0 - rln2 - 11.D0/6.D0
     &    *x2 - x2*rln2 - 10.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*dlmuF*dls12*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*dlmuF*d0x1*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*dlmuF**2*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x2 )
      e0 = e0 + GII(30,2)**2*rtree1 * ( 11.D0/24.D0 + 1.D0/2.D0*rln2 + 
     &    41.D0/24.D0*x2 + 1.D0/2.D0*x2*rln2 + 5.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)**2*dls12*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x2 )
      e0 = e0 + GII(30,2)**2*d0x1*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x2 )
      e0 = e0 + GII(30,2)**2*dlmuF*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*x2
     &     )
      e0 = e0 + GII(30,2)**3*rtree1 * (  - 1.D0/12.D0 - 1.D0/12.D0*x2 )
      e0 = e0 + GII(30,2)*GII(31,2)*omx2**(-1)*rtree1 * (  - 2.D0/3.D0
     &     )
      e0 = e0 + GII(30,2)*GII(31,2)*rtree1 * (  - 1.D0/6.D0 - 4.D0/3.D0
     &    *x2**(-1) + rln2 - 25.D0/6.D0*x2 + x2*rln2 - 2*x2**2 )
      e0 = e0 + GII(30,2)*GII(31,2)**2*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0
     &    *x2 )
      e0 = e0 + GII(30,2)*GII(31,2)*PLI1(2)*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(30,2)*PLI1(2)*omx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(30,2)*PLI1(2)*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) - rln2 + 1.D0/6.D0*x2 - x2*rln2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*PLI1(2)**2*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*
     &    x2 )
      e0 = e0 + GII(31,2)*omx2**(-1)*rloop2 * ( 2 )
      e0 = e0 + GII(31,2)*omx2**(-1)*rtree1 * (  - 4.D0/9.D0 )
      e0 = e0 + GII(31,2)*omx2**(-1)*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(31,2)*omx2**(-1)*d0x1*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(31,2)*rloop2 * (  - 4 + 2*x2**(-1) + 2*x2 - 2*x2**2
     &     )
      e0 = e0 + GII(31,2)*rtree1 * (  - 35.D0/18.D0 - 20.D0/9.D0*
     &    x2**(-1) + 1.D0/6.D0*pi**2 - 245.D0/18.D0*x2 + 1.D0/6.D0*x2*
     &    pi**2 - 9*x2**2 )
      e0 = e0 + GII(31,2)*dls12*rtree1 * (  - 1.D0/6.D0 - 4.D0/3.D0*
     &    x2**(-1) - 25.D0/6.D0*x2 - 2*x2**2 )
      e0 = e0 + GII(31,2)*d0x1*rtree1 * (  - 1.D0/6.D0 - 4.D0/3.D0*
     &    x2**(-1) - 25.D0/6.D0*x2 - 2*x2**2 )
      e0 = e0 + GII(31,2)*dlmuF*omx2**(-1)*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + GII(31,2)*dlmuF*rtree1 * ( 25.D0/6.D0 - 2.D0/3.D0*
     &    x2**(-1) + 13.D0/6.D0*x2 + 4*x2**2 )
      e0 = e0 + GII(31,2)**2*rtree1 * (  - 1.D0/2.D0*rln2 - 1.D0/2.D0*
     &    x2*rln2 )
      e0 = e0 + GII(31,2)**3*rtree1 * (  - 1.D0/3.D0 - 1.D0/3.D0*x2 )
      e0 = e0 + GII(31,2)**2*PLI1(2)*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*
     &    x2 )
      e0 = e0 + GII(31,2)*PLI1(2)*omx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(31,2)*PLI1(2)*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + PLI1(2)*rloop2 * ( 4 - 2*x2**(-1) - 2*x2 + 2*x2**2 )
      e0 = e0 + PLI1(2)*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D0*x2**(-1)
     &     - 2.D0/9.D0*x2 - 17.D0/9.D0*x2**2 )
      e0 = e0 + PLI1(2)*dls12*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 1.D0/6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(2)*d0x1*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 1.D0/6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(2)*dlmuF*rtree1 * (  - 19.D0/6.D0 + 2.D0/3.D0*
     &    x2**(-1) + 11.D0/6.D0*x2 - 2.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(2)**2*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0*x2**(-1)
     &     - 1.D0/12.D0*x2 + 2.D0/3.D0*x2**2 )
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.2.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  + omz1**(-1)*rtree1 * ( 89.D0/27.D0 - 56.D0/27.D0*
     &    x2**(-1) + 2.D0/9.D0*x2**(-1)*pi**2 - 5.D0/36.D0*pi**2 + 107.D
     &    0/27.D0*x2 + 1.D0/36.D0*x2*pi**2 - 121.D0/27.D0*x2**2 - 2.D0/
     &    9.D0*x2**2*pi**2 )
      e0 = e0 + omz1**(-1)*dls12*rloop2 * (  - 4 + 2*x2**(-1) + 2*x2 - 
     &    2*x2**2 )
      e0 = e0 + omz1**(-1)*dls12*rtree1 * ( 19.D0/18.D0 - 20.D0/9.D0*
     &    x2**(-1) + 7.D0/18.D0*x2 + 17.D0/9.D0*x2**2 )
      e0 = e0 + omz1**(-1)*dls12**2*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0*
     &    x2**(-1) - 1.D0/12.D0*x2 + 2.D0/3.D0*x2**2 )
      e0 = e0 + omz1**(-1)*d2x2*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + omz1**(-1)*d1x2*rloop2 * (  - 2 )
      e0 = e0 + omz1**(-1)*d1x2*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + omz1**(-1)*d1x2*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + omz1**(-1)*d0x2*rtree1 * (  - 28.D0/27.D0 + 1.D0/9.D0*
     &    pi**2 )
      e0 = e0 + omz1**(-1)*d0x2*dls12*rloop2 * ( 2 )
      e0 = e0 + omz1**(-1)*d0x2*dls12*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + omz1**(-1)*d0x2*dls12**2*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + d1x1*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*x2**(-1) + 1.D0
     &    /6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + d1x1*d0x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x1*rloop2 * (  - 4 + 2*x2**(-1) + 2*x2 - 2*x2**2 )
      e0 = e0 + d0x1*rtree1 * ( 19.D0/18.D0 - 20.D0/9.D0*x2**(-1) + 7.D0
     &    /18.D0*x2 + 17.D0/9.D0*x2**2 )
      e0 = e0 + d0x1*dls12*rtree1 * ( 5.D0/6.D0 - 4.D0/3.D0*x2**(-1) - 
     &    1.D0/6.D0*x2 + 4.D0/3.D0*x2**2 )
      e0 = e0 + d0x1*d1x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x1*d0x2*rloop2 * ( 2 )
      e0 = e0 + d0x1*d0x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + d0x1*d0x2*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*rloop2 * ( 4 - 2*x2**(-1) - 2*x2 + 2*
     &    x2**2 )
      e0 = e0 + dlmuF*omz1**(-1)*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D0
     &    *x2**(-1) - 7.D0/18.D0*x2 - 17.D0/9.D0*x2**2 )
      e0 = e0 + dlmuF*omz1**(-1)*dls12*rtree1 * ( 19.D0/6.D0 - 2.D0/3.D0
     &    *x2**(-1) - 11.D0/6.D0*x2 + 2.D0/3.D0*x2**2 )
      e0 = e0 + dlmuF*omz1**(-1)*d1x2*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*d0x2*rloop2 * (  - 2 )
      e0 = e0 + dlmuF*omz1**(-1)*d0x2*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + dlmuF*omz1**(-1)*d0x2*dls12*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*rtree1 * ( 19.D0/6.D0 - 2.D0/3.D0*x2**(-1)
     &     - 11.D0/6.D0*x2 + 2.D0/3.D0*x2**2 )
      e0 = e0 + dlmuF*d0x1*d0x2*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF**2*omz1**(-1)*rtree1 * (  - 43.D0/12.D0 + 4.D0/3.D
     &    0*x2**(-1) + 23.D0/12.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + dlmuF**2*omz1**(-1)*d0x2*rtree1 * ( 5.D0/3.D0 )
      e0 = e0 + GII(18,2)*omx2**(-1)*omz1**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(18,2)*omz1**(-1)*rtree1 * (  - 1 + 4.D0/3.D0*
     &    x2**(-1) + 2*x2 + 2*x2**2 )
      e0 = e0 + GII(18,2)*omz1**(-1)*dls12*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(18,2)*d0x1*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(18,2)*dlmuF*omz1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(18,2)*GII(30,2)*omz1**(-1)*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(18,2)*PLI1(2)*omz1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(18,2)*PLI1(4)*omz1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,2)*omx2**(-1)*omz1**(-1)*rtree1 * (  - 2.D0/3.D0
     &     )
      e0 = e0 + GII(20,2)*omz1**(-1)*rtree1 * ( 1 - 4.D0/3.D0*x2**(-1)
     &     - 2*x2 - 2*x2**2 )
      e0 = e0 + GII(20,2)*omz1**(-1)*dls12*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,2)*d0x1*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,2)*dlmuF*omz1**(-1)*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(20,2)*GII(30,2)*omz1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,2)*PLI1(2)*omz1**(-1)*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(20,2)*PLI1(4)*omz1**(-1)*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(21,2)*omx2**(-1)*omz1**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(21,2)*omz1**(-1)*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + GII(24,2)*omz1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(26,2)*omz1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(28,2)*omz1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*omx2**(-1)*omz1**(-1)*rtree1 * (  - 2.D0/3.D0
     &     - 2.D0/3.D0*rln2 )
      e0 = e0 + GII(30,2)*omz1**(-1)*rtree1 * ( 22.D0/9.D0 - 4.D0/3.D0*
     &    x2**(-1)*rln2 + rln2 + 215.D0/18.D0*x2 - 2*x2*rln2 + 98.D0/9.D
     &    0*x2**2 - 2*x2**2*rln2 )
      e0 = e0 + GII(30,2)*omz1**(-1)*dls12*rtree1 * (  - 1.D0/6.D0 + 
     &    rln2 + 11.D0/6.D0*x2 + x2*rln2 + 10.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*omz1**(-1)*dls12**2*rtree1 * (  - 1.D0/2.D0
     &     - 1.D0/2.D0*x2 )
      e0 = e0 + GII(30,2)*d1x1*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*d0x1*rtree1 * (  - 1.D0/6.D0 + rln2 + 11.D0/6.
     &    D0*x2 + x2*rln2 + 10.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*d0x1*dls12*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(30,2)*dlmuF*omz1**(-1)*rtree1 * ( 1.D0/6.D0 - rln2
     &     - 11.D0/6.D0*x2 - x2*rln2 - 10.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*dlmuF*omz1**(-1)*dls12*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*dlmuF*d0x1*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*dlmuF**2*omz1**(-1)*rtree1 * (  - 1.D0/2.D0
     &     - 1.D0/2.D0*x2 )
      e0 = e0 + GII(30,2)**2*omz1**(-1)*rtree1 * ( 11.D0/24.D0 + 1.D0/2.
     &    D0*rln2 + 41.D0/24.D0*x2 + 1.D0/2.D0*x2*rln2 + 5.D0/3.D0*
     &    x2**2 )
      e0 = e0 + GII(30,2)**2*omz1**(-1)*dls12*rtree1 * (  - 1.D0/2.D0
     &     - 1.D0/2.D0*x2 )
      e0 = e0 + GII(30,2)**2*d0x1*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x2 )
      e0 = e0 + GII(30,2)**2*dlmuF*omz1**(-1)*rtree1 * ( 1.D0/2.D0 + 1.D
     &    0/2.D0*x2 )
      e0 = e0 + GII(30,2)**3*omz1**(-1)*rtree1 * (  - 1.D0/12.D0 - 1.D0/
     &    12.D0*x2 )
      e0 = e0 + GII(30,2)**2*PLI1(4)*omz1**(-1)*rtree1 * ( 1.D0/2.D0 + 
     &    1.D0/2.D0*x2 )
      e0 = e0 + GII(30,2)*GII(31,2)*omx2**(-1)*omz1**(-1)*rtree1 * ( 
     &     - 2.D0/3.D0 )
      e0 = e0 + GII(30,2)*GII(31,2)*omz1**(-1)*rtree1 * (  - 1.D0/6.D0
     &     - 4.D0/3.D0*x2**(-1) + rln2 - 25.D0/6.D0*x2 + x2*rln2 - 2*
     &    x2**2 )
      e0 = e0 + GII(30,2)*GII(31,2)**2*omz1**(-1)*rtree1 * ( 1.D0/2.D0
     &     + 1.D0/2.D0*x2 )
      e0 = e0 + GII(30,2)*GII(31,2)*PLI1(2)*omz1**(-1)*rtree1 * (  - 1
     &     - x2 )
      e0 = e0 + GII(30,2)*PLI1(2)*omx2**(-1)*omz1**(-1)*rtree1 * ( 2.D0/
     &    3.D0 )
      e0 = e0 + GII(30,2)*PLI1(2)*omz1**(-1)*rtree1 * (  - 5.D0/6.D0 + 
     &    4.D0/3.D0*x2**(-1) - rln2 + 1.D0/6.D0*x2 - x2*rln2 - 4.D0/3.D0
     &    *x2**2 )
      e0 = e0 + GII(30,2)*PLI1(2)**2*omz1**(-1)*rtree1 * ( 1.D0/2.D0 + 
     &    1.D0/2.D0*x2 )
      e0 = e0 + GII(30,2)*PLI1(4)*omz1**(-1)*rtree1 * ( 1.D0/6.D0 - 
     &    rln2 - 11.D0/6.D0*x2 - x2*rln2 - 10.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*PLI1(4)*omz1**(-1)*dls12*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*PLI1(4)*dlmuF*omz1**(-1)*rtree1 * (  - 1 - x2
     &     )
      e0 = e0 + GII(30,2)*PLI1(4)**2*omz1**(-1)*rtree1 * (  - 1.D0/2.D0
     &     - 1.D0/2.D0*x2 )
      e0 = e0 + GII(31,2)*omx2**(-1)*omz1**(-1)*rloop2 * ( 2 )
      e0 = e0 + GII(31,2)*omx2**(-1)*omz1**(-1)*rtree1 * (  - 4.D0/9.D0
     &     )
      e0 = e0 + GII(31,2)*omx2**(-1)*omz1**(-1)*dls12*rtree1 * (  - 2.D0
     &    /3.D0 )
      e0 = e0 + GII(31,2)*omx2**(-1)*d0x1*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(31,2)*omz1**(-1)*rloop2 * (  - 4 + 2*x2**(-1) + 2*
     &    x2 - 2*x2**2 )
      e0 = e0 + GII(31,2)*omz1**(-1)*rtree1 * (  - 35.D0/18.D0 - 20.D0/
     &    9.D0*x2**(-1) + 1.D0/6.D0*pi**2 - 245.D0/18.D0*x2 + 1.D0/6.D0
     &    *x2*pi**2 - 9*x2**2 )
      e0 = e0 + GII(31,2)*omz1**(-1)*dls12*rtree1 * (  - 1.D0/6.D0 - 4.D
     &    0/3.D0*x2**(-1) - 25.D0/6.D0*x2 - 2*x2**2 )
      e0 = e0 + GII(31,2)*d0x1*rtree1 * (  - 1.D0/6.D0 - 4.D0/3.D0*
     &    x2**(-1) - 25.D0/6.D0*x2 - 2*x2**2 )
      e0 = e0 + GII(31,2)*dlmuF*omx2**(-1)*omz1**(-1)*rtree1 * (  - 4.D0
     &    /3.D0 )
      e0 = e0 + GII(31,2)*dlmuF*omz1**(-1)*rtree1 * ( 25.D0/6.D0 - 2.D0/
     &    3.D0*x2**(-1) + 13.D0/6.D0*x2 + 4*x2**2 )
      e0 = e0 + GII(31,2)**2*omz1**(-1)*rtree1 * (  - 1.D0/2.D0*rln2 - 
     &    1.D0/2.D0*x2*rln2 )
      e0 = e0 + GII(31,2)**3*omz1**(-1)*rtree1 * (  - 1.D0/3.D0 - 1.D0/
     &    3.D0*x2 )
      e0 = e0 + GII(31,2)**2*PLI1(2)*omz1**(-1)*rtree1 * ( 1.D0/2.D0 + 
     &    1.D0/2.D0*x2 )
      e0 = e0 + GII(31,2)*PLI1(2)*omx2**(-1)*omz1**(-1)*rtree1 * ( 2.D0/
     &    3.D0 )
      e0 = e0 + GII(31,2)*PLI1(2)*omz1**(-1)*rtree1 * ( 1.D0/6.D0 + 4.D0
     &    /3.D0*x2**(-1) + 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + GII(31,2)*PLI1(4)*omx2**(-1)*omz1**(-1)*rtree1 * ( 2.D0/
     &    3.D0 )
      e0 = e0 + GII(31,2)*PLI1(4)*omz1**(-1)*rtree1 * ( 1.D0/6.D0 + 4.D0
     &    /3.D0*x2**(-1) + 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + PLI1(2)*omz1**(-1)*rloop2 * ( 4 - 2*x2**(-1) - 2*x2 + 2
     &    *x2**2 )
      e0 = e0 + PLI1(2)*omz1**(-1)*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D
     &    0*x2**(-1) - 2.D0/9.D0*x2 - 17.D0/9.D0*x2**2 )
      e0 = e0 + PLI1(2)*omz1**(-1)*dls12*rtree1 * (  - 5.D0/6.D0 + 4.D0/
     &    3.D0*x2**(-1) + 1.D0/6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(2)*d0x1*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 1.D0/6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(2)*dlmuF*omz1**(-1)*rtree1 * (  - 19.D0/6.D0 + 2.D0
     &    /3.D0*x2**(-1) + 11.D0/6.D0*x2 - 2.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(2)**2*omz1**(-1)*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0
     &    *x2**(-1) - 1.D0/12.D0*x2 + 2.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(2)*PLI1(4)*omz1**(-1)*rtree1 * ( 5.D0/6.D0 - 4.D0/
     &    3.D0*x2**(-1) - 1.D0/6.D0*x2 + 4.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*rloop2 * ( 4 - 2*x2**(-1) - 2*x2 + 2
     &    *x2**2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D
     &    0*x2**(-1) - 7.D0/18.D0*x2 - 17.D0/9.D0*x2**2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*dls12*rtree1 * (  - 5.D0/6.D0 + 4.D0/
     &    3.D0*x2**(-1) + 1.D0/6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*d1x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*d0x2*rloop2 * (  - 2 )
      e0 = e0 + PLI1(4)*omz1**(-1)*d0x2*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + PLI1(4)*omz1**(-1)*d0x2*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*rtree1 * (  - 19.D0/6.D0 + 2.D0
     &    /3.D0*x2**(-1) + 11.D0/6.D0*x2 - 2.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(4)*dlmuF*omz1**(-1)*d0x2*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0
     &    *x2**(-1) - 1.D0/12.D0*x2 + 2.D0/3.D0*x2**2 )
      e0 = e0 + PLI1(4)**2*omz1**(-1)*d0x2*rtree1 * (  - 1.D0/3.D0 )
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.3.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  + rtree1 * ( 89.D0/27.D0 - 56.D0/27.D0*x1**(-1) + 2.D0/
     &    9.D0*x1**(-1)*pi**2 - 5.D0/36.D0*pi**2 + 107.D0/27.D0*x1 + 1.D
     &    0/36.D0*x1*pi**2 - 121.D0/27.D0*x1**2 - 2.D0/9.D0*x1**2*pi**2
     &     )
      e0 = e0 + dls12*rloop2 * (  - 4 + 2*x1**(-1) + 2*x1 - 2*x1**2 )
      e0 = e0 + dls12*rtree1 * ( 19.D0/18.D0 - 20.D0/9.D0*x1**(-1) + 7.D
     &    0/18.D0*x1 + 17.D0/9.D0*x1**2 )
      e0 = e0 + dls12**2*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0*x1**(-1) - 1.
     &    D0/12.D0*x1 + 2.D0/3.D0*x1**2 )
      e0 = e0 + d1x2*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*x1**(-1) + 1.D0
     &    /6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + d0x2*rloop2 * (  - 4 + 2*x1**(-1) + 2*x1 - 2*x1**2 )
      e0 = e0 + d0x2*rtree1 * ( 19.D0/18.D0 - 20.D0/9.D0*x1**(-1) + 7.D0
     &    /18.D0*x1 + 17.D0/9.D0*x1**2 )
      e0 = e0 + d0x2*dls12*rtree1 * ( 5.D0/6.D0 - 4.D0/3.D0*x1**(-1) - 
     &    1.D0/6.D0*x1 + 4.D0/3.D0*x1**2 )
      e0 = e0 + d2x1*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + d1x1*rloop2 * (  - 2 )
      e0 = e0 + d1x1*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + d1x1*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d1x1*d0x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x1*rtree1 * (  - 28.D0/27.D0 + 1.D0/9.D0*pi**2 )
      e0 = e0 + d0x1*dls12*rloop2 * ( 2 )
      e0 = e0 + d0x1*dls12*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + d0x1*dls12**2*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + d0x1*d1x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x1*d0x2*rloop2 * ( 2 )
      e0 = e0 + d0x1*d0x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + d0x1*d0x2*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + dlmuF*rloop2 * ( 4 - 2*x1**(-1) - 2*x1 + 2*x1**2 )
      e0 = e0 + dlmuF*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D0*x1**(-1)
     &     - 7.D0/18.D0*x1 - 17.D0/9.D0*x1**2 )
      e0 = e0 + dlmuF*dls12*rtree1 * ( 19.D0/6.D0 - 2.D0/3.D0*x1**(-1)
     &     - 11.D0/6.D0*x1 + 2.D0/3.D0*x1**2 )
      e0 = e0 + dlmuF*d0x2*rtree1 * ( 19.D0/6.D0 - 2.D0/3.D0*x1**(-1)
     &     - 11.D0/6.D0*x1 + 2.D0/3.D0*x1**2 )
      e0 = e0 + dlmuF*d1x1*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*rloop2 * (  - 2 )
      e0 = e0 + dlmuF*d0x1*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + dlmuF*d0x1*dls12*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x1*d0x2*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF**2*rtree1 * (  - 43.D0/12.D0 + 4.D0/3.D0*x1**(-1)
     &     + 23.D0/12.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + dlmuF**2*d0x1*rtree1 * ( 5.D0/3.D0 )
      e0 = e0 + GII(18,1)*omx1**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(18,1)*rtree1 * (  - 1 + 4.D0/3.D0*x1**(-1) + 2*x1
     &     + 2*x1**2 )
      e0 = e0 + GII(18,1)*dls12*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(18,1)*d0x2*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(18,1)*dlmuF*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(18,1)*GII(30,1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(18,1)*PLI1(1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(20,1)*omx1**(-1)*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(20,1)*rtree1 * ( 1 - 4.D0/3.D0*x1**(-1) - 2*x1 - 2*
     &    x1**2 )
      e0 = e0 + GII(20,1)*dls12*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(20,1)*d0x2*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(20,1)*dlmuF*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(20,1)*GII(30,1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(20,1)*PLI1(1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(21,1)*omx1**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(21,1)*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*x1**(-1) + 
     &    25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + GII(24,1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(26,1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(28,1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*omx1**(-1)*rtree1 * (  - 2.D0/3.D0 - 2.D0/3.D0
     &    *rln2 )
      e0 = e0 + GII(30,1)*rtree1 * ( 22.D0/9.D0 - 4.D0/3.D0*x1**(-1)*
     &    rln2 + rln2 + 215.D0/18.D0*x1 - 2*x1*rln2 + 98.D0/9.D0*x1**2
     &     - 2*x1**2*rln2 )
      e0 = e0 + GII(30,1)*dls12*rtree1 * (  - 1.D0/6.D0 + rln2 + 11.D0/
     &    6.D0*x1 + x1*rln2 + 10.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*dls12**2*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x1 )
      e0 = e0 + GII(30,1)*d1x2*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*d0x2*rtree1 * (  - 1.D0/6.D0 + rln2 + 11.D0/6.
     &    D0*x1 + x1*rln2 + 10.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*d0x2*dls12*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(30,1)*dlmuF*rtree1 * ( 1.D0/6.D0 - rln2 - 11.D0/6.D0
     &    *x1 - x1*rln2 - 10.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*dlmuF*dls12*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*dlmuF*d0x2*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*dlmuF**2*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x1 )
      e0 = e0 + GII(30,1)**2*rtree1 * ( 11.D0/24.D0 + 1.D0/2.D0*rln2 + 
     &    41.D0/24.D0*x1 + 1.D0/2.D0*x1*rln2 + 5.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)**2*dls12*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x1 )
      e0 = e0 + GII(30,1)**2*d0x2*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x1 )
      e0 = e0 + GII(30,1)**2*dlmuF*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*x1
     &     )
      e0 = e0 + GII(30,1)**3*rtree1 * (  - 1.D0/12.D0 - 1.D0/12.D0*x1 )
      e0 = e0 + GII(30,1)*GII(31,1)*omx1**(-1)*rtree1 * (  - 2.D0/3.D0
     &     )
      e0 = e0 + GII(30,1)*GII(31,1)*rtree1 * (  - 1.D0/6.D0 - 4.D0/3.D0
     &    *x1**(-1) + rln2 - 25.D0/6.D0*x1 + x1*rln2 - 2*x1**2 )
      e0 = e0 + GII(30,1)*GII(31,1)**2*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0
     &    *x1 )
      e0 = e0 + GII(30,1)*GII(31,1)*PLI1(1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(30,1)*PLI1(1)*omx1**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(30,1)*PLI1(1)*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) - rln2 + 1.D0/6.D0*x1 - x1*rln2 - 4.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*PLI1(1)**2*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*
     &    x1 )
      e0 = e0 + GII(31,1)*omx1**(-1)*rloop2 * ( 2 )
      e0 = e0 + GII(31,1)*omx1**(-1)*rtree1 * (  - 4.D0/9.D0 )
      e0 = e0 + GII(31,1)*omx1**(-1)*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(31,1)*omx1**(-1)*d0x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(31,1)*rloop2 * (  - 4 + 2*x1**(-1) + 2*x1 - 2*x1**2
     &     )
      e0 = e0 + GII(31,1)*rtree1 * (  - 35.D0/18.D0 - 20.D0/9.D0*
     &    x1**(-1) + 1.D0/6.D0*pi**2 - 245.D0/18.D0*x1 + 1.D0/6.D0*x1*
     &    pi**2 - 9*x1**2 )
      e0 = e0 + GII(31,1)*dls12*rtree1 * (  - 1.D0/6.D0 - 4.D0/3.D0*
     &    x1**(-1) - 25.D0/6.D0*x1 - 2*x1**2 )
      e0 = e0 + GII(31,1)*d0x2*rtree1 * (  - 1.D0/6.D0 - 4.D0/3.D0*
     &    x1**(-1) - 25.D0/6.D0*x1 - 2*x1**2 )
      e0 = e0 + GII(31,1)*dlmuF*omx1**(-1)*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + GII(31,1)*dlmuF*rtree1 * ( 25.D0/6.D0 - 2.D0/3.D0*
     &    x1**(-1) + 13.D0/6.D0*x1 + 4*x1**2 )
      e0 = e0 + GII(31,1)**2*rtree1 * (  - 1.D0/2.D0*rln2 - 1.D0/2.D0*
     &    x1*rln2 )
      e0 = e0 + GII(31,1)**3*rtree1 * (  - 1.D0/3.D0 - 1.D0/3.D0*x1 )
      e0 = e0 + GII(31,1)**2*PLI1(1)*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*
     &    x1 )
      e0 = e0 + GII(31,1)*PLI1(1)*omx1**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(31,1)*PLI1(1)*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + PLI1(1)*rloop2 * ( 4 - 2*x1**(-1) - 2*x1 + 2*x1**2 )
      e0 = e0 + PLI1(1)*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D0*x1**(-1)
     &     - 2.D0/9.D0*x1 - 17.D0/9.D0*x1**2 )
      e0 = e0 + PLI1(1)*dls12*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 1.D0/6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(1)*d0x2*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 1.D0/6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(1)*dlmuF*rtree1 * (  - 19.D0/6.D0 + 2.D0/3.D0*
     &    x1**(-1) + 11.D0/6.D0*x1 - 2.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(1)**2*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0*x1**(-1)
     &     - 1.D0/12.D0*x1 + 2.D0/3.D0*x1**2 )
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.3.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  + omz2**(-1)*rtree1 * ( 89.D0/27.D0 - 56.D0/27.D0*
     &    x1**(-1) + 2.D0/9.D0*x1**(-1)*pi**2 - 5.D0/36.D0*pi**2 + 107.D
     &    0/27.D0*x1 + 1.D0/36.D0*x1*pi**2 - 121.D0/27.D0*x1**2 - 2.D0/
     &    9.D0*x1**2*pi**2 )
      e0 = e0 + omz2**(-1)*dls12*rloop2 * (  - 4 + 2*x1**(-1) + 2*x1 - 
     &    2*x1**2 )
      e0 = e0 + omz2**(-1)*dls12*rtree1 * ( 19.D0/18.D0 - 20.D0/9.D0*
     &    x1**(-1) + 7.D0/18.D0*x1 + 17.D0/9.D0*x1**2 )
      e0 = e0 + omz2**(-1)*dls12**2*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0*
     &    x1**(-1) - 1.D0/12.D0*x1 + 2.D0/3.D0*x1**2 )
      e0 = e0 + omz2**(-1)*d2x1*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + omz2**(-1)*d1x1*rloop2 * (  - 2 )
      e0 = e0 + omz2**(-1)*d1x1*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + omz2**(-1)*d1x1*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + omz2**(-1)*d0x1*rtree1 * (  - 28.D0/27.D0 + 1.D0/9.D0*
     &    pi**2 )
      e0 = e0 + omz2**(-1)*d0x1*dls12*rloop2 * ( 2 )
      e0 = e0 + omz2**(-1)*d0x1*dls12*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + omz2**(-1)*d0x1*dls12**2*rtree1 * (  - 1.D0/3.D0 )
      e0 = e0 + d1x2*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*x1**(-1) + 1.D0
     &    /6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + d0x2*rloop2 * (  - 4 + 2*x1**(-1) + 2*x1 - 2*x1**2 )
      e0 = e0 + d0x2*rtree1 * ( 19.D0/18.D0 - 20.D0/9.D0*x1**(-1) + 7.D0
     &    /18.D0*x1 + 17.D0/9.D0*x1**2 )
      e0 = e0 + d0x2*dls12*rtree1 * ( 5.D0/6.D0 - 4.D0/3.D0*x1**(-1) - 
     &    1.D0/6.D0*x1 + 4.D0/3.D0*x1**2 )
      e0 = e0 + d1x1*d0x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x1*d1x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + d0x1*d0x2*rloop2 * ( 2 )
      e0 = e0 + d0x1*d0x2*rtree1 * (  - 10.D0/9.D0 )
      e0 = e0 + d0x1*d0x2*dls12*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*rloop2 * ( 4 - 2*x1**(-1) - 2*x1 + 2*
     &    x1**2 )
      e0 = e0 + dlmuF*omz2**(-1)*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D0
     &    *x1**(-1) - 7.D0/18.D0*x1 - 17.D0/9.D0*x1**2 )
      e0 = e0 + dlmuF*omz2**(-1)*dls12*rtree1 * ( 19.D0/6.D0 - 2.D0/3.D0
     &    *x1**(-1) - 11.D0/6.D0*x1 + 2.D0/3.D0*x1**2 )
      e0 = e0 + dlmuF*omz2**(-1)*d1x1*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*rloop2 * (  - 2 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + dlmuF*omz2**(-1)*d0x1*dls12*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF*d0x2*rtree1 * ( 19.D0/6.D0 - 2.D0/3.D0*x1**(-1)
     &     - 11.D0/6.D0*x1 + 2.D0/3.D0*x1**2 )
      e0 = e0 + dlmuF*d0x1*d0x2*rtree1 * (  - 4.D0/3.D0 )
      e0 = e0 + dlmuF**2*omz2**(-1)*rtree1 * (  - 43.D0/12.D0 + 4.D0/3.D
     &    0*x1**(-1) + 23.D0/12.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + dlmuF**2*omz2**(-1)*d0x1*rtree1 * ( 5.D0/3.D0 )
      e0 = e0 + GII(18,1)*omx1**(-1)*omz2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(18,1)*omz2**(-1)*rtree1 * (  - 1 + 4.D0/3.D0*
     &    x1**(-1) + 2*x1 + 2*x1**2 )
      e0 = e0 + GII(18,1)*omz2**(-1)*dls12*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(18,1)*d0x2*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(18,1)*dlmuF*omz2**(-1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(18,1)*GII(30,1)*omz2**(-1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(18,1)*PLI1(1)*omz2**(-1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(18,1)*PLI1(5)*omz2**(-1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(20,1)*omx1**(-1)*omz2**(-1)*rtree1 * (  - 2.D0/3.D0
     &     )
      e0 = e0 + GII(20,1)*omz2**(-1)*rtree1 * ( 1 - 4.D0/3.D0*x1**(-1)
     &     - 2*x1 - 2*x1**2 )
      e0 = e0 + GII(20,1)*omz2**(-1)*dls12*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(20,1)*d0x2*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(20,1)*dlmuF*omz2**(-1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(20,1)*GII(30,1)*omz2**(-1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(20,1)*PLI1(1)*omz2**(-1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(20,1)*PLI1(5)*omz2**(-1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(21,1)*omx1**(-1)*omz2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(21,1)*omz2**(-1)*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + GII(24,1)*omz2**(-1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(26,1)*omz2**(-1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(28,1)*omz2**(-1)*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*omx1**(-1)*omz2**(-1)*rtree1 * (  - 2.D0/3.D0
     &     - 2.D0/3.D0*rln2 )
      e0 = e0 + GII(30,1)*omz2**(-1)*rtree1 * ( 22.D0/9.D0 - 4.D0/3.D0*
     &    x1**(-1)*rln2 + rln2 + 215.D0/18.D0*x1 - 2*x1*rln2 + 98.D0/9.D
     &    0*x1**2 - 2*x1**2*rln2 )
      e0 = e0 + GII(30,1)*omz2**(-1)*dls12*rtree1 * (  - 1.D0/6.D0 + 
     &    rln2 + 11.D0/6.D0*x1 + x1*rln2 + 10.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*omz2**(-1)*dls12**2*rtree1 * (  - 1.D0/2.D0
     &     - 1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)*d1x2*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*d0x2*rtree1 * (  - 1.D0/6.D0 + rln2 + 11.D0/6.
     &    D0*x1 + x1*rln2 + 10.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*d0x2*dls12*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(30,1)*dlmuF*omz2**(-1)*rtree1 * ( 1.D0/6.D0 - rln2
     &     - 11.D0/6.D0*x1 - x1*rln2 - 10.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*dlmuF*omz2**(-1)*dls12*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*dlmuF*d0x2*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*dlmuF**2*omz2**(-1)*rtree1 * (  - 1.D0/2.D0
     &     - 1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)**2*omz2**(-1)*rtree1 * ( 11.D0/24.D0 + 1.D0/2.
     &    D0*rln2 + 41.D0/24.D0*x1 + 1.D0/2.D0*x1*rln2 + 5.D0/3.D0*
     &    x1**2 )
      e0 = e0 + GII(30,1)**2*omz2**(-1)*dls12*rtree1 * (  - 1.D0/2.D0
     &     - 1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)**2*d0x2*rtree1 * (  - 1.D0/2.D0 - 1.D0/2.D0*
     &    x1 )
      e0 = e0 + GII(30,1)**2*dlmuF*omz2**(-1)*rtree1 * ( 1.D0/2.D0 + 1.D
     &    0/2.D0*x1 )
      e0 = e0 + GII(30,1)**3*omz2**(-1)*rtree1 * (  - 1.D0/12.D0 - 1.D0/
     &    12.D0*x1 )
      e0 = e0 + GII(30,1)**2*PLI1(5)*omz2**(-1)*rtree1 * ( 1.D0/2.D0 + 
     &    1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)*GII(31,1)*omx1**(-1)*omz2**(-1)*rtree1 * ( 
     &     - 2.D0/3.D0 )
      e0 = e0 + GII(30,1)*GII(31,1)*omz2**(-1)*rtree1 * (  - 1.D0/6.D0
     &     - 4.D0/3.D0*x1**(-1) + rln2 - 25.D0/6.D0*x1 + x1*rln2 - 2*
     &    x1**2 )
      e0 = e0 + GII(30,1)*GII(31,1)**2*omz2**(-1)*rtree1 * ( 1.D0/2.D0
     &     + 1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)*GII(31,1)*PLI1(1)*omz2**(-1)*rtree1 * (  - 1
     &     - x1 )
      e0 = e0 + GII(30,1)*PLI1(1)*omx1**(-1)*omz2**(-1)*rtree1 * ( 2.D0/
     &    3.D0 )
      e0 = e0 + GII(30,1)*PLI1(1)*omz2**(-1)*rtree1 * (  - 5.D0/6.D0 + 
     &    4.D0/3.D0*x1**(-1) - rln2 + 1.D0/6.D0*x1 - x1*rln2 - 4.D0/3.D0
     &    *x1**2 )
      e0 = e0 + GII(30,1)*PLI1(1)**2*omz2**(-1)*rtree1 * ( 1.D0/2.D0 + 
     &    1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)*PLI1(5)*omz2**(-1)*rtree1 * ( 1.D0/6.D0 - 
     &    rln2 - 11.D0/6.D0*x1 - x1*rln2 - 10.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*PLI1(5)*omz2**(-1)*dls12*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*PLI1(5)*dlmuF*omz2**(-1)*rtree1 * (  - 1 - x1
     &     )
      e0 = e0 + GII(30,1)*PLI1(5)**2*omz2**(-1)*rtree1 * (  - 1.D0/2.D0
     &     - 1.D0/2.D0*x1 )
      e0 = e0 + GII(31,1)*omx1**(-1)*omz2**(-1)*rloop2 * ( 2 )
      e0 = e0 + GII(31,1)*omx1**(-1)*omz2**(-1)*rtree1 * (  - 4.D0/9.D0
     &     )
      e0 = e0 + GII(31,1)*omx1**(-1)*omz2**(-1)*dls12*rtree1 * (  - 2.D0
     &    /3.D0 )
      e0 = e0 + GII(31,1)*omx1**(-1)*d0x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + GII(31,1)*omz2**(-1)*rloop2 * (  - 4 + 2*x1**(-1) + 2*
     &    x1 - 2*x1**2 )
      e0 = e0 + GII(31,1)*omz2**(-1)*rtree1 * (  - 35.D0/18.D0 - 20.D0/
     &    9.D0*x1**(-1) + 1.D0/6.D0*pi**2 - 245.D0/18.D0*x1 + 1.D0/6.D0
     &    *x1*pi**2 - 9*x1**2 )
      e0 = e0 + GII(31,1)*omz2**(-1)*dls12*rtree1 * (  - 1.D0/6.D0 - 4.D
     &    0/3.D0*x1**(-1) - 25.D0/6.D0*x1 - 2*x1**2 )
      e0 = e0 + GII(31,1)*d0x2*rtree1 * (  - 1.D0/6.D0 - 4.D0/3.D0*
     &    x1**(-1) - 25.D0/6.D0*x1 - 2*x1**2 )
      e0 = e0 + GII(31,1)*dlmuF*omx1**(-1)*omz2**(-1)*rtree1 * (  - 4.D0
     &    /3.D0 )
      e0 = e0 + GII(31,1)*dlmuF*omz2**(-1)*rtree1 * ( 25.D0/6.D0 - 2.D0/
     &    3.D0*x1**(-1) + 13.D0/6.D0*x1 + 4*x1**2 )
      e0 = e0 + GII(31,1)**2*omz2**(-1)*rtree1 * (  - 1.D0/2.D0*rln2 - 
     &    1.D0/2.D0*x1*rln2 )
      e0 = e0 + GII(31,1)**3*omz2**(-1)*rtree1 * (  - 1.D0/3.D0 - 1.D0/
     &    3.D0*x1 )
      e0 = e0 + GII(31,1)**2*PLI1(1)*omz2**(-1)*rtree1 * ( 1.D0/2.D0 + 
     &    1.D0/2.D0*x1 )
      e0 = e0 + GII(31,1)*PLI1(1)*omx1**(-1)*omz2**(-1)*rtree1 * ( 2.D0/
     &    3.D0 )
      e0 = e0 + GII(31,1)*PLI1(1)*omz2**(-1)*rtree1 * ( 1.D0/6.D0 + 4.D0
     &    /3.D0*x1**(-1) + 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + GII(31,1)*PLI1(5)*omx1**(-1)*omz2**(-1)*rtree1 * ( 2.D0/
     &    3.D0 )
      e0 = e0 + GII(31,1)*PLI1(5)*omz2**(-1)*rtree1 * ( 1.D0/6.D0 + 4.D0
     &    /3.D0*x1**(-1) + 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + PLI1(1)*omz2**(-1)*rloop2 * ( 4 - 2*x1**(-1) - 2*x1 + 2
     &    *x1**2 )
      e0 = e0 + PLI1(1)*omz2**(-1)*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D
     &    0*x1**(-1) - 2.D0/9.D0*x1 - 17.D0/9.D0*x1**2 )
      e0 = e0 + PLI1(1)*omz2**(-1)*dls12*rtree1 * (  - 5.D0/6.D0 + 4.D0/
     &    3.D0*x1**(-1) + 1.D0/6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(1)*d0x2*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 1.D0/6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(1)*dlmuF*omz2**(-1)*rtree1 * (  - 19.D0/6.D0 + 2.D0
     &    /3.D0*x1**(-1) + 11.D0/6.D0*x1 - 2.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(1)**2*omz2**(-1)*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0
     &    *x1**(-1) - 1.D0/12.D0*x1 + 2.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(1)*PLI1(5)*omz2**(-1)*rtree1 * ( 5.D0/6.D0 - 4.D0/
     &    3.D0*x1**(-1) - 1.D0/6.D0*x1 + 4.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(5)*omz2**(-1)*rloop2 * ( 4 - 2*x1**(-1) - 2*x1 + 2
     &    *x1**2 )
      e0 = e0 + PLI1(5)*omz2**(-1)*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D
     &    0*x1**(-1) - 7.D0/18.D0*x1 - 17.D0/9.D0*x1**2 )
      e0 = e0 + PLI1(5)*omz2**(-1)*dls12*rtree1 * (  - 5.D0/6.D0 + 4.D0/
     &    3.D0*x1**(-1) + 1.D0/6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(5)*omz2**(-1)*d1x1*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + PLI1(5)*omz2**(-1)*d0x1*rloop2 * (  - 2 )
      e0 = e0 + PLI1(5)*omz2**(-1)*d0x1*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + PLI1(5)*omz2**(-1)*d0x1*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + PLI1(5)*dlmuF*omz2**(-1)*rtree1 * (  - 19.D0/6.D0 + 2.D0
     &    /3.D0*x1**(-1) + 11.D0/6.D0*x1 - 2.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(5)*dlmuF*omz2**(-1)*d0x1*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + PLI1(5)**2*omz2**(-1)*rtree1 * ( 5.D0/12.D0 - 2.D0/3.D0
     &    *x1**(-1) - 1.D0/12.D0*x1 + 2.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(5)**2*omz2**(-1)*d0x1*rtree1 * (  - 1.D0/3.D0 )
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.4)then
        if(ipole.eq.0)then
          e0 =  + opx1**(-1)*opx2**(-1)*rloop2 * (  - 2 )
      e0 = e0 + opx1**(-1)*opx2**(-1)*rtree1 * ( 4.D0/9.D0 )
      e0 = e0 + opx1**(-1)*opx2**(-1)*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + opx1**(-1)*rloop2 * ( 4 + 2*x2**(-1) + 2*x2 + 2*x2**2 )
      e0 = e0 + opx1**(-1)*rtree1 * ( 35.D0/18.D0 - 20.D0/9.D0*x2**(-1)
     &     - 245.D0/18.D0*x2 + 9*x2**2 )
      e0 = e0 + opx1**(-1)*dls12*rtree1 * ( 1.D0/6.D0 - 4.D0/3.D0*
     &    x2**(-1) - 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + opx2**(-1)*rloop2 * ( 4 + 2*x1**(-1) + 2*x1 + 2*x1**2 )
      e0 = e0 + opx2**(-1)*rtree1 * ( 35.D0/18.D0 - 20.D0/9.D0*x1**(-1)
     &     - 245.D0/18.D0*x1 + 9*x1**2 )
      e0 = e0 + opx2**(-1)*dls12*rtree1 * ( 1.D0/6.D0 - 4.D0/3.D0*
     &    x1**(-1) - 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + omx1x2**(-2)*rtree1 * ( 4.D0/3.D0*x2**2 - 4.D0/3.D0*
     &    x2**3 + 4.D0/3.D0*x1**2 - 4.D0/3.D0*x1**3 )
      e0 = e0 + omx1x2**(-1)*rtree1 * (  - 2.D0/3.D0 + 2.D0/3.D0*x2 - 4.
     &    D0/3.D0*x2**2 + 2.D0/3.D0*x2**3 + 2.D0/3.D0*x1 - 4.D0/3.D0*
     &    x1**2 + 2.D0/3.D0*x1**3 )
      e0 = e0 + rloop2 * (  - 8 - 4*x1**(-1)*x2**(-1) + 8*x1px2**(-2)
     &     - 4*x2*x1px2**(-3) - 4*x2*x1px2**(-1) + 4*x2**2*x1px2**(-4)
     &     - 8*x2**2*x1px2**(-2) - 8*x2**2 + 24*x2**3*x1px2**(-3) - 4*
     &    x2**3*x1px2**(-1) - 12*x2**4*x1px2**(-4) + 32*x2**4*
     &    x1px2**(-2) - 20*x2**4 - 36*x2**5*x1px2**(-3) + 40*x2**5*
     &    x1px2**(-1) + 12*x2**6*x1px2**(-4) - 32*x2**6*x1px2**(-2) + 
     &    16*x2**7*x1px2**(-3) - 4*x2**8*x1px2**(-4) + 4*x1*x2 + 8*x1*
     &    x2**3 - 4*x1**2 - 4*x1**2*x2**2 )
      e0 = e0 + rtree1 * ( 335.D0/18.D0 + 320.D0/3.D0*x1**(-3)*x2 - 320.
     &    D0/3.D0*x1**(-3)*x2**2 + 29.D0/6.D0*x1**(-2) - 191.D0/3.D0*
     &    x1**(-2)*x2 + 353.D0/6.D0*x1**(-2)*x2**2 + 407.D0/18.D0*
     &    x1**(-1)*x2**(-1) - 41.D0/3.D0*x1**(-1) + 43.D0/6.D0*x1**(-1)
     &    *x2 - 35.D0/3.D0*x1**(-1)*x2**2 + 29.D0/6.D0*x2**(-2) - 41.D0/
     &    3.D0*x2**(-1) + 3.D0/2.D0*x1px2**(-2) + 5.D0/3.D0*x1px2**(-1)
     &     + 14.D0/3.D0*x2*x1px2**(-3) - 4.D0/3.D0*x2*x1px2**(-2) + 167.
     &    D0/9.D0*x2*x1px2**(-1) - 158.D0/9.D0*x2 - 14.D0/3.D0*x2**2*
     &    x1px2**(-4) + 4.D0/3.D0*x2**2*x1px2**(-3) - 41.D0/9.D0*x2**2*
     &    x1px2**(-2) + 25.D0/9.D0*x2**2*x1px2**(-1) + 145.D0/9.D0*
     &    x2**2 - 28*x2**3*x1px2**(-3) + 16.D0/3.D0*x2**3*x1px2**(-2)
     &     - 25.D0/9.D0*x2**3*x1px2**(-1) - 4*x2**3 + 14*x2**4*
     &    x1px2**(-4) - 8.D0/3.D0*x2**4*x1px2**(-3) - 605.D0/18.D0*
     &    x2**4*x1px2**(-2) + 20.D0/3.D0*x2**4*x1px2**(-1) + 22*x2**4
     &     + 42*x2**5*x1px2**(-3) - 4*x2**5*x1px2**(-2) - 134.D0/3.D0*
     &    x2**5*x1px2**(-1) )
      e0 = e0 + rtree1 * (  - 14*x2**6*x1px2**(-4) + 4.D0/3.D0*x2**6*
     &    x1px2**(-3) + 110.D0/3.D0*x2**6*x1px2**(-2) - 56.D0/3.D0*
     &    x2**7*x1px2**(-3) + 14.D0/3.D0*x2**8*x1px2**(-4) + 320.D0/3.D0
     &    *x1*x2**(-3) - 191.D0/3.D0*x1*x2**(-2) + 43.D0/6.D0*x1*
     &    x2**(-1) - 109.D0/9.D0*x1 + 149.D0/18.D0*x1*x2 + 4.D0/3.D0*x1
     &    *x2**2 - 26.D0/3.D0*x1*x2**3 - 320.D0/3.D0*x1**2*x2**(-3) + 
     &    353.D0/6.D0*x1**2*x2**(-2) - 35.D0/3.D0*x1**2*x2**(-1) + 139.D
     &    0/18.D0*x1**2 - 4.D0/3.D0*x1**2*x2 + 14.D0/3.D0*x1**2*x2**2 )
      e0 = e0 + dls12*rtree1 * ( 23.D0/3.D0 + 22*x1**(-3)*x2 - 22*
     &    x1**(-3)*x2**2 + 3*x1**(-2) - 14*x1**(-2)*x2 + 11*x1**(-2)*
     &    x2**2 + 7*x1**(-1)*x2**(-1) - 4*x1**(-1) + 3*x1**(-1)*x2 - 10.
     &    D0/3.D0*x1**(-1)*x2**2 + 3*x2**(-2) - 4*x2**(-1) - 5.D0/3.D0*
     &    x1px2**(-2) + 4.D0/3.D0*x2*x1px2**(-3) + 10.D0/3.D0*x2*
     &    x1px2**(-1) - 5*x2 - 4.D0/3.D0*x2**2*x1px2**(-4) + 2.D0/3.D0*
     &    x2**2*x1px2**(-2) + 14.D0/3.D0*x2**2 - 8*x2**3*x1px2**(-3) - 
     &    2.D0/3.D0*x2**3*x1px2**(-1) + 4*x2**4*x1px2**(-4) - 29.D0/3.D0
     &    *x2**4*x1px2**(-2) + 20.D0/3.D0*x2**4 + 12*x2**5*x1px2**(-3)
     &     - 40.D0/3.D0*x2**5*x1px2**(-1) - 4*x2**6*x1px2**(-4) + 32.D0/
     &    3.D0*x2**6*x1px2**(-2) - 16.D0/3.D0*x2**7*x1px2**(-3) + 4.D0/
     &    3.D0*x2**8*x1px2**(-4) + 22*x1*x2**(-3) - 14*x1*x2**(-2) + 3*
     &    x1*x2**(-1) - 5*x1 + 11.D0/3.D0*x1*x2 - 8.D0/3.D0*x1*x2**3 - 
     &    22*x1**2*x2**(-3) + 11*x1**2*x2**(-2) - 10.D0/3.D0*x1**2*
     &    x2**(-1) + 7.D0/3.D0*x1**2 + 4.D0/3.D0*x1**2*x2**2 )
      e0 = e0 + d1x2*rtree1 * ( 5.D0/6.D0 - 4.D0/3.D0*x1**(-1) - 1.D0/6.
     &    D0*x1 + 4.D0/3.D0*x1**2 )
      e0 = e0 + d0x2*rloop2 * ( 4 - 2*x1**(-1) - 2*x1 + 2*x1**2 )
      e0 = e0 + d0x2*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D0*x1**(-1) - 
     &    7.D0/18.D0*x1 - 17.D0/9.D0*x1**2 )
      e0 = e0 + d0x2*dls12*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*x1**(-1)
     &     + 1.D0/6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + d1x1*rtree1 * ( 5.D0/6.D0 - 4.D0/3.D0*x2**(-1) - 1.D0/6.
     &    D0*x2 + 4.D0/3.D0*x2**2 )
      e0 = e0 + d1x1*d0x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d0x1*rloop2 * ( 4 - 2*x2**(-1) - 2*x2 + 2*x2**2 )
      e0 = e0 + d0x1*rtree1 * (  - 19.D0/18.D0 + 20.D0/9.D0*x2**(-1) - 
     &    7.D0/18.D0*x2 - 17.D0/9.D0*x2**2 )
      e0 = e0 + d0x1*dls12*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0*x2**(-1)
     &     + 1.D0/6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + d0x1*d1x2*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + d0x1*d0x2*rloop2 * (  - 2 )
      e0 = e0 + d0x1*d0x2*rtree1 * ( 10.D0/9.D0 )
      e0 = e0 + d0x1*d0x2*dls12*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + dlmuF*opx1**(-1)*opx2**(-1)*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + dlmuF*opx1**(-1)*rtree1 * (  - 25.D0/6.D0 - 2.D0/3.D0*
     &    x2**(-1) + 13.D0/6.D0*x2 - 4*x2**2 )
      e0 = e0 + dlmuF*opx2**(-1)*rtree1 * (  - 25.D0/6.D0 - 2.D0/3.D0*
     &    x1**(-1) + 13.D0/6.D0*x1 - 4*x1**2 )
      e0 = e0 + dlmuF*rtree1 * ( 1.D0/3.D0 - 22*x1**(-3)*x2 + 22*
     &    x1**(-3)*x2**2 - 3*x1**(-2) + 14*x1**(-2)*x2 - 11*x1**(-2)*
     &    x2**2 - 3*x1**(-1)*x2**(-1) + 4*x1**(-1) - 3*x1**(-1)*x2 + 10.
     &    D0/3.D0*x1**(-1)*x2**2 - 3*x2**(-2) + 4*x2**(-1) - 19.D0/3.D0
     &    *x1px2**(-2) + 8.D0/3.D0*x2*x1px2**(-3) + 2.D0/3.D0*x2*
     &    x1px2**(-1) + 5*x2 - 8.D0/3.D0*x2**2*x1px2**(-4) + 22.D0/3.D0
     &    *x2**2*x1px2**(-2) + 10.D0/3.D0*x2**2 - 16*x2**3*x1px2**(-3)
     &     + 14.D0/3.D0*x2**3*x1px2**(-1) + 8*x2**4*x1px2**(-4) - 67.D0/
     &    3.D0*x2**4*x1px2**(-2) + 40.D0/3.D0*x2**4 + 24*x2**5*
     &    x1px2**(-3) - 80.D0/3.D0*x2**5*x1px2**(-1) - 8*x2**6*
     &    x1px2**(-4) + 64.D0/3.D0*x2**6*x1px2**(-2) - 32.D0/3.D0*x2**7
     &    *x1px2**(-3) + 8.D0/3.D0*x2**8*x1px2**(-4) - 22*x1*x2**(-3)
     &     + 14*x1*x2**(-2) - 3*x1*x2**(-1) + 5*x1 - 23.D0/3.D0*x1*x2
     &     - 16.D0/3.D0*x1*x2**3 + 22*x1**2*x2**(-3) - 11*x1**2*
     &    x2**(-2) + 10.D0/3.D0*x1**2*x2**(-1) + 5.D0/3.D0*x1**2 + 8.D0/
     &    3.D0*x1**2*x2**2 )
      e0 = e0 + dlmuF*d0x2*rtree1 * (  - 19.D0/6.D0 + 2.D0/3.D0*
     &    x1**(-1) + 11.D0/6.D0*x1 - 2.D0/3.D0*x1**2 )
      e0 = e0 + dlmuF*d0x1*rtree1 * (  - 19.D0/6.D0 + 2.D0/3.D0*
     &    x2**(-1) + 11.D0/6.D0*x2 - 2.D0/3.D0*x2**2 )
      e0 = e0 + dlmuF*d0x1*d0x2*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + GII(11,1)*opx1**(-1)*rtree1 * ( 1 - x2 )
      e0 = e0 + GII(11,1)*omx1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(11,1)*opx2**(-1)*rtree1 * (  - 1 + x1 )
      e0 = e0 + GII(11,1)*omx2**(-1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(11,1)*rtree1 * ( 22*x1**(-4)*x2**2 + 14*x1**(-3)*x2
     &     + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2 - 4*x2**(-2)
     &     - 14*x1*x2**(-3) - 2*x1*x2**(-1) - 22*x1**2*x2**(-4) + 4*
     &    x1**2*x2**(-2) )
      e0 = e0 + GII(12,1)*rtree1 * (  - 2 - 4*x2**(-2) - 3*x2**2 - 14*
     &    x1*x2**(-3) - 2*x1*x2**(-1) - 2*x1*x2 - 22*x1**2*x2**(-4) + 4
     &    *x1**2*x2**(-2) )
      e0 = e0 + GII(12,2)*rtree1 * (  - 2 - 22*x1**(-4)*x2**2 - 14*
     &    x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*x1**(-1)*x2
     &     - 2*x1*x2 - 3*x1**2 )
      e0 = e0 + GII(15,1)*opx1**(-1)*opx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(15,1)*opx1**(-1)*rtree1 * ( 1.D0/6.D0 - 4.D0/3.D0*
     &    x2**(-1) - 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + GII(15,1)*omx1**(-1)*omx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(15,1)*omx1**(-1)*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + GII(15,1)*opx2**(-1)*rtree1 * ( 1.D0/6.D0 - 4.D0/3.D0*
     &    x1**(-1) - 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + GII(15,1)*omx2**(-1)*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + GII(15,1)*rtree1 * (  - 4.D0/3.D0 - 254.D0/3.D0*
     &    x1**(-4)*x2**2 - 116.D0/3.D0*x1**(-3)*x2 - 19.D0/3.D0*
     &    x1**(-2) + 26*x1**(-2)*x2**2 + 16.D0/3.D0*x1**(-1)*x2**(-1)
     &     + 22.D0/3.D0*x1**(-1)*x2 + 4.D0/3.D0*x1**(-1)*x2**3 - 19.D0/
     &    3.D0*x2**(-2) - 8.D0/3.D0*x2**2 - 116.D0/3.D0*x1*x2**(-3) + 
     &    22.D0/3.D0*x1*x2**(-1) - 22.D0/3.D0*x1*x2 - 254.D0/3.D0*x1**2
     &    *x2**(-4) + 26*x1**2*x2**(-2) - 8.D0/3.D0*x1**2 + 4.D0/3.D0*
     &    x1**3*x2**(-1) )
      e0 = e0 + GII(15,1)*dls12*rtree1 * (  - 4 - 22*x1**(-4)*x2**2 - 
     &    14*x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*x1**(-1)*
     &    x2 - 4*x2**(-2) - 3*x2**2 - 14*x1*x2**(-3) - 2*x1*x2**(-1) - 
     &    4*x1*x2 - 22*x1**2*x2**(-4) + 4*x1**2*x2**(-2) - 3*x1**2 )
      e0 = e0 + GII(15,1)*dlmuF*rtree1 * ( 4 + 22*x1**(-4)*x2**2 + 14*
     &    x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2
     &     + 4*x2**(-2) + 3*x2**2 + 14*x1*x2**(-3) + 2*x1*x2**(-1) + 4*
     &    x1*x2 + 22*x1**2*x2**(-4) - 4*x1**2*x2**(-2) + 3*x1**2 )
      e0 = e0 + GII(15,1)**2*rtree1 * (  - 2 - 11*x1**(-4)*x2**2 - 7*
     &    x1**(-3)*x2 - 2*x1**(-2) + 2*x1**(-2)*x2**2 - x1**(-1)*x2 - 2
     &    *x2**(-2) - 3.D0/2.D0*x2**2 - 7*x1*x2**(-3) - x1*x2**(-1) - 2
     &    *x1*x2 - 11*x1**2*x2**(-4) + 2*x1**2*x2**(-2) - 3.D0/2.D0*
     &    x1**2 )
      e0 = e0 + GII(15,1)*GII(30,1)*rtree1 * (  - 4 - 22*x1**(-4)*x2**2
     &     - 14*x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*
     &    x1**(-1)*x2 - 4*x2**(-2) - 3*x2**2 - 14*x1*x2**(-3) - 2*x1*
     &    x2**(-1) - 4*x1*x2 - 22*x1**2*x2**(-4) + 4*x1**2*x2**(-2) - 3
     &    *x1**2 )
      e0 = e0 + GII(15,1)*GII(30,2)*rtree1 * (  - 4 - 22*x1**(-4)*x2**2
     &     - 14*x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*
     &    x1**(-1)*x2 - 4*x2**(-2) - 3*x2**2 - 14*x1*x2**(-3) - 2*x1*
     &    x2**(-1) - 4*x1*x2 - 22*x1**2*x2**(-4) + 4*x1**2*x2**(-2) - 3
     &    *x1**2 )
      e0 = e0 + GII(15,1)*GII(31,1)*rtree1 * (  - 2 - 4*x2**(-2) - 3*
     &    x2**2 - 14*x1*x2**(-3) - 2*x1*x2**(-1) - 2*x1*x2 - 22*x1**2*
     &    x2**(-4) + 4*x1**2*x2**(-2) )
      e0 = e0 + GII(15,1)*GII(31,2)*rtree1 * (  - 2 - 22*x1**(-4)*x2**2
     &     - 14*x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*
     &    x1**(-1)*x2 - 2*x1*x2 - 3*x1**2 )
      e0 = e0 + GII(15,1)*PLI1(1)*rtree1 * ( 4 + 22*x1**(-4)*x2**2 + 14
     &    *x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2
     &     + 4*x2**(-2) + 3*x2**2 + 14*x1*x2**(-3) + 2*x1*x2**(-1) + 4*
     &    x1*x2 + 22*x1**2*x2**(-4) - 4*x1**2*x2**(-2) + 3*x1**2 )
      e0 = e0 + GII(15,1)*PLI1(2)*rtree1 * ( 4 + 22*x1**(-4)*x2**2 + 14
     &    *x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2
     &     + 4*x2**(-2) + 3*x2**2 + 14*x1*x2**(-3) + 2*x1*x2**(-1) + 4*
     &    x1*x2 + 22*x1**2*x2**(-4) - 4*x1**2*x2**(-2) + 3*x1**2 )
      e0 = e0 + GII(18,1)*opx2**(-1)*rtree1 * ( 1 - x1 )
      e0 = e0 + GII(18,1)*rtree1 * ( 4*x2**(-2) + 14*x1*x2**(-3) + 2*x1
     &    *x2**(-1) + 22*x1**2*x2**(-4) - 4*x1**2*x2**(-2) )
      e0 = e0 + GII(18,1)*d0x2*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(18,2)*opx1**(-1)*rtree1 * ( 1 - x2 )
      e0 = e0 + GII(18,2)*rtree1 * ( 22*x1**(-4)*x2**2 + 14*x1**(-3)*x2
     &     + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2 )
      e0 = e0 + GII(18,2)*d0x1*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(20,1)*opx2**(-1)*rtree1 * (  - 1 + x1 )
      e0 = e0 + GII(20,1)*rtree1 * (  - 4*x2**(-2) - 14*x1*x2**(-3) - 2
     &    *x1*x2**(-1) - 22*x1**2*x2**(-4) + 4*x1**2*x2**(-2) )
      e0 = e0 + GII(20,1)*d0x2*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(20,2)*opx1**(-1)*rtree1 * (  - 1 + x2 )
      e0 = e0 + GII(20,2)*rtree1 * (  - 22*x1**(-4)*x2**2 - 14*x1**(-3)
     &    *x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*x1**(-1)*x2 )
      e0 = e0 + GII(20,2)*d0x1*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(21,1)*rtree1 * ( 2 + 4*x2**(-2) + 3*x2**2 + 14*x1*
     &    x2**(-3) + 2*x1*x2**(-1) + 2*x1*x2 + 22*x1**2*x2**(-4) - 4*
     &    x1**2*x2**(-2) )
      e0 = e0 + GII(21,2)*rtree1 * ( 2 + 22*x1**(-4)*x2**2 + 14*
     &    x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2
     &     + 2*x1*x2 + 3*x1**2 )
      e0 = e0 + GII(30,1)*opx1**(-1)*opx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(30,1)*opx1**(-1)*rtree1 * ( 1.D0/6.D0 - 4.D0/3.D0*
     &    x2**(-1) - 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + GII(30,1)*omx1**(-1)*omx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(30,1)*omx1**(-1)*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0
     &    *x2**(-1) + 1.D0/6.D0*x2 - 4.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,1)*opx2**(-1)*omx1x2**(-1)*rtree1 * (  - 2.D0/3.D
     &    0 )
      e0 = e0 + GII(30,1)*opx2**(-1)*rtree1 * ( 7.D0/6.D0 - rln2 - 13.D0
     &    /6.D0*x1 + x1*rln2 )
      e0 = e0 + GII(30,1)*opx2**(-1)*dls12*rtree1 * ( 1 - x1 )
      e0 = e0 + GII(30,1)*omx2**(-1)*omx1x2**(-1)*rtree1 * (  - 2.D0/3.D
     &    0 )
      e0 = e0 + GII(30,1)*omx1x2**(-3)*rtree1 * ( 4.D0/3.D0*x1**2 - 4.D0
     &    /3.D0*x1**4 )
      e0 = e0 + GII(30,1)*omx1x2**(-2)*rtree1 * (  - 4.D0/3.D0*x1**2 + 
     &    2.D0/3.D0*x1**4 )
      e0 = e0 + GII(30,1)*omx1x2**(-1)*rtree1 * (  - 4.D0/3.D0*x1**2 - 
     &    4.D0/3.D0*x1**4 )
      e0 = e0 + GII(30,1)*rtree1 * ( 20.D0/3.D0 + 22*x1**(-3)*x2 - 22*
     &    x1**(-3)*x2**2 + 3*x1**(-2) - 14*x1**(-2)*x2 + 11*x1**(-2)*
     &    x2**2 + 13.D0/3.D0*x1**(-1)*x2**(-1) - 4*x1**(-1) + 3*
     &    x1**(-1)*x2 - 10.D0/3.D0*x1**(-1)*x2**2 + 28.D0/3.D0*x2**(-2)
     &     - 4*x2**(-2)*rln2 - 4*x2**(-1) - 5.D0/3.D0*x1px2**(-2) + 4.D0
     &    /3.D0*x2*x1px2**(-3) + 10.D0/3.D0*x2*x1px2**(-1) - 5*x2 - 4.D0
     &    /3.D0*x2**2*x1px2**(-4) + 2.D0/3.D0*x2**2*x1px2**(-2) + 14.D0/
     &    3.D0*x2**2 - 8*x2**3*x1px2**(-3) - 2.D0/3.D0*x2**3*
     &    x1px2**(-1) + 4*x2**4*x1px2**(-4) - 29.D0/3.D0*x2**4*
     &    x1px2**(-2) + 20.D0/3.D0*x2**4 + 12*x2**5*x1px2**(-3) - 40.D0/
     &    3.D0*x2**5*x1px2**(-1) - 4*x2**6*x1px2**(-4) + 32.D0/3.D0*
     &    x2**6*x1px2**(-2) - 16.D0/3.D0*x2**7*x1px2**(-3) + 4.D0/3.D0*
     &    x2**8*x1px2**(-4) + 182.D0/3.D0*x1*x2**(-3) - 14*x1*x2**(-3)*
     &    rln2 - 14*x1*x2**(-2) - 13.D0/3.D0*x1*x2**(-1) - 2*x1*
     &    x2**(-1)*rln2 - 5*x1 + 11.D0/3.D0*x1*x2 - 8.D0/3.D0*x1*x2**3
     &     + 254.D0/3.D0*x1**2*x2**(-4) )
      e0 = e0 + GII(30,1)*rtree1 * (  - 22*x1**2*x2**(-4)*rln2 - 22*
     &    x1**2*x2**(-3) - 15*x1**2*x2**(-2) + 4*x1**2*x2**(-2)*rln2 - 
     &    10.D0/3.D0*x1**2*x2**(-1) + 7.D0/3.D0*x1**2 + 4.D0/3.D0*x1**2
     &    *x2**2 - 4.D0/3.D0*x1**3*x2**(-1) )
      e0 = e0 + GII(30,1)*dls12*rtree1 * ( 4*x2**(-2) + 14*x1*x2**(-3)
     &     + 2*x1*x2**(-1) + 22*x1**2*x2**(-4) - 4*x1**2*x2**(-2) )
      e0 = e0 + GII(30,1)*d1x2*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(30,1)*d0x2*rtree1 * ( 1.D0/6.D0 - rln2 - 11.D0/6.D0
     &    *x1 - x1*rln2 - 10.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,1)*d0x2*dls12*rtree1 * ( 1 + x1 )
      e0 = e0 + GII(30,1)*dlmuF*opx2**(-1)*rtree1 * (  - 1 + x1 )
      e0 = e0 + GII(30,1)*dlmuF*rtree1 * (  - 4*x2**(-2) - 14*x1*
     &    x2**(-3) - 2*x1*x2**(-1) - 22*x1**2*x2**(-4) + 4*x1**2*
     &    x2**(-2) )
      e0 = e0 + GII(30,1)*dlmuF*d0x2*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(30,1)**2*opx2**(-1)*rtree1 * ( 1.D0/2.D0 - 1.D0/2.D0
     &    *x1 )
      e0 = e0 + GII(30,1)**2*rtree1 * ( 2*x2**(-2) + 7*x1*x2**(-3) + x1
     &    *x2**(-1) + 11*x1**2*x2**(-4) - 2*x1**2*x2**(-2) )
      e0 = e0 + GII(30,1)**2*d0x2*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*x1 )
      e0 = e0 + GII(30,1)*GII(30,2)*opx1**(-1)*rtree1 * ( 1 - x2 )
      e0 = e0 + GII(30,1)*GII(30,2)*omx1**(-1)*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,1)*GII(30,2)*opx2**(-1)*rtree1 * ( 2 - 2*x1 )
      e0 = e0 + GII(30,1)*GII(30,2)*omx2**(-1)*rtree1 * ( 2 + 2*x1 )
      e0 = e0 + GII(30,1)*GII(30,2)*rtree1 * ( 22*x1**(-4)*x2**2 + 14*
     &    x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2
     &     + 8*x2**(-2) + 28*x1*x2**(-3) + 4*x1*x2**(-1) + 44*x1**2*
     &    x2**(-4) - 8*x1**2*x2**(-2) )
      e0 = e0 + GII(30,1)*GII(31,1)*rtree1 * (  - 2 - 4*x2**(-2) - 3*
     &    x2**2 - 14*x1*x2**(-3) - 2*x1*x2**(-1) - 2*x1*x2 - 22*x1**2*
     &    x2**(-4) + 4*x1**2*x2**(-2) )
      e0 = e0 + GII(30,1)*GII(31,2)*opx2**(-1)*rtree1 * (  - 1 + x1 )
      e0 = e0 + GII(30,1)*GII(31,2)*omx2**(-1)*rtree1 * (  - 1 - x1 )
      e0 = e0 + GII(30,1)*GII(31,2)*rtree1 * (  - 2 - 22*x1**(-4)*x2**2
     &     - 14*x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*
     &    x1**(-1)*x2 - 4*x2**(-2) - 14*x1*x2**(-3) - 2*x1*x2**(-1) - 2
     &    *x1*x2 - 22*x1**2*x2**(-4) + 4*x1**2*x2**(-2) - 3*x1**2 )
      e0 = e0 + GII(30,1)*PLI1(2)*opx2**(-1)*rtree1 * (  - 1 + x1 )
      e0 = e0 + GII(30,1)*PLI1(2)*rtree1 * (  - 4*x2**(-2) - 14*x1*
     &    x2**(-3) - 2*x1*x2**(-1) - 22*x1**2*x2**(-4) + 4*x1**2*
     &    x2**(-2) )
      e0 = e0 + GII(30,2)*opx1**(-1)*rtree1 * ( 7.D0/6.D0 - rln2 - 13.D0
     &    /6.D0*x2 + x2*rln2 )
      e0 = e0 + GII(30,2)*opx1**(-1)*dls12*rtree1 * ( 1 - x2 )
      e0 = e0 + GII(30,2)*opx2**(-1)*omx1x2**(-1)*rtree1 * ( 2.D0/3.D0
     &     )
      e0 = e0 + GII(30,2)*opx2**(-1)*rtree1 * ( 1.D0/6.D0 - 4.D0/3.D0*
     &    x1**(-1) - 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + GII(30,2)*omx2**(-1)*omx1x2**(-1)*rtree1 * ( 2.D0/3.D0
     &     )
      e0 = e0 + GII(30,2)*omx2**(-1)*rtree1 * (  - 5.D0/6.D0 + 4.D0/3.D0
     &    *x1**(-1) + 1.D0/6.D0*x1 - 4.D0/3.D0*x1**2 )
      e0 = e0 + GII(30,2)*omx1x2**(-3)*rtree1 * ( 4.D0/3.D0*x2**2 - 4.D0
     &    /3.D0*x2**4 )
      e0 = e0 + GII(30,2)*omx1x2**(-2)*rtree1 * (  - 4.D0/3.D0*x2**2 + 
     &    2.D0/3.D0*x2**4 )
      e0 = e0 + GII(30,2)*omx1x2**(-1)*rtree1 * (  - 4.D0/3.D0 - 4.D0/3.
     &    D0*x2**2 - 4.D0/3.D0*x2**4 )
      e0 = e0 + GII(30,2)*rtree1 * ( 20.D0/3.D0 + 254.D0/3.D0*x1**(-4)*
     &    x2**2 - 22*x1**(-4)*x2**2*rln2 + 182.D0/3.D0*x1**(-3)*x2 - 14
     &    *x1**(-3)*x2*rln2 - 22*x1**(-3)*x2**2 + 28.D0/3.D0*x1**(-2)
     &     - 4*x1**(-2)*rln2 - 14*x1**(-2)*x2 - 15*x1**(-2)*x2**2 + 4*
     &    x1**(-2)*x2**2*rln2 + 13.D0/3.D0*x1**(-1)*x2**(-1) - 4*
     &    x1**(-1) - 13.D0/3.D0*x1**(-1)*x2 - 2*x1**(-1)*x2*rln2 - 10.D0
     &    /3.D0*x1**(-1)*x2**2 - 4.D0/3.D0*x1**(-1)*x2**3 + 3*x2**(-2)
     &     - 4*x2**(-1) - 5.D0/3.D0*x1px2**(-2) + 4.D0/3.D0*x2*
     &    x1px2**(-3) + 10.D0/3.D0*x2*x1px2**(-1) - 5*x2 - 4.D0/3.D0*
     &    x2**2*x1px2**(-4) + 2.D0/3.D0*x2**2*x1px2**(-2) + 14.D0/3.D0*
     &    x2**2 - 8*x2**3*x1px2**(-3) - 2.D0/3.D0*x2**3*x1px2**(-1) + 4
     &    *x2**4*x1px2**(-4) - 29.D0/3.D0*x2**4*x1px2**(-2) + 20.D0/3.D0
     &    *x2**4 + 12*x2**5*x1px2**(-3) - 40.D0/3.D0*x2**5*x1px2**(-1)
     &     - 4*x2**6*x1px2**(-4) + 32.D0/3.D0*x2**6*x1px2**(-2) - 16.D0/
     &    3.D0*x2**7*x1px2**(-3) + 4.D0/3.D0*x2**8*x1px2**(-4) + 22*x1*
     &    x2**(-3) )
      e0 = e0 + GII(30,2)*rtree1 * (  - 14*x1*x2**(-2) + 3*x1*x2**(-1)
     &     - 5*x1 + 11.D0/3.D0*x1*x2 - 8.D0/3.D0*x1*x2**3 - 22*x1**2*
     &    x2**(-3) + 11*x1**2*x2**(-2) - 10.D0/3.D0*x1**2*x2**(-1) + 7.D
     &    0/3.D0*x1**2 + 4.D0/3.D0*x1**2*x2**2 )
      e0 = e0 + GII(30,2)*dls12*rtree1 * ( 22*x1**(-4)*x2**2 + 14*
     &    x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2 )
      e0 = e0 + GII(30,2)*d1x1*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(30,2)*d0x1*rtree1 * ( 1.D0/6.D0 - rln2 - 11.D0/6.D0
     &    *x2 - x2*rln2 - 10.D0/3.D0*x2**2 )
      e0 = e0 + GII(30,2)*d0x1*dls12*rtree1 * ( 1 + x2 )
      e0 = e0 + GII(30,2)*dlmuF*opx1**(-1)*rtree1 * (  - 1 + x2 )
      e0 = e0 + GII(30,2)*dlmuF*rtree1 * (  - 22*x1**(-4)*x2**2 - 14*
     &    x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*x1**(-1)*x2 )
      e0 = e0 + GII(30,2)*dlmuF*d0x1*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(30,2)**2*opx1**(-1)*rtree1 * ( 1.D0/2.D0 - 1.D0/2.D0
     &    *x2 )
      e0 = e0 + GII(30,2)**2*rtree1 * ( 11*x1**(-4)*x2**2 + 7*x1**(-3)*
     &    x2 + 2*x1**(-2) - 2*x1**(-2)*x2**2 + x1**(-1)*x2 )
      e0 = e0 + GII(30,2)**2*d0x1*rtree1 * ( 1.D0/2.D0 + 1.D0/2.D0*x2 )
      e0 = e0 + GII(30,2)*GII(31,1)*opx1**(-1)*rtree1 * (  - 1 + x2 )
      e0 = e0 + GII(30,2)*GII(31,1)*omx1**(-1)*rtree1 * (  - 1 - x2 )
      e0 = e0 + GII(30,2)*GII(31,1)*rtree1 * (  - 2 - 22*x1**(-4)*x2**2
     &     - 14*x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*
     &    x1**(-1)*x2 - 4*x2**(-2) - 3*x2**2 - 14*x1*x2**(-3) - 2*x1*
     &    x2**(-1) - 2*x1*x2 - 22*x1**2*x2**(-4) + 4*x1**2*x2**(-2) )
      e0 = e0 + GII(30,2)*GII(31,2)*rtree1 * (  - 2 - 22*x1**(-4)*x2**2
     &     - 14*x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*
     &    x1**(-1)*x2 - 2*x1*x2 - 3*x1**2 )
      e0 = e0 + GII(30,2)*PLI1(1)*opx1**(-1)*rtree1 * (  - 1 + x2 )
      e0 = e0 + GII(30,2)*PLI1(1)*rtree1 * (  - 22*x1**(-4)*x2**2 - 14*
     &    x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*x1**(-1)*x2 )
      e0 = e0 + GII(31,1)*opx1**(-1)*opx2**(-1)*rtree1 * (  - 2.D0/3.D0
     &     )
      e0 = e0 + GII(31,1)*omx1**(-1)*omx2**(-1)*rtree1 * (  - 4.D0/3.D0
     &     )
      e0 = e0 + GII(31,1)*omx1**(-1)*d0x2*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(31,1)*opx2**(-1)*omx1x2**(-1)*rtree1 * ( 4.D0/3.D0
     &     )
      e0 = e0 + GII(31,1)*opx2**(-1)*rtree1 * ( 1.D0/6.D0 - 4.D0/3.D0*
     &    x1**(-1) - 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + GII(31,1)*omx2**(-1)*omx1x2**(-1)*rtree1 * ( 4.D0/3.D0
     &     )
      e0 = e0 + GII(31,1)*omx1x2**(-3)*rtree1 * ( 4.D0/3.D0*x2**2 - 4.D0
     &    /3.D0*x2**4 - 4.D0/3.D0*x1**2 + 4.D0/3.D0*x1**4 )
      e0 = e0 + GII(31,1)*omx1x2**(-2)*rtree1 * (  - 4.D0/3.D0*x2**2 + 
     &    2.D0/3.D0*x2**4 + 4.D0/3.D0*x1**2 - 2.D0/3.D0*x1**4 )
      e0 = e0 + GII(31,1)*omx1x2**(-1)*rtree1 * (  - 4.D0/3.D0 - 4.D0/3.
     &    D0*x2**2 - 4.D0/3.D0*x2**4 + 4.D0/3.D0*x1**2 + 4.D0/3.D0*
     &    x1**4 )
      e0 = e0 + GII(31,1)*rtree1 * ( 8.D0/3.D0*x1**(-1)*x2**(-1) - 19.D0
     &    /3.D0*x2**(-2) - 8.D0/3.D0*x2**2 - 116.D0/3.D0*x1*x2**(-3) + 
     &    22.D0/3.D0*x1*x2**(-1) - 3*x1*x2 - 254.D0/3.D0*x1**2*x2**(-4)
     &     + 26*x1**2*x2**(-2) + 4.D0/3.D0*x1**2 + 4.D0/3.D0*x1**3*
     &    x2**(-1) )
      e0 = e0 + GII(31,1)*dls12*rtree1 * (  - 2 - 4*x2**(-2) - 3*x2**2
     &     - 14*x1*x2**(-3) - 2*x1*x2**(-1) - 2*x1*x2 - 22*x1**2*
     &    x2**(-4) + 4*x1**2*x2**(-2) )
      e0 = e0 + GII(31,1)*d0x2*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 25.D0/6.D0*x1 + 2*x1**2 )
      e0 = e0 + GII(31,1)*dlmuF*rtree1 * ( 2 + 4*x2**(-2) + 3*x2**2 + 
     &    14*x1*x2**(-3) + 2*x1*x2**(-1) + 2*x1*x2 + 22*x1**2*x2**(-4)
     &     - 4*x1**2*x2**(-2) )
      e0 = e0 + GII(31,1)*PLI1(1)*rtree1 * ( 2 + 4*x2**(-2) + 3*x2**2
     &     + 14*x1*x2**(-3) + 2*x1*x2**(-1) + 2*x1*x2 + 22*x1**2*
     &    x2**(-4) - 4*x1**2*x2**(-2) )
      e0 = e0 + GII(31,1)*PLI1(2)*rtree1 * ( 2 + 4*x2**(-2) + 3*x2**2
     &     + 14*x1*x2**(-3) + 2*x1*x2**(-1) + 2*x1*x2 + 22*x1**2*
     &    x2**(-4) - 4*x1**2*x2**(-2) )
      e0 = e0 + GII(31,2)*opx1**(-1)*opx2**(-1)*rtree1 * ( 4.D0/3.D0 )
      e0 = e0 + GII(31,2)*opx1**(-1)*rtree1 * ( 1.D0/6.D0 - 4.D0/3.D0*
     &    x2**(-1) - 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + GII(31,2)*omx1**(-1)*omx2**(-1)*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(31,2)*opx2**(-1)*omx1x2**(-1)*rtree1 * (  - 4.D0/3.D
     &    0 )
      e0 = e0 + GII(31,2)*omx2**(-1)*omx1x2**(-1)*rtree1 * (  - 4.D0/3.D
     &    0 )
      e0 = e0 + GII(31,2)*omx2**(-1)*d0x1*rtree1 * ( 2.D0/3.D0 )
      e0 = e0 + GII(31,2)*omx1x2**(-3)*rtree1 * (  - 4.D0/3.D0*x2**2 + 
     &    4.D0/3.D0*x2**4 + 4.D0/3.D0*x1**2 - 4.D0/3.D0*x1**4 )
      e0 = e0 + GII(31,2)*omx1x2**(-2)*rtree1 * ( 4.D0/3.D0*x2**2 - 2.D0
     &    /3.D0*x2**4 - 4.D0/3.D0*x1**2 + 2.D0/3.D0*x1**4 )
      e0 = e0 + GII(31,2)*omx1x2**(-1)*rtree1 * ( 4.D0/3.D0 + 4.D0/3.D0
     &    *x2**2 + 4.D0/3.D0*x2**4 - 4.D0/3.D0*x1**2 - 4.D0/3.D0*x1**4
     &     )
      e0 = e0 + GII(31,2)*rtree1 * (  - 4.D0/3.D0 - 254.D0/3.D0*
     &    x1**(-4)*x2**2 - 116.D0/3.D0*x1**(-3)*x2 - 19.D0/3.D0*
     &    x1**(-2) + 26*x1**(-2)*x2**2 + 8.D0/3.D0*x1**(-1)*x2**(-1) + 
     &    22.D0/3.D0*x1**(-1)*x2 + 4.D0/3.D0*x1**(-1)*x2**3 - 13.D0/3.D0
     &    *x1*x2 - 4*x1**2 )
      e0 = e0 + GII(31,2)*dls12*rtree1 * (  - 2 - 22*x1**(-4)*x2**2 - 
     &    14*x1**(-3)*x2 - 4*x1**(-2) + 4*x1**(-2)*x2**2 - 2*x1**(-1)*
     &    x2 - 2*x1*x2 - 3*x1**2 )
      e0 = e0 + GII(31,2)*d0x1*rtree1 * ( 1.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 25.D0/6.D0*x2 + 2*x2**2 )
      e0 = e0 + GII(31,2)*dlmuF*rtree1 * ( 2 + 22*x1**(-4)*x2**2 + 14*
     &    x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2
     &     + 2*x1*x2 + 3*x1**2 )
      e0 = e0 + GII(31,2)*PLI1(1)*rtree1 * ( 2 + 22*x1**(-4)*x2**2 + 14
     &    *x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2
     &     + 2*x1*x2 + 3*x1**2 )
      e0 = e0 + GII(31,2)*PLI1(2)*rtree1 * ( 2 + 22*x1**(-4)*x2**2 + 14
     &    *x1**(-3)*x2 + 4*x1**(-2) - 4*x1**(-2)*x2**2 + 2*x1**(-1)*x2
     &     + 2*x1*x2 + 3*x1**2 )
      e0 = e0 + PLI1(1)*opx1**(-1)*opx2**(-1)*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + PLI1(1)*opx1**(-1)*rtree1 * (  - 1.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 25.D0/6.D0*x2 - 2*x2**2 )
      e0 = e0 + PLI1(1)*opx2**(-1)*rtree1 * (  - 1.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 25.D0/6.D0*x1 - 2*x1**2 )
      e0 = e0 + PLI1(1)*rtree1 * (  - 23.D0/3.D0 - 22*x1**(-3)*x2 + 22*
     &    x1**(-3)*x2**2 - 3*x1**(-2) + 14*x1**(-2)*x2 - 11*x1**(-2)*
     &    x2**2 - 7*x1**(-1)*x2**(-1) + 4*x1**(-1) - 3*x1**(-1)*x2 + 10.
     &    D0/3.D0*x1**(-1)*x2**2 - 3*x2**(-2) + 4*x2**(-1) + 5.D0/3.D0*
     &    x1px2**(-2) - 4.D0/3.D0*x2*x1px2**(-3) - 10.D0/3.D0*x2*
     &    x1px2**(-1) + 5*x2 + 4.D0/3.D0*x2**2*x1px2**(-4) - 2.D0/3.D0*
     &    x2**2*x1px2**(-2) - 14.D0/3.D0*x2**2 + 8*x2**3*x1px2**(-3) + 
     &    2.D0/3.D0*x2**3*x1px2**(-1) - 4*x2**4*x1px2**(-4) + 29.D0/3.D0
     &    *x2**4*x1px2**(-2) - 20.D0/3.D0*x2**4 - 12*x2**5*x1px2**(-3)
     &     + 40.D0/3.D0*x2**5*x1px2**(-1) + 4*x2**6*x1px2**(-4) - 32.D0/
     &    3.D0*x2**6*x1px2**(-2) + 16.D0/3.D0*x2**7*x1px2**(-3) - 4.D0/
     &    3.D0*x2**8*x1px2**(-4) - 22*x1*x2**(-3) + 14*x1*x2**(-2) - 3*
     &    x1*x2**(-1) + 5*x1 - 11.D0/3.D0*x1*x2 + 8.D0/3.D0*x1*x2**3 + 
     &    22*x1**2*x2**(-3) - 11*x1**2*x2**(-2) + 10.D0/3.D0*x1**2*
     &    x2**(-1) - 7.D0/3.D0*x1**2 - 4.D0/3.D0*x1**2*x2**2 )
      e0 = e0 + PLI1(1)*d0x2*rtree1 * ( 5.D0/6.D0 - 4.D0/3.D0*x1**(-1)
     &     - 1.D0/6.D0*x1 + 4.D0/3.D0*x1**2 )
      e0 = e0 + PLI1(2)*opx1**(-1)*opx2**(-1)*rtree1 * (  - 2.D0/3.D0 )
      e0 = e0 + PLI1(2)*opx1**(-1)*rtree1 * (  - 1.D0/6.D0 + 4.D0/3.D0*
     &    x2**(-1) + 25.D0/6.D0*x2 - 2*x2**2 )
      e0 = e0 + PLI1(2)*opx2**(-1)*rtree1 * (  - 1.D0/6.D0 + 4.D0/3.D0*
     &    x1**(-1) + 25.D0/6.D0*x1 - 2*x1**2 )
      e0 = e0 + PLI1(2)*rtree1 * (  - 23.D0/3.D0 - 22*x1**(-3)*x2 + 22*
     &    x1**(-3)*x2**2 - 3*x1**(-2) + 14*x1**(-2)*x2 - 11*x1**(-2)*
     &    x2**2 - 7*x1**(-1)*x2**(-1) + 4*x1**(-1) - 3*x1**(-1)*x2 + 10.
     &    D0/3.D0*x1**(-1)*x2**2 - 3*x2**(-2) + 4*x2**(-1) + 5.D0/3.D0*
     &    x1px2**(-2) - 4.D0/3.D0*x2*x1px2**(-3) - 10.D0/3.D0*x2*
     &    x1px2**(-1) + 5*x2 + 4.D0/3.D0*x2**2*x1px2**(-4) - 2.D0/3.D0*
     &    x2**2*x1px2**(-2) - 14.D0/3.D0*x2**2 + 8*x2**3*x1px2**(-3) + 
     &    2.D0/3.D0*x2**3*x1px2**(-1) - 4*x2**4*x1px2**(-4) + 29.D0/3.D0
     &    *x2**4*x1px2**(-2) - 20.D0/3.D0*x2**4 - 12*x2**5*x1px2**(-3)
     &     + 40.D0/3.D0*x2**5*x1px2**(-1) + 4*x2**6*x1px2**(-4) - 32.D0/
     &    3.D0*x2**6*x1px2**(-2) + 16.D0/3.D0*x2**7*x1px2**(-3) - 4.D0/
     &    3.D0*x2**8*x1px2**(-4) - 22*x1*x2**(-3) + 14*x1*x2**(-2) - 3*
     &    x1*x2**(-1) + 5*x1 - 11.D0/3.D0*x1*x2 + 8.D0/3.D0*x1*x2**3 + 
     &    22*x1**2*x2**(-3) - 11*x1**2*x2**(-2) + 10.D0/3.D0*x1**2*
     &    x2**(-1) - 7.D0/3.D0*x1**2 - 4.D0/3.D0*x1**2*x2**2 )
      e0 = e0 + PLI1(2)*d0x1*rtree1 * ( 5.D0/6.D0 - 4.D0/3.D0*x2**(-1)
     &     - 1.D0/6.D0*x2 + 4.D0/3.D0*x2**2 )
      e0 = e0 + GIIdiff(31)*opx1**(-1)*x1mx2**(-1)*rtree1 * (  - 2.D0/3.
     &    D0 )
      e0 = e0 + GIIdiff(31)*omx1**(-1)*x1mx2**(-1)*rtree1 * ( 2.D0/3.D0
     &     )
      e0 = e0 + GIIdiff(31)*x1mx2**(-1)*rtree1 * (  - 4.D0/3.D0*x1 - 4.D
     &    0/3.D0*x1**3 )
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      endif
      Ah2g2H2U = Ah2g2H2U - bino(iix,partons,-e0)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      rtree1=0d0
      rloop1=0d0
      rloop2=0d0
      end do
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      return
      end
