************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function Btth2g1H3XT(ix,x1,x2,i1,i3,i4,i2,i5,i6,i7,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(7)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello Btth2g1H3XT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i1,i3,i4,i2,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21hGGFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0H3(i1,i3,i4,i2,i5,i6,i7)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i3,i2/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 4
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+1d0)*FullqqA30II(i1,i3,i2,7)*Bh1g1H3(j1,j3,j2,j4,j5,j6,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i3,i2/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 5
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+1d0)*FullqqAh31II(i1,i3,i2,7,muR2_scl(i))*B1g0H3(j1,j3,j2,j4,j5,j6)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 4
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+1d0)*FullqqA30II(i1,i4,i2,7)*Bh1g1H3(j1,j3,j2,j4,j5,j6,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 5
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+1d0)*FullqqAh31II(i1,i4,i2,7,muR2_scl(i))*B1g0H3(j1,j3,j2,j4,j5,j6)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i3,i2/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21hGGFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i3,i2,7)*B1g0H3(j1,j3,j2,j4,j5,j6)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21hGGFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i4,i2,7)*B1g0H3(j1,j3,j2,j4,j5,j6)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      Btth2g1H3XT = - sum(wt)  ! minus in bino(-...)


      return


      end function Btth2g1H3XT
