************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function ggBt1g1H3T(ix,x1,x2,i1,i2,i3,i4,i5,i6,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(4)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello ggBt1g1H3T"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i2,i3,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQgtoqIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B1g0H3(i1,i2,i3,i4,i5,i6)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i2,i1,i3,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQgtoqFI(ix,x1,x2,i3,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B1g0H3(i2,i1,i3,i4,i5,i6)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgG30II(i2,i1,i3,6)*A2g0H3(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqFI(ix,x1,x2,i3,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgqG30II(i1,i2,i3,6)*A2g0H3(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      ggBt1g1H3T = - sum(wt)  ! minus in bino(-...)


      return


      end function ggBt1g1H3T
