      double precision function C0g0WFH(i1,i3,i2,i4,i5,i6)
         use C0gVBF_mod
         implicit none
         integer i1,i3,i2,i4,i5,i6

         C0g0WFH = C0g0VBF(i1,i3,i2,i4,i5,i6,1)

         return
      end function


      double precision function C0g0ZFH(i1,i3,i2,i4,i5,i6)
         use C0gVBF_mod             
         implicit none
         integer i1,i3,i2,i4,i5,i6

         C0g0ZFH = C0g0VBF(i1,i3,i2,i4,i5,i6,0)

         return
      end function

      !>
      !> Symmetrised version of C0g0VFH over i2-i3
      !> only to be called by subtraction terms
      !>
      double precision function sC0g0WFH(i1, i3,i2, i4,i5,i6)
         implicit none
         double precision C0g0WFH
         integer i1,i3,i2,i4,i5,i6

         sC0g0WFH = (C0g0WFH(i1, i3,i2, i4,i5,i6)
     .            +  C0g0WFH(i1, i2,i3, i4,i5,i6))/2d0

      return
      end function 

      double precision function sC0g0ZFH(i1, i3,i2, i4,i5,i6)
         implicit none
         double precision C0g0ZFH
         integer i1,i3,i2,i4,i5,i6

         sC0g0ZFH = (C0g0ZFH(i1, i3,i2, i4,i5,i6)
     .            +  C0g0ZFH(i1, i2,i3, i4,i5,i6))/2d0

      return
      end function 
