      function C0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,iboson)
      use C0gVBF_mod
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole
      integer npars, nspec, n
      common /npars/npars,nspec,n

      s14   = kin(nspec+4)%s(i1,i4)
      s23   = kin(nspec+4)%s(i2,i3)
      tree1 = C0g0VBF(i1,i3,i2,i4,i5,i6,iboson)
      dls14 = dlog(renscale2/abs(s14))
      dls23 = dlog(renscale2/abs(s23))

      select case(ipole)
      case(-4)
      C0g2VBF =  + tree1 * ( 2 )
      case(-3)
      C0g2VBF =  + tree1 * ( 35.D0/4.D0 )
      case(-2)
      C0g2VBF =  + tree1 * ( 385.D0/18.D0 - 1.D0/4.D0*pi**2 )
      case(-1)
      C0g2VBF =  + tree1 * ( 22189.D0/432.D0 - 35.D0/6.D0*zeta3 - 29.D0/
     &    24.D0*pi**2 )
      case default
      C0g2VBF =  + tree1 * (  - 19451.D0/2592.D0 - 22.D0/3.D0*dls23 -
     &    22.D0/3.D0*dls14 + 389.D0/36.D0*zeta3 - 5.D0/18.D0*pi**2 + 49.
     &    D0/720.D0*pi**4 )
      endselect

      return
      end

      function Ch0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,iboson)
      use C0gVBF_mod
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole
      integer npars, nspec, n
      common /npars/npars,nspec,n

      s14   = kin(nspec+4)%s(i1,i4)
      s23   = kin(nspec+4)%s(i2,i3)
      tree1 = C0g0VBF(i1,i3,i2,i4,i5,i6,iboson)
      dls14 = dlog(renscale2/abs(s14))
      dls23 = dlog(renscale2/abs(s23))

      select case(ipole)
      case(-4)
      Ch0g2VBF =  0
      case(-3)
      Ch0g2VBF =  + tree1 * (  - 1.D0/2.D0 )
      case(-2)
      Ch0g2VBF =  + tree1 * (  - 2.D0/9.D0 )
      case(-1)
      Ch0g2VBF =  + tree1 * ( 65.D0/108.D0 + 1.D0/12.D0*pi**2 )
      case default
      Ch0g2VBF =  + tree1 * ( 4085.D0/648.D0 + 4.D0/3.D0*dls23 + 4.D0/3.
     &    D0*dls14 - 1.D0/18.D0*zeta3 + 7.D0/36.D0*pi**2 )
      endselect

      return
      end

      function Ct0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,iboson)
      use C0gVBF_mod
      use KinData_mod
      use Constants_mod
      implicit double precision (a-h,o-z)
      common /order2l/ipole
      integer npars, nspec, n
      common /npars/npars,nspec,n

      s14   = kin(nspec+4)%s(i1,i4)
      s23   = kin(nspec+4)%s(i2,i3)
      tree1 = C0g0VBF(i1,i3,i2,i4,i5,i6,iboson)
      dls14 = dlog(renscale2/abs(s14))
      dls23 = dlog(renscale2/abs(s23))

      select case(ipole)
      case(-4)
      Ct0g2VBF =  + tree1 * ( 2 )
      case(-3)
      Ct0g2VBF =  + tree1 * ( 6 )
      case(-2)
      Ct0g2VBF =  + tree1 * ( 41.D0/2.D0 - 1.D0/3.D0*pi**2 )
      case(-1)
      Ct0g2VBF =  + tree1 * ( 893.D0/16.D0 - 37.D0/3.D0*zeta3 - 3.D0/4.D
     &    0*pi**2 )
      case default
      Ct0g2VBF =  + tree1 * ( 1023.D0/32.D0 - 15.D0/2.D0*zeta3 + 29.D0/
     &    24.D0*pi**2 - 11.D0/180.D0*pi**4 )
      endselect

      return
      end

      double precision function C0g2ZFH(i1,i3,i2,i4,i5,i6,renscale2)
      implicit none
      double precision renscale2, C0g2VBF
      integer i1, i2, i3, i4, i5, i6
         C0g2ZFH = C0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,0)
      return
      end
      double precision function C0g2WFH(i1,i3,i2,i4,i5,i6,renscale2)
      implicit none
      double precision renscale2, C0g2VBF
      integer i1, i2, i3, i4, i5, i6
         C0g2WFH = C0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,1)
      return
      end
      double precision function Ch0g2ZFH(i1,i3,i2,i4,i5,i6,renscale2)
      implicit none
      double precision renscale2, Ch0g2VBF
      integer i1, i2, i3, i4, i5, i6
         Ch0g2ZFH = Ch0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,0)
      return
      end
      double precision function Ch0g2WFH(i1,i3,i2,i4,i5,i6,renscale2)
      implicit none
      double precision renscale2, Ch0g2VBF
      integer i1, i2, i3, i4, i5, i6
         Ch0g2WFH = Ch0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,1)
      return
      end
      double precision function Ct0g2ZFH(i1,i3,i2,i4,i5,i6,renscale2)
      implicit none
      double precision renscale2, Ct0g2VBF
      integer i1, i2, i3, i4, i5, i6
         Ct0g2ZFH = Ct0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,0)
      return
      end
      double precision function Ct0g2WFH(i1,i3,i2,i4,i5,i6,renscale2)
      implicit none
      double precision renscale2, Ct0g2VBF
      integer i1, i2, i3, i4, i5, i6
         Ct0g2WFH = Ct0g2VBF(i1,i3,i2,i4,i5,i6,renscale2,1)
      return
      end
