      double precision function D0g0WZFH(i1,i3,i2,i4,i5,i6)
         !> Interference term between Z and W fusion (t/u and s/t)
         use C0gVBF_mod
         implicit none
         integer, intent(in) :: i1, i3, i2, i4, i5, i6
         integer :: ip1, ip2
         common /idparton/ip1,ip2
!$omp threadprivate(/idparton/)
         if (( ( (i1*i4) > 2 ).and.( (i2*i3) > 2 ) ) 
     .     .and.( ip1 /= -ip2 ))then
            D0g0WZFH = D0g0VBF(i1,i3,i2,i4,i5,i6,2)
         else
            D0g0WZFH = 0d0
         endif
         return
      end function

      double precision function D0g0ZFH(i1,i3,i2,i4,i5,i6)
         !> Interference between different channels (t/u and s/t)
         use C0gVBF_mod
         implicit none
         integer, intent(in) :: i1, i3, i2, i4, i5, i6
         if ( ( (i1*i4) > 2 ).and.( (i2*i3) > 2 ) ) then
            !> Workaround for the extra factor of two of makeproc
            D0g0ZFH = 2d0*D0g0VBF(i1,i3,i2,i4,i5,i6,0)
         else
            D0g0ZFH = 0d0 !D0g0VBF(i1,i3,i2,i4,i5,i6,0)
         endif
         return
      end function
