************************************************************************
*XC link inclusive VFH production ME with 4 decay particles
************************************************************************
****************All tree amplitudes*************************************
************************************************************************
      function C0g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C0g0ZFH4=C0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function C0g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C0g0WFH4=C0g0WFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function sC0g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC0g0WFH4=sC0g0WFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function sC0g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC0g0ZFH4=sC0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      D0g0ZFH4=D0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0WZFH4(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      D0g0WZFH4=D0g0WZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function C1g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C1g0ZFH4=C1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C1g0WFH4=C1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end


************************************************************************
      function D1g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      D1g0ZFH4=D1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function D1g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      D1g0WFH4=D1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0ZFH4s1(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C1g0ZFH4s1=C1g0ZFHs1(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0WFH4s1(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C1g0WFH4s1=C1g0WFHs1(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC1g0WFH4=sC1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0WFH4s0(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC1g0WFH4s0=sC1g0WFHs0(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC1g0ZFH4=sC1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0ZFH4s0(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC1g0ZFH4s0=sC1g0ZFHs0(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C2g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C2g0WFH4=C2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function C2g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C2g0ZFH4=C2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sC2g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC2g0ZFH4=sC2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sC2g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC2g0WFH4=sC2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sCt2g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sCt2g0ZFH4=sCt2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sCt2g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sCt2g0WFH4=sCt2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function Ct2g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ct2g0WFH4=Ct2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function Ct2g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ct2g0ZFH4=Ct2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function E0g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      E0g0ZFH4=E0g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function E0g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      E0g0WFH4=E0g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function F0g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      F0g0ZFH4=F0g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function F0g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=10

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      F0g0WFH4=F0g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
*      function D2g0ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
*      use Process_mod, only : name_proc
*      use KinData_mod
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*
*      ipset=10
*
*      select case ( name_proc )
*      case('VFHTO2E2MU','VFHTO2E2MUJ')
*        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
*      case('VFHTO4E','VFHTO4EJ')
*        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
*      case('VFHTO2L2N','VFHTO2L2NJ')
*        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
*      case default
*         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
*         stop
*      end select
*
*      D2g0ZFH4=D2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME
*
*      return
*      end
*
*************************************************************************
*      function D2g0WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10)
*      use Process_mod, only : name_proc
*      use KinData_mod
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*
*      ipset=10
*
*      select case ( name_proc )
*      case('VFHTO2E2MU','VFHTO2E2MUJ')
*        decayME=HZZ2e2mu0(i7,i8,i9,i10,ipset)
*      case('VFHTO4E','VFHTO4EJ')
*        decayME=HZZ4e0(i7,i8,i9,i10,ipset)
*      case('VFHTO2L2N','VFHTO2L2NJ')
*        decayME=HWW2l2n0(i7,i8,i9,i10,ipset)
*      case default
*         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
*         stop
*      end select
*
*      D2g0WFH4=D2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME
*
*      return
*      end






************************************************************************
**********************All 1-loop ME*************************************
************************************************************************
      function C0g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C0g1ZFH4=C0g1ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C0g1WFH4=C0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function fC0g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      fC0g1ZFH4=fC0g1ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function fC0g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      fC0g1WFH4=fC0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC0g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC0g1ZFH4=sC0g1ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC0g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC0g1WFH4=sC0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC1g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC1g1ZFH4=sC1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sC1g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sC1g1WFH4=sC1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function C1g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C1g1ZFH4=C1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function C1g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C1g1WFH4=C1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCt1g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sCt1g1ZFH4=sCt1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCt1g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sCt1g1WFH4=sCt1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ct1g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ct1g1ZFH4=Ct1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ct1g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ct1g1WFH4=Ct1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCh1g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sCh1g1ZFH4=sCh1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCh1g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      sCh1g1WFH4=sCh1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ch1g1WFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ch1g1WFH4=Ch1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ch1g1ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,i9,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i6,i7,i8,i9,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i6,i7,i8,i9,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i6,i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ch1g1ZFH4=Ch1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
****************All 2-loop amplitudes***********************************
************************************************************************
      function C0g2ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C0g2ZFH4=C0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g2WFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      C0g2WFH4=C0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g2ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ct0g2ZFH4=Ct0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g2WFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ct0g2WFH4=Ct0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g2ZFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ch0g2ZFH4=Ch0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g2WFH4(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2E2MU','VFHTO2E2MUJ')
        decayME=HZZ2e2mu0(i5,i6,i7,i8,ipset)
      case('VFHTO4E','VFHTO4EJ')
        decayME=HZZ4e0(i5,i6,i7,i8,ipset)
      case('VFHTO2L2N','VFHTO2L2NJ')
        decayME=HWW2l2n0(i5,i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH4.f: ", name_proc
         stop
      end select

      Ch0g2WFH4=Ch0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

