************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qgBh1g1WT(ix,x1,x2,i1,i2,i3,i4,i5,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(2)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgBh1g1WT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i2,i3,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hQGII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21hGQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B1g0W(i1,i2,i3,i4,i5)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 6
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqgAh31II(i1,i2,i3,5,muR2_scl(i))*B0g0W(j1,j2,j3,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21hQGII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21hGQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i3,5)*B0g0W(j1,j2,j3,j4)*wtcalX30
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgBh1g1WT = - sum(wt)  ! minus in bino(-...)


      return


      end function qgBh1g1WT
