************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qbgC0g1ZT(ix,x1,x2,i3,i4,i2,i1,i5,i6,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(20)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qbgC0g1ZT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i3,i2,i1,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQqtogIF(ix,x1,x2,i4,i1,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + sf2B2g0Z(i3,i2,i1,i4,i5,i6)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i3,i1,i2,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQqtogIF(ix,x1,x2,i4,i1,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + sf2B2g0Z(i3,i1,i2,i4,i5,i6)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,i4,i1,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgA30IF(i4,i1,i3,6)*sf2B1g0Z(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j2,j1,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,i4,i1,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullggD30II(i4,i1,i2,6)*sf2B1g0Z(j2,j1,j3,j4,j5)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j2,j1,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GQqtogIF(ix,x1,x2,i4,i1,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=ggd30II(i4,i1,i2,6)*sf2B1g0Z(j2,j1,j3,j4,j5)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j2,j1,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,j3,j1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=ggd30II(i3,i2,i1,6)*sf2B1g0Z(j2,j1,j3,j4,j5)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i2,i3,i4,i1,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C0g0Z(i2,i3,i4,i1,i5,i6)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j2,j3,j1,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i2,i3,i4,6)*f1B1g0Z(j2,j3,j1,j4,j5)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i4,i3,i2,i1,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C0g0Z(i4,i3,i2,i1,i5,i6)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j2,j1,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqpE30II(i2,i1,i4,6)*f2B1g0Z(j2,j1,j3,j4,j5)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j2,j1,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i4,i3,i2,6)*f1B1g0Z(j3,j2,j1,j4,j5)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i3,i2,i4,i1,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C0g0Z(i3,i2,i4,i1,i5,i6)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j2,j1,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqpE30II(i1,i4,i2,6)*f1B1g0Z(j3,j2,j1,j4,j5)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j1,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqpE30II(i2,i3,i1,6)*f2B1g0Z(j3,j1,j2,j4,j5)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j2,j1,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i2,i3,i4,6)*f1B1g0Z(j3,j2,j1,j4,j5)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j1,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqFI(ix,x1,x2,i2,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i3,i4,i1,6)*sf2B1g0Z(j3,j1,j2,j4,j5)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j1,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,i3,i1,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GQqtogIF(ix,x1,x2,j3,j1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullggD30II(i3,i1,i2,6)*sf2B1g0Z(j3,j1,j2,j4,j5)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j2,j1,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GQqtogIF(ix,x1,x2,i3,i1,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,j3,j1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgA30IF(i4,i1,i3,6)*sf2B1g0Z(j2,j1,j3,j4,j5)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j2,j1,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,i3,i1,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GQqtogIF(ix,x1,x2,j3,j1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=ggd30II(i4,i1,i2,6)*sf2B1g0Z(j2,j1,j3,j4,j5)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j1,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GQqtogIF(ix,x1,x2,i3,i1,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,j3,j1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgA30IF(i3,i2,i4,6)*sf2B1g0Z(j3,j1,j2,j4,j5)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qbgC0g1ZT = - sum(wt)  ! minus in bino(-...)


      return


      end function qbgC0g1ZT
