************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function ggBh3g1XT2(ix,x1,x2,i3,i1,i2,i4,i5,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(24)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello ggBh3g1XT2"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i2,i3,i5,i4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C1g01(i1,i2,i3,i5,i4)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgG30IF(i2,i3,i5,5)*B2g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i5] = j4, [i4, i5] = j3, [i5, i3] = j4, [i5, i4] = j3}
      call set_map(5,4, (/i4,i5,i3/), (/i1,i2,i4,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullE30FF(i4,i5,i3,5)*B2g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i3,5)*C0g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i5,i4,i1,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i2,i5,i4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C1g01(i3,i1,i2,i5,i4)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgG30IF(i1,i3,i4,5)*B2g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i4] = j4, [i4, i3] = j4, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i5,i4,i3/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullE30FF(i5,i4,i3,5)*B2g0(j3,j4,j1,j2)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgqA30II(i3,i1,i2,5)*C0g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i4,i5,i2,5)*B2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGgtoqII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i1,i3,i5,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GQgtoqII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i2,i5,i4,5)*B2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i2,i1,i3,i5,i4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C1g01(i2,i1,i3,i5,i4)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgG30IF(i1,i3,i5,5)*B2g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i5] = j4, [i4, i5] = j3, [i5, i3] = j4, [i5, i4] = j3}
      call set_map(5,4, (/i4,i5,i3/), (/i1,i2,i4,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullE30FF(i4,i5,i3,5)*B2g0(j2,j1,j4,j3)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgqA30II(i2,i1,i3,5)*C0g0(j2,j1,j4,j3)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i5,i4,i2,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i2,i1,i5,i4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C1g01(i3,i2,i1,i5,i4)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgG30IF(i2,i3,i4,5)*B2g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i4] = j4, [i4, i3] = j4, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i5,i4,i3/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullE30FF(i5,i4,i3,5)*B2g0(j3,j4,j2,j1)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i3,i2,i1,5)*C0g0(j2,j1,j4,j3)*(wtcalX30)
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i4,i5,i1,5)*B2g0(j4,j2,j1,j3)*(wtcalX30)
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GQgtoqII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i2,i3,i5,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGgtoqII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGgtoqII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i1,i5,i4,5)*B2g0(j4,j2,j1,j3)*(wtcalX30)
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      ggBh3g1XT2 = - sum(wt)  ! minus in bino(-...)


      return


      end function ggBh3g1XT2
