************************************************************************
*  generated using makeformVV on 2025-02-16
*
      function ggCt0g2XU(iix,xx1,xx2,i1,i2,i3,i4,
     .rscale2,fscale2)
      use Constants_mod
      use KinData_mod
      use Scales_mod
      use Flavour_mod, only: isActive_flav,set_flav_perm,unset_flav_perm
      implicit double precision (a-h,o-z)
      integer :: nBlocks, block
      double precision rtree1(nMax_scl)
      double precision rtree2(nMax_scl)
      double precision dlmuF(nMax_scl)
      double precision dls12(nMax_scl)
      double precision dls13(nMax_scl)
      double precision dls14(nMax_scl)
      double precision dls23(nMax_scl)
      double precision dls24(nMax_scl)
      double precision dls34(nMax_scl)
      double precision e0(nMax_scl)
      double precision partons(nMax_scl)
      double precision factor(nMax_scl)
      logical jflag
      common /order2l/ipole
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      common /distomx/ dd0x1,dd1x1,dd2x1,dd3x1,dd0x2,dd1x2,dd2x2,dd3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ zz1,zz2
!$omp threadprivate(/parfrac/)
      dimension GII(32,2),GIIdiff(32),PLI1(5)
      parameter(dli2one=1.6449340668482264365d0)
      parameter(dli2mone=-.82246703342411321826d0)
      parameter(dli2half=0.58224052646501250592d0)
      parameter(dli3one=1.2020569031595942854d0)
      parameter(dli3mone=-.90154267736969571405d0)
      parameter(dli3half=0.53721319360804020089d0)
      dimension ixSwap(4)
      data      ixSwap /1,3,2,4/
      ggCt0g2XU = 0d0
      ipass=1
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.0)return
      ipass=0
      jflag = .false.
      if ( i1.eq.1 .and. i2.eq.2 ) then
        ix=iix
        x1=xx1
        x2=xx2
        z1=zz1
        z2=zz2
        d0x1=dd0x1
        d1x1=dd1x1
        d2x1=dd2x1
        d3x1=dd3x1
        d0x2=dd0x2
        d1x2=dd1x2
        d2x2=dd2x2
        d3x2=dd3x2
      elseif ( i1.eq.2 .and. i2.eq.1 ) then
        ix=ixSwap(iix)
        x1=xx2
        x2=xx1
        z1=zz2
        z2=zz1
        d0x1=dd0x2
        d1x1=dd1x2
        d2x1=dd2x2
        d3x1=dd3x2
        d0x2=dd0x1
        d1x2=dd1x1
        d2x2=dd2x1
        d3x2=dd3x1
      else
        write(*,*) "ggCt0g2XU: bad input ",i1,i2,i3,i4 
        stop
      endif
      s12=s4(i1,i2)
      s13=s4(i1,i3)
      s14=s4(i1,i4)
      s23=s4(i2,i3)
      s24=s4(i2,i4)
      s34=s4(i3,i4)
      nBlocks=2
      e0=0d0
      GII=0d0
      GIIdiff=0d0
      if(ix.eq.4)then
          small=1d-12
          dsmall = dmin1(abs(1d0-x1),abs(1d0-x2),
     .                   abs(1d0-x1*x2),abs(x1-x2))
          if(dsmall.lt.small)call VVdebug(x1,x2)
      endif
      omz1 = 1d0-z1
      omz2 = 1d0-z2
      opx1 = 1d0+x1
      omx1 = 1d0-x1
      opx2 = 1d0+x2
      omx2 = 1d0-x2
      x1px2 = x1+x2
      x1mx2 = x1-x2
      omx1x2 = 1d0-x1*x2
      opx1x2 = 1d0+x1*x2
      GII(1,1)=g13(x1,x2)-g13(1d0,x2)-g13(x1,1d0)+g13(1d0,1d0)
      GII(2,1)=g14(x1,x2)-g14(1d0,x2)-g14(x1,1d0)+g14(1d0,1d0)
      GII(3,1)=g22(x1,x2)-g22(1d0,x2)-g22(x1,1d0)+g22(1d0,1d0)
      GII(4,1)=g23(x1,x2)-g23(1d0,x2)-g23(x1,1d0)+g23(1d0,1d0)
      GII(5,1)=g24(x1,x2)-g24(1d0,x2)-g24(x1,1d0)+g24(1d0,1d0)
      GII(6,1)=g25(x1,x2)-g25(1d0,x2)-g25(x1,1d0)+g25(1d0,1d0)
      GII(7,1)=dli2(x1mx2/opx1)-dli2(omx2/2d0)-dli2(-omx1/opx1)
      GII(8,1)=dli2(x1mx2/x1px2)-dli2(omx2/opx2)-dli2(-omx1/opx1)
      GII(9,1)=dli2(x1*opx2/opx1)-dli2(opx2/2d0)-dli2(2d0*x1/opx1)
     .+dli2one
      GII(10,1)=dli2(opx1*omx1/opx1x2)-dli2(omx1)
      GII(11,1)=dli2(-x1/x2)-dli2(-1d0/x2)-dli2(-x1)+dli2mone
      GII(12,1)=dli2(-omx1/x1px2)-dli2(-omx1/opx1)
      GII(13,1)=dli2(omx1x2)-dli2(omx2)-dli2(omx1)
      GII(14,1)=log(opx1x2)-log(opx2)-log(opx1)+rln2
      GII(15,1)=log(x1px2)-log(opx2)-log(opx1)+rln2
      GII(1,2)=g13(x2,x1)-g13(1d0,x1)-g13(x2,1d0)+g13(1d0,1d0)
      GII(2,2)=g14(x2,x1)-g14(1d0,x1)-g14(x2,1d0)+g14(1d0,1d0)
      GII(3,2)=g22(x2,x1)-g22(1d0,x1)-g22(x2,1d0)+g22(1d0,1d0)
      GII(4,2)=g23(x2,x1)-g23(1d0,x1)-g23(x2,1d0)+g23(1d0,1d0)
      GII(5,2)=g24(x2,x1)-g24(1d0,x1)-g24(x2,1d0)+g24(1d0,1d0)
      GII(6,2)=g25(x2,x1)-g25(1d0,x1)-g25(x2,1d0)+g25(1d0,1d0)
      GII(7,2)=dli2(-x1mx2/opx2)-dli2(omx1/2d0)-dli2(-omx2/opx2)
      GII(8,2)=dli2(-x1mx2/x1px2)-dli2(omx1/opx1)-dli2(-omx2/opx2)
      GII(9,2)=dli2(x2*opx1/opx2)-dli2(opx1/2d0)-dli2(2d0*x2/opx2)
     .+dli2one
      GII(10,2)=dli2(opx2*omx2/opx1x2)-dli2(omx2)
      GII(11,2)=dli2(-x2/x1)-dli2(-1d0/x1)-dli2(-x2)+dli2mone
      GII(12,2)=dli2(-omx2/x1px2)-dli2(-omx2/opx2)
      GII(13,2)=dli2(omx1x2)-dli2(omx1)-dli2(omx2)
      GII(14,2)=GII(14,1)
      GII(15,2)=GII(15,1)
      GII(16,1)=g23b(x1)
      GII(17,1)=g23c(x1)
      GII(18,1)=dli2(x1)-dli2one
      GII(19,1)=dli2(x1/opx1)-dli2half
      GII(20,1)=dli2(-x1)-dli2mone
      GII(21,1)=dli2(1d0/2d0*omx1)
      GII(22,1)=dli3(x1)-dli3one
      GII(23,1)=dli3(1d0/opx1)-dli3half
      GII(24,1)=dli3(omx1/opx1)
      GII(25,1)=dli3(-x1)-dli3mone
      GII(26,1)=dli3(2d0*x1/opx1)-dli3one
      GII(27,1)=dli3(omx1)
      GII(28,1)=dli3(1d0/2d0*omx1)
      GII(29,1)=dli3(1d0/2d0*opx1)-dli3one
      GII(30,1)=log(x1)
      GII(31,1)=log(opx1)-rln2
      GII(16,2)=g23b(x2)
      GII(17,2)=g23c(x2)
      GII(18,2)=dli2(x2)-dli2one
      GII(19,2)=dli2(x2/opx2)-dli2half
      GII(20,2)=dli2(-x2)-dli2mone
      GII(21,2)=dli2(1d0/2d0*omx2)
      GII(22,2)=dli3(x2)-dli3one
      GII(23,2)=dli3(1d0/opx2)-dli3half
      GII(24,2)=dli3(omx2/opx2)
      GII(25,2)=dli3(-x2)-dli3mone
      GII(26,2)=dli3(2d0*x2/opx2)-dli3one
      GII(27,2)=dli3(omx2)
      GII(28,2)=dli3(1d0/2d0*omx2)
      GII(29,2)=dli3(1d0/2d0*opx2)-dli3one
      GII(30,2)=log(x2)
      GII(31,2)=log(opx2)-rln2
      do i=1,32
        GIIdiff(i)=GII(i,1)-GII(i,2)
      enddo
      PLI1(1)=log(omx1)
      PLI1(2)=log(omx2)
      PLI1(3)=log(omx1x2)
      PLI1(4)=log(omz1)
      PLI1(5)=log(omz2)
      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      rtree1=0d0
      rtree2=0d0
      do block = 1, nBlocks
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      
      select case (block)
      
      case (1)
        ipass_block=1
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(iix, partons, factor, 4, ipass_block, 1)
        call unset_flav_perm()
        if ( ipass_block == 0 ) cycle
        ipass=1
        rtree1=factor(:)*C0g0(i1,i2,i3,i4)
C       skip all but last to accumulate rtree
        if ( .not.isActive_flav() ) cycle
      
      case (2)
        ipass_block=1
        call set_flav_perm(4, (/ i1,i3,i4,i2 /))
        call getqcdnorm(iix, partons, factor, 4, ipass_block, 1)
        call unset_flav_perm()
        if ( ipass_block == 0 ) cycle
        ipass=1
        rtree2=factor(:)*C0g0(i1,i3,i4,i2)
      
      end select
      
      dls12(:)  = 0d0
      dls13(:)  = 0d0
      dls14(:)  = 0d0
      dls23(:)  = 0d0
      dls24(:)  = 0d0
      dls34(:)  = 0d0
      do i=1,nAct_scl
        idmap = idmap_scl(i, withR=.true.)
        if (idmap == i) then
          dls12(i)  = log(muR2_scl(i)/abs(s12))
          dls13(i)  = log(muR2_scl(i)/abs(s13))
          dls14(i)  = log(muR2_scl(i)/abs(s14))
          dls23(i)  = log(muR2_scl(i)/abs(s23))
          dls24(i)  = log(muR2_scl(i)/abs(s24))
          dls34(i)  = log(muR2_scl(i)/abs(s34))
        else
          dls12(i)  = dls12(idmap)
          dls13(i)  = dls13(idmap)
          dls14(i)  = dls14(idmap)
          dls23(i)  = dls23(idmap)
          dls24(i)  = dls24(idmap)
          dls34(i)  = dls34(idmap)
        end if
      enddo
      dlmuF(:) = 0d0
      do i=1,nAct_scl
        idmap = idmap_scl(i, withR=.true., withF=.true.)
        if (idmap == i) then
          dlmuF(i) = log(muR2_scl(i)/muF2_scl(i))
        else
          dlmuF(i) = dlmuF(idmap)
        end if
      enddo
      if(ipass.eq.0)return
      if(ix.eq.1.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.1.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.2.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.2.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.3.and.imethod.eq.1)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.3.and.imethod.eq.2)then
        if(ipole.eq.0)then
          e0 =  0
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      elseif(ix.eq.4)then
        if(ipole.eq.0)then
          e0 =  + rtree2 * ( 39.D0/2.D0 - 60*x1**(-1)*x2 + 60*x1**(-1)*
     &    x2**2 - 1.D0/3.D0*pi**2 - 22*x2*x1px2**(-1) + 47*x2 + 2.D0/3.D
     &    0*x2*pi**2 + 106*x2**2*x1px2**(-2) - 136*x2**2*x1px2**(-1) - 
     &    165.D0/2.D0*x2**2 - 2.D0/3.D0*x2**2*pi**2 - 168*x2**3*
     &    x1px2**(-3) + 192*x2**3*x1px2**(-2) + 268*x2**3*x1px2**(-1)
     &     - 148*x2**3 + 84*x2**4*x1px2**(-4) - 96*x2**4*x1px2**(-3) - 
     &    554*x2**4*x1px2**(-2) + 346*x2**4*x1px2**(-1) + 164*x2**4 + 
     &    504*x2**5*x1px2**(-3) - 288*x2**5*x1px2**(-2) - 456*x2**5*
     &    x1px2**(-1) - 168*x2**6*x1px2**(-4) + 96*x2**6*x1px2**(-3) + 
     &    544*x2**6*x1px2**(-2) - 336*x2**7*x1px2**(-3) + 84*x2**8*
     &    x1px2**(-4) - 60*x1*x2**(-1) + 7*x1 + 2.D0/3.D0*x1*pi**2 + 48
     &    *x1*x2 - 4.D0/3.D0*x1*x2*pi**2 + 27*x1*x2**2 + 4.D0/3.D0*x1*
     &    x2**2*pi**2 - 46*x1*x2**3 + 60*x1**2*x2**(-1) - 65.D0/2.D0*
     &    x1**2 - 2.D0/3.D0*x1**2*pi**2 - 31*x1**2*x2 + 4.D0/3.D0*x1**2
     &    *x2*pi**2 + 55.D0/2.D0*x1**2*x2**2 - 4.D0/3.D0*x1**2*x2**2*
     &    pi**2 )
      e0 = e0 + rtree2 * ( 6*x1**3 - 6*x1**3*x2 )
      e0 = e0 + rtree1 * ( 39 - 120*x1**(-1)*x2 + 120*x1**(-1)*x2**2 - 
     &    2.D0/3.D0*pi**2 - 44*x2*x1px2**(-1) + 94*x2 + 4.D0/3.D0*x2*
     &    pi**2 + 212*x2**2*x1px2**(-2) - 272*x2**2*x1px2**(-1) - 165*
     &    x2**2 - 4.D0/3.D0*x2**2*pi**2 - 336*x2**3*x1px2**(-3) + 384*
     &    x2**3*x1px2**(-2) + 536*x2**3*x1px2**(-1) - 296*x2**3 + 168*
     &    x2**4*x1px2**(-4) - 192*x2**4*x1px2**(-3) - 1108*x2**4*
     &    x1px2**(-2) + 692*x2**4*x1px2**(-1) + 328*x2**4 + 1008*x2**5*
     &    x1px2**(-3) - 576*x2**5*x1px2**(-2) - 912*x2**5*x1px2**(-1)
     &     - 336*x2**6*x1px2**(-4) + 192*x2**6*x1px2**(-3) + 1088*x2**6
     &    *x1px2**(-2) - 672*x2**7*x1px2**(-3) + 168*x2**8*x1px2**(-4)
     &     - 120*x1*x2**(-1) + 14*x1 + 4.D0/3.D0*x1*pi**2 + 96*x1*x2 - 
     &    8.D0/3.D0*x1*x2*pi**2 + 54*x1*x2**2 + 8.D0/3.D0*x1*x2**2*
     &    pi**2 - 92*x1*x2**3 + 120*x1**2*x2**(-1) - 65*x1**2 - 4.D0/3.D
     &    0*x1**2*pi**2 - 62*x1**2*x2 + 8.D0/3.D0*x1**2*x2*pi**2 + 55*
     &    x1**2*x2**2 - 8.D0/3.D0*x1**2*x2**2*pi**2 + 12*x1**3 - 12*
     &    x1**3*x2 )
      e0 = e0 + dls12*rtree2 * ( 1 - 16*x1**(-1)*x2 + 16*x1**(-1)*x2**2
     &     + 2*x2*x1px2**(-1) + 2*x2 - 2*x2**2*x1px2**(-2) + x2**2 - 8*
     &    x2**3*x1px2**(-1) + 2*x2**3 + 4*x2**4*x1px2**(-2) - 4*x2**4
     &     + 6*x2**5*x1px2**(-1) - 2*x2**6*x1px2**(-2) - 16*x1*x2**(-1)
     &     + 2*x1 + 22*x1*x2 - 20*x1*x2**2 + 16*x1**2*x2**(-1) - 3*
     &    x1**2 - 20*x1**2*x2 + 17*x1**2*x2**2 + 2*x1**3 - 2*x1**3*x2 )
      e0 = e0 + dls12*rtree1 * ( 2 - 32*x1**(-1)*x2 + 32*x1**(-1)*x2**2
     &     + 4*x2*x1px2**(-1) + 4*x2 - 4*x2**2*x1px2**(-2) + 2*x2**2 - 
     &    16*x2**3*x1px2**(-1) + 4*x2**3 + 8*x2**4*x1px2**(-2) - 8*
     &    x2**4 + 12*x2**5*x1px2**(-1) - 4*x2**6*x1px2**(-2) - 32*x1*
     &    x2**(-1) + 4*x1 + 44*x1*x2 - 40*x1*x2**2 + 32*x1**2*x2**(-1)
     &     - 6*x1**2 - 40*x1**2*x2 + 34*x1**2*x2**2 + 4*x1**3 - 4*x1**3
     &    *x2 )
      e0 = e0 + dls12**2*rtree2 * ( 1 - 2*x2 + 2*x2**2 - 2*x1 + 4*x1*x2
     &     - 4*x1*x2**2 + 2*x1**2 - 4*x1**2*x2 + 4*x1**2*x2**2 )
      e0 = e0 + dls12**2*rtree1 * ( 2 - 4*x2 + 4*x2**2 - 4*x1 + 8*x1*x2
     &     - 8*x1*x2**2 + 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
      e0 = e0 + dlmuF*rtree2 * (  - 1 + 16*x1**(-1)*x2 - 16*x1**(-1)*
     &    x2**2 - 2*x2*x1px2**(-1) - 2*x2 + 2*x2**2*x1px2**(-2) - x2**2
     &     + 8*x2**3*x1px2**(-1) - 2*x2**3 - 4*x2**4*x1px2**(-2) + 4*
     &    x2**4 - 6*x2**5*x1px2**(-1) + 2*x2**6*x1px2**(-2) + 16*x1*
     &    x2**(-1) - 2*x1 - 22*x1*x2 + 20*x1*x2**2 - 16*x1**2*x2**(-1)
     &     + 3*x1**2 + 20*x1**2*x2 - 17*x1**2*x2**2 - 2*x1**3 + 2*x1**3
     &    *x2 )
      e0 = e0 + dlmuF*rtree1 * (  - 2 + 32*x1**(-1)*x2 - 32*x1**(-1)*
     &    x2**2 - 4*x2*x1px2**(-1) - 4*x2 + 4*x2**2*x1px2**(-2) - 2*
     &    x2**2 + 16*x2**3*x1px2**(-1) - 4*x2**3 - 8*x2**4*x1px2**(-2)
     &     + 8*x2**4 - 12*x2**5*x1px2**(-1) + 4*x2**6*x1px2**(-2) + 32*
     &    x1*x2**(-1) - 4*x1 - 44*x1*x2 + 40*x1*x2**2 - 32*x1**2*
     &    x2**(-1) + 6*x1**2 + 40*x1**2*x2 - 34*x1**2*x2**2 - 4*x1**3
     &     + 4*x1**3*x2 )
      e0 = e0 + dlmuF*dls12*rtree2 * (  - 2 + 4*x2 - 4*x2**2 + 4*x1 - 8
     &    *x1*x2 + 8*x1*x2**2 - 4*x1**2 + 8*x1**2*x2 - 8*x1**2*x2**2 )
      e0 = e0 + dlmuF*dls12*rtree1 * (  - 4 + 8*x2 - 8*x2**2 + 8*x1 - 
     &    16*x1*x2 + 16*x1*x2**2 - 8*x1**2 + 16*x1**2*x2 - 16*x1**2*
     &    x2**2 )
      e0 = e0 + dlmuF**2*rtree2 * ( 1 - 2*x2 + 2*x2**2 - 2*x1 + 4*x1*x2
     &     - 4*x1*x2**2 + 2*x1**2 - 4*x1**2*x2 + 4*x1**2*x2**2 )
      e0 = e0 + dlmuF**2*rtree1 * ( 2 - 4*x2 + 4*x2**2 - 4*x1 + 8*x1*x2
     &     - 8*x1*x2**2 + 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
      e0 = e0 + GII(1,1)*rtree2 * (  - 2*x2*x1px2**(-1) - 2*x2**2*
     &    x1px2**(-2) - 8*x2**2 + x2**3*x1px2**(-3) - 12*x2**3*
     &    x1px2**(-1) + 8*x2**4*x1px2**(-2) - 16*x2**4 + 16*x2**5*
     &    x1px2**(-1) )
      e0 = e0 + GII(1,1)*rtree1 * (  - 4*x2*x1px2**(-1) - 4*x2**2*
     &    x1px2**(-2) - 16*x2**2 + 2*x2**3*x1px2**(-3) - 24*x2**3*
     &    x1px2**(-1) + 16*x2**4*x1px2**(-2) - 32*x2**4 + 32*x2**5*
     &    x1px2**(-1) )
      e0 = e0 + GII(1,2)*rtree2 * (  - 3 + 3*x2*x1px2**(-1) + x2**2*
     &    x1px2**(-2) + 12*x2**2 - x2**3*x1px2**(-3) - 20*x2**3*
     &    x1px2**(-1) + 8*x2**4*x1px2**(-2) + 16*x2**4 - 16*x2**5*
     &    x1px2**(-1) - 4*x1*x2 - 16*x1*x2**3 - 12*x1**2 + 16*x1**2*
     &    x2**2 - 16*x1**3*x2 )
      e0 = e0 + GII(1,2)*rtree1 * (  - 6 + 6*x2*x1px2**(-1) + 2*x2**2*
     &    x1px2**(-2) + 24*x2**2 - 2*x2**3*x1px2**(-3) - 40*x2**3*
     &    x1px2**(-1) + 16*x2**4*x1px2**(-2) + 32*x2**4 - 32*x2**5*
     &    x1px2**(-1) - 8*x1*x2 - 32*x1*x2**3 - 24*x1**2 + 32*x1**2*
     &    x2**2 - 32*x1**3*x2 )
      e0 = e0 + GII(3,1)*rtree2 * (  - 2*x2*x1px2**(-1) - 4*x2**2 + 4*
     &    x2**3*x1px2**(-1) + 4*x2**4 - 4*x2**5*x1px2**(-1) - 4*x1*
     &    x2**3 )
      e0 = e0 + GII(3,1)*rtree1 * (  - 4*x2*x1px2**(-1) - 8*x2**2 + 8*
     &    x2**3*x1px2**(-1) + 8*x2**4 - 8*x2**5*x1px2**(-1) - 8*x1*
     &    x2**3 )
      e0 = e0 + GII(3,2)*rtree2 * (  - 2 + 2*x2*x1px2**(-1) + 4*x2**2
     &     - 4*x2**3*x1px2**(-1) - 4*x2**4 + 4*x2**5*x1px2**(-1) - 4*x1
     &    *x2 + 4*x1*x2**3 - 4*x1**2*x2**2 )
      e0 = e0 + GII(3,2)*rtree1 * (  - 4 + 4*x2*x1px2**(-1) + 8*x2**2
     &     - 8*x2**3*x1px2**(-1) - 8*x2**4 + 8*x2**5*x1px2**(-1) - 8*x1
     &    *x2 + 8*x1*x2**3 - 8*x1**2*x2**2 )
      e0 = e0 + GII(11,1)*rtree2 * (  - 16*x1**(-2)*x2**2 - 8*x1**(-1)*
     &    x2 + 12*x2**2 + 4*x2**4 + 8*x1*x2**(-1) + 8*x1*x2**3 + 16*
     &    x1**2*x2**(-2) - 12*x1**2 - 8*x1**3*x2 - 4*x1**4 )
      e0 = e0 + GII(11,1)*rtree1 * (  - 32*x1**(-2)*x2**2 - 16*x1**(-1)
     &    *x2 + 24*x2**2 + 8*x2**4 + 16*x1*x2**(-1) + 16*x1*x2**3 + 32*
     &    x1**2*x2**(-2) - 24*x1**2 - 16*x1**3*x2 - 8*x1**4 )
      e0 = e0 + GII(12,1)*rtree2 * ( 4 - 2*x2*x1px2**(-1) + 4*x2 + 2*
     &    x2**2 + 4*x2**3*x1px2**(-1) + 6*x2**4 - 4*x2**5*x1px2**(-1)
     &     + 8*x1*x2**(-1) + 4*x1 + 12*x1*x2 + 8*x1*x2**2 + 16*x1**2*
     &    x2**(-2) - 4*x1**2 + 8*x1**2*x2 + 12*x1**2*x2**2 )
      e0 = e0 + GII(12,1)*rtree1 * ( 8 - 4*x2*x1px2**(-1) + 8*x2 + 4*
     &    x2**2 + 8*x2**3*x1px2**(-1) + 12*x2**4 - 8*x2**5*x1px2**(-1)
     &     + 16*x1*x2**(-1) + 8*x1 + 24*x1*x2 + 16*x1*x2**2 + 32*x1**2*
     &    x2**(-2) - 8*x1**2 + 16*x1**2*x2 + 24*x1**2*x2**2 )
      e0 = e0 + GII(12,2)*rtree2 * ( 2 + 16*x1**(-2)*x2**2 + 8*x1**(-1)
     &    *x2 + 2*x2*x1px2**(-1) + 4*x2 - 4*x2**3*x1px2**(-1) - 4*x2**4
     &     + 4*x2**5*x1px2**(-1) + 4*x1 + 8*x1*x2 + 8*x1*x2**2 + 4*x1*
     &    x2**3 + 6*x1**2 + 8*x1**2*x2 + 8*x1**2*x2**2 + 4*x1**3*x2 + 2
     &    *x1**4 )
      e0 = e0 + GII(12,2)*rtree1 * ( 4 + 32*x1**(-2)*x2**2 + 16*
     &    x1**(-1)*x2 + 4*x2*x1px2**(-1) + 8*x2 - 8*x2**3*x1px2**(-1)
     &     - 8*x2**4 + 8*x2**5*x1px2**(-1) + 8*x1 + 16*x1*x2 + 16*x1*
     &    x2**2 + 8*x1*x2**3 + 12*x1**2 + 16*x1**2*x2 + 16*x1**2*x2**2
     &     + 8*x1**3*x2 + 4*x1**4 )
      e0 = e0 + GII(15,1)*rtree2 * (  - 7 + 44*x1**(-2)*x2**2 + 12*
     &    x1**(-1)*x2 + x2*x1px2**(-1) - x2**2*x1px2**(-2) + 10*x2**2
     &     - 24*x2**3*x1px2**(-1) + 12*x2**4*x1px2**(-2) + 8*x2**4 + 12
     &    *x1*x2**(-1) + 28*x1*x2 + 4*x1*x2**3 + 44*x1**2*x2**(-2) - 2*
     &    x1**2 + 10*x1**2*x2**2 + 4*x1**3*x2 + 8*x1**4 )
      e0 = e0 + GII(15,1)*rtree1 * (  - 14 + 88*x1**(-2)*x2**2 + 24*
     &    x1**(-1)*x2 + 2*x2*x1px2**(-1) - 2*x2**2*x1px2**(-2) + 20*
     &    x2**2 - 48*x2**3*x1px2**(-1) + 24*x2**4*x1px2**(-2) + 16*
     &    x2**4 + 24*x1*x2**(-1) + 56*x1*x2 + 8*x1*x2**3 + 88*x1**2*
     &    x2**(-2) - 4*x1**2 + 20*x1**2*x2**2 + 8*x1**3*x2 + 16*x1**4 )
      e0 = e0 + GII(15,1)*dls12*rtree2 * ( 4 + 16*x1**(-2)*x2**2 + 8*
     &    x1**(-1)*x2 + 2*x2**2 + 2*x2**4 + 8*x1*x2**(-1) + 16*x1*x2 + 
     &    4*x1*x2**3 + 16*x1**2*x2**(-2) + 2*x1**2 + 16*x1**2*x2**2 + 4
     &    *x1**3*x2 + 2*x1**4 )
      e0 = e0 + GII(15,1)*dls12*rtree1 * ( 8 + 32*x1**(-2)*x2**2 + 16*
     &    x1**(-1)*x2 + 4*x2**2 + 4*x2**4 + 16*x1*x2**(-1) + 32*x1*x2
     &     + 8*x1*x2**3 + 32*x1**2*x2**(-2) + 4*x1**2 + 32*x1**2*x2**2
     &     + 8*x1**3*x2 + 4*x1**4 )
      e0 = e0 + GII(15,1)*dlmuF*rtree2 * (  - 4 - 16*x1**(-2)*x2**2 - 8
     &    *x1**(-1)*x2 - 2*x2**2 - 2*x2**4 - 8*x1*x2**(-1) - 16*x1*x2
     &     - 4*x1*x2**3 - 16*x1**2*x2**(-2) - 2*x1**2 - 16*x1**2*x2**2
     &     - 4*x1**3*x2 - 2*x1**4 )
      e0 = e0 + GII(15,1)*dlmuF*rtree1 * (  - 8 - 32*x1**(-2)*x2**2 - 
     &    16*x1**(-1)*x2 - 4*x2**2 - 4*x2**4 - 16*x1*x2**(-1) - 32*x1*
     &    x2 - 8*x1*x2**3 - 32*x1**2*x2**(-2) - 4*x1**2 - 32*x1**2*
     &    x2**2 - 8*x1**3*x2 - 4*x1**4 )
      e0 = e0 + GII(15,1)**2*rtree2 * ( 2 + 8*x1**(-2)*x2**2 + 4*
     &    x1**(-1)*x2 + 4*x2 + x2**2 + x2**4 + 4*x1*x2**(-1) + 4*x1 + 8
     &    *x1*x2 + 8*x1*x2**2 + 2*x1*x2**3 + 8*x1**2*x2**(-2) + x1**2
     &     + 8*x1**2*x2 + 8*x1**2*x2**2 + 2*x1**3*x2 + x1**4 )
      e0 = e0 + GII(15,1)**2*rtree1 * ( 4 + 16*x1**(-2)*x2**2 + 8*
     &    x1**(-1)*x2 + 8*x2 + 2*x2**2 + 2*x2**4 + 8*x1*x2**(-1) + 8*x1
     &     + 16*x1*x2 + 16*x1*x2**2 + 4*x1*x2**3 + 16*x1**2*x2**(-2) + 
     &    2*x1**2 + 16*x1**2*x2 + 16*x1**2*x2**2 + 4*x1**3*x2 + 2*x1**4
     &     )
      e0 = e0 + GII(15,1)*GII(30,1)*rtree2 * ( 8 + 16*x1**(-2)*x2**2 + 
     &    8*x1**(-1)*x2 - 4*x2*x1px2**(-1) - 4*x2**2 + 8*x2**3*
     &    x1px2**(-1) + 12*x2**4 - 8*x2**5*x1px2**(-1) + 8*x1*x2**(-1)
     &     + 24*x1*x2 + 16*x1**2*x2**(-2) + 4*x1**2 + 24*x1**2*x2**2 + 
     &    8*x1**3*x2 + 4*x1**4 )
      e0 = e0 + GII(15,1)*GII(30,1)*rtree1 * ( 16 + 32*x1**(-2)*x2**2
     &     + 16*x1**(-1)*x2 - 8*x2*x1px2**(-1) - 8*x2**2 + 16*x2**3*
     &    x1px2**(-1) + 24*x2**4 - 16*x2**5*x1px2**(-1) + 16*x1*
     &    x2**(-1) + 48*x1*x2 + 32*x1**2*x2**(-2) + 8*x1**2 + 48*x1**2*
     &    x2**2 + 16*x1**3*x2 + 8*x1**4 )
      e0 = e0 + GII(15,1)*GII(30,2)*rtree2 * ( 4 + 16*x1**(-2)*x2**2 + 
     &    8*x1**(-1)*x2 + 4*x2*x1px2**(-1) + 12*x2**2 - 8*x2**3*
     &    x1px2**(-1) - 4*x2**4 + 8*x2**5*x1px2**(-1) + 8*x1*x2**(-1)
     &     + 16*x1*x2 + 16*x1*x2**3 + 16*x1**2*x2**(-2) + 4*x1**2 + 16*
     &    x1**2*x2**2 + 8*x1**3*x2 + 4*x1**4 )
      e0 = e0 + GII(15,1)*GII(30,2)*rtree1 * ( 8 + 32*x1**(-2)*x2**2 + 
     &    16*x1**(-1)*x2 + 8*x2*x1px2**(-1) + 24*x2**2 - 16*x2**3*
     &    x1px2**(-1) - 8*x2**4 + 16*x2**5*x1px2**(-1) + 16*x1*x2**(-1)
     &     + 32*x1*x2 + 32*x1*x2**3 + 32*x1**2*x2**(-2) + 8*x1**2 + 32*
     &    x1**2*x2**2 + 16*x1**3*x2 + 8*x1**4 )
      e0 = e0 + GII(15,1)*GII(31,1)*rtree2 * ( 2 + 4*x2 + 6*x2**2 + 2*
     &    x2**4 + 8*x1*x2**(-1) + 4*x1 + 8*x1*x2 + 8*x1*x2**2 + 4*x1*
     &    x2**3 + 16*x1**2*x2**(-2) - 4*x1**2 + 8*x1**2*x2 + 8*x1**2*
     &    x2**2 )
      e0 = e0 + GII(15,1)*GII(31,1)*rtree1 * ( 4 + 8*x2 + 12*x2**2 + 4*
     &    x2**4 + 16*x1*x2**(-1) + 8*x1 + 16*x1*x2 + 16*x1*x2**2 + 8*x1
     &    *x2**3 + 32*x1**2*x2**(-2) - 8*x1**2 + 16*x1**2*x2 + 16*x1**2
     &    *x2**2 )
      e0 = e0 + GII(15,1)*GII(31,2)*rtree2 * ( 2 + 16*x1**(-2)*x2**2 + 
     &    8*x1**(-1)*x2 + 4*x2 - 4*x2**2 + 4*x1 + 8*x1*x2 + 8*x1*x2**2
     &     + 6*x1**2 + 8*x1**2*x2 + 8*x1**2*x2**2 + 4*x1**3*x2 + 2*
     &    x1**4 )
      e0 = e0 + GII(15,1)*GII(31,2)*rtree1 * ( 4 + 32*x1**(-2)*x2**2 + 
     &    16*x1**(-1)*x2 + 8*x2 - 8*x2**2 + 8*x1 + 16*x1*x2 + 16*x1*
     &    x2**2 + 12*x1**2 + 16*x1**2*x2 + 16*x1**2*x2**2 + 8*x1**3*x2
     &     + 4*x1**4 )
      e0 = e0 + GII(15,1)*PLI1(1)*rtree2 * (  - 4 - 16*x1**(-2)*x2**2
     &     - 8*x1**(-1)*x2 - 2*x2**2 - 2*x2**4 - 8*x1*x2**(-1) - 16*x1*
     &    x2 - 4*x1*x2**3 - 16*x1**2*x2**(-2) - 2*x1**2 - 16*x1**2*
     &    x2**2 - 4*x1**3*x2 - 2*x1**4 )
      e0 = e0 + GII(15,1)*PLI1(1)*rtree1 * (  - 8 - 32*x1**(-2)*x2**2
     &     - 16*x1**(-1)*x2 - 4*x2**2 - 4*x2**4 - 16*x1*x2**(-1) - 32*
     &    x1*x2 - 8*x1*x2**3 - 32*x1**2*x2**(-2) - 4*x1**2 - 32*x1**2*
     &    x2**2 - 8*x1**3*x2 - 4*x1**4 )
      e0 = e0 + GII(15,1)*PLI1(2)*rtree2 * (  - 4 - 16*x1**(-2)*x2**2
     &     - 8*x1**(-1)*x2 - 2*x2**2 - 2*x2**4 - 8*x1*x2**(-1) - 16*x1*
     &    x2 - 4*x1*x2**3 - 16*x1**2*x2**(-2) - 2*x1**2 - 16*x1**2*
     &    x2**2 - 4*x1**3*x2 - 2*x1**4 )
      e0 = e0 + GII(15,1)*PLI1(2)*rtree1 * (  - 8 - 32*x1**(-2)*x2**2
     &     - 16*x1**(-1)*x2 - 4*x2**2 - 4*x2**4 - 16*x1*x2**(-1) - 32*
     &    x1*x2 - 8*x1*x2**3 - 32*x1**2*x2**(-2) - 4*x1**2 - 32*x1**2*
     &    x2**2 - 8*x1**3*x2 - 4*x1**4 )
      e0 = e0 + GII(18,1)*rtree2 * (  - 2 + 4*x2 - 4*x2**2 - 8*x1*
     &    x2**(-1) + 4*x1 - 8*x1*x2 + 8*x1*x2**2 - 16*x1**2*x2**(-2) + 
     &    4*x1**2 + 8*x1**2*x2 - 8*x1**2*x2**2 )
      e0 = e0 + GII(18,1)*rtree1 * (  - 4 + 8*x2 - 8*x2**2 - 16*x1*
     &    x2**(-1) + 8*x1 - 16*x1*x2 + 16*x1*x2**2 - 32*x1**2*x2**(-2)
     &     + 8*x1**2 + 16*x1**2*x2 - 16*x1**2*x2**2 )
      e0 = e0 + GII(18,2)*rtree2 * (  - 2 - 16*x1**(-2)*x2**2 - 8*
     &    x1**(-1)*x2 + 4*x2 + 4*x2**2 + 4*x1 - 8*x1*x2 + 8*x1*x2**2 - 
     &    4*x1**2 + 8*x1**2*x2 - 8*x1**2*x2**2 )
      e0 = e0 + GII(18,2)*rtree1 * (  - 4 - 32*x1**(-2)*x2**2 - 16*
     &    x1**(-1)*x2 + 8*x2 + 8*x2**2 + 8*x1 - 16*x1*x2 + 16*x1*x2**2
     &     - 8*x1**2 + 16*x1**2*x2 - 16*x1**2*x2**2 )
      e0 = e0 + GII(20,1)*rtree2 * ( 2 - 4*x2 + 8*x2**2 + 4*x2**4 + 8*
     &    x1*x2**(-1) - 4*x1 + 8*x1*x2 - 8*x1*x2**2 + 8*x1*x2**3 + 16*
     &    x1**2*x2**(-2) - 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
      e0 = e0 + GII(20,1)*rtree1 * ( 4 - 8*x2 + 16*x2**2 + 8*x2**4 + 16
     &    *x1*x2**(-1) - 8*x1 + 16*x1*x2 - 16*x1*x2**2 + 16*x1*x2**3 + 
     &    32*x1**2*x2**(-2) - 8*x1**2 - 16*x1**2*x2 + 16*x1**2*x2**2 )
      e0 = e0 + GII(20,2)*rtree2 * ( 2 + 16*x1**(-2)*x2**2 + 8*x1**(-1)
     &    *x2 - 4*x2 - 4*x2**2 - 4*x1 + 8*x1*x2 - 8*x1*x2**2 + 8*x1**2
     &     - 8*x1**2*x2 + 8*x1**2*x2**2 + 8*x1**3*x2 + 4*x1**4 )
      e0 = e0 + GII(20,2)*rtree1 * ( 4 + 32*x1**(-2)*x2**2 + 16*
     &    x1**(-1)*x2 - 8*x2 - 8*x2**2 - 8*x1 + 16*x1*x2 - 16*x1*x2**2
     &     + 16*x1**2 - 16*x1**2*x2 + 16*x1**2*x2**2 + 16*x1**3*x2 + 8*
     &    x1**4 )
      e0 = e0 + GII(21,1)*rtree2 * (  - 2 + 4*x2 - 6*x2**2 - 2*x2**4 - 
     &    8*x1*x2**(-1) + 4*x1 - 8*x1*x2 + 8*x1*x2**2 - 4*x1*x2**3 - 16
     &    *x1**2*x2**(-2) + 4*x1**2 + 8*x1**2*x2 - 8*x1**2*x2**2 )
      e0 = e0 + GII(21,1)*rtree1 * (  - 4 + 8*x2 - 12*x2**2 - 4*x2**4
     &     - 16*x1*x2**(-1) + 8*x1 - 16*x1*x2 + 16*x1*x2**2 - 8*x1*
     &    x2**3 - 32*x1**2*x2**(-2) + 8*x1**2 + 16*x1**2*x2 - 16*x1**2*
     &    x2**2 )
      e0 = e0 + GII(21,2)*rtree2 * (  - 2 - 16*x1**(-2)*x2**2 - 8*
     &    x1**(-1)*x2 + 4*x2 + 4*x2**2 + 4*x1 - 8*x1*x2 + 8*x1*x2**2 - 
     &    6*x1**2 + 8*x1**2*x2 - 8*x1**2*x2**2 - 4*x1**3*x2 - 2*x1**4 )
      e0 = e0 + GII(21,2)*rtree1 * (  - 4 - 32*x1**(-2)*x2**2 - 16*
     &    x1**(-1)*x2 + 8*x2 + 8*x2**2 + 8*x1 - 16*x1*x2 + 16*x1*x2**2
     &     - 12*x1**2 + 16*x1**2*x2 - 16*x1**2*x2**2 - 8*x1**3*x2 - 4*
     &    x1**4 )
      e0 = e0 + GII(30,1)*rtree2 * ( 6 - 16*x1**(-1)*x2 + 16*x1**(-1)*
     &    x2**2 + 2*rln2 - 22*x2*x1px2**(-1) - 8*x2 - 4*x2*rln2 + 58*
     &    x2**2*x1px2**(-2) + 96*x2**2*x1px2**(-1) - 36*x2**2 + 8*x2**2
     &    *rln2 - 78*x2**3*x1px2**(-3) - 224*x2**3*x1px2**(-2) + 80*
     &    x2**3*x1px2**(-1) + 96*x2**3 + 36*x2**4*x1px2**(-4) + 240*
     &    x2**4*x1px2**(-3) - 92*x2**4*x1px2**(-2) - 320*x2**4*
     &    x1px2**(-1) - 84*x2**4 + 4*x2**4*rln2 - 96*x2**5*x1px2**(-4)
     &     + 40*x2**5*x1px2**(-3) + 464*x2**5*x1px2**(-2) + 204*x2**5*
     &    x1px2**(-1) - 336*x2**6*x1px2**(-3) - 220*x2**6*x1px2**(-2)
     &     + 96*x2**7*x1px2**(-4) + 136*x2**7*x1px2**(-3) - 36*x2**8*
     &    x1px2**(-4) - 28*x1*x2**(-1) + 8*x1*x2**(-1)*rln2 - 4*x1*rln2
     &     + 12*x1*x2 + 8*x1*x2*rln2 - 16*x1*x2**2 - 8*x1*x2**2*rln2 + 
     &    24*x1*x2**3 + 8*x1*x2**3*rln2 - 44*x1**2*x2**(-2) + 16*x1**2*
     &    x2**(-2)*rln2 + 16*x1**2*x2**(-1) - 2*x1**2 - 4*x1**2*rln2 - 
     &    8*x1**2*x2 - 8*x1**2*x2*rln2 + 6*x1**2*x2**2 + 8*x1**2*x2**2*
     &    rln2 )
      e0 = e0 + GII(30,1)*rtree2 * ( 4*x1**3 - 4*x1**3*x2 + 6/(1 + 2*x1
     &    ) - 6/(1 + 2*x1)*x2*x1px2**(-1) - 2/(1 + 2*x1)*x2**2*
     &    x1px2**(-2) - 24/(1 + 2*x1)*x2**2 + 2/(1 + 2*x1)*x2**3*
     &    x1px2**(-3) + 40/(1 + 2*x1)*x2**3*x1px2**(-1) - 16/(1 + 2*x1)
     &    *x2**4*x1px2**(-2) - 32/(1 + 2*x1)*x2**4 + 32/(1 + 2*x1)*
     &    x2**5*x1px2**(-1) + 8/(1 + 2*x1)*x1*x2 + 32/(1 + 2*x1)*x1*
     &    x2**3 + 24/(1 + 2*x1)*x1**2 - 32/(1 + 2*x1)*x1**2*x2**2 + 32
     &    /(1 + 2*x1)*x1**3*x2 )
      e0 = e0 + GII(30,1)*rtree1 * ( 12 - 32*x1**(-1)*x2 + 32*x1**(-1)*
     &    x2**2 + 4*rln2 - 44*x2*x1px2**(-1) - 16*x2 - 8*x2*rln2 + 116*
     &    x2**2*x1px2**(-2) + 192*x2**2*x1px2**(-1) - 72*x2**2 + 16*
     &    x2**2*rln2 - 156*x2**3*x1px2**(-3) - 448*x2**3*x1px2**(-2) + 
     &    160*x2**3*x1px2**(-1) + 192*x2**3 + 72*x2**4*x1px2**(-4) + 
     &    480*x2**4*x1px2**(-3) - 184*x2**4*x1px2**(-2) - 640*x2**4*
     &    x1px2**(-1) - 168*x2**4 + 8*x2**4*rln2 - 192*x2**5*
     &    x1px2**(-4) + 80*x2**5*x1px2**(-3) + 928*x2**5*x1px2**(-2) + 
     &    408*x2**5*x1px2**(-1) - 672*x2**6*x1px2**(-3) - 440*x2**6*
     &    x1px2**(-2) + 192*x2**7*x1px2**(-4) + 272*x2**7*x1px2**(-3)
     &     - 72*x2**8*x1px2**(-4) - 56*x1*x2**(-1) + 16*x1*x2**(-1)*
     &    rln2 - 8*x1*rln2 + 24*x1*x2 + 16*x1*x2*rln2 - 32*x1*x2**2 - 
     &    16*x1*x2**2*rln2 + 48*x1*x2**3 + 16*x1*x2**3*rln2 - 88*x1**2*
     &    x2**(-2) + 32*x1**2*x2**(-2)*rln2 + 32*x1**2*x2**(-1) - 4*
     &    x1**2 - 8*x1**2*rln2 - 16*x1**2*x2 - 16*x1**2*x2*rln2 + 12*
     &    x1**2*x2**2 )
      e0 = e0 + GII(30,1)*rtree1 * ( 16*x1**2*x2**2*rln2 + 8*x1**3 - 8*
     &    x1**3*x2 + 12/(1 + 2*x1) - 12/(1 + 2*x1)*x2*x1px2**(-1) - 4/(
     &    1 + 2*x1)*x2**2*x1px2**(-2) - 48/(1 + 2*x1)*x2**2 + 4/(1 + 2*
     &    x1)*x2**3*x1px2**(-3) + 80/(1 + 2*x1)*x2**3*x1px2**(-1) - 32
     &    /(1 + 2*x1)*x2**4*x1px2**(-2) - 64/(1 + 2*x1)*x2**4 + 64/(1
     &     + 2*x1)*x2**5*x1px2**(-1) + 16/(1 + 2*x1)*x1*x2 + 64/(1 + 2*
     &    x1)*x1*x2**3 + 48/(1 + 2*x1)*x1**2 - 64/(1 + 2*x1)*x1**2*
     &    x2**2 + 64/(1 + 2*x1)*x1**3*x2 )
      e0 = e0 + GII(30,1)*dls12*rtree2 * (  - 8*x1*x2**(-1) - 16*x1**2*
     &    x2**(-2) + 8*x1**2 )
      e0 = e0 + GII(30,1)*dls12*rtree1 * (  - 16*x1*x2**(-1) - 32*x1**2
     &    *x2**(-2) + 16*x1**2 )
      e0 = e0 + GII(30,1)*dlmuF*rtree2 * ( 8*x1*x2**(-1) + 16*x1**2*
     &    x2**(-2) - 8*x1**2 )
      e0 = e0 + GII(30,1)*dlmuF*rtree1 * ( 16*x1*x2**(-1) + 32*x1**2*
     &    x2**(-2) - 16*x1**2 )
      e0 = e0 + GII(30,1)**2*rtree2 * (  - 4*x1*x2**(-1) - 8*x1**2*
     &    x2**(-2) + 4*x1**2 )
      e0 = e0 + GII(30,1)**2*rtree1 * (  - 8*x1*x2**(-1) - 16*x1**2*
     &    x2**(-2) + 8*x1**2 )
      e0 = e0 + GII(30,1)*GII(30,2)*rtree2 * (  - 4 - 16*x1**(-2)*x2**2
     &     - 8*x1**(-1)*x2 - 16*x2*x1px2**(-1) + 32*x2**2*x1px2**(-2)
     &     - 52*x2**2 - 32*x2**3*x1px2**(-3) + 176*x2**3*x1px2**(-1) + 
     &    16*x2**4*x1px2**(-4) - 288*x2**4*x1px2**(-2) + 76*x2**4 + 240
     &    *x2**5*x1px2**(-3) - 160*x2**5*x1px2**(-1) - 80*x2**6*
     &    x1px2**(-4) + 128*x2**6*x1px2**(-2) - 64*x2**7*x1px2**(-3) + 
     &    16*x2**8*x1px2**(-4) - 16*x1*x2**(-1) - 16*x1*x2 - 40*x1*
     &    x2**3 - 32*x1**2*x2**(-2) + 8*x1**2 - 16*x1**2*x2**2 )
      e0 = e0 + GII(30,1)*GII(30,2)*rtree1 * (  - 8 - 32*x1**(-2)*x2**2
     &     - 16*x1**(-1)*x2 - 32*x2*x1px2**(-1) + 64*x2**2*x1px2**(-2)
     &     - 104*x2**2 - 64*x2**3*x1px2**(-3) + 352*x2**3*x1px2**(-1)
     &     + 32*x2**4*x1px2**(-4) - 576*x2**4*x1px2**(-2) + 152*x2**4
     &     + 480*x2**5*x1px2**(-3) - 320*x2**5*x1px2**(-1) - 160*x2**6*
     &    x1px2**(-4) + 256*x2**6*x1px2**(-2) - 128*x2**7*x1px2**(-3)
     &     + 32*x2**8*x1px2**(-4) - 32*x1*x2**(-1) - 32*x1*x2 - 80*x1*
     &    x2**3 - 64*x1**2*x2**(-2) + 16*x1**2 - 32*x1**2*x2**2 )
      e0 = e0 + GII(30,1)*GII(31,1)*rtree2 * ( 2 - 4*x2 + 8*x2**2 + 4*
     &    x2**4 + 8*x1*x2**(-1) - 4*x1 + 8*x1*x2 - 8*x1*x2**2 + 8*x1*
     &    x2**3 + 16*x1**2*x2**(-2) - 4*x1**2 - 8*x1**2*x2 + 8*x1**2*
     &    x2**2 )
      e0 = e0 + GII(30,1)*GII(31,1)*rtree1 * ( 4 - 8*x2 + 16*x2**2 + 8*
     &    x2**4 + 16*x1*x2**(-1) - 8*x1 + 16*x1*x2 - 16*x1*x2**2 + 16*
     &    x1*x2**3 + 32*x1**2*x2**(-2) - 8*x1**2 - 16*x1**2*x2 + 16*
     &    x1**2*x2**2 )
      e0 = e0 + GII(30,1)*GII(31,2)*rtree2 * ( 8 + 16*x1**(-2)*x2**2 + 
     &    8*x1**(-1)*x2 - 4*x2*x1px2**(-1) - 4*x2**2 + 8*x2**3*
     &    x1px2**(-1) + 12*x2**4 - 8*x2**5*x1px2**(-1) + 8*x1*x2**(-1)
     &     + 24*x1*x2 + 16*x1**2*x2**(-2) + 4*x1**2 + 24*x1**2*x2**2 + 
     &    8*x1**3*x2 + 4*x1**4 )
      e0 = e0 + GII(30,1)*GII(31,2)*rtree1 * ( 16 + 32*x1**(-2)*x2**2
     &     + 16*x1**(-1)*x2 - 8*x2*x1px2**(-1) - 8*x2**2 + 16*x2**3*
     &    x1px2**(-1) + 24*x2**4 - 16*x2**5*x1px2**(-1) + 16*x1*
     &    x2**(-1) + 48*x1*x2 + 32*x1**2*x2**(-2) + 8*x1**2 + 48*x1**2*
     &    x2**2 + 16*x1**3*x2 + 8*x1**4 )
      e0 = e0 + GII(30,1)*PLI1(1)*rtree2 * (  - 2 + 4*x2 - 4*x2**2 + 4*
     &    x1 - 8*x1*x2 + 8*x1*x2**2 - 4*x1**2 + 8*x1**2*x2 - 8*x1**2*
     &    x2**2 )
      e0 = e0 + GII(30,1)*PLI1(1)*rtree1 * (  - 4 + 8*x2 - 8*x2**2 + 8*
     &    x1 - 16*x1*x2 + 16*x1*x2**2 - 8*x1**2 + 16*x1**2*x2 - 16*
     &    x1**2*x2**2 )
      e0 = e0 + GII(30,1)*PLI1(2)*rtree2 * ( 8*x1*x2**(-1) + 16*x1**2*
     &    x2**(-2) - 8*x1**2 )
      e0 = e0 + GII(30,1)*PLI1(2)*rtree1 * ( 16*x1*x2**(-1) + 32*x1**2*
     &    x2**(-2) - 16*x1**2 )
      e0 = e0 + GII(30,2)*rtree2 * (  - 44*x1**(-2)*x2**2 + 16*x1**(-2)
     &    *x2**2*rln2 - 28*x1**(-1)*x2 + 8*x1**(-1)*x2*rln2 + 16*
     &    x1**(-1)*x2**2 + 2*rln2 - 4*x2*x1px2**(-1) + 16*x2 - 4*x2*
     &    rln2 + 40*x2**2*x1px2**(-2) - 96*x2**2*x1px2**(-1) + 42*x2**2
     &     - 4*x2**2*rln2 - 66*x2**3*x1px2**(-3) + 224*x2**3*
     &    x1px2**(-2) - 112*x2**3*x1px2**(-1) - 92*x2**3 + 36*x2**4*
     &    x1px2**(-4) - 240*x2**4*x1px2**(-3) + 108*x2**4*x1px2**(-2)
     &     + 320*x2**4*x1px2**(-1) - 116*x2**4 + 96*x2**5*x1px2**(-4)
     &     - 40*x2**5*x1px2**(-3) - 464*x2**5*x1px2**(-2) + 276*x2**5*
     &    x1px2**(-1) + 336*x2**6*x1px2**(-3) - 276*x2**6*x1px2**(-2)
     &     - 96*x2**7*x1px2**(-4) + 152*x2**7*x1px2**(-3) - 36*x2**8*
     &    x1px2**(-4) - 16*x1*x2**(-1) + 8*x1 - 4*x1*rln2 - 4*x1*x2 + 8
     &    *x1*x2*rln2 + 8*x1*x2**2 - 8*x1*x2**2*rln2 + 32*x1*x2**3 + 16
     &    *x1**2*x2**(-1) - 8*x1**2 + 8*x1**2*rln2 - 8*x1**2*x2*rln2 + 
     &    6*x1**2*x2**2 + 8*x1**2*x2**2*rln2 - 4*x1**3*x2 + 8*x1**3*x2*
     &    rln2 )
      e0 = e0 + GII(30,2)*rtree2 * ( 4*x1**4*rln2 + 4/(1 + 2*x2)*x2*
     &    x1px2**(-1) + 4/(1 + 2*x2)*x2**2*x1px2**(-2) + 16/(1 + 2*x2)*
     &    x2**2 - 2/(1 + 2*x2)*x2**3*x1px2**(-3) + 24/(1 + 2*x2)*x2**3*
     &    x1px2**(-1) - 16/(1 + 2*x2)*x2**4*x1px2**(-2) + 32/(1 + 2*x2)
     &    *x2**4 - 32/(1 + 2*x2)*x2**5*x1px2**(-1) )
      e0 = e0 + GII(30,2)*rtree1 * (  - 88*x1**(-2)*x2**2 + 32*x1**(-2)
     &    *x2**2*rln2 - 56*x1**(-1)*x2 + 16*x1**(-1)*x2*rln2 + 32*
     &    x1**(-1)*x2**2 + 4*rln2 - 8*x2*x1px2**(-1) + 32*x2 - 8*x2*
     &    rln2 + 80*x2**2*x1px2**(-2) - 192*x2**2*x1px2**(-1) + 84*
     &    x2**2 - 8*x2**2*rln2 - 132*x2**3*x1px2**(-3) + 448*x2**3*
     &    x1px2**(-2) - 224*x2**3*x1px2**(-1) - 184*x2**3 + 72*x2**4*
     &    x1px2**(-4) - 480*x2**4*x1px2**(-3) + 216*x2**4*x1px2**(-2)
     &     + 640*x2**4*x1px2**(-1) - 232*x2**4 + 192*x2**5*x1px2**(-4)
     &     - 80*x2**5*x1px2**(-3) - 928*x2**5*x1px2**(-2) + 552*x2**5*
     &    x1px2**(-1) + 672*x2**6*x1px2**(-3) - 552*x2**6*x1px2**(-2)
     &     - 192*x2**7*x1px2**(-4) + 304*x2**7*x1px2**(-3) - 72*x2**8*
     &    x1px2**(-4) - 32*x1*x2**(-1) + 16*x1 - 8*x1*rln2 - 8*x1*x2 + 
     &    16*x1*x2*rln2 + 16*x1*x2**2 - 16*x1*x2**2*rln2 + 64*x1*x2**3
     &     + 32*x1**2*x2**(-1) - 16*x1**2 + 16*x1**2*rln2 - 16*x1**2*x2
     &    *rln2 + 12*x1**2*x2**2 + 16*x1**2*x2**2*rln2 - 8*x1**3*x2 + 
     &    16*x1**3*x2*rln2 )
      e0 = e0 + GII(30,2)*rtree1 * ( 8*x1**4*rln2 + 8/(1 + 2*x2)*x2*
     &    x1px2**(-1) + 8/(1 + 2*x2)*x2**2*x1px2**(-2) + 32/(1 + 2*x2)*
     &    x2**2 - 4/(1 + 2*x2)*x2**3*x1px2**(-3) + 48/(1 + 2*x2)*x2**3*
     &    x1px2**(-1) - 32/(1 + 2*x2)*x2**4*x1px2**(-2) + 64/(1 + 2*x2)
     &    *x2**4 - 64/(1 + 2*x2)*x2**5*x1px2**(-1) )
      e0 = e0 + GII(30,2)*dls12*rtree2 * (  - 16*x1**(-2)*x2**2 - 8*
     &    x1**(-1)*x2 + 8*x2**2 )
      e0 = e0 + GII(30,2)*dls12*rtree1 * (  - 32*x1**(-2)*x2**2 - 16*
     &    x1**(-1)*x2 + 16*x2**2 )
      e0 = e0 + GII(30,2)*dlmuF*rtree2 * ( 16*x1**(-2)*x2**2 + 8*
     &    x1**(-1)*x2 - 8*x2**2 )
      e0 = e0 + GII(30,2)*dlmuF*rtree1 * ( 32*x1**(-2)*x2**2 + 16*
     &    x1**(-1)*x2 - 16*x2**2 )
      e0 = e0 + GII(30,2)**2*rtree2 * (  - 8*x1**(-2)*x2**2 - 4*
     &    x1**(-1)*x2 + 4*x2**2 )
      e0 = e0 + GII(30,2)**2*rtree1 * (  - 16*x1**(-2)*x2**2 - 8*
     &    x1**(-1)*x2 + 8*x2**2 )
      e0 = e0 + GII(30,2)*GII(31,1)*rtree2 * ( 4 + 16*x1**(-2)*x2**2 + 
     &    8*x1**(-1)*x2 + 4*x2*x1px2**(-1) + 12*x2**2 - 8*x2**3*
     &    x1px2**(-1) - 4*x2**4 + 8*x2**5*x1px2**(-1) + 8*x1*x2**(-1)
     &     + 16*x1*x2 + 16*x1*x2**3 + 16*x1**2*x2**(-2) + 4*x1**2 + 16*
     &    x1**2*x2**2 + 8*x1**3*x2 + 4*x1**4 )
      e0 = e0 + GII(30,2)*GII(31,1)*rtree1 * ( 8 + 32*x1**(-2)*x2**2 + 
     &    16*x1**(-1)*x2 + 8*x2*x1px2**(-1) + 24*x2**2 - 16*x2**3*
     &    x1px2**(-1) - 8*x2**4 + 16*x2**5*x1px2**(-1) + 16*x1*x2**(-1)
     &     + 32*x1*x2 + 32*x1*x2**3 + 32*x1**2*x2**(-2) + 8*x1**2 + 32*
     &    x1**2*x2**2 + 16*x1**3*x2 + 8*x1**4 )
      e0 = e0 + GII(30,2)*GII(31,2)*rtree2 * ( 2 + 16*x1**(-2)*x2**2 + 
     &    8*x1**(-1)*x2 - 4*x2 - 4*x2**2 - 4*x1 + 8*x1*x2 - 8*x1*x2**2
     &     + 8*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 + 8*x1**3*x2 + 4*
     &    x1**4 )
      e0 = e0 + GII(30,2)*GII(31,2)*rtree1 * ( 4 + 32*x1**(-2)*x2**2 + 
     &    16*x1**(-1)*x2 - 8*x2 - 8*x2**2 - 8*x1 + 16*x1*x2 - 16*x1*
     &    x2**2 + 16*x1**2 - 16*x1**2*x2 + 16*x1**2*x2**2 + 16*x1**3*x2
     &     + 8*x1**4 )
      e0 = e0 + GII(30,2)*PLI1(1)*rtree2 * ( 16*x1**(-2)*x2**2 + 8*
     &    x1**(-1)*x2 - 8*x2**2 )
      e0 = e0 + GII(30,2)*PLI1(1)*rtree1 * ( 32*x1**(-2)*x2**2 + 16*
     &    x1**(-1)*x2 - 16*x2**2 )
      e0 = e0 + GII(30,2)*PLI1(2)*rtree2 * (  - 2 + 4*x2 - 4*x2**2 + 4*
     &    x1 - 8*x1*x2 + 8*x1*x2**2 - 4*x1**2 + 8*x1**2*x2 - 8*x1**2*
     &    x2**2 )
      e0 = e0 + GII(30,2)*PLI1(2)*rtree1 * (  - 4 + 8*x2 - 8*x2**2 + 8*
     &    x1 - 16*x1*x2 + 16*x1*x2**2 - 8*x1**2 + 16*x1**2*x2 - 16*
     &    x1**2*x2**2 )
      e0 = e0 + GII(31,1)*rtree2 * (  - 5 + 3*x2*x1px2**(-1) - 2*x2 + 
     &    x2**2*x1px2**(-2) + 10*x2**2 - x2**3*x1px2**(-3) - 16*x2**3*
     &    x1px2**(-1) + 6*x2**4*x1px2**(-2) + 14*x2**4 - 6*x2**5*
     &    x1px2**(-1) + 12*x1*x2**(-1) - 2*x1 + 12*x1*x2 - 16*x1*x2**2
     &     - 2*x1*x2**3 + 44*x1**2*x2**(-2) - 2*x1**2 - 16*x1**2*x2 + 8
     &    *x1**2*x2**2 - 3/(1 + 2*x1) + 3/(1 + 2*x1)*x2*x1px2**(-1) + 
     &    1/(1 + 2*x1)*x2**2*x1px2**(-2) + 12/(1 + 2*x1)*x2**2 - 1/(1
     &     + 2*x1)*x2**3*x1px2**(-3) - 20/(1 + 2*x1)*x2**3*x1px2**(-1)
     &     + 8/(1 + 2*x1)*x2**4*x1px2**(-2) + 16/(1 + 2*x1)*x2**4 - 16
     &    /(1 + 2*x1)*x2**5*x1px2**(-1) - 4/(1 + 2*x1)*x1*x2 - 16/(1 + 
     &    2*x1)*x1*x2**3 - 12/(1 + 2*x1)*x1**2 + 16/(1 + 2*x1)*x1**2*
     &    x2**2 - 16/(1 + 2*x1)*x1**3*x2 )
      e0 = e0 + GII(31,1)*rtree1 * (  - 10 + 6*x2*x1px2**(-1) - 4*x2 + 
     &    2*x2**2*x1px2**(-2) + 20*x2**2 - 2*x2**3*x1px2**(-3) - 32*
     &    x2**3*x1px2**(-1) + 12*x2**4*x1px2**(-2) + 28*x2**4 - 12*
     &    x2**5*x1px2**(-1) + 24*x1*x2**(-1) - 4*x1 + 24*x1*x2 - 32*x1*
     &    x2**2 - 4*x1*x2**3 + 88*x1**2*x2**(-2) - 4*x1**2 - 32*x1**2*
     &    x2 + 16*x1**2*x2**2 - 6/(1 + 2*x1) + 6/(1 + 2*x1)*x2*
     &    x1px2**(-1) + 2/(1 + 2*x1)*x2**2*x1px2**(-2) + 24/(1 + 2*x1)*
     &    x2**2 - 2/(1 + 2*x1)*x2**3*x1px2**(-3) - 40/(1 + 2*x1)*x2**3*
     &    x1px2**(-1) + 16/(1 + 2*x1)*x2**4*x1px2**(-2) + 32/(1 + 2*x1)
     &    *x2**4 - 32/(1 + 2*x1)*x2**5*x1px2**(-1) - 8/(1 + 2*x1)*x1*x2
     &     - 32/(1 + 2*x1)*x1*x2**3 - 24/(1 + 2*x1)*x1**2 + 32/(1 + 2*
     &    x1)*x1**2*x2**2 - 32/(1 + 2*x1)*x1**3*x2 )
      e0 = e0 + GII(31,1)*dls12*rtree2 * ( 2 - 4*x2 + 6*x2**2 + 2*x2**4
     &     + 8*x1*x2**(-1) - 4*x1 + 8*x1*x2 - 8*x1*x2**2 + 4*x1*x2**3
     &     + 16*x1**2*x2**(-2) - 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
      e0 = e0 + GII(31,1)*dls12*rtree1 * ( 4 - 8*x2 + 12*x2**2 + 4*
     &    x2**4 + 16*x1*x2**(-1) - 8*x1 + 16*x1*x2 - 16*x1*x2**2 + 8*x1
     &    *x2**3 + 32*x1**2*x2**(-2) - 8*x1**2 - 16*x1**2*x2 + 16*x1**2
     &    *x2**2 )
      e0 = e0 + GII(31,1)*dlmuF*rtree2 * (  - 2 + 4*x2 - 6*x2**2 - 2*
     &    x2**4 - 8*x1*x2**(-1) + 4*x1 - 8*x1*x2 + 8*x1*x2**2 - 4*x1*
     &    x2**3 - 16*x1**2*x2**(-2) + 4*x1**2 + 8*x1**2*x2 - 8*x1**2*
     &    x2**2 )
      e0 = e0 + GII(31,1)*dlmuF*rtree1 * (  - 4 + 8*x2 - 12*x2**2 - 4*
     &    x2**4 - 16*x1*x2**(-1) + 8*x1 - 16*x1*x2 + 16*x1*x2**2 - 8*x1
     &    *x2**3 - 32*x1**2*x2**(-2) + 8*x1**2 + 16*x1**2*x2 - 16*x1**2
     &    *x2**2 )
      e0 = e0 + GII(31,1)*PLI1(1)*rtree2 * (  - 2 + 4*x2 - 6*x2**2 - 2*
     &    x2**4 - 8*x1*x2**(-1) + 4*x1 - 8*x1*x2 + 8*x1*x2**2 - 4*x1*
     &    x2**3 - 16*x1**2*x2**(-2) + 4*x1**2 + 8*x1**2*x2 - 8*x1**2*
     &    x2**2 )
      e0 = e0 + GII(31,1)*PLI1(1)*rtree1 * (  - 4 + 8*x2 - 12*x2**2 - 4
     &    *x2**4 - 16*x1*x2**(-1) + 8*x1 - 16*x1*x2 + 16*x1*x2**2 - 8*
     &    x1*x2**3 - 32*x1**2*x2**(-2) + 8*x1**2 + 16*x1**2*x2 - 16*
     &    x1**2*x2**2 )
      e0 = e0 + GII(31,1)*PLI1(2)*rtree2 * (  - 2 + 4*x2 - 6*x2**2 - 2*
     &    x2**4 - 8*x1*x2**(-1) + 4*x1 - 8*x1*x2 + 8*x1*x2**2 - 4*x1*
     &    x2**3 - 16*x1**2*x2**(-2) + 4*x1**2 + 8*x1**2*x2 - 8*x1**2*
     &    x2**2 )
      e0 = e0 + GII(31,1)*PLI1(2)*rtree1 * (  - 4 + 8*x2 - 12*x2**2 - 4
     &    *x2**4 - 16*x1*x2**(-1) + 8*x1 - 16*x1*x2 + 16*x1*x2**2 - 8*
     &    x1*x2**3 - 32*x1**2*x2**(-2) + 8*x1**2 + 16*x1**2*x2 - 16*
     &    x1**2*x2**2 )
      e0 = e0 + GII(31,2)*rtree2 * (  - 2 + 44*x1**(-2)*x2**2 + 12*
     &    x1**(-1)*x2 - 2*x2*x1px2**(-1) - 2*x2 - 2*x2**2*x1px2**(-2)
     &     + x2**3*x1px2**(-3) - 8*x2**3*x1px2**(-1) + 6*x2**4*
     &    x1px2**(-2) - 6*x2**4 + 6*x2**5*x1px2**(-1) - 2*x1 + 16*x1*x2
     &     - 16*x1*x2**2 + 6*x1*x2**3 - 16*x1**2*x2 + 2*x1**2*x2**2 + 4
     &    *x1**3*x2 + 8*x1**4 - 2/(1 + 2*x2)*x2*x1px2**(-1) - 2/(1 + 2*
     &    x2)*x2**2*x1px2**(-2) - 8/(1 + 2*x2)*x2**2 + 1/(1 + 2*x2)*
     &    x2**3*x1px2**(-3) - 12/(1 + 2*x2)*x2**3*x1px2**(-1) + 8/(1 + 
     &    2*x2)*x2**4*x1px2**(-2) - 16/(1 + 2*x2)*x2**4 + 16/(1 + 2*x2)
     &    *x2**5*x1px2**(-1) )
      e0 = e0 + GII(31,2)*rtree1 * (  - 4 + 88*x1**(-2)*x2**2 + 24*
     &    x1**(-1)*x2 - 4*x2*x1px2**(-1) - 4*x2 - 4*x2**2*x1px2**(-2)
     &     + 2*x2**3*x1px2**(-3) - 16*x2**3*x1px2**(-1) + 12*x2**4*
     &    x1px2**(-2) - 12*x2**4 + 12*x2**5*x1px2**(-1) - 4*x1 + 32*x1*
     &    x2 - 32*x1*x2**2 + 12*x1*x2**3 - 32*x1**2*x2 + 4*x1**2*x2**2
     &     + 8*x1**3*x2 + 16*x1**4 - 4/(1 + 2*x2)*x2*x1px2**(-1) - 4/(1
     &     + 2*x2)*x2**2*x1px2**(-2) - 16/(1 + 2*x2)*x2**2 + 2/(1 + 2*
     &    x2)*x2**3*x1px2**(-3) - 24/(1 + 2*x2)*x2**3*x1px2**(-1) + 16
     &    /(1 + 2*x2)*x2**4*x1px2**(-2) - 32/(1 + 2*x2)*x2**4 + 32/(1
     &     + 2*x2)*x2**5*x1px2**(-1) )
      e0 = e0 + GII(31,2)*dls12*rtree2 * ( 2 + 16*x1**(-2)*x2**2 + 8*
     &    x1**(-1)*x2 - 4*x2 - 4*x2**2 - 4*x1 + 8*x1*x2 - 8*x1*x2**2 + 
     &    6*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 + 4*x1**3*x2 + 2*x1**4 )
      e0 = e0 + GII(31,2)*dls12*rtree1 * ( 4 + 32*x1**(-2)*x2**2 + 16*
     &    x1**(-1)*x2 - 8*x2 - 8*x2**2 - 8*x1 + 16*x1*x2 - 16*x1*x2**2
     &     + 12*x1**2 - 16*x1**2*x2 + 16*x1**2*x2**2 + 8*x1**3*x2 + 4*
     &    x1**4 )
      e0 = e0 + GII(31,2)*dlmuF*rtree2 * (  - 2 - 16*x1**(-2)*x2**2 - 8
     &    *x1**(-1)*x2 + 4*x2 + 4*x2**2 + 4*x1 - 8*x1*x2 + 8*x1*x2**2
     &     - 6*x1**2 + 8*x1**2*x2 - 8*x1**2*x2**2 - 4*x1**3*x2 - 2*
     &    x1**4 )
      e0 = e0 + GII(31,2)*dlmuF*rtree1 * (  - 4 - 32*x1**(-2)*x2**2 - 
     &    16*x1**(-1)*x2 + 8*x2 + 8*x2**2 + 8*x1 - 16*x1*x2 + 16*x1*
     &    x2**2 - 12*x1**2 + 16*x1**2*x2 - 16*x1**2*x2**2 - 8*x1**3*x2
     &     - 4*x1**4 )
      e0 = e0 + GII(31,2)*PLI1(1)*rtree2 * (  - 2 - 16*x1**(-2)*x2**2
     &     - 8*x1**(-1)*x2 + 4*x2 + 4*x2**2 + 4*x1 - 8*x1*x2 + 8*x1*
     &    x2**2 - 6*x1**2 + 8*x1**2*x2 - 8*x1**2*x2**2 - 4*x1**3*x2 - 2
     &    *x1**4 )
      e0 = e0 + GII(31,2)*PLI1(1)*rtree1 * (  - 4 - 32*x1**(-2)*x2**2
     &     - 16*x1**(-1)*x2 + 8*x2 + 8*x2**2 + 8*x1 - 16*x1*x2 + 16*x1*
     &    x2**2 - 12*x1**2 + 16*x1**2*x2 - 16*x1**2*x2**2 - 8*x1**3*x2
     &     - 4*x1**4 )
      e0 = e0 + GII(31,2)*PLI1(2)*rtree2 * (  - 2 - 16*x1**(-2)*x2**2
     &     - 8*x1**(-1)*x2 + 4*x2 + 4*x2**2 + 4*x1 - 8*x1*x2 + 8*x1*
     &    x2**2 - 6*x1**2 + 8*x1**2*x2 - 8*x1**2*x2**2 - 4*x1**3*x2 - 2
     &    *x1**4 )
      e0 = e0 + GII(31,2)*PLI1(2)*rtree1 * (  - 4 - 32*x1**(-2)*x2**2
     &     - 16*x1**(-1)*x2 + 8*x2 + 8*x2**2 + 8*x1 - 16*x1*x2 + 16*x1*
     &    x2**2 - 12*x1**2 + 16*x1**2*x2 - 16*x1**2*x2**2 - 8*x1**3*x2
     &     - 4*x1**4 )
      e0 = e0 + PLI1(1)*rtree2 * (  - 1 + 16*x1**(-1)*x2 - 16*x1**(-1)*
     &    x2**2 - 2*x2*x1px2**(-1) - 2*x2 + 2*x2**2*x1px2**(-2) - x2**2
     &     + 8*x2**3*x1px2**(-1) - 2*x2**3 - 4*x2**4*x1px2**(-2) + 4*
     &    x2**4 - 6*x2**5*x1px2**(-1) + 2*x2**6*x1px2**(-2) + 16*x1*
     &    x2**(-1) - 2*x1 - 22*x1*x2 + 20*x1*x2**2 - 16*x1**2*x2**(-1)
     &     + 3*x1**2 + 20*x1**2*x2 - 17*x1**2*x2**2 - 2*x1**3 + 2*x1**3
     &    *x2 )
      e0 = e0 + PLI1(1)*rtree1 * (  - 2 + 32*x1**(-1)*x2 - 32*x1**(-1)*
     &    x2**2 - 4*x2*x1px2**(-1) - 4*x2 + 4*x2**2*x1px2**(-2) - 2*
     &    x2**2 + 16*x2**3*x1px2**(-1) - 4*x2**3 - 8*x2**4*x1px2**(-2)
     &     + 8*x2**4 - 12*x2**5*x1px2**(-1) + 4*x2**6*x1px2**(-2) + 32*
     &    x1*x2**(-1) - 4*x1 - 44*x1*x2 + 40*x1*x2**2 - 32*x1**2*
     &    x2**(-1) + 6*x1**2 + 40*x1**2*x2 - 34*x1**2*x2**2 - 4*x1**3
     &     + 4*x1**3*x2 )
      e0 = e0 + PLI1(1)*dls12*rtree2 * (  - 2 + 4*x2 - 4*x2**2 + 4*x1
     &     - 8*x1*x2 + 8*x1*x2**2 - 4*x1**2 + 8*x1**2*x2 - 8*x1**2*
     &    x2**2 )
      e0 = e0 + PLI1(1)*dls12*rtree1 * (  - 4 + 8*x2 - 8*x2**2 + 8*x1
     &     - 16*x1*x2 + 16*x1*x2**2 - 8*x1**2 + 16*x1**2*x2 - 16*x1**2*
     &    x2**2 )
      e0 = e0 + PLI1(1)*dlmuF*rtree2 * ( 2 - 4*x2 + 4*x2**2 - 4*x1 + 8*
     &    x1*x2 - 8*x1*x2**2 + 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
      e0 = e0 + PLI1(1)*dlmuF*rtree1 * ( 4 - 8*x2 + 8*x2**2 - 8*x1 + 16
     &    *x1*x2 - 16*x1*x2**2 + 8*x1**2 - 16*x1**2*x2 + 16*x1**2*x2**2
     &     )
      e0 = e0 + PLI1(1)**2*rtree2 * ( 1 - 2*x2 + 2*x2**2 - 2*x1 + 4*x1*
     &    x2 - 4*x1*x2**2 + 2*x1**2 - 4*x1**2*x2 + 4*x1**2*x2**2 )
      e0 = e0 + PLI1(1)**2*rtree1 * ( 2 - 4*x2 + 4*x2**2 - 4*x1 + 8*x1*
     &    x2 - 8*x1*x2**2 + 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
      e0 = e0 + PLI1(1)*PLI1(2)*rtree2 * ( 2 - 4*x2 + 4*x2**2 - 4*x1 + 
     &    8*x1*x2 - 8*x1*x2**2 + 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
      e0 = e0 + PLI1(1)*PLI1(2)*rtree1 * ( 4 - 8*x2 + 8*x2**2 - 8*x1 + 
     &    16*x1*x2 - 16*x1*x2**2 + 8*x1**2 - 16*x1**2*x2 + 16*x1**2*
     &    x2**2 )
      e0 = e0 + PLI1(2)*rtree2 * (  - 1 + 16*x1**(-1)*x2 - 16*x1**(-1)*
     &    x2**2 - 2*x2*x1px2**(-1) - 2*x2 + 2*x2**2*x1px2**(-2) - x2**2
     &     + 8*x2**3*x1px2**(-1) - 2*x2**3 - 4*x2**4*x1px2**(-2) + 4*
     &    x2**4 - 6*x2**5*x1px2**(-1) + 2*x2**6*x1px2**(-2) + 16*x1*
     &    x2**(-1) - 2*x1 - 22*x1*x2 + 20*x1*x2**2 - 16*x1**2*x2**(-1)
     &     + 3*x1**2 + 20*x1**2*x2 - 17*x1**2*x2**2 - 2*x1**3 + 2*x1**3
     &    *x2 )
      e0 = e0 + PLI1(2)*rtree1 * (  - 2 + 32*x1**(-1)*x2 - 32*x1**(-1)*
     &    x2**2 - 4*x2*x1px2**(-1) - 4*x2 + 4*x2**2*x1px2**(-2) - 2*
     &    x2**2 + 16*x2**3*x1px2**(-1) - 4*x2**3 - 8*x2**4*x1px2**(-2)
     &     + 8*x2**4 - 12*x2**5*x1px2**(-1) + 4*x2**6*x1px2**(-2) + 32*
     &    x1*x2**(-1) - 4*x1 - 44*x1*x2 + 40*x1*x2**2 - 32*x1**2*
     &    x2**(-1) + 6*x1**2 + 40*x1**2*x2 - 34*x1**2*x2**2 - 4*x1**3
     &     + 4*x1**3*x2 )
      e0 = e0 + PLI1(2)*dls12*rtree2 * (  - 2 + 4*x2 - 4*x2**2 + 4*x1
     &     - 8*x1*x2 + 8*x1*x2**2 - 4*x1**2 + 8*x1**2*x2 - 8*x1**2*
     &    x2**2 )
      e0 = e0 + PLI1(2)*dls12*rtree1 * (  - 4 + 8*x2 - 8*x2**2 + 8*x1
     &     - 16*x1*x2 + 16*x1*x2**2 - 8*x1**2 + 16*x1**2*x2 - 16*x1**2*
     &    x2**2 )
      e0 = e0 + PLI1(2)*dlmuF*rtree2 * ( 2 - 4*x2 + 4*x2**2 - 4*x1 + 8*
     &    x1*x2 - 8*x1*x2**2 + 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
      e0 = e0 + PLI1(2)*dlmuF*rtree1 * ( 4 - 8*x2 + 8*x2**2 - 8*x1 + 16
     &    *x1*x2 - 16*x1*x2**2 + 8*x1**2 - 16*x1**2*x2 + 16*x1**2*x2**2
     &     )
      e0 = e0 + PLI1(2)**2*rtree2 * ( 1 - 2*x2 + 2*x2**2 - 2*x1 + 4*x1*
     &    x2 - 4*x1*x2**2 + 2*x1**2 - 4*x1**2*x2 + 4*x1**2*x2**2 )
      e0 = e0 + PLI1(2)**2*rtree1 * ( 2 - 4*x2 + 4*x2**2 - 4*x1 + 8*x1*
     &    x2 - 8*x1*x2**2 + 4*x1**2 - 8*x1**2*x2 + 8*x1**2*x2**2 )
        elseif(ipole.eq.-1)then
          e0 =  0
        elseif(ipole.eq.-2)then
          e0 =  0
        elseif(ipole.eq.-3)then
          e0 =  0
        elseif(ipole.eq.-4)then
          e0 =  0
        endif
      endif
      ggCt0g2XU = ggCt0g2XU - bino(iix,partons,-e0)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      rtree1=0d0
      rtree2=0d0
      end do
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      return
      end
