************************************************************************
*
* four gluon one loop matrix elements interfered with tree level
*
*                      g  g  g  g
*
* summed over colour orderings, summed and squared
*
      function FullA4g1(ig1,ig2,ig3,ig4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)

c      write(*,*)" hello FullA4g1"
      fac=(as*nc/2d0/pi)*(4d0*pi*as*nc)**2*(nc**2-1d0)*2d0

      FullA4g1=               +A4g1X(ig1,ig2,ig3,ig4,renscale2)
     .                        +A4g1X(ig1,ig2,ig4,ig3,renscale2)
     .                        +A4g1Y(ig1,ig3,ig2,ig4,renscale2)
     .       +dble(nf)/dble(nc)*Ah4g1X(ig1,ig2,ig3,ig4,renscale2)
     .       +dble(nf)/dble(nc)*Ah4g1X(ig1,ig2,ig4,ig3,renscale2)
     .       +dble(nf)/dble(nc)*Ah4g1Y(ig1,ig3,ig2,ig4,renscale2)


      FullA4g1=fac*FullA4g1

*c      write(*,*)"FullA4g1",FullA4g1
      return
      end
*
*
************************************************************************
*
      function A4g1(ig1,ig2,ig3,ig4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((ig1.eq.1).and.(ig2.eq.2).and.(ig3.eq.3).and.(ig4.eq.4))then
        A4g1=A4g1X(ig1,ig2,ig3,ig4,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.2).and.(ig3.eq.4).and.(ig4.eq.3))then
        A4g1=A4g1X(ig1,ig2,ig3,ig4,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.3).and.(ig3.eq.2).and.(ig4.eq.4))then
        A4g1=A4g1Y(ig1,ig2,ig3,ig4,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.3).and.(ig3.eq.4).and.(ig4.eq.2))then
        A4g1=A4g1X(ig1,ig4,ig3,ig2,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.4).and.(ig3.eq.2).and.(ig4.eq.3))then
        A4g1=A4g1Y(ig1,ig4,ig3,ig2,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.4).and.(ig3.eq.3).and.(ig4.eq.2))then
        A4g1=A4g1X(ig1,ig4,ig3,ig2,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.1).and.(ig3.eq.3).and.(ig4.eq.4))then
        A4g1=A4g1X(ig2,ig1,ig4,ig3,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.1).and.(ig3.eq.4).and.(ig4.eq.3))then
        A4g1=A4g1X(ig2,ig1,ig4,ig3,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.3).and.(ig3.eq.1).and.(ig4.eq.4))then
        A4g1=A4g1Y(ig3,ig2,ig1,ig4,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.3).and.(ig3.eq.4).and.(ig4.eq.1))then
        A4g1=A4g1X(ig4,ig1,ig2,ig3,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.4).and.(ig3.eq.1).and.(ig4.eq.3))then
        A4g1=A4g1Y(ig3,ig4,ig1,ig2,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.4).and.(ig3.eq.3).and.(ig4.eq.1))then
        A4g1=A4g1X(ig4,ig1,ig2,ig3,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.1).and.(ig3.eq.2).and.(ig4.eq.4))then
        A4g1=A4g1X(ig2,ig3,ig4,ig1,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.1).and.(ig3.eq.4).and.(ig4.eq.2))then
        A4g1=A4g1Y(ig2,ig3,ig4,ig1,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.2).and.(ig3.eq.1).and.(ig4.eq.4))then
        A4g1=A4g1X(ig3,ig2,ig1,ig4,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.2).and.(ig3.eq.4).and.(ig4.eq.1))then
        A4g1=A4g1Y(ig4,ig3,ig2,ig1,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.4).and.(ig3.eq.1).and.(ig4.eq.2))then
        A4g1=A4g1X(ig3,ig4,ig1,ig2,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.4).and.(ig3.eq.2).and.(ig4.eq.1))then
        A4g1=A4g1X(ig4,ig3,ig2,ig1,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.1).and.(ig3.eq.2).and.(ig4.eq.3))then
        A4g1=A4g1X(ig2,ig3,ig4,ig1,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.1).and.(ig3.eq.3).and.(ig4.eq.2))then
        A4g1=A4g1Y(ig2,ig3,ig4,ig1,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.2).and.(ig3.eq.1).and.(ig4.eq.3))then
        A4g1=A4g1X(ig3,ig2,ig1,ig4,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.2).and.(ig3.eq.3).and.(ig4.eq.1))then
        A4g1=A4g1Y(ig4,ig3,ig2,ig1,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.3).and.(ig3.eq.1).and.(ig4.eq.2))then
        A4g1=A4g1X(ig3,ig4,ig1,ig2,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.3).and.(ig3.eq.2).and.(ig4.eq.1))then
        A4g1=A4g1X(ig4,ig3,ig2,ig1,renscale2)
      endif
      return
      end
*
*
************************************************************************
*
      function Ah4g1(ig1,ig2,ig3,ig4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)

      if((ig1.eq.1).and.(ig2.eq.2).and.(ig3.eq.3).and.(ig4.eq.4))then
        Ah4g1=Ah4g1X(ig1,ig2,ig3,ig4,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.2).and.(ig3.eq.4).and.(ig4.eq.3))then
        Ah4g1=Ah4g1X(ig1,ig2,ig3,ig4,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.3).and.(ig3.eq.2).and.(ig4.eq.4))then
        Ah4g1=Ah4g1Y(ig1,ig2,ig3,ig4,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.3).and.(ig3.eq.4).and.(ig4.eq.2))then
        Ah4g1=Ah4g1X(ig1,ig4,ig3,ig2,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.4).and.(ig3.eq.2).and.(ig4.eq.3))then
        Ah4g1=Ah4g1Y(ig1,ig4,ig3,ig2,renscale2)
      elseif((ig1.eq.1).and.(ig2.eq.4).and.(ig3.eq.3).and.(ig4.eq.2))then
        Ah4g1=Ah4g1X(ig1,ig4,ig3,ig2,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.1).and.(ig3.eq.3).and.(ig4.eq.4))then
        Ah4g1=Ah4g1X(ig2,ig1,ig4,ig3,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.1).and.(ig3.eq.4).and.(ig4.eq.3))then
        Ah4g1=Ah4g1X(ig2,ig1,ig4,ig3,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.3).and.(ig3.eq.1).and.(ig4.eq.4))then
        Ah4g1=Ah4g1Y(ig3,ig2,ig1,ig4,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.3).and.(ig3.eq.4).and.(ig4.eq.1))then
        Ah4g1=Ah4g1X(ig4,ig1,ig2,ig3,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.4).and.(ig3.eq.1).and.(ig4.eq.3))then
        Ah4g1=Ah4g1Y(ig3,ig4,ig1,ig2,renscale2)
      elseif((ig1.eq.2).and.(ig2.eq.4).and.(ig3.eq.3).and.(ig4.eq.1))then
        Ah4g1=Ah4g1X(ig4,ig1,ig2,ig3,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.1).and.(ig3.eq.2).and.(ig4.eq.4))then
        Ah4g1=Ah4g1X(ig2,ig3,ig4,ig1,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.1).and.(ig3.eq.4).and.(ig4.eq.2))then
        Ah4g1=Ah4g1Y(ig2,ig3,ig4,ig1,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.2).and.(ig3.eq.1).and.(ig4.eq.4))then
        Ah4g1=Ah4g1X(ig3,ig2,ig1,ig4,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.2).and.(ig3.eq.4).and.(ig4.eq.1))then
        Ah4g1=Ah4g1Y(ig4,ig3,ig2,ig1,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.4).and.(ig3.eq.1).and.(ig4.eq.2))then
        Ah4g1=Ah4g1X(ig3,ig4,ig1,ig2,renscale2)
      elseif((ig1.eq.3).and.(ig2.eq.4).and.(ig3.eq.2).and.(ig4.eq.1))then
        Ah4g1=Ah4g1X(ig4,ig3,ig2,ig1,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.1).and.(ig3.eq.2).and.(ig4.eq.3))then
        Ah4g1=Ah4g1X(ig2,ig3,ig4,ig1,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.1).and.(ig3.eq.3).and.(ig4.eq.2))then
        Ah4g1=Ah4g1Y(ig2,ig3,ig4,ig1,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.2).and.(ig3.eq.1).and.(ig4.eq.3))then
        Ah4g1=Ah4g1X(ig3,ig2,ig1,ig4,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.2).and.(ig3.eq.3).and.(ig4.eq.1))then
        Ah4g1=Ah4g1Y(ig4,ig3,ig2,ig1,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.3).and.(ig3.eq.1).and.(ig4.eq.2))then
        Ah4g1=Ah4g1X(ig3,ig4,ig1,ig2,renscale2)
      elseif((ig1.eq.4).and.(ig2.eq.3).and.(ig3.eq.2).and.(ig4.eq.1))then
        Ah4g1=Ah4g1X(ig4,ig3,ig2,ig1,renscale2)
      endif
      return
      end
*

************************************************************************
*
      function A4g1X(ig1,ig2,ig3,ig4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(ig1,ig2)
      s23 =s4(ig2,ig3)
      s13 =s4(ig1,ig3)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      A4g1X =  - 48.D0 - 16.D0*s12**(-2)*s23**2 - 32.D0*s12**(-1)*s23
     &     - 32.D0*s12*s23**(-1) - 16.D0*s12**2*s23**(-2)

      elseif(ieorder.eq.-1)then
      A4g1X =  + dls * ( 48.D0 + 16.D0*s12**(-2)*s23**2 + 32.D0*
     &    s12**(-1)*s23 + 32.D0*s12*s23**(-1) + 16.D0*s12**2*s23**(-2)
     &     )
      A4g1X = A4g1X + dlx * ( 24.D0 + 8.D0*s12**(-2)*s23**2 + 16.D0*
     &    s12**(-1)*s23 + 16.D0*s12*s23**(-1) + 8.D0*s12**2*s23**(-2) )
      A4g1X = A4g1X - 88.D0 - 88.D0/3.D0*s12**(-2)*s23**2 - 176.D0/3.D0
     &    *s12**(-1)*s23 - 176.D0/3.D0*s12*s23**(-1) - 88.D0/3.D0*
     &    s12**2*s23**(-2)

      elseif(ieorder.eq.0)then
      A4g1X =  + pi**2 * ( 16.D0 + 16.D0/3.D0*s12**(-2)*s23**2 + 32.D0/
     &    3.D0*s12**(-1)*s23 + 32.D0/3.D0*s12*s23**(-1) + 16.D0/3.D0*
     &    s12**2*s23**(-2) )
      A4g1X = A4g1X + dls * ( 44.D0 + 44.D0/3.D0*s12**(-2)*s23**2 + 88.D
     &    0/3.D0*s12**(-1)*s23 + 88.D0/3.D0*s12*s23**(-1) + 44.D0/3.D0*
     &    s12**2*s23**(-2) )
      A4g1X = A4g1X + dls**2 * (  - 24.D0 - 8.D0*s12**(-2)*s23**2 - 16.D
     &    0*s12**(-1)*s23 - 16.D0*s12*s23**(-1) - 8.D0*s12**2*s23**(-2)
     &     )
      A4g1X = A4g1X + dlx * ( 22.D0 + 28.D0/3.D0*s12**(-1)*s23 + 20.D0*
     &    s12*s23**(-1) + 44.D0/3.D0*s12**2*s23**(-2) )
      A4g1X = A4g1X + dlx*dls * (  - 24.D0 - 8.D0*s12**(-2)*s23**2 - 16.
     &    D0*s12**(-1)*s23 - 16.D0*s12*s23**(-1) - 8.D0*s12**2*
     &    s23**(-2) )
      A4g1X = A4g1X + dlx**2 * (  - 6.D0 - 4.D0*s12**(-1)*s23 - 4.D0*
     &    s12*s23**(-1) )
      A4g1X = A4g1X - 280.D0/3.D0 - 268.D0/9.D0*s12**(-2)*s23**2 - 554.D
     &    0/9.D0*s12**(-1)*s23 - 554.D0/9.D0*s12*s23**(-1) - 268.D0/9.D0
     &    *s12**2*s23**(-2)

      endif
      return
      end
************************************************************************
*
      function A4g1Y(ig1,ig2,ig3,ig4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(ig1,ig3)
      s23 =s4(ig2,ig3)
      s13 =s4(ig1,ig2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      A4g1Y =  - 32.D0 - 16.D0*s13**(-2)*s23**2 - 32.D0*s13**(-1)*s23
     &     - 16.D0*s12**2*s23**(-2)

      elseif(ieorder.eq.-1)then
      A4g1Y =  + dls * ( 32.D0 + 16.D0*s13**(-2)*s23**2 + 32.D0*
     &    s13**(-1)*s23 + 16.D0*s12**2*s23**(-2) )
      A4g1Y = A4g1Y + dlomx * ( 16.D0 + 8.D0*s13**(-2)*s23**2 + 16.D0*
     &    s13**(-1)*s23 + 8.D0*s12**2*s23**(-2) )
      A4g1Y = A4g1Y + dlx * ( 16.D0 + 8.D0*s13**(-2)*s23**2 + 16.D0*
     &    s13**(-1)*s23 + 8.D0*s12**2*s23**(-2) )
      A4g1Y = A4g1Y - 176.D0/3.D0 - 88.D0/3.D0*s13**(-2)*s23**2 - 176.D0
     &    /3.D0*s13**(-1)*s23 - 88.D0/3.D0*s12**2*s23**(-2)

      elseif(ieorder.eq.0)then
      A4g1Y =  + pi**2 * ( 26.D0/3.D0 + 16.D0/3.D0*s13**(-2)*s23**2 +
     &    20.D0/3.D0*s13**(-1)*s23 + 4.D0*s12*s23**(-1) + 16.D0/3.D0*
     &    s12**2*s23**(-2) )
      A4g1Y = A4g1Y + dls * ( 88.D0/3.D0 + 44.D0/3.D0*s13**(-2)*s23**2
     &     + 88.D0/3.D0*s13**(-1)*s23 + 44.D0/3.D0*s12**2*s23**(-2) )
      A4g1Y = A4g1Y + dls**2 * (  - 16.D0 - 8.D0*s13**(-2)*s23**2 - 16.D
     &    0*s13**(-1)*s23 - 8.D0*s12**2*s23**(-2) )
      A4g1Y = A4g1Y + dlomx * ( 38.D0/3.D0 + 44.D0/3.D0*s13**(-2)*
     &    s23**2 + 20.D0*s13**(-1)*s23 - 28.D0/3.D0*s12*s23**(-1) )
      A4g1Y = A4g1Y + dlomx*dls * (  - 16.D0 - 8.D0*s13**(-2)*s23**2 -
     &    16.D0*s13**(-1)*s23 - 8.D0*s12**2*s23**(-2) )
      A4g1Y = A4g1Y + dlomx**2 * (  - 2.D0 - 4.D0*s13**(-1)*s23 + 4.D0*
     &    s12*s23**(-1) )
      A4g1Y = A4g1Y + dlx * ( 50.D0/3.D0 + 28.D0/3.D0*s13**(-1)*s23 +
     &    28.D0/3.D0*s12*s23**(-1) + 44.D0/3.D0*s12**2*s23**(-2) )
      A4g1Y = A4g1Y + dlx*dls * (  - 16.D0 - 8.D0*s13**(-2)*s23**2 - 16.
     &    D0*s13**(-1)*s23 - 8.D0*s12**2*s23**(-2) )
      A4g1Y = A4g1Y + dlx*dlomx * (  - 12.D0 - 8.D0*s13**(-2)*s23**2 -
     &    8.D0*s13**(-1)*s23 - 8.D0*s12*s23**(-1) - 8.D0*s12**2*
     &    s23**(-2) )
      A4g1Y = A4g1Y + dlx**2 * (  - 2.D0 - 4.D0*s13**(-1)*s23 + 4.D0*
     &    s12*s23**(-1) )
      A4g1Y = A4g1Y - 554.D0/9.D0 - 268.D0/9.D0*s13**(-2)*s23**2 - 554.D
     &    0/9.D0*s13**(-1)*s23 + 2.D0*s12*s23**(-1) - 268.D0/9.D0*
     &    s12**2*s23**(-2)

      endif
      return
      end
************************************************************************
*
      function Ah4g1X(ig1,ig2,ig3,ig4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(ig1,ig2)
      s23 =s4(ig2,ig3)
      s13 =s4(ig1,ig3)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Ah4g1X =  0

      elseif(ieorder.eq.-1)then
      Ah4g1X =  + 16.D0 + 16.D0/3.D0*s12**(-2)*s23**2 + 32.D0/3.D0*
     &    s12**(-1)*s23 + 32.D0/3.D0*s12*s23**(-1) + 16.D0/3.D0*s12**2*
     &    s23**(-2)

      elseif(ieorder.eq.0)then
      Ah4g1X =  + dls * (  - 8.D0 - 8.D0/3.D0*s12**(-2)*s23**2 - 16.D0/
     &    3.D0*s12**(-1)*s23 - 16.D0/3.D0*s12*s23**(-1) - 8.D0/3.D0*
     &    s12**2*s23**(-2) )
      Ah4g1X = Ah4g1X + dlx * (  - 4.D0 - 10.D0/3.D0*s12**(-1)*s23 - 2.D
     &    0*s12*s23**(-1) - 8.D0/3.D0*s12**2*s23**(-2) )
      Ah4g1X = Ah4g1X + dlx**2 * ( s12**(-1)*s23 + s12*s23**(-1) )
      Ah4g1X = Ah4g1X + 52.D0/3.D0 + 40.D0/9.D0*s12**(-2)*s23**2 + 98.D0
     &    /9.D0*s12**(-1)*s23 + 98.D0/9.D0*s12*s23**(-1) + 40.D0/9.D0*
     &    s12**2*s23**(-2)

      endif
      return
      end
************************************************************************
*
      function Ah4g1Y(ig1,ig2,ig3,ig4,renscale2)
      use KinData_mod
      implicit double precision (a-h,o-z)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      common /order/ieorder
      s12 =s4(ig1,ig3)
      s23 =s4(ig2,ig3)
      s13 =s4(ig1,ig2)
      dlx   =log(-s23/s12)
      dlomx =log(-s13/s12)
      dls =log(s12/renscale2)
      if(ieorder.eq.-2)then
      Ah4g1Y =  0

      elseif(ieorder.eq.-1)then
      Ah4g1Y =  + 32.D0/3.D0 + 16.D0/3.D0*s13**(-2)*s23**2 + 32.D0/3.D0
     &    *s13**(-1)*s23 + 16.D0/3.D0*s12**2*s23**(-2)

      elseif(ieorder.eq.0)then
      Ah4g1Y =  + pi**2 * (  - 1.D0 + s13**(-1)*s23 - s12*s23**(-1) )
      Ah4g1Y = Ah4g1Y + dls * (  - 16.D0/3.D0 - 8.D0/3.D0*s13**(-2)*
     &    s23**2 - 16.D0/3.D0*s13**(-1)*s23 - 8.D0/3.D0*s12**2*
     &    s23**(-2) )
      Ah4g1Y = Ah4g1Y + dlomx * (  - 2.D0/3.D0 - 8.D0/3.D0*s13**(-2)*
     &    s23**2 - 2.D0*s13**(-1)*s23 + 10.D0/3.D0*s12*s23**(-1) )
      Ah4g1Y = Ah4g1Y + dlomx**2 * (  - 1.D0 + s13**(-1)*s23 - s12*
     &    s23**(-1) )
      Ah4g1Y = Ah4g1Y + dlx * (  - 14.D0/3.D0 - 10.D0/3.D0*s13**(-1)*
     &    s23 - 10.D0/3.D0*s12*s23**(-1) - 8.D0/3.D0*s12**2*s23**(-2) )
      Ah4g1Y = Ah4g1Y + dlx*dlomx * ( 2.D0 - 2.D0*s13**(-1)*s23 + 2.D0*
     &    s12*s23**(-1) )
      Ah4g1Y = Ah4g1Y + dlx**2 * (  - 1.D0 + s13**(-1)*s23 - s12*
     &    s23**(-1) )
      Ah4g1Y = Ah4g1Y + 98.D0/9.D0 + 40.D0/9.D0*s13**(-2)*s23**2 + 98.D0
     &    /9.D0*s13**(-1)*s23 - 2.D0*s12*s23**(-1) + 40.D0/9.D0*s12**2*
     &    s23**(-2)

      endif
      return
      end
