************************************************************************
*
*  generated using makefortRR on 2025-02-16
*
      function qgtoqgC2g0S(i1,i2,i3,i4,i5,i6)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      dimension wt(150)
      double precision partons(nMax_scl)
      double precision facnorm(nMax_scl)
      dimension jpass(150)
*      write(*,*)" hello qgtoqgC2g0S"

      ix=1

      wt=0d0
      partons=0d0
      facnorm=0d0
      jpass=0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i5 = j5, [i2] = j2, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i2,i4,i6/), (/i1,i2,i6,i3,i5/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(1)=1
        call set_flav_perm(5, (/ j3,j2,j1,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(1)=+1d0/2d0*gd30IF(i4,i6,i2,6)*C1g01(j3,j2,j1,j4,j5)
        wt(1)=bino(ix,partons,-wt(1)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i6] = j3, [i5, i6] = j4, [i6, i3] = j3, [i6, i5] = j4}
      call set_map(6,5, (/i3,i6,i5/), (/i1,i2,i3,i5,i4/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(2)=1
        call set_flav_perm(5, (/ j5,j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(2)=+1d0/2d0*FullA30FF(i3,i6,i5,6)*C1g01(j5,j2,j1,j3,j4)
        wt(2)=bino(ix,partons,-wt(2)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, i5 = j5, [i2] = j2, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i2,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(3)=1
        call set_flav_perm(5, (/ j3,j2,j5,j4,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(3)=+1d0/2d0*gd30IF(i3,i6,i2,6)*C1g01(j3,j2,j5,j4,j1)
        wt(3)=bino(ix,partons,-wt(3)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(4)=1
        call set_flav_perm(5, (/ j4,j2,j1,j3,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(4)=+1d0/2d0*FullqgD30II(i1,i6,i2,6)*C1g01(j4,j2,j1,j3,j5)
        wt(4)=bino(ix,partons,-wt(4)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i5 = j5, [i1] = j1, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i1,i4,i6/), (/i1,i2,i6,i3,i5/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(5)=1
        call set_flav_perm(5, (/ j4,j2,j5,j3,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(5)=+1d0/2d0*FullqA30IF(i4,i6,i1,6)*C1g01(j4,j2,j5,j3,j1)
        wt(5)=bino(ix,partons,-wt(5)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i4 = j5, [i2] = j2, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i2,i5,i6/), (/i1,i2,i6,i3,i4/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(6)=1
        call set_flav_perm(5, (/ j4,j2,j3,j5,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(6)=+1d0/2d0*gd30IF(i5,i6,i2,6)*C1g01(j4,j2,j3,j5,j1)
        wt(6)=bino(ix,partons,-wt(6)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(7)=1
        call set_flav_perm(5, (/ j3,j4,j5,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(7)=+1d0/4d0*FullE30FF(i3,i5,i4,6)*B3g0(j3,j4,j5,j2,j1)
        wt(7)=bino(ix,partons,-wt(7)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i4, i6] = j3, [i5, i4] = j4, [i6, i4] = j3}
      call set_map(6,5, (/i6,i4,i5/), (/i1,i2,i6,i5,i3/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(8)=1
        call set_flav_perm(5, (/ j5,j4,j3,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(8)=+1d0/4d0*FullG30FF(i6,i4,i5,6)*B3g0(j5,j4,j3,j2,j1)
        wt(8)=bino(ix,partons,-wt(8)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(9)=1
        call set_flav_perm(5, (/ j5,j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(9)=+1d0/4d0*FullG30FF(i6,i5,i4,6)*B3g0(j5,j3,j4,j2,j1)
        wt(9)=bino(ix,partons,-wt(9)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(10)=1
        call set_flav_perm(5, (/ j4,j5,j3,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(10)=+1d0/4d0*FullgG30IF(i2,i4,i5,6)*B3g0(j4,j5,j3,j2,j1)
        wt(10)=bino(ix,partons,-wt(10)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(11)=1
        call set_flav_perm(5, (/ j4,j5,j2,j3,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(11)=+1d0/4d0*FullgG30IF(i2,i5,i4,6)*B3g0(j4,j5,j2,j3,j1)
        wt(11)=bino(ix,partons,-wt(11)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(12)=1
        call set_flav_perm(5, (/ j4,j5,j2,j3,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(12)=+1d0/4d0*FullqE30IF(i1,i4,i5,6)*B3g0(j4,j5,j2,j3,j1)
        wt(12)=bino(ix,partons,-wt(12)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(13)=1
        call set_flav_perm(5, (/ j3,j4,j2,j5,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(13)=+1d0/4d0*FullE30FF(i3,i5,i4,6)*B3g0(j3,j4,j2,j5,j1)
        wt(13)=bino(ix,partons,-wt(13)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(14)=1
        call set_flav_perm(5, (/ j4,j3,j2,j5,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(14)=+1d0/4d0*FullgG30IF(i2,i4,i5,6)*B3g0(j4,j3,j2,j5,j1)
        wt(14)=bino(ix,partons,-wt(14)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(15)=1
        call set_flav_perm(5, (/ j4,j2,j3,j5,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(15)=+1d0/4d0*FullgG30IF(i2,i5,i4,6)*B3g0(j4,j2,j3,j5,j1)
        wt(15)=bino(ix,partons,-wt(15)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i4, i6] = j3, [i5, i4] = j4, [i6, i4] = j3}
      call set_map(6,5, (/i6,i4,i5/), (/i1,i2,i6,i5,i3/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(16)=1
        call set_flav_perm(5, (/ j5,j2,j4,j3,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(16)=+1d0/4d0*FullG30FF(i6,i4,i5,6)*B3g0(j5,j2,j4,j3,j1)
        wt(16)=bino(ix,partons,-wt(16)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(17)=1
        call set_flav_perm(5, (/ j5,j2,j3,j4,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(17)=+1d0/4d0*FullG30FF(i6,i5,i4,6)*B3g0(j5,j2,j3,j4,j1)
        wt(17)=bino(ix,partons,-wt(17)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(18)=1
        call set_flav_perm(5, (/ j4,j2,j5,j3,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(18)=+1d0/4d0*FullqE30IF(i1,i4,i5,6)*B3g0(j4,j2,j5,j3,j1)
        wt(18)=bino(ix,partons,-wt(18)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(19)=1
        call set_flav_perm(5, (/ j3,j5,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(19)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*B3g0(j3,j5,j2,j1,j4)
        wt(19)=bino(ix,partons,-wt(19)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(20)=1
        call set_flav_perm(5, (/ j3,j2,j1,j5,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(20)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*B3g0(j3,j2,j1,j5,j4)
        wt(20)=bino(ix,partons,-wt(20)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(21)=1
        call set_flav_perm(5, (/ j3,j1,j5,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(21)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*B3g0(j3,j1,j5,j2,j4)
        wt(21)=bino(ix,partons,-wt(21)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(22)=1
        call set_flav_perm(5, (/ j3,j2,j5,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(22)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*B3g0(j3,j2,j5,j1,j4)
        wt(22)=bino(ix,partons,-wt(22)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(23)=1
        call set_flav_perm(5, (/ j3,j5,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(23)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*B3g0(j3,j5,j1,j2,j4)
        wt(23)=bino(ix,partons,-wt(23)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(24)=1
        call set_flav_perm(5, (/ j3,j1,j2,j5,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(24)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*B3g0(j3,j1,j2,j5,j4)
        wt(24)=bino(ix,partons,-wt(24)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(25)=1
        call set_flav_perm(5, (/ j2,j5,j4,j3,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(25)=-1d0/2d0*FullqgA30II(i3,i2,i1,6)*C1g01(j2,j5,j4,j3,j1)
        wt(25)=bino(ix,partons,-wt(25)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(26)=1
        call set_flav_perm(5, (/ j3,j5,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(26)=-1d0/2d0*FullqgA30II(i3,i2,i1,6)*C1g01(j3,j5,j1,j2,j4)
        wt(26)=bino(ix,partons,-wt(26)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(27)=1
        call set_flav_perm(5, (/ j2,j5,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(27)=-1d0/2d0*FullqgA30II(i4,i2,i1,6)*C1g01(j2,j5,j1,j3,j4)
        wt(27)=bino(ix,partons,-wt(27)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(28)=1
        call set_flav_perm(5, (/ j3,j5,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(28)=-1d0/2d0*FullqgA30II(i4,i2,i1,6)*C1g01(j3,j5,j4,j2,j1)
        wt(28)=bino(ix,partons,-wt(28)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(29)=1
        call set_flav_perm(5, (/ j4,j5,j1,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(29)=-1d0/2d0*FullqgA30II(i5,i2,i1,6)*C1g01(j4,j5,j1,j3,j2)
        wt(29)=bino(ix,partons,-wt(29)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        jpass(30)=1
        call set_flav_perm(5, (/ j3,j5,j2,j4,j1 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(30)=-1d0/2d0*FullqgA30II(i5,i2,i1,6)*C1g01(j3,j5,j2,j4,j1)
        wt(30)=bino(ix,partons,-wt(30)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = k1, i2 = k2, [i3, i5, i4] = k3, [i4, i5, i3] = k3, [i5, i4, i6] = k4, [i6, i4, i5] = k4}
      call set_map(6,4, (/i3,i5,i4,i6/), (/i1,i2,i3,i6/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(31)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(31)=+1d0/2d0*E40a(i3,i5,i4,i6,6)*B2g0(k3,k4,k2,k1)
        wt(31)=bino(ix,partons,-wt(31)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i4, i6] = j3, [i5, i4] = j4, [i6, i4] = j3}
      call set_map(6,5, (/i6,i4,i5/), (/i1,i2,i6,i5,i3/), ipass)
* FF: {j1 = k1, j2 = k2, [j3, j4] = k4, [j4, j3] = k4, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j5,j4,j3/), (/j1,j2,j5,j3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(32)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(32)=-1d0/4d0*FullG30FF(i6,i4,i5,6)*d30FF(j5,j4,j3,5)*B2g0(k3,k4,k2,k1)
        wt(32)=bino(ix,partons,-wt(32)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* FF: {j1 = k1, j2 = k2, [j3, j4] = k3, [j4, j3] = k3, [j4, j5] = k4, [j5, j4] = k4}
      call set_map(5,4, (/j3,j4,j5/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(33)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(33)=-1d0/4d0*FullE30FF(i3,i5,i4,6)*d30FF(j3,j4,j5,5)*B2g0(k3,k4,k2,k1)
        wt(33)=bino(ix,partons,-wt(33)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = k1, i2 = k2, [i3, i6, i4] = k3, [i4, i6, i3] = k3, [i5, i4, i6] = k4, [i6, i4, i5] = k4}
      call set_map(6,4, (/i3,i6,i4,i5/), (/i1,i2,i3,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(34)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(34)=+1d0/2d0*E40b(i3,i6,i4,i5,6)*B2g0(k3,k4,k2,k1)
        wt(34)=bino(ix,partons,-wt(34)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i6] = j3, [i4, i6] = j4, [i6, i3] = j3, [i6, i4] = j4}
      call set_map(6,5, (/i3,i6,i4/), (/i1,i2,i3,i4,i5/), ipass)
* FF: {j1 = k1, j2 = k2, [j3, j4] = k3, [j4, j3] = k3, [j4, j5] = k4, [j5, j4] = k4}
      call set_map(5,4, (/j3,j4,j5/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(35)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(35)=-1d0/2d0*FullA30FF(i3,i6,i4,6)*FullE30FF(j3,j4,j5,5)*B2g0(k3,k4,k2,k1)
        wt(35)=bino(ix,partons,-wt(35)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
* FF: {j1 = k1, j2 = k2, [j3, j4] = k4, [j3, j5] = k3, [j4, j3] = k4, [j5, j3] = k3}
      call set_map(5,4, (/j5,j3,j4/), (/j1,j2,j5,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(36)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(36)=-1d0/4d0*FullG30FF(i6,i5,i4,6)*d30FF(j5,j3,j4,5)*B2g0(k3,k4,k2,k1)
        wt(36)=bino(ix,partons,-wt(36)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* FF: {j1 = k1, j2 = k2, [j3, j5] = k3, [j4, j5] = k4, [j5, j3] = k3, [j5, j4] = k4}
      call set_map(5,4, (/j3,j5,j4/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(37)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(37)=-1d0/4d0*FullE30FF(i3,i5,i4,6)*d30FF(j3,j5,j4,5)*B2g0(k3,k4,k2,k1)
        wt(37)=bino(ix,partons,-wt(37)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, i5 = j5, [i2] = j2, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i2,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
* FF: {j1 = k1, j2 = k2, [j3, j5] = k3, [j4, j5] = k4, [j5, j3] = k3, [j5, j4] = k4}
      call set_map(5,4, (/j3,j5,j4/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(38)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(38)=-1d0/4d0*gd30IF(i3,i6,i2,6)*FullE30FF(j3,j5,j4,5)*B2g0(k3,k4,k2,k1)
        wt(38)=bino(ix,partons,-wt(38)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, i5 = j5, [i1] = j1, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i1,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
* FF: {j1 = k1, j2 = k2, [j3, j5] = k3, [j4, j5] = k4, [j5, j3] = k3, [j5, j4] = k4}
      call set_map(5,4, (/j3,j5,j4/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(39)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(39)=+1d0/4d0*FullqA30IF(i1,i6,i3,6)*FullE30FF(j3,j5,j4,5)*B2g0(k3,k4,k2,k1)
        wt(39)=bino(ix,partons,-wt(39)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* IF: {j1 = k1, j4 = k4, [j2] = k2, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j2,j3,j5/), (/j1,j2,j5,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(40)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(40)=+1d0/4d0*FullE30FF(i3,i5,i4,6)*gd30IF(j3,j5,j2,5)*B2g0(k3,k4,k2,k1)
        wt(40)=bino(ix,partons,-wt(40)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i6] = j3, [i4, i6] = j4, [i6, i3] = j3, [i6, i4] = j4}
      call set_map(6,5, (/i3,i6,i4/), (/i1,i2,i3,i4,i5/), ipass)
      call fillson5FF(i1,i2,i3,i6,i4,i5,j1,j2,j3,j4,j5,6,ipass)
* FF: {j1 = k1, j2 = k2, [j3, j5] = k3, [j4, j5] = k4, [j5, j3] = k3, [j5, j4] = k4}
      call set_map(5,4, (/j3,j5,j4/), (/j1,j2,j3,j4/), ipass)
      call fillson4FF(j1,j2,j3,j5,j4,k1,k2,k3,k4,6,ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(41)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wtsoft=0d0
        wtsoft=wtsoft-1d0*SS1(k2,i6,k4,4,6)
        wtsoft=wtsoft+1d0*SS1(j1,i6,j2,5,6)
        wtsoft=wtsoft+1d0*SS1(k3,i6,k4,4,6)
        wtsoft=wtsoft-1d0*SS1(j1,i6,j3,5,6)
        wtsoft=wtsoft+1d0*SS1(j2,i6,j3,5,6)
        wtsoft=wtsoft-1d0*SS1(k2,i6,k3,4,6)
        wt(41)=+1d0/4d0*wtsoft*FullE30FF(j3,j5,j4,5)*B2g0(k3,k4,k2,k1)
        wt(41)=bino(ix,partons,-wt(41)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = k1, i3 = k4, [i2] = k2, [i4, i5, i6] = k3, [i4, i6, i5] = k3, [i5, i4, i6] = k3, [i5, i6, i4] = k3, [i6, i4, i5] = k3, [i6, i5, i4] = k3}
      call set_map(6,4, (/i2,i4,i5,i6/), (/i1,i2,i6,i3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(42)=1
        call set_flav_perm(4, (/ k4,k3,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(42)=+1d0/2d0*FullG40(i6,i5,i4,i2,6)*B2g0(k4,k3,k2,k1)
        wt(42)=bino(ix,partons,-wt(42)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i4 = j5, [i2] = j2, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i2,i5,i6/), (/i1,i2,i6,i3,i4/), ipass)
* IF: {j1 = k1, j4 = k4, [j2] = k2, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j2,j3,j5/), (/j1,j2,j5,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(43)=1
        call set_flav_perm(4, (/ k4,k3,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(43)=-1d0/2d0*gd30IF(i5,i6,i2,6)*FullgG30IF(j2,j3,j5,5)*B2g0(k4,k3,k2,k1)
        wt(43)=bino(ix,partons,-wt(43)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(44)=1
        call set_flav_perm(4, (/ k4,k3,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(44)=-1d0/4d0*FullG30FF(i6,i5,i4,6)*FullgF30IF(j3,j4,j2,5)*B2g0(k4,k3,k2,k1)
        wt(44)=bino(ix,partons,-wt(44)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j1 = k1, j4 = k4, [j2] = k2, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j2,j3,j5/), (/j1,j2,j5,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(45)=1
        call set_flav_perm(4, (/ k4,k3,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(45)=-1d0/4d0*FullgG30IF(i2,i4,i5,6)*FullgF30IF(j5,j3,j2,5)*B2g0(k4,k3,k2,k1)
        wt(45)=bino(ix,partons,-wt(45)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* IF: {j1 = k1, j3 = k4, [j2] = k2, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j2,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(46)=1
        call set_flav_perm(4, (/ k4,k3,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(46)=-1d0/2d0*FullqgA30II(i4,i2,i1,6)*FullqpG30IF(j5,j4,j2,5)*B2g0(k4,k3,k2,k1)
        wt(46)=bino(ix,partons,-wt(46)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j2 = k2, j3 = k4, [j1] = k1, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j1,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(47)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(47)=-1d0/4d0*FullgG30IF(i2,i4,i5,6)*FullqA30IF(j1,j5,j4,5)*B2g0(k3,k4,k2,k1)
        wt(47)=bino(ix,partons,-wt(47)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i6] = j3, [i5, i6] = j4, [i6, i3] = j3, [i6, i5] = j4}
      call set_map(6,5, (/i3,i6,i5/), (/i1,i2,i3,i5,i4/), ipass)
      call fillson5FF(i1,i2,i3,i6,i5,i4,j1,j2,j3,j4,j5,6,ipass)
* IF: {j1 = k1, j3 = k4, [j2] = k2, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j2,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call fillson4IF(j1,j2,j4,j5,j3,k1,k2,k3,k4,6,ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(48)=1
        call set_flav_perm(4, (/ k4,k3,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wtsoft=0d0
        wtsoft=wtsoft+1d0*SS1(k4,i6,k3,4,6)
        wtsoft=wtsoft-1d0*SS1(k2,i6,k3,4,6)
        wtsoft=wtsoft-1d0*SS1(j1,i6,j3,5,6)
        wtsoft=wtsoft+1d0*SS1(k1,i6,k2,4,6)
        wt(48)=-1d0/4d0*wtsoft*FullgG30IF(j2,j5,j4,5)*B2g0(k4,k3,k2,k1)
        wt(48)=bino(ix,partons,-wt(48)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = k3, i6 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i4,i5,i2/), (/i1,i2,i3,i6/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(49)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(49)=+1d0/2d0*FullE40(i1,i4,i5,i2,6)*B2g0(k3,k4,k2,k1)
        wt(49)=bino(ix,partons,-wt(49)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(50)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(50)=-1d0/4d0*FullqE30IF(i1,i4,i5,6)*FullqgD30II(j1,j3,j2,5)*B2g0(k3,k4,k2,k1)
        wt(50)=bino(ix,partons,-wt(50)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(51)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(51)=-1d0/4d0*FullgG30IF(i2,i5,i4,6)*FullqgD30II(j1,j3,j2,5)*B2g0(k3,k4,k2,k1)
        wt(51)=bino(ix,partons,-wt(51)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(52)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(52)=-1d0/2d0*FullqgA30II(i5,i2,i1,6)*FullqqpE30II(j1,j4,j2,5)*B2g0(k3,k4,k2,k1)
        wt(52)=bino(ix,partons,-wt(52)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = k1, i6 = k4, [i2] = k2, [i3, i4, i5] = k3, [i3, i5, i4] = k3, [i4, i3, i5] = k3, [i4, i5, i3] = k3, [i5, i3, i4] = k3, [i5, i4, i3] = k3}
      call set_map(6,4, (/i2,i3,i4,i5/), (/i1,i2,i5,i6/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(53)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(53)=+1d0/2d0*FullE40(i3,i5,i4,i2,6)*B2g0(k3,k2,k4,k1)
        wt(53)=bino(ix,partons,-wt(53)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(54)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(54)=-1d0/4d0*FullE30FF(i3,i5,i4,6)*FullgD30IF(j3,j4,j2,5)*B2g0(k3,k2,k4,k1)
        wt(54)=bino(ix,partons,-wt(54)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(55)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(55)=-1d0/4d0*FullgG30IF(i2,i5,i4,6)*FullgD30IF(j4,j3,j2,5)*B2g0(k3,k2,k4,k1)
        wt(55)=bino(ix,partons,-wt(55)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(56)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(56)=-1d0/2d0*FullqgA30II(i4,i2,i1,6)*FullqpE30IF(j3,j4,j2,5)*B2g0(k3,k2,k4,k1)
        wt(56)=bino(ix,partons,-wt(56)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(57)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(57)=-1d0/2d0*gd30IFGTOQ(i3,i2,i4,6)*FullqE30IF(j2,j4,j3,5)*B2g0(k3,k2,k4,k1)
        wt(57)=bino(ix,partons,-wt(57)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(58)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(58)=+1d0/4d0*FullE30FF(i3,i5,i4,6)*gd30IFGTOQ(j3,j2,j4,5)*B2g0(k3,k2,k4,k1)
        wt(58)=bino(ix,partons,-wt(58)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(59)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(59)=+1d0/4d0*FullgG30IF(i2,i4,i5,6)*gd30IFGTOQ(j4,j2,j3,5)*B2g0(k3,k2,k4,k1)
        wt(59)=bino(ix,partons,-wt(59)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(60)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(60)=-1d0/2d0*FullqE30IF(i1,i4,i5,6)*gd30IFGTOQ(j4,j2,j3,5)*B2g0(k3,k2,k4,k1)
        wt(60)=bino(ix,partons,-wt(60)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(61)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(61)=+1d0/2d0*gd30IFGTOQ(i3,i2,i4,6)*FullqE30IF(j1,j3,j4,5)*B2g0(k3,k2,k4,k1)
        wt(61)=bino(ix,partons,-wt(61)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = k1, i3 = k4, [i2] = k2, [i4, i5, i6] = k3, [i4, i6, i5] = k3, [i5, i4, i6] = k3, [i5, i6, i4] = k3, [i6, i4, i5] = k3, [i6, i5, i4] = k3}
      call set_map(6,4, (/i2,i4,i5,i6/), (/i1,i2,i6,i3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(62)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(62)=+1d0/2d0*FullG40(i2,i5,i4,i6,6)*B2g0(k4,k2,k3,k1)
        wt(62)=bino(ix,partons,-wt(62)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i5 = j5, [i2] = j2, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i2,i4,i6/), (/i1,i2,i6,i3,i5/), ipass)
* IF: {j1 = k1, j4 = k4, [j2] = k2, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j2,j3,j5/), (/j1,j2,j5,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(63)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(63)=-1d0/2d0*gd30IF(i4,i6,i2,6)*FullgG30IF(j2,j3,j5,5)*B2g0(k4,k2,k3,k1)
        wt(63)=bino(ix,partons,-wt(63)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j1 = k1, j4 = k4, [j2] = k2, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j2,j3,j5/), (/j1,j2,j5,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(64)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(64)=-1d0/4d0*FullgG30IF(i2,i5,i4,6)*FullgF30IF(j2,j3,j5,5)*B2g0(k4,k2,k3,k1)
        wt(64)=bino(ix,partons,-wt(64)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i4, i6] = j3, [i5, i4] = j4, [i6, i4] = j3}
      call set_map(6,5, (/i6,i4,i5/), (/i1,i2,i6,i5,i3/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(65)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(65)=-1d0/4d0*FullG30FF(i6,i4,i5,6)*FullgF30IF(j2,j4,j3,5)*B2g0(k4,k2,k3,k1)
        wt(65)=bino(ix,partons,-wt(65)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
* IF: {j1 = k1, j3 = k4, [j2] = k2, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j2,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(66)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(66)=-1d0/2d0*FullqgA30II(i5,i2,i1,6)*FullqpG30IF(j5,j2,j4,5)*B2g0(k4,k2,k3,k1)
        wt(66)=bino(ix,partons,-wt(66)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j2 = k2, j3 = k4, [j1] = k1, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j1,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(67)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(67)=-1d0/4d0*FullgG30IF(i2,i5,i4,6)*FullqA30IF(j1,j5,j4,5)*B2g0(k3,k2,k4,k1)
        wt(67)=bino(ix,partons,-wt(67)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i6] = j3, [i4, i6] = j4, [i6, i3] = j3, [i6, i4] = j4}
      call set_map(6,5, (/i3,i6,i4/), (/i1,i2,i3,i4,i5/), ipass)
      call fillson5FF(i1,i2,i3,i6,i4,i5,j1,j2,j3,j4,j5,6,ipass)
* IF: {j1 = k1, j3 = k4, [j2] = k2, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j2,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call fillson4IF(j1,j2,j4,j5,j3,k1,k2,k3,k4,6,ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(68)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wtsoft=0d0
        wtsoft=wtsoft+1d0*SS1(k2,i6,k4,4,6)
        wtsoft=wtsoft+1d0*SS1(k1,i6,k3,4,6)
        wtsoft=wtsoft-1d0*SS1(k2,i6,k3,4,6)
        wtsoft=wtsoft-1d0*SS1(j1,i6,j3,5,6)
        wt(68)=-1d0/4d0*wtsoft*FullgG30IF(j2,j5,j4,5)*B2g0(k4,k2,k3,k1)
        wt(68)=bino(ix,partons,-wt(68)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = k2, i3 = k4, [i1] = k1, [i4, i5, i6] = k3, [i4, i6, i5] = k3, [i5, i4, i6] = k3, [i5, i6, i4] = k3, [i6, i4, i5] = k3, [i6, i5, i4] = k3}
      call set_map(6,4, (/i1,i4,i5,i6/), (/i1,i2,i6,i3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(69)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(69)=+1d0/2d0*FullE40(i1,i4,i5,i6,6)*B2g0(k4,k2,k3,k1)
        wt(69)=bino(ix,partons,-wt(69)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i4 = j5, [i1] = j1, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i1,i5,i6/), (/i1,i2,i6,i3,i4/), ipass)
* IF: {j2 = k2, j4 = k4, [j1] = k1, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j1,j3,j5/), (/j1,j2,j5,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(70)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(70)=-1d0/2d0*FullqA30IF(i1,i6,i5,6)*FullqE30IF(j1,j5,j3,5)*B2g0(k4,k2,k3,k1)
        wt(70)=bino(ix,partons,-wt(70)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j2 = k2, j4 = k4, [j1] = k1, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j1,j3,j5/), (/j1,j2,j5,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(71)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(71)=-1d0/4d0*FullqE30IF(i1,i4,i5,6)*FullqD30IF(j1,j3,j5,5)*B2g0(k4,k2,k3,k1)
        wt(71)=bino(ix,partons,-wt(71)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(72)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(72)=-1d0/4d0*FullG30FF(i6,i5,i4,6)*FullqD30IF(j1,j4,j3,5)*B2g0(k4,k2,k3,k1)
        wt(72)=bino(ix,partons,-wt(72)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j2 = k2, j3 = k4, [j1] = k1, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j1,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(73)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(73)=+1d0/4d0*FullqE30IF(i1,i4,i5,6)*FullqA30IF(j1,j5,j4,5)*B2g0(k3,k2,k4,k1)
        wt(73)=bino(ix,partons,-wt(73)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i6] = j3, [i5, i6] = j4, [i6, i3] = j3, [i6, i5] = j4}
      call set_map(6,5, (/i3,i6,i5/), (/i1,i2,i3,i5,i4/), ipass)
      call fillson5FF(i1,i2,i3,i6,i5,i4,j1,j2,j3,j4,j5,6,ipass)
* IF: {j2 = k2, j3 = k4, [j1] = k1, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j1,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call fillson4IF(j2,j1,j4,j5,j3,k2,k1,k3,k4,6,ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(74)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wtsoft=0d0
        wtsoft=wtsoft-1d0*SS1(j2,i6,j3,5,6)
        wtsoft=wtsoft+1d0*SS1(k2,i6,k3,4,6)
        wtsoft=wtsoft-1d0*SS1(k1,i6,k3,4,6)
        wtsoft=wtsoft+1d0*SS1(k1,i6,k4,4,6)
        wt(74)=-1d0/4d0*wtsoft*FullqE30IF(j1,j5,j4,5)*B2g0(k4,k2,k3,k1)
        wt(74)=bino(ix,partons,-wt(74)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = k2, i6 = k4, [i1] = k1, [i3, i4, i5] = k3, [i3, i5, i4] = k3, [i4, i3, i5] = k3, [i4, i5, i3] = k3, [i5, i3, i4] = k3, [i5, i4, i3] = k3}
      call set_map(6,4, (/i1,i3,i4,i5/), (/i1,i2,i5,i6/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(75)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(75)=+1d0/2d0*FullB40(i4,i1,i3,i5,6)*B2g0(k3,k4,k2,k1)
        wt(75)=bino(ix,partons,-wt(75)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(76)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(76)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*FullgA30IF(j3,j1,j4,5)*B2g0(k3,k4,k2,k1)
        wt(76)=bino(ix,partons,-wt(76)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = k2, i6 = k4, [i1] = k1, [i3, i4, i5] = k3, [i3, i5, i4] = k3, [i4, i3, i5] = k3, [i4, i5, i3] = k3, [i5, i3, i4] = k3, [i5, i4, i3] = k3}
      call set_map(6,4, (/i1,i3,i4,i5/), (/i1,i2,i5,i6/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(77)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(77)=+1d0/2d0*FullB40(i4,i1,i3,i5,6)*B2g0(k3,k2,k4,k1)
        wt(77)=bino(ix,partons,-wt(77)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(78)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(78)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*FullgA30IF(j3,j1,j4,5)*B2g0(k3,k2,k4,k1)
        wt(78)=bino(ix,partons,-wt(78)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(79)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(79)=-1d0/2d0*FullE30FF(i3,i5,i4,6)*FullqgD30II(j1,j5,j2,5)*B2g0(k3,k4,k2,k1)
        wt(79)=bino(ix,partons,-wt(79)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, i5 = j5, [i2] = j2, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i2,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
* IF: {j2 = k2, j3 = k4, [j1] = k1, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j1,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(80)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(80)=-1d0/2d0*gd30IF(i3,i6,i2,6)*FullqE30IF(j1,j4,j5,5)*B2g0(k4,k2,k3,k1)
        wt(80)=bino(ix,partons,-wt(80)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i4, i6] = j3, [i5, i4] = j4, [i6, i4] = j3}
      call set_map(6,5, (/i6,i4,i5/), (/i1,i2,i6,i5,i3/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(81)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(81)=+1d0/4d0*FullG30FF(i6,i4,i5,6)*FullqgG30II(j2,j1,j5,5)*A4g0(k1,k2,k3,k4)
        wt(81)=bino(ix,partons,-wt(81)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(82)=1
        call set_flav_perm(4, (/ k1,k2,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(82)=+1d0/4d0*FullE30FF(i3,i5,i4,6)*FullqgG30II(j2,j1,j3,5)*A4g0(k1,k2,k4,k3)
        wt(82)=bino(ix,partons,-wt(82)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(83)=1
        call set_flav_perm(4, (/ k1,k4,k2,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(83)=+1d0/4d0*FullgG30IF(i2,i4,i5,6)*FullqgG30II(j2,j1,j4,5)*A4g0(k1,k4,k2,k3)
        wt(83)=bino(ix,partons,-wt(83)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(84)=1
        call set_flav_perm(4, (/ k1,k4,k2,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(84)=+1d0/4d0*FullE30FF(i3,i5,i4,6)*FullqgG30II(j2,j1,j3,5)*A4g0(k1,k4,k2,k3)
        wt(84)=bino(ix,partons,-wt(84)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(85)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(85)=+1d0/4d0*FullgG30IF(i2,i4,i5,6)*FullqgG30II(j2,j1,j4,5)*A4g0(k1,k2,k3,k4)
        wt(85)=bino(ix,partons,-wt(85)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(86)=1
        call set_flav_perm(4, (/ k1,k2,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(86)=+1d0/4d0*FullG30FF(i6,i5,i4,6)*FullqgG30II(j2,j1,j5,5)*A4g0(k1,k2,k4,k3)
        wt(86)=bino(ix,partons,-wt(86)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(87)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(87)=+1d0/4d0*FullgG30IF(i2,i5,i4,6)*FullqgG30II(j2,j1,j4,5)*A4g0(k1,k2,k3,k4)
        wt(87)=bino(ix,partons,-wt(87)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i4, i6] = j3, [i5, i4] = j4, [i6, i4] = j3}
      call set_map(6,5, (/i6,i4,i5/), (/i1,i2,i6,i5,i3/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(88)=1
        call set_flav_perm(4, (/ k1,k2,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(88)=+1d0/4d0*FullG30FF(i6,i4,i5,6)*FullqgG30II(j2,j1,j5,5)*A4g0(k1,k2,k4,k3)
        wt(88)=bino(ix,partons,-wt(88)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(89)=1
        call set_flav_perm(4, (/ k1,k4,k2,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(89)=+1d0/4d0*FullgG30IF(i2,i5,i4,6)*FullqgG30II(j2,j1,j4,5)*A4g0(k1,k4,k2,k3)
        wt(89)=bino(ix,partons,-wt(89)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(90)=1
        call set_flav_perm(4, (/ k1,k4,k2,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(90)=+1d0/4d0*FullqE30IF(i1,i4,i5,6)*FullqgG30II(j2,j1,j4,5)*A4g0(k1,k4,k2,k3)
        wt(90)=bino(ix,partons,-wt(90)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(91)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(91)=+1d0/4d0*FullG30FF(i6,i5,i4,6)*FullqgG30II(j2,j1,j5,5)*A4g0(k1,k2,k3,k4)
        wt(91)=bino(ix,partons,-wt(91)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(92)=1
        call set_flav_perm(4, (/ k1,k2,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        wt(92)=+1d0/4d0*FullqE30IF(i1,i4,i5,6)*FullqgG30II(j2,j1,j4,5)*A4g0(k1,k2,k4,k3)
        wt(92)=bino(ix,partons,-wt(92)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = k3, i5 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i4,i6,i2/), (/i1,i2,i3,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(93)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(93)=-1d0/2d0*FullA40(i4,i6,i2,i1,6)*C0g0(k3,k4,k2,k1)
        wt(93)=bino(ix,partons,-wt(93)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i5 = j5, [i2] = j2, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i2,i4,i6/), (/i1,i2,i6,i3,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(94)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(94)=+1d0/2d0*gd30IF(i4,i6,i2,6)*FullqgA30II(j3,j2,j1,5)*C0g0(k3,k4,k2,k1)
        wt(94)=bino(ix,partons,-wt(94)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = k3, i5 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i4,i6,i2/), (/i1,i2,i3,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(95)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(95)=-1d0/2d0*FullA40(i4,i2,i6,i1,6)*C0g0(k3,k4,k2,k1)
        wt(95)=bino(ix,partons,-wt(95)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(96)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(96)=+1d0/2d0*FullqgD30II(i1,i6,i2,6)*FullqgA30II(j4,j2,j1,5)*C0g0(k3,k4,k2,k1)
        wt(96)=bino(ix,partons,-wt(96)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(97)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(97)=+1d0/2d0*FullqgA30II(i4,i2,i1,6)*FullqqA30II(j2,j5,j1,5)*C0g0(k3,k4,k2,k1)
        wt(97)=bino(ix,partons,-wt(97)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i6] = j3, [i5, i6] = j4, [i6, i3] = j3, [i6, i5] = j4}
      call set_map(6,5, (/i3,i6,i5/), (/i1,i2,i3,i5,i4/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(98)=1
        call set_flav_perm(4, (/ k3,k4,k2,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(98)=+1d0/2d0*FullA30FF(i3,i6,i5,6)*FullqgA30II(j5,j2,j1,5)*C0g0(k3,k4,k2,k1)
        wt(98)=bino(ix,partons,-wt(98)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = k3, i5 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i3,i6,i2/), (/i1,i2,i4,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(99)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(99)=-1d0/2d0*FullG40(i6,i1,i3,i2,6)*B2g0(k3,k1,k2,k4)
        wt(99)=bino(ix,partons,-wt(99)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(100)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(100)=+1d0/2d0*FullqgD30II(i1,i6,i2,6)*FullqgG30II(j2,j1,j3,5)*B2g0(k3,k1,k2,k4)
        wt(100)=bino(ix,partons,-wt(100)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(101)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(101)=+1d0/2d0*FullqgG30II(i2,i1,i3,6)*FullggF30II(j2,j1,j5,5)*B2g0(k3,k1,k2,k4)
        wt(101)=bino(ix,partons,-wt(101)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(102)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(102)=+1d0/2d0*FullqgA30II(i3,i2,i1,6)*FullqqG30II(j5,j1,j2,5)*B2g0(k3,k1,k2,k4)
        wt(102)=bino(ix,partons,-wt(102)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = k3, i5 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i3,i6,i2/), (/i1,i2,i4,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(103)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(103)=-1d0/2d0*FullG40(i2,i1,i3,i6,6)*B2g0(k3,k1,k2,k4)
        wt(103)=bino(ix,partons,-wt(103)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, i5 = j5, [i2] = j2, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i2,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(104)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(104)=+1d0/2d0*gd30IF(i3,i6,i2,6)*FullqgG30II(j2,j1,j3,5)*B2g0(k3,k1,k2,k4)
        wt(104)=bino(ix,partons,-wt(104)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(105)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(105)=+1d0/2d0*FullqgG30II(i2,i1,i3,6)*FullggF30II(j2,j1,j5,5)*B2g0(k3,k1,k2,k4)
        wt(105)=bino(ix,partons,-wt(105)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = k3, i5 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i3,i6,i2/), (/i1,i2,i4,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(106)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(106)=-1d0/2d0*FullG40(i6,i1,i3,i2,6)*B2g0(k3,k2,k1,k4)
        wt(106)=bino(ix,partons,-wt(106)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(107)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(107)=+1d0/2d0*FullqgD30II(i1,i6,i2,6)*FullqgG30II(j2,j1,j3,5)*B2g0(k3,k2,k1,k4)
        wt(107)=bino(ix,partons,-wt(107)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(108)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(108)=+1d0/2d0*FullqgG30II(i2,i1,i3,6)*FullggF30II(j2,j1,j5,5)*B2g0(k3,k2,k1,k4)
        wt(108)=bino(ix,partons,-wt(108)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(109)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(109)=+1d0/2d0*FullqgA30II(i3,i2,i1,6)*FullqqG30II(j5,j1,j2,5)*B2g0(k3,k2,k1,k4)
        wt(109)=bino(ix,partons,-wt(109)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = k3, i5 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i3,i6,i2/), (/i1,i2,i4,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(110)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(110)=-1d0/2d0*FullG40(i2,i1,i3,i6,6)*B2g0(k3,k2,k1,k4)
        wt(110)=bino(ix,partons,-wt(110)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, i5 = j5, [i2] = j2, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i2,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(111)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(111)=+1d0/2d0*gd30IF(i3,i6,i2,6)*FullqgG30II(j2,j1,j3,5)*B2g0(k3,k2,k1,k4)
        wt(111)=bino(ix,partons,-wt(111)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(112)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(112)=+1d0/2d0*FullqgG30II(i2,i1,i3,6)*FullggF30II(j1,j5,j2,5)*B2g0(k3,k2,k1,k4)
        wt(112)=bino(ix,partons,-wt(112)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i5 = j5, [i1] = j1, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i1,i4,i6/), (/i1,i2,i6,i3,i5/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(113)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(113)=+1d0/2d0*FullqA30IF(i4,i6,i1,6)*FullqgG30II(j2,j1,j4,5)*B2g0(k3,k1,k2,k4)
        wt(113)=bino(ix,partons,-wt(113)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i4 = j5, [i2] = j2, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i2,i5,i6/), (/i1,i2,i6,i3,i4/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(114)=1
        call set_flav_perm(4, (/ k4,k1,k2,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(114)=+1d0/2d0*gd30IF(i5,i6,i2,6)*FullqgG30II(j2,j1,j4,5)*B2g0(k4,k1,k2,k3)
        wt(114)=bino(ix,partons,-wt(114)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(115)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(115)=-1d0/2d0*FullqgD30II(i1,i6,i2,6)*FullqgG30II(j2,j1,j3,5)*B2g0(k3,k1,k2,k4)
        wt(115)=bino(ix,partons,-wt(115)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i6] = j3, [i5, i6] = j4, [i6, i4] = j3, [i6, i5] = j4}
      call set_map(6,5, (/i4,i6,i5/), (/i1,i2,i4,i5,i3/), ipass)
      call fillson5FF(i1,i2,i4,i6,i5,i3,j1,j2,j3,j4,j5,6,ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call fillson4II(j1,j2,j5,j3,j4,k1,k2,k3,k4,6,ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(116)=1
        call set_flav_perm(4, (/ k3,k1,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wtsoft=0d0
        wtsoft=wtsoft+1d0*SS1(k1,i6,k3,4,6)
        wtsoft=wtsoft-1d0*SS1(k1,i6,k2,4,6)
        wtsoft=wtsoft+1d0*SS1(j1,i6,j2,5,6)
        wtsoft=wtsoft-1d0*SS1(j1,i6,j3,5,6)
        wtsoft=wtsoft-1d0*SS1(j2,i6,j4,5,6)
        wtsoft=wtsoft+1d0*SS1(k2,i6,k4,4,6)
        wt(116)=+1d0/2d0*wtsoft*FullqgG30II(j2,j1,j5,5)*B2g0(k3,k1,k2,k4)
        wt(116)=bino(ix,partons,-wt(116)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i5 = j5, [i2] = j2, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i2,i4,i6/), (/i1,i2,i6,i3,i5/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(117)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(117)=+1d0/2d0*gd30IF(i4,i6,i2,6)*FullqgG30II(j2,j1,j4,5)*B2g0(k3,k2,k1,k4)
        wt(117)=bino(ix,partons,-wt(117)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i6] = j4, [i5, i6] = j3, [i6, i3] = j4, [i6, i5] = j3}
      call set_map(6,5, (/i5,i6,i3/), (/i1,i2,i5,i3,i4/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(118)=1
        call set_flav_perm(4, (/ k4,k2,k1,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(118)=+1d0/2d0*FullA30FF(i5,i6,i3,6)*FullqgG30II(j2,j1,j4,5)*B2g0(k4,k2,k1,k3)
        wt(118)=bino(ix,partons,-wt(118)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, i5 = j5, [i2] = j2, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i2,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(119)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(119)=-1d0/2d0*gd30IF(i3,i6,i2,6)*FullqgG30II(j2,j1,j3,5)*B2g0(k3,k2,k1,k4)
        wt(119)=bino(ix,partons,-wt(119)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i6] = j3, [i5, i6] = j4, [i6, i4] = j3, [i6, i5] = j4}
      call set_map(6,5, (/i4,i6,i5/), (/i1,i2,i4,i5,i3/), ipass)
      call fillson5FF(i1,i2,i4,i6,i5,i3,j1,j2,j3,j4,j5,6,ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call fillson4II(j1,j2,j5,j3,j4,k1,k2,k3,k4,6,ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(120)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wtsoft=0d0
        wtsoft=wtsoft-1d0*SS1(k1,i6,k2,4,6)
        wtsoft=wtsoft-1d0*SS1(j2,i6,j3,5,6)
        wtsoft=wtsoft+1d0*SS1(k2,i6,k3,4,6)
        wtsoft=wtsoft+1d0*SS1(j2,i6,j5,5,6)
        wtsoft=wtsoft-1d0*SS1(j5,i6,j4,5,6)
        wtsoft=wtsoft+1d0*SS1(k1,i6,k4,4,6)
        wt(120)=+1d0/2d0*wtsoft*FullqgG30II(j2,j1,j5,5)*B2g0(k3,k2,k1,k4)
        wt(120)=bino(ix,partons,-wt(120)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = k3, i4 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i5,i6,i2/), (/i1,i2,i3,i4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(121)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(121)=-1d0/2d0*FullA40(i5,i2,i6,i1,6)*C0g0(k3,k2,k4,k1)
        wt(121)=bino(ix,partons,-wt(121)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(122)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(122)=+1d0/2d0*FullqgD30II(i1,i6,i2,6)*FullqgA30II(j5,j2,j1,5)*C0g0(k3,k2,k4,k1)
        wt(122)=bino(ix,partons,-wt(122)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(123)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(123)=+1d0/2d0*FullqgA30II(i5,i2,i1,6)*FullqqA30II(j2,j5,j1,5)*C0g0(k3,k2,k4,k1)
        wt(123)=bino(ix,partons,-wt(123)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = k3, i4 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i5,i6,i2/), (/i1,i2,i3,i4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(124)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(124)=-1d0/2d0*FullA40(i5,i6,i2,i1,6)*C0g0(k3,k2,k4,k1)
        wt(124)=bino(ix,partons,-wt(124)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i4 = j5, [i2] = j2, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i2,i5,i6/), (/i1,i2,i6,i3,i4/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(125)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(125)=+1d0/2d0*gd30IF(i5,i6,i2,6)*FullqgA30II(j3,j2,j1,5)*C0g0(k3,k2,k4,k1)
        wt(125)=bino(ix,partons,-wt(125)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, i5 = j5, [i2] = j2, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i2,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(126)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(126)=+1d0/2d0*gd30IF(i3,i6,i2,6)*FullqgA30II(j5,j2,j1,5)*C0g0(k3,k2,k4,k1)
        wt(126)=bino(ix,partons,-wt(126)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i5 = j5, [i1] = j1, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i1,i4,i6/), (/i1,i2,i6,i3,i5/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(127)=1
        call set_flav_perm(4, (/ k4,k2,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(127)=+1d0/2d0*FullqA30IF(i4,i6,i1,6)*FullqgA30II(j5,j2,j1,5)*C0g0(k4,k2,k3,k1)
        wt(127)=bino(ix,partons,-wt(127)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(128)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(128)=-1d0/2d0*FullqgD30II(i1,i6,i2,6)*FullqgA30II(j5,j2,j1,5)*C0g0(k3,k2,k4,k1)
        wt(128)=bino(ix,partons,-wt(128)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i6] = j3, [i4, i6] = j4, [i6, i3] = j3, [i6, i4] = j4}
      call set_map(6,5, (/i3,i6,i4/), (/i1,i2,i3,i4,i5/), ipass)
      call fillson5FF(i1,i2,i3,i6,i4,i5,j1,j2,j3,j4,j5,6,ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call fillson4II(j1,j2,j5,j3,j4,k1,k2,k3,k4,6,ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(129)=1
        call set_flav_perm(4, (/ k3,k2,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wtsoft=0d0
        wtsoft=wtsoft+1d0*SS1(k3,i6,k2,4,6)
        wtsoft=wtsoft-1d0*SS1(k1,i6,k2,4,6)
        wtsoft=wtsoft-1d0*SS1(j3,i6,j2,5,6)
        wtsoft=wtsoft+1d0*SS1(j1,i6,j2,5,6)
        wtsoft=wtsoft+1d0*SS1(k4,i6,k1,4,6)
        wtsoft=wtsoft-1d0*SS1(j4,i6,j1,5,6)
        wt(129)=+1d0/2d0*wtsoft*FullqgA30II(j5,j2,j1,5)*C0g0(k3,k2,k4,k1)
        wt(129)=bino(ix,partons,-wt(129)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = k3, i5 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i3,i6,i2/), (/i1,i2,i4,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(130)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(130)=-1d0/2d0*FullA40(i3,i2,i6,i1,6)*C0g0(k2,k4,k3,k1)
        wt(130)=bino(ix,partons,-wt(130)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(131)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(131)=+1d0/2d0*FullqgD30II(i1,i6,i2,6)*FullqgA30II(j3,j2,j1,5)*C0g0(k2,k4,k3,k1)
        wt(131)=bino(ix,partons,-wt(131)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(132)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(132)=+1d0/2d0*FullqgA30II(i3,i2,i1,6)*FullqqA30II(j2,j5,j1,5)*C0g0(k2,k4,k3,k1)
        wt(132)=bino(ix,partons,-wt(132)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = k3, i5 = k4, [i1] = k1, [i2] = k2}
      call set_map(6,4, (/i1,i3,i6,i2/), (/i1,i2,i4,i5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(133)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(133)=-1d0/2d0*FullA40(i3,i6,i2,i1,6)*C0g0(k2,k4,k3,k1)
        wt(133)=bino(ix,partons,-wt(133)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, i5 = j5, [i2] = j2, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i2,i3,i6/), (/i1,i2,i6,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(134)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(134)=+1d0/2d0*gd30IF(i3,i6,i2,6)*FullqgA30II(j3,j2,j1,5)*C0g0(k2,k4,k3,k1)
        wt(134)=bino(ix,partons,-wt(134)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i4 = j5, [i2] = j2, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i2,i5,i6/), (/i1,i2,i6,i3,i4/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(135)=1
        call set_flav_perm(4, (/ k2,k3,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(135)=+1d0/2d0*gd30IF(i5,i6,i2,6)*FullqgA30II(j4,j2,j1,5)*C0g0(k2,k3,k4,k1)
        wt(135)=bino(ix,partons,-wt(135)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i5 = j5, [i1] = j1, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i1,i4,i6/), (/i1,i2,i6,i3,i5/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(136)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(136)=+1d0/2d0*FullqA30IF(i4,i6,i1,6)*FullqgA30II(j4,j2,j1,5)*C0g0(k2,k4,k3,k1)
        wt(136)=bino(ix,partons,-wt(136)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i5 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i6,i2/), (/i1,i2,i3,i4,i5/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(137)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(137)=-1d0/2d0*FullqgD30II(i1,i6,i2,6)*FullqgA30II(j3,j2,j1,5)*C0g0(k2,k4,k3,k1)
        wt(137)=bino(ix,partons,-wt(137)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i6] = j3, [i5, i6] = j4, [i6, i4] = j3, [i6, i5] = j4}
      call set_map(6,5, (/i4,i6,i5/), (/i1,i2,i4,i5,i3/), ipass)
      call fillson5FF(i1,i2,i4,i6,i5,i3,j1,j2,j3,j4,j5,6,ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call fillson4II(j1,j2,j5,j3,j4,k1,k2,k3,k4,6,ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(138)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wtsoft=0d0
        wtsoft=wtsoft+1d0*SS1(k1,i6,k3,4,6)
        wtsoft=wtsoft-1d0*SS1(k1,i6,k2,4,6)
        wtsoft=wtsoft+1d0*SS1(j1,i6,j2,5,6)
        wtsoft=wtsoft-1d0*SS1(j1,i6,j3,5,6)
        wtsoft=wtsoft-1d0*SS1(j2,i6,j4,5,6)
        wtsoft=wtsoft+1d0*SS1(k2,i6,k4,4,6)
        wt(138)=+1d0/2d0*wtsoft*FullqgA30II(j5,j2,j1,5)*C0g0(k2,k4,k3,k1)
        wt(138)=bino(ix,partons,-wt(138)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(139)=1
        call set_flav_perm(4, (/ k2,k3,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(139)=+1d0/4d0*FullG30FF(i6,i5,i4,6)*FullqgA30II(j5,j2,j1,5)*B2g0(k2,k3,k4,k1)
        wt(139)=bino(ix,partons,-wt(139)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(140)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(140)=+1d0/4d0*FullqgA30II(i3,i2,i1,6)*FullqE30IF(j1,j3,j4,5)*B2g0(k2,k4,k3,k1)
        wt(140)=bino(ix,partons,-wt(140)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i4, i6] = j3, [i5, i4] = j4, [i6, i4] = j3}
      call set_map(6,5, (/i6,i4,i5/), (/i1,i2,i6,i5,i3/), ipass)
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(141)=1
        call set_flav_perm(4, (/ k2,k4,k3,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(141)=+1d0/4d0*FullG30FF(i6,i4,i5,6)*FullqgA30II(j5,j2,j1,5)*B2g0(k2,k4,k3,k1)
        wt(141)=bino(ix,partons,-wt(141)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(142)=1
        call set_flav_perm(4, (/ k2,k3,k4,k1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(142)=+1d0/4d0*FullgG30IF(i2,i5,i4,6)*FullqgA30II(j4,j2,j1,5)*B2g0(k2,k3,k4,k1)
        wt(142)=bino(ix,partons,-wt(142)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(143)=1
        call set_flav_perm(4, (/ k2,k1,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(143)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*FullgA30IF(j3,j2,j4,5)*B2g0(k2,k1,k4,k3)
        wt(143)=bino(ix,partons,-wt(143)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(144)=1
        call set_flav_perm(4, (/ k2,k1,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(144)=-1d0/2d0*FullqgA30II(i4,i2,i1,6)*FullqqpE30II(j2,j1,j3,5)*B2g0(k2,k1,k4,k3)
        wt(144)=bino(ix,partons,-wt(144)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(145)=1
        call set_flav_perm(4, (/ k2,k1,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(145)=-1d0/2d0*FullqgA30II(i5,i2,i1,6)*FullqqpE30II(j2,j1,j3,5)*B2g0(k2,k1,k4,k3)
        wt(145)=bino(ix,partons,-wt(145)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(146)=1
        call set_flav_perm(4, (/ k2,k1,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(146)=+1d0/2d0*FullgA30IF(i4,i2,i5,6)*FullqqpE30II(j2,j1,j4,5)*B2g0(k2,k1,k4,k3)
        wt(146)=bino(ix,partons,-wt(146)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(147)=1
        call set_flav_perm(4, (/ k2,k4,k1,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(147)=-1d0/2d0*FullqgG30II(i2,i1,i3,6)*FullgA30IF(j3,j2,j4,5)*B2g0(k2,k4,k1,k3)
        wt(147)=bino(ix,partons,-wt(147)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(148)=1
        call set_flav_perm(4, (/ k2,k4,k1,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(148)=-1d0/2d0*FullqgA30II(i4,i2,i1,6)*FullqqpE30II(j2,j1,j3,5)*B2g0(k2,k4,k1,k3)
        wt(148)=bino(ix,partons,-wt(148)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(149)=1
        call set_flav_perm(4, (/ k2,k4,k1,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(149)=-1d0/2d0*FullqgA30II(i5,i2,i1,6)*FullqqpE30II(j2,j1,j3,5)*B2g0(k2,k4,k1,k3)
        wt(149)=bino(ix,partons,-wt(149)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, i6 = j5, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i2,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
* II: {j3 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j4,j2/), (/j1,j2,j3,j5/), ipass)
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        jpass(150)=1
        call set_flav_perm(4, (/ k2,k4,k1,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(150)=+1d0/2d0*FullgA30IF(i4,i2,i5,6)*FullqqpE30II(j2,j1,j4,5)*B2g0(k2,k4,k1,k3)
        wt(150)=bino(ix,partons,-wt(150)*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgtoqgC2g0S = - sum(wt)  ! minus in bino(-...)


      return
      end function qgtoqgC2g0S
