************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qgCtt1g1XT(ix,x1,x2,i1,i3,i4,i5,i2,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(50)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgCtt1g1XT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQFF(ix,x1,x2,i4,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0/2d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0/2d0
     .  *rJ21QQFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQFF(ix,x1,x2,i4,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0/2d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0/2d0
     .  *rJ21QQFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i2,i4,i5,i3 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i2,i4,i5,i3)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQgtoqIF(ix,x1,x2,i4,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i5,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Ct1g0(i1,i3,i5,i2,i4)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i5,i2,i1,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/4d0
     .  *rJ21GQqtogIF(ix,x1,x2,i4,i1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Btt3g0(i5,i2,i1,i3,i4)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i5,i2,i3,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/4d0
     .  *rJ21GQqtogIF(ix,x1,x2,i5,i1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Btt3g0(i5,i2,i3,i1,i4)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0/2d0)*FullqgA30II(i1,i2,i3,5)*Ct0g1(j1,j4,j3,j2,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i3,5)*C0g0(j1,j4,j3,j2)*wtcalX30
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0/2d0)*ga30IFGTOQ(i4,i2,i5,5)*Ct0g1(j1,j3,j2,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + ga30IFGTOQ(i4,i2,i5,5)*C0g0(j1,j3,j2,j4)*wtcalX30
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0/2d0)*ga30IFGTOQ(i5,i2,i4,5)*Ct0g1(j1,j2,j3,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + ga30IFGTOQ(i5,i2,i4,5)*C0g0(j1,j2,j3,j4)*wtcalX30
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0/4d0)*FullqE30IF(i1,i4,i5,5)*Btt2g1(j1,j2,j3,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqE30IF(i1,i4,i5,5)*Bt2g0(j1,j2,j3,j4)*wtcalX30
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0/4d0)*FullE30FF(i3,i4,i5,5)*Btt2g1(j1,j2,j4,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullE30FF(i3,i4,i5,5)*Bt2g0(j1,j2,j4,j3)*wtcalX30
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0/4d0)*FullqpE30IF(i4,i1,i3,5)*Btt2g1(j3,j2,j1,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqpE30IF(i4,i1,i3,5)*Bt2g0(j3,j2,j1,j4)*wtcalX30
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0/4d0)*FullqpE30IF(i5,i1,i3,5)*Btt2g1(j4,j2,j1,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQFF(ix,x1,x2,j4,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqpE30IF(i5,i1,i3,5)*Bt2g0(j4,j2,j1,j3)*wtcalX30
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0/2d0)*FullqgAt31II(i1,i2,i3,5,muR2_scl(i))*C0g0(j1,j4,j3,j2)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i3,5)*C0g0(j1,j4,j3,j2)*wtcalX30
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0/2d0)*FullgAt31IF(i4,i2,i5,5,muR2_scl(i))*C0g0(j1,j3,j2,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i4,i2,i5,5)*C0g0(j1,j3,j2,j4)*wtcalX30
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0/4d0)*FullqEt31IF(i1,i4,i5,5,muR2_scl(i))*Bt2g0(j1,j2,j3,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqE30IF(i1,i4,i5,5)*Bt2g0(j1,j2,j3,j4)*wtcalX30
        enddo
        wt(25)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0/4d0)*FullEt31FF(i3,i4,i5,5,muR2_scl(i))*Bt2g0(j1,j2,j4,j3)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullE30FF(i3,i4,i5,5)*Bt2g0(j1,j2,j4,j3)*wtcalX30
        enddo
        wt(26)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0/4d0)*FullqpEt31IF(i4,i1,i3,5,muR2_scl(i))*Bt2g0(j3,j2,j1,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqpE30IF(i4,i1,i3,5)*Bt2g0(j3,j2,j1,j4)*wtcalX30
        enddo
        wt(27)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0/4d0)*FullqpEt31IF(i5,i1,i3,5,muR2_scl(i))*Bt2g0(j4,j2,j1,j3)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqpE30IF(i5,i1,i3,5)*Bt2g0(j4,j2,j1,j3)*wtcalX30
        enddo
        wt(28)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i3,i2,5)*C0g0(j1,j4,j3,j2)*(wtcalX30)
        enddo
        wt(29)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullA30FF(i4,i3,i5,5)*C0g0(j1,j4,j3,j2)*(wtcalX30)
        enddo
        wt(30)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i1,i4,i5,5)*Bt2g0(j1,j4,j3,j2)*(wtcalX30)
        enddo
        wt(31)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqE30IF(i2,i4,i5,5)*Bt2g0(j1,j4,j3,j2)*(wtcalX30)
        enddo
        wt(32)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqIF(ix,x1,x2,i4,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i3,5)*C0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(33)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqIF(ix,x1,x2,i4,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i5,i4,5)*C0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(34)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQgtoqIF(ix,x1,x2,j3,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqpE30II(i2,i1,i3,5)*Bt2g0(j2,j4,j1,j3)*(wtcalX30)
        enddo
        wt(35)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQgtoqIF(ix,x1,x2,j3,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i4,i1,i3,5)*Bt2g0(j2,j4,j1,j3)*(wtcalX30)
        enddo
        wt(36)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQgtoqIF(ix,x1,x2,i4,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqpE30II(i1,i2,i4,5)*Bt2g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(37)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQgtoqIF(ix,x1,x2,i4,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i3,i2,i4,5)*Bt2g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(38)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*C0g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(39)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*C0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(40)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j3,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQgtoqIF(ix,x1,x2,j4,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqpE30II(i2,i1,i3,5)*Bt2g0(j2,j3,j1,j4)*(wtcalX30)
        enddo
        wt(41)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQgtoqIF(ix,x1,x2,j3,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i5,i1,i3,5)*Bt2g0(j2,j4,j1,j3)*(wtcalX30)
        enddo
        wt(42)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqpE30II(i1,i2,i5,5)*Bt2g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(43)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpE30IF(i3,i2,i5,5)*Bt2g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(44)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21GQqtogIF(ix,x1,x2,i4,i1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgA30IF(i5,i1,i4,5)*Bt2g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(45)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21GQqtogIF(ix,x1,x2,i4,i1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgA30IF(i5,i2,i4,5)*Bt2g0(j2,j1,j4,j3)*(wtcalX30)
        enddo
        wt(46)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i4] = j4, [i3, i5] = j3, [i4, i3] = j4, [i5, i3] = j3}
      call set_map(5,4, (/i5,i3,i4/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/4d0*rJ21GQqtogIF(ix,x1,x2,i4,i1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullA30FF(i5,i3,i4,5)*Bt2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(47)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21GQqtogIF(ix,x1,x2,i5,i1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgA30IF(i5,i1,i4,5)*Bt2g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(48)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/4d0*rJ21GQqtogIF(ix,x1,x2,i5,i1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgA30IF(i5,i2,i4,5)*Bt2g0(j2,j1,j4,j3)*(wtcalX30)
        enddo
        wt(49)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i4] = j4, [i3, i5] = j3, [i4, i3] = j4, [i5, i3] = j3}
      call set_map(5,4, (/i5,i3,i4/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/4d0*rJ21GQqtogIF(ix,x1,x2,i5,i1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullA30FF(i5,i3,i4,5)*Bt2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(50)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgCtt1g1XT = - sum(wt)  ! minus in bino(-...)


      return


      end function qgCtt1g1XT
