************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qgDt1g1XT(ix,x1,x2,i1,i3,i4,i5,i2,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(80)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgDt1g1XT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QGII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intd(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21GQIF(ix,x1,x2,i3,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 9)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21GQIF(ix,x1,x2,i3,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intdc(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21GQIF(ix,x1,x2,i4,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21GQIF(ix,x1,x2,i4,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intc(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21GQIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21GQIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intcd(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intc(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intcd(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 9)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intdc(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intd(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intc(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 9)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intdc(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i4,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQFF(ix,x1,x2,i4,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i4,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intcd(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i4,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intd(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +2d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(25)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(26)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intc(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(27)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intd(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(28)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +2d0
     .  *rJ21QQFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(29)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(30)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 9)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intdc(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(31)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intcd(i1,i3,i4,i5,i2)*(wtcalX30)
        enddo
        wt(32)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i4,i2,i5,i3 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i4,i2,i5,i3)*(wtcalX30)
        enddo
        wt(33)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i2,i4,i5,i3 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i2,i4,i5,i3)*(wtcalX30)
        enddo
        wt(34)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i5,i4,i2,i3 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i5,i4,i2,i3)*(wtcalX30)
        enddo
        wt(35)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqgA30II(i1,i2,i4,5)*D0g1(j1,j3,j2,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i4,5)*D0g0(j1,j3,j2,j4)*wtcalX30
        enddo
        wt(36)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullgA30IF(i3,i2,i5,5)*D0g1(j1,j2,j4,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i3,i2,i5,5)*D0g0(j1,j2,j4,j3)*wtcalX30
        enddo
        wt(37)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullqgA30II(i1,i2,i4,5)*Dt0g1(j1,j3,j2,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i4,5)*D0g0(j1,j3,j2,j4)*wtcalX30
        enddo
        wt(38)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 3
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullgA30IF(i3,i2,i5,5)*Dt0g1(j1,j2,j4,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,j4,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i3,i2,i5,5)*D0g0(j1,j2,j4,j3)*wtcalX30
        enddo
        wt(39)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqgA31II(i1,i2,i4,5,muR2_scl(i))*D0g0(j1,j3,j2,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQIF(ix,x1,x2,i4,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i4,5)*D0g0(j1,j3,j2,j4)*wtcalX30
        enddo
        wt(40)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullgA31IF(i3,i2,i5,5,muR2_scl(i))*D0g0(j1,j2,j4,j3)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQIF(ix,x1,x2,i3,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i3,i2,i5,5)*D0g0(j1,j2,j4,j3)*wtcalX30
        enddo
        wt(41)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqgAt31II(i1,i2,i4,5,muR2_scl(i))*D0g0(j1,j3,j2,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i4,5)*D0g0(j1,j3,j2,j4)*wtcalX30
        enddo
        wt(42)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullgAt31IF(i3,i2,i5,5,muR2_scl(i))*D0g0(j1,j2,j4,j3)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i3,i2,i5,5)*D0g0(j1,j2,j4,j3)*wtcalX30
        enddo
        wt(43)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i3,i4,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(44)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i3,i5,5)*D0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(45)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i3,i5,5)*D0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(46)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i3,i4,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(47)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i3,i2,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(48)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullA30FF(i4,i3,i5,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(49)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i3,i5,5)*D0g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(50)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqIF(ix,x1,x2,i5,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i3,i4,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(51)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i1,i2,5,i4,i5,5,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,i1,i4,5,i4,i5,5,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i2,i4,5,i4,i5,5,muR2_scl(i))
        wtcalS=wtcalS-2d0*SSint(ix,x1,x2,i2,i5,5,i4,i5,5,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,j3,j1,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j3,j2,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS+2d0*SSint(ix,x1,x2,j4,j2,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j1,j2,4,j3,j4,4,muR2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQIF(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21GQIF(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i3,5)*D0g0(j1,j2,j3,j4)*(wtcalX30+wtcalS)
        enddo
        wt(52)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS-2d0*SSint(ix,x1,x2,i1,i2,5,i3,i5,5,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i1,i3,5,i3,i5,5,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i1,i5,5,i3,i5,5,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i2,i3,5,i3,i5,5,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i2,i5,5,i3,i5,5,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j3,j1,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j3,j2,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j4,j1,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j4,j2,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS+2d0*SSint(ix,x1,x2,j1,j2,4,j3,j4,4,muR2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQIF(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21QGII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i4,5)*D0g0(j1,j3,j2,j4)*(wtcalX30+wtcalS)
        enddo
        wt(53)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i1,i2,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,i1,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-2d0*SSint(ix,x1,x2,i2,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i2,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+2d0*SSint(ix,x1,x2,j3,j2,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,j4,j1,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j4,j2,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j1,j2,4,j3,j4,4,muR2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21GQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQIF(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i5,5)*D0g0(j1,j3,j4,j2)*(wtcalX30+wtcalS)
        enddo
        wt(54)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i3,i2,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(55)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i4,i3,i2,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(56)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i5,i3,i2,5)*D0g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(57)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i3,i4,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(58)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i5,i2,5)*D0g0(j1,j3,j4,j2)*(wtcalX30)
        enddo
        wt(59)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i4,i5,i2,5)*D0g0(j1,j4,j3,j2)*(wtcalX30)
        enddo
        wt(60)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i3,i5,i2,5)*D0g0(j1,j3,j4,j2)*(wtcalX30)
        enddo
        wt(61)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i4,5)*D0g0(j1,j4,j3,j2)*(wtcalX30)
        enddo
        wt(62)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i4,i2,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(63)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i3,i4,i2,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(64)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i5,i4,i2,5)*D0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(65)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(66)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*D0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(67)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i3,i2,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(68)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i4,i3,i2,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(69)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i5,i3,i2,5)*D0g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(70)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i3,i4,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(71)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i5,i2,5)*D0g0(j1,j3,j4,j2)*(wtcalX30)
        enddo
        wt(72)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i4,i5,i2,5)*D0g0(j1,j4,j3,j2)*(wtcalX30)
        enddo
        wt(73)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i3,i5,i2,5)*D0g0(j1,j3,j4,j2)*(wtcalX30)
        enddo
        wt(74)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i4,5)*D0g0(j1,j4,j3,j2)*(wtcalX30)
        enddo
        wt(75)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i4,i2,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(76)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i3,i4,i2,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(77)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i5,i4,i2,5)*D0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(78)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(79)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*D0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(80)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgDt1g1XT = - sum(wt)  ! minus in bino(-...)


      return


      end function qgDt1g1XT
