************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qqD1g1XT(ix,x1,x2,i1,i3,i2,i4,i5,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(50)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qqD1g1XT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 15)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intca(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 11)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intb(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 9)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intac(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 15)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intca(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QGFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intab(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 14)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intbd(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGIF(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QGIF(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0inta(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 18)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGIF(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intdb(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 14)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGIF(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intbd(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QGFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 12)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QGFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intba(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 18)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intdb(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 9)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intac(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 16)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intcb(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 17)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intda(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 13)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intbc(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 10)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intad(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 12)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intba(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intab(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 7)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0inta(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i3,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 11)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0intb(i1,i3,i2,i4,i5)*(wtcalX30)
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+2d0)*FullqA30IF(i1,i5,i3,5)*D0g1subA(j1,j4,j2,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(25)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+2d0)*FullqA30IF(i1,i5,i3,5)*D0g1subB(j1,j4,j2,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(26)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i3,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(27)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+2d0)*FullqA30IF(i2,i5,i4,5)*D0g1subA(j1,j3,j2,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(28)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+2d0)*FullqA30IF(i2,i5,i4,5)*D0g1subB(j1,j3,j2,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(29)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQFF(ix,x1,x2,j4,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i5,i4,5)*D0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(30)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+2d0)*FullqA30IF(i1,i5,i4,5)*D0g1subC(j1,j3,j2,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(31)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+2d0)*FullqA30IF(i1,i5,i4,5)*D0g1subD(j1,j3,j2,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(32)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQFF(ix,x1,x2,j4,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i4,5)*D0g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(33)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+2d0)*FullqA30IF(i2,i5,i3,5)*D0g1subC(j1,j4,j2,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(34)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(+2d0)*FullqA30IF(i2,i5,i3,5)*D0g1subD(j1,j4,j2,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(35)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i5,i3,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(36)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-2d0)*FullqqA30II(i1,i5,i2,5)*D0g1subA(j1,j4,j2,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(37)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-2d0)*FullqqA30II(i1,i5,i2,5)*D0g1subC(j1,j4,j2,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(38)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i5,i2,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(39)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-2d0)*FullA30FF(i3,i5,i4,5)*D0g1subA(j1,j4,j2,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(40)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-2d0)*FullA30FF(i3,i5,i4,5)*D0g1subC(j1,j4,j2,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(41)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullA30FF(i3,i5,i4,5)*D0g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(42)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqqA31II(i1,i5,i2,5,muR2_scl(i))*D0g0(j1,j3,j2,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGIF(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqqA30II(i1,i5,i2,5)*D0g0(j1,j3,j2,j4)*wtcalX30
        enddo
        wt(43)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass)
* BLOCK 6
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullA31FF(i3,i5,i4,5,muR2_scl(i))*D0g0(j1,j3,j2,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGFF(ix,x1,x2,i3,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFF(ix,x1,x2,i4,i5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullA30FF(i3,i5,i4,5)*D0g0(j1,j3,j2,j4)*wtcalX30
        enddo
        wt(44)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i1,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j3,j1,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i2,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j3,j2,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i1,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j4,j1,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i2,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j4,j2,4,j3,j4,4,muR2_scl(i))
        wtcalS=wtcalS-1d0/2d0*SSint(ix,x1,x2,i1,i2,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/2d0*SSint(ix,x1,x2,j1,j2,4,j3,j4,4,muR2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i5,i2,5)*D0g0(j1,j3,j2,j4)*(wtcalX30+wtcalS)
        enddo
        wt(45)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i3,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j4,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,i1,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,j4,j1,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,i2,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,j2,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i1,i2,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j2,j1,4,i3,i4,5,muR2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQFF(ix,x1,x2,i3,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i3,5)*D0g0(j1,j3,j2,j4)*(wtcalX30+wtcalS)
        enddo
        wt(46)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i1,i2,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j2,j1,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i3,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j4,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,i1,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,j4,j1,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,i2,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,j2,j3,4,i3,i4,5,muR2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQFF(ix,x1,x2,i3,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQFF(ix,x1,x2,j4,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i4,5)*D0g0(j1,j4,j2,j3)*(wtcalX30+wtcalS)
        enddo
        wt(47)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i1,i2,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j1,j2,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i3,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j4,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,i1,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,j1,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,i2,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,j4,j2,4,i3,i4,5,muR2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQFF(ix,x1,x2,i3,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i5,i3,5)*D0g0(j1,j3,j2,j4)*(wtcalX30+wtcalS)
        enddo
        wt(48)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i3,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j4,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,i1,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,j1,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,i2,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,j4,j2,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i1,i2,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j1,j2,4,i3,i4,5,muR2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQFF(ix,x1,x2,i3,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQFF(ix,x1,x2,j4,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQII(ix,x1,x2,i1,i2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQII(ix,x1,x2,j1,j2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i5,i4,5)*D0g0(j1,j4,j2,j3)*(wtcalX30+wtcalS)
        enddo
        wt(49)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS-1d0/2d0*SSint(ix,x1,x2,i3,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/2d0*SSint(ix,x1,x2,j3,j4,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i1,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j1,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i1,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j1,j4,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i2,i3,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j2,j3,4,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS+1d0/4d0*SSint(ix,x1,x2,i2,i4,5,i3,i4,5,muR2_scl(i))
        wtcalS=wtcalS-1d0/4d0*SSint(ix,x1,x2,j2,j4,4,i3,i4,5,muR2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQFF(ix,x1,x2,i3,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQFF(ix,x1,x2,j3,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/4d0*rJ21QQIF(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/4d0*rJ21QQIF(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullA30FF(i3,i5,i4,5)*D0g0(j1,j3,j2,j4)*(wtcalX30+wtcalS)
        enddo
        wt(50)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qqD1g1XT = - sum(wt)  ! minus in bino(-...)


      return


      end function qqD1g1XT
