************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qqbB2g1TNLO(ix,x1,x2,i1,i3,i4,i2,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(2)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qqbB2g1TNLO"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQFI(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGFF(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGIF(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQFI(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGFF(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGIF(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i2,i4,i3,i1)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qqbB2g1TNLO = - sum(wt)  ! minus in bino(-...)


      return


      end function qqbB2g1TNLO
