************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qqbDh1g1XT(ix,x1,x2,i1,i2,i3,i4,i5,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(8)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qqbDh1g1XT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i2,i3,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +2d0
     .  *rJ21hQGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i1,i2,i3,i4,i5)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_jet(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i1,i2,i3,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21hQGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i1,i2,i3,i4,i5)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqA30IF(i1,i5,i3,5)*Dh0g1(j1,j2,j3,j4,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 4
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqA30IF(i2,i5,i4,5)*Dh0g1(j1,j2,j4,j3,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 5
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqAh31IF(i1,i5,i3,5,muR2_scl(i))*D0g0(j1,j2,j3,j4)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 5
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if(ix.eq.1)then
          kinwt(i)=(-1d0)*FullqAh31IF(i2,i5,i4,5,muR2_scl(i))*D0g0(j1,j2,j4,j3)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21hQGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i3,5)*D0g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_jet(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21hQGIF(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i5,i4,5)*D0g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qqbDh1g1XT = - sum(wt)  ! minus in bino(-...)


      return


      end function qqbDh1g1XT
