************************************************************************
* full colour matrix element for six quark zero gluon three identical quark pairs
* (i1,i2), (i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)
      function FullG0g0detail(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      dimension ztmp(6,4),tmp(6,4),tmp2(6,4)

c     write(*,*)"hello fullF0g0"

      fac=(4d0*pi*as)**4*(nc**2-1d0)*nc

      wt =
     .   + E0g0(i1,i4,i3,i6,i5,i2)
     .   + E0g0(i1,i6,i5,i4,i3,i2)
     .   + E0g0(i1,i2,i3,i6,i5,i4)
     .   + E0g0(i1,i6,i5,i2,i3,i4)
     .   + E0g0(i1,i6,i3,i2,i5,i4)
     .   + E0g0(i1,i2,i5,i6,i3,i4)
     .   + E0g0(i5,i4,i3,i6,i1,i2)
     .   + E0g0(i5,i6,i1,i4,i3,i2)
     .   + E0g0(i5,i2,i3,i6,i1,i4)
     .   + E0g0(i5,i6,i1,i2,i3,i4)
     .   + E0g0(i5,i6,i3,i2,i1,i4)
     .   + E0g0(i5,i2,i1,i6,i3,i4)
*       + N*V * (
*          + M(1,4,3,6,5,2)*Mc(1,4,3,6,5,2)
*          + M(1,6,5,4,3,2)*Mc(1,6,5,4,3,2)
**as in treeE
*          + M(1,2,3,6,5,4)*Mc(1,2,3,6,5,4)
*          + M(1,6,5,2,3,4)*Mc(1,6,5,2,3,4)
** (exchange 2 <--> 4 in treeE)	
*          + M(1,6,3,2,5,4)*Mc(1,6,3,2,5,4)
*          + M(1,2,5,6,3,4)*Mc(1,2,5,6,3,4)
** (first exchange 2 <--> 4 then exchange 6 <--> 2 in treeE)	
*          + M(5,4,3,6,1,2)*Mc(5,4,3,6,1,2)
*          + M(5,6,1,4,3,2)*Mc(5,6,1,4,3,2)
** (exchange 1 <--> 5 in treeE)	
*          + M(5,2,3,6,1,4)*Mc(5,2,3,6,1,4)
*          + M(5,6,1,2,3,4)*Mc(5,6,1,2,3,4)
** (exchange 1 <--> 5 and 2 <--> 4 in treeE)	
*          + M(5,6,3,2,1,4)*Mc(5,6,3,2,1,4)
*          + M(5,2,1,6,3,4)*Mc(5,2,1,6,3,4)
** (exchange 1<-->5 and 2 <--> 4 then exchange 6 <--> 2 in treeE)	

     .   + G0g0(i1,i2,i3,i6,i5,i4)
*          + M(1,2,3,6,5,4)*Mc(5,4,3,6,1,2) = M(1,2,3,6,5,4)*Mc(1,2,5,4,3,6)
*          + M(5,4,3,6,1,2)*Mc(1,2,3,6,5,4) = M(1,2,5,4,3,6)*Mc(1,2,3,6,5,4)
     .   + G0g0(i1,i2,i5,i6,i3,i4)
*          + M(1,2,5,6,3,4)*Mc(5,6,1,2,3,4) = M(1,2,5,6,3,4)*Mc(1,2,3,4,5,6)
*          + M(5,6,1,2,3,4)*Mc(1,2,5,6,3,4) = M(1,2,3,4,5,6)*Mc(1,2,5,6,3,4)
     .   + G0g0(i1,i4,i3,i6,i5,i2)
*          + M(1,4,3,6,5,2)*Mc(5,2,3,6,1,4) = M(1,4,3,6,5,2)*Mc(1,4,5,2,3,6)
*          + M(5,2,3,6,1,4)*Mc(1,4,3,6,5,2) = M(1,4,5,2,3,6)*Mc(1,4,3,6,5,2)
     .   + G0g0(i1,i4,i3,i2,i5,i6)
*          + M(5,6,1,4,3,2)*Mc(5,6,3,2,1,4) = M(1,4,3,2,5,6)*Mc(1,4,5,6,3,2)
*          + M(5,6,3,2,1,4)*Mc(5,6,1,4,3,2) = M(1,4,5,6,3,2)*Mc(1,4,3,2,5,6)
     .   + G0g0(i1,i6,i5,i4,i3,i2)
*          + M(1,6,5,4,3,2)*Mc(1,6,3,2,5,4)
*          + M(1,6,3,2,5,4)*Mc(1,6,5,4,3,2)
     .   + G0g0(i1,i6,i5,i2,i3,i4)
*          + M(1,6,5,2,3,4)*Mc(5,2,1,6,3,4) = M(1,6,5,2,3,4)*Mc(1,6,3,4,5,2)
*          + M(5,2,1,6,3,4)*Mc(1,6,5,2,3,4) = M(1,6,3,4,5,2)*Mc(1,6,5,2,3,4)

     .   - 2d0*Gtt0g0(i1,i4,i3,i2,i5,i6)
*          - 2*Mtt(1,4,3,2,5,6)*Mttc(5,4,3,6,1,2) = - 2*Mtt(1,4,3,2,5,6)*Mttc(1,2,5,4,3,6)
*          - 2*Mtt(5,4,3,6,1,2)*Mttc(1,4,3,2,5,6) = - 2*Mtt(1,2,5,4,3,6)*Mttc(1,4,3,2,5,6)
     .   - 2d0*Gtt0g0(i1,i2,i3,i4,i5,i6)
*          - 2*Mtt(1,2,3,4,5,6)*Mttc(1,4,3,6,5,2) = - 2*Mtt(1,2,3,4,5,6)*Mttc(1,4,5,2,3,6)
*          - 2*Mtt(1,4,3,6,5,2)*Mttc(1,2,3,4,5,6) = - 2*Mtt(1,4,5,2,3,6)*Mttc(1,2,3,4,5,6)
     .   - 2d0*Gtt0g0(i1,i2,i5,i6,i3,i4)
*          - 2*Mtt(1,2,3,4,5,6)*Mttc(5,4,3,2,1,6) = - 2*Mtt(1,2,5,6,3,4)*Mttc(1,6,3,2,5,4)
*          - 2*Mtt(5,4,3,2,1,6)*Mttc(1,2,3,4,5,6) = - 2*Mtt(1,6,3,2,5,4)*Mttc(1,2,5,6,3,4)
     .   - 2d0*Gtt0g0(i1,i4,i5,i6,i3,i2)
*          - 2*Mtt(1,4,3,2,5,6)*Mttc(5,2,3,4,1,6) = - 2*Mtt(1,4,5,6,3,2)*Mttc(1,6,3,4,5,2)
*          - 2*Mtt(5,2,3,4,1,6)*Mttc(1,4,3,2,5,6) = - 2*Mtt(1,6,3,4,5,2)*Mttc(1,4,5,6,3,2)
     .   - 2d0*Gtt0g0(i1,i4,i3,i6,i5,i2)
*          - 2*Mtt(1,4,3,6,5,2)*Mttc(5,4,3,2,1,6) = - 2*Mtt(1,4,3,6,5,2)*Mttc(1,6,5,4,3,2)
*          - 2*Mtt(5,4,3,2,1,6)*Mttc(1,4,3,6,5,2) = - 2*Mtt(1,6,5,4,3,2)*Mttc(1,4,3,6,5,2)
     .   - 2d0*Gtt0g0(i1,i6,i5,i2,i3,i4)
*          - 2*Mtt(5,2,3,4,1,6)*Mttc(5,4,3,6,1,2) = - 2*Mtt(1,6,5,2,3,4)*Mttc(1,2,3,6,5,4)
*          - 2*Mtt(5,4,3,6,1,2)*Mttc(5,2,3,4,1,6) = - 2*Mtt(1,2,3,6,5,4)*Mttc(1,6,5,2,3,4)
*          )

     .   - 1d0/dble(nc)*(
     .   + F0g0(i1,i2,i3,i6,i5,i4)
     .   + F0g0(i5,i4,i1,i2,i3,i6)
     .   + F0g0(i3,i6,i5,i4,i1,i2)
     .   + F0g0(i5,i6,i3,i2,i1,i4)
     .   + F0g0(i3,i2,i1,i4,i5,i6)
     .   + F0g0(i1,i4,i5,i6,i3,i2)
*block A
     .   + F0g0(i1,i2,i5,i6,i3,i4)
     .   + F0g0(i3,i4,i1,i2,i5,i6)
     .   + F0g0(i5,i6,i3,i4,i1,i2)
     .   + F0g0(i3,i6,i5,i2,i1,i4)
     .   + F0g0(i5,i2,i1,i4,i3,i6)
     .   + F0g0(i1,i4,i3,i6,i5,i2)
*exchange 3 <--> 5 of block A
     .   + F0g0(i1,i6,i3,i2,i5,i4)
     .   + F0g0(i5,i4,i1,i6,i3,i2)
     .   + F0g0(i3,i2,i5,i4,i1,i6)
     .   + F0g0(i5,i2,i3,i6,i1,i4)
     .   + F0g0(i3,i6,i1,i4,i5,i2)
     .   + F0g0(i1,i4,i5,i2,i3,i6)
*exchange 2 <--> 6 of block A
     .   + F0g0(i1,i6,i5,i2,i3,i4)
     .   + F0g0(i3,i4,i1,i6,i5,i2)
     .   + F0g0(i5,i2,i3,i4,i1,i6)
     .   + F0g0(i3,i2,i5,i6,i1,i4)
     .   + F0g0(i5,i6,i1,i4,i3,i2)
     .   + F0g0(i1,i4,i3,i2,i5,i6)
*exchange 2 <--> 6 and 3 <--> 5 of block A
     .   + F0g0(i1,i6,i5,i4,i3,i2)
     .   + F0g0(i3,i2,i1,i6,i5,i4)
     .   + F0g0(i5,i4,i3,i2,i1,i6)
     .   + F0g0(i3,i4,i5,i6,i1,i2)
     .   + F0g0(i5,i6,i1,i2,i3,i4)
     .   + F0g0(i1,i2,i3,i4,i5,i6)
*exchange 2 <--> 6 and 3 <--> 5 then exchange 2 <--> 4 of block A
     .   + F0g0(i1,i6,i3,i4,i5,i2)
     .   + F0g0(i5,i2,i1,i6,i3,i4)
     .   + F0g0(i3,i4,i5,i2,i1,i6)
     .   + F0g0(i5,i4,i3,i6,i1,i2)
     .   + F0g0(i3,i6,i1,i2,i5,i4)
     .   + F0g0(i1,i2,i5,i4,i3,i6)
*exchange 2 <--> 6 then exchange 2 <--> 4 of block A
     .    )
*       + V * (
*          - (M(1,2,3,6,5,4) + M(5,6,3,2,1,4)) * (Mtc(1,6,5,2,3,4) + Mtc(3,4,1,6,5,2) + Mtc(5,2,1,6,3,4))
*          - (Mt(1,6,5,2,3,4) + Mt(3,4,1,6,5,2) + Mt(5,2,1,6,3,4)) * (Mc(1,2,3,6,5,4) + Mc(5,6,3,2,1,4))
*block A
*          - (M(1,2,5,6,3,4) + M(1,4,3,6,5,2)) * (Mtc(1,6,5,4,3,2) + Mtc(3,2,1,6,5,4) + Mtc(5,4,3,2,1,6))
*          - (Mt(1,6,5,4,3,2) + Mt(3,2,1,6,5,4) + Mt(5,4,3,2,1,6)) * (Mc(1,2,5,6,3,4) + Mc(1,4,3,6,5,2))
*exchange 3 <--> 5 of block A
*          - (M(1,6,3,2,5,4) + M(5,2,3,6,1,4)) * (Mtc(1,2,5,6,3,4) + Mtc(3,4,5,6,1,2) + Mtc(5,6,1,2,3,4))
*          - (Mt(1,2,5,6,3,4) + Mt(3,4,5,6,1,2) + Mt(5,6,1,2,3,4)) * (Mc(1,6,3,2,5,4) + Mc(5,2,3,6,1,4))
*exchange 2 <--> 6 of block A
*          - (M(1,6,5,2,3,4) + M(5,6,1,4,3,2)) * (Mtc(1,2,3,6,5,4) + Mtc(3,6,1,2,5,4) + Mtc(5,4,3,6,1,2))
*          - (Mt(1,2,3,6,5,4) + Mt(3,6,1,2,5,4) + Mt(5,4,3,6,1,2)) * (Mc(1,6,5,2,3,4) + Mc(5,6,1,4,3,2))
*exchange 2 <--> 6 and 3 <--> 5 of block A
*          - (M(1,6,5,4,3,2) + M(5,6,1,2,3,4)) * (Mtc(1,4,3,6,5,2) + Mtc(3,6,5,2,1,4) + Mtc(5,2,3,6,1,4))
*          - (Mt(1,4,3,6,5,2) + Mt(3,6,5,2,1,4) + Mt(5,2,3,6,1,4)) * (Mc(1,6,5,4,3,2) + Mc(5,6,1,2,3,4))
*exchange 2 <--> 6 and 3 <--> 5 then exchange 2 <--> 4 of block A
*          - (M(5,2,1,6,3,4) + M(5,4,3,6,1,2)) * (Mtc(1,4,3,2,5,6) + Mtc(3,2,5,6,1,4) + Mtc(5,6,1,4,3,2))
*          - (Mt(1,4,3,2,5,6) + Mt(3,2,5,6,1,4) + Mt(5,6,1,4,3,2)) * (Mc(5,2,1,6,3,4) + Mc(5,4,3,6,1,2))
*exchange 2 <--> 6 then exchange 2 <--> 4 of block A
*          )

     .   + (nc**2-1d0)/dble(nc**2)*(
     .   + 3d0*Gtt0g0(i1,i6,i5,i4,i3,i2)
     .   + 3d0*Gtt0g0(i1,i6,i3,i2,i5,i4)
     .   + 3d0*Gtt0g0(i1,i2,i3,i4,i5,i6)
     .   + 3d0*Gtt0g0(i1,i4,i5,i6,i3,i2)
     .   + 3d0*Gtt0g0(i1,i4,i3,i2,i5,i6)
     .   + 3d0*Gtt0g0(i1,i2,i3,i6,i5,i4)
     .    )
*       + N^-1*V^2 * (
*          + 3*Mtt(5,4,3,2,1,6)*Mttc(1,4,3,6,5,2) = + 3*Mtt(1,6,5,4,3,2)*Mttc(1,4,3,6,5,2)
*          + 3*Mtt(1,4,3,6,5,2)*Mttc(5,4,3,2,1,6) = + 3*Mtt(1,4,3,6,5,2)*Mttc(1,6,5,4,3,2)

*          + 3*Mtt(5,4,3,2,1,6)*Mttc(1,2,3,4,5,6) = + 3*Mtt(1,6,3,2,5,4)*Mttc(1,2,5,6,3,4)
*          + 3*Mtt(1,2,3,4,5,6)*Mttc(5,4,3,2,1,6) = + 3*Mtt(1,2,5,6,3,4)*Mttc(1,6,3,2,5,4)

*          + 3*Mtt(1,2,3,4,5,6)*Mttc(1,4,3,6,5,2) = + 3*Mtt(1,2,3,4,5,6)*Mttc(1,4,5,2,3,6)
*          + 3*Mtt(1,4,3,6,5,2)*Mttc(1,2,3,4,5,6) = + 3*Mtt(1,4,5,2,3,6)*Mttc(1,2,3,4,5,6)

*          + 3*Mtt(1,4,3,2,5,6)*Mttc(5,2,3,4,1,6) = + 3*Mtt(1,4,5,6,3,2)*Mttc(1,6,3,4,5,2)
*          + 3*Mtt(5,2,3,4,1,6)*Mttc(1,4,3,2,5,6) = + 3*Mtt(1,6,3,4,5,2)*Mttc(1,4,5,6,3,2)

*          + 3*Mtt(1,4,3,2,5,6)*Mttc(5,4,3,6,1,2) = + 3*Mtt(1,4,3,2,5,6)*Mttc(1,2,5,4,3,6)
*          + 3*Mtt(5,4,3,6,1,2)*Mttc(1,4,3,2,5,6) = + 3*Mtt(1,2,5,4,3,6)*Mttc(1,4,3,2,5,6)

*          + 3*Mtt(5,4,3,6,1,2)*Mttc(5,2,3,4,1,6) = + 3*Mtt(1,2,3,6,5,4)*Mttc(1,6,5,2,3,4)
*          + 3*Mtt(5,2,3,4,1,6)*Mttc(5,4,3,6,1,2) = + 3*Mtt(1,6,5,2,3,4)*Mttc(1,2,3,6,5,4)
*          )

     .   - (nc**2-1d0)**2/dble(nc**4)*(
     .   + Gtt0g0(i1,i2,i3,i4,i5,i6)
     .   + Gtt0g0(i1,i2,i5,i6,i3,i4)
     .   + Gtt0g0(i1,i4,i5,i6,i3,i2)
     .   + Gtt0g0(i1,i4,i3,i2,i5,i6)
     .   + Gtt0g0(i1,i4,i3,i6,i5,i2)
     .   + Gtt0g0(i1,i6,i5,i2,i3,i4)
     .    )
*       + N^-3*V^3 * (
*          - Mtt(1,2,3,4,5,6)*Mttc(1,4,3,6,5,2) =  - Mtt(1,2,3,4,5,6)*Mttc(1,4,5,2,3,6)
*          - Mtt(1,4,3,6,5,2)*Mttc(1,2,3,4,5,6) =  - Mtt(1,4,5,2,3,6)*Mttc(1,2,3,4,5,6)
                                                                        
*          - Mtt(1,2,3,4,5,6)*Mttc(5,4,3,2,1,6) =  - Mtt(1,2,5,6,3,4)*Mttc(1,6,3,2,5,4)
*          - Mtt(5,4,3,2,1,6)*Mttc(1,2,3,4,5,6) =  - Mtt(1,6,3,2,5,4)*Mttc(1,2,5,6,3,4)
                                                                        
*          - Mtt(1,4,3,2,5,6)*Mttc(5,2,3,4,1,6) =  - Mtt(1,4,5,6,3,2)*Mttc(1,6,3,4,5,2)
*          - Mtt(5,2,3,4,1,6)*Mttc(1,4,3,2,5,6) =  - Mtt(1,6,3,4,5,2)*Mttc(1,4,5,6,3,2)
                                                                        
*          - Mtt(1,4,3,2,5,6)*Mttc(5,4,3,6,1,2) =  - Mtt(1,4,3,2,5,6)*Mttc(1,2,5,4,3,6)
*          - Mtt(5,4,3,6,1,2)*Mttc(1,4,3,2,5,6) =  - Mtt(1,2,5,4,3,6)*Mttc(1,4,3,2,5,6)
                                                                        
*          - Mtt(1,4,3,6,5,2)*Mttc(5,4,3,2,1,6) =  - Mtt(1,4,3,6,5,2)*Mttc(1,6,5,4,3,2)
*          - Mtt(5,4,3,2,1,6)*Mttc(1,4,3,6,5,2) =  - Mtt(1,6,5,4,3,2)*Mttc(1,4,3,6,5,2)
                                                                        
*          - Mtt(5,2,3,4,1,6)*Mttc(5,4,3,6,1,2) =  - Mtt(1,6,5,2,3,4)*Mttc(1,2,3,6,5,4)
*          - Mtt(5,4,3,6,1,2)*Mttc(5,2,3,4,1,6) =  - Mtt(1,2,3,6,5,4)*Mttc(1,6,5,2,3,4)
*          )

     .   + (nc**2-1d0)/dble(nc)**3*(
     .   - Ft0g0(i1,i2,i3,i4,i5,i6)
     .   - Ft0g0(i5,i6,i3,i4,i1,i2)
     .   - Ft0g0(i5,i6,i1,i2,i3,i4)

     .   - Ft0g0(i3,i6,i5,i4,i1,i2)
     .   - Ft0g0(i1,i2,i5,i4,i3,i6)
     .   - Ft0g0(i3,i6,i1,i2,i5,i4)

     .   - Ft0g0(i3,i6,i5,i2,i1,i4)
     .   - Ft0g0(i5,i2,i1,i4,i3,i6)
     .   - Ft0g0(i3,i6,i1,i4,i5,i2)

     .   - Ft0g0(i3,i2,i5,i6,i1,i4)
     .   - Ft0g0(i5,i6,i1,i4,i3,i2)
     .   - Ft0g0(i1,i4,i3,i2,i5,i6)

     .   - Ft0g0(i1,i6,i5,i4,i3,i2)
     .   - Ft0g0(i3,i2,i1,i6,i5,i4)
     .   - Ft0g0(i5,i4,i3,i2,i1,i6)

     .   - Ft0g0(i1,i6,i5,i2,i3,i4)
     .   - Ft0g0(i1,i6,i3,i4,i5,i2)
     .   - Ft0g0(i5,i2,i3,i4,i1,i6)

     .   + 3d0*Ftt0g0(i1,i2,i3,i4,i5,i6)
     .   + 3d0*Ftt0g0(i5,i4,i3,i2,i1,i6)
     .   + 3d0*Ftt0g0(i1,i4,i3,i6,i5,i2)
     .   + 3d0*Ftt0g0(i1,i4,i5,i2,i3,i6)
     .   + 3d0*Ftt0g0(i1,i2,i5,i6,i3,i4)
     .   + 3d0*Ftt0g0(i5,i6,i3,i4,i1,i2)
     .   + 3d0*Ftt0g0(i1,i6,i5,i4,i3,i2)
     .   + 3d0*Ftt0g0(i3,i2,i1,i6,i5,i4)
     .   + 3d0*Ftt0g0(i3,i6,i5,i2,i1,i4)
     .    )
*       + N^-2*V^2 * (
*          + 3 *Mtt(1,2,3,4,5,6)*Mttc(1,4,3,2,5,6)
*          + 3 *Mtt(1,4,3,2,5,6)*Mttc(1,2,3,4,5,6)
*
*          + 3 *Mtt(5,4,3,2,1,6)*Mttc(5,2,3,4,1,6)
*          + 3 *Mtt(5,2,3,4,1,6)*Mttc(5,4,3,2,1,6)
*
*          + 3 *Mtt(1,4,3,6,5,2)*Mttc(5,2,3,4,1,6) = + 3 *Mtt(1,4,3,6,5,2)*Mttc(1,6,3,4,5,2)
*          + 3 *Mtt(5,2,3,4,1,6)*Mttc(1,4,3,6,5,2) = + 3 *Mtt(1,6,3,4,5,2)*Mttc(1,4,3,6,5,2)
*
*          + 3 *Mtt(1,4,3,6,5,2)*Mttc(5,4,3,6,1,2) = + 3 *Mtt(1,4,5,2,3,6)*Mttc(1,2,5,4,3,6)
*          + 3 *Mtt(5,4,3,6,1,2)*Mttc(1,4,3,6,5,2) = + 3 *Mtt(1,2,5,4,3,6)*Mttc(1,4,5,2,3,6)
*
*          + 3 *Mtt(1,2,3,4,5,6)*Mttc(5,2,3,4,1,6) = + 3 *Mtt(1,2,5,6,3,4)*Mttc(1,6,5,2,3,4)
*          + 3 *Mtt(5,2,3,4,1,6)*Mttc(1,2,3,4,5,6) = + 3 *Mtt(1,6,5,2,3,4)*Mttc(1,2,5,6,3,4)
*
*          + 3 *Mtt(1,2,3,4,5,6)*Mttc(5,4,3,6,1,2) = + 3 *Mtt(5,6,3,4,1,2)*Mttc(5,4,3,6,1,2)
*          + 3 *Mtt(5,4,3,6,1,2)*Mttc(1,2,3,4,5,6) = + 3 *Mtt(5,4,3,6,1,2)*Mttc(5,6,3,4,1,2)
*
*          + 3 *Mtt(5,4,3,2,1,6)*Mttc(1,4,3,2,5,6) = + 3 *Mtt(1,6,5,4,3,2)*Mttc(1,4,5,6,3,2)
*          + 3 *Mtt(1,4,3,2,5,6)*Mttc(5,4,3,2,1,6) = + 3 *Mtt(1,4,5,6,3,2)*Mttc(1,6,5,4,3,2)
*
*          + 3 *Mtt(5,4,3,2,1,6)*Mttc(5,4,3,6,1,2) = + 3 *Mtt(3,2,1,6,5,4)*Mttc(3,6,1,2,5,4)
*          + 3 *Mtt(5,4,3,6,1,2)*Mttc(5,4,3,2,1,6) = + 3 *Mtt(3,6,1,2,5,4)*Mttc(3,2,1,6,5,4)
*
*          + 3 *Mtt(1,4,3,6,5,2)*Mttc(1,4,3,2,5,6) = + 3 *Mtt(3,6,5,2,1,4)*Mttc(3,2,5,6,1,4)
*          + 3 *Mtt(1,4,3,2,5,6)*Mttc(1,4,3,6,5,2) = + 3 *Mtt(3,2,5,6,1,4)*Mttc(3,6,5,2,1,4)

*          - Mtt(1,2,3,4,5,6) * (Mtc(1,2,5,6,3,4) + Mtc(3,4,5,6,1,2) + Mtc(5,6,1,2,3,4))
*          - (Mt(5,6,1,2,3,4) + Mt(3,4,5,6,1,2) + Mt(1,2,5,6,3,4)) * Mttc(1,2,3,4,5,6)
*
*          - Mtt(5,4,3,6,1,2) * (Mtc(1,2,3,6,5,4) + Mtc(3,6,1,2,5,4) + Mtc(5,4,3,6,1,2))
*          - (Mt(3,6,1,2,5,4) + Mt(5,4,3,6,1,2) + Mt(1,2,3,6,5,4)) * Mttc(5,4,3,6,1,2)
*
*          - Mtt(1,4,3,6,5,2) * (Mtc(1,4,3,6,5,2) + Mtc(3,6,5,2,1,4) + Mtc(5,2,3,6,1,4))
*          - (Mt(3,6,5,2,1,4) + Mt(5,2,3,6,1,4) + Mt(1,4,3,6,5,2)) * Mttc(1,4,3,6,5,2)
*
*          - Mtt(1,4,3,2,5,6) * (Mtc(1,4,3,2,5,6) + Mtc(3,2,5,6,1,4) + Mtc(5,6,1,4,3,2))
*          - (Mt(5,6,1,4,3,2) + Mt(3,2,5,6,1,4) + Mt(1,4,3,2,5,6)) * Mttc(1,4,3,2,5,6)
*
*          - Mtt(5,4,3,2,1,6) * (Mtc(3,2,1,6,5,4) + Mtc(5,4,3,2,1,6) + Mtc(1,6,5,4,3,2))
*          - (Mt(5,4,3,2,1,6) + Mt(3,2,1,6,5,4) + Mt(1,6,5,4,3,2)) * Mttc(5,4,3,2,1,6)
*
*          - Mtt(5,2,3,4,1,6) * (Mtc(3,4,1,6,5,2) + Mtc(5,2,1,6,3,4) + Mtc(1,6,5,2,3,4))
*          - (Mt(3,4,1,6,5,2) + Mt(5,2,1,6,3,4) + Mt(1,6,5,2,3,4)) * Mttc(5,2,3,4,1,6)
*          )

     .   + 1d0/dble(nc)**2*(
     .   - 3d0*Ett0g0(i1,i2,i3,i4,i5,i6)
     .   - 3d0*Ett0g0(i1,i4,i3,i6,i5,i2)
     .   - 3d0*Ett0g0(i5,i4,i3,i6,i1,i2)
     .   - 3d0*Ett0g0(i1,i4,i3,i2,i5,i6)
     .   - 3d0*Ett0g0(i5,i2,i3,i4,i1,i6)
     .   - 3d0*Ett0g0(i5,i4,i3,i2,i1,i6)

     .   - Gta0g0(i1,i2,i3,i6,i5,i4)
     .   - Gta0g0(i1,i4,i3,i6,i5,i2)
     .   - Gta0g0(i1,i6,i3,i2,i5,i4)
     .   - Gta0g0(i1,i4,i5,i2,i3,i6)
     .   - Gta0g0(i1,i2,i5,i4,i3,i6)
     .   - Gta0g0(i1,i4,i5,i6,i3,i2)
     .   - Gta0g0(i1,i6,i5,i4,i3,i2)
     .   - Gta0g0(i1,i6,i5,i2,i3,i4)
     .   - Gta0g0(i1,i2,i5,i6,i3,i4)
     .   - Gta0g0(i1,i2,i3,i4,i5,i6)
     .   - Gta0g0(i1,i4,i3,i2,i5,i6)
     .   - Gta0g0(i1,i6,i3,i4,i5,i2)

     .   + Et0g0(i1,i6,i5,i2,i3,i4)
     .   + Et0g0(i5,i2,i3,i4,i1,i6)
     .   + Et0g0(i1,i6,i3,i4,i5,i2)
     .   + Et0g0(i3,i6,i5,i4,i1,i2)
     .   + Et0g0(i1,i2,i5,i4,i3,i6)
     .   + Et0g0(i3,i6,i1,i2,i5,i4)
     .   + Et0g0(i5,i6,i3,i4,i1,i2)
     .   + Et0g0(i5,i6,i1,i2,i3,i4)
     .   + Et0g0(i1,i2,i3,i4,i5,i6)
     .   + Et0g0(i3,i2,i5,i6,i1,i4)
     .   + Et0g0(i5,i6,i1,i4,i3,i2)
     .   + Et0g0(i1,i4,i3,i2,i5,i6)
     .   + Et0g0(i3,i6,i5,i2,i1,i4)
     .   + Et0g0(i5,i2,i1,i4,i3,i6)
     .   + Et0g0(i3,i6,i1,i4,i5,i2)
     .   + Et0g0(i5,i4,i3,i2,i1,i6)
     .   + Et0g0(i1,i6,i5,i4,i3,i2)
     .   + Et0g0(i3,i2,i1,i6,i5,i4)

     .   + Gtb0g0(i5,i2,i1,i6,i3,i4)
     .   + Gtb0g0(i1,i6,i5,i2,i3,i4)
     .   + Gtb0g0(i5,i2,i3,i4,i1,i6)
     .   + Gtb0g0(i3,i6,i5,i4,i1,i2)
     .   + Gtb0g0(i5,i4,i3,i6,i1,i2)
     .   + Gtb0g0(i5,i4,i1,i2,i3,i6)
     .   + Gtb0g0(i5,i6,i3,i4,i1,i2)
     .   + Gtb0g0(i3,i4,i5,i6,i1,i2)
     .   + Gtb0g0(i5,i6,i1,i2,i3,i4)
     .   + Gtb0g0(i3,i2,i5,i6,i1,i4)
     .   + Gtb0g0(i5,i6,i3,i2,i1,i4)
     .   + Gtb0g0(i5,i6,i1,i4,i3,i2)
     .   + Gtb0g0(i5,i4,i3,i2,i1,i6)
     .   + Gtb0g0(i3,i2,i5,i4,i1,i6)
     .   + Gtb0g0(i5,i4,i1,i6,i3,i2)
     .   + Gtb0g0(i3,i6,i5,i2,i1,i4)
     .   + Gtb0g0(i5,i2,i3,i6,i1,i4)
     .   + Gtb0g0(i5,i2,i1,i4,i3,i6)
     .    )
*       + N^-1*V * (
*          - 3*Mtt(1,2,3,4,5,6)*Mttc(1,2,3,4,5,6)
*          - 3*Mtt(1,4,3,6,5,2)*Mttc(1,4,3,6,5,2)
*          - 3*Mtt(5,4,3,6,1,2)*Mttc(5,4,3,6,1,2)
*          - 3*Mtt(1,4,3,2,5,6)*Mttc(1,4,3,2,5,6)
*          - 3*Mtt(5,2,3,4,1,6)*Mttc(5,2,3,4,1,6)
*          - 3*Mtt(5,4,3,2,1,6)*Mttc(5,4,3,2,1,6)
*
*          - M(1,2,3,6,5,4)*Mttc(5,2,3,4,1,6) = - M(1,2,3,6,5,4)*Mttc(1,6,5,2,3,4)
*          - Mtt(5,2,3,4,1,6)*Mc(1,2,3,6,5,4) = - Mtt(1,6,5,2,3,4)*Mc(1,2,3,6,5,4)
*
*          - M(1,4,3,6,5,2)*Mttc(5,4,3,2,1,6) = - M(1,4,3,6,5,2)*Mttc(1,6,5,4,3,2)
*          - Mtt(5,4,3,2,1,6)*Mc(1,4,3,6,5,2) = - Mtt(1,6,5,4,3,2)*Mc(1,4,3,6,5,2)
*
*          - M(1,6,3,2,5,4)*Mttc(1,2,3,4,5,6) = - M(1,6,3,2,5,4)*Mttc(1,2,5,6,3,4)
*          - Mtt(1,2,3,4,5,6)*Mc(1,6,3,2,5,4) = - Mtt(1,2,5,6,3,4)*Mc(1,6,3,2,5,4)
*                                                                                 
*          - M(5,2,3,6,1,4)*Mttc(1,2,3,4,5,6) = - M(1,4,5,2,3,6)*Mttc(1,2,3,4,5,6)
*          - Mtt(1,2,3,4,5,6)*Mc(5,2,3,6,1,4) = - Mtt(1,2,3,4,5,6)*Mc(1,4,5,2,3,6)
*                                                                                 
*          - M(5,4,3,6,1,2)*Mttc(1,4,3,2,5,6) = - M(1,2,5,4,3,6)*Mttc(1,4,3,2,5,6)
*          - Mtt(1,4,3,2,5,6)*Mc(5,4,3,6,1,2) = - Mtt(1,4,3,2,5,6)*Mc(1,2,5,4,3,6)
*                                                                                 
*          - M(5,6,3,2,1,4)*Mttc(5,2,3,4,1,6) = - M(1,4,5,6,3,2)*Mttc(1,6,3,4,5,2)
*          - Mtt(5,2,3,4,1,6)*Mc(5,6,3,2,1,4) = - Mtt(1,6,3,4,5,2)*Mc(1,4,5,6,3,2)
*                                                                                 
*          - M(1,6,5,4,3,2)*Mttc(1,4,3,6,5,2) = - M(1,6,5,4,3,2)*Mttc(1,4,3,6,5,2)
*          - Mtt(1,4,3,6,5,2)*Mc(1,6,5,4,3,2) = - Mtt(1,4,3,6,5,2)*Mc(1,6,5,4,3,2)
*                                                                                 
*          - M(1,6,5,2,3,4)*Mttc(5,4,3,6,1,2) = - M(1,6,5,2,3,4)*Mttc(1,2,3,6,5,4)
*          - Mtt(5,4,3,6,1,2)*Mc(1,6,5,2,3,4) = - Mtt(1,2,3,6,5,4)*Mc(1,6,5,2,3,4)
*                                                                                 
*          - M(1,2,5,6,3,4)*Mttc(5,4,3,2,1,6) = - M(1,2,5,6,3,4)*Mttc(1,6,3,2,5,4)
*          - Mtt(5,4,3,2,1,6)*Mc(1,2,5,6,3,4) = - Mtt(1,6,3,2,5,4)*Mc(1,2,5,6,3,4)
*                                                                                 
*          - M(5,6,1,2,3,4)*Mttc(1,4,3,6,5,2) = - M(1,2,3,4,5,6)*Mttc(1,4,5,2,3,6)
*          - Mtt(1,4,3,6,5,2)*Mc(5,6,1,2,3,4) = - Mtt(1,4,5,2,3,6)*Mc(1,2,3,4,5,6)
*                                                                                 
*          - M(5,6,1,4,3,2)*Mttc(5,4,3,6,1,2) = - M(1,4,3,2,5,6)*Mttc(1,2,5,4,3,6)
*          - Mtt(5,4,3,6,1,2)*Mc(5,6,1,4,3,2) = - Mtt(1,2,5,4,3,6)*Mc(1,4,3,2,5,6)
*                                                                                 
*          - M(5,2,1,6,3,4)*Mttc(1,4,3,2,5,6) = - M(1,6,3,4,5,2)*Mttc(1,4,5,6,3,2)
*          - Mtt(1,4,3,2,5,6)*Mc(5,2,1,6,3,4) = - Mtt(1,4,5,6,3,2)*Mc(1,6,3,4,5,2)
*
*
*          + Mt(3,4,1,6,5,2)*Mtc(3,4,1,6,5,2)
*          + Mt(1,6,5,2,3,4)*Mtc(1,6,5,2,3,4)
*          + Mt(5,2,1,6,3,4)*Mtc(5,2,1,6,3,4)
*          + Mt(1,2,3,6,5,4)*Mtc(1,2,3,6,5,4)
*          + Mt(3,6,1,2,5,4)*Mtc(3,6,1,2,5,4)
*          + Mt(5,4,3,6,1,2)*Mtc(5,4,3,6,1,2)
*          + Mt(1,2,5,6,3,4)*Mtc(1,2,5,6,3,4)
*          + Mt(3,4,5,6,1,2)*Mtc(3,4,5,6,1,2)
*          + Mt(5,6,1,2,3,4)*Mtc(5,6,1,2,3,4)
*          + Mt(1,4,3,2,5,6)*Mtc(1,4,3,2,5,6)
*          + Mt(3,2,5,6,1,4)*Mtc(3,2,5,6,1,4)
*          + Mt(5,6,1,4,3,2)*Mtc(5,6,1,4,3,2)
*          + Mt(1,4,3,6,5,2)*Mtc(1,4,3,6,5,2)
*          + Mt(3,6,5,2,1,4)*Mtc(3,6,5,2,1,4)
*          + Mt(5,2,3,6,1,4)*Mtc(5,2,3,6,1,4)
*          + Mt(1,6,5,4,3,2)*Mtc(1,6,5,4,3,2)
*          + Mt(3,2,1,6,5,4)*Mtc(3,2,1,6,5,4)
*          + Mt(5,4,3,2,1,6)*Mtc(5,4,3,2,1,6)
*
*
*          + Mt(3,4,1,6,5,2)*Mtc(5,2,1,6,3,4) = + Mt(3,4,5,2,1,6)*Mtc(5,2,1,6,3,4)
*          + Mt(5,2,1,6,3,4)*Mtc(3,4,1,6,5,2) = + Mt(5,2,1,6,3,4)*Mtc(3,4,5,2,1,6)
*                                                                                 
*          + Mt(3,4,1,6,5,2)*Mtc(1,6,5,2,3,4) 
*          + Mt(1,6,5,2,3,4)*Mtc(3,4,1,6,5,2) 
*                                                                                 
*          + Mt(1,6,5,2,3,4)*Mtc(5,2,1,6,3,4) = + Mt(1,6,5,2,3,4)*Mtc(5,2,3,4,1,6)
*          + Mt(5,2,1,6,3,4)*Mtc(1,6,5,2,3,4) = + Mt(5,2,3,4,1,6)*Mtc(1,6,5,2,3,4)
*                                                                                 
*          + Mt(1,2,3,6,5,4)*Mtc(3,6,1,2,5,4) = + Mt(1,2,3,6,5,4)*Mtc(3,6,5,4,1,2)
*          + Mt(3,6,1,2,5,4)*Mtc(1,2,3,6,5,4) = + Mt(3,6,5,4,1,2)*Mtc(1,2,3,6,5,4)
*                                                                                 
*          + Mt(1,2,3,6,5,4)*Mtc(5,4,3,6,1,2) = + Mt(1,2,5,4,3,6)*Mtc(5,4,3,6,1,2)
*          + Mt(5,4,3,6,1,2)*Mtc(1,2,3,6,5,4) = + Mt(5,4,3,6,1,2)*Mtc(1,2,5,4,3,6)
*                                                                                 
*          + Mt(3,6,1,2,5,4)*Mtc(5,4,3,6,1,2) = + Mt(3,6,5,4,1,2)*Mtc(5,4,1,2,3,6)
*          + Mt(5,4,3,6,1,2)*Mtc(3,6,1,2,5,4) = + Mt(5,4,1,2,3,6)*Mtc(3,6,5,4,1,2)
*                                                                                 
*          + Mt(1,2,5,6,3,4)*Mtc(5,6,1,2,3,4) = + Mt(1,2,5,6,3,4)*Mtc(5,6,3,4,1,2)
*          + Mt(5,6,1,2,3,4)*Mtc(1,2,5,6,3,4) = + Mt(5,6,3,4,1,2)*Mtc(1,2,5,6,3,4)
*                                                                                 
*          + Mt(1,2,5,6,3,4)*Mtc(3,4,5,6,1,2) = + Mt(1,2,3,4,5,6)*Mtc(3,4,5,6,1,2)
*          + Mt(3,4,5,6,1,2)*Mtc(1,2,5,6,3,4) = + Mt(3,4,5,6,1,2)*Mtc(1,2,3,4,5,6)
*                                                                                 
*          + Mt(3,4,5,6,1,2)*Mtc(5,6,1,2,3,4)
*          + Mt(5,6,1,2,3,4)*Mtc(3,4,5,6,1,2)
*                                                                                 
*          + Mt(1,4,3,2,5,6)*Mtc(3,2,5,6,1,4)
*          + Mt(3,2,5,6,1,4)*Mtc(1,4,3,2,5,6)
*                                                                                 
*          + Mt(1,4,3,2,5,6)*Mtc(5,6,1,4,3,2) = + Mt(1,4,5,6,3,2)*Mtc(5,6,1,4,3,2)
*          + Mt(5,6,1,4,3,2)*Mtc(1,4,3,2,5,6) = + Mt(5,6,1,4,3,2)*Mtc(1,4,5,6,3,2)
*                                                                                 
*          + Mt(3,2,5,6,1,4)*Mtc(5,6,1,4,3,2)
*          + Mt(5,6,1,4,3,2)*Mtc(3,2,5,6,1,4)
*                                                                                 
*          + Mt(1,6,5,4,3,2)*Mtc(5,4,3,2,1,6)
*          + Mt(5,4,3,2,1,6)*Mtc(1,6,5,4,3,2)
*                                                                                 
*          + Mt(1,6,5,4,3,2)*Mtc(3,2,1,6,5,4) = + Mt(1,6,3,2,5,4)*Mtc(3,2,5,4,1,6)
*          + Mt(3,2,1,6,5,4)*Mtc(1,6,5,4,3,2) = + Mt(3,2,5,4,1,6)*Mtc(1,6,3,2,5,4)
*                                                                                 
*          + Mt(3,2,1,6,5,4)*Mtc(5,4,3,2,1,6) = + Mt(3,2,5,4,1,6)*Mtc(5,4,1,6,3,2)
*          + Mt(5,4,3,2,1,6)*Mtc(3,2,1,6,5,4) = + Mt(5,4,1,6,3,2)*Mtc(3,2,5,4,1,6)
*                                                                                 
*          + Mt(1,4,3,6,5,2)*Mtc(3,6,5,2,1,4)
*          + Mt(3,6,5,2,1,4)*Mtc(1,4,3,6,5,2)
*                                                                                 
*          + Mt(1,4,3,6,5,2)*Mtc(5,2,3,6,1,4) = + Mt(1,4,5,2,3,6)*Mtc(5,2,3,6,1,4)
*          + Mt(5,2,3,6,1,4)*Mtc(1,4,3,6,5,2) = + Mt(5,2,3,6,1,4)*Mtc(1,4,5,2,3,6)
*                                                                                 
*          + Mt(3,6,5,2,1,4)*Mtc(5,2,3,6,1,4) = + Mt(3,6,5,2,1,4)*Mtc(5,2,1,4,3,6)
*          + Mt(5,2,3,6,1,4)*Mtc(3,6,5,2,1,4) = + Mt(5,2,1,4,3,6)*Mtc(3,6,5,2,1,4)
*          )

*      write(*,*)"testpoint, FullG0g0,i1,i2,i3,i4,i5,i6=",ip,wt,i1,i2,i3,i4,i5,i6

      wt = wt*fac

      FullG0g0detail=wt
      return
      end


************************************************************************
* full colour matrix element for six quark zero gluon two identical, one non-identical quark pairs
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)
* same as FullG0g0detail but using a compact form
      function FullG0g0compact(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0
      common /strong/ as
!$omp threadprivate(/strong/)
      dimension ztmp(6,4),tmp(6,4),tmp2(6,4)

c     write(*,*)"hello fullG0g0"

      fac=(4d0*pi*as)**4*(nc**2-1d0)*nc

      wt = FullG0g0(i1,i2,i3,i4,i5,i6)

      wt = wt*fac

      FullG0g0compact=wt
      return
      end

************************************************************************
* colour matrix element for full six quark zero gluon three identical quark pairs
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)
* used by FullG0g0compact
      function FullG0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0

      FullG0g0 =
     .   + FullF0g0(i1,i2,i3,i4,i5,i6)
     .   + FullF0g0(i1,i2,i3,i6,i5,i4)
     .   + FullF0g0(i1,i4,i3,i6,i5,i2)

     .   + FullF0g0only(i1,i2,i5,i4,i3,i6)
     .   + FullF0g0only(i1,i2,i5,i6,i3,i4)
     .   + FullF0g0only(i1,i4,i5,i6,i3,i2)
     .   + FullF0g0only(i3,i2,i5,i4,i1,i6)
     .   + FullF0g0only(i3,i2,i5,i6,i1,i4)
     .   + FullF0g0only(i3,i4,i5,i6,i1,i2)

     .   + FullG0g0only(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************
* colour matrix element for exclusive part of six quark zero gluon three identical quark pairs
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)
      function FullG0g0only(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)
      parameter(pi=3.141592653589793238d0)
      common /koppel/ nf,nc,b0

      FullG0g0only =
     .   + G0g0X(i1,i2,i3,i4,i5,i6)
     .   + 1d0/dble(nc)**2*Gt0g0X(i1,i2,i3,i4,i5,i6)
     .   - (nc**2+1d0)/nc**4*Gtt0g0X(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************
* sum of leading colour squared amplitudes
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)

      function G0g0X(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      G0g0X =
     .   + G0g0(i1,i2,i3,i6,i5,i4)
     .   + G0g0(i1,i4,i3,i6,i5,i2)
     .   + G0g0(i1,i4,i3,i2,i5,i6)
     .   + G0g0(i1,i2,i5,i6,i3,i4)
     .   + G0g0(i1,i6,i5,i2,i3,i4)
     .   + G0g0(i1,i6,i5,i4,i3,i2)
      return
      end

*XC Note that there is no single or double unresolved limits of G0g0X.
*XC One can check the definition of each G0g0 or numerical check the 
*XC weight of G0g0X in each single and double unresolved limits in the spike tests
************************************************************************
* sum of sub-leading colour squared amplitudes
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)

      function Gta0g0X(i1,i2,i3,i6,i5,i4)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Gta0g0X =
     .   + Gta0g0(i1,i2,i3,i6,i5,i4)
     .   + Gta0g0(i1,i6,i5,i2,i3,i4)
      return
      end

************************************************************************
* sum of sub-leading colour squared amplitudes
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)

      function Gtb0g0X(i5,i2,i1,i6,i3,i4)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Gtb0g0X =
     .   + Gtb0g0(i5,i2,i1,i6,i3,i4)
     .   + Gtb0g0(i1,i6,i5,i2,i3,i4)
     .   + Gtb0g0(i5,i2,i3,i4,i1,i6)
      return
      end

************************************************************************
* sum of sub-leading colour squared amplitudes
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)
      function Gt0g0X(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Gt0g0X =

     .   - Gta0g0X(i1,i4,i3,i6,i5,i2)
     .   - Gta0g0X(i1,i4,i5,i6,i3,i2)
     .   - Gta0g0X(i1,i2,i3,i6,i5,i4)
     .   - Gta0g0X(i1,i6,i3,i2,i5,i4)
     .   - Gta0g0X(i1,i4,i5,i2,i3,i6)
     .   - Gta0g0X(i1,i2,i5,i4,i3,i6)

     .   + Gtb0g0X(i1,i2,i3,i4,i5,i6)
     .   + Gtb0g0X(i1,i2,i3,i6,i5,i4)
     .   + Gtb0g0X(i1,i4,i3,i2,i5,i6)
     .   + Gtb0g0X(i1,i4,i3,i6,i5,i2)
     .   + Gtb0g0X(i1,i6,i5,i2,i3,i4)
     .   + Gtb0g0X(i1,i6,i5,i4,i3,i2)

      return
      end

*XC Note that there is no single unresolved limits of Gt0g0X. However,
*XC there is triple collinear limits of Gt0g0X which could be removed
*XC by C40 antenna functions.
************************************************************************
* sum of sub-sub-leading colour squared amplitudes
* (i1,i2),(i3,i4),(i5,i6) = (q,qb),(q,qb),(q,qb)

      function Gtt0g0X(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Gtt0g0X =
     .   + Gtt0g0(i1,i2,i3,i4,i5,i6)
     .   + Gtt0g0(i1,i4,i3,i2,i5,i6)
     .   + Gtt0g0(i1,i4,i5,i6,i3,i2)
     .   + Gtt0g0(i1,i6,i5,i4,i3,i2)
     .   + Gtt0g0(i1,i6,i3,i2,i5,i4)
     .   + Gtt0g0(i1,i2,i3,i6,i5,i4)
      return
      end

*XC Note that there is no single unresolved limits of Gtt0g0X. However,
*XC there is triple collinear limits of Gt0g0X which could be removed
*XC by C40 antenna functions.
************************************************************************
* G leading colour squared amplitude
* The four helicity combinations are (ztmpE1)
*       i1 i2 i3 i4 i5 i6
*ihel=1 +  -  +  -  +  -
*ihel   +  +  -  -  +  -  
*ihel   +  -  +  +  -  -  
*ihel   +  +  -  +  -  - 
* For easy comparison the corresponding ztmpE2 is
*       i1 i2 i5 i6 i3 i4
*ihel=1 +  -  +  -  +  - 
*ihel   +  +  +  -  -  -  = 0 
*ihel   +  -  -  -  +  +  = 0
*ihel   +  +  -  -  -  +  = 0

* The other one helicity combinations starting with
* q - is obtained by factor of 2 after modular square.
      function G0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      ztmpE1=zE0g0(i1,i2,i3,i4,i5,i6,1)
      ztmpE2=zE0g0(i1,i2,i5,i6,i3,i4,1)
      wt=wt+2d0*dreal(dconjg(ztmpE1)*ztmpE2)
*          + M(1,2,3,6,5,4)*Mc(5,4,3,6,1,2) = M(1,2,3,6,5,4)*Mc(1,2,5,4,3,6)
*          + M(5,4,3,6,1,2)*Mc(1,2,3,6,5,4) = M(1,2,5,4,3,6)*Mc(1,2,3,6,5,4)
      G0g0=2d0*wt

*XC G0g0 doesn't have any IR divergent limit. 

      return
      end

************************************************************************
* G sub-leading colour squared amplitude
* The four helicity combinations are (ztmpE)
*       i1 i2 i3 i4 i5 i6
*ihel=1 +  -  +  -  +  -
*ihel   +  +  -  -  +  -   
*ihel   +  -  +  +  -  -  
*ihel   +  +  -  +  -  -  
* For easy comparison the corresponding ztmpEtt is
*       i1 i4 i5 i2 i3 i6
*ihel=1 +  -  +  -  +  -
*ihel   +  -  +  +  -  -  = 0 
*ihel   +  +  -  -  +  -  = 0
*ihel   +  +  -  +  -  -  = 0

* The other one helicity combinations starting with
* q - is obtained by factor of 2 after modular square.
      function Gta0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      ztmpE  =zE0g0(i1,i2,i3,i4,i5,i6,1)
      ztmpEtt=zEtt0g0(i1,i4,i5,i2,i3,i6,1)
      wt=wt+2d0*dreal(dconjg(ztmpE)*ztmpEtt)
*           M(1,2,3,6,5,4)*Mttc(5,2,3,4,1,6) = M(1,2,3,6,5,4)*Mttc(1,6,5,2,3,4)
*           Mtt(5,2,3,4,1,6)*Mc(1,2,3,6,5,4) = Mtt(1,6,5,2,3,4)*Mc(1,2,3,6,5,4)
      Gta0g0=2d0*wt

*XC Gta0g0 doesn't have any IR divergent limit. 

      return
      end

************************************************************************
* G sub-leading colour squared amplitude
* The four helicity combinations are (ztmpEt1)
*       i1 i2 i3 i4 i5 i6
*ihel=1 +  -  +  -  +  -   
*ihel=2 +  +  -  -  +  -  
*ihel=3 +  -  +  -  -  +  
*ihel=4 +  +  -  -  -  +  
* For easy comparison the corresponding ztmpEt2 is
*       i3 i4 i5 i6 i1 i2 
*ihel=1 +  -  +  -  +  -   
*ihel=2 -  -  +  -  +  +  = 0
*ihel=3 +  -  -  +  +  -  = 0
*ihel=4 -  -  -  +  +  +  = 0

* The other one helicity combinations starting with
* q - is obtained by factor of 2 after modular square.
      function Gtb0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      ztmpEt1=zEt0g0(i1,i2,i3,i4,i5,i6,1)
      ztmpEt2=zEt0g0(i5,i6,i3,i4,i1,i2,1)
      wt=wt+2d0*dreal(dconjg(ztmpEt1)*ztmpEt2)
*          + Mt(3,4,1,6,5,2)*Mtc(1,6,5,2,3,4) = zEt0g0(1,6,5,2,3,4)*dconjg(zEt0g0(5,2,3,4,1,6))
*          + Mt(1,6,5,2,3,4)*Mtc(3,4,1,6,5,2) = zEt0g0(5,2,3,4,1,6)*dconjg(zEt0g0(1,6,5,2,3,4))
      Gtb0g0=2d0*wt

*XC Gtb0g0 doesn't have any IR divergent limit. 

      return
      end

************************************************************************
* G sub-sub-leading colour squared amplitude
* The four helicity combinations are (ztmpEtt1)
*       i1 i2 i3 i4 i5 i6
*ihel=1 +  -  +  -  +  - 
*ihel=2 +  -  -  +  +  -  
*ihel=3 +  -  +  -  -  +  
*ihel=4 +  -  -  +  -  +  
* For easy comparison the corresponding ztmpEtt2 is
*       i1 i4 i5 i2 i3 i6
*ihel=1 +  -  +  -  +  - 
*ihel=2 +  +  +  -  -  -  = 0
*ihel=3 +  -  -  -  +  +  = 0
*ihel=4 +  +  -  -  -  +  = 0
* The other one helicity combinations starting with
* q - is obtained by factor of 2 after modular square.
      function Gtt0g0(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      wt=0d0
      ztmpEtt1=zEtt0g0(i1,i2,i3,i4,i5,i6,1)
      ztmpEtt2=zEtt0g0(i1,i4,i5,i2,i3,i6,1)
      wt=wt+2d0*dreal(dconjg(ztmpEtt1)*ztmpEtt2)
*          Mtt(1,4,3,2,5,6)*Mttc(5,4,3,6,1,2) = Mtt(1,4,3,2,5,6)*Mttc(1,2,5,4,3,6)
*          Mtt(5,4,3,6,1,2)*Mttc(1,4,3,2,5,6) = Mtt(1,2,5,4,3,6)*Mttc(1,4,3,2,5,6)
      Gtt0g0=2d0*wt

*XC Gtt0g0 doesn't have any IR divergent limit. 

      return
      end
************************************************************************
* Wrapper function for full SLC level of FullG0g0
      function Gt0g0SLC(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Gt0g0SLC = Gt0g0X(i1,i2,i3,i4,i5,i6)
     .         - Gtt0g0X(i1,i2,i3,i4,i5,i6)

      return
      end
************************************************************************
* Wrapper function for full SSLC level of FullG0g0
      function Gtt0g0SSLC(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16(z)

      Gtt0g0SSLC = - Gtt0g0X(i1,i2,i3,i4,i5,i6)

      return
      end
************************************************************************

