!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!phasenewGGXX is very similiar to phasenewhXXX !!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!but replace Higgs mass with energy limits of the collider!!!!!!!!!!!!!
!!!!!!!!!!!!!!!Phase spce wedges and cuts are recycling the phasenewhXXX code!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase3GG(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4),pap(4),pbp(4),qp(4)
      dimension p1a(4),p2a(4),p3a(4)
      dimension p1ap(4),p2ap(4),p3ap(4)
      dimension p12(4),p12p(4)
      dimension pqa(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common /pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common /invar3/sij3(3,3),tij3(2,3)
!$omp threadprivate(/invar3/)
      common /pmomang3/pang3(4,3,2)
!$omp threadprivate(/pmomang3/)
      common /invarang3/sijang3(3,3,2),tijang3(2,3,2),iacc(2)
!$omp threadprivate(/invarang3/)
      common /nwa/rm12,rg12,inwa
      common /tcuts/ymin,y0
      common /mxdim/ mxdim
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase3GG", x(1), wt, ifail

      wtps = 1d0
      Nphase = 1

*
* phase space for 2->3 scattering, a+b -> 1+2+3 with q=p1+p2
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_3 = 1/256/pi**3*sab = 1.25982x10^-4*sab
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      ifail =1
      wt = 0d0

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3)))**2,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick(2,s12,s12min,s12max,r1,wtps)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the di-photon
      wtps = wtps/2d0/pi
      call p2generic_alt(4,r2,0d0,shat,rma2,rmb2,s12,rm2(3),
     .                   p12,p3,pa,pb,wtps)
      if(wtps.eq.0d0) return
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r3,wtps)
      call pick(1,phi,0d0,twopi,r4,wtps)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      call unboostrest(p12,ubmat)

      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         pang3(i,1,1) = p1(i)
         pang3(i,2,1) = p2(i)
         pang3(i,3,1) = p3(i)
      enddo

      if(p3(4).lt.0d0)then ! negative energy jets
         ifail=1
         return
      endif

      call fillinv(3,pang3(1:4,1:3,1),pa,pb,sijang3(1:3,1:3,1)
     .                                     ,tijang3(1:2,1:3,1))


 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 105  format('pa:',4f14.6)
 106  format('pb:',4f14.6)
 109  format('pp:',4f14.6)

      ifail =0
      wt = wtps

      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase4GG(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),v(4),v1(4),q(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),pap(4)
      dimension p1a(4),p2a(4),p3a(4),p4a(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4)
      dimension p12(4)
      dimension p34(4),p34p(4),p34g(4),papg(4),parb(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common /pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common /pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common /invar4/sij4(4,4),tij4(2,4)
!$omp threadprivate(/invar4/)
      common /pmomang4/pang4(4,4,4)
!$omp threadprivate(/pmomang4/)
      common /invarang4/sijang4(4,4,4),tijang4(2,4,4),iacc(4)
!$omp threadprivate(/invarang4/)
      common /nwa/rm12,rg12,inwa
      common /techpar/iang
      common /tcuts/ymin,y0
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase4GG", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=2
      else
         Nphase=4
         wtps=wtps/2d0
      endif

c---  corresponds to the phase space(3,4;a)

*
* phase space for 2->4 scattering, a+b -> 1+2+3+4 with q=p1+p2
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_4 = 1/24576/pi**5 = 1.32965643x10^-7
*

      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      ifail =1
      wt = 0d0

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3))-dsqrt(rm2(4)))**2
     .              ,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick(2,s12,s12min,s12max,r1,wtps)
      if(shat.lt.s12) return ! Insufficient scattering energy to produce the di-photon
      wtps = wtps/2d0/pi
      s34min = dmax1(y0*shat,(dsqrt(rm2(3))+dsqrt(rm2(4)))**2)
      s34max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s34min.ge.s34max) return
      call pick(10,s34,s34min,s34max,r2,wtps)
      wtps = wtps/2d0/pi
c      write(6,*) 'm1, s23',rm2(1),s23,s23min,s23max
      call p2generic_alt(3,r3,0d0,shat,rma2,rmb2,s12,s34,
     .                   p12,p34,pa,pb,wtps)
      if(wtps.eq.0d0) return

c      call pick(12,costh,-1d0,1d0,r4,wtps)
      call pickcos_alt(costh,r4,wtps)
      call pick(1,phi,0d0,twopi,r5,wtps)
      call makeps2com(s34,costh,phi,rm2(3),rm2(4),p3p,p4p,p3ap,p4ap)
      wtps = wtps*dsqrt(dlambda(s34,rm2(3),rm2(4)))/s34/32d0/pi**2


*****************************************

      call boostrest(p34,bmat)
      call unboostrest(p34,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p3(i) = 0d0
         p4(i) = 0d0
         p3a(i) = 0d0
         p4a(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
         enddo
      enddo

      if((p3(4).lt.0).or.(p3a(4).lt.0).or.(p4(4).lt.0).or.(p4a(4).lt.0))then
         ifail = 1
         return
      endif


      call pick(1,costh,-1d0,1d0,r6,wtps)

      call pick(1,phi,0d0,twopi,r7,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p1a(i) = p1(i)
         p2a(i) = p2(i)
         pang4(i,1,1) = p1(i)
         pang4(i,2,1) = p2(i)
         pang4(i,3,1) = p3(i)
         pang4(i,4,1) = p4(i)
         pang4(i,1,2) = p1a(i)
         pang4(i,2,2) = p2a(i)
         pang4(i,3,2) = p3a(i)
         pang4(i,4,2) = p4a(i)
      enddo

      call fillinv(4,p,pa,pb,sij4,tij4)
      do i=1,2
         call fillinv(4,pang4(1:4,1:4,i),pa,pb,sijang4(1:4,1:4,i)
     .                                        ,tijang4(1:2,1:4,i))
      enddo

      do i=1,2
         call acceptcuts4(sijang4(1:4,1:4,i),tijang4(1:2,1:4,i),iacc(i))
      enddo
      if (iacc(1)+iacc(2).eq.0) return
      ifail =0
      wt = wtps

c      write(6,101) p1(1:4)
c      write(6,102) v(1:4)
c      write(6,103) p3(1:4)
c      write(6,105) pa(1:4)
c      write(6,106) pb(1:4)
 101  format('p1:',4f14.6)
 102  format('p2:',4f14.6)
 103  format('p3:',4f14.6)
 105  format('pa:',4f14.6)
 106  format('pb:',4f14.6)

      return
      end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase5allGG(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          p3pp(4),p3app(4),papp(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p12(4),p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension parb(4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5allGG", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
      else
         Nphase=24
         wtps=wtps/4d0
      endif


* this is (3;4,5;a)
*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to pa axis
* (45)  system is rotated with respect to pa axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      r9 = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1


      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3)))**2,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick(2,s12,s12min,s12max,r1,wtps)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the di-photon
      wtps = wtps/2d0/pi
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r2,wtps)
      call pick(1,phi,0d0,twopi,r3,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s345max.le.s345min) return
      call pick(1,s345,s345min,s345max,r4,wtps)
      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
*      call pick(1,s45,s45min,s45max,r5,wtps)
*     sample log(s45)
      call pick(2,s45,s45min,s45max,r5,wtps)
      wtps = wtps/2d0/pi

      call p2generic_alt(2,r6,0d0,shat,0d0,0d0,s12,s345,
     .                   p12,p345,pa,pb,wtps)
      if(wtps.eq.0d0) return

      costhmin = -1d0
      costhmax = 1d0
      call pickcos(costh,y0,r7,wtps)

      call pick(1,phi,0d0,twopi,r8,wtps)
      call makeps2com(s345,costh,phi,rm2(3),s45,p3p,p45p,p3ap,p45ap)
      wtps = wtps*dsqrt(dlambda(s345,rm2(3),s45))/s345/32d0/pi**2

***********************************************

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      call pickcos_alt(costh,r9,wtps)
*      call pickcos(costh,y0,r9,wtps)

      call pick(1,phi,0d0,twopi,r10,wtps)
      call makeps2com(s45,costh,phi,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap)
      wtps = wtps*dsqrt(dlambda(s45,rm2(4),rm2(5)))/s45/32d0/pi**2

***********************************************


      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo


      if(p345(4).lt.0d0)then
         ifail = 1
         return
      endif

c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,1,1) = p1(i)
         pang5(i,2,1) = p2(i)
         pang5(i,3,1) = p3(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)

         pang5(i,1,2) = p1(i)
         pang5(i,2,2) = p2(i)
         pang5(i,3,2) = p3(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)

         pang5(i,1,3) = p1(i)
         pang5(i,2,3) = p2(i)
         pang5(i,3,3) = p3a(i)
         pang5(i,4,3) = p4t(i)
         pang5(i,5,3) = p5t(i)

         pang5(i,1,4) = p1(i)
         pang5(i,2,4) = p2(i)
         pang5(i,3,4) = p3a(i)
         pang5(i,4,4) = p4ta(i)
         pang5(i,5,4) = p5ta(i)
      enddo

      do i=1,4
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo

      do i=1,4
        call acceptcuts5all(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

      ifail =0
      wt = wtps

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase5aGG(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          p3pp(4),p3app(4),papp(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p12(4),p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      dimension parb(4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5aGG", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase=6
      else
         Nphase=24
         wtps=wtps/4d0
      endif

* this is (3;4,5;a)
*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to pa axis
* (45)  system is rotated with respect to p3 axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      r9 = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3)))**2,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick(2,s12,s12min,s12max,r1,wtps)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the di-photon
      wtps = wtps/2d0/pi
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r2,wtps)
      call pick(1,phi,0d0,twopi,r3,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s345max.le.s345min) return
      call pick(10,s345,s345min,s345max,r4,wtps)
      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
*      call pick(1,s45,s45min,s45max,r5,wtps)
*     sample log(s45)
      call pick(2,s45,s45min,s45max,r5,wtps)
      wtps = wtps/2d0/pi

      call p2generic_alt(2,r6,0d0,shat,0d0,0d0,s12,s345,
     .                   p12,p345,pa,pb,wtps)
      if(wtps.eq.0d0) return

      costhmin = -1d0
      costhmax = 1d0

      call pickcos(costh,y0,r7,wtps)

      call pick(1,phi,0d0,twopi,r8,wtps)
      call makeps2com(s345,costh,phi,rm2(3),s45,p3p,p45p,p3ap,p45ap)
      wtps = wtps*dsqrt(dlambda(s345,rm2(3),s45))/s345/32d0/pi**2

***********************************************

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      call pickcos_alt(costh,r9,wtps)

      call pick(1,phi,0d0,twopi,r10,wtps)
      call makeps2com(s45,costh,phi,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap)
      wtps = wtps*dsqrt(dlambda(s45,rm2(4),rm2(5)))/s45/32d0/pi**2

***********************************************


      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo


      if(p345(4).lt.0d0)then
         ifail = 1
         return
      endif

c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo

      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         papp(i) = 0d0
         do j=1,4
            papp(i) = papp(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(papp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,1,1) = p1(i)
         pang5(i,2,1) = p2(i)
         pang5(i,3,1) = p3(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)

         pang5(i,1,2) = p1(i)
         pang5(i,2,2) = p2(i)
         pang5(i,3,2) = p3(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)

         pang5(i,1,3) = p1(i)
         pang5(i,2,3) = p2(i)
         pang5(i,3,3) = p3a(i)
         pang5(i,4,3) = p4t(i)
         pang5(i,5,3) = p5t(i)

         pang5(i,1,4) = p1(i)
         pang5(i,2,4) = p2(i)
         pang5(i,3,4) = p3a(i)
         pang5(i,4,4) = p4ta(i)
         pang5(i,5,4) = p5ta(i)
      enddo

      do i=1,4
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo

      do i=1,4
        call acceptcuts5a(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo
      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return

      ifail =0
      wt = wtps


c
c      k10 = 1
c      write(6,101) pang5(1:4,1,k10)
c      write(6,102) pang5(1:4,2,k10)
c      write(6,103) pang5(1:4,3,k10)
c      write(6,104) pang5(1:4,4,k10)
c      write(6,105) pang5(1:4,5,k10)
c      write(6,106) pa(1:4)
c      write(6,107) pb(1:4)
c      write(6,109) v1(1:4)
c      write(6,*) q2/dot(q,q)
c

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine phase5bGG(x,wt,ifail)
      use Constants_mod, only : pi, twopi
      use Process_mod, only : s_proc
      use KinData_mod, only : boostrest,unboostrest,rotatetoz,unrotatetoz
      implicit real*8(a-h,o-z)
      dimension p1(4),p2(4),p3(4),p4(4),p5(4),v(4),q(4),v1(4)
      dimension p1p(4),p2p(4),p3p(4),p4p(4),p5p(4),pap(4),
     .          pbp(4),pbap(4)
      dimension parb(4),pbrb(4)
      dimension p1ap(4),p2ap(4),p3ap(4),p4ap(4),p5ap(4)
      dimension p3a(4),p4a(4),p5a(4)
      dimension p12(4),p345(4),p45p(4),p45(4)
      dimension p345p(4)
      dimension p45a(4),p45ap(4),p4t(4),p5t(4),p4ta(4),p5ta(4)
      dimension x(*)
      dimension bmat(4,4),ubmat(4,4),rmat(4,4),urmat(4,4),fmat(4,4)
      common/pmasses/rma2,rmb2,rm2(1:7),shat
!$omp threadprivate(/pmasses/)
      common /nwa/rm12,rg12,inwa
      common/pin/pa(4),pb(4)
!$omp threadprivate(/pin/)
      common/pmom/p(4,7)
!$omp threadprivate(/pmom/)
      common/pmomang5/pang5(4,5,4)
!$omp threadprivate(/pmomang5/)
      common/invar5/sij5(5,5),tij5(2,5)
!$omp threadprivate(/invar5/)
      common/invarang5/sijang5(5,5,4),tijang5(2,5,4),iacc(4)
!$omp threadprivate(/invarang5/)
      common/tcuts/ymin,y0
      common /techpar/iang
      common /Nphase/Nphase
!$omp threadprivate(/Nphase/)

cLIPS      print*, "phase5bGG", x(1), wt, ifail

      wtps = 1d0

      if(iang.eq.0)then
         Nphase = 6
      else
         Nphase = 24
         wtps=wtps/4d0
      endif


* this is (3;a;4,5;b)
*
* phase space for 2->5 scattering, a+b -> 1+2+3+4+5 with q=p1+p2
* with sequential splitting (345) -> 3+(45) -> 3+4+5
*
* (345) system is rotated with respect to pa axis
* (45)  system is rotated with respect to pb axis
*
* default momenta             : pang(i,j,1)
* (45) rotated                : pang(i,j,2)
* (345) rotated               : pang(i,j,3)
* (345) rotated, (45) rotated : pang(i,j,4)
*
* incoming momenta along z-axis, pa is +z
*
*
* massless case: integrates to P_5 = 1/4718592/pi**7*sab^3 = 0.7016789753e-10*sab^3
*
* incoming momenta along z-axis, pa is +z
*
      r1 = x(1)
      r2 = x(2)
      r3 = x(3)
      r4 = x(4)
      r5 = x(5)
      r6 = x(6)
      r7 = x(7)
      r8 = x(8)
      r9 = x(9)
      r10 = x(10)
      wt = 0d0
      ifail =1

      s12min = dmax1(y0*shat,(dsqrt(rm2(1))+dsqrt(rm2(2)))**2)
      s12max = dmin1((dsqrt(shat)-dsqrt(rm2(3)))**2,(1d0-y0)*shat)
      if (s12min.ge.s12max) return
      call pick(2,s12,s12min,s12max,r1,wtps)

      if(shat.lt.s12) return ! Insufficient scattering energy to produce the di-photon
      wtps = wtps/2d0/pi
      costhmin = -1d0
      costhmax = 1d0
      call pick(1,costh,costhmin,costhmax,r2,wtps)
      call pick(1,phi,0d0,twopi,r3,wtps)
      call makeps2com(s12,costh,phi,rm2(1),rm2(2),p1p,p2p,p1ap,p2ap)
      wtps = wtps*dsqrt(dlambda(s12,rm2(1),rm2(2)))/s12/32d0/pi**2

      s345min = dmax1(y0*shat,
     .           (dsqrt(rm2(3))+dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s345max = dmin1((dsqrt(shat)-dsqrt(s12))**2,(1d0-y0)*shat)
      if (s345max.le.s345min) return
      call pick(10,s345,s345min,s345max,r4,wtps)
      wtps = wtps/2d0/pi
      s45min = dmax1(y0*shat,(dsqrt(rm2(4))+dsqrt(rm2(5)))**2)
      s45max = dmin1(s345,(1d0-y0)*shat)
      if (s45max.le.s45min) return
      call pick(2,s45,s45min,s45max,r5,wtps)
      wtps = wtps/2d0/pi

      call p2generic_alt(2,r6,0d0,shat,0d0,0d0,s12,
     .                   s345,p12,p345,pa,pb,wtps)
      if(wtps.eq.0d0) return

      call pickcos(costh,y0,r7,wtps)

      call pick(1,phi,0d0,twopi,r8,wtps)
      call makeps2com(s345,costh,phi,rm2(3),s45,p3p,p45p,p3ap,p45ap)
      wtps = wtps*dsqrt(dlambda(s345,rm2(3),s45))/s345/32d0/pi**2

***********************************************

c---- rotate the (345) system
      call boostrest(p345,bmat)
      call unboostrest(p345,ubmat)
      do i=1,4
         v(i) = 0d0
         pap(i) = 0d0
         do j=1,4
            pap(i) = pap(i) + bmat(i,j)*pa(j)
         enddo
      enddo
      call unrotatetoz(pap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p3(i) = 0d0
         p45(i) = 0d0
         p3a(i) = 0d0
         p45a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p3(i) = p3(i) + fmat(i,j)*p3p(j)
            p45(i) = p45(i) + fmat(i,j)*p45p(j)
            p3a(i) = p3a(i) + fmat(i,j)*p3ap(j)
            p45a(i) = p45a(i) + fmat(i,j)*p45ap(j)
            v(i) = v(i) + fmat(i,j)*pap(j)
         enddo
      enddo

      call pickcos_alt(costh,r9,wtps)

      call pick(1,phi,0d0,twopi,r10,wtps)
      call makeps2com(s45,costh,phi,rm2(4),rm2(5),p4p,p5p,p4ap,p5ap)
      wtps = wtps*dsqrt(dlambda(s45,rm2(4),rm2(5)))/s45/32d0/pi**2

***********************************************

      call unboostrest(p12,ubmat)
      do i=1,4
         p1(i) = 0d0
         p2(i) = 0d0
         do j=1,4
            p1(i) = p1(i) + ubmat(i,j)*p1p(j)
            p2(i) = p2(i) + ubmat(i,j)*p2p(j)
         enddo
      enddo

      if(p345(4).lt.0d0)then
         ifail = 1
         return
      endif

c---- rotate the (45) system
      call boostrest(p45,bmat)
      call unboostrest(p45,ubmat)
      do i=1,4
         v(i) = 0d0
         pbp(i) = 0d0
         do j=1,4
            pbp(i) = pbp(i) + bmat(i,j)*pb(j)
         enddo
      enddo
      call unrotatetoz(pbp,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4(i) = 0d0
         p5(i) = 0d0
         p4a(i) = 0d0
         p5a(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4(i) = p4(i) + fmat(i,j)*p4p(j)
            p5(i) = p5(i) + fmat(i,j)*p5p(j)
            p4a(i) = p4a(i) + fmat(i,j)*p4ap(j)
            p5a(i) = p5a(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pbp(j)
         enddo
      enddo

c      write(6,107) v(1:4)

c---- rotate the (45ang) system
      call boostrest(p45a,bmat)
      call unboostrest(p45a,ubmat)
      do i=1,4
         v(i) = 0d0
         pbap(i) = 0d0
         do j=1,4
            pbap(i) = pbap(i) + bmat(i,j)*pb(j)
         enddo
      enddo
      call unrotatetoz(pbap,urmat)
      do i=1,4
         do j=1,4
            fmat(i,j) = 0d0
            do k=1,4
               fmat(i,j) = fmat(i,j)+ubmat(i,k)*urmat(k,j)
            enddo
         enddo
      enddo
      do i=1,4
         p4t(i) = 0d0
         p5t(i) = 0d0
         p4ta(i) = 0d0
         p5ta(i) = 0d0
         v(i) = 0d0
         do j=1,4
            p4t(i) = p4t(i) + fmat(i,j)*p4p(j)
            p5t(i) = p5t(i) + fmat(i,j)*p5p(j)
            p4ta(i) = p4ta(i) + fmat(i,j)*p4ap(j)
            p5ta(i) = p5ta(i) + fmat(i,j)*p5ap(j)
            v(i) = v(i) + fmat(i,j)*pbap(j)
         enddo
      enddo

      do i=1,4
         p(i,1) = p1(i)
         p(i,2) = p2(i)
         p(i,3) = p3(i)
         p(i,4) = p4(i)
         p(i,5) = p5(i)
         pang5(i,1,1) = p1(i)
         pang5(i,2,1) = p2(i)
         pang5(i,3,1) = p3(i)
         pang5(i,4,1) = p4(i)
         pang5(i,5,1) = p5(i)
         pang5(i,1,2) = p1(i)
         pang5(i,2,2) = p2(i)
         pang5(i,3,2) = p3(i)
         pang5(i,4,2) = p4a(i)
         pang5(i,5,2) = p5a(i)
         pang5(i,1,3) = p1(i)
         pang5(i,2,3) = p2(i)
         pang5(i,3,3) = p3a(i)
         pang5(i,4,3) = p4t(i)
         pang5(i,5,3) = p5t(i)
         pang5(i,1,4) = p1(i)
         pang5(i,2,4) = p2(i)
         pang5(i,3,4) = p3a(i)
         pang5(i,4,4) = p4ta(i)
         pang5(i,5,4) = p5ta(i)
      enddo

      do i=1,4
         call fillinv(5,pang5(1:4,1:5,i),pa,pb,sijang5(1:5,1:5,i)
     .                                        ,tijang5(1:2,1:5,i))
      enddo
      do i=1,4
        call acceptcuts5b(sijang5(1:5,1:5,i),tijang5(1:2,1:5,i),iacc(i),itechpass)
c        if(itechpass.eq.0) return ! failed a technical cut, bin the whole set
      enddo

      if (iacc(1)+iacc(2)+iacc(3)+iacc(4).eq.0) return


      ifail =0
      wt = wtps

 101  format('p1:',4f14.9)
 102  format('p2:',4f14.9)
 103  format('p3:',4f14.9)
 104  format('p4:',4f14.9)
 105  format('p5:',4f14.9)
 106  format('pa:',4f14.9)
 107  format('pb:',4f14.9)
 109  format('pp:',4f14.9)

      return
      end

