      function sigUDIS(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUDIS=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d em to em g d      
        if (qactive_chan(219).and.qselect_chan(219)) then
          current_chan = 219
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemB1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(220).and.qselect_chan(220)) then
          current_chan = 220
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemB1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(221).and.qselect_chan(221)) then
          current_chan = 221
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemB1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(222).and.qselect_chan(222)) then
          current_chan = 222
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemB1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(223).and.qselect_chan(223)) then
          current_chan = 223
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemB1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(224).and.qselect_chan(224)) then
          current_chan = 224
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemB1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(225).and.qselect_chan(225)) then
          current_chan = 225
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemB1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(226).and.qselect_chan(226)) then
          current_chan = 226
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemB1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(227).and.qselect_chan(227)) then
          current_chan = 227
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemB1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(228).and.qselect_chan(228)) then
          current_chan = 228
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemB1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(229).and.qselect_chan(229)) then
          current_chan = 229
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(230).and.qselect_chan(230)) then
          current_chan = 230
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemBt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(231).and.qselect_chan(231)) then
          current_chan = 231
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBt1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(232).and.qselect_chan(232)) then
          current_chan = 232
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemBt1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(233).and.qselect_chan(233)) then
          current_chan = 233
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBt1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(234).and.qselect_chan(234)) then
          current_chan = 234
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemBt1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(235).and.qselect_chan(235)) then
          current_chan = 235
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(236).and.qselect_chan(236)) then
          current_chan = 236
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemBt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(237).and.qselect_chan(237)) then
          current_chan = 237
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(238).and.qselect_chan(238)) then
          current_chan = 238
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemBt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(239).and.qselect_chan(239)) then
          current_chan = 239
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBtt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(240).and.qselect_chan(240)) then
          current_chan = 240
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemBtt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(241).and.qselect_chan(241)) then
          current_chan = 241
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBtt1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(242).and.qselect_chan(242)) then
          current_chan = 242
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemBtt1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(243).and.qselect_chan(243)) then
          current_chan = 243
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBtt1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(244).and.qselect_chan(244)) then
          current_chan = 244
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemBtt1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(245).and.qselect_chan(245)) then
          current_chan = 245
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBtt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(246).and.qselect_chan(246)) then
          current_chan = 246
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemBtt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(247).and.qselect_chan(247)) then
          current_chan = 247
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBtt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(248).and.qselect_chan(248)) then
          current_chan = 248
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemBtt1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(249).and.qselect_chan(249)) then
          current_chan = 249
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(250).and.qselect_chan(250)) then
          current_chan = 250
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemBh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(251).and.qselect_chan(251)) then
          current_chan = 251
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBh1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(252).and.qselect_chan(252)) then
          current_chan = 252
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemBh1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(253).and.qselect_chan(253)) then
          current_chan = 253
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBh1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(254).and.qselect_chan(254)) then
          current_chan = 254
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemBh1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(255).and.qselect_chan(255)) then
          current_chan = 255
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(256).and.qselect_chan(256)) then
          current_chan = 256
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemBh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(257).and.qselect_chan(257)) then
          current_chan = 257
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(258).and.qselect_chan(258)) then
          current_chan = 258
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemBh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(259).and.qselect_chan(259)) then
          current_chan = 259
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBht1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(260).and.qselect_chan(260)) then
          current_chan = 260
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemBht1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(261).and.qselect_chan(261)) then
          current_chan = 261
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBht1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(262).and.qselect_chan(262)) then
          current_chan = 262
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemBht1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(263).and.qselect_chan(263)) then
          current_chan = 263
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBht1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(264).and.qselect_chan(264)) then
          current_chan = 264
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemBht1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(265).and.qselect_chan(265)) then
          current_chan = 265
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBht1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(266).and.qselect_chan(266)) then
          current_chan = 266
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemBht1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(267).and.qselect_chan(267)) then
          current_chan = 267
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBht1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(268).and.qselect_chan(268)) then
          current_chan = 268
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemBht1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(269).and.qselect_chan(269)) then
          current_chan = 269
          ip1_chan     = 10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBhh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(270).and.qselect_chan(270)) then
          current_chan = 270
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qemBhh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(271).and.qselect_chan(271)) then
          current_chan = 271
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBhh1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(272).and.qselect_chan(272)) then
          current_chan = 272
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = gemBhh1g2ZDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(273).and.qselect_chan(273)) then
          current_chan = 273
          ip1_chan     = -10
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBhh1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(274).and.qselect_chan(274)) then
          current_chan = 274
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qbemBhh1g2ZDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(275).and.qselect_chan(275)) then
          current_chan = 275
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBhh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(276).and.qselect_chan(276)) then
          current_chan = 276
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpemBhh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(277).and.qselect_chan(277)) then
          current_chan = 277
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBhh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(278).and.qselect_chan(278)) then
          current_chan = 278
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = qpbemBhh1g2ZDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUDIS=sigUDIS+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
