      subroutine getqcdnormOLDIS1j(ix, partons, factor, npar, ipass, flav_block)
      use Constants_mod
      use Process_mod
      use Channels_mod
      use Scales_mod
      use Parameters_mod
      use LIPS_mod
      integer, intent(in) :: ix, npar, flav_block
      integer, intent(inout) :: ipass
      real(8), intent(out), dimension(nMax_scl) :: partons, factor
      double precision nc, nf, nup, ndown, qnf
      parameter(nc=3d0)
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      parameter(qnf=0.333333333333333333d0)
      
      ilips = 1
      if (isActive_reduce_lips()) then
        ilips = LIPSwgtDIS1j(current_chan)
        if (ilips == 0) then
          ipass = 0
          return
        end if
      end if
      
      
      call ecuts_dis1j(1,npar,ipass)
      if (ipass==0) return
      
      call get_lumi_scl(ix, ip1_chan, ip2_chan, partons)
      
      select case (current_chan)

c -- tree level


c -- real


c -- virtual


c -- double real


c -- real virtual


c -- double virtual

      case default
         factor=0d0
      end select
      
      factor = ilips * factor
      

      return
      end
