      function sigSNLODIS1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLODIS1j=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- d em to em g d      
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = 10
        ip2_chan     = 99
        nfB1 = 1
        wt = qemB1g0ZDIS1jSNLO(1,4,5,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to em g u      
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 2
        wt = qemB1g0ZDIS1jSNLO(1,4,5,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to em db d     
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        wt = gemB1g0ZDIS1jSNLO(4,1,5,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to em ub u     
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 2
        wt = gemB1g0ZDIS1jSNLO(4,1,5,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to em db g    
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = -10
        ip2_chan     = 99
        nfB1 = 1
        wt = qbemB1g0ZDIS1jSNLO(4,5,1,3,2)
        wtsum = wtsum + wt
      endif
c--- ub em to em ub g    
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = -20
        ip2_chan     = 99
        nfB1 = 2
        wt = qbemB1g0ZDIS1jSNLO(4,5,1,3,2)
        wtsum = wtsum + wt
      endif
      sigSNLODIS1j=sigSNLODIS1j+rnorm*wtsum

      return
      end
