      function sigTDIS1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTDIS1j=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d em to em g d      
        if (qactive_chan(45).and.qselect_chan(45)) then
          current_chan = 45
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemcsB1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(46).and.qselect_chan(46)) then
          current_chan = 46
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemcsB1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(47).and.qselect_chan(47)) then
          current_chan = 47
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemcsB1g1ZDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(48).and.qselect_chan(48)) then
          current_chan = 48
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemcsB1g1ZDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(49).and.qselect_chan(49)) then
          current_chan = 49
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemcsB1g1ZDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(50).and.qselect_chan(50)) then
          current_chan = 50
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemcsB1g1ZDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(51).and.qselect_chan(51)) then
          current_chan = 51
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemcsB1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(52).and.qselect_chan(52)) then
          current_chan = 52
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemcsB1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(53).and.qselect_chan(53)) then
          current_chan = 53
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemcsB1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(54).and.qselect_chan(54)) then
          current_chan = 54
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemcsB1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(55).and.qselect_chan(55)) then
          current_chan = 55
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemcsBt1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(56).and.qselect_chan(56)) then
          current_chan = 56
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemcsBt1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(57).and.qselect_chan(57)) then
          current_chan = 57
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemcsBt1g1ZDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(58).and.qselect_chan(58)) then
          current_chan = 58
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemcsBt1g1ZDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(59).and.qselect_chan(59)) then
          current_chan = 59
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemcsBt1g1ZDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(60).and.qselect_chan(60)) then
          current_chan = 60
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemcsBt1g1ZDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(61).and.qselect_chan(61)) then
          current_chan = 61
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemcsBt1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(62).and.qselect_chan(62)) then
          current_chan = 62
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemcsBt1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(63).and.qselect_chan(63)) then
          current_chan = 63
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemcsBt1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(64).and.qselect_chan(64)) then
          current_chan = 64
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemcsBt1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em to em g d      
        if (qactive_chan(65).and.qselect_chan(65)) then
          current_chan = 65
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemcsBh1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em g u      
        if (qactive_chan(66).and.qselect_chan(66)) then
          current_chan = 66
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemcsBh1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em db d     
        if (qactive_chan(67).and.qselect_chan(67)) then
          current_chan = 67
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemcsBh1g1ZDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to em ub u     
        if (qactive_chan(68).and.qselect_chan(68)) then
          current_chan = 68
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemcsBh1g1ZDIS1jT(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db g    
        if (qactive_chan(69).and.qselect_chan(69)) then
          current_chan = 69
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemcsBh1g1ZDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub g    
        if (qactive_chan(70).and.qselect_chan(70)) then
          current_chan = 70
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemcsBh1g1ZDIS1jT(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(71).and.qselect_chan(71)) then
          current_chan = 71
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemcsBh1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(72).and.qselect_chan(72)) then
          current_chan = 72
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemcsBh1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(73).and.qselect_chan(73)) then
          current_chan = 73
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemcsBh1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(74).and.qselect_chan(74)) then
          current_chan = 74
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemcsBh1g1ZDIS1jT(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTDIS1j=sigTDIS1j+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
