      function sigTNLODIS1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLODIS1j=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d em to em d        
        if (qactive_chan(11).and.qselect_chan(11)) then
          current_chan = 11
          ip1_chan     = 10
          ip2_chan     = 99
          nfB1 = 1
          wt = qemB0g1ZDIS1jTNLO(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to em u        
        if (qactive_chan(12).and.qselect_chan(12)) then
          current_chan = 12
          ip1_chan     = 20
          ip2_chan     = 99
          nfB1 = 2
          wt = qemB0g1ZDIS1jTNLO(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to em db      
        if (qactive_chan(13).and.qselect_chan(13)) then
          current_chan = 13
          ip1_chan     = -10
          ip2_chan     = 99
          nfB1 = 1
          wt = qbemB0g1ZDIS1jTNLO(ix,xri1,xri2,4,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em to em ub      
        if (qactive_chan(14).and.qselect_chan(14)) then
          current_chan = 14
          ip1_chan     = -20
          ip2_chan     = 99
          nfB1 = 2
          wt = qbemB0g1ZDIS1jTNLO(ix,xri1,xri2,4,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(15).and.qselect_chan(15)) then
          current_chan = 15
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpemB0g1ZDIS1jTNLO(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(16).and.qselect_chan(16)) then
          current_chan = 16
          ip1_chan     = 30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpemB0g1ZDIS1jTNLO(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(17).and.qselect_chan(17)) then
          current_chan = 17
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 1
          wt = qpbemB0g1ZDIS1jTNLO(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(18).and.qselect_chan(18)) then
          current_chan = 18
          ip1_chan     = -30
          ip2_chan     = 99
          nfB1 = 2
          wt = qpbemB0g1ZDIS1jTNLO(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(19).and.qselect_chan(19)) then
          current_chan = 19
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 1
          wt = gemB0g1ZDIS1jTNLO(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em initiated      
        if (qactive_chan(20).and.qselect_chan(20)) then
          current_chan = 20
          ip1_chan     = 0
          ip2_chan     = 99
          nfB1 = 2
          wt = gemB0g1ZDIS1jTNLO(ix,xri1,xri2,1,4,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLODIS1j=sigTNLODIS1j+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
