#ifdef FLAVDISWp

      integer function max_nflavourDISWp()
        use Channels_mod, only: qactive_chan, ntot_chan
        implicit none
        integer ip, nflavourDISWp
        max_nflavourDISWp = 0
        do ip=1,ntot_chan
            if (.not.qactive_chan(ip)) cycle
            max_nflavourDISWp =  max(max_nflavourDISWp, nflavourDISWp(ip))
        end do
      end function max_nflavourDISWp


      integer function nflavourDISWp(ip)
        implicit none
        integer, intent(in) :: ip
        select case(ip)
c--- d ep to enub g u
        case(1)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(2)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(3)
          nflavourDISWp = 2
c--- d ep to enub g g u
        case(4)
          nflavourDISWp = 2
c--- g ep to enub db g u
        case(5)
          nflavourDISWp = 2
c--- ub ep to enub db g g
        case(6)
          nflavourDISWp = 2
c--- d ep to enub gt gt u
        case(7)
          nflavourDISWp = 2
c--- gt ep to enub db gt u
        case(8)
          nflavourDISWp = 2
c--- ub ep to enub db gt gt
        case(9)
          nflavourDISWp = 2
c--- d ep to enub Q Qb u
        case(10)
          nflavourDISWp = 10
c--- Qb ep to enub db Qb u
        case(11)
          nflavourDISWp = 0
c--- Q ep to enub db Q u
        case(12)
          nflavourDISWp = 0
c--- ub ep to enub db Q Qb
        case(13)
          nflavourDISWp = 10
c--- d ep to enub d db u
        case(14)
          nflavourDISWp = 2
c--- db ep to enub db db u
        case(15)
          nflavourDISWp = 2
c--- ub ep to enub db d db
        case(16)
          nflavourDISWp = 2
c--- d ep to enub u ub u
        case(17)
          nflavourDISWp = 2
c--- ub ep to enub db ub u
        case(18)
          nflavourDISWp = 2
c--- u ep to enub db u u
        case(19)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(20)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(21)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(22)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(25)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(26)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(27)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(30)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(31)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(32)
          nflavourDISWp = 2
c--- d ep to enub g g g u
        case(35)
          nflavourDISWp = 2
c--- g ep to enub db g g u
        case(36)
          nflavourDISWp = 2
c--- ub ep to enub db g g g
        case(37)
          nflavourDISWp = 2
c--- d ep to enub g g g u
        case(38)
          nflavourDISWp = 2
c--- g ep to enub db g g u
        case(39)
          nflavourDISWp = 2
c--- ub ep to enub db g g g
        case(40)
          nflavourDISWp = 2
c--- d ep to enub gt gt gt u
        case(41)
          nflavourDISWp = 2
c--- gt ep to enub db gt gt u
        case(42)
          nflavourDISWp = 2
c--- ub ep to enub db gt gt gt
        case(43)
          nflavourDISWp = 2
c--- d ep to enub g Q Qb u
        case(44)
          nflavourDISWp = 10
c--- g ep to enub db Q Qb u
        case(45)
          nflavourDISWp = 10
c--- Qb ep to enub db g Qb u
        case(46)
          nflavourDISWp = 0
c--- Q ep to enub db g Q u
        case(47)
          nflavourDISWp = 0
c--- ub ep to enub db g Q Qb
        case(48)
          nflavourDISWp = 10
c--- d ep to enub g Q Qb u
        case(49)
          nflavourDISWp = 10
c--- g ep to enub db Q Qb u
        case(50)
          nflavourDISWp = 10
c--- Qb ep to enub db g Qb u
        case(51)
          nflavourDISWp = 0
c--- Q ep to enub db g Q u
        case(52)
          nflavourDISWp = 0
c--- ub ep to enub db g Q Qb
        case(53)
          nflavourDISWp = 10
c--- d ep to enub g d db u
        case(54)
          nflavourDISWp = 2
c--- g ep to enub db d db u
        case(55)
          nflavourDISWp = 2
c--- db ep to enub db g db u
        case(56)
          nflavourDISWp = 2
c--- ub ep to enub db g d db
        case(57)
          nflavourDISWp = 2
c--- d ep to enub g u ub u
        case(58)
          nflavourDISWp = 2
c--- g ep to enub db u ub u
        case(59)
          nflavourDISWp = 2
c--- ub ep to enub db g ub u
        case(60)
          nflavourDISWp = 2
c--- u ep to enub db g u u
        case(61)
          nflavourDISWp = 2
c--- d ep to enub g d db u
        case(62)
          nflavourDISWp = 2
c--- g ep to enub db d db u
        case(63)
          nflavourDISWp = 2
c--- db ep to enub db g db u
        case(64)
          nflavourDISWp = 2
c--- ub ep to enub db g d db
        case(65)
          nflavourDISWp = 2
c--- d ep to enub g u ub u
        case(66)
          nflavourDISWp = 2
c--- g ep to enub db u ub u
        case(67)
          nflavourDISWp = 2
c--- ub ep to enub db g ub u
        case(68)
          nflavourDISWp = 2
c--- u ep to enub db g u u
        case(69)
          nflavourDISWp = 2
c--- d ep to enub g g u
        case(70)
          nflavourDISWp = 2
c--- g ep to enub db g u
        case(71)
          nflavourDISWp = 2
c--- ub ep to enub db g g
        case(72)
          nflavourDISWp = 2
c--- d ep to enub gt gt u
        case(75)
          nflavourDISWp = 2
c--- gt ep to enub db gt u
        case(76)
          nflavourDISWp = 2
c--- ub ep to enub db gt gt
        case(77)
          nflavourDISWp = 2
c--- d ep to enub gt gt u
        case(80)
          nflavourDISWp = 2
c--- gt ep to enub db gt u
        case(81)
          nflavourDISWp = 2
c--- ub ep to enub db gt gt
        case(82)
          nflavourDISWp = 2
c--- d ep to enub g g u
        case(85)
          nflavourDISWp = 2
c--- g ep to enub db g u
        case(86)
          nflavourDISWp = 2
c--- ub ep to enub db g g
        case(87)
          nflavourDISWp = 2
c--- d ep to enub gt gt u
        case(90)
          nflavourDISWp = 2
c--- gt ep to enub db gt u
        case(91)
          nflavourDISWp = 2
c--- ub ep to enub db gt gt
        case(92)
          nflavourDISWp = 2
c--- d ep to enub Q Qb u
        case(95)
          nflavourDISWp = 10
c--- Qb ep to enub db Qb u
        case(96)
          nflavourDISWp = 0
c--- Q ep to enub db Q u
        case(97)
          nflavourDISWp = 0
c--- ub ep to enub db Q Qb
        case(98)
          nflavourDISWp = 10
c--- d ep to enub Q Qb u
        case(100)
          nflavourDISWp = 10
c--- Qb ep to enub db Qb u
        case(101)
          nflavourDISWp = 0
c--- Q ep to enub db Q u
        case(102)
          nflavourDISWp = 0
c--- ub ep to enub db Q Qb
        case(103)
          nflavourDISWp = 10
c--- d ep to enub Q Qb u
        case(105)
          nflavourDISWp = 10
c--- Qb ep to enub db Qb u
        case(106)
          nflavourDISWp = 0
c--- Q ep to enub db Q u
        case(107)
          nflavourDISWp = 0
c--- ub ep to enub db Q Qb
        case(108)
          nflavourDISWp = 10
c--- d ep to enub d db u
        case(110)
          nflavourDISWp = 2
c--- db ep to enub db db u
        case(111)
          nflavourDISWp = 2
c--- ub ep to enub db d db
        case(112)
          nflavourDISWp = 2
c--- d ep to enub u ub u
        case(114)
          nflavourDISWp = 2
c--- ub ep to enub db ub u
        case(115)
          nflavourDISWp = 2
c--- u ep to enub db u u
        case(116)
          nflavourDISWp = 2
c--- d ep to enub d db u
        case(118)
          nflavourDISWp = 2
c--- db ep to enub db db u
        case(119)
          nflavourDISWp = 2
c--- ub ep to enub db d db
        case(120)
          nflavourDISWp = 2
c--- d ep to enub u ub u
        case(122)
          nflavourDISWp = 2
c--- ub ep to enub db ub u
        case(123)
          nflavourDISWp = 2
c--- u ep to enub db u u
        case(124)
          nflavourDISWp = 2
c--- d ep to enub d db u
        case(126)
          nflavourDISWp = 2
c--- db ep to enub db db u
        case(127)
          nflavourDISWp = 2
c--- ub ep to enub db d db
        case(128)
          nflavourDISWp = 2
c--- d ep to enub u ub u
        case(130)
          nflavourDISWp = 2
c--- ub ep to enub db ub u
        case(131)
          nflavourDISWp = 2
c--- u ep to enub db u u
        case(132)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(134)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(135)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(136)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(141)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(142)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(143)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(148)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(149)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(150)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(155)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(156)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(157)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(162)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(163)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(164)
          nflavourDISWp = 2
c--- d ep to enub g u
        case(169)
          nflavourDISWp = 2
c--- g ep to enub db u
        case(170)
          nflavourDISWp = 2
c--- ub ep to enub db g
        case(171)
          nflavourDISWp = 2
        end select
      end function nflavourDISWp


      double precision function relfacflavourDISWp(ip)
        implicit none
        integer, intent(in) :: ip
        double precision nf, nup, ndown
        parameter(nf=5d0)
        parameter(nup=2d0)
        parameter(ndown=3d0)
        select case(ip)
c--- g ep to enub db u 
        case(2)
          relfacflavourDISWp = nup
c--- g ep to enub db g u 
        case(5)
          relfacflavourDISWp = nup
c--- gt ep to enub db gt u 
        case(8)
          relfacflavourDISWp = nup
c--- d ep to enub Q Qb u 
        case(10)
          relfacflavourDISWp = nf
c--- Qb ep to enub db Qb u 
        case(11)
          relfacflavourDISWp = nup
c--- Q ep to enub db Q u 
        case(12)
          relfacflavourDISWp = nup
c--- ub ep to enub db Q Qb 
        case(13)
          relfacflavourDISWp = nf
c--- g ep to enub db u 
        case(21)
          relfacflavourDISWp = nup
c--- g ep to enub db u 
        case(26)
          relfacflavourDISWp = nup
c--- g ep to enub db u 
        case(31)
          relfacflavourDISWp = nup
c--- g ep to enub db g g u 
        case(36)
          relfacflavourDISWp = nup
c--- g ep to enub db g g u 
        case(39)
          relfacflavourDISWp = nup
c--- gt ep to enub db gt gt u 
        case(42)
          relfacflavourDISWp = nup
c--- d ep to enub g Q Qb u 
        case(44)
          relfacflavourDISWp = nf
c--- g ep to enub db Q Qb u 
        case(45)
          relfacflavourDISWp = nf * nup
c--- Qb ep to enub db g Qb u 
        case(46)
          relfacflavourDISWp = nup
c--- Q ep to enub db g Q u 
        case(47)
          relfacflavourDISWp = nup
c--- ub ep to enub db g Q Qb 
        case(48)
          relfacflavourDISWp = nf
c--- d ep to enub g Q Qb u 
        case(49)
          relfacflavourDISWp = nf
c--- g ep to enub db Q Qb u 
        case(50)
          relfacflavourDISWp = nf * nup
c--- Qb ep to enub db g Qb u 
        case(51)
          relfacflavourDISWp = nup
c--- Q ep to enub db g Q u 
        case(52)
          relfacflavourDISWp = nup
c--- ub ep to enub db g Q Qb 
        case(53)
          relfacflavourDISWp = nf
c--- g ep to enub db d db u 
        case(55)
          relfacflavourDISWp = nup
c--- g ep to enub db u ub u 
        case(59)
          relfacflavourDISWp = nup
c--- g ep to enub db d db u 
        case(63)
          relfacflavourDISWp = nup
c--- g ep to enub db u ub u 
        case(67)
          relfacflavourDISWp = nup
c--- g ep to enub db g u 
        case(71)
          relfacflavourDISWp = nup
c--- gt ep to enub db gt u 
        case(76)
          relfacflavourDISWp = nup
c--- gt ep to enub db gt u 
        case(81)
          relfacflavourDISWp = nup
c--- g ep to enub db g u 
        case(86)
          relfacflavourDISWp = nup
c--- gt ep to enub db gt u 
        case(91)
          relfacflavourDISWp = nup
c--- d ep to enub Q Qb u 
        case(95)
          relfacflavourDISWp = nf
c--- Qb ep to enub db Qb u 
        case(96)
          relfacflavourDISWp = nup
c--- Q ep to enub db Q u 
        case(97)
          relfacflavourDISWp = nup
c--- ub ep to enub db Q Qb 
        case(98)
          relfacflavourDISWp = nf
c--- d ep to enub Q Qb u 
        case(100)
          relfacflavourDISWp = nf
c--- Qb ep to enub db Qb u 
        case(101)
          relfacflavourDISWp = nup
c--- Q ep to enub db Q u 
        case(102)
          relfacflavourDISWp = nup
c--- ub ep to enub db Q Qb 
        case(103)
          relfacflavourDISWp = nf
c--- d ep to enub Q Qb u 
        case(105)
          relfacflavourDISWp = nf
c--- Qb ep to enub db Qb u 
        case(106)
          relfacflavourDISWp = nup
c--- Q ep to enub db Q u 
        case(107)
          relfacflavourDISWp = nup
c--- ub ep to enub db Q Qb 
        case(108)
          relfacflavourDISWp = nf
c--- g ep to enub db u 
        case(135)
          relfacflavourDISWp = nup
c--- g ep to enub db u 
        case(142)
          relfacflavourDISWp = nup
c--- g ep to enub db u 
        case(149)
          relfacflavourDISWp = nup
c--- g ep to enub db u 
        case(156)
          relfacflavourDISWp = nup
c--- g ep to enub db u 
        case(163)
          relfacflavourDISWp = nup
c--- g ep to enub db u 
        case(170)
          relfacflavourDISWp = nup
        case default
          relfacflavourDISWp = 1d0
        end select
      end function relfacflavourDISWp


      subroutine dress_flav_DISWp(ip, isub, ipass, flav_block)
        use Flavour_mod
        implicit none
        integer, intent(in) :: ip, isub, flav_block
        integer, intent(inout) :: ipass

        if (ipass == 0) return
        select case(ip)
c--- d ep to enub g u
        case(1)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS matching to B1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=1,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS matching to B1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=1,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=1)"
          end select
c--- g ep to enub db u
        case(2)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS matching to B1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=2,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS matching to B1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=2,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=2)"
          end select
c--- ub ep to enub db g
        case(3)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS matching to B1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=3,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS matching to B1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=3,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=3)"
          end select
c--- d ep to enub g g u
        case(4)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B2g0WDIS matching to B2g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=4,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B2g0WDIS matching to B2g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=4,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=4)"
          end select
c--- g ep to enub db g u
        case(5)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B2g0WDIS matching to B2g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=5,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B2g0WDIS matching to B2g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=5,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=5)"
          end select
c--- ub ep to enub db g g
        case(6)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B2g0WDIS matching to B2g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=6,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B2g0WDIS matching to B2g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=6,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=6)"
          end select
c--- d ep to enub gt gt u
        case(7)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0WDIS matching to Bt2g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=7,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0WDIS matching to Bt2g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=7,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=7)"
          end select
c--- gt ep to enub db gt u
        case(8)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0WDIS matching to Bt2g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=8,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0WDIS matching to Bt2g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=8,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=8)"
          end select
c--- ub ep to enub db gt gt
        case(9)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0WDIS matching to Bt2g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=9,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0WDIS matching to Bt2g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=9,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=9)"
          end select
c--- d ep to enub Q Qb u
        case(10)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=10,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=10)"
          end select
c--- Qb ep to enub db Qb u
        case(11)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=11)"
          end select
c--- Q ep to enub db Q u
        case(12)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=12)"
          end select
c--- ub ep to enub db Q Qb
        case(13)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: C0g0WDIS matching to C0g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=13,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=13)"
          end select
c--- d ep to enub d db u
        case(14)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS matching to D0g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=14,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS matching to D0g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=14,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=14)"
          end select
c--- db ep to enub db db u
        case(15)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS matching to D0g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=15,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS matching to D0g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=15,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=15)"
          end select
c--- ub ep to enub db d db
        case(16)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS matching to D0g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=16,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS matching to D0g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=16,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=16)"
          end select
c--- d ep to enub u ub u
        case(17)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS matching to D0g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=17,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS matching to D0g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=17,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=17)"
          end select
c--- ub ep to enub db ub u
        case(18)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS matching to D0g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=18,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS matching to D0g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=18,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=18)"
          end select
c--- u ep to enub db u u
        case(19)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS matching to D0g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=19,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS matching to D0g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=19,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=19)"
          end select
c--- d ep to enub g u
        case(20)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g1WDIS matching to B1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=20,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g1WDIS matching to B1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=20,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=20)"
          end select
c--- g ep to enub db u
        case(21)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g1WDIS matching to B1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=21,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g1WDIS matching to B1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=21,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=21)"
          end select
c--- ub ep to enub db g
        case(22)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g1WDIS matching to B1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=22,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g1WDIS matching to B1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=22,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=22)"
          end select
c--- d ep to enub g u
        case(25)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1WDIS matching to Bt1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=25,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1WDIS matching to Bt1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=25,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=25)"
          end select
c--- g ep to enub db u
        case(26)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1WDIS matching to Bt1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=26,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1WDIS matching to Bt1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=26,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=26)"
          end select
c--- ub ep to enub db g
        case(27)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1WDIS matching to Bt1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=27,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1WDIS matching to Bt1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=27,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=27)"
          end select
c--- d ep to enub g u
        case(30)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1WDIS matching to Bh1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=30,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1WDIS matching to Bh1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=30,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=30)"
          end select
c--- g ep to enub db u
        case(31)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1WDIS matching to Bh1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=31,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1WDIS matching to Bh1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=31,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=31)"
          end select
c--- ub ep to enub db g
        case(32)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1WDIS matching to Bh1g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=32,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1WDIS matching to Bh1g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=32,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=32)"
          end select
c--- d ep to enub g g g u
        case(35)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sB3g0WDIS matching to B3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=35,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sB3g0WDIS matching to B3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=35,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=35)"
          end select
c--- g ep to enub db g g u
        case(36)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sB3g0WDIS matching to B3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=36,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sB3g0WDIS matching to B3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=36,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=36)"
          end select
c--- ub ep to enub db g g g
        case(37)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sB3g0WDIS matching to B3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=37,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sB3g0WDIS matching to B3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=37,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=37)"
          end select
c--- d ep to enub g g g u
        case(38)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBt3g0WDIS matching to Bt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=38,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBt3g0WDIS matching to Bt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=38,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=38)"
          end select
c--- g ep to enub db g g u
        case(39)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBt3g0WDIS matching to Bt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=39,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBt3g0WDIS matching to Bt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=39,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=39)"
          end select
c--- ub ep to enub db g g g
        case(40)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBt3g0WDIS matching to Bt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=40,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBt3g0WDIS matching to Bt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=40,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=40)"
          end select
c--- d ep to enub gt gt gt u
        case(41)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBtt3g0WDIS matching to Btt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=41,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBtt3g0WDIS matching to Btt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=41,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=41)"
          end select
c--- gt ep to enub db gt gt u
        case(42)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBtt3g0WDIS matching to Btt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=42,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBtt3g0WDIS matching to Btt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=42,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=42)"
          end select
c--- ub ep to enub db gt gt gt
        case(43)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBtt3g0WDIS matching to Btt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 0, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=43,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBtt3g0WDIS matching to Btt3g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 0, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=43,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=43)"
          end select
c--- d ep to enub g Q Qb u
        case(44)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 3, -3, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 4, -4, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 5, -5, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 1, -1, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 2, -2, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 5, -5, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=44,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=44)"
          end select
c--- g ep to enub db Q Qb u
        case(45)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 3, -3, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 4, -4, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 5, -5, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 1, -1, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 2, -2, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 5, -5, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=45,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=45)"
          end select
c--- Qb ep to enub db g Qb u
        case(46)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=46)"
          end select
c--- Q ep to enub db g Q u
        case(47)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=47)"
          end select
c--- ub ep to enub db g Q Qb
        case(48)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 3, -3, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 4, -4, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 5, -5, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 1, -1, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 2, -2, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC1g0WDIS matching to C1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 5, -5, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=48,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=48)"
          end select
c--- d ep to enub g Q Qb u
        case(49)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 3, -3, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 4, -4, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 5, -5, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 1, -1, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 2, -2, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 5, -5, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=49,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=49)"
          end select
c--- g ep to enub db Q Qb u
        case(50)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 3, -3, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 4, -4, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 5, -5, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 1, -1, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 2, -2, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 5, -5, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=50,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=50)"
          end select
c--- Qb ep to enub db g Qb u
        case(51)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=51)"
          end select
c--- Q ep to enub db g Q u
        case(52)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=52)"
          end select
c--- ub ep to enub db g Q Qb
        case(53)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 3, -3, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 4, -4, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 5, -5, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 1, -1, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 2, -2, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sCt1g0WDIS matching to Ct1g0W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 5, -5, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=53,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=53)"
          end select
c--- d ep to enub g d db u
        case(54)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmacDIS matching to D1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=54,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmacDIS matching to D1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=54,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=54)"
          end select
c--- g ep to enub db d db u
        case(55)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmacDIS matching to D1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=55,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmacDIS matching to D1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=55,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=55)"
          end select
c--- db ep to enub db g db u
        case(56)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmacDIS matching to D1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ -1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=56,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmacDIS matching to D1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ -3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=56,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=56)"
          end select
c--- ub ep to enub db g d db
        case(57)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmacDIS matching to D1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=57,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmacDIS matching to D1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=57,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=57)"
          end select
c--- d ep to enub g u ub u
        case(58)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmbcDIS matching to D1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=58,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmbcDIS matching to D1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=58,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=58)"
          end select
c--- g ep to enub db u ub u
        case(59)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmbcDIS matching to D1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=59,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmbcDIS matching to D1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=59,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=59)"
          end select
c--- ub ep to enub db g ub u
        case(60)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmbcDIS matching to D1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=60,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmbcDIS matching to D1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=60,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=60)"
          end select
c--- u ep to enub db g u u
        case(61)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmbcDIS matching to D1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=61,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D1g0WmbcDIS matching to D1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=61,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=61)"
          end select
c--- d ep to enub g d db u
        case(62)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmaDIS matching to Dt1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=62,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmaDIS matching to Dt1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=62,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=62)"
          end select
c--- g ep to enub db d db u
        case(63)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmaDIS matching to Dt1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=63,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmaDIS matching to Dt1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=63,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=63)"
          end select
c--- db ep to enub db g db u
        case(64)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmaDIS matching to Dt1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ -1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=64,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmaDIS matching to Dt1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ -3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=64,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=64)"
          end select
c--- ub ep to enub db g d db
        case(65)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmaDIS matching to Dt1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 1, -1, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=65,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmaDIS matching to Dt1g0Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 3, -3, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=65,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=65)"
          end select
c--- d ep to enub g u ub u
        case(66)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmbDIS matching to Dt1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=66,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmbDIS matching to Dt1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=66,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=66)"
          end select
c--- g ep to enub db u ub u
        case(67)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmbDIS matching to Dt1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=67,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmbDIS matching to Dt1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=67,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=67)"
          end select
c--- ub ep to enub db g ub u
        case(68)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmbDIS matching to Dt1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=68,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmbDIS matching to Dt1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=68,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=68)"
          end select
c--- u ep to enub db g u u
        case(69)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmbDIS matching to Dt1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, -2, 2, 98, -99 /), 7, ipass, (/ 2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=69,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt1g0WmbDIS matching to Dt1g0Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, -4, 4, 98, -99 /), 7, ipass, (/ 4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=69,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=69)"
          end select
c--- d ep to enub g g u
        case(70)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sB2g1WDIS matching to B2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=70,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sB2g1WDIS matching to B2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=70,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=70)"
          end select
c--- g ep to enub db g u
        case(71)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sB2g1WDIS matching to B2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=71,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sB2g1WDIS matching to B2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=71,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=71)"
          end select
c--- ub ep to enub db g g
        case(72)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sB2g1WDIS matching to B2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=72,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sB2g1WDIS matching to B2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=72,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=72)"
          end select
c--- d ep to enub gt gt u
        case(75)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBt2g1WDIS matching to Bt2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=75,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBt2g1WDIS matching to Bt2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=75,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=75)"
          end select
c--- gt ep to enub db gt u
        case(76)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBt2g1WDIS matching to Bt2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=76,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBt2g1WDIS matching to Bt2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=76,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=76)"
          end select
c--- ub ep to enub db gt gt
        case(77)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBt2g1WDIS matching to Bt2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=77,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBt2g1WDIS matching to Bt2g1Z in FLAVlistDISW.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=77,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=77)"
          end select
c--- d ep to enub gt gt u
        case(80)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBttt2g1WDIS matching to Bttt2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=80,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBttt2g1WDIS matching to Bttt2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=80,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=80)"
          end select
c--- gt ep to enub db gt u
        case(81)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBttt2g1WDIS matching to Bttt2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=81,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBttt2g1WDIS matching to Bttt2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=81,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=81)"
          end select
c--- ub ep to enub db gt gt
        case(82)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBttt2g1WDIS matching to Bttt2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=82,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBttt2g1WDIS matching to Bttt2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=82,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=82)"
          end select
c--- d ep to enub g g u
        case(85)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBh2g1WDIS matching to Bh2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=85,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBh2g1WDIS matching to Bh2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=85,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=85)"
          end select
c--- g ep to enub db g u
        case(86)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBh2g1WDIS matching to Bh2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=86,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBh2g1WDIS matching to Bh2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=86,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=86)"
          end select
c--- ub ep to enub db g g
        case(87)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBh2g1WDIS matching to Bh2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=87,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBh2g1WDIS matching to Bh2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=87,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=87)"
          end select
c--- d ep to enub gt gt u
        case(90)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBth2g1WDIS matching to Bth2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=90,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBth2g1WDIS matching to Bth2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=90,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=90)"
          end select
c--- gt ep to enub db gt u
        case(91)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBth2g1WDIS matching to Bth2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=91,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBth2g1WDIS matching to Bth2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=91,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=91)"
          end select
c--- ub ep to enub db gt gt
        case(92)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sBth2g1WDIS matching to Bth2g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 0, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=92,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sBth2g1WDIS matching to Bth2g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 0, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=92,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=92)"
          end select
c--- d ep to enub Q Qb u
        case(95)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=95,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=95)"
          end select
c--- Qb ep to enub db Qb u
        case(96)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=96)"
          end select
c--- Q ep to enub db Q u
        case(97)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=97)"
          end select
c--- ub ep to enub db Q Qb
        case(98)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC0g1WDIS matching to C0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=98,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=98)"
          end select
c--- d ep to enub Q Qb u
        case(100)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=100,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=100)"
          end select
c--- Qb ep to enub db Qb u
        case(101)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=101)"
          end select
c--- Q ep to enub db Q u
        case(102)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=102)"
          end select
c--- ub ep to enub db Q Qb
        case(103)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: Ct0g1WDIS matching to Ct0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=103,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=103)"
          end select
c--- d ep to enub Q Qb u
        case(105)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=105,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=105)"
          end select
c--- Qb ep to enub db Qb u
        case(106)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=106)"
          end select
c--- Q ep to enub db Q u
        case(107)
          select case (isub)
          case default
            stop "dress_flav_DISWp: unknown isub (ip=107)"
          end select
c--- ub ep to enub db Q Qb
        case(108)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: Ch0g1WDIS matching to Ch0g1W in FLAVlistDISW.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=108,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=108)"
          end select
c--- d ep to enub d db u
        case(110)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmaDIS matching to D0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=110,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmaDIS matching to D0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=110,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=110)"
          end select
c--- db ep to enub db db u
        case(111)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmaDIS matching to D0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=111,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmaDIS matching to D0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=111,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=111)"
          end select
c--- ub ep to enub db d db
        case(112)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmaDIS matching to D0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=112,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmaDIS matching to D0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=112,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=112)"
          end select
c--- d ep to enub u ub u
        case(114)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmbDIS matching to D0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=114,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmbDIS matching to D0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=114,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=114)"
          end select
c--- ub ep to enub db ub u
        case(115)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmbDIS matching to D0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=115,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmbDIS matching to D0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=115,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=115)"
          end select
c--- u ep to enub db u u
        case(116)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmbDIS matching to D0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=116,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g1WmbDIS matching to D0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=116,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=116)"
          end select
c--- d ep to enub d db u
        case(118)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmaDIS matching to Dt0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=118,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmaDIS matching to Dt0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=118,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=118)"
          end select
c--- db ep to enub db db u
        case(119)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmaDIS matching to Dt0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=119,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmaDIS matching to Dt0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=119,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=119)"
          end select
c--- ub ep to enub db d db
        case(120)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmaDIS matching to Dt0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=120,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmaDIS matching to Dt0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=120,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=120)"
          end select
c--- d ep to enub u ub u
        case(122)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmbDIS matching to Dt0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=122,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmbDIS matching to Dt0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=122,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=122)"
          end select
c--- ub ep to enub db ub u
        case(123)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmbDIS matching to Dt0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=123,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmbDIS matching to Dt0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=123,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=123)"
          end select
c--- u ep to enub db u u
        case(124)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmbDIS matching to Dt0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=124,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dt0g1WmbDIS matching to Dt0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=124,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=124)"
          end select
c--- d ep to enub d db u
        case(126)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmaDIS matching to Dh0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=126,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmaDIS matching to Dh0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=126,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=126)"
          end select
c--- db ep to enub db db u
        case(127)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmaDIS matching to Dh0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=127,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmaDIS matching to Dh0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=127,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=127)"
          end select
c--- ub ep to enub db d db
        case(128)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmaDIS matching to Dh0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=128,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmaDIS matching to Dh0g1Wa in FLAVlistDISW.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=128,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=128)"
          end select
c--- d ep to enub u ub u
        case(130)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmbDIS matching to Dh0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=130,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmbDIS matching to Dh0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=130,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=130)"
          end select
c--- ub ep to enub db ub u
        case(131)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmbDIS matching to Dh0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=131,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmbDIS matching to Dh0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=131,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=131)"
          end select
c--- u ep to enub db u u
        case(132)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmbDIS matching to Dh0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=132,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Dh0g1WmbDIS matching to Dh0g1Wb in FLAVlistDISW.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=132,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=132)"
          end select
c--- d ep to enub g u
        case(134)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g2WDIS matching to B1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=134,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g2WDIS matching to B1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=134,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=134)"
          end select
c--- g ep to enub db u
        case(135)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g2WDIS matching to B1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=135,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g2WDIS matching to B1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=135,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=135)"
          end select
c--- ub ep to enub db g
        case(136)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g2WDIS matching to B1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=136,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g2WDIS matching to B1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=136,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=136)"
          end select
c--- d ep to enub g u
        case(141)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g2WDIS matching to Bt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=141,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g2WDIS matching to Bt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=141,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=141)"
          end select
c--- g ep to enub db u
        case(142)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g2WDIS matching to Bt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=142,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g2WDIS matching to Bt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=142,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=142)"
          end select
c--- ub ep to enub db g
        case(143)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g2WDIS matching to Bt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=143,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g2WDIS matching to Bt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=143,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=143)"
          end select
c--- d ep to enub g u
        case(148)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Btt1g2WDIS matching to Btt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=148,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Btt1g2WDIS matching to Btt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=148,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=148)"
          end select
c--- g ep to enub db u
        case(149)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Btt1g2WDIS matching to Btt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=149,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Btt1g2WDIS matching to Btt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=149,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=149)"
          end select
c--- ub ep to enub db g
        case(150)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Btt1g2WDIS matching to Btt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=150,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Btt1g2WDIS matching to Btt1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=150,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=150)"
          end select
c--- d ep to enub g u
        case(155)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g2WDIS matching to Bh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=155,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g2WDIS matching to Bh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=155,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=155)"
          end select
c--- g ep to enub db u
        case(156)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g2WDIS matching to Bh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=156,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g2WDIS matching to Bh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=156,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=156)"
          end select
c--- ub ep to enub db g
        case(157)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g2WDIS matching to Bh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=157,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g2WDIS matching to Bh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=157,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=157)"
          end select
c--- d ep to enub g u
        case(162)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bht1g2WDIS matching to Bht1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=162,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bht1g2WDIS matching to Bht1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=162,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=162)"
          end select
c--- g ep to enub db u
        case(163)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bht1g2WDIS matching to Bht1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=163,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bht1g2WDIS matching to Bht1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=163,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=163)"
          end select
c--- ub ep to enub db g
        case(164)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bht1g2WDIS matching to Bht1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=164,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bht1g2WDIS matching to Bht1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=164,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=164)"
          end select
c--- d ep to enub g u
        case(169)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bhh1g2WDIS matching to Bhh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=169,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bhh1g2WDIS matching to Bhh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=169,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=169)"
          end select
c--- g ep to enub db u
        case(170)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bhh1g2WDIS matching to Bhh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=170,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bhh1g2WDIS matching to Bhh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=170,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=170)"
          end select
c--- ub ep to enub db g
        case(171)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bhh1g2WDIS matching to Bhh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=171,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bhh1g2WDIS matching to Bhh1g2W in FLAVlistDISW.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp: unknown flav_block (ip=171,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp: unknown isub (ip=171)"
          end select
        end select
      end subroutine dress_flav_DISWp

#endif

