      function sigSDISWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSDISWm=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      jflag=.false.
      ix=1
      ix_chan=1

c--- u em to enu g g g d 
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        wt = qemsB3g0WDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub g g d 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        wt = gemsB3g0WDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g g g 
      if (qactive_chan(37).and.qselect_chan(37)) then
        current_chan = 37
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        wt = qbemsB3g0WDISS(4,5,6,7,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu g g g d 
      if (qactive_chan(38).and.qselect_chan(38)) then
        current_chan = 38
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        wt = qemsBt3g0WDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub g g d 
      if (qactive_chan(39).and.qselect_chan(39)) then
        current_chan = 39
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        wt = gemsBt3g0WDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g g g 
      if (qactive_chan(40).and.qselect_chan(40)) then
        current_chan = 40
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        wt = qbemsBt3g0WDISS(4,5,6,7,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu gt gt gt d 
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = 20
        ip2_chan     = 99
        nfB1 = 1
        wt = qemsBtt3g0WDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- gt em to enu ub gt gt d 
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = 0
        ip2_chan     = 99
        nfB1 = 1
        wt = gtemsBtt3g0WDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub gt gt gt 
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = -40
        ip2_chan     = 99
        nfB1 = 1
        wt = qbemsBtt3g0WDISS(4,5,6,7,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu g Q Qb d 
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qemsC1g0WDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub Q Qb d 
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = gemsC1g0WDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- Qb em to enu ub g Qb d 
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = -30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qpbemsC1g0WDISS(4,5,1,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- Q em to enu ub g Q d 
      if (qactive_chan(47).and.qselect_chan(47)) then
        current_chan = 47
        ip1_chan     = 30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qpemsC1g0WDISS(4,5,6,1,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g Q Qb 
      if (qactive_chan(48).and.qselect_chan(48)) then
        current_chan = 48
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qbemsC1g0WDISS(4,5,6,7,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu g Q Qb d 
      if (qactive_chan(49).and.qselect_chan(49)) then
        current_chan = 49
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qemsCt1g0WDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub Q Qb d 
      if (qactive_chan(50).and.qselect_chan(50)) then
        current_chan = 50
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = gemsCt1g0WDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- Qb em to enu ub g Qb d 
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = -30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qpbemsCt1g0WDISS(4,5,1,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- Q em to enu ub g Q d 
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = 30
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qpemsCt1g0WDISS(4,5,6,1,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g Q Qb 
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 4
        wt = qbemsCt1g0WDISS(4,5,6,7,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu g u ub d 
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qemD1g0WpacDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub u ub d 
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = gemD1g0WpacDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- ub em to enu ub g ub d 
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qbemD1g0WpacDISS(4,5,1,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g u ub 
      if (qactive_chan(57).and.qselect_chan(57)) then
        current_chan = 57
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qpbemD1g0WpacDISS(4,5,6,7,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu g d db d 
      if (qactive_chan(58).and.qselect_chan(58)) then
        current_chan = 58
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qemD1g0WpbcDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub d db d 
      if (qactive_chan(59).and.qselect_chan(59)) then
        current_chan = 59
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = gemD1g0WpbcDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g db d 
      if (qactive_chan(60).and.qselect_chan(60)) then
        current_chan = 60
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qpbemD1g0WpbcDISS(4,5,1,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- d em to enu ub g d d 
      if (qactive_chan(61).and.qselect_chan(61)) then
        current_chan = 61
        ip1_chan     = 40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qpemD1g0WpbcDISS(4,5,6,1,7,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu g u ub d 
      if (qactive_chan(62).and.qselect_chan(62)) then
        current_chan = 62
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qemDt1g0WpaDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub u ub d 
      if (qactive_chan(63).and.qselect_chan(63)) then
        current_chan = 63
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = gemDt1g0WpaDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- ub em to enu ub g ub d 
      if (qactive_chan(64).and.qselect_chan(64)) then
        current_chan = 64
        ip1_chan     = -20
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qbemDt1g0WpaDISS(4,5,1,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g u ub 
      if (qactive_chan(65).and.qselect_chan(65)) then
        current_chan = 65
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = qpbemDt1g0WpaDISS(4,5,6,7,1,3,2)
        wtsum = wtsum + wt
      endif
c--- u em to enu g d db d 
      if (qactive_chan(66).and.qselect_chan(66)) then
        current_chan = 66
        ip1_chan     = 20
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qemDt1g0WpbDISS(1,4,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- g em to enu ub d db d 
      if (qactive_chan(67).and.qselect_chan(67)) then
        current_chan = 67
        ip1_chan     = 0
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = gemDt1g0WpbDISS(4,1,5,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- db em to enu ub g db d 
      if (qactive_chan(68).and.qselect_chan(68)) then
        current_chan = 68
        ip1_chan     = -40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qpbemDt1g0WpbDISS(4,5,1,6,7,3,2)
        wtsum = wtsum + wt
      endif
c--- d em to enu ub g d d 
      if (qactive_chan(69).and.qselect_chan(69)) then
        current_chan = 69
        ip1_chan     = 40
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = qpemDt1g0WpbDISS(4,5,6,1,7,3,2)
        wtsum = wtsum + wt
      endif
      sigSDISWm=sigSDISWm+rnorm*wtsum

      return
      end
