      function sigSDISWp(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSDISWp=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      jflag=.false.
      ix=1
      ix_chan=1

c--- d ep to enub g g g u 
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = 40
        ip2_chan     = -99
        nfB1 = 2
        wt = qepsB3g0WDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db g g u 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = 0
        ip2_chan     = -99
        nfB1 = 2
        wt = gepsB3g0WDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g g g 
      if (qactive_chan(37).and.qselect_chan(37)) then
        current_chan = 37
        ip1_chan     = -20
        ip2_chan     = -99
        nfB1 = 2
        wt = qbepsB3g0WDISS(4,5,6,7,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub g g g u 
      if (qactive_chan(38).and.qselect_chan(38)) then
        current_chan = 38
        ip1_chan     = 40
        ip2_chan     = -99
        nfB1 = 2
        wt = qepsBt3g0WDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db g g u 
      if (qactive_chan(39).and.qselect_chan(39)) then
        current_chan = 39
        ip1_chan     = 0
        ip2_chan     = -99
        nfB1 = 2
        wt = gepsBt3g0WDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g g g 
      if (qactive_chan(40).and.qselect_chan(40)) then
        current_chan = 40
        ip1_chan     = -20
        ip2_chan     = -99
        nfB1 = 2
        wt = qbepsBt3g0WDISS(4,5,6,7,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub gt gt gt u 
      if (qactive_chan(41).and.qselect_chan(41)) then
        current_chan = 41
        ip1_chan     = 40
        ip2_chan     = -99
        nfB1 = 2
        wt = qepsBtt3g0WDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- gt ep to enub db gt gt u 
      if (qactive_chan(42).and.qselect_chan(42)) then
        current_chan = 42
        ip1_chan     = 0
        ip2_chan     = -99
        nfB1 = 2
        wt = gtepsBtt3g0WDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db gt gt gt 
      if (qactive_chan(43).and.qselect_chan(43)) then
        current_chan = 43
        ip1_chan     = -20
        ip2_chan     = -99
        nfB1 = 2
        wt = qbepsBtt3g0WDISS(4,5,6,7,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub g Q Qb u 
      if (qactive_chan(44).and.qselect_chan(44)) then
        current_chan = 44
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qepsC1g0WDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db Q Qb u 
      if (qactive_chan(45).and.qselect_chan(45)) then
        current_chan = 45
        ip1_chan     = 0
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = gepsC1g0WDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- Qb ep to enub db g Qb u 
      if (qactive_chan(46).and.qselect_chan(46)) then
        current_chan = 46
        ip1_chan     = -30
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qpbepsC1g0WDISS(4,5,1,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- Q ep to enub db g Q u 
      if (qactive_chan(47).and.qselect_chan(47)) then
        current_chan = 47
        ip1_chan     = 30
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qpepsC1g0WDISS(4,5,6,1,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g Q Qb 
      if (qactive_chan(48).and.qselect_chan(48)) then
        current_chan = 48
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qbepsC1g0WDISS(4,5,6,7,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub g Q Qb u 
      if (qactive_chan(49).and.qselect_chan(49)) then
        current_chan = 49
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qepsCt1g0WDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db Q Qb u 
      if (qactive_chan(50).and.qselect_chan(50)) then
        current_chan = 50
        ip1_chan     = 0
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = gepsCt1g0WDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- Qb ep to enub db g Qb u 
      if (qactive_chan(51).and.qselect_chan(51)) then
        current_chan = 51
        ip1_chan     = -30
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qpbepsCt1g0WDISS(4,5,1,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- Q ep to enub db g Q u 
      if (qactive_chan(52).and.qselect_chan(52)) then
        current_chan = 52
        ip1_chan     = 30
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qpepsCt1g0WDISS(4,5,6,1,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g Q Qb 
      if (qactive_chan(53).and.qselect_chan(53)) then
        current_chan = 53
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 4
        wt = qbepsCt1g0WDISS(4,5,6,7,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub g d db u 
      if (qactive_chan(54).and.qselect_chan(54)) then
        current_chan = 54
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qpepD1g0WmacDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db d db u 
      if (qactive_chan(55).and.qselect_chan(55)) then
        current_chan = 55
        ip1_chan     = 0
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = gepD1g0WmacDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- db ep to enub db g db u 
      if (qactive_chan(56).and.qselect_chan(56)) then
        current_chan = 56
        ip1_chan     = -40
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qpbepD1g0WmacDISS(4,5,1,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g d db 
      if (qactive_chan(57).and.qselect_chan(57)) then
        current_chan = 57
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qbepD1g0WmacDISS(4,5,6,7,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub g u ub u 
      if (qactive_chan(58).and.qselect_chan(58)) then
        current_chan = 58
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qpepD1g0WmbcDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db u ub u 
      if (qactive_chan(59).and.qselect_chan(59)) then
        current_chan = 59
        ip1_chan     = 0
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = gepD1g0WmbcDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g ub u 
      if (qactive_chan(60).and.qselect_chan(60)) then
        current_chan = 60
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qbepD1g0WmbcDISS(4,5,1,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- u ep to enub db g u u 
      if (qactive_chan(61).and.qselect_chan(61)) then
        current_chan = 61
        ip1_chan     = 20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qepD1g0WmbcDISS(4,5,6,1,7,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub g d db u 
      if (qactive_chan(62).and.qselect_chan(62)) then
        current_chan = 62
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qpepDt1g0WmaDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db d db u 
      if (qactive_chan(63).and.qselect_chan(63)) then
        current_chan = 63
        ip1_chan     = 0
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = gepDt1g0WmaDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- db ep to enub db g db u 
      if (qactive_chan(64).and.qselect_chan(64)) then
        current_chan = 64
        ip1_chan     = -40
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qpbepDt1g0WmaDISS(4,5,1,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g d db 
      if (qactive_chan(65).and.qselect_chan(65)) then
        current_chan = 65
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 1
        nfC2 = 1
        wt = qbepDt1g0WmaDISS(4,5,6,7,1,2,3)
        wtsum = wtsum + wt
      endif
c--- d ep to enub g u ub u 
      if (qactive_chan(66).and.qselect_chan(66)) then
        current_chan = 66
        ip1_chan     = 40
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qpepDt1g0WmbDISS(1,4,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- g ep to enub db u ub u 
      if (qactive_chan(67).and.qselect_chan(67)) then
        current_chan = 67
        ip1_chan     = 0
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = gepDt1g0WmbDISS(4,1,5,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- ub ep to enub db g ub u 
      if (qactive_chan(68).and.qselect_chan(68)) then
        current_chan = 68
        ip1_chan     = -20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qbepDt1g0WmbDISS(4,5,1,6,7,2,3)
        wtsum = wtsum + wt
      endif
c--- u ep to enub db g u u 
      if (qactive_chan(69).and.qselect_chan(69)) then
        current_chan = 69
        ip1_chan     = 20
        ip2_chan     = -99
        nfC1 = 2
        nfC2 = 2
        wt = qepDt1g0WmbDISS(4,5,6,1,7,2,3)
        wtsum = wtsum + wt
      endif
      sigSDISWp=sigSDISWp+rnorm*wtsum

      return
      end
