      function sigUDISWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUDISWm=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- u em to enu g d     
        if (qactive_chan(134).and.qselect_chan(134)) then
          current_chan = 134
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemB1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(135).and.qselect_chan(135)) then
          current_chan = 135
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemB1g2WDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(136).and.qselect_chan(136)) then
          current_chan = 136
          ip1_chan     = -40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemB1g2WDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(137).and.qselect_chan(137)) then
          current_chan = 137
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemB1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(138).and.qselect_chan(138)) then
          current_chan = 138
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemB1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em initiated      
        if (qactive_chan(139).and.qselect_chan(139)) then
          current_chan = 139
          ip1_chan     = 40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = demB1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em initiated     
        if (qactive_chan(140).and.qselect_chan(140)) then
          current_chan = 140
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = ubemB1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(141).and.qselect_chan(141)) then
          current_chan = 141
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(142).and.qselect_chan(142)) then
          current_chan = 142
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBt1g2WDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(143).and.qselect_chan(143)) then
          current_chan = 143
          ip1_chan     = -40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBt1g2WDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(144).and.qselect_chan(144)) then
          current_chan = 144
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(145).and.qselect_chan(145)) then
          current_chan = 145
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em initiated      
        if (qactive_chan(146).and.qselect_chan(146)) then
          current_chan = 146
          ip1_chan     = 40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = demBt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em initiated     
        if (qactive_chan(147).and.qselect_chan(147)) then
          current_chan = 147
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = ubemBt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(148).and.qselect_chan(148)) then
          current_chan = 148
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBtt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(149).and.qselect_chan(149)) then
          current_chan = 149
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBtt1g2WDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(150).and.qselect_chan(150)) then
          current_chan = 150
          ip1_chan     = -40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBtt1g2WDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(151).and.qselect_chan(151)) then
          current_chan = 151
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBtt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(152).and.qselect_chan(152)) then
          current_chan = 152
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBtt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em initiated      
        if (qactive_chan(153).and.qselect_chan(153)) then
          current_chan = 153
          ip1_chan     = 40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = demBtt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em initiated     
        if (qactive_chan(154).and.qselect_chan(154)) then
          current_chan = 154
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = ubemBtt1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(155).and.qselect_chan(155)) then
          current_chan = 155
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(156).and.qselect_chan(156)) then
          current_chan = 156
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBh1g2WDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(157).and.qselect_chan(157)) then
          current_chan = 157
          ip1_chan     = -40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBh1g2WDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(158).and.qselect_chan(158)) then
          current_chan = 158
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(159).and.qselect_chan(159)) then
          current_chan = 159
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em initiated      
        if (qactive_chan(160).and.qselect_chan(160)) then
          current_chan = 160
          ip1_chan     = 40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = demBh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em initiated     
        if (qactive_chan(161).and.qselect_chan(161)) then
          current_chan = 161
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = ubemBh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(162).and.qselect_chan(162)) then
          current_chan = 162
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBht1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(163).and.qselect_chan(163)) then
          current_chan = 163
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBht1g2WDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(164).and.qselect_chan(164)) then
          current_chan = 164
          ip1_chan     = -40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBht1g2WDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(165).and.qselect_chan(165)) then
          current_chan = 165
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBht1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(166).and.qselect_chan(166)) then
          current_chan = 166
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBht1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em initiated      
        if (qactive_chan(167).and.qselect_chan(167)) then
          current_chan = 167
          ip1_chan     = 40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = demBht1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em initiated     
        if (qactive_chan(168).and.qselect_chan(168)) then
          current_chan = 168
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = ubemBht1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u em to enu g d     
        if (qactive_chan(169).and.qselect_chan(169)) then
          current_chan = 169
          ip1_chan     = 20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qemBhh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g em to enu ub d    
        if (qactive_chan(170).and.qselect_chan(170)) then
          current_chan = 170
          ip1_chan     = 0
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = gemBhh1g2WDISU(ix,xri1,xri2,4,1,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db em to enu ub g   
        if (qactive_chan(171).and.qselect_chan(171)) then
          current_chan = 171
          ip1_chan     = -40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qbemBhh1g2WDISU(ix,xri1,xri2,4,5,1,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q em initiated      
        if (qactive_chan(172).and.qselect_chan(172)) then
          current_chan = 172
          ip1_chan     = 30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpemBhh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb em initiated     
        if (qactive_chan(173).and.qselect_chan(173)) then
          current_chan = 173
          ip1_chan     = -30
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = qpbemBhh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d em initiated      
        if (qactive_chan(174).and.qselect_chan(174)) then
          current_chan = 174
          ip1_chan     = 40
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = demBhh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub em initiated     
        if (qactive_chan(175).and.qselect_chan(175)) then
          current_chan = 175
          ip1_chan     = -20
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = ubemBhh1g2WDISU(ix,xri1,xri2,1,4,5,3,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUDISWm=sigUDISWm+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
