#ifdef FLAVDISWm1j

      integer function max_nflavourDISWm1j()
        use Channels_mod, only: qactive_chan, ntot_chan
        implicit none
        integer ip, nflavourDISWm1j
        max_nflavourDISWm1j = 0
        do ip=1,ntot_chan
            if (.not.qactive_chan(ip)) cycle
            max_nflavourDISWm1j =  max(max_nflavourDISWm1j, nflavourDISWm1j(ip))
        end do
      end function max_nflavourDISWm1j


      integer function nflavourDISWm1j(ip)
        implicit none
        integer, intent(in) :: ip
        select case(ip)
c--- u em to enu d
        case(1)
          nflavourDISWm1j = 2
c--- db em to enu ub
        case(2)
          nflavourDISWm1j = 2
c--- u em to enu g d
        case(3)
          nflavourDISWm1j = 2
c--- g em to enu ub d
        case(4)
          nflavourDISWm1j = 2
c--- db em to enu ub g
        case(5)
          nflavourDISWm1j = 2
c--- u em to enu d
        case(6)
          nflavourDISWm1j = 2
c--- db em to enu ub
        case(7)
          nflavourDISWm1j = 2
c--- g em subtraction
        case(10)
          nflavourDISWm1j = 2
c--- u em to enu g g d
        case(11)
          nflavourDISWm1j = 2
c--- g em to enu ub g d
        case(12)
          nflavourDISWm1j = 3
c--- db em to enu ub g g
        case(13)
          nflavourDISWm1j = 3
c--- u em to enu gt gt d
        case(14)
          nflavourDISWm1j = 2
c--- gt em to enu ub gt d
        case(15)
          nflavourDISWm1j = 3
c--- db em to enu ub gt gt
        case(16)
          nflavourDISWm1j = 3
c--- u em to enu Q Qb d
        case(17)
          nflavourDISWm1j = 10
c--- Qb em to enu ub Qb d
        case(18)
          nflavourDISWm1j = 0
c--- Q em to enu ub Q d
        case(19)
          nflavourDISWm1j = 0
c--- db em to enu ub Q Qb
        case(20)
          nflavourDISWm1j = 10
c--- u em to enu u ub d
        case(21)
          nflavourDISWm1j = 2
c--- ub em to enu ub ub d
        case(22)
          nflavourDISWm1j = 2
c--- db em to enu ub u ub
        case(23)
          nflavourDISWm1j = 2
c--- u em to enu d db d
        case(24)
          nflavourDISWm1j = 2
c--- db em to enu ub db d
        case(25)
          nflavourDISWm1j = 2
c--- d em to enu ub d d
        case(26)
          nflavourDISWm1j = 2
c--- u em to enu g d
        case(27)
          nflavourDISWm1j = 2
c--- g em to enu ub d
        case(28)
          nflavourDISWm1j = 3
c--- db em to enu ub g
        case(29)
          nflavourDISWm1j = 3
c--- u em to enu g d
        case(32)
          nflavourDISWm1j = 2
c--- g em to enu ub d
        case(33)
          nflavourDISWm1j = 3
c--- db em to enu ub g
        case(34)
          nflavourDISWm1j = 3
c--- u em to enu g d
        case(37)
          nflavourDISWm1j = 2
c--- g em to enu ub d
        case(38)
          nflavourDISWm1j = 3
c--- db em to enu ub g
        case(39)
          nflavourDISWm1j = 3
c--- u em to enu d
        case(42)
          nflavourDISWm1j = 2
c--- db em to enu ub
        case(43)
          nflavourDISWm1j = 2
c--- d em subtraction
        case(46)
          nflavourDISWm1j = 2
c--- g em subtraction
        case(47)
          nflavourDISWm1j = 2
c--- ub em subtraction
        case(48)
          nflavourDISWm1j = 2
c--- u em to enu d
        case(49)
          nflavourDISWm1j = 2
c--- db em to enu ub
        case(50)
          nflavourDISWm1j = 2
c--- Q em subtraction
        case(51)
          nflavourDISWm1j = 2
c--- Qb em subtraction
        case(52)
          nflavourDISWm1j = 2
c--- d em subtraction
        case(53)
          nflavourDISWm1j = 2
c--- g em subtraction
        case(54)
          nflavourDISWm1j = 2
c--- ub em subtraction
        case(55)
          nflavourDISWm1j = 2
c--- u em to enu d
        case(56)
          nflavourDISWm1j = 2
c--- db em to enu ub
        case(57)
          nflavourDISWm1j = 2
c--- d em subtraction
        case(60)
          nflavourDISWm1j = 2
c--- g em subtraction
        case(61)
          nflavourDISWm1j = 2
c--- ub em subtraction
        case(62)
          nflavourDISWm1j = 2
        end select
      end function nflavourDISWm1j


      double precision function relfacflavourDISWm1j(ip)
        implicit none
        integer, intent(in) :: ip
        double precision nf, nup, ndown
        parameter(nf=5d0)
        parameter(nup=2d0)
        parameter(ndown=3d0)
        select case(ip)
c--- g em to enu ub d 
        case(4)
          relfacflavourDISWm1j = nup
c--- g em subtraction 
        case(10)
          relfacflavourDISWm1j = nup
c--- g em to enu ub g d 
        case(12)
          relfacflavourDISWm1j = nup
c--- gt em to enu ub gt d 
        case(15)
          relfacflavourDISWm1j = nup
c--- u em to enu Q Qb d 
        case(17)
          relfacflavourDISWm1j = nf
c--- Qb em to enu ub Qb d 
        case(18)
          relfacflavourDISWm1j = nup
c--- Q em to enu ub Q d 
        case(19)
          relfacflavourDISWm1j = nup
c--- db em to enu ub Q Qb 
        case(20)
          relfacflavourDISWm1j = nf
c--- g em to enu ub d 
        case(28)
          relfacflavourDISWm1j = nup
c--- g em to enu ub d 
        case(33)
          relfacflavourDISWm1j = nup
c--- g em to enu ub d 
        case(38)
          relfacflavourDISWm1j = nup
c--- g em subtraction 
        case(47)
          relfacflavourDISWm1j = nup
c--- Q em subtraction 
        case(51)
          relfacflavourDISWm1j = nup
c--- Qb em subtraction 
        case(52)
          relfacflavourDISWm1j = nup
c--- g em subtraction 
        case(54)
          relfacflavourDISWm1j = nup
c--- g em subtraction 
        case(61)
          relfacflavourDISWm1j = nup
        case default
          relfacflavourDISWm1j = 1d0
        end select
      end function relfacflavourDISWm1j


      subroutine dress_flav_DISWm1j(ip, isub, ipass, flav_block)
        use Flavour_mod
        implicit none
        integer, intent(in) :: ip, isub, flav_block
        integer, intent(inout) :: ipass

        if (ipass == 0) return
        select case(ip)
c--- u em to enu d
        case(1)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g0WDIS1j matching to B0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=1,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g0WDIS1j matching to B0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=1,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=1)"
          end select
c--- db em to enu ub
        case(2)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g0WDIS1j matching to B0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=2,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g0WDIS1j matching to B0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=2,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=2)"
          end select
c--- u em to enu g d
        case(3)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=3,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=3,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=3)"
          end select
c--- g em to enu ub d
        case(4)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ 0,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=4,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ 0,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=4,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=4)"
          end select
c--- db em to enu ub g
        case(5)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=5,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=5,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=5)"
          end select
c--- u em to enu d
        case(6)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g1WDIS1j matching to B0g1W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=6,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g1WDIS1j matching to B0g1W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=6,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=6)"
          end select
c--- db em to enu ub
        case(7)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g1WDIS1j matching to B0g1W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=7,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g1WDIS1j matching to B0g1W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=7,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=7)"
          end select
c--- g em subtraction
        case(10)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=10,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=10,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=10)"
          end select
c--- u em to enu g g d
        case(11)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 0, 1, -99, 99 /), 6, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=11,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 0, 3, -99, 99 /), 6, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=11,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=11)"
          end select
c--- g em to enu ub g d
        case(12)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 0, 1, -99, 99 /), 6, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=12,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 0, 3, -99, 99 /), 6, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=12,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 0, 5, -99, 99 /), 6, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=12,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=12)"
          end select
c--- db em to enu ub g g
        case(13)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 0, 1, -99, 99 /), 6, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=13,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 0, 3, -99, 99 /), 6, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=13,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 0, 5, -99, 99 /), 6, ipass, (/ -5,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=13,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=13)"
          end select
c--- u em to enu gt gt d
        case(14)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 0, 1, -99, 99 /), 6, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=14,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 0, 3, -99, 99 /), 6, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=14,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=14)"
          end select
c--- gt em to enu ub gt d
        case(15)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 0, 1, -99, 99 /), 6, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=15,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 0, 3, -99, 99 /), 6, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=15,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 0, 5, -99, 99 /), 6, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=15,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=15)"
          end select
c--- db em to enu ub gt gt
        case(16)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 0, 1, -99, 99 /), 6, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=16,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 0, 3, -99, 99 /), 6, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=16,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 0, 5, -99, 99 /), 6, ipass, (/ -5,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=16,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=16)"
          end select
c--- u em to enu Q Qb d
        case(17)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, -1, 1, 98, -99 /), 6, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,2, -2, 1, 98, -99 /), 6, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,3, -3, 1, 98, -99 /), 6, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,4, -4, 1, 98, -99 /), 6, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,5, -5, 1, 98, -99 /), 6, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,1, -1, 3, 98, -99 /), 6, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,2, -2, 3, 98, -99 /), 6, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, -3, 3, 98, -99 /), 6, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,4, -4, 3, 98, -99 /), 6, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,5, -5, 3, 98, -99 /), 6, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=17,isub=10)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=17)"
          end select
c--- Qb em to enu ub Qb d
        case(18)
          select case (isub)
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=18)"
          end select
c--- Q em to enu ub Q d
        case(19)
          select case (isub)
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=19)"
          end select
c--- db em to enu ub Q Qb
        case(20)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, -1, 1, 98, -99 /), 6, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,2, -2, 1, 98, -99 /), 6, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,3, -3, 1, 98, -99 /), 6, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,4, -4, 1, 98, -99 /), 6, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,5, -5, 1, 98, -99 /), 6, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -2,0, 1, 98, -99 /), 5, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,1, -1, 3, 98, -99 /), 6, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,2, -2, 3, 98, -99 /), 6, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, -3, 3, 98, -99 /), 6, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,4, -4, 3, 98, -99 /), 6, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,5, -5, 3, 98, -99 /), 6, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(2) ! Reduced matrix element: B1g0W
              call dress_flav( (/ -4,0, 3, 98, -99 /), 5, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=20,isub=10)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=20)"
          end select
c--- u em to enu u ub d
        case(21)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -2,2, -2, 1, 98, -99 /), 6, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=21,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -4,4, -4, 3, 98, -99 /), 6, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=21,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=21)"
          end select
c--- ub em to enu ub ub d
        case(22)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -2,2, -2, 1, 98, -99 /), 6, ipass, (/ -2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=22,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -4,4, -4, 3, 98, -99 /), 6, ipass, (/ -4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=22,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=22)"
          end select
c--- db em to enu ub u ub
        case(23)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -2,2, -2, 1, 98, -99 /), 6, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=23,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -4,4, -4, 3, 98, -99 /), 6, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=23,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=23)"
          end select
c--- u em to enu d db d
        case(24)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, -1, 1, 98, -99 /), 6, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=24,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, -3, 3, 98, -99 /), 6, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=24,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=24)"
          end select
c--- db em to enu ub db d
        case(25)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, -1, 1, 98, -99 /), 6, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=25,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, -3, 3, 98, -99 /), 6, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=25,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=25)"
          end select
c--- d em to enu ub d d
        case(26)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, -1, 1, 98, -99 /), 6, ipass, (/ 1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=26,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, -3, 3, 98, -99 /), 6, ipass, (/ 3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=26,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=26)"
          end select
c--- u em to enu g d
        case(27)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=27,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=27,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=27)"
          end select
c--- g em to enu ub d
        case(28)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=28,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=28,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=28,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=28)"
          end select
c--- db em to enu ub g
        case(29)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=29,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=29,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -5,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=29,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=29)"
          end select
c--- u em to enu g d
        case(32)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=32,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=32,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=32)"
          end select
c--- g em to enu ub d
        case(33)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=33,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=33,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=33,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=33)"
          end select
c--- db em to enu ub g
        case(34)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=34,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=34,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -5,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=34,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=34)"
          end select
c--- u em to enu g d
        case(37)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=37,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=37,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=37)"
          end select
c--- g em to enu ub d
        case(38)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=38,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=38,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=38,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=38)"
          end select
c--- db em to enu ub g
        case(39)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=39,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=39,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -5,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=39,isub=3)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=39)"
          end select
c--- u em to enu d
        case(42)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g2WDIS1j matching to B0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=42,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g2WDIS1j matching to B0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=42,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=42)"
          end select
c--- db em to enu ub
        case(43)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g2WDIS1j matching to B0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=43,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g2WDIS1j matching to B0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=43,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=43)"
          end select
c--- d em subtraction
        case(46)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 1,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=46,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 3,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=46,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=46)"
          end select
c--- g em subtraction
        case(47)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 0,99 /))
            case(2) ! Reduced matrix element: sB0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=47,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 0,99 /))
            case(2) ! Reduced matrix element: sB0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=47,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=47)"
          end select
c--- ub em subtraction
        case(48)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -2,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=48,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -4,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=48,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=48)"
          end select
c--- u em to enu d
        case(49)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2WDIS1j matching to Bt0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=49,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2WDIS1j matching to Bt0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=49,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=49)"
          end select
c--- db em to enu ub
        case(50)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2WDIS1j matching to Bt0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=50,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2WDIS1j matching to Bt0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=50,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=50)"
          end select
c--- Q em subtraction
        case(51)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ Qp,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=51,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ Qp,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=51,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=51)"
          end select
c--- Qb em subtraction
        case(52)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -Qp,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=52,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -Qp,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=52,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=52)"
          end select
c--- d em subtraction
        case(53)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 1,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=53,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 3,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=53,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=53)"
          end select
c--- g em subtraction
        case(54)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 0,99 /))
            case(2) ! Reduced matrix element: sB0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=54,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 0,99 /))
            case(2) ! Reduced matrix element: sB0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=54,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=54)"
          end select
c--- ub em subtraction
        case(55)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -2,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=55,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -4,99 /))
            case(2) ! Reduced matrix element: B0g1W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=55,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=55)"
          end select
c--- u em to enu d
        case(56)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2WDIS1j matching to Bh0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case(2) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=56,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2WDIS1j matching to Bh0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case(2) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=56,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=56)"
          end select
c--- db em to enu ub
        case(57)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2WDIS1j matching to Bh0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case(2) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=57,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2WDIS1j matching to Bh0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case(2) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=57,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=57)"
          end select
c--- d em subtraction
        case(60)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 1,99 /))
            case(2) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 1,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=60,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 3,99 /))
            case(2) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 3,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=60,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=60)"
          end select
c--- g em subtraction
        case(61)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=61,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ 0,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=61,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=61)"
          end select
c--- ub em subtraction
        case(62)
          select case (isub)
          case(1)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -2,99 /))
            case(2) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -2,1, 98, -99 /), 4, ipass, (/ -2,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=62,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(1) ! Reduced matrix element: sB0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -4,99 /))
            case(2) ! Reduced matrix element: B0g0W
              call dress_flav( (/ -4,3, 98, -99 /), 4, ipass, (/ -4,99 /))
            case default
              stop "dress_flav_DISWm1j: unknown flav_block (ip=62,isub=2)"
            end select
          case default
            stop "dress_flav_DISWm1j: unknown isub (ip=62)"
          end select
        end select
      end subroutine dress_flav_DISWm1j

#endif

