#ifdef FLAVDISWp1j

      integer function max_nflavourDISWp1j()
        use Channels_mod, only: qactive_chan, ntot_chan
        implicit none
        integer ip, nflavourDISWp1j
        max_nflavourDISWp1j = 0
        do ip=1,ntot_chan
            if (.not.qactive_chan(ip)) cycle
            max_nflavourDISWp1j =  max(max_nflavourDISWp1j, nflavourDISWp1j(ip))
        end do
      end function max_nflavourDISWp1j


      integer function nflavourDISWp1j(ip)
        implicit none
        integer, intent(in) :: ip
        select case(ip)
c--- d ep to enub u
        case(1)
          nflavourDISWp1j = 2
c--- ub ep to enub db
        case(2)
          nflavourDISWp1j = 2
c--- d ep to enub g u
        case(3)
          nflavourDISWp1j = 2
c--- g ep to enub db u
        case(4)
          nflavourDISWp1j = 2
c--- ub ep to enub db g
        case(5)
          nflavourDISWp1j = 2
c--- d ep to enub u
        case(6)
          nflavourDISWp1j = 2
c--- ub ep to enub db
        case(7)
          nflavourDISWp1j = 2
c--- d ep to enub g g u
        case(11)
          nflavourDISWp1j = 2
c--- g ep to enub db g u
        case(12)
          nflavourDISWp1j = 2
c--- ub ep to enub db g g
        case(13)
          nflavourDISWp1j = 2
c--- d ep to enub gt gt u
        case(14)
          nflavourDISWp1j = 2
c--- gt ep to enub db gt u
        case(15)
          nflavourDISWp1j = 2
c--- ub ep to enub db gt gt
        case(16)
          nflavourDISWp1j = 2
c--- d ep to enub Q Qb u
        case(17)
          nflavourDISWp1j = 10
c--- Qb ep to enub db Qb u
        case(18)
          nflavourDISWp1j = 0
c--- Q ep to enub db Q u
        case(19)
          nflavourDISWp1j = 0
c--- ub ep to enub db Q Qb
        case(20)
          nflavourDISWp1j = 10
c--- d ep to enub d db u
        case(21)
          nflavourDISWp1j = 2
c--- db ep to enub db db u
        case(22)
          nflavourDISWp1j = 2
c--- ub ep to enub db d db
        case(23)
          nflavourDISWp1j = 2
c--- d ep to enub u ub u
        case(24)
          nflavourDISWp1j = 2
c--- ub ep to enub db ub u
        case(25)
          nflavourDISWp1j = 2
c--- u ep to enub db u u
        case(26)
          nflavourDISWp1j = 2
c--- d ep to enub g u
        case(27)
          nflavourDISWp1j = 2
c--- g ep to enub db u
        case(28)
          nflavourDISWp1j = 2
c--- ub ep to enub db g
        case(29)
          nflavourDISWp1j = 2
c--- d ep to enub g u
        case(32)
          nflavourDISWp1j = 2
c--- g ep to enub db u
        case(33)
          nflavourDISWp1j = 2
c--- ub ep to enub db g
        case(34)
          nflavourDISWp1j = 2
c--- d ep to enub g u
        case(37)
          nflavourDISWp1j = 2
c--- g ep to enub db u
        case(38)
          nflavourDISWp1j = 2
c--- ub ep to enub db g
        case(39)
          nflavourDISWp1j = 2
c--- d ep to enub u
        case(42)
          nflavourDISWp1j = 2
c--- ub ep to enub db
        case(43)
          nflavourDISWp1j = 2
c--- d ep to enub u
        case(49)
          nflavourDISWp1j = 2
c--- ub ep to enub db
        case(50)
          nflavourDISWp1j = 2
c--- d ep to enub u
        case(56)
          nflavourDISWp1j = 2
c--- ub ep to enub db
        case(57)
          nflavourDISWp1j = 2
        end select
      end function nflavourDISWp1j


      double precision function relfacflavourDISWp1j(ip)
        implicit none
        integer, intent(in) :: ip
        double precision nf, nup, ndown
        parameter(nf=5d0)
        parameter(nup=2d0)
        parameter(ndown=3d0)
        select case(ip)
c--- g ep to enub db u 
        case(4)
          relfacflavourDISWp1j = nup
c--- g ep to enub db g u 
        case(12)
          relfacflavourDISWp1j = nup
c--- gt ep to enub db gt u 
        case(15)
          relfacflavourDISWp1j = nup
c--- d ep to enub Q Qb u 
        case(17)
          relfacflavourDISWp1j = nf
c--- Qb ep to enub db Qb u 
        case(18)
          relfacflavourDISWp1j = nup
c--- Q ep to enub db Q u 
        case(19)
          relfacflavourDISWp1j = nup
c--- ub ep to enub db Q Qb 
        case(20)
          relfacflavourDISWp1j = nf
c--- g ep to enub db u 
        case(28)
          relfacflavourDISWp1j = nup
c--- g ep to enub db u 
        case(33)
          relfacflavourDISWp1j = nup
c--- g ep to enub db u 
        case(38)
          relfacflavourDISWp1j = nup
        case default
          relfacflavourDISWp1j = 1d0
        end select
      end function relfacflavourDISWp1j


      subroutine dress_flav_DISWp1j(ip, isub, ipass, flav_block)
        use Flavour_mod
        implicit none
        integer, intent(in) :: ip, isub, flav_block
        integer, intent(inout) :: ipass

        if (ipass == 0) return
        select case(ip)
c--- d ep to enub u
        case(1)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g0WDIS1j matching to B0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=1,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g0WDIS1j matching to B0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=1,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=1)"
          end select
c--- ub ep to enub db
        case(2)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g0WDIS1j matching to B0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=2,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g0WDIS1j matching to B0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=2,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=2)"
          end select
c--- d ep to enub g u
        case(3)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=3,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=3,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=3)"
          end select
c--- g ep to enub db u
        case(4)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=4,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=4,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=4)"
          end select
c--- ub ep to enub db g
        case(5)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,0, 2, 98, -99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=5,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0WDIS1j matching to B1g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,0, 4, 98, -99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=5,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=5)"
          end select
c--- d ep to enub u
        case(6)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g1WDIS1j matching to B0g1W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=6,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g1WDIS1j matching to B0g1W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=6,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=6)"
          end select
c--- ub ep to enub db
        case(7)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g1WDIS1j matching to B0g1W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=7,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g1WDIS1j matching to B0g1W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=7,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=7)"
          end select
c--- d ep to enub g g u
        case(11)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=11,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=11,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=11)"
          end select
c--- g ep to enub db g u
        case(12)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=12,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=12,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=12)"
          end select
c--- ub ep to enub db g g
        case(13)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=13,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB2g0WDIS1j matching to csB2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=13,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=13)"
          end select
c--- d ep to enub gt gt u
        case(14)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=14,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=14,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=14)"
          end select
c--- gt ep to enub db gt u
        case(15)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=15,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=15,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=15)"
          end select
c--- ub ep to enub db gt gt
        case(16)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=16,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt2g0WDIS1j matching to csBt2g0Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=16,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=16)"
          end select
c--- d ep to enub Q Qb u
        case(17)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=17,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=17)"
          end select
c--- Qb ep to enub db Qb u
        case(18)
          select case (isub)
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=18)"
          end select
c--- Q ep to enub db Q u
        case(19)
          select case (isub)
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=19)"
          end select
c--- ub ep to enub db Q Qb
        case(20)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,3, -3, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,4, -4, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,5, -5, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,1, -1, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,2, -2, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=9)"
            end select
          case(10)
            select case (flav_block)
            case(0) ! Matrix element: sC0g0WDIS1j matching to C0g0W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,5, -5, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=20,isub=10)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=20)"
          end select
c--- d ep to enub d db u
        case(21)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=21,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=21,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=21)"
          end select
c--- db ep to enub db db u
        case(22)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=22,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=22,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=22)"
          end select
c--- ub ep to enub db d db
        case(23)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -1,1, -1, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=23,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WaDIS1j matching to D0g0Wa in FLAVlistDISW1j.map
              call dress_flav( (/ -3,3, -3, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=23,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=23)"
          end select
c--- d ep to enub u ub u
        case(24)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=24,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=24,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=24)"
          end select
c--- ub ep to enub db ub u
        case(25)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=25,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=25,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=25)"
          end select
c--- u ep to enub db u u
        case(26)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, -2, 2, 98, -99 /), 6, ipass, (/ 2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=26,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0WbDIS1j matching to D0g0Wb in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, -4, 4, 98, -99 /), 6, ipass, (/ 4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=26,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=26)"
          end select
c--- d ep to enub g u
        case(27)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=27,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=27,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=27)"
          end select
c--- g ep to enub db u
        case(28)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=28,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=28,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=28)"
          end select
c--- ub ep to enub db g
        case(29)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=29,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csB1g1WDIS1j matching to csB1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=29,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=29)"
          end select
c--- d ep to enub g u
        case(32)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=32,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=32,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=32)"
          end select
c--- g ep to enub db u
        case(33)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=33,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=33,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=33)"
          end select
c--- ub ep to enub db g
        case(34)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=34,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBt1g1WDIS1j matching to csBt1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=34,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=34)"
          end select
c--- d ep to enub g u
        case(37)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=37,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=37,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=37)"
          end select
c--- g ep to enub db u
        case(38)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=38,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ 0,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=38,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=38)"
          end select
c--- ub ep to enub db g
        case(39)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=39,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: csBh1g1WDIS1j matching to csBh1g1Z in FLAVlistDISW1j.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=39,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=39)"
          end select
c--- d ep to enub u
        case(42)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g2WDIS1j matching to B0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=42,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g2WDIS1j matching to B0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=42,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=42)"
          end select
c--- ub ep to enub db
        case(43)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g2WDIS1j matching to B0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=43,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g2WDIS1j matching to B0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=43,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=43)"
          end select
c--- d ep to enub u
        case(49)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2WDIS1j matching to Bt0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=49,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2WDIS1j matching to Bt0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=49,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=49)"
          end select
c--- ub ep to enub db
        case(50)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2WDIS1j matching to Bt0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=50,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2WDIS1j matching to Bt0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=50,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=50)"
          end select
c--- d ep to enub u
        case(56)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2WDIS1j matching to Bh0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ 1,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=56,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2WDIS1j matching to Bh0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ 3,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=56,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=56)"
          end select
c--- ub ep to enub db
        case(57)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2WDIS1j matching to Bh0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -1,2, 98, -99 /), 4, ipass, (/ -2,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=57,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2WDIS1j matching to Bh0g2W in FLAVlistDISW1j.map
              call dress_flav( (/ -3,4, 98, -99 /), 4, ipass, (/ -4,-99 /))
            case default
              stop "dress_flav_DISWp1j: unknown flav_block (ip=57,isub=2)"
            end select
          case default
            stop "dress_flav_DISWp1j: unknown isub (ip=57)"
          end select
        end select
      end subroutine dress_flav_DISWp1j

#endif

