      function sigUDISWp1j(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUDISWp1j=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.eq.2.or.ix.eq.4) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d ep to enub u      
        if (qactive_chan(42).and.qselect_chan(42)) then
          current_chan = 42
          ip1_chan     = 40
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qepB0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db    
        if (qactive_chan(43).and.qselect_chan(43)) then
          current_chan = 43
          ip1_chan     = -20
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qbepB0g2WDIS1jU(ix,xri1,xri2,4,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep initiated      
        if (qactive_chan(44).and.qselect_chan(44)) then
          current_chan = 44
          ip1_chan     = 30
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qpepB0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep initiated     
        if (qactive_chan(45).and.qselect_chan(45)) then
          current_chan = 45
          ip1_chan     = -30
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qpbepB0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ep initiated     
        if (qactive_chan(46).and.qselect_chan(46)) then
          current_chan = 46
          ip1_chan     = -40
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = dbepB0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(47).and.qselect_chan(47)) then
          current_chan = 47
          ip1_chan     = 0
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = gepB0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ep initiated      
        if (qactive_chan(48).and.qselect_chan(48)) then
          current_chan = 48
          ip1_chan     = 20
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = uepB0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub u      
        if (qactive_chan(49).and.qselect_chan(49)) then
          current_chan = 49
          ip1_chan     = 40
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qepBt0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db    
        if (qactive_chan(50).and.qselect_chan(50)) then
          current_chan = 50
          ip1_chan     = -20
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qbepBt0g2WDIS1jU(ix,xri1,xri2,4,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep initiated      
        if (qactive_chan(51).and.qselect_chan(51)) then
          current_chan = 51
          ip1_chan     = 30
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qpepBt0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep initiated     
        if (qactive_chan(52).and.qselect_chan(52)) then
          current_chan = 52
          ip1_chan     = -30
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qpbepBt0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ep initiated     
        if (qactive_chan(53).and.qselect_chan(53)) then
          current_chan = 53
          ip1_chan     = -40
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = dbepBt0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(54).and.qselect_chan(54)) then
          current_chan = 54
          ip1_chan     = 0
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = gepBt0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ep initiated      
        if (qactive_chan(55).and.qselect_chan(55)) then
          current_chan = 55
          ip1_chan     = 20
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = uepBt0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ep to enub u      
        if (qactive_chan(56).and.qselect_chan(56)) then
          current_chan = 56
          ip1_chan     = 40
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qepBh0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ep to enub db    
        if (qactive_chan(57).and.qselect_chan(57)) then
          current_chan = 57
          ip1_chan     = -20
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qbepBh0g2WDIS1jU(ix,xri1,xri2,4,1,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ep initiated      
        if (qactive_chan(58).and.qselect_chan(58)) then
          current_chan = 58
          ip1_chan     = 30
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qpepBh0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ep initiated     
        if (qactive_chan(59).and.qselect_chan(59)) then
          current_chan = 59
          ip1_chan     = -30
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = qpbepBh0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ep initiated     
        if (qactive_chan(60).and.qselect_chan(60)) then
          current_chan = 60
          ip1_chan     = -40
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = dbepBh0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ep initiated      
        if (qactive_chan(61).and.qselect_chan(61)) then
          current_chan = 61
          ip1_chan     = 0
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = gepBh0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ep initiated      
        if (qactive_chan(62).and.qselect_chan(62)) then
          current_chan = 62
          ip1_chan     = 20
          ip2_chan     = -99
          call Q3_check
          nfB1 = 2
          wt = uepBh0g2WDIS1jU(ix,xri1,xri2,1,4,2,3,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUDISWp1j=sigUDISWp1j+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
