*********************************************************************
*
*
* Quark pair NLO real subtraction term for
*
* q(i1) g (i2) g (i3) qb(i4) e-(i5) e+(i6)
*
* summed and squared over helicities, single colour ordering without
* overall factors
*
* The flavour of the quark pair in this matrix element is determined from the flav variable in the common block /BGFlav/

      function gqB2g0GSNLO(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqB2g0GSNLO = qgB2g0GSNLO(i1,i2,i3,i4,i5)

      return
      end
      
      function gqbB2g0GSNLO(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      gqbB2g0GSNLO = qbgB2g0GSNLO(i1,i2,i3,i4,i5)

      return
      end

      function qbqB2g0GSNLO(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      parameter(pi=3.141592653589793238d0)

      qbqB2g0GSNLO = qqbB2g0GSNLO(i1,i2,i3,i4,i5)

      return
      end
      
*      function gqB2g0GSNLO_frag(i1,i2,i3,i4,i5)
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*      parameter(pi=3.141592653589793238d0)
*
*      gqB2g0GSNLO_frag = qgB2g0GSNLO_frag(i1,i2,i3,i4,i5)
*      
*      return
*      end
*      
*      function gqbB2g0GSNLO_frag(i1,i2,i3,i4,i5)
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*      parameter(pi=3.141592653589793238d0)
*
*      gqbB2g0GSNLO_frag = qbgB2g0GSNLO_frag(i1,i2,i3,i4,i5)
*
*      return
*      end

