      function sigTNLOGJJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLOGJJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d g to g d G        
        if (qactive_chan(215).and.qselect_chan(215)) then
          current_chan = 215
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g u G        
        if (qactive_chan(216).and.qselect_chan(216)) then
          current_chan = 216
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g g G       
        if (qactive_chan(217).and.qselect_chan(217)) then
          current_chan = 217
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsB2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g g G       
        if (qactive_chan(218).and.qselect_chan(218)) then
          current_chan = 218
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsB2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g d G        
        if (qactive_chan(219).and.qselect_chan(219)) then
          current_chan = 219
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqsB2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g u G        
        if (qactive_chan(220).and.qselect_chan(220)) then
          current_chan = 220
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqsB2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g g G       
        if (qactive_chan(221).and.qselect_chan(221)) then
          current_chan = 221
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsB2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g g G       
        if (qactive_chan(222).and.qselect_chan(222)) then
          current_chan = 222
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsB2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db d G       
        if (qactive_chan(223).and.qselect_chan(223)) then
          current_chan = 223
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggsB2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub u G       
        if (qactive_chan(224).and.qselect_chan(224)) then
          current_chan = 224
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggsB2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db g G      
        if (qactive_chan(225).and.qselect_chan(225)) then
          current_chan = 225
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbsB2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub g G      
        if (qactive_chan(226).and.qselect_chan(226)) then
          current_chan = 226
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbsB2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db g G      
        if (qactive_chan(227).and.qselect_chan(227)) then
          current_chan = 227
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgsB2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub g G      
        if (qactive_chan(228).and.qselect_chan(228)) then
          current_chan = 228
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgsB2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(229).and.qselect_chan(229)) then
          current_chan = 229
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(230).and.qselect_chan(230)) then
          current_chan = 230
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(231).and.qselect_chan(231)) then
          current_chan = 231
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(232).and.qselect_chan(232)) then
          current_chan = 232
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(233).and.qselect_chan(233)) then
          current_chan = 233
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(234).and.qselect_chan(234)) then
          current_chan = 234
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(235).and.qselect_chan(235)) then
          current_chan = 235
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(236).and.qselect_chan(236)) then
          current_chan = 236
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(237).and.qselect_chan(237)) then
          current_chan = 237
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(238).and.qselect_chan(238)) then
          current_chan = 238
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(239).and.qselect_chan(239)) then
          current_chan = 239
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(240).and.qselect_chan(240)) then
          current_chan = 240
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(241).and.qselect_chan(241)) then
          current_chan = 241
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(242).and.qselect_chan(242)) then
          current_chan = 242
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(243).and.qselect_chan(243)) then
          current_chan = 243
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(244).and.qselect_chan(244)) then
          current_chan = 244
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsB2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to g d G        
        if (qactive_chan(245).and.qselect_chan(245)) then
          current_chan = 245
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g u G        
        if (qactive_chan(246).and.qselect_chan(246)) then
          current_chan = 246
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g g G       
        if (qactive_chan(247).and.qselect_chan(247)) then
          current_chan = 247
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBt2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g g G       
        if (qactive_chan(248).and.qselect_chan(248)) then
          current_chan = 248
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBt2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g d G        
        if (qactive_chan(249).and.qselect_chan(249)) then
          current_chan = 249
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqsBt2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g u G        
        if (qactive_chan(250).and.qselect_chan(250)) then
          current_chan = 250
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqsBt2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g g G       
        if (qactive_chan(251).and.qselect_chan(251)) then
          current_chan = 251
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBt2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g g G       
        if (qactive_chan(252).and.qselect_chan(252)) then
          current_chan = 252
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBt2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db d G       
        if (qactive_chan(253).and.qselect_chan(253)) then
          current_chan = 253
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggsBt2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub u G       
        if (qactive_chan(254).and.qselect_chan(254)) then
          current_chan = 254
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggsBt2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db g G      
        if (qactive_chan(255).and.qselect_chan(255)) then
          current_chan = 255
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbsBt2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub g G      
        if (qactive_chan(256).and.qselect_chan(256)) then
          current_chan = 256
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbsBt2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db g G      
        if (qactive_chan(257).and.qselect_chan(257)) then
          current_chan = 257
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgsBt2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub g G      
        if (qactive_chan(258).and.qselect_chan(258)) then
          current_chan = 258
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgsBt2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(259).and.qselect_chan(259)) then
          current_chan = 259
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(260).and.qselect_chan(260)) then
          current_chan = 260
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(261).and.qselect_chan(261)) then
          current_chan = 261
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(262).and.qselect_chan(262)) then
          current_chan = 262
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(263).and.qselect_chan(263)) then
          current_chan = 263
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(264).and.qselect_chan(264)) then
          current_chan = 264
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(265).and.qselect_chan(265)) then
          current_chan = 265
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(266).and.qselect_chan(266)) then
          current_chan = 266
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(267).and.qselect_chan(267)) then
          current_chan = 267
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(268).and.qselect_chan(268)) then
          current_chan = 268
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(269).and.qselect_chan(269)) then
          current_chan = 269
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(270).and.qselect_chan(270)) then
          current_chan = 270
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(271).and.qselect_chan(271)) then
          current_chan = 271
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(272).and.qselect_chan(272)) then
          current_chan = 272
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(273).and.qselect_chan(273)) then
          current_chan = 273
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(274).and.qselect_chan(274)) then
          current_chan = 274
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsBt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt d G      
        if (qactive_chan(275).and.qselect_chan(275)) then
          current_chan = 275
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgtsBtt2g1GcTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt u G      
        if (qactive_chan(276).and.qselect_chan(276)) then
          current_chan = 276
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgtsBtt2g1GcTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to gt gt G     
        if (qactive_chan(277).and.qselect_chan(277)) then
          current_chan = 277
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBtt2g1GcTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to gt gt G     
        if (qactive_chan(278).and.qselect_chan(278)) then
          current_chan = 278
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBtt2g1GcTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt d G      
        if (qactive_chan(279).and.qselect_chan(279)) then
          current_chan = 279
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gtqsBtt2g1GcTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt u G      
        if (qactive_chan(280).and.qselect_chan(280)) then
          current_chan = 280
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gtqsBtt2g1GcTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to gt gt G     
        if (qactive_chan(281).and.qselect_chan(281)) then
          current_chan = 281
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBtt2g1GcTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to gt gt G     
        if (qactive_chan(282).and.qselect_chan(282)) then
          current_chan = 282
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBtt2g1GcTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db d G     
        if (qactive_chan(283).and.qselect_chan(283)) then
          current_chan = 283
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = gtgtsBtt2g1GcTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub u G     
        if (qactive_chan(284).and.qselect_chan(284)) then
          current_chan = 284
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = gtgtsBtt2g1GcTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to db gt G    
        if (qactive_chan(285).and.qselect_chan(285)) then
          current_chan = 285
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gtqbsBtt2g1GcTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to ub gt G    
        if (qactive_chan(286).and.qselect_chan(286)) then
          current_chan = 286
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gtqbsBtt2g1GcTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to db gt G    
        if (qactive_chan(287).and.qselect_chan(287)) then
          current_chan = 287
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgtsBtt2g1GcTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to ub gt G    
        if (qactive_chan(288).and.qselect_chan(288)) then
          current_chan = 288
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgtsBtt2g1GcTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt d G      
        if (qactive_chan(289).and.qselect_chan(289)) then
          current_chan = 289
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgtsBttt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt u G      
        if (qactive_chan(290).and.qselect_chan(290)) then
          current_chan = 290
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgtsBttt2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to gt gt G     
        if (qactive_chan(291).and.qselect_chan(291)) then
          current_chan = 291
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBttt2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to gt gt G     
        if (qactive_chan(292).and.qselect_chan(292)) then
          current_chan = 292
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBttt2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt d G      
        if (qactive_chan(293).and.qselect_chan(293)) then
          current_chan = 293
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gtqsBttt2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt u G      
        if (qactive_chan(294).and.qselect_chan(294)) then
          current_chan = 294
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gtqsBttt2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to gt gt G     
        if (qactive_chan(295).and.qselect_chan(295)) then
          current_chan = 295
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBttt2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to gt gt G     
        if (qactive_chan(296).and.qselect_chan(296)) then
          current_chan = 296
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBttt2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db d G     
        if (qactive_chan(297).and.qselect_chan(297)) then
          current_chan = 297
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = gtgtsBttt2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub u G     
        if (qactive_chan(298).and.qselect_chan(298)) then
          current_chan = 298
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = gtgtsBttt2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to db gt G    
        if (qactive_chan(299).and.qselect_chan(299)) then
          current_chan = 299
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gtqbsBttt2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to ub gt G    
        if (qactive_chan(300).and.qselect_chan(300)) then
          current_chan = 300
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gtqbsBttt2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to db gt G    
        if (qactive_chan(301).and.qselect_chan(301)) then
          current_chan = 301
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgtsBttt2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to ub gt G    
        if (qactive_chan(302).and.qselect_chan(302)) then
          current_chan = 302
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgtsBttt2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to g d G        
        if (qactive_chan(303).and.qselect_chan(303)) then
          current_chan = 303
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g u G        
        if (qactive_chan(304).and.qselect_chan(304)) then
          current_chan = 304
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g g G       
        if (qactive_chan(305).and.qselect_chan(305)) then
          current_chan = 305
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBh2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g g G       
        if (qactive_chan(306).and.qselect_chan(306)) then
          current_chan = 306
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBh2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g d G        
        if (qactive_chan(307).and.qselect_chan(307)) then
          current_chan = 307
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqsBh2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g u G        
        if (qactive_chan(308).and.qselect_chan(308)) then
          current_chan = 308
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqsBh2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g g G       
        if (qactive_chan(309).and.qselect_chan(309)) then
          current_chan = 309
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBh2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g g G       
        if (qactive_chan(310).and.qselect_chan(310)) then
          current_chan = 310
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBh2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db d G       
        if (qactive_chan(311).and.qselect_chan(311)) then
          current_chan = 311
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggsBh2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub u G       
        if (qactive_chan(312).and.qselect_chan(312)) then
          current_chan = 312
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggsBh2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db g G      
        if (qactive_chan(313).and.qselect_chan(313)) then
          current_chan = 313
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbsBh2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub g G      
        if (qactive_chan(314).and.qselect_chan(314)) then
          current_chan = 314
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbsBh2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db g G      
        if (qactive_chan(315).and.qselect_chan(315)) then
          current_chan = 315
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgsBh2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub g G      
        if (qactive_chan(316).and.qselect_chan(316)) then
          current_chan = 316
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgsBh2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(317).and.qselect_chan(317)) then
          current_chan = 317
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(318).and.qselect_chan(318)) then
          current_chan = 318
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(319).and.qselect_chan(319)) then
          current_chan = 319
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(320).and.qselect_chan(320)) then
          current_chan = 320
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(321).and.qselect_chan(321)) then
          current_chan = 321
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(322).and.qselect_chan(322)) then
          current_chan = 322
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(323).and.qselect_chan(323)) then
          current_chan = 323
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(324).and.qselect_chan(324)) then
          current_chan = 324
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(325).and.qselect_chan(325)) then
          current_chan = 325
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(326).and.qselect_chan(326)) then
          current_chan = 326
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(327).and.qselect_chan(327)) then
          current_chan = 327
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(328).and.qselect_chan(328)) then
          current_chan = 328
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(329).and.qselect_chan(329)) then
          current_chan = 329
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(330).and.qselect_chan(330)) then
          current_chan = 330
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(331).and.qselect_chan(331)) then
          current_chan = 331
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(332).and.qselect_chan(332)) then
          current_chan = 332
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsBh2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d gt to gt d G      
        if (qactive_chan(333).and.qselect_chan(333)) then
          current_chan = 333
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgtsBth2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u gt to gt u G      
        if (qactive_chan(334).and.qselect_chan(334)) then
          current_chan = 334
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgtsBth2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to gt gt G     
        if (qactive_chan(335).and.qselect_chan(335)) then
          current_chan = 335
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbsBth2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to gt gt G     
        if (qactive_chan(336).and.qselect_chan(336)) then
          current_chan = 336
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbsBth2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt d to gt d G      
        if (qactive_chan(337).and.qselect_chan(337)) then
          current_chan = 337
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gtqsBth2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt u to gt u G      
        if (qactive_chan(338).and.qselect_chan(338)) then
          current_chan = 338
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gtqsBth2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to gt gt G     
        if (qactive_chan(339).and.qselect_chan(339)) then
          current_chan = 339
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqsBth2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to gt gt G     
        if (qactive_chan(340).and.qselect_chan(340)) then
          current_chan = 340
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqsBth2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to db d G     
        if (qactive_chan(341).and.qselect_chan(341)) then
          current_chan = 341
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = gtgtsBth2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to ub u G     
        if (qactive_chan(342).and.qselect_chan(342)) then
          current_chan = 342
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = gtgtsBth2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt db to db gt G    
        if (qactive_chan(343).and.qselect_chan(343)) then
          current_chan = 343
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gtqbsBth2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt ub to ub gt G    
        if (qactive_chan(344).and.qselect_chan(344)) then
          current_chan = 344
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gtqbsBth2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db gt to db gt G    
        if (qactive_chan(345).and.qselect_chan(345)) then
          current_chan = 345
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgtsBth2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub gt to ub gt G    
        if (qactive_chan(346).and.qselect_chan(346)) then
          current_chan = 346
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgtsBth2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to g d G        
        if (qactive_chan(347).and.qselect_chan(347)) then
          current_chan = 347
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g to g u G        
        if (qactive_chan(348).and.qselect_chan(348)) then
          current_chan = 348
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to g g G       
        if (qactive_chan(349).and.qselect_chan(349)) then
          current_chan = 349
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbBv2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to g g G       
        if (qactive_chan(350).and.qselect_chan(350)) then
          current_chan = 350
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbBv2g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to g d G        
        if (qactive_chan(351).and.qselect_chan(351)) then
          current_chan = 351
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqBv2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u to g u G        
        if (qactive_chan(352).and.qselect_chan(352)) then
          current_chan = 352
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqBv2g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to g g G       
        if (qactive_chan(353).and.qselect_chan(353)) then
          current_chan = 353
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqBv2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to g g G       
        if (qactive_chan(354).and.qselect_chan(354)) then
          current_chan = 354
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqBv2g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to db d G       
        if (qactive_chan(355).and.qselect_chan(355)) then
          current_chan = 355
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 1
          wt = ggBv2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to ub u G       
        if (qactive_chan(356).and.qselect_chan(356)) then
          current_chan = 356
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 2
          wt = ggBv2g1GTNLO(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db to db g G      
        if (qactive_chan(357).and.qselect_chan(357)) then
          current_chan = 357
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbBv2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to ub g G      
        if (qactive_chan(358).and.qselect_chan(358)) then
          current_chan = 358
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbBv2g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g to db g G      
        if (qactive_chan(359).and.qselect_chan(359)) then
          current_chan = 359
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgBv2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to ub g G      
        if (qactive_chan(360).and.qselect_chan(360)) then
          current_chan = 360
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgBv2g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d initiated       
        if (qactive_chan(361).and.qselect_chan(361)) then
          current_chan = 361
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(362).and.qselect_chan(362)) then
          current_chan = 362
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(363).and.qselect_chan(363)) then
          current_chan = 363
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u initiated       
        if (qactive_chan(364).and.qselect_chan(364)) then
          current_chan = 364
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db initiated      
        if (qactive_chan(365).and.qselect_chan(365)) then
          current_chan = 365
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub initiated      
        if (qactive_chan(366).and.qselect_chan(366)) then
          current_chan = 366
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db initiated      
        if (qactive_chan(367).and.qselect_chan(367)) then
          current_chan = 367
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub initiated      
        if (qactive_chan(368).and.qselect_chan(368)) then
          current_chan = 368
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d initiated      
        if (qactive_chan(369).and.qselect_chan(369)) then
          current_chan = 369
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u initiated      
        if (qactive_chan(370).and.qselect_chan(370)) then
          current_chan = 370
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d initiated      
        if (qactive_chan(371).and.qselect_chan(371)) then
          current_chan = 371
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u initiated      
        if (qactive_chan(372).and.qselect_chan(372)) then
          current_chan = 372
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db initiated     
        if (qactive_chan(373).and.qselect_chan(373)) then
          current_chan = 373
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(374).and.qselect_chan(374)) then
          current_chan = 374
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(375).and.qselect_chan(375)) then
          current_chan = 375
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub initiated     
        if (qactive_chan(376).and.qselect_chan(376)) then
          current_chan = 376
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbBv2g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d G      
        if (qactive_chan(377).and.qselect_chan(377)) then
          current_chan = 377
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub d G      
        if (qactive_chan(378).and.qselect_chan(378)) then
          current_chan = 378
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db u G      
        if (qactive_chan(379).and.qselect_chan(379)) then
          current_chan = 379
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u G      
        if (qactive_chan(380).and.qselect_chan(380)) then
          current_chan = 380
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d G        
        if (qactive_chan(381).and.qselect_chan(381)) then
          current_chan = 381
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsC0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u d G        
        if (qactive_chan(382).and.qselect_chan(382)) then
          current_chan = 382
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsC0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d u G        
        if (qactive_chan(383).and.qselect_chan(383)) then
          current_chan = 383
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsC0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u G        
        if (qactive_chan(384).and.qselect_chan(384)) then
          current_chan = 384
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsC0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to d db G      
        if (qactive_chan(385).and.qselect_chan(385)) then
          current_chan = 385
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbsC0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to u ub G      
        if (qactive_chan(386).and.qselect_chan(386)) then
          current_chan = 386
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = qqbsC0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to d db G      
        if (qactive_chan(387).and.qselect_chan(387)) then
          current_chan = 387
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = qqbsC0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to u ub G      
        if (qactive_chan(388).and.qselect_chan(388)) then
          current_chan = 388
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbsC0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to d db G      
        if (qactive_chan(389).and.qselect_chan(389)) then
          current_chan = 389
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqsC0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to u ub G      
        if (qactive_chan(390).and.qselect_chan(390)) then
          current_chan = 390
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = qbqsC0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to d db G      
        if (qactive_chan(391).and.qselect_chan(391)) then
          current_chan = 391
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = qbqsC0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to u ub G      
        if (qactive_chan(392).and.qselect_chan(392)) then
          current_chan = 392
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqsC0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db G    
        if (qactive_chan(393).and.qselect_chan(393)) then
          current_chan = 393
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsC0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db ub G    
        if (qactive_chan(394).and.qselect_chan(394)) then
          current_chan = 394
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsC0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub db G    
        if (qactive_chan(395).and.qselect_chan(395)) then
          current_chan = 395
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsC0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub G    
        if (qactive_chan(396).and.qselect_chan(396)) then
          current_chan = 396
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsC0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d G      
        if (qactive_chan(397).and.qselect_chan(397)) then
          current_chan = 397
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsC0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db u G      
        if (qactive_chan(398).and.qselect_chan(398)) then
          current_chan = 398
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsC0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub d G      
        if (qactive_chan(399).and.qselect_chan(399)) then
          current_chan = 399
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsC0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u G      
        if (qactive_chan(400).and.qselect_chan(400)) then
          current_chan = 400
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsC0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(401).and.qselect_chan(401)) then
          current_chan = 401
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = gqsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(402).and.qselect_chan(402)) then
          current_chan = 402
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = gqsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(403).and.qselect_chan(403)) then
          current_chan = 403
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = gqsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(404).and.qselect_chan(404)) then
          current_chan = 404
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = gqsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(405).and.qselect_chan(405)) then
          current_chan = 405
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = gqbsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(406).and.qselect_chan(406)) then
          current_chan = 406
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = gqbsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(407).and.qselect_chan(407)) then
          current_chan = 407
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = gqbsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(408).and.qselect_chan(408)) then
          current_chan = 408
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = gqbsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(409).and.qselect_chan(409)) then
          current_chan = 409
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qgsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(410).and.qselect_chan(410)) then
          current_chan = 410
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qgsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(411).and.qselect_chan(411)) then
          current_chan = 411
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qgsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(412).and.qselect_chan(412)) then
          current_chan = 412
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qgsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(413).and.qselect_chan(413)) then
          current_chan = 413
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qbgsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(414).and.qselect_chan(414)) then
          current_chan = 414
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qbgsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(415).and.qselect_chan(415)) then
          current_chan = 415
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qbgsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(416).and.qselect_chan(416)) then
          current_chan = 416
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qbgsC0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d G      
        if (qactive_chan(417).and.qselect_chan(417)) then
          current_chan = 417
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub d G      
        if (qactive_chan(418).and.qselect_chan(418)) then
          current_chan = 418
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db u G      
        if (qactive_chan(419).and.qselect_chan(419)) then
          current_chan = 419
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u G      
        if (qactive_chan(420).and.qselect_chan(420)) then
          current_chan = 420
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d G        
        if (qactive_chan(421).and.qselect_chan(421)) then
          current_chan = 421
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsCt0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u d G        
        if (qactive_chan(422).and.qselect_chan(422)) then
          current_chan = 422
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsCt0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d u G        
        if (qactive_chan(423).and.qselect_chan(423)) then
          current_chan = 423
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsCt0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u G        
        if (qactive_chan(424).and.qselect_chan(424)) then
          current_chan = 424
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsCt0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to d db G      
        if (qactive_chan(425).and.qselect_chan(425)) then
          current_chan = 425
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbsCt0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to u ub G      
        if (qactive_chan(426).and.qselect_chan(426)) then
          current_chan = 426
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = qqbsCt0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to d db G      
        if (qactive_chan(427).and.qselect_chan(427)) then
          current_chan = 427
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = qqbsCt0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to u ub G      
        if (qactive_chan(428).and.qselect_chan(428)) then
          current_chan = 428
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbsCt0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to d db G      
        if (qactive_chan(429).and.qselect_chan(429)) then
          current_chan = 429
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqsCt0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to u ub G      
        if (qactive_chan(430).and.qselect_chan(430)) then
          current_chan = 430
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = qbqsCt0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to d db G      
        if (qactive_chan(431).and.qselect_chan(431)) then
          current_chan = 431
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = qbqsCt0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to u ub G      
        if (qactive_chan(432).and.qselect_chan(432)) then
          current_chan = 432
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqsCt0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db G    
        if (qactive_chan(433).and.qselect_chan(433)) then
          current_chan = 433
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsCt0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db ub G    
        if (qactive_chan(434).and.qselect_chan(434)) then
          current_chan = 434
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsCt0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub db G    
        if (qactive_chan(435).and.qselect_chan(435)) then
          current_chan = 435
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsCt0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub G    
        if (qactive_chan(436).and.qselect_chan(436)) then
          current_chan = 436
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsCt0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d G      
        if (qactive_chan(437).and.qselect_chan(437)) then
          current_chan = 437
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsCt0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db u G      
        if (qactive_chan(438).and.qselect_chan(438)) then
          current_chan = 438
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsCt0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub d G      
        if (qactive_chan(439).and.qselect_chan(439)) then
          current_chan = 439
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsCt0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u G      
        if (qactive_chan(440).and.qselect_chan(440)) then
          current_chan = 440
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsCt0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(441).and.qselect_chan(441)) then
          current_chan = 441
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = gqsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(442).and.qselect_chan(442)) then
          current_chan = 442
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = gqsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(443).and.qselect_chan(443)) then
          current_chan = 443
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = gqsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(444).and.qselect_chan(444)) then
          current_chan = 444
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = gqsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(445).and.qselect_chan(445)) then
          current_chan = 445
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = gqbsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(446).and.qselect_chan(446)) then
          current_chan = 446
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = gqbsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(447).and.qselect_chan(447)) then
          current_chan = 447
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = gqbsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(448).and.qselect_chan(448)) then
          current_chan = 448
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = gqbsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(449).and.qselect_chan(449)) then
          current_chan = 449
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qgsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(450).and.qselect_chan(450)) then
          current_chan = 450
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qgsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(451).and.qselect_chan(451)) then
          current_chan = 451
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qgsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(452).and.qselect_chan(452)) then
          current_chan = 452
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qgsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(453).and.qselect_chan(453)) then
          current_chan = 453
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qbgsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(454).and.qselect_chan(454)) then
          current_chan = 454
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qbgsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(455).and.qselect_chan(455)) then
          current_chan = 455
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qbgsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(456).and.qselect_chan(456)) then
          current_chan = 456
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qbgsCt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d G      
        if (qactive_chan(457).and.qselect_chan(457)) then
          current_chan = 457
          ip1_chan     = 11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qqpbsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to ub d G      
        if (qactive_chan(458).and.qselect_chan(458)) then
          current_chan = 458
          ip1_chan     = 11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qqpbsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u db to db u G      
        if (qactive_chan(459).and.qselect_chan(459)) then
          current_chan = 459
          ip1_chan     = 21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qqpbsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u G      
        if (qactive_chan(460).and.qselect_chan(460)) then
          current_chan = 460
          ip1_chan     = 21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qqpbsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d G        
        if (qactive_chan(461).and.qselect_chan(461)) then
          current_chan = 461
          ip1_chan     = 11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qqpsCh0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u to u d G        
        if (qactive_chan(462).and.qselect_chan(462)) then
          current_chan = 462
          ip1_chan     = 11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qqpsCh0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d to d u G        
        if (qactive_chan(463).and.qselect_chan(463)) then
          current_chan = 463
          ip1_chan     = 21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qqpsCh0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u G        
        if (qactive_chan(464).and.qselect_chan(464)) then
          current_chan = 464
          ip1_chan     = 21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qqpsCh0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to d db G      
        if (qactive_chan(465).and.qselect_chan(465)) then
          current_chan = 465
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbsCh0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to u ub G      
        if (qactive_chan(466).and.qselect_chan(466)) then
          current_chan = 466
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = qqbsCh0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to d db G      
        if (qactive_chan(467).and.qselect_chan(467)) then
          current_chan = 467
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = qqbsCh0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to u ub G      
        if (qactive_chan(468).and.qselect_chan(468)) then
          current_chan = 468
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbsCh0g1GTNLO(ix,xri1,xri2,1,3,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to d db G      
        if (qactive_chan(469).and.qselect_chan(469)) then
          current_chan = 469
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqsCh0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to u ub G      
        if (qactive_chan(470).and.qselect_chan(470)) then
          current_chan = 470
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = qbqsCh0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to d db G      
        if (qactive_chan(471).and.qselect_chan(471)) then
          current_chan = 471
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = qbqsCh0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to u ub G      
        if (qactive_chan(472).and.qselect_chan(472)) then
          current_chan = 472
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqsCh0g1GTNLO(ix,xri1,xri2,2,3,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db G    
        if (qactive_chan(473).and.qselect_chan(473)) then
          current_chan = 473
          ip1_chan     = -11
          ip2_chan     = -11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpbsCh0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub to db ub G    
        if (qactive_chan(474).and.qselect_chan(474)) then
          current_chan = 474
          ip1_chan     = -11
          ip2_chan     = -21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpbsCh0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db to ub db G    
        if (qactive_chan(475).and.qselect_chan(475)) then
          current_chan = 475
          ip1_chan     = -21
          ip2_chan     = -11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpbsCh0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub G    
        if (qactive_chan(476).and.qselect_chan(476)) then
          current_chan = 476
          ip1_chan     = -21
          ip2_chan     = -21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpbsCh0g1GTNLO(ix,xri1,xri2,3,2,4,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d G      
        if (qactive_chan(477).and.qselect_chan(477)) then
          current_chan = 477
          ip1_chan     = -11
          ip2_chan     = 11
          nfC1 = 1
          nfC2 = 1
          wt = qbqpsCh0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db u to db u G      
        if (qactive_chan(478).and.qselect_chan(478)) then
          current_chan = 478
          ip1_chan     = -11
          ip2_chan     = 21
          nfC1 = 1
          nfC2 = 2
          wt = qbqpsCh0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to ub d G      
        if (qactive_chan(479).and.qselect_chan(479)) then
          current_chan = 479
          ip1_chan     = -21
          ip2_chan     = 11
          nfC1 = 2
          nfC2 = 1
          wt = qbqpsCh0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u G      
        if (qactive_chan(480).and.qselect_chan(480)) then
          current_chan = 480
          ip1_chan     = -21
          ip2_chan     = 21
          nfC1 = 2
          nfC2 = 2
          wt = qbqpsCh0g1GTNLO(ix,xri1,xri2,3,4,2,1,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(481).and.qselect_chan(481)) then
          current_chan = 481
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = gqsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(482).and.qselect_chan(482)) then
          current_chan = 482
          ip1_chan     = 0
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 2
          wt = gqsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(483).and.qselect_chan(483)) then
          current_chan = 483
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 1
          wt = gqsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(484).and.qselect_chan(484)) then
          current_chan = 484
          ip1_chan     = 0
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = gqsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(485).and.qselect_chan(485)) then
          current_chan = 485
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = gqbsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(486).and.qselect_chan(486)) then
          current_chan = 486
          ip1_chan     = 0
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 2
          wt = gqbsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(487).and.qselect_chan(487)) then
          current_chan = 487
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 1
          wt = gqbsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(488).and.qselect_chan(488)) then
          current_chan = 488
          ip1_chan     = 0
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = gqbsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(489).and.qselect_chan(489)) then
          current_chan = 489
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qgsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(490).and.qselect_chan(490)) then
          current_chan = 490
          ip1_chan     = 10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qgsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(491).and.qselect_chan(491)) then
          current_chan = 491
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qgsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(492).and.qselect_chan(492)) then
          current_chan = 492
          ip1_chan     = 20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qgsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(493).and.qselect_chan(493)) then
          current_chan = 493
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 1
          wt = qbgsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(494).and.qselect_chan(494)) then
          current_chan = 494
          ip1_chan     = -10
          ip2_chan     = 0
          nfC1 = 1
          nfC2 = 2
          wt = qbgsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(495).and.qselect_chan(495)) then
          current_chan = 495
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 1
          wt = qbgsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(496).and.qselect_chan(496)) then
          current_chan = 496
          ip1_chan     = -20
          ip2_chan     = 0
          nfC1 = 2
          nfC2 = 2
          wt = qbgsCh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d G      
        if (qactive_chan(497).and.qselect_chan(497)) then
          current_chan = 497
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u G      
        if (qactive_chan(498).and.qselect_chan(498)) then
          current_chan = 498
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d G        
        if (qactive_chan(499).and.qselect_chan(499)) then
          current_chan = 499
          ip1_chan     = 10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qqD0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u G        
        if (qactive_chan(500).and.qselect_chan(500)) then
          current_chan = 500
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qqD0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d G      
        if (qactive_chan(501).and.qselect_chan(501)) then
          current_chan = 501
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqD0g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u G      
        if (qactive_chan(502).and.qselect_chan(502)) then
          current_chan = 502
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqD0g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db G    
        if (qactive_chan(503).and.qselect_chan(503)) then
          current_chan = 503
          ip1_chan     = -10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qbqbD0g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub G    
        if (qactive_chan(504).and.qselect_chan(504)) then
          current_chan = 504
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qbqbD0g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(505).and.qselect_chan(505)) then
          current_chan = 505
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(506).and.qselect_chan(506)) then
          current_chan = 506
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(507).and.qselect_chan(507)) then
          current_chan = 507
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(508).and.qselect_chan(508)) then
          current_chan = 508
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(509).and.qselect_chan(509)) then
          current_chan = 509
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(510).and.qselect_chan(510)) then
          current_chan = 510
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(511).and.qselect_chan(511)) then
          current_chan = 511
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(512).and.qselect_chan(512)) then
          current_chan = 512
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgD0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d G      
        if (qactive_chan(513).and.qselect_chan(513)) then
          current_chan = 513
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u G      
        if (qactive_chan(514).and.qselect_chan(514)) then
          current_chan = 514
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d G        
        if (qactive_chan(515).and.qselect_chan(515)) then
          current_chan = 515
          ip1_chan     = 10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qqDt0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u G        
        if (qactive_chan(516).and.qselect_chan(516)) then
          current_chan = 516
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qqDt0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d G      
        if (qactive_chan(517).and.qselect_chan(517)) then
          current_chan = 517
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqDt0g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u G      
        if (qactive_chan(518).and.qselect_chan(518)) then
          current_chan = 518
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqDt0g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db G    
        if (qactive_chan(519).and.qselect_chan(519)) then
          current_chan = 519
          ip1_chan     = -10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qbqbDt0g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub G    
        if (qactive_chan(520).and.qselect_chan(520)) then
          current_chan = 520
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qbqbDt0g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(521).and.qselect_chan(521)) then
          current_chan = 521
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(522).and.qselect_chan(522)) then
          current_chan = 522
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(523).and.qselect_chan(523)) then
          current_chan = 523
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(524).and.qselect_chan(524)) then
          current_chan = 524
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(525).and.qselect_chan(525)) then
          current_chan = 525
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(526).and.qselect_chan(526)) then
          current_chan = 526
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(527).and.qselect_chan(527)) then
          current_chan = 527
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(528).and.qselect_chan(528)) then
          current_chan = 528
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgDt0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d db to db d G      
        if (qactive_chan(529).and.qselect_chan(529)) then
          current_chan = 529
          ip1_chan     = 10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qqbDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to ub u G      
        if (qactive_chan(530).and.qselect_chan(530)) then
          current_chan = 530
          ip1_chan     = 20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qqbDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d d to d d G        
        if (qactive_chan(531).and.qselect_chan(531)) then
          current_chan = 531
          ip1_chan     = 10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qqDh0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u u to u u G        
        if (qactive_chan(532).and.qselect_chan(532)) then
          current_chan = 532
          ip1_chan     = 20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qqDh0g1GTNLO(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to db d G      
        if (qactive_chan(533).and.qselect_chan(533)) then
          current_chan = 533
          ip1_chan     = -10
          ip2_chan     = 10
          nfC1 = 1
          nfC2 = 1
          wt = qbqDh0g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to ub u G      
        if (qactive_chan(534).and.qselect_chan(534)) then
          current_chan = 534
          ip1_chan     = -20
          ip2_chan     = 20
          nfC1 = 2
          nfC2 = 2
          wt = qbqDh0g1GTNLO(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db db to db db G    
        if (qactive_chan(535).and.qselect_chan(535)) then
          current_chan = 535
          ip1_chan     = -10
          ip2_chan     = -10
          nfC1 = 1
          nfC2 = 1
          wt = qbqbDh0g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub ub to ub ub G    
        if (qactive_chan(536).and.qselect_chan(536)) then
          current_chan = 536
          ip1_chan     = -20
          ip2_chan     = -20
          nfC1 = 2
          nfC2 = 2
          wt = qbqbDh0g1GTNLO(ix,xri1,xri2,3,1,4,2,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(537).and.qselect_chan(537)) then
          current_chan = 537
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(538).and.qselect_chan(538)) then
          current_chan = 538
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(539).and.qselect_chan(539)) then
          current_chan = 539
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(540).and.qselect_chan(540)) then
          current_chan = 540
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(541).and.qselect_chan(541)) then
          current_chan = 541
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(542).and.qselect_chan(542)) then
          current_chan = 542
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(543).and.qselect_chan(543)) then
          current_chan = 543
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(544).and.qselect_chan(544)) then
          current_chan = 544
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgDh0g1GTNLO(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLOGJJ=sigTNLOGJJ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
