      function sigSNLOH2J(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLOH2J=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- g g to g g ph1 ph2  
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = 0
        ip2_chan     = 0
        wt = ggA4g0H2SNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q g to g q ph1 ph2  
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgB2g0H2SNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to g g ph1 ph2 
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbB2g0H2SNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- g q to g q ph1 ph2  
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gqB2g0H2SNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to g g ph1 ph2 
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqB2g0H2SNLO(2,3,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- g g to qb q ph1 ph2 
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = ggB2g0H2SNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- g qb to qb g ph1 ph2 
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gqbB2g0H2SNLO(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb g to qb g ph1 ph2 
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgB2g0H2SNLO(3,2,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- q gt to gt q ph1 ph2 
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = 30
        ip2_chan     = 0
        nfB1 = 3
        wt = qgtBt2g0H2SNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to gt gt ph1 ph2 
      if (qactive_chan(17).and.qselect_chan(17)) then
        current_chan = 17
        ip1_chan     = 30
        ip2_chan     = -30
        nfB1 = 3
        wt = qqbBt2g0H2SNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- gt q to gt q ph1 ph2 
      if (qactive_chan(18).and.qselect_chan(18)) then
        current_chan = 18
        ip1_chan     = 0
        ip2_chan     = 30
        nfB1 = 3
        wt = gtqBt2g0H2SNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to gt gt ph1 ph2 
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = -30
        ip2_chan     = 30
        nfB1 = 3
        wt = qbqBt2g0H2SNLO(2,3,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- gt gt to qb q ph1 ph2 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 3
        wt = gtgtBt2g0H2SNLO(3,1,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- gt qb to qb gt ph1 ph2 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = 0
        ip2_chan     = -30
        nfB1 = 3
        wt = gtqbBt2g0H2SNLO(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb gt to qb gt ph1 ph2 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = -30
        ip2_chan     = 0
        nfB1 = 3
        wt = qbgtBt2g0H2SNLO(3,2,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- q Qb to Qb q ph1 ph2 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = 31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qqpbC0g0H2SNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q Q to Q q ph1 ph2  
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = 31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qqpC0g0H2SNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to Q Qb ph1 ph2 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 4
        wt = qqbC0g0H2SNLO(1,3,4,2,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to Q Qb ph1 ph2 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 4
        wt = qbqC0g0H2SNLO(2,3,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Qb to qb Qb ph1 ph2 
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = -31
        ip2_chan     = -31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpbC0g0H2SNLO(3,2,4,1,5,6)
        wtsum = wtsum + wt
      endif
c--- qb Q to qb Q ph1 ph2 
      if (qactive_chan(28).and.qselect_chan(28)) then
        current_chan = 28
        ip1_chan     = -31
        ip2_chan     = 31
        nfC1 = 3
        nfC2 = 4
        wt = qbqpC0g0H2SNLO(3,4,2,1,5,6)
        wtsum = wtsum + wt
      endif
c--- q qb to qb q ph1 ph2 
      if (qactive_chan(29).and.qselect_chan(29)) then
        current_chan = 29
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qqbD0g0H2SNLO(1,2,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- q q to q q ph1 ph2  
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = 30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qqD0g0H2SNLO(1,3,2,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb q to qb q ph1 ph2 
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 3
        nfC2 = 3
        wt = qbqD0g0H2SNLO(2,1,3,4,5,6)
        wtsum = wtsum + wt
      endif
c--- qb qb to qb qb ph1 ph2 
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = -30
        ip2_chan     = -30
        nfC1 = 3
        nfC2 = 3
        wt = qbqbD0g0H2SNLO(3,1,4,2,5,6)
        wtsum = wtsum + wt
      endif
      sigSNLOH2J=sigSNLOH2J+rnorm*wtsum

      return
      end
