      function sigTH4J(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTH4J=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(8,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(8,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- g g to g g l1 l2 l3 l4 
        if (qactive_chan(141).and.qselect_chan(141)) then
          current_chan = 141
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggA4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(142).and.qselect_chan(142)) then
          current_chan = 142
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqA4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(143).and.qselect_chan(143)) then
          current_chan = 143
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbA4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(144).and.qselect_chan(144)) then
          current_chan = 144
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgA4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(145).and.qselect_chan(145)) then
          current_chan = 145
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgA4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g l1 l2 l3 l4 
        if (qactive_chan(146).and.qselect_chan(146)) then
          current_chan = 146
          ip1_chan     = 0
          ip2_chan     = 0
          wt = ggAh4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(147).and.qselect_chan(147)) then
          current_chan = 147
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqAh4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(148).and.qselect_chan(148)) then
          current_chan = 148
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbAh4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(149).and.qselect_chan(149)) then
          current_chan = 149
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgAh4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(150).and.qselect_chan(150)) then
          current_chan = 150
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgAh4g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g q l1 l2 l3 l4 
        if (qactive_chan(151).and.qselect_chan(151)) then
          current_chan = 151
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgB2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g l1 l2 l3 l4 
        if (qactive_chan(152).and.qselect_chan(152)) then
          current_chan = 152
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbB2g1H4T(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g q l1 l2 l3 l4 
        if (qactive_chan(153).and.qselect_chan(153)) then
          current_chan = 153
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqB2g1H4T(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g l1 l2 l3 l4 
        if (qactive_chan(154).and.qselect_chan(154)) then
          current_chan = 154
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqB2g1H4T(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb q l1 l2 l3 l4 
        if (qactive_chan(155).and.qselect_chan(155)) then
          current_chan = 155
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggB2g1H4T(ix,xri1,xri2,3,1,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g l1 l2 l3 l4 
        if (qactive_chan(156).and.qselect_chan(156)) then
          current_chan = 156
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbB2g1H4T(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g l1 l2 l3 l4 
        if (qactive_chan(157).and.qselect_chan(157)) then
          current_chan = 157
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgB2g1H4T(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(158).and.qselect_chan(158)) then
          current_chan = 158
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpB2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(159).and.qselect_chan(159)) then
          current_chan = 159
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbB2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(160).and.qselect_chan(160)) then
          current_chan = 160
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpB2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(161).and.qselect_chan(161)) then
          current_chan = 161
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbB2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g q l1 l2 l3 l4 
        if (qactive_chan(162).and.qselect_chan(162)) then
          current_chan = 162
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgBh2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g l1 l2 l3 l4 
        if (qactive_chan(163).and.qselect_chan(163)) then
          current_chan = 163
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBh2g1H4T(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g q l1 l2 l3 l4 
        if (qactive_chan(164).and.qselect_chan(164)) then
          current_chan = 164
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqBh2g1H4T(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g l1 l2 l3 l4 
        if (qactive_chan(165).and.qselect_chan(165)) then
          current_chan = 165
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBh2g1H4T(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb q l1 l2 l3 l4 
        if (qactive_chan(166).and.qselect_chan(166)) then
          current_chan = 166
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggBh2g1H4T(ix,xri1,xri2,3,1,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g l1 l2 l3 l4 
        if (qactive_chan(167).and.qselect_chan(167)) then
          current_chan = 167
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbBh2g1H4T(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g l1 l2 l3 l4 
        if (qactive_chan(168).and.qselect_chan(168)) then
          current_chan = 168
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgBh2g1H4T(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(169).and.qselect_chan(169)) then
          current_chan = 169
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpBh2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(170).and.qselect_chan(170)) then
          current_chan = 170
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBh2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(171).and.qselect_chan(171)) then
          current_chan = 171
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBh2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(172).and.qselect_chan(172)) then
          current_chan = 172
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBh2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g to g q l1 l2 l3 l4 
        if (qactive_chan(173).and.qselect_chan(173)) then
          current_chan = 173
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgBt2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to g g l1 l2 l3 l4 
        if (qactive_chan(174).and.qselect_chan(174)) then
          current_chan = 174
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBt2g1H4T(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q to g q l1 l2 l3 l4 
        if (qactive_chan(175).and.qselect_chan(175)) then
          current_chan = 175
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqBt2g1H4T(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to g g l1 l2 l3 l4 
        if (qactive_chan(176).and.qselect_chan(176)) then
          current_chan = 176
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBt2g1H4T(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to qb q l1 l2 l3 l4 
        if (qactive_chan(177).and.qselect_chan(177)) then
          current_chan = 177
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = ggBt2g1H4T(ix,xri1,xri2,3,1,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb to qb g l1 l2 l3 l4 
        if (qactive_chan(178).and.qselect_chan(178)) then
          current_chan = 178
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbBt2g1H4T(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g to qb g l1 l2 l3 l4 
        if (qactive_chan(179).and.qselect_chan(179)) then
          current_chan = 179
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgBt2g1H4T(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q initiated       
        if (qactive_chan(180).and.qselect_chan(180)) then
          current_chan = 180
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpBt2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb initiated      
        if (qactive_chan(181).and.qselect_chan(181)) then
          current_chan = 181
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbBt2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q initiated      
        if (qactive_chan(182).and.qselect_chan(182)) then
          current_chan = 182
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpBt2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb initiated     
        if (qactive_chan(183).and.qselect_chan(183)) then
          current_chan = 183
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbBt2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q l1 l2 l3 l4 
        if (qactive_chan(184).and.qselect_chan(184)) then
          current_chan = 184
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBtt2g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt l1 l2 l3 l4 
        if (qactive_chan(185).and.qselect_chan(185)) then
          current_chan = 185
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBtt2g1H4FT(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q l1 l2 l3 l4 
        if (qactive_chan(186).and.qselect_chan(186)) then
          current_chan = 186
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBtt2g1H4FT(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt l1 l2 l3 l4 
        if (qactive_chan(187).and.qselect_chan(187)) then
          current_chan = 187
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBtt2g1H4FT(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q l1 l2 l3 l4 
        if (qactive_chan(188).and.qselect_chan(188)) then
          current_chan = 188
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBtt2g1H4FT(ix,xri1,xri2,3,1,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt l1 l2 l3 l4 
        if (qactive_chan(189).and.qselect_chan(189)) then
          current_chan = 189
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBtt2g1H4FT(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt l1 l2 l3 l4 
        if (qactive_chan(190).and.qselect_chan(190)) then
          current_chan = 190
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBtt2g1H4FT(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q l1 l2 l3 l4 
        if (qactive_chan(191).and.qselect_chan(191)) then
          current_chan = 191
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBttt2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt l1 l2 l3 l4 
        if (qactive_chan(192).and.qselect_chan(192)) then
          current_chan = 192
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBttt2g1H4T(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q l1 l2 l3 l4 
        if (qactive_chan(193).and.qselect_chan(193)) then
          current_chan = 193
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBttt2g1H4T(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt l1 l2 l3 l4 
        if (qactive_chan(194).and.qselect_chan(194)) then
          current_chan = 194
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBttt2g1H4T(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q l1 l2 l3 l4 
        if (qactive_chan(195).and.qselect_chan(195)) then
          current_chan = 195
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBttt2g1H4T(ix,xri1,xri2,3,1,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt l1 l2 l3 l4 
        if (qactive_chan(196).and.qselect_chan(196)) then
          current_chan = 196
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBttt2g1H4T(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt l1 l2 l3 l4 
        if (qactive_chan(197).and.qselect_chan(197)) then
          current_chan = 197
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBttt2g1H4T(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q gt to gt q l1 l2 l3 l4 
        if (qactive_chan(198).and.qselect_chan(198)) then
          current_chan = 198
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgtBtth2g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt l1 l2 l3 l4 
        if (qactive_chan(199).and.qselect_chan(199)) then
          current_chan = 199
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = qqbBtth2g1H4T(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt q to gt q l1 l2 l3 l4 
        if (qactive_chan(200).and.qselect_chan(200)) then
          current_chan = 200
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gtqBtth2g1H4T(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt l1 l2 l3 l4 
        if (qactive_chan(201).and.qselect_chan(201)) then
          current_chan = 201
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = qbqBtth2g1H4T(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q l1 l2 l3 l4 
        if (qactive_chan(202).and.qselect_chan(202)) then
          current_chan = 202
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = gtgtBtth2g1H4T(ix,xri1,xri2,3,1,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt l1 l2 l3 l4 
        if (qactive_chan(203).and.qselect_chan(203)) then
          current_chan = 203
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gtqbBtth2g1H4T(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt l1 l2 l3 l4 
        if (qactive_chan(204).and.qselect_chan(204)) then
          current_chan = 204
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgtBtth2g1H4T(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q l1 l2 l3 l4 
        if (qactive_chan(205).and.qselect_chan(205)) then
          current_chan = 205
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbC0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q l1 l2 l3 l4 
        if (qactive_chan(206).and.qselect_chan(206)) then
          current_chan = 206
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpC0g1H4FT(ix,xri1,xri2,1,3,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb l1 l2 l3 l4 
        if (qactive_chan(207).and.qselect_chan(207)) then
          current_chan = 207
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbC0g1H4FT(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb l1 l2 l3 l4 
        if (qactive_chan(208).and.qselect_chan(208)) then
          current_chan = 208
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqC0g1H4FT(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb l1 l2 l3 l4 
        if (qactive_chan(209).and.qselect_chan(209)) then
          current_chan = 209
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbC0g1H4FT(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q l1 l2 l3 l4 
        if (qactive_chan(210).and.qselect_chan(210)) then
          current_chan = 210
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpC0g1H4FT(ix,xri1,xri2,3,4,2,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(211).and.qselect_chan(211)) then
          current_chan = 211
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqC0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(212).and.qselect_chan(212)) then
          current_chan = 212
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbC0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(213).and.qselect_chan(213)) then
          current_chan = 213
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgC0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(214).and.qselect_chan(214)) then
          current_chan = 214
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgC0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q l1 l2 l3 l4 
        if (qactive_chan(215).and.qselect_chan(215)) then
          current_chan = 215
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCt0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q l1 l2 l3 l4 
        if (qactive_chan(216).and.qselect_chan(216)) then
          current_chan = 216
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpCt0g1H4FT(ix,xri1,xri2,1,3,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb l1 l2 l3 l4 
        if (qactive_chan(217).and.qselect_chan(217)) then
          current_chan = 217
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbCt0g1H4FT(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb l1 l2 l3 l4 
        if (qactive_chan(218).and.qselect_chan(218)) then
          current_chan = 218
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqCt0g1H4FT(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb l1 l2 l3 l4 
        if (qactive_chan(219).and.qselect_chan(219)) then
          current_chan = 219
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCt0g1H4FT(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q l1 l2 l3 l4 
        if (qactive_chan(220).and.qselect_chan(220)) then
          current_chan = 220
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCt0g1H4FT(ix,xri1,xri2,3,4,2,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(221).and.qselect_chan(221)) then
          current_chan = 221
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqCt0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(222).and.qselect_chan(222)) then
          current_chan = 222
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbCt0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(223).and.qselect_chan(223)) then
          current_chan = 223
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgCt0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(224).and.qselect_chan(224)) then
          current_chan = 224
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgCt0g1H4FT(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q l1 l2 l3 l4 
        if (qactive_chan(225).and.qselect_chan(225)) then
          current_chan = 225
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qqpbCh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q Q to Q q l1 l2 l3 l4 
        if (qactive_chan(226).and.qselect_chan(226)) then
          current_chan = 226
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qqpCh0g1H4T(ix,xri1,xri2,1,3,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb l1 l2 l3 l4 
        if (qactive_chan(227).and.qselect_chan(227)) then
          current_chan = 227
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = qqbCh0g1H4T(ix,xri1,xri2,1,3,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb l1 l2 l3 l4 
        if (qactive_chan(228).and.qselect_chan(228)) then
          current_chan = 228
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = qbqCh0g1H4T(ix,xri1,xri2,2,3,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb l1 l2 l3 l4 
        if (qactive_chan(229).and.qselect_chan(229)) then
          current_chan = 229
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpbCh0g1H4T(ix,xri1,xri2,3,2,4,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q l1 l2 l3 l4 
        if (qactive_chan(230).and.qselect_chan(230)) then
          current_chan = 230
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = qbqpCh0g1H4T(ix,xri1,xri2,3,4,2,1,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(231).and.qselect_chan(231)) then
          current_chan = 231
          ip1_chan     = 0
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = gqCh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(232).and.qselect_chan(232)) then
          current_chan = 232
          ip1_chan     = 0
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = gqbCh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(233).and.qselect_chan(233)) then
          current_chan = 233
          ip1_chan     = 30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qgCh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(234).and.qselect_chan(234)) then
          current_chan = 234
          ip1_chan     = -30
          ip2_chan     = 0
          nfC1 = 3
          nfC2 = 4
          wt = qbgCh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q l1 l2 l3 l4 
        if (qactive_chan(235).and.qselect_chan(235)) then
          current_chan = 235
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbD0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q l1 l2 l3 l4 
        if (qactive_chan(236).and.qselect_chan(236)) then
          current_chan = 236
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqD0g1H4T(ix,xri1,xri2,1,3,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q l1 l2 l3 l4 
        if (qactive_chan(237).and.qselect_chan(237)) then
          current_chan = 237
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqD0g1H4T(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb l1 l2 l3 l4 
        if (qactive_chan(238).and.qselect_chan(238)) then
          current_chan = 238
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbD0g1H4T(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(239).and.qselect_chan(239)) then
          current_chan = 239
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqD0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(240).and.qselect_chan(240)) then
          current_chan = 240
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbD0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(241).and.qselect_chan(241)) then
          current_chan = 241
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgD0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(242).and.qselect_chan(242)) then
          current_chan = 242
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgD0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q l1 l2 l3 l4 
        if (qactive_chan(243).and.qselect_chan(243)) then
          current_chan = 243
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbDt0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q l1 l2 l3 l4 
        if (qactive_chan(244).and.qselect_chan(244)) then
          current_chan = 244
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqDt0g1H4T(ix,xri1,xri2,1,3,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q l1 l2 l3 l4 
        if (qactive_chan(245).and.qselect_chan(245)) then
          current_chan = 245
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqDt0g1H4T(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb l1 l2 l3 l4 
        if (qactive_chan(246).and.qselect_chan(246)) then
          current_chan = 246
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDt0g1H4T(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(247).and.qselect_chan(247)) then
          current_chan = 247
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqDt0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(248).and.qselect_chan(248)) then
          current_chan = 248
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbDt0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(249).and.qselect_chan(249)) then
          current_chan = 249
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgDt0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(250).and.qselect_chan(250)) then
          current_chan = 250
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgDt0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q qb to qb q l1 l2 l3 l4 
        if (qactive_chan(251).and.qselect_chan(251)) then
          current_chan = 251
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qqbDh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q q to q q l1 l2 l3 l4 
        if (qactive_chan(252).and.qselect_chan(252)) then
          current_chan = 252
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qqDh0g1H4T(ix,xri1,xri2,1,3,2,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb q to qb q l1 l2 l3 l4 
        if (qactive_chan(253).and.qselect_chan(253)) then
          current_chan = 253
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = qbqDh0g1H4T(ix,xri1,xri2,2,1,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb l1 l2 l3 l4 
        if (qactive_chan(254).and.qselect_chan(254)) then
          current_chan = 254
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = qbqbDh0g1H4T(ix,xri1,xri2,3,1,4,2,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g q initiated       
        if (qactive_chan(255).and.qselect_chan(255)) then
          current_chan = 255
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = gqDh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g qb initiated      
        if (qactive_chan(256).and.qselect_chan(256)) then
          current_chan = 256
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = gqbDh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- q g initiated       
        if (qactive_chan(257).and.qselect_chan(257)) then
          current_chan = 257
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = qgDh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- qb g initiated      
        if (qactive_chan(258).and.qselect_chan(258)) then
          current_chan = 258
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = qbgDh0g1H4T(ix,xri1,xri2,1,2,3,4,5,6,7,8,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g to g g l1 l2 l3 l4 wilson
        if (qactive_chan(259).and.qselect_chan(259)) then
          current_chan = 259
          ip1_chan     = 0
          ip2_chan     = 0
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = ggA4g0H4SNLO(1,2,3,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q g to g q l1 l2 l3 l4 wilson
        if (qactive_chan(260).and.qselect_chan(260)) then
          current_chan = 260
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qgB2g0H4SNLO(1,2,3,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q qb to g g l1 l2 l3 l4 wilson
        if (qactive_chan(261).and.qselect_chan(261)) then
          current_chan = 261
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qqbB2g0H4SNLO(1,3,4,2,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- g q to g q l1 l2 l3 l4 wilson
        if (qactive_chan(262).and.qselect_chan(262)) then
          current_chan = 262
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = gqB2g0H4SNLO(2,1,3,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb q to g g l1 l2 l3 l4 wilson
        if (qactive_chan(263).and.qselect_chan(263)) then
          current_chan = 263
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbqB2g0H4SNLO(2,3,4,1,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- g g to qb q l1 l2 l3 l4 wilson
        if (qactive_chan(264).and.qselect_chan(264)) then
          current_chan = 264
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = ggB2g0H4SNLO(3,1,2,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- g qb to qb g l1 l2 l3 l4 wilson
        if (qactive_chan(265).and.qselect_chan(265)) then
          current_chan = 265
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = gqbB2g0H4SNLO(3,1,4,2,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb g to qb g l1 l2 l3 l4 wilson
        if (qactive_chan(266).and.qselect_chan(266)) then
          current_chan = 266
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbgB2g0H4SNLO(3,2,4,1,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q gt to gt q l1 l2 l3 l4 wilson
        if (qactive_chan(267).and.qselect_chan(267)) then
          current_chan = 267
          ip1_chan     = 30
          ip2_chan     = 0
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qgtBt2g0H4SNLO(1,2,3,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q qb to gt gt l1 l2 l3 l4 wilson
        if (qactive_chan(268).and.qselect_chan(268)) then
          current_chan = 268
          ip1_chan     = 30
          ip2_chan     = -30
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qqbBt2g0H4SNLO(1,3,4,2,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- gt q to gt q l1 l2 l3 l4 wilson
        if (qactive_chan(269).and.qselect_chan(269)) then
          current_chan = 269
          ip1_chan     = 0
          ip2_chan     = 30
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = gtqBt2g0H4SNLO(2,1,3,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb q to gt gt l1 l2 l3 l4 wilson
        if (qactive_chan(270).and.qselect_chan(270)) then
          current_chan = 270
          ip1_chan     = -30
          ip2_chan     = 30
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbqBt2g0H4SNLO(2,3,4,1,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- gt gt to qb q l1 l2 l3 l4 wilson
        if (qactive_chan(271).and.qselect_chan(271)) then
          current_chan = 271
          ip1_chan     = 0
          ip2_chan     = 0
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = gtgtBt2g0H4SNLO(3,1,2,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- gt qb to qb gt l1 l2 l3 l4 wilson
        if (qactive_chan(272).and.qselect_chan(272)) then
          current_chan = 272
          ip1_chan     = 0
          ip2_chan     = -30
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = gtqbBt2g0H4SNLO(3,1,4,2,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb gt to qb gt l1 l2 l3 l4 wilson
        if (qactive_chan(273).and.qselect_chan(273)) then
          current_chan = 273
          ip1_chan     = -30
          ip2_chan     = 0
          nfB1 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbgtBt2g0H4SNLO(3,2,4,1,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q Qb to Qb q l1 l2 l3 l4 wilson
        if (qactive_chan(274).and.qselect_chan(274)) then
          current_chan = 274
          ip1_chan     = 31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qqpbC0g0H4SNLO(1,2,3,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q Q to Q q l1 l2 l3 l4 wilson
        if (qactive_chan(275).and.qselect_chan(275)) then
          current_chan = 275
          ip1_chan     = 31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qqpC0g0H4SNLO(1,3,2,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q qb to Q Qb l1 l2 l3 l4 wilson
        if (qactive_chan(276).and.qselect_chan(276)) then
          current_chan = 276
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 4
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qqbC0g0H4SNLO(1,3,4,2,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb q to Q Qb l1 l2 l3 l4 wilson
        if (qactive_chan(277).and.qselect_chan(277)) then
          current_chan = 277
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 4
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbqC0g0H4SNLO(2,3,4,1,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb Qb to qb Qb l1 l2 l3 l4 wilson
        if (qactive_chan(278).and.qselect_chan(278)) then
          current_chan = 278
          ip1_chan     = -31
          ip2_chan     = -31
          nfC1 = 3
          nfC2 = 4
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbqpbC0g0H4SNLO(3,2,4,1,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb Q to qb Q l1 l2 l3 l4 wilson
        if (qactive_chan(279).and.qselect_chan(279)) then
          current_chan = 279
          ip1_chan     = -31
          ip2_chan     = 31
          nfC1 = 3
          nfC2 = 4
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbqpC0g0H4SNLO(3,4,2,1,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q qb to qb q l1 l2 l3 l4 wilson
        if (qactive_chan(280).and.qselect_chan(280)) then
          current_chan = 280
          ip1_chan     = 30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qqbD0g0H4SNLO(1,2,3,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- q q to q q l1 l2 l3 l4 wilson
        if (qactive_chan(281).and.qselect_chan(281)) then
          current_chan = 281
          ip1_chan     = 30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qqD0g0H4SNLO(1,3,2,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb q to qb q l1 l2 l3 l4 wilson
        if (qactive_chan(282).and.qselect_chan(282)) then
          current_chan = 282
          ip1_chan     = -30
          ip2_chan     = 30
          nfC1 = 3
          nfC2 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbqD0g0H4SNLO(2,1,3,4,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
c--- qb qb to qb qb l1 l2 l3 l4 wilson
        if (qactive_chan(283).and.qselect_chan(283)) then
          current_chan = 283
          ip1_chan     = -30
          ip2_chan     = -30
          nfC1 = 3
          nfC2 = 3
          wt = 0d0
          if(ix.eq.1)then
          jflag=.true.
          wt = qbqbD0g0H4SNLO(3,1,4,2,5,6,7,8)
          endif
          wtsum = wtsum + wt
        endif
        sigTH4J=sigTH4J+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
