      function sigSNLOWm(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLOWm=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- d g to u lm nub     
      if (qactive_chan(3).and.qselect_chan(3)) then
        current_chan = 3
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = qgB1g0WSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- d ub to g lm nub    
      if (qactive_chan(4).and.qselect_chan(4)) then
        current_chan = 4
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
          ckmflag = .true.
        wt = qqbB1g0WSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- g d to u lm nub     
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
          ckmflag = .false.
        wt = gqB1g0WSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- ub d to g lm nub    
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
          ckmflag = .true.
        wt = qbqB1g0WSNLO(2,3,1,4,5)
        wtsum = wtsum + wt
      endif
c--- g ub to db lm nub   
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
          ckmflag = .false.
        wt = gqbB1g0WSNLO(3,1,2,4,5)
        wtsum = wtsum + wt
      endif
c--- ub g to db lm nub   
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = qbgB1g0WSNLO(3,2,1,4,5)
        wtsum = wtsum + wt
      endif
      sigSNLOWm=sigSNLOWm+rnorm*wtsum

      return
      end
