! DW added i1 <-> i2 swaps for all Q/Qb initiated subtraction only terms as required 16/17
! DW split up Wp/Wm to avoid conflicts in finite subtraction only channels inherited from D-type RR contributions

      function gqB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqB1g2WmU = qgB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function gqbB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqbB1g2WmU = qbgB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      return
      end

      function qbgB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbgB1g2WmU = qbgB1g2WFPU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
     .           +qbgB1g2WgtoqU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)


      return
      end

      function qbqB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqB1g2WmU = qqbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbqpbB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: notation change
C       qbqpbB1g2WmU = qbqpbC1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      qbqpbB1g2WmU = qbqpbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqpB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: notation change
C       qqpB1g2WmU = qqpC1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      qqpB1g2WmU = qqpB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qgB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qgB1g2WmU = qgB1g2WFPU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
     .          +qgB1g2WgtoqU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function ggB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      !--- Aude's subtraction terms
      ggB1g2WmU = ggB1g2WU_v2(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qpbqB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpbqB1g2WmU = qqpbB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpbqbB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: notation change
C       qpbqbB1g2WmU = qbqpbC1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap
      qpbqbB1g2WmU = qbqpbB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpqB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: notation change
C       qpqB1g2WmU = qqpC1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap
      qpqB1g2WmU = qqpB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpqbB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpqbB1g2WmU = qbqpB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap
      return
      end

      function ubdbB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used Wp as the source for ordering)
C       ubdbB1g2WmU = qbqpbD0g2WaU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp
      ubdbB1g2WmU = ubdbB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp

      return
      end

      function udB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used Wp as the source for ordering)
C       udB1g2WmU = qqpD0g2WbU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp
      udB1g2WmU = udB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp

      return
      end

      function duB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used Wp as the source for ordering)
C       duB1g2WmU = qqpD0g2WbU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp
      duB1g2WmU = udB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp

      return
      end

      function dbubB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used Wp as the source for ordering)
C       dbubB1g2WmU = qbqpbD0g2WaU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp
      dbubB1g2WmU = ubdbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap wrt Wp

      return
      end

      function qqpbB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqpbB1g2WmU = qqpbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbqpB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqpB1g2WmU = qbqpB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqbB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqbB1g2WmU = qqbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function dbgB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      dbgB1g2WmU = 0d0

      return
      end

      function gdbB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gdbB1g2WmU = 0d0

      return
      end

      function ugB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      ugB1g2WmU = 0d0

      return
      end

      function guB1g2WmU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      guB1g2WmU = 0d0

      return
      end
