! DW added i1 <-> i2 swaps for all Q/Qb initiated subtraction only terms as required 16/17
! DW split up Wp/Wm to avoid conflicts in finite subtraction only channels inherited from D-type RR contributions
      function gqB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqB1g2WpU = qgB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function gqbB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqbB1g2WpU = qbgB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      return
      end

      function qbgB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbgB1g2WpU = qbgB1g2WFPU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
     .           +qbgB1g2WgtoqU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)


      return
      end

      function qbqB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqB1g2WpU = qqbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbqpbB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: notation change
C       qbqpbB1g2WpU = qbqpbC1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      qbqpbB1g2WpU = qbqpbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqpB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: notation change
C       qqpB1g2WpU = qqpC1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      qqpB1g2WpU = qqpB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qgB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qgB1g2WpU = qgB1g2WFPU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
     .          +qgB1g2WgtoqU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function ggB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      !--- Xuan's converted subtraction terms
      !  ggB1g2WU = ggB1g2WU_v1(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      !--- Aude's subtraction terms
      ggB1g2WpU = ggB1g2WU_v2(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qpbqB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpbqB1g2WpU = qqpbB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpbqbB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: notation change
C       qpbqbB1g2WpU = qbqpbC1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap
      qpbqbB1g2WpU = qbqpbB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpqB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: notation change
C       qpqB1g2WpU = qqpC1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap
      qpqB1g2WpU = qqpB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap

      return
      end

      function qpqbB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)
!     Fixed linking here DW 16/17
      qpqbB1g2WpU = qbqpB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2) !i1 <-> i2 swap
      return
      end

      function ubdbB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used this as the source for ordering)
C       ubdbB1g2WpU = qbqpbD0g2WaU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      ubdbB1g2WpU = ubdbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function ubgB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      ubgB1g2WpU = 0d0

      return
      end

      function udB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used this as the source for ordering)
C       udB1g2WpU = qqpD0g2WbU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      udB1g2WpU = udB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function dgB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      dgB1g2WpU = 0d0

      return
      end

      function duB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used this as the source for ordering)
C       duB1g2WpU = qqpD0g2WbU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)
      duB1g2WpU = udB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)

      return
      end

      function gdB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gdB1g2WpU = 0d0

      return
      end

      function gubB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gubB1g2WpU = 0d0

      return
      end

      function dbubB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C IM: renamed (used this as the source for ordering)
C       dbubB1g2WpU = qbqpbD0g2WaU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)
      dbubB1g2WpU = ubdbB1g2WU(ix,x1,x2,i2,i1,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqpbB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqpbB1g2WpU = qqpbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qbqpB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqpB1g2WpU = qbqpB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

      function qqbB1g2WpU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qqbB1g2WpU = qqbB1g2WU(ix,x1,x2,i1,i2,i3,i4,i5,renscale2,facscale2)

      return
      end

