C --- Note: Ct0g1W, unlike C0g1W, is not symmetrised over the final state quark pair. This is because
C --- of a problem with the soft limits in the qqb initiated subtraction term when we symmetrise.
C --- See maple/process/W/qqbCt0g1WT.map for more information.

      function gqCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqCt0g1WT = qgCt0g1WT(ix,x1,x2,i2,i1,i3,i4,i5,i6,renscale2,facscale2) ! i1 <-> i2

      return
      end

      function gqbCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqbCt0g1WT = qbgCt0g1WT(ix,x1,x2,i2,i1,i3,i4,i5,i6,renscale2,facscale2)  ! i1 <-> i2

      return
      end

      function qbgCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      fac = subfac(-1d0)

C IM: renamed
C       qbgCt0g1WT = -1d0*qbgBth2g1WqtogT(ix,x1,x2,i4,i3,i2,i1,i5,i6,renscale2,facscale2)
      qbgCt0g1WT = -1d0*qbgCt0g1WXT(ix,x1,x2,i4,i3,i2,i1,i5,i6,renscale2,facscale2)

      fac = subfac(1d0)

      return
      end

      function qbqCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqCt0g1WT = qqbCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      return
      end

      function qgCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)
      fac=subfac(-1d0)

C IM: renamed
C       qgCt0g1WT = -1d0*qgBth2g1WqtogT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      qgCt0g1WT = -1d0*qgCt0g1WXT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      fac=subfac(1d0)

      return
      end

      function qpbqCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpbqCt0g1WT = qqpbCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      return
      end

      function qpbqbCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpbqbCt0g1WT = qbqpbCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      return
      end

      function qpbqpCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpbqpCt0g1WT = qpqpbCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      return
      end

      function qpqCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpqCt0g1WT = qqpCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      return
      end

      function qpqbCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qpqbCt0g1WT = qbqpCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      return
      end

      function gqpCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqpCt0g1WT = qpgCt0g1WT(ix,x1,x2,i2,i1,i3,i4,i5,i6,renscale2,facscale2) !i1 <->i2

      return
      end

      function gqpbCt0g1WT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      gqpbCt0g1WT = qpbgCt0g1WT(ix,x1,x2,i2,i1,i3,i4,i5,i6,renscale2,facscale2) !i1 <->i2

      return
      end



