      function sigSWmJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSWmJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      jflag=.false.
      ix=1
      ix_chan=1

c--- d g to g g u lm nub 
      if (qactive_chan(92).and.qselect_chan(92)) then
        current_chan = 92
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = qgsB3g0WS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g g g lm nub 
      if (qactive_chan(93).and.qselect_chan(93)) then
        current_chan = 93
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
          ckmflag = .true.
        wt = qqbsB3g0WS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to g g u lm nub 
      if (qactive_chan(94).and.qselect_chan(94)) then
        current_chan = 94
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
          ckmflag = .false.
        wt = gqsB3g0WS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to g g g lm nub 
      if (qactive_chan(95).and.qselect_chan(95)) then
        current_chan = 95
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
          ckmflag = .true.
        wt = qbqsB3g0WS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g g to db g u lm nub 
      if (qactive_chan(96).and.qselect_chan(96)) then
        current_chan = 96
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = ggsB3g0WS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to db g g lm nub 
      if (qactive_chan(97).and.qselect_chan(97)) then
        current_chan = 97
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
          ckmflag = .false.
        wt = gqbsB3g0WS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to db g g lm nub 
      if (qactive_chan(98).and.qselect_chan(98)) then
        current_chan = 98
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = qbgsB3g0WS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to g g u lm nub 
      if (qactive_chan(99).and.qselect_chan(99)) then
        current_chan = 99
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = qgsBt3g0WS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g g g lm nub 
      if (qactive_chan(100).and.qselect_chan(100)) then
        current_chan = 100
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
          ckmflag = .true.
        wt = qqbsBt3g0WS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to g g u lm nub 
      if (qactive_chan(101).and.qselect_chan(101)) then
        current_chan = 101
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
          ckmflag = .false.
        wt = gqsBt3g0WS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to g g g lm nub 
      if (qactive_chan(102).and.qselect_chan(102)) then
        current_chan = 102
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
          ckmflag = .true.
        wt = qbqsBt3g0WS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g g to db g u lm nub 
      if (qactive_chan(103).and.qselect_chan(103)) then
        current_chan = 103
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = ggsBt3g0WS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to db g g lm nub 
      if (qactive_chan(104).and.qselect_chan(104)) then
        current_chan = 104
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
          ckmflag = .false.
        wt = gqbsBt3g0WS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to db g g lm nub 
      if (qactive_chan(105).and.qselect_chan(105)) then
        current_chan = 105
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = qbgsBt3g0WS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d gt to gt gt u lm nub 
      if (qactive_chan(106).and.qselect_chan(106)) then
        current_chan = 106
        ip1_chan     = 40
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = qgtsBtt3g0WS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to gt gt gt lm nub 
      if (qactive_chan(107).and.qselect_chan(107)) then
        current_chan = 107
        ip1_chan     = 40
        ip2_chan     = -20
        nfB1 = 2
          ckmflag = .true.
        wt = qqbsBtt3g0WS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- gt d to gt gt u lm nub 
      if (qactive_chan(108).and.qselect_chan(108)) then
        current_chan = 108
        ip1_chan     = 0
        ip2_chan     = 40
        nfB1 = 2
          ckmflag = .false.
        wt = gtqsBtt3g0WS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to gt gt gt lm nub 
      if (qactive_chan(109).and.qselect_chan(109)) then
        current_chan = 109
        ip1_chan     = -20
        ip2_chan     = 40
        nfB1 = 2
          ckmflag = .true.
        wt = qbqsBtt3g0WS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- gt gt to db gt u lm nub 
      if (qactive_chan(110).and.qselect_chan(110)) then
        current_chan = 110
        ip1_chan     = 0
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = gtgtsBtt3g0WS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- gt ub to db gt gt lm nub 
      if (qactive_chan(111).and.qselect_chan(111)) then
        current_chan = 111
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
          ckmflag = .false.
        wt = gtqbsBtt3g0WS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub gt to db gt gt lm nub 
      if (qactive_chan(112).and.qselect_chan(112)) then
        current_chan = 112
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
          ckmflag = .false.
        wt = qbgtsBtt3g0WS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to Q Qb u lm nub 
      if (qactive_chan(113).and.qselect_chan(113)) then
        current_chan = 113
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qgsC1g0WS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d Qb to g Qb u lm nub 
      if (qactive_chan(114).and.qselect_chan(114)) then
        current_chan = 114
        ip1_chan     = 41
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qqpbsC1g0WS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d Q to g Q u lm nub 
      if (qactive_chan(115).and.qselect_chan(115)) then
        current_chan = 115
        ip1_chan     = 41
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qqpsC1g0WS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g Q Qb lm nub 
      if (qactive_chan(116).and.qselect_chan(116)) then
        current_chan = 116
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
          ckmflag = .true.
        wt = qqbsC1g0WS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to Q Qb u lm nub 
      if (qactive_chan(117).and.qselect_chan(117)) then
        current_chan = 117
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = gqsC1g0WS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb d to g Qb u lm nub 
      if (qactive_chan(118).and.qselect_chan(118)) then
        current_chan = 118
        ip1_chan     = -31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqsC1g0WS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Q d to g Q u lm nub 
      if (qactive_chan(119).and.qselect_chan(119)) then
        current_chan = 119
        ip1_chan     = 31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpqsC1g0WS(2,3,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to g Q Qb lm nub 
      if (qactive_chan(120).and.qselect_chan(120)) then
        current_chan = 120
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
          ckmflag = .true.
        wt = qbqsC1g0WS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g Qb to db Qb u lm nub 
      if (qactive_chan(121).and.qselect_chan(121)) then
        current_chan = 121
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = gqpbsC1g0WS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g Q to db Q u lm nub 
      if (qactive_chan(122).and.qselect_chan(122)) then
        current_chan = 122
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = gqpsC1g0WS(3,1,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to db Q Qb lm nub 
      if (qactive_chan(123).and.qselect_chan(123)) then
        current_chan = 123
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = gqbsC1g0WS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb g to db Qb u lm nub 
      if (qactive_chan(124).and.qselect_chan(124)) then
        current_chan = 124
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpbgsC1g0WS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Q g to db Q u lm nub 
      if (qactive_chan(125).and.qselect_chan(125)) then
        current_chan = 125
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpgsC1g0WS(3,2,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to db Q Qb lm nub 
      if (qactive_chan(126).and.qselect_chan(126)) then
        current_chan = 126
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qbgsC1g0WS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb Q to db g u lm nub 
      if (qactive_chan(127).and.qselect_chan(127)) then
        current_chan = 127
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqpsC1g0WS(3,4,1,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb ub to db g Qb lm nub 
      if (qactive_chan(128).and.qselect_chan(128)) then
        current_chan = 128
        ip1_chan     = -31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqbsC1g0WS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- Q Qb to db g u lm nub 
      if (qactive_chan(129).and.qselect_chan(129)) then
        current_chan = 129
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpqpbsC1g0WS(3,4,2,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub Qb to db g Qb lm nub 
      if (qactive_chan(130).and.qselect_chan(130)) then
        current_chan = 130
        ip1_chan     = -21
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpbsC1g0WS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- Q ub to db g Q lm nub 
      if (qactive_chan(131).and.qselect_chan(131)) then
        current_chan = 131
        ip1_chan     = 31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpqbsC1g0WS(3,4,5,1,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub Q to db g Q lm nub 
      if (qactive_chan(132).and.qselect_chan(132)) then
        current_chan = 132
        ip1_chan     = -21
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpsC1g0WS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to Q Qb u lm nub 
      if (qactive_chan(133).and.qselect_chan(133)) then
        current_chan = 133
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qgsCt1g0WS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d Qb to g Qb u lm nub 
      if (qactive_chan(134).and.qselect_chan(134)) then
        current_chan = 134
        ip1_chan     = 41
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qqpbsCt1g0WS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d Q to g Q u lm nub 
      if (qactive_chan(135).and.qselect_chan(135)) then
        current_chan = 135
        ip1_chan     = 41
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qqpsCt1g0WS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g Q Qb lm nub 
      if (qactive_chan(136).and.qselect_chan(136)) then
        current_chan = 136
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
          ckmflag = .true.
        wt = qqbsCt1g0WS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to Q Qb u lm nub 
      if (qactive_chan(137).and.qselect_chan(137)) then
        current_chan = 137
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = gqsCt1g0WS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb d to g Qb u lm nub 
      if (qactive_chan(138).and.qselect_chan(138)) then
        current_chan = 138
        ip1_chan     = -31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqsCt1g0WS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Q d to g Q u lm nub 
      if (qactive_chan(139).and.qselect_chan(139)) then
        current_chan = 139
        ip1_chan     = 31
        ip2_chan     = 41
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpqsCt1g0WS(2,3,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to g Q Qb lm nub 
      if (qactive_chan(140).and.qselect_chan(140)) then
        current_chan = 140
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 4
          ckmflag = .true.
        wt = qbqsCt1g0WS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g Qb to db Qb u lm nub 
      if (qactive_chan(141).and.qselect_chan(141)) then
        current_chan = 141
        ip1_chan     = 0
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = gqpbsCt1g0WS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g Q to db Q u lm nub 
      if (qactive_chan(142).and.qselect_chan(142)) then
        current_chan = 142
        ip1_chan     = 0
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = gqpsCt1g0WS(3,1,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to db Q Qb lm nub 
      if (qactive_chan(143).and.qselect_chan(143)) then
        current_chan = 143
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = gqbsCt1g0WS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb g to db Qb u lm nub 
      if (qactive_chan(144).and.qselect_chan(144)) then
        current_chan = 144
        ip1_chan     = -30
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpbgsCt1g0WS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Q g to db Q u lm nub 
      if (qactive_chan(145).and.qselect_chan(145)) then
        current_chan = 145
        ip1_chan     = 30
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpgsCt1g0WS(3,2,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to db Q Qb lm nub 
      if (qactive_chan(146).and.qselect_chan(146)) then
        current_chan = 146
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qbgsCt1g0WS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb Q to db g u lm nub 
      if (qactive_chan(147).and.qselect_chan(147)) then
        current_chan = 147
        ip1_chan     = -30
        ip2_chan     = 30
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqpsCt1g0WS(3,4,1,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- Qb ub to db g Qb lm nub 
      if (qactive_chan(148).and.qselect_chan(148)) then
        current_chan = 148
        ip1_chan     = -31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpbqbsCt1g0WS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- Q Qb to db g u lm nub 
      if (qactive_chan(149).and.qselect_chan(149)) then
        current_chan = 149
        ip1_chan     = 30
        ip2_chan     = -30
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpqpbsCt1g0WS(3,4,2,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub Qb to db g Qb lm nub 
      if (qactive_chan(150).and.qselect_chan(150)) then
        current_chan = 150
        ip1_chan     = -21
        ip2_chan     = -31
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpbsCt1g0WS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- Q ub to db g Q lm nub 
      if (qactive_chan(151).and.qselect_chan(151)) then
        current_chan = 151
        ip1_chan     = 31
        ip2_chan     = -21
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qpqbsCt1g0WS(3,4,5,1,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub Q to db g Q lm nub 
      if (qactive_chan(152).and.qselect_chan(152)) then
        current_chan = 152
        ip1_chan     = -21
        ip2_chan     = 31
        nfC1 = 2
        nfC2 = 4
          ckmflag = .false.
        wt = qbqpsCt1g0WS(3,4,5,2,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to d db u lm nub 
      if (qactive_chan(153).and.qselect_chan(153)) then
        current_chan = 153
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpgD1g0WmacS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g db u lm nub 
      if (qactive_chan(154).and.qselect_chan(154)) then
        current_chan = 154
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqpbD1g0WmacS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d d to g d u lm nub 
      if (qactive_chan(155).and.qselect_chan(155)) then
        current_chan = 155
        ip1_chan     = 40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqpD1g0WmacS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g d db lm nub 
      if (qactive_chan(156).and.qselect_chan(156)) then
        current_chan = 156
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qpqbD1g0WmacS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to d db u lm nub 
      if (qactive_chan(157).and.qselect_chan(157)) then
        current_chan = 157
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqpD1g0WmacS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g db u lm nub 
      if (qactive_chan(158).and.qselect_chan(158)) then
        current_chan = 158
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqpD1g0WmacS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to g d db lm nub 
      if (qactive_chan(159).and.qselect_chan(159)) then
        current_chan = 159
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qbqpD1g0WmacS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db db u lm nub 
      if (qactive_chan(160).and.qselect_chan(160)) then
        current_chan = 160
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqpbD1g0WmacS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to db d db lm nub 
      if (qactive_chan(161).and.qselect_chan(161)) then
        current_chan = 161
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqbD1g0WmacS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db db u lm nub 
      if (qactive_chan(162).and.qselect_chan(162)) then
        current_chan = 162
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbgD1g0WmacS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to db d db lm nub 
      if (qactive_chan(163).and.qselect_chan(163)) then
        current_chan = 163
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qbgD1g0WmacS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db ub to db g db lm nub 
      if (qactive_chan(164).and.qselect_chan(164)) then
        current_chan = 164
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqbD1g0WmacS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub db to db g db lm nub 
      if (qactive_chan(165).and.qselect_chan(165)) then
        current_chan = 165
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qbqpbD1g0WmacS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to u ub u lm nub 
      if (qactive_chan(166).and.qselect_chan(166)) then
        current_chan = 166
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpgD1g0WmbcS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g ub u lm nub 
      if (qactive_chan(167).and.qselect_chan(167)) then
        current_chan = 167
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qpqbD1g0WmbcS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d u to g u u lm nub 
      if (qactive_chan(168).and.qselect_chan(168)) then
        current_chan = 168
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpqD1g0WmbcS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to u ub u lm nub 
      if (qactive_chan(169).and.qselect_chan(169)) then
        current_chan = 169
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqpD1g0WmbcS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to g ub u lm nub 
      if (qactive_chan(170).and.qselect_chan(170)) then
        current_chan = 170
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qbqpD1g0WmbcS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u d to g u u lm nub 
      if (qactive_chan(171).and.qselect_chan(171)) then
        current_chan = 171
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqpD1g0WmbcS(2,3,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to db ub u lm nub 
      if (qactive_chan(172).and.qselect_chan(172)) then
        current_chan = 172
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqbD1g0WmbcS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to db u u lm nub 
      if (qactive_chan(173).and.qselect_chan(173)) then
        current_chan = 173
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqD1g0WmbcS(3,1,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to db ub u lm nub 
      if (qactive_chan(174).and.qselect_chan(174)) then
        current_chan = 174
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbgD1g0WmbcS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to db u u lm nub 
      if (qactive_chan(175).and.qselect_chan(175)) then
        current_chan = 175
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qgD1g0WmbcS(3,2,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to db g u lm nub 
      if (qactive_chan(176).and.qselect_chan(176)) then
        current_chan = 176
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqD1g0WmbcS(3,4,1,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub ub to db g ub lm nub 
      if (qactive_chan(177).and.qselect_chan(177)) then
        current_chan = 177
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqbD1g0WmbcS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to db g u lm nub 
      if (qactive_chan(178).and.qselect_chan(178)) then
        current_chan = 178
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqbD1g0WmbcS(3,4,2,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to d db u lm nub 
      if (qactive_chan(179).and.qselect_chan(179)) then
        current_chan = 179
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpgDt1g0WmaS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d db to g db u lm nub 
      if (qactive_chan(180).and.qselect_chan(180)) then
        current_chan = 180
        ip1_chan     = 40
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqpbDt1g0WmaS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d d to g d u lm nub 
      if (qactive_chan(181).and.qselect_chan(181)) then
        current_chan = 181
        ip1_chan     = 40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpqpDt1g0WmaS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g d db lm nub 
      if (qactive_chan(182).and.qselect_chan(182)) then
        current_chan = 182
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qpqbDt1g0WmaS(1,3,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to d db u lm nub 
      if (qactive_chan(183).and.qselect_chan(183)) then
        current_chan = 183
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqpDt1g0WmaS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- db d to g db u lm nub 
      if (qactive_chan(184).and.qselect_chan(184)) then
        current_chan = 184
        ip1_chan     = -40
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqpDt1g0WmaS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to g d db lm nub 
      if (qactive_chan(185).and.qselect_chan(185)) then
        current_chan = 185
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .true.
        wt = qbqpDt1g0WmaS(2,3,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- g db to db db u lm nub 
      if (qactive_chan(186).and.qselect_chan(186)) then
        current_chan = 186
        ip1_chan     = 0
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqpbDt1g0WmaS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to db d db lm nub 
      if (qactive_chan(187).and.qselect_chan(187)) then
        current_chan = 187
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = gqbDt1g0WmaS(3,1,4,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- db g to db db u lm nub 
      if (qactive_chan(188).and.qselect_chan(188)) then
        current_chan = 188
        ip1_chan     = -40
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbgDt1g0WmaS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to db d db lm nub 
      if (qactive_chan(189).and.qselect_chan(189)) then
        current_chan = 189
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qbgDt1g0WmaS(3,2,4,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- db ub to db g db lm nub 
      if (qactive_chan(190).and.qselect_chan(190)) then
        current_chan = 190
        ip1_chan     = -40
        ip2_chan     = -20
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qpbqbDt1g0WmaS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- ub db to db g db lm nub 
      if (qactive_chan(191).and.qselect_chan(191)) then
        current_chan = 191
        ip1_chan     = -20
        ip2_chan     = -40
        nfC1 = 1
        nfC2 = 1
          ckmflag = .false.
        wt = qbqpbDt1g0WmaS(3,4,2,5,1,6,7)
        wtsum = wtsum + wt
      endif
c--- d g to u ub u lm nub 
      if (qactive_chan(192).and.qselect_chan(192)) then
        current_chan = 192
        ip1_chan     = 40
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpgDt1g0WmbS(1,2,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d ub to g ub u lm nub 
      if (qactive_chan(193).and.qselect_chan(193)) then
        current_chan = 193
        ip1_chan     = 40
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qpqbDt1g0WmbS(1,3,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- d u to g u u lm nub 
      if (qactive_chan(194).and.qselect_chan(194)) then
        current_chan = 194
        ip1_chan     = 40
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qpqDt1g0WmbS(1,3,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g d to u ub u lm nub 
      if (qactive_chan(195).and.qselect_chan(195)) then
        current_chan = 195
        ip1_chan     = 0
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqpDt1g0WmbS(2,1,3,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub d to g ub u lm nub 
      if (qactive_chan(196).and.qselect_chan(196)) then
        current_chan = 196
        ip1_chan     = -20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .true.
        wt = qbqpDt1g0WmbS(2,3,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u d to g u u lm nub 
      if (qactive_chan(197).and.qselect_chan(197)) then
        current_chan = 197
        ip1_chan     = 20
        ip2_chan     = 40
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqpDt1g0WmbS(2,3,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g ub to db ub u lm nub 
      if (qactive_chan(198).and.qselect_chan(198)) then
        current_chan = 198
        ip1_chan     = 0
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqbDt1g0WmbS(3,1,2,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- g u to db u u lm nub 
      if (qactive_chan(199).and.qselect_chan(199)) then
        current_chan = 199
        ip1_chan     = 0
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = gqDt1g0WmbS(3,1,4,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub g to db ub u lm nub 
      if (qactive_chan(200).and.qselect_chan(200)) then
        current_chan = 200
        ip1_chan     = -20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbgDt1g0WmbS(3,2,1,4,5,6,7)
        wtsum = wtsum + wt
      endif
c--- u g to db u u lm nub 
      if (qactive_chan(201).and.qselect_chan(201)) then
        current_chan = 201
        ip1_chan     = 20
        ip2_chan     = 0
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qgDt1g0WmbS(3,2,4,1,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub u to db g u lm nub 
      if (qactive_chan(202).and.qselect_chan(202)) then
        current_chan = 202
        ip1_chan     = -20
        ip2_chan     = 20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqDt1g0WmbS(3,4,1,2,5,6,7)
        wtsum = wtsum + wt
      endif
c--- ub ub to db g ub lm nub 
      if (qactive_chan(203).and.qselect_chan(203)) then
        current_chan = 203
        ip1_chan     = -20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qbqbDt1g0WmbS(3,4,1,5,2,6,7)
        wtsum = wtsum + wt
      endif
c--- u ub to db g u lm nub 
      if (qactive_chan(204).and.qselect_chan(204)) then
        current_chan = 204
        ip1_chan     = 20
        ip2_chan     = -20
        nfC1 = 2
        nfC2 = 2
          ckmflag = .false.
        wt = qqbDt1g0WmbS(3,4,2,1,5,6,7)
        wtsum = wtsum + wt
      endif
      sigSWmJ=sigSWmJ+rnorm*wtsum

      return
      end
