      function sigUWmJ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      use CKM_mod, only : ckmflag  
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUWmJ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d g to u lm nub     
        if (qactive_chan(409).and.qselect_chan(409)) then
          current_chan = 409
          ip1_chan     = 40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qgB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(410).and.qselect_chan(410)) then
          current_chan = 410
          ip1_chan     = 40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qqbB1g2WmU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(411).and.qselect_chan(411)) then
          current_chan = 411
          ip1_chan     = 0
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqB1g2WmU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(412).and.qselect_chan(412)) then
          current_chan = 412
          ip1_chan     = -20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qbqB1g2WmU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(413).and.qselect_chan(413)) then
          current_chan = 413
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqbB1g2WmU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(414).and.qselect_chan(414)) then
          current_chan = 414
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qbgB1g2WmU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(415).and.qselect_chan(415)) then
          current_chan = 415
          ip1_chan     = 31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(416).and.qselect_chan(416)) then
          current_chan = 416
          ip1_chan     = 31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(417).and.qselect_chan(417)) then
          current_chan = 417
          ip1_chan     = -31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(418).and.qselect_chan(418)) then
          current_chan = 418
          ip1_chan     = -31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(419).and.qselect_chan(419)) then
          current_chan = 419
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = duB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(420).and.qselect_chan(420)) then
          current_chan = 420
          ip1_chan     = -40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbgB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(421).and.qselect_chan(421)) then
          current_chan = 421
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbubB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(422).and.qselect_chan(422)) then
          current_chan = 422
          ip1_chan     = 0
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gdbB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(423).and.qselect_chan(423)) then
          current_chan = 423
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ggB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(424).and.qselect_chan(424)) then
          current_chan = 424
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = guB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(425).and.qselect_chan(425)) then
          current_chan = 425
          ip1_chan     = 41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(426).and.qselect_chan(426)) then
          current_chan = 426
          ip1_chan     = 41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(427).and.qselect_chan(427)) then
          current_chan = 427
          ip1_chan     = -21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(428).and.qselect_chan(428)) then
          current_chan = 428
          ip1_chan     = -21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(429).and.qselect_chan(429)) then
          current_chan = 429
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = udB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(430).and.qselect_chan(430)) then
          current_chan = 430
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ugB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(431).and.qselect_chan(431)) then
          current_chan = 431
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ubdbB1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to u lm nub     
        if (qactive_chan(432).and.qselect_chan(432)) then
          current_chan = 432
          ip1_chan     = 40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qgBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(433).and.qselect_chan(433)) then
          current_chan = 433
          ip1_chan     = 40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qqbBt1g2WmU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(434).and.qselect_chan(434)) then
          current_chan = 434
          ip1_chan     = 0
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqBt1g2WmU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(435).and.qselect_chan(435)) then
          current_chan = 435
          ip1_chan     = -20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qbqBt1g2WmU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(436).and.qselect_chan(436)) then
          current_chan = 436
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqbBt1g2WmU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(437).and.qselect_chan(437)) then
          current_chan = 437
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qbgBt1g2WmU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(438).and.qselect_chan(438)) then
          current_chan = 438
          ip1_chan     = 31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(439).and.qselect_chan(439)) then
          current_chan = 439
          ip1_chan     = 31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(440).and.qselect_chan(440)) then
          current_chan = 440
          ip1_chan     = -31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(441).and.qselect_chan(441)) then
          current_chan = 441
          ip1_chan     = -31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(442).and.qselect_chan(442)) then
          current_chan = 442
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = duBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(443).and.qselect_chan(443)) then
          current_chan = 443
          ip1_chan     = -40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbgBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(444).and.qselect_chan(444)) then
          current_chan = 444
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbubBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(445).and.qselect_chan(445)) then
          current_chan = 445
          ip1_chan     = 0
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gdbBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(446).and.qselect_chan(446)) then
          current_chan = 446
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ggBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(447).and.qselect_chan(447)) then
          current_chan = 447
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = guBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(448).and.qselect_chan(448)) then
          current_chan = 448
          ip1_chan     = 41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(449).and.qselect_chan(449)) then
          current_chan = 449
          ip1_chan     = 41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(450).and.qselect_chan(450)) then
          current_chan = 450
          ip1_chan     = -21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(451).and.qselect_chan(451)) then
          current_chan = 451
          ip1_chan     = -21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(452).and.qselect_chan(452)) then
          current_chan = 452
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = udBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(453).and.qselect_chan(453)) then
          current_chan = 453
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ugBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(454).and.qselect_chan(454)) then
          current_chan = 454
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ubdbBt1g2WmU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to u lm nub     
        if (qactive_chan(455).and.qselect_chan(455)) then
          current_chan = 455
          ip1_chan     = 40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qgBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(456).and.qselect_chan(456)) then
          current_chan = 456
          ip1_chan     = 40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qqbBtt1g2WU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(457).and.qselect_chan(457)) then
          current_chan = 457
          ip1_chan     = 0
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqBtt1g2WU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(458).and.qselect_chan(458)) then
          current_chan = 458
          ip1_chan     = -20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qbqBtt1g2WU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(459).and.qselect_chan(459)) then
          current_chan = 459
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqbBtt1g2WU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(460).and.qselect_chan(460)) then
          current_chan = 460
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qbgBtt1g2WU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(461).and.qselect_chan(461)) then
          current_chan = 461
          ip1_chan     = 31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(462).and.qselect_chan(462)) then
          current_chan = 462
          ip1_chan     = 31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(463).and.qselect_chan(463)) then
          current_chan = 463
          ip1_chan     = -31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(464).and.qselect_chan(464)) then
          current_chan = 464
          ip1_chan     = -31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(465).and.qselect_chan(465)) then
          current_chan = 465
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = duBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(466).and.qselect_chan(466)) then
          current_chan = 466
          ip1_chan     = -40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbgBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(467).and.qselect_chan(467)) then
          current_chan = 467
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbubBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(468).and.qselect_chan(468)) then
          current_chan = 468
          ip1_chan     = 0
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gdbBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(469).and.qselect_chan(469)) then
          current_chan = 469
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ggBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(470).and.qselect_chan(470)) then
          current_chan = 470
          ip1_chan     = 0
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = guBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(471).and.qselect_chan(471)) then
          current_chan = 471
          ip1_chan     = 41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(472).and.qselect_chan(472)) then
          current_chan = 472
          ip1_chan     = 41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(473).and.qselect_chan(473)) then
          current_chan = 473
          ip1_chan     = -21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(474).and.qselect_chan(474)) then
          current_chan = 474
          ip1_chan     = -21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(475).and.qselect_chan(475)) then
          current_chan = 475
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = udBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(476).and.qselect_chan(476)) then
          current_chan = 476
          ip1_chan     = 20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ugBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(477).and.qselect_chan(477)) then
          current_chan = 477
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ubdbBtt1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to u lm nub     
        if (qactive_chan(478).and.qselect_chan(478)) then
          current_chan = 478
          ip1_chan     = 40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qgBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(479).and.qselect_chan(479)) then
          current_chan = 479
          ip1_chan     = 40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qqbBh1g2WU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(480).and.qselect_chan(480)) then
          current_chan = 480
          ip1_chan     = 0
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqBh1g2WU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(481).and.qselect_chan(481)) then
          current_chan = 481
          ip1_chan     = -20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qbqBh1g2WU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(482).and.qselect_chan(482)) then
          current_chan = 482
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqbBh1g2WU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(483).and.qselect_chan(483)) then
          current_chan = 483
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qbgBh1g2WU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(484).and.qselect_chan(484)) then
          current_chan = 484
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpgBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(485).and.qselect_chan(485)) then
          current_chan = 485
          ip1_chan     = 31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(486).and.qselect_chan(486)) then
          current_chan = 486
          ip1_chan     = 31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(487).and.qselect_chan(487)) then
          current_chan = 487
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(488).and.qselect_chan(488)) then
          current_chan = 488
          ip1_chan     = -31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(489).and.qselect_chan(489)) then
          current_chan = 489
          ip1_chan     = -31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(490).and.qselect_chan(490)) then
          current_chan = 490
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = duBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(491).and.qselect_chan(491)) then
          current_chan = 491
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbubBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(492).and.qselect_chan(492)) then
          current_chan = 492
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(493).and.qselect_chan(493)) then
          current_chan = 493
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(494).and.qselect_chan(494)) then
          current_chan = 494
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ggBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(495).and.qselect_chan(495)) then
          current_chan = 495
          ip1_chan     = 41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(496).and.qselect_chan(496)) then
          current_chan = 496
          ip1_chan     = 41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(497).and.qselect_chan(497)) then
          current_chan = 497
          ip1_chan     = -21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(498).and.qselect_chan(498)) then
          current_chan = 498
          ip1_chan     = -21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(499).and.qselect_chan(499)) then
          current_chan = 499
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = udBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(500).and.qselect_chan(500)) then
          current_chan = 500
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ubdbBh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to u lm nub     
        if (qactive_chan(501).and.qselect_chan(501)) then
          current_chan = 501
          ip1_chan     = 40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qgBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(502).and.qselect_chan(502)) then
          current_chan = 502
          ip1_chan     = 40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qqbBht1g2WU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(503).and.qselect_chan(503)) then
          current_chan = 503
          ip1_chan     = 0
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqBht1g2WU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(504).and.qselect_chan(504)) then
          current_chan = 504
          ip1_chan     = -20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qbqBht1g2WU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(505).and.qselect_chan(505)) then
          current_chan = 505
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqbBht1g2WU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(506).and.qselect_chan(506)) then
          current_chan = 506
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qbgBht1g2WU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(507).and.qselect_chan(507)) then
          current_chan = 507
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpgBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(508).and.qselect_chan(508)) then
          current_chan = 508
          ip1_chan     = 31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(509).and.qselect_chan(509)) then
          current_chan = 509
          ip1_chan     = 31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(510).and.qselect_chan(510)) then
          current_chan = 510
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(511).and.qselect_chan(511)) then
          current_chan = 511
          ip1_chan     = -31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(512).and.qselect_chan(512)) then
          current_chan = 512
          ip1_chan     = -31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(513).and.qselect_chan(513)) then
          current_chan = 513
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = duBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(514).and.qselect_chan(514)) then
          current_chan = 514
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbubBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(515).and.qselect_chan(515)) then
          current_chan = 515
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(516).and.qselect_chan(516)) then
          current_chan = 516
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(517).and.qselect_chan(517)) then
          current_chan = 517
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ggBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(518).and.qselect_chan(518)) then
          current_chan = 518
          ip1_chan     = 41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(519).and.qselect_chan(519)) then
          current_chan = 519
          ip1_chan     = 41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(520).and.qselect_chan(520)) then
          current_chan = 520
          ip1_chan     = -21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(521).and.qselect_chan(521)) then
          current_chan = 521
          ip1_chan     = -21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(522).and.qselect_chan(522)) then
          current_chan = 522
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = udBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(523).and.qselect_chan(523)) then
          current_chan = 523
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ubdbBht1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g to u lm nub     
        if (qactive_chan(524).and.qselect_chan(524)) then
          current_chan = 524
          ip1_chan     = 40
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qgBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d ub to g lm nub    
        if (qactive_chan(525).and.qselect_chan(525)) then
          current_chan = 525
          ip1_chan     = 40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qqbBhh1g2WU(ix,xri1,xri2,1,3,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d to u lm nub     
        if (qactive_chan(526).and.qselect_chan(526)) then
          current_chan = 526
          ip1_chan     = 0
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqBhh1g2WU(ix,xri1,xri2,2,1,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub d to g lm nub    
        if (qactive_chan(527).and.qselect_chan(527)) then
          current_chan = 527
          ip1_chan     = -20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .true.
          wt = qbqBhh1g2WU(ix,xri1,xri2,2,3,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub to db lm nub   
        if (qactive_chan(528).and.qselect_chan(528)) then
          current_chan = 528
          ip1_chan     = 0
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = gqbBhh1g2WU(ix,xri1,xri2,3,1,2,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g to db lm nub   
        if (qactive_chan(529).and.qselect_chan(529)) then
          current_chan = 529
          ip1_chan     = -20
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = qbgBhh1g2WU(ix,xri1,xri2,3,2,1,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q g initiated       
        if (qactive_chan(530).and.qselect_chan(530)) then
          current_chan = 530
          ip1_chan     = 30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpgBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q d initiated       
        if (qactive_chan(531).and.qselect_chan(531)) then
          current_chan = 531
          ip1_chan     = 31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Q ub initiated      
        if (qactive_chan(532).and.qselect_chan(532)) then
          current_chan = 532
          ip1_chan     = 31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpqbBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb g initiated      
        if (qactive_chan(533).and.qselect_chan(533)) then
          current_chan = 533
          ip1_chan     = -30
          ip2_chan     = 0
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbgBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb d initiated      
        if (qactive_chan(534).and.qselect_chan(534)) then
          current_chan = 534
          ip1_chan     = -31
          ip2_chan     = 41
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- Qb ub initiated     
        if (qactive_chan(535).and.qselect_chan(535)) then
          current_chan = 535
          ip1_chan     = -31
          ip2_chan     = -21
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qpbqbBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d u initiated       
        if (qactive_chan(536).and.qselect_chan(536)) then
          current_chan = 536
          ip1_chan     = 40
          ip2_chan     = 20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = duBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db ub initiated     
        if (qactive_chan(537).and.qselect_chan(537)) then
          current_chan = 537
          ip1_chan     = -40
          ip2_chan     = -20
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = dbubBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Q initiated       
        if (qactive_chan(538).and.qselect_chan(538)) then
          current_chan = 538
          ip1_chan     = 0
          ip2_chan     = 30
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g Qb initiated      
        if (qactive_chan(539).and.qselect_chan(539)) then
          current_chan = 539
          ip1_chan     = 0
          ip2_chan     = -30
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = gqpbBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g g initiated       
        if (qactive_chan(540).and.qselect_chan(540)) then
          current_chan = 540
          ip1_chan     = 0
          ip2_chan     = 0
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ggBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Q initiated       
        if (qactive_chan(541).and.qselect_chan(541)) then
          current_chan = 541
          ip1_chan     = 41
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d Qb initiated      
        if (qactive_chan(542).and.qselect_chan(542)) then
          current_chan = 542
          ip1_chan     = 41
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qqpbBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Q initiated      
        if (qactive_chan(543).and.qselect_chan(543)) then
          current_chan = 543
          ip1_chan     = -21
          ip2_chan     = 31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub Qb initiated     
        if (qactive_chan(544).and.qselect_chan(544)) then
          current_chan = 544
          ip1_chan     = -21
          ip2_chan     = -31
          call Q3_check
          nfC1 = 2
          nfC2 = 4
          ckmflag = .false.
          wt = qbqpbBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u d initiated       
        if (qactive_chan(545).and.qselect_chan(545)) then
          current_chan = 545
          ip1_chan     = 20
          ip2_chan     = 40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = udBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub db initiated     
        if (qactive_chan(546).and.qselect_chan(546)) then
          current_chan = 546
          ip1_chan     = -20
          ip2_chan     = -40
          call Q3_check
          nfB1 = 2
          ckmflag = .false.
          wt = ubdbBhh1g2WU(ix,xri1,xri2,1,2,3,4,5,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUWmJ=sigUWmJ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
