      function sigSNLOZ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLOZ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- d g to d lp lm      
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = 10
        ip2_chan     = 0
        nfB1 = 1
        wt = qgB1g0ZSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- u g to u lp lm      
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = 20
        ip2_chan     = 0
        nfB1 = 2
        wt = qgB1g0ZSNLO(1,2,3,4,5)
        wtsum = wtsum + wt
      endif
c--- d db to g lp lm     
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = 10
        ip2_chan     = -10
        nfB1 = 1
        wt = qqbB1g0ZSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- u ub to g lp lm     
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = 20
        ip2_chan     = -20
        nfB1 = 2
        wt = qqbB1g0ZSNLO(1,3,2,4,5)
        wtsum = wtsum + wt
      endif
c--- g d to d lp lm      
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = 0
        ip2_chan     = 10
        nfB1 = 1
        wt = gqB1g0ZSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- g u to u lp lm      
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = 0
        ip2_chan     = 20
        nfB1 = 2
        wt = gqB1g0ZSNLO(2,1,3,4,5)
        wtsum = wtsum + wt
      endif
c--- db d to g lp lm     
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = -10
        ip2_chan     = 10
        nfB1 = 1
        wt = qbqB1g0ZSNLO(2,3,1,4,5)
        wtsum = wtsum + wt
      endif
c--- ub u to g lp lm     
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = -20
        ip2_chan     = 20
        nfB1 = 2
        wt = qbqB1g0ZSNLO(2,3,1,4,5)
        wtsum = wtsum + wt
      endif
c--- g db to db lp lm    
      if (qactive_chan(13).and.qselect_chan(13)) then
        current_chan = 13
        ip1_chan     = 0
        ip2_chan     = -10
        nfB1 = 1
        wt = gqbB1g0ZSNLO(3,1,2,4,5)
        wtsum = wtsum + wt
      endif
c--- g ub to ub lp lm    
      if (qactive_chan(14).and.qselect_chan(14)) then
        current_chan = 14
        ip1_chan     = 0
        ip2_chan     = -20
        nfB1 = 2
        wt = gqbB1g0ZSNLO(3,1,2,4,5)
        wtsum = wtsum + wt
      endif
c--- db g to db lp lm    
      if (qactive_chan(15).and.qselect_chan(15)) then
        current_chan = 15
        ip1_chan     = -10
        ip2_chan     = 0
        nfB1 = 1
        wt = qbgB1g0ZSNLO(3,2,1,4,5)
        wtsum = wtsum + wt
      endif
c--- ub g to ub lp lm    
      if (qactive_chan(16).and.qselect_chan(16)) then
        current_chan = 16
        ip1_chan     = -20
        ip2_chan     = 0
        nfB1 = 2
        wt = qbgB1g0ZSNLO(3,2,1,4,5)
        wtsum = wtsum + wt
      endif
      sigSNLOZ=sigSNLOZ+rnorm*wtsum

      return
      end
