      function sigTNLOZ(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTNLOZ=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(4,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(4,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- d db to lp lm       
        if (qactive_chan(17).and.qselect_chan(17)) then
          current_chan = 17
          ip1_chan     = 10
          ip2_chan     = -10
          nfB1 = 1
          wt = qqbB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u ub to lp lm       
        if (qactive_chan(18).and.qselect_chan(18)) then
          current_chan = 18
          ip1_chan     = 20
          ip2_chan     = -20
          nfB1 = 2
          wt = qqbB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db d to lp lm       
        if (qactive_chan(19).and.qselect_chan(19)) then
          current_chan = 19
          ip1_chan     = -10
          ip2_chan     = 10
          nfB1 = 1
          wt = qbqB0g1ZTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub u to lp lm       
        if (qactive_chan(20).and.qselect_chan(20)) then
          current_chan = 20
          ip1_chan     = -20
          ip2_chan     = 20
          nfB1 = 2
          wt = qbqB0g1ZTNLO(ix,xri1,xri2,2,1,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g d initiated       
        if (qactive_chan(21).and.qselect_chan(21)) then
          current_chan = 21
          ip1_chan     = 0
          ip2_chan     = 10
          nfB1 = 1
          wt = gqB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g u initiated       
        if (qactive_chan(22).and.qselect_chan(22)) then
          current_chan = 22
          ip1_chan     = 0
          ip2_chan     = 20
          nfB1 = 2
          wt = gqB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g db initiated      
        if (qactive_chan(23).and.qselect_chan(23)) then
          current_chan = 23
          ip1_chan     = 0
          ip2_chan     = -10
          nfB1 = 1
          wt = gqbB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- g ub initiated      
        if (qactive_chan(24).and.qselect_chan(24)) then
          current_chan = 24
          ip1_chan     = 0
          ip2_chan     = -20
          nfB1 = 2
          wt = gqbB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- d g initiated       
        if (qactive_chan(25).and.qselect_chan(25)) then
          current_chan = 25
          ip1_chan     = 10
          ip2_chan     = 0
          nfB1 = 1
          wt = qgB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- u g initiated       
        if (qactive_chan(26).and.qselect_chan(26)) then
          current_chan = 26
          ip1_chan     = 20
          ip2_chan     = 0
          nfB1 = 2
          wt = qgB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- db g initiated      
        if (qactive_chan(27).and.qselect_chan(27)) then
          current_chan = 27
          ip1_chan     = -10
          ip2_chan     = 0
          nfB1 = 1
          wt = qbgB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ub g initiated      
        if (qactive_chan(28).and.qselect_chan(28)) then
          current_chan = 28
          ip1_chan     = -20
          ip2_chan     = 0
          nfB1 = 2
          wt = qbgB0g1ZTNLO(ix,xri1,xri2,1,2,3,4,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTNLOZ=sigTNLOZ+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
