C --- Note: Ct0g1Z, unlike C0g1Z, is not symmetrised over the final state quark pair. This is because
C --- of a problem with the soft limits in the qqb initiated subtraction term when we symmetrise.
C --- See maple/process/Z/qqbCt0g1ZT.map for more information.

      function gqCt0g1ZT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C --- called as gqCt0g1ZT(1,2,3,4,5,6)
      gqCt0g1ZT = qgCt0g1ZT(ix,x1,x2,i2,i1,i3,i4,i5,i6,renscale2,facscale2) ! i1 <-> i2

      return
      end

      function gqbCt0g1ZT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C --- called as gqbCt0g1ZT(1,2,3,4,5,6)
      gqbCt0g1ZT = qbgCt0g1ZT(ix,x1,x2,i2,i1,i3,i4,i5,i6,renscale2,facscale2) ! i1 <-> i2

      return
      end

      function qbgCt0g1ZT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C --- called as qbgCt0g1ZT(1,2,3,4,5,6)
      fac = subfac(-1d0)

C IM: renamed (added an X prefix to keep -1d0 multiplicative factor here)
C       qbgCt0g1ZT = -1d0*qbgBth2g1ZqtogT(ix,x1,x2,i4,i3,i2,i1,i5,i6,renscale2,facscale2) ! reverse
      qbgCt0g1ZT = -1d0*qbgCt0g1ZXT(ix,x1,x2,i4,i3,i2,i1,i5,i6,renscale2,facscale2) ! reverse

      fac = subfac(1d0)

      return
      end

      function qbqCt0g1ZT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

      qbqCt0g1ZT = qqbCt0g1ZT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      return
      end

      function qgCt0g1ZT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)
      implicit double precision (a-h,o-y)

C --- called as qgCt0g1ZT(1,2,3,4,5,6)
      fac = subfac(-1d0)

C IM: renamed (added an X prefix to keep -1d0 multiplicative factor here)
      qgCt0g1ZT = -1d0*qgCt0g1ZXT(ix,x1,x2,i1,i2,i3,i4,i5,i6,renscale2,facscale2)

      fac = subfac(1d0)

      return
      end

