      function sigSNLOepem(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSNLOepem=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      call currentContrib_chan(nsplit=nv)
      jflag=.false.
      if(nv.ne.0)jflag=.true.
      ix=1
      ix_chan=1

c--- ep em to db g g d   
      if (qactive_chan(3).and.qselect_chan(3)) then
        current_chan = 3
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 1
        wt = epemB2g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g g u   
      if (qactive_chan(4).and.qselect_chan(4)) then
        current_chan = 4
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 2
        wt = epemB2g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db gt gt d 
      if (qactive_chan(5).and.qselect_chan(5)) then
        current_chan = 5
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 1
        wt = epemBt2g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub gt gt u 
      if (qactive_chan(6).and.qselect_chan(6)) then
        current_chan = 6
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 2
        wt = epemBt2g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db d db d  
      if (qactive_chan(7).and.qselect_chan(7)) then
        current_chan = 7
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = epemC0g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db u ub d  
      if (qactive_chan(8).and.qselect_chan(8)) then
        current_chan = 8
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        wt = epemC0g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub d db u  
      if (qactive_chan(9).and.qselect_chan(9)) then
        current_chan = 9
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        wt = epemC0g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub u ub u  
      if (qactive_chan(10).and.qselect_chan(10)) then
        current_chan = 10
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = epemC0g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db d db d  
      if (qactive_chan(11).and.qselect_chan(11)) then
        current_chan = 11
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = epemD0g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub u ub u  
      if (qactive_chan(12).and.qselect_chan(12)) then
        current_chan = 12
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = epemD0g0ZepemSNLO(3,4,5,6,1,2)
        wtsum = wtsum + wt
      endif
      sigSNLOepem=sigSNLOepem+rnorm*wtsum

      return
      end
