      function sigSepem(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod
      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigSepem=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.false.
      jflag=.false.
      ix=1
      ix_chan=1

c--- ep em to db g g g d 
      if (qactive_chan(19).and.qselect_chan(19)) then
        current_chan = 19
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 1
        wt = epemB3g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g g g u 
      if (qactive_chan(20).and.qselect_chan(20)) then
        current_chan = 20
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 2
        wt = epemB3g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db g g g d 
      if (qactive_chan(21).and.qselect_chan(21)) then
        current_chan = 21
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 1
        wt = epemBt3g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g g g u 
      if (qactive_chan(22).and.qselect_chan(22)) then
        current_chan = 22
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 2
        wt = epemBt3g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db gt gt gt d 
      if (qactive_chan(23).and.qselect_chan(23)) then
        current_chan = 23
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 1
        wt = epemBtt3g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub gt gt gt u 
      if (qactive_chan(24).and.qselect_chan(24)) then
        current_chan = 24
        ip1_chan     = -99
        ip2_chan     = 99
        nfB1 = 2
        wt = epemBtt3g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db g d db d 
      if (qactive_chan(25).and.qselect_chan(25)) then
        current_chan = 25
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = epemC1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db g u ub d 
      if (qactive_chan(26).and.qselect_chan(26)) then
        current_chan = 26
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        wt = epemC1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g d db u 
      if (qactive_chan(27).and.qselect_chan(27)) then
        current_chan = 27
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        wt = epemC1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g u ub u 
      if (qactive_chan(28).and.qselect_chan(28)) then
        current_chan = 28
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = epemC1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db g d db d 
      if (qactive_chan(29).and.qselect_chan(29)) then
        current_chan = 29
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = epemsCt1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db g u ub d 
      if (qactive_chan(30).and.qselect_chan(30)) then
        current_chan = 30
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 2
        wt = epemsCt1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g d db u 
      if (qactive_chan(31).and.qselect_chan(31)) then
        current_chan = 31
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 1
        wt = epemsCt1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g u ub u 
      if (qactive_chan(32).and.qselect_chan(32)) then
        current_chan = 32
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = epemsCt1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db g d db d 
      if (qactive_chan(33).and.qselect_chan(33)) then
        current_chan = 33
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = epemD1g0ZcepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g u ub u 
      if (qactive_chan(34).and.qselect_chan(34)) then
        current_chan = 34
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = epemD1g0ZcepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to db g d db d 
      if (qactive_chan(35).and.qselect_chan(35)) then
        current_chan = 35
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 1
        nfC2 = 1
        wt = epemDt1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
c--- ep em to ub g u ub u 
      if (qactive_chan(36).and.qselect_chan(36)) then
        current_chan = 36
        ip1_chan     = -99
        ip2_chan     = 99
        nfC1 = 2
        nfC2 = 2
        wt = epemDt1g0ZepemS(3,4,5,6,7,1,2)
        wtsum = wtsum + wt
      endif
      sigSepem=sigSepem+rnorm*wtsum

      return
      end
