      function sigTepem(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigTepem=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.ne.1) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(6,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(6,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- ep em to db g g d   
        if (qactive_chan(37).and.qselect_chan(37)) then
          current_chan = 37
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 1
          wt = epemB2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub g g u   
        if (qactive_chan(38).and.qselect_chan(38)) then
          current_chan = 38
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 2
          wt = epemB2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db gt gt d 
        if (qactive_chan(39).and.qselect_chan(39)) then
          current_chan = 39
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 1
          wt = epemBt2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub gt gt u 
        if (qactive_chan(40).and.qselect_chan(40)) then
          current_chan = 40
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 2
          wt = epemBt2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db gt gt d 
        if (qactive_chan(41).and.qselect_chan(41)) then
          current_chan = 41
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 1
          wt = epemBttt2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub gt gt u 
        if (qactive_chan(42).and.qselect_chan(42)) then
          current_chan = 42
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 2
          wt = epemBttt2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db g g d   
        if (qactive_chan(43).and.qselect_chan(43)) then
          current_chan = 43
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 1
          wt = epemBh2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub g g u   
        if (qactive_chan(44).and.qselect_chan(44)) then
          current_chan = 44
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 2
          wt = epemBh2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db gt gt d 
        if (qactive_chan(45).and.qselect_chan(45)) then
          current_chan = 45
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 1
          wt = epemBth2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub gt gt u 
        if (qactive_chan(46).and.qselect_chan(46)) then
          current_chan = 46
          ip1_chan     = -99
          ip2_chan     = 99
          nfB1 = 2
          wt = epemBth2g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db d db d  
        if (qactive_chan(47).and.qselect_chan(47)) then
          current_chan = 47
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = epemsC0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db u ub d  
        if (qactive_chan(48).and.qselect_chan(48)) then
          current_chan = 48
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = epemsC0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub d db u  
        if (qactive_chan(49).and.qselect_chan(49)) then
          current_chan = 49
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = epemsC0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub u ub u  
        if (qactive_chan(50).and.qselect_chan(50)) then
          current_chan = 50
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = epemsC0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db d db d  
        if (qactive_chan(51).and.qselect_chan(51)) then
          current_chan = 51
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = epemCt0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db u ub d  
        if (qactive_chan(52).and.qselect_chan(52)) then
          current_chan = 52
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = epemCt0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub d db u  
        if (qactive_chan(53).and.qselect_chan(53)) then
          current_chan = 53
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = epemCt0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub u ub u  
        if (qactive_chan(54).and.qselect_chan(54)) then
          current_chan = 54
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = epemCt0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db d db d  
        if (qactive_chan(55).and.qselect_chan(55)) then
          current_chan = 55
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = epemCh0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db u ub d  
        if (qactive_chan(56).and.qselect_chan(56)) then
          current_chan = 56
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 2
          wt = epemCh0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub d db u  
        if (qactive_chan(57).and.qselect_chan(57)) then
          current_chan = 57
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 1
          wt = epemCh0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub u ub u  
        if (qactive_chan(58).and.qselect_chan(58)) then
          current_chan = 58
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = epemCh0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db d db d  
        if (qactive_chan(59).and.qselect_chan(59)) then
          current_chan = 59
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = epemD0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub u ub u  
        if (qactive_chan(60).and.qselect_chan(60)) then
          current_chan = 60
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = epemD0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db d db d  
        if (qactive_chan(61).and.qselect_chan(61)) then
          current_chan = 61
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = epemDt0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub u ub u  
        if (qactive_chan(62).and.qselect_chan(62)) then
          current_chan = 62
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = epemDt0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db d db d  
        if (qactive_chan(63).and.qselect_chan(63)) then
          current_chan = 63
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 1
          nfC2 = 1
          wt = epemDh0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub u ub u  
        if (qactive_chan(64).and.qselect_chan(64)) then
          current_chan = 64
          ip1_chan     = -99
          ip2_chan     = 99
          nfC1 = 2
          nfC2 = 2
          wt = epemDh0g1ZepemT(ix,xri1,xri2,3,4,5,6,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigTepem=sigTepem+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
