      function sigUepem(rnorm,x1,x2,wgt)
      use Channels_mod
      use Scales_mod
      implicit real*8(a-h,o-y)
      logical virtsflag,jflag
      common /parfrac/x1curr,x2curr
!$omp threadprivate(/parfrac/)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /BZFlav/ nfB1
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /koppel/ nf,nc,b0
      common /histonorm/rnormcurr,wgtcurr
!$omp threadprivate(/histonorm/)
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /method/imethod

      call generatez1z2(xreg1,xreg2)

      x1curr = x1
      x2curr = x2
      rnormcurr = rnorm
      wgtcurr = wgt

      sigUepem=0d0
      wtsum=0d0
      ipass=1
      virtsflag=.true.
      jflag=.true.
      if((imethod.eq.2).and.((xreg1.lt.x1).or.(xreg2.lt.x2)))ipass=0
      if(ipass.eq.0)return

      do ix=1,4
        ix_chan=ix
        if(ix.ne.1) cycle
        wtsum=0d0
        ifail=0 
        if (imethod.eq.1) then 
        call fillparmom(5,ix,x1,x2,xreg1,xreg2,rnorm,ifail)
        call genphase(5,1,ix,x1,x2,xreg1,xreg2,ifail)
        endif 
        rnormcurr=rnorm
        if(ifail.ne.1)then
        call determineregions(ix,xreg1,xreg2,xri1,xri2)
c--- ep em to db g d     
        if (qactive_chan(65).and.qselect_chan(65)) then
          current_chan = 65
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = epemB1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub g u     
        if (qactive_chan(66).and.qselect_chan(66)) then
          current_chan = 66
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = epemB1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db g d     
        if (qactive_chan(67).and.qselect_chan(67)) then
          current_chan = 67
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = epemBt1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub g u     
        if (qactive_chan(68).and.qselect_chan(68)) then
          current_chan = 68
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = epemBt1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db g d     
        if (qactive_chan(69).and.qselect_chan(69)) then
          current_chan = 69
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = epemBtt1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub g u     
        if (qactive_chan(70).and.qselect_chan(70)) then
          current_chan = 70
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = epemBtt1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db g d     
        if (qactive_chan(71).and.qselect_chan(71)) then
          current_chan = 71
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = epemBh1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub g u     
        if (qactive_chan(72).and.qselect_chan(72)) then
          current_chan = 72
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = epemBh1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db g d     
        if (qactive_chan(73).and.qselect_chan(73)) then
          current_chan = 73
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = epemBht1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub g u     
        if (qactive_chan(74).and.qselect_chan(74)) then
          current_chan = 74
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = epemBht1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to db g d     
        if (qactive_chan(75).and.qselect_chan(75)) then
          current_chan = 75
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 1
          wt = epemBhh1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
c--- ep em to ub g u     
        if (qactive_chan(76).and.qselect_chan(76)) then
          current_chan = 76
          ip1_chan     = -99
          ip2_chan     = 99
          call Q3_check
          nfB1 = 2
          wt = epemBhh1g2ZepemU(ix,xri1,xri2,3,4,5,1,2,0d0,0d0)
          wtsum = wtsum + wt
        endif
        sigUepem=sigUepem+rnorm*wtsum
      endif  ! end ifail if
      end do  ! ix

      return
      end
