#ifdef FLAVepemjj

      integer function max_nflavourepemjj()
        use Channels_mod, only: qactive_chan, ntot_chan
        implicit none
        integer ip, nflavourepemjj
        max_nflavourepemjj = 0
        do ip=1,ntot_chan
            if (.not.qactive_chan(ip)) cycle
            max_nflavourepemjj =  max(max_nflavourepemjj, nflavourepemjj(ip))
        end do
      end function max_nflavourepemjj


      integer function nflavourepemjj(ip)
        implicit none
        integer, intent(in) :: ip
        select case(ip)
c--- ep em to db d
        case(1)
          nflavourepemjj = 3
c--- ep em to ub u
        case(2)
          nflavourepemjj = 2
c--- ep em to db g d
        case(3)
          nflavourepemjj = 3
c--- ep em to ub g u
        case(4)
          nflavourepemjj = 2
c--- ep em to db d
        case(5)
          nflavourepemjj = 3
c--- ep em to ub u
        case(6)
          nflavourepemjj = 2
c--- ep em to db g g d
        case(7)
          nflavourepemjj = 3
c--- ep em to ub g g u
        case(8)
          nflavourepemjj = 2
c--- ep em to db gt gt d
        case(9)
          nflavourepemjj = 3
c--- ep em to ub gt gt u
        case(10)
          nflavourepemjj = 2
c--- ep em to db d db d
        case(11)
          nflavourepemjj = 9
c--- ep em to db u ub d
        case(12)
          nflavourepemjj = 6
c--- ep em to ub d db u
        case(13)
          nflavourepemjj = 6
c--- ep em to ub u ub u
        case(14)
          nflavourepemjj = 4
c--- ep em to db d db d
        case(15)
          nflavourepemjj = 3
c--- ep em to ub u ub u
        case(16)
          nflavourepemjj = 2
c--- ep em to db g d
        case(17)
          nflavourepemjj = 3
c--- ep em to ub g u
        case(18)
          nflavourepemjj = 2
c--- ep em to db g d
        case(19)
          nflavourepemjj = 3
c--- ep em to ub g u
        case(20)
          nflavourepemjj = 2
c--- ep em to db g d
        case(21)
          nflavourepemjj = 3
c--- ep em to ub g u
        case(22)
          nflavourepemjj = 2
c--- ep em to db d
        case(23)
          nflavourepemjj = 3
c--- ep em to ub u
        case(24)
          nflavourepemjj = 2
c--- ep em to db d
        case(25)
          nflavourepemjj = 3
c--- ep em to ub u
        case(26)
          nflavourepemjj = 2
c--- ep em to db d
        case(27)
          nflavourepemjj = 3
c--- ep em to ub u
        case(28)
          nflavourepemjj = 2
        end select
      end function nflavourepemjj


      double precision function relfacflavourepemjj(ip)
        implicit none
        integer, intent(in) :: ip
        double precision nf, nup, ndown
        parameter(nf=5d0)
        parameter(nup=2d0)
        parameter(ndown=3d0)
        select case(ip)
c--- ep em to db d 
        case(1)
          relfacflavourepemjj = ndown
c--- ep em to ub u 
        case(2)
          relfacflavourepemjj = nup
c--- ep em to db g d 
        case(3)
          relfacflavourepemjj = ndown
c--- ep em to ub g u 
        case(4)
          relfacflavourepemjj = nup
c--- ep em to db d 
        case(5)
          relfacflavourepemjj = ndown
c--- ep em to ub u 
        case(6)
          relfacflavourepemjj = nup
c--- ep em to db g g d 
        case(7)
          relfacflavourepemjj = ndown
c--- ep em to ub g g u 
        case(8)
          relfacflavourepemjj = nup
c--- ep em to db gt gt d 
        case(9)
          relfacflavourepemjj = ndown
c--- ep em to ub gt gt u 
        case(10)
          relfacflavourepemjj = nup
c--- ep em to db d db d 
        case(11)
          relfacflavourepemjj = ndown ** 2
c--- ep em to db u ub d 
        case(12)
          relfacflavourepemjj = ndown * nup
c--- ep em to ub d db u 
        case(13)
          relfacflavourepemjj = ndown * nup
c--- ep em to ub u ub u 
        case(14)
          relfacflavourepemjj = nup ** 2
c--- ep em to db d db d 
        case(15)
          relfacflavourepemjj = ndown
c--- ep em to ub u ub u 
        case(16)
          relfacflavourepemjj = nup
c--- ep em to db g d 
        case(17)
          relfacflavourepemjj = ndown
c--- ep em to ub g u 
        case(18)
          relfacflavourepemjj = nup
c--- ep em to db g d 
        case(19)
          relfacflavourepemjj = ndown
c--- ep em to ub g u 
        case(20)
          relfacflavourepemjj = nup
c--- ep em to db g d 
        case(21)
          relfacflavourepemjj = ndown
c--- ep em to ub g u 
        case(22)
          relfacflavourepemjj = nup
c--- ep em to db d 
        case(23)
          relfacflavourepemjj = ndown
c--- ep em to ub u 
        case(24)
          relfacflavourepemjj = nup
c--- ep em to db d 
        case(25)
          relfacflavourepemjj = ndown
c--- ep em to ub u 
        case(26)
          relfacflavourepemjj = nup
c--- ep em to db d 
        case(27)
          relfacflavourepemjj = ndown
c--- ep em to ub u 
        case(28)
          relfacflavourepemjj = nup
        case default
          relfacflavourepemjj = 1d0
        end select
      end function relfacflavourepemjj


      subroutine dress_flav_epemjj(ip, isub, ipass, flav_block)
        use Flavour_mod
        implicit none
        integer, intent(in) :: ip, isub, flav_block
        integer, intent(inout) :: ipass

        if (ipass == 0) return
        select case(ip)
c--- ep em to db d
        case(1)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g0Z matching to B0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=1,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g0Z matching to B0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=1,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: B0g0Z matching to B0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=1,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=1)"
          end select
c--- ep em to ub u
        case(2)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g0Z matching to B0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=2,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g0Z matching to B0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=2,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=2)"
          end select
c--- ep em to db g d
        case(3)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0Z matching to B1g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=3,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0Z matching to B1g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=3,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: B1g0Z matching to B1g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=3,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=3)"
          end select
c--- ep em to ub g u
        case(4)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g0Z matching to B1g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=4,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g0Z matching to B1g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=4,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=4)"
          end select
c--- ep em to db d
        case(5)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g1Z matching to B0g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=5,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g1Z matching to B0g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=5,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: B0g1Z matching to B0g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=5,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=5)"
          end select
c--- ep em to ub u
        case(6)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g1Z matching to B0g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=6,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g1Z matching to B0g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=6,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=6)"
          end select
c--- ep em to db g g d
        case(7)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B2g0Z matching to B2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,0, 0, 1, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=7,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B2g0Z matching to B2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,0, 0, 3, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=7,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: B2g0Z matching to B2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,0, 0, 5, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=7,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=7)"
          end select
c--- ep em to ub g g u
        case(8)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B2g0Z matching to B2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=8,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B2g0Z matching to B2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=8,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=8)"
          end select
c--- ep em to db gt gt d
        case(9)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0Z matching to Bt2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,0, 0, 1, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=9,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0Z matching to Bt2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,0, 0, 3, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=9,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0Z matching to Bt2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,0, 0, 5, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=9,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=9)"
          end select
c--- ep em to ub gt gt u
        case(10)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0Z matching to Bt2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,0, 0, 2, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=10,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt2g0Z matching to Bt2g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,0, 0, 4, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=10,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=10)"
          end select
c--- ep em to db d db d
        case(11)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,1, -1, 1, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,3, -3, 1, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,5, -5, 1, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,1, -1, 3, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,3, -3, 3, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,5, -5, 3, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=6)"
            end select
          case(7)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,1, -1, 5, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=7)"
            end select
          case(8)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,3, -3, 5, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=8)"
            end select
          case(9)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,5, -5, 5, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=11,isub=9)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=11)"
          end select
c--- ep em to db u ub d
        case(12)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,2, -2, 1, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=12,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,4, -4, 1, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=12,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,2, -2, 3, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=12,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,4, -4, 3, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=12,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,2, -2, 5, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=12,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,4, -4, 5, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=12,isub=6)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=12)"
          end select
c--- ep em to ub d db u
        case(13)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,1, -1, 2, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=13,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,3, -3, 2, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=13,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,5, -5, 2, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=13,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,1, -1, 4, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=13,isub=4)"
            end select
          case(5)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,3, -3, 4, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=13,isub=5)"
            end select
          case(6)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,5, -5, 4, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=13,isub=6)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=13)"
          end select
c--- ep em to ub u ub u
        case(14)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,2, -2, 2, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=14,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,4, -4, 2, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=14,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,2, -2, 4, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=14,isub=3)"
            end select
          case(4)
            select case (flav_block)
            case(0) ! Matrix element: C0g0Z matching to C0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,4, -4, 4, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: f1B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: f2B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(4) ! Reduced matrix element: f2B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=14,isub=4)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=14)"
          end select
c--- ep em to db d db d
        case(15)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0Z matching to D0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,1, -1, 1, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=15,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0Z matching to D0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,3, -3, 3, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=15,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: D0g0Z matching to D0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,5, -5, 5, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=15,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=15)"
          end select
c--- ep em to ub u ub u
        case(16)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: D0g0Z matching to D0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,2, -2, 2, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=16,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: D0g0Z matching to D0g0Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,4, -4, 4, -99, 99 /), 6, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: f1B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=16,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=16)"
          end select
c--- ep em to db g d
        case(17)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g1Z matching to B1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=17,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g1Z matching to B1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=17,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: B1g1Z matching to B1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=17,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=17)"
          end select
c--- ep em to ub g u
        case(18)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B1g1Z matching to B1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=18,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B1g1Z matching to B1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=18,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=18)"
          end select
c--- ep em to db g d
        case(19)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1Z matching to Bt1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=19,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1Z matching to Bt1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=19,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1Z matching to Bt1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=19,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=19)"
          end select
c--- ep em to ub g u
        case(20)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1Z matching to Bt1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=20,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt1g1Z matching to Bt1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(3) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=20,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=20)"
          end select
c--- ep em to db g d
        case(21)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1Z matching to Bh1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -1,0, 1, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=21,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1Z matching to Bh1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -3,0, 3, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=21,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1Z matching to Bh1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -5,0, 5, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=21,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=21)"
          end select
c--- ep em to ub g u
        case(22)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1Z matching to Bh1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -2,0, 2, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=22,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh1g1Z matching to Bh1g1Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B1g0Z
              call dress_flav( (/ -4,0, 4, -99, 99 /), 5, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=22,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=22)"
          end select
c--- ep em to db d
        case(23)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g2Z matching to B0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=23,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g2Z matching to B0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=23,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: B0g2Z matching to B0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=23,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=23)"
          end select
c--- ep em to ub u
        case(24)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: B0g2Z matching to B0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=24,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: B0g2Z matching to B0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=24,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=24)"
          end select
c--- ep em to db d
        case(25)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2Z matching to Bt0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=25,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2Z matching to Bt0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=25,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2Z matching to Bt0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=25,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=25)"
          end select
c--- ep em to ub u
        case(26)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2Z matching to Bt0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=26,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bt0g2Z matching to Bt0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(2) ! Reduced matrix element: B0g1Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=26,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=26)"
          end select
c--- ep em to db d
        case(27)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2Z matching to Bh0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -1,1, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=27,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2Z matching to Bh0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -3,3, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=27,isub=2)"
            end select
          case(3)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2Z matching to Bh0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -5,5, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=27,isub=3)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=27)"
          end select
c--- ep em to ub u
        case(28)
          select case (isub)
          case(1)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2Z matching to Bh0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -2,2, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=28,isub=1)"
            end select
          case(2)
            select case (flav_block)
            case(0) ! Matrix element: Bh0g2Z matching to Bh0g2Z in FLAVlistepemjj.map
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case(1) ! Reduced matrix element: B0g0Z
              call dress_flav( (/ -4,4, -99, 99 /), 4, ipass, (/ -99,99 /))
            case default
              stop "dress_flav_epemjj: unknown flav_block (ip=28,isub=2)"
            end select
          case default
            stop "dress_flav_epemjj: unknown isub (ip=28)"
          end select
        end select
      end subroutine dress_flav_epemjj

#endif

