****************************************************
* SS1(j1,i3,j2,jpset,ipset) i.e. for i3 soft - carried in psoft
      function SS1(j1,i3,j2,jpset,ipset)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /s9on8/s98(9,8)
!$omp threadprivate(/s9on8/)
      common /s9on7/s97(9,7)
!$omp threadprivate(/s9on7/)
      common /s8on7/s87(8,7)
!$omp threadprivate(/s8on7/)
      common /s8on6/s86(8,6)
!$omp threadprivate(/s8on6/)
      common /s7on6/s76(7,6)
!$omp threadprivate(/s7on6/)
      common /s7on5/s75(7,5)
!$omp threadprivate(/s7on5/)
      common /s6on5/s65(6,5)
!$omp threadprivate(/s6on5/)
      common /s6on4/s64(6,4)
!$omp threadprivate(/s6on4/)
      common /s5on4/s54(5,4)
!$omp threadprivate(/s5on4/)
      common /soft/psoft(4)
!$omp threadprivate(/soft/)

      s12=0d0
      s13=0d0
      s23=0d0

      if(jpset.eq.8.and.ipset.eq.9)then
        s12 =  s8(j1,j2)
        s13 = s98(i3,j1)
        s23 = s98(i3,j2)
c          s13 = 2d0*dot(p9(:,i3),p8(:,j1))
c          s23 = 2d0*dot(p9(:,i3),p8(:,j2))
      elseif(jpset.eq.7.and.ipset.eq.9)then
        s12 =  s7(j1,j2)
        s13 = s97(i3,j1)
        s23 = s97(i3,j2)
c          s13 = 2d0*dot(p9(:,i3),p7(:,j1))
c          s23 = 2d0*dot(p9(:,i3),p7(:,j2))
      elseif(jpset.eq.7.and.ipset.eq.8)then
        s12 =  s7(j1,j2)
        s13 = s87(i3,j1)
        s23 = s87(i3,j2)
c          s13 = 2d0*dot(p8(:,i3),p7(:,j1))
c          s23 = 2d0*dot(p8(:,i3),p7(:,j2))
      elseif(jpset.eq.6.and.ipset.eq.8)then
        s12 =  s6(j1,j2)
        s13 = s86(i3,j1)
        s23 = s86(i3,j2)
c          s13 = 2d0*dot(p8(:,i3),p6(:,j1))
c          s23 = 2d0*dot(p8(:,i3),p6(:,j2))
      elseif(jpset.eq.6.and.ipset.eq.7)then
        olds13=2d0*dot(p6(:,j1),psoft)
        olds23=2d0*dot(p6(:,j2),psoft)
        olds12=2d0*dot(p6(:,j1),p6(:,j2))
        s12= s6(j1,j2)
        s13=s76(i3,j1)
        s23=s76(i3,j2)
c        s13=2d0*dot(p7(:,i3),p6(:,j1))
c        s23=2d0*dot(p7(:,i3),p6(:,j2))
      elseif(jpset.eq.5.and.ipset.eq.6)then
        olds13=2d0*dot(p5(:,j1),psoft)
        olds23=2d0*dot(p5(:,j2),psoft)
        olds12=2d0*dot(p5(:,j1),p5(:,j2))
        s12= s5(j1,j2)
        s13=s65(i3,j1)
        s23=s65(i3,j2)
c        s13=2d0*dot(p6(:,i3),p5(:,j1))
c        s23=2d0*dot(p6(:,i3),p5(:,j2))
      elseif(jpset.eq.4.and.ipset.eq.5)then
        olds12=2d0*dot(p4(:,j1),p4(:,j2))
        olds13=2d0*dot(p4(:,j1),psoft)
        olds23=2d0*dot(p4(:,j2),psoft)
        s12= s4(j1,j2)
        s13=s54(i3,j1)
        s23=s54(i3,j2)
c        s13=2d0*dot(p5(:,i3),p4(:,j1))
c        s23=2d0*dot(p5(:,i3),p4(:,j2))
      elseif(jpset.eq.5.and.ipset.eq.7)then
        olds13=2d0*dot(p5(:,j1),psoft)
        olds23=2d0*dot(p5(:,j2),psoft)
        olds12=2d0*dot(p5(:,j1),p5(:,j2))
        s12= s5(j1,j2)
        s13=s75(i3,j1)
        s23=s75(i3,j2)
c        s13=2d0*dot(p7(:,i3),p5(:,j1))
c        s23=2d0*dot(p7(:,i3),p5(:,j2))
      elseif(jpset.eq.4.and.ipset.eq.6)then
        olds12=2d0*dot(p4(:,j1),p4(:,j2))
        olds13=2d0*dot(p4(:,j1),psoft)
        olds23=2d0*dot(p4(:,j2),psoft)
        s12= s4(j1,j2)
        s13=s64(i3,j1)
        s23=s64(i3,j2)
c        s13=2d0*dot(p6(:,i3),p4(:,j1))
c        s23=2d0*dot(p6(:,i3),p4(:,j2))
      endif

      SS1= abs(2d0*s12/s13/s23)

      if(abs(SS1).gt.abs(huge(SS1)))then
c      if(j1.eq.1.and.i3.eq.7.and.j2.eq.5.and.jpset.eq.5) then
         write(*,*)" in SS1   ",j1,i3,j2,jpset,ipset
         write(*,*)s12,s13,s23,SS1
      endif
      return
      end
