************************************************************************
*
      function qqA30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = d0x2 + d0x1
      e0 = -pi ** 2 / 0.12D2 - d1x2 - d1x1 + d0x1 * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + 0.1D1 / om
     #z1 / omz2 * rH1(1, z2) + d0x2 / omz1
      e0 = d0x1 * d0x2 + d0x1 / omz2 * rH1(1, z2) + 0.1D1 / omz1 * rH1
     #(1, z1) * d0x2 - d1x1 / omz2 - 0.1D1 / omz1 * d1x2 + 0.1D1 / omz1 
     #/ omz2 * rH1(1, z2) * rH1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1,
     # z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z2) - pi ** 2 / omz1 / omz2
     # / 0.12D2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 + x2 / 0.2D1 - d0x2
      e0 = (0.1D1 / 0.2D1 + x2 / 0.2D1) * d0x1 - d0x1 * d0x2 + d1x2 - 
     #x2 / 0.2D1 + 0.1D1 / 0.2D1 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) * rln2 
     #+ (0.1D1 / 0.2D1 + x2 / 0.2D1) * rH1(-1, x2) + (0.1D1 / 0.2D1 + x2
     # / 0.2D1) * rH1(1, x2) + 0.1D1 / omx2 * rln2 - rH1(-1, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 - d0x2 / omz1
      e0 = (0.1D1 / 0.2D1 + x2 / 0.2D1) * d0x1 - d0x1 * d0x2 - 0.1D1 /
     # omz1 * rH1(1, z1) * d0x2 + 0.1D1 / omz1 * d1x2 + (-x2 / 0.2D1 + 0
     #.1D1 / 0.2D1) / omz1 + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * rH1(1
     #, z1) + (0.1D1 / 0.2D1 + x2 / 0.2D1) / omz1 * rH1(-1, x2) + (-0.1D
     #1 / 0.2D1 - x2 / 0.2D1) / omz1 * rln2 + (0.1D1 / 0.2D1 + x2 / 0.2D
     #1) * rH1(1, x2) / omz1 - 0.1D1 / omz1 * rH1(-1, x2) / omx2 + 0.1D1
     # / omz1 * rln2 / omx2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 + x1 / 0.2D1 - d0x1
      e0 = -d0x1 * d0x2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) * d0x2 + d1x1 -
     # x1 / 0.2D1 + 0.1D1 / 0.2D1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rln2
     # + (0.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(-1, x1) + (0.1D1 / 0.2D1 + x
     #1 / 0.2D1) * rH1(1, x1) + 0.1D1 / omx1 * rln2 - rH1(-1, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 - d0x1 / omz2
      e0 = -d0x1 * d0x2 - d0x1 / omz2 * rH1(1, z2) + (0.1D1 / 0.2D1 + 
     #x1 / 0.2D1) * d0x2 + d1x1 / omz2 + (-x1 / 0.2D1 + 0.1D1 / 0.2D1) /
     # omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * rH1(-1, x1) + (-0.1D
     #1 / 0.2D1 - x1 / 0.2D1) / omz2 * rln2 + (0.1D1 / 0.2D1 + x1 / 0.2D
     #1) * rH1(1, x1) / omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * rH1
     #(1, z2) - 0.1D1 / omz2 * rH1(-1, x1) / omx1 + 0.1D1 / omz2 * rln2 
     #/ omx1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = d0x1 * d0x2 + (-0.1D1 / 0.2D1 - x2 / 0.2D1) * d0x1 + (-0.1D
     #1 / 0.2D1 - x1 / 0.2D1) * d0x2 + (x1 ** 2 + x2 ** 2) * (0.2D1 * x1
     # ** 2 * x2 ** 2 + 0.2D1 * x1 ** 2 * x2 + 0.2D1 * x1 * x2 ** 2 + x1
     # ** 2 + 0.6D1 * x1 * x2 + x2 ** 2 + 0.2D1 * x1 + 0.2D1 * x2 + 0.2D
     #1) / (x2 + x1) ** 2 / (0.1D1 + x1) / (0.1D1 + x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        qqA30IIint=e2
      elseif(ieorder.eq.-1)then
        qqA30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qqA30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qqA30IIint ",qqA30IIint

      return
      end
************************************************************************
*
      function qgD30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        qgD30IIint=gqD30IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = d0x2 + d0x1
      e0 = -pi ** 2 / 0.12D2 - d1x2 - d1x1 + d0x1 * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + rH1(1, z2)
     # / omz1 / omz2 + d0x2 / omz1
      e0 = d0x1 * d0x2 + d0x1 / omz2 * rH1(1, z2) + 0.1D1 / omz1 * rH1
     #(1, z1) * d0x2 - d1x1 / omz2 - 0.1D1 / omz1 * d1x2 + rH1(1, z2) / 
     #omz1 / omz2 * rH1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1) + 0
     #.1D1 / omz1 / omz2 * rH2(1, 1, z2) - pi ** 2 / omz1 / omz2 / 0.12D
     #2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = -d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) * d
     #0x1 / x2 + d1x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * 
     #rH1(-1, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH1(
     #1, x2) - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rln2 + 0.
     #1D1 / omx2 * rln2 - rH1(-1, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = -d0x2 / omz1 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 / omz1
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) * d
     #0x1 / x2 - 0.1D1 / omz1 * rH1(1, z1) * d0x2 + 0.1D1 / omz1 * d1x2 
     #+ (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(1, z1
     #) + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(-1,
     # x2) - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rln2
     # + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(1, x
     #2) - 0.1D1 / omz1 * rH1(-1, x2) / omx2 + 0.1D1 / omz1 * rln2 / omx
     #2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 + x1 / 0.2D1 - d0x1
      e0 = -d0x1 * d0x2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) * d0x2 + d1x1 -
     # x1 / 0.2D1 + 0.1D1 / 0.2D1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rln2
     # + (0.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(-1, x1) + (0.1D1 / 0.2D1 + x
     #1 / 0.2D1) * rH1(1, x1) + 0.1D1 / omx1 * rln2 - rH1(-1, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 - d0x1 / omz2
      e0 = -d0x1 * d0x2 - d0x1 / omz2 * rH1(1, z2) + (0.1D1 / 0.2D1 + 
     #x1 / 0.2D1) * d0x2 + d1x1 / omz2 + (-x1 / 0.2D1 + 0.1D1 / 0.2D1) /
     # omz2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * rH1(1, z2) + (0.1D1 
     #/ 0.2D1 + x1 / 0.2D1) / omz2 * rH1(-1, x1) + (-0.1D1 / 0.2D1 - x1 
     #/ 0.2D1) / omz2 * rln2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(1, x1)
     # / omz2 - 0.1D1 / omz2 * rH1(-1, x1) / omx1 + 0.1D1 / omz2 * rln2 
     #/ omx1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = d0x1 * d0x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) * d0
     #x1 / x2 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * d0x2 + (0.2D1 * x1 ** 5 
     #* x2 ** 5 + 0.4D1 * x1 ** 4 * x2 ** 6 + 0.4D1 * x1 ** 3 * x2 ** 7 
     #+ 0.2D1 * x1 ** 5 * x2 ** 4 + 0.6D1 * x1 ** 4 * x2 ** 5 + 0.8D1 * 
     #x1 ** 3 * x2 ** 6 + 0.4D1 * x1 ** 2 * x2 ** 7 + 0.2D1 * x1 ** 5 * 
     #x2 ** 3 + 0.10D2 * x1 ** 4 * x2 ** 4 + 0.12D2 * x1 ** 3 * x2 ** 5 
     #+ 0.12D2 * x1 ** 2 * x2 ** 6 + 0.4D1 * x1 * x2 ** 7 + 0.2D1 * x1 *
     #* 5 * x2 ** 2 + 0.10D2 * x1 ** 4 * x2 ** 3 + 0.14D2 * x1 ** 3 * x2
     # ** 4 + 0.10D2 * x1 ** 2 * x2 ** 5 + 0.6D1 * x1 * x2 ** 6 + 0.2D1 
     #* x2 ** 7 + x1 ** 5 * x2 + 0.7D1 * x1 ** 4 * x2 ** 2 + 0.21D2 * x1
     # ** 3 * x2 ** 3 + 0.19D2 * x1 ** 2 * x2 ** 4 + 0.4D1 * x1 * x2 ** 
     #5 + 0.2D1 * x1 ** 4 * x2 + 0.10D2 * x1 ** 3 * x2 ** 2 + 0.18D2 * x
     #1 ** 2 * x2 ** 3 + 0.12D2 * x1 * x2 ** 4 + 0.2D1 * x2 ** 5 + x2 * 
     #x1 ** 3 + 0.3D1 * x1 ** 2 * x2 ** 2 + 0.9D1 * x1 * x2 ** 3 + 0.3D1
     # * x2 ** 4 + 0.2D1 * x1 ** 3 + 0.2D1 * x1 ** 2 * x2 + 0.4D1 * x1 *
     #* 2 + 0.4D1 * x1 * x2 + 0.2D1 * x2 ** 2) / (x2 + x1) ** 3 / x2 / (
     #0.1D1 + x1) / (0.1D1 + x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        qgD30IIint=e2
      elseif(ieorder.eq.-1)then
        qgD30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qgD30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qgD30IIint ",qgD30IIint

      return
      end
************************************************************************
*
      function qqpE30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        qqpE30IIint=qpqE30IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (x2 - 
     #0.1D1) / x2 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rln2 / 0.2D1 +
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(-1, x2) / 0.2D1 + (x2 *
     #* 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(1, x2) / 0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (x2 - 
     #0.1D1) / x2 / omz1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * 
     #rH1(1, z1) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * 
     #rH1(-1, x2) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rln2 / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * rH1(1
     #, x2) / 0.2D1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 + (0.2D
     #1 * x1 ** 2 * x2 ** 4 + 0.2D1 * x1 * x2 ** 4 - x1 ** 2 * x2 ** 2 -
     # 0.2D1 * x1 * x2 ** 3 + x2 ** 4 + 0.2D1 * x1 ** 2 * x2 + 0.2D1 * x
     #1 * x2 ** 2 - 0.2D1 * x2 ** 3 - 0.2D1 * x1 ** 2 + 0.4D1 * x1 * x2 
     #+ 0.2D1 * x2 ** 2 - 0.4D1 * x1) / (x2 + x1) ** 2 / (0.1D1 + x1) / 
     #x2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        qqpE30IIint=e2
      elseif(ieorder.eq.-1)then
        qqpE30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qqpE30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qqpE30IIint ",qqpE30IIint

      return
      end
************************************************************************
*
      function qpqE30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        qpqE30IIint=qqpE30IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (x2 - 
     #0.1D1) / x2 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rln2 / 0.2D1 +
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(-1, x2) / 0.2D1 + (x2 *
     #* 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(1, x2) / 0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (x2 - 
     #0.1D1) / x2 / omz1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * 
     #rH1(-1, x2) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rH1(1, x2) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rH1(1, z1) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rln2 / 0.2D1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 + (0.2D
     #1 * x1 ** 2 * x2 ** 4 + 0.2D1 * x1 * x2 ** 4 - x1 ** 2 * x2 ** 2 -
     # 0.2D1 * x1 * x2 ** 3 + x2 ** 4 + 0.2D1 * x1 ** 2 * x2 + 0.2D1 * x
     #1 * x2 ** 2 - 0.2D1 * x2 ** 3 - 0.2D1 * x1 ** 2 + 0.4D1 * x1 * x2 
     #+ 0.2D1 * x2 ** 2 - 0.4D1 * x1) / (x2 + x1) ** 2 / (0.1D1 + x1) / 
     #x2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        qpqE30IIint=e2
      elseif(ieorder.eq.-1)then
        qpqE30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qpqE30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qpqE30IIint ",qpqE30IIint

      return
      end
************************************************************************
*
      function ggF30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = d0x2 + d0x1
      e0 = -pi ** 2 / 0.12D2 - d1x2 - d1x1 + d0x1 * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + rH1(1, z2)
     # / omz1 / omz2 + d0x2 / omz1
      e0 = d0x1 * d0x2 + d0x1 / omz2 * rH1(1, z2) + rH1(1, z1) / omz1 
     #* d0x2 - d1x1 / omz2 - 0.1D1 / omz1 * d1x2 + rH1(1, z2) / omz1 / o
     #mz2 * rH1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1) + 0.1D1 / o
     #mz1 / omz2 * rH2(1, 1, z2) - pi ** 2 / omz1 / omz2 / 0.12D2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = -d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) * d
     #0x1 / x2 + d1x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * 
     #rH1(-1, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH1(
     #1, x2) - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rln2 + 0.
     #1D1 / omx2 * rln2 - rH1(-1, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = -d0x2 / omz1 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x
     #2 / omz1
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) * d
     #0x1 / x2 - rH1(1, z1) / omz1 * d0x2 + 0.1D1 / omz1 * d1x2 + (x2 **
     # 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(-1, x2) + (x2
     # ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rH1(1, x2) + (
     #x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH1(1, z1) / omz1 -
     # (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 / omz1 * rln2 - rH1
     #(-1, x2) / omz1 / omx2 + rln2 / omz1 / omx2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = -d0x1 + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1
      e0 = -d0x1 * d0x2 + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) * d
     #0x2 / x1 + d1x1 + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * 
     #rH1(-1, x1) + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * rH1(
     #1, x1) - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 * rln2 + 0.
     #1D1 / omx1 * rln2 - rH1(-1, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = -d0x1 / omz2 + (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x
     #1 / omz2
      e0 = -d0x1 * d0x2 - d0x1 / omz2 * rH1(1, z2) + (x1 ** 3 - x1 ** 
     #2 + 0.2D1 * x1 - 0.1D1) * d0x2 / x1 + d1x1 / omz2 + (x1 ** 3 - x1 
     #** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * rH1(-1, x1) - (x1 ** 3 - 
     #x1 ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * rln2 + (x1 ** 3 - x1 *
     #* 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * rH1(1, x1) + (x1 ** 3 - x1
     # ** 2 + 0.2D1 * x1 - 0.1D1) / x1 / omz2 * rH1(1, z2) - 0.1D1 / omz
     #2 * rH1(-1, x1) / omx1 + 0.1D1 / omz2 * rln2 / omx1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = d0x1 * d0x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) * d0
     #x1 / x2 - (x1 ** 3 - x1 ** 2 + 0.2D1 * x1 - 0.1D1) * d0x2 / x1 + (
     #0.2D1 * x1 ** 8 * x2 ** 4 + 0.4D1 * x1 ** 7 * x2 ** 5 + 0.6D1 * x1
     # ** 6 * x2 ** 6 + 0.4D1 * x1 ** 5 * x2 ** 7 + 0.2D1 * x1 ** 4 * x2
     # ** 8 + 0.2D1 * x1 ** 8 * x2 ** 3 + 0.6D1 * x1 ** 7 * x2 ** 4 + 0.
     #10D2 * x1 ** 6 * x2 ** 5 + 0.10D2 * x1 ** 5 * x2 ** 6 + 0.6D1 * x1
     # ** 4 * x2 ** 7 + 0.2D1 * x1 ** 3 * x2 ** 8 + 0.2D1 * x1 ** 8 * x2
     # ** 2 + 0.8D1 * x1 ** 7 * x2 ** 3 + 0.12D2 * x1 ** 6 * x2 ** 4 + 0
     #.20D2 * x1 ** 5 * x2 ** 5 + 0.12D2 * x1 ** 4 * x2 ** 6 + 0.8D1 * x
     #1 ** 3 * x2 ** 7 + 0.2D1 * x1 ** 2 * x2 ** 8 + x1 ** 8 * x2 + 0.4D
     #1 * x1 ** 7 * x2 ** 2 + 0.8D1 * x1 ** 6 * x2 ** 3 + 0.17D2 * x1 **
     # 5 * x2 ** 4 + 0.17D2 * x1 ** 4 * x2 ** 5 + 0.8D1 * x1 ** 3 * x2 *
     #* 6 + 0.4D1 * x1 ** 2 * x2 ** 7 + x1 * x2 ** 8 + 0.2D1 * x1 ** 6 *
     # x2 ** 2 + 0.12D2 * x1 ** 5 * x2 ** 3 + 0.32D2 * x1 ** 4 * x2 ** 4
     # + 0.12D2 * x1 ** 3 * x2 ** 5 + 0.2D1 * x1 ** 2 * x2 ** 6 + x1 ** 
     #6 * x2 + 0.7D1 * x1 ** 5 * x2 ** 2 + 0.22D2 * x1 ** 4 * x2 ** 3 + 
     #0.22D2 * x1 ** 3 * x2 ** 4 + 0.7D1 * x1 ** 2 * x2 ** 5 + x1 * x2 *
     #* 6 + x1 ** 5 * x2 + 0.2D1 * x1 ** 4 * x2 ** 2 + 0.10D2 * x1 ** 3 
     #* x2 ** 3 + 0.2D1 * x1 ** 2 * x2 ** 4 + x2 ** 5 * x1 + x1 ** 5 + x
     #1 ** 4 * x2 + x1 * x2 ** 4 + x2 ** 5 + 0.2D1 * x1 ** 4 + 0.4D1 * x
     #2 * x1 ** 3 + 0.6D1 * x1 ** 2 * x2 ** 2 + 0.4D1 * x1 * x2 ** 3 + 0
     #.2D1 * x2 ** 4) / x1 / (0.1D1 + x2) / (x2 + x1) ** 4 / x2 / (0.1D1
     # + x1)
      endif

      if(ieorder.eq.-2)then
        ggF30IIint=e2
      elseif(ieorder.eq.-1)then
        ggF30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        ggF30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" ggF30IIint ",ggF30IIint

      return
      end
************************************************************************
*
      function gqG30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        gqG30IIint=qgG30IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (x2 - 
     #0.1D1) / x2 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rln2 / 0.2D1 +
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(-1, x2) / 0.2D1 + (x2 *
     #* 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(1, x2) / 0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (x2 - 
     #0.1D1) / x2 / omz1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * 
     #rH1(-1, x2) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rH1(1, x2) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rH1(1, z1) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rln2 / 0.2D1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (-0.2
     #D1 * x1 ** 2 * x2 ** 5 - 0.2D1 * x2 ** 5 * x1 + x1 ** 3 * x2 ** 2 
     #+ 0.7D1 * x1 ** 2 * x2 ** 3 + x1 * x2 ** 4 - x2 ** 5 - 0.2D1 * x2 
     #* x1 ** 3 - 0.4D1 * x1 ** 2 * x2 ** 2 + 0.4D1 * x1 * x2 ** 3 + 0.2
     #D1 * x2 ** 4 + 0.2D1 * x1 ** 3 - 0.2D1 * x1 ** 2 * x2 - 0.4D1 * x1
     # * x2 ** 2 - 0.2D1 * x2 ** 3 + 0.4D1 * x1 ** 2 + 0.4D1 * x1 * x2 +
     # 0.2D1 * x2 ** 2) / (x2 + x1) ** 3 / (0.1D1 + x1) / x2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        gqG30IIint=e2
      elseif(ieorder.eq.-1)then
        gqG30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gqG30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gqG30IIint ",gqG30IIint

      return
      end
************************************************************************
*
      function qgA30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        qgA30IIint=gqA30IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 - x2 + x2 ** 2
      e0 = -0.1D1 / 0.2D1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * d0x1 + (-
     #0.1D1 / 0.2D1 + x2 - x2 ** 2) * rln2 + (0.1D1 / 0.2D1 - x2 + x2 **
     # 2) * rH1(-1, x2) + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rH1(1, x2)
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) / omz1
      e0 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) * d0x1 + (0.1D1 / 0.2D1 - x2
     # + x2 ** 2) * rH1(-1, x2) / omz1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2) 
     #* rH1(1, x2) / omz1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rH1(1, z1) 
     #/ omz1 - 0.1D1 / omz1 / 0.2D1 + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) / 
     #omz1 * rln2
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * d0x1 + (0.2D1 * x1 ** 5 *
     # x2 ** 3 + 0.4D1 * x1 ** 4 * x2 ** 4 + 0.4D1 * x1 ** 3 * x2 ** 5 +
     # 0.2D1 * x1 ** 4 * x2 ** 3 + 0.4D1 * x1 ** 3 * x2 ** 4 + 0.4D1 * x
     #1 ** 2 * x2 ** 5 - 0.2D1 * x1 ** 4 * x2 ** 2 - 0.2D1 * x1 ** 3 * x
     #2 ** 3 + 0.8D1 * x1 ** 2 * x2 ** 4 + 0.4D1 * x1 * x2 ** 5 - 0.4D1 
     #* x1 ** 3 * x2 ** 2 - 0.8D1 * x1 ** 2 * x2 ** 3 + 0.2D1 * x1 * x2 
     #** 4 + 0.2D1 * x2 ** 5 - 0.4D1 * x1 ** 2 * x2 ** 2 - 0.4D1 * x1 * 
     #x2 ** 3 - 0.2D1 * x2 ** 4 - x1 ** 3 - x1 ** 2 * x2 - x1 * x2 ** 2 
     #+ x2 ** 3) / (0.1D1 + x1) / (x2 + x1) ** 3 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        qgA30IIint=e2
      elseif(ieorder.eq.-1)then
        qgA30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qgA30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qgA30IIint ",qgA30IIint

      return
      end
************************************************************************
*
      function ggD30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 - x2 + x2 ** 2
      e0 = -0.1D1 / 0.2D1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * d0x1 + (-
     #0.1D1 / 0.2D1 + x2 - x2 ** 2) * rln2 + (0.1D1 / 0.2D1 - x2 + x2 **
     # 2) * rH1(-1, x2) + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rH1(1, x2)
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) / omz1
      e0 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) * d0x1 + (0.1D1 / 0.2D1 - x2
     # + x2 ** 2) * rH1(-1, x2) / omz1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2) 
     #* rH1(1, x2) / omz1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rH1(1, z1) 
     #/ omz1 - 0.1D1 / omz1 / 0.2D1 + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) / 
     #omz1 * rln2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 - x1 + x1 ** 2
      e0 = -0.1D1 / 0.2D1 + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * d0x2 + (-
     #0.1D1 / 0.2D1 + x1 - x1 ** 2) * rln2 + (0.1D1 / 0.2D1 - x1 + x1 **
     # 2) * rH1(-1, x1) + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rH1(1, x1)
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) / omz2
      e0 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) * d0x2 - 0.1D1 / omz2 / 0.2D
     #1 + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2 * rln2 + (0.1D1 / 0.2D1
     # - x1 + x1 ** 2) * rH1(-1, x1) / omz2 + (0.1D1 / 0.2D1 - x1 + x1 *
     #* 2) * rH1(1, x1) / omz2 + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rH1(1,
     # z2) / omz2
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * d0x1 + (-0.1D1 / 0.2D1 + 
     #x1 - x1 ** 2) * d0x2 + (0.4D1 * x1 ** 7 * x2 ** 3 + 0.8D1 * x1 ** 
     #6 * x2 ** 4 + 0.12D2 * x1 ** 5 * x2 ** 5 + 0.8D1 * x1 ** 4 * x2 **
     # 6 + 0.4D1 * x1 ** 3 * x2 ** 7 + 0.4D1 * x1 ** 7 * x2 ** 2 + 0.12D
     #2 * x1 ** 6 * x2 ** 3 + 0.20D2 * x1 ** 5 * x2 ** 4 + 0.20D2 * x1 *
     #* 4 * x2 ** 5 + 0.12D2 * x1 ** 3 * x2 ** 6 + 0.4D1 * x1 ** 2 * x2 
     #** 7 + 0.4D1 * x1 ** 7 * x2 + 0.16D2 * x1 ** 6 * x2 ** 2 + 0.18D2 
     #* x1 ** 5 * x2 ** 3 + 0.28D2 * x1 ** 4 * x2 ** 4 + 0.18D2 * x1 ** 
     #3 * x2 ** 5 + 0.16D2 * x1 ** 2 * x2 ** 6 + 0.4D1 * x2 ** 7 * x1 + 
     #0.2D1 * x1 ** 7 + 0.8D1 * x1 ** 6 * x2 + 0.10D2 * x1 ** 5 * x2 ** 
     #2 + 0.16D2 * x1 ** 4 * x2 ** 3 + 0.16D2 * x1 ** 3 * x2 ** 4 + 0.10
     #D2 * x1 ** 2 * x2 ** 5 + 0.8D1 * x1 * x2 ** 6 + 0.2D1 * x2 ** 7 - 
     #0.2D1 * x1 ** 5 * x2 - 0.6D1 * x1 ** 4 * x2 ** 2 + 0.16D2 * x1 ** 
     #3 * x2 ** 3 - 0.6D1 * x1 ** 2 * x2 ** 4 - 0.2D1 * x1 * x2 ** 5 - x
     #1 ** 5 - x1 ** 4 * x2 + 0.14D2 * x1 ** 3 * x2 ** 2 + 0.14D2 * x1 *
     #* 2 * x2 ** 3 - x1 * x2 ** 4 - x2 ** 5 + 0.2D1 * x2 * x1 ** 3 + 0.
     #20D2 * x1 ** 2 * x2 ** 2 + 0.2D1 * x1 * x2 ** 3 - 0.2D1 * x1 ** 3 
     #- 0.2D1 * x1 ** 2 * x2 - 0.2D1 * x1 * x2 ** 2 - 0.2D1 * x2 ** 3 - 
     #0.2D1 * x1 ** 2 - 0.2D1 * x2 ** 2) / (0.1D1 + x2) / (x2 + x1) ** 4
     # / (0.1D1 + x1) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        ggD30IIint=e2
      elseif(ieorder.eq.-1)then
        ggD30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        ggD30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" ggD30IIint ",ggD30IIint

      return
      end
************************************************************************
*
      function qpqpE30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = x2 * x1 * (x1 ** 2 + x2 ** 2 - 0.2D1) * (x1 * x2 + 0.1D1) *
     #* 2 / (x2 + x1) ** 4
      endif

      if(ieorder.eq.-2)then
        qpqpE30IIint=e2
      elseif(ieorder.eq.-1)then
        qpqpE30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qpqpE30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qpqpE30IIint ",qpqpE30IIint

      return
      end
************************************************************************
*
      function qqG30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (x1 * x2 + 0.1D1) * (x1 ** 4 * x2 ** 2 + x1 ** 2 * x2 ** 4 
     #- 0.4D1 * x1 ** 2 * x2 ** 2 + x1 ** 2 + x2 ** 2) / (x2 + x1) ** 4
      endif

      if(ieorder.eq.-2)then
        qqG30IIint=e2
      elseif(ieorder.eq.-1)then
        qqG30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qqG30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qqG30IIint ",qqG30IIint

      return
      end
************************************************************************
*
      function ggD301IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        ggD301IIint=ggD302IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 - x1 + x1 ** 2
      e0 = -0.1D1 / 0.2D1 + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * d0x2 + (-
     #0.1D1 / 0.2D1 + x1 - x1 ** 2) * rln2 + (0.1D1 / 0.2D1 - x1 + x1 **
     # 2) * rH1(-1, x1) + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rH1(1, x1)
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) / omz2
      e0 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) * d0x2 - 0.1D1 / omz2 / 0.2D
     #1 + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2 * rln2 + (0.1D1 / 0.2D1
     # - x1 + x1 ** 2) * rH1(-1, x1) / omz2 + (0.1D1 / 0.2D1 - x1 + x1 *
     #* 2) * rH1(1, x1) / omz2 + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rH1(1,
     # z2) / omz2
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x1 - x1 ** 2) * d0x2 + (0.4D1 * x1 ** 6 *
     # x2 ** 3 + 0.6D1 * x1 ** 4 * x2 ** 5 + 0.8D1 * x1 ** 3 * x2 ** 6 +
     # 0.4D1 * x1 ** 6 * x2 ** 2 + 0.6D1 * x1 ** 4 * x2 ** 4 + 0.8D1 * x
     #1 ** 3 * x2 ** 5 + 0.4D1 * x1 ** 6 * x2 + 0.12D2 * x1 ** 5 * x2 **
     # 2 - 0.10D2 * x1 ** 4 * x2 ** 3 + 0.8D1 * x1 ** 3 * x2 ** 4 + 0.20
     #D2 * x1 ** 2 * x2 ** 5 + 0.2D1 * x1 ** 6 + 0.4D1 * x1 ** 5 * x2 - 
     #0.22D2 * x1 ** 4 * x2 ** 2 + 0.18D2 * x1 ** 2 * x2 ** 4 - 0.2D1 * 
     #x1 ** 5 - 0.6D1 * x1 ** 4 * x2 - 0.22D2 * x1 ** 3 * x2 ** 2 + 0.8D
     #1 * x1 ** 2 * x2 ** 3 + 0.20D2 * x1 * x2 ** 4 + x1 ** 4 - 0.14D2 *
     # x2 * x1 ** 3 + 0.10D2 * x1 ** 2 * x2 ** 2 + 0.18D2 * x1 * x2 ** 3
     # - x2 ** 4 - 0.6D1 * x1 ** 2 * x2 + 0.4D1 * x2 ** 3 - 0.6D1 * x1 *
     #* 2 + 0.4D1 * x2 ** 2) / (x2 + x1) ** 4 / (0.1D1 + x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        ggD301IIint=e2
      elseif(ieorder.eq.-1)then
        ggD301IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        ggD301IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" ggD301IIint ",ggD301IIint

      return
      end
************************************************************************
*
      function ggD302IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        ggD302IIint=ggD301IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 - x1 + x1 ** 2
      e0 = -0.1D1 / 0.2D1 + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * d0x2 + (-
     #0.1D1 / 0.2D1 + x1 - x1 ** 2) * rln2 + (0.1D1 / 0.2D1 - x1 + x1 **
     # 2) * rH1(-1, x1) + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rH1(1, x1)
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) / omz2
      e0 = (0.1D1 / 0.2D1 - x1 + x1 ** 2) * d0x2 - 0.1D1 / omz2 / 0.2D
     #1 + (-0.1D1 / 0.2D1 + x1 - x1 ** 2) / omz2 * rln2 + (0.1D1 / 0.2D1
     # - x1 + x1 ** 2) * rH1(-1, x1) / omz2 + (0.1D1 / 0.2D1 - x1 + x1 *
     #* 2) * rH1(1, x1) / omz2 + (0.1D1 / 0.2D1 - x1 + x1 ** 2) * rH1(1,
     # z2) / omz2
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x1 - x1 ** 2) * d0x2 + (0.4D1 * x1 ** 6 *
     # x2 ** 3 + 0.6D1 * x1 ** 4 * x2 ** 5 + 0.8D1 * x1 ** 3 * x2 ** 6 +
     # 0.4D1 * x1 ** 6 * x2 ** 2 + 0.6D1 * x1 ** 4 * x2 ** 4 + 0.8D1 * x
     #1 ** 3 * x2 ** 5 + 0.4D1 * x1 ** 6 * x2 + 0.12D2 * x1 ** 5 * x2 **
     # 2 - 0.10D2 * x1 ** 4 * x2 ** 3 + 0.8D1 * x1 ** 3 * x2 ** 4 + 0.20
     #D2 * x1 ** 2 * x2 ** 5 + 0.2D1 * x1 ** 6 + 0.4D1 * x1 ** 5 * x2 - 
     #0.22D2 * x1 ** 4 * x2 ** 2 + 0.18D2 * x1 ** 2 * x2 ** 4 - 0.2D1 * 
     #x1 ** 5 - 0.6D1 * x1 ** 4 * x2 - 0.22D2 * x1 ** 3 * x2 ** 2 + 0.8D
     #1 * x1 ** 2 * x2 ** 3 + 0.20D2 * x1 * x2 ** 4 + x1 ** 4 - 0.14D2 *
     # x2 * x1 ** 3 + 0.10D2 * x1 ** 2 * x2 ** 2 + 0.18D2 * x1 * x2 ** 3
     # - x2 ** 4 - 0.6D1 * x1 ** 2 * x2 + 0.4D1 * x2 ** 3 - 0.6D1 * x1 *
     #* 2 + 0.4D1 * x2 ** 2) / (x2 + x1) ** 4 / (0.1D1 + x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        ggD302IIint=e2
      elseif(ieorder.eq.-1)then
        ggD302IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        ggD302IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" ggD302IIint ",ggD302IIint

      return
      end
************************************************************************
*
      function gqD30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        gqD30IIint=qgD30IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.1.and.imethod.eq.1)then
      e2 = 1
      e1 = d0x2 + d0x1
      e0 = -pi ** 2 / 0.12D2 - d1x2 - d1x1 + d0x1 * d0x2
      endif
      if(ix.eq.1.and.imethod.eq.2)then
      e2 = 0.1D1 / omz1 / omz2
      e1 = d0x1 / omz2 + 0.1D1 / omz1 / omz2 * rH1(1, z1) + rH1(1, z2)
     # / omz1 / omz2 + d0x2 / omz1
      e0 = d0x1 * d0x2 + d0x1 / omz2 * rH1(1, z2) + rH1(1, z1) / omz1 
     #* d0x2 - d1x1 / omz2 - 0.1D1 / omz1 * d1x2 + rH1(1, z2) / omz1 / o
     #mz2 * rH1(1, z1) + 0.1D1 / omz1 / omz2 * rH2(1, 1, z1) + 0.1D1 / o
     #mz1 / omz2 * rH2(1, 1, z2) - pi ** 2 / omz1 / omz2 / 0.12D2
      endif
      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = -d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) * d
     #0x1 / x2 + d1x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * 
     #rH1(-1, x2) + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH1(
     #1, x2) - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rln2 + 0.
     #1D1 / omx2 * rln2 - rH1(-1, x2) / omx2
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = -d0x2 / omz1 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / o
     #mz1 / x2
      e0 = -d0x1 * d0x2 + (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) * d
     #0x1 / x2 - rH1(1, z1) / omz1 * d0x2 + 0.1D1 / omz1 * d1x2 + (x2 **
     # 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / omz1 / x2 * rH1(-1, x2) + (x2
     # ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / omz1 / x2 * rH1(1, x2) + (
     #x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2 * rH1(1, z1) / omz1 -
     # (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / omz1 / x2 * rln2 - rH1
     #(-1, x2) / omz1 / omx2 + 0.1D1 / omz1 * rln2 / omx2
      endif
      if(ix.eq.3.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 + x1 / 0.2D1 - d0x1
      e0 = -d0x1 * d0x2 + (0.1D1 / 0.2D1 + x1 / 0.2D1) * d0x2 + d1x1 -
     # x1 / 0.2D1 + 0.1D1 / 0.2D1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * rln2
     # + (0.1D1 / 0.2D1 + x1 / 0.2D1) * rH1(-1, x1) + (0.1D1 / 0.2D1 + x
     #1 / 0.2D1) * rH1(1, x1) + 0.1D1 / omx1 * rln2 - rH1(-1, x1) / omx1
      endif
      if(ix.eq.3.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 - d0x1 / omz2
      e0 = -d0x1 * d0x2 - 0.1D1 / omz2 * rH1(1, z2) * d0x1 + (0.1D1 / 
     #0.2D1 + x1 / 0.2D1) * d0x2 + d1x1 / omz2 + (0.1D1 / 0.2D1 + x1 / 0
     #.2D1) / omz2 * rH1(1, z2) + (0.1D1 / 0.2D1 + x1 / 0.2D1) / omz2 * 
     #rH1(-1, x1) + (-0.1D1 / 0.2D1 - x1 / 0.2D1) / omz2 * rln2 + (0.1D1
     # / 0.2D1 + x1 / 0.2D1) * rH1(1, x1) / omz2 + (-x1 / 0.2D1 + 0.1D1 
     #/ 0.2D1) / omz2 - 0.1D1 / omz2 * rH1(-1, x1) / omx1 + 0.1D1 / omz2
     # * rln2 / omx1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = d0x1 * d0x2 - (x2 ** 3 - x2 ** 2 + 0.2D1 * x2 - 0.1D1) / x2
     # * d0x1 + (-0.1D1 / 0.2D1 - x1 / 0.2D1) * d0x2 + (0.2D1 * x1 ** 5 
     #* x2 ** 5 + 0.4D1 * x1 ** 4 * x2 ** 6 + 0.4D1 * x1 ** 3 * x2 ** 7 
     #+ 0.2D1 * x1 ** 5 * x2 ** 4 + 0.6D1 * x1 ** 4 * x2 ** 5 + 0.8D1 * 
     #x1 ** 3 * x2 ** 6 + 0.4D1 * x1 ** 2 * x2 ** 7 + 0.2D1 * x1 ** 5 * 
     #x2 ** 3 + 0.10D2 * x1 ** 4 * x2 ** 4 + 0.12D2 * x1 ** 3 * x2 ** 5 
     #+ 0.12D2 * x1 ** 2 * x2 ** 6 + 0.4D1 * x1 * x2 ** 7 + 0.2D1 * x1 *
     #* 5 * x2 ** 2 + 0.10D2 * x1 ** 4 * x2 ** 3 + 0.14D2 * x1 ** 3 * x2
     # ** 4 + 0.10D2 * x1 ** 2 * x2 ** 5 + 0.6D1 * x1 * x2 ** 6 + 0.2D1 
     #* x2 ** 7 + x1 ** 5 * x2 + 0.7D1 * x1 ** 4 * x2 ** 2 + 0.21D2 * x1
     # ** 3 * x2 ** 3 + 0.19D2 * x1 ** 2 * x2 ** 4 + 0.4D1 * x1 * x2 ** 
     #5 + 0.2D1 * x1 ** 4 * x2 + 0.10D2 * x1 ** 3 * x2 ** 2 + 0.18D2 * x
     #1 ** 2 * x2 ** 3 + 0.12D2 * x1 * x2 ** 4 + 0.2D1 * x2 ** 5 + x2 * 
     #x1 ** 3 + 0.3D1 * x1 ** 2 * x2 ** 2 + 0.9D1 * x1 * x2 ** 3 + 0.3D1
     # * x2 ** 4 + 0.2D1 * x1 ** 3 + 0.2D1 * x1 ** 2 * x2 + 0.4D1 * x1 *
     #* 2 + 0.4D1 * x1 * x2 + 0.2D1 * x2 ** 2) / (x2 + x1) ** 3 / x2 / (
     #0.1D1 + x1) / (0.1D1 + x2) / 0.2D1
      endif

      if(ieorder.eq.-2)then
        gqD30IIint=e2
      elseif(ieorder.eq.-1)then
        gqD30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gqD30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gqD30IIint ",gqD30IIint

      return
      end
************************************************************************
*
      function qgG30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        qgG30IIint=gqG30IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (x2 - 
     #0.1D1) / x2 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rln2 / 0.2D1 +
     # (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(-1, x2) / 0.2D1 + (x2 *
     #* 2 - 0.2D1 * x2 + 0.2D1) / x2 * rH1(1, x2) / 0.2D1
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 / 0.2D1
      e0 = (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (x2 - 
     #0.1D1) / x2 / omz1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 * 
     #rH1(-1, x2) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rH1(1, x2) / 0.2D1 + (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rH1(1, z1) / 0.2D1 - (x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 / omz1 *
     # rln2 / 0.2D1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = -(x2 ** 2 - 0.2D1 * x2 + 0.2D1) / x2 * d0x1 / 0.2D1 - (-0.2
     #D1 * x1 ** 2 * x2 ** 5 - 0.2D1 * x1 * x2 ** 5 + x1 ** 3 * x2 ** 2 
     #+ 0.7D1 * x1 ** 2 * x2 ** 3 + x1 * x2 ** 4 - x2 ** 5 - 0.2D1 * x2 
     #* x1 ** 3 - 0.4D1 * x1 ** 2 * x2 ** 2 + 0.4D1 * x1 * x2 ** 3 + 0.2
     #D1 * x2 ** 4 + 0.2D1 * x1 ** 3 - 0.2D1 * x1 ** 2 * x2 - 0.4D1 * x1
     # * x2 ** 2 - 0.2D1 * x2 ** 3 + 0.4D1 * x1 ** 2 + 0.4D1 * x1 * x2 +
     # 0.2D1 * x2 ** 2) / (x2 + x1) ** 3 / (0.1D1 + x1) / x2 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        qgG30IIint=e2
      elseif(ieorder.eq.-1)then
        qgG30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        qgG30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" qgG30IIint ",qgG30IIint

      return
      end
************************************************************************
*
      function gqA30IIint(ix,x1,x2,i1,i2,ipset,renscale2)
      use KinData_mod, only : kin
      implicit double precision (a-h,o-z)
      common /order/ieorder
      common /method/imethod
      common /distomx/ d0x1,d1x1,d2x1,d3x1,d0x2,d1x2,d2x2,d3x2
!$omp threadprivate(/distomx/)
      common /parfrac/ z1,z2
!$omp threadprivate(/parfrac/)
      parameter(pi=3.141592653589793238d0)
      parameter(zeta3=1.202056903159594285d0)
      parameter(rln2=0.693147180559945309d0)

      if((i1.eq.2).and.(i2.eq.1))then
        gqA30IIint=qgA30IIint(ix,x1,x2,i2,i1,ipset,renscale2)
        return
      endif

      s12=kin(ipset)%s(i1,i2)

      dls=log(renscale2/abs(s12))
      e0=0d0
      e1=0d0
      e2=0d0
      omx1=1d0-x1
      omx2=1d0-x2
      omz1=1d0-z1
      omz2=1d0-z2

      if(ix.eq.2.and.imethod.eq.1)then
      e2 = 0
      e1 = 0.1D1 / 0.2D1 - x2 + x2 ** 2
      e0 = -0.1D1 / 0.2D1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * d0x1 + (-
     #0.1D1 / 0.2D1 + x2 - x2 ** 2) * rln2 + (0.1D1 / 0.2D1 - x2 + x2 **
     # 2) * rH1(-1, x2) + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rH1(1, x2)
      endif
      if(ix.eq.2.and.imethod.eq.2)then
      e2 = 0
      e1 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) / omz1
      e0 = (0.1D1 / 0.2D1 - x2 + x2 ** 2) * d0x1 - 0.1D1 / omz1 / 0.2D
     #1 + (0.1D1 / 0.2D1 - x2 + x2 ** 2) * rH1(-1, x2) / omz1 + (0.1D1 /
     # 0.2D1 - x2 + x2 ** 2) * rH1(1, x2) / omz1 + (0.1D1 / 0.2D1 - x2 +
     # x2 ** 2) * rH1(1, z1) / omz1 + (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * 
     #rln2 / omz1
      endif
      if(ix.eq.4)then
      e2 = 0
      e1 = 0
      e0 = (-0.1D1 / 0.2D1 + x2 - x2 ** 2) * d0x1 + (0.2D1 * x1 ** 5 *
     # x2 ** 3 + 0.4D1 * x1 ** 4 * x2 ** 4 + 0.4D1 * x1 ** 3 * x2 ** 5 +
     # 0.2D1 * x1 ** 4 * x2 ** 3 + 0.4D1 * x1 ** 3 * x2 ** 4 + 0.4D1 * x
     #1 ** 2 * x2 ** 5 - 0.2D1 * x1 ** 4 * x2 ** 2 - 0.2D1 * x1 ** 3 * x
     #2 ** 3 + 0.8D1 * x1 ** 2 * x2 ** 4 + 0.4D1 * x1 * x2 ** 5 - 0.4D1 
     #* x1 ** 3 * x2 ** 2 - 0.8D1 * x1 ** 2 * x2 ** 3 + 0.2D1 * x1 * x2 
     #** 4 + 0.2D1 * x2 ** 5 - 0.4D1 * x1 ** 2 * x2 ** 2 - 0.4D1 * x1 * 
     #x2 ** 3 - 0.2D1 * x2 ** 4 - x1 ** 3 - x1 ** 2 * x2 - x1 * x2 ** 2 
     #+ x2 ** 3) / (0.1D1 + x1) / (x2 + x1) ** 3 / 0.2D1
      endif

      if(ieorder.eq.-2)then
        gqA30IIint=e2
      elseif(ieorder.eq.-1)then
        gqA30IIint=e1
     . +e2*dls
      elseif(ieorder.eq.0)then
        gqA30IIint=e0
     . +e1*dls+e2*dls**2/2d0
      endif

*      write(*,*)" gqA30IIint ",gqA30IIint

      return
      end
