****************************************************
* FullAt31FF(i1,i2,i3,ipset,renscale) i.e. for i2 soft
      function FullAt31FF(i1,i2,i3,ipset,renscale)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      FullA30=FullA30FF(i1,i2,i3,ipset)
      y12=s12/s123
      y13=s13/s123
      y23=s23/s123

      FullAt31FF=
     . 2d0*(xIqqone(s13,renscale)
     .     -xIqqone(s123,renscale))*FullA30

      if(ieorder.eq.0)then
      FullAt31FF=FullAt31FF
     . -(rr(y12,y13)+rr(y13,y23)+3d0/2d0*rH1(0,abs(y13)))*FullA30
     . -(s13+s23)/2d0/s123/s12
     . -(s13+s12)/2d0/s123/s23
     . +s13/2d0/s123/(s12+s13)
     . +s13/2d0/s123/(s13+s23)
     . +2d0*s13/s123/(s12+s23)
     . +2d0*rH1(0,abs(y13))/s123*(2d0*s13/(s12+s23)+s13**2/(s12+s23)**2)
     . +rH1(0,abs(y12))/2d0/s123*(s12*s13/(s13+s23)**2
     .                           +4d0*s13/(s13+s23)+s12/(s13+s23))
     . +rH1(0,abs(y23))/2d0/s123*(s13*s23/(s12+s13)**2
     .                           +4d0*s13/(s12+s13)+s23/(s12+s13))
     .  +rr(y13,y12)*(2d0*s13+s12)/s123/s23
     .  +rr(y13,y23)*(2d0*s13+s23)/s123/s12
      endif
*      write(*,*)" FullAt31FF ",FullAt31FF
      return
      end
************************************************************************
