****************************************************
* FullGt31FF(i1,i2,i3,ipset,renscale) i.e. for i2 soft
      function FullGt31FF(i1,i2,i3,ipset,renscale)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      G30=FullG30FF(i1,i2,i3,ipset)
      y12=s12/s123
      y13=s13/s123
      y23=s23/s123

      FullGt31FF=
     . 2d0*(xIqqone(s23,renscale))*G30

      if(ieorder.eq.0)then
      FullGt31FF=FullGt31FF
     . -(4d0+rr(y12,y13))*G30
     .  +(s12+s13)/2d0/s123**2
      endif
*      write(*,*)" FullGt31FF ",FullGt31FF
      return
      end
************************************************************************
