****************************************************
* FullggF31II(i1,i2,i3,ipset,renscale) i.e. for i2 soft
      function FullggF31II(i1,i2,i3,ipset,renscale)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      F30=FullggF30II(i1,i2,i3,ipset)
      y12=s12/s123
      y13=s13/s123
      y23=s23/s123

      FullggF31II=
     . 2d0*(xIggone(s12,renscale)
     .     +xIggone(s13,renscale)
     .     +xIggone(s23,renscale)
     . -2d0*xIggone(s123,renscale))*F30

      if(ieorder.eq.0)then
      FullggF31II=FullggF31II+
     . (-11d0/6d0*rH1(0,abs(y12))
     .  -11d0/6d0*rH1(0,abs(y13))
     .  -11d0/6d0*rH1(0,abs(y23))
     .  -rr(y12,y13)-rr(y13,y23)-rr(y12,y23))*F30
     .  +1d0/3d0/s12+1d0/3d0/s23+1d0/3d0/s13+1d0/3d0/s123
     .  +11d0/6d0*log(renscale/abs(s123))*F30
      endif


*      write(*,*)" FullggF31II ",FullggF31II
      return
      end
************************************************************************
