****************************************************
* f31FF(i1,i2,i3,ipset,renscale) i.e. for i2 soft
      function f31FF(i1,i2,i3,ipset,renscale)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      f30=f30FF(i1,i2,i3,ipset)
      y12=s12/s123
      y13=s13/s123
      y23=s23/s123

      f31FF=
     . 2d0*(xIggone(s12,renscale)
     .     +xIggone(s13,renscale)
     .     +xIggone(s23,renscale)
     . -2d0*xIggone(s123,renscale))*f30

      if(ieorder.eq.0)then
      f31FF=f31FF+
     . (-11d0/6d0*rH1(0,abs(y12))
     .  -11d0/6d0*rH1(0,abs(y13))
     .  -11d0/6d0*rH1(0,abs(y23))
     .  -rr(y12,y13)-rr(y13,y23)-rr(y12,y23))*f30
     .  +1d0/6d0/s12+1d0/6d0/s23+1d0/9d0/s123
     .  +11d0/6d0*log(renscale/abs(s123))*f30
      endif
*      write(*,*)" f31FF ",f31FF
      return
      end
************************************************************************
