****************************************************
* qdh31IF(i1,i2,i3,ipset,renscale) i.e. for i2 soft
      function qdh31IF(i1,i2,i3,ipset,renscale)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /order/ieorder
      real*8, pointer :: s12,s13,s23

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s23 => kin(ipset)%s(i2,i3)
      s123 = s12+s13+s23

      d30=qd30IF(i1,i2,i3,ipset)
      y12=s12/s123
      y13=s13/s123
      y23=s23/s123

      qdh31IF=
     . 2d0*(xIqgFone(s12,renscale)
     .     +xIqgFone(s13,renscale)
     .     +xIggFone(s23,renscale)
     . -2d0*xIqgFone(s123,renscale))*d30

      if(ieorder.eq.0)then
      qdh31IF=qdh31IF+
     . 1d0/6d0*(rH1(0,abs(y12))
     .         +rH1(0,abs(y13))
     .     +2d0*rH1(0,abs(y23)))*d30
     .  -1d0/6d0/s23
     .  -2d0/6d0*log(renscale/abs(s123))*d30
      endif
*      write(*,*)" qdh31IF ",qdh31IF
      return
      end
************************************************************************
