****************************************************
      function FullB40(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34

      s1234=s12+s13+s14+s23+s24+s34

      b40 =  + s134**(-2)*s1234**(-1)*S34**(-2) * (
     &     - 2.D0*s14**2*s24
     &     - 2.D0*s14**2*s23
     &     - 2.D0*s12*s14**2
     &     )
      b40 = b40 + s134**(-2)*s1234**(-1)*S34**(-1) * (
     &     - 2.D0*s14*s24
     &     - 2.D0*s14*s23
     &     - 2.D0*s12*s14
     &     )
      b40 = b40 + s134**(-2)*s1234**(-1) * (
     &     - s24
     &     - s23
     &     - s12
     &     )
      b40 = b40 + s134**(-1)*s234**(-1)*s1234**(-1)*S34**(-2) * (
     &     + 4.D0*s12*s14*s24
     &     )
      b40 = b40 + s134**(-1)*s234**(-1)*s1234**(-1)*S34**(-1) * (
     &     + 2.D0*s24**2
     &     - 4.D0*s14*s24
     &     + 2.D0*s14**2
     &     + 2.D0*s12*s24
     &     + 2.D0*s12*s14
     &     + 2.D0*s12**2
     &     )
      b40 = b40 + s134**(-1)*s1234**(-1)*S34**(-2) * (
     &     + 4.D0*s14*s24
     &     - 2.D0*s14**2
     &     )
      b40 = b40 + s134**(-1)*s1234**(-1)*S34**(-1) * (
     &     + s24
     &     + s23
     &     + 2.D0*s12
     &     )
      b40 = b40 + s234**(-2)*s1234**(-1)*S34**(-2) * (
     &     - 2.D0*s14*s24**2
     &     - 2.D0*s13*s24**2
     &     - 2.D0*s12*s24**2
     &     )
      b40 = b40 + s234**(-2)*s1234**(-1)*S34**(-1) * (
     &     - 2.D0*s14*s24
     &     - 2.D0*s13*s24
     &     - 2.D0*s12*s24
     &     )
      b40 = b40 + s234**(-2)*s1234**(-1) * (
     &     - s14
     &     - s13
     &     - s12
     &     )
      b40 = b40 + s234**(-1)*s1234**(-1)*S34**(-2) * (
     &     - 2.D0*s24**2
     &     + 4.D0*s14*s24
     &     )
      b40 = b40 + s234**(-1)*s1234**(-1)*S34**(-1) * (
     &     + s14
     &     + s13
     &     + 2.D0*s12
     &     )

      FullB40 = b40

      return
      end

********************************************************************************
      function B40c(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34

      s1234=s12+s13+s14+s23+s24+s34

      wt = 
     &  - s34**(-1) + 2*s134**(-1) + s24*s34**(-1)*s134**(-1) - s24*
     & s134**(-2) + s23*s34**(-1)*s134**(-1) - s23*s134**(-2) + 4*s13*
     & s34**(-1)*s134**(-1) - 2*s13*s24*s34**(-1)*s134**(-2) - 2*s13*
     & s23*s34**(-1)*s134**(-2) - 2*s13**2*s34**(-1)*s134**(-2) + 2*s12
     & *s34**(-1)*s134**(-1) - s12*s134**(-2) - 2*s12*s13*s34**(-1)*
     & s134**(-2) - 6/(s234 + s134) - 2/(s234 + s134)*s34*s134**(-1) - 
     & 4/(s234 + s134)*s24*s34**(-2)*s234 - 2/(s234 + s134)*s24*
     & s34**(-1) - 4/(s234 + s134)*s24*s134**(-1) + 4/(s234 + s134)*
     & s24**2*s34**(-2) - 10/(s234 + s134)*s23*s34**(-1) + 2/(s234 + 
     & s134)*s23*s24*s34**(-2) - 2/(s234 + s134)*s14*s34**(-1) - 1/(
     & s234 + s134)*s14*s24*s34**(-2) - 2/(s234 + s134)*s14*s23**2*
     & s34**(-2)*s134**(-1) + 2/(s234 + s134)*s14**2*s24*s34**(-2)*
     & s134**(-1) - 2/(s234 + s134)*s14**2*s23*s34**(-2)*s134**(-1) - 4
     & /(s234 + s134)*s13*s134**(-1) + 2/(s234 + s134)*s13*s24*
     & s34**(-2)
      wt = wt - 4/(s234 + s134)*s13*s24*s34**(-1)*s134**(-1) + 3/(
     & s234 + s134)*s13*s23*s34**(-2) + 4/(s234 + s134)*s13*s23*s24*
     & s34**(-2)*s134**(-1) + 2/(s234 + s134)*s13*s23**2*s34**(-2)*
     & s134**(-1) + 4/(s234 + s134)*s13*s14*s24*s34**(-2)*s134**(-1) + 
     & 2/(s234 + s134)*s13**2*s134**(-2) - 2/(s234 + s134)*s13**2*
     & s24**2*s34**(-2)*s134**(-2) - 4/(s234 + s134)*s13**2*s23*s24*
     & s34**(-2)*s134**(-2) - 2/(s234 + s134)*s13**2*s23**2*s34**(-2)*
     & s134**(-2) - 2/(s234 + s134)*s12*s24*s34**(-2) + 2/(s234 + s134)
     & *s12*s24*s34**(-1)*s134**(-1) + 2/(s234 + s134)*s12*s14*s24*
     & s34**(-2)*s134**(-1) - 2/(s234 + s134)*s12*s14*s23*s34**(-2)*
     & s134**(-1) + 2/(s234 + s134)*s12*s13*s34**(-1)*s134**(-1) + 2/(
     & s234 + s134)*s12*s13*s24*s34**(-2)*s134**(-1) + 2/(s234 + s134)*
     & s12*s13*s23*s34**(-2)*s134**(-1) - 2/(s234 + s134)*s12*s13**2*
     & s34**(-1)*s134**(-2) - 2/(s234 + s134)*s12*s13**2*s24*s34**(-2)*
     & s134**(-2) - 2/(s234 + s134)*s12*s13**2*s23*s34**(-2)*s134**(-2)
     &  + 2/(s234 + s134)*s12**2*s34**(-1)*s134**(-1)
      wt = wt + 6/(s234**2 + 2*s134*s234 + s134**2)*s34**(-1)*s134*
     & s234 + 6/(s234**2 + 2*s134*s234 + s134**2)*s34 + 4/(s234**2 + 2*
     & s134*s234 + s134**2)*s24*s34**(-2)*s234**2 + 10/(s234**2 + 2*
     & s134*s234 + s134**2)*s24 - 4/(s234**2 + 2*s134*s234 + s134**2)*
     & s24**2*s34**(-2)*s234 + 3/(s234**2 + 2*s134*s234 + s134**2)*
     & s24**2*s34**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s24**2*
     & s134**(-1) + 12/(s234**2 + 2*s134*s234 + s134**2)*s23*s34**(-1)*
     & s234 + 6/(s234**2 + 2*s134*s234 + s134**2)*s23 + 2/(s234**2 + 2*
     & s134*s234 + s134**2)*s23*s24*s34**(-1) - 2/(s234**2 + 2*s134*
     & s234 + s134**2)*s23*s24**2*s34**(-2) - 3/(s234**2 + 2*s134*s234
     &  + s134**2)*s23**2*s34**(-1) - 2/(s234**2 + 2*s134*s234 + 
     & s134**2)*s23**2*s24*s34**(-2) + 6/(s234**2 + 2*s134*s234 + 
     & s134**2)*s14 + 4/(s234**2 + 2*s134*s234 + s134**2)*s14*s24*
     & s34**(-1) + 1/(s234**2 + 2*s134*s234 + s134**2)*s14*s24**2*
     & s34**(-2) + 6/(s234**2 + 2*s134*s234 + s134**2)*s14*s23*
     & s34**(-1)
      wt = wt + 5/(s234**2 + 2*s134*s234 + s134**2)*s14*s23*s24*
     & s34**(-2) + 3/(s234**2 + 2*s134*s234 + s134**2)*s14**2*s34**(-1)
     &  - 1/(s234**2 + 2*s134*s234 + s134**2)*s14**2*s24*s34**(-2) - 2
     & /(s234**2 + 2*s134*s234 + s134**2)*s14**2*s24**2*s34**(-2)*
     & s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s14**2*s23*
     & s34**(-2) - 2/(s234**2 + 2*s134*s234 + s134**2)*s13 - 4/(s234**2
     &  + 2*s134*s234 + s134**2)*s13*s24*s34**(-1) - 4/(s234**2 + 2*
     & s134*s234 + s134**2)*s13*s24**2*s34**(-2) - 2/(s234**2 + 2*s134*
     & s234 + s134**2)*s13*s23*s34**(-1) - 1/(s234**2 + 2*s134*s234 + 
     & s134**2)*s13*s23*s24*s34**(-2) - 1/(s234**2 + 2*s134*s234 + 
     & s134**2)*s13*s23**2*s34**(-2) - 5/(s234**2 + 2*s134*s234 + 
     & s134**2)*s13*s14*s24*s34**(-2) - 4/(s234**2 + 2*s134*s234 + 
     & s134**2)*s13*s14*s24**2*s34**(-2)*s134**(-1) - 3/(s234**2 + 2*
     & s134*s234 + s134**2)*s13*s14*s23*s34**(-2) - 1/(s234**2 + 2*s134
     & *s234 + s134**2)*s13**2*s34**(-1) + 2/(s234**2 + 2*s134*s234 + 
     & s134**2)*s13**2*s134**(-1)
      wt = wt - 2/(s234**2 + 2*s134*s234 + s134**2)*s13**2*s24*
     & s34**(-2) - 4/(s234**2 + 2*s134*s234 + s134**2)*s13**2*s24**2*
     & s34**(-2)*s134**(-1) - 3/(s234**2 + 2*s134*s234 + s134**2)*
     & s13**2*s23*s34**(-2) - 4/(s234**2 + 2*s134*s234 + s134**2)*
     & s13**2*s23*s24*s34**(-2)*s134**(-1) - 2/(s234**2 + 2*s134*s234
     &  + s134**2)*s13**2*s23**2*s34**(-2)*s134**(-1) + 4/(s234**2 + 2*
     & s134*s234 + s134**2)*s12*s24*s34**(-2)*s234 - 2/(s234**2 + 2*
     & s134*s234 + s134**2)*s12*s24**2*s34**(-2) - 2/(s234**2 + 2*s134*
     & s234 + s134**2)*s12*s24**2*s34**(-1)*s134**(-1) - 2/(s234**2 + 2
     & *s134*s234 + s134**2)*s12*s23*s24*s34**(-2) - 2/(s234**2 + 2*
     & s134*s234 + s134**2)*s12*s14*s24**2*s34**(-2)*s134**(-1) + 2/(
     & s234**2 + 2*s134*s234 + s134**2)*s12*s13*s24*s34**(-2) - 2/(
     & s234**2 + 2*s134*s234 + s134**2)*s12*s13*s24**2*s34**(-2)*
     & s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s13*s23*
     & s34**(-2) - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s13**2*
     & s34**(-1)*s134**(-1)
      wt = wt - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s13**2*s24*
     & s34**(-2)*s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s13**2*s23*s34**(-2)*s134**(-1) - 2/(s234**3 + 3*s134*s234**2 + 
     & 3*s134**2*s234 + s134**3)*s14*s23*s24*s34**(-1) - 2/(s234**3 + 3
     & *s134*s234**2 + 3*s134**2*s234 + s134**3)*s14*s23*s24**2*
     & s34**(-2) - 4/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s14*s23**2*s34**(-2)*s234 + 2/(s234**3 + 3*s134*s234**2
     &  + 3*s134**2*s234 + s134**3)*s14*s23**2*s34**(-1) + 2/(s234**3
     &  + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s14*s23**3*
     & s34**(-2) - 2/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s14**2*s23*s34**(-1) - 2/(s234**3 + 3*s134*s234**2 + 3*
     & s134**2*s234 + s134**3)*s14**2*s23*s24*s34**(-2) - 2/(s234**3 + 
     & 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s14**2*s23**2*
     & s34**(-2) + 2/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s13*s24**2*s34**(-1) + 2/(s234**3 + 3*s134*s234**2 + 3*
     & s134**2*s234 + s134**3)*s13*s24**3*s34**(-2)
      wt = wt + 4/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s13*s23*s24*s34**(-2)*s234 - 2/(s234**3 + 3*s134*
     & s234**2 + 3*s134**2*s234 + s134**3)*s13*s23*s24*s34**(-1) - 2/(
     & s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s13*s23**2*
     & s24*s34**(-2) + 2/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s13*s14*s24*s34**(-1) + 2/(s234**3 + 3*s134*s234**2 + 3
     & *s134**2*s234 + s134**3)*s13*s14*s24**2*s34**(-2) - 4/(s234**3
     &  + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s13*s14*s23*
     & s34**(-2)*s234 + 2/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s13*s14*s23*s34**(-1) + 4/(s234**3 + 3*s134*s234**2 + 3
     & *s134**2*s234 + s134**3)*s13*s14*s23*s24*s34**(-2) + 2/(s234**3
     &  + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s13*s14*s23**2*
     & s34**(-2) + 4/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s13**2*s24*s34**(-2)*s234 - 2/(s234**3 + 3*s134*s234**2
     &  + 3*s134**2*s234 + s134**3)*s13**2*s24*s34**(-1) - 2/(s234**3
     &  + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s13**2*s24**2*
     & s34**(-2)
      wt = wt - 2/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s13**2*s23*s24*s34**(-2) - 4/(s234**3 + 3*s134*s234**2
     &  + 3*s134**2*s234 + s134**3)*s12*s24**2*s34**(-1) + 4/(s234**3
     &  + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s12*s23*s24*
     & s34**(-1) - 4/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s12*s14*s24*s34**(-1) + 2/(s234**3 + 3*s134*s234**2 + 3
     & *s134**2*s234 + s134**3)*s12*s14*s23*s24*s34**(-2) - 2/(s234**3
     &  + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s12*s14*s23**2*
     & s34**(-2) + 2/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s12*s14**2*s23*s34**(-2) - 2/(s234**3 + 3*s134*s234**2
     &  + 3*s134**2*s234 + s134**3)*s12*s13*s24**2*s34**(-2) + 4/(
     & s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s12*s13*s23
     & *s34**(-1) + 2/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s12*s13*s23*s24*s34**(-2) - 4/(s234**3 + 3*s134*s234**2
     &  + 3*s134**2*s234 + s134**3)*s12*s13*s14*s34**(-1) - 2/(s234**3
     &  + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s12*s13*s14*s24*
     & s34**(-2)
      wt = wt - 2/(s234**3 + 3*s134*s234**2 + 3*s134**2*s234 + 
     & s134**3)*s12*s13*s14*s23*s34**(-2) + 4/(s234**3 + 3*s134*s234**2
     &  + 3*s134**2*s234 + s134**3)*s12*s13**2*s34**(-1) + 2/(s234**3
     &  + 3*s134*s234**2 + 3*s134**2*s234 + s134**3)*s12*s13**2*s24*
     & s34**(-2) + 4/(s234**4 + 4*s134*s234**3 + 6*s134**2*s234**2 + 4*
     & s134**3*s234 + s134**4)*s12**2*s23*s24*s34**(-1) - 4/(s234**4 + 
     & 4*s134*s234**3 + 6*s134**2*s234**2 + 4*s134**3*s234 + s134**4)*
     & s12**2*s13*s14*s34**(-1)

      B40c=wt/s1234

      return
      end 
