************************************************************************
      function FullGt40(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit double precision(a-h,o-z)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s123=s12+s13+s23
      s124=s12+s14+s24
      s134=s13+s14+s34
      s234=s23+s24+s34

      s1234=s12+s13+s14+s23+s24+s34

      g40t =  + s134**(-2)*s1234**(-2)*S13**(-1) * (
     &     - s24**2*s34
     &     - 2.D0*s23*s24*s34
     &     - s23**2*s34
     &     - 2.D0*s12*s24*s34
     &     - 2.D0*s12*s23*s34
     &     - s12**2*s34
     &     )
      g40t = g40t + s134**(-2)*s1234**(-2)*S14**(-1) * (
     &     - s24**2*s34
     &     - 2.D0*s23*s24*s34
     &     - s23**2*s34
     &     - 2.D0*s12*s24*s34
     &     - 2.D0*s12*s23*s34
     &     - s12**2*s34
     &     )
      g40t = g40t + s134**(-2)*s1234**(-2) * (
     &     - 2.D0*s24**2
     &     - 4.D0*s23*s24
     &     - 2.D0*s23**2
     &     - 4.D0*s12*s24
     &     - 4.D0*s12*s23
     &     - 2.D0*s12**2
     &     )
      g40t = g40t + s134**(-1)*s234**(-1)*s1234**(-2)*S13**(-1)*
     & S23**(-1) * (
     &     - s12*s34**3
     &     - s12**3*s34
     &     )
      g40t = g40t + s134**(-1)*s234**(-1)*s1234**(-2)*S13**(-1) * (
     &     - s34**3
     &     - 2.D0*s24*s34**2
     &     - 2.D0*s24**2*s34
     &     + 2.D0*s12*s34**2
     &     + 4.D0*s12*s24*s34
     &     - 3.D0*s12**2*s34
     &     )
      g40t = g40t + s134**(-1)*s234**(-1)*s1234**(-2)*S14**(-1)*
     & S24**(-1) * (
     &     - s12*s34**3
     &     - s12**3*s34
     &     )
      g40t = g40t + s134**(-1)*s234**(-1)*s1234**(-2)*S14**(-1) * (
     &     - s34**3
     &     - 2.D0*s24*s34**2
     &     - 2.D0*s24**2*s34
     &     - 2.D0*s12*s34**2
     &     - 4.D0*s12*s24*s34
     &     - 3.D0*s12**2*s34
     &     )
      g40t = g40t + s134**(-1)*s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     - s34**3
     &     - 2.D0*s14*s34**2
     &     - 2.D0*s14**2*s34
     &     + 2.D0*s12*s34**2
     &     + 4.D0*s12*s14*s34
     &     - 3.D0*s12**2*s34
     &     )
      g40t = g40t + s134**(-1)*s234**(-1)*s1234**(-2)*S24**(-1) * (
     &     - s34**3
     &     - 2.D0*s14*s34**2
     &     - 2.D0*s14**2*s34
     &     - 2.D0*s12*s34**2
     &     - 4.D0*s12*s14*s34
     &     - 3.D0*s12**2*s34
     &     )
      g40t = g40t + s134**(-1)*s234**(-1)*s1234**(-2) * (
     &     - 8.D0*s12*s34
     &     - 4.D0*s12**2
     &     )
      g40t = g40t + s134**(-1)*s1234**(-2)*S13**(-1) * (
     &     + 2.D0*s24*s34
     &     - s24**2
     &     - 2.D0*s23*s34
     &     + s23**2
     &     - 4.D0*s12*s34
     &     - 2.D0*s12*s24
     &     - s12**2
     &     )
      g40t = g40t + s134**(-1)*s1234**(-2)*S14**(-1) * (
     &     + s24**2
     &     - s23**2
     &     - 2.D0*s12*s23
     &     - s12**2
     &     )
      g40t = g40t + s134**(-1)*s1234**(-2)*S23**(-1) * (
     &     + s34**2
     &     + 2.D0*s14*s34
     &     + 2.D0*s14**2
     &     - 2.D0*s12*s34
     &     - 2.D0*s12*s14
     &     + s12**2
     &     )
      g40t = g40t + s134**(-1)*s1234**(-2)*S24**(-1) * (
     &     + s34**2
     &     + 2.D0*s14*s34
     &     + 2.D0*s14**2
     &     + 2.D0*s12*s14
     &     + s12**2
     &     )
      g40t = g40t + s134**(-1)*s1234**(-2) * (
     &     - 2.D0*s34
     &     - 2.D0*s24
     &     - 2.D0*s23
     &     - 4.D0*s12
     &     )
      g40t = g40t + s234**(-2)*s1234**(-2)*S23**(-1) * (
     &     - s14**2*s34
     &     - 2.D0*s13*s14*s34
     &     - s13**2*s34
     &     - 2.D0*s12*s14*s34
     &     - 2.D0*s12*s13*s34
     &     - s12**2*s34
     &     )
      g40t = g40t + s234**(-2)*s1234**(-2)*S24**(-1) * (
     &     - s14**2*s34
     &     - 2.D0*s13*s14*s34
     &     - s13**2*s34
     &     - 2.D0*s12*s14*s34
     &     - 2.D0*s12*s13*s34
     &     - s12**2*s34
     &     )
      g40t = g40t + s234**(-2)*s1234**(-2) * (
     &     - 2.D0*s14**2
     &     - 4.D0*s13*s14
     &     - 2.D0*s13**2
     &     - 4.D0*s12*s14
     &     - 4.D0*s12*s13
     &     - 2.D0*s12**2
     &     )
      g40t = g40t + s234**(-1)*s1234**(-2)*S13**(-1) * (
     &     + s34**2
     &     + 2.D0*s24*s34
     &     + 2.D0*s24**2
     &     - 2.D0*s12*s34
     &     - 2.D0*s12*s24
     &     + s12**2
     &     )
      g40t = g40t + s234**(-1)*s1234**(-2)*S14**(-1) * (
     &     + s34**2
     &     + 2.D0*s24*s34
     &     + 2.D0*s24**2
     &     + 2.D0*s12*s24
     &     + s12**2
     &     )
      g40t = g40t + s234**(-1)*s1234**(-2)*S23**(-1) * (
     &     + 2.D0*s14*s34
     &     - s14**2
     &     - 2.D0*s13*s34
     &     + s13**2
     &     - 4.D0*s12*s34
     &     - 2.D0*s12*s14
     &     - s12**2
     &     )
      g40t = g40t + s234**(-1)*s1234**(-2)*S24**(-1) * (
     &     + s14**2
     &     - s13**2
     &     - 2.D0*s12*s13
     &     - s12**2
     &     )
      g40t = g40t + s234**(-1)*s1234**(-2) * (
     &     - 2.D0*s34
     &     - 2.D0*s14
     &     - 2.D0*s13
     &     - 4.D0*s12
     &     )
      g40t = g40t + s1234**(-2)*S13**(-1)*S14**(-1) * (
     &     + 2.D0*s24**2
     &     + 2.D0*s23**2
     &     + 2.D0*s12*s24
     &     + 2.D0*s12*s23
     &     + 2.D0*s12**2
     &     )
      g40t = g40t + s1234**(-2)*S13**(-1)*S24**(-1) * (
     &     - s14*s23
     &     + s12*s34
     &     )
      g40t = g40t + s1234**(-2)*S13**(-1) * (
     &     - 2.D0*s24
     &     + 2.D0*s23
     &     + 2.D0*s12
     &     )
      g40t = g40t + s1234**(-2)*S14**(-1)*S23**(-1) * (
     &     - s13*s24
     &     + s12*s34
     &     )
      g40t = g40t + s1234**(-2)*S23**(-1)*S24**(-1) * (
     &     + 2.D0*s14**2
     &     + 2.D0*s13**2
     &     + 2.D0*s12*s14
     &     + 2.D0*s12*s13
     &     + 2.D0*s12**2
     &     )
      g40t = g40t + s1234**(-2)*S23**(-1) * (
     &     - 2.D0*s14
     &     + 2.D0*s13
     &     + 2.D0*s12
     &     )
      g40t = g40t + s1234**(-2) * (
     &     - 2.D0
     &     )

      FullGt40 = g40t

      return
      end
