***************************************************
      function at40a(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s1234=s12+s13+s14+s23+s24+s34
      s134=s13+s14+s34
      s234=s23+s24+s34

      wt = -2/s13 + (2*s12)/(s13*(s13 + s14)) - 2/s24 +
     .   (s12*(2*s12 + s14))/(s13*(s13 + s23)*s24) +
     .   (3*(2*s12 + s14 + s23))/(s13*s24) +
     .   (s12*(2*s12 + s24))/(s13*(s13 + s14)*(s13 + s23)) +
     .   (s12*(2*s12 + s23))/(s13*(s13 + s14)*(s14 + s24)) +
     .   (2*s12**3)/(s13*(s13 + s14)*(s13 + s23)*(s14 + s24)) +
     .   (s12*(2*s12 + s23))/(s13*s24*(s14 + s24)) +
     .   (2*s12**3)/(s13*(s13 + s23)*s24*(s14 + s24)) +
     .   (2*s12)/(s24*(s23 + s24)) +
     .   (s12*(2*s12 + s14))/((s13 + s23)*s24*(s23 + s24)) +
     .   (s12*(2*s12 + s13))/(s24*(s14 + s24)*(s23 + s24)) +
     .   (2*s12**3)/((s13 + s23)*s24*(s14 + s24)*(s23 + s24)) +
     .   (s12 + s23 + s24)/(s13 + s14 + s34)**2 +
     .   ((s12 + s23 + s24)*s34)/(s13*(s13 + s14 + s34)**2) +
     .   1/(s13 + s14 + s34) - (s23 + s24 - 2*s34)/
     .  (s13*(s13 + s14 + s34)) +
     .   (s12*(2*s12 + s23 + s34))/(s24*(s14 + s24)*
     .   (s13 + s14 + s34)) +
     .   (s12*(2*s12 + s24 + s34))/(s13*(s13 + s23)*
     .   (s13 + s14 + s34)) +
     .   (s12 + s13 + s14)/(s23 + s24 + s34)**2 +
     .   ((s12 + s13 + s14)*s34)/(s24*(s23 + s24 + s34)**2) +
     .   1/(s23 + s24 + s34) - (s13 + s14 - 2*s34)/
     .  (s24*(s23 + s24 + s34)) +
     .   (s12*(2*s12 + s13 + s34))/(s24*(s14 + s24)*
     .  (s23 + s24 + s34)) +
     .   (s12*(2*s12 + s14 + s34))/(s13*(s13 + s23)*
     .  (s23 + s24 + s34)) +
     .   (2*s12**3)/(s13*(s13 + s23)*
     .  (s13 + s14 + s34)*(s23 + s24 + s34)) +
     .   (2*s12**3)/(s24*(s14 + s24)*
     .  (s13 + s14 + s34)*(s23 + s24 + s34)) +
     .   (2*(s12 - s34))/((s13 + s14 + s34)*(s23 + s24 + s34)) +
     .   ((3*s12 - s13 - 2*s34)*s34)/
     .    (s24*(s13 + s14 + s34)*(s23 + s24 + s34)) +
     .   ((3*s12 - s24 - 2*s34)*s34)/
     .    (s13*(s13 + s14 + s34)*(s23 + s24 + s34)) +
     .   (-2*s12 + s13 - 2*s23 + 2*s34)/(s24*(s13 + s14 + s34)) +
     .   (-2*s12 - 2*s14 + s24 + 2*s34)/(s13*(s23 + s24 + s34)) +
     .   (4*s12**2 + s14**2 + 3*s12*(s14 - s34) - s14*s34 + s34**2)/
     .    (s13*s24*(s23 + s24 + s34)) +
     .   (4*s12**2 + s23**2 + 3*s12*(s23 - s34) - s23*s34 + s34**2)/
     .    (s13*s24*(s13 + s14 + s34)) +
     .   (2*s12**3 - 4*s12**2*s34 + 3*s12*s34**2 - s34**3)/
     .    (s13*s24*(s13 + s14 + s34)*(s23 + s24 + s34))

      at40a= wt/s1234

*      write(*,*)"at40a",at40a
      return
      end


      function a40c(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s1234=s12+s13+s14+s23+s24+s34
      s134=s13+s14+s34
      s234=s23+s24+s34

      wt =
     & s13**(-1)*s24**(-1)*s34**2*s134**(-1) + 2*s13**(-1)*s24*
     & s34**(-1) - 2*s13**(-1)*s24*s134**(-1) + s13**(-1)*s24*s34*
     & s134**(-2) + 3*s13**(-1)*s23*s24**(-1) - s13**(-1)*s23*s24**(-1)
     & *s34*s134**(-1) + 3*s13**(-1)*s23*s34**(-1) - 2*s13**(-1)*s23*
     & s134**(-1) + s13**(-1)*s23*s34*s134**(-2) + s13**(-1)*s23**2*
     & s24**(-1)*s34**(-1) + s13**(-1)*s23**2*s24**(-1)*s134**(-1) + 3*
     & s13**(-1)*s14*s24**(-1) + s24**(-1)*s34*s134**(-1) + 2*s34**(-2)
     & *s234 - s34**(-1) - s24*s34**(-1)*s134**(-1) + s24*s134**(-2) - 
     & s23*s24**(-1)*s134**(-1) - 3*s23*s34**(-1)*s134**(-1) - 9*s23*
     & s34**(-1)*s234**(-1) + s23*s134**(-2) - 4*s23*s24*s34**(-2)*
     & s234**(-1) + s23**2*s24**(-1)*s34**(-1)*s134**(-1) - s14*
     & s24**(-1)*s134**(-1) - 2*s14*s24*s34**(-1)*s134**(-2) + 2*s14*
     & s23*s24**(-1)*s34**(-1)*s134**(-1) - 2*s14*s23*s34**(-1)*
     & s134**(-2) + 2*s13*s34**(-1)*s134**(-1) + 2*s13*s24*s34**(-2)*
     & s134**(-1)
      wt = wt - 2*s13*s23*s34**(-2)*s134**(-1) + 4*s13*s23*
     & s34**(-1)*s134**(-1)*s234**(-1) - 2*s13*s14*s24*s34**(-2)*
     & s134**(-2) - 2*s13*s14*s23*s34**(-2)*s134**(-2) + 6*s12*
     & s13**(-1)*s24**(-1) - 3*s12*s13**(-1)*s24**(-1)*s34*s134**(-1)
     &  + 4*s12*s13**(-1)*s34**(-1) - 3*s12*s13**(-1)*s134**(-1) + s12*
     & s13**(-1)*s34*s134**(-2) + 2*s12*s13**(-1)*s23*s24**(-1)*
     & s34**(-1) + 3*s12*s13**(-1)*s23*s24**(-1)*s134**(-1) - 4*s12*
     & s24**(-1)*s134**(-1) - 6*s12*s34**(-1)*s134**(-1) + s12*
     & s134**(-2) + 2*s12*s23*s24**(-1)*s34**(-1)*s134**(-1) - 2*s12*
     & s14*s34**(-1)*s134**(-2) + 4*s12**2*s13**(-1)*s24**(-1)*
     & s134**(-1) - 1/(s234 + s134)*s13**(-1)*s24**(-1)*s34**3*
     & s134**(-1) - 1/(s234 + s134)*s13**(-1)*s34**2*s134**(-1) + 1/(
     & s234 + s134)*s13**(-1)*s23*s34*s134**(-1) - 1/(s234 + s134)*
     & s13**(-1)*s23**2*s134**(-1) - 1/(s234 + s134)*s24**(-1)*s34**2*
     & s134**(-1) - 11/(s234 + s134)*s34**(-1)*s234 - 2/(s234 + s134)*
     & s34*s134**(-1)
      wt = wt - 4/(s234 + s134)*s24**2*s34**(-2) + 19/(s234 + s134)
     & *s23*s34**(-1) - 1/(s234 + s134)*s23*s134**(-1) - 2/(s234 + s134
     & )*s23**2*s34**(-2) + 1/(s234 + s134)*s14*s24**(-1)*s34*
     & s134**(-1) - 3/(s234 + s134)*s14*s134**(-1) - 2/(s234 + s134)*
     & s14*s24*s34**(-1)*s134**(-1) - 2/(s234 + s134)*s14*s23*s34**(-1)
     & *s134**(-1) + 2/(s234 + s134)*s14*s23**2*s34**(-2)*s134**(-1) - 
     & 3/(s234 + s134)*s14**2*s34**(-1)*s134**(-1) - 2/(s234 + s134)*
     & s14**2*s24*s34**(-2)*s134**(-1) + 1/(s234 + s134)*s14**2*s23*
     & s24**(-1)*s34**(-1)*s134**(-1) + 2/(s234 + s134)*s14**2*s23*
     & s34**(-2)*s134**(-1) - 2/(s234 + s134)*s13*s134**(-1) - 2/(s234
     &  + s134)*s13*s24*s34**(-1)*s134**(-1) - 10/(s234 + s134)*s13*s23
     & *s34**(-1)*s134**(-1) + 2/(s234 + s134)*s13*s23**2*s34**(-2)*
     & s134**(-1) - 4/(s234 + s134)*s13*s14*s34**(-1)*s134**(-1) - 4/(
     & s234 + s134)*s13*s14*s24*s34**(-2)*s134**(-1) + 3/(s234 + s134)*
     & s12*s13**(-1)*s24**(-1)*s34**2*s134**(-1) + 3/(s234 + s134)*s12*
     & s13**(-1)*s34*s134**(-1)
      wt = wt - 3/(s234 + s134)*s12*s13**(-1)*s23*s134**(-1) + 3/(
     & s234 + s134)*s12*s24**(-1)*s34*s134**(-1) + 2/(s234 + s134)*s12*
     & s34**(-2)*s234 + 4/(s234 + s134)*s12*s134**(-1) - 2/(s234 + s134
     & )*s12*s24*s34**(-1)*s134**(-1) - 2/(s234 + s134)*s12*s23*
     & s34**(-2) - 2/(s234 + s134)*s12*s23*s34**(-1)*s134**(-1) - 6/(
     & s234 + s134)*s12*s23*s34**(-1)*s234**(-1) - 1/(s234 + s134)*s12*
     & s14*s24**(-1)*s134**(-1) - 2/(s234 + s134)*s12*s14*s24*s34**(-2)
     & *s134**(-1) + 2/(s234 + s134)*s12*s14*s23*s24**(-1)*s34**(-1)*
     & s134**(-1) + 2/(s234 + s134)*s12*s14*s23*s34**(-2)*s134**(-1) - 
     & 2/(s234 + s134)*s12*s13*s14*s34**(-1)*s134**(-2) - 2/(s234 + 
     & s134)*s12*s13*s14*s24*s34**(-2)*s134**(-2) - 2/(s234 + s134)*s12
     & *s13*s14*s23*s34**(-2)*s134**(-2) - 4/(s234 + s134)*s12**2*
     & s13**(-1)*s24**(-1)*s34*s134**(-1) - 4/(s234 + s134)*s12**2*
     & s13**(-1)*s134**(-1) - 2/(s234 + s134)*s12**2*s24**(-1)*
     & s134**(-1) - 6/(s234 + s134)*s12**2*s34**(-1)*s134**(-1) + 2/(
     & s234 + s134)*s12**2*s23*s24**(-1)*s34**(-1)*s134**(-1)
      wt = wt + 2/(s234 + s134)*s12**3*s13**(-1)*s24**(-1)*
     & s134**(-1) - 1/(s234 + s134)/(s234 + s13)*s13**(-1)*s24**(-1)*
     & s34**3 - 1/(s234 + s134)/(s234 + s13)*s13**(-1)*s34**2 + 1/(s234
     &  + s134)/(s234 + s13)*s13**(-1)*s23*s34 - 1/(s234 + s134)/(s234
     &  + s13)*s13**(-1)*s23**2 - 1/(s234 + s134)/(s234 + s13)*s14**2*
     & s24**(-1) + 3/(s234 + s134)/(s234 + s13)*s12*s13**(-1)*s24**(-1)
     & *s34**2 + 3/(s234 + s134)/(s234 + s13)*s12*s13**(-1)*s34 - 3/(
     & s234 + s134)/(s234 + s13)*s12*s13**(-1)*s23 - 4/(s234 + s134)/(
     & s234 + s13)*s12**2*s13**(-1)*s24**(-1)*s34 - 4/(s234 + s134)/(
     & s234 + s13)*s12**2*s13**(-1) + 2/(s234 + s134)/(s234 + s13)*
     & s12**2*s34**(-1) + 2/(s234 + s134)/(s234 + s13)*s12**3*s13**(-1)
     & *s24**(-1) - 2/(s234 + s134)/(s234**2 + 2*s13*s234 + s13**2)*
     & s14**2*s24**(-1)*s234 - 2/(s234 + s134)/(s234**2 + 2*s13*s234 + 
     & s13**2)*s14**3*s24**(-1) - 2/(s234 + s134)/(s234**2 + 2*s13*s234
     &  + s13**2)*s12*s14**2*s24**(-1) - 2/(s234 + s134)/(s234**3 + 3*
     & s13*s234**2 + 3*s13**2*s234 + s13**3)*s14**2*s24**(-1)*s234**2
      wt = wt - 4/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2
     & *s234 + s13**3)*s14**3*s24**(-1)*s234 - 2/(s234 + s134)/(s234**3
     &  + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s14**4*s24**(-1) - 4
     & /(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3
     & )*s12*s14**2*s24**(-1)*s234 - 4/(s234 + s134)/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s12*s14**3*s24**(-1) - 2/(s234
     &  + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*
     & s12**2*s14**2*s24**(-1) - 4/(s234 + s134)/(s23 + s13)/(s234 + 
     & s13)*s12**2*s24*s34**(-1) - 4/(s234 + s134)/(s23 + s13)/(s234 + 
     & s13)*s12**2*s23*s34**(-1) - 4/(s234 + s134)/(s23 + s13)/(s234 + 
     & s13)*s12**2*s14*s34**(-1) - 4/(s234 + s134)/(s23 + s13)/(s234 + 
     & s13)*s12**2*s13*s34**(-1) + 1/(s234 + s13)*s13**(-1)*s24**(-1)*
     & s34**2 + 1/(s234 + s13)*s13**(-1)*s34 - 1/(s234 + s13)*s13**(-1)
     & *s23 + 1/(s234 + s13)*s13**(-1)*s23**2*s34**(-1) - 1/(s234 + s13
     & )*s13**(-1)*s14*s24**(-1)*s34 - 1/(s234 + s13)*s13**(-1)*s14 + 2
     & /(s234 + s13)*s13**(-1)*s14*s23*s34**(-1)
      wt = wt + 2/(s234 + s13)*s13**(-1)*s14**2*s24**(-1) + 2/(s234
     &  + s13)*s13**(-1)*s14**2*s34**(-1) + 1/(s234 + s13)*s13**(-1)*
     & s14**2*s23*s24**(-1)*s34**(-1) + 3/(s234 + s13)*s34**(-1)*s134
     &  + 1/(s234 + s13)*s23**2*s34**(-1)*s234**(-1) + 1/(s234 + s13)*
     & s13*s34**(-1) - 2/(s234 + s13)*s13*s23*s34**(-1)*s234**(-1) - 3
     & /(s234 + s13)*s12*s13**(-1)*s24**(-1)*s34 - 4/(s234 + s13)*s12*
     & s13**(-1) + 2/(s234 + s13)*s12*s13**(-1)*s23*s34**(-1) + 5/(s234
     &  + s13)*s12*s13**(-1)*s14*s24**(-1) + 4/(s234 + s13)*s12*
     & s13**(-1)*s14*s34**(-1) + 2/(s234 + s13)*s12*s13**(-1)*s14*s23*
     & s24**(-1)*s34**(-1) + 2/(s234 + s13)*s12*s34**(-1) + 2/(s234 + 
     & s13)*s12*s13*s34**(-1)*s134**(-1) + 6/(s234 + s13)*s12**2*
     & s13**(-1)*s24**(-1) + 4/(s234 + s13)*s12**2*s13**(-1)*s34**(-1)
     &  + 2/(s234 + s13)*s12**2*s13**(-1)*s23*s24**(-1)*s34**(-1) - 2/(
     & s234**2 + 2*s134*s234 + s134**2)*s34**(-2)*s234**3 + 10/(s234**2
     &  + 2*s134*s234 + s134**2)*s34**(-1)*s234**2 + 4/(s234**2 + 2*
     & s134*s234 + s134**2)*s24**2*s34**(-2)*s234
      wt = wt + 4/(s234**2 + 2*s134*s234 + s134**2)*s23*s34**(-2)*
     & s234**2 - 12/(s234**2 + 2*s134*s234 + s134**2)*s23*s34**(-1)*
     & s234 - 2/(s234**2 + 2*s134*s234 + s134**2)*s23**2*s34**(-2)*s234
     &  + 2/(s234**2 + 2*s134*s234 + s134**2)*s23**2*s34**(-1) + 2/(
     & s234**2 + 2*s134*s234 + s134**2)*s14*s34*s134**(-1) + 4/(s234**2
     &  + 2*s134*s234 + s134**2)*s14*s24*s134**(-1) + 2/(s234**2 + 2*
     & s134*s234 + s134**2)*s14*s24**2*s34**(-1)*s134**(-1) + 2/(
     & s234**2 + 2*s134*s234 + s134**2)*s14**2*s134**(-1) + 4/(s234**2
     &  + 2*s134*s234 + s134**2)*s14**2*s24*s34**(-1)*s134**(-1) + 2/(
     & s234**2 + 2*s134*s234 + s134**2)*s14**2*s24**2*s34**(-2)*
     & s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s13*s34*
     & s134**(-1) + 4/(s234**2 + 2*s134*s234 + s134**2)*s13*s24*
     & s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s13*s24**2*
     & s34**(-1)*s134**(-1) + 4/(s234**2 + 2*s134*s234 + s134**2)*s13*
     & s14*s134**(-1) + 8/(s234**2 + 2*s134*s234 + s134**2)*s13*s14*s24
     & *s34**(-1)*s134**(-1)
      wt = wt + 4/(s234**2 + 2*s134*s234 + s134**2)*s13*s14*s24**2*
     & s34**(-2)*s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*
     & s13**2*s134**(-1) + 4/(s234**2 + 2*s134*s234 + s134**2)*s13**2*
     & s24*s34**(-1)*s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*
     & s13**2*s24**2*s34**(-2)*s134**(-1) - 6/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12*s34**(-1)*s234 + 2/(s234**2 + 2*s134*s234 + s134**2
     & )*s12*s34*s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s24*s34**(-2)*s234 + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s24
     & *s34**(-2)*s134 + 4/(s234**2 + 2*s134*s234 + s134**2)*s12*s24*
     & s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s24**2*
     & s34**(-1)*s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s23*s34**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s14*
     & s34**(-2)*s234 + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s14*
     & s134**(-1) + 4/(s234**2 + 2*s134*s234 + s134**2)*s12*s14*s24*
     & s34**(-1)*s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s14*s24**2*s34**(-2)*s134**(-1)
      wt = wt + 4/(s234**2 + 2*s134*s234 + s134**2)*s12*s14*s23**2*
     & s34**(-2)*s234**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s13*s134**(-1) + 4/(s234**2 + 2*s134*s234 + s134**2)*s12*s13*s24
     & *s34**(-1)*s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s13*s24**2*s34**(-2)*s134**(-1) + 8/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12*s13*s23*s34**(-1)*s134**(-1) - 4/(s234**2 + 2*s134*
     & s234 + s134**2)*s12*s13*s23*s24*s34**(-2)*s234**(-1) - 2/(
     & s234**2 + 2*s134*s234 + s134**2)*s12*s13*s14*s34**(-1)*
     & s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s13*s14*s24
     & *s34**(-2)*s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s13*s14*s23*s34**(-2)*s134**(-1) - 4/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12**2*s23*s34**(-1)*s234**(-1) + 4/(s234**2 + 2*s134*
     & s234 + s134**2)*s12**2*s13*s23*s34**(-1)*s134**(-1)*s234**(-1)
     &  - 2/(s234**2 + 2*s13*s234 + s13**2)*s12*s14*s24**(-1) - 2/(
     & s234**2 + 2*s13*s234 + s13**2)*s12**2*s24**(-1) + 2/(s234**3 + 3
     & *s13*s234**2 + 3*s13**2*s234 + s13**3)*s14**2*s24**(-1)*s234
      wt = wt + 2/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3
     & )*s14**2 + 2/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*
     & s14**3*s24**(-1) + 2/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + 
     & s13**3)*s12*s14*s24**(-1)*s234 + 2/(s234**3 + 3*s13*s234**2 + 3*
     & s13**2*s234 + s13**3)*s12*s14 + 4/(s234**3 + 3*s13*s234**2 + 3*
     & s13**2*s234 + s13**3)*s12*s14**2*s24**(-1) + 2/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s12**2*s14*s24**(-1) - 2/(s23
     &  + s13)/(s234 + s13)*s24*s34**(-1)*s134 - 2/(s23 + s13)/(s234 + 
     & s13)*s23*s34**(-1)*s134 - 2/(s23 + s13)/(s234 + s13)*s14*
     & s34**(-1)*s134 - 2/(s23 + s13)/(s234 + s13)*s13*s34**(-1)*s134
     &  - 4/(s23 + s13)/(s234 + s13)*s12*s24*s34**(-1) - 4/(s23 + s13)
     & /(s234 + s13)*s12*s23*s34**(-1) - 4/(s23 + s13)/(s234 + s13)*s12
     & *s14*s34**(-1) - 4/(s23 + s13)/(s234 + s13)*s12*s13*s34**(-1)

      a40c= wt/s1234

*      write(*,*)"a40c",a40c
      return
      end


      function a40d(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s1234=s12+s13+s14+s23+s24+s34
      s134=s13+s14+s34
      s234=s23+s24+s34

      wt =
     & s13**(-1)*s24**(-1)*s34**2*s234**(-1) - s13**(-1)*s24**(-1)*
     & s34**3*s134**(-1)*s234**(-1) + s13**(-1)*s34*s234**(-1) - 
     & s13**(-1)*s34**2*s134**(-1)*s234**(-1) - s13**(-1)*s23*
     & s234**(-1) + s13**(-1)*s23*s34*s134**(-1)*s234**(-1) + s13**(-1)
     & *s23**2*s34**(-1)*s234**(-1) - s13**(-1)*s23**2*s134**(-1)*
     & s234**(-1) - s13**(-1)*s14*s24**(-1)*s34*s234**(-1) - s13**(-1)*
     & s14*s234**(-1) + 2*s13**(-1)*s14*s23*s34**(-1)*s234**(-1) + 
     & s13**(-1)*s14**2*s24**(-1)*s34**(-1) + s13**(-1)*s14**2*
     & s24**(-1)*s234**(-1) + s13**(-1)*s14**2*s34**(-1)*s234**(-1) - 
     & s24**(-1)*s34**2*s134**(-1)*s234**(-1) - 2*s34**(-2)*s234 - 
     & s34**(-1) - 2*s34*s134**(-1)*s234**(-1) + 11*s23*s34**(-1)*
     & s234**(-1) - s23*s134**(-1)*s234**(-1) + 4*s23*s24*s34**(-2)*
     & s234**(-1) + 3*s14*s24**(-1)*s34**(-1) - 2*s14*s24**(-1)*
     & s234**(-1) + s14*s24**(-1)*s34*s134**(-1)*s234**(-1) + s14*
     & s24**(-1)*s34*s234**(-2)
      wt = wt - s14*s34**(-1)*s234**(-1) - s14*s134**(-1)*
     & s234**(-1) + s14*s234**(-2) - 2*s14*s23*s34**(-1)*s134**(-1)*
     & s234**(-1) - 2*s14*s23*s134**(-1)*s234**(-2) - 2*s14*s23*s24*
     & s34**(-1)*s134**(-1)*s234**(-2) + 2*s14*s23**2*s34**(-2)*
     & s134**(-1)*s234**(-1) + s14**2*s24**(-1)*s34**(-1)*s134**(-1) - 
     & s14**2*s24**(-1)*s134**(-1)*s234**(-1) - 2*s14**2*s34**(-1)*
     & s134**(-1)*s234**(-1) + 2*s14**2*s23*s34**(-2)*s134**(-1)*
     & s234**(-1) - 2*s14**2*s23*s34**(-1)*s134**(-1)*s234**(-2) - 2*
     & s14**2*s23*s24*s34**(-2)*s134**(-1)*s234**(-2) + 2*s13*s24**(-1)
     & *s34**(-1) - 2*s13*s24**(-1)*s234**(-1) + s13*s24**(-1)*s34*
     & s234**(-2) - 3*s13*s34**(-1)*s234**(-1) + s13*s234**(-2) - 6*s13
     & *s23*s34**(-1)*s134**(-1)*s234**(-1) - 2*s13*s23*s134**(-1)*
     & s234**(-2) - 2*s13*s23*s24*s34**(-1)*s134**(-1)*s234**(-2) + 2*
     & s13*s23**2*s34**(-2)*s134**(-1)*s234**(-1) - 4*s13*s14*s23*
     & s34**(-1)*s134**(-1)*s234**(-2) - 4*s13*s14*s23*s24*s34**(-2)*
     & s134**(-1)*s234**(-2)
      wt = wt + 2*s13**2*s34**(-2)*s134**(-1) - 2*s13**2*s23*
     & s34**(-2)*s134**(-1)*s234**(-1) - 2*s13**2*s23*s34**(-1)*
     & s134**(-1)*s234**(-2) - 2*s13**2*s23*s24*s34**(-2)*s134**(-1)*
     & s234**(-2) - 3*s12*s13**(-1)*s24**(-1)*s34*s234**(-1) + 3*s12*
     & s13**(-1)*s24**(-1)*s34**2*s134**(-1)*s234**(-1) - 4*s12*
     & s13**(-1)*s234**(-1) + 3*s12*s13**(-1)*s34*s134**(-1)*s234**(-1)
     &  + 2*s12*s13**(-1)*s23*s34**(-1)*s234**(-1) - 3*s12*s13**(-1)*
     & s23*s134**(-1)*s234**(-1) + 2*s12*s13**(-1)*s14*s24**(-1)*
     & s34**(-1) + 3*s12*s13**(-1)*s14*s24**(-1)*s234**(-1) + 2*s12*
     & s13**(-1)*s14*s34**(-1)*s234**(-1) + 4*s12*s24**(-1)*s34**(-1)
     &  - 3*s12*s24**(-1)*s234**(-1) + 3*s12*s24**(-1)*s34*s134**(-1)*
     & s234**(-1) + s12*s24**(-1)*s34*s234**(-2) - 8*s12*s34**(-1)*
     & s234**(-1) + 6*s12*s134**(-1)*s234**(-1) + s12*s234**(-2) - 2*
     & s12*s23*s34**(-1)*s134**(-1)*s234**(-1) - 2*s12*s23*s134**(-1)*
     & s234**(-2) - 2*s12*s23*s24*s34**(-1)*s134**(-1)*s234**(-2) + 2*
     & s12*s14*s24**(-1)*s34**(-1)*s134**(-1)
      wt = wt - 3*s12*s14*s24**(-1)*s134**(-1)*s234**(-1) + 2*s12*
     & s14*s23*s34**(-2)*s134**(-1)*s234**(-1) - 2*s12*s14*s23*
     & s34**(-1)*s134**(-1)*s234**(-2) - 2*s12*s14*s23*s24*s34**(-2)*
     & s134**(-1)*s234**(-2) + 2*s12*s13*s34**(-2)*s134**(-1) - 2*s12*
     & s13*s23*s34**(-2)*s134**(-1)*s234**(-1) - 2*s12*s13*s23*
     & s34**(-1)*s134**(-1)*s234**(-2) - 2*s12*s13*s23*s24*s34**(-2)*
     & s134**(-1)*s234**(-2) - 2*s12*s13*s14*s34**(-2)*s134**(-2) + 2*
     & s12**2*s13**(-1)*s24**(-1)*s34**(-1) + 4*s12**2*s13**(-1)*
     & s24**(-1)*s234**(-1) - 4*s12**2*s13**(-1)*s24**(-1)*s34*
     & s134**(-1)*s234**(-1) + 2*s12**2*s13**(-1)*s34**(-1)*s234**(-1)
     &  - 4*s12**2*s13**(-1)*s134**(-1)*s234**(-1) + 2*s12**2*s24**(-1)
     & *s34**(-1)*s134**(-1) - 4*s12**2*s24**(-1)*s134**(-1)*s234**(-1)
     &  - 8*s12**2*s34**(-1)*s134**(-1)*s234**(-1) + 2*s12**3*s13**(-1)
     & *s24**(-1)*s134**(-1)*s234**(-1) + 1/(s234 + s134)*s13**(-1)*
     & s24**(-1)*s34**3*s134**(-1) + 1/(s234 + s134)*s13**(-1)*s34**2*
     & s134**(-1)
      wt = wt - 1/(s234 + s134)*s13**(-1)*s23*s34*s134**(-1) + 1/(
     & s234 + s134)*s13**(-1)*s23**2*s134**(-1) + 1/(s234 + s134)*
     & s24**(-1)*s34**2*s134**(-1) + 11/(s234 + s134)*s34**(-1)*s234 + 
     & 2/(s234 + s134)*s34*s134**(-1) + 4/(s234 + s134)*s24**2*
     & s34**(-2) - 19/(s234 + s134)*s23*s34**(-1) + 1/(s234 + s134)*s23
     & *s134**(-1) + 2/(s234 + s134)*s23**2*s34**(-2) - 1/(s234 + s134)
     & *s14*s24**(-1)*s34*s134**(-1) + 3/(s234 + s134)*s14*s134**(-1)
     &  + 2/(s234 + s134)*s14*s24*s34**(-1)*s134**(-1) + 2/(s234 + s134
     & )*s14*s23*s34**(-1)*s134**(-1) - 2/(s234 + s134)*s14*s23**2*
     & s34**(-2)*s134**(-1) + 3/(s234 + s134)*s14**2*s34**(-1)*
     & s134**(-1) + 2/(s234 + s134)*s14**2*s24*s34**(-2)*s134**(-1) - 
     & 1/(s234 + s134)*s14**2*s23*s24**(-1)*s34**(-1)*s134**(-1) - 2/(
     & s234 + s134)*s14**2*s23*s34**(-2)*s134**(-1) + 2/(s234 + s134)*
     & s13*s134**(-1) + 2/(s234 + s134)*s13*s24*s34**(-1)*s134**(-1) + 
     & 10/(s234 + s134)*s13*s23*s34**(-1)*s134**(-1) - 2/(s234 + s134)*
     & s13*s23**2*s34**(-2)*s134**(-1)
      wt = wt + 4/(s234 + s134)*s13*s14*s34**(-1)*s134**(-1) + 4/(
     & s234 + s134)*s13*s14*s24*s34**(-2)*s134**(-1) - 3/(s234 + s134)*
     & s12*s13**(-1)*s24**(-1)*s34**2*s134**(-1) - 3/(s234 + s134)*s12*
     & s13**(-1)*s34*s134**(-1) + 3/(s234 + s134)*s12*s13**(-1)*s23*
     & s134**(-1) - 3/(s234 + s134)*s12*s24**(-1)*s34*s134**(-1) - 2/(
     & s234 + s134)*s12*s34**(-2)*s234 - 4/(s234 + s134)*s12*s134**(-1)
     &  + 2/(s234 + s134)*s12*s24*s34**(-1)*s134**(-1) + 2/(s234 + s134
     & )*s12*s23*s34**(-2) + 2/(s234 + s134)*s12*s23*s34**(-1)*
     & s134**(-1) + 6/(s234 + s134)*s12*s23*s34**(-1)*s234**(-1) + 1/(
     & s234 + s134)*s12*s14*s24**(-1)*s134**(-1) + 2/(s234 + s134)*s12*
     & s14*s24*s34**(-2)*s134**(-1) - 2/(s234 + s134)*s12*s14*s23*
     & s24**(-1)*s34**(-1)*s134**(-1) - 2/(s234 + s134)*s12*s14*s23*
     & s34**(-2)*s134**(-1) + 2/(s234 + s134)*s12*s13*s14*s34**(-1)*
     & s134**(-2) + 2/(s234 + s134)*s12*s13*s14*s24*s34**(-2)*
     & s134**(-2) + 2/(s234 + s134)*s12*s13*s14*s23*s34**(-2)*
     & s134**(-2)
      wt = wt + 4/(s234 + s134)*s12**2*s13**(-1)*s24**(-1)*s34*
     & s134**(-1) + 4/(s234 + s134)*s12**2*s13**(-1)*s134**(-1) + 2/(
     & s234 + s134)*s12**2*s24**(-1)*s134**(-1) + 6/(s234 + s134)*
     & s12**2*s34**(-1)*s134**(-1) - 2/(s234 + s134)*s12**2*s23*
     & s24**(-1)*s34**(-1)*s134**(-1) - 2/(s234 + s134)*s12**3*
     & s13**(-1)*s24**(-1)*s134**(-1) + 1/(s234 + s134)/(s234 + s13)*
     & s13**(-1)*s24**(-1)*s34**3 + 1/(s234 + s134)/(s234 + s13)*
     & s13**(-1)*s34**2 - 1/(s234 + s134)/(s234 + s13)*s13**(-1)*s23*
     & s34 + 1/(s234 + s134)/(s234 + s13)*s13**(-1)*s23**2 + 1/(s234 + 
     & s134)/(s234 + s13)*s14**2*s24**(-1) - 3/(s234 + s134)/(s234 + 
     & s13)*s12*s13**(-1)*s24**(-1)*s34**2 - 3/(s234 + s134)/(s234 + 
     & s13)*s12*s13**(-1)*s34 + 3/(s234 + s134)/(s234 + s13)*s12*
     & s13**(-1)*s23 + 4/(s234 + s134)/(s234 + s13)*s12**2*s13**(-1)*
     & s24**(-1)*s34 + 4/(s234 + s134)/(s234 + s13)*s12**2*s13**(-1) - 
     & 2/(s234 + s134)/(s234 + s13)*s12**2*s34**(-1) - 2/(s234 + s134)
     & /(s234 + s13)*s12**3*s13**(-1)*s24**(-1)
      wt = wt + 2/(s234 + s134)/(s234**2 + 2*s13*s234 + s13**2)*
     & s14**2*s24**(-1)*s234 + 2/(s234 + s134)/(s234**2 + 2*s13*s234 + 
     & s13**2)*s14**3*s24**(-1) + 2/(s234 + s134)/(s234**2 + 2*s13*s234
     &  + s13**2)*s12*s14**2*s24**(-1) + 2/(s234 + s134)/(s234**3 + 3*
     & s13*s234**2 + 3*s13**2*s234 + s13**3)*s14**2*s24**(-1)*s234**2
     &  + 4/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + 
     & s13**3)*s14**3*s24**(-1)*s234 + 2/(s234 + s134)/(s234**3 + 3*s13
     & *s234**2 + 3*s13**2*s234 + s13**3)*s14**4*s24**(-1) + 4/(s234 + 
     & s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s12*
     & s14**2*s24**(-1)*s234 + 4/(s234 + s134)/(s234**3 + 3*s13*s234**2
     &  + 3*s13**2*s234 + s13**3)*s12*s14**3*s24**(-1) + 2/(s234 + s134
     & )/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s12**2*
     & s14**2*s24**(-1) + 4/(s234 + s134)/(s23 + s13)/(s234 + s13)*
     & s12**2*s24*s34**(-1) + 4/(s234 + s134)/(s23 + s13)/(s234 + s13)*
     & s12**2*s23*s34**(-1) + 4/(s234 + s134)/(s23 + s13)/(s234 + s13)*
     & s12**2*s14*s34**(-1)
      wt = wt + 4/(s234 + s134)/(s23 + s13)/(s234 + s13)*s12**2*s13
     & *s34**(-1) - 1/(s234 + s13)*s13**(-1)*s24**(-1)*s34**2 - 1/(s234
     &  + s13)*s13**(-1)*s34 + 1/(s234 + s13)*s13**(-1)*s23 - 1/(s234
     &  + s13)*s13**(-1)*s23**2*s34**(-1) + 1/(s234 + s13)*s13**(-1)*
     & s14*s24**(-1)*s34 + 1/(s234 + s13)*s13**(-1)*s14 - 2/(s234 + s13
     & )*s13**(-1)*s14*s23*s34**(-1) - 2/(s234 + s13)*s13**(-1)*s14**2*
     & s24**(-1) - 2/(s234 + s13)*s13**(-1)*s14**2*s34**(-1) - 1/(s234
     &  + s13)*s13**(-1)*s14**2*s23*s24**(-1)*s34**(-1) - 3/(s234 + s13
     & )*s34**(-1)*s134 - 1/(s234 + s13)*s23**2*s34**(-1)*s234**(-1) - 
     & 1/(s234 + s13)*s13*s34**(-1) + 2/(s234 + s13)*s13*s23*s34**(-1)*
     & s234**(-1) + 3/(s234 + s13)*s12*s13**(-1)*s24**(-1)*s34 + 4/(
     & s234 + s13)*s12*s13**(-1) - 2/(s234 + s13)*s12*s13**(-1)*s23*
     & s34**(-1) - 5/(s234 + s13)*s12*s13**(-1)*s14*s24**(-1) - 4/(s234
     &  + s13)*s12*s13**(-1)*s14*s34**(-1) - 2/(s234 + s13)*s12*
     & s13**(-1)*s14*s23*s24**(-1)*s34**(-1) - 2/(s234 + s13)*s12*
     & s34**(-1)
      wt = wt - 2/(s234 + s13)*s12*s13*s34**(-1)*s134**(-1) - 6/(
     & s234 + s13)*s12**2*s13**(-1)*s24**(-1) - 4/(s234 + s13)*s12**2*
     & s13**(-1)*s34**(-1) - 2/(s234 + s13)*s12**2*s13**(-1)*s23*
     & s24**(-1)*s34**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*
     & s34**(-2)*s234**3 - 10/(s234**2 + 2*s134*s234 + s134**2)*
     & s34**(-1)*s234**2 - 4/(s234**2 + 2*s134*s234 + s134**2)*s24**2*
     & s34**(-2)*s234 - 4/(s234**2 + 2*s134*s234 + s134**2)*s23*
     & s34**(-2)*s234**2 + 12/(s234**2 + 2*s134*s234 + s134**2)*s23*
     & s34**(-1)*s234 + 2/(s234**2 + 2*s134*s234 + s134**2)*s23**2*
     & s34**(-2)*s234 - 2/(s234**2 + 2*s134*s234 + s134**2)*s23**2*
     & s34**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s14*s34*
     & s134**(-1) - 4/(s234**2 + 2*s134*s234 + s134**2)*s14*s24*
     & s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s14*s24**2*
     & s34**(-1)*s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*
     & s14**2*s134**(-1) - 4/(s234**2 + 2*s134*s234 + s134**2)*s14**2*
     & s24*s34**(-1)*s134**(-1)
      wt = wt - 2/(s234**2 + 2*s134*s234 + s134**2)*s14**2*s24**2*
     & s34**(-2)*s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s13*
     & s34*s134**(-1) - 4/(s234**2 + 2*s134*s234 + s134**2)*s13*s24*
     & s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s13*s24**2*
     & s34**(-1)*s134**(-1) - 4/(s234**2 + 2*s134*s234 + s134**2)*s13*
     & s14*s134**(-1) - 8/(s234**2 + 2*s134*s234 + s134**2)*s13*s14*s24
     & *s34**(-1)*s134**(-1) - 4/(s234**2 + 2*s134*s234 + s134**2)*s13*
     & s14*s24**2*s34**(-2)*s134**(-1) - 2/(s234**2 + 2*s134*s234 + 
     & s134**2)*s13**2*s134**(-1) - 4/(s234**2 + 2*s134*s234 + s134**2)
     & *s13**2*s24*s34**(-1)*s134**(-1) - 2/(s234**2 + 2*s134*s234 + 
     & s134**2)*s13**2*s24**2*s34**(-2)*s134**(-1) + 6/(s234**2 + 2*
     & s134*s234 + s134**2)*s12*s34**(-1)*s234 - 2/(s234**2 + 2*s134*
     & s234 + s134**2)*s12*s34*s134**(-1) + 2/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12*s24*s34**(-2)*s234 - 2/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12*s24*s34**(-2)*s134 - 4/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12*s24*s134**(-1)
      wt = wt - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s24**2*
     & s34**(-1)*s134**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s23*s34**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s14*
     & s34**(-2)*s234 - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s14*
     & s134**(-1) - 4/(s234**2 + 2*s134*s234 + s134**2)*s12*s14*s24*
     & s34**(-1)*s134**(-1) - 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s14*s24**2*s34**(-2)*s134**(-1) - 4/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12*s14*s23**2*s34**(-2)*s234**(-1) - 2/(s234**2 + 2*
     & s134*s234 + s134**2)*s12*s13*s134**(-1) - 4/(s234**2 + 2*s134*
     & s234 + s134**2)*s12*s13*s24*s34**(-1)*s134**(-1) - 2/(s234**2 + 
     & 2*s134*s234 + s134**2)*s12*s13*s24**2*s34**(-2)*s134**(-1) - 8/(
     & s234**2 + 2*s134*s234 + s134**2)*s12*s13*s23*s34**(-1)*
     & s134**(-1) + 4/(s234**2 + 2*s134*s234 + s134**2)*s12*s13*s23*s24
     & *s34**(-2)*s234**(-1) + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*
     & s13*s14*s34**(-1)*s134**(-1) + 2/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12*s13*s14*s24*s34**(-2)*s134**(-1)
      wt = wt + 2/(s234**2 + 2*s134*s234 + s134**2)*s12*s13*s14*s23
     & *s34**(-2)*s134**(-1) + 4/(s234**2 + 2*s134*s234 + s134**2)*
     & s12**2*s23*s34**(-1)*s234**(-1) - 4/(s234**2 + 2*s134*s234 + 
     & s134**2)*s12**2*s13*s23*s34**(-1)*s134**(-1)*s234**(-1) + 2/(
     & s234**2 + 2*s13*s234 + s13**2)*s12*s14*s24**(-1) + 2/(s234**2 + 
     & 2*s13*s234 + s13**2)*s12**2*s24**(-1) - 2/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s14**2*s24**(-1)*s234 - 2/(
     & s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s14**2 - 2/(
     & s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s14**3*
     & s24**(-1) - 2/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)
     & *s12*s14*s24**(-1)*s234 - 2/(s234**3 + 3*s13*s234**2 + 3*s13**2*
     & s234 + s13**3)*s12*s14 - 4/(s234**3 + 3*s13*s234**2 + 3*s13**2*
     & s234 + s13**3)*s12*s14**2*s24**(-1) - 2/(s234**3 + 3*s13*s234**2
     &  + 3*s13**2*s234 + s13**3)*s12**2*s14*s24**(-1) + 2/(s23 + s13)
     & /(s234 + s13)*s24*s34**(-1)*s134 + 2/(s23 + s13)/(s234 + s13)*
     & s23*s34**(-1)*s134
      wt = wt + 2/(s23 + s13)/(s234 + s13)*s14*s34**(-1)*s134 + 2/(
     & s23 + s13)/(s234 + s13)*s13*s34**(-1)*s134 + 4/(s23 + s13)/(s234
     &  + s13)*s12*s24*s34**(-1) + 4/(s23 + s13)/(s234 + s13)*s12*s23*
     & s34**(-1) + 4/(s23 + s13)/(s234 + s13)*s12*s14*s34**(-1) + 4/(
     & s23 + s13)/(s234 + s13)*s12*s13*s34**(-1)
     
      a40d= wt/s1234

*      write(*,*)"a40d",a40d
      return
      end

      
      function at40d(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s1234=s12+s13+s14+s23+s24+s34
      s134=s13+s14+s34
      s234=s23+s24+s34

      wt  =
     & s13**(-1)*s24**(-1)*s34 + s13**(-1)*s24**(-1)*s34**2*s134**(-1)
     &  - 2*s13**(-1) + 2*s13**(-1)*s34*s134**(-1) - s13**(-1)*s24*
     & s134**(-1) + s13**(-1)*s24*s34*s134**(-2) + 3*s13**(-1)*s23*
     & s24**(-1) - s13**(-1)*s23*s24**(-1)*s34*s134**(-1) - s13**(-1)*
     & s23*s134**(-1) + s13**(-1)*s23*s34*s134**(-2) + s13**(-1)*s23**2
     & *s24**(-1)*s134**(-1) + 2*s13**(-1)*s14*s24**(-1) + s134**(-1)
     &  + s24*s134**(-2) - 2*s23*s24**(-1)*s134**(-1) + s23*s134**(-2)
     &  - s13*s14**(-1)*s134**(-1) - s13*s14**(-1)*s24*s134**(-2) - s13
     & *s14**(-1)*s23*s134**(-2) + 2*s12*s13**(-1)*s14**(-1) + s12*
     & s13**(-1)*s14**(-1)*s23*s24**(-1) + 3*s12*s13**(-1)*s24**(-1) - 
     & 3*s12*s13**(-1)*s24**(-1)*s34*s134**(-1) + s12*s13**(-1)*s34*
     & s134**(-2) + 3*s12*s13**(-1)*s23*s24**(-1)*s134**(-1) + s12*
     & s14**(-1)*s24**(-1) + s12*s14**(-1)*s134**(-1) + s12*s14**(-1)*
     & s23*s24**(-1)*s134**(-1) + s12*s134**(-2) - s12*s13*s14**(-1)*
     & s24**(-1)*s134**(-1)
      wt = wt - s12*s13*s14**(-1)*s134**(-2) + 2*s12**2*s13**(-1)
     & *s14**(-1)*s24**(-1) + 4*s12**2*s13**(-1)*s24**(-1)*s134**(-1)
     &  + 2*s12**2*s14**(-1)*s24**(-1)*s134**(-1) - 1/(s234 + s134)*
     & s13**(-1)*s24**(-1)*s34**3*s134**(-1) - 2/(s234 + s134)*
     & s13**(-1)*s34**2*s134**(-1) - 1/(s234 + s134)*s13**(-1)*s24*s34*
     & s134**(-1) - 2/(s234 + s134)*s34*s134**(-1) - 1/(s234 + s134)*
     & s24*s134**(-1) + 1/(s234 + s134)*s23*s24**(-1)*s34*s134**(-1) - 
     & 1/(s234 + s134)*s14*s134**(-1) - 1/(s234 + s134)*s14*s23*
     & s24**(-1)*s134**(-1) + 1/(s234 + s134)*s13*s14**(-1)*s34*
     & s134**(-1) - 1/(s234 + s134)*s13*s14**(-1)*s24*s134**(-1) + 3/(
     & s234 + s134)*s12*s13**(-1)*s24**(-1)*s34**2*s134**(-1) + 3/(s234
     &  + s134)*s12*s13**(-1)*s34*s134**(-1) - 2/(s234 + s134)*s12*
     & s134**(-1) - 3/(s234 + s134)*s12*s23*s24**(-1)*s134**(-1) - 3/(
     & s234 + s134)*s12*s13*s14**(-1)*s134**(-1) - 4/(s234 + s134)*
     & s12**2*s13**(-1)*s24**(-1)*s34*s134**(-1) + 2/(s234 + s134)*
     & s12**3*s13**(-1)*s24**(-1)*s134**(-1)
      wt = wt + 2/(s234 + s134)*s12**3*s14**(-1)*s24**(-1)*
     & s134**(-1) - 1/(s234 + s134)/(s234 + s13)*s13**(-1)*s24**(-1)*
     & s34**3 - 2/(s234 + s134)/(s234 + s13)*s13**(-1)*s34**2 - 1/(s234
     &  + s134)/(s234 + s13)*s13**(-1)*s24*s34 - 1/(s234 + s134)/(s234
     &  + s13)*s24**(-1)*s34**2 - 3/(s234 + s134)/(s234 + s13)*s14*
     & s24**(-1)*s34 - 3/(s234 + s134)/(s234 + s13)*s14**2*s24**(-1) + 
     & 3/(s234 + s134)/(s234 + s13)*s12*s13**(-1)*s24**(-1)*s34**2 + 3
     & /(s234 + s134)/(s234 + s13)*s12*s13**(-1)*s34 - 4/(s234 + s134)
     & /(s234 + s13)*s12**2*s13**(-1)*s24**(-1)*s34 + 2/(s234 + s134)/(
     & s234 + s13)*s12**3*s13**(-1)*s24**(-1) - 3/(s234 + s134)/(
     & s234**2 + 2*s13*s234 + s13**2)*s34**2 - 3/(s234 + s134)/(s234**2
     &  + 2*s13*s234 + s13**2)*s14*s24**(-1)*s34**2 - 8/(s234 + s134)/(
     & s234**2 + 2*s13*s234 + s13**2)*s14*s34 - 8/(s234 + s134)/(
     & s234**2 + 2*s13*s234 + s13**2)*s14**2*s24**(-1)*s34 - 5/(s234 + 
     & s134)/(s234**2 + 2*s13*s234 + s13**2)*s14**2 - 5/(s234 + s134)/(
     & s234**2 + 2*s13*s234 + s13**2)*s14**3*s24**(-1)
      wt = wt - 3/(s234 + s134)/(s234**2 + 2*s13*s234 + s13**2)*
     & s12*s24**(-1)*s34**2 - 8/(s234 + s134)/(s234**2 + 2*s13*s234 + 
     & s13**2)*s12*s14*s24**(-1)*s34 - 5/(s234 + s134)/(s234**2 + 2*s13
     & *s234 + s13**2)*s12*s14**2*s24**(-1) - 2/(s234 + s134)/(s234**3
     &  + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s24*s34**2 - 4/(s234
     &  + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s14*
     & s34**2 - 4/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*
     & s234 + s13**3)*s14*s24*s34 - 2/(s234 + s134)/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s14**2*s24**(-1)*s34**2 - 8/(
     & s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*
     & s14**2*s34 - 2/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2
     & *s234 + s13**3)*s14**2*s24 - 4/(s234 + s134)/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s14**3*s24**(-1)*s34 - 4/(s234
     &  + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*
     & s14**3 - 2/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*
     & s234 + s13**3)*s14**4*s24**(-1)
      wt = wt - 4/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*
     & s13**2*s234 + s13**3)*s12*s34**2 - 4/(s234 + s134)/(s234**3 + 3*
     & s13*s234**2 + 3*s13**2*s234 + s13**3)*s12*s14*s24**(-1)*s34**2
     &  - 8/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + 
     & s13**3)*s12*s14*s34 - 8/(s234 + s134)/(s234**3 + 3*s13*s234**2
     &  + 3*s13**2*s234 + s13**3)*s12*s14**2*s24**(-1)*s34 - 4/(s234 + 
     & s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s12*
     & s14**2 - 4/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*
     & s234 + s13**3)*s12*s14**3*s24**(-1) - 2/(s234 + s134)/(s234**3
     &  + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s12**2*s24**(-1)*
     & s34**2 - 4/(s234 + s134)/(s234**3 + 3*s13*s234**2 + 3*s13**2*
     & s234 + s13**3)*s12**2*s14*s24**(-1)*s34 - 2/(s234 + s134)/(
     & s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s12**2*s14**2*
     & s24**(-1) + 1/(s234 + s134)/(s134 + s23)*s14**(-1)*s34**2 - 1/(
     & s234 + s134)/(s134 + s23)*s14**(-1)*s34**3*s134**(-1) + 3/(s234
     &  + s134)/(s134 + s23)*s14**(-1)*s24*s34
      wt = wt + 3/(s234 + s134)/(s134 + s23)*s14**(-1)*s24**2 - 2
     & /(s234 + s134)/(s134 + s23)*s34**2*s134**(-1) - 1/(s234 + s134)
     & /(s134 + s23)*s14*s34*s134**(-1) + 3/(s234 + s134)/(s134 + s23)*
     & s12*s14**(-1)*s34**2*s134**(-1) + 3/(s234 + s134)/(s134 + s23)*
     & s12*s34*s134**(-1) - 4/(s234 + s134)/(s134 + s23)*s12**2*
     & s14**(-1)*s34*s134**(-1) + 2/(s234 + s134)/(s134 + s23)*s12**3*
     & s14**(-1)*s134**(-1) + 3/(s234 + s134)/(s134**2 + 2*s23*s134 + 
     & s23**2)*s14**(-1)*s24*s34**2 + 8/(s234 + s134)/(s134**2 + 2*s23*
     & s134 + s23**2)*s14**(-1)*s24**2*s34 + 5/(s234 + s134)/(s134**2
     &  + 2*s23*s134 + s23**2)*s14**(-1)*s24**3 + 3/(s234 + s134)/(
     & s134**2 + 2*s23*s134 + s23**2)*s34**2 + 8/(s234 + s134)/(s134**2
     &  + 2*s23*s134 + s23**2)*s24*s34 + 5/(s234 + s134)/(s134**2 + 2*
     & s23*s134 + s23**2)*s24**2 + 3/(s234 + s134)/(s134**2 + 2*s23*
     & s134 + s23**2)*s12*s14**(-1)*s34**2 + 8/(s234 + s134)/(s134**2
     &  + 2*s23*s134 + s23**2)*s12*s14**(-1)*s24*s34 + 5/(s234 + s134)
     & /(s134**2 + 2*s23*s134 + s23**2)*s12*s14**(-1)*s24**2
      wt = wt + 2/(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3*
     & s23**2*s134 + s23**3)*s14**(-1)*s24**2*s34**2 + 4/(s234 + s134)
     & /(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*s14**(-1)*
     & s24**3*s34 + 2/(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3*s23**2
     & *s134 + s23**3)*s14**(-1)*s24**4 + 4/(s234 + s134)/(s134**3 + 3*
     & s23*s134**2 + 3*s23**2*s134 + s23**3)*s24*s34**2 + 8/(s234 + 
     & s134)/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*s24**2*
     & s34 + 4/(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134
     &  + s23**3)*s24**3 + 2/(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3
     & *s23**2*s134 + s23**3)*s14*s34**2 + 4/(s234 + s134)/(s134**3 + 3
     & *s23*s134**2 + 3*s23**2*s134 + s23**3)*s14*s24*s34 + 2/(s234 + 
     & s134)/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*s14*
     & s24**2 + 4/(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3*s23**2*
     & s134 + s23**3)*s12*s14**(-1)*s24*s34**2 + 8/(s234 + s134)/(
     & s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*s12*s14**(-1)*
     & s24**2*s34
      wt = wt + 4/(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3*
     & s23**2*s134 + s23**3)*s12*s14**(-1)*s24**3 + 4/(s234 + s134)/(
     & s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*s12*s34**2 + 8
     & /(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3
     & )*s12*s24*s34 + 4/(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3*
     & s23**2*s134 + s23**3)*s12*s24**2 + 2/(s234 + s134)/(s134**3 + 3*
     & s23*s134**2 + 3*s23**2*s134 + s23**3)*s12**2*s14**(-1)*s34**2 + 
     & 4/(s234 + s134)/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + 
     & s23**3)*s12**2*s14**(-1)*s24*s34 + 2/(s234 + s134)/(s134**3 + 3*
     & s23*s134**2 + 3*s23**2*s134 + s23**3)*s12**2*s14**(-1)*s24**2 + 
     & 2/(s234 + s134)/(s23 + s13)*s12**3*s13**(-1)*s134**(-1) + 2/(
     & s234 + s134)/(s23 + s13)/(s234 + s13)*s12**3*s13**(-1) + 2/(s234
     &  + s134)/(s23 + s13)/(s134 + s23)*s12**3*s134**(-1) + 1/(s234 + 
     & s13)*s13**(-1)*s34 + 1/(s234 + s13)*s13**(-1)*s24 - 1/(s234 + 
     & s13)*s13**(-1)*s23*s24**(-1)*s34 - 1/(s234 + s13)*s13**(-1)*s14
     &  + 1/(s234 + s13)*s13**(-1)*s14*s23*s24**(-1)
      wt = wt + 1/(s234 + s13)*s13**(-1)*s14**2*s24**(-1) + 1/(
     & s234 + s13)*s12*s13**(-1) + 3/(s234 + s13)*s12*s13**(-1)*s23*
     & s24**(-1) + 3/(s234 + s13)*s12*s13**(-1)*s14*s24**(-1) + 4/(s234
     &  + s13)*s12**2*s13**(-1)*s24**(-1) + 3/(s234**2 + 2*s13*s234 + 
     & s13**2)*s14*s24**(-1)*s34 + 6/(s234**2 + 2*s13*s234 + s13**2)*
     & s14 + 3/(s234**2 + 2*s13*s234 + s13**2)*s14*s23*s24**(-1) + 3/(
     & s234**2 + 2*s13*s234 + s13**2)*s14**2*s24**(-1) + 3/(s234**2 + 2
     & *s13*s234 + s13**2)*s12*s14*s24**(-1) + 4/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s14*s34 + 6/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s14*s24 + 4/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s14*s23 + 4/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s14**2*s24**(-1)*s34 + 8/(
     & s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s14**2 + 4/(
     & s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s14**2*s23*
     & s24**(-1) + 2/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)
     & *s14**3*s24**(-1)
      wt = wt + 4/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + 
     & s13**3)*s12*s14*s24**(-1)*s34 + 8/(s234**3 + 3*s13*s234**2 + 3*
     & s13**2*s234 + s13**3)*s12*s14 + 4/(s234**3 + 3*s13*s234**2 + 3*
     & s13**2*s234 + s13**3)*s12*s14*s23*s24**(-1) + 4/(s234**3 + 3*s13
     & *s234**2 + 3*s13**2*s234 + s13**3)*s12*s14**2*s24**(-1) + 2/(
     & s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s12**2*s14*
     & s24**(-1) + 1/(s134 + s23)*s14**(-1)*s24**2*s134**(-1) + 1/(s134
     &  + s23)*s34*s134**(-1) - 1/(s134 + s23)*s24*s134**(-1) + 1/(s134
     &  + s23)*s14*s134**(-1) - 1/(s134 + s23)*s13*s14**(-1)*s34*
     & s134**(-1) + 1/(s134 + s23)*s13*s14**(-1)*s24*s134**(-1) + 3/(
     & s134 + s23)*s12*s14**(-1)*s24*s134**(-1) + 1/(s134 + s23)*s12*
     & s134**(-1) + 3/(s134 + s23)*s12*s13*s14**(-1)*s134**(-1) + 4/(
     & s134 + s23)*s12**2*s14**(-1)*s134**(-1) - 3/(s134**2 + 2*s23*
     & s134 + s23**2)*s14**(-1)*s24*s34 - 3/(s134**2 + 2*s23*s134 + 
     & s23**2)*s14**(-1)*s24**2 - 6/(s134**2 + 2*s23*s134 + s23**2)*s24
     &  - 3/(s134**2 + 2*s23*s134 + s23**2)*s13*s14**(-1)*s24
      wt = wt - 3/(s134**2 + 2*s23*s134 + s23**2)*s12*s14**(-1)*
     & s24 - 4/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*
     & s14**(-1)*s24**2*s34 - 2/(s134**3 + 3*s23*s134**2 + 3*s23**2*
     & s134 + s23**3)*s14**(-1)*s24**3 - 4/(s134**3 + 3*s23*s134**2 + 3
     & *s23**2*s134 + s23**3)*s24*s34 - 8/(s134**3 + 3*s23*s134**2 + 3*
     & s23**2*s134 + s23**3)*s24**2 - 6/(s134**3 + 3*s23*s134**2 + 3*
     & s23**2*s134 + s23**3)*s14*s24 - 4/(s134**3 + 3*s23*s134**2 + 3*
     & s23**2*s134 + s23**3)*s13*s14**(-1)*s24**2 - 4/(s134**3 + 3*s23*
     & s134**2 + 3*s23**2*s134 + s23**3)*s13*s24 - 4/(s134**3 + 3*s23*
     & s134**2 + 3*s23**2*s134 + s23**3)*s12*s14**(-1)*s24*s34 - 4/(
     & s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*s12*s14**(-1)*
     & s24**2 - 8/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*
     & s12*s24 - 4/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*
     & s12*s13*s14**(-1)*s24 - 2/(s134**3 + 3*s23*s134**2 + 3*s23**2*
     & s134 + s23**3)*s12**2*s14**(-1)*s24 + 1/(s23 + s13)*s12*
     & s13**(-1)*s14**(-1)*s24
      wt = wt + 1/(s23 + s13)*s12*s13**(-1)*s34*s134**(-1) + 1/(
     & s23 + s13)*s12*s13**(-1)*s24*s134**(-1) + 1/(s23 + s13)*s12*
     & s13**(-1)*s14*s24**(-1) + 2/(s23 + s13)*s12**2*s13**(-1)*
     & s14**(-1) + 2/(s23 + s13)*s12**2*s13**(-1)*s24**(-1) + 2/(s23 + 
     & s13)*s12**2*s13**(-1)*s134**(-1) + 2/(s23 + s13)*s12**3*
     & s13**(-1)*s14**(-1)*s24**(-1) + 1/(s23 + s13)/(s234 + s13)*
     & s14**2*s24**(-1) + 1/(s23 + s13)/(s234 + s13)*s12*s13**(-1)*s34
     &  + 1/(s23 + s13)/(s234 + s13)*s12*s13**(-1)*s14 + 2/(s23 + s13)
     & /(s234 + s13)*s12**2*s13**(-1) - 2/(s23 + s13)/(s234**2 + 2*s13*
     & s234 + s13**2)*s14*s34 - 2/(s23 + s13)/(s234**2 + 2*s13*s234 + 
     & s13**2)*s14**2*s24**(-1)*s34 - 2/(s23 + s13)/(s234**2 + 2*s13*
     & s234 + s13**2)*s12*s14*s24**(-1)*s34 + 2/(s23 + s13)/(s234**3 + 
     & 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s24*s34**2 + 4/(s23 + 
     & s13)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*s14*
     & s34**2 + 2/(s23 + s13)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234
     &  + s13**3)*s14**2*s24**(-1)*s34**2
      wt = wt + 4/(s23 + s13)/(s234**3 + 3*s13*s234**2 + 3*s13**2
     & *s234 + s13**3)*s12*s34**2 + 4/(s23 + s13)/(s234**3 + 3*s13*
     & s234**2 + 3*s13**2*s234 + s13**3)*s12*s14*s24**(-1)*s34**2 + 2/(
     & s23 + s13)/(s234**3 + 3*s13*s234**2 + 3*s13**2*s234 + s13**3)*
     & s12**2*s24**(-1)*s34**2 - 1/(s23 + s13)/(s134 + s23)*s14**(-1)*
     & s24**2 + 1/(s23 + s13)/(s134 + s23)*s12*s34*s134**(-1) + 1/(s23
     &  + s13)/(s134 + s23)*s12*s24*s134**(-1) + 2/(s23 + s13)/(s134 + 
     & s23)*s12**2*s134**(-1) + 2/(s23 + s13)/(s134**2 + 2*s23*s134 + 
     & s23**2)*s14**(-1)*s24**2*s34 + 2/(s23 + s13)/(s134**2 + 2*s23*
     & s134 + s23**2)*s24*s34 + 2/(s23 + s13)/(s134**2 + 2*s23*s134 + 
     & s23**2)*s12*s14**(-1)*s24*s34 - 2/(s23 + s13)/(s134**3 + 3*s23*
     & s134**2 + 3*s23**2*s134 + s23**3)*s14**(-1)*s24**2*s34**2 - 4/(
     & s23 + s13)/(s134**3 + 3*s23*s134**2 + 3*s23**2*s134 + s23**3)*
     & s24*s34**2 - 2/(s23 + s13)/(s134**3 + 3*s23*s134**2 + 3*s23**2*
     & s134 + s23**3)*s14*s34**2 - 4/(s23 + s13)/(s134**3 + 3*s23*
     & s134**2 + 3*s23**2*s134 + s23**3)*s12*s14**(-1)*s24*s34**2
      wt = wt - 4/(s23 + s13)/(s134**3 + 3*s23*s134**2 + 3*s23**2
     & *s134 + s23**3)*s12*s34**2 - 2/(s23 + s13)/(s134**3 + 3*s23*
     &     s134**2 + 3*s23**2*s134 + s23**3)*s12**2*s14**(-1)*s34**2
      
      at40d= wt/s1234

*      write(*,*)"at40a",at40a
      return
      end



      function at40e(i1,i3,i4,i2,ipset)
      use KinData_mod
      implicit real*8 (a-h,o-y)
      real*8, pointer :: s12,s13,s14,s23,s24,s34

      s12 => kin(ipset)%s(i1,i2)
      s13 => kin(ipset)%s(i1,i3)
      s14 => kin(ipset)%s(i1,i4)
      s23 => kin(ipset)%s(i2,i3)
      s24 => kin(ipset)%s(i2,i4)
      s34 => kin(ipset)%s(i3,i4)

      s1234=s12+s13+s14+s23+s24+s34
      s134=s13+s14+s34
      s234=s23+s24+s34

      wt =
     & s13**(-1)*s24**(-1)*s34**2*s134**(-1) + s13**(-1)*s24**(-1)*
     & s34**2*s234**(-1) - s13**(-1)*s24**(-1)*s34**3*s134**(-1)*
     & s234**(-1) - 2*s13**(-1) + 2*s13**(-1)*s34*s134**(-1) + 2*
     & s13**(-1)*s34*s234**(-1) - 2*s13**(-1)*s34**2*s134**(-1)*
     & s234**(-1) - s13**(-1)*s24*s134**(-1) + s13**(-1)*s24*s234**(-1)
     &  + s13**(-1)*s24*s34*s134**(-2) - s13**(-1)*s24*s34*s134**(-1)*
     & s234**(-1) + 3*s13**(-1)*s23*s24**(-1) - s13**(-1)*s23*s24**(-1)
     & *s34*s134**(-1) - s13**(-1)*s23*s134**(-1) + s13**(-1)*s23*s34*
     & s134**(-2) + s13**(-1)*s23**2*s24**(-1)*s134**(-1) + 3*s13**(-1)
     & *s14*s24**(-1) - s13**(-1)*s14*s24**(-1)*s34*s234**(-1) - 2*
     & s13**(-1)*s14*s234**(-1) + s13**(-1)*s14**2*s24**(-1)*s234**(-1)
     &  - s24**(-1) + s24**(-1)*s34*s134**(-1) + s24**(-1)*s34*
     & s234**(-1) - s24**(-1)*s34**2*s134**(-1)*s234**(-1) + s134**(-1)
     &  + s234**(-1) - 2*s34*s134**(-1)*s234**(-1) + s24*s134**(-2) - 2
     & *s23*s24**(-1)*s134**(-1)
      wt = wt + s23*s134**(-2) - s14*s24**(-1)*s134**(-1) - s14*
     & s24**(-1)*s234**(-1) + s14*s24**(-1)*s34*s134**(-1)*s234**(-1)
     &  + s14*s24**(-1)*s34*s234**(-2) + s14*s234**(-2) - s13*s24**(-1)
     & *s234**(-1) + s13*s24**(-1)*s34*s234**(-2) + s13*s234**(-2) + 6*
     & s12*s13**(-1)*s24**(-1) - 3*s12*s13**(-1)*s24**(-1)*s34*
     & s134**(-1) - 3*s12*s13**(-1)*s24**(-1)*s34*s234**(-1) + 3*s12*
     & s13**(-1)*s24**(-1)*s34**2*s134**(-1)*s234**(-1) - 2*s12*
     & s13**(-1)*s234**(-1) + s12*s13**(-1)*s34*s134**(-2) + 3*s12*
     & s13**(-1)*s34*s134**(-1)*s234**(-1) + 3*s12*s13**(-1)*s23*
     & s24**(-1)*s134**(-1) + 3*s12*s13**(-1)*s14*s24**(-1)*s234**(-1)
     &  - 2*s12*s24**(-1)*s134**(-1) + 3*s12*s24**(-1)*s34*s134**(-1)*
     & s234**(-1) + s12*s24**(-1)*s34*s234**(-2) + s12*s134**(-2) + 2*
     & s12*s134**(-1)*s234**(-1) + s12*s234**(-2) + 4*s12**2*s13**(-1)*
     & s24**(-1)*s134**(-1) + 4*s12**2*s13**(-1)*s24**(-1)*s234**(-1)
     &  - 4*s12**2*s13**(-1)*s24**(-1)*s34*s134**(-1)*s234**(-1) + 2*
     & s12**3*s13**(-1)*s24**(-1)*s134**(-1)*s234**(-1)
      wt = wt + 2/(s24 + s23)*s12*s24**(-1) + 1/(s24 + s14)*s12*
     & s13**(-1)*s23*s24**(-1) + 1/(s24 + s14)*s12*s24**(-1)*s34*
     & s134**(-1) + 1/(s24 + s14)*s12*s24**(-1)*s34*s234**(-1) + 1/(s24
     &  + s14)*s12*s23*s24**(-1)*s134**(-1) + 1/(s24 + s14)*s12*s13*
     & s24**(-1)*s234**(-1) + 2/(s24 + s14)*s12**2*s13**(-1)*s24**(-1)
     &  + 2/(s24 + s14)*s12**2*s24**(-1)*s134**(-1) + 2/(s24 + s14)*
     & s12**2*s24**(-1)*s234**(-1) + 2/(s24 + s14)*s12**3*s24**(-1)*
     & s134**(-1)*s234**(-1) + 1/(s24 + s14)/(s24 + s23)*s12*s13*
     & s24**(-1) + 2/(s24 + s14)/(s24 + s23)*s12**2*s24**(-1) + 1/(s24
     &  + s14)/(s14 + s13)*s12*s13**(-1)*s23 + 2/(s24 + s14)/(s14 + s13
     & )*s12**2*s13**(-1) + 1/(s23 + s13)*s12*s13**(-1)*s34*s134**(-1)
     &  + 1/(s23 + s13)*s12*s13**(-1)*s34*s234**(-1) + 1/(s23 + s13)*
     & s12*s13**(-1)*s24*s134**(-1) + 1/(s23 + s13)*s12*s13**(-1)*s14*
     & s24**(-1) + 1/(s23 + s13)*s12*s13**(-1)*s14*s234**(-1) + 2/(s23
     &  + s13)*s12**2*s13**(-1)*s24**(-1) + 2/(s23 + s13)*s12**2*
     & s13**(-1)*s134**(-1)
      wt = wt + 2/(s23 + s13)*s12**2*s13**(-1)*s234**(-1) + 2/(
     & s23 + s13)*s12**3*s13**(-1)*s134**(-1)*s234**(-1) + 1/(s23 + s13
     & )/(s24 + s23)*s12*s14*s24**(-1) + 2/(s23 + s13)/(s24 + s23)*
     & s12**2*s24**(-1) + 2/(s23 + s13)/(s24 + s14)*s12**3*s13**(-1)*
     & s24**(-1) + 2/(s23 + s13)/(s24 + s14)/(s24 + s23)*s12**3*
     & s24**(-1) + 2/(s23 + s13)/(s24 + s14)/(s14 + s13)*s12**3*
     & s13**(-1) + 1/(s23 + s13)/(s14 + s13)*s12*s13**(-1)*s24 + 2/(s23
     &  + s13)/(s14 + s13)*s12**2*s13**(-1) + 2/(s14 + s13)*s12*
     & s13**(-1)
      
      at40e= wt/s1234

*      write(*,*)"at40a",at40a
      return
      end
