!************************************************************
!* A small subroutine for ensuring that the parton labellings
!* between the mappings is consistent
!*

      subroutine genjkset(i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,npar)
      use Process_mod, only : nPDFs_proc
      implicit double precision (a-h,o-z)
      common/jset/j1,j2,j3,j4,j5,j6,j7,j8,j9
!$omp threadprivate(/jset/)
      common/kset/k1,k2,k3,k4,k5,k6,k7,k8
!$omp threadprivate(/kset/)
      integer :: i

      !> DIS: the final-state lepton (next-to-last entry in momentum set)
      !>      is fixed to position 3

      ! print*, "------------------- genjkset -------------------"
      ! do i=1,npar
      !    select case (i)
      !    case(1)
      !      print*, "iset", i,">", i1
      !    case(2)
      !      print*, "iset", i,">", i2
      !    case(3)
      !      print*, "iset", i,">", i3
      !    case(4)
      !      print*, "iset", i,">", i4
      !    case(5)
      !      print*, "iset", i,">", i5
      !    case(6)
      !      print*, "iset", i,">", i6
      !    case(7)
      !      print*, "iset", i,">", i7
      !    case(8)
      !      print*, "iset", i,">", i8
      !    case(9)
      !      print*, "iset", i,">", i9
      !    case(10)
      !      print*, "iset", i,">", i10
      !    case default
      !      print*, "genjkset: outside iset", i
      !      stop
      !    end select
      ! end do

      if (nPDFs_proc.eq.1) then
            j8=0
            j9=0
            k7=0
            k8=0
               select case (npar)
               case(7)
                  j1=i1
                  j2=i2
                  j3=4
                  j4=5
                  j5=6
                  j6=3
                  j7=0

                  k1=i1
                  k2=i2
                  k3=4
                  k4=5
                  k5=3
                  k6=0
               case(6)
                  j1=i1
                  j2=i2
                  j3=4
                  j4=5
                  j5=3
                  j6=0
                  j7=0

                  k1=i1
                  k2=i2
                  k3=4
                  k4=3
                  k5=0
                  k6=0
               case(5)
                  j1=i1
                  j2=i2
                  j3=4
                  j4=3
                  j5=0
                  j6=0
                  j7=0

                  k1=i1
                  k2=i2
                  k3=3
                  k4=0
                  k5=0
                  k6=0
               case(4)
                  j1=i1
                  j2=i2
                  j3=3
                  j4=0
                  j5=0
                  j6=0
                  j7=0

                  k1=i1
                  k2=i2
                  k3=0
                  k4=0
                  k5=0
                  k6=0
               end select
      else
         j1=i1
         j2=i2
         j3=3
         j4=4
         j5=5
         j6=6
         j7=7
         j8=8
         j9=9

         k1=i1
         k2=i2
         k3=3
         k4=4
         k5=5
         k6=6
         k7=7
         k8=8

      end if
      return
      end
