************************************************************************
*
      function rJ22QQFIqgam_frag(ix,x1,x2,i1,i2,ipset,renscale2,facscale2,fragscale2)
      use KinData_mod, only : zfrag_kin
      implicit double precision (a-h,o-z)
      common /xregions/xreg1,xreg2,virtsflag
!$omp threadprivate(/xregions/)
      common /method/imethod


      if(imethod /= 2)then
        stop 'J22QQFIqgam_frag: only imethod=2!'
      endif

      if((i1.eq.1).or.(i2.eq.1))then
        rJ22QQFIqgam_frag=rJ22QQIFqgam_frag(ix,x1,x2,i2,i1,ipset,renscale2,facscale2,fragscale2)
        return
      endif

      x1h=xreg1
      x2h=xreg2
      omx1h=1d0-x1h
      omx2h=1d0-x2h
      zh=zfrag_kin
      cutdia = 1.0d-4

      if(abs(zh-x2h)<cutdia .and. abs(zh-omx2h)<cutdia)then
        step1 = (cutdia - abs(zh-x2h))/sqrt(2.d0)
        step2 = (cutdia - abs(zh-omx2h))/sqrt(2.d0)
        zeval = zh + sign(1d0,zh-x2h) * step1 + sign(1d0,zh-omx2h) * step2
        xeval = x2h - sign(1d0,zh-x2h) * step2 + sign(1d0,zh-omx2h) * step2
        rJ22QQFIqgam_frag = rJ22QQFIqgam_fragh(ix,x1h,xeval,zeval,i1,i2,ipset,renscale2,facscale2,fragscale2)
      else if(abs(zh-x2h)<cutdia) then
        step1 = (cutdia - abs(zh-x2h))/sqrt(2d0)
        step2 = (cutdia + abs(zh-x2h))/sqrt(2d0)
        zeval1 = zh + sign(1d0,zh-x2h) * step1
        xeval1 = x2h - sign(1d0,zh-x2h) * step1
        zeval2 = zh - sign(1d0,zh-x2h) * step2
        xeval2 = x2h + sign(1d0,zh-x2h) * step2
        res1 = rJ22QQFIqgam_fragh(ix,x1h,xeval1,zeval1,i1,i2,ipset,renscale2,facscale2,fragscale2)
        res2 = rJ22QQFIqgam_fragh(ix,x1h,xeval2,zeval2,i1,i2,ipset,renscale2,facscale2,fragscale2)
        rJ22QQFIqgam_frag = step2 * sqrt(2d0) / 2d0 / cutdia * res1 + step1 * sqrt(2d0) / 2d0 / cutdia * res2
      else if(abs(zh-omx2h)<cutdia) then
        step1 = (cutdia - abs(zh-omx2h))/sqrt(2d0)
        step2 = (cutdia + abs(zh-omx2h))/sqrt(2d0)
        zeval1 = zh + sign(1d0,zh-omx2h) * step1
        xeval1 = x2h + sign(1d0,zh-omx2h) * step1
        zeval2 = zh - sign(1d0,zh-omx2h) * step2
        xeval2 = x2h - sign(1d0,zh-omx2h) * step2
        res1 = rJ22QQFIqgam_fragh(ix,x1h,xeval1,zeval1,i1,i2,ipset,renscale2,facscale2,fragscale2)
        res2 = rJ22QQFIqgam_fragh(ix,x1h,xeval2,zeval2,i1,i2,ipset,renscale2,facscale2,fragscale2)
        rJ22QQFIqgam_frag = step2 * sqrt(2d0) / 2d0 / cutdia * res1 + step1 * sqrt(2d0) / 2d0 / cutdia *  res2
      else
        rJ22QQFIqgam_frag = rJ22QQFIqgam_fragh(ix,x1h,x2h,zh,i1,i2,ipset,renscale2,facscale2,fragscale2)
      end if

*      write(*,*)" rJ22QQFIqgam_frag ",rJ22QQFIqgam_frag

      return
      end
