      function D0g0DISG(iqb,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)

      if(nf1.ne.nf2)then
         write(*,*) "Falvours in D0g0DISG do not match", nf1,nf2
         stop
      endif

      D0g0DISG=abs(zewfac(1))**2*D0g0(iq,iQb2,iQ2,iqb)/2d0
      return
      end

      function BD0g0DISG(iqb,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)


      nf1=nflav
      nf2=nflav

      BD0g0DISG=D0g0DISG(iqb,iQ2,iQb2,iq)
      return
      end

      function D1g0DISG(iqb,ig,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      if(nf1.ne.nf2)then
         write(*,*) "Falvours in D1g0DISG do not match", nf1,nf2
         stop
      endif

      call eweakV1qq(nf1,0d0)

       D1g0DISG=-abs(zewfac(1))**2*(D1g0X(iq,iqb,iQ2,iQb2,ig)/2d0
     .     -D1g0gam(iq,iqb,iQ2,iQb2,ig)/2d0)
      return
      end


      function BD1g0DISG(iqb,ig,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      nf1=nflav
      nf2=nflav
      BD1g0DISG=D1g0DISG(iqb,ig,iQ2,iQb2,iq)

      return
      end



      function Dt1g0DISG(iqb,ig,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      if(nf1.ne.nf2)then
         write(*,*) "Falvours in Dt1g0DISG do not match", nf1,nf2
         stop
      endif

      call eweakV1qq(nf1,0d0)

      Dt1g0DISG=abs(zewfac(1))**2*(-D1g0gam(iq,iqb,iQ2,iQb2,ig)/2d0)
      return
      end

      function BDt1g0DISG(iqb,ig,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      nf1=nflav
      nf2=nflav
      BDt1g0DISG=Dt1g0DISG(iqb,ig,iQ2,iQb2,iq)

      return
      end


      function D0g1DISG(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)

      if(nf1.ne.nf2)then
         write(*,*) "Falvours in D0g1DISG do not match", nf1,nf2
         stop
      endif


       D0g1DISG=abs(zewfac(1))**2*D0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function BD0g1DISG(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      nf1=nflav
      nf2=nflav
      BD0g1DISG=D0g1DISG(iqb,iQ2,iQb2,iq,renscale2)

      return
      end


      function Dt0g1DISG(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      if(nf1.ne.nf2)then
         write(*,*) "Falvours in Dt0g1DISG do not match", nf1,nf2
         stop
      endif


       Dt0g1DISG=-abs(zewfac(1))**2*Dt0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function BDt0g1DISG(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      nf1=nflav
      nf2=nflav
      BDt0g1DISG=Dt0g1DISG(iqb,iQ2,iQb2,iq,renscale2)

      return
      end


!> C-types

      function f1C0g0(iqb,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)

      f1C0g0=abs(zewfac(1))**2*C0g0(iq,iQb2,iQ2,iqb)/2d0

      return
      end

      function f2C0g0(iqb,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)

      f2C0g0=abs(zewfac(1))**2*C0g0(iq,iQb2,iQ2,iqb)/2d0

      return
      end


      function avC0g0(iqb,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      double precision nf, nup, ndown
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV2qq(1,2,0d0)

      avC0g0=(ndown*abs(zewfac(1))**2+nup*abs(zewfac(2))**2)/nf*C0g0(iq,iQb2,iQ2,iqb)/2d0

      return
      end


      function f1C0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)
      f1C0g1=abs(zewfac(1))**2*C0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function f2C0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)
      f2C0g1=abs(zewfac(1))**2*C0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function avC0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      double precision nf, nup, ndown
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)

      call eweakV2qq(1,2,0d0)

      avC0g1=(ndown*abs(zewfac(1))**2+nup*abs(zewfac(2))**2)/nf*C0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function f1Ct0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)
      f1Ct0g1=-1d0*abs(zewfac(1))**2*Ct0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function f2Ct0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)
      f2Ct0g1=-1d0*abs(zewfac(1))**2*Ct0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function savCt0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      double precision nf, nup, ndown
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV2qq(1,2,0d0)

      savCt0g1=(ndown*abs(zewfac(1))**2+nup*abs(zewfac(2))**2)/nf*sCt0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end


      function sf1Ct0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)

      sf1Ct0g1=abs(zewfac(1))**2*sCt0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function sf2Ct0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)

      sf2Ct0g1=abs(zewfac(1))**2*sCt0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function sCt0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)

      sCt0g1=(Ct0g1(iq,iQb2,iQ2,iqb,renscale2)+Ct0g1(iq,iQ2,iQb2,iqb,renscale2))/2d0

      return
      end



      function f1Ch0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)
      f1Ch0g1=abs(zewfac(1))**2*Ch0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end

      function f2Ch0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)
      f2Ch0g1=abs(zewfac(1))**2*Ch0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end


      function avCh0g1(iqb,iQ2,iQb2,iq,renscale2)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      double precision nf, nup, ndown
      parameter(nf=5d0)
      parameter(nup=2d0)
      parameter(ndown=3d0)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)

      call eweakV2qq(1,2,0d0)

      avCh0g1=(ndown*abs(zewfac(1))**2+nup*abs(zewfac(2))**2)/nf*Ch0g1(iq,iQb2,iQ2,iqb,renscale2)/2d0

      return
      end


      function f1C1g0(iqb,ig,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)

      f1C1g0=abs(zewfac(1))**2*C1g0X(iq,iqb,iQ2,iQb2,ig)/2d0

      return
      end

      function f2C1g0(iqb,ig,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)

      f2C1g0=abs(zewfac(1))**2*C1g0X(iq,iqb,iQ2,iQb2,ig)/2d0

      return
      end


      function f1Ct1g0(iqb,ig,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)

      f1Ct1g0=-abs(zewfac(1))**2*C1g0Y(iq,iqb,iQ2,iQb2,ig)/2d0

      return
      end

      function f2Ct1g0(iqb,ig,iQ2,iQb2,iq)
      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)

      f2Ct1g0=-abs(zewfac(1))**2*C1g0Y(iq,iqb,iQ2,iQb2,ig)/2d0

      return
      end


      function B3g0DISG(iqb,ig3,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      B3g0DISG=abs(zewfac(1))**2*B3g0(iq,ig1,ig2,ig3,iqb)/2d0

      return
      end


      function Bt3g0DISG(iqb,ip,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      Bt3g0DISG=abs(zewfac(1))**2*Bt3g0(iq,ip,ig1,ig2,iqb)/2d0

      return
      end


      function Btt3g0DISG(iqb,ip,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      Btt3g0DISG=abs(zewfac(1))**2*Btt3g0(iq,ip,ig1,ig2,iqb)/2d0

      return
      end


      function B2g0DISG(iqb,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      B2g0DISG=abs(zewfac(1))**2*B2g0(iq,ig1,ig2,iqb)/2d0

      return
      end


      function A4g0DISG(ig1,ig2,ig3,ig4)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      A4g0DISG=abs(zewfac(1))**2*A4g0(ig1,ig2,ig3,ig4)

      return
      end


      function Bh2g1DISG(iqb,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      Bh2g1DISG=abs(zewfac(1))**2*Bh2g1(iq,ig1,ig2,iqb)/2d0

      return
      end

      function Bth2g1DISG(iqb,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)
      !> convention conversion jet <-> ZJ
      Bth2g1DISG=-abs(zewfac(1))**2*Bth2g1(iq,ig1,ig2,iqb)/2d0

      return
      end


      function f1B2g0DISG(iqb,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)

      f1B2g0DISG=abs(zewfac(1))**2*B2g0(iq,ig1,ig2,iqb)/2d0

      return
      end

      function f2B2g0DISG(iqb,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)

      f2B2g0DISG=abs(zewfac(1))**2*B2g0(iq,ig1,ig2,iqb)/2d0

      return
      end


      function Bt2g0DISG(iqb,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nflav
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nflav,0d0)

      Bt2g0DISG=abs(zewfac(1))**2*Bt2g0(iq,ig1,ig2,iqb)/2d0

      return
      end


      function f1Bt2g0DISG(iqb,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf1,0d0)

      f1Bt2g0DISG=abs(zewfac(1))**2*Bt2g0(iq,ig1,ig2,iqb)/2d0

      return
      end

      function f2Bt2g0DISG(iqb,ig2,ig1,iq)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)

      call eweakV1qq(nf2,0d0)

      f2Bt2g0DISG=abs(zewfac(1))**2*Bt2g0(iq,ig1,ig2,iqb)/2d0

      return
      end

      
      function B2g1DISG(iqb,ig2,ig1,iq,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nf1
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nf1,0d0)

      B2g1DISG=abs(zewfac(1))**2*B2g1(iq,ig1,ig2,iqb,renscale2)/2d0

      return
      end

      function Bt2g1DISG(iqb,ig2,ig1,iq,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nf1
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nf1,0d0)
      !> extra minus sign from ZJ -> dijet convention
      Bt2g1DISG=-abs(zewfac(1))**2*Bt2g1(iq,ig1,ig2,iqb,renscale2)/2d0

      return
      end

      function Bttt2g1DISG(iqb,ig1,ig2,iq,renscale2)
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nf1
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nf1,0d0)

      Bttt2g1DISG=abs(zewfac(1))**2*Btt2g1(iq,ig1,ig2,iqb,renscale2)/2d0


      return
      end


c trivial wrappers

!> LO
      function B1g0GDIS(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      B1g0GDIS=B1g0G(i1,i2,i3,i4,i5)
      return
      end

!> Wrappers for renamings of maple file header names
!> R
      function B2g0GDIS(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      B2g0GDIS=B2g0G(i1,i2,i3,i4,i5)
      return
      end

      function Bt2g0GDIS(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      Bt2g0GDIS=Bt2g0G(i1,i2,i3,i4,i5)
      return
      end

      function C0g0GDIS(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      C0g0GDIS=C0g0G(i1,i2,i3,i4,i5)
      return
      end

      function D0g0GDIS(i1,i2,i3,i4,i5)
      implicit double precision (a-h,o-y)
      D0g0GDIS=D0g0G(i1,i2,i3,i4,i5) 
      return
      end
!> V 

      function B1g1GDIS(i1,i2,i3,i4,renscale2)
      implicit double precision (a-h,o-y)
      B1g1GDIS = B1g1G(i1,i2,i3,i4,renscale2)
      return
      end

      function Bt1g1GDIS(i1,i2,i3,i4,renscale2)
      implicit double precision (a-h,o-y)
      Bt1g1GDIS = Bt1g1G(i1,i2,i3,i4,renscale2)
      return
      end

      function Bh1g1GDIS(i1,i2,i3,i4,renscale2)
      implicit double precision (a-h,o-y)
      Bh1g1GDIS = Bh1g1G(i1,i2,i3,i4,renscale2)
      return
      end


!> RR

      function B3g0GDIS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      B3g0GDIS=B3g0G(i1,i2,i3,i4,i5,i6)
      return
      end

      function Bt3g0GDIS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      Bt3g0GDIS=Bt3g0G(i1,i2,i3,i4,i5,i6)
      return
      end

      function Btt3g0GDIS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      Btt3g0GDIS=Btt3g0G(i1,i2,i3,i4,i5,i6)
      return
      end

      function C1g0GDIS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      C1g0GDIS=C1g0G(i1,i2,i3,i4,i5,i6)
      return
      end

      function sC1g0GDIS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      if(((i1.eq.1).or.(i5.eq.1)))then
         sC1g0GDIS = 0.5d0*(C1g0G(i1,i2,i3,i4,i5,i6)
     .        +C1g0G(i1,i2,i4,i3,i5,i6))
      else
         sC1g0GDIS = C1g0G(i1,i2,i3,i4,i5,i6)
      endif
      return
      end

      function sCt1g0GDIS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      if((i1.eq.1).or.(i5.eq.1))then
         sCt1g0GDIS = -0.5d0*(Ct1g0G(i1,i2,i3,i4,i5,i6)
     .        +Ct1g0G(i1,i2,i4,i3,i5,i6))
      else
         sCt1g0GDIS = -1d0*Ct1g0G(i1,i2,i3,i4,i5,i6)
      endif
      return
      end

      function D1g0GcDIS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      D1g0GcDIS=D1g0Gc(i1,i2,i3,i4,i5,i6)
      return
      end

      function Dt1g0GDIS(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      Dt1g0GDIS=Dt1g0G(i1,i2,i3,i4,i5,i6)
      return
      end


!> RV

      function B2g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      B2g1GDIS=B2g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

      function Bt2g1GDIS(i1,i2,i3,i4,i5,renscale2)
      parameter(nc=3d0)
      implicit double precision (a-h,o-y)
      Bt2g1GDIS=Bt2g1G(i1,i2,i3,i4,i5,renscale2)+Bt2g1G(i1,i3,i2,i4,i5,renscale2)
     .     +Btt2g1G(i1,i2,i3,i4,i5,renscale2)
      return
      end


      function Bttt2g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      Bttt2g1GDIS=Bttt2g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

      function Bh2g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      Bh2g1GDIS=Bh2g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

      function Bth2g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      Bth2g1GDIS=Bth2g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

      function sC0g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      sC0g1GDIS=0.5d0*(C0g1G(i1,i2,i3,i4,i5,renscale)
     .     +C0g1G(i1,i3,i2,i4,i5,renscale))
      return
      end

      function Ct0g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      Ct0g1GDIS=Ct0g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

      function sCt0g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      sCt0g1GDIS=0.5d0*(Ct0g1G(i1,i2,i3,i4,i5,renscale)
     .     +Ct0g1G(i1,i3,i2,i4,i5,renscale))
      return
      end


      function Ch0g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      Ch0g1GDIS=Ch0g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

      function D0g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      D0g1GDIS=D0g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

      function Dt0g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      Dt0g1GDIS=Dt0g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

      function Dh0g1GDIS(i1,i2,i3,i4,i5,renscale)
      implicit double precision (a-h,o-y)
      Dh0g1GDIS=Dh0g1G(i1,i2,i3,i4,i5,renscale)
      return
      end

!> VV

      function B1g2GDIS(i1,i2,i3,i4,rs2)
      implicit double precision (a-h,o-y)
      B1g2GDIS=B1g2G(i1,i2,i3,i4,rs2)
      return
      end

      function Bt1g2GDIS(i1,i2,i3,i4,rs2)
      implicit double precision (a-h,o-y)
      Bt1g2GDIS=Bt1g2G(i1,i2,i3,i4,rs2)
      return
      end

      function Btt1g2GDIS(i1,i2,i3,i4,rs2)
      implicit double precision (a-h,o-y)
      Btt1g2GDIS=Btt1g2G(i1,i2,i3,i4,rs2)
      return
      end

      function Bh1g2GDIS(i1,i2,i3,i4,rs2)
      implicit double precision (a-h,o-y)
      Bh1g2GDIS=Bh1g2G(i1,i2,i3,i4,rs2)
      return
      end

      function Bht1g2GDIS(i1,i2,i3,i4,rs2)
      implicit double precision (a-h,o-y)
      Bht1g2GDIS=Bht1g2G(i1,i2,i3,i4,rs2)
      return
      end

      function Bhh1g2GDIS(i1,i2,i3,i4,rs2)
      implicit double precision (a-h,o-y)
      Bhh1g2GDIS=Bhh1g2G(i1,i2,i3,i4,rs2)
      return
      end
