************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function ggB2g1U_frag(ix,x1,x2,i3,i1,i2,i4,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(84)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello ggB2g1U_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag_ho(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_B2g1(i3,i1,i2,i4,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQFIqgam_frag_ho(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_B2g1(i3,i2,i1,i4,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag_ho(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_B2g1(i3,i2,i1,i4,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQFIqgam_frag_ho(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_B2g1(i3,i1,i2,i4,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21GQIF_frag(ix,x1,x2,i1,i4,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21GGII_frag(ix,x1,x2,i1,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QGFIgq_frag(ix,x1,x2,i1,i4,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22QQIFqgam_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -4 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QGgtoqII_frag(ix,x1,x2,i1,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i2,i3,i4)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -4 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QGgtoqIF_frag(ix,x1,x2,i1,i4,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i1,i3,i2,i4)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21QGFI_frag(ix,x1,x2,i2,i4,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21GGII_frag(ix,x1,x2,i2,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21GQIFgq_frag(ix,x1,x2,i2,i4,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22QQFIqgam_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i1,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -4 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21GQgtoqII_frag(ix,x1,x2,i2,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i2,i1,i3,i4)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -4 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21GQgtoqFI_frag(ix,x1,x2,i2,i4,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i2,i3,i1,i4)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21GGII_frag(ix,x1,x2,i1,i3,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21GQIF_frag(ix,x1,x2,i1,i3,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21QGFIgq_frag(ix,x1,x2,i1,i3,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22QQIFqgam_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i2,i1,i4)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21GGII_frag(ix,x1,x2,i2,i3,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21QGFI_frag(ix,x1,x2,i2,i3,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21GQIFgq_frag(ix,x1,x2,i2,i3,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22QQFIqgam_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B2g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -8 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21hQGIFqqp_frag(ix,x1,x2,i1,i3,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(25)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22hQGIFqgam_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i3,i1,i2,i4)*(wtcalX30)
        enddo
        wt(26)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i4,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -8 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21hQGIFqqp_frag(ix,x1,x2,i1,i3,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i3,i4,i2,i1)*(wtcalX30)
        enddo
        wt(27)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i4,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22hQGIFqgam_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i3,i4,i2,i1)*(wtcalX30)
        enddo
        wt(28)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i4,i1,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -8 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21hGQFIqqp_frag(ix,x1,x2,i2,i3,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i3,i4,i1,i2)*(wtcalX30)
        enddo
        wt(29)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i3,i4,i1,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22hGQFIqgam_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i3,i4,i1,i2)*(wtcalX30)
        enddo
        wt(30)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i4,i2,i1,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -8 * Qf1 ** 2 )
     .  *rJ21QQFIqgamxJ21hGQFIqqp_frag(ix,x1,x2,i2,i4,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i4,i2,i1,i3)*(wtcalX30)
        enddo
        wt(31)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i4,i2,i1,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22hGQFIqgam_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i4,i2,i1,i3)*(wtcalX30)
        enddo
        wt(32)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i4,i1,i3,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -8 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21hQGIFqqp_frag(ix,x1,x2,i1,i4,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i4,i1,i3,i2)*(wtcalX30)
        enddo
        wt(33)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i4,i1,i3,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22hQGIFqgam_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i4,i1,i3,i2)*(wtcalX30)
        enddo
        wt(34)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i4,i2,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -8 * Qf1 ** 2 )
     .  *rJ21QQIFqgamxJ21hQGIFqqp_frag(ix,x1,x2,i1,i4,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i4,i2,i3,i1)*(wtcalX30)
        enddo
        wt(35)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i4,i2,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ22hQGIFqgam_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + A4g0(i4,i2,i3,i1)*(wtcalX30)
        enddo
        wt(36)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=B2g1(i3,i1,i2,i4,muR2_scl(i))*(+( -Qf1 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(37)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=B2g1(i3,i2,i1,i4,muR2_scl(i))*(+( -Qf1 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(38)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QGFIgq_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i1,i2,i4)*(wtcalX30)
        end do
        wt(39)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i1,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(40)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GQIF(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i1,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(41)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(42)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i1,i3,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(43)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GQIFgq_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i2,i1,i4)*(wtcalX30)
        end do
        wt(44)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i2,i1,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(45)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QGFI(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i2,i1,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(46)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i1,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i2,i1,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(47)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i3,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i2,i3,i1,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(48)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21hGGIFgq_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(49)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21hGGFFgq_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(50)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21hGGIFgq_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i3,i2,i4)*(wtcalX30)
        end do
        wt(51)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21hGGFIgq_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i3,i2,i4)*(wtcalX30)
        end do
        wt(52)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21hGGFFgq_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
        wt(53)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21hGGFIgq_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
        wt(54)=bino_Dfrag(ix, if1, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=B2g1(i3,i1,i2,i4,muR2_scl(i))*(+( -Qf1 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(55)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=B2g1(i3,i2,i1,i4,muR2_scl(i))*(+( -Qf1 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(56)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QGFI(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i1,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(57)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i1,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(58)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GQIFgq_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i1,i2,i4)*(wtcalX30)
        end do
        wt(59)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i1,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i1,i4,i2)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(60)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i4,i1,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i4,i1,i2)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(61)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GQIF(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i2,i1,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(62)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21GGII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i2,i1,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(63)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QGFIgq_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i2,i1,i4)*(wtcalX30)
        end do
        wt(64)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i2,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i2,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(65)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i4,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i4,i2,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(66)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21hGGIFgq_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
        wt(67)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i4,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21hGGFFgq_frag(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i4,i3)*(wtcalX30)
        end do
        wt(68)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i4,i2,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21hGGIFgq_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i4,i2,i3)*(wtcalX30)
        end do
        wt(69)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i4,i2,i3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21hGGFIgq_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i4,i2,i3)*(wtcalX30)
        end do
        wt(70)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -Qf1 ** 2 )
     .  *rJ21hGGFFgq_frag(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(71)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21hGGFIgq_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=A4g0(i1,i2,i3,i4)*(wtcalX30)
        end do
        wt(72)=bino_Dfrag(ix, if1, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFIgg_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i1,i2,i4)*(wtcalX30)
        end do
        wt(73)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i1,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQIFgg_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i1,i2,i4)*(wtcalX30)
        end do
        wt(74)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i2,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i1,i2,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(75)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i1,i3,i2,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i1,i3,i2,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(76)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i1,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i1,i4,i2)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(77)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i4,i1,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i4,i1,i2)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(78)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQIFgg_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i2,i1,i4)*(wtcalX30)
        end do
        wt(79)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i3,i2,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFIgg_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=B2g0(i3,i2,i1,i4)*(wtcalX30)
        end do
        wt(80)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i1,i3,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i2,i1,i3,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(81)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i3,i1,i4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i2,i3,i1,i4)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(82)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i2,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i2,i4,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(83)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i3,i4,i2,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGgtoqII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=B2g0(i3,i4,i2,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(84)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)


      ggB2g1U_frag = - sum(wt)  ! minus in bino(-...)


      return


      contains


      real(8) function poles_B2g1(j1,j2,j3,j4,muR2,ieps)
      integer :: j1, j2, j3, j4, ieps
      real(8) :: rln1, rln2, rln3, muR2
      real(8) :: ref
      integer :: ieorder, ieorder_sav
      common /order/ieorder
      rln1 = log(abs(s4(j1,j2))/muR2)
      rln2 = log(abs(s4(j2,j3))/muR2)
      rln3 = log(abs(s4(j3,j4))/muR2)
      select case (ieps)
      case(-2)
        poles_B2g1 = -3 * B2g0(j1, j2, j3, j4)
      case(-1)
        poles_B2g1 = 0.2D1 * (-0.31D2 / 0.12D2 + rln1 / 0.2D1 + rln2 / 0.2D1 + 
     #rln3 / 0.2D1) * B2g0(j1, j2, j3, j4)
      case(0)
        poles_B2g1 = B2g1(j1,j2,j3,j4,muR2)
      case default
        stop "poles_B2g1: unintended case"
      end select
C ATTENTION: this only works on a single thread!
#ifdef DEBUG_POLES
        ieorder_sav = ieorder 
        ieorder = ieps 
        ref = B2g1(j1,j2,j3,j4,muR2)
        ieorder = ieorder_sav 
        if ( abs(poles_B2g1)+abs(ref) > 0d0 ) then 
          if ( abs((poles_B2g1-ref)/(poles_B2g1+ref)) > 1d-6 ) then 
            print*, "B2g1 pole check failed", ieps
          end if
        end if
#endif
      end function poles_B2g1


      end function ggB2g1U_frag
