************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function ggB3g0T_frag(ix,x1,x2,i3,i1,i2,i4,i5,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(146)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello ggB3g0T_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i1,i2,i4,i5)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i1,i2,i4,i5)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*B2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*B2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=ggd30II(i3,i1,i2,5)*B2g0(j1,j2,j3,j4)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i1,i3,i5,5)*A4g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i1,i3,i5,5)*A4g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IF(i5,i4,i2,5)*B2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IF(i5,i4,i2,5)*B2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i4,i2,i1,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i4,i2,i1,i5)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i4,i2,i1,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i4,i2,i1,i5)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i3,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*B2g0(j4,j2,j1,j3)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i4,i5,5)*B2g0(j4,j2,j1,j3)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=ggd30II(i5,i1,i2,5)*B2g0(j3,j4,j2,j1)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i1,i3,i5,5)*A4g0(j3,j4,j2,j1)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i1,i3,i5,5)*A4g0(j3,j4,j2,j1)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IF(i3,i4,i2,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IF(i3,i4,i2,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i4,i1,i2,i5)*(wtcalX30)
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i4,i1,i2,i5)*(wtcalX30)
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i3,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(25)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i3,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(26)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*B2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(27)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*B2g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(28)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=ggd30II(i5,i2,i1,5)*B2g0(j3,j4,j1,j2)*(wtcalX30)
        enddo
        wt(29)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i2,i3,i5,5)*A4g0(j3,j4,j1,j2)*(wtcalX30)
        enddo
        wt(30)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i2,i3,i5,5)*A4g0(j3,j4,j1,j2)*(wtcalX30)
        enddo
        wt(31)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IF(i3,i4,i1,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(32)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IF(i3,i4,i1,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(33)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i2,i1,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i2,i1,i4,i5)*(wtcalX30)
        enddo
        wt(34)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i2,i1,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i2,i1,i4,i5)*(wtcalX30)
        enddo
        wt(35)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*B2g0(j4,j2,j1,j3)*(wtcalX30)
        enddo
        wt(36)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i5,5)*B2g0(j4,j2,j1,j3)*(wtcalX30)
        enddo
        wt(37)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i3,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(38)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i4,i3,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(39)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=ggd30II(i3,i2,i1,5)*B2g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(40)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i2,i3,i5,5)*A4g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(41)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i2,i3,i5,5)*A4g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(42)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i2,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IF(i5,i4,i1,5)*B2g0(j4,j2,j1,j3)*(wtcalX30)
        enddo
        wt(43)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IF(i5,i4,i1,5)*B2g0(j4,j2,j1,j3)*(wtcalX30)
        enddo
        wt(44)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i4,i2,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i1,i4,i2,i5)*(wtcalX30)
        enddo
        wt(45)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i4,i2,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i1,i4,i2,i5)*(wtcalX30)
        enddo
        wt(46)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullggF30II(i1,i4,i2,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(47)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullggF30II(i1,i4,i2,5)*B2g0(j3,j1,j2,j4)*(wtcalX30)
        enddo
        wt(48)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i3,i1,i4,5)*B2g0(j1,j3,j2,j4)*(wtcalX30)
        enddo
        wt(49)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i5,i2,i4,5)*B2g0(j4,j1,j3,j2)*(wtcalX30)
        enddo
        wt(50)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i1,i3,i5,5)*A4g0(j3,j1,j4,j2)*(wtcalX30)
        enddo
        wt(51)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j1,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i1,i3,i5,5)*A4g0(j3,j1,j4,j2)*(wtcalX30)
        enddo
        wt(52)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i2,i4,i1,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i2,i4,i1,i5)*(wtcalX30)
        enddo
        wt(53)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i2,i4,i1,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + B3g0(i3,i2,i4,i1,i5)*(wtcalX30)
        enddo
        wt(54)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullggF30II(i2,i4,i1,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(55)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullggF30II(i2,i4,i1,5)*B2g0(j3,j2,j1,j4)*(wtcalX30)
        enddo
        wt(56)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j3,j1,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i3,i2,i4,5)*B2g0(j2,j3,j1,j4)*(wtcalX30)
        enddo
        wt(57)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j2,j3,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=gd30IFGTOQ(i5,i1,i4,5)*B2g0(j4,j2,j3,j1)*(wtcalX30)
        enddo
        wt(58)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i1,i3,i5,5)*A4g0(j3,j2,j4,j1)*(wtcalX30)
        enddo
        wt(59)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i1,i3,i5,5)*A4g0(j3,j2,j4,j1)*(wtcalX30)
        enddo
        wt(60)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i1,i2,i4,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(61)=bino_Dfrag(ix, if1, i5, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i2,i1,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i4,i2,i1,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(62)=bino_Dfrag(ix, if1, i5, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i4,i1,i2,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(63)=bino_Dfrag(ix, if1, i5, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i2,i1,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i2,i1,i4,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(64)=bino_Dfrag(ix, if1, i5, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i4,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i1,i4,i2,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(65)=bino_Dfrag(ix, if1, i5, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i2,i4,i1,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i2,i4,i1,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(66)=bino_Dfrag(ix, if1, i5, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*gd30IF(i5,i4,i2,5)*B2g0(j4,j1,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(67)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullggF30II(i1,i4,i2,5)*B2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(68)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*gd30IF(i3,i4,i1,5)*B2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(69)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i1,i3,i5,5)*A4g0(j1,j2,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(70)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullG30FF(i4,i3,i5,5)*A4g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(71)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i1,i3,i5,5)*A4g0(j1,j4,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(72)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i2,i3,i5,5)*A4g0(j1,j4,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(73)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullG30FF(i4,i3,i5,5)*A4g0(j1,j2,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(74)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i2,i3,i5,5)*A4g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(75)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i5,i2,i1,5)*B2g0(j3,j1,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(76)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j1,j2 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i5,i2,i1,5)*B2g0(j3,j4,j1,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(77)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*gd30IF(i5,i4,i1,5)*B2g0(j4,j2,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(78)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullggF30II(i2,i4,i1,5)*B2g0(j3,j2,j1,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(79)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*gd30IF(i3,i4,i2,5)*B2g0(j3,j2,j1,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(80)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i2,i3,i5,5)*A4g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(81)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullG30FF(i4,i3,i5,5)*A4g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(82)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i2,i3,i5,5)*A4g0(j2,j4,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(83)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i1,i3,i5,5)*A4g0(j2,j4,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(84)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullG30FF(i4,i3,i5,5)*A4g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(85)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i1,i3,i5,5)*A4g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(86)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i5,i1,i2,5)*B2g0(j3,j2,j4,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(87)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i5,i1,i2,5)*B2g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(88)=bino_Dfrag(ix, if1, i5, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i1,i2,i4,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(89)=bino_Dfrag(ix, if1, i3, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i2,i1,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i4,i2,i1,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(90)=bino_Dfrag(ix, if1, i3, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i4,i1,i2,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(91)=bino_Dfrag(ix, if1, i3, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i2,i1,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i2,i1,i4,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(92)=bino_Dfrag(ix, if1, i3, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i4,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i1,i4,i2,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(93)=bino_Dfrag(ix, if1, i3, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i2,i4,i1,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i2,i4,i1,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(94)=bino_Dfrag(ix, if1, i3, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*gd30IF(i5,i4,i2,5)*B2g0(j4,j1,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(95)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullggF30II(i1,i4,i2,5)*B2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(96)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*gd30IF(i3,i4,i1,5)*B2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(97)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i1,i3,i5,5)*A4g0(j1,j2,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(98)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullG30FF(i4,i3,i5,5)*A4g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(99)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i1,i3,i5,5)*A4g0(j1,j4,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(100)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i2,i3,i5,5)*A4g0(j1,j4,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(101)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullG30FF(i4,i3,i5,5)*A4g0(j1,j2,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(102)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i2,i3,i5,5)*A4g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(103)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i3,i1,i2,5)*B2g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(104)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i3,i1,i2,5)*B2g0(j1,j3,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(105)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*gd30IF(i5,i4,i1,5)*B2g0(j4,j2,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(106)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullggF30II(i2,i4,i1,5)*B2g0(j3,j2,j1,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(107)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*gd30IF(i3,i4,i2,5)*B2g0(j3,j2,j1,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(108)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i2,i3,i5,5)*A4g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(109)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullG30FF(i4,i3,i5,5)*A4g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(110)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i2,i3,i5,5)*A4g0(j2,j4,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(111)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i1,i3,i5,5)*A4g0(j2,j4,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(112)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullG30FF(i4,i3,i5,5)*A4g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(113)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 / 0.2D1 ))*FullgG30IF(i1,i3,i5,5)*A4g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(114)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i3,i2,i1,5)*B2g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(115)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j3,j1,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*ggd30II(i3,i2,i1,5)*B2g0(j2,j3,j1,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(116)=bino_Dfrag(ix, if1, i3, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i1,i2,i4,i5)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(117)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i2,i1,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i4,i2,i1,i5)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(118)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i4,i1,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i4,i1,i2,i5)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(119)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i2,i1,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i2,i1,i4,i5)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(120)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i4,i2,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i1,i4,i2,i5)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(121)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i2,i4,i1,i5 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i3,i2,i4,i1,i5)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(122)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i5,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*gd30IF(i5,i4,i2,5)*B2g0(j4,j1,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(123)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*gd30IF(i3,i4,i1,5)*B2g0(j3,j1,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(124)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullgG30IF(i1,i3,i5,5)*A4g0(j1,j2,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(125)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullG30FF(i4,i3,i5,5)*A4g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(126)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullgG30IF(i1,i3,i5,5)*A4g0(j1,j4,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(127)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullgG30IF(i2,i3,i5,5)*A4g0(j1,j4,j2,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(128)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullG30FF(i4,i3,i5,5)*A4g0(j1,j2,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(129)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullgG30IF(i2,i3,i5,5)*A4g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(130)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j2,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i3,i1,i2,5)*B2g0(j1,j2,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(131)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j2,j4 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i3,i1,i2,5)*B2g0(j1,j3,j2,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(132)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j1,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i5,i2,i1,5)*B2g0(j3,j1,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(133)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j1,j2 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i5,i2,i1,5)*B2g0(j3,j4,j1,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(134)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i3 = j4, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i1,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i5,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j4,j2,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*gd30IF(i5,i4,i1,5)*B2g0(j4,j2,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(135)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j1,j4 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*gd30IF(i3,i4,i2,5)*B2g0(j3,j2,j1,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(136)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullgG30IF(i2,i3,i5,5)*A4g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(137)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullG30FF(i4,i3,i5,5)*A4g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(138)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i1 = j1, i4 = j4, [i2] = j2, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i2,i3,i5/), (/i1,i2,i5,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullgG30IF(i2,i3,i5,5)*A4g0(j2,j4,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(139)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullgG30IF(i1,i3,i5,5)*A4g0(j2,j4,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(140)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i3, i5] = j4, [i4, i3] = j3, [i5, i3] = j4}
      call set_map(5,4, (/i4,i3,i5/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullG30FF(i4,i3,i5,5)*A4g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(141)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+1d0/2d0)*FullgG30IF(i1,i3,i5,5)*A4g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(142)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i3,i2,i1,5)*B2g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(143)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j3,j1,j4 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i3,i2,i1,5)*B2g0(j2,j3,j1,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(144)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i5,i1,i2,5)*B2g0(j3,j2,j4,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(145)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*ggd30II(i5,i1,i2,5)*B2g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(146)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)


      ggB3g0T_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function ggB3g0T_frag
