************************************************************************
*
*  generated using makefortRR on 2025-02-16
*
      function qgCt1g0GS_frag(i1,i2,i3,i4,i5,i6)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      dimension wt(30)
      double precision partons(nMax_scl)
      double precision facnorm(nMax_scl)
      dimension jpass(30)
*      write(*,*)" hello qgCt1g0GS_frag"

      ix=1

      wt=0d0
      partons=0d0
      facnorm=0d0
      jpass=0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(1)=1
        call set_flav_perm(5, (/ j1,j3,j4,j2,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        wt(1)=+1d0*FullqgA30II(i1,i2,i5,6)*C0g0G(j1,j3,j4,j2,j5)
        wt(1)=bino(ix,partons,-wt(1)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(2)=1
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        wt(2)=+1d0*ga30IFGTOQ(i3,i2,i4,6)*C0g0G(j1,j2,j3,j4,j5)
        wt(2)=bino(ix,partons,-wt(2)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(3)=1
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        wt(3)=+1d0*ga30IFGTOQ(i4,i2,i3,6)*C0g0G(j1,j3,j2,j4,j5)
        wt(3)=bino(ix,partons,-wt(3)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i4] = j4, [i3, i5] = j3, [i4, i3] = j4, [i5, i3] = j3}
      call set_map(6,5, (/i5,i3,i4/), (/i1,i2,i5,i4,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(4)=1
        call set_flav_perm(5, (/ j1,j2,j4,j3,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(4)=-1d0*FullE30FF(i5,i3,i4,6)*f1Bt2g0G(j1,j2,j4,j3,j5)
        wt(4)=bino(ix,partons,-wt(4)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(5)=1
        call set_flav_perm(5, (/ j4,j2,j1,j3,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 5)
        if(ipass_block/=0) then
        wt(5)=+1d0*FullgqG30II(i2,i1,i5,6)*sf2Bt2g0G(j4,j2,j1,j3,j5)
        wt(5)=bino(ix,partons,-wt(5)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = k2, i6 = k4, [i1] = k1, [i3, i4, i5] = k3, [i3, i5, i4] = k3, [i4, i3, i5] = k3, [i4, i5, i3] = k3, [i5, i3, i4] = k3, [i5, i4, i3] = k3}
      call set_map(6,4, (/i1,i3,i4,i5/), (/i1,i2,i5,i6/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(6)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(6)=-1d0*FullB40(i1,i3,i4,i5,6)*f1B1g0G(k1,k2,k3,k4)
        wt(6)=bino(ix,partons,-wt(6)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i4] = j4, [i4, i3] = j4, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i5,i4,i3/), (/i1,i2,i5,i3,i6/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(7)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(7)=+1d0*FullE30FF(i5,i4,i3,6)*FullqA30IF(j1,j4,j3,5)*f1B1g0G(k1,k2,k3,k4)
        wt(7)=bino(ix,partons,-wt(7)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = k2, i6 = k4, [i1] = k1, [i3, i4, i5] = k3, [i3, i5, i4] = k3, [i4, i3, i5] = k3, [i4, i5, i3] = k3, [i5, i3, i4] = k3, [i5, i4, i3] = k3}
      call set_map(6,4, (/i1,i3,i4,i5/), (/i1,i2,i5,i6/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(8)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(8)=-1d0*FullB40(i3,i1,i5,i4,6)*sf2B1g0G(k3,k2,k1,k4)
        wt(8)=bino(ix,partons,-wt(8)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, i6 = j5, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(6,5, (/i1,i3,i5/), (/i1,i2,i5,i4,i6/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(9)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(9)=+1d0*FullqpE30IF(i3,i1,i5,6)*FullgA30IF(j3,j1,j4,5)*sf2B1g0G(k3,k2,k1,k4)
        wt(9)=bino(ix,partons,-wt(9)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = k1, i6 = k4, [i2] = k2, [i3, i4, i5] = k3, [i3, i5, i4] = k3, [i4, i3, i5] = k3, [i4, i5, i3] = k3, [i5, i3, i4] = k3, [i5, i4, i3] = k3}
      call set_map(6,4, (/i2,i3,i4,i5/), (/i1,i2,i5,i6/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(10)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(10)=-1d0*FullEt40(i5,i3,i2,i4,6)*f1B1g0G(k1,k2,k3,k4)
        wt(10)=bino(ix,partons,-wt(10)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(11)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(11)=+1d0*FullgA30IF(i3,i2,i4,6)*FullqpE30IF(j4,j2,j3,5)*f1B1g0G(k1,k2,k3,k4)
        wt(11)=bino(ix,partons,-wt(11)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(12)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(12)=+1d0*FullgqG30II(i2,i1,i5,6)*FullgA30IF(j3,j1,j4,5)*sf2B1g0G(k3,k2,k1,k4)
        wt(12)=bino(ix,partons,-wt(12)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, i6 = j5, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(6,5, (/i1,i3,i5/), (/i1,i2,i5,i4,i6/), ipass)
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(13)=1
        call set_flav_perm(4, (/ k3,k2,k1,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(13)=-1d0*FullqpE30IF(i3,i1,i5,6)*FullgA30IF(j3,j1,j4,5)*sf2B1g0G(k3,k2,k1,k4)
        wt(13)=bino(ix,partons,-wt(13)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
* IF: {j1 = k1, j5 = k4, [j2] = k2, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j2,j3,j4/), (/j1,j2,j4,j5/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(14)=1
        call set_flav_perm(4, (/ k2,k1,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 4)
        if(ipass_block/=0) then
        wt(14)=+1d0*FullgqG30II(i2,i1,i5,6)*FullgA30IF(j3,j2,j4,5)*sf2B1g0G(k2,k1,k3,k4)
        wt(14)=bino(ix,partons,-wt(14)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i4] = j4, [i3, i5] = j3, [i4, i3] = j4, [i5, i3] = j3}
      call set_map(6,5, (/i5,i3,i4/), (/i1,i2,i5,i4,i6/), ipass)
* II: {j4 = k3, j5 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j3,j2/), (/j1,j2,j4,j5/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(15)=1
        call set_flav_perm(4, (/ k1,k3,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        wt(15)=-1d0*FullE30FF(i5,i3,i4,6)*FullqgA30II(j1,j2,j3,5)*f1B1g0G(k1,k3,k2,k4)
        wt(15)=bino(ix,partons,-wt(15)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i4 = j5, [i1] = j1, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i1,i5,i6/), (/i1,i2,i6,i3,i4/), ipass, frag=(/i5,i6/))
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(16)=1
        call set_flav_perm(5, (/ j3,j1,j4,j5,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        wt(16)=+( Qf1 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i5,6)*C1g0Y(j3,j1,j4,j5,j2)
        wt(16)=bino(ix,partons,-wt(16)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i5 = j5, [i1] = j1, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i1,i4,i6/), (/i1,i2,i6,i3,i5/), ipass, frag=(/i4,i6/))
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(17)=1
        call set_flav_perm(5, (/ j5,j1,j4,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        wt(17)=+( Qf2 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i4,6)*C1g0Y(j5,j1,j4,j3,j2)
        wt(17)=bino(ix,partons,-wt(17)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, i5 = j5, [i1] = j1, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i1,i3,i6/), (/i1,i2,i6,i4,i5/), ipass, frag=(/i3,i6/))
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(18)=1
        call set_flav_perm(5, (/ j5,j1,j3,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 8)
        if(ipass_block/=0) then
        wt(18)=+( Qf2 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i3,6)*C1g0Y(j5,j1,j3,j4,j2)
        wt(18)=bino(ix,partons,-wt(18)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = k2, i5 = k4, [i1] = k1, [i3, i4, i6] = k3, [i3, i6, i4] = k3, [i4, i3, i6] = k3, [i4, i6, i3] = k3, [i6, i3, i4] = k3, [i6, i4, i3] = k3}
      call set_map(6,4, (/i1,i3,i4,i6/), (/i1,i2,i6,i5/), ipass, frag=(/i3,i4,i6/))
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(19)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        wt(19)=+( -Qf2 ** 2 / 0.2D1 )*FullEt40(i1,i3,i6,i4,6)*Bt2g0(k1,k2,k3,k4)
        wt(19)=bino(ix,partons,-wt(19)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i5 = j5, [i1] = j1, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i1,i4,i6/), (/i1,i2,i6,i3,i5/), ipass, frag=(/i4,i6/))
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass, frag=(/j4,j3/))
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(20)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        wt(20)=+( Qf2 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i4,6)*FullqpE30IF(j1,j4,j3,5)*Bt2g0(k1,k2,k3,k4)
        wt(20)=bino(ix,partons,-wt(20)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, i5 = j5, [i1] = j1, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i1,i3,i6/), (/i1,i2,i6,i4,i5/), ipass, frag=(/i3,i6/))
* IF: {j2 = k2, j5 = k4, [j1] = k1, [j3, j4] = k3, [j4, j3] = k3}
      call set_map(5,4, (/j1,j3,j4/), (/j1,j2,j4,j5/), ipass, frag=(/j4,j3/))
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(21)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        wt(21)=+( Qf2 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i3,6)*FullqpE30IF(j1,j3,j4,5)*Bt2g0(k1,k2,k3,k4)
        wt(21)=bino(ix,partons,-wt(21)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i5 = j5, [i1] = j1, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i1,i4,i6/), (/i1,i2,i6,i3,i5/), ipass, frag=(/i4,i6/))
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(22)=1
        call set_flav_perm(4, (/ k1,k3,k4,k2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 7)
        if(ipass_block/=0) then
        wt(22)=+( -Qf2 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i4,6)*FullqgA30II(j1,j2,j5,5)*C0g0(k1,k3,k4,k2)
        wt(22)=bino(ix,partons,-wt(22)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, i5 = j5, [i1] = j1, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i1,i3,i6/), (/i1,i2,i6,i4,i5/), ipass, frag=(/i3,i6/))
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(23)=1
        call set_flav_perm(4, (/ k1,k3,k4,k2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 7)
        if(ipass_block/=0) then
        wt(23)=+( -Qf2 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i3,6)*FullqgA30II(j1,j2,j5,5)*C0g0(k1,k3,k4,k2)
        wt(23)=bino(ix,partons,-wt(23)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i4 = j5, [i1] = j1, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i1,i5,i6/), (/i1,i2,i6,i3,i4/), ipass, frag=(/i5,i6/))
* IF: {j1 = k1, j3 = k4, [j2] = k2, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j2,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(24)=1
        call set_flav_perm(4, (/ k1,k2,k3,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 7)
        if(ipass_block/=0) then
        wt(24)=+( -Qf1 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i5,6)*ga30IFGTOQ(j4,j2,j5,5)*C0g0(k1,k2,k3,k4)
        wt(24)=bino(ix,partons,-wt(24)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i4 = j5, [i1] = j1, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i1,i5,i6/), (/i1,i2,i6,i3,i4/), ipass, frag=(/i5,i6/))
* IF: {j1 = k1, j3 = k4, [j2] = k2, [j4, j5] = k3, [j5, j4] = k3}
      call set_map(5,4, (/j2,j4,j5/), (/j1,j2,j5,j3/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(25)=1
        call set_flav_perm(4, (/ k1,k3,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 7)
        if(ipass_block/=0) then
        wt(25)=+( -Qf1 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i5,6)*ga30IFGTOQ(j5,j2,j4,5)*C0g0(k1,k3,k2,k4)
        wt(25)=bino(ix,partons,-wt(25)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i4] = j4, [i3, i5] = j3, [i4, i3] = j4, [i5, i3] = j3}
      call set_map(6,5, (/i5,i3,i4/), (/i1,i2,i5,i4,i6/), ipass)
* IF: {j2 = k2, j4 = k4, [j1] = k1, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j1,j3,j5/), (/j1,j2,j5,j4/), ipass, frag=(/j3,j5/))
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(26)=1
        call set_flav_perm(4, (/ k1,k2,k4,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        wt(26)=+( Qf1 ** 2 / 0.2D1 )*FullE30FF(i5,i3,i4,6)*FullqA30IF(j1,j5,j3,5)*Bt2g0(k1,k2,k4,k3)
        wt(26)=bino(ix,partons,-wt(26)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j2 = k2, j4 = k4, [j1] = k1, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j1,j3,j5/), (/j1,j2,j5,j4/), ipass, frag=(/j3,j5/))
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(27)=1
        call set_flav_perm(4, (/ k1,k3,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 7)
        if(ipass_block/=0) then
        wt(27)=+( -Qf2 ** 2 / 0.2D1 )*ga30IFGTOQ(i3,i2,i4,6)*FullqA30IF(j1,j5,j3,5)*C0g0(k1,k3,k2,k4)
        wt(27)=bino(ix,partons,-wt(27)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* IF: {j2 = k2, j4 = k4, [j1] = k1, [j3, j5] = k3, [j5, j3] = k3}
      call set_map(5,4, (/j1,j3,j5/), (/j1,j2,j5,j4/), ipass, frag=(/j3,j5/))
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(28)=1
        call set_flav_perm(4, (/ k1,k3,k2,k4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 7)
        if(ipass_block/=0) then
        wt(28)=+( -Qf2 ** 2 / 0.2D1 )*ga30IFGTOQ(i4,i2,i3,6)*FullqA30IF(j1,j5,j3,5)*C0g0(k1,k3,k2,k4)
        wt(28)=bino(ix,partons,-wt(28)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i4 = j4, i5 = j5, [i1] = j1, [i3, i6] = j3, [i6, i3] = j3}
      call set_map(6,5, (/i1,i3,i6/), (/i1,i2,i6,i4,i5/), ipass, frag=(/i3,i6/))
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(29)=1
        call set_flav_perm(4, (/ k4,k2,k1,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        wt(29)=+( -Qf2 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i3,6)*FullgqG30II(j2,j1,j5,5)*Bt2g0(k4,k2,k1,k3)
        wt(29)=bino(ix,partons,-wt(29)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i5 = j5, [i1] = j1, [i4, i6] = j3, [i6, i4] = j3}
      call set_map(6,5, (/i1,i4,i6/), (/i1,i2,i6,i3,i5/), ipass, frag=(/i4,i6/))
* II: {j3 = k3, j4 = k4, [j1] = k1, [j2] = k2}
      call set_map(5,4, (/j1,j5,j2/), (/j1,j2,j3,j4/), ipass)
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        jpass(30)=1
        call set_flav_perm(4, (/ k4,k2,k1,k3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 6)
        if(ipass_block/=0) then
        wt(30)=+( -Qf2 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i4,6)*FullgqG30II(j2,j1,j5,5)*Bt2g0(k4,k2,k1,k3)
        wt(30)=bino(ix,partons,-wt(30)*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgCt1g0GS_frag = - sum(wt)  ! minus in bino(-...)


      return
      end function qgCt1g0GS_frag
