************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qgD1g0comT_frag(ix,x1,x2,i1,i3,i4,i5,i2,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(24)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgD1g0comT_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i5,i1,i3,i4,i2)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i5,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i5,i1,i3,i4,i2)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i5,i1,i3,i4,i2)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i5,i1,i3,i4,i2)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + D1g0X(i5,i1,i3,i4,i2)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i4,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + D1g0gam(i5,i1,i3,i4,i2)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i3,5)*D0g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=0)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i4,5)*D0g0(j4,j1,j3,j2)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i3,5)*D0g0(j4,j1,j2,j3)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i5,5)*D0g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i5,5)*D0g0(j2,j1,j3,j4)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j1,j3,j2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i4,5)*D0g0(j4,j1,j3,j2)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        kinwt = 0d0
        kinwt(:)=D1g0X(i5,i1,i3,i4,i2)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(13)=bino_Dfrag(ix, if1, i1, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        kinwt = 0d0
        kinwt(:)=D1g0gam(i5,i1,i3,i4,i2)*(+( Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(14)=bino_Dfrag(ix, if1, i1, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullqgA30II(i3,i2,i1,5)*D0g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(15)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullqgA30II(i1,i2,i4,5)*D0g0(j3,j2,j4,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(16)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        kinwt = 0d0
        kinwt(:)=D1g0X(i5,i1,i3,i4,i2)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(17)=bino_Dfrag(ix, if1, i1, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        kinwt = 0d0
        kinwt(:)=D1g0gam(i5,i1,i3,i4,i2)*(+( Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(18)=bino_Dfrag(ix, if1, i1, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullqgA30II(i1,i2,i5,5)*D0g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(19)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i4,i2/), (/i1,i2,i3,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullqgA30II(i1,i2,i4,5)*D0g0(j3,j2,j4,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(20)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        kinwt = 0d0
        kinwt(:)=D1g0X(i5,i1,i3,i4,i2)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(21)=bino_Dfrag(ix, if1, i1, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i5,i1,i3,i4,i2 /))
        kinwt = 0d0
        kinwt(:)=D1g0gam(i5,i1,i3,i4,i2)*(+( Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(22)=bino_Dfrag(ix, if1, i1, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i4 = j3, i5 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i3,i2/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullqgA30II(i3,i2,i1,5)*D0g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(23)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j3,j4 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullqgA30II(i1,i2,i5,5)*D0g0(j2,j1,j3,j4)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(24)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)


      qgD1g0comT_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function qgD1g0comT_frag
