************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qqbB3g0XT_frag(ix,x1,x2,i1,i3,i4,i5,i2,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(13)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qqbB3g0XT_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i1,i3,i4,i5,i2)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(1)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*qd30IF(i1,i3,i4,5)*B2g0(j1,j3,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(2)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i4,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*f30FF(i3,i4,i5,5)*B2g0(j1,j3,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(3)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i4,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*qd30IF(i2,i5,i4,5)*B2g0(j1,j4,j3,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(4)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i1,i3,i4,i5,i2)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(5)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*qd30IF(i1,i3,i4,5)*B2g0(j1,j3,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(6)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*f30FF(i3,i4,i5,5)*B2g0(j1,j3,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(7)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i5,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*f30FF(i3,i4,i5,5)*B2g0(j1,j3,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(8)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i5,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*qd30IF(i2,i5,i4,5)*B2g0(j1,j4,j3,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(9)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i1,i3,i4,i5,i2 /))
        kinwt = 0d0
        kinwt(:)=B3g0(i1,i3,i4,i5,i2)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(10)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*qd30IF(i1,i3,i4,5)*B2g0(j1,j3,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(11)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(5,4, (/i3,i4,i5/), (/i1,i2,i3,i5/), ipass, frag=(/i4,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j3,j4,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*f30FF(i3,i4,i5,5)*B2g0(j1,j3,j4,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(12)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j1,j4,j3,j2 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*qd30IF(i2,i5,i4,5)*B2g0(j1,j4,j3,j2)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(13)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)


      qqbB3g0XT_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function qqbB3g0XT_frag
