************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qqbCt0g1U_frag(ix,x1,x2,i1,i3,i4,i2,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(42)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qqbCt0g1U_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgam_frag_ho(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_Ct0g1(i2,i4,i3,i1,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqgam_frag_ho(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_Ct0g1(i2,i4,i3,i1,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -4 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQIFqq_frag(ix,x1,x2,i1,i4,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -4 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQFI_frag(ix,x1,x2,i1,i4,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 4 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQFIqq_frag(ix,x1,x2,i1,i4,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 4 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQIF_frag(ix,x1,x2,i1,i4,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQII_frag(ix,x1,x2,i1,i4,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQFFqbq_frag(ix,x1,x2,i1,i4,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ22QQIFqgam_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQII_frag(ix,x1,x2,i1,i3,i1,i2,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQFFqbq_frag(ix,x1,x2,i1,i3,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -4 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQIF_frag(ix,x1,x2,i1,i3,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -4 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQFIqq_frag(ix,x1,x2,i1,i3,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 4 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQIFqq_frag(ix,x1,x2,i1,i3,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 4 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21QQFI_frag(ix,x1,x2,i1,i3,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ22QQIFqgam_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C0g0(i2,i3,i4,i1)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i3,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 8 * Qf2 ** 2 )
     .  *rJ21QQIFqgamxJ21hQGIFqqp_frag(ix,x1,x2,i1,i4,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0(i1,i3,i4,i2)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i1,i3,i4,i2 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ22hQGIFqgam_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0(i1,i3,i4,i2)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Ct0g1(i2,i4,i3,i1,muR2_scl(i))*(+( -Qf2 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(19)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ21QQFIqq_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(20)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ21QQIF(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(21)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQFI(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(22)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIFqq_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(23)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf2 ** 2 )
     .  *rJ21QQII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(24)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf2 ** 2 )
     .  *rJ21QQFFqbq_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(25)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf2 ** 2 )
     .  *rJ21hQGIFqqp_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i2,i3,i4,i1)*(wtcalX30)
        end do
        wt(26)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf2 ** 2 )
     .  *rJ21hGQFIqqp_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(27)=bino_Dfrag(ix, if2, i3, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Ct0g1(i2,i4,i3,i1,muR2_scl(i))*(+( -Qf2 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(28)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ21QQFI(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(29)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( 2 * Qf2 ** 2 )
     .  *rJ21QQIFqq_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(30)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQFIqq_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(31)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQIF(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(32)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf2 ** 2 )
     .  *rJ21QQII(ix,x1,x2,i1,i2,4,muR2_scl(i),muF2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)
        wt(33)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf2 ** 2 )
     .  *rJ21QQFFqbq_frag(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(34)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf2 ** 2 )
     .  *rJ21hQGIFqqp_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(35)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( Qf2 ** 2 )
     .  *rJ21hGQFIqqp_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=Bt2g0(i2,i3,i4,i1)*(wtcalX30)
        end do
        wt(36)=bino_Dfrag(ix, if2, i4, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +2d0
     .  *rJ21QQFIqg_frag(ix,x1,x2,i2,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(37)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +2d0
     .  *rJ21QQIFqg_frag(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(38)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQFIqg_frag(ix,x1,x2,i2,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(39)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQIFqg_frag(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(40)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQFFqg_frag(ix,x1,x2,i3,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(41)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) ) then
        call set_flav_perm(4, (/ i2,i4,i3,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQFFqg_frag(ix,x1,x2,i4,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=C0g0(i2,i4,i3,i1)*(wtcalX30)
        end do
        wt(42)=bino_Dfrag(ix, 0, 0, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)


      qqbCt0g1U_frag = - sum(wt)  ! minus in bino(-...)


      return


      contains


      real(8) function poles_Ct0g1(j1,j2,j3,j4,muR2,ieps)
      integer :: j1, j2, j3, j4, ieps
      real(8) :: rln1, rln2, rln3, rln4, rln5, rln6, muR2
      real(8) :: ref
      integer :: ieorder, ieorder_sav
      common /order/ieorder
      rln1 = log(abs(s4(j1,j2))/muR2)
      rln2 = log(abs(s4(j1,j3))/muR2)
      rln3 = log(abs(s4(j1,j4))/muR2)
      rln4 = log(abs(s4(j2,j3))/muR2)
      rln5 = log(abs(s4(j2,j4))/muR2)
      rln6 = log(abs(s4(j3,j4))/muR2)
      select case (ieps)
      case(-2)
        poles_Ct0g1 = 2 * C0g0(j1, j2, j3, j4)
      case(-1)
        poles_Ct0g1 = -0.2D1 * (-0.3D1 / 0.2D1 + rln1 + rln6 + rln3 / 0.2D1 + rl
     #n4 / 0.2D1 - rln2 - rln5) * C0g0(j1, j2, j3, j4)
      case(0)
        poles_Ct0g1 = Ct0g1(j1,j2,j3,j4,muR2)
      case default
        stop "poles_Ct0g1: unintended case"
      end select
C ATTENTION: this only works on a single thread!
#ifdef DEBUG_POLES
        ieorder_sav = ieorder 
        ieorder = ieps 
        ref = Ct0g1(j1,j2,j3,j4,muR2)
        ieorder = ieorder_sav 
        if ( abs(poles_Ct0g1)+abs(ref) > 0d0 ) then 
          if ( abs((poles_Ct0g1-ref)/(poles_Ct0g1+ref)) > 1d-6 ) then 
            print*, "Ct0g1 pole check failed", ieps
          end if
        end if
#endif
      end function poles_Ct0g1


      end function qqbCt0g1U_frag
