************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qqbDh0g1U_frag(ix,x1,x2,i1,i2,i3,i4,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(4)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qqbDh0g1U_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag_ho(ix,x1,x2,i1,i3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_Dh0g1(i2,i3,i4,i1,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        do ie=-2,ieorder
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag_ho(ix,x1,x2,i1,i4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i),ieorder-ie)
        kinwt(i) = kinwt(i) + poles_Dh0g1(i2,i3,i4,i1,muR2_scl(i),ie)*(wtcalX30)
        enddo
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Dh0g1(i2,i3,i4,i1,muR2_scl(i))*(+( -Qf1 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(3)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(4,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ i2,i3,i4,i1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, -1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
          kinwt(i)=Dh0g1(i2,i3,i4,i1,muR2_scl(i))*(+( -Qf1 ** 2 ))
        end do
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(4)=bino_Dfrag(ix, if1, i1, 4, -kinwt, -1)
        end if
        call unset_flav_perm()
      end if
      call unset_frag(4)


      qqbDh0g1U_frag = - sum(wt)  ! minus in bino(-...)


      return


      contains


      real(8) function poles_Dh0g1(j1,j2,j3,j4,muR2,ieps)
      integer :: j1, j2, j3, j4, ieps
      real(8) :: muR2
      real(8) :: ref
      integer :: ieorder, ieorder_sav
      common /order/ieorder
      select case (ieps)
      case(-2)
        poles_Dh0g1 = 0
      case(-1)
        poles_Dh0g1 = 0
      case(0)
        poles_Dh0g1 = Dh0g1(j1,j2,j3,j4,muR2)
      case default
        stop "poles_Dh0g1: unintended case"
      end select
C ATTENTION: this only works on a single thread!
#ifdef DEBUG_POLES
        ieorder_sav = ieorder 
        ieorder = ieps 
        ref = Dh0g1(j1,j2,j3,j4,muR2)
        ieorder = ieorder_sav 
        if ( abs(poles_Dh0g1)+abs(ref) > 0d0 ) then 
          if ( abs((poles_Dh0g1-ref)/(poles_Dh0g1+ref)) > 1d-6 ) then 
            print*, "Dh0g1 pole check failed", ieps
          end if
        end if
#endif
      end function poles_Dh0g1


      end function qqbDh0g1U_frag
