************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qqpbC1g0XT_frag(ix,x1,x2,i1,i3,i4,i2,i5,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use PhotonFragmentation_mod
      use KinData_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(31)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qqpbC1g0XT_frag"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf1 ** 2 )
     .  *rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C1g0X(i3,i1,i2,i4,i5)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* BLOCK 1
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +( -2 * Qf2 ** 2 )
     .  *rJ21QQFIqgam_frag(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i) = kinwt(i) + C1g0X(i3,i1,i2,i4,i5)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,i1,i3,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i3,5)*C0g0(j3,j4,j2,j1)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i5,i4/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j3,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf2 ** 2 )*rJ21QQFIqgam_frag(ix,x1,x2,i2,i4,5,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i5,i4,5)*C0g0(j4,j3,j2,j1)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqqA30II(i1,i5,i2,5)*C0g0(j3,j4,j2,j1)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* FF: {i1 = j1, i2 = j2, [i3, i5] = j4, [i4, i5] = j3, [i5, i3] = j4, [i5, i4] = j3}
      call set_map(5,4, (/i4,i5,i3/), (/i1,i2,i4,i3/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j3,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullA30FF(i4,i5,i3,5)*C0g0(j4,j3,j2,j1)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i2 = j2, i4 = j4, [i1] = j1, [i3, i5] = j3, [i5, i3] = j3}
      call set_map(5,4, (/i1,i3,i5/), (/i1,i2,i5,i4/), ipass, frag=(/i5,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i1,i5,i3,5)*C0g0(j3,j4,j2,j1)*(wtcalX30)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf2 ** 2 )*rJ21QQFIqgam_frag(ix,x1,x2,j2,j4,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqqA30II(i1,i5,i2,5)*C0g0(j3,j4,j2,j1)*(wtcalX30)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* FF: {i1 = j1, i2 = j2, [i3, i5] = j4, [i4, i5] = j3, [i5, i3] = j4, [i5, i4] = j3}
      call set_map(5,4, (/i4,i5,i3/), (/i1,i2,i4,i3/), ipass, frag=(/i5,i4/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j3,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( 2 * Qf2 ** 2 )*rJ21QQFIqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullA30FF(i4,i5,i3,5)*C0g0(j4,j3,j2,j1)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* IF: {i1 = j1, i3 = j4, [i2] = j2, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(5,4, (/i2,i4,i5/), (/i1,i2,i5,i3/), ipass, frag=(/i5,i4/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j4,j3,j2,j1 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf2 ** 2 )*rJ21QQFIqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqA30IF(i2,i5,i4,5)*C0g0(j4,j3,j2,j1)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j2,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i3,i4,i2,5)*B2g0(j1,j2,j4,j3)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=0)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j1,j4,j2,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf1 ** 2 )*rJ21QQIFqgam_frag(ix,x1,x2,j1,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i3,i4,i2,5)*B2g0(j1,j4,j2,j3)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf2 ** 2 )*rJ21QQFIqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i4,i3,i1,5)*B2g0(j2,j1,j4,j3)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=0)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* BLOCK 7
      call ecuts_vj(0,4,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        call getqcdnorm(ix,partons,facnorm, 4, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+( -2 * Qf2 ** 2 )*rJ21QQFIqgam_frag(ix,x1,x2,j2,j3,4,muR2_scl(i),muF2_scl(i),muA2_scl(i))
        kinwt(i)=FullqpE30IF(i4,i3,i1,5)*B2g0(j2,j4,j1,j3)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=C1g0X(i3,i1,i2,i4,i5)*(+( -Qf1 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(15)=bino_Dfrag(ix, if1, i1, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass, frag=(/i5,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullA30FF(i3,i5,i4,5)*C0g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(16)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf1 ** 2 ))*FullqqA30II(i2,i5,i1,5)*C0g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(17)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*FullqpE30IF(i3,i4,i2,5)*B2g0(j3,j2,j4,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(18)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i3,ipass,nDfrag=1)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i4,i3/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf1 ** 2 ))*FullqpE30IF(i3,i4,i2,5)*B2g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(19)=bino_Dfrag(ix, if1, i1, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=C1g0X(i3,i1,i2,i4,i5)*(+( -Qf2 ** 2 ))
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(20)=bino_Dfrag(ix, if2, i2, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass, frag=(/i5,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf2 ** 2 ))*FullA30FF(i3,i5,i4,5)*C0g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(21)=bino_Dfrag(ix, if2, i2, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* II: {i3 = j3, i4 = j4, [i1] = j1, [i2] = j2}
      call set_map(5,4, (/i1,i5,i2/), (/i1,i2,i3,i4/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(+( Qf2 ** 2 ))*FullqqA30II(i2,i5,i1,5)*C0g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(22)=bino_Dfrag(ix, if2, i2, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf2 ** 2 ))*FullqpE30IF(i4,i3,i1,5)*B2g0(j2,j4,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(23)=bino_Dfrag(ix, if2, i2, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i4,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass, frag=(/i3,i4/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(+( -Qf2 ** 2 ))*FullqpE30IF(i4,i3,i1,5)*B2g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(24)=bino_Dfrag(ix, if2, i2, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* DFRAG BLOCK 1
      call ecuts_vj(0,5,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(5, (/ i3,i1,i2,i4,i5 /))
        kinwt = 0d0
        kinwt(:)=C1g0X(i3,i1,i2,i4,i5)*(-1d0)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(25)=bino_Dfrag(ix, 0, 0, 5, -kinwt, 3)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass, frag=(/i4,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*FullA30FF(i3,i5,i4,5)*C0g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(26)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* FF: {i1 = j1, i2 = j2, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(5,4, (/i3,i5,i4/), (/i1,i2,i3,i4/), ipass, frag=(/i3,i5/))
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(+1d0)*FullA30FF(i3,i5,i4,5)*C0g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(27)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 2)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j2,j4,j1 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*FullqpE30IF(i3,i4,i2,5)*B2g0(j3,j2,j4,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(28)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i1 = j1, i5 = j4, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i2,i3,i4/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j3,j4,j2,j1 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*FullqpE30IF(i3,i4,i2,5)*B2g0(j3,j4,j2,j1)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(29)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j4,j1,j3 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*FullqpE30IF(i4,i3,i1,5)*B2g0(j2,j4,j1,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(30)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)
*
*
      ipass=1
      ipass_block=1
      call unset_map()
      call set_frag(5,i5,ipass,nDfrag=1)
* IF: {i2 = j2, i5 = j4, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(5,4, (/i1,i3,i4/), (/i1,i2,i4,i5/), ipass)
* DFRAG BLOCK 2
      call ecuts_vj(0,4,ipass)
      if ( (ipass==1) .and. (iz_frag==1) .and. (ix==1) ) then
        call set_flav_perm(4, (/ j2,j1,j4,j3 /))
        kinwt = 0d0
        kinwt(:)=(-1d0)*FullqpE30IF(i4,i3,i1,5)*B2g0(j2,j1,j4,j3)
C---    Jacobian factor(s)
        kinwt = kinwt/(1d0-zfrag_kin)/(1d0-z1)/(1d0-z2)
        wt(31)=bino_Dfrag(ix, 0, 0, 4, -kinwt, 1)
        call unset_flav_perm()
      end if
      call unset_frag(5)


      qqpbC1g0XT_frag = - sum(wt)  ! minus in bino(-...)


      return


      end function qqpbC1g0XT_frag
