      function FullB0g0GG(iqb,iq,i3,i4)
      use KinData_mod
      use Constants_mod
      use GGconst
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
      common /strong/ as
!$omp threadprivate(/strong/)

      write(*,*) "Hello FullB0g0GG"
      
      ave = 1d0/(2d0*nc)**2
      FullB0g0GG = ave*(4d0*pi*amz)**2*nc*8d0/2d0*B0g0GG(iqb,iq,i3,i4)
      
      write(*,*) pi, amz, nc, B0g0GG(iqb,iq,i3,i4)
      
      return
      end

      function FullB1g0GG(iqb,ig,iq,i3,i4)
      use KinData_mod
      use Constants_mod
      use GGconst
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
      common /strong/ as
!$omp threadprivate(/strong/)
      
      
      g2qcd = 4d0*pi*as
      
!       write(*,*) pi, g2qcd, as
      
!      write(*,*) iqb, ig, iq, i3, i4
      
      if(iqb.le.2.and.iq.le.2) then
         ave = 1d0/(2d0*nc)**2
      elseif(iqb.gt.2.and.iq.gt.2) then
         write(*,*) "photon initiated: should be forbidden!"
         ave = 1d0/(2d0*(nc**2-1d0))**2
      else   
         ave = 1d0/(4d0*nc*(nc**2-1d0))
      endif   
      !next line is for MCFM
!      amz = 1/(4d0*pi)

      facB=ave*(4d0*pi*amz)**2*nc*8d0/2d0
      facR=facB*nc*g2qcd
      
!       write(*,*) as, g2qcd, nc, amz
!       write(*,*) ave, (4d0*pi*amz)
!       write(*,*) "B1 in Full", B1g0GG(iqb,ig,iq,i3,i4)
      
      FullB1g0GG = (nc**2-1d0)/nc**2*facR*B1g0GG(iqb,ig,iq,i3,i4)
      
      return
      end

      function FullB2g0GG(iqb,ig1,ig2,iq,i5,i6)
      use KinData_mod
      use Constants_mod
      use GGconst
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
      common /strong/ as
!$omp threadprivate(/strong/)

      g2qcd = 4d0*pi*as
      
      if(iqb.le.2.and.iq.le.2) then
         ave = 1d0/(2d0*nc)**2
      elseif(iqb.gt.2.and.iq.gt.2) then
         ave = 1d0/(2d0*(nc**2-1d0))**2
      else   
         ave = 1d0/(4d0*nc*(nc**2-1d0))
      endif   
      
      facB=ave*(4d0*pi*amz)**2*nc*8d0/2d0
      facR=facB*nc*g2qcd
      facRR=facR*nc*g2qcd

      FullB2g0GG = (B2g0GG(iqb,ig1,ig2,iq,i5,i6) + B2g0GG(iqb,ig2,ig1,iq,i5,i6))
     &              -(1d0/dble(nc)**2)*Bt2g0GG(iqb,ig1,ig2,iq,i5,i6)
      
      FullB2g0GG = ave*(nc**2-1d0)/nc**2*facRR*FullB2g0GG
      
      return
      end
      
      function FullC0g0GG(iq1b,iQ2,iQ2b,iq1,i5,i6)
      use KinData_mod
      use Constants_mod
      use GGconst
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      integer :: nfC1, nfC2
      integer :: nu, nd, nud
      common /eweakZ/ amz,zewfac(4),zewnull(4)
      common /CZFlav/ nfC1, nfC2
      common /strong/ as
!$omp threadprivate(/strong/)
      
      ave = 1d0/(2d0*nc)**2
      g2qcd = 4d0*pi*as

      write(*,*) "iq1b, iq1:", iq1b, iq1, "; iQ2, iQ2b:", iQ2, iQ2b
      
      facB=ave*(4d0*pi*amz)**2*nc*8d0/2d0
      facR=facB*nc*g2qcd
      facRR=facR*nc*g2qcd      
      C0g0GGfac = (nc**2-1d0)/nc**3*facRR
      D0g0GGfac = -(nc**2-1d0)/nc**4*facRR

!      nu = nup
!      nd = ndown
      nu = 1
      nd = 1
 
      if (nfC2.eq.1) then
         nud = nd
      else if (nfC2.eq.2) then
         nud = nd
      else
         nud = 0
      endif

      if ((iq1b.le.2).and.(iq1.le.2)) then
!     q-q initiated
         write(*,*) "q-q initated"
         C0g0GGfac = (nc**2-1d0)/nc**3**facRR*nud
         D0g0GGfac = -(nc**2-1d0)/nc**4*facRR
      else if ((iQ2b.le.2).and.(iQ2.le.2)) then
!     Q-Qb initiated
         write(*,*) "Q-Qb initiated should not occur"
         C0g0GGfac = (nc**2-1d0)/nc**3**facRR
      else if ((iq1.le.2).and.(iQ2.le.2)) then
!     q-Q initiated
         write(*,*) "q-Q initiated"
         C0g0GGfac = (nc**2-1d0)/nc**3*facRR
         D0g0GGfac = -(nc**2-1d0)/nc**4*1d0/2d0*facRR
      else if ((iq1b.le.2).and.(iQ2b.le.2)) then
         write(*,*) "qb-Qb initiated"
!     qb-Qb initiated
         C0g0GGfac = (nc**2-1d0)/nc**3*facRR
         D0g0GGfac = -(nc**2-1d0)/nc**4*1d0/2d0*facRR
      else if ((i5.le.2).or.(i6.le.2)) then
         write(*,*) "error: photon-initiated"
      else
!         Q-qb or Qb-q initiated
         C0g0GGfac = (nc**2-1d0)/nc**3*facRR
         D0g0GGfac = -(nc**2-1d0)/nc**4*facRR
      endif
     
      !write(*,*) "C0g0GG not ready yet"

!      write(*,*) ave, C0g0GGfac, facRR, nc, amz, pi
      
      FullC0g0GG = C0g0GGfac*(C0g0GG(iq1b,iQ2,iQ2b,iq1,i5,i6))
!+C0g0GG(iq1b,iq1,iQ2b,iQ2,i5,i6))/2d0
      
      if (nfC1.eq.nfC2) then
         write(*,*) "identical"
         write(*,*) FullC0g0GG
         write(*,*) D0g0GGfac*D0g0GG(iq1b,iQ2,iQ2b,iq1,i5,i6)
         FullC0g0GG = FullC0g0GG + D0g0GGfac*D0g0GG(iq1b,iQ2,iQ2b,iq1,i5,i6)
      endif


      write(*,*) "Symmetry test"
      write(*,*) C0g0GGfac*C0g0GG(iq1b,iQ2,iQ2b,iq1,i5,i6), C0g0GGfac*C0g0GG(iq1b,iq1,iQ2b,iQ2,i5,i6)

      return
      end




***************************************************************************
*
* two quark two photon tree level matrix element
*
*                  qb q G G
*
* make use of 2g2q subleading colour ME, summed and squared
*
      function B0g0GG(i4,i1,i2,i3)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nfB1,0d0) 
      
!       write(*,*) "HELLO B0g0GG"
!      write(*,*) "zewfac", abs(zewfac(1))
      !> dress jet MEs with fractional charges
      B0g0GG = abs(zewfac(1))**4*Bt2g0(i1,i2,i3,i4)/2d0
      !> Factor of 1/2 to compensate for the hardcoded factor 2 in Bt2g0
      return
      end
*
***************************************************************************
*
* two quark one gluon two photon tree level matrix elements
*
*                qb g q G G

      !> photons as last argument -> i2,i3 to the back
      function B1g0GG(iqb,ig,iq,i4,i5)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)

!      write(*,*) "B1g0GG iqb, ig, iq, iG, iG", iqb, ig, iq, i4, i5

      call eweakV1qq(nfB1,0d0)
      !> dress jet MEs with fractional charges
      B1g0GG = abs(zewfac(1))**4*Btt3g0(iqb,ig,i4,i5,iq)/2d0
      
     
      return
      end
*
***************************************************************************
*
* leading colour two quark two gluon two photon tree level matrix elements
*
*                qb g g q G G

      !> photons as last argument -> i2,i3 to the back
      function B2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer aux
      COMPLEX*16 M(24,14),zR(24)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
      dimension j1(3),j2(8),j3(11),j4(23)


      call eweakV1qq(nfB1,0d0) 

!     Order in BBt goes g1, g2, G3, G4, qb5, q6
!     change back to 5 4 if doesn't fix spike plots
      call BBt2g0GG(i2,i3,i5,i6,i1,i4,B2g0GG,B2g0GGswap,Bt2g0GG)
!       i1,i4,i5,i6,i2,i3
!       call BBt2g0GG(i5,i4,i2,i3,i1,i6,B2g0GG,B2g0GGswap,Bt2g0GG)

      B2g0GG = abs(zewfac(1))**4 * B2g0GG
      

      return
      end      

*
***************************************************************************
*
* subleading colour two quark two gluon two photon tree level matrix elements
*
*                qb g g q G G

      !> photons as last argument -> i2,i3 to the back
      function Bt2g0GG(i1,i4,i5,i6,i2,i3)
      
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      integer aux
      COMPLEX*16 M(24,14),zR(24)
      parameter(pi=3.141592653589793238d0)
      common /eweakZ/ amz,zewfac(4),zenwull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
      dimension j1(3),j2(8),j3(11),j4(23)

      call eweakV1qq(nfB1,0d0) 

!     Order in BBt goes g1, g2, G3, G4, qb5, q6
      call BBt2g0GG(i4,i5,i2,i3,i1,i6,B2g0GG,B2g0GGswap,Bt2g0GG)

      Bt2g0GG = abs(zewfac(1))**4 * Bt2g0GG
      
      return
      end
           

*
***************************************************************************
*     Encodes (-iA) where A are 0 -> 2g + 2G + qb + q amplitudes from del Duca (arXiv:hep-ph/9910253)
*     uses similar notation to MCFM to facilitate comparison
*     Idea: use these instead of summed dijet amplitudes for better performance
*     ...pm for qb(5+) q(6-) omitted for brevity


*     g(1-) g(2+) G(3+) G(4+) qb(5+) q(6-)
!     From/double-checked against Del Duca eqn 2.9      
      function zB2g0GG_mppp(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      zB2g0GG_mppp = zA6(i5,i1)*zA6(i6,i1)**3/(zA6(i5,i6)*zA6(i6,i1)
     &     *zA6(i1,i2)*zA6(i2,i5))*zA6(i6,i5)/(zA6(i6,i3)*zA6(i3,i5))
     &     *zA6(i6,i5)/(zA6(i6,i4)*zA6(i4,i5))
            
      return
      end


*     g(1+) g(2-) G(3+) G(4+) qb(5+) q(6-)
!     From/double-checked against Del Duca eqn 2.9       
      function zB2g0GG_pmpp(i1,i2,i3,i4,i5,i6)
      use KinData_mod     

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
            
      zB2g0GG_pmpp = zA6(i5,i2)*zA6(i6,i2)**3/(zA6(i5,i6)*zA6(i6,i1)
     &     *zA6(i1,i2)*zA6(i2,i5))*zA6(i6,i5)/(zA6(i6,i3)*zA6(i3,i5))
     &     *zA6(i6,i5)/(zA6(i6,i4)*zA6(i4,i5))
      
      return
      end


*     g(1+) g(2+) G(3-) G(4+) qb(5+) q(6-)      
!     From/double-checked against Del Duca eqn 2.9       
      function zB2g0GG_ppmp(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      zB2g0GG_ppmp = zA6(i5,i3)*zA6(i6,i3)**3/(zA6(i5,i6)*zA6(i6,i1)
     &     *zA6(i1,i2)*zA6(i2,i5))*zA6(i6,i5)/(zA6(i6,i3)*zA6(i3,i5))
     &     *zA6(i6,i5)/(zA6(i6,i4)*zA6(i4,i5))
            
      return
      end
      
      
*     g(1+) g(2+) G(3+) G(4-) qb(5+) q(6-)
!     From/double-checked against Del Duca eqn 2.9      
      function zB2g0GG_pppm(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
            
      zB2g0GG_pppm = (zA6(i5,i4)*zA6(i6,i4)**3/(zA6(i5,i6)*zA6(i6,i1)
     &     *zA6(i1,i2)*zA6(i2,i5)))*(zA6(i6,i5)/(zA6(i6,i3)*zA6(i3,i5)))
     &     *(zA6(i6,i5)/(zA6(i6,i4)*zA6(i4,i5)))
     
      return
      end
      
      
*     g(1-) g(2-) G(3+) G(4+) qb(5+) q(6-)
!     From/double-checked against Del Duca eqn 4.1
      function zB2g0GG_mmpp(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      t126 = s6(i1,i2)+s6(i1,i6)+s6(i2,i6)
      t136 = s6(i1,i3)+s6(i1,i6)+s6(i3,i6)
      t146 = s6(i1,i4)+s6(i1,i6)+s6(i4,i6)
            
      zB2g0GG_mmpp=(zB6(i5,i1)*zA6(i1,i6)+zB6(i5,i2)*zA6(i2,i6))*zA6(i5,i6)
     &     *t126/(zB6(i5,i2)*zB6(i1,i6)*zB6(i2,i1)*zA6(i6,i3)*zA6(i6,i4)
     &     *zA6(i5,i3)*zA6(i5,i4))
     &     -zA6(i1,i6)*zB6(i4,i5)*(zB6(i3,i1)*zA6(i1,i2)+zB6(i3,i6)*zA6(i6,i2))
     &     /(zB6(i1,i6)*zA6(i4,i5)*zB6(i5,i2)*zA6(i6,i3)*t136)
     &     -zA6(i1,i6)*zB6(i3,i5)*(zB6(i4,i1)*zA6(i1,i2)+zB6(i4,i6)*zA6(i6,i2))
     &     /(zB6(i1,i6)*zA6(i3,i5)*zB6(i5,i2)*zA6(i6,i4)*t146)
      
      return
      end
      
*     g(1+) g(2-) G(3-) G(4+) qb(5+) q(6-)
!     From/double-checked against Del Duca eqn 4.2 
      function zB2g0GG_pmmp_old(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      t125 = s6(i1,i2)+s6(i1,i5)+s6(i2,i5)
      t126 = s6(i1,i2)+s6(i1,i6)+s6(i2,i6)
      t136 = s6(i1,i3)+s6(i1,i6)+s6(i3,i6)
      t145 = s6(i1,i4)+s6(i1,i5)+s6(i4,i5)
      
      zB2g0GG_pmmp_old = zB6(i4,i5)*zA6(i2,i6)**2*(zB6(i1,i2)*zA6(i2,i3)
     &     +zB6(i1,i6)*zA6(i6,i3))/(zA6(i4,i5)*zB6(i5,i3)*zA6(i1,i6)
     &     *s6(i1,i2)*t126)
     &     +zA6(i3,i6)*zB6(i5,i4)*(zB6(i1,i3)*zA6(i3,i2)+zB6(i1,i6)
     &     *zA6(i6,i2))/(zB6(i3,i6)*zA6(i5,i4)*zB6(i5,i2)*zA6(i1,i6)*t136)
     &     +zA6(i3,i6)*zB6(i1,i5)**2*(zB6(i4,i3)*zA6(i3,i2)+zB6(i4,i6)
     &     *zA6(i6,i2))/(zB6(i3,i6)*zB6(i2,i5)*zA6(i6,i4)*s6(i1,i2)*t125)
     &     +zB6(i5,i1)*zA6(i6,i2)*(zB6(i5,i1)*zA6(i1,i6)+zB6(i5,i4)
     &     *zA6(i4,i6))*t145/(zB6(i3,i6)*zB6(i5,i2)*zB6(i5,i3)*zA6(i6,i1)
     &     *zA6(i6,i4)*zA6(i4,i5)*s6(i1,i2))
     &     +(zB6(i1,i3)*zA6(i3,i2)+zB6(i1,i6)*zA6(i6,i2))*(zB6(i5,i1)
     &     *zA6(i1,i6)*(zB6(i5,i2)*zA6(i2,i6)+zB6(i5,i3)*zA6(i3,i6))
     &     +zB6(i5,i4)*zA6(i4,i6)*zB6(i5,i2)*zA6(i2,i6))/(zB6(i3,i6)
     &     *zB6(i5,i2)*zB6(i5,i3)*zA6(i6,i1)*zA6(i6,i4)*zA6(i4,i5)*s6(i1,i2))
     
      return
      end
      
      
*     g(1+) g(2-) G(3-) G(4+) qb(5+) q(6-)
!     From/double-checked against Del Duca eqn 4.2 
!     Factorise s12 out for num. stablity
      function zB2g0GG_pmmp(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      t125 = s6(i1,i2)+s6(i1,i5)+s6(i2,i5)
      t126 = s6(i1,i2)+s6(i1,i6)+s6(i2,i6)
      t136 = s6(i1,i3)+s6(i1,i6)+s6(i3,i6)
      t145 = s6(i1,i4)+s6(i1,i5)+s6(i4,i5)
      
      zB2g0GG_pmmp = 1d0/s6(i1,i2)*(
     &     zB6(i4,i5)*zA6(i2,i6)**2*(zB6(i1,i2)*zA6(i2,i3)
     &     +zB6(i1,i6)*zA6(i6,i3))/(zA6(i4,i5)*zB6(i5,i3)*zA6(i1,i6)
     &     *t126)
     &     +zA6(i3,i6)*zB6(i1,i5)**2*(zB6(i4,i3)*zA6(i3,i2)+zB6(i4,i6)
     &     *zA6(i6,i2))/(zB6(i3,i6)*zB6(i2,i5)*zA6(i6,i4)*t125)
     &     +zB6(i5,i1)*zA6(i6,i2)*(zB6(i5,i1)*zA6(i1,i6)+zB6(i5,i4)
     &     *zA6(i4,i6))*t145/(zB6(i3,i6)*zB6(i5,i2)*zB6(i5,i3)*zA6(i6,i1)
     &     *zA6(i6,i4)*zA6(i4,i5))
     &     +(zB6(i1,i3)*zA6(i3,i2)+zB6(i1,i6)*zA6(i6,i2))*(zB6(i5,i1)
     &     *zA6(i1,i6)*(zB6(i5,i2)*zA6(i2,i6)+zB6(i5,i3)*zA6(i3,i6))
     &     +zB6(i5,i4)*zA6(i4,i6)*zB6(i5,i2)*zA6(i2,i6))/(zB6(i3,i6)
     &     *zB6(i5,i2)*zB6(i5,i3)*zA6(i6,i1)*zA6(i6,i4)*zA6(i4,i5))
     &     )
     &     +zA6(i3,i6)*zB6(i5,i4)*(zB6(i1,i3)*zA6(i3,i2)+zB6(i1,i6)
     &     *zA6(i6,i2))/(zB6(i3,i6)*zA6(i5,i4)*zB6(i5,i2)*zA6(i1,i6)*t136)

     
      return
      end
      
      
*     g(1-) g(2+) G(3-) G(4+) qb(5+) q(6-)
!     From/double-checked against Del Duca eqn 4.3
      function zB2g0GG_mpmp(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      t126 = s6(i1,i2)+s6(i1,i6)+s6(i2,i6)
      t136 = s6(i1,i3)+s6(i1,i6)+s6(i3,i6)
      t146 = s6(i1,i4)+s6(i1,i6)+s6(i4,i6)
      t346 = s6(i3,i4)+s6(i3,i6)+s6(i4,i6)
      
      
      zB2g0GG_mpmp = zA6(i1,i6)*zB6(i2,i5)*(zB6(i4,i2)*zA6(i2,i3)
     &     +zB6(i4,i5)*zA6(i5,i3))/(zB6(i1,i6)*zA6(i2,i5)*zB6(i5,i3)
     &     *zA6(i6,i4)*t146)
     &     +1d0/s6(i1,i2)*(
     &     +zA6(i1,i6)*zB6(i4,i5)*zB6(i6,i2)*(zB6(i2,i4)*zA6(i4,i3)
     &     +zB6(i2,i5)*zA6(i5,i3))/(zB6(i1,i6)*zA6(i4,i5)*zB6(i5,i3)
     &     *t126)
     &     +zA6(i3,i6)*zB6(i2,i5)*zA6(i5,i1)*(zB6(i4,i2)*zA6(i2,i1)
     &     +zB6(i4,i5)*zA6(i5,i1))/(zB6(i3,i6)*zA6(i2,i5)*zA6(i6,i4)
     &     *t346)
     &     +zA6(i1,i6)*zB6(i2,i5)*(zB6(i2,i4)*zA6(i4,i3)+zB6(i2,i5)
     &     *zA6(i5,i3))/(zB6(i1,i6)*zB6(i3,i5)*zA6(i5,i4)*zA6(i4,i6)
     &     )
     &     +t136*(zA6(i5,i1)*zB6(i2,i6)*zB6(i5,i3)*zA6(i3,i6)+zB6(i1,i2)
     &     *zB6(i6,i5)*zA6(i1,i6)*zA6(i5,i1))/(zB6(i1,i6)*zB6(i5,i3)
     &     *zB6(i3,i6)*zA6(i2,i5)*zA6(i5,i4)*zA6(i4,i6))
     &     )
      
      return
      end
      
*
***************************************************************************
*     Assembles q qb -> 2g + 2G amplitudes from del Duca (arXiv:hep-ph/9910253)
*     Written as subroutine to maximise performance (minimise redundancy)

      subroutine BBt2g0GG(i1,i2,i3,i4,i5,i6,B,Bswap,Bt)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      complex*16 :: amp(2,2,2,2,2), swamp(2,2,2,2,2)
      integer :: h1,h2,h3,h4,h5
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)
        
!     1 = '-'; 2 = '+'; helicity ordering matches momenta: g1, g2, G3, G4, qb5 (q6 not independent of qb5: quark line)
!     swamp is amp with gluon ordering swapped (required for Bt)

!     single '1' (-) trivially-vanishing

      amp(2,2,2,2,2) = (0d0,0d0)
      swamp(2,2,2,2,2) = (0d0,0d0)

!     two '1's (-) : MHV
      
      amp(1,2,2,2,2) = zB2g0GG_mppp(i1,i2,i3,i4,i5,i6)
      swamp(1,2,2,2,2) = zB2g0GG_mppp(i2,i1,i3,i4,i5,i6)

      amp(2,1,2,2,2) = zB2g0GG_pmpp(i1,i2,i3,i4,i5,i6)
      swamp(2,1,2,2,2) = zB2g0GG_pmpp(i2,i1,i3,i4,i5,i6)

      amp(2,2,1,2,2) = zB2g0GG_ppmp(i1,i2,i3,i4,i5,i6)
      swamp(2,2,1,2,2) = zB2g0GG_ppmp(i2,i1,i3,i4,i5,i6)

      amp(2,2,2,1,2) = zB2g0GG_pppm(i1,i2,i3,i4,i5,i6)
      swamp(2,2,2,1,2) = zB2g0GG_pppm(i2,i1,i3,i4,i5,i6)

!     three '1's (--) : NMHV
      
      amp(1,1,2,2,2) = zB2g0GG_mmpp(i1,i2,i3,i4,i5,i6)
      swamp(1,1,2,2,2) = zB2g0GG_mmpp(i2,i1,i3,i4,i5,i6)

      amp(2,1,1,2,2) = zB2g0GG_pmmp(i1,i2,i3,i4,i5,i6)
      swamp(2,1,1,2,2) = zB2g0GG_pmmp(i2,i1,i3,i4,i5,i6)

      amp(1,2,1,2,2) = zB2g0GG_mpmp(i1,i2,i3,i4,i5,i6)
      swamp(1,2,1,2,2) = zB2g0GG_mpmp(i2,i1,i3,i4,i5,i6)

!     single '2' (+) : trivially vanishing

      amp(1,1,1,1,2) = (0d0,0d0)
      swamp(1,1,1,1,2) = (0d0,0d0)
      

!     CP(?) conjugation of amplitudes: complex conjugate; reflect quark line [check]

!     two '2's (++) : anti-MHV

      amp(1,2,1,1,2) = dconjg(zB2g0GG_mppp(i2,i1,i3,i4,i6,i5))
      swamp(1,2,1,1,2) = dconjg(zB2g0GG_mppp(i1,i2,i3,i4,i6,i5))

      amp(2,1,1,1,2) = dconjg(zB2g0GG_pmpp(i2,i1,i3,i4,i6,i5))
      swamp(2,1,1,1,2) = dconjg(zB2g0GG_pmpp(i1,i2,i3,i4,i6,i5))      

      amp(1,1,2,1,2) = dconjg(zB2g0GG_ppmp(i2,i1,i3,i4,i6,i5))
      swamp(1,1,2,1,2) = dconjg(zB2g0GG_ppmp(i1,i2,i3,i4,i6,i5))

      amp(1,1,1,2,2) = dconjg(zB2g0GG_pppm(i2,i1,i3,i4,i6,i5))
      swamp(1,1,1,2,2) = dconjg(zB2g0GG_pppm(i1,i2,i3,i4,i6,i5))

!     three '2's (+++) : anti-NMHV

      amp(2,2,1,1,2) = dconjg(zB2g0GG_mmpp(i2,i1,i3,i4,i6,i5))
      swamp(2,2,1,1,2) = dconjg(zB2g0GG_mmpp(i1,i2,i3,i4,i6,i5))
      
      amp(2,1,2,1,2) = dconjg(zB2g0GG_pmmp(i2,i1,i3,i4,i6,i5))
      swamp(2,1,2,1,2) = dconjg(zB2g0GG_pmmp(i1,i2,i3,i4,i6,i5))
      
      amp(1,2,2,1,2) = dconjg(zB2g0GG_mpmp(i2,i1,i3,i4,i6,i5))
      swamp(1,2,2,1,2) = dconjg(zB2g0GG_mpmp(i1,i2,i3,i4,i6,i5))

!     Parity conjugation
      
      do h1=1,2
        do h2=1,2
          do h3=1,2
            do h4=1,2
              amp(h1,h2,h3,h4,1)=amp(3-h1,3-h2,3-h3,3-h4,2)
              swamp(h1,h2,h3,h4,1)=swamp(3-h1,3-h2,3-h3,3-h4,2)
            enddo
          enddo
        enddo
      enddo
      
!     sum over helicities

      B = 0d0
      Bswap = 0d0
      Bt = 0d0
      do h1=1,2
        do h2=1,2
          do h3=1,2
            do h4=1,2
              do h5=1,2
                B = B + abs(amp(h1,h2,h3,h4,h5))**2
                Bswap = Bswap + abs(swamp(h1,h2,h3,h4,h5))**2
                Bt = Bt + abs(amp(h1,h2,h3,h4,h5)+swamp(h2,h1,h3,h4,h5))**2
              enddo
            enddo
          enddo
        enddo
      enddo
      
      B = B/2d0
      Bswap = Bswap/2d0
      Bt = Bt/2d0

C     call eweakV1qq(nfB1,0d0) 
      !> dress MEs with fractional charges
      ! factors of 2 necessary to get correct eikonal factors relative to B1g0GG
c$$$      B = abs(zewfac(1))**4*B/2d0
c$$$      Bswap = abs(zewfac(1))**4*Bswap/2d0
c$$$      Bt = abs(zewfac(1))**4*Bt/2d0
      
      
      return
      end



*
***************************************************************************
*     Encodes (-iA) where A are 0 -> (qb + q) + (Qb + Q) + 2G amplitudes from del Duca (arXiv:hep-ph/9910253)
*     again uses similar notation to MCFM to facilitate comparison/bug hunting
*     Idea: use these instead of summed dijet amplitudes for better performance
*     Arguably less justified than for B2g0GG case
*     Still need to double-check


*     MHV: qb(1-) q(2+) Qb(3-) Q(4+) G(5+) G(6+)
!     From/double-checked against Del Duca eqn 2.15
      function zC0g0GG_mpmppp(i1,i2,i3,i4,i5,i6,Q12,Q34)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      ! Q12 = Q_q; Q34 = Q_Q
      
      zC0g0GG_mpmppp = (Q12*zA6(i2,i1)/(zA6(i2,i5)*zA6(i5,i1)) + Q34*zA6(i4,i3)/(zA6(i4,i5)*zA6(i5,i3)))
     &*(Q12*zA6(i2,i1)/(zA6(i2,i6)*zA6(i6,i1)) + Q34*zA6(i4,i3)/(zA6(i4,i6)*zA6(i6,i3)))
     &*((-zA6(i1,i3)**2)/(zA6(i1,i2)*zA6(i3,i4)))
            
      return
      end
      
      
*     qb(1-) q(2+) Qb(3+) Q(4-) G(5+) G(6+)
!     From Del Duca eqn 2.15
      function zC0g0GG_mppmpp(i1,i2,i3,i4,i5,i6,Q12,Q34)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      ! Q12 = Q_q; Q34 = Q_Q
      
      zC0g0GG_mppmpp =  (Q12*zA6(i2,i1)/(zA6(i2,i5)*zA6(i5,i1)) + Q34*zA6(i4,i3)/(zA6(i4,i5)*zA6(i5,i3)))
     &*(Q12*zA6(i2,i1)/(zA6(i2,i6)*zA6(i6,i1)) + Q34*zA6(i4,i3)/(zA6(i4,i6)*zA6(i6,i3)))
     &*((+zA6(i1,i4)**2)/(zA6(i1,i2)*zA6(i3,i4)))
            
      return
      end
      
      
*     qb(1+) q(2-) Qb(3-) Q(4+) G(5+) G(6+)
!     From Del Duca eqn 2.15
      function zC0g0GG_pmmppp(i1,i2,i3,i4,i5,i6,Q12,Q34)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      ! Q12 = Q_q; Q34 = Q_Q
      
      
      zC0g0GG_pmmppp = (Q12*zA6(i2,i1)/(zA6(i2,i5)*zA6(i5,i1)) + Q34*zA6(i4,i3)/(zA6(i4,i5)*zA6(i5,i3)))
     &*(Q12*zA6(i2,i1)/(zA6(i2,i6)*zA6(i6,i1)) + Q34*zA6(i4,i3)/(zA6(i4,i6)*zA6(i6,i3)))
     &*((+zA6(i2,i3)**2)/(zA6(i1,i2)*zA6(i3,i4)))
            
      return
      end
      

*     qb(1+) q(2-) Qb(3+) Q(4-) G(5+) G(6+)
!     From Del Duca eqn 2.15
      function zC0g0GG_pmpmpp(i1,i2,i3,i4,i5,i6,Q12,Q34)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      ! Q12 = Q_q; Q34 = Q_Q
      
      
      zC0g0GG_pmpmpp = (Q12*zA6(i2,i1)/(zA6(i2,i5)*zA6(i5,i1)) + Q34*zA6(i4,i3)/(zA6(i4,i5)*zA6(i5,i3)))
     &*(Q12*zA6(i2,i1)/(zA6(i2,i6)*zA6(i6,i1)) + Q34*zA6(i4,i3)/(zA6(i4,i6)*zA6(i6,i3)))
     &*((-zA6(i2,i4)**2)/(zA6(i1,i2)*zA6(i3,i4)))
            
      return
      end
      
      
*     qb(1+) q(2-) Qb(3+) Q(4-) G(5-) G(6+)
!     From/double-checked against Del Duca eqn 4.5
      function zC0g0GG_pmpmmp(i1,i2,i3,i4,i5,i6,Q12,Q34)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      ! Q12 = Q_q; Q34 = Q_Q
      
      
      zC0g0GG_pmpmmp = Q12**2*zC0g0GG_g1(i1,i2,i3,i4,i5,i6) + Q34**2*zC0g0GG_g1(i3,i4,i1,i2,i5,i6)
     &+Q12*Q34*(zC0g0GG_g2(i1,i2,i3,i4,i5,i6)+zC0g0GG_g2(i3,i4,i1,i2,i5,i6))
            
      return
      end
      
      
*     qb(1+) q(2-) Qb(3-) Q(4+) G(5-) G(6+)
!     From/double-checked against Del Duca eqn 4.5
      function zC0g0GG_pmmpmp(i1,i2,i3,i4,i5,i6,Q12,Q34)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      ! Q12 = Q_q; Q34 = Q_Q
      
      
      zC0g0GG_pmmpmp = Q12**2*zC0g0GG_g1(i1,i2,i4,i3,i5,i6) + Q34**2*zC0g0GG_g1(i4,i3,i1,i2,i5,i6)
     &-Q12*Q34*(zC0g0GG_g2(i1,i2,i4,i3,i5,i6)+zC0g0GG_g2(i4,i3,i1,i2,i5,i6))
            
      return
      end
      
      
*     Ancillary function g_1 for qqbQQbGG amplitudes (x -i)
!     From/double-checked against Del Duca eqn 3.9
      function zC0g0GG_g1(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      t134 = s6(i1,i3)+s6(i1,i4)+s6(i3,i4)
      t156 = s6(i1,i5)+s6(i1,i6)+s6(i5,i6)
      
      zC0g0GG_g1 = (zB6(i1,i3)*zA6(i3,i4)+zB6(i1,i6)*zA6(i6,i4))
     &     *(zB6(i3,i1)*zA6(i1,i2)+zB6(i3,i6)*zA6(i6,i2))/(zA6(i1,i6)
     &     *zA6(i6,i2)*zB6(i1,i5)*zB6(i5,i2)*s6(i3,i4))
     &     +zB6(i1,i6)*zA6(i2,i4)*(zB6(i3,i1)*zA6(i1,i5) + zB6(i3,i6)
     &     *zA6(i6,i5))/(zA6(i1,i6)*zB6(i1,i5)*s6(i3,i4)*t156)
     &     +zA6(i5,i2)*zB6(i3,i1)*(zB6(i6,i2)*zA6(i2,i4) + zB6(i6,i5)
     &     *zA6(i5,i4))/(zB6(i5,i2)*zA6(i6,i2)*s6(i3,i4)*t134)
            
      return
      end
      
      
*     Ancillary function g_2 for qqbQQbGG amplitudes (x -i)
!     From/double-checked against Del Duca eqn 3.10
      function zC0g0GG_g2(i1,i2,i3,i4,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      
      t126 = s6(i1,i2)+s6(i1,i6)+s6(i2,i6)
      
      zC0g0GG_g2 = -(zB6(i3,i1)*zA6(i1,i2)+zB6(i3,i6)*zA6(i6,i2))**2/(zA6(i1,i6)*zA6(i6,i2)*zB6(i3,i5)*zB6(i5,i4)*t126)
            
      return
      end
      
*
***************************************************************************
*     Assembles 0 -> qb q Qb Q G G amplitudes from del Duca (arXiv:hep-ph/9910253) into matrix element
!     When ordered i1 i2 i3 i4 i5 i6, gives (outgoing) qb q Qb Q.  GG.map says qb Q Qb q: should correspond to 1432

      function C0g0GG(i1,i4,i3,i2,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      complex*16 :: amp(2,2,2,2)
      integer :: h1,h2,h3,h4
      common /eweakZ/ amz, zewfac1(4), zewfac2(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)
! 
! !     swap conventions
!       i = i2
!       i2 = i4
!       i4 = i

      if(nfC1.eq.0.or.nfC2.eq.0)then
         write(*,*) "Error in C0g0GG: flavours have not been initialised"
         stop
      endif

      call eweakV2qq(nfC1,nfC2,0d0)
      
      fac1 = real(zewfac1(1))
      fac2 = real(zewfac2(1))


!     1 = '-'; 2 = '+'; helicity ordering matches momenta: qb1, (q2,) Qb3, (Q4,) G5, G6
!     (q2 opposite of qb1, Q4 of Qb3: quark line)

!     go through systematically

      amp(2,2,2,2) = zC0g0GG_pmpmpp(i1,i2,i3,i4,i5,i6,fac1,fac2)
      amp(1,2,2,2) = zC0g0GG_mppmpp(i1,i2,i3,i4,i5,i6,fac1,fac2)
      amp(2,1,2,2) = zC0g0GG_pmmppp(i1,i2,i3,i4,i5,i6,fac1,fac2)
      amp(1,1,2,2) = zC0g0GG_mpmppp(i1,i2,i3,i4,i5,i6,fac1,fac2)
            
            
      amp(2,2,1,2) = zC0g0GG_pmpmmp(i1,i2,i3,i4,i5,i6,fac1,fac2)
!     amp(1,2,1,2)   set from 2121 later
      amp(2,1,1,2) = zC0g0GG_pmmpmp(i1,i2,i3,i4,i5,i6,fac1,fac2)
!     amp(1,1,1,2)   set from 2221 later
      
!     exploit photon interchange symmetry for 2221, 2121
      amp(2,2,2,1) = zC0g0GG_pmpmmp(i1,i2,i3,i4,i6,i5,fac1,fac2)
      amp(1,2,2,1) = dconjg(amp(2,1,1,2))
      amp(2,1,2,1) = zC0g0GG_pmmpmp(i1,i2,i3,i4,i6,i5,fac1,fac2)
      amp(1,1,2,1) = dconjg(amp(2,2,1,2))

!     can now set amplitudes missed out above
      amp(1,2,1,2) = dconjg(amp(2,1,2,1))
      amp(1,1,1,2) = dconjg(amp(2,2,2,1))
      
      amp(2,2,1,1) = dconjg(amp(1,1,2,2))
      amp(1,2,1,1) = dconjg(amp(2,1,2,2))
      amp(2,1,1,1) = dconjg(amp(1,2,2,2))
      amp(1,1,1,1) = dconjg(amp(2,2,2,2))
      
      C0g0GG = 0d0
      
      do h4=1,2
        do h3=1,2
          do h2=1,2
            do h1=1,2
!               write(*,*) h4, h3, h2, h1
!               write(*,*) amp(h1,h2,h3,h4)
              C0g0GG = C0g0GG + abs(amp(h1,h2,h3,h4))**2
            enddo
          enddo
        enddo
      enddo
      
      C0g0GG = C0g0GG/2d0
      return
      end
      
      
*
***************************************************************************
*     Assembles q qb -> Q Qb + 2G amplitudes from del Duca (arXiv:hep-ph/9910253) for identical quarks
!     Permuted arguments from 1 2 3 4 5 6 (what's needed for testing against MadGraph)
!     Repermuted arguments from 143256
!     
      function D0g0GG(i1,i4,i3,i2,i5,i6)
      use KinData_mod

      implicit real*8 (a-h,o-y)
      implicit complex*16(z)
      complex*16 :: amp(2,2,2), swamp(2,2,2)
      integer :: h1,h2,h3,h4
      common /eweakZ/ amz, zewfac1(4), zewfac2(4)
!$omp threadprivate(/eweakZ/)
      common /CZFlav/ nfC1,nfC2
!$omp threadprivate(/CZFlav/)

      if(nfC1.eq.0.or.nfC2.eq.0)then
         write(*,*) "Error in D0g0GG: flavours have not been initialised"
         stop
      endif

      call eweakV2qq(nfC1,nfC2,0d0)
      
      fac1 = real(zewfac1(1))
      fac2 = real(zewfac2(1))
      
      if (fac1.ne.fac2) then
        write(*,*) "error? D0g0GG called for non-matching quarks"
      end if
      
!     helicities of quark pairs must match (or resulting quark line after interchange forbidden)
!     so now helicity indices go qb[1&3], G5, G6

!     amplitudes for unswapped process (repeating calculations done for C! ideally, combine)
      amp(2,2,2) = zC0g0GG_pmpmpp(i1,i2,i3,i4,i5,i6,fac1,fac2)
      amp(1,2,2) = zC0g0GG_mpmppp(i1,i2,i3,i4,i5,i6,fac1,fac2)
            
      amp(2,1,2) = zC0g0GG_pmpmmp(i1,i2,i3,i4,i5,i6,fac1,fac2)
!     amp(1,1,2)   set from 221 later
      
!     exploit photon interchange symmetry for 221
      amp(2,2,1) = zC0g0GG_pmpmmp(i1,i2,i3,i4,i6,i5,fac1,fac2)
      amp(1,2,1) = dconjg(amp(2,1,2))

!     can now set amplitudes missed out above
      amp(1,1,2) = dconjg(amp(2,2,1))
      
      amp(2,1,1) = dconjg(amp(1,2,2))
      amp(1,1,1) = dconjg(amp(2,2,2))
      
!     amplitudes with quarks 2, 4 swapped
      swamp(2,2,2) = zC0g0GG_pmpmpp(i1,i4,i3,i2,i5,i6,fac1,fac2)
      swamp(1,2,2) = zC0g0GG_mpmppp(i1,i4,i3,i2,i5,i6,fac1,fac2)
                        
      swamp(2,1,2) = zC0g0GG_pmpmmp(i1,i4,i3,i2,i5,i6,fac1,fac2)
!     amp(1,1,2)   set from 221 later
      
!     exploit photon interchange symmetry for 2221, 2121
      swamp(2,2,1) = zC0g0GG_pmpmmp(i1,i4,i3,i2,i6,i5,fac1,fac2)
      swamp(1,2,1) = dconjg(swamp(2,1,2))

!     can now set amplitudes missed out above
      swamp(1,1,2) = dconjg(swamp(2,2,1))
      
      swamp(2,1,1) = dconjg(swamp(1,2,2))
      swamp(1,1,1) = dconjg(swamp(2,2,2))
      
      
      D0g0GG = 0d0
      
!     swap quarks 2 and 4
!     quark helicities have to be equal
      do h4=1,2
        do h3=1,2
          do h2=1,2
!             write(*,*) h2, h3, h4
!             write(*,*) amp(h2,h3,h4), swamp(h2,h3,h4)
            D0g0GG = D0g0GG + 2d0*real(amp(h2,h3,h4)*dconjg(swamp(h2,h3,h4)))
          enddo
        enddo
      enddo
            
      D0g0GG = -D0g0GG/2d0
      
      return
      end
      
*
***************************************************************************
* A wrapper function for B0g0GG which inherits the flavour of the first
* pair of quarks from the C0g0GG common block.
*
* This is invoked by the maple code for four-quark processes, where the
* reduced 'B'-matrix element has the flavour of the first pair of quarks.
*

      function f1B0g0GG(i1,i2,i3,i4)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /CZFlav/nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)

      if(nfC1.ne.0)then
         nfB1 = nfC1
!          write(*,*) "0: nfB1 from nfC1 is ", nfB1, "; nfCs are ", nfC1, nfC2
         f1B0g0GG = B0g0GG(i1,i2,i3,i4)
      else
         write(*,*) "Error in f1B0g0GG: flavours have not been initialised"
         stop
      endif

      return
      end
      
      function f2B0g0GG(i1,i2,i3,i4)
      use KinData_mod
      implicit double precision (a-h,o-z)
      common /CZFlav/nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)

      if(nfC2.ne.0)then
         nfB1 = nfC2
!          write(*,*) "0: nfB1 from nfC2 is ", nfB1, "; nfCs are ", nfC1, nfC2
         f2B0g0GG = B0g0GG(i1,i2,i3,i4)
      else
         write(*,*) "Error in f2B0g0GG: flavours have not been initialised"
         stop
      endif

      return
      end

*
************************************************************************
* A wrapper function for B1g0GG which inherits the flavour of the first
* pair of quarks from the C0g0GG common block.
*
      function f1B1g0GG(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)

      if(nfC1.ne.0)then
         nfB1 = nfC1
!          write(*,*) "1: nfB1 from nfC1 is ", nfB1, "; nfCs are ", nfC1, nfC2         
         f1B1g0GG = B1g0GG(i1,i2,i3,i4,i5)
      else
         write(*,*) "Error in f1B1g0GG: flavours have not been initialised"
         stop
      endif
      return
      end

      function f2B1g0GG(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nfC1,nfC2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)

      if(nfC2.ne.0)then
         nfB1 = nfC2
!          write(*,*) "1: nfB1 from nfC2 is ", nfB1, "; nfCs are ", nfC1, nfC2         
         f2B1g0GG = B1g0GG(i1,i2,i3,i4,i5)
      else
         write(*,*) "Error in f2B1g0GG: flavours have not been initialised"
         stop
      endif

      return
      end
      
      
***************************************************************************
*
* two quark three photon tree level matrix element
*
*                  qb q G G G
*
* used for testing loop-level
      function B0g0GGG(iqb,iq,i3,i4,i5)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      complex*16 :: amp(2,2,2,2)
      integer :: h1,h2,h3,h4
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nfB1,0d0) 
      
!     TREE-LEVEL
      
!     single '1' (-) trivially-vanishing
      amp(2,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV      
      amp(2,2,2,1) = zb0g0GGG_MHV(iq,iqb,i3,i4,i5)
      amp(2,2,1,2) = zb0g0GGG_MHV(iq,iqb,i5,i3,i4)
      amp(2,1,2,2) = zb0g0GGG_MHV(iq,iqb,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      amp(2,1,2,1) = -zb0g0GGG_MHV(iqb,iq,i3,i4,i5)
      amp(2,1,1,2) = -zb0g0GGG_MHV(iqb,iq,i5,i3,i4)
      amp(2,2,1,1) = -zb0g0GGG_MHV(iqb,iq,i4,i5,i3)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      amp(2,1,1,1) = (0d0,0d0)
      
!     LINE REVERSAL
      
!     single '1' (-) trivially-vanishing
      amp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      amp(1,2,2,1) = zb0g0GGG_MHV(iqb,iq,i3,i4,i5)
      amp(1,2,1,2) = zb0g0GGG_MHV(iqb,iq,i5,i3,i4)
      amp(1,1,2,2) = zb0g0GGG_MHV(iqb,iq,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      amp(1,1,2,1) = -zb0g0GGG_MHV(iq,iqb,i3,i4,i5)
      amp(1,1,1,2) = -zb0g0GGG_MHV(iq,iqb,i5,i3,i4)
      amp(1,2,1,1) = -zb0g0GGG_MHV(iq,iqb,i4,i5,i3)
      call resetzAB_kin(5)
      
!     single '2' (+) : trivially vanishing
      amp(1,1,1,1) = (0d0,0d0)
      
      B = 0d0
      
      do h1=1,2 
        do h2=1,2 
          do h3=1,2 
            do h4=1,2
!               write(*,*) h1,h2,h3,h4
!               write(*,*) amp(h1,h2,h3,h4)
              B = B + amp(h1,h2,h3,h4)*dconjg(amp(h1,h2,h3,h4))
            enddo
          enddo
        enddo     
      enddo
      
      
!       write(*,*) B
!> dress jet MEs with fractional charges
      B0g0GGG = abs(zewfac(1))**6*B
      return
      end
*

***************************************************************************
*
* two quark, one gluon, two photon tree level matrix element
*
*                  qb q g G G
*
* used for testing loop-level
      function B1g0GGtest(iqb,i3,iq,i4,i5)
      use KinData_mod
      implicit real*8(a-h,o-y)
      implicit complex*16(z)
      complex*16 :: amp(2,2,2,2)
      integer :: h1,h2,h3,h4
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /BZFlav/nfB1
!$omp threadprivate(/BZFlav/)

      call eweakV1qq(nfB1,0d0) 
      
!     TREE-LEVEL
      
!     single '1' (-) trivially-vanishing
      amp(2,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV      
      amp(2,2,2,1) = zb1g0GG_MHV(iq,iqb,i3,i4,i5)
      amp(2,2,1,2) = zb1g0GG_MHV(iq,iqb,i5,i3,i4)
      amp(2,1,2,2) = zb1g0GG_MHV(iq,iqb,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      amp(2,1,2,1) = -zb1g0GG_MHV(iqb,iq,i3,i4,i5)
      amp(2,1,1,2) = -zb1g0GG_MHV(iqb,iq,i5,i3,i4)
      amp(2,2,1,1) = -zb1g0GG_MHV(iqb,iq,i4,i5,i3)
      call resetzAB_kin(5)

!     single '2' (+) : trivially vanishing
      amp(2,1,1,1) = (0d0,0d0)
      
!     LINE REVERSAL
      
!     single '1' (-) trivially-vanishing
      amp(1,2,2,2) = (0d0,0d0)
      
!     two '1's (-) : G-MHV
      amp(1,2,2,1) = zb1g0GG_MHV(iqb,iq,i3,i4,i5)
      amp(1,2,1,2) = zb1g0GG_MHV(iqb,iq,i5,i3,i4)
      amp(1,1,2,2) = zb1g0GG_MHV(iqb,iq,i4,i5,i3)

!     three '1's (--) : G-anti-MHV
      call swapzAB_kin(5)
      amp(1,1,1,2) = -zb1g0GG_MHV(iq,iqb,i3,i4,i5)
      amp(1,1,2,1) = -zb1g0GG_MHV(iq,iqb,i5,i3,i4)
      amp(1,2,1,1) = -zb1g0GG_MHV(iq,iqb,i4,i5,i3)
      call resetzAB_kin(5)
      
!     single '2' (+) : trivially vanishing
      amp(1,1,1,1) = (0d0,0d0)
      
      B = 0d0
      
      do h1=1,2 
        do h2=1,2 
          do h3=1,2 
            do h4=1,2
!               write(*,*) h1,h2,h3,h4
!               write(*,*) amp(h1,h2,h3,h4)
!               write(*,*) amp(h1,h2,h3,h4)*dconjg(amp(h1,h2,h3,h4))
              B = B + amp(h1,h2,h3,h4)*dconjg(amp(h1,h2,h3,h4))
            enddo
          enddo
        enddo     
      enddo
      
      
!       write(*,*) B
      !> dress jet MEs with fractional charges
      B1g0GGtest = abs(zewfac(1))**4*B/2d0
      return
      end

*******************************************************************
* Symmetrised B2g0GG across the qqb pair.
*
*
      function sB2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sB2g0GG = 0.5d0*(B2g0GG(i1,i2,i3,i4,i5,i6)
     .               +B2g0GG(i4,i3,i2,i1,i5,i6))

      return
      end
      
*******************************************************************
* Conditionally symmetrised B2g0GG across the qqb pair.
*
*
      function csB2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if(i2.eq.1.or.i3.eq.1) then
         csB2g0GG = 0.5d0*(B2g0GG(i1,i2,i3,i4,i5,i6)
     .        +B2g0GG(i4,i3,i2,i1,i5,i6))
      else
         csB2g0GG = B2g0GG(i1,i2,i3,i4,i5,i6)
      endif

      return
      end

*******************************************************************
* Symmetrised Bt2g0GG across the qqb pair.
*
*
      function sBt2g0GG(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sBt2g0GG = 0.5d0*(Bt2g0GG(i1,i2,i3,i4,i5,i6)
     .                +Bt2g0GG(i4,i3,i2,i1,i5,i6))

      return
      end

*******************************************************************
* Conditionally symmetrised Bt2g0GG across the qqb pair.
*
*
      function csBt2g0GG(i1,i2,i3,i4,i5,i6)
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      if(i2.eq.1.or.i3.eq.1) then
         csBt2g0GG = 0.5d0*(Bt2g0GG(i1,i2,i3,i4,i5,i6)
     .        +Bt2g0GG(i4,i3,i2,i1,i5,i6))
      else
         csBt2g0GG = Bt2g0GG(i1,i2,i3,i4,i5,i6)
      endif

      return
      end

************************************************************************
* A wrapper function for B2g0GG which inherits the flavour of the first
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the first pair of quarks


      function f1B2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf1
         f1B2g0GG = B2g0GG(i4,i2,i3,i1,i5,i6)
      else
         write(*,*) "Error in f1B2g0GG: flavours have not been initialised"
         stop
      endif

      return
      end

************************************************************************
* A wrapper function for B2g0GG which inherits the flavour of the second
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the second pair of quarks
*

      function f2B2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf2.ne.0)then
         nf1g = nf2
         f2B2g0GG = B2g0GG(i4,i2,i3,i1,i5,i6)
      else
         write(*,*) "Error in f2B2g0GG: flavours have not been initialised"
         stop
      endif

      return
      end


************************************************************************
* A wrapper function for Bt2g0GG which inherits the flavour of the first
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the first pair of quarks


      function f1Bt2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf1.ne.0)then
         nf1g = nf1
         f1Bt2g0GG = Bt2g0GG(i1,i2,i3,i4,i5,i6)
      else
         write(*,*) "Error in f1Bt2g0GG: flavours have not been initialised"
         stop
      endif

      return
      end

************************************************************************
* A wrapper function for Bt2g0GG which inherits the flavour of the second
* pair of quarks from the C0g0GG common block.
*
* This must be called in the maple code for 4 quark processes where the
* reduced matrix element has the flavour of the second pair of quarks
*

      function f2Bt2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /CZFlav/nf1,nf2
!$omp threadprivate(/CZFlav/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)

      if(nf2.ne.0)then
         nf1g = nf2
         f2Bt2g0GG = Bt2g0GG(i1,i2,i3,i4,i5,i6)
      else
         write(*,*) "Error in f2Bt2g0GG: flavours have not been initialised"
         stop
      endif

      return
      end


*******************************************************************
* Symmetrised B2g0GG across the qqb pair, taking the flavour from
* the first quark pair of the C-type matrix elements.
*
*

      function sf1B2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sf1B2g0GG = 0.5d0*(f1B2g0GG(i1,i2,i3,i4,i5,i6)
     .                 +f1B2g0GG(i4,i3,i2,i1,i5,i6))

      return
      end

*******************************************************************
* Symmetrised B2g0GG across the qqb pair, taking the flavour from the
* second quark pair of the C-type matrix elements.
*

      function sf2B2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sf2B2g0GG = 0.5d0*(f2B2g0GG(i1,i2,i3,i4,i5,i6)
     .                 +f2B2g0GG(i4,i3,i2,i1,i5,i6))

      return
      end


*******************************************************************
* Symmetrised B2g0GG across the qqb pair, taking the flavour from
* the first quark pair of the C-type matrix elements.
*
*

      function sf1Bt2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sf1Bt2g0GG = 0.5d0*(f1Bt2g0GG(i1,i2,i3,i4,i5,i6)
     .                 +f1Bt2g0GG(i4,i3,i2,i1,i5,i6))

      return
      end

*******************************************************************
* Symmetrised B2g0GG across the qqb pair, taking the flavour from the
* second quark pair of the C-type matrix elements.
*

      function sf2Bt2g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sf2Bt2g0GG = 0.5d0*(f2Bt2g0GG(i1,i2,i3,i4,i5,i6)
     .                  +f2Bt2g0GG(i4,i3,i2,i1,i5,i6))

      return
      end

************************************************************
* A wrapper function for D0g0GG where it inherits the flavours
* from the matrix element B2g0GG
*
*

      function BD0g0GG(i1,i2,i3,i4,i5,i6)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)
      common /BZFlav/ nf2g
!$omp threadprivate(/BZFlav/)
      common /CZFlav/ nf1,nf2
!$omp threadprivate(/CZFlav/)

      nf1 = nf2g
      nf2 = nf2g

      BD0g0GG = D0g0GG(i1,i2,i3,i4,i5,i6)

      return
      end

************************************************************************
*
* A symmetrised version of the B1g0GG over the qqb pair.
*

      function sB1g0GG(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sB1g0GG = 0.5d0*(B1g0GG(i1,i2,i3,i4,i5)
     .               +B1g0GG(i3,i2,i1,i4,i5))


      return
      end

************************************************************************
*
* A symmetrised version of the B1g0GG over the qqb pair, taking the
* flavour from the first quark pair of C-type matrix elements
*

      function sf1B1g0GG(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sf1B1g0GG = 0.5d0*(f1B1g0GG(i1,i2,i3,i4,i5)
     .                 +f1B1g0GG(i3,i2,i1,i4,i5))


      return
      end

************************************************************************
*
* A symmetrised version of the B1g0GG over the qqb pair, taking the
* flavour from the second quark pair of C-type matrix elements
*

      function sf2B1g0GG(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      sf2B1g0GG = 0.5d0*(f2B1g0GG(i1,i2,i3,i4,i5)
     .                 +f2B1g0GG(i3,i2,i1,i4,i5))


      return
      end

