************************************************************************
*
*  generated using makefortRR on 2025-02-16
*
      function qgC1g0GSNLO_frag(i1,i2,i3,i4,i5,i6)
      use Mapping_mod
      use Scales_mod
      use Charges_EW_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      dimension wt(10)
      double precision partons(nMax_scl)
      double precision facnorm(nMax_scl)
      dimension jpass(10)
*      write(*,*)" hello qgC1g0GSNLO_frag"

      ix=1

      wt=0d0
      partons=0d0
      facnorm=0d0
      jpass=0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(1)=1
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        wt(1)=-1d0*FullqgA30II(i3,i2,i1,6)*C0g0G(j1,j2,j3,j4,j5)
        wt(1)=bino(ix,partons,-wt(1)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i4] = j4, [i4, i3] = j4, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i5,i4,i3/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(2)=1
        call set_flav_perm(5, (/ j1,j2,j4,j3,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        wt(2)=+1d0*FullE30FF(i5,i4,i3,6)*f1B2g0G(j1,j2,j4,j3,j5)
        wt(2)=bino(ix,partons,-wt(2)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(3)=1
        call set_flav_perm(5, (/ j3,j1,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(3)=-1d0*FullqpE30IF(i4,i5,i1,6)*sf2B2g0G(j3,j1,j2,j4,j5)
        wt(3)=bino(ix,partons,-wt(3)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(4)=1
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        wt(4)=-1d0*FullqgA30II(i4,i2,i1,6)*C0g0G(j1,j3,j2,j4,j5)
        wt(4)=bino(ix,partons,-wt(4)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i4 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i5,i2/), (/i1,i2,i3,i4,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(5)=1
        call set_flav_perm(5, (/ j1,j3,j4,j2,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        wt(5)=-1d0*FullqgA30II(i5,i2,i1,6)*C0g0G(j1,j3,j4,j2,j5)
        wt(5)=bino(ix,partons,-wt(5)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i4] = j4, [i3, i5] = j3, [i4, i3] = j4, [i5, i3] = j3}
      call set_map(6,5, (/i5,i3,i4/), (/i1,i2,i5,i4,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(6)=1
        call set_flav_perm(5, (/ j1,j4,j2,j3,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 2)
        if(ipass_block/=0) then
        wt(6)=+1d0*FullE30FF(i5,i3,i4,6)*f1B2g0G(j1,j4,j2,j3,j5)
        wt(6)=bino(ix,partons,-wt(6)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i6 = j5, [i1] = j1, [i4, i5] = j3, [i5, i4] = j3}
      call set_map(6,5, (/i1,i4,i5/), (/i1,i2,i5,i3,i6/), ipass)
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(7)=1
        call set_flav_perm(5, (/ j3,j2,j1,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 3)
        if(ipass_block/=0) then
        wt(7)=-1d0*FullqpE30IF(i4,i5,i1,6)*sf2B2g0G(j3,j2,j1,j4,j5)
        wt(7)=bino(ix,partons,-wt(7)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i3 = j4, i4 = j5, [i1] = j1, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i1,i5,i6/), (/i1,i2,i6,i3,i4/), ipass, frag=(/i5,i6/))
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(8)=1
        call set_flav_perm(5, (/ j3,j1,j4,j5,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        wt(8)=+( Qf1 ** 2 / 0.2D1 )*FullqA30IF(i1,i6,i5,6)*C1g0X(j3,j1,j4,j5,j2)
        wt(8)=bino(ix,partons,-wt(8)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i6] = j3, [i4, i6] = j4, [i6, i3] = j3, [i6, i4] = j4}
      call set_map(6,5, (/i3,i6,i4/), (/i1,i2,i3,i4,i5/), ipass, frag=(/i3,i6/))
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(9)=1
        call set_flav_perm(5, (/ j5,j1,j3,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        wt(9)=+( Qf2 ** 2 / 0.2D1 )*FullA30FF(i3,i6,i4,6)*C1g0X(j5,j1,j3,j4,j2)
        wt(9)=bino(ix,partons,-wt(9)*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i6] = j3, [i4, i6] = j4, [i6, i3] = j3, [i6, i4] = j4}
      call set_map(6,5, (/i3,i6,i4/), (/i1,i2,i3,i4,i5/), ipass, frag=(/i4,i6/))
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        jpass(10)=1
        call set_flav_perm(5, (/ j5,j1,j3,j4,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        wt(10)=+( Qf2 ** 2 / 0.2D1 )*FullA30FF(i3,i6,i4,6)*C1g0X(j5,j1,j3,j4,j2)
        wt(10)=bino(ix,partons,-wt(10)*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgC1g0GSNLO_frag = - sum(wt)  ! minus in bino(-...)


      return
      end function qgC1g0GSNLO_frag
