************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function A4g1HYT(ix,x1,x2,i1,i3,i2,i4,i5,i6,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(7)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello A4g1HYT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i3,i2,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGFI(ix,x1,x2,i3,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGFI(ix,x1,x2,i4,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + A4g0H(i1,i3,i2,i4,i5,i6)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 3
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullggF30II(i1,i3,i2,6)*A3g1H(j1,j2,j3,j4,j5,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullggF30II(i1,i3,i2,6)*A3g0H(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 3
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullggF30II(i2,i4,i1,6)*A3g1H(j1,j3,j2,j4,j5,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullggF30II(i2,i4,i1,6)*A3g0H(j1,j3,j2,j4,j5)*wtcalX30
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullggF31II(i1,i3,i2,6,muR2_scl(i))*A3g0H(j1,j2,j3,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGFI(ix,x1,x2,i3,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullggF30II(i1,i3,i2,6)*A3g0H(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullggF31II(i1,i4,i2,6,muR2_scl(i))*A3g0H(j1,j3,j2,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGFI(ix,x1,x2,i4,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullggF30II(i1,i4,i2,6)*A3g0H(j1,j3,j2,j4,j5)*wtcalX30
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        call makeinitII(i1,6,i1,i2,i3,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,j1,j2,5,j1,j3,5,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,i1,i2,6,i1,i4,6,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i3,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,j2,j3,5,j1,j3,5,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,i2,i4,6,i1,i4,6,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i3,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,j1,j3,5,j1,j3,5,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,i1,i4,6,i1,i4,6,muR2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21GGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21GGFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21GGFI(ix,x1,x2,i4,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21GGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21GGIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullggF30II(i1,i3,i2,6)*A3g0H(j1,j2,j3,j4,j5)*(wtcalX30+wtcalS)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        call makeinitII(i2,6,i1,i2,i4,6)
        wtcalS=wtcalS-1d0/2d0*SSintFI(ix,x1,x2,j1,j2,5,j2,j3,5,muR2_scl(i))
        call makeinit(i2,6)
        wtcalS=wtcalS+1d0/2d0*SSintFI(ix,x1,x2,i1,i2,6,i2,i3,6,muR2_scl(i))
        call makeinitII(i2,6,i1,i2,i4,6)
        wtcalS=wtcalS+1d0/2d0*SSintFI(ix,x1,x2,j2,j3,5,j2,j3,5,muR2_scl(i))
        call makeinit(i2,6)
        wtcalS=wtcalS-1d0/2d0*SSintFI(ix,x1,x2,i2,i3,6,i2,i3,6,muR2_scl(i))
        call makeinitII(i2,6,i1,i2,i4,6)
        wtcalS=wtcalS+1d0/2d0*SSintFI(ix,x1,x2,j1,j3,5,j2,j3,5,muR2_scl(i))
        call makeinit(i2,6)
        wtcalS=wtcalS-1d0/2d0*SSintFI(ix,x1,x2,i1,i3,6,i2,i3,6,muR2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21GGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21GGFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21GGFI(ix,x1,x2,i3,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21GGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21GGIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullggF30II(i1,i4,i2,6)*A3g0H(j1,j3,j2,j4,j5)*(wtcalX30+wtcalS)
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      A4g1HYT = - sum(wt)  ! minus in bino(-...)


      return


      end function A4g1HYT
