************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function ggBt2g1H3XT(ix,x1,x2,i3,i1,i2,i4,i5,i6,i7,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(30)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello ggBt2g1H3XT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i3,i1,i2,i4,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H3(i3,i1,i2,i4,i5,i6,i7)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i3,i2,i1,i4,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H3(i3,i2,i1,i4,i5,i6,i7)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i1,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 3
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullgA30IF(i3,i1,i4,7)*Bt1g1H3(j1,j2,j3,j4,j5,j6,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,j1,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i3,i1,i4,7)*B1g0H3(j1,j2,j3,j4,j5,j6)*wtcalX30
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, i7 = j6, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i2,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 3
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j1,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullgA30IF(i3,i2,i4,7)*Bt1g1H3(j2,j1,j3,j4,j5,j6,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQFI(ix,x1,x2,j2,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i3,i2,i4,7)*B1g0H3(j2,j1,j3,j4,j5,j6)*wtcalX30
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i1,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 6
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullgAt31IF(i3,i1,i4,7,muR2_scl(i))*B1g0H3(j1,j2,j3,j4,j5,j6)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j1,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i3,i1,i4,7)*B1g0H3(j1,j2,j3,j4,j5,j6)*wtcalX30
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, i7 = j6, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i2,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 6
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j1,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullgAt31IF(i3,i2,i4,7,muR2_scl(i))*B1g0H3(j2,j1,j3,j4,j5,j6)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQFI(ix,x1,x2,j2,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgA30IF(i3,i2,i4,7)*B1g0H3(j2,j1,j3,j4,j5,j6)*wtcalX30
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i1,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 6
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullgGt31IF(i1,i3,i4,7,muR2_scl(i))*A3g0H3(j1,j2,j3,j4,j5,j6)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgG30IF(i1,i3,i4,7)*A3g0H3(j1,j2,j3,j4,j5,j6)*wtcalX30
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, i7 = j6, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i2,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 6
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullgGt31IF(i2,i3,i4,7,muR2_scl(i))*A3g0H3(j1,j2,j3,j4,j5,j6)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,i3,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgG30IF(i2,i3,i4,7)*A3g0H3(j1,j2,j3,j4,j5,j6)*wtcalX30
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i1,i2,i3,i4,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0H3(i1,i2,i3,i4,i5,i6,i7)*(wtcalX30)
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i4,7)*B1g0H3(j1,j3,j2,j4,j5,j6)*(wtcalX30)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i1,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i3,i4,7)*B1g0H3(j1,j2,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i2,i1,i3,i4,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0H3(i2,i1,i3,i4,i5,i6,i7)*(wtcalX30)
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j3,j1,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgqA30II(i2,i1,i4,7)*B1g0H3(j2,j3,j1,j4,j5,j6)*(wtcalX30)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, i7 = j6, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i2,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j1,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i3,i4,7)*B1g0H3(j2,j1,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i1,i2,i3,i4,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H3(i1,i2,i3,i4,i5,i6,i7)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, i7 = j6, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i2,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqIF(ix,x1,x2,j1,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=gd30IF(i4,i3,i2,7)*B1g0H3(j1,j2,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgG30II(i2,i1,i4,7)*A3g0H3(j1,j2,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i1,i3,i2,i4,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H3(i1,i3,i2,i4,i5,i6,i7)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i4,7)*B1g0H3(j1,j3,j2,j4,j5,j6)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i3,i2/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqIF(ix,x1,x2,j1,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgD30II(i1,i3,i2,7)*B1g0H3(j1,j2,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i1,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j3,j2,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpG30IF(i3,i1,i4,7)*A3g0H3(j1,j3,j2,j4,j5,j6)*(wtcalX30)
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i1,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqIF(ix,x1,x2,i1,i4,7,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqIF(ix,x1,x2,j1,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i3,i4,7)*B1g0H3(j1,j2,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i2,i1,i3,i4,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H3(i2,i1,i3,i4,i5,i6,i7)*(wtcalX30)
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i1,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j1,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqFI(ix,x1,x2,j2,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=gd30IF(i4,i3,i1,7)*B1g0H3(j2,j1,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j1,j2,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgqG30II(i1,i2,i4,7)*A3g0H3(j1,j2,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(25)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,7,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(7, (/ i2,i3,i1,i4,i5,i6,i7 /))
        call getqcdnorm(ix,partons,facnorm, 7, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -2d0
     .  *rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H3(i2,i3,i1,i4,i5,i6,i7)*(wtcalX30)
        enddo
        wt(26)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i4,i2/), (/i1,i2,i3,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j3,j1,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgqA30II(i2,i1,i4,7)*B1g0H3(j2,j3,j1,j4,j5,j6)*(wtcalX30)
        enddo
        wt(27)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, i7 = j6, [i1] = j1, [i2] = j2}
      call set_map(7,6, (/i1,i3,i2/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j1,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqFI(ix,x1,x2,j2,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgqD30II(i2,i3,i1,7)*B1g0H3(j2,j1,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(28)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, i7 = j6, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i2,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j3,j1,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqpG30IF(i3,i2,i4,7)*A3g0H3(j2,j3,j1,j4,j5,j6)*(wtcalX30)
        enddo
        wt(29)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, i7 = j6, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(7,6, (/i2,i3,i4/), (/i1,i2,i4,i5,i6,i7/), ipass)
* BLOCK 7
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ j2,j1,j3,j4,j5,j6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+2d0*rJ21QQgtoqFI(ix,x1,x2,i2,i4,7,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QQgtoqFI(ix,x1,x2,j2,j3,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i2,i3,i4,7)*B1g0H3(j2,j1,j3,j4,j5,j6)*(wtcalX30)
        enddo
        wt(30)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      ggBt2g1H3XT = - sum(wt)  ! minus in bino(-...)


      return


      end function ggBt2g1H3XT
