************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function qgB2g1H2FT(ix,x1,x2,i1,i2,i3,i4,i5,i6,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(47)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgB2g1H2FT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i2,i3,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGFI(ix,x1,x2,i2,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GQFF(ix,x1,x2,i3,i4,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H2(i1,i2,i3,i4,i5,i6)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i3,i2,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGFI(ix,x1,x2,i2,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFI(ix,x1,x2,i2,i4,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H2(i1,i3,i2,i4,i5,i6)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 3
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*gd30IF(i4,i3,i2,6)*B1g1H2(j1,j2,j3,j4,j5,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + gd30IF(i4,i3,i2,6)*B1g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullgD31IF(i4,i3,i2,6,muR2_scl(i))*B1g0H2(j1,j2,j3,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i4,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGFI(ix,x1,x2,i3,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFI(ix,x1,x2,i4,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QGFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgD30IF(i4,i3,i2,6)*B1g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        call makeinit(j1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,j2,j3,5,i1,i4,6,muR2_scl(i))
        call makeinit(j1,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,i2,i4,6,i1,i4,6,muR2_scl(i))
        call makeinit(j1,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,j1,j2,5,i1,i4,6,muR2_scl(i))
        call makeinit(j1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,i1,i2,6,i1,i4,6,muR2_scl(i))
        call makeinit(j1,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,j1,j3,5,i1,i4,6,muR2_scl(i))
        call makeinit(j1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,i1,i4,6,i1,i4,6,muR2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QGFI(ix,x1,x2,i4,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=gd30IF(i4,i3,i2,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30+wtcalS)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 3
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullqgD30II(i1,i3,i2,6)*B1g1H2(j1,j2,j3,j4,j5,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgD30II(i1,i3,i2,6)*B1g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullqgD31II(i1,i3,i2,6,muR2_scl(i))*B1g0H2(j1,j2,j3,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGFI(ix,x1,x2,i2,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgD30II(i1,i3,i2,6)*B1g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        call makeinitII(i1,6,i1,i2,i3,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,j1,j2,5,j1,j3,5,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,i1,i2,6,i1,i4,6,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i3,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,j2,j3,5,j1,j3,5,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,i2,i4,6,i1,i4,6,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i3,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,j1,j3,5,j1,j3,5,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,i1,i4,6,i1,i4,6,muR2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGFI(ix,x1,x2,i4,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QGFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgD30II(i1,i3,i2,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30+wtcalS)
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqAt31IF(i1,i3,i4,6,muR2_scl(i))*B1g0H2(j1,j2,j3,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,i4,i1,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,j3,j1,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqA30IF(i1,i3,i4,6)*B1g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,i1,i4,6,i1,i4,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,j1,j3,5,i1,i4,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,i1,i2,6,i1,i4,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,j1,j2,5,i1,i4,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0/2d0*SSintIF(ix,x1,x2,i2,i4,6,i1,i4,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0/2d0*SSintIF(ix,x1,x2,j2,j3,5,i1,i4,6,muR2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QGFI(ix,x1,x2,i4,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0/2d0*rJ21QGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqA30IF(i1,i3,i4,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30+wtcalS)
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqgAt31II(i1,i2,i4,6,muR2_scl(i))*B1g0H2(j1,j2,j3,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i4,6)*B1g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqgA31II(i1,i2,i4,6,muR2_scl(i))*B1g0H2(j1,j2,j3,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFI(ix,x1,x2,i2,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i4,6)*B1g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0*SSintIF(ix,x1,x2,i1,i2,6,i1,i3,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+2d0*SSintIF(ix,x1,x2,i1,i3,6,i1,i3,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0*SSintIF(ix,x1,x2,i1,i4,6,i1,i3,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0*SSintIF(ix,x1,x2,i2,i3,6,i1,i3,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0*SSintIF(ix,x1,x2,i4,i3,6,i1,i3,6,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS-2d0*SSintIF(ix,x1,x2,j1,j3,5,j1,j3,5,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS+2d0*SSintIF(ix,x1,x2,j1,j2,5,j1,j3,5,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS-2d0*SSintIF(ix,x1,x2,j2,j3,5,j1,j3,5,muR2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GGFI(ix,x1,x2,i2,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21GQFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFF(ix,x1,x2,i3,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QGIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21QGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QQII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i4,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30+wtcalS)
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21GQFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21QGFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=gd30IFGTOQ(i4,i2,i3,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i3,i2,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=qd30IF(i1,i3,i4,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=qd30IF(i2,i3,i4,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(17)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i4,i2,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(18)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=qd30IF(i1,i4,i3,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(19)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=qd30IF(i2,i4,i3,6)*B1g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(20)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i3,i4,i2,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H2(i1,i3,i4,i2,i5,i6)*(wtcalX30)
        enddo
        wt(21)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=qd30IF(i1,i3,i4,6)*B1g0H2(j1,j3,j2,j4,j5)*(wtcalX30)
        enddo
        wt(22)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=qd30IF(i2,i4,i3,6)*B1g0H2(j1,j3,j2,j4,j5)*(wtcalX30)
        enddo
        wt(23)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i3,i2,6)*B1g0H2(j1,j3,j2,j4,j5)*(wtcalX30)
        enddo
        wt(24)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i4,i3,i2,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 6)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0/2d0
     .  *rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H2(i1,i4,i3,i2,i5,i6)*(wtcalX30)
        enddo
        wt(25)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=qd30IF(i1,i4,i3,6)*B1g0H2(j1,j3,j2,j4,j5)*(wtcalX30)
        enddo
        wt(26)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=qd30IF(i2,i3,i4,6)*B1g0H2(j1,j3,j2,j4,j5)*(wtcalX30)
        enddo
        wt(27)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqA30II(i1,i4,i2,6)*B1g0H2(j1,j3,j2,j4,j5)*(wtcalX30)
        enddo
        wt(28)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 3
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqgA30II(i1,i2,i4,6)*B1g1H2(j1,j3,j2,j4,j5,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GQFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i4,6)*B1g0H2(j1,j3,j2,j4,j5)*wtcalX30
        enddo
        wt(29)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-1d0)*FullqgA31II(i1,i2,i4,6,muR2_scl(i))*B1g0H2(j1,j3,j2,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFI(ix,x1,x2,i2,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullqgA30II(i1,i2,i4,6)*B1g0H2(j1,j3,j2,j4,j5)*wtcalX30
        enddo
        wt(30)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 4)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0*SSintIF(ix,x1,x2,i1,i2,6,i1,i3,6,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS+1d0*SSintIF(ix,x1,x2,j1,j2,5,j1,j3,5,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS-1d0*SSintIF(ix,x1,x2,j1,j3,5,j1,j3,5,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0*SSintIF(ix,x1,x2,i1,i3,6,i1,i3,6,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS-1d0*SSintIF(ix,x1,x2,j2,j3,5,j1,j3,5,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0*SSintIF(ix,x1,x2,i2,i3,6,i1,i3,6,muR2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21GGFI(ix,x1,x2,i2,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GQFI(ix,x1,x2,j3,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqgA30II(i1,i2,i4,6)*B1g0H2(j1,j3,j2,j4,j5)*(wtcalX30+wtcalS)
        enddo
        wt(31)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 3
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-2d0)*FullgqG30II(i2,i1,i4,6)*A3g1H2(j1,j2,j3,j4,j5,muR2_scl(i))
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21GGFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21GGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgqG30II(i2,i1,i4,6)*A3g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(32)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 6
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(-2d0)*FullgqG31II(i2,i1,i4,6,muR2_scl(i))*A3g0H2(j1,j2,j3,j4,j5)
          kinwt(i)=kinwt(i)/(1d0-z1)/(1d0-z2) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+4d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QGFI(ix,x1,x2,i4,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullgqG30II(i2,i1,i4,6)*A3g0H2(j1,j2,j3,j4,j5)*wtcalX30
        enddo
        wt(33)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0*SSintIF(ix,x1,x2,i1,i2,6,i1,i3,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0*SSintIF(ix,x1,x2,i1,i3,6,i1,i3,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+2d0*SSintIF(ix,x1,x2,i2,i3,6,i1,i3,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS-1d0*SSintIF(ix,x1,x2,i2,i4,6,i1,i3,6,muR2_scl(i))
        call makeinit(i1,6)
        wtcalS=wtcalS+1d0*SSintIF(ix,x1,x2,i4,i3,6,i1,i3,6,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS-2d0*SSintIF(ix,x1,x2,j1,j3,5,j1,j3,5,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS+2d0*SSintIF(ix,x1,x2,j1,j2,5,j1,j3,5,muR2_scl(i))
        call makeinitII(i1,6,i1,i2,i4,6)
        wtcalS=wtcalS-2d0*SSintIF(ix,x1,x2,j2,j3,5,j1,j3,5,muR2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21GGFI(ix,x1,x2,i2,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21GGFI(ix,x1,x2,j2,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+2d0*rJ21GGIF(ix,x1,x2,j1,j3,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21GGII(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFF(ix,x1,x2,i3,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFI(ix,x1,x2,i2,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGIF(ix,x1,x2,i1,i3,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGII(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullgqG30II(i2,i1,i4,6)*A3g0H2(j1,j3,j2,j4,j5)*(wtcalX30+wtcalS)
        enddo
        wt(34)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i2,i3,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGqtogII1(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + A4g0H2(i1,i2,i3,i4,i5,i6)*(wtcalX30)
        enddo
        wt(35)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGqtogII1(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=gf30IF(i2,i3,i4,6)*A3g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(36)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGqtogII1(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=gf30IF(i1,i4,i3,6)*A3g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(37)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GGqtogII1(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGqtogII1(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullggF30II(i1,i3,i2,6)*A3g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(38)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i2,i4,i3,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGqtogII1(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + A4g0H2(i1,i2,i4,i3,i5,i6)*(wtcalX30)
        enddo
        wt(39)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i1 = j1, i5 = j4, i6 = j5, [i2] = j2, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i2,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGqtogII1(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=gf30IF(i2,i4,i3,6)*A3g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(40)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* IF: {i2 = j2, i5 = j4, i6 = j5, [i1] = j1, [i3, i4] = j3, [i4, i3] = j3}
      call set_map(6,5, (/i1,i3,i4/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGqtogII1(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=gf30IF(i1,i3,i4,6)*A3g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(41)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GGqtogII1(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21GGqtogII1(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullggF30II(i1,i4,i2,6)*A3g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(42)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i3,i2,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21GGqtogII1(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + A4g0H2(i1,i3,i2,i4,i5,i6)*(wtcalX30)
        enddo
        wt(43)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGqtogII1(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullggF30II(i1,i3,i2,6)*A3g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(44)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j2,j3,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21GGqtogII1(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullggF30II(i1,i4,i2,6)*A3g0H2(j1,j2,j3,j4,j5)*(wtcalX30)
        enddo
        wt(45)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i4 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i3,i2/), (/i1,i2,i4,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqG30II(i3,i2,i1,6)*A3g0H2(j1,j3,j2,j4,j5)*(wtcalX30)
        enddo
        wt(46)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* II: {i3 = j3, i5 = j4, i6 = j5, [i1] = j1, [i2] = j2}
      call set_map(6,5, (/i1,i4,i2/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 7
      call ecuts_vj(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j1,j3,j2,j4,j5 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,j1,j2,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullqqG30II(i4,i2,i1,6)*A3g0H2(j1,j3,j2,j4,j5)*(wtcalX30)
        enddo
        wt(47)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgB2g1H2FT = - sum(wt)  ! minus in bino(-...)


      return


      end function qgB2g1H2FT
