************************************************************************
*
*  generated using makefortRV on 2023-03-15
*
      function qgBh2g1H4YTNLO(ix,x1,x2,i1,i3,i2,i4,i5,i6,i7,i8,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder, ieorder_sav
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(6)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgBh2g1H4YTNLO"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,8,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(8, (/ i1,i3,i2,i4,i5,i6,i7,i8 /))
        call getqcdnorm(ix,partons,facnorm, 8, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-2d0*rJ21hQGFF(ix,x1,x2,i3,i4,8,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-2d0*rJ21hQGII(ix,x1,x2,i1,i2,8,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H4(i1,i3,i2,i4,i5,i6,i7,i8)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,8,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(8, (/ i3,i1,i2,i4,i5,i6,i7,i8 /))
        call getqcdnorm(ix,partons,facnorm, 8, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,i3,i1,8,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H4(i3,i1,i2,i4,i5,i6,i7,i8)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,8,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(8, (/ i3,i2,i1,i4,i5,i6,i7,i8 /))
        call getqcdnorm(ix,partons,facnorm, 8, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21GQqtogIF(ix,x1,x2,i3,i1,8,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0H4(i3,i2,i1,i4,i5,i6,i7,i8)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,8,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(8, (/ i1,i3,i4,i2,i5,i6,i7,i8 /))
        call getqcdnorm(ix,partons,facnorm, 8, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,8,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C0g0H4(i1,i3,i4,i2,i5,i6,i7,i8)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,8,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(8, (/ i1,i2,i4,i3,i5,i6,i7,i8 /))
        call getqcdnorm(ix,partons,facnorm, 8, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,8,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C0g0H4(i1,i2,i4,i3,i5,i6,i7,i8)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,8,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(8, (/ i1,i3,i2,i4,i5,i6,i7,i8 /))
        call getqcdnorm(ix,partons,facnorm, 8, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,8,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + C0g0H4(i1,i3,i2,i4,i5,i6,i7,i8)*(wtcalX30)
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgBh2g1H4YTNLO = - sum(wt)  ! minus in bino(-...)


      return


      end function qgBh2g1H4YTNLO
