************************************************************************
*
*  generated using makefortRV on 2023-03-15
*
      function qgBttt2g1H2XTNLO(ix,x1,x2,i1,i2,i3,i4,i5,i6,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder, ieorder_sav
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(5)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello qgBttt2g1H2XTNLO"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i2,i3,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQIF(ix,x1,x2,i1,i4,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0H2(i1,i2,i3,i4,i5,i6)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i3,i4,i2,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0H2(i1,i3,i4,i2,i5,i6)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i3,i2,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D0g0H2(i1,i3,i2,i4,i5,i6)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i3,i4,i2,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D0g0H2(i1,i3,i4,i2,i5,i6)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_vj(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i1,i2,i3,i4,i5,i6 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 2)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0/2d0*rJ21QQgtoqII2(ix,x1,x2,i1,i2,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + D0g0H2(i1,i2,i3,i4,i5,i6)*(wtcalX30)
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      qgBttt2g1H2XTNLO = - sum(wt)  ! minus in bino(-...)


      return


      end function qgBttt2g1H2XTNLO
