************************************************************************
*
*  higgs decay to tau+tau-
* i1=tau-, i2=tau+.
* s(i1,i2)=mH^2
**
*
************************************************************************
      function Htautau(i1,i2,ipset)
      use KinData_mod
      implicit double precision (a-h,o-y)
      common /Zmass/ emz,ezwidth
      common /Wmass/ emw,ewwidth
      common /Qmass/emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Hmass/emh,ehwidth

      s12 =     dot(kin(ipset)%p(:,ipset-1),kin(ipset)%p(:,ipset-1))
     .     +    dot(kin(ipset)%p(:,ipset)  ,kin(ipset)%p(:,ipset)  )
     .     +2d0*dot(kin(ipset)%p(:,ipset)  ,kin(ipset)%p(:,ipset-1))

      propHnarrow=1d0/((s12-emh**2)**2+(emh*ehwidth)**2)

      Htautau=emtau**2/(4d0*emw**2)*2d0*(s12-4d0*emtau**2)*propHnarrow
      return
      end
