************************************************************************
*XC link inclusive VFH production ME with 3 decay particles
************************************************************************
****************All tree amplitudes*************************************
************************************************************************
      function C0g0ZFH3(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C0g0ZFH3=C0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function C0g0WFH3(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C0g0WFH3=C0g0WFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function sC0g0WFH3(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC0g0WFH3=sC0g0WFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function sC0g0ZFH3(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC0g0ZFH3=sC0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0ZFH3(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      D0g0ZFH3=D0g0ZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function D0g0WZFH3(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      D0g0WZFH3=D0g0WZFH(i1,i2,i3,i4,i5,i6)*decayME

      return
      end

************************************************************************
      function C1g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C1g0ZFH3=C1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C1g0WFH3=C1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function D1g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      D1g0ZFH3=D1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function D1g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      D1g0WFH3=D1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0ZFH3s1(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C1g0ZFH3s1=C1g0ZFHs1(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C1g0WFH3s1(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C1g0WFH3s1=C1g0WFHs1(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC1g0WFH3=sC1g0WFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0WFH3s0(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC1g0WFH3s0=sC1g0WFHs0(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC1g0ZFH3=sC1g0ZFH(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function sC1g0ZFH3s0(i1,i2,i3,i4,i5,i6,i7,i8)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC1g0ZFH3s0=sC1g0ZFHs0(i1,i2,i3,i4,i5,i6,i7)*decayME

      return
      end

************************************************************************
      function C2g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C2g0WFH3=C2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function C2g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C2g0ZFH3=C2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sC2g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC2g0ZFH3=sC2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sC2g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC2g0WFH3=sC2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sCt2g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sCt2g0ZFH4=sCt2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function sCt2g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sCt2g0WFH3=sCt2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function Ct2g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ct2g0WFH3=Ct2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function Ct2g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ct2g0ZFH3=Ct2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function E0g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      E0g0ZFH3=E0g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function E0g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      E0g0WFH3=E0g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function F0g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      F0g0ZFH3=F0g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
      function F0g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=9

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i7,i8,i9,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      F0g0WFH3=F0g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME

      return
      end

************************************************************************
*      function D2g0ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
*      use Process_mod, only : name_proc
*      use KinData_mod
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*
*      ipset=9
*
*      select case ( name_proc )
*      case('VFHTO2L1P','VFHTO2L1PJ')
*        decayME=HZg2l1g0(i7,i8,i9,ipset)
*      case default
*         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
*         stop
*      end select
*
*      D2g0ZFH3=D2g0ZFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME
*
*      return
*      end
*
*************************************************************************
*      function D2g0WFH3(i1,i2,i3,i4,i5,i6,i7,i8,i9)
*      use Process_mod, only : name_proc
*      use KinData_mod
*      implicit double precision (a-h,o-y)
*      implicit complex*16 (z)
*
*      ipset=9
*
*      select case ( name_proc )
*      case('VFHTO2L1P','VFHTO2L1PJ')
*        decayME=HZg2l1g0(i7,i8,i9,ipset)
*      case default
*         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
*         stop
*      end select
*
*      D2g0WFH3=D2g0WFH(i1,i2,i3,i4,i5,i6,i7,i8)*decayME
*
*      return
*      end





************************************************************************
**********************All 1-loop ME*************************************
************************************************************************
      function C0g1ZFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C0g1ZFH3=C0g1ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g1WFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C0g1WFH3=C0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function fC0g1ZFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      fC0g1ZFH3=fC0g1ZFH2(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function fC0g1WFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      fC0g1WFH3=fC0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC0g1ZFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC0g1ZFH3=sC0g1ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC0g1WFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC0g1WFH3=sC0g1WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function sC1g1ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC1g1ZFH3=sC1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sC1g1WFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sC1g1WFH3=sC1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function C1g1ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C1g1ZFH3=C1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function C1g1WFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C1g1WFH3=C1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCt1g1ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sCt1g1ZFH3=sCt1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCt1g1WFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sCt1g1WFH3=sCt1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ct1g1ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ct1g1ZFH3=Ct1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ct1g1WFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ct1g1WFH3=Ct1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCh1g1ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sCh1g1ZFH3=sCh1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function sCh1g1WFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      sCh1g1WFH3=sCh1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ch1g1WFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ch1g1WFH3=Ch1g1WFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end

************************************************************************
      function Ch1g1ZFH3(i1,i2,i3,i4,i5,i6,i7,i8,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=8

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i6,i7,i8,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ch1g1ZFH3=Ch1g1ZFH(i1,i2,i3,i4,i5,i6,i7,renscale2)*decayME

      return
      end



************************************************************************
****************All 2-loop amplitudes***********************************
************************************************************************
      function C0g2ZFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C0g2ZFH3=C0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function C0g2WFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      C0g2WFH3=C0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g2ZFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ct0g2ZFH3=Ct0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ct0g2WFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ct0g2WFH3=Ct0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g2ZFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ch0g2ZFH3=Ch0g2ZFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

************************************************************************
      function Ch0g2WFH3(i1,i2,i3,i4,i5,i6,i7,renscale2)
      use Process_mod, only : name_proc
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)

      ipset=7

      select case ( name_proc )
      case('VFHTO2L1P','VFHTO2L1PJ')
        decayME=HZg2l1g0(i5,i6,i7,ipset)
      case default
         write(*,*) "Invalid decay process in wrapVFH3.f: ", name_proc
         stop
      end select

      Ch0g2WFH3=Ch0g2WFH(i1,i2,i3,i4,i5,i6,renscale2)*decayME

      return
      end

