! TODO: Remove unneccesary calls in C1gZ/C1g0Z to populate RR... helicities in C terms - they are all set to zero anyway.
! Can check against old versions to see if integration changes

********************************************************

      double precision function D1g0Wa(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : iboson_proc
      implicit none
      integer i1,i2,i3,i4,i5,i6,i7
      double precision D1g0W

      if(abs(iboson_proc).eq.1)then
          D1g0Wa=D1g0W(i1,i2,i3,i4,i5,i6,i7)
       else
         write(*,*) "Error in D1g0Wa: iboson_proc parameter incorrectly initialised"
         stop
      endif

      return
      end

********************************************************

      double precision function Dt1g0Wa(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : iboson_proc
      implicit none
      integer i1,i2,i3,i4,i5,i6,i7
      double precision Dt1g0W

      if(abs(iboson_proc).eq.1)then
          Dt1g0Wa=Dt1g0W(i1,i2,i3,i4,i5,i6,i7)
      else
         write(*,*) "Error in Dt1g0Wa: iboson_proc parameter incorrectly initialised"
         stop
      endif

      return
      end

********************************************************

      double precision function D1g0Wb(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : iboson_proc
      implicit none
      integer i1,i2,i3,i4,i5,i6,i7
      double precision D1g0W

      if(abs(iboson_proc).eq.1)then
          D1g0Wb=D1g0W(i5,i2,i4,i3,i1,i7,i6)
      else
         write(*,*) "Error in D1g0Wb: iboson_proc parameter incorrectly initialised"
         stop
      endif

      return
      end

********************************************************

      double precision function Dt1g0Wb(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : iboson_proc
      implicit none
      integer i1,i2,i3,i4,i5,i6,i7
      double precision Dt1g0W

      if(abs(iboson_proc).eq.1)then
          Dt1g0Wb=Dt1g0W(i5,i2,i4,i3,i1,i7,i6)
      else
         write(*,*) "Error in Dt1g0Wb: iboson_proc parameter incorrectly initialised"
         stop
      endif

      return
      end


***********************************************************
* A wrapper function for (D1g0Wa-Dt1g0Wa). This is convenient
* to use in the driver program
*


      function D1g0Wac(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)


      D1g0Wac = D1g0Wa(i1,i2,i3,i4,i5,i6,i7)
     .        -Dt1g0Wa(i1,i2,i3,i4,i5,i6,i7)

      return
      end
***********************************************************
* A wrapper function for (D1g0Wb-Dt1g0Wb). This is convenient
* to use in the driver program
*

      function D1g0Wbc(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)


      D1g0Wbc = D1g0Wb(i1,i2,i3,i4,i5,i6,i7)
     .        -Dt1g0Wb(i1,i2,i3,i4,i5,i6,i7)

      return
      end

***********************************************************
* A wrapper function for (D1g0Wa-Dt1g0Wa). This is convenient
* to use in the driver program
*


      function D1g0Wpac(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)


      D1g0Wpac = D1g0Wa(i1,i2,i3,i4,i5,i6,i7)
     .        -Dt1g0Wa(i1,i2,i3,i4,i5,i6,i7)

      return
      end
***********************************************************
* A wrapper function for (D1g0Wb-Dt1g0Wb). This is convenient
* to use in the driver program
*

      function D1g0Wpbc(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)


      D1g0Wpbc = D1g0Wb(i1,i2,i3,i4,i5,i6,i7)
     .        -Dt1g0Wb(i1,i2,i3,i4,i5,i6,i7)

      return
      end

***********************************************************
* A wrapper function for (D1g0Wa-Dt1g0Wa). This is convenient
* to use in the driver program
*


      function D1g0Wmac(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)


      D1g0Wmac = D1g0Wa(i1,i2,i3,i4,i5,i6,i7)
     .        -Dt1g0Wa(i1,i2,i3,i4,i5,i6,i7)

      return
      end
***********************************************************
* A wrapper function for (D1g0Wb-Dt1g0Wb). This is convenient
* to use in the driver program
*

      function D1g0Wmbc(i1,i2,i3,i4,i5,i6,i7)
      use KinData_mod
      implicit double precision (a-h,o-y)
      implicit complex*16 (z)


      D1g0Wmbc = D1g0Wb(i1,i2,i3,i4,i5,i6,i7)
     .        -Dt1g0Wb(i1,i2,i3,i4,i5,i6,i7)

      return
      end

********************************************************

      double precision function Dt1g0Wpb(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : iboson_proc
      implicit none
      integer i1,i2,i3,i4,i5,i6,i7
      double precision Dt1g0Wb

      if(abs(iboson_proc).eq.1)then
          Dt1g0Wpb=Dt1g0Wb(i1,i2,i3,i4,i5,i6,i7)
      else
         write(*,*) "Error in Dt1g0Wpb: iboson_proc parameter incorrectly initialised"
         stop
      endif

      return
      end

********************************************************

      double precision function Dt1g0Wpa(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : iboson_proc
      implicit none
      integer i1,i2,i3,i4,i5,i6,i7
      double precision Dt1g0Wa

      if(abs(iboson_proc).eq.1)then
          Dt1g0Wpa=Dt1g0Wa(i1,i2,i3,i4,i5,i6,i7)
      else
         write(*,*) "Error in Dt1g0Wpa: iboson_proc parameter incorrectly initialised"
         stop
      endif

      return
      end

********************************************************

      double precision function Dt1g0Wmb(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : iboson_proc
      implicit none
      integer i1,i2,i3,i4,i5,i6,i7
      double precision Dt1g0Wb

      if(abs(iboson_proc).eq.1)then
          Dt1g0Wmb=Dt1g0Wb(i1,i2,i3,i4,i5,i6,i7)
      else
         write(*,*) "Error in Dt1g0Wmb: iboson_proc parameter incorrectly initialised"
         stop
      endif

      return
      end

********************************************************

      double precision function Dt1g0Wma(i1,i2,i3,i4,i5,i6,i7)
      use Process_mod, only : iboson_proc
      implicit none
      integer i1,i2,i3,i4,i5,i6,i7
      double precision Dt1g0Wa

      if(abs(iboson_proc).eq.1)then
          Dt1g0Wma=Dt1g0Wa(i1,i2,i3,i4,i5,i6,i7)
      else
         write(*,*) "Error in Dt1g0Wma: iboson_proc parameter incorrectly initialised"
         stop
      endif

      return
      end

