* The vector and axial vector contribution from MCFM, replaced by independent and more results in B1gNZax.f
      function B1g1Zax(i1,i2,i3,i4,i5,renscale2)
      use KinData_mod
      implicit none
      double precision B1g1Zax,renscale2
      complex*16 zB1g1Zvec(4)
C       double precision B1g1Zvec(4)
      double precision s
      complex*16 zampax,zamptree
      common /eweakZ/ amz,zewfac(4),zewnull(4)
!$omp threadprivate(/eweakZ/)
      common /axial/zewax(2)
!$omp threadprivate(/axial/)
      common /BZFlav/nf1g
!$omp threadprivate(/BZFlav/)
      common /order/iorder
      double precision amz
      complex*16 zewfac,zewnull,zaxamp,zaxtree,zewax
      integer i,i1,i2,i3,i4,i5,ii,jj,iorder
      integer nf1g
      integer ihel(5,4)

      B1g1Zax = 0d0
      do ii=1,4
         zB1g1Zvec(ii) = 0d0
      enddo

      if(iorder.eq.0)then

      s = s5(i4,i5)
      call eweakV1qq(nf1g,s)

C       ihel = reshape((/i1,i2,i3,i5,i4,
C      .                 i1,i2,i3,i4,i5,
C      .                 i3,i2,i1,i5,i4,
C      .                 i3,i2,i1,i4,i5/),(/5,4/))
C       do i=1,4
C          zampax = zaxamp(ihel(1,i),ihel(2,i),ihel(3,i),ihel(4,i),ihel(5,i))
C          zamptree = zaxtree(ihel(1,i),ihel(2,i),ihel(3,i),ihel(4,i),ihel(5,i))
C          B1g1Zvec(i) = dble(dconjg(zamptree)*zampax)
C       enddo
C       B1g1Zvec = abs(zewfac)**2*B1g1Zvec
C       B1g1Zax = sum(B1g1Zvec)

      ihel = reshape((/i1,i2,i3,i4,i5,
     .                 i1,i2,i3,i5,i4,
     .                 i1,i2,i3,i5,i4,
     .                 i1,i2,i3,i4,i5/),(/5,4/))

      do i=1,4
         if (i.le.2) then
               zampax = zaxamp(ihel(1,i),ihel(2,i),ihel(3,i),ihel(4,i),ihel(5,i))
               zamptree = zaxtree(ihel(1,i),ihel(2,i),ihel(3,i),ihel(4,i),ihel(5,i))
         else
            call swapzAB_kin(5)
               zampax = zaxamp(ihel(1,i),ihel(2,i),ihel(3,i),ihel(4,i),ihel(5,i))
               zamptree = zaxtree(ihel(1,i),ihel(2,i),ihel(3,i),ihel(4,i),ihel(5,i))
            call swapzAB_kin(5)
         endif
         zB1g1Zvec(i) = dconjg(zamptree)*zampax
      enddo

      do ii=1,4
         if ((ii.eq.1).or.(ii.eq.3))then
            jj = 1
         else
            jj = 2
         endif
         zB1g1Zvec(ii) = dconjg(zewfac(ii))*zewax(jj)*zB1g1Zvec(ii)
      enddo

      B1g1Zax = dble(sum(zB1g1Zvec))
      endif

      return
      end


* hep-ph/9708239 (IV.11)
      function zaxamp(i1,i2,i3,i4,i5)
      use KinData_mod
      use Parameters_mod
      implicit none
      complex*16 zaxamp,zL1d
      integer i1,i2,i3,i4,i5
      double precision :: emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth
      common /Qmass/ emt,etwidth,emb,ebwidth,emc,ecwidth,emtau,etauwidth

      if (emt.eq.0d0)then
         write(*,*) "Error in axial vector contribution to B1g1Zax,
     .the mass of the top has not been defined"
         stop
      endif


      zaxamp = -zB5(i5,i2)*zB5(i2,i1)*zA5(i3,i4)*(zL1d(-s5(i1,i3),-s5(i4,i5))/s5(i4,i5)**2
     .                                            -1d0/(12d0*s5(i4,i5)*emt**2))

      return
      end

      function zaxtree(i1,i2,i3,i4,i5)
      use KinData_mod
      implicit none
      complex*16 zaxtree
      integer i1,i2,i3,i4,i5


      zaxtree = dcmplx(0d0,1d0)*zA5(i3,i4)**2/(zA5(i3,i2)*zA5(i2,i1)*zA5(i4,i5))

      return
      end


