************************************************************************
*
*  generated using makefortRV on 2025-02-16
*
      function Bt2g1ZepemT(ix,x1,x2,i3,i4,i5,i6,i1,i2,rscale2,fscale2)
      use Mapping_mod
      use Scales_mod
      use Flavour_mod, only: set_flav_perm, unset_flav_perm
      implicit double precision (a-h,o-z)
      integer ieorder
      common /order/ieorder
      logical jflag
      common /jacobian/jflag
!$omp threadprivate(/jacobian/)
      common /parfrac/z1,z2
!$omp threadprivate(/parfrac/)
      dimension wt(16)
      dimension partons(nMax_scl)
      dimension facnorm(nMax_scl)

      double precision kinwt(nMax_scl)

      jflag = .false.
*      write(*,*)" hello Bt2g1ZepemT"

      wt=0d0
      kinwt=0d0
      partons=0d0
      facnorm=0d0
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_epem(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i3,i4,i5,i6,i1,i2 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i6,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0Z(i3,i4,i5,i6,i1,i2)*(wtcalX30)
        enddo
        wt(1)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_epem(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i3,i5,i4,i6,i1,i2 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 3)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i6,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + B2g0Z(i3,i5,i4,i6,i1,i2)*(wtcalX30)
        enddo
        wt(2)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_epem(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i3,i4,i5,i6,i1,i2 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFF(ix,x1,x2,i3,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFF(ix,x1,x2,i3,i5,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFF(ix,x1,x2,i6,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30
     .  -1d0
     .  *rJ21QGFF(ix,x1,x2,i6,i5,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0Z(i3,i4,i5,i6,i1,i2)*(wtcalX30)
        enddo
        wt(3)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* BLOCK 1
      call ecuts_epem(0,6,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(6, (/ i3,i5,i4,i6,i1,i2 /))
        call getqcdnorm(ix,partons,facnorm, 6, ipass_block, 5)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalX30=wtcalX30
     .  +1d0
     .  *rJ21QQFF(ix,x1,x2,i3,i6,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + Bt2g0Z(i3,i5,i4,i6,i1,i2)*(wtcalX30)
        enddo
        wt(4)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i4] = j3, [i4, i3] = j3, [i4, i6] = j4, [i6, i4] = j4}
      call set_map(6,5, (/i3,i4,i6/), (/i1,i2,i3,i6,i5/), ipass)
* BLOCK 3
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j5,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullA30FF(i3,i4,i6,6)*B1g1Z(j3,j5,j4,j1,j2,muR2_scl(i))
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,j3,j5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,j4,j5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullA30FF(i3,i4,i6,6)*B1g0Z(j3,j5,j4,j1,j2)*wtcalX30
        enddo
        wt(5)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i5] = j3, [i5, i3] = j3, [i5, i6] = j4, [i6, i5] = j4}
      call set_map(6,5, (/i3,i5,i6/), (/i1,i2,i3,i6,i4/), ipass)
* BLOCK 3
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j5,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullA30FF(i3,i5,i6,6)*B1g1Z(j3,j5,j4,j1,j2,muR2_scl(i))
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,j4,j5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,j3,j5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullA30FF(i3,i5,i6,6)*B1g0Z(j3,j5,j4,j1,j2)*wtcalX30
        enddo
        wt(6)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i4, i6] = j3, [i5, i4] = j4, [i6, i4] = j3}
      call set_map(6,5, (/i6,i4,i5/), (/i1,i2,i6,i5,i3/), ipass)
* BLOCK 3
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j5,j4,j3,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*d30FF(i6,i4,i5,6)*Bt1g1Z(j5,j4,j3,j1,j2,muR2_scl(i))
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j5,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + d30FF(i6,i4,i5,6)*B1g0Z(j5,j4,j3,j1,j2)*wtcalX30
        enddo
        wt(7)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i3 = j5, [i4, i5] = j4, [i5, i4] = j4, [i5, i6] = j3, [i6, i5] = j3}
      call set_map(6,5, (/i6,i5,i4/), (/i1,i2,i6,i4,i3/), ipass)
* BLOCK 3
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j5,j4,j3,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*d30FF(i6,i5,i4,6)*Bt1g1Z(j5,j4,j3,j1,j2,muR2_scl(i))
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j5,j3,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + d30FF(i6,i5,i4,6)*B1g0Z(j5,j4,j3,j1,j2)*wtcalX30
        enddo
        wt(8)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i4] = j3, [i4, i3] = j3, [i4, i5] = j4, [i5, i4] = j4}
      call set_map(6,5, (/i3,i4,i5/), (/i1,i2,i3,i5,i6/), ipass)
* BLOCK 3
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j4,j5,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*d30FF(i3,i4,i5,6)*Bt1g1Z(j3,j4,j5,j1,j2,muR2_scl(i))
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j3,j5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + d30FF(i3,i4,i5,6)*B1g0Z(j3,j4,j5,j1,j2)*wtcalX30
        enddo
        wt(9)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i6 = j5, [i3, i5] = j3, [i4, i5] = j4, [i5, i3] = j3, [i5, i4] = j4}
      call set_map(6,5, (/i3,i5,i4/), (/i1,i2,i3,i4,i6/), ipass)
* BLOCK 3
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j4,j5,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*d30FF(i3,i5,i4,6)*Bt1g1Z(j3,j4,j5,j1,j2,muR2_scl(i))
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j3,j5,5,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + d30FF(i3,i5,i4,6)*B1g0Z(j3,j4,j5,j1,j2)*wtcalX30
        enddo
        wt(10)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i4] = j3, [i4, i3] = j3, [i4, i6] = j4, [i6, i4] = j4}
      call set_map(6,5, (/i3,i4,i6/), (/i1,i2,i3,i6,i5/), ipass)
* BLOCK 6
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j5,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullA31FF(i3,i4,i6,6,muR2_scl(i))*B1g0Z(j3,j5,j4,j1,j2)
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,j3,j4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i6,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i3,i4,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullA30FF(i3,i4,i6,6)*B1g0Z(j3,j5,j4,j1,j2)*wtcalX30
        enddo
        wt(11)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i5] = j3, [i5, i3] = j3, [i5, i6] = j4, [i6, i5] = j4}
      call set_map(6,5, (/i3,i5,i6/), (/i1,i2,i3,i6,i4/), ipass)
* BLOCK 6
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j5,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullA31FF(i3,i5,i6,6,muR2_scl(i))*B1g0Z(j3,j5,j4,j1,j2)
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,j3,j4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i3,i5,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i6,i5,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullA30FF(i3,i5,i6,6)*B1g0Z(j3,j5,j4,j1,j2)*wtcalX30
        enddo
        wt(12)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i4] = j3, [i4, i3] = j3, [i4, i6] = j4, [i6, i4] = j4}
      call set_map(6,5, (/i3,i4,i6/), (/i1,i2,i3,i6,i5/), ipass)
* BLOCK 6
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j5,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullAt31FF(i3,i4,i6,6,muR2_scl(i))*B1g0Z(j3,j5,j4,j1,j2)
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,j3,j4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,i3,i6,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullA30FF(i3,i4,i6,6)*B1g0Z(j3,j5,j4,j1,j2)*wtcalX30
        enddo
        wt(13)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i5] = j3, [i5, i3] = j3, [i5, i6] = j4, [i6, i5] = j4}
      call set_map(6,5, (/i3,i5,i6/), (/i1,i2,i3,i6,i4/), ipass)
* BLOCK 6
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j5,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        if (ix == 1) then
          kinwt(i)=(+1d0)*FullAt31FF(i3,i5,i6,6,muR2_scl(i))*B1g0Z(j3,j5,j4,j1,j2)
          kinwt(i)=kinwt(i) ! Jacobian factor
        endif
        wtcalX30=0d0
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,j3,j4,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,i3,i6,6,muR2_scl(i),muF2_scl(i))
        kinwt(i) = kinwt(i) + FullA30FF(i3,i5,i6,6)*B1g0Z(j3,j5,j4,j1,j2)*wtcalX30
        enddo
        wt(14)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i5 = j5, [i3, i4] = j3, [i4, i3] = j3, [i4, i6] = j4, [i6, i4] = j4}
      call set_map(6,5, (/i3,i4,i6/), (/i1,i2,i3,i6,i5/), ipass)
* BLOCK 7
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j5,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i3,i6,6,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j3,j4,5,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,i3,i5,6,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,j3,j5,5,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,i6,i5,6,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,j4,j5,5,i3,i6,6,muR2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i3,i5,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFF(ix,x1,x2,j3,j5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i6,i5,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFF(ix,x1,x2,j4,j5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,i3,i6,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j3,j4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullA30FF(i3,i4,i6,6)*B1g0Z(j3,j5,j4,j1,j2)*(wtcalX30+wtcalS)
        enddo
        wt(15)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif
*
*
      ipass=1
      ipass_block=1
      call unset_map()
* FF: {i1 = j1, i2 = j2, i4 = j5, [i3, i5] = j3, [i5, i3] = j3, [i5, i6] = j4, [i6, i5] = j4}
      call set_map(6,5, (/i3,i5,i6/), (/i1,i2,i3,i6,i4/), ipass)
* BLOCK 7
      call ecuts_epem(0,5,ipass)
      if(ipass.eq.1)then
        call set_flav_perm(5, (/ j3,j5,j4,j1,j2 /))
        call getqcdnorm(ix,partons,facnorm, 5, ipass_block, 1)
        if(ipass_block/=0) then
        kinwt = 0d0
        do i=1,nAct_scl
        wtcalX30=0d0
        wtcalS=0d0
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,i3,i6,6,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,j3,j4,5,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,i3,i4,6,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,j3,j5,5,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS-1d0*SSint(ix,x1,x2,i6,i4,6,i3,i6,6,muR2_scl(i))
        wtcalS=wtcalS+1d0*SSint(ix,x1,x2,j4,j5,5,i3,i6,6,muR2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFF(ix,x1,x2,j4,j5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i3,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QGFF(ix,x1,x2,j3,j5,5,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QGFF(ix,x1,x2,i6,i4,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30-1d0*rJ21QQFF(ix,x1,x2,i3,i6,6,muR2_scl(i),muF2_scl(i))
        wtcalX30=wtcalX30+1d0*rJ21QQFF(ix,x1,x2,j3,j4,5,muR2_scl(i),muF2_scl(i))
        kinwt(i)=FullA30FF(i3,i5,i6,6)*B1g0Z(j3,j5,j4,j1,j2)*(wtcalX30+wtcalS)
        enddo
        wt(16)=bino(ix,partons,-kinwt*facnorm)
        end if
        call unset_flav_perm()
      endif


      Bt2g1ZepemT = - sum(wt)  ! minus in bino(-...)


      return


      end function Bt2g1ZepemT
