*************************************************************************
*	FUNCTIONS
************************************************************************
*
      complex*16 function zLzero(x,y)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      zLzero=(zzlog(x)-zzlog(y))/(1d0-x/y)
      return
      end
************************************************************************
*
      complex*16 function zLone(x,y)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      zLone=(zzlog(x)-zzlog(y)+1d0-x/y)/(1d0-x/y)**(2)
      return
      end
************************************************************************
*
      complex*16 function zLtwo(x,y)
      implicit real*8(a-h,o-y)
      implicit complex*16 (z)
      zLtwo=(zzlog(x)-zzlog(y)-1d0/2d0*(x/y-y/x))/(1d0-x/y)**(3)
      return
      end
************************************************************************
*
      complex*16 function zLs1(x,y,z,w)
      implicit real*8(a-h,o-z)
      complex*16 zzlog,zLzero,zspence,xoy,zow,zh2
      parameter( pi = 3.14159265358979323846d0 )
      xoy=dcmplx(x/y,0d0)
      zow=dcmplx(z/w,0d0)
       zLs1=1d0/(1d0-x/y-z/w)**(2)*(zh2(0,1,1d0-xoy)+zh2(0,1,1d0-zow)
     &   +(zzlog(x)-zzlog(y))*(zzlog(z)-zzlog(w))
     &  -pi**(2)/6d0+(1d0-x/y-z/w)*(zLzero(x,y)+zLzero(z,w)))
      return
      end
***********************************************************************
*
      real*8 function rr(x,y)
      implicit real*8(a-h,o-z)
      parameter(pi=3.141592653589793238d0)

      xx = dabs(x)
      yy = dabs(y)
      rr = rH1(0,xx)*rH1(0,yy)+pi**2/6d0
      if(x.lt.0d0.and.y.lt.0d0)rr=rr-pi**2
      if(x.ge.0d0.and.x.lt.1d0)rr=rr+rH2(1,0,x)
      if(x.lt.0d0)rr=rr-rH2(1,0,-x/(1d0-x))-rH2(1,1,-x/(1d0-x))
      if(x.gt.1d0)rr=rr-rH2(1,0,1d0/x)-rH2(0,0,1d0/x)-pi**2/3d0
      if(y.ge.0d0.and.y.lt.1d0)rr=rr+rH2(1,0,y)
      if(y.lt.0d0)rr=rr-rH2(1,0,-y/(1d0-y))-rH2(1,1,-y/(1d0-y))
      if(y.gt.1d0)rr=rr-rH2(1,0,1d0/y)-rH2(0,0,1d0/y)-pi**2/3d0

*     write(*,*)" rr ",rr
      return
      end

